package ai;

import l2ft.extensions.scripts.Functions;
import l2ft.gameserver.ai.DefaultAI;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.network.NpcStringId;
import l2ft.util.Location;
import l2ft.util.Rnd;

public class AdeptGiran extends DefaultAI
{
	static final Location[] points = { new Location(84864, 147764, -3409), new Location(83689, 147694, -3409),
			new Location(83583, 148708, -3409), new Location(83676, 147705, -3409), new Location(84864, 147764, -3409),
			new Location(83620, 147703, -3409), new Location(83622, 149534, -3409), new Location(83853, 149538, -3409),
			new Location(83630, 149554, -3409), new Location(83627, 147723, -3409), new Location(84864, 147764, -3409) };

	private int current_point = -1;
	private long wait_timeout = 0;
	private boolean wait = false;

	public AdeptGiran(L2Character actor)
	{
		super(actor);
	}

	@Override
	public boolean isGlobalAI()
	{
		return true;
	}

	@Override
	protected boolean thinkActive()
	{
		L2NpcInstance actor = getActor();
		if(actor == null || actor.isDead())
			return true;

		if(_def_think)
		{
			doTask();
			return true;
		}

		if(System.currentTimeMillis() > wait_timeout && (current_point > -1 || Rnd.chance(5)))
		{
			if(!wait)
				switch(current_point)
				{
					case 1:
						wait_timeout = System.currentTimeMillis() + 5000;
						Functions.npcSay2(actor, NpcStringId.A_BLACK_MOON_NOW_DO_YOU_UNDERSTAND_THAT_HE_HAS_OPENED_HIS_EYES);
						wait = true;
						return true;
					case 3:
						wait_timeout = System.currentTimeMillis() + 5000;
						Functions.npcSay2(actor, NpcStringId.A_BLACK_MOON_NOW_DO_YOU_UNDERSTAND_THAT_HE_HAS_OPENED_HIS_EYES);
						wait = true;
						return true;
					case 4:
						wait_timeout = System.currentTimeMillis() + 20000;
						wait = true;
						return true;
					case 5:
						wait_timeout = System.currentTimeMillis() + 1000;
						Functions.npcSay2(actor, NpcStringId.CLOUDS_OF_BLOOD_ARE_GATHERING_SOON_IT_WILL_START_TO_RAIN_THE_RAIN_OF_CRIMSON_BLOOD);
						wait = true;
						return true;
					case 6:
						wait_timeout = System.currentTimeMillis() + 10000;
						wait = true;
						return true;
					case 9:
						wait_timeout = System.currentTimeMillis() + 1000;
						Functions.npcSay2(actor, NpcStringId.CLOUDS_OF_BLOOD_ARE_GATHERING_SOON_IT_WILL_START_TO_RAIN_THE_RAIN_OF_CRIMSON_BLOOD);
						wait = true;
						return true;
					case 10:
						wait_timeout = System.currentTimeMillis() + 30000;
						wait = true;
						return true;
					case 2:
					case 7:
					case 8:
				}

			wait_timeout = 0;
			wait = false;
			current_point += 1;

			if(current_point >= points.length)
				current_point = 0;

			addTaskMove(points[current_point], true);
			doTask();
			return true;
		}

		if(randomAnimation())
			return true;

		return false;
	}

	@Override
	protected void onEvtAttacked(L2Character attacker, int damage)
	{}

	@Override
	protected void onEvtAggression(L2Character target, int aggro)
	{}
}