package ai;

import l2ft.extensions.scripts.Functions;
import l2ft.gameserver.ai.DefaultAI;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.network.NpcStringId;
import l2ft.util.Location;
import l2ft.util.Rnd;

public class AdeptGludio extends DefaultAI
{
	static final Location[] points = { new Location(-14169, 121265, -2993), new Location(-14577, 121265, -2993),
			new Location(-13664, 121265, -2993), new Location(-14154, 121265, -2993), new Location(-14149, 121673, -2993),
			new Location(-13896, 122257, -2993), new Location(-13092, 122262, -2993), new Location(-13887, 122271, -2993),
			new Location(-14155, 121690, -2993), new Location(-14150, 121273, -2993), new Location(-13736, 121251, -2993),
			new Location(-14548, 121265, -2993), new Location(-14165, 121265, -2993) };

	private int current_point = -1;
	private long wait_timeout = 0;
	private boolean wait = false;

	public AdeptGludio(L2Character actor)
	{
		super(actor);
	}

	@Override
	public boolean isGlobalAI()
	{
		return true;
	}

	@Override
	protected boolean thinkActive()
	{
		L2NpcInstance actor = getActor();
		if(actor == null || actor.isDead())
			return true;

		if(_def_think)
		{
			doTask();
			return true;
		}

		if(System.currentTimeMillis() > wait_timeout && (current_point > -1 || Rnd.chance(5)))
		{
			if(!wait)
				switch(current_point)
				{
					case 3:
						wait_timeout = System.currentTimeMillis() + 5000;
						Functions.npcSay2(actor, NpcStringId.CLOUDS_OF_BLOOD_ARE_GATHERING_SOON_IT_WILL_START_TO_RAIN_THE_RAIN_OF_CRIMSON_BLOOD);
						wait = true;
						return true;
					case 4:
						wait_timeout = System.currentTimeMillis() + 5000;
						Functions.npcSay2(actor, NpcStringId.A_BLACK_MOON_NOW_DO_YOU_UNDERSTAND_THAT_HE_HAS_OPENED_HIS_EYES);
						wait = true;
						return true;
					case 7:
						wait_timeout = System.currentTimeMillis() + 5000;
						Functions.npcSay2(actor, NpcStringId.A_BLACK_MOON_NOW_DO_YOU_UNDERSTAND_THAT_HE_HAS_OPENED_HIS_EYES);
						wait = true;
						return true;
					case 9:
						wait_timeout = System.currentTimeMillis() + 5000;
						Functions.npcSay2(actor, NpcStringId.WHILE_THE_FOOLISH_LIGHT_WAS_ASLEEP_THE_DARKNESS_WILL_AWAKEN_FIRST_UH_HUH_HUH);
						wait = true;
						return true;
					case 12:
						wait_timeout = System.currentTimeMillis() + 30000;
						Functions.npcSay2(actor, NpcStringId.WHILE_THE_FOOLISH_LIGHT_WAS_ASLEEP_THE_DARKNESS_WILL_AWAKEN_FIRST_UH_HUH_HUH);
						wait = true;
						return true;
					case 5:
					case 6:
					case 8:
					case 10:
					case 11:
				}

			wait_timeout = 0;
			wait = false;
			current_point += 1;

			if(current_point >= points.length)
				current_point = 0;

			addTaskMove(points[current_point], true);
			doTask();
			return true;
		}

		if(randomAnimation())
			return true;

		return false;
	}

	@Override
	protected void onEvtAttacked(L2Character attacker, int damage)
	{}

	@Override
	protected void onEvtAggression(L2Character target, int aggro)
	{}
}