package ai;

import l2ft.extensions.scripts.Functions;
import l2ft.gameserver.ai.DefaultAI;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.network.NpcStringId;
import l2ft.util.Location;
import l2ft.util.Rnd;

public class AdeptRune extends DefaultAI
{
	static final Location[] points = { new Location(43393, -46803, -807), new Location(43291, -47389, -801),
			new Location(43502, -48107, -801), new Location(45204, -47995, -801), new Location(45900, -48176, -801),
			new Location(45224, -47931, -801), new Location(43515, -48067, -801), new Location(43305, -47420, -801),
			new Location(43393, -46803, -807), new Location(43291, -47389, -801), new Location(43502, -48107, -801),
			new Location(45204, -47995, -801), new Location(45900, -48176, -801), new Location(45224, -47931, -801),
			new Location(43515, -48067, -801), new Location(43305, -47420, -801), new Location(43393, -46803, -807),
			new Location(43291, -47389, -801), new Location(43502, -48107, -801), new Location(45204, -47995, -801),
			new Location(45900, -48176, -801), new Location(45224, -47931, -801), new Location(43515, -48067, -801),
			new Location(43305, -47420, -801), new Location(43393, -46803, -807) };

	private int current_point = -1;
	private long wait_timeout = 0;
	private boolean wait = false;

	public AdeptRune(L2Character actor)
	{
		super(actor);
	}

	@Override
	public boolean isGlobalAI()
	{
		return true;
	}

	@Override
	protected boolean thinkActive()
	{
		L2NpcInstance actor = getActor();
		if(actor == null || actor.isDead())
			return true;

		if(_def_think)
		{
			doTask();
			return true;
		}

		if(System.currentTimeMillis() > wait_timeout && (current_point > -1 || Rnd.chance(5)))
		{
			if(!wait)
				switch(current_point)
				{
					case 2:
						wait_timeout = System.currentTimeMillis() + 1000;
						Functions.npcSay2(actor, NpcStringId.A_BLACK_MOON_NOW_DO_YOU_UNDERSTAND_THAT_HE_HAS_OPENED_HIS_EYES);
						wait = true;
						return true;
					case 5:
						wait_timeout = System.currentTimeMillis() + 1000;
						Functions.npcSay2(actor, NpcStringId.CLOUDS_OF_BLOOD_ARE_GATHERING_SOON_IT_WILL_START_TO_RAIN_THE_RAIN_OF_CRIMSON_BLOOD);
						wait = true;
						return true;
					case 7:
						wait_timeout = System.currentTimeMillis() + 1000;
						Functions.npcSay2(actor, NpcStringId.WHILE_THE_FOOLISH_LIGHT_WAS_ASLEEP_THE_DARKNESS_WILL_AWAKEN_FIRST_UH_HUH_HUH);
						wait = true;
						return true;
					case 9:
						wait_timeout = System.currentTimeMillis() + 1000;
						Functions.npcSay2(actor, NpcStringId.A_BLACK_MOON_NOW_DO_YOU_UNDERSTAND_THAT_HE_HAS_OPENED_HIS_EYES);
						wait = true;
						return true;
					case 11:
						wait_timeout = System.currentTimeMillis() + 1000;
						Functions.npcSay2(actor, NpcStringId.CLOUDS_OF_BLOOD_ARE_GATHERING_SOON_IT_WILL_START_TO_RAIN_THE_RAIN_OF_CRIMSON_BLOOD);
						wait = true;
						return true;
					case 14:
						wait_timeout = System.currentTimeMillis() + 1000;
						Functions.npcSay2(actor, NpcStringId.WHILE_THE_FOOLISH_LIGHT_WAS_ASLEEP_THE_DARKNESS_WILL_AWAKEN_FIRST_UH_HUH_HUH);
						wait = true;
						return true;
					case 18:
						wait_timeout = System.currentTimeMillis() + 1000;
						Functions.npcSay2(actor, NpcStringId.A_BLACK_MOON_NOW_DO_YOU_UNDERSTAND_THAT_HE_HAS_OPENED_HIS_EYES);
						wait = true;
						return true;
					case 21:
						wait_timeout = System.currentTimeMillis() + 1000;
						Functions.npcSay2(actor, NpcStringId.CLOUDS_OF_BLOOD_ARE_GATHERING_SOON_IT_WILL_START_TO_RAIN_THE_RAIN_OF_CRIMSON_BLOOD);
						wait = true;
						return true;
					case 23:
						wait_timeout = System.currentTimeMillis() + 1000;
						Functions.npcSay2(actor, NpcStringId.WHILE_THE_FOOLISH_LIGHT_WAS_ASLEEP_THE_DARKNESS_WILL_AWAKEN_FIRST_UH_HUH_HUH);
						wait = true;
						return true;
					case 3:
					case 4:
					case 6:
					case 8:
					case 10:
					case 12:
					case 13:
					case 15:
					case 16:
					case 17:
					case 19:
					case 20:
					case 22:
				}

			wait_timeout = 0;
			wait = false;
			current_point += 1;

			if(current_point >= points.length)
				current_point = 0;

			addTaskMove(points[current_point], true);
			doTask();
			return true;
		}

		if(randomAnimation())
			return true;

		return false;
	}

	@Override
	protected void onEvtAttacked(L2Character attacker, int damage)
	{}

	@Override
	protected void onEvtAggression(L2Character target, int aggro)
	{}
}