package ai;


import l2ft.gameserver.ai.Fighter;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.L2Spawn;
import l2ft.gameserver.tables.NpcTable;
 
public class AncientEgg extends Fighter
{
	private boolean _firstTimeAttacked = true;
	private static final int[] BROTHERS = { 22196, 22199, 22200, 22203 };

	public AncientEgg(L2Character actor)
	{
		super(actor);
	}
	
	public void onEvtAttacked(L2Character attacker, int damage)
	{
		if (_firstTimeAttacked)
		{
			_firstTimeAttacked = false;
			try
			{
				for(int mobId : BROTHERS)
				{
					L2Spawn spawn = new L2Spawn(NpcTable.getTemplate(mobId));
					spawn.setLoc(attacker.getLoc());
					spawn.doSpawn(true);
					spawn.stopRespawn();
				}
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
		}
		super.onEvtAttacked(attacker, damage);
	}
	
	protected boolean randomWalk()
	{
		return false;
	}
	
	protected void onEvtDead(L2Character killer)
	{
		_firstTimeAttacked = true;
		super.onEvtDead(killer);
	}
}
