package ai;

import l2ft.gameserver.ai.CtrlIntention;
import l2ft.gameserver.ai.Fighter;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.L2World;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.util.Rnd;

public class BeastFarmF extends Fighter
{
	private L2NpcInstance mob;
			
	public BeastFarmF(L2Character actor)
	{
		super(actor);
		AI_TASK_DELAY = 1000;
		AI_TASK_ACTIVE_DELAY = 1000;
	}
	
	@Override
	public boolean isGlobalAI()
	{
		return true;
	}
		
	@Override
	protected boolean thinkActive()
	{
		L2NpcInstance actor = getActor();
		if(actor == null || actor.isDead())
			return true;

		if(Rnd.chance(10)) {
			if(getIntention() == CtrlIntention.AI_INTENTION_ACTIVE)
			{
			    if(mob == null)
			    	for(L2NpcInstance npc : L2World.getAroundNpc(actor, 1000, 200))
				    	if(npc.getNpcId() == 18887 || npc.getNpcId() == 18894 || npc.getNpcId() == 18873)
						{
							npc.addDamageHate(actor, 0, 100);
					    	mob = npc;
						}
							
				if(mob != null)
			    	setIntention(CtrlIntention.AI_INTENTION_ATTACK, mob);
			}
		}
		
		return true;
	}
}