package ai;

import l2ft.gameserver.ai.CtrlEvent;
import l2ft.gameserver.ai.Fighter;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.instances.L2MonsterInstance;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.tables.NpcTable;
import l2ft.util.Rnd;

public class ContaminatedOrc extends Fighter
{
	private static final int TurkaCommandersGhost = 22701;
	private static final int TurkaFollowersGhost = 22706;

	public ContaminatedOrc(L2Character actor)
	{
		super(actor);
	}

	protected void onEvtDead(L2Character killer)
	{
		L2NpcInstance actor = getActor();
		if (actor == null)
			return;
		if (Rnd.chance(30))
			spawn(actor, killer, actor.getNpcId());
		if (Rnd.chance(5))
		{
			L2NpcInstance npc = spawn(actor, killer, TurkaCommandersGhost);
			for (int i = 1; i <= 3; i++)
				spawn(npc, killer, TurkaFollowersGhost);
		}
		super.onEvtDead(killer);
	}

	private L2NpcInstance spawn(L2NpcInstance actor, L2Character attacker, int mob)
	{
		try
		{
			L2NpcInstance npc = NpcTable.getTemplate(mob).getNewInstance();
			npc.setSpawnedLoc(((L2MonsterInstance)actor).getMinionPosition());
			npc.setReflection(actor.getReflection());
			npc.onSpawn();
			npc.spawnMe(npc.getSpawnedLoc());
			npc.getAI().notifyEvent(CtrlEvent.EVT_AGGRESSION, attacker, Integer.valueOf(Rnd.get(1, 100)));
			return npc;
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		return null;
	}
}