package ai;

import l2ft.gameserver.ai.Mystic;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.tables.SkillTable;
import l2ft.util.GArray;
import l2ft.util.Rnd;

public class CorpseCollector extends Mystic
{
	public CorpseCollector(L2Character actor)
	{
		super(actor);
		SkillTable.getInstance().getInfo(4672, 1).setCastRange(40);
	}

	protected boolean thinkActive()
	{
		if ((super.thinkActive()) || (!this._task_list.isEmpty())) {
			return true;
		}
		L2NpcInstance actor = getActor();
		if ((actor != null) && (!actor.isInCombat()) && (Rnd.chance(10)) && (!actor.isMovementDisabled()))
		{
			GArray<L2NpcInstance> possible = null;
			for (L2NpcInstance around : actor.getAroundNpc(600, 200)) {
    	    if ((around.isVisible()) && (around.isDead()))
    	    {
    	    	if (possible == null)
    	    		possible = new GArray<L2NpcInstance>();
    	    	possible.add(around);
    	    }
			}
			if ((possible == null) || (possible.isEmpty())) {
				return false;
			}
			L2NpcInstance target = possible.getRandomize();

			clearTasks();
			addTaskCast(target, SkillTable.getInstance().getInfo(1151, 1));
			doTask();
			clearTasks();
			return true;
		}
		return false;
	}
}