package ai;

import l2ft.common.ThreadPoolManager;
import l2ft.extensions.scripts.Functions;
import l2ft.gameserver.ai.DefaultAI;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.L2ObjectsStorage;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.serverpackets.SocialAction;
import l2ft.util.GArray;
import l2ft.util.Rnd;

/**
 *  AI fo Dilios
 *  General Dilios (Генерал  Дилиос ) — NPC 70 уровня расы Humans и обитает в локации Keucereus Alliance Base.
 */
public class Dilios extends DefaultAI
{
  private long _wait_timeout = System.currentTimeMillis() + 60000L;
  private static GArray<L2NpcInstance> _arm;

  public Dilios(L2Character actor)
  {
    super(actor);
  }

  protected boolean thinkActive()
  {
    L2NpcInstance actor = getActor();
    if (actor == null) {
      return true;
    }
    if (this._wait_timeout < System.currentTimeMillis())
    {
      if (_arm == null) {
        _arm = L2ObjectsStorage.getAllByNpcId(32619, false);
      }
      this._wait_timeout = (System.currentTimeMillis() + Rnd.get(45, 90) * 1000);

      Functions.npcSayCustomMessage(actor, "scripts.ai.Dilios.1");

      int time = 3000;
      for (int i = 0; i <= 2; ++i)
      {
        ThreadPoolManager.getInstance().scheduleGeneral(new Runnable()
        {
          public void run()
          {
            for (L2NpcInstance voin : Dilios._arm)
              voin.broadcastPacket(new SocialAction(voin.getObjectId(), 4));
          }
        }
        , time);

        time += 3000;
      }
    }
    return true;
  }

  public boolean isGlobalAI()
  {
    return true;
  }

  protected void onEvtAttacked(L2Character attacker, int damage)
  {
  }

  protected void onEvtAggression(L2Character target, int aggro)
  {
  }
}