package ai;

import l2ft.gameserver.ai.Fighter;
import l2ft.gameserver.geodata.GeoEngine;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.L2Spawn;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.tables.NpcTable;
import l2ft.util.Location;
import l2ft.util.Rnd;

/**
 * AI моба Dragon Knight (1) для LOA.<br>
 * После убийства моба с шансом 50% спавнится Dragon Knight (2) и 4 Dragon Knight Warrior
 * @author RuLeX
 */
public class DragonKnight1 extends Fighter
{
	private static final int ELIT_DK = 22845;
	private static final int WARIOR_DK = 22847;
	private static final int MOBS_COUNT = 4;
	private boolean FLAG = false;

	public DragonKnight1(L2Character actor)
	{
		super(actor);
	}

	@Override
	protected void onEvtDead(L2Character killer)
	{
		L2NpcInstance actor = getActor();
		int sh = Rnd.get(10);
		if(actor != null && sh <= 5)
			try
			{
				Location pos = GeoEngine.findPointToStay(actor.getX(), actor.getY(), actor.getZ(), 100, 120, actor.getReflection().getGeoIndex());
				L2Spawn sp = new L2Spawn(NpcTable.getTemplate(ELIT_DK));
				sp.setLoc(pos);
				sp.doSpawn(true);
				boolean FLAG = true;
				spawnWarior(killer);
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
		super.onEvtDead(killer);
	}
	
	private void spawnWarior(L2Character killer)
	{
		L2NpcInstance actor = getActor();
		if(actor != null && FLAG)
			for(int i = 0; i < MOBS_COUNT; i++)
				try
				{
					Location pos = GeoEngine.findPointToStay(actor.getX(), actor.getY(), actor.getZ(), 100, 120, actor.getReflection().getGeoIndex());
					L2Spawn sp = new L2Spawn(NpcTable.getTemplate(WARIOR_DK));
					sp.setLoc(pos);
					L2NpcInstance npc = sp.doSpawn(true);
				}
				catch(Exception e)
				{
					e.printStackTrace();
				}
	}


}