package ai;

import l2ft.gameserver.ai.CtrlIntention;
import l2ft.gameserver.ai.Fighter;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.instances.L2MinionInstance;
import l2ft.gameserver.model.instances.L2MonsterInstance;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.util.Location;
import l2ft.util.MinionList;
import l2ft.util.Rnd;


/**
 * User: RuLeX
 * Date: 24.09.11
 * Ходит по кольцу в ЛОА
 */
public class DrakeLeader extends Fighter
{
    //Координаты точки.
	public Location[] points = null;
    //Текущая точка в инт
	private int current_point = -1;
    //Открываем|закрываем метод назначение координат для хобьбы.
    private boolean start = false;
    //Определение последней точки.
    private boolean last = false;

    //АИ включенно всегда
    @Override
	public boolean isGlobalAI()
	{
		return true;
	}

    //Отключаем хождение.
	@Override
	protected boolean randomWalk()
	{
		return false;
	}

    public DrakeLeader(L2Character actor)
    {
        super(actor);
		AI_TASK_DELAY = 1000;
		AI_TASK_ACTIVE_DELAY = 1000;
    }


    @Override
	public void startAITask()
	{
		L2NpcInstance actor = getActor();

        MinionList ml = ((L2MonsterInstance) actor).getMinionList();
        if(ml != null)
        {
            for(L2MinionInstance m : ml.getSpawnedMinions())
               m.getAI().setIntention(CtrlIntention.AI_INTENTION_FOLLOW, actor, 500);
        }
        super.startAITask();
    }

    @Override
	protected boolean thinkActive()
	{
		L2NpcInstance actor = getActor();
		if(actor == null || actor.isDead())
			return true;
		
		//Определяем координыты моба.
		int mob_x = actor.getX();
		int mob_y = actor.getY();
		
		if(!start)
        {

			//Если координаты точки спавна поподают в нужную область то, задаём координаты движения по кольцу.
			if ((mob_x <= 147336 && mob_x >= 146376) && (mob_y <= 113064 && mob_y >= 112168))
			{
				int track = Rnd.get(4);
				switch(track)
					{
						case 0:
						{
							start = true;
							points = new Location[] {new Location(146792, 112520,-3750), new Location(148152, 112104,-3750), new Location(148952, 112520,-3750), new Location(149176, 113464,-3750), new Location(149224, 114872,-3750), new Location(148808, 115672,-3750), new Location(148232, 115992,-3750), new Location(147448, 116312, -3736), new Location(146312, 116184,-3750), new Location(145416, 115560,-3750), new Location(145048, 114680,-3750), new Location(145144, 113592,-3750), new Location(145784, 112808,-3750), new Location(146024, 112616,-3750)};
							break;
						}	
						case 1:
						{
							start = true;
							points = new Location[] {new Location(147032, 112808,-3750), new Location(147992, 112632,-3750), new Location(148712, 112904,-3750), new Location(148968, 113560,-3750), new Location(149096, 114840,-3750), new Location(148680, 115560,-3750), new Location(148184, 115864,-3750), new Location(147384, 116120,-3750), new Location(146392, 116136,-3750), new Location(145544, 115400,-3750), new Location(145128, 114696,-3750), new Location(145224, 113656,-3750), new Location(145720, 112936,-3750), new Location(146104, 112776,-3750)};
							break;
						}	
						case 2:
						{
							start = true;
							points = new Location[] {new Location(146872, 112696,-3750), new Location(148056, 112680,-3750), new Location(148648, 112984,-3750), new Location(148872, 113576,-3750), new Location(149160, 114856,-3750), new Location(148632, 115496,-3750), new Location(148200, 115896,-3750), new Location(147384, 116056,-3750), new Location(146344, 116232,-3750), new Location(145464, 115480,-3750), new Location(145224, 114648,-3750), new Location(145176, 113640,-3750), new Location(145768, 112936,-3750), new Location(146120, 112840,-3750)};
							break;
						}	
						case 3:
						{
							start = true;
							points = new Location[] {new Location(146824, 112568,-3750), new Location(148120, 112184,-3750), new Location(148808, 112760,-3750), new Location(149064, 113496,-3750), new Location(149208, 114856,-3750), new Location(148744, 115608,-3750), new Location(148200, 115960,-3750), new Location(147432, 116232, -3739), new Location(146360, 116216,-3750), new Location(145432, 115528,-3750), new Location(145176, 114664,-3750), new Location(145112, 113592,-3750), new Location(145624, 112904,-3750), new Location(146056, 112696,-3750)};
							break;
						}	
						case 4:
						{
							start = true;
							points = new Location[] {new Location(146760, 112424,-3750), new Location(148120, 111976,-3750), new Location(148888, 112648,-3750), new Location(149256, 113448,-3750), new Location(149320, 114856,-3750), new Location(148856, 115704,-3750), new Location(148296, 116088,-3750), new Location(147480, 116408, -3731), new Location(146312, 116280,-3750), new Location(145352, 115656,-3750), new Location(144936, 114712,-3750), new Location(145048, 113576,-3750), new Location(145560, 112856,-3750), new Location(146024, 112536,-3750)};
							break;
						}	
					}
			}	
					
			if ((mob_x <= 148504 && mob_x >= 147432) && (mob_y <= 112952 && mob_y >= 111752))
			{
				int track = Rnd.get(4);
				switch(track)
					{
						case 0:
						{
							start = true;
							points = new Location[] {new Location(148152, 112104,-3750), new Location(148952, 112520,-3750), new Location(149176, 113464,-3750), new Location(149224, 114872,-3750), new Location(148808, 115672,-3750), new Location(148232, 115992,-3750), new Location(147448, 116312, -3736), new Location(146312, 116184,-3750), new Location(145416, 115560,-3750), new Location(145048, 114680,-3750), new Location(145144, 113592,-3750), new Location(145784, 112808,-3750), new Location(146024, 112616,-3750), new Location(146792, 112520,-3750)};
							break;
						}	
						case 1:
						{
							start = true;
							points = new Location[] {new Location(147992, 112632,-3750), new Location(148712, 112904,-3750), new Location(148968, 113560,-3750), new Location(149096, 114840,-3750), new Location(148680, 115560,-3750), new Location(148184, 115864,-3750), new Location(147384, 116120,-3750), new Location(146392, 116136,-3750), new Location(145544, 115400,-3750), new Location(145128, 114696,-3750), new Location(145224, 113656,-3750), new Location(145720, 112936,-3750), new Location(146104, 112776,-3750), new Location(147032, 112808,-3750)};
							break;
						}	
						case 2:
						{
							start = true;
							points = new Location[] {new Location(148056, 112680,-3750), new Location(148648, 112984,-3750), new Location(148872, 113576,-3750), new Location(149160, 114856,-3750), new Location(148632, 115496,-3750), new Location(148200, 115896,-3750), new Location(147384, 116056,-3750), new Location(146344, 116232,-3750), new Location(145464, 115480,-3750), new Location(145224, 114648,-3750), new Location(145176, 113640,-3750), new Location(145768, 112936,-3750), new Location(146120, 112840,-3750), new Location(146872, 112696,-3750)};
							break;
						}	
						case 3:
						{
							start = true;
							points = new Location[] {new Location(148120, 112184,-3750), new Location(148808, 112760,-3750), new Location(149064, 113496,-3750), new Location(149208, 114856,-3750), new Location(148744, 115608,-3750), new Location(148200, 115960,-3750), new Location(147432, 116232, -3739), new Location(146360, 116216,-3750), new Location(145432, 115528,-3750), new Location(145176, 114664,-3750), new Location(145112, 113592,-3750), new Location(145624, 112904,-3750), new Location(146056, 112696,-3750), new Location(146824, 112568,-3750)};
							break;
						}	
						case 4:
						{
							start = true;
							points = new Location[] {new Location(148120, 111976,-3750), new Location(148888, 112648,-3750), new Location(149256, 113448,-3750), new Location(149320, 114856,-3750), new Location(148856, 115704,-3750), new Location(148296, 116088,-3750), new Location(147480, 116408, -3731), new Location(146312, 116280,-3750), new Location(145352, 115656,-3750), new Location(144936, 114712,-3750), new Location(145048, 113576,-3750), new Location(145560, 112856,-3750), new Location(146024, 112536,-3750), new Location(146760, 112424,-3750)};
							break;
						}	
					}
			}			
			if ((mob_x <= 149256 && mob_x >= 148504) && (mob_y <= 113032 && mob_y >= 111832))
			{
				int track = Rnd.get(4);
				switch(track)
					{
						case 0:
						{
							start = true;
							points = new Location[] {new Location(148952, 112520,-3750), new Location(149176, 113464,-3750), new Location(149224, 114872,-3750), new Location(148808, 115672,-3750), new Location(148232, 115992,-3750), new Location(147448, 116312, -3736), new Location(146312, 116184,-3750), new Location(145416, 115560,-3750), new Location(145048, 114680,-3750), new Location(145144, 113592,-3750), new Location(145784, 112808,-3750), new Location(146024, 112616,-3750), new Location(146792, 112520,-3750), new Location(148152, 112104,-3750)};
							break;
						}	
						case 1:
						{
							start = true;
							points = new Location[] {new Location(148712, 112904,-3750), new Location(148968, 113560,-3750), new Location(149096, 114840,-3750), new Location(148680, 115560,-3750), new Location(148184, 115864,-3750), new Location(147384, 116120,-3750), new Location(146392, 116136,-3750), new Location(145544, 115400,-3750), new Location(145128, 114696,-3750), new Location(145224, 113656,-3750), new Location(145720, 112936,-3750), new Location(146104, 112776,-3750), new Location(147032, 112808,-3750), new Location(147992, 112632,-3750)};
							break;
						}	
						case 2:
						{
							start = true;
							points = new Location[] {new Location(148648, 112984,-3750), new Location(148872, 113576,-3750), new Location(149160, 114856,-3750), new Location(148632, 115496,-3750), new Location(148200, 115896,-3750), new Location(147384, 116056,-3750), new Location(146344, 116232,-3750), new Location(145464, 115480,-3750), new Location(145224, 114648,-3750), new Location(145176, 113640,-3750), new Location(145768, 112936,-3750), new Location(146120, 112840,-3750), new Location(146872, 112696,-3750), new Location(148056, 112680,-3750)};
							break;
						}	
						case 3:
						{
							start = true;
							points = new Location[] {new Location(148808, 112760,-3750), new Location(149064, 113496,-3750), new Location(149208, 114856,-3750), new Location(148744, 115608,-3750), new Location(148200, 115960,-3750), new Location(147432, 116232, -3739), new Location(146360, 116216,-3750), new Location(145432, 115528,-3750), new Location(145176, 114664,-3750), new Location(145112, 113592,-3750), new Location(145624, 112904,-3750), new Location(146056, 112696,-3750), new Location(146824, 112568,-3750), new Location(148120, 112184,-3750)};
							break;
						}	
						case 4:
						{
							start = true;
							points = new Location[] {new Location(148888, 112648,-3750), new Location(149256, 113448,-3750), new Location(149320, 114856,-3750), new Location(148856, 115704,-3750), new Location(148296, 116088,-3750), new Location(147480, 116408, -3731), new Location(146312, 116280,-3750), new Location(145352, 115656,-3750), new Location(144936, 114712,-3750), new Location(145048, 113576,-3750), new Location(145560, 112856,-3750), new Location(146024, 112536,-3750), new Location(146760, 112424,-3750), new Location(148120, 111976,-3750)};
							break;
						}	
					}
			}			
			if ((mob_x <= 149432 && mob_x >= 148808) && (mob_y <= 113928 && mob_y >= 113208))
			{
				int track = Rnd.get(4);
				switch(track)
					{
						case 0:
						{
							start = true;
							points = new Location[] {new Location(149176, 113464,-3750), new Location(149224, 114872,-3750), new Location(148808, 115672,-3750), new Location(148232, 115992,-3750), new Location(147448, 116312, -3736), new Location(146312, 116184,-3750), new Location(145416, 115560,-3750), new Location(145048, 114680,-3750), new Location(145144, 113592,-3750), new Location(145784, 112808,-3750), new Location(146024, 112616,-3750), new Location(146792, 112520,-3750), new Location(148152, 112104,-3750), new Location(148952, 112520,-3750)};
							break;
						}	
						case 1:
						{
							start = true;
							points = new Location[] {new Location(148968, 113560,-3750), new Location(149096, 114840,-3750), new Location(148680, 115560,-3750), new Location(148184, 115864,-3750), new Location(147384, 116120,-3750), new Location(146392, 116136,-3750), new Location(145544, 115400,-3750), new Location(145128, 114696,-3750), new Location(145224, 113656,-3750), new Location(145720, 112936,-3750), new Location(146104, 112776,-3750), new Location(147032, 112808,-3750), new Location(147992, 112632,-3750), new Location(148712, 112904,-3750)};
							break;
						}	
						case 2:
						{
							start = true;
							points = new Location[] {new Location(148872, 113576,-3750), new Location(149160, 114856,-3750), new Location(148632, 115496,-3750), new Location(148200, 115896,-3750), new Location(147384, 116056,-3750), new Location(146344, 116232,-3750), new Location(145464, 115480,-3750), new Location(145224, 114648,-3750), new Location(145176, 113640,-3750), new Location(145768, 112936,-3750), new Location(146120, 112840,-3750), new Location(146872, 112696,-3750), new Location(148056, 112680,-3750), new Location(148648, 112984,-3750)};
							break;
						}	
						case 3:
						{
							start = true;
							points = new Location[] {new Location(149064, 113496,-3750), new Location(149208, 114856,-3750), new Location(148744, 115608,-3750), new Location(148200, 115960,-3750), new Location(147432, 116232, -3739), new Location(146360, 116216,-3750), new Location(145432, 115528,-3750), new Location(145176, 114664,-3750), new Location(145112, 113592,-3750), new Location(145624, 112904,-3750), new Location(146056, 112696,-3750), new Location(146824, 112568,-3750), new Location(148120, 112184,-3750), new Location(148808, 112760,-3750)};
							break;
						}	
						case 4:
						{
							start = true;
							points = new Location[] {new Location(149256, 113448,-3750), new Location(149320, 114856,-3750), new Location(148856, 115704,-3750), new Location(148296, 116088,-3750), new Location(147480, 116408, -3731), new Location(146312, 116280,-3750), new Location(145352, 115656,-3750), new Location(144936, 114712,-3750), new Location(145048, 113576,-3750), new Location(145560, 112856,-3750), new Location(146024, 112536,-3750), new Location(146760, 112424,-3750), new Location(148120, 111976,-3750), new Location(148888, 112648,-3750)};
							break;
						}	
					}
			}			
			if ((mob_x <= 149480 && mob_x >= 148904) && (mob_y <= 115352 && mob_y >= 114600))
			{
				int track = Rnd.get(4);
				switch(track)
					{
						case 0:
						{
							start = true;
							points = new Location[] {new Location(149224, 114872,-3750), new Location(148808, 115672,-3750), new Location(148232, 115992,-3750), new Location(147448, 116312, -3736), new Location(146312, 116184,-3750), new Location(145416, 115560,-3750), new Location(145048, 114680,-3750), new Location(145144, 113592,-3750), new Location(145784, 112808,-3750), new Location(146024, 112616,-3750), new Location(146792, 112520,-3750), new Location(148152, 112104,-3750), new Location(148952, 112520,-3750), new Location(149176, 113464,-3750)};
							break;
						}	
						case 1:
						{
							start = true;
							points = new Location[] {new Location(149096, 114840,-3750), new Location(148680, 115560,-3750), new Location(148184, 115864,-3750), new Location(147384, 116120,-3750), new Location(146392, 116136,-3750), new Location(145544, 115400,-3750), new Location(145128, 114696,-3750), new Location(145224, 113656,-3750), new Location(145720, 112936,-3750), new Location(146104, 112776,-3750), new Location(147032, 112808,-3750), new Location(147992, 112632,-3750), new Location(148712, 112904,-3750), new Location(148968, 113560,-3750)};
							break;
						}	
						case 2:
						{
							start = true;
							points = new Location[] {new Location(149160, 114856,-3750), new Location(148632, 115496,-3750), new Location(148200, 115896,-3750), new Location(147384, 116056,-3750), new Location(146344, 116232,-3750), new Location(145464, 115480,-3750), new Location(145224, 114648,-3750), new Location(145176, 113640,-3750), new Location(145768, 112936,-3750), new Location(146120, 112840,-3750), new Location(146872, 112696,-3750), new Location(148056, 112680,-3750), new Location(148648, 112984,-3750), new Location(148872, 113576,-3750)};
							break;
						}	
						case 3:
						{
							start = true;
							points = new Location[] {new Location(149208, 114856,-3750), new Location(148744, 115608,-3750), new Location(148200, 115960,-3750), new Location(147432, 116232, -3739), new Location(146360, 116216,-3750), new Location(145432, 115528,-3750), new Location(145176, 114664,-3750), new Location(145112, 113592,-3750), new Location(145624, 112904,-3750), new Location(146056, 112696,-3750), new Location(146824, 112568,-3750), new Location(148120, 112184,-3750), new Location(148808, 112760,-3750), new Location(149064, 113496,-3750)};
							break;
						}	
						case 4:
						{
							start = true;
							points = new Location[] {new Location(149320, 114856,-3750), new Location(148856, 115704,-3750), new Location(148296, 116088,-3750), new Location(147480, 116408, -3731), new Location(146312, 116280,-3750), new Location(145352, 115656,-3750), new Location(144936, 114712,-3750), new Location(145048, 113576,-3750), new Location(145560, 112856,-3750), new Location(146024, 112536,-3750), new Location(146760, 112424,-3750), new Location(148120, 111976,-3750), new Location(148888, 112648,-3750), new Location(149256, 113448,-3750)};
							break;
						}	
					}
			}			
			if ((mob_x <= 149320 && mob_x >= 148472) && (mob_y <= 116040 && mob_y >= 115256))
			{
				int track = Rnd.get(4);
				switch(track)
					{
						case 0:
						{
							start = true;
							points = new Location[] {new Location(148808, 115672,-3750), new Location(148232, 115992,-3750), new Location(147448, 116312, -3736), new Location(146312, 116184,-3750), new Location(145416, 115560,-3750), new Location(145048, 114680,-3750), new Location(145144, 113592,-3750), new Location(145784, 112808,-3750), new Location(146024, 112616,-3750), new Location(146792, 112520,-3750), new Location(148152, 112104,-3750), new Location(148952, 112520,-3750), new Location(149176, 113464,-3750), new Location(149224, 114872,-3750)};
							break;
						}	
						case 1:
						{
							start = true;
							points = new Location[] {new Location(148680, 115560,-3750), new Location(148184, 115864,-3750), new Location(147384, 116120,-3750), new Location(146392, 116136,-3750), new Location(145544, 115400,-3750), new Location(145128, 114696,-3750), new Location(145224, 113656,-3750), new Location(145720, 112936,-3750), new Location(146104, 112776,-3750), new Location(147032, 112808,-3750), new Location(147992, 112632,-3750), new Location(148712, 112904,-3750), new Location(148968, 113560,-3750), new Location(149096, 114840,-3750)};
							break;
						}	
						case 2:
						{
							start = true;
							points = new Location[] {new Location(148632, 115496,-3750), new Location(148200, 115896,-3750), new Location(147384, 116056,-3750), new Location(146344, 116232,-3750), new Location(145464, 115480,-3750), new Location(145224, 114648,-3750), new Location(145176, 113640,-3750), new Location(145768, 112936,-3750), new Location(146120, 112840,-3750), new Location(146872, 112696,-3750), new Location(148056, 112680,-3750), new Location(148648, 112984,-3750), new Location(148872, 113576,-3750), new Location(149160, 114856,-3750)};
							break;
						}	
						case 3:
						{
							start = true;
							points = new Location[] {new Location(148744, 115608,-3750), new Location(148200, 115960,-3750), new Location(147432, 116232, -3739), new Location(146360, 116216,-3750), new Location(145432, 115528,-3750), new Location(145176, 114664,-3750), new Location(145112, 113592,-3750), new Location(145624, 112904,-3750), new Location(146056, 112696,-3750), new Location(146824, 112568,-3750), new Location(148120, 112184,-3750), new Location(148808, 112760,-3750), new Location(149064, 113496,-3750), new Location(149208, 114856,-3750)};
							break;
						}	
						case 4:
						{
							start = true;
							points = new Location[] {new Location(148856, 115704,-3750), new Location(148296, 116088,-3750), new Location(147480, 116408, -3731), new Location(146312, 116280,-3750), new Location(145352, 115656,-3750), new Location(144936, 114712,-3750), new Location(145048, 113576,-3750), new Location(145560, 112856,-3750), new Location(146024, 112536,-3750), new Location(146760, 112424,-3750), new Location(148120, 111976,-3750), new Location(148888, 112648,-3750), new Location(149256, 113448,-3750), new Location(149320, 114856,-3750)};
							break;
						}	
					}
			}			
			if ((mob_x <= 148600 && mob_x >= 147960) && (mob_y <= 116344 && mob_y >= 115736))
			{
				int track = Rnd.get(4);
				switch(track)
					{
						case 0:
						{
							start = true;
							points = new Location[] {new Location(148232, 115992,-3750), new Location(147448, 116312, -3736), new Location(146312, 116184,-3750), new Location(145416, 115560,-3750), new Location(145048, 114680,-3750), new Location(145144, 113592,-3750), new Location(145784, 112808,-3750), new Location(146024, 112616,-3750), new Location(146792, 112520,-3750), new Location(148152, 112104,-3750), new Location(148952, 112520,-3750), new Location(149176, 113464,-3750), new Location(149224, 114872,-3750), new Location(148808, 115672,-3750)};
							break;
						}	
						case 1:
						{
							start = true;
							points = new Location[] {new Location(148184, 115864,-3750), new Location(147384, 116120,-3750), new Location(146392, 116136,-3750), new Location(145544, 115400,-3750), new Location(145128, 114696,-3750), new Location(145224, 113656,-3750), new Location(145720, 112936,-3750), new Location(146104, 112776,-3750), new Location(147032, 112808,-3750), new Location(147992, 112632,-3750), new Location(148712, 112904,-3750), new Location(148968, 113560,-3750), new Location(149096, 114840,-3750), new Location(148680, 115560,-3750)};
							break;
						}	
						case 2:
						{
							start = true;
							points = new Location[] {new Location(148200, 115896,-3750), new Location(147384, 116056,-3750), new Location(146344, 116232,-3750), new Location(145464, 115480,-3750), new Location(145224, 114648,-3750), new Location(145176, 113640,-3750), new Location(145768, 112936,-3750), new Location(146120, 112840,-3750), new Location(146872, 112696,-3750), new Location(148056, 112680,-3750), new Location(148648, 112984,-3750), new Location(148872, 113576,-3750), new Location(149160, 114856,-3750), new Location(148632, 115496,-3750)};
							break;
						}	
						case 3:
						{
							start = true;
							points = new Location[] {new Location(148200, 115960,-3750), new Location(147432, 116232, -3739), new Location(146360, 116216,-3750), new Location(145432, 115528,-3750), new Location(145176, 114664,-3750), new Location(145112, 113592,-3750), new Location(145624, 112904,-3750), new Location(146056, 112696,-3750), new Location(146824, 112568,-3750), new Location(148120, 112184,-3750), new Location(148808, 112760,-3750), new Location(149064, 113496,-3750), new Location(149208, 114856,-3750), new Location(148744, 115608,-3750)};
							break;
						}	
						case 4:
						{
							start = true;
							points = new Location[] {new Location(148296, 116088,-3750), new Location(147480, 116408, -3731), new Location(146312, 116280,-3750), new Location(145352, 115656,-3750), new Location(144936, 114712,-3750), new Location(145048, 113576,-3750), new Location(145560, 112856,-3750), new Location(146024, 112536,-3750), new Location(146760, 112424,-3750), new Location(148120, 111976,-3750), new Location(148888, 112648,-3750), new Location(149256, 113448,-3750), new Location(149320, 114856,-3750), new Location(148856, 115704,-3750)};
							break;
						}	
					}
			}			
			if ((mob_x <= 147896 && mob_x >= 147144) && (mob_y <= 116712 && mob_y >= 115912))
			{
				int track = Rnd.get(4);
				switch(track)
					{
						case 0:
						{
							start = true;
							points = new Location[] {new Location(147448, 116312, -3736), new Location(146312, 116184,-3750), new Location(145416, 115560,-3750), new Location(145048, 114680,-3750), new Location(145144, 113592,-3750), new Location(145784, 112808,-3750), new Location(146024, 112616,-3750), new Location(146792, 112520,-3750), new Location(148152, 112104,-3750), new Location(148952, 112520,-3750), new Location(149176, 113464,-3750), new Location(149224, 114872,-3750), new Location(148808, 115672,-3750), new Location(148232, 115992,-3750)};
							break;
						}	
						case 1:
						{
							start = true;
							points = new Location[] {new Location(147384, 116120,-3750), new Location(146392, 116136,-3750), new Location(145544, 115400,-3750), new Location(145128, 114696,-3750), new Location(145224, 113656,-3750), new Location(145720, 112936,-3750), new Location(146104, 112776,-3750), new Location(147032, 112808,-3750), new Location(147992, 112632,-3750), new Location(148712, 112904,-3750), new Location(148968, 113560,-3750), new Location(149096, 114840,-3750), new Location(148680, 115560,-3750), new Location(148184, 115864,-3750)};
							break;
						}	
						case 2:
						{
							start = true;
							points = new Location[] {new Location(147384, 116056,-3750), new Location(146344, 116232,-3750), new Location(145464, 115480,-3750), new Location(145224, 114648,-3750), new Location(145176, 113640,-3750), new Location(145768, 112936,-3750), new Location(146120, 112840,-3750), new Location(146872, 112696,-3750), new Location(148056, 112680,-3750), new Location(148648, 112984,-3750), new Location(148872, 113576,-3750), new Location(149160, 114856,-3750), new Location(148632, 115496,-3750), new Location(148200, 115896,-3750)};
							break;
						}	
						case 3:
						{
							start = true;
							points = new Location[] {new Location(147432, 116232, -3739), new Location(146360, 116216,-3750), new Location(145432, 115528,-3750), new Location(145176, 114664,-3750), new Location(145112, 113592,-3750), new Location(145624, 112904,-3750), new Location(146056, 112696,-3750), new Location(146824, 112568,-3750), new Location(148120, 112184,-3750), new Location(148808, 112760,-3750), new Location(149064, 113496,-3750), new Location(149208, 114856,-3750), new Location(148744, 115608,-3750), new Location(148200, 115960,-3750)};
							break;
						}	
						case 4:
						{
							start = true;
							points = new Location[] {new Location(147480, 116408, -3731), new Location(146312, 116280,-3750), new Location(145352, 115656,-3750), new Location(144936, 114712,-3750), new Location(145048, 113576,-3750), new Location(145560, 112856,-3750), new Location(146024, 112536,-3750), new Location(146760, 112424,-3750), new Location(148120, 111976,-3750), new Location(148888, 112648,-3750), new Location(149256, 113448,-3750), new Location(149320, 114856,-3750), new Location(148856, 115704,-3750), new Location(148296, 116088,-3750)};
							break;
						}	
					}
			}			
			if ((mob_x <= 146680 && mob_x >= 145928) && (mob_y <= 116552 && mob_y >= 115832))
			{
				int track = Rnd.get(4);
				switch(track)
					{
						case 0:
						{
							start = true;
							points = new Location[] {new Location(146312, 116184,-3750), new Location(145416, 115560,-3750), new Location(145048, 114680,-3750), new Location(145144, 113592,-3750), new Location(145784, 112808,-3750), new Location(146024, 112616,-3750), new Location(146792, 112520,-3750), new Location(148152, 112104,-3750), new Location(148952, 112520,-3750), new Location(149176, 113464,-3750), new Location(149224, 114872,-3750), new Location(148808, 115672,-3750), new Location(148232, 115992,-3750), new Location(147448, 116312, -3736)};
							break;
						}	
						case 1:
						{
							start = true;
							points = new Location[] {new Location(146392, 116136,-3750), new Location(145544, 115400,-3750), new Location(145128, 114696,-3750), new Location(145224, 113656,-3750), new Location(145720, 112936,-3750), new Location(146104, 112776,-3750), new Location(147032, 112808,-3750), new Location(147992, 112632,-3750), new Location(148712, 112904,-3750), new Location(148968, 113560,-3750), new Location(149096, 114840,-3750), new Location(148680, 115560,-3750), new Location(148184, 115864,-3750), new Location(147384, 116120,-3750)};
							break;
						}	
						case 2:
						{
							start = true;
							points = new Location[] {new Location(146344, 116232,-3750), new Location(145464, 115480,-3750), new Location(145224, 114648,-3750), new Location(145176, 113640,-3750), new Location(145768, 112936,-3750), new Location(146120, 112840,-3750), new Location(146872, 112696,-3750), new Location(148056, 112680,-3750), new Location(148648, 112984,-3750), new Location(148872, 113576,-3750), new Location(149160, 114856,-3750), new Location(148632, 115496,-3750), new Location(148200, 115896,-3750), new Location(147384, 116056,-3750)};
							break;
						}	
						case 3:
						{
							start = true;
							points = new Location[] {new Location(146360, 116216,-3750), new Location(145432, 115528,-3750), new Location(145176, 114664,-3750), new Location(145112, 113592,-3750), new Location(145624, 112904,-3750), new Location(146056, 112696,-3750), new Location(146824, 112568,-3750), new Location(148120, 112184,-3750), new Location(148808, 112760,-3750), new Location(149064, 113496,-3750), new Location(149208, 114856,-3750), new Location(148744, 115608,-3750), new Location(148200, 115960,-3750), new Location(147432, 116232, -3739)};
							break;
						}	
						case 4:
						{
							start = true;
							points = new Location[] {new Location(146312, 116280,-3750), new Location(145352, 115656,-3750), new Location(144936, 114712,-3750), new Location(145048, 113576,-3750), new Location(145560, 112856,-3750), new Location(146024, 112536,-3750), new Location(146760, 112424,-3750), new Location(148120, 111976,-3750), new Location(148888, 112648,-3750), new Location(149256, 113448,-3750), new Location(149320, 114856,-3750), new Location(148856, 115704,-3750), new Location(148296, 116088,-3750), new Location(147480, 116408, -3731)};
							break;
						}	
					}
			}			
			if ((mob_x <= 145784 && mob_x >= 144776) && (mob_y <= 116056 && mob_y >= 115048))
			{
				int track = Rnd.get(4);
				switch(track)
					{
						case 0:
						{
							start = true;
							points = new Location[] {new Location(145416, 115560,-3750), new Location(145048, 114680,-3750), new Location(145144, 113592,-3750), new Location(145784, 112808,-3750), new Location(146024, 112616,-3750), new Location(146792, 112520,-3750), new Location(148152, 112104,-3750), new Location(148952, 112520,-3750), new Location(149176, 113464,-3750), new Location(149224, 114872,-3750), new Location(148808, 115672,-3750), new Location(148232, 115992,-3750), new Location(147448, 116312, -3736), new Location(146312, 116184,-3750)};
							break;
						}	
						case 1:
						{
							start = true;
							points = new Location[] {new Location(145544, 115400,-3750), new Location(145128, 114696,-3750), new Location(145224, 113656,-3750), new Location(145720, 112936,-3750), new Location(146104, 112776,-3750), new Location(147032, 112808,-3750), new Location(147992, 112632,-3750), new Location(148712, 112904,-3750), new Location(148968, 113560,-3750), new Location(149096, 114840,-3750), new Location(148680, 115560,-3750), new Location(148184, 115864,-3750), new Location(147384, 116120,-3750), new Location(146392, 116136,-3750)};
							break;
						}	
						case 2:
						{
							start = true;
							points = new Location[] {new Location(145464, 115480,-3750), new Location(145224, 114648,-3750), new Location(145176, 113640,-3750), new Location(145768, 112936,-3750), new Location(146120, 112840,-3750), new Location(146872, 112696,-3750), new Location(148056, 112680,-3750), new Location(148648, 112984,-3750), new Location(148872, 113576,-3750), new Location(149160, 114856,-3750), new Location(148632, 115496,-3750), new Location(148200, 115896,-3750), new Location(147384, 116056,-3750), new Location(146344, 116232,-3750)};
							break;
						}	
						case 3:
						{
							start = true;
							points = new Location[] {new Location(145432, 115528,-3750), new Location(145176, 114664,-3750), new Location(145112, 113592,-3750), new Location(145624, 112904,-3750), new Location(146056, 112696,-3750), new Location(146824, 112568,-3750), new Location(148120, 112184,-3750), new Location(148808, 112760,-3750), new Location(149064, 113496,-3750), new Location(149208, 114856,-3750), new Location(148744, 115608,-3750), new Location(148200, 115960,-3750), new Location(147432, 116232, -3739), new Location(146360, 116216,-3750)};
							break;
						}	
						case 4:
						{
							start = true;
							points = new Location[] {new Location(145352, 115656,-3750), new Location(144936, 114712,-3750), new Location(145048, 113576,-3750), new Location(145560, 112856,-3750), new Location(146024, 112536,-3750), new Location(146760, 112424,-3750), new Location(148120, 111976,-3750), new Location(148888, 112648,-3750), new Location(149256, 113448,-3750), new Location(149320, 114856,-3750), new Location(148856, 115704,-3750), new Location(148296, 116088,-3750), new Location(147480, 116408, -3731), new Location(146312, 116280,-3750)};
							break;
						}	
					}
			}			
			if ((mob_x <= 145240 && mob_x >= 144648) && (mob_y <= 115096 && mob_y >= 114216))
			{
				int track = Rnd.get(4);
				switch(track)
					{
						case 0:
						{
							start = true;
							points = new Location[] {new Location(145048, 114680,-3750), new Location(145144, 113592,-3750), new Location(145784, 112808,-3750), new Location(146024, 112616,-3750), new Location(146792, 112520,-3750), new Location(148152, 112104,-3750), new Location(148952, 112520,-3750), new Location(149176, 113464,-3750), new Location(149224, 114872,-3750), new Location(148808, 115672,-3750), new Location(148232, 115992,-3750), new Location(147448, 116312, -3736), new Location(146312, 116184,-3750), new Location(145416, 115560,-3750)};
							break;
						}	
						case 1:
						{
							start = true;
							points = new Location[] {new Location(145128, 114696,-3750), new Location(145224, 113656,-3750), new Location(145720, 112936,-3750), new Location(146104, 112776,-3750), new Location(147032, 112808,-3750), new Location(147992, 112632,-3750), new Location(148712, 112904,-3750), new Location(148968, 113560,-3750), new Location(149096, 114840,-3750), new Location(148680, 115560,-3750), new Location(148184, 115864,-3750), new Location(147384, 116120,-3750), new Location(146392, 116136,-3750), new Location(145544, 115400,-3750)};
							break;
						}	
						case 2:
						{
							start = true;
							points = new Location[] {new Location(145224, 114648,-3750), new Location(145176, 113640,-3750), new Location(145768, 112936,-3750), new Location(146120, 112840,-3750), new Location(146872, 112696,-3750), new Location(148056, 112680,-3750), new Location(148648, 112984,-3750), new Location(148872, 113576,-3750), new Location(149160, 114856,-3750), new Location(148632, 115496,-3750), new Location(148200, 115896,-3750), new Location(147384, 116056,-3750), new Location(146344, 116232,-3750), new Location(145464, 115480,-3750)};
							break;
						}	
						case 3:
						{
							start = true;
							points = new Location[] {new Location(145176, 114664,-3750), new Location(145112, 113592,-3750), new Location(145624, 112904,-3750), new Location(146056, 112696,-3750), new Location(146824, 112568,-3750), new Location(148120, 112184,-3750), new Location(148808, 112760,-3750), new Location(149064, 113496,-3750), new Location(149208, 114856,-3750), new Location(148744, 115608,-3750), new Location(148200, 115960,-3750), new Location(147432, 116232, -3739), new Location(146360, 116216,-3750), new Location(145432, 115528,-3750)};
							break;
						}	
						case 4:
						{
							start = true;
							points = new Location[] {new Location(144936, 114712,-3750), new Location(145048, 113576,-3750), new Location(145560, 112856,-3750), new Location(146024, 112536,-3750), new Location(146760, 112424,-3750), new Location(148120, 111976,-3750), new Location(148888, 112648,-3750), new Location(149256, 113448,-3750), new Location(149320, 114856,-3750), new Location(148856, 115704,-3750), new Location(148296, 116088,-3750), new Location(147480, 116408, -3731), new Location(146312, 116280,-3750), new Location(145352, 115656,-3750)};
							break;
						}	
					}
			}			
			if ((mob_x <= 145320 && mob_x >= 144904) && (mob_y <= 113864 && mob_y >= 113512))
			{
				int track = Rnd.get(4);
				switch(track)
					{
						case 0:
						{
							start = true;
							points = new Location[] {new Location(145144, 113592,-3750), new Location(145784, 112808,-3750), new Location(146024, 112616,-3750), new Location(146792, 112520,-3750), new Location(148152, 112104,-3750), new Location(148952, 112520,-3750), new Location(149176, 113464,-3750), new Location(149224, 114872,-3750), new Location(148808, 115672,-3750), new Location(148232, 115992,-3750), new Location(147448, 116312, -3736), new Location(146312, 116184,-3750), new Location(145416, 115560,-3750), new Location(145048, 114680,-3750)};
							break;
						}	
						case 1:
						{
							start = true;
							points = new Location[] {new Location(145224, 113656,-3750), new Location(145720, 112936,-3750), new Location(146104, 112776,-3750), new Location(147032, 112808,-3750), new Location(147992, 112632,-3750), new Location(148712, 112904,-3750), new Location(148968, 113560,-3750), new Location(149096, 114840,-3750), new Location(148680, 115560,-3750), new Location(148184, 115864,-3750), new Location(147384, 116120,-3750), new Location(146392, 116136,-3750), new Location(145544, 115400,-3750), new Location(145128, 114696,-3750)};
							break;
						}	
						case 2:
						{
							start = true;
							points = new Location[] {new Location(145176, 113640,-3750), new Location(145768, 112936,-3750), new Location(146120, 112840,-3750), new Location(146872, 112696,-3750), new Location(148056, 112680,-3750), new Location(148648, 112984,-3750), new Location(148872, 113576,-3750), new Location(149160, 114856,-3750), new Location(148632, 115496,-3750), new Location(148200, 115896,-3750), new Location(147384, 116056,-3750), new Location(146344, 116232,-3750), new Location(145464, 115480,-3750), new Location(145224, 114648,-3750)};
							break;
						}	
						case 3:
						{
							start = true;
							points = new Location[] {new Location(145112, 113592,-3750), new Location(145624, 112904,-3750), new Location(146056, 112696,-3750), new Location(146824, 112568,-3750), new Location(148120, 112184,-3750), new Location(148808, 112760,-3750), new Location(149064, 113496,-3750), new Location(149208, 114856,-3750), new Location(148744, 115608,-3750), new Location(148200, 115960,-3750), new Location(147432, 116232, -3739), new Location(146360, 116216,-3750), new Location(145432, 115528,-3750), new Location(145176, 114664,-3750)};
							break;
						}	
						case 4:
						{
							start = true;
							points = new Location[] {new Location(145048, 113576,-3750), new Location(145560, 112856,-3750), new Location(146024, 112536,-3750), new Location(146760, 112424,-3750), new Location(148120, 111976,-3750), new Location(148888, 112648,-3750), new Location(149256, 113448,-3750), new Location(149320, 114856,-3750), new Location(148856, 115704,-3750), new Location(148296, 116088,-3750), new Location(147480, 116408, -3731), new Location(146312, 116280,-3750), new Location(145352, 115656,-3750), new Location(144936, 114712,-3750)};
							break;
						}	
					}
			}			
			if ((mob_x <= 145928 && mob_x >= 145256) && (mob_y <= 113320 && mob_y >= 112616))
			{
				int track = Rnd.get(4);
				switch(track)
					{
						case 0:
						{
							start = true;
							points = new Location[] {new Location(145784, 112808,-3750), new Location(146024, 112616,-3750), new Location(146792, 112520,-3750), new Location(148152, 112104,-3750), new Location(148952, 112520,-3750), new Location(149176, 113464,-3750), new Location(149224, 114872,-3750), new Location(148808, 115672,-3750), new Location(148232, 115992,-3750), new Location(147448, 116312, -3736), new Location(146312, 116184,-3750), new Location(145416, 115560,-3750), new Location(145048, 114680,-3750), new Location(145144, 113592,-3750)};
							break;
						}	
						case 1:
						{
							start = true;
							points = new Location[] {new Location(145720, 112936,-3750), new Location(146104, 112776,-3750), new Location(147032, 112808,-3750), new Location(147992, 112632,-3750), new Location(148712, 112904,-3750), new Location(148968, 113560,-3750), new Location(149096, 114840,-3750), new Location(148680, 115560,-3750), new Location(148184, 115864,-3750), new Location(147384, 116120,-3750), new Location(146392, 116136,-3750), new Location(145544, 115400,-3750), new Location(145128, 114696,-3750), new Location(145224, 113656,-3750)};
							break;
						}	
						case 2:
						{
							start = true;
							points = new Location[] {new Location(145768, 112936,-3750), new Location(146120, 112840,-3750), new Location(146872, 112696,-3750), new Location(148056, 112680,-3750), new Location(148648, 112984,-3750), new Location(148872, 113576,-3750), new Location(149160, 114856,-3750), new Location(148632, 115496,-3750), new Location(148200, 115896,-3750), new Location(147384, 116056,-3750), new Location(146344, 116232,-3750), new Location(145464, 115480,-3750), new Location(145224, 114648,-3750), new Location(145176, 113640,-3750)};
							break;
						}	
						case 3:
						{
							start = true;
							points = new Location[] {new Location(145624, 112904,-3750), new Location(146056, 112696,-3750), new Location(146824, 112568,-3750), new Location(148120, 112184,-3750), new Location(148808, 112760,-3750), new Location(149064, 113496,-3750), new Location(149208, 114856,-3750), new Location(148744, 115608,-3750), new Location(148200, 115960,-3750), new Location(147432, 116232, -3739), new Location(146360, 116216,-3750), new Location(145432, 115528,-3750), new Location(145176, 114664,-3750), new Location(145112, 113592,-3750)};
							break;
						}	
						case 4:
						{
							start = true;
							points = new Location[] {new Location(145560, 112856,-3750), new Location(146024, 112536,-3750), new Location(146760, 112424,-3750), new Location(148120, 111976,-3750), new Location(148888, 112648,-3750), new Location(149256, 113448,-3750), new Location(149320, 114856,-3750), new Location(148856, 115704,-3750), new Location(148296, 116088,-3750), new Location(147480, 116408, -3731), new Location(146312, 116280,-3750), new Location(145352, 115656,-3750), new Location(144936, 114712,-3750), new Location(145048, 113576,-3750)};
							break;
						}	
					}
			}		
			if ((mob_x <= 146232 && mob_x >= 145768) && (mob_y <= 112904 && mob_y >= 112408))
			{
				int track = Rnd.get(4);
				switch(track)
					{
						case 0:
						{
							start = true;
							points = new Location[] {new Location(146024, 112616,-3750), new Location(146792, 112520,-3750), new Location(148152, 112104,-3750), new Location(148952, 112520,-3750), new Location(149176, 113464,-3750), new Location(149224, 114872,-3750), new Location(148808, 115672,-3750), new Location(148232, 115992,-3750), new Location(147448, 116312, -3736), new Location(146312, 116184,-3750), new Location(145416, 115560,-3750), new Location(145048, 114680,-3750), new Location(145144, 113592,-3750), new Location(145784, 112808,-3750)};
							break;
						}	
						case 1:
						{
							start = true;
							points = new Location[] {new Location(146104, 112776,-3750), new Location(147032, 112808,-3750), new Location(147992, 112632,-3750), new Location(148712, 112904,-3750), new Location(148968, 113560,-3750), new Location(149096, 114840,-3750), new Location(148680, 115560,-3750), new Location(148184, 115864,-3750), new Location(147384, 116120,-3750), new Location(146392, 116136,-3750), new Location(145544, 115400,-3750), new Location(145128, 114696,-3750), new Location(145224, 113656,-3750), new Location(145720, 112936,-3750)};
							break;
						}	
						case 2:
						{
							start = true;
							points = new Location[] {new Location(146120, 112840,-3750), new Location(146872, 112696,-3750), new Location(148056, 112680,-3750), new Location(148648, 112984,-3750), new Location(148872, 113576,-3750), new Location(149160, 114856,-3750), new Location(148632, 115496,-3750), new Location(148200, 115896,-3750), new Location(147384, 116056,-3750), new Location(146344, 116232,-3750), new Location(145464, 115480,-3750), new Location(145224, 114648,-3750), new Location(145176, 113640,-3750), new Location(145768, 112936,-3750)};
							break;
						}	
						case 3:
						{
							start = true;
							points = new Location[] {new Location(146056, 112696,-3750), new Location(146824, 112568,-3750), new Location(148120, 112184,-3750), new Location(148808, 112760,-3750), new Location(149064, 113496,-3750), new Location(149208, 114856,-3750), new Location(148744, 115608,-3750), new Location(148200, 115960,-3750), new Location(147432, 116232, -3739), new Location(146360, 116216,-3750), new Location(145432, 115528,-3750), new Location(145176, 114664,-3750), new Location(145112, 113592,-3750), new Location(145624, 112904,-3750)};
							break;
						}	
						case 4:
						{
							start = true;
							points = new Location[] {new Location(146024, 112536,-3750), new Location(146760, 112424,-3750), new Location(148120, 111976,-3750), new Location(148888, 112648,-3750), new Location(149256, 113448,-3750), new Location(149320, 114856,-3750), new Location(148856, 115704,-3750), new Location(148296, 116088,-3750), new Location(147480, 116408, -3731), new Location(146312, 116280,-3750), new Location(145352, 115656,-3750), new Location(144936, 114712,-3750), new Location(145048, 113576,-3750), new Location(145560, 112856,-3750)};
							break;
						}	
					}
			}	
		}
		
		if(_def_think)
		{
			doTask();
			return true;
		}
			
		if(points == null)
			return true;

        if(!last)
            current_point++;

		if(current_point >= points.length)
            last = true;

        if(last)
		{
            current_point = 0;
            last = false;
		}	
			
        actor.setWalking();

		addTaskMove(points[current_point], false);
		doTask();
		return true;
	}
	
	@Override
	protected void onEvtDead(L2Character killer)
	{
        start = false;
        points = null;
        current_point = -1;
		super.onEvtDead(killer);
	}
	
}
