package ai;

import l2ft.gameserver.ai.CtrlIntention;
import l2ft.gameserver.ai.Mystic;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.util.Rnd;

public class FreyaDefault extends Mystic
{
	public FreyaDefault(L2Character actor)
	{
		super(actor);
		AI_TASK_DELAY = 1000;
		AI_TASK_ACTIVE_DELAY = 1000;
	}

	@Override
	protected boolean thinkActive()
	{
		L2NpcInstance actor = getActor();
		if(actor == null)
			return true;
		if(getIntention() == CtrlIntention.AI_INTENTION_ACTIVE)
		{
			for(L2NpcInstance mob : actor.getReflection().getMonsters())
			{
				System.out.println();
				if(mob != null)
				{
					if(mob.isDead())
						continue;
					if(mob.getNpcId() == 22767)
						continue;
					if(Rnd.getRnd(600000))
						continue;
					mob.addDamageHate(actor, 0, 100); // Это нужно, чтобы гвард не перестал атаковать цель после первых ударов
					actor.setRunning(); // Включаем бег...
					actor.setAttackTimeout(Integer.MAX_VALUE + System.currentTimeMillis()); // Это нужно, чтобы не сработал таймаут
					actor.getAI().setAttackTarget(mob); // На всякий случай, не обязательно делать
					actor.getAI().changeIntention(CtrlIntention.AI_INTENTION_ATTACK, mob, null); // Переводим в состояние атаки
					actor.getAI().addTaskAttack(mob); // Добавляем отложенное задание атаки, сработает в самом конце движения
					return true;
				}
			}
		}
		return true;
	}

	@Override
	public void onIntentionAttack(L2Character target)
	{
		L2NpcInstance actor = getActor();
		if(actor == null)
			return;
		if(target.getNpcId() == 22767)
		{
			setIntention(CtrlIntention.AI_INTENTION_ACTIVE);
			return;
		}
		super.onIntentionAttack(target);
	}
	
	@Override
	public boolean isGlobalAI()
	{
		return true;
	}

	public boolean isNotReturnHome()
	{
		return true;
	}
}