package ai;

import l2ft.gameserver.ai.CtrlIntention;
import l2ft.gameserver.ai.Fighter;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.util.Rnd;

public class FreyaGuard extends Fighter
{
	public FreyaGuard(L2Character actor)
	{
		super(actor);
		AI_TASK_DELAY = 100;
		AI_TASK_ACTIVE_DELAY = 100;
	}

	@Override
	protected boolean thinkActive()
	{
		L2NpcInstance actor = getActor();
		if(actor == null)
			return true;
		if(getIntention() == CtrlIntention.AI_INTENTION_ACTIVE)
		{
			if(actor.getNpcId() == 18854 || actor.getNpcId() == 18855 || actor.getNpcId() == 18856)
			{
				for(L2Player player : actor.getReflection().getPlayers())
				{
					if(player != null)
					{
						if(player.isDead())
							continue;
						if(Rnd.getRnd(600000))
							continue;
						player.addDamageHate(actor, 0, Rnd.get(50, 150)); // Это нужно, чтобы гвард не перестал атаковать цель после первых ударов
						actor.setRunning(); // Включаем бег...
						actor.setAttackTimeout(Integer.MAX_VALUE + System.currentTimeMillis()); // Это нужно, чтобы не сработал таймаут
						actor.getAI().setAttackTarget(player); // На всякий случай, не обязательно делать
						actor.getAI().changeIntention(CtrlIntention.AI_INTENTION_ATTACK, player, null); // Переводим в состояние атаки
						actor.getAI().addTaskAttack(player); // Добавляем отложенное задание атаки, сработает в самом конце движения
						return true;
					}
				}
			}
		}
		return true;
	}

	@Override
	public void onIntentionAttack(L2Character target)
	{
		L2NpcInstance actor = getActor();
		if(actor == null)
			return;
		if(target.getNpcId() == 18855 || target.getNpcId() == 18856 || target.getNpcId() == 18854 || target.getNpcId() == 25699 || target.getNpcId() == 25700 || target.getNpcId() == 18853 || target.getNpcId() == 29179 || target.getNpcId() == 29180 || target.getNpcId() == 29177 || target.getNpcId() == 29178)
		{
			setIntention(CtrlIntention.AI_INTENTION_ACTIVE);
			return;
		}
		super.onIntentionAttack(target);
	}

	@Override
	public boolean isGlobalAI()
	{
		return true;
	}

	public boolean isNotReturnHome()
	{
		return true;
	}
}