package ai;

import l2ft.extensions.scripts.Functions;
import l2ft.gameserver.ai.DefaultAI;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.L2World;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.util.Location;

public class Gumiel extends DefaultAI
{
	private Location[] points = null;
	private boolean stop = false;
	public Gumiel(L2Character actor)
	{
		super(actor);
		AI_TASK_DELAY = 1500;
		AI_TASK_ACTIVE_DELAY = 1500;
	}

	@Override
	public boolean isGlobalAI()
	{
		return true;
	}
	
	@Override
	protected boolean randomWalk()
	{
		return false;
	}
	
	@Override
	protected void onEvtSpawn()
	{
		stop = false;
	}
	
	@Override
	protected boolean thinkActive()
	{
		L2NpcInstance actor = getActor();
		if(actor == null || actor.isDead())
			return true;
			
		if (stop == false) {	
		
			int x = 0;
			int y = 0;
			int z = 0;
			
			if(DefaultAI.namechar != null) {
				L2Player pc = L2World.getPlayer(DefaultAI.namechar);
				
				if (pc != null) {
					x = pc.getX();
					y = pc.getY();
					z = pc.getZ();
					
					points = new Location[] {new Location(x,y,z)};
					addTaskMove(points[0], false);	
					doTask();
					if(actor.getX() > 107000 && actor.getX() < 108300) {
						if (actor.getY() < -87300 && actor.getY() > -88300) {
						stop = true;
						Functions.npcSay(actor, "Наконец то мы пришли! Получите награду!");
						}	
					}
					points = null;				
					return true;
				}
				
			}
		
		}
		return false;
	}

}