package ai;

import l2ft.gameserver.ai.CtrlIntention;
import l2ft.gameserver.ai.Fighter;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.util.Rnd;

public class JiniaGuard extends Fighter
{
	public JiniaGuard(L2Character actor)
	{
		super(actor);
		AI_TASK_DELAY = 1000;
		AI_TASK_ACTIVE_DELAY = 1000;
	}

	@Override
	protected boolean thinkActive()
	{
		L2NpcInstance actor = getActor();
		if(actor == null)
			return true;
		if(getIntention() == CtrlIntention.AI_INTENTION_ACTIVE)
		{
			if(actor.getNpcId() == 22767)
			{
				for(L2NpcInstance mob : actor.getReflection().getMonsters())
				{
					if(mob != null)
					{
						if(mob.isDead())
							continue;
						if(mob.getNpcId() == 22767 || mob.getNpcId() == 18847)
							continue;
						if(Rnd.getRnd(600000))
							continue;
						mob.addDamageHate(actor, 0, Rnd.get(50, 150)); // Это нужно, чтобы гвард не перестал атаковать цель после первых ударов
						actor.setRunning(); // Включаем бег...
						actor.setAttackTimeout(Integer.MAX_VALUE + System.currentTimeMillis()); // Это нужно, чтобы не сработал таймаут
						actor.getAI().setAttackTarget(mob); // На всякий случай, не обязательно делать
						actor.getAI().changeIntention(CtrlIntention.AI_INTENTION_ATTACK, mob, null); // Переводим в состояние атаки
						actor.getAI().addTaskAttack(mob); // Добавляем отложенное задание атаки, сработает в самом конце движения
						return true;
					}
				}
			}
			else
			{
				for(L2NpcInstance mob : actor.getReflection().getMonsters())
				{
					if(mob != null)
					{
						if(mob.isDead())
							continue;
						if(mob.getNpcId() == 18848 || mob.getNpcId() == 18849 || mob.getNpcId() == 18926 || mob.isPlayer())
							continue;
						if(Rnd.getRnd(600000))
							continue;
						mob.addDamageHate(actor, 0, Rnd.get(50, 150)); // Это нужно, чтобы гвард не перестал атаковать цель после первых ударов
						actor.setRunning();
						actor.setAttackTimeout(Integer.MAX_VALUE + System.currentTimeMillis()); // Это нужно, чтобы не сработал таймаут
						actor.getAI().setAttackTarget(mob); // На всякий случай, не обязательно делать
						actor.getAI().changeIntention(CtrlIntention.AI_INTENTION_ATTACK, mob, null); // Переводим в состояние атаки
						actor.getAI().addTaskAttack(mob); // Добавляем отложенное задание атаки, сработает в самом конце движения
						return true;
					}
				}
			}
		}
		return true;
	}

	@Override
	public void onIntentionAttack(L2Character target)
	{
		L2NpcInstance actor = getActor();
		if(actor == null)
			return;
		if(actor.getNpcId() == 18848 || actor.getNpcId() == 18849 || actor.getNpcId() == 18926)
		{
			if(target.getNpcId() == 18848 || target.getNpcId() == 18849 || target.getNpcId() == 18926 || target.isPlayer())
			{
				setIntention(CtrlIntention.AI_INTENTION_ACTIVE);
				return;
			}
		}
		else if(actor.getNpcId() == 22767)
		{
			if(target.getNpcId() == 22767 || target.getNpcId() == 18847)
			{
				setIntention(CtrlIntention.AI_INTENTION_ACTIVE);
				return;
			}
		}
		super.onIntentionAttack(target);
	}

	@Override
	public boolean isGlobalAI()
	{
		return true;
	}

	@Override
	protected boolean randomWalk()
	{
		return false;
	}
}