package ai;

import l2ft.gameserver.ai.Fighter;
import l2ft.gameserver.instancemanager.GameHandyManager;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.instances.L2BlockInstance;
import l2ft.gameserver.model.instances.L2NpcInstance;

/**
 * @author Byldas
 * @date 17.11.11  
 */

public class L2Block extends Fighter
{
	public L2Block(L2Character actor)
	{
		super(actor);
	}

	@Override
	protected void onEvtAttacked(L2Character attacker, int damage)
	{
		L2Player player = (L2Player) attacker;
		L2BlockInstance block = (L2BlockInstance) getActor();
		block.setColorHandyCubik(attacker.getTeam(), block);
		changestate(block, attacker.getTeam());
		int arenaId = GameHandyManager.getPlayerArena(player);
		int teamId = GameHandyManager.getPlayerTeam(player);
		GameHandyManager.increaseKill(teamId, arenaId, player);
		
		super.onEvtAttacked(attacker, damage);
	}
	
	private void changestate(L2NpcInstance actor, int state)
	{
		actor.setNpcState(state);
	}
}