package ai;

import l2ft.gameserver.ai.Fighter;
import l2ft.gameserver.instancemanager.HellboundManager;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.tables.DoorTable;

public class Leodas extends Fighter
{
	private static final int[] doors = { 19250003, 19250004 };

	public Leodas(L2Character actor)
	{
		super(actor);
	}

	protected void onEvtAttacked(L2Character attacker, int damage)
	{
		L2NpcInstance actor = getActor();
		if (actor == null)
			return;
		for (int i : doors)
			DoorTable.getInstance().getDoor(i).closeMe();
		super.onEvtAttacked(attacker, damage);
	}

	protected void onEvtDead(L2Character killer)
	{
		for (int i : doors)
		{
			DoorTable.getInstance().getDoor(i).openMe();
			DoorTable.getInstance().getDoor(i).onOpen();
		}

		HellboundManager.getInstance().updatePoints(-1000);
		super.onEvtDead(killer);
	}
}