package ai;

import l2ft.extensions.scripts.Functions;
import l2ft.gameserver.ai.DefaultAI;
import l2ft.gameserver.geodata.GeoEngine;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.tables.NpcTable;
import l2ft.gameserver.tables.SkillTable;
import l2ft.gameserver.templates.L2NpcTemplate;
import l2ft.util.Location;
import l2ft.util.Rnd;

public class LeylaMira extends DefaultAI
{
	L2NpcTemplate template = NpcTable.getTemplate(npcId);

	// Лейлик :)
	private static int npcId = 32431;
	// Радиус ее похождений...
	private static int minRange = 300;
	private static int maxRange = 900;
	private static int range = Rnd.get(minRange, maxRange);
	// Через сколько говорить будем
	private static int minVoiceTime = 12000;
	private static int maxVoiceTime = 25000;
	private static final int voiceTime = Rnd.get(minVoiceTime, maxVoiceTime);
	// Радиус, для определения имен
	private static final int radius = 1500;

	// Ожидание
	private boolean wait = false;
	private long wait_timeout = 0;
	private long wait_move = Rnd.get(60000,80000);
	// Время до последнего действия
	private long _lastAction;
	// Радномный текст...
	String[] _sayText = 
	{
		"Всем привет! Я Клариса, Клариса Мира!",
		"Эээ... чего это вы никто не здароваетесь со мной?! :(",
		"А я несу мир в этот Мир!",
		"Ой, чего это я интересно обкурилась сегодня...",
		"Эй! %player_random% Ты чего тут шляешся?",
		"Привет %player_random%, как поживаеш?",
		"Оооо! %player_random%, угостиш даму зажигалкой?"
	};
	String[] _attackText = 
	{
		"Эй, ты офигел чтоли! ",
		"Эээ.. мне же больно :(",
		"Ты любиш грубость.. ммм возбуждающе!",
		"О да, да да..."
	};

	public LeylaMira(L2Character actor)
	{
		super(actor);
	}

	@Override
	public boolean isGlobalAI()
	{
		return true;
	}

	@Override
	protected boolean thinkActive()
	{
		L2NpcInstance actor = getActor();
		if(actor.isDead())
			return true;

		if(_def_think)
		{
			doTask();
			return true;
		}

		int spawnX = actor.getSpawnedLoc().x;
		int spawnY = actor.getSpawnedLoc().y;
		int spawnZ = actor.getSpawnedLoc().z;

		int x = spawnX + Rnd.get(2 * range) - range;
		int y = spawnY + Rnd.get(2 * range) - range;
		int z = GeoEngine.getHeight(x, y, spawnZ,actor.getReflection().getGeoIndex());

		if(System.currentTimeMillis() > wait_timeout)
		{
			if(!wait )
			{
				wait_timeout = System.currentTimeMillis() + wait_move;
				actor.moveToLocation(x, y, z, 0, true);
				wait = true;
			}

			wait_timeout = 0;
			wait = false;

			Task task = new Task();
			task.type = TaskType.MOVE;
			task.loc = new Location(spawnX, spawnY, spawnZ);
			_task_list.add(task);
			_def_think = true;

			if(System.currentTimeMillis() - _lastAction > voiceTime)
			{
				Functions.npcSayInRange(actor, _sayText[Rnd.get(_sayText.length)], radius);
				_lastAction = System.currentTimeMillis();
			}
			return true;
		}

		if(randomAnimation())
			return true;

		return false;
	}

	@Override
	protected void onEvtAttacked(L2Character attacker, int damage)
	{
        L2NpcInstance actor = getActor();
		if(attacker == null || attacker.getPlayer() == null)
			return;

		actor.startAttackStanceTask();

		// Ругаемся и кастуем скилл не чаще, чем раз в 3 секунды
		if(System.currentTimeMillis() - _lastAction > 3000)
		{
			int chance = Rnd.get(0, 100);
			if(chance < 2)
			{
				attacker.getPlayer().setKarma(attacker.getPlayer().getKarma() + 5);
				attacker.sendChanges();
			}
			else if(chance < 4)
				actor.doCast(SkillTable.getInstance().getInfo(553, 1), attacker, true);
			else
				actor.doCast(SkillTable.getInstance().getInfo(554, 1), attacker, true);

			Functions.npcShout(actor, attacker.getName() + ", " + _attackText[Rnd.get(_attackText.length)]);
			_lastAction = System.currentTimeMillis();
		}
	}
}