package ai;

import java.util.concurrent.ScheduledFuture;

import l2ft.common.ThreadPoolManager;
import l2ft.extensions.scripts.Functions;
import l2ft.gameserver.ai.CtrlIntention;
import l2ft.gameserver.ai.DefaultAI;
import l2ft.gameserver.ai.Fighter;
import l2ft.gameserver.geodata.GeoEngine;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.L2Object;
import l2ft.gameserver.model.L2ObjectsStorage;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.L2World;
import l2ft.gameserver.model.Reflection;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.items.L2ItemInstance;
import l2ft.util.Location;
import l2ft.util.Rnd;

/**
 * @author Byldas
 * @date 09.10.11  
 * @AI for Luckpy-Luckpy Event HF
 */

public class Luckpy extends Fighter
{
	L2Player player = null;
	private ScheduledFuture<?> FollowTask;
	private long _lastSay;
	private int[] Cristall = {9552, 9553, 9554, 9555, 9556, 9557};
	private int[] Cristall_Dush = {5577, 5578, 5579};
	private int Luckpy_52 = 18664;
	private int Luckpy_70 = 18665;
	private int Luckpy_75 = 18666;
	private int Wingless_Luckpy = 2502;
	private int Wingless_Luckpy_Gold = 2503;
	private static final String[] say = { "Найдите меня :)!" };
	private static final String[] says = { "Спасибо, а можно еще?!" };
	private static String[] says2 = new String[] { "Ну ладно... не жадничай",
		"Куда оно подевалось?", "Наверное показалось...", "Оо", "ZzZzzz" };
	private L2ItemInstance itemToConsume = null;
	private int kol = 0;
	
	public Luckpy(L2Character actor)
	{
		super(actor);
	}

	@Override
	protected void onEvtAttacked(L2Character attacker, int damage)
	{
		super.onEvtAttacked(attacker, damage);
	}

	@Override
	protected boolean thinkActive()
	{
		L2NpcInstance actor = getActor();
		if(actor == null || actor.isDead())
			return true;

		if (actor.getNpcId() == Luckpy_52 || actor.getNpcId() == Luckpy_70 || actor.getNpcId() == Luckpy_75)
		{
			if(DefaultAI.namechar == null)
			{
				Reflection r = actor.getReflection();
				// Оповещаем не чаще, чем раз в 30 секунд
				if(System.currentTimeMillis() - _lastSay > 30000)
				{
					Functions.npcShout(actor, say[Rnd.get(say.length)]);
					_lastSay = System.currentTimeMillis();
	
					for(L2Player player : r.getPlayers())
						Functions.npcSayToPlayer(actor, player, say[Rnd.get(say.length)]);
				}
			
				for(L2Player player : L2World.getAroundPlayers(actor, 1000, 200))
					if(player != null)
						if (Rnd.chance(75))
						{
							DefaultAI.namechar = player.getName();
							return true;
						}
			}
			else
			{
				if(FollowTask != null)
					FollowTask.cancel(false);
				FollowTask = null;
				FollowTask = ThreadPoolManager.getInstance().scheduleGeneralAtFixedRate(new Follow(actor, player), 10, 1000);
			
				if(itemToConsume != null)
					if(itemToConsume.isVisible() && itemToConsume.getCount() >= 25000000 && itemToConsume.getCount() > player.getInventory().getAdena()/100 )
					{
						if (kol < 10)
						{
							itemToConsume.pickupMe(actor);
							itemToConsume = null;
							kol++;
						}
						else
							respawn(player);
					}
					else
					{
						itemToConsume = null;
						Functions.npcSay(actor, says2[Rnd.get(says.length)]);
						actor.setWalking();
						return true;
					}
				
				for(L2Object object : L2World.getAroundObjects(actor, 100, 200))
				{
					if (object.isItem())
					{
						L2ItemInstance item = (L2ItemInstance) object;
							if(item.getItemId() == 57)
							{
								if(Rnd.chance(50))
									Functions.npcSay(actor, says[Rnd.get(says.length)]);
								itemToConsume = item;
								return true;
							}
					}
				}
			}
			if(randomAnimation())
				return true;
			
			return false;
		}
		return super.thinkActive();
	}
	
	@Override
	protected void onEvtDead(L2Character killer)
	{
		L2NpcInstance actor = getActor();
		if(actor == null)
			return;
		int lvl = Integer.parseInt(actor.getTitle().substring(0, 2).trim());
			if(killer != null)
			{
				L2Player player = killer.getPlayer();
				if(player != null)
				{
					if (actor.getNpcId() == Wingless_Luckpy)
						switch(lvl)
						{
						case 52:
							player.getInventory().addItem(8755, Rnd.get(1,2));
							return;
						case 70:
							player.getInventory().addItem(Rnd.get(Cristall_Dush.length), (Rnd.get(1,2)));
							return;
						case 75:
							player.getInventory().addItem(Rnd.get(Cristall.length), (Rnd.get(1,2)));
							return;
						}
					if (actor.getNpcId() == Wingless_Luckpy_Gold)
						switch(lvl)
						{
						case 52:
							player.getInventory().addItem(8755, Rnd.get(1,2));
							player.getInventory().addItem(14678, 1);
							return;
						case 70:
							player.getInventory().addItem(Rnd.get(Cristall_Dush.length), (Rnd.get(1,2)));
							player.getInventory().addItem(14679, 1);
							return;
						case 75:
							player.getInventory().addItem(Rnd.get(Cristall.length), (Rnd.get(1,2)));
							player.getInventory().addItem(14680, 1);
							return;
						}
				}
			}		
					
		super.onEvtDead(killer);
	}
	
	private void respawn(L2Player player)
	{
		L2NpcInstance actor = getActor();
		
		
		Reflection r = actor.getReflection();
		
		L2NpcInstance npc = L2ObjectsStorage.getByNpcId(Rnd.chance(30) ? Wingless_Luckpy_Gold : Wingless_Luckpy);
		Location pos = GeoEngine.findPointToStay(actor.getX(), actor.getY(), actor.getZ(), 50, 150, actor.getReflection().getGeoIndex());
		npc.setSpawnedLoc(pos);
		npc.setReflection(r);
		npc.onSpawn();
		npc.setTitle(actor.getLevel()+" LVL");
		npc.spawnMe(npc.getSpawnedLoc());
		
		actor.stopMove();
		actor.decayMe();
		FollowTask = null;
	}
	
	private class Follow implements Runnable
	{
		private L2NpcInstance _npc;
		private L2Player player;
		
		private Follow(L2NpcInstance npc, L2Player pl)
		{
			_npc = npc;
			player = pl;
		}

		
		@Override
		public void run()
		{
			_npc.getAI().setIntention(CtrlIntention.AI_INTENTION_FOLLOW, player, 150);
		}
	}
	
}