package ai;

import static l2ft.gameserver.ai.CtrlIntention.AI_INTENTION_ACTIVE;
import l2ft.extensions.scripts.Functions;
import l2ft.gameserver.ai.Fighter;
import l2ft.gameserver.geodata.GeoEngine;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.tables.NpcTable;
import l2ft.util.Location;
import l2ft.util.Rnd;

/**
 * AI монахов в Monastery of Silence<br>
 * - агрятся на чаров с оружием в руках
 * - перед тем как броситься в атаку кричат
 */
public class MoSMonk extends Fighter
{
	public MoSMonk(L2Character actor)
	{
		super(actor);
	}

	@Override
	protected void onIntentionAttack(L2Character target)
	{
		L2NpcInstance actor = getActor();
		if(actor == null)
			return;
			
		if(getIntention() == AI_INTENTION_ACTIVE && Rnd.chance(50))
			Functions.npcSay(actor, "Вы не сможете пронести оружие с собой без особого разрешения!");
			//"You cannot carry a weapon without authorization!"
				
		super.onIntentionAttack(target);
	}

	@Override
	public void checkAggression(L2Character target)
	{
		if(target.getActiveWeaponInstance() == null)
			return;
		super.checkAggression(target);
	}
	
	// for quest _457_LostandFound 
	@Override
	protected void onEvtDead(L2Character killer)
	{
		L2NpcInstance actor = getActor();
		if(actor == null)
			return;
			
		if(Rnd.chance(1)) {
			if(Rnd.chance(10)) {
				Location pos = GeoEngine.findPointToStay(actor.getX(), actor.getY(), actor.getZ(), 100, 120, actor.getReflection().getGeoIndex());
				L2NpcInstance npc = NpcTable.getTemplate(32759).getNewInstance();
				npc.setSpawnedLoc(pos);
				npc.setReflection(actor.getReflection());
				npc.onSpawn();
				npc.spawnMe(npc.getSpawnedLoc());				
				Functions.npcSay(npc, "Эй, Путешественник! Вы не похожи на монаха. Поможете мне? ");
			}
		}
		
		super.onEvtDead(killer);
	}
}