package ai;

import java.util.concurrent.ConcurrentSkipListSet;
import l2ft.gameserver.ai.CtrlIntention;
import l2ft.gameserver.ai.Fighter;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.L2Object;
import l2ft.gameserver.model.L2World;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.util.GArray;

public class Quest196Fighter extends Fighter
{
	public Quest196Fighter(L2Character actor)
	{
		super(actor);
	}

	protected boolean thinkActive()
	{
		if (super.thinkActive() || !_task_list.isEmpty())
			return true;

		L2NpcInstance actor = getActor();
		if (actor == null)
			return false;

		if (getIntention() == CtrlIntention.AI_INTENTION_ACTIVE)
		{
			GArray<L2Object> targets = new GArray<L2Object>();
			for (L2NpcInstance obj : L2World.getAroundNpc(actor))
			{
				if (obj != null && !obj.isAlikeDead() && !obj.isInvul() && obj.isVisible() && (obj.getAI() instanceof Quest196Fighter))
				{
					if (actor.getFactionId().equalsIgnoreCase(obj.getFactionId()))
						continue;
					targets.add(obj);
				}
			}
			setIntention(CtrlIntention.AI_INTENTION_ATTACK, targets.getRandom());
		}

		return true;
	}

	protected void onEvtAttacked(L2Character attacker, int damage)
	{
	}

	protected void onEvtAggression(L2Character target, int aggro)
	{
	}
}