package ai;

import l2ft.extensions.scripts.Functions;
import l2ft.gameserver.ai.CtrlEvent;
import l2ft.gameserver.ai.CtrlIntention;
import l2ft.gameserver.ai.Mystic;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.L2World;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.util.Rnd;

public class SeerUrgos extends Mystic
{
    private int _stage = 1;
    private static boolean useHandler = false;
	private L2NpcInstance mob = null;

    public SeerUrgos(L2Character actor)
    {
        super(actor);
    }

    @Override
    protected void onEvtAttacked(L2Character attacker, int damage)
    {
        L2NpcInstance actor = getActor();
        double curHpPer = actor.getCurrentHpPercents();
        if(curHpPer < 85 && _stage == 1)
        {
            for(L2NpcInstance npc : L2World.getAroundNpc(actor, 500, 100))
			{
				if(mob == null)
				{
					if(npc.getNpcId() == 18867)
					{
						actor.clearAggroList(false);
						npc.addDamageHate(actor, 0,  Rnd.get(100000, 150000));
						actor.setAttackTimeout(getMaxAttackTimeout() + System.currentTimeMillis());
						actor.getAI().notifyEvent(CtrlEvent.EVT_AGGRESSION, npc, 10000000);
						actor.getAI().setAttackTarget(npc);
						actor.getAI().changeIntention(CtrlIntention.AI_INTENTION_ATTACK, npc, null);
						actor.getAI().addTaskAttack(npc);
						Functions.npcSay(actor, "Вы оказались сильным противником! Но у меня есть зелье, дарованное мне Черной Бездной! Посмотрим еще...");
						mob = npc;
						_stage = 2;
					}
				}
			}
        }
        if(curHpPer < 50 && _stage == 2)
        {
			mob = null;
            for(L2NpcInstance npc : L2World.getAroundNpc(actor, 500, 100))
			{
				if(mob == null)
				{
					if(npc.getNpcId() == 18867)
					{
						mob = npc;
						actor.clearAggroList(false);
						npc.addDamageHate(actor, 0,  Rnd.get(1, 100));
						actor.setAttackTimeout(getMaxAttackTimeout() + System.currentTimeMillis());
						actor.getAI().notifyEvent(CtrlEvent.EVT_AGGRESSION, npc, 10000000);
						actor.getAI().setAttackTarget(npc);
						actor.getAI().changeIntention(CtrlIntention.AI_INTENTION_ATTACK, npc, null);
						actor.getAI().addTaskAttack(npc);
						Functions.npcSay(actor, "Вы оказались сильным противником! Но у меня есть зелье, дарованное мне Черной Бездной! Посмотрим еще...");
						_stage = 3;
					}
				}
			}
        }
        if(curHpPer < 25 && _stage == 3)
        {
			mob = null;
            for(L2NpcInstance npc : L2World.getAroundNpc(actor, 500, 100))
			{
				if(mob == null)
				{
					if(npc.getNpcId() == 18867)
					{
						mob = npc;
						actor.clearAggroList(false);
						npc.addDamageHate(actor, 0,  Rnd.get(1, 100));
						actor.setAttackTimeout(getMaxAttackTimeout() + System.currentTimeMillis());
						actor.getAI().notifyEvent(CtrlEvent.EVT_AGGRESSION, npc, 10000000);
						actor.getAI().setAttackTarget(npc);
						actor.getAI().changeIntention(CtrlIntention.AI_INTENTION_ATTACK, npc, null);
						actor.getAI().addTaskAttack(npc);
						Functions.npcSay(actor, "Вы оказались сильным противником! Но у меня есть зелье, дарованное мне Черной Бездной! Посмотрим еще...");
						_stage = 4;
					}
				}
			}
        }

        super.onEvtAttacked(attacker, damage);
    }

	@Override
	protected void onEvtDead(L2Character killer)
	{
        L2NpcInstance actor = getActor();
        Functions.npcShout(actor, "А... Моё поражение... Черная Бездна, прими меня...");
        _stage = 0;
		mob = null;
		useHandler = false;
    }

    public static void setHandler(boolean change)
    {
        useHandler = change;
    }

    public static boolean getHandler()
    {
        return useHandler;
    }
}
