package ai;

import l2ft.gameserver.ai.CtrlIntention;
import l2ft.gameserver.ai.Fighter;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.instances.L2MinionInstance;
import l2ft.gameserver.model.instances.L2MonsterInstance;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.util.Location;
import l2ft.util.Rnd;

/**
 * AI моба Sel Mahum Chef (ID: 18908) в локации Sel Mahum Training Ground`s
 * TODO: Исправить застревание некоторых мобов
 */
public class SelMahumCook extends Fighter
{
	private final static int GUARD_ID = 22779;

	/** Маршрут */
	private Location[] points = null;
	/** Текущая точка */
	private int current_point = -1;
	/** Определение последней точки. */
	private boolean last = false;

	@Override
	public boolean isGlobalAI()
	{
		return true;
	}

	public SelMahumCook(L2Character actor)
	{
		super(actor);
	}

	@Override
	protected void onEvtSpawn()
	{
		L2NpcInstance actor = getActor();
		if(actor == null)
			return;

		// Спауним минионов, левому из них устанавливаем значение Busy
		L2MonsterInstance master = (L2MonsterInstance) actor;
		master.setNewMinionList();
		L2MinionInstance left = master.getMinionList().spawnSingleMinionSync(GUARD_ID);
		left.setBusy(true);
		master.getMinionList().spawnSingleMinionSync(GUARD_ID);

		// Определение пути, в зависимости от точки спауна
		switch(actor.getX())
		{
			case 85852: // 85852;53212;-3624 Cooker_01
			case 78332: // 78332;63440;-3640 Cooker_07
			case 82814: // 82814;69481;-3192 Cooker_09
				points = new Location[] { new Location(85764, 54368, -3604), new Location(86760, 53968, -3696),
						new Location(87310, 54592, -3648), new Location(88272, 54171, -3600), new Location(89017, 54030, -3712),
						new Location(89936, 54224, -3760), new Location(90647, 54350, -3776) };
				break;
			case 93964: // 93964;55692;-3352  Cooker_02
				points = new Location[] { new Location(91260, 55012, -3760), new Location(94418, 54744, -3576),
						new Location(93952, 54461, -3632), new Location(92713, 54672, -3680), new Location(91712, 55664, -3648),
						new Location(91744, 56688, -3568) };
				break;
			case 87612: // 87612;59356;-3552  Cooker_03
			case 88532: // 88532;60352;-3642  Cooker_05
				points = new Location[] { new Location(88092, 60352, -3584), new Location(89265, 60176, -3648),
						new Location(90031, 60799, -3664), new Location(88672, 59842, -3568), new Location(90863, 59871, -3664) };
				break;
			case 83724: // 83724;62668;-3472  Cooker_04
				points = new Location[] { new Location(85764, 54368, -3604), new Location(86760, 53968, -3696),
						new Location(87310, 54592, -3648), new Location(88272, 54171, -3600), new Location(89017, 54030, -3712),
						new Location(89936, 54224, -3760), new Location(90647, 54350, -3776) };
				break;
			case 92981: // 92981;60834;-3288  Cooker_06
				points = new Location[] { new Location(85764, 54368, -3604), new Location(86760, 53968, -3696),
						new Location(87310, 54592, -3648), new Location(88272, 54171, -3600), new Location(89017, 54030, -3712),
						new Location(89936, 54224, -3760), new Location(90647, 54350, -3776) };
				break;
			case 77836: // 77836;68796;-3312 Cooker_08
				points = new Location[] {//
				new Location(78040, 69515, -3136), //
						new Location(79168, 69256, -3328) };
				break;
			case 83404: // 83404;65772;-3032 Cooker_10
				points = new Location[] { //
				new Location(83631, 66179, -3040), //
						new Location(84128, 65740, -3152) };
				break;
			case 96487: // 96487;69432;-3408 Cooker_11
				points = new Location[] { new Location(93792, 69440, -3851), new Location(95163, 70886, -3851),
						new Location(93795, 71347, -3851), new Location(92262, 70814, -3851), new Location(92501, 68335, -3851),
						new Location(93665, 66871, -3851), new Location(94653, 66934, -3851), new Location(97262, 69006, -3851),
						new Location(96506, 69958, -3851), new Location(94265, 68391, -3851) };
				break;
			case 91238: // 91238;67728;-3631 Cooker_12
				points = new Location[] { new Location(91216, 67311, -3632), new Location(91824, 67728, -3632),
						new Location(91472, 68048, -3568) };
				break;
		}

		super.onEvtSpawn();
	}

	@Override
	public void checkAggression(L2Character target)
	{
		if(getIntention() != CtrlIntention.AI_INTENTION_ACTIVE)
			return;
		super.checkAggression(target);
		// Продолжит идти с предыдущей точки
		if(getIntention() != CtrlIntention.AI_INTENTION_ACTIVE && current_point > -1)
			current_point--;
	}

	@Override
	protected boolean thinkActive()
	{
		L2NpcInstance actor = getActor();
		if(actor == null || actor.isDead())
			return true;

		if(_def_think)
		{
			if(doTask())
				clearTasks();
			return true;
		}

		if(points != null && (current_point > -1 || Rnd.chance(5)))
		{
			if(!last)
				current_point++;

			if(current_point >= points.length)
				last = true;

			if(last)
				current_point--;

			if(current_point < 0)
				current_point = 0;

			if(current_point == 0 && last)
				last = false;

			actor.setWalking();

			addTaskMove(points[current_point], true);
			doTask();
			return true;
		}

		return false;
	}

	@Override
	protected void onEvtDead(L2Character killer)
	{
		points = null;
		current_point = -1;
		super.onEvtDead(killer);
	}
}