package ai;

import l2ft.gameserver.ai.Fighter;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.instances.L2MinionInstance;
import l2ft.gameserver.model.instances.L2MonsterInstance;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.util.Util;

/**
 * AI for location Sel Mahum Training ground. Mob ID: 22779
 * @author SYS
 */
public class SelMahumGuard extends Fighter
{
	private static final int DRIFT_DISTANCE = 100;

	public SelMahumGuard(L2Character actor)
	{
		super(actor);
	}

	@Override
	public boolean isGlobalAI()
	{
		return true;
	}

	@Override
	protected boolean randomAnimation()
	{
		return false;
	}

	@Override
	protected boolean randomWalk()
	{
		return false;
	}

	@Override
	protected boolean thinkActive()
	{
		L2NpcInstance actor = getActor();
		if(actor == null || actor.isMoving || actor.isFollow)
			return true;

		L2MonsterInstance master = ((L2MinionInstance) actor).getLeader();
		if(master == null)
			return true;

		if(actor.getDistance(master) > DRIFT_DISTANCE * 2)
		{
			// Busy флаг, определяющий левого миниона устанавливается при спауне в AI SelMahumCook
			double radian = Math.toRadians(Util.convertHeadingToDegree(master.getHeading()) - 90 * (actor.isBusy() ? 1 : -1));
			actor.moveToLocation(master.getX() + (int) (Math.cos(radian) * DRIFT_DISTANCE), master.getY() + (int) (Math.sin(radian) * DRIFT_DISTANCE), master.getZ(), 0, true);
			return true;
		}

		return super.thinkActive();
	}
}