package ai;

import java.util.HashMap;

import javolution.util.FastMap;
import l2ft.extensions.scripts.Functions;
import l2ft.gameserver.ai.DefaultAI;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.L2Skill;
import l2ft.gameserver.model.L2World;
import l2ft.gameserver.model.instances.L2NpcInstance;

/**
 * @author People
 * @date 20.06.11
 * @AI for location Plains of Lizardman
 */

public class Ugoros extends DefaultAI
{
	private L2NpcInstance mob;
	private boolean check = false;
	private final L2Skill skillUgoros;
	private long _lastSay;
			
	public Ugoros(L2Character actor)
	{
		super(actor);
		HashMap<Integer, L2Skill> skills = getActor().getTemplate().getSkills();
		AI_TASK_DELAY = 1000;
		AI_TASK_ACTIVE_DELAY = 1000;
		skillUgoros = skills.get(6426);
	}
	
	@Override
	public boolean isGlobalAI()
	{
		return true;
	}
	
	@Override
	protected boolean createNewTask()
	{
		clearTasks();		
		L2Character target;
		if((target = prepareTarget()) == null)
			return false;
		L2NpcInstance actor = getActor();
		if(actor == null)
			return false;
			
		double distance = 0;	
		distance = actor.getDistance(target);	
		FastMap<L2Skill, Integer> d_skill = new FastMap<L2Skill, Integer>();
		if (actor.getCurrentHpPercents() <= 85) {
                for(L2NpcInstance npc : L2World.getAroundNpc(actor, 1000, 300)) {
                    if(npc.getNpcId() == 18867 && !npc.isDead())
                    {
                        npc.addDamageHate(actor, 0, 100);
                        mob = npc;
                    }
				}	

				if(mob == null)
				{
					L2Skill r_skill = selectTopSkill(d_skill);
					mob = null;
					return chooseTaskAndTargets(r_skill, target, distance);
				}
				if(System.currentTimeMillis() - _lastSay > 5000)
				{
					Functions.npcSay(actor, "Вы оказались сильным противником! Но у меня есть зелье, дарованное мне Черной Бездной! Посмотрим еше...");
					_lastSay = System.currentTimeMillis();
				}	
				distance = actor.getDistance(mob);	
				addDesiredSkill(d_skill, mob, distance, skillUgoros);
				L2Skill r_skill = selectTopSkill(d_skill);
				check = true;
				return chooseTaskAndTargets(r_skill, mob, distance);
		}
		mob = null;
		L2Skill r_skill = selectTopSkill(d_skill);
		return chooseTaskAndTargets(r_skill, target, distance);
	
	}
	
	@Override
	protected void onEvtDead(L2Character killer)
	{
		L2Player player = (L2Player)killer;
		if(!check)
			Functions.addItem(player, 15497, 1L);
		else 
			Functions.addItem(player, 15498, 1L);
		super.onEvtDead(killer);
	}
}