package ai;

import l2ft.extensions.scripts.Functions;
import l2ft.gameserver.ai.DefaultAI;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.util.Location;
import l2ft.util.Rnd;

public class VoteAnnouncer extends DefaultAI
{
	static final Location[] points = {
		new Location(82776, 147768, -3464),
		new Location(82776, 149448, -3472),
		new Location(81016, 149352, -3472),
		new Location(81080, 147768, -3464) };
	
	private int current_point = -1;
	private long wait_timeout = 0;
	private boolean wait = false;
	
	public VoteAnnouncer(L2Character actor)
	{
		super(actor);
	}

	@Override
	public boolean isGlobalAI()
	{
		return true;
	}

	@Override
	protected boolean thinkActive()
	{
		L2NpcInstance actor = getActor();
		if(actor == null || actor.isDead())
			return true;

		if(_def_think)
		{
			doTask();
			return true;
		}

		if(System.currentTimeMillis() > wait_timeout && (current_point > -1 || Rnd.chance(5)))
		{
			if(!wait)
				switch(current_point)
				{
					case 1:
						wait_timeout = System.currentTimeMillis() + 120000;
						Functions.npcShoutCustomMessage(actor, "scripts.ai.VoteAnnouncer." + Rnd.get(1,4));
						wait = true;
						return true;
					case 2:
						wait_timeout = System.currentTimeMillis() + 120000;
						Functions.npcShoutCustomMessage(actor, "scripts.ai.VoteAnnouncer." + Rnd.get(1,4));
						wait = true;
						return true;
					case 3:
						wait_timeout = System.currentTimeMillis() + 120000;
						Functions.npcShoutCustomMessage(actor, "scripts.ai.VoteAnnouncer." + Rnd.get(1,4));
						wait = true;
						return true;
					case 4:
						wait_timeout = System.currentTimeMillis() + 120000;
						Functions.npcShoutCustomMessage(actor, "scripts.ai.VoteAnnouncer." + Rnd.get(1,4));
						wait = true;
						return true;
				}

			wait_timeout = 0;
			wait = false;
			current_point++;

			if(current_point >= points.length)
				current_point = 0;

			addTaskMove(points[current_point], true);
			doTask();
			return true;
		}

		if(randomAnimation())
			return true;

		return false;
	}

	@Override
	protected void onEvtAttacked(L2Character attacker, int damage)
	{}

	@Override
	protected void onEvtAggression(L2Character target, int aggro)
	{}
}