package commands.user;

import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.cache.Msg;
import l2ft.gameserver.handler.IUserCommandHandler;
import l2ft.gameserver.handler.UserCommandHandler;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.entity.olympiad.NobleInfo;
import l2ft.gameserver.model.entity.olympiad.Olympiad;
import l2ft.gameserver.serverpackets.L2GameServerPacket;
import l2ft.gameserver.serverpackets.SystemMessage;
/**
 * Support for /olympiadstat command
 */
public class OlympiadStat implements IUserCommandHandler, ScriptFile
{
	private static final int[] COMMAND_IDS = { 109 };

	@Override
	public boolean useUserCommand(int id, L2Player activeChar)
	{
		
		if (id != COMMAND_IDS[0]) 
			return false;
		
		L2Player player = activeChar.getTarget() != null && activeChar.getTarget().isPlayer() ? (L2Player)activeChar.getTarget() : activeChar;

		NobleInfo noble = Olympiad.getNobleInfo(player.getObjectId());
		if (!player.isNoble() || noble == null) 
		{
			activeChar.sendPacket(Msg.THIS_COMMAND_CAN_ONLY_BE_USED_BY_A_NOBLESSE);
		}
		else 
		{
			SystemMessage sm = new SystemMessage(1673);
			sm.addNumber(noble.competitions_done);
			sm.addNumber(noble.competitions_win);
			sm.addNumber(noble.competitions_loose);
			sm.addNumber(noble.olympiad_points);
			activeChar.sendPacket(sm);

			sm = new SystemMessage(3261);
			sm.addNumber(Olympiad._MatchesLimitGeneral - noble.getAllCompetitionCount());
			sm.addNumber(Olympiad._MatchesLimitClassed - noble.competitions_week_0);
			sm.addNumber(Olympiad._MatchesLimitNonClassed - noble.competitions_week_1);
			sm.addNumber(Olympiad._MatchesLimitTeam - noble.competitions_week_3);
			activeChar.sendPacket(sm);
		}
		return true;
	}

	@Override
	public int[] getUserCommandList()
	{
		return COMMAND_IDS;
	}

	@Override
	public void onLoad()
	{
		UserCommandHandler.getInstance().registerUserCommandHandler(this);
	}

	@Override
	public void onReload()
	{}

	@Override
	public void onShutdown()
	{}
}