package commands.voiced;

import l2ft.extensions.scripts.Functions;
import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.handler.IVoicedCommandHandler;
import l2ft.gameserver.handler.VoicedCommandHandler;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.serverpackets.MyTargetSelected;

public class AroundNPCs extends Functions implements IVoicedCommandHandler, ScriptFile
{
	private String[] _commandList = new String[] { "target" };

	@Override
	public String[] getVoicedCommandList()
	{
		return _commandList;
	}
	
	@Override
	public boolean useVoicedCommand(String command, L2Player activeChar, String target)
	{
		StringBuilder dialog = new StringBuilder("<html><body>");
		dialog.append("<center><font color=\"LEVEL\">Around NPCs</font></center><br><br>");

		for(L2NpcInstance npc : activeChar.getAroundNpc(400, 200))
		{
			if(npc.isNpc() && !npc.isMonster())
				dialog.append("[scripts_commands.voiced.AroundNPCs:shownpc ").append(npc.getObjectId()).append("|").append(npc.getName()).append("]<br1>");
		}
		dialog.append("</body></html>");

		show(dialog.toString(), activeChar, null);
		return true;
	}

	public void shownpc(String[] var)
	{
		L2Player player = (L2Player) getSelf();
		if(var.length != 1)
		{
			show("Некорректные данные", player);
			return;
		}
		int ID = Integer.parseInt(var[0]);
		player.sendPacket(new MyTargetSelected(ID, player.getLevel()));
	}
	
	@Override
	public void onLoad()
	{
		VoicedCommandHandler.getInstance().registerVoicedCommandHandler(this);
	}

	@Override
	public void onReload()
	{

	}

	@Override
	public void onShutdown()
	{

	}
}
