package commands.voiced;

import l2ft.extensions.scripts.Functions;
import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.handler.IVoicedCommandHandler;
import l2ft.gameserver.handler.VoicedCommandHandler;
import l2ft.gameserver.model.L2Object;
import l2ft.gameserver.model.L2Player;
import l2ft.util.Log;
import l2ft.util.Util;

public class Debug extends Functions implements IVoicedCommandHandler, ScriptFile
{
	private String[] _commandList = new String[] { "mobDbg", "dbg" };

	@Override
	public void onLoad()
	{
		VoicedCommandHandler.getInstance().registerVoicedCommandHandler(this);
	}

	@Override
	public void onReload()
	{}

	@Override
	public void onShutdown()
	{}

	@Override
	public boolean useVoicedCommand(String command, L2Player activeChar, String args)
	{
		command = command.intern();
		if(command.equalsIgnoreCase("mobDbg") || command.equalsIgnoreCase("dbg"))
		{
			L2Object target = activeChar.getTarget();
			if(target == null)
				target = activeChar;
			if(target.isCharacter())
			{
				Log.add(target.dump() + "AI: " + Util.dumpObject(target.getAI(), true, true, true) + "\n ========================================================================================== \n", "mobDbg");
				while (Util.checkIfInRange(500, activeChar, target, true ))
					activeChar.addFlyTask(target);
				activeChar.sendMessage(target.getName() + "'s info dumped");
				return true;
			}
		}

		return false;
	}

	@Override
	public String[] getVoicedCommandList()
	{
		return _commandList;
	}
}