package commands.voiced;

import l2ft.extensions.scripts.Functions;
import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.handler.IVoicedCommandHandler;
import l2ft.gameserver.handler.VoicedCommandHandler;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.skills.EffectType;

public class Gotoleader extends Functions implements IVoicedCommandHandler, ScriptFile
{
	private String[] _commandList = new String[] { "gotoleader" };

	@Override
	public boolean useVoicedCommand(String command, L2Player activeChar, String target)
	{
		if (command.equals("gotoleader"))
		{
			if (activeChar.getClan() != null)
			{
				L2Player clanLeader = activeChar.getClan().getLeader().getPlayer();
				if (clanLeader == null)
					return false;
				if (clanLeader.getEffectList().getEffectByType(EffectType.ClanGate) != null)
				{
					if (!validateGateCondition(clanLeader, activeChar))
						return false;
					activeChar.teleToLocation(clanLeader.getX(), clanLeader.getY(), clanLeader.getZ());
					return true;
				}
				activeChar.sendMessage("I cannot find the lord's signal right now, so it is impossible to cast the spell.");
			}
		}
		return true;
	}
	
	
	
	
	private static boolean validateGateCondition(L2Player clanLeader, L2Player player)
	{
		if (clanLeader.isAlikeDead())
		{
			// Need retail message if there's one.
			player.sendMessage("Couldn't teleport to clan leader. The requirements was not meet.");
			return false;
		}
		if (clanLeader.isInStoreMode())
		{
			// Need retail message if there's one.
			player.sendMessage("Couldn't teleport to clan leader. The requirements was not meet.");
			return false;
		}
		if (clanLeader.isRooted() || clanLeader.isInCombat())
		{
			// Need retail message if there's one.
			player.sendMessage("Couldn't teleport to clan leader. The requirements was not meet.");
			return false;
		}
		if (clanLeader.isInOlympiadMode())
		{
			// Need retail message if there's one.
			player.sendMessage("Couldn't teleport to clan leader. The requirements was not meet.");
			return false;
		}
		if (clanLeader.isFestivalParticipant())
		{
			// Need retail message if there's one.
			player.sendMessage("Couldn't teleport to clan leader. The requirements was not meet.");
			return false;
		}
		if (clanLeader.inObserverMode())
		{
			// Need retail message if there's one.
			player.sendMessage("Couldn't teleport to clan leader. The requirements was not meet.");
			return false;
		}
		
		return true;
		
	}

	@Override
	public void onLoad() 
	{
		VoicedCommandHandler.getInstance().registerVoicedCommandHandler(this);
	}

	@Override
	public void onReload() 
	{
	
	}

	@Override
	public void onShutdown() 
	{
		
	}

	@Override
	public String[] getVoicedCommandList() 
	{
		return _commandList;
	}
}
