package commands.voiced;

import static services.Talks.Kief.getPoints;
import l2ft.Config;
import l2ft.extensions.scripts.Functions;
import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.handler.IVoicedCommandHandler;
import l2ft.gameserver.handler.VoicedCommandHandler;
import l2ft.gameserver.instancemanager.HellboundManager;
import l2ft.gameserver.model.L2Object;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.util.Files;

///@author Ragnarok
///@date 28.01.2010

public class HellboundVoiced extends Functions implements IVoicedCommandHandler, ScriptFile
{

	//	Голосовая команда .hellbound
	//	Предназначена для вывода информации о текущем состоянии острова

	public static L2Object self;
	public static L2NpcInstance npc;

	private String[] _commandList = new String[]{"hellbound"};

	@Override
	public boolean useVoicedCommand(String command, L2Player activeChar, String args)
	{

		if(command.equals("hellbound"))
		{

			HellboundManager.getInstance().checkLevel();
			int level = HellboundManager.getInstance().getLevel();
			long trust = HellboundManager.getInstance().getPoints();
			boolean _isOpen = HellboundManager.getInstance().checkIsOpen();
			long life_points = getPoints();

			String status = "";
			if (_isOpen)
				status = "Открыт";
			else
				status = "Закрыт";
			if(!Config.HELLSCHAT)
			{
				String dialog = Files.read("data/scripts/commands/voiced/hellbound.htm", activeChar);
				dialog = dialog.replaceFirst("%status%", status);
				dialog = dialog.replaceFirst("%level%", ""+level);
				dialog = dialog.replaceFirst("%trust%", ""+trust);
				if (level == 7)
					dialog = dialog.replaceFirst("%life_points%", "<tr><td width=5></td><td width=120>Количество очков Жизни:</td><td width=40><font color=LEVEL>"+life_points+" из 1.000.000</font></td></tr>");
				show(dialog, activeChar);
				return true;
			}
			else
			{
				activeChar.sendMessage("Статус Хеллбаунда: " + status);
				activeChar.sendMessage("Текущий уровень: "+level);
				activeChar.sendMessage("Уровень Доверия: "+trust);
				activeChar.sendMessage("Количество очков Жизни: "+life_points);
			}
		}
		return true;
	}

	@Override
	public String[] getVoicedCommandList()
	{
		return _commandList;
	}

	@Override
	public void onLoad()
	{
		VoicedCommandHandler.getInstance().registerVoicedCommandHandler(this);
	}

	@Override
	public void onReload()
	{}

	@Override
	public void onShutdown()
	{}
}