package commands.voiced;

import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.handler.IVoicedCommandHandler;
import l2ft.gameserver.handler.VoicedCommandHandler;
import l2ft.gameserver.instancemanager.CastleManager;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.entity.residence.Residence;
import l2ft.gameserver.model.instances.L2DoorInstance;

public class PlayerCastleDoors implements IVoicedCommandHandler, ScriptFile
{
	private static String[] _voicedCommands = { "open", "close" };

	@Override
	public boolean useVoicedCommand(String command, L2Player activeChar, String target)
	{
		if(activeChar.getTarget() == null || !activeChar.getTarget().isDoor() || activeChar.getClan() == null)
			return false;
		L2DoorInstance door = (L2DoorInstance) activeChar.getTarget();
		Residence castle = CastleManager.getInstance().getCastleByIndex(activeChar.getClan().getHasCastle());
		if(door == null || castle == null)
			return false;

		if(target.equals("doors") && activeChar.isClanLeader() && castle.checkIfInZone(door.getX(), door.getY()))
			if(command.startsWith("open"))
				door.openMe();
			else if(command.startsWith("close"))
				door.closeMe();
		return true;
	}

	@Override
	public String[] getVoicedCommandList()
	{
		return _voicedCommands;
	}

	@Override
	public void onLoad()
	{
		VoicedCommandHandler.getInstance().registerVoicedCommandHandler(this);
	}

	@Override
	public void onReload()
	{}

	@Override
	public void onShutdown()
	{}
}