package commands.voiced;

import java.sql.SQLException;

import l2ft.Config;
import l2ft.database.L2DatabaseFactory;
import l2ft.database.mysql;
import l2ft.extensions.scripts.Functions;
import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.handler.IVoicedCommandHandler;
import l2ft.gameserver.handler.VoicedCommandHandler;
import l2ft.gameserver.model.L2Player;
import l2ft.util.Files;

public class hwid extends Functions  implements IVoicedCommandHandler, ScriptFile
{
	private static final String[] _commandList = { "hwid", "hwid2" };

	private static String defaultPage = "data/scripts/commands/voiced/hwid.html";
  
	private void showDefaultPage(L2Player activeChar)
	{
		String html = Files.read(defaultPage, activeChar);
		show(html, activeChar);
	}
  
	public boolean useVoicedCommand(String command, L2Player activeChar, String target)
	{
		if (activeChar.isBlocked()) 
			return false;
    
		if (((command.equals("hwid")) || (command.equals("hwid2"))) && ((target == null) || (target.isEmpty())))
		{
			showDefaultPage(activeChar);
			return true;
		}

		String[] param = target.split(" ");

		if (param.length > 0)
		{
			int time = 86400;
			if (param.length > 1)
				for (int i = 1; i < param.length; i++)
					try
					{
						time = Integer.parseInt(param[1]) * 60 * 60 * 24;
					}
					catch (NumberFormatException e)
					{
					}
				time = command.equals("hwid2") ? Math.min(time, 1209600) : Math.min(time, 604800);
				if (param[0].equalsIgnoreCase("on"))
				{
					if (!activeChar.hasHWID())
					{
						System.out.println("WARNING! Can't lock account by HWID. " + activeChar + " / Con: " + activeChar.getNetConnection());
						return false;
					}
					mysql.setEx(Config.ACCOUNTS_DATABASE.instance, "UPDATE accounts SET lock_expire = ? WHERE login = ?", new Object[] { Integer.valueOf(time), activeChar.getAccountName() });
					mysql.setEx(Config.ACCOUNTS_DATABASE.instance, "REPLACE INTO `lock` (`login`, `type`, `string`) VALUES (?, ?, ?)", new Object[] { activeChar.getAccountName(), "HWID", activeChar.getHWID().Full });
					
					activeChar.sendMessage("Account locked.");
					return true;
				}
				if (param[0].equalsIgnoreCase("off"))
				{
					mysql.setEx(Config.ACCOUNTS_DATABASE.instance, "DELETE FROM `lock` WHERE login=?", new Object[] { activeChar.getAccountName() });
					activeChar.sendMessage("Account unlocked.");
					return true;
				}
		}

		showDefaultPage(activeChar);
		return true;
	}

	@Override
	public String[] getVoicedCommandList()
	{
		return _commandList;
	}

	@Override
	public void onLoad()
	{
		VoicedCommandHandler.getInstance().registerVoicedCommandHandler(this);
	}

	@Override
	public void onReload()
	{}

	@Override
	public void onShutdown()
	{}
}