package npc.model;

import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.templates.L2NpcTemplate;
import bosses.EkimusManager;

public class DestroyedTumorEntranceInstance extends L2NpcInstance
{
	public DestroyedTumorEntranceInstance(int objectId, L2NpcTemplate template)
	{
		super(objectId, template);
	}

	public String getHtmlPath(int npcId, int val)
	{
		if(val == 0)
			return "data/html/instance/SeedOfInfinity/TumorEntrance.htm";
		return "data/html/instance/SeedOfInfinity/TumorEntrance-" + val + ".htm";
	}

	public void onBypassFeedback(L2Player player, String command)
	{
		if (!canBypassCheck(player, this))
			return;
		if (command.equalsIgnoreCase("view"))
			showChatWindow(player, getHtmlPath(getNpcId(), 1));
		else if(command.equalsIgnoreCase("enter"))
			if (player.getParty() == null || !player.getParty().isLeader(player))
			{
				showChatWindow(player, getHtmlPath(getNpcId(), 2));
			}
			else
			{
				if(EkimusManager.teleToHeart(player, (L2NpcInstance)player.getTarget()))
					return;
				showChatWindow(player, getHtmlPath(getNpcId(), 3));
			}
		else
			onBypassFeedback(player, command);
	}
}