package npc.model;

import l2ft.extensions.scripts.Functions;
import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.items.L2ItemInstance;
import l2ft.gameserver.model.quest.QuestState;
import l2ft.gameserver.serverpackets.NpcHtmlMessage;
import l2ft.gameserver.templates.L2NpcTemplate;

/**
 * @author DarkShadow74
 *         L2JiniaNpcInstance for Jinia
 */

public class L2JiniaNpcInstance extends L2NpcInstance implements ScriptFile
{
	private static final int ICE_QUEEN_CASTLE = 139; //Ice Queen's Castle
	private static final int ICE_QUEEN_CASTLE_ULTIMATE = 144; //Ice Queen's Castle (ultimate battle)
	private static final int FrozenCore = 15469;
	private static final int BlackFrozenCore = 15470;
	
	public L2JiniaNpcInstance(int objectId, L2NpcTemplate template)
	{
		super(objectId, template);
	}

	public void onLoad()
	{}

	public void onReload()
	{}

	public void onShutdown()
	{}

	@Override
	public void onBypassFeedback(L2Player player, String command)
	{
		if(!canBypassCheck(player, this))
			return;
		
		if(command.startsWith("ask"))
		{
			int val = Integer.parseInt(command.substring(4));
			QuestState q10286 = player.getQuestState("_10286_ReunionwithSirra");
			switch(val)
			{
				/*case 1:
				    if(q10286 != null || q10286.getCond() == 5)
					{
	    				q10286.setCond(6);
						q10286.playSound("ItemSound.quest_middle");
						FreyaManager.enterInstance(player, ICE_QUEEN_CASTLE, "data/html/default/32781-07.htm");
					}
					else
	    				FreyaManager.enterInstance(player, ICE_QUEEN_CASTLE, "data/html/default/32781-07.htm");
					break;*/
				case 1:
				  //TODO  FreyaManager.enterInstance(player, ICE_QUEEN_CASTLE, "data/html/default/32781-07.htm");
					break;
				case 2:
					//Notdone Yet
					//Timer On Freya Ultimate Start TODO
	    			/**FreyaManager.enterInstance(player, ICE_QUEEN_CASTLE_ULTIMATE, "data/html/default/32781-07.htm"); */
					break;
				case 3:
				    L2ItemInstance fCore = player.getInventory().getItemByItemId(FrozenCore);
				    L2ItemInstance BlackFCore = player.getInventory().getItemByItemId(BlackFrozenCore);
					if(fCore.getCount() > 0 || BlackFCore.getCount() > 0)
					{
			    		showHtmlFile(player, "32781-09.htm");
						return;
					}
					if(q10286 == null || !q10286.isCompleted())
					{
			    		showHtmlFile(player, "32781-08.htm");
						Functions.addItem(player, BlackFrozenCore, 1);
					}
					else
					{
			    		showHtmlFile(player, "32781-08.htm");
						Functions.addItem(player, FrozenCore, 1);
					}
					break;
				case 4:
			    	showHtmlFile(player, "32781-03.htm");
					break;
				case 5:
			    	showHtmlFile(player, "32781-04.htm");
					break;
				case 6:
			    	showHtmlFile(player, "32781-05.htm");
					break;
				case 7:
			    	showHtmlFile(player, "32781-06.htm");
					break;
				default:
					showChatWindow(player, 0);
			}
		}
		else
			super.onBypassFeedback(player, command);
	}

	public void showHtmlFile(L2Player player, String file)
	{
		NpcHtmlMessage html = new NpcHtmlMessage(player, this);
		if(!player.getLang().equalsIgnoreCase("ru"))
	    	html.setFile("data/html/default/" + file);
		else
	    	html.setFile("data/html-ru/default/" + file);
			
		player.sendPacket(html);
	}

	@Override
	public void showChatWindow(L2Player player, int val)
	{
		if(player.getLevel() < 82)
		{
	    	showHtmlFile(player, "32781.htm");
		}
		else
		{
	    	showHtmlFile(player, "32781-02.htm");
		}
	}
}