package npc.model;

import l2ft.extensions.scripts.Functions;
import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.items.L2ItemInstance;
import l2ft.gameserver.serverpackets.NpcHtmlMessage;
import l2ft.gameserver.templates.L2NpcTemplate;

public class L2VitaminManagerInstance extends L2NpcInstance implements ScriptFile
{

	private static int coupon = 21275;
	private static int advancedCoupon = 21279;
	private static int roseCoupon = 20914;
	
	private static int laska = 13017;
	private static int princessa = 13018;
	private static int zver = 13019;
	private static int shaman = 13020;
	private static int toy_knight = 13548;
	private static int soul_of_mage = 13549;
	private static int owl_monk = 13550; // на руоффе не используется!
	private static int cherepaha = 13551;
	// Используем advanced итемы на 5 часов.
	private static int dzelof = 20915;
	private static int huuma = 20916;
	private static int lekang = 20917;
	private static int liliat = 20918;
	private static int lafam = 20919;
	private static int mafum = 20920;
	
	public L2VitaminManagerInstance(int objectId, L2NpcTemplate template)
	{
		super(objectId, template);
	}

	public void onLoad()
	{}

	public void onReload()
	{}

	public void onShutdown()
	{}

	@Override
	public void onBypassFeedback(L2Player player, String command)
	{
		
		L2ItemInstance _coupon = player.getInventory().getItemByItemId(coupon);
		L2ItemInstance _advancedCoupon = player.getInventory().getItemByItemId(advancedCoupon);
		L2ItemInstance _roseCoupon = player.getInventory().getItemByItemId(roseCoupon);
		
		if(!canBypassCheck(player, this))
			return;
		
		if(command.startsWith("laska"))
		{
			if (_coupon.getCount() > 0)
			{
				Functions.addItem(player, laska , 1);
				Functions.removeItem(player, coupon, 1);
			}
			else
				showHtmlFile(player, "32478-fail.htm");		
		}
		else if(command.startsWith("princessa"))
		{
			if (_coupon.getCount() > 0)
			{
				Functions.addItem(player, princessa , 1);
				Functions.removeItem(player, coupon, 1);
			}
			else
				showHtmlFile(player, "32478-fail.htm");		
		}
		else if(command.startsWith("zver"))
		{
			if (_coupon.getCount() > 0)
			{
				Functions.addItem(player, zver , 1);
				Functions.removeItem(player, coupon, 1);
			}
			else
				showHtmlFile(player, "32478-fail.htm");		
		}
		else if(command.startsWith("shaman"))
		{
			if (_coupon.getCount() > 0)
			{
				Functions.addItem(player, shaman , 1);
				Functions.removeItem(player, coupon, 1);
			}
			else
				showHtmlFile(player, "32478-fail.htm");		
		}
		else if(command.startsWith("toy_knight"))
		{
			if (_advancedCoupon.getCount() > 0)
			{
				Functions.addItem(player, toy_knight , 1);
				Functions.removeItem(player, advancedCoupon, 1);
			}
			else
				showHtmlFile(player, "32478-fail.htm");		
		}
		else if(command.startsWith("soul_of_mage"))
		{
			if (_advancedCoupon.getCount() > 0)
			{
				Functions.addItem(player, soul_of_mage , 1);
				Functions.removeItem(player, advancedCoupon, 1);
			}
			else
				showHtmlFile(player, "32478-fail.htm");		
		}
		else if(command.startsWith("cherepaha"))
		{
			if (_advancedCoupon.getCount() > 0)
			{
				Functions.addItem(player, cherepaha , 1);
				Functions.removeItem(player, advancedCoupon, 1);
			}
			else
				showHtmlFile(player, "32478-fail.htm");		
		}
		else if(command.startsWith("owl_monk"))
		{
			if (_advancedCoupon.getCount() > 0)
			{
				Functions.addItem(player, owl_monk , 1);
				Functions.removeItem(player, advancedCoupon, 1);
			}
			else
				showHtmlFile(player, "32478-fail.htm");		
		}
		else if(command.startsWith("dzelof"))
		{
			if (_roseCoupon.getCount() > 0)
			{
				Functions.addItem(player, dzelof , 1);
				Functions.removeItem(player, roseCoupon, 1);
			}
			else
				showHtmlFile(player, "32478-fail5.htm");		
		}
		else if(command.startsWith("huuma"))
		{
			if (_roseCoupon.getCount() > 0)
			{
				Functions.addItem(player, huuma , 1);
				Functions.removeItem(player, roseCoupon, 1);
			}
			else
				showHtmlFile(player, "32478-fail5.htm");		
		}
		else if(command.startsWith("lekang"))
		{
			if (_roseCoupon.getCount() > 0)
			{
				Functions.addItem(player, lekang , 1);
				Functions.removeItem(player, roseCoupon, 1);
			}
			else
				showHtmlFile(player, "32478-fail5.htm");		
		}
		else if(command.startsWith("liliat"))
		{
			if (_roseCoupon.getCount() > 0)
			{
				Functions.addItem(player, liliat , 1);
				Functions.removeItem(player, roseCoupon, 1);
			}
			else
				showHtmlFile(player, "32478-fail5.htm");		
		}
		else if(command.startsWith("lafam"))
		{
			if (_roseCoupon.getCount() > 0)
			{
				Functions.addItem(player, lafam , 1);
				Functions.removeItem(player, roseCoupon, 1);
			}
			else
				showHtmlFile(player, "32478-fail5.htm");		
		}
		else if(command.startsWith("mafum"))
		{
			if (_roseCoupon.getCount() > 0)
			{
				Functions.addItem(player, mafum , 1);
				Functions.removeItem(player, roseCoupon, 1);
			}
			else
				showHtmlFile(player, "32478-fail5.htm");		
		}
		else
			super.onBypassFeedback(player, command);
	}

	public void showHtmlFile(L2Player player, String file)
	{
		NpcHtmlMessage html = new NpcHtmlMessage(player, this);
		if(!player.getLang().equalsIgnoreCase("ru"))
	    	html.setFile("data/html/default/" + file);
		else
	    	html.setFile("data/html-ru/default/" + file);
			
		player.sendPacket(html);
	}

}