package npc.model;

import l2ft.extensions.scripts.Functions;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.instances.L2SpecialMonsterInstance;
import l2ft.gameserver.serverpackets.L2GameServerPacket;
import l2ft.gameserver.serverpackets.NpcHtmlMessage;
import l2ft.gameserver.templates.L2NpcTemplate;

public class SeducedMobInstance extends L2SpecialMonsterInstance
{
	public SeducedMobInstance(int objectId, L2NpcTemplate template)
	{
		super(objectId, template);
		hasChatWindow = true;
		boolean showHP = true;
		setAggroRange(900);

		if ((getNpcId() == 36564) || (getNpcId() == 36568) || (getNpcId() == 36563) || (getNpcId() == 36567))
			setImobilised(true);
	}

	public void spawnMe()
	{
		super.spawnMe();
		getAI().setGlobalAggro(System.currentTimeMillis() + 3000L);

		if ((getNpcId() == 36562) || (getNpcId() == 36566))
			Functions.npcSayCustomMessage(this, "q.727.SeducedKnightSpawn", new Object[0]);
	}

	public void showChatWindow(L2Player player, int val)
	{
		val = getReflection().getCollapseTime() - System.currentTimeMillis() < 300000L ? 1 : 0;
		String filename = getHtmlPath(getNpcId(), val);
		player.sendPacket(new L2GameServerPacket[] { new NpcHtmlMessage(player, this, filename, val) });
	}

	public void onBypassFeedback(L2Player player, String command)
	{
		if (!canBypassCheck(player, this)) {
			return;
		}
		if ((command.equalsIgnoreCase("LeavePailaka")) && 
			(getReflection().getId() > 0L))
			player.teleToLocation(player.getReflection().getReturnLoc(), 0L);
	}

	public boolean isAutoAttackable(L2Character attacker)
	{
		return attacker.isMonster();
	}

	public boolean isFearImmune()
	{
		return true;
	}

	public boolean isParalyzeImmune()
	{
		return true;
	}

	public boolean isLethalImmune()
	{
		return true;
	}
}