package npc.model;

import l2ft.common.ThreadPoolManager;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.instances.L2DoorInstance;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.tables.DoorTable;
import l2ft.gameserver.templates.L2NpcTemplate;
import l2ft.util.Rnd;

public class TullyDoorInstance extends L2NpcInstance
{
	public static boolean block = false;
	static int[][][] doorManager =
		{
			{{18445}, {19260002, 19260001}},
			{{18446}, {19260003}},
			{{18447}, {19260004, 19260005}},
			{{18448}, {19260006, 19260007}},
			{{18449}, {19260008}},
			{{18450}, {19260010}},
			{{18451}, {19260012}},
			{{18452}, {19260009, 19260011}},
			{{18453}, {19260014, 19260013}},
			{{18454}, {19260023, 19260015}},
			{{18455}, {19260016, 19260019}},
			{{18456}, {19260017}},
			{{18457}, {19260021, 19260020}},
			{{18458}, {19260022}},
			{{18459}, {19260018}},
			{{18460}, {19260051}},
			{{18461}, {19260052}}
		};

    public TullyDoorInstance(int objectId, L2NpcTemplate template)
    {
        super(objectId, template);
    }

	public String getHtmlPath(int npcId, int val)
	{
		if(val == 0)
			return "data/html/Tully/device_operate.htm";
		return "data/html/Tully/device_operate-" + val + ".htm";
	}

	public void onBypassFeedback(L2Player player, String command)
	{
		if (!canBypassCheck(player, this))
			return;
		if (command.equalsIgnoreCase("open"))
			if(block)
                showChatWindow(player, getHtmlPath(getNpcId(), 2));
            else
                openDoor(player);
		else
			onBypassFeedback(player, command);
	}

    public String openDoor(L2Player player)
	{
		int npc = getNpcId();
		for(int[][] index : doorManager)
		{
			if(index[0][0] == npc)
			{
                if(block)
                {
                    showChatWindow(player, getHtmlPath(npc, 2));
                }
				if(player.getClassId().getId() == 118 || Rnd.chance(40))
				{
					for(int door : index[1])
					{
						L2DoorInstance doorObj = DoorTable.getInstance().getDoor(door);
						if(door != 19260051 && door != 19260052)
						{
							ThreadPoolManager.getInstance().scheduleAi(new CloseDoor(door), 60000, false);
						}
						doorObj.openMe();
					}
				}
				else
				{
					block = true;
                    showChatWindow(player, getHtmlPath(npc, 1));
					ThreadPoolManager.getInstance().scheduleAi(new unlock(), 60000, false);
				}
			}
		}
        return null;
    }

	class CloseDoor implements Runnable
	{
		private int doorId;

		public CloseDoor(int doorId)
		{
			this.doorId = doorId;
		}

		public void run()
		{
			DoorTable.getInstance().getDoor(doorId).closeMe();
		}
	}

	class unlock implements Runnable
	{
		public void run()
		{
			block = false;
		}
	}
}