package quests._023_LidiasHeart;

import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;
import quests._022_TragedyInVonHellmannForest._022_TragedyInVonHellmannForest;

public class _023_LidiasHeart extends Quest implements ScriptFile
{
	// ~~~~~~ npcId list: ~~~~~~
	int Innocentin = 31328;
	int BrokenBookshelf = 31526;
	int GhostofvonHellmann = 31524;
	int Tombstone = 31523;
	int Violet = 31386;
	int Box = 31530;

	// ~~~~~ itemId List ~~~~~
	int MapForestofDeadman = 7063;
	int SilverKey = 7149;
	int LidiaHairPin = 7148;
	int LidiaDiary = 7064;
	int SilverSpear = 7150;

	@Override
	public void onLoad()
	{}

	@Override
	public void onReload()
	{}

	@Override
	public void onShutdown()
	{}

	public _023_LidiasHeart()
	{
		super(false);

		addStartNpc(Innocentin);

		addTalkId(Innocentin);
		addTalkId(BrokenBookshelf);
		addTalkId(GhostofvonHellmann);
		addTalkId(Tombstone);
		addTalkId(Violet);
		addTalkId(Box);
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		String htmltext = event;
		if(event.equals("highpriest_innocentin_q0023_03.htm"))
		{
			st.giveItems(MapForestofDeadman, 1);
			st.giveItems(SilverKey, 1);
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equals("highpriest_innocentin_q0023_04.htm"))
			st.set("cond", "2");
		else if(event.equals("broken_desk1_q0023_02.htm"))
			st.set("cond", "3");
		else if(event.equals("broken_desk1_q0023_06.htm"))
		{
			st.giveItems(LidiaHairPin, 1);
			if(st.getQuestItemsCount(LidiaDiary) != 0)
				st.set("cond", "4");
		}
		else if(event.equals("broken_desk1_q0023_11.htm"))
		{
			st.giveItems(LidiaDiary, 1);
			if(st.getQuestItemsCount(LidiaHairPin) != 0)
				st.set("cond", "4");
		}
		else if(event.equals("highpriest_innocentin_q0023_20.htm"))
			st.set("cond", "6");
		else if(event.equals("rune_ghost1_q0023_04.htm"))
		{
			st.set("cond", "7");
			st.takeItems(LidiaDiary, -1);
		}
		else if(event.equals("q_forest_stone1_q0023_02.htm"))
			st.addSpawn(GhostofvonHellmann, 120000);
		else if(event.equals("q_forest_stone1_q0023_05.htm"))
			st.startQuestTimer("viwer_timer", 10000);
		else if(event.equals("viwer_timer"))
		{
			st.set("cond", "8");
			htmltext = "q_forest_stone1_q0023_06.htm";
		}
		else if(event.equals("rust_box1_q0023_02.htm"))
		{
			st.set("cond", "10");
			st.takeItems(SilverKey, -1);
			st.giveItems(SilverSpear, 1);
		}
		else if(event.equals("q_ridia_diary_q0023_02.htm"))
			htmltext = "q_ridia_diary_q0023_02.htm";
		else if(event.equals("broken_desk1_q0023_13.htm"))
			st.startQuestTimer("read_book", 120000);
		else if(event.equals("read_book"))
			htmltext = "q_ridia_diary001.htm";
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == Innocentin)
		{
			if(cond == 0)
			{
				QuestState TragedyInVonHellmannForest = st.getPlayer().getQuestState(_022_TragedyInVonHellmannForest.class);
				if(TragedyInVonHellmannForest != null)
					if(TragedyInVonHellmannForest.isCompleted())
						htmltext = "highpriest_innocentin_q0023_01.htm";
					else
						htmltext = "highpriest_innocentin_q0023_01a.htm";
			}
			else if(cond == 1)
				htmltext = "highpriest_innocentin_q0023_04.htm";
			else if(cond == 2)
				htmltext = "highpriest_innocentin_q0023_08.htm";
			else if(cond == 4)
				htmltext = "highpriest_innocentin_q0023_09.htm";
			else if(cond == 6)
				htmltext = "highpriest_innocentin_q0023_20.htm";
		}
		else if(npcId == BrokenBookshelf)
		{
			if(cond == 2)
			{
				if(st.getQuestItemsCount(SilverKey) != 0)
					htmltext = "broken_desk1_q0023_01.htm";
			}
			else if(cond == 3)
			{
				if(st.getQuestItemsCount(LidiaHairPin) == 0 && st.getQuestItemsCount(LidiaDiary) != 0)
					htmltext = "broken_desk1_q0023_12.htm";
				else if(st.getQuestItemsCount(LidiaHairPin) != 0 && st.getQuestItemsCount(LidiaDiary) == 0)
					htmltext = "broken_desk1_q0023_07.htm";
				else if(st.getQuestItemsCount(LidiaHairPin) == 0 && st.getQuestItemsCount(LidiaDiary) == 0)
					htmltext = "broken_desk1_q0023_03.htm";
			}
			else if(cond == 4)
				htmltext = "broken_desk1_q0023_13.htm";
		}
		else if(npcId == GhostofvonHellmann)
		{
			if(cond == 6)
				htmltext = "rune_ghost1_q0023_01.htm";
			else if(cond == 7)
				htmltext = "rune_ghost1_q0023_05.htm";
		}
		else if(npcId == Tombstone)
		{
			if(cond == 6)
				if(st.getQuestTimer("spawn_timer") != null)
					htmltext = "q_forest_stone1_q0023_03.htm";
				else
					htmltext = "q_forest_stone1_q0023_01.htm";
			if(cond == 7)
				htmltext = "q_forest_stone1_q0023_04.htm";
			else if(cond == 8)
				htmltext = "q_forest_stone1_q0023_06.htm";
		}
		else if(npcId == Violet)
		{
			if(cond == 8)
			{
				htmltext = "day_violet_q0023_01.htm";
				st.set("cond", "9");
			}
			else if(cond == 9)
				htmltext = "day_violet_q0023_02.htm";
			else if(cond == 10)
				if(st.getQuestItemsCount(SilverSpear) != 0)
				{
					htmltext = "day_violet_q0023_03.htm";
					st.takeItems(SilverSpear, -1);
					st.giveItems(ADENA_ID, 350000);
					st.addExpAndSp(456893, 42112);
					st.playSound(SOUND_FINISH);
					st.exitCurrentQuest(false);
				}
				else
					htmltext = "You have no Silver Spear...";
		}
		else if(npcId == Box)
			if(cond == 9)
				if(st.getQuestItemsCount(SilverKey) != 0)
					htmltext = "rust_box1_q0023_01.htm";
				else
					htmltext = "You have no key...";
			else if(cond == 10)
				htmltext = "day_violet_q0023_03.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		return null;
	}
}