package quests._026_TiredofWaiting;

import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;

public class _026_TiredofWaiting extends Quest implements ScriptFile
{
	//NPC
	private static final int Isael_Silvershadow = 30655;
	private static final int Kitzka = 31045;
	//Items
	private static final int Large_Dragon_Bone =  17248;
	private static final int Will_of_Antharas = 17266;
	private static final int Sealed_Blood_Crystal = 17267;

	public void onLoad()
	{}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _026_TiredofWaiting()
	{
		super(false);

		addStartNpc(Isael_Silvershadow);
		addTalkId(Kitzka);
	}
	
	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("Large_Dragon_Bone"))
		{
			htmltext = "31045-2.htm";
			st.giveItems(Large_Dragon_Bone, 1, true);
			st.playSound(SOUND_FINISH);
			st.setState(COMPLETED);
			st.exitCurrentQuest(false);
		}
		else if(event.equalsIgnoreCase("Will_of_Antharas"))
		{
			htmltext = "31045-2.htm";
			st.giveItems(Will_of_Antharas, 1, true);
			st.playSound(SOUND_FINISH);
			st.setState(COMPLETED);
			st.exitCurrentQuest(false);
		}
		else if(event.equalsIgnoreCase("Sealed_Blood_Crystal"))
		{
			htmltext = "31045-2.htm";
			st.giveItems(Sealed_Blood_Crystal, 1, true);
			st.playSound(SOUND_FINISH);
			st.setState(COMPLETED);
			st.exitCurrentQuest(false);
		}
		else if(event.equalsIgnoreCase("30655-2.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		String htmltext = "noquest";
		int cond = st.getInt("cond");
		if(npcId == Isael_Silvershadow)
		{
			if(cond == 0)
			{
				if(st.getPlayer().getLevel() >= 80)
					htmltext = "30655-1.htm";
				else
				{
					htmltext = "30655-3.htm";
					st.exitCurrentQuest(true);
				}
			}
			else if(cond == 1)
				htmltext = "30655-4.htm";
		}
		else if(npcId == Kitzka)
			if(cond == 1)
				htmltext = "31045-1.htm";
		return htmltext;
	}
}