package quests._10268_ToTheSeedOfInfinity;

import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;

public class _10268_ToTheSeedOfInfinity extends Quest implements ScriptFile
{
	private final static int Keucereus = 32548;
	private final static int Tepios = 32603;

	private final static int Introduction = 13811;

	public CheckStatus LAST_CHECK_STATUS = CheckStatus.HIGH_FIVE;

	@Override
	public void onLoad()
	{}

	@Override
	public void onReload()
	{}

	@Override
	public void onShutdown()
	{}

	public _10268_ToTheSeedOfInfinity()
	{
		super(false);
		addStartNpc(Keucereus);
		addTalkId(Tepios);
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("quest_accept"))
		{
			htmltext = "kserth_q10268_07.htm";
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
			st.giveItems(Introduction, 1);
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int id = st.getState();
		int npcId = npc.getNpcId();
		switch(id)
		{
			case COMPLETED:
				if(npcId == Tepios)
					htmltext = "officer_tepios_q10268_02.htm";
				else
					htmltext = "kserth_q10268_03.htm";
				break;
			case CREATED:
				if(npcId == Keucereus)
					if(st.getPlayer().getLevel() < 75)
						htmltext = "kserth_q10268_02.htm";
					else
						htmltext = "kserth_q10268_01.htm";
				break;
			case STARTED:
				if(npcId == Keucereus)
					htmltext = "kserth_q10268_08.htm";
				else if(npcId == Tepios)
				{
					htmltext = "officer_tepios_q10268_01.htm";
					st.giveItems(ADENA_ID, 16671);
					st.addExpAndSp(100640, 10098, true);
					st.exitCurrentQuest(false);
					st.playSound(SOUND_FINISH);
				}
				break;
		}
		return htmltext;
	}
}