package quests._10269_ToTheSeedOfDestruction;

import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;

public class _10269_ToTheSeedOfDestruction extends Quest implements ScriptFile
{
	private final static int Keucereus = 32548;
	private final static int Allenos = 32526;

	private final static int Introduction = 13812;

	public CheckStatus LAST_CHECK_STATUS = CheckStatus.GRACIA_EPILOGUE;

	@Override
	public void onLoad()
	{}

	@Override
	public void onReload()
	{}

	@Override
	public void onShutdown()
	{}

	public _10269_ToTheSeedOfDestruction()
	{
		super(false);

		addStartNpc(Keucereus);

		addTalkId(Allenos);
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("quest_accept"))
		{
			htmltext = "kserth_q10269_07.htm";
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
			st.giveItems(Introduction, 1);
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int id = st.getState();
		int npcId = npc.getNpcId();
		if(id == COMPLETED)
			if(npcId == Allenos)
				htmltext = "servant_of_kserth_q10269_02.htm";
			else
				htmltext = "kserth_q10269_03.htm";
		else if(id == CREATED && npcId == Keucereus)
			if(st.getPlayer().getLevel() < 75)
				htmltext = "kserth_q10269_02.htm";
			else
				htmltext = "kserth_q10269_01.htm";
		else if(id == STARTED && npcId == Keucereus)
			htmltext = "kserth_q10269_08.htm";
		else if(id == STARTED && npcId == Allenos)
		{
			htmltext = "servant_of_kserth_q10269_01.htm";
			st.giveItems(ADENA_ID, 29174);
			st.addExpAndSp(176121, 17671, true);
			st.exitCurrentQuest(false);
			st.playSound(SOUND_FINISH);
		}
		return htmltext;
	}
}