package quests._10292_SevenSignsGirlOfDoubt;

import javolution.util.FastMap;
import l2ft.gameserver.ai.CtrlEvent;
import l2ft.gameserver.cache.Msg;
import l2ft.gameserver.instancemanager.InstancedZoneManager;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.entity.InstancedZone;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;
import l2ft.gameserver.model.Reflection;
import l2ft.gameserver.serverpackets.SystemMessage;
import l2ft.gameserver.serverpackets.SocialAction;
import l2ft.util.GArray;
import quests._198_SevenSignsEmbryo._198_SevenSignsEmbryo;

public class _10292_SevenSignsGirlOfDoubt extends Quest
{
	private static FastMap<Integer, Long> _instances = new FastMap<Integer, Long>();
	private static FastMap<Integer, Integer> spawns = new FastMap<Integer, Integer>();
	private static FastMap<Integer, Integer> spawns1 = new FastMap<Integer, Integer>();
	// NPCs
	private static int Wood = 32593;
	private static int Franz = 32597;
	private static int AbyssalSaintessElcadia = 31621;
	private static int Hardin = 30832;
	private static int Jaina = 32582;
	private static int GruffLookingMan = 32862;

	// Monsters
	private static int CruelPincerGolem = 22801;
	private static int HorrifyingJackhammerGolem = 22804;
	private static int CreatureOfTheDusk = 27421;

	// Items
	private static int ElcadiasMark = 17226;

	public _10292_SevenSignsGirlOfDoubt()
	{
		super(false);

		addStartNpc(Wood);
		addTalkId(Franz, Jaina, GruffLookingMan, AbyssalSaintessElcadia, Hardin);
		addKillId(CruelPincerGolem, HorrifyingJackhammerGolem, CreatureOfTheDusk);
		addQuestItem(ElcadiasMark);
	}

	private void spawn(QuestState st, int npcId)
	{
		L2Player player = st.getPlayer();
		Reflection r = player.getReflection();
		L2NpcInstance mob = addSpawnToInstance(npcId, player.getLoc(), 0, r.getId());
		L2NpcInstance mob1 = addSpawnToInstance(npcId, player.getLoc(), 0, r.getId());
		spawns.put(player.getObjectId(), mob.getObjectId());
		spawns1.put(player.getObjectId(), mob1.getObjectId());
		mob.getAI().notifyEvent(CtrlEvent.EVT_AGGRESSION, player, 100000);
		mob1.getAI().notifyEvent(CtrlEvent.EVT_AGGRESSION, player, 100000);	
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		L2Player player = st.getPlayer();
		String htmltext = event;
		if(event.equalsIgnoreCase("32597-03.htm"))
		{
			st.setCond(2);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("31621-03.htm"))
		{
			st.setCond(3);
			st.playSound(SOUND_MIDDLE);
			returnToBackCoords(player);
		}
		else if(event.equalsIgnoreCase("Summon"))
		{
			st.setCond(5);
			spawn(st, CreatureOfTheDusk);
			return null;
		}
		else if(event.equalsIgnoreCase("31621-11.htm"))
		{
			st.setCond(7);
			st.playSound(SOUND_MIDDLE);
			returnToBackCoords(player);
		}
		else if(event.equalsIgnoreCase("30832-02.htm"))
		{
			st.setCond(8);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("Enter1"))
		{
			st.setCond(1);
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
			enterInstance(player, 21);
			return null;
		}
		else if(event.equalsIgnoreCase("Return1"))
		{
			returnToBackCoords(player);
			return null;
		}
		else if(event.equalsIgnoreCase("EnterElcadia"))
		{
			enterInstance(player , 22);
			return null;
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getCond();
		L2Player player = st.getPlayer();
		String htmltext = "noquest";
		if(npcId == Wood)
		{
			QuestState qs = player.getQuestState(_198_SevenSignsEmbryo.class);
			if(cond == 0)
			{
				if(player.getLevel() >= 81 && qs != null && qs.isCompleted())
					htmltext = "32593-01.htm";
				else
				{
					htmltext = "32593-00.htm";
					st.exitQuest(true);
				}
			}
			else if(cond == 1)
				htmltext = "32593-02.htm";
			else if(cond >= 2)
				htmltext = "32593-05.htm";
		}
		else if(npcId == GruffLookingMan)
		{
			if(cond == 2 || cond == 4 || cond == 8)
				htmltext = "32862-01.htm";
		}
		else if(npcId == Franz)
		{
			if(cond == 1)
				htmltext = "32597-01.htm";
			else if(cond == 2)
				htmltext = "32597-05.htm";
		}
		else if(npcId == Jaina)
		{
			if(cond == 2)
				htmltext = "32582.htm";
		}
		else if(npcId == AbyssalSaintessElcadia)
		{
			if(cond == 2)
				htmltext = "31621-01.htm";
			else if(cond == 3)
				htmltext = "31621-04.htm";
			else if(cond == 4)
			{
				st.setCond(4);
				st.playSound(SOUND_MIDDLE);
				htmltext = "31621-05.htm";
			}
			else if(cond == 5)
				htmltext = "31621-07.htm";
			else if(cond == 6)
				htmltext = "31621-08.htm";
			else if(cond == 7)
				htmltext = "31621-11.htm";
			else if(cond == 8)
			{
				if(player.getLevel() < 81)
					htmltext = "<html><body>Only characters who are <font color=\"LEVEL\">level 81</font> or higher may complete this quest.</body></html>";
				else
				{
					htmltext = "31621-12.htm";
					st.addExpAndSp(10000000, 1000000);
					player.broadcastPacket(new SocialAction(player.getObjectId(), SocialAction.VICTORY));
					st.exitQuest(false);
					st.playSound(SOUND_FINISH);
					returnToBackCoords(player);
				}
			}
		}
		else if(npcId == Hardin)
		{
			if(cond == 7)
				htmltext = "30832-01.htm";
			else if(cond == 8)
				htmltext = "30832-03.htm";
		}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getCond();
		L2Player player = st.getPlayer();
		if(player == null)
			return null;
		if(cond == 3)
		{
			if(npcId == CruelPincerGolem || npcId == HorrifyingJackhammerGolem)
			{
				st.giveItems(ElcadiasMark, 1);
				if(st.getQuestItemsCount(ElcadiasMark) >= 10)
				{
					st.setCond(4);
					st.playSound(SOUND_MIDDLE);
				}
				else
					st.playSound(SOUND_ITEMGET);
			}
		}
		else if(cond == 5)
		{
			if(npcId == CreatureOfTheDusk)
				if(st.getInt("killed") == 1)
				{
					st.setCond(6);
					st.playSound(SOUND_MIDDLE);
				}
				else
					st.set("killed", 1);
		}
		return null;
	}

	private void enterInstance(L2Player player, int instancedZoneId)
	{
		InstancedZoneManager ilm = InstancedZoneManager.getInstance();
		FastMap<Integer, InstancedZone> ils = ilm.getById(instancedZoneId);
		if(ils == null)
		{
			player.sendPacket(Msg.SYSTEM_ERROR);
			return;
		}

		InstancedZone il = ils.get(0);

		assert il != null;

		if(player.isInParty())
		{
			player.sendPacket(Msg.A_PARTY_CANNOT_BE_FORMED_IN_THIS_AREA);
			return;
		}

		if(player.isCursedWeaponEquipped())
		{
			player.sendPacket(new SystemMessage(SystemMessage.C1S_QUEST_REQUIREMENT_IS_NOT_SUFFICIENT_AND_CANNOT_BE_ENTERED).addName(player));
			return;
		}

		Reflection r = new Reflection(il.getName());
		r.setInstancedZoneId(instancedZoneId);
		for(InstancedZone i : ils.values())
		{
			if(r.getReturnLoc() == null)
				r.setReturnLoc(i.getReturnCoords());
			if(r.getTeleportLoc() == null)
				r.setTeleportLoc(i.getTeleportCoords());
			r.FillSpawns(i.getSpawnsInfo());
			r.FillDoors(i.getDoors());
		}

		int timelimit = il.getTimelimit();

		player.setReflection(r);
		player.teleToLocation(il.getTeleportCoords());
		player.setVar("backCoords", r.getReturnLoc().toXYZString());

		r.setNotCollapseWithoutPlayers(true);
		r.startCollapseTimer(timelimit * 60 * 1000L);

		_instances.put(player.getObjectId(), r.getId());
	}

	private void returnToBackCoords(L2Player player)
	{
		Reflection r = player.getReflection();
		if(r.getReturnLoc() != null)
			player.teleToLocation(r.getReturnLoc(), 0);
		else
			player.setReflection(0);
		player.unsetVar("backCoords");
	}
}