package quests._10293_SevenSignsForbiddenBook;

import javolution.util.FastMap;
import l2ft.gameserver.cache.Msg;
import l2ft.gameserver.instancemanager.InstancedZoneManager;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.entity.InstancedZone;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;
import l2ft.gameserver.model.Reflection;
import l2ft.gameserver.serverpackets.SystemMessage;
import l2ft.gameserver.serverpackets.SocialAction;
import l2ft.util.Location;
import quests._10292_SevenSignsGirlOfDoubt._10292_SevenSignsGirlOfDoubt;

public class _10293_SevenSignsForbiddenBook extends Quest
{
	private static FastMap<Integer, Long> _instances = new FastMap<Integer, Long>();
	// NPCs
	private static int Sophia1 = 32596;
	private static int Sophia2 = 32861;
	private static int Sophia3 = 32863;
	private static int AbyssalSaintessElcadia1 = 31621;
	private static int AbyssalSaintessElcadia2 = 32784; // TODO AI
	private static int PileOfBooks = 32809;
	private static int GruffLookingMan = 32862;

	// Items
	private static int SolinasBiography = 17213;
	
	public _10293_SevenSignsForbiddenBook()
	{
		super(false);

		addStartNpc(AbyssalSaintessElcadia1, GruffLookingMan);
		addTalkId(Sophia1, Sophia2, Sophia3, AbyssalSaintessElcadia2, PileOfBooks);
		addQuestItem(SolinasBiography);
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		L2Player player = st.getPlayer();
		String htmltext = event;
		if(event.equalsIgnoreCase("31621-03.htm"))
		{
			st.setCond(1);
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
			returnToTown(player);
		}
		else if(event.equalsIgnoreCase("NotReady"))
			return null;
		else if(event.equalsIgnoreCase("32861-04.htm"))
		{
			st.setCond(2);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("32861-07.htm"))
		{
			st.setCond(4);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("32784-06.htm"))
		{
			st.setCond(5);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("32861-09.htm"))
		{
			st.setCond(6);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("32784-08.htm"))
		{
			st.setCond(7);
			st.giveItems(SolinasBiography, 1);
			st.playSound(SOUND_ITEMGET);
		}
		else if(event.equalsIgnoreCase("31621-06.htm")) // TODO этого диалога не хватает, на оф. сервере вместо него ошибка
		{
			if(player.getLevel() < 81)
				htmltext = "<html><body>Only characters who are <font color=\"LEVEL\">level 81</font> or higher may complete this quest.</body></html>";
			else
			{
				st.addExpAndSp(15000000, 1500000);
				player.broadcastPacket(new SocialAction(player.getObjectId(), SocialAction.VICTORY));
				st.exitQuest(false);
				st.playSound(SOUND_FINISH);
				returnToTown(player);
			}
			return null;
		}
		else if(event.equalsIgnoreCase("Enter1"))
		{
			enterInstance(player, 601);
			return null;
		}
		else if(event.equalsIgnoreCase("Enter2"))
		{
			player.teleToLocation(new Location(37352, -50600, -1176));
			htmltext = "return.htm";
			return null;
		}
		else if(event.equalsIgnoreCase("Enter3"))
		{
			player.teleToLocation(new Location(37048, -49576, -1128));
			return null;
		}
		else if(event.equalsIgnoreCase("EnterElcadia"))
		{
			enterInstance(player , 22);
			return null;
		}
		else if(event.equalsIgnoreCase("ReturnToTown"))
		{
			returnToTown(player);
			return null;
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getCond();
		L2Player player = st.getPlayer();
		String htmltext = "noquest";
		if(npcId == AbyssalSaintessElcadia1)
		{
			QuestState qs = player.getQuestState(_10292_SevenSignsGirlOfDoubt.class);
			if(cond == 0)
			{
				if(player.getLevel() >= 81 && qs != null && qs.isCompleted())
					htmltext = "31621-01.htm";
				else
				{
					htmltext = "31621-00.htm";
					st.exitQuest(true);
				}
			}
			else if(cond == 1)
				htmltext = "31621-03.htm";
			else if(cond == 8)
				htmltext = "31621-04.htm";
		}
		else if(npcId == PileOfBooks)
		{
			if(cond == 6)
				htmltext = "32809-01.htm";
		}
		else if(npcId == GruffLookingMan)
		{
			htmltext = "32862-01.htm";
		}
		else if(npcId == Sophia1)
		{
			if(cond == 1)
				htmltext = "32596-01.htm";
			else if(cond == 2)
				htmltext = "32596-03.htm";
		}
		else if(npcId == Sophia2)
		{
			if(cond == 1)
				htmltext = "32861-01.htm";
			else if(cond == 2)
				htmltext = "32861-04.htm";
			else if(cond == 3)
				htmltext = "32861-05.htm";
			else if(cond == 4)
				htmltext = "32861-07.htm";
			else if(cond == 5)
				htmltext = "32861-08.htm";
			else if(cond == 6)
				htmltext = "32861-10.htm";
			else if(cond == 8)
				htmltext = "32861-11.htm";
		}
		else if(npcId == Sophia3)
		{
			if(cond == 6)
				htmltext = "32863-01.htm";
			else if(cond == 7 || cond == 8)
				htmltext = "32863-02.htm";
		}
		else if(npcId == AbyssalSaintessElcadia2)
		{
			if(cond == 1)
				htmltext = "32784-01.htm";
			else if(cond == 2)
			{
				st.setCond(3);
				st.playSound(SOUND_MIDDLE);
				htmltext = "32784-03.htm";
			}
			else if(cond == 3)
				htmltext = "32784-04.htm";
			else if(cond == 4)
				htmltext = "32784-05.htm";
			else if(cond == 5)
				htmltext = "32784-06.htm";
			else if(cond == 6)
				htmltext = "32784-07.htm";
			else if(cond == 7)
			{
				st.setCond(8);
				st.playSound(SOUND_MIDDLE);
				htmltext = "32784-09.htm";
			}
			else if(cond == 8)
				htmltext = "32784-10.htm";
		}
		return htmltext;
	}

	private void returnToTown(L2Player player)
	{
		Reflection r = player.getReflection();
		if(r.getReturnLoc() != null)
			player.teleToLocation(r.getReturnLoc(), 0);
		else
			player.setReflection(0);
		player.unsetVar("backCoords");
	}

	private void enterInstance(L2Player player, int instancedZoneId)
	{
		InstancedZoneManager ilm = InstancedZoneManager.getInstance();
		FastMap<Integer, InstancedZone> ils = ilm.getById(instancedZoneId);
		if(ils == null)
		{
			player.sendPacket(Msg.SYSTEM_ERROR);
			return;
		}

		InstancedZone il = ils.get(0);

		assert il != null;

		if(player.isInParty())
		{
			player.sendPacket(Msg.A_PARTY_CANNOT_BE_FORMED_IN_THIS_AREA);
			return;
		}

		if(player.isCursedWeaponEquipped())
		{
			player.sendPacket(new SystemMessage(SystemMessage.C1S_QUEST_REQUIREMENT_IS_NOT_SUFFICIENT_AND_CANNOT_BE_ENTERED).addName(player));
			return;
		}

		Reflection r = new Reflection(il.getName());
		r.setInstancedZoneId(instancedZoneId);
		for(InstancedZone i : ils.values())
		{
			if(r.getReturnLoc() == null)
				r.setReturnLoc(i.getReturnCoords());
			if(r.getTeleportLoc() == null)
				r.setTeleportLoc(i.getTeleportCoords());
			r.FillSpawns(i.getSpawnsInfo());
			r.FillDoors(i.getDoors());
		}

		int timelimit = il.getTimelimit();

		player.setReflection(r);
		player.teleToLocation(il.getTeleportCoords());
		player.setVar("backCoords", r.getReturnLoc().toXYZString());

		r.setNotCollapseWithoutPlayers(true);
		r.startCollapseTimer(timelimit * 60 * 1000L);

		_instances.put(player.getObjectId(), r.getId());
	}
}