package quests._10294_SevenSignsToTheMonastery;

import javolution.util.FastMap;
import l2ft.common.ThreadPoolManager;
import l2ft.gameserver.cache.Msg;
import l2ft.gameserver.instancemanager.InstancedZoneManager;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.entity.InstancedZone;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;
import l2ft.gameserver.model.Reflection;
import l2ft.gameserver.serverpackets.EventTrigger;
import l2ft.gameserver.serverpackets.ExChangeNpcState;
import l2ft.gameserver.serverpackets.ExStartScenePlayer;
import l2ft.gameserver.serverpackets.SocialAction;
import l2ft.gameserver.serverpackets.SystemMessage;
import l2ft.util.Location;
import l2ft.util.Util;
import quests._10293_SevenSignsForbiddenBook._10293_SevenSignsForbiddenBook;

public class _10294_SevenSignsToTheMonastery extends Quest
{
	private static FastMap<Integer, Long> _instances = new FastMap<Integer, Long>();
	// NPCs
	private static int AbyssalSaintessElcadia = 31621;
	private static int AbyssalSaintessElcadia2 = 32785; // TODO AI
	private static int ErissEvilThoughts = 32792;
	private static int GruffLookingMan = 32862;
	private static int Globus = 32815;

	private static int RelicGuardian = 32803;

	private static int WestRelicWatcher = 32804;
	private static int NorthRelicWatcher = 32805;
	private static int EastRelicWatcher = 32806;
	private static int SouthRelicWatcher = 32807;

	private static int WestTeleportControlDevice = 32816;
	private static int NorthTeleportControlDevice = 32817;
	private static int EastTeleportControlDevice = 32818;
	private static int SouthTeleportControlDevice = 32819;

	private static int WestReadingDesk1 = 32821;
	private static int WestReadingDesk2 = 32822;
	private static int WestReadingDesk3 = 32823;
	private static int WestReadingDesk4 = 32824;

	private static int NorthReadingDesk1 = 32825;
	private static int NorthReadingDesk2 = 32826;
	private static int NorthReadingDesk3 = 32827;
	private static int NorthReadingDesk4 = 32828;

	private static int EastReadingDesk1 = 32829;
	private static int EastReadingDesk2 = 32830;
	private static int EastReadingDesk3 = 32831;
	private static int EastReadingDesk4 = 32832;

	private static int SouthReadingDesk1 = 32833;
	private static int SouthReadingDesk2 = 32834;
	private static int SouthReadingDesk3 = 32835;
	private static int SouthReadingDesk4 = 32836;

	// TODO охранники, спавняться при неправильной книге.
	//private static int EtisVanEtina = 32808; // этот первым, как предупреждение
	//private static int JudeVanEtinasEvilThoughts = 32888; // а этот вместе с гвардами

	//private static int SolinasEvilThoughts = 32793; // Появляется после последней заставки

	/* TODO диалоги
	<HTML><BODY>There's a book emitting holy light on what appears to be a stone coffin.<br><a action="bypass -h talk_select">Quest</a></body></html>

	<HTML><BODY>Jude van Etina:<br>What we need now is silence, I care not for any truth or confession.<br><a action="bypass -h talk_select">Quest</a></body></html>
	<html><head><body>Jude van Etina's Evil Thoughts:<br>How dare you.... Do you test my wrath?? No one interupts Solina's resting place! Leave before I remove your head from its body!</body></html>

	<html><head><body>Jude van Etina's Evil Thoughts:<br>Monastery of Silence and Saint's secret must remain in the shadows. Your simple minds could never handle the truth hidden in this place...</body></html>

	<HTML><BODY>Elmore-Aden's Saintess Solina:<br>For an eternity, I've been waiting for you.<br><a action="bypass -h talk_select">Quest</a></body></html>
	<html><head><body>Elmore-Aden's Saintess Solina:<br>……<br><br>This phantom looks like Solina, Elmore-Aden's Saintess. The phantom appears to be trying to say something. It looks like she doesn't intend to harm us... </body></html>
	 */

	private static int[][] desks = new int[][] {
			{ WestReadingDesk1, WestReadingDesk2, WestReadingDesk3, WestReadingDesk4 },
			{ NorthReadingDesk1, NorthReadingDesk2, NorthReadingDesk3, NorthReadingDesk4 },
			{ EastReadingDesk1, EastReadingDesk2, EastReadingDesk3, EastReadingDesk4 },
			{ SouthReadingDesk1, SouthReadingDesk2, SouthReadingDesk3, SouthReadingDesk4 } };

	public _10294_SevenSignsToTheMonastery()
	{
		super(false);
		addStartNpc(AbyssalSaintessElcadia, GruffLookingMan);
		addTalkId(ErissEvilThoughts, AbyssalSaintessElcadia2, RelicGuardian, Globus);
		addTalkId(WestRelicWatcher, NorthRelicWatcher, EastRelicWatcher, SouthRelicWatcher);
		addTalkId(WestTeleportControlDevice, NorthTeleportControlDevice, EastTeleportControlDevice, SouthTeleportControlDevice);
		addFirstTalkId(WestTeleportControlDevice, NorthTeleportControlDevice, EastTeleportControlDevice, SouthTeleportControlDevice);

		for(int[] ids : desks)
			addTalkId(ids);

		for(int[] ids : desks)
			addFirstTalkId(ids);

		//addQuestItem();
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		L2Player player = st.getPlayer();
		String htmltext = event;
		if(event.equalsIgnoreCase("31621-03.htm"))
		{
			st.setCond(1);
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
			returnToTown(player);
		}
		if(event.equalsIgnoreCase("32792-03.htm"))
		{
			st.setCond(2);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("Enter3"))
		{
			player.teleToLocation(new Location(85937, -249618, -8320));
			ThreadPoolManager.getInstance().scheduleAi(new MovieStartTask(player), 5000, true);
			return null;
		}
		else if(event.equalsIgnoreCase("TeleWest"))
		{
			if(st.getCond() == 3)
				return "32785-06.htm";
			player.teleToLocation(new Location(82434, -249546, -8320));
			return null;
		}
		else if(event.equalsIgnoreCase("TeleNorth"))
		{
			if(st.getCond() == 3)
				return "32785-06.htm";
			player.teleToLocation(new Location(85691, -252426, -8320));
			return null;
		}
		else if(event.equalsIgnoreCase("TeleEast"))
		{
			if(st.getCond() == 3)
				return "32785-06.htm";
			player.teleToLocation(new Location(88573, -249556, -8320));
			return null;
		}
		else if(event.equalsIgnoreCase("TeleSouth"))
		{
			if(st.getCond() == 3)
				return "32785-06.htm";
			player.teleToLocation(new Location(85675, -246630, -8320));
			return null;
		}
		else if(event.equalsIgnoreCase("ReturnToEris"))
		{
			player.teleToLocation(new Location(120727, -86868, -3392));
			return null;
		}
		else if(event.equalsIgnoreCase("ReturnToGuardian"))
		{
			player.teleToLocation(new Location(85937, -249618, -8320));
			return null;
		}
		else if(event.equalsIgnoreCase("EnterElcadia"))
		{
			enterInstance(player , 22);
			return null;
		}
		else if(event.equalsIgnoreCase("32785-04.htm"))
		{
			// TODO спавн охраны
		}
		else if(event.equalsIgnoreCase("TeleInst"))
		{
			enterInstance(player, 603);
			return null;
		}
		else if(event.equalsIgnoreCase("to32821"))
		{
			st.playSound(SOUND_MIDDLE);
			st.playSound(SOUND_MIDDLE);
			player.sendPacket(new ExChangeNpcState(npc.getObjectId(), 1));
			st.set("book_" + 32821, 1);
			htmltext = "32785-05.htm";
			if(isAllBooksFinded(st))
			{
				player.sendPacket(new EventTrigger(22100500, false));
				player.sendPacket(new EventTrigger(22100502, true));
				player.showQuestMovie(ExStartScenePlayer.SCENE_SSQ2_HOLY_BURIAL_GROUND_CLOSING);
			}
			return null;
		}
		else if(event.equalsIgnoreCase("to32825"))
		{
			st.playSound(SOUND_MIDDLE);
			st.playSound(SOUND_MIDDLE);
			player.sendPacket(new ExChangeNpcState(npc.getObjectId(), 1));
			st.set("book_" + 32825, 1);
			htmltext = "32785-05.htm";
			if(isAllBooksFinded(st))
			{
				player.sendPacket(new EventTrigger(22100500, false));
				player.sendPacket(new EventTrigger(22100502, true));
				player.showQuestMovie(ExStartScenePlayer.SCENE_SSQ2_HOLY_BURIAL_GROUND_CLOSING);
			}
			return null;
		}
		else if(event.equalsIgnoreCase("to32829"))
		{
			st.playSound(SOUND_MIDDLE);
			st.playSound(SOUND_MIDDLE);
			player.sendPacket(new ExChangeNpcState(npc.getObjectId(), 1));
			st.set("book_" + 32829, 1);
			htmltext = "32785-05.htm";
			if(isAllBooksFinded(st))
			{
				player.sendPacket(new EventTrigger(22100500, false));
				player.sendPacket(new EventTrigger(22100502, true));
				player.showQuestMovie(ExStartScenePlayer.SCENE_SSQ2_HOLY_BURIAL_GROUND_CLOSING);
			}
			return null;
		}
		else if(event.equalsIgnoreCase("to32833"))
		{
			st.playSound(SOUND_MIDDLE);
			st.playSound(SOUND_MIDDLE);
			player.sendPacket(new ExChangeNpcState(npc.getObjectId(), 1));
			st.set("book_" + 32833, 1);
			htmltext = "32785-05.htm";
			if(isAllBooksFinded(st))
			{
				player.sendPacket(new EventTrigger(22100500, false));
				player.sendPacket(new EventTrigger(22100502, true));
				player.showQuestMovie(ExStartScenePlayer.SCENE_SSQ2_HOLY_BURIAL_GROUND_CLOSING);
			}
			return null;
		}
		else if(event.equalsIgnoreCase("32804-04.htm"))
		{
			if(st.getInt("book_" + WestReadingDesk1) > 0)
				htmltext = "32804-05.htm";
		}
		else if(event.equalsIgnoreCase("32805-04.htm"))
		{
			if(st.getInt("book_" + NorthReadingDesk1) > 0)
				htmltext = "32805-05.htm";
		}
		else if(event.equalsIgnoreCase("32806-04.htm"))
		{
			if(st.getInt("book_" + EastReadingDesk1) > 0)
				htmltext = "32806-05.htm";
		}
		else if(event.equalsIgnoreCase("32807-04.htm"))
		{
			if(st.getInt("book_" + SouthReadingDesk1) > 0)
				htmltext = "32807-05.htm";
		}
		else if(event.equalsIgnoreCase("32792-08.htm"))
		{
			if(player.getLevel() < 81)
				htmltext = "<html><body>Only characters who are <font color=\"LEVEL\">level 81</font> or higher may complete this quest.</body></html>";
			else
			{
				st.addExpAndSp(25000000, 2500000);
				player.broadcastPacket(new SocialAction(player.getObjectId(), SocialAction.VICTORY));
				st.exitQuest(false);
				st.playSound(SOUND_FINISH);
				returnToTown(player);
			}
		}
		else if(event.equalsIgnoreCase("NotReady"))
			return null;
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getCond();
		L2Player player = st.getPlayer();
		String htmltext = "noquest";
		if(npcId == AbyssalSaintessElcadia)
		{
			QuestState qs = player.getQuestState(_10293_SevenSignsForbiddenBook.class);
			if(cond == 0)
			{
				if(player.getLevel() >= 81 && qs != null && qs.isCompleted())
					htmltext = "31621-01.htm";
				else
				{
					htmltext = "31621-00.htm";
					st.exitQuest(true);
				}
			}
			else if(cond == 1)
				htmltext = "31621-04.htm";
		}
		else if(npcId == AbyssalSaintessElcadia2)
		{
			if(cond == 1)
				htmltext = "32785-01.htm";
			else if(cond == 2)
				htmltext = "32785-02.htm";
			else if(cond == 3)
				htmltext = "32785-03.htm";
		}
		else if(npcId == ErissEvilThoughts)
		{
			if(cond == 1)
				htmltext = "32792-01.htm";
			else if(cond == 2)
				htmltext = "32792-06.htm";
			else if(cond == 3)
				htmltext = "32792-07.htm";
		}
		else if(npcId == GruffLookingMan)
		{
			htmltext = "32862-01.htm";
		}
		else if(npcId == Globus)
		{
			if(cond == 1)
				htmltext = "32815-01.htm";
		}
		else if(npcId == RelicGuardian)
		{
			if(cond == 2)
			{
				if(isAllBooksFinded(st))
				{
					htmltext = "32803-04.htm";
					st.setCond(3);
					st.playSound(SOUND_MIDDLE);
				}
				else
					htmltext = "32803-01.htm";
			}
			else if(cond == 3)
				htmltext = "32803-05.htm";
		}
		else if(npcId == WestRelicWatcher)
			htmltext = "32804-01.htm";
		else if(npcId == NorthRelicWatcher)
			htmltext = "32805-01.htm";
		else if(npcId == EastRelicWatcher)
			htmltext = "32806-01.htm";
		else if(npcId == SouthRelicWatcher)
			htmltext = "32807-01.htm";
		else
			for(int[] d : desks)
				if(Util.ArrayContains(d, npcId))
				{
					if(npcId == d[0])
						htmltext = npcId + "-01.htm";
					else
						htmltext = "empty_desk.htm";
					break;
				}
		return htmltext;
	}

	@Override
	public String onFirstTalk(L2NpcInstance npc, L2Player player)
	{
		int npcId = npc.getNpcId();
		if(npcId == WestTeleportControlDevice)
			return "32816-01.htm";
		else if(npcId == NorthTeleportControlDevice)
			return "32817-01.htm";
		else if(npcId == EastTeleportControlDevice)
			return "32818-01.htm";
		else if(npcId == SouthTeleportControlDevice)
			return "32819-01.htm";

		for(int[] d : desks)
			if(Util.ArrayContains(d, npcId))
			{
				if(npcId == d[0])
					return npcId + "-01.htm";
				else
					return "empty_desk.htm";
			}

		return null;
	}

	private boolean isAllBooksFinded(QuestState st)
	{
		return st.getInt("book_" + WestReadingDesk1) + st.getInt("book_" + NorthReadingDesk1) + st.getInt("book_" + EastReadingDesk1) + st.getInt("book_" + SouthReadingDesk1) >= 4;
	}

	private static class MovieStartTask implements Runnable
	{
		private L2Player _player;

		public MovieStartTask(L2Player player)
		{
			_player = player;
		}

		@Override
		public void run()
		{
			_player.sendPacket(new EventTrigger(22100500, true));
			_player.sendPacket(new EventTrigger(21100100, true));
			_player.sendPacket(new EventTrigger(21100202, true));
			_player.sendPacket(new EventTrigger(21100200, true));
			_player.sendPacket(new EventTrigger(21100204, true));
			_player.sendPacket(new EventTrigger(21100206, true));
			_player.showQuestMovie(ExStartScenePlayer.SCENE_SSQ2_HOLY_BURIAL_GROUND_OPENING);
		}
	}

	private void returnToTown(L2Player player)
	{
		Reflection r = player.getReflection();
		if(r.getReturnLoc() != null)
			player.teleToLocation(r.getReturnLoc(), 0);
		else
			player.setReflection(0);
		player.unsetVar("backCoords");
	}

	private void enterInstance(L2Player player, int instancedZoneId)
	{
		InstancedZoneManager ilm = InstancedZoneManager.getInstance();
		FastMap<Integer, InstancedZone> ils = ilm.getById(instancedZoneId);
		if(ils == null)
		{
			player.sendPacket(Msg.SYSTEM_ERROR);
			return;
		}

		InstancedZone il = ils.get(0);

		assert il != null;

		if(player.isInParty())
		{
			player.sendPacket(Msg.A_PARTY_CANNOT_BE_FORMED_IN_THIS_AREA);
			return;
		}

		if(player.isCursedWeaponEquipped())
		{
			player.sendPacket(new SystemMessage(SystemMessage.C1S_QUEST_REQUIREMENT_IS_NOT_SUFFICIENT_AND_CANNOT_BE_ENTERED).addName(player));
			return;
		}

		Reflection r = new Reflection(il.getName());
		r.setInstancedZoneId(instancedZoneId);
		for(InstancedZone i : ils.values())
		{
			if(r.getReturnLoc() == null)
				r.setReturnLoc(i.getReturnCoords());
			if(r.getTeleportLoc() == null)
				r.setTeleportLoc(i.getTeleportCoords());
			r.FillSpawns(i.getSpawnsInfo());
			r.FillDoors(i.getDoors());
		}

		int timelimit = il.getTimelimit();

		player.setReflection(r);
		player.teleToLocation(il.getTeleportCoords());
		player.setVar("backCoords", r.getReturnLoc().toXYZString());

		r.setNotCollapseWithoutPlayers(true);
		r.startCollapseTimer(timelimit * 60 * 1000L);

		_instances.put(player.getObjectId(), r.getId());
	}
}