package quests._10295_SevenSignsSolinasTomb;

import javolution.util.FastMap;
import l2ft.common.ThreadPoolManager;
import l2ft.extensions.scripts.Functions;
import l2ft.gameserver.cache.Msg;
import l2ft.gameserver.instancemanager.InstancedZoneManager;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.entity.InstancedZone;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;
import l2ft.gameserver.model.Reflection;
import l2ft.gameserver.serverpackets.EventTrigger;
import l2ft.gameserver.serverpackets.ExStartScenePlayer;
import l2ft.gameserver.serverpackets.SocialAction;
import l2ft.gameserver.serverpackets.SystemMessage;
import l2ft.gameserver.skills.AbnormalEffect;
import l2ft.util.Location;
import quests._10294_SevenSignsToTheMonastery._10294_SevenSignsToTheMonastery;

public class _10295_SevenSignsSolinasTomb extends Quest
{
	private static FastMap<Integer, Long> _instances = new FastMap<Integer, Long>();
	// NPCs
	private static final int ErissEvilThoughts = 32792;
	private static final int AbyssalSaintessElcadia = 32785; // TODO AI
	private static final int TeleportControlDevice1 = 32837;
	private static final int TeleportControlDevice2 = 32842;
	private static final int TombOfTheSaintess = 32843;
	private static final int SolinasEvilThoughts = 32793;
	private static final int Globus = 32815;

	private static final int AltarOfHallows_Staff = 32857;
	private static final int AltarOfHallows_Sword = 32858;
	private static final int AltarOfHallows_Scroll = 32859;
	private static final int AltarOfHallows_Shield = 32860;

	private static final int PowerfulDevice_Scroll = 32838;
	private static final int PowerfulDevice_Shield = 32839;
	private static final int PowerfulDevice_Sword = 32840;
	private static final int PowerfulDevice_Staff = 32841;

	// Mobs
	private static final int SolinasGuardian1 = 18952;
	private static final int SolinasGuardian2 = 18953;
	private static final int SolinasGuardian3 = 18954;
	private static final int SolinasGuardian4 = 18955;

	private static final int GuardianOfTheTomb1 = 18956;
	private static final int GuardianOfTheTomb2 = 18957;
	private static final int GuardianOfTheTomb3 = 18958;
	private static final int GuardianOfTheTomb4 = 18959;

	// Items
	private static final int ScrollOfAbstinence = 17228;
	private static final int ShieldOfSacrifice = 17229;
	private static final int SwordOfHolySpirit = 17230;
	private static final int StaffOfBlessing = 17231;

	// Events
	private static final int TeleportDeviceEvent = 21100100;
	private static final int ScrollDeviceEvent = 21100200;
	private static final int ShieldDeviceEvent = 21100202;
	private static final int SwordDeviceEvent = 21100204;
	private static final int StaffDeviceEvent = 21100206;
	private static final int SolinaEvent1 = 21100102;
	private static final int SolinaEvent2 = 22100500;

	private static final int Door1 = 21100101;
	private static final int Door2 = 21100102;
	private static final int Door3 = 21100103;
	private static final int Door4 = 21100104;
	private static final int Door5 = 21100018;

	public _10295_SevenSignsSolinasTomb()
	{
		super(false);
		addStartNpc(ErissEvilThoughts, Globus);
		addTalkId(AbyssalSaintessElcadia, TeleportControlDevice1, TeleportControlDevice2, TombOfTheSaintess, SolinasEvilThoughts);
		addTalkId(AltarOfHallows_Staff, AltarOfHallows_Sword, AltarOfHallows_Scroll, AltarOfHallows_Shield);
		addTalkId(PowerfulDevice_Scroll, PowerfulDevice_Shield, PowerfulDevice_Sword, PowerfulDevice_Staff);
		addKillId(SolinasGuardian1, SolinasGuardian2, SolinasGuardian3, SolinasGuardian4);
		addKillId(GuardianOfTheTomb1, GuardianOfTheTomb2, GuardianOfTheTomb3, GuardianOfTheTomb4);
		addQuestItem(ScrollOfAbstinence, ShieldOfSacrifice, SwordOfHolySpirit, StaffOfBlessing);
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		L2Player player = st.getPlayer();
		String htmltext = event;
		if(event.equalsIgnoreCase("32792-05.htm"))
		{
			st.setCond(1);
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equalsIgnoreCase("TeleInst"))
		{
			enterInstance(player, 603);
			return null;
		}
		else if(event.equalsIgnoreCase("Enter1"))
		{
			player.teleToLocation(new Location(45545, -249423, -6760));
			ThreadPoolManager.getInstance().scheduleAi(new MovieStartTask(player), 5000, true);
			ThreadPoolManager.getInstance().scheduleAi(new SetEventsTask(player), 31000, true);
			return null;
		}
		else if(event.equalsIgnoreCase("ReturnToEris"))
		{
			player.teleToLocation(new Location(120717, -86879, -3392));
			return null;
		}
		else if(event.equalsIgnoreCase("MoveToSaintess"))
		{
			player.teleToLocation(new Location(56033, -252944, -6760));
			ThreadPoolManager.getInstance().scheduleAi(new SetEventsTask2(player), 3000, true);
			return null;
		}
		else if(event.equalsIgnoreCase("MoveToSaintess2"))
		{
			player.teleToLocation(new Location(55955, -250394, -6760));
			return null;
		}
		else if(event.equalsIgnoreCase("32857-02.htm"))
		{
			if(st.checkQuestItemsCount(StaffOfBlessing))
				htmltext = "32857-03.htm";
			else
				st.giveItems(StaffOfBlessing, 1);
		}
		else if(event.equalsIgnoreCase("32858-02.htm"))
		{
			if(st.checkQuestItemsCount(SwordOfHolySpirit))
				htmltext = "32858-03.htm";
			else
				st.giveItems(SwordOfHolySpirit, 1);
		}
		else if(event.equalsIgnoreCase("32859-02.htm"))
		{
			if(st.checkQuestItemsCount(ScrollOfAbstinence))
				htmltext = "32859-03.htm";
			else
				st.giveItems(ScrollOfAbstinence, 1);
		}
		else if(event.equalsIgnoreCase("32860-02.htm"))
		{
			if(st.checkQuestItemsCount(ShieldOfSacrifice))
				htmltext = "32860-03.htm";
			else
				st.giveItems(ShieldOfSacrifice, 1);
		}
		else if(event.equalsIgnoreCase("deactivate-17228-21100200-18952"))
		{
			if(st.checkQuestItemsCount(ScrollOfAbstinence))
			{
				st.takeAllItems(ScrollOfAbstinence);
				player.sendPacket(new EventTrigger(ScrollDeviceEvent, false));
				setInvul(player, SolinasGuardian1, false);
				return null;
			}
			htmltext = "32838-03.htm";
		}
		else if(event.equalsIgnoreCase("deactivate-17229-21100202-18953"))
		{
			if(st.checkQuestItemsCount(ShieldOfSacrifice))
			{
				st.takeAllItems(ShieldOfSacrifice);
				player.sendPacket(new EventTrigger(ShieldDeviceEvent, false));
				setInvul(player, SolinasGuardian2, false);
				return null;
			}
			htmltext = "32839-03.htm";
		}
		else if(event.equalsIgnoreCase("deactivate-17230-21100204-18954"))
		{
			if(st.checkQuestItemsCount(SwordOfHolySpirit))
			{
				st.takeAllItems(SwordOfHolySpirit);
				player.sendPacket(new EventTrigger(SwordDeviceEvent, false));
				setInvul(player, SolinasGuardian3, false);
				return null;
			}
			htmltext = "32840-03.htm";
		}
		else if(event.equalsIgnoreCase("deactivate-17231-21100206-18955"))
		{
			if(st.checkQuestItemsCount(StaffOfBlessing))
			{
				st.takeAllItems(StaffOfBlessing);
				player.sendPacket(new EventTrigger(StaffDeviceEvent, false));
				setInvul(player, SolinasGuardian4, false);
				return null;
			}
			htmltext = "32841-03.htm";
		}
		else if(event.equalsIgnoreCase("32843-02.htm"))
		{
			st.set("tomb_opened", 1);
			player.getReflection().openDoor(Door1);
			player.getReflection().openDoor(Door2);
			player.getReflection().openDoor(Door3);
			player.getReflection().openDoor(Door4);
			long refId = player.getReflection().getId();
			addSpawnToInstance(27403, new Location(55669, -252227, -6760), 0, refId);
			addSpawnToInstance(27403, new Location(55824, -252112, -6760), 0, refId);
			addSpawnToInstance(27403, new Location(55810, -252262, -6760), 0, refId);
			addSpawnToInstance(27403, new Location(55672, -252099, -6760), 0, refId);
			addSpawnToInstance(27403, new Location(55824, -252679, -6760), 0, refId);
			addSpawnToInstance(27403, new Location(55687, -252718, -6760), 0, refId);
			addSpawnToInstance(27403, new Location(55825, -252792, -6760), 0, refId);
			addSpawnToInstance(27403, new Location(55680, -252832, -6760), 0, refId);
			addSpawnToInstance(27403, new Location(55825, -252792, -6760), 0, refId);
			addSpawnToInstance(27403, new Location(55824, -252112, -6760), 0, refId);
			addSpawnToInstance(27403, new Location(55824, -252679, -6760), 0, refId);
			addSpawnToInstance(27403, new Location(55680, -252832, -6760), 0, refId);
			addSpawnToInstance(27403, new Location(55810, -252262, -6760), 0, refId);
			addSpawnToInstance(27403, new Location(55669, -252227, -6760), 0, refId);
			addSpawnToInstance(27404, new Location(56481, -252725, -6760), 0, refId);
			addSpawnToInstance(27404, new Location(56336, -252168, -6760), 0, refId);
			addSpawnToInstance(27404, new Location(56463, -252225, -6760), 0, refId);
			addSpawnToInstance(27404, new Location(56336, -252288, -6760), 0, refId);
			addSpawnToInstance(27404, new Location(56368, -252787, -6760), 0, refId);
			addSpawnToInstance(27404, new Location(56368, -252669, -6760), 0, refId);
			addSpawnToInstance(27404, new Location(56480, -252833, -6760), 0, refId);
			addSpawnToInstance(27404, new Location(56469, -252108, -6760), 0, refId);
			addSpawnToInstance(27404, new Location(56368, -252787, -6760), 0, refId);
			addSpawnToInstance(27404, new Location(56368, -252669, -6760), 0, refId);
			addSpawnToInstance(27404, new Location(56336, -252168, -6760), 0, refId);
			addSpawnToInstance(27404, new Location(56480, -252833, -6760), 0, refId);
			addSpawnToInstance(27404, new Location(56481, -252725, -6760), 0, refId);
		}
		else if(event.equalsIgnoreCase("32793-04.htm"))
		{
			st.setCond(2);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("32793-07.htm"))
		{
			st.setCond(3);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("NotReady"))
			return null;
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getCond();
		L2Player player = st.getPlayer();
		String htmltext = "noquest";
		if(npcId == ErissEvilThoughts)
		{
			QuestState qs = player.getQuestState(_10294_SevenSignsToTheMonastery.class);
			if(cond == 0)
			{
				if(player.getLevel() >= 81 && qs != null && qs.isCompleted())
					htmltext = "32792-01.htm";
				else
				{
					htmltext = "32792-00.htm";
					st.exitQuest(true);
				}
			}
			else if(cond == 1 || cond == 2)
				htmltext = "32792-06.htm";
			else if(cond == 3)
			{
				st.addExpAndSp(125000000, 12500000);
				player.broadcastPacket(new SocialAction(player.getObjectId(), SocialAction.VICTORY));
				st.exitQuest(false);
				st.playSound(SOUND_FINISH);
				htmltext = "32792-07.htm";
				returnToTown(player);
			}
		}
		else if(npcId == Globus)
		{
			htmltext = "32815-01.htm";
		}
		else if(npcId == AbyssalSaintessElcadia)
		{
			if(cond == 1)
			{
				if(st.getInt("seal_removed") == 1)
					htmltext = "32785-02.htm";
				else
					htmltext = "32785-01.htm";
			}
			else if(cond == 2)
				htmltext = "32785-03.htm";
		}
		else if(npcId == TeleportControlDevice1)
		{
			if(st.getInt("seal_removed") == 1)
				htmltext = "32837-02.htm";
			else
				htmltext = "32837-01.htm";
		}
		else if(npcId == TeleportControlDevice2)
		{
			if(st.getInt("tomb_opened") == 1)
				htmltext = "32842-01.htm";
		}
		else if(npcId == TombOfTheSaintess)
		{
			if(st.getInt("tomb_opened") != 1)
				htmltext = "32843-01.htm";
		}
		else if(npcId == SolinasEvilThoughts)
		{
			if(cond == 1)
				htmltext = "32793-01.htm";
			else if(cond == 2)
				htmltext = "32793-04.htm";
			else if(cond == 3)
				htmltext = "32793-07.htm";
		}
		if(cond == 1 && st.getInt("seal_removed") != 1)
		{
			if(npcId == AltarOfHallows_Staff)
				htmltext = "32857-01.htm";
			else if(npcId == AltarOfHallows_Sword)
				htmltext = "32858-01.htm";
			else if(npcId == AltarOfHallows_Scroll)
				htmltext = "32859-01.htm";
			else if(npcId == AltarOfHallows_Shield)
				htmltext = "32860-01.htm";
			else if(npcId == PowerfulDevice_Scroll)
				htmltext = "32838-01.htm";
			else if(npcId == PowerfulDevice_Shield)
				htmltext = "32839-01.htm";
			else if(npcId == PowerfulDevice_Sword)
				htmltext = "32840-01.htm";
			else if(npcId == PowerfulDevice_Staff)
				htmltext = "32841-01.htm";
		}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int cond = st.getCond();
		int npcId = npc.getNpcId();
		L2Player player = st.getPlayer();
		if(player == null || cond != 1)
			return null;
		switch(npcId)
		{
			case SolinasGuardian1:
			case SolinasGuardian2:
			case SolinasGuardian3:
			case SolinasGuardian4:
				if(isAllDead(player, SolinasGuardian1, SolinasGuardian2, SolinasGuardian3, SolinasGuardian4))
				{
					st.set("seal_removed", 1);
					st.playSound(SOUND_MIDDLE);
					player.sendPacket(new EventTrigger(TeleportDeviceEvent, false));
					player.showQuestMovie(ExStartScenePlayer.SCENE_SSQ2_SOLINA_TOMB_CLOSING);
				}
				break;
			case GuardianOfTheTomb1:
			case GuardianOfTheTomb2:
			case GuardianOfTheTomb3:
			case GuardianOfTheTomb4:
				if(isAllDead(player, GuardianOfTheTomb1, GuardianOfTheTomb2, GuardianOfTheTomb3, GuardianOfTheTomb4))
				{
					player.getReflection().openDoor(Door5);
					st.playSound(SOUND_MIDDLE);
				}
				break;
		}
		return null;
	}

	private boolean isAllDead(L2Player player, int... ids)
	{
		L2NpcInstance npc;
		for(int id : ids)
		{
			npc = player.getReflection().findFirstNPC(id);
			if(npc != null && !npc.isDead())
				return false;
		}
		return true;
	}

	private static void setInvul(L2Player player, int npcId, boolean activate)
	{
		L2NpcInstance npc = player.getReflection().findFirstNPC(npcId);
		if(npc != null)
			if(activate)
			{
				npc.setIsInvul(24 * 60 * 60);
				npc.startAbnormalEffect(AbnormalEffect.S_INVULNERABLE);
			}
			else
			{
				npc.setIsInvul(0);
				npc.stopAbnormalEffect(AbnormalEffect.S_INVULNERABLE);
			}
	}

	private static class MovieStartTask implements Runnable
	{
		private L2Player _player;

		public MovieStartTask(L2Player player)
		{
			_player = player;
		}

		@Override
		public void run()
		{
			_player.showQuestMovie(ExStartScenePlayer.SCENE_SSQ2_SOLINA_TOMB_OPENING);
		}
	}

	private static class SetEventsTask implements Runnable
	{
		private L2Player _player;

		public SetEventsTask(L2Player player)
		{
			_player = player;
		}

		@Override
		public void run()
		{
			_player.sendPacket(new EventTrigger(TeleportDeviceEvent, true));
			_player.sendPacket(new EventTrigger(ScrollDeviceEvent, true));
			_player.sendPacket(new EventTrigger(ShieldDeviceEvent, true));
			_player.sendPacket(new EventTrigger(SwordDeviceEvent, true));
			_player.sendPacket(new EventTrigger(StaffDeviceEvent, true));

			setInvul(_player, SolinasGuardian1, true);
			setInvul(_player, SolinasGuardian2, true);
			setInvul(_player, SolinasGuardian3, true);
			setInvul(_player, SolinasGuardian4, true);
		}
	}

	private static class SetEventsTask2 implements Runnable
	{
		private L2Player _player;

		public SetEventsTask2(L2Player player)
		{
			_player = player;
		}

		@Override
		public void run()
		{
			_player.sendPacket(new EventTrigger(SolinaEvent1, true));
			_player.sendPacket(new EventTrigger(SolinaEvent2, true));
		}
	}

	private void returnToTown(L2Player player)
	{
		Reflection r = player.getReflection();
		if(r.getReturnLoc() != null)
			player.teleToLocation(r.getReturnLoc(), 0);
		else
			player.setReflection(0);
		player.unsetVar("backCoords");
	}

	private void enterInstance(L2Player player, int instancedZoneId)
	{
		InstancedZoneManager ilm = InstancedZoneManager.getInstance();
		FastMap<Integer, InstancedZone> ils = ilm.getById(instancedZoneId);
		if(ils == null)
		{
			player.sendPacket(Msg.SYSTEM_ERROR);
			return;
		}

		InstancedZone il = ils.get(0);

		assert il != null;

		if(player.isInParty())
		{
			player.sendPacket(Msg.A_PARTY_CANNOT_BE_FORMED_IN_THIS_AREA);
			return;
		}

		if(player.isCursedWeaponEquipped())
		{
			player.sendPacket(new SystemMessage(SystemMessage.C1S_QUEST_REQUIREMENT_IS_NOT_SUFFICIENT_AND_CANNOT_BE_ENTERED).addName(player));
			return;
		}

		Reflection r = new Reflection(il.getName());
		r.setInstancedZoneId(instancedZoneId);
		for(InstancedZone i : ils.values())
		{
			if(r.getReturnLoc() == null)
				r.setReturnLoc(i.getReturnCoords());
			if(r.getTeleportLoc() == null)
				r.setTeleportLoc(i.getTeleportCoords());
			r.FillSpawns(i.getSpawnsInfo());
			r.FillDoors(i.getDoors());
		}

		int timelimit = il.getTimelimit();

		player.setReflection(r);
		player.teleToLocation(il.getTeleportCoords());
		player.setVar("backCoords", r.getReturnLoc().toXYZString());

		r.setNotCollapseWithoutPlayers(true);
		r.startCollapseTimer(timelimit * 60 * 1000L);

		_instances.put(player.getObjectId(), r.getId());
	}
}