package quests._10296_SevenSignsOneWhoSeeksPower;

import javolution.util.FastMap;
import l2ft.common.ThreadPoolManager;
import l2ft.gameserver.cache.Msg;
import l2ft.gameserver.instancemanager.InstancedZoneManager;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.entity.InstancedZone;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;
import l2ft.gameserver.model.Reflection;
import l2ft.gameserver.serverpackets.ExStartScenePlayer;
import l2ft.gameserver.serverpackets.SocialAction;
import l2ft.gameserver.serverpackets.SystemMessage;
import l2ft.util.Location;
import quests._10295_SevenSignsSolinasTomb._10295_SevenSignsSolinasTomb;

public class _10296_SevenSignsOneWhoSeeksPower extends Quest
{
	private static FastMap<Integer, Long> _instances = new FastMap<Integer, Long>();
	// NPCs
	private static final int ErissEvilThoughts = 32792;
	private static final int AbyssalSaintessElcadia = 32785; // TODO AI
	private static final int AbyssalSaintessElcadia2 = 31621;
	private static final int GruffLookingMan = 32862;
	private static final int Hardin = 30832;
	private static final int Wood = 32593;
	private static final int Franz = 32597;
	private static final int Globus = 32815;
	private static final int Jaina = 32582;

	// Mobs
	private static final int EtisVanEtina = 18949;

	// Items
	private static final int CertificateOfDawn = 17265;
	
	public _10296_SevenSignsOneWhoSeeksPower()
	{
		super(false);
		addStartNpc(ErissEvilThoughts, Globus);
		addTalkId(AbyssalSaintessElcadia, AbyssalSaintessElcadia2, GruffLookingMan, Hardin, Wood, Franz);
		addKillId(EtisVanEtina);
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		L2Player player = st.getPlayer();
		String htmltext = event;
		if(event.equalsIgnoreCase("32792-03.htm"))
		{
			st.setCond(1);
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equalsIgnoreCase("TeleInst"))
		{
			enterInstance(player, 603);
			return null;
		}
		else if(event.equalsIgnoreCase("EnterElcadia"))
		{
			enterInstance(player , 22);
			return null;
		}
		else if(event.equalsIgnoreCase("Return1"))
		{
			returnToTown(player);
			return null;
		}
		else if(event.equalsIgnoreCase("31621-03.htm"))
		{
			st.setCond(4);
			st.playSound(SOUND_MIDDLE);
			returnToTown(player);
		}
		else if(event.equalsIgnoreCase("30832-03.htm"))
		{
			st.setCond(5);
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("32597-03.htm"))
		{
			st.addExpAndSp(125000000, 12500000);
			st.giveItems(CertificateOfDawn, 1);
			player.broadcastPacket(new SocialAction(player.getObjectId(), SocialAction.VICTORY));
			st.exitQuest(false);
			st.playSound(SOUND_FINISH);
			returnToTown(player);
		}
		else if(event.equalsIgnoreCase("32593-04.htm"))
		{
			enterInstance(player, 21);
		}
		else if(event.equalsIgnoreCase("SummonEtis"))
		{
			st.setCond(2);
			player.showQuestMovie(ExStartScenePlayer.SCENE_SSQ2_BOSS_OPENING);
			ThreadPoolManager.getInstance().scheduleAi(new TeleportTask(player, new Location(76707, -241022, -10832)), 60000, true);
			return null;
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getCond();
		L2Player player = st.getPlayer();
		String htmltext = "noquest";
		if(npcId == ErissEvilThoughts)
		{
			QuestState qs = player.getQuestState(_10295_SevenSignsSolinasTomb.class);
			if(cond == 0)
			{
				if(player.getLevel() >= 81 && qs != null && qs.isCompleted())
					htmltext = "32792-01.htm";
				else
				{
					htmltext = "32792-00.htm";
					st.exitQuest(true);
				}
			}
			else if(cond == 1)
				htmltext = "32792-04.htm";
		}
		else if(npcId == Jaina)
		{
			if(cond == 2)
				htmltext = "32582.htm";
		}
		else if(npcId == GruffLookingMan)
		{
			htmltext = "32862-01.htm";
		}
		else if(npcId == Globus)
		{
			htmltext = "32815-01.htm";
		}
		else if(npcId == AbyssalSaintessElcadia)
		{
			if(cond == 1)
				htmltext = "32785-02.htm";
			else if(cond == 3)
				htmltext = "32785-03.htm";
		}
		else if(npcId == AbyssalSaintessElcadia2)
		{
			if(cond == 3)
				htmltext = "31621-01.htm";
			else if(cond == 4)
				htmltext = "31621-04.htm";
		}
		else if(npcId == Hardin)
		{
			if(cond == 4)
				htmltext = "30832-01.htm";
			else if(cond == 5)
				htmltext = "30832-03.htm";
		}
		else if(npcId == Wood)
		{
			if(cond < 5)
				htmltext = "32593-01.htm";
			else
				htmltext = "32593-02.htm";
		}
		else if(npcId == Franz)
		{
			if(cond == 5)
				htmltext = "32597-01.htm";
		}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int cond = st.getCond();
		int npcId = npc.getNpcId();
		L2Player player = st.getPlayer();
		if(player == null || cond != 2)
			return null;
		if(npcId == EtisVanEtina)
		{
			st.setCond(3);
			player.showQuestMovie(ExStartScenePlayer.SCENE_SSQ2_BOSS_CLOSING);
			L2NpcInstance Elcadia = player.getReflection().findFirstNPC(AbyssalSaintessElcadia);
			if(Elcadia != null)
			{
				Elcadia.decayMe();
				ThreadPoolManager.getInstance().scheduleAi(new EndMovieTask(Elcadia), 60000, true);
			}
		}
		return null;
	}

	private class TeleportTask implements Runnable
	{
		private L2Player _player;
		private Location _loc;

		public TeleportTask(L2Player player, Location loc)
		{
			_player = player;
			_loc = loc;
		}

		@Override
		public void run()
		{
			_player.teleToLocation(_loc);
		}
	}

	private class EndMovieTask implements Runnable
	{
		private L2NpcInstance _npc;

		public EndMovieTask(L2NpcInstance npc)
		{
			_npc = npc;
		}

		@Override
		public void run()
		{
			_npc.spawnMe();
		}
	}

	private void returnToTown(L2Player player)
	{
		Reflection r = player.getReflection();
		if(r.getReturnLoc() != null)
			player.teleToLocation(r.getReturnLoc(), 0);
		else
			player.setReflection(0);
		player.unsetVar("backCoords");
	}

	private void enterInstance(L2Player player, int instancedZoneId)
	{
		InstancedZoneManager ilm = InstancedZoneManager.getInstance();
		FastMap<Integer, InstancedZone> ils = ilm.getById(instancedZoneId);
		if(ils == null)
		{
			player.sendPacket(Msg.SYSTEM_ERROR);
			return;
		}

		InstancedZone il = ils.get(0);

		assert il != null;

		if(player.isInParty())
		{
			player.sendPacket(Msg.A_PARTY_CANNOT_BE_FORMED_IN_THIS_AREA);
			return;
		}

		if(player.isCursedWeaponEquipped())
		{
			player.sendPacket(new SystemMessage(SystemMessage.C1S_QUEST_REQUIREMENT_IS_NOT_SUFFICIENT_AND_CANNOT_BE_ENTERED).addName(player));
			return;
		}

		Reflection r = new Reflection(il.getName());
		r.setInstancedZoneId(instancedZoneId);
		for(InstancedZone i : ils.values())
		{
			if(r.getReturnLoc() == null)
				r.setReturnLoc(i.getReturnCoords());
			if(r.getTeleportLoc() == null)
				r.setTeleportLoc(i.getTeleportCoords());
			r.FillSpawns(i.getSpawnsInfo());
			r.FillDoors(i.getDoors());
		}

		int timelimit = il.getTimelimit();

		player.setReflection(r);
		player.teleToLocation(il.getTeleportCoords());
		player.setVar("backCoords", r.getReturnLoc().toXYZString());

		r.setNotCollapseWithoutPlayers(true);
		r.startCollapseTimer(timelimit * 60 * 1000L);

		_instances.put(player.getObjectId(), r.getId());
	}
}