package quests._10501_ZakenEmbroideredSoulCloak;

import l2ft.Config;
import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.L2Party;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;

public class _10501_ZakenEmbroideredSoulCloak extends Quest implements ScriptFile
{
	private static final int OLF_ADAMS = 32612;
	private static final int ZAKEN = 29181;
	private static final int ZAKEN_SOUL_FRAGMENT = 21722;
	private static final int CLOAK_OF_ZAKEN = 21719;

	public void onLoad()
	{}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _10501_ZakenEmbroideredSoulCloak()
	{
		super(false);
		
		addStartNpc(OLF_ADAMS);
		addTalkId(OLF_ADAMS);
		addKillId(ZAKEN);
		addQuestItem(ZAKEN_SOUL_FRAGMENT);
	}
	
	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("quest_accept"))
		{
			htmltext = "32612-1.htm";
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		if(event.equalsIgnoreCase("accept"))
		{
			htmltext = "32612w.htm";
			st.takeItems(ZAKEN_SOUL_FRAGMENT, -1);
			st.giveItems(CLOAK_OF_ZAKEN, 1);
			st.playSound(SOUND_FINISH);
			st.setState(COMPLETED);
			st.exitCurrentQuest(false);
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int id = st.getState();
		int cond = st.getCond();

		if(id == COMPLETED)
		{
			htmltext = "completed";
		}
		else if(id == CREATED)
		{
			if(st.getPlayer().getLevel() < 78)
				htmltext = "32612-00.htm";
			else
				htmltext = "32612.htm";

		}
		else if(id == STARTED)
		{
			if(cond == 1)
				htmltext =  "32612-1.htm";
			if(cond == 2)
				htmltext =  "32612-2.htm";
		}
		return htmltext;
	}

	
	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		L2Player player = st.getPlayer();
		L2Party party = player.getParty();
		
		if(party != null)
		{
			for(L2Player player1 : party.getPartyMembers())
				if(player1.getDistance(player) <= Config.ALT_PARTY_DISTRIBUTION_RANGE)
				{
					QuestState st1 = player1.getQuestState(_10501_ZakenEmbroideredSoulCloak.class);
					if(st1 != null && st1.getCond() == 1)
					{	
						st.rollAndGive(ZAKEN_SOUL_FRAGMENT, 1, 3, 100);
						st1.rollAndGive(ZAKEN_SOUL_FRAGMENT, 1, 3, 100);
						if(st.getQuestItemsCount(ZAKEN_SOUL_FRAGMENT) <= 19)
						{
							st.playSound(SOUND_ITEMGET);
						}
						else if(st.getQuestItemsCount(ZAKEN_SOUL_FRAGMENT) >= 20)
						{
							st.set("cond", "2");
							st.playSound(SOUND_MIDDLE);
							st.setState(STARTED);
						}
					}	
				}
		}
		else
		{
			if(st != null && st.getCond() == 1)
			{	
				st.rollAndGive(ZAKEN_SOUL_FRAGMENT, 1, 3, 100);
				if(st.getQuestItemsCount(ZAKEN_SOUL_FRAGMENT) <= 19)
				{
					st.playSound(SOUND_ITEMGET);
				}
				else if(st.getQuestItemsCount(ZAKEN_SOUL_FRAGMENT) >= 20)
				{
					st.set("cond", "2");
					st.playSound(SOUND_MIDDLE);
					st.setState(STARTED);
				}
			}	
		}
		return null;
	}
}