package quests._10504_JewelOfAntharas;

import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;

public class _10504_JewelOfAntharas extends Quest implements ScriptFile
{
	// NPC
	private static final int Theodoric = 30755;
	private static final int Antharas = 29019;

	// Item
	private static final int PortalStone = 3865;
	private static final int FilledCrystalAntharas = 21907;
	private static final int JewelOfAntharas = 21898;

	@Override
	public void onLoad()
	{}

	@Override
	public void onReload()
	{}

	@Override
	public void onShutdown()
	{}

	public _10504_JewelOfAntharas()
	{
		super(false);
		addStartNpc(Theodoric);
		addTalkId(Theodoric);
		addKillId(Antharas);
		addQuestItem(FilledCrystalAntharas);
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		String htmltext = event;
		if(st == null)
			return htmltext;
		if(event.equalsIgnoreCase("quest_accept"))
		{
			htmltext = "30755-3.htm";
			st.setState(STARTED);
			st.set("cond", "1");
			st.playSound(SOUND_ACCEPT);
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		if(st == null)
			return htmltext;
		switch(st.getState())
		{
			case CREATED:
			{
				if(st.getPlayer().getLevel() >= 83 && st.getQuestItemsCount(PortalStone) >= 1)
					htmltext = "30755.htm";
				else if(st.getPlayer().getLevel() < 83)
					htmltext = "30755-0.htm";
				else
					htmltext = "30755-0a.htm";
				break;
			}
			case STARTED:
				if(st.getInt("cond") == 1)
					htmltext = "30755-4.htm";
				if(st.getInt("cond") == 2 && st.getQuestItemsCount(FilledCrystalAntharas) > 0)
				{
					htmltext = "30755-5.htm";
					st.giveItems(JewelOfAntharas, 1);
					st.unset("cond");
					st.exitCurrentQuest(false);
					st.playSound(SOUND_FINISH);
				}
				break;
		}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		if(st.getPlayer().getParty() != null)
			for(L2Player partyMember : st.getPlayer().getParty().getPartyMembers())
				rewardPlayer(partyMember);
		else
			rewardPlayer(st.getPlayer());
		return null;
	}

	private void rewardPlayer(L2Player player)
	{
		QuestState st = player.getQuestState(getClass());
		if(st != null && st.getInt("cond") == 1)
		{
			st.giveItems(FilledCrystalAntharas, 1);
			st.playSound(SOUND_MIDDLE);
			st.set("cond", "2");
		}
	}
}