package quests._10505_JewelOfValakas;

import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;
import l2ft.util.Rnd;

/**
 * Квест Сфера Дракона Огня
 * @author RuLeX
 */

public class _10505_JewelOfValakas extends Quest implements ScriptFile
{
	public void onLoad()
	{}

	public void onReload()
	{}

	public void onShutdown()
	{}
	

	// Quest Items
	private static final int FILLED_CRYSTAL = 21908;

	// NPC
	private static final int KLEIN = 31540;
	private static final int VALAKAS = 29028;
	
	//REWARDS
	
	private static final int JEWEL_OF_VALAKAS = 21896;
	private static final int CHANCE = 100;




	public _10505_JewelOfValakas()
	{
		super(true);
		addStartNpc(KLEIN);
				
		addKillId(VALAKAS);

		addQuestItem(FILLED_CRYSTAL);
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("quest_accept"))
		{
			htmltext = "klein_q10505_05.htm";
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equalsIgnoreCase("give_item"))
		{
			htmltext = "klein_q10505_06.htm";
			st.takeItems(FILLED_CRYSTAL, 1);
			st.giveItems(JEWEL_OF_VALAKAS, 1);
			st.playSound(SOUND_FINISH);
			st.exitCurrentQuest(true);
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int id = st.getState();
		if(id == CREATED)
			st.set("cond", "0");
		// На случай любых ошибок, если предметы есть - квест все равно пройдется.
		if(st.getQuestItemsCount(FILLED_CRYSTAL) >= 1)
			st.set("cond", "2");
		int cond = st.getInt("cond");
		if(npcId == KLEIN)
			if(st.getQuestItemsCount(7267) >= 1)
			{	
				if(cond == 0)
				{
					if(st.getPlayer().getLevel() >= 84)
						htmltext = "klein_q10505_01.htm";
					else
					{
						htmltext = "klein_q10505_02.htm";
						st.exitCurrentQuest(true);
					}
				}
				else if(cond == 1 && st.getQuestItemsCount(FILLED_CRYSTAL) < 1)
					htmltext = "klein_q10505_03.htm";
				else if(cond == 2 && st.getQuestItemsCount(FILLED_CRYSTAL) >= 1)
					htmltext = "klein_q10505_04.htm";
			}
			else htmltext = "klein_q10505_07.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		if(st.getInt("cond") == 1)
		{
			if(npcId == VALAKAS)
			{
				if(st.getQuestItemsCount(FILLED_CRYSTAL) < 1)
				{
					st.rollAndGive(FILLED_CRYSTAL, 1, CHANCE);
					if(st.getQuestItemsCount(FILLED_CRYSTAL) == 1)
					{
						st.set("cond", "2");
						st.playSound(SOUND_MIDDLE);
					}
				}
			}
		}
		return null;
	}

}