package quests._111_ElrokianHuntersProof;

import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.L2Party;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;
import l2ft.util.Rnd;

/**
 * @author TheOne, Ortiva, edited by Byldas
 */
public class _111_ElrokianHuntersProof extends Quest implements ScriptFile
{
	public void onLoad()
	{}

	public void onReload()
	{}

	public void onShutdown()
	{}
	
	private static final int Marquez = 32113;
	private static final int Mushika  = 32114;
	private static final int Asamah = 32115;
	private static final int Kirikachin = 32116;
	private static final int Karakawei  = 32117;
	
	// Fragment
	private final static int DiaryFragment =  8768 ;
		
	private final static int QUEST_MONSTERS1[] = { 22196, 22197, 22198 , 22218};
	private final static int QUEST_MONSTERS2[] = {22200, 22201, 22202, 22219};
	private final static int QUEST_MONSTERS3[] = {22208, 22209, 22210, 22221};
	private final static int QUEST_MONSTERS4[] = {22203, 22204, 22205, 22220};

	public _111_ElrokianHuntersProof()
	{
		super(true);
		addStartNpc(Marquez);
		addTalkId(Mushika);
		addTalkId(Asamah);
		addTalkId(Kirikachin);

		
		for (final int i : QUEST_MONSTERS1)
			addKillId(i);
		for (final int i : QUEST_MONSTERS2)
			addKillId(i);
		for (final int i : QUEST_MONSTERS3)
			addKillId(i);
		for (final int i : QUEST_MONSTERS4)
			addKillId(i);

		addQuestItem(DiaryFragment);
	}	
	
	private boolean checkPartyCondition(QuestState st, L2Player leader)
	{		
		if (leader == null)
			return false;
		
		final L2Party party = leader.getParty();
		if (party == null)
			return false;
		
		if (party.getPartyLeader() != leader)
			return false;
		
		for (L2Player player: party.getPartyMembers())
		{
			if (player.getLevel() < 75)
				return false;
		}
		
		return true;
	}
	
	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int id = st.getState();
		final int cond = st.getInt("cond");
		String htmltext = "noquest";
		final int npcId = npc.getNpcId();
		
		switch (id)
		{
			case COMPLETED:
				return "completed";
			case CREATED:
				if (npcId == Marquez)
				{
					if  (st.getPlayer().getLevel() >= 75 || checkPartyCondition(st, st.getPlayer()))
					{
						st.set("cond","1");
						st.playSound("ItemSound.quest_accept");
						st.setState(STARTED);
						htmltext = "32113-1.htm";
					}
					else
					{
				        st.exitCurrentQuest(true);
				        htmltext = "<html><body>This quest can only be undertaken by a party of level 75 or higher. Only the party leader may talk to the quest NPCs.</body></html>";
					}
				}
				break;
			case STARTED:
				if (npcId == Marquez)
				{
					switch (cond)
					{
						case 3:
							st.set("cond","4");
							st.playSound("ItemSound.quest_middle");
							htmltext = "32113-2.htm";
							break;
						case 5:
							if(st.getQuestItemsCount(DiaryFragment) >= 50)
							{
								st.takeItems(DiaryFragment, -1);
								st.set("cond", "6");
								st.playSound("ItemSound.quest_middle");
								htmltext = "32113-3.htm";
							}
							break;
					}
				}
				else if (npcId == Mushika)
				{
					if (cond == 1)
					{
						st.set("cond","2");
						st.playSound("ItemSound.quest_middle");
						htmltext = "32114-1.htm";
					}
				}
				else if (npcId == Asamah)
				{
					switch (cond)
					{
						case 2:
							st.set("cond","3");
							st.playSound("ItemSound.quest_middle");
							htmltext = "32115-1.htm";
							break;
						case 8:
							st.set("cond","9");
							st.playSound("ItemSound.quest_middle");
							htmltext = "32115-2.htm";
							break;
						case 9:
							st.set("cond","10");
							st.playSound("ItemSound.quest_middle");
							htmltext = "32115-3.htm";
							break;
						case 11:
							st.set("cond","12");
							st.playSound("ItemSound.quest_middle");
							st.giveItems(8773,1);
							htmltext = "32115-5.htm";
							break;
					}
				}
				else if (npcId == Kirikachin)
				{
					switch (cond)
					{
						case 6:
							st.set("cond","8");
							st.playSound("EtcSound.elcroki_song_full");
							htmltext = "32116-1.htm";
							break;
						case 12:
							if (st.getQuestItemsCount(8773) >= 1)
							{
								st.takeItems(8773,1);
								st.giveItems(8763,1);
								st.giveItems(8764,100);
								st.giveItems(57,1022636);
								st.playSound("ItemSound.quest_finish");
								st.exitCurrentQuest(false);
								htmltext = "32116-2.htm";	
							}
							break;
					}
				}
				break;
		}
		return htmltext;
	}
	
	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{	
		L2Player player = st.getPlayer();
		if (player == null || player.getParty() == null)
			return super.onKill(npc, st);
		
		if (st == null || st.getState() != STARTED)
			return super.onKill(npc, st);
		
		final int cond = st.getInt("cond");
		final int npcId = npc.getNpcId();
		
		switch (cond)
		{
			case 4:
				if (contains(QUEST_MONSTERS1, npcId))
				{
					if (Rnd.chance(25))
					{
						st.giveItems(DiaryFragment, 1);
						if (st.getQuestItemsCount(DiaryFragment) <= 49)
							st.playSound("ItemSound.quest_itemget");
						else
						{
							st.set("cond","5");
							st.playSound("ItemSound.quest_middle");
						}
					}
				}
				break;
			case 10:
				if (contains(QUEST_MONSTERS2, npcId))
				{
					if (Rnd.chance(75))
					{
						st.giveItems(8770,1);
						if (st.getQuestItemsCount(8770) <= 9)
							st.playSound("ItemSound.quest_itemget");
					}
				}
				else if (contains(QUEST_MONSTERS3, npcId))
				{
					if (Rnd.chance(75))
					{
						st.giveItems(8772,1);
						if (st.getQuestItemsCount(8771) <= 9)
							st.playSound("ItemSound.quest_itemget");
					}
				}
				else if (contains(QUEST_MONSTERS4, npcId))
				{
					if (Rnd.chance(75))
					{
						st.giveItems(8771,1);
						if (st.getQuestItemsCount(8772) <= 9)
							st.playSound("ItemSound.quest_itemget");
					}
				}

				if (st.getQuestItemsCount(8770) >= 10 && st.getQuestItemsCount(8771) >= 10 && st.getQuestItemsCount(8772) >= 10)
				{
					st.set("cond","11");
					st.playSound("ItemSound.quest_middle");
				}
				break;				
		}
		
		return super.onKill(npc, st);
	}
	
	
}
