package quests._254_LegendName;

import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;

/**
 * Квест Именем легенды
 * @author RuLeX
 */

public class _254_LegendName extends Quest implements ScriptFile
{
	public void onLoad()
	{}

	public void onReload()
	{}

	public void onShutdown()
	{}
	

	// Quest Items
	private static final int LARGE_DRAGON_SKULL  = 17249;

	// NPC
	private static final int GILMORE = 30754;
	private static final int DRAGON_VORTEX = 32871;
	
	//REWARDS
	private static final int CHANCE = 100;
	private static final int THROWER = 13467;
	private static final int STORMER = 13462;
	private static final int RETRIBUTER = 13464;
	private static final int FIGHTER = 13461;
	private static final int CASTER = 13465;
	private static final int AVENGER = 13463;
	private static final int SHAPER = 13460;
	private static final int SINGER = 13466;
	private static final int BUSTER = 13459;
	private static final int CUTTER = 13457;
	private static final int SLASHER = 13458;


	public _254_LegendName()
	{
		super(true);
		addStartNpc(GILMORE);
		
		addTalkId(DRAGON_VORTEX);

		for(int mob = 25718; mob < 25725; mob++)
			addKillId(mob);

		addQuestItem(LARGE_DRAGON_SKULL);
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		String htmltext = event;
		long count = st.getQuestItemsCount(LARGE_DRAGON_SKULL);
		if(event.equalsIgnoreCase("30754-04.htm"))
		{
			st.setState(STARTED);
			st.set("cond", "1");
			st.playSound(SOUND_ACCEPT);
				/*for (int Id=25718; Id<25725; Id++)
				{
					st.set("KB254_" + Id, 0);
				}*/
		}
		else if(event.equalsIgnoreCase("30754-08.htm"))
		{
			st.exitCurrentQuest(true);
			st.playSound(SOUND_FINISH);
		}
		else if(event.equalsIgnoreCase("30754-06"))
		{	
			if (count < 7)
			{
				htmltext = "30754-07.htm";
			}
			else if (count >= 7)
			{
				htmltext = "30754-06.htm";
			}	
		}		
		else if(event.equalsIgnoreCase("254_10"))
		{
			htmltext = "30754-11.htm";
			st.giveItems(THROWER, 1, false);
			st.takeItems(LARGE_DRAGON_SKULL, 7);
			st.setState(COMPLETED);
			st.exitCurrentQuest(false);
			st.playSound(SOUND_FINISH);
		}
		else if(event.equalsIgnoreCase("254_11"))
		{
			htmltext = "30754-11.htm";
			st.giveItems(STORMER, 1, false);
			st.takeItems(LARGE_DRAGON_SKULL, 7);
			st.setState(COMPLETED);
			st.exitCurrentQuest(false);
			st.playSound(SOUND_FINISH);
		}
		else if(event.equalsIgnoreCase("254_12"))
		{
			htmltext = "30754-11.htm";
			st.giveItems(RETRIBUTER, 1, false);
			st.takeItems(LARGE_DRAGON_SKULL, 7);
			st.setState(COMPLETED);
			st.exitCurrentQuest(false);
			st.playSound(SOUND_FINISH);
		}
		else if(event.equalsIgnoreCase("254_13"))
		{
			htmltext = "30754-11.htm";
			st.giveItems(FIGHTER, 1, false);
			st.takeItems(LARGE_DRAGON_SKULL, 7);
			st.setState(COMPLETED);
			st.exitCurrentQuest(false);
			st.playSound(SOUND_FINISH);
		}
		else if(event.equalsIgnoreCase("254_14"))
		{
			htmltext = "30754-11.htm";
			st.giveItems(CASTER, 1, false);
			st.takeItems(LARGE_DRAGON_SKULL, 7);
			st.setState(COMPLETED);
			st.exitCurrentQuest(false);
			st.playSound(SOUND_FINISH);
		}
		else if(event.equalsIgnoreCase("254_15"))
		{
			htmltext = "30754-11.htm";
			st.giveItems(AVENGER, 1, false);
			st.takeItems(LARGE_DRAGON_SKULL, 7);
			st.setState(COMPLETED);
			st.exitCurrentQuest(false);
			st.playSound(SOUND_FINISH);
		}
		else if(event.equalsIgnoreCase("254_16"))
		{
			htmltext = "30754-11.htm";
			st.giveItems(SHAPER, 1, false);
			st.takeItems(LARGE_DRAGON_SKULL, 7);
			st.setState(COMPLETED);
			st.exitCurrentQuest(false);
			st.playSound(SOUND_FINISH);
		}
		else if(event.equalsIgnoreCase("254_17"))
		{
			htmltext = "30754-11.htm";
			st.giveItems(SINGER, 1, false);
			st.takeItems(LARGE_DRAGON_SKULL, 7);
			st.setState(COMPLETED);
			st.exitCurrentQuest(false);
			st.playSound(SOUND_FINISH);
		}
		else if(event.equalsIgnoreCase("254_18"))
		{
			htmltext = "30754-11.htm";
			st.giveItems(BUSTER, 1, false);
			st.takeItems(LARGE_DRAGON_SKULL, 7);
			st.setState(COMPLETED);
			st.exitCurrentQuest(false);
			st.playSound(SOUND_FINISH);
		}
		else if(event.equalsIgnoreCase("254_19"))
		{
			htmltext = "30754-11.htm";
			st.giveItems(CUTTER, 1, false);
			st.takeItems(LARGE_DRAGON_SKULL, 7);
			st.setState(COMPLETED);
			st.exitCurrentQuest(false);
			st.playSound(SOUND_FINISH);
		}
		else if(event.equalsIgnoreCase("254_20"))
		{
			htmltext = "30754-11.htm";
			st.giveItems(SLASHER, 1, false);
			st.takeItems(LARGE_DRAGON_SKULL, 7);
			st.setState(COMPLETED);
			st.exitCurrentQuest(false);
			st.playSound(SOUND_FINISH);
		}

		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int id = st.getState();
		if (id == COMPLETED)
		{
			htmltext = "30754-10.htm";
		}
		else if(id == CREATED)
		{
			if(st.getPlayer().getLevel() >= 80)
			{
				htmltext = "30754-02.htm";
			}
			else
			{
				htmltext = "30754-01.htm";
				st.exitCurrentQuest(true);
			}
		}
		else if (st.getInt("cond") == 1)
		{
			htmltext = "30754-05.htm";
		}
		else if (st.getInt("cond") == 2)
		{
			htmltext = "30754-03.htm";
		}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		if(st.getInt("cond") == 1)
		{
			if ( npcId >= 25718 && npcId <= 25724)
				if (st.getInt("KB254_" + npcId) != 1)
				{	
					st.giveItems(LARGE_DRAGON_SKULL, 1, false);
					st.playSound(SOUND_ITEMGET);
					st.set("KB254_" + npcId, 1);
				}
			if (st.getQuestItemsCount(LARGE_DRAGON_SKULL) >= 7)
            {
                st.set("cond", "2");
                st.playSound(SOUND_MIDDLE);
            }
		}
		return null;
	}
}