package quests._270_TheOneWhoEndsSilence;

import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;
import l2ft.util.Rnd;
import quests._10288_SecretMission._10288_SecretMission;

public class _270_TheOneWhoEndsSilence extends Quest implements ScriptFile
{

	// NPC
	private static final int Greymore = 32757;
	//item
	private static final int Tattered = 15526;
	private static int[] Recept = { 10374, 10375, 10376, 10373, 10380, 10381, 10379, 10377, 10378 };
	private static int[] Piece = { 10398, 10399, 10397, 10400, 10405, 10404, 10402, 10401, 10403 };
	private static int[] Scroll = { 9898, 5595, 5594, 5593 };
	// MOB
	private static int[] Mobs = { 22790, 22791, 22793, 22794, 22795, 22796, 22797, 22798, 22799, 22800 };
	
	public void onLoad()
	{}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _270_TheOneWhoEndsSilence()
	{
		super(true);
		addStartNpc(Greymore);
		for (int mob : Mobs)
	    	addKillId(mob);
		for (int item1 : Recept)
	    	addQuestItem(item1);
		for (int item2 : Piece)
	    	addQuestItem(item2);
		for (int item3 : Scroll)
	    	addQuestItem(item3);
		addQuestItem(Tattered);
	}

	@Override
	public String onEvent(String event, final QuestState st, L2NpcInstance npc)
	{
		final L2Player player = st.getPlayer();
		String htmltext = event;
		if(event.equalsIgnoreCase("new_falsepriest_gremory_q0270_04.htm"))
		{
			st.setCond(1);
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		if(event.equalsIgnoreCase("killmob"))
		{
			if(st.getQuestItemsCount(Tattered) == 0)
				return "new_falsepriest_gremory_q0270_06.htm";
			if(st.getQuestItemsCount(Tattered) < 100)
				return "new_falsepriest_gremory_q0270_07.htm";
			if(st.getQuestItemsCount(Tattered) >= 100)
				return "new_falsepriest_gremory_q0270_08.htm";
		}
		if(event.equalsIgnoreCase("100item"))
		{
			if(st.getQuestItemsCount(Tattered) >= 100) {
				st.takeItems(Tattered, 100);
				if(Rnd.chance(50))
					st.giveItems(Recept[Rnd.get(9)], 1);
				else
					st.giveItems(Piece[Rnd.get(9)], 1);
				return "new_falsepriest_gremory_q0270_09.htm";
			} else
				return "new_falsepriest_gremory_q0270_10.htm";
		}
		if(event.equalsIgnoreCase("200item"))
		{
			if(st.getQuestItemsCount(Tattered) >= 200) {
				st.takeItems(Tattered, 200);
				st.giveItems(Recept[Rnd.get(9)], 1);
				st.giveItems(Piece[Rnd.get(9)], 1);
				return "new_falsepriest_gremory_q0270_09.htm";
			} else
				return "new_falsepriest_gremory_q0270_10.htm";
		}
		if(event.equalsIgnoreCase("300item"))
		{
			if(st.getQuestItemsCount(Tattered) >= 300) {
				st.takeItems(Tattered, 300);
				st.giveItems(Recept[Rnd.get(9)], 1);
				st.giveItems(Piece[Rnd.get(9)], 1);
				st.giveItems(Scroll[Rnd.get(4)], 1);
				return "new_falsepriest_gremory_q0270_09.htm";	
			} else
				return "new_falsepriest_gremory_q0270_10.htm";
			
		}
		if(event.equalsIgnoreCase("400item"))
		{
			if(st.getQuestItemsCount(Tattered) >= 400) {
				st.takeItems(Tattered, 400);
				if(Rnd.chance(50)) {
					st.giveItems(Recept[Rnd.get(9)], 1);
					st.giveItems(Recept[Rnd.get(9)], 1);
					st.giveItems(Scroll[Rnd.get(4)], 1);
				}	
				else {
					st.giveItems(Recept[Rnd.get(9)], 1);
					st.giveItems(Scroll[Rnd.get(4)], 1);
					st.giveItems(Scroll[Rnd.get(4)], 1);
					st.giveItems(Piece[Rnd.get(9)], 1);
				}	
				return "new_falsepriest_gremory_q0270_09.htm";
			} else
				return "new_falsepriest_gremory_q0270_10.htm";
		}
		if(event.equalsIgnoreCase("500item"))
		{
			if(st.getQuestItemsCount(Tattered) >= 500) {
				st.takeItems(Tattered, 500);
				st.giveItems(Recept[Rnd.get(9)], 1);
				st.giveItems(Recept[Rnd.get(9)], 1);
				st.giveItems(Scroll[Rnd.get(4)], 1);
				st.giveItems(Scroll[Rnd.get(4)], 1);
				st.giveItems(Piece[Rnd.get(9)], 1);
				return "new_falsepriest_gremory_q0270_09.htm";
			} else
				return "new_falsepriest_gremory_q0270_10.htm";
		}
		if(event.equalsIgnoreCase("exit"))
		{
			st.takeItems(Tattered, -1);
			st.setState(COMPLETED);
			st.playSound(SOUND_FINISH);
			st.unset("cond");
			st.exitCurrentQuest(true);
			return "new_falsepriest_gremory_q0270_13.htm";
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int id = st.getState();
		int cond = st.getCond();
		
		if(npcId == Greymore)
		{
			if(id == CREATED)
			{
				QuestState qs = st.getPlayer().getQuestState(_10288_SecretMission.class);
				if(qs != null && qs.isCompleted() && st.getPlayer().getLevel() >= 82)
					return "new_falsepriest_gremory_q0270_01.htm";
				else
					return "lvl.htm";			
			}
			if(id == STARTED)
			{
				if(cond == 1)
				return "new_falsepriest_gremory_q0270_05.htm";
			}
		}

		return "noquest";
	}
	
	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		if(st.getState() != STARTED)
			return null;
		int npcId = npc.getNpcId();

		if(contains(Mobs, npcId))
		{
			if(Rnd.chance(50)) {
				st.giveItems(Tattered, 1);
				st.playSound("ItemSound.quest_itemget");
			}
		}
		return null;
	}
	
}