package quests._279_TargetOfOpportunity;

import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;
import l2ft.util.Rnd;

public class _279_TargetOfOpportunity extends Quest implements ScriptFile
{
	//Npc
	private static final int JERIAN = 32302;
	//Mobs
	private static final int SCOUT = 22373;
	private static final int WATCHER = 22374;
	private static final int PRIEST = 22375;
	private static final int LORD = 22376;
	
	//Items
	private static final int PART1 = 15517;
	private static final int PART2 = 15518;
	private static final int PART3 = 15519;
	private static final int PART4 = 15520;
	//Reward
	private static final int BREAKER5 = 15515;
	private static final int BREAKER10 = 15516;

	public void onLoad()
	{}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _279_TargetOfOpportunity()
	{
		super(false);
		addStartNpc(JERIAN);
		addKillId(SCOUT);
		addKillId(WATCHER);
		addKillId(PRIEST);
		addKillId(LORD);
		addQuestItem(PART1);
		addQuestItem(PART2);
		addQuestItem(PART3);
		addQuestItem(PART4);
		}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		String htmltext = event;
		int npcId = npc.getNpcId();

		if(npcId != JERIAN)
			return htmltext;

		if(event.equalsIgnoreCase("32302-04.htm"))
		{
			if (st.getPlayer().getLevel() >= 82)
			{
				st.setState(STARTED);
				st.set("cond","1");
				st.playSound("SOUND_ACCEPT");
			}
		}
		if (event.equalsIgnoreCase("32302-07.htm"))
		{
			st.giveItems(BREAKER5,1);
			st.giveItems(BREAKER10,1);
			st.takeItems(PART1,-1);
			st.takeItems(PART2,-1);
			st.takeItems(PART3,-1);
			st.takeItems(PART4,-1);
			st.exitCurrentQuest(true);
			st.playSound("SOUND_FINISH");
		}
	
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		
		String htmltext = "<html><body>There is no mandate, or the conditions do not match.</body></html>";
		if (st == null)
		{
			return htmltext;
		}
		int npcId = npc.getNpcId();
		int id = st.getState();
		int cond = st.getInt("cond");

		if(npcId != JERIAN)
			return htmltext;

		if(id == CREATED)
		{
			if(st.getPlayer().getLevel() >= 82)
				htmltext = "32302-01.htm";
			else
			{
				htmltext = "32302-00.htm";
				st.exitCurrentQuest(true);
			}
		} else {
			if(cond == 1)
				htmltext = "32302-05.htm";
			else if (cond == 2)
				htmltext = "32302-06.htm";
		}
		
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int id = st.getState();
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(id == STARTED)
		{
			if(cond == 1)
				if(Rnd.chance(70))
				{
					if (npcId == SCOUT)
					{
						if (st.getQuestItemsCount(PART1) == 0)
						{
							st.giveItems(PART1,1);
							if (st.getQuestItemsCount(PART1) == 1 && st.getQuestItemsCount(PART2) == 1 && st.getQuestItemsCount(PART3) == 1 &&  st.getQuestItemsCount(PART4) == 1)
							{
								st.set("cond","2");
								st.playSound("SOUND_MIDDLE");
							}
						}
					}
					if (npcId == WATCHER)
					{
						if (st.getQuestItemsCount(PART2) == 0)
						{
							st.giveItems(PART2,1);
							if (st.getQuestItemsCount(PART1) == 1 && st.getQuestItemsCount(PART2) == 1 && st.getQuestItemsCount(PART3) == 1 &&  st.getQuestItemsCount(PART4) == 1)
							{
								st.set("cond","2");
								st.playSound("SOUND_MIDDLE");
							} else {
								st.playSound("ItemSound.quest_itemget");
							}
						}
					}
					if (npcId == PRIEST)	
					{
						if (st.getQuestItemsCount(PART3) == 0)
						{
							st.giveItems(PART3,1);
							if (st.getQuestItemsCount(PART1) == 1 && st.getQuestItemsCount(PART2) == 1 && st.getQuestItemsCount(PART3) == 1 &&  st.getQuestItemsCount(PART4) == 1)
							{
								st.set("cond","2");
								st.playSound("SOUND_MIDDLE");
							} else {
								st.playSound("ItemSound.quest_itemget");
							}
						}
					}
					if (npcId == LORD)
					{
						if (st.getQuestItemsCount(PART4) == 0)
						{
							st.giveItems(PART4,1);
							if (st.getQuestItemsCount(PART1) == 1 && st.getQuestItemsCount(PART2) == 1 && st.getQuestItemsCount(PART3) == 1 &&  st.getQuestItemsCount(PART4) == 1)
							{
								st.set("cond","2");
								st.playSound("SOUND_MIDDLE");
							} else {
								st.playSound("ItemSound.quest_itemget");
							}
						}
					}
				}
		}
		return null;
	}
}
