package quests._290_ThreatRemoval;

import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;
import l2ft.util.Rnd;
import quests._251_NoSecrets._251_NoSecrets;

public class _290_ThreatRemoval extends Quest
{
	private static final int SelMahumIDTag = 15714;

	private static final int Pinaps = 30201;

	private static final int ScrollEnchantWeaponSGrade = 959;
	private static final int ScrollEnchantArmorSGrade = 960;
	private static final int FireCrystal = 9552;

	private static final int SelMahumDrillSergeant1 = 22775;
	private static final int SelMahumTrainingOfficer = 22776;
	private static final int SelMahumDrillSergeant2 = 22777;
	private static final int SelMahumRecruit1 = 22780;
	private static final int SelMahumSoldier1 = 22781;
	private static final int SelMahumRecruit2 = 22782;
	private static final int SelMahumSoldier2 = 22783;
	private static final int SelMahumRecruit3 = 22784;

	public _290_ThreatRemoval()
	{
		super(PARTY_ONE);

		addStartNpc(Pinaps);
		addKillId(SelMahumDrillSergeant1, SelMahumTrainingOfficer, SelMahumDrillSergeant2, SelMahumRecruit1, SelMahumSoldier1, SelMahumRecruit2, SelMahumSoldier2, SelMahumRecruit3);
		addQuestItem(SelMahumIDTag);
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		String htmltext = event;
		if(event.equals("pinaps_q0290_03.htm"))
		{
			st.setCond(1);
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equals("pinaps_q0290_06.htm"))
		{
			st.takeItems(SelMahumIDTag, 400);
			int reward = Rnd.get(3);
			if(reward == 0)
				st.giveItems(ScrollEnchantWeaponSGrade, 1);
			else if(reward == 1)
				st.giveItems(ScrollEnchantArmorSGrade, Rnd.get(1, 3));
			else if(reward == 2)
				st.giveItems(FireCrystal, Rnd.get(1, 2));
		}
		else if(event.equals("pinaps_q0290_09.htm"))
		{
			if(Rnd.chance(50))
				htmltext = "pinaps_q0290_10.htm";
			st.exitCurrentQuest(true);
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int id = st.getState();
		if(npcId == Pinaps)
			if(id == CREATED)
			{
				htmltext = "pinaps_q0290_02.htm";
				QuestState qs = st.getPlayer().getQuestState(_251_NoSecrets.class);
				if(st.getPlayer().getLevel() < 82 || qs == null || !qs.isCompleted())
				{
					st.exitCurrentQuest(true);
					htmltext = "pinaps_q0290_01.htm";
				}
			}
			else if(id == STARTED)
			{
				long count = st.getQuestItemsCount(SelMahumIDTag);
				if(count < 400)
					htmltext = "pinaps_q0290_04.htm";
				else
					htmltext = "pinaps_q0290_05.htm";
			}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		if(st.getState() == STARTED && Rnd.chance(70))
		{
			st.giveItems(SelMahumIDTag, 1);
			st.playSound(SOUND_ITEMGET);
		}
		return null;
	}
}