package quests._309_ForAGoodCause;

import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;
import l2ft.gameserver.serverpackets.RadarControl;
import l2ft.util.Rnd;
import l2ft.util.Util;
import quests._239_WontYouJoinUs._239_WontYouJoinUs;
import quests._308_ReedFieldMaintenance._308_ReedFieldMaintenance;

public class _309_ForAGoodCause extends Quest implements ScriptFile
{
	// NPC's
	private static final int ATRA = 32647;

	// Mobs
	private static final int CONTAMINATED_MUCROKIAN = 22654;
	private static final int CHANGED_MUCROKIAN = 22655;
	private static final int[] MUCROKIANS = { 22650, 22651, 22652, 22653 };

	// Quest Items
	private static final int MUCROKIAN_HIDE = 14873;
	private static final int FALLEN_MUCROKIAN_HIDE = 14874;

	private static final int MUCROKIAN_HIDE_CHANCE = 50;
	private static final int FALLEN_HIDE_CHANCE = 35;

	// Rewards	
	private static final int REC_DYNASTY_EARRINGS_70 = 9985;
	private static final int REC_DYNASTY_NECKLACE_70 = 9986;
	private static final int REC_DYNASTY_RING_70 = 9987;
	private static final int REC_DYNASTY_SIGIL_60 = 10115;

	private static final int REC_MOIRAI_CIRCLET_60 = 15777;
	private static final int REC_MOIRAI_TUNIC_60 = 15780;
	private static final int REC_MOIRAI_STOCKINGS_60 = 15783;
	private static final int REC_MOIRAI_GLOVES_60 = 15786;
	private static final int REC_MOIRAI_SHOES_60 = 15789;
	private static final int REC_MOIRAI_SIGIL_60 = 15790;
	private static final int REC_MOIRAI_EARRING_70 = 15814;
	private static final int REC_MOIRAI_NECKLACE_70 = 15813;
	private static final int REC_MOIRAI_RING_70 = 15812;

	private static final int[] MOIRAI_PIECES = { 15647, 15650, 15653, 15656, 15659, 15692, 15772, 15773, 15774 };

	@Override
	public void onLoad()
	{}

	@Override
	public void onReload()
	{}

	@Override
	public void onShutdown()
	{}

	public _309_ForAGoodCause()
	{
		super(false);
		addStartNpc(ATRA);
		addQuestItem(MUCROKIAN_HIDE, FALLEN_MUCROKIAN_HIDE);
		for(int _mob : MUCROKIANS)
			addKillId(_mob, CONTAMINATED_MUCROKIAN, CHANGED_MUCROKIAN);
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		final L2Player player = st.getPlayer();
		QuestState qs = st.getPlayer().getQuestState(_239_WontYouJoinUs.class);
		String htmltext = event;

		if(event.equalsIgnoreCase("pro_agitator_q0309_08.htm"))
		{
			st.setState(STARTED);
			st.setCond(1);
			st.playSound(SOUND_ACCEPT);
			player.sendPacket(new RadarControl(0, 2, 77325, 205773, -3432));
		}
		else if(event.equalsIgnoreCase("claimreward"))
		{
			if(qs != null)
				if(qs.isCompleted())
					htmltext = "pro_agitator_q0309_18.htm";
				else
					htmltext = "pro_agitator_q0309_17.htm";
			htmltext = "pro_agitator_q0309_12.htm";
		}
		else if(event.equalsIgnoreCase("receivepieces"))
			htmltext = onPiecesExchangeRequest(st, MOIRAI_PIECES[Rnd.get(MOIRAI_PIECES.length - 1)], 100);
		else if(Util.isDigit(event))
		{
			int val = Integer.parseInt(event);
			switch(val)
			{
				case 96:
					htmltext = onRecipeExchangeRequest(st, REC_DYNASTY_EARRINGS_70, FALLEN_MUCROKIAN_HIDE, Integer.parseInt(event));
					break;
				case 192:
					htmltext = onRecipeExchangeRequest(st, REC_DYNASTY_EARRINGS_70, MUCROKIAN_HIDE, Integer.parseInt(event));
					break;
				case 256:
					htmltext = onRecipeExchangeRequest(st, REC_DYNASTY_NECKLACE_70, MUCROKIAN_HIDE, Integer.parseInt(event));
					break;
				case 64:
					htmltext = onRecipeExchangeRequest(st, REC_DYNASTY_RING_70, FALLEN_MUCROKIAN_HIDE, Integer.parseInt(event));
					break;
				case 103:
					htmltext = onRecipeExchangeRequest(st, REC_DYNASTY_SIGIL_60, FALLEN_MUCROKIAN_HIDE, Integer.parseInt(event));
					break;
				case 206:
					htmltext = onRecipeExchangeRequest(st, REC_DYNASTY_SIGIL_60, MUCROKIAN_HIDE, Integer.parseInt(event));
					break;
			}
		}
		else if(event.startsWith("circlet"))
		{
			if(event.endsWith("90"))
				htmltext = onRecipeExchangeRequest(st, REC_MOIRAI_CIRCLET_60, FALLEN_MUCROKIAN_HIDE, 90);
			else if(event.endsWith("180"))
				htmltext = onRecipeExchangeRequest(st, REC_MOIRAI_CIRCLET_60, MUCROKIAN_HIDE, 180);
		}
		else if(event.startsWith("stockings"))
		{
			if(event.endsWith("90"))
				htmltext = onRecipeExchangeRequest(st, REC_MOIRAI_STOCKINGS_60, FALLEN_MUCROKIAN_HIDE, 90);
			else if(event.endsWith("180"))
				htmltext = onRecipeExchangeRequest(st, REC_MOIRAI_STOCKINGS_60, MUCROKIAN_HIDE, 180);
		}
		else if(event.startsWith("tunic"))
		{
			if(event.endsWith("90"))
				htmltext = onRecipeExchangeRequest(st, REC_MOIRAI_TUNIC_60, FALLEN_MUCROKIAN_HIDE, 90);
			else if(event.endsWith("180"))
				htmltext = onRecipeExchangeRequest(st, REC_MOIRAI_TUNIC_60, MUCROKIAN_HIDE, 180);
		}
		else if(event.startsWith("gloves"))
		{
			if(event.endsWith("90"))
				htmltext = onRecipeExchangeRequest(st, REC_MOIRAI_GLOVES_60, FALLEN_MUCROKIAN_HIDE, 90);
			else if(event.endsWith("180"))
				htmltext = onRecipeExchangeRequest(st, REC_MOIRAI_GLOVES_60, MUCROKIAN_HIDE, 180);
		}
		else if(event.startsWith("shoes"))
		{
			if(event.endsWith("90"))
				htmltext = onRecipeExchangeRequest(st, REC_MOIRAI_SHOES_60, FALLEN_MUCROKIAN_HIDE, 90);
			else if(event.endsWith("180"))
				htmltext = onRecipeExchangeRequest(st, REC_MOIRAI_SHOES_60, MUCROKIAN_HIDE, 180);
		}
		else if(event.startsWith("sigil"))
		{
			if(event.endsWith("90"))
				htmltext = onRecipeExchangeRequest(st, REC_MOIRAI_SIGIL_60, FALLEN_MUCROKIAN_HIDE, 90);
			else if(event.endsWith("180"))
				htmltext = onRecipeExchangeRequest(st, REC_MOIRAI_SIGIL_60, MUCROKIAN_HIDE, 180);
		}
		else if(event.startsWith("earring"))
		{
			if(event.endsWith("90"))
				htmltext = onRecipeExchangeRequest(st, REC_MOIRAI_EARRING_70, FALLEN_MUCROKIAN_HIDE, 90);
			else if(event.endsWith("180"))
				htmltext = onRecipeExchangeRequest(st, REC_MOIRAI_EARRING_70, MUCROKIAN_HIDE, 180);
		}
		else if(event.startsWith("necklace"))
		{
			if(event.endsWith("90"))
				htmltext = onRecipeExchangeRequest(st, REC_MOIRAI_NECKLACE_70, FALLEN_MUCROKIAN_HIDE, 90);
			else if(event.endsWith("180"))
				htmltext = onRecipeExchangeRequest(st, REC_MOIRAI_NECKLACE_70, MUCROKIAN_HIDE, 180);
			else if(event.endsWith("128"))
				htmltext = onRecipeExchangeRequest(st, REC_DYNASTY_NECKLACE_70, MUCROKIAN_HIDE, 128);
		}
		else if(event.startsWith("ring"))
		{
			if(event.endsWith("90"))
				htmltext = onRecipeExchangeRequest(st, REC_MOIRAI_RING_70, FALLEN_MUCROKIAN_HIDE, 90);
			else if(event.endsWith("180"))
				htmltext = onRecipeExchangeRequest(st, REC_MOIRAI_RING_70, MUCROKIAN_HIDE, 180);
			else if(event.endsWith("128"))
				htmltext = onRecipeExchangeRequest(st, REC_DYNASTY_RING_70, MUCROKIAN_HIDE, 128);
		}
		else if(event.equalsIgnoreCase("pro_agitator_q0309_16.htm") || event.equalsIgnoreCase("pro_agitator_q0309_07.htm"))
		{
			st.playSound(SOUND_FINISH);
			st.exitCurrentQuest(true);
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int id = st.getState();
		int cond = st.getCond();

		if(npcId == ATRA)
			if(id == CREATED)
			{
				QuestState qs1 = st.getPlayer().getQuestState(_308_ReedFieldMaintenance.class);
				if(qs1 != null && qs1.isStarted())
					htmltext = "pro_agitator_q0309_02.htm";
				if(st.getPlayer().getLevel() < 82)
				{
					htmltext = "pro_agitator_q0309_04.htm";
					st.exitCurrentQuest(true);
				}
				else
					htmltext = "pro_agitator_q0309_01.htm";
			}
			else if(id == STARTED || cond == 1)
				if(st.getQuestItemsCount(MUCROKIAN_HIDE) >= 1 || st.getQuestItemsCount(FALLEN_MUCROKIAN_HIDE) >= 1)
					htmltext = "pro_agitator_q0309_10.htm";
				else
					htmltext = "pro_agitator_q0309_09.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int cond = st.getCond();

		if(contains(MUCROKIANS, npc.getNpcId()) && cond == 1)
		{
			st.rollAndGive(MUCROKIAN_HIDE, 1, 1, MUCROKIAN_HIDE_CHANCE);
			st.playSound(SOUND_ITEMGET);
		}
		else if(npc.getNpcId() == CHANGED_MUCROKIAN)
		{
			st.rollAndGive(FALLEN_MUCROKIAN_HIDE, 1, 1, FALLEN_HIDE_CHANCE);
			st.playSound(SOUND_ITEMGET);
		}
		else if(npc.getNpcId() == CONTAMINATED_MUCROKIAN)
		{
			st.rollAndGive(FALLEN_MUCROKIAN_HIDE, 1, 1, FALLEN_HIDE_CHANCE);
			st.playSound(SOUND_ITEMGET);
		}
		return null;
	}

	private String onPiecesExchangeRequest(QuestState st, int pieces, int event)
	{
		long h1 = st.getQuestItemsCount(MUCROKIAN_HIDE);
		if(h1 >= event)
		{
			st.giveItems(pieces, Rnd.get(1, 4));
			st.takeItems(MUCROKIAN_HIDE, event);
			st.playSound(SOUND_FINISH);
			return "pro_agitator_q0309_20.htm";
		}
		else
			return "pro_agitator_q0309_21.htm";
	}

	private String onRecipeExchangeRequest(QuestState st, int recipe, int takeid, int quanty)
	{
		long h1 = st.getQuestItemsCount(takeid);
		if(h1 >= quanty)
		{
			st.giveItems(recipe, 1);
			st.takeItems(takeid, quanty);
			st.playSound(SOUND_FINISH);
			return "pro_agitator_q0309_20.htm";
		}
		else
			return "pro_agitator_q0309_21.htm";
	}
}