package quests._351_BlackSwan;

import java.io.File;

import l2ft.Config;
import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.L2Multisell;
import l2ft.gameserver.model.base.Experience;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;

// Рейты учтены
public class _351_BlackSwan extends Quest implements ScriptFile
{
	//NPC
	private static final int Gosta = 30916;
	private static final int Heine = 30969;
	private static final int Roman = 30897;
	private static final int ORDER_OF_GOSTA = 4296;
	private static final int LIZARD_FANG = 4297;
	private static final int BARREL_OF_LEAGUE = 4298;
	private static final int BILL_OF_IASON_HEINE = 4310;
	private static final int CHANCE = 100;
	private static final int CHANCE2 = 5;

	@Override
	public void onLoad()
	{}

	@Override
	public void onReload()
	{}

	@Override
	public void onShutdown()
	{}

	private static void loadMultiSell()
	{
		L2Multisell.getInstance().parseFile(new File(Config.DATAPACK_ROOT, "data/scripts/quests/_351_BlackSwan/351.xml"));
	}

	public static void OnReloadMultiSell()
	{
		loadMultiSell();
	}

	static
	{
		loadMultiSell();
	}

	public _351_BlackSwan()
	{
		super(false);
		addStartNpc(Gosta);
		addTalkId(Heine);
		addTalkId(Roman);
		addKillId(new int[] { 20784, 20785, 21639, 21640, 21642, 21643 });
		addQuestItem(new int[] { ORDER_OF_GOSTA, LIZARD_FANG, BARREL_OF_LEAGUE });
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		String htmltext = event;
		long amount = st.getQuestItemsCount(LIZARD_FANG);
		long amount2 = st.getQuestItemsCount(BARREL_OF_LEAGUE);

		if(event.equalsIgnoreCase("captain_gosta_q0351_04.htm"))
		{
			st.setState(STARTED);
			st.set("cond", "1");
			st.giveItems(ORDER_OF_GOSTA, 1);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equalsIgnoreCase("iason_haine_q0351_02.htm") && amount > 0)
		{
			htmltext = "iason_haine_q0351_03.htm";
			st.giveItems(ADENA_ID, amount * 30, false);
			st.takeItems(LIZARD_FANG, -1);
		}
		else if(event.equalsIgnoreCase("iason_haine_q0351_04.htm") && amount2 > 0)
		{
			htmltext = "iason_haine_q0351_05.htm";
			st.set("cond", "2");
			st.giveItems(ADENA_ID, amount2 * 500, false);
			st.giveItems(BILL_OF_IASON_HEINE, amount2, false);
			st.takeItems(BARREL_OF_LEAGUE, -1);
		}
		else if(event.equalsIgnoreCase("iason_haine_q0351_01.htm") && st.getInt("cond") == 2)
			htmltext = "iason_haine_q0351_06.htm";
		else if(event.equalsIgnoreCase("iason_haine_q0351_09.htm"))
		{
			st.exitCurrentQuest(true);
			st.playSound(SOUND_FINISH);
			htmltext = "";
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		String htmltext = "noquest";
		int cond = st.getInt("cond");
		long amount = st.getQuestItemsCount(LIZARD_FANG);
		if(npcId == Gosta)
			if(cond == 0)
			{
				if(st.getPlayer().getLevel() >= 32)
					htmltext = "captain_gosta_q0351_02.htm";
				else
				{
					htmltext = "captain_gosta_q0351_01.htm";
					st.exitCurrentQuest(true);
				}
			}
			else if(cond >= 1)
				htmltext = "captain_gosta_q0351_05.htm";
		if(npcId == Heine)
		{
			if(cond == 1)
				htmltext = "iason_haine_q0351_01.htm";
			if(cond == 2)
				htmltext = "iason_haine_q0351_06.htm";
		}
		if(npcId == Roman && amount >= 0)
			htmltext = "head_blacksmith_roman_q0351_01.htm";
		else
			htmltext = "head_blacksmith_roman_q0351_02.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		double mod = Experience.penaltyModifier(st.calculateLevelDiffForDrop(npc.getLevel(), st.getPlayer().getLevel()), 9);
		st.rollAndGive(LIZARD_FANG, 1, CHANCE * mod);
		st.rollAndGive(BARREL_OF_LEAGUE, 1, CHANCE2 * mod);
		return null;
	}
}