package quests._451_LuciensAltar;

import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;

public class _451_LuciensAltar extends Quest implements ScriptFile
{
	@Override
	public void onLoad()
	{}

	@Override
	public void onReload()
	{}

	@Override
	public void onShutdown()
	{}

	private static int DAICHIR = 30537;

	private static int REPLENISHED_BEAD = 14877;
	private static int DISCHARGED_BEAD = 14878;

	private static int ALTAR_1 = 32706;
	private static int ALTAR_2 = 32707;
	private static int ALTAR_3 = 32708;
	private static int ALTAR_4 = 32709;
	private static int ALTAR_5 = 32710;

	private static int[] ALTARS = new int[] { ALTAR_1, ALTAR_2, ALTAR_3, ALTAR_4, ALTAR_5 };

	public _451_LuciensAltar()
	{
		super(false);

		addStartNpc(DAICHIR);
		addTalkId(ALTARS);
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		if(event.equalsIgnoreCase("daichir_priest_of_earth_q0451_07.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.giveItems(REPLENISHED_BEAD, 5);
			st.playSound(SOUND_ACCEPT);
		}
		return event;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int cond = st.getCond();
		L2Player player = st.getPlayer();

		if(npcId == DAICHIR)
		{
			if(cond == 0)
			{
				if(player.getLevel() < 80)
				{
					htmltext = "daichir_priest_of_earth_q0451_02.htm";
					st.exitCurrentQuest(true);
				}
				else if(!canEnter(player))
				{
					htmltext = "daichir_priest_of_earth_q0451_03.htm";
					st.exitCurrentQuest(true);
				}
				else
					htmltext = "daichir_priest_of_earth_q0451_01.htm";
			}
			else if(cond == 1)
				htmltext = "daichir_priest_of_earth_q0451_10.htm";
			else if(cond == 2)
			{
				htmltext = "daichir_priest_of_earth_q0451_12.htm";
				st.giveItems(ADENA_ID, 127690);
				st.takeItems(DISCHARGED_BEAD, -1);
				st.exitCurrentQuest(true);
				st.playSound(SOUND_FINISH);
				st.getPlayer().setVar(getName(), String.valueOf(System.currentTimeMillis()));
			}
		}
		else if(cond == 1 && contains(ALTARS, npcId))
			if(npcId == ALTAR_1 && st.getInt("Altar1") < 1)
			{
				htmltext = "altar_of_lucien_q0451_01.htm";
				onAltarCheck(st);
				st.set("Altar1", 1);
			}
			else if(npcId == ALTAR_2 && st.getInt("Altar2") < 1)
			{
				htmltext = "altar_of_lucien_q0451_01.htm";
				onAltarCheck(st);
				st.set("Altar2", 1);
			}
			else if(npcId == ALTAR_3 && st.getInt("Altar3") < 1)
			{
				htmltext = "altar_of_lucien_q0451_01.htm";
				onAltarCheck(st);
				st.set("Altar3", 1);
			}
			else if(npcId == ALTAR_4 && st.getInt("Altar4") < 1)
			{
				htmltext = "altar_of_lucien_q0451_01.htm";
				onAltarCheck(st);
				st.set("Altar4", 1);
			}
			else if(npcId == ALTAR_5 && st.getInt("Altar5") < 1)
			{
				htmltext = "altar_of_lucien_q0451_01.htm";
				onAltarCheck(st);
				st.set("Altar5", 1);
			}
			else
				htmltext = "altar_of_lucien_q0451_02.htm";
		return htmltext;
	}

	private void onAltarCheck(QuestState st)
	{
		st.takeItems(REPLENISHED_BEAD, 1);
		st.giveItems(DISCHARGED_BEAD, 1);
		st.playSound(SOUND_ITEMGET);
		if(st.getQuestItemsCount(DISCHARGED_BEAD) >= 5)
		{
			st.set("cond", "2");
			st.playSound(SOUND_MIDDLE);
		}
	}

	private boolean canEnter(L2Player player)
	{
		if(player.isGM())
			return true;
		String var = player.getVar(getName());
		if(var == null)
			return true;
		return Long.parseLong(var) - System.currentTimeMillis() > 24 * 60 * 60 * 1000;
	}
}