package quests._455_WingsOfSand;

import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;
import l2ft.util.Rnd;

/**
 * Квест Крылья из песка
 * Шанс выпадения квестового итема поставлен приблизительно и равен 50%
 * Прнизы выдаются за один итем один предмет рандомно(куски по 2 шт.), если 2 итема то 2 предмета: 
 * Рецепт и кусок для (Оружия, Шмота и Бижутерии) либо Атрибут и Заточка.
 * @author RuLeX
 */

public class _455_WingsOfSand extends Quest implements ScriptFile
{
	public void onLoad()
	{}

	public void onReload()
	{}

	public void onShutdown()
	{}
	

	// Quest Items
	private static final int LARGE_BABY_DRAGON  = 17250;

	// NPC
	private static final int SEPARATED_SOUL1 = 32864;
	private static final int SEPARATED_SOUL2 = 32865;
	private static final int SEPARATED_SOUL3 = 32866;
	private static final int SEPARATED_SOUL4 = 32867;
	private static final int SEPARATED_SOUL5 = 32868;
	private static final int SEPARATED_SOUL6 = 32869;
	private static final int SEPARATED_SOUL7 = 32870;
	private static final int SEPARATED_SOUL8 = 32891;
	
	
	//REWARDS
	private static final int[] WEAPON_REC = {15818, 15817, 15815, 15816, 15825, 15823, 15821, 15824, 15822, 15820, 15819};
	private static final int[] WEAPON_PIECE = {15637, 15636, 15634, 15635, 15644, 15642, 15640, 15643, 15641, 15639, 15638};
	private static final int[] ARMOR_REC = {15792, 15795, 15798, 15801, 15804, 15808, 15793, 15796, 15799, 15802, 15805, 15794, 15797, 15800, 15803, 15806, 15807};
	private static final int[] ARMOR_PIECE = {15663, 15666, 15660, 15667, 15668, 15669, 15664, 15670, 15661, 15671, 15672, 15665, 15673, 15662, 15674, 15675, 15691};
	private static final int[] JEWEL_REC = {15811, 15810, 15809};
	private static final int[] JEWEL_PIECE = {15771, 15770, 15769};
	private static final int[] ATRIBUT_CRISTAL = {9552, 9553, 9554, 9555, 9557, 9556};
	private static final int[] BLESS_SCROLL = {6577, 6578};



	public _455_WingsOfSand()
	{
		super(true);
		addStartNpc(SEPARATED_SOUL1);
		addStartNpc(SEPARATED_SOUL2);
		addStartNpc(SEPARATED_SOUL3);
		addStartNpc(SEPARATED_SOUL4);
		addStartNpc(SEPARATED_SOUL5);
		addStartNpc(SEPARATED_SOUL6);
		addStartNpc(SEPARATED_SOUL7);
		addStartNpc(SEPARATED_SOUL8);
		

		for(int mob = 25718; mob <= 25724; mob++)
			addKillId(mob);

		addQuestItem(LARGE_BABY_DRAGON);
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		String htmltext = event;
		long count = st.getQuestItemsCount(LARGE_BABY_DRAGON);
		int cond = st.getInt("cond");
		int level = st.getPlayer().getLevel();
		if(event.equalsIgnoreCase("quest_accept"))
		{
			st.setState(STARTED);
			st.set("cond", "1");
			st.playSound(SOUND_ACCEPT);
			htmltext = "32864-4.htm";
		}
		else if(event.equalsIgnoreCase("32864-8.htm"))
		{
			st.exitCurrentQuest(true);
			st.playSound(SOUND_FINISH);
		}
		else if(event.equalsIgnoreCase("32864-5"))
		{
			if(count == 1)
				htmltext = "32864-5.htm";
			else if (count >= 2)
				htmltext = "32864-5a.htm";
			else
				htmltext = "32864-9.htm";
		}
		else if(event.equalsIgnoreCase("give_reward") && count == 1)
		{
			st.takeItems(LARGE_BABY_DRAGON, 1);
			int priz = Rnd.get(8);
			switch(priz)
				{
					case 0:
						htmltext = "32864-6.htm";
						st.giveItems(WEAPON_REC[Rnd.get(11)], 1, true);
						break;
					case 1:
						htmltext = "32864-6.htm";
						st.giveItems(WEAPON_PIECE[Rnd.get(11)], Rnd.get(2), true);
						break;
					case 2:
						htmltext = "32864-6.htm";
						st.giveItems(ARMOR_REC[Rnd.get(17)], 1, true);
						break;
					case 3:
						htmltext = "32864-6.htm";
						st.giveItems(ARMOR_PIECE[Rnd.get(17)], Rnd.get(2), true);
						break;
					case 4:
						htmltext = "32864-6.htm";
						st.giveItems(JEWEL_REC[Rnd.get(3)], 1, true);
						break;
					case 5:
						htmltext = "32864-6.htm";
						st.giveItems(JEWEL_PIECE[Rnd.get(3)], Rnd.get(2), true);
						break;
					case 6:
						htmltext = "32864-6.htm";
						st.giveItems(ATRIBUT_CRISTAL[Rnd.get(6)], 1, true);
						break;
					case 7:
						htmltext = "32864-6.htm";
						st.giveItems(BLESS_SCROLL[Rnd.get(2)], 1, true);
						break;				
				}
		}
		else if(event.equalsIgnoreCase("give_reward") && count >= 2)
		{
			st.takeItems(LARGE_BABY_DRAGON, 2);
			int priz = Rnd.get(4);
			switch(priz)
				{
					case 0:
						htmltext = "32864-6.htm";
						st.giveItems(WEAPON_REC[Rnd.get(11)], 1, true);
						st.giveItems(WEAPON_PIECE[Rnd.get(11)], Rnd.get(2), true);
						break;
					case 1:
						htmltext = "32864-6.htm";
						st.giveItems(ARMOR_REC[Rnd.get(17)], 1, true);
						st.giveItems(ARMOR_PIECE[Rnd.get(17)], Rnd.get(2), true);
						break;
					case 2:
						htmltext = "32864-6.htm";
						st.giveItems(JEWEL_REC[Rnd.get(3)], 1, true);
						st.giveItems(JEWEL_PIECE[Rnd.get(3)], Rnd.get(2), true);
						break;
					case 3:
						htmltext = "32864-6.htm";
						st.giveItems(ATRIBUT_CRISTAL[Rnd.get(6)], 1, true);
						st.giveItems(BLESS_SCROLL[Rnd.get(2)], 1, true);
						break;			
				}
		}
		
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int id = st.getState();		
		if(id == CREATED)
		{
			if(st.getPlayer().getLevel() >= 80)
			{
				st.set("cond", "1");
				htmltext = "32864.htm";
			}	
			else
			{
				htmltext = "32864-lvl.htm";
				st.exitCurrentQuest(true);
			}
		}
		else if (st.getInt("cond") >= 1)
		{
			htmltext = "32864-men.htm";
		}

		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		if(st.getInt("cond") == 1)
		{
			if(Rnd.get(100) <= 30)
			{
				st.giveItems(LARGE_BABY_DRAGON, 1, false);
				st.playSound(SOUND_ITEMGET);
			}
			if (st.getQuestItemsCount(LARGE_BABY_DRAGON) >= 2)
            {
                st.set("cond", "2");
                st.playSound(SOUND_MIDDLE);
            }
		}
		return null;
	}
}