package quests._605_AllianceWithKetraOrcs;

import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;

public class _605_AllianceWithKetraOrcs extends Quest implements ScriptFile
{
	//ketra mobs
	private static final int[] KETRA_NPC_LIST = new int[19];

	// items
	private static final int MARK_OF_KETRA_ALLIANCE1 = 7211;
	private static final int MARK_OF_KETRA_ALLIANCE2 = 7212;
	private static final int MARK_OF_KETRA_ALLIANCE3 = 7213;
	private static final int MARK_OF_KETRA_ALLIANCE4 = 7214;
	private static final int MARK_OF_KETRA_ALLIANCE5 = 7215;
	private static final int VB_SOLDIER = 7216;
	private static final int VB_CAPTAIN = 7217;
	private static final int VB_GENERAL = 7218;
	private static final int TOTEM_OF_VALOR = 7219;
	private static final int TOTEM_OF_WISDOM = 7220;

	// hunt for soldier
	private static final int RECRUIT = 21350;
	private static final int FOOTMAN = 21351;
	private static final int SCOUT = 21353;
	private static final int HUNTER = 21354;
	private static final int SHAMAN = 21355;

	// hunt for captain
	private static final int PRIEST = 21357;
	private static final int WARRIOR = 21358;
	private static final int MEDIUM = 21360;
	private static final int MAGUS = 21361;
	private static final int OFFICIER = 21362;
	private static final int COMMANDER = 21369;
	private static final int ELITE_GUARD = 21370;

	// hunt for general
	private static final int GREAT_MAGUS = 21365;
	private static final int GENERAL = 21366;
	private static final int GREAT_SEER = 21368;
	private static final int VARKA_PROPHET = 21373;
	private static final int DISCIPLE_OF_PROPHET = 21375;
	private static final int PROPHET_GUARDS = 21374;
	private static final int HEAD_MAGUS = 21371;
	private static final int HEAD_GUARDS = 21372;
	private static final int Wahkan = 31371;

	public _605_AllianceWithKetraOrcs()
	{
		super(true);

		addStartNpc(Wahkan);

		//ketra mobs
		KETRA_NPC_LIST[0] = 21324;
		KETRA_NPC_LIST[1] = 21325;
		KETRA_NPC_LIST[2] = 21327;
		KETRA_NPC_LIST[3] = 21328;
		KETRA_NPC_LIST[4] = 21329;
		KETRA_NPC_LIST[5] = 21331;
		KETRA_NPC_LIST[6] = 21332;
		KETRA_NPC_LIST[7] = 21334;
		KETRA_NPC_LIST[8] = 21335;
		KETRA_NPC_LIST[9] = 21336;
		KETRA_NPC_LIST[10] = 21338;
		KETRA_NPC_LIST[11] = 21339;
		KETRA_NPC_LIST[12] = 21340;
		KETRA_NPC_LIST[13] = 21342;
		KETRA_NPC_LIST[14] = 21343;
		KETRA_NPC_LIST[15] = 21344;
		KETRA_NPC_LIST[16] = 21345;
		KETRA_NPC_LIST[17] = 21346;
		KETRA_NPC_LIST[18] = 21347;
		addKillId(KETRA_NPC_LIST);

		//hunt for soldier
		addKillId(RECRUIT);
		addKillId(FOOTMAN);
		addKillId(SCOUT);
		addKillId(HUNTER);
		addKillId(SHAMAN);

		//hunt for captain
		addKillId(PRIEST);
		addKillId(WARRIOR);
		addKillId(MEDIUM);
		addKillId(MAGUS);
		addKillId(OFFICIER);
		addKillId(COMMANDER);
		addKillId(ELITE_GUARD);

		//hunt for general
		addKillId(GREAT_MAGUS);
		addKillId(GENERAL);
		addKillId(GREAT_SEER);
		addKillId(VARKA_PROPHET);
		addKillId(DISCIPLE_OF_PROPHET);
		addKillId(PROPHET_GUARDS);
		addKillId(HEAD_MAGUS);
		addKillId(HEAD_GUARDS);

		addQuestItem(VB_SOLDIER);
		addQuestItem(VB_CAPTAIN);
		addQuestItem(VB_GENERAL);
	}

	public boolean isKetraNpc(int npc)
	{
		for(int i : KETRA_NPC_LIST)
			if(npc == i)
				return true;
		return false;
	}

	@Override
	public void onLoad()
	{}

	@Override
	public void onReload()
	{}

	@Override
	public void onShutdown()
	{}

	@Override
	public void onAbort(QuestState st)
	{
		takeAllMarks(st);
		st.set("cond", "0");
		st.getPlayer().updateKetraVarka();
		st.playSound(SOUND_MIDDLE);
	}

	private static void takeAllMarks(QuestState st)
	{
		st.takeItems(MARK_OF_KETRA_ALLIANCE1, -1);
		st.takeItems(MARK_OF_KETRA_ALLIANCE2, -1);
		st.takeItems(MARK_OF_KETRA_ALLIANCE3, -1);
		st.takeItems(MARK_OF_KETRA_ALLIANCE4, -1);
		st.takeItems(MARK_OF_KETRA_ALLIANCE5, -1);
	}

	private void checkMarks(QuestState st)
	{
		if(st.getInt("cond") == 0)
			return;
		if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE5) > 0)
			st.set("cond", "6");
		else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE4) > 0)
			st.set("cond", "5");
		else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE3) > 0)
			st.set("cond", "4");
		else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE2) > 0)
			st.set("cond", "3");
		else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE1) > 0)
			st.set("cond", "2");
		else
			st.set("cond", "1");
	}

	private static boolean CheckNextLevel(QuestState st, int soilder_count, int capitan_count, int general_count, int other_item, boolean take)
	{
		if(soilder_count > 0 && st.getQuestItemsCount(VB_SOLDIER) < soilder_count)
			return false;
		if(capitan_count > 0 && st.getQuestItemsCount(VB_CAPTAIN) < capitan_count)
			return false;
		if(general_count > 0 && st.getQuestItemsCount(VB_GENERAL) < general_count)
			return false;
		if(other_item > 0 && st.getQuestItemsCount(other_item) < 1)
			return false;

		if(take)
		{
			if(soilder_count > 0)
				st.takeItems(VB_SOLDIER, soilder_count);
			if(capitan_count > 0)
				st.takeItems(VB_CAPTAIN, capitan_count);
			if(general_count > 0)
				st.takeItems(VB_GENERAL, general_count);
			if(other_item > 0)
				st.takeItems(other_item, 1);
			takeAllMarks(st);
		}
		return true;
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		if(event.equalsIgnoreCase("herald_wakan_q0605_04.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
			return event;
		}

		checkMarks(st);
		int cond = st.getInt("cond");

		if(event.equalsIgnoreCase("herald_wakan_q0605_12.htm") && cond == 1 && CheckNextLevel(st, 100, 0, 0, 0, true))
		{
			st.giveItems(MARK_OF_KETRA_ALLIANCE1, 1);
			st.set("cond", "2");
			st.getPlayer().updateKetraVarka();
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("herald_wakan_q0605_15.htm") && cond == 2 && CheckNextLevel(st, 200, 100, 0, 0, true))
		{
			st.giveItems(MARK_OF_KETRA_ALLIANCE2, 1);
			st.set("cond", "3");
			st.getPlayer().updateKetraVarka();
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("herald_wakan_q0605_18.htm") && cond == 3 && CheckNextLevel(st, 300, 200, 100, 0, true))
		{
			st.giveItems(MARK_OF_KETRA_ALLIANCE3, 1);
			st.set("cond", "4");
			st.getPlayer().updateKetraVarka();
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("herald_wakan_q0605_21.htm") && cond == 4 && CheckNextLevel(st, 300, 300, 200, TOTEM_OF_VALOR, true))
		{
			st.giveItems(MARK_OF_KETRA_ALLIANCE4, 1);
			st.set("cond", "5");
			st.getPlayer().updateKetraVarka();
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("herald_wakan_q0605_23.htm") && cond == 5 && CheckNextLevel(st, 400, 400, 200, TOTEM_OF_WISDOM, true))
		{
			st.giveItems(MARK_OF_KETRA_ALLIANCE5, 1);
			st.set("cond", "6");
			st.getPlayer().updateKetraVarka();
			st.playSound(SOUND_MIDDLE);
		}
		else if(event.equalsIgnoreCase("herald_wakan_q0605_26.htm"))
		{
			takeAllMarks(st);
			st.set("cond", "0");
			st.getPlayer().updateKetraVarka();
			st.playSound(SOUND_MIDDLE);
			st.exitCurrentQuest(true);
		}
		return event;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		if(st.getPlayer().getVarka() > 0)
		{
			st.exitCurrentQuest(true);
			return "herald_wakan_q0605_02.htm";
		}
		checkMarks(st);
		if(st.getState() == CREATED)
			st.set("cond", "0");
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == 31371)
		{
			if(cond == 0)
			{
				if(st.getPlayer().getLevel() < 74)
				{
					st.exitCurrentQuest(true);
					return "herald_wakan_q0605_03.htm";
				}
				return "herald_wakan_q0605_01.htm";
			}
			if(cond == 1)
				return CheckNextLevel(st, 100, 0, 0, 0, false) ? "herald_wakan_q0605_11.htm" : "herald_wakan_q0605_10.htm";
			if(cond == 2)
				return CheckNextLevel(st, 200, 100, 0, 0, false) ? "herald_wakan_q0605_14.htm" : "herald_wakan_q0605_13.htm";
			if(cond == 3)
				return CheckNextLevel(st, 300, 200, 100, 0, false) ? "herald_wakan_q0605_17.htm" : "herald_wakan_q0605_16.htm";
			if(cond == 4)
				return CheckNextLevel(st, 300, 300, 200, TOTEM_OF_VALOR, false) ? "herald_wakan_q0605_20.htm" : "herald_wakan_q0605_19.htm";
			if(cond == 5)
				return CheckNextLevel(st, 400, 400, 200, TOTEM_OF_WISDOM, false) ? "herald_wakan_q0605_27.htm" : "herald_wakan_q0605_22.htm";
			if(cond == 6)
				return "herald_wakan_q0605_24.htm";
		}
		return "noquest";
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		if(isKetraNpc(npcId))
			if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE5) > 0)
			{
				takeAllMarks(st);
				st.giveItems(MARK_OF_KETRA_ALLIANCE4, 1);
				st.getPlayer().updateKetraVarka();
			}
			else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE4) > 0)
			{
				takeAllMarks(st);
				st.giveItems(MARK_OF_KETRA_ALLIANCE3, 1);
				st.getPlayer().updateKetraVarka();
			}
			else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE3) > 0)
			{
				takeAllMarks(st);
				st.giveItems(MARK_OF_KETRA_ALLIANCE2, 1);
				st.getPlayer().updateKetraVarka();
			}
			else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE2) > 0)
			{
				takeAllMarks(st);
				st.giveItems(MARK_OF_KETRA_ALLIANCE1, 1);
				st.getPlayer().updateKetraVarka();
			}
			else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE1) > 0)
			{
				takeAllMarks(st);
				st.getPlayer().updateKetraVarka();
			}
			else if(st.getPlayer().getKetra() > 0)
			{
				st.getPlayer().updateKetraVarka();
				st.exitCurrentQuest(true);
				return "herald_wakan_q0605_26.htm";
			}

		if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE5) > 0)
			return null;

		int cond = st.getInt("cond");
		if(npcId == RECRUIT || npcId == FOOTMAN || npcId == SCOUT || npcId == HUNTER || npcId == SHAMAN)
		{
			if(cond > 0)
				st.rollAndGive(VB_SOLDIER, 1, 60);
		}
		else if(npcId == PRIEST || npcId == WARRIOR || npcId == MEDIUM || npcId == MAGUS || npcId == OFFICIER || npcId == COMMANDER || npcId == ELITE_GUARD)
		{
			if(cond > 1)
				st.rollAndGive(VB_CAPTAIN, 1, 70);
		}
		else if(npcId == GREAT_MAGUS || npcId == GENERAL || npcId == GREAT_SEER || npcId == VARKA_PROPHET || npcId == DISCIPLE_OF_PROPHET || npcId == PROPHET_GUARDS || npcId == HEAD_MAGUS || npcId == HEAD_GUARDS)
			if(cond > 2)
				st.rollAndGive(VB_GENERAL, 1, 80);
		return null;
	}
}