package quests._702_TrapForRevenge;

import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;
import l2ft.util.Rnd;
import quests._10273_GoodDayToFly._10273_GoodDayToFly;

public class _702_TrapForRevenge extends Quest implements ScriptFile
{

	// NPC
	private static final int Plenos = 32563;
	private static final int Tenius  = 32555;
	//item
	private static final int DrakesFlesh = 13877;
	
	public void onLoad()
	{}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _702_TrapForRevenge()
	{
		super(true);
		addStartNpc(Plenos);
		addTalkId(Tenius);
		addKillId(22612);
		addKillId(25631);
		addKillId(22610);
		addQuestItem(DrakesFlesh);
		addQuestItem(9629);
	}

	@Override
	public String onEvent(String event, final QuestState st, L2NpcInstance npc)
	{
		final L2Player player = st.getPlayer();
		String htmltext = event;
		if(event.equalsIgnoreCase("wharf_soldier_plenos_q0702_04.htm"))
		{
			st.setCond(1);
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		if(event.equalsIgnoreCase("soldier_tenis_q0702_03.htm"))
		{
			st.setCond(2);
			st.playSound(SOUND_ACCEPT);
		}
		if(event.equalsIgnoreCase("exit"))
		{
		
			if(st.getQuestItemsCount(DrakesFlesh) < 100) {
				return "soldier_tenis_q0702_06.htm";
			} else {
				st.takeItems(DrakesFlesh, -1);
				st.giveItems(57, 3144000);
				st.giveItems(9629, 3);
				st.playSound(SOUND_FINISH);
				st.exitCurrentQuest(true);
				return "exit.htm";
			}
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int id = st.getState();
		int cond = st.getCond();
		
		if(npcId == Plenos)
		{
			if(id == CREATED)
			{
				QuestState qs = st.getPlayer().getQuestState(_10273_GoodDayToFly.class);
				if(qs != null && qs.isCompleted() && st.getPlayer().getLevel() >= 78)
					return "wharf_soldier_plenos_q0702_01.htm";
				else
					return "lvl.htm";			
			}
			if(id == STARTED)
			{
				if(cond == 1)
				return "wharf_soldier_plenos_q0702_05.htm";
			}
		}
		
		if(npcId == Tenius)
		{
			if(cond == 1)
				return "soldier_tenis_q0702_01.htm";
			if(cond ==2)
				return "soldier_tenis_q0702_04.htm";
		
		}

		return "noquest";
	}
	
	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		if(st.getState() != STARTED)
			return null;
		int npcId = npc.getNpcId();
		int cond = st.getCond();
		if (cond == 2) {
			if(npcId == 22612 || npcId == 25631 || npcId == 22610)
			{
				if(Rnd.chance(50)) {
					st.giveItems(DrakesFlesh, 1);
					st.playSound("ItemSound.quest_itemget");
				}
			}
		}
		return null;
	}	
}