package quests._717_ForTheSakeOfTheTerritoryGludio;

import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.entity.siege.territory.TerritorySiege;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;
import l2ft.gameserver.serverpackets.ExShowScreenMessage;
import l2ft.util.Util;

public class _717_ForTheSakeOfTheTerritoryGludio extends Quest
{
	private static final int territoryId = 1;
	private static final int TerritoryCatapult = 36499;
	private static final int SuppliesSafe = 36591;
	private static final int[] Leaders = { 6508, 36510, 36513 };
	private static final int[] Guards = { 36509, 36511, 36512 };
	private static final String MSG = "The defence of Gludio has been broken!";

	public _717_ForTheSakeOfTheTerritoryGludio()
	{
		super(false);
		boolean doCount = false;

		addKillId(new int[] { 36499 });
		addKillId(Leaders);
		addKillId(Guards);
	}

	public static void OnPlayerEnter(L2Player player)
	{
		if (player == null)
			return;
		if (player.getTerritorySiege() < 0)
		{
			QuestState st = player.getQuestState(_717_ForTheSakeOfTheTerritoryGludio.class);
			if (st != null)
				st.exitCurrentQuest(true);
		}
	}

	public String onKill(L2NpcInstance npc, QuestState st)
	{
		if (st.getPlayer().getTerritorySiege() == 1)
			return null;
		int npcId = npc.getNpcId();
		int cond = st.getCond();
		if (npcId == 36499)
		{
			if (cond == 1 || cond == 2 || cond == 4 || cond == 8 || cond == 10)
			{
				TerritorySiege.addBadges(st.getPlayer(), 3.0D);
				switch (cond)
				{
					case 1:
						st.setCond(2);
						break;
					case 3:
						st.setCond(7);
						break;
					case 4:
						st.setCond(9);
						break;
					case 8:
					case 10:
						complete(st);
				}
			} 
		} 
		else if (npcId == 36591)
		{
			if (cond == 1 || cond == 2 || cond == 4 || cond == 6 || cond == 9)
			{
				TerritorySiege.addBadges(st.getPlayer(), 2.0D);
				switch (cond)
				{
					case 1:
						st.setCond(3);
						break;
					case 2:
						st.setCond(5);
						break;
					case 4:
						st.setCond(10);
						break;
					case 6:
						complete(st);
				}
			}
		}
		else if (Util.ArrayContains(Leaders, npcId))
		{
			if (cond == 1 || cond == 2 || cond == 3 || cond == 5 || cond == 7)
			{
				TerritorySiege.addBadges(st.getPlayer(), 2.0D);
				switch (cond)
				{
					case 1:
						st.setCond(4);
						break;
					case 2:
						st.setCond(6);
						break;
					case 3:
						st.setCond(8);
						break;
					case 5:
						complete(st);
				}
			}
		}
		else if (Util.ArrayContains(Guards, npcId))
			TerritorySiege.addBadges(st.getPlayer(), 1.0D);
		return null;
	}

	public void complete(QuestState st)
	{
		st.setCond(11);
		TerritorySiege.addBadges(st.getPlayer(), 10.0D);
		TerritorySiege.territoryDefenceDestroyed(1);
		TerritorySiege.broadcastToPlayer(new ExShowScreenMessage("The defence of Gludio has been broken!", 10000, ExShowScreenMessage.ScreenMessageAlign.TOP_CENTER), false);
	}
}