package quests._903_TheCallOfAntharas;

import java.util.Calendar;

import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;
import l2ft.gameserver.serverpackets.NpcSay;
import l2ft.util.Files;
import l2ft.util.Rnd;

/**
 * Квест Зов дракона земли
 * @author RuLeX
 */

public class _903_TheCallOfAntharas extends Quest implements ScriptFile
{
	public void onLoad()
	{}

	public void onReload()
	{}

	public void onShutdown()
	{}
	

	// Quest Items
	private static final int TARASK_LEATHER  = 21991;
	private static final int BEHEMOTH_LEATHER  = 21992;

	// NPC
	private static final int THEODRIC = 30755;
	private static final int TARASK_DRAGON = 29190;
	private static final int TARASK_BEHEMOTH = 29069;
	
	//REWARDS
	
	private static final int ANTHARAS_CALL = 21897;
	private static final int CHANCE = 80;
	
	//RESET
	private static final int RESET_HOUR = 6;
	private static final int RESET_MIN = 30;




	public _903_TheCallOfAntharas()
	{
		super(true);
		addStartNpc(THEODRIC);
				
		addKillId(TARASK_DRAGON);
		addKillId(TARASK_BEHEMOTH);

		addQuestItem(TARASK_LEATHER);
		addQuestItem(BEHEMOTH_LEATHER);
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("quest_accept"))
		{
			htmltext = "theodric_q903_05.htm";
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equalsIgnoreCase("give_item"))
		{
			htmltext = "theodric_q903_06.htm";
			st.takeItems(TARASK_LEATHER, 1);
			st.takeItems(BEHEMOTH_LEATHER, 1);
			st.giveItems(ANTHARAS_CALL, 1);
			st.playSound(SOUND_FINISH);
			st.exitCurrentQuest(true);
			
			Calendar reDo = Calendar.getInstance();
				reDo.set(Calendar.MINUTE, RESET_MIN);
				if (reDo.get(Calendar.HOUR_OF_DAY) >= RESET_HOUR)
					reDo.add(Calendar.DATE, 1);
				reDo.set(Calendar.HOUR_OF_DAY, RESET_HOUR);
		        st.getPlayer().setVar("NextQuest903", "" + (reDo.getTimeInMillis()));
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int id = st.getState();
		if(id == CREATED)
			st.set("cond", "0");
		// На случай любых ошибок, если предметы есть - квест все равно пройдется.
		if(summ(st) >= 2)
			st.set("cond", "2");
		int cond = st.getInt("cond");
		if(npcId == THEODRIC)
			if(st.getQuestItemsCount(3865) >= 1)
			{	
				if(cond == 0)
				{
					String req = st.getPlayer().getVar("NextQuest903") == null ? "0" : st.getPlayer().getVar("NextQuest903");
					if (Long.parseLong(req) > System.currentTimeMillis())
						return "theodric_q903_08.htm";
					else
					{				
						if(st.getPlayer().getLevel() >= 83)
							htmltext = "theodric_q903_01.htm";
						else
						{
							htmltext = "theodric_q903_02.htm";
							st.exitCurrentQuest(true);
						}					
					}	
				}
				else if(cond == 1 && summ(st) < 2)
					htmltext = "theodric_q903_03.htm";
				else if(cond == 2 && summ(st) >= 2)
					htmltext = "theodric_q903_04.htm";
			}
			else htmltext = "theodric_q903_07.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		if(st.getInt("cond") == 1)
		{
			if(npcId == TARASK_DRAGON)
			{
				if(st.getQuestItemsCount(TARASK_LEATHER) < 1)
				{
					st.giveItems(TARASK_LEATHER, CHANCE);
					if(st.getQuestItemsCount(TARASK_LEATHER) == 1)
					{
						if(summ(st) >= 2)
							st.set("cond", "2");
						st.playSound(SOUND_MIDDLE);
					}
					else
						st.playSound(SOUND_ITEMGET);
				}
			}
			else if(npcId == TARASK_BEHEMOTH)
			{
				if(st.getQuestItemsCount(BEHEMOTH_LEATHER) < 1)
				{
					st.rollAndGive(BEHEMOTH_LEATHER, 1, CHANCE);
					if(st.getQuestItemsCount(BEHEMOTH_LEATHER) == 1)
					{
						if(summ(st) >= 2)
							st.set("cond", "2");
						st.playSound(SOUND_MIDDLE);
					}
					else
						st.playSound(SOUND_ITEMGET);
				}
			}
		}
		return null;
	}
	
	private long summ(QuestState st)
	{
		return st.getQuestItemsCount(TARASK_DRAGON) + st.getQuestItemsCount(BEHEMOTH_LEATHER);
	}

}