package quests._906_TheCallOfValakas;

import java.util.Calendar;

import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.quest.Quest;
import l2ft.gameserver.model.quest.QuestState;
import l2ft.gameserver.serverpackets.NpcSay;
import l2ft.util.Files;
import l2ft.util.Rnd;

/**
 * Квест Зов дракона огня
 * @author RuLeX
 */

public class _906_TheCallOfValakas extends Quest implements ScriptFile
{
	public void onLoad()
	{}

	public void onReload()
	{}

	public void onShutdown()
	{}
	

	// Quest Items
	private static final int LAVASAURUS_ALPHA_FRAGMENT  = 21993;

	// NPC
	private static final int KLEIN = 31540;
	private static final int LAVASAURUS_ALPHA = 29029;
	
	//REWARDS
	
	private static final int ANTHARAS_CALL = 21895;
	private static final int CHANCE = 80;

	//RESET
	private static final int RESET_HOUR = 6;
	private static final int RESET_MIN = 30;


	public _906_TheCallOfValakas()
	{
		super(true);
		addStartNpc(KLEIN);				

		addKillId(LAVASAURUS_ALPHA);

		addQuestItem(LAVASAURUS_ALPHA_FRAGMENT);
	}

	@Override
	public String onEvent(String event, QuestState st, L2NpcInstance npc)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("quest_accept"))
		{
			htmltext = "klein_q906_05.htm";
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound(SOUND_ACCEPT);
		}
		else if(event.equalsIgnoreCase("give_item"))
		{
			htmltext = "klein_q906_06.htm";
			st.takeItems(LAVASAURUS_ALPHA_FRAGMENT, 1);
			st.giveItems(ANTHARAS_CALL, 1);
			st.playSound(SOUND_FINISH);
			st.exitCurrentQuest(true);
			
			Calendar reDo = Calendar.getInstance();
				reDo.set(Calendar.MINUTE, RESET_MIN);
				if (reDo.get(Calendar.HOUR_OF_DAY) >= RESET_HOUR)
					reDo.add(Calendar.DATE, 1);
				reDo.set(Calendar.HOUR_OF_DAY, RESET_HOUR);
		        st.getPlayer().setVar("NextQuest906", "" + (reDo.getTimeInMillis()));
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "noquest";
		int npcId = npc.getNpcId();
		int id = st.getState();
		if(id == CREATED)
			st.set("cond", "0");
		// На случай любых ошибок, если предметы есть - квест все равно пройдется.
		if(st.getQuestItemsCount(LAVASAURUS_ALPHA_FRAGMENT) >= 1)
			st.set("cond", "2");
		int cond = st.getInt("cond");
		if(npcId == KLEIN)
			if(st.getQuestItemsCount(7267) >= 1)
			{	
				if(cond == 0)
				{
				String req = st.getPlayer().getVar("NextQuest906") == null ? "0" : st.getPlayer().getVar("NextQuest906");
					if (Long.parseLong(req) > System.currentTimeMillis())
						return "klein_q906_08.htm";
					else
					{
						if(st.getPlayer().getLevel() >= 83)
							htmltext = "klein_q906_01.htm";
						else
						{
							htmltext = "klein_q906_02.htm";
							st.exitCurrentQuest(true);
						}
					}	
				}
				else if(cond == 1)
					htmltext = "klein_q906_03.htm";
				else if(cond == 2)
					htmltext = "klein_q906_04.htm";
			}
			else htmltext = "klein_q906_07.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		if(st.getInt("cond") == 1)
		{
			if(npcId == LAVASAURUS_ALPHA)
			{
				if(st.getQuestItemsCount(LAVASAURUS_ALPHA_FRAGMENT) < 1)
				{
					st.rollAndGive(LAVASAURUS_ALPHA_FRAGMENT, 1, CHANCE);
					if(st.getQuestItemsCount(LAVASAURUS_ALPHA_FRAGMENT) == 1)
					{
						st.set("cond", "2");
						st.playSound(SOUND_MIDDLE);
					}
				}
			}			
		}
		return null;
	}
}