package services;

import l2ft.Config;
import l2ft.extensions.scripts.Functions;
import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.util.Files;
import l2ft.util.Rnd;

import java.util.Calendar;

/**
 * Используется в Black Marketeer Of Mammon (id: 31092), для обмена адены на старые адены.
 * Наменять можно только 500к старых аден в день
 * @Author: RuLeX
 * @Date: 8/09/2011
 */
public class BlackMarketeerOfMammon extends Functions implements ScriptFile
{

	private static final int AncientAdena = 5575;
	private static final int Adena = 57;
	
	private static final int LimitAncientAdena = Config.BLACK_MARKETEER_OF_MAMMON_LIMIT_ANCIENT_ADENA;
	private static final int MinLvl = Config.BLACK_MARKETEER_OF_MAMMON_MIN_LVL;
	
	private static final int RESET_HOUR = Config.BLACK_MARKETEER_OF_MAMMON_RESET_HOUR;
	private static final int RESET_MIN = Config.BLACK_MARKETEER_OF_MAMMON_RESET_MIN;

	public void onLoad()
	{
		if(Config.ALLOW_SERVICE_BLACK_MARKETEER_OF_MAMMON)
			System.out.println("Loaded Service: Black Marketeer Of Mammon");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public void Aden1k()
	{
		ExchangeAdena(1000);
	}
	
	public void Aden10k()
	{
		ExchangeAdena(10000);
	}
	
	public void Aden50k()
	{
		ExchangeAdena(50000);
	}
	
	public void Aden100k()
	{
		ExchangeAdena(100000);
	}
	
	public void Aden500k()
	{
		ExchangeAdena(500000);
	}


	private void ExchangeAdena(int CountAden)
	{
		if(Config.ALLOW_SERVICE_BLACK_MARKETEER_OF_MAMMON)
		{
			L2Player player = (L2Player) getSelf();
			L2NpcInstance npc = getNpc();
			int lvl = player.getLevel();
			String req = player.getVar("BMMTime") == null ? "0" : player.getVar("BMMTime");
			String lim = player.getVar("BMMLim") == null ? "0" : player.getVar("BMMLim");
			String flag = player.getVar("BMMFlag") == null ? "0" : player.getVar("BMMFlag");
			if(player == null || npc == null)
				return;		
			else if(lvl < MinLvl)
				{
					show(Files.read("data/html/seven_signs/blkmrkt-8.htm", player), player, npc);
					return;
				}
			else if((Long.parseLong(req) < System.currentTimeMillis()) && (flag == "1"))
			{
				player.setVar("BMMLim", "0");
				player.setVar("BMMFlag", "0");
				return;
			}
			else if(getItemCount(player, Adena) < (CountAden*4))
				{
					show(Files.read("data/html/seven_signs/blkmrkt-5.htm", player), player, npc);
					return;
				}								
			/*else if ((Long.parseLong(req) > System.currentTimeMillis()) && (flag == "1"))
			{
				show(Files.read("data/html/seven_signs/blkmrkt-6.htm", player), player, npc);
				return;
			}*/
			else if ((Integer.parseInt(lim)+ CountAden) > LimitAncientAdena)
			{
				show(Files.read("data/html/seven_signs/blkmrkt-7.htm", player), player, npc);
				return;
			}
			else
			{
			
				Calendar reDo = Calendar.getInstance();
					reDo.set(Calendar.MINUTE, RESET_MIN);
					if (reDo.get(Calendar.HOUR_OF_DAY) >= RESET_HOUR)
						reDo.add(Calendar.DATE, 1);
					reDo.set(Calendar.HOUR_OF_DAY, RESET_HOUR);
					player.setVar("BMMTime", "" + (reDo.getTimeInMillis()));
			
				removeItem(player, Adena, (CountAden*4));
				addItem(player, AncientAdena, CountAden);
				player.setVar("BMMLim", Integer.toString(Integer.parseInt(lim)+(CountAden)));
				
				if (Integer.parseInt(lim) >= LimitAncientAdena)
					player.setVar("BMMFlag", "1");	
			
				return;
			}
		}
		else
			return;
	}
}