package services;

import l2ft.extensions.scripts.Functions;
import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.cache.Msg;
import l2ft.gameserver.model.L2Player;
import l2ft.util.GArray;
import l2ft.util.Rnd;

public class ClanReputationUp extends Functions implements ScriptFile
{
	public void onLoad()
	{
		System.out.println("Loaded Service: ClanReputationUp");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public void Reputation()
	{
		L2Player player = (L2Player) getSelf();

		if(player == null)
			return;

        if(player.getClan() == null || player.getClan().getLevel() < 5)
        {
            player.sendMessage("Нет клана или его уровень меньше 5.");
            return;
        }

		if(!player.isQuestContinuationPossible(false))
		{
			player.sendPacket(Msg.YOUR_INVENTORY_IS_FULL);
			return;
		}

		if(getItemCount(player, 13068) < 1)
		{
            player.sendMessage("У вас нету Деревянных монет.");
			return;
		}
        if(player.getClan().getReputationScore() >= 10000000)
        {
            player.sendMessage("Вы достигли максимума.");
            return;
        }
        removeItem(player, 13068, 1);
		player.getClan().incReputation(500000, false, "ClanReputationUp");
		player.sendMessage("Вашему клану "+ player.getClan().getName() + " добавлено 500 000 репутации.");
	}

    public void Talisman()
	{
		L2Player player = (L2Player) getSelf();

		if(player == null)
			return;

		if(!player.isQuestContinuationPossible(false))
		{
			player.sendPacket(Msg.YOUR_INVENTORY_IS_FULL);
			return;
		}

		if(getItemCount(player, 10639) < 1)
		{
			player.sendMessage("Для получение талисмана у вас должна быть минимум 1 Мышиная монета.");
			return;
		}

		final GArray<Integer> talismans = new GArray<Integer>();

		//9914-9965
		for(int i = 9914; i <= 9965; i++)
			if(i != 9923)
				talismans.add(i);
		//10416-10424
		for(int i = 10416; i <= 10424; i++)
			talismans.add(i);
		//10518-10519
		for(int i = 10518; i <= 10519; i++)
			talismans.add(i);
		//10533-10543
		for(int i = 10533; i <= 10543; i++)
			talismans.add(i);

		removeItem(player, 10639, 1);
		addItem(player, talismans.get(Rnd.get(talismans.size())), 1);
		player.sendMessage("=) Талисманчик.");
	}

    public void Slava()
	{
		L2Player player = (L2Player) getSelf();

		if(player == null)
			return;

		if(getItemCount(player, 10639) < 1)
		{
            player.sendMessage("Для получение славы у вас должна быть минимум 1 Мышиная монета.");
			return;
		}
        removeItem(player, 10639, 1);
        int oldFame = player.getFame();
        player.setFame(oldFame + 500, "ClanReputationUp");
		//player.sendMessage("Вы получили 500 славы.");
	}

}