package services;

import l2ft.extensions.scripts.Functions;
import l2ft.extensions.scripts.ScriptFile;
import l2ft.gameserver.model.L2Party;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.util.Location;

public class TeleToTullyWorkshop  extends Functions implements ScriptFile
{
	private final static Location[]	teleports	=
	{
		new Location(-12904, 273848, -15332), //1 этаж
		new Location(-12700, 273340, -13600), //2 этаж
		new Location(-13246, 275740, -11936), //3 этаж
		new Location(-12798, 273458, -10496), //4 этаж
        new Location(-13500, 275912, -9032), //5 этаж
	};

	public void teleTo(String[] args)
	{
		L2Player player = (L2Player) getSelf();
		L2NpcInstance npc = getNpc();
		if(player == null || npc == null)
			return;
		if(args.length != 1)
			return;

		Location loc = teleports[Integer.parseInt(args[0]) - 1];
		L2Party party = player.getParty();
		if(party == null)
			return;
		else
		{
			for(L2Player member : party.getPartyMembers())
				if(member == null && player.isInRange(member, 1000))
                    return;
                else
					member.teleToLocation(loc);
		}
	}

	@Override
	public void onLoad()
	{}

	@Override
	public void onReload()
	{}

	@Override
	public void onShutdown()
	{}
}
