package services;

import java.util.concurrent.ScheduledFuture;
import l2ft.extensions.scripts.Functions;
import l2ft.extensions.scripts.ScriptFile;
import l2ft.common.ThreadPoolManager;
import l2ft.gameserver.model.L2CommandChannel;
import l2ft.gameserver.model.L2Party;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.L2ObjectsStorage;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.serverpackets.SystemMessage;
import l2ft.gameserver.serverpackets.ExPCCafePointInfo;

public class pcpts extends Functions implements ScriptFile
{
	private static final int	GIVE_PCPTS_TIMER		= 5 * 60 * 1000;
	private static ScheduledFuture<?>	_pcpts;
	//private static Logger _log = Logger.getLogger(pcpts.class.getName());

	@Override
	public void onLoad()
	{
		System.out.println("Loaded Event: 'pcpts' [state: activated]");
		if(_pcpts == null)
			_pcpts = ThreadPoolManager.getInstance().scheduleGeneralAtFixedRate(new getPC(), GIVE_PCPTS_TIMER, GIVE_PCPTS_TIMER);
	}

	@Override
	public void onReload()
	{
		if(_pcpts != null)
			{
				_pcpts.cancel(true);
				_pcpts = null;
			}
	}

	@Override
	public void onShutdown()
	{}
	
	public class getPC implements Runnable
	{
		@Override
		public void run()
		{
			//if(!_active)
			//	return;
			for(L2Player player : L2ObjectsStorage.getAllPlayersForIterate())
			{
				if (player.isOnline() && player.isConnected())
				{
					player.setPcBangPoints(player.getPcBangPoints()+5);
					player.sendPacket(new ExPCCafePointInfo(player.getPcBangPoints(), 5, true, false, 1));
				}

			}
		}
	}

	public static void givePCPoints(L2Player player, int pts, String str)
	{
		player.sendPacket(new SystemMessage(SystemMessage.S2_S1)
			.addString("За убийство " + str + " вы получили " + Integer.toString(pts) + " PC очков"));
		player.setPcBangPoints(player.getPcBangPoints() + pts);
		player.sendPacket(new ExPCCafePointInfo(player.getPcBangPoints(), pts, true, false, 1));
	}
	
	//@Override
	public static void OnDie(L2Character killed, L2Character killer)
	{
		if(killer != null && killer.isPlayer())
		{
			L2Player _killer = killer.getPlayer();
			if (killed.isPlayer()){
				L2Player _killed = killed.getPlayer();
				if(_killer != null && _killed !=null)
				{
					if (_killer.getIP() == _killed.getIP() || _killer.getLevel() < 80 || _killed.getLevel() < 80)
						return;
					givePCPoints(_killer, 10, "игрока");
				}
			} else if (killed.isMonster()){
				if (killed.isBoss()) // для Эпиков
				{
					if (_killer.isInParty()) // завалил Эпика в пати
					{
						if (_killer.getParty().isInCommandChannel()) // пати в CC?
						{
							// выдаем награду всему CC
							L2CommandChannel cc = _killer.getParty().getCommandChannel();
							for(L2Player ccMember : cc.getMembers())
								if(ccMember != null && ccMember.isInRange(killed, 1000))
								{
									givePCPoints(ccMember, 1000, "Эпика");
								}
						} else { // это просто пати?
							// выдаем награду всей пати
							L2Party party = _killer.getParty();
							for (L2Player partyMember : party.getPartyMembers())
								if(partyMember != null && partyMember.isInRange(killed, 1000))
								{
									givePCPoints(partyMember, 1000, "Эпика");
								}
						}
					} else
					{ // завалил Эпика один
						givePCPoints(_killer, 1000, "Эпика");
					}
				} else if(killed.isRaid()) // для обычных Рейдов
				{
					if (_killer.isInParty()) // завалил Рейда в пати
					{
						// выдаем награду всей пати
						L2Party party = _killer.getParty();
						for (L2Player partyMember : party.getPartyMembers())
							if(partyMember != null && partyMember.isInRange(killed, 1000))
							{
								givePCPoints(partyMember, 300, "Рейд Босса");
							}
					} else { // завалил Рейда один 
						givePCPoints(_killer, 300, "Рейд Босса");
					}
				}
			}
		}
	}
}