package l2ft;

import java.io.File;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.xml.parsers.DocumentBuilderFactory;

import l2ft.util.GArray;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;

public class CLASSConfig
{
	private static final Logger _log = Logger.getLogger(CLASSConfig.class.getName());
	public static GArray<Configs> _configs = new GArray<Configs>();
	
	public static void load()
	{
		try
		{
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			factory.setValidating(false);
			factory.setIgnoringComments(true);

			File file = new File("./config/events/TC.xml");
			Document doc = factory.newDocumentBuilder().parse(file);

			for (Node n = doc.getFirstChild(); n != null; n = n.getNextSibling()) {
				if (!"list".equalsIgnoreCase(n.getNodeName()))
					continue;
				for (Node d = n.getFirstChild(); d != null; d = d.getNextSibling())
				{
					if (!"TransformClass".equalsIgnoreCase(d.getNodeName()))
						continue;
					Configs _config = new Configs();

					NamedNodeMap attrs = d.getAttributes();

					for (Node cd = d.getFirstChild(); cd != null; cd = cd.getNextSibling()) 
					{
						if ("Level".equalsIgnoreCase(cd.getNodeName()))
						{
							attrs = cd.getAttributes();
							_config.MIN_LEVEL = Integer.parseInt(attrs.getNamedItem("min").getNodeValue());
							_config.MAX_LEVEL = Integer.parseInt(attrs.getNamedItem("max").getNodeValue());
						}
						else if ("AllowWeightPenalty".equalsIgnoreCase(cd.getNodeName()))
						{
							attrs = cd.getAttributes();
							_config.ALLOW_WEIGHT_PENALTY = Boolean.parseBoolean(attrs.getNamedItem("val").getNodeValue());
						}
						else if ("AllowInventoryLimit".equalsIgnoreCase(cd.getNodeName()))
						{
							attrs = cd.getAttributes();
							_config.ALLOW_INVENTORY_LIMIT = Boolean.parseBoolean(attrs.getNamedItem("val").getNodeValue());
						}
						else if ("AllowTransformation".equalsIgnoreCase(cd.getNodeName()))
						{
							attrs = cd.getAttributes();
							_config.ALLOW_TRANSFORMATION = Boolean.parseBoolean(attrs.getNamedItem("val").getNodeValue());
						}
						else if ("AllowPet".equalsIgnoreCase(cd.getNodeName()))
						{
							attrs = cd.getAttributes();
							_config.ALLOW_PETS = Boolean.parseBoolean(attrs.getNamedItem("val").getNodeValue());
						}
						else if ("NameNPC".equalsIgnoreCase(cd.getNodeName()))
						{
							attrs = cd.getAttributes();
							_config.NAME_NPC = attrs.getNamedItem("val").getNodeValue();
						}
						else if ("TimeTrans1".equalsIgnoreCase(cd.getNodeName()))
						{
							attrs = cd.getAttributes();
							_config.TIME_TRANS_1 = Integer.parseInt(attrs.getNamedItem("val").getNodeValue());
						}else if ("TimeTrans2".equalsIgnoreCase(cd.getNodeName()))
						{
							attrs = cd.getAttributes();
							_config.TIME_TRANS_2 = Integer.parseInt(attrs.getNamedItem("val").getNodeValue());
						}else if ("TimeTrans3".equalsIgnoreCase(cd.getNodeName()))
						{
							attrs = cd.getAttributes();
							_config.TIME_TRANS_3 = Integer.parseInt(attrs.getNamedItem("val").getNodeValue());
						}else if ("Reward".equalsIgnoreCase(cd.getNodeName()))
						{
							attrs = cd.getAttributes();
							_config.REWARD_ITEM_ID = Integer.parseInt(attrs.getNamedItem("id").getNodeValue());
							_config.REWARD_COUNT = Integer.parseInt(attrs.getNamedItem("count").getNodeValue());
						}else if ("Destroy".equalsIgnoreCase(cd.getNodeName()))
						{
							attrs = cd.getAttributes();
							_config.DESTROY_ITEM_ID = Integer.parseInt(attrs.getNamedItem("id").getNodeValue());
							_config.DESTROY_COUNT = Integer.parseInt(attrs.getNamedItem("count").getNodeValue());
						}else if ("items0".equalsIgnoreCase(cd.getNodeName()))
						{
							attrs = cd.getAttributes();
							for (Node ccd = cd.getFirstChild(); ccd != null; ccd = ccd.getNextSibling()) 
							{
								if ("item".equalsIgnoreCase(ccd.getNodeName()))
								{
									attrs = ccd.getAttributes();
									_config.ITEMS0.put(Integer.parseInt(attrs.getNamedItem("val").getNodeValue()), Integer.parseInt(attrs.getNamedItem("count").getNodeValue()));
								}
							}
						}else if ("items1".equalsIgnoreCase(cd.getNodeName()))
						{
							attrs = cd.getAttributes();
							for (Node ccd = cd.getFirstChild(); ccd != null; ccd = ccd.getNextSibling()) 
							{
								if ("item".equalsIgnoreCase(ccd.getNodeName()))
								{
									attrs = ccd.getAttributes();
									_config.ITEMS1.put(Integer.parseInt(attrs.getNamedItem("val").getNodeValue()), Integer.parseInt(attrs.getNamedItem("count").getNodeValue()));
								}
							}
						}else if ("items2".equalsIgnoreCase(cd.getNodeName()))
						{
							attrs = cd.getAttributes();
							_config.TIME_TRANS_1 = Integer.parseInt(attrs.getNamedItem("time").getNodeValue());
							
							for (Node ccd = cd.getFirstChild(); ccd != null; ccd = ccd.getNextSibling()) 
							{
								if ("item".equalsIgnoreCase(ccd.getNodeName()))
								{
									attrs = ccd.getAttributes();
									_config.ITEMS2.put(Integer.parseInt(attrs.getNamedItem("val").getNodeValue()), Integer.parseInt(attrs.getNamedItem("count").getNodeValue()));
								}
							}
						}else if ("items3".equalsIgnoreCase(cd.getNodeName()))
						{
							attrs = cd.getAttributes();
							_config.TIME_TRANS_2 = Integer.parseInt(attrs.getNamedItem("time").getNodeValue());
							
							
							for (Node ccd = cd.getFirstChild(); ccd != null; ccd = ccd.getNextSibling()) 
							{
								if ("item".equalsIgnoreCase(ccd.getNodeName()))
								{
									attrs = ccd.getAttributes();
									_config.ITEMS3.put(Integer.parseInt(attrs.getNamedItem("val").getNodeValue()), Integer.parseInt(attrs.getNamedItem("count").getNodeValue()));
								}
							}
						}else if ("items4".equalsIgnoreCase(cd.getNodeName()))
						{
							attrs = cd.getAttributes();
							_config.TIME_TRANS_3 = Integer.parseInt(attrs.getNamedItem("time").getNodeValue());
							
							
							for (Node ccd = cd.getFirstChild(); ccd != null; ccd = ccd.getNextSibling()) 
							{
								if ("item".equalsIgnoreCase(ccd.getNodeName()))
								{
									attrs = ccd.getAttributes();
									_config.ITEMS4.put(Integer.parseInt(attrs.getNamedItem("val").getNodeValue()), Integer.parseInt(attrs.getNamedItem("count").getNodeValue()));
								}
							}
						}
						
					}
					_configs.add(_config);
				}
			}

			_configs.sort();
			_log.info("Loaded " + _configs.size() + " configs for Transform Class event.");
		}
		catch (Exception e)
		{
			_log.log(Level.SEVERE, "Error parsing TC.xml, by error: ", e);
		}
	}
}