package l2ft.database;

import java.sql.SQLException;
import java.util.ArrayList;
import l2ft.Config;

public class DatabaseConnectionProperties
{
	public final String URL;
	public final String Login;
	public final String Password;
	public final L2DatabaseFactory instance;
	private static ArrayList<DatabaseConnectionProperties> allConnectionProperties = new ArrayList<DatabaseConnectionProperties>();

	private DatabaseConnectionProperties(String aURL, String aLogin, String aPassword) throws SQLException
	{
		URL = aURL;
		Login = aLogin;
		Password = aPassword;
		instance = new L2DatabaseFactory(aURL, aLogin, aPassword, Config.DATABASE_MAX_CONNECTIONS, Config.DATABASE_MAX_IDLE_TIMEOUT);
	}

	public static synchronized DatabaseConnectionProperties InitConnectionProperties(String aURL, String aLogin, String aPassword) throws SQLException
	{
		for (DatabaseConnectionProperties c : allConnectionProperties)
		{
			if ((c.URL.equals(aURL)) && (c.Login.equals(aLogin)) && (c.Password.equals(aPassword)))
			return c;
		}
		DatabaseConnectionProperties ret = new DatabaseConnectionProperties(aURL, aLogin, aPassword);
		allConnectionProperties.add(ret);
		return ret;
	}
}