package l2ft.extensions.listeners;

import l2ft.extensions.listeners.events.MethodEvent;
import l2ft.extensions.listeners.events.L2Zone.L2TerritoryEnterLeaveEvent;
import l2ft.gameserver.model.L2Object;
import l2ft.gameserver.model.L2Territory;

public abstract class L2TerritoryEnterLeaveListener implements MethodInvokeListener, MethodCollection
{
	@Override
	public final void methodInvoked(MethodEvent e)
	{
		L2TerritoryEnterLeaveEvent event = (L2TerritoryEnterLeaveEvent) e;
		L2Territory owner = event.getOwner();
		L2Object actor = event.getArgs()[0];
		String methodName = event.getMethodName();
		if (methodName.equals("L2Territory.doEnter"))
			objectEntered(owner, actor);
		else
			objectLeaved(owner, actor);
	}

	@Override
	public final boolean accept(MethodEvent event)
	{
		String methodName = event.getMethodName();
		return (methodName.equals("L2Territory.doEnter")) || (methodName.equals("L2Territory.doLeave"));
	}

	public abstract void objectEntered(L2Territory paramL2Territory, L2Object paramL2Object);

	public abstract void objectLeaved(L2Territory paramL2Territory, L2Object paramL2Object);
}