package l2ft.gameserver.clientpackets;

import l2ft.Config;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.network.L2GameClient;
import l2ft.gameserver.network.L2GameClient.GameClientState;
import l2ft.gameserver.serverpackets.CharSelected;
import l2ft.util.AutoBan;

public class CharacterSelected extends L2GameClientPacket
{
	private int _charSlot;

	/**
	 * Format: cdhddd
	 */
	@Override
	public void readImpl()
	{
		_charSlot = readD();
	}

	@Override
	public void runImpl()
	{
		L2GameClient client = getClient();

		
		if (Config.SECOND_AUTH_ENABLED && !client.getSecondaryAuth().isAuthed())
		{
			client.getSecondaryAuth().openDialog();
			return;
		}
		
		
		if(client.getActiveChar() != null)
			return;

		L2Player activeChar = client.loadCharFromDisk(_charSlot);
		if(activeChar == null)
			return;
		if(Config.SERVER_GMONLY && !activeChar.isGM())
		{
			activeChar.logout(false, false, true, true);
			return;
		}
		
		if(AutoBan.isBanned(activeChar.getObjectId()))
		{
			activeChar.setAccessLevel(-100);
			activeChar.logout(false, false, true, true);
			return;
		}

		if(activeChar.getAccessLevel() < 0)
			activeChar.setAccessLevel(0);

		client.setState(GameClientState.IN_GAME);

		sendPacket(new CharSelected(activeChar, client.getSessionId().playOkID1));
	}
}