package l2ft.gameserver.clientpackets;

import l2ft.gameserver.instancemanager.ItemAuctionManager;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.itemauction.ItemAuction;
import l2ft.gameserver.itemauction.ItemAuctionInstance;
import l2ft.gameserver.model.items.PcInventory;

public final class RequestBidItemAuction extends L2GameClientPacket
{
    private int _instanceId;
    private long _bid;

	@Override
    protected final void readImpl()
    {
		_instanceId = super.readD();
		_bid = super.readQ();
    }

	@Override
    protected final void runImpl()
    {
        final L2Player activeChar = getClient().getActiveChar();
        if(activeChar == null)
            return;

        if(_bid < 0 || _bid > PcInventory.MAX_ADENA)
            return;

        final ItemAuctionInstance instance = ItemAuctionManager.getInstance().getManagerInstance(_instanceId);
        if(instance != null)
        {
            final ItemAuction auction = instance.getCurrentAuction();
            if(auction != null)
                auction.registerBid(activeChar, _bid);
        }
    }

	@Override
	public final String getType()
	{
		return "[C] D0:39 RequestBidItemAuction";
	}
}