package l2ft.gameserver.clientpackets;

import l2ft.gameserver.cache.Msg;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.serverpackets.ExSetPartyLooting;
import l2ft.gameserver.serverpackets.SystemMessage;

public class RequestExPartyLootingModifyAgreement extends L2GameClientPacket
{
	private int _answer;

	public void readImpl()
	{
		_answer = readD();
	}

	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if (activeChar == null || activeChar.getParty() == null)
		return;

		if (activeChar.getParty()._lootVoteType == -1 || activeChar.getParty()._accepted == null)
			return;

		if (_answer == 0)
		{
			activeChar.getParty().broadcastToPartyMembers(Msg.PARTY_LOOT_CHANGE_WAS_CANCELLED, new ExSetPartyLooting(0, activeChar.getParty().getLootDistribution()));
			activeChar.getParty()._accepted = null;
			activeChar.getParty()._lootVoteType = -1;
		}
		else
		{
			activeChar.getParty()._accepted.add(activeChar.getStoredId());

			if (activeChar.getParty()._accepted.size() == activeChar.getParty().getMemberCount() - 1)
			{
				activeChar.getParty().broadcastToPartyMembers(new SystemMessage(3138).addNumber(Integer.valueOf(activeChar.getParty()._lootVoteType)), new ExSetPartyLooting(1, activeChar.getParty()._lootVoteType));
				activeChar.getParty().setLootDistribution(activeChar.getParty()._lootVoteType);
				activeChar.getParty()._accepted = null;
				activeChar.getParty()._lootVoteType = -1;
			}
		}
	}
}