package l2ft.gameserver.clientpackets;

import l2ft.gameserver.instancemanager.ItemAuctionManager;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.itemauction.ItemAuction;
import l2ft.gameserver.itemauction.ItemAuctionInstance;
import l2ft.gameserver.serverpackets.ExItemAuctionInfoPacket;

public final class RequestInfoItemAuction extends L2GameClientPacket
{
	private int _instanceId;
	
	@Override
    protected final void readImpl()
    {
        _instanceId = super.readD();
    }	
	
	@Override
    protected void runImpl()
    {
        final L2Player activeChar = getClient().getActiveChar();
        if(activeChar == null)
            return;
			
        final ItemAuctionInstance instance = ItemAuctionManager.getInstance().getManagerInstance(_instanceId);
        if(instance == null)
            return;
			
        final ItemAuction auction = instance.getCurrentAuction();
        if(auction == null)
            return;
		
		activeChar.updateLastItemAuctionRequest();
		activeChar.sendPacket(new ExItemAuctionInfoPacket(true, auction, instance.getNextAuction()));
    }
	
	@Override
	public final String getType()
	{
		return "[C] D0:3A RequestInfoItemAuction";
	}
}