package l2ft.gameserver.clientpackets;

import l2ft.Config;
import l2ft.extensions.multilang.CustomMessage;
import l2ft.gameserver.model.L2Party;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.Reflection;
import l2ft.gameserver.model.entity.DimensionalRift;

public class RequestOustPartyMember extends L2GameClientPacket
{
	//Format: cS
	private String _name;

	@Override
	public void readImpl()
	{
		_name = readS(Config.CNAME_MAXLEN);
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		L2Party party = activeChar.getParty();
		if(party != null && party.isLeader(activeChar))
		{
			if(activeChar.isInOlympiadMode())
			{
				activeChar.sendMessage("Вы не можете сейчас выйти из группы.");
				return;
			}
			Reflection r = party.getReflection();
			L2Player oustPlayer = party.getPlayerByName(_name);
			if(r != null && r instanceof DimensionalRift && oustPlayer != null && oustPlayer.getReflection().equals(r))
				activeChar.sendMessage(new CustomMessage("l2ft.gameserver.clientpackets.RequestOustPartyMember.CantOustInRift", activeChar));
			else if(r != null && !(r instanceof DimensionalRift))
				activeChar.sendMessage(new CustomMessage("l2ft.gameserver.clientpackets.RequestOustPartyMember.CantOustInDungeon", activeChar));
			else
				party.oustPartyMember(_name);
		}
	}
}