package l2ft.gameserver.clientpackets;

import l2ft.gameserver.cache.Msg;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.items.L2PremiumItem;
import l2ft.gameserver.serverpackets.ExGetPremiumItemList;
import l2ft.gameserver.serverpackets.L2GameServerPacket;

public final class RequestWithDrawPremiumItem extends L2GameClientPacket
{
	private int _itemNum;
	private int _charObjId;
	private long _itemcount;

	protected void readImpl()
	{
		_itemNum = readD();
		_charObjId = readD();
		_itemcount = readQ();
	}

	protected void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();

		if (activeChar == null || _itemcount <= 0)
			return;

		if (activeChar.getObjectId() != _charObjId || activeChar.getInventory().getPremiumItemList().isEmpty())
			return;

		if (activeChar.getWeightPenalty() >= 3 || !activeChar.isQuestContinuationPossible(false))
		{
			activeChar.sendPacket(Msg.YOU_CANNOT_RECEIVE_THE_VITAMIN_ITEM_BECAUSE_YOU_HAVE_EXCEED_YOUR_INVENTORY_WEIGHT_QUANTITY_LIMIT);
			return;
		}

		if (activeChar.isInTransaction())
		{
			activeChar.sendPacket(new L2GameServerPacket[] { Msg.YOU_CANNOT_RECEIVE_A_VITAMIN_ITEM_DURING_AN_EXCHANGE });
			return;
		}

		L2PremiumItem item = activeChar.getInventory().getPremiumItemList().get(_itemNum);

		if (item == null || item.getCount() < _itemcount)
			return;

		activeChar.getInventory().addItem(item.getItemId(), _itemcount);

		if (_itemcount < item.getCount())
		{
			(activeChar.getInventory().getPremiumItemList().get(_itemNum)).updateCount(item.getCount() - _itemcount);
			activeChar.getInventory().updatePremiumItem(_itemNum, item.getCount() - _itemcount);
		}
		else
		{
			activeChar.getInventory().getPremiumItemList().remove(Integer.valueOf(_itemNum));
			activeChar.getInventory().deletePremiumItem(_itemNum);
		}

		if (activeChar.getInventory().getPremiumItemList().isEmpty())
			activeChar.sendPacket(Msg.THERE_ARE_NO_MORE_VITAMIN_ITEMS_TO_BE_FOUND);
		else
			activeChar.sendPacket(new ExGetPremiumItemList(activeChar));
  }
}