package l2ft.gameserver.communitybbs;

import java.util.HashMap;
import java.util.StringTokenizer;

import javolution.text.TextBuilder;
import l2ft.Config;
import l2ft.extensions.multilang.CustomMessage;
import l2ft.gameserver.TradeController;
import l2ft.gameserver.cache.Msg;
import l2ft.gameserver.communitybbs.Manager.AuctionBBSManager;
import l2ft.gameserver.communitybbs.Manager.BuffBBSManager;
import l2ft.gameserver.communitybbs.Manager.ClanBBSManager;
import l2ft.gameserver.communitybbs.Manager.ClassBBSManager;
import l2ft.gameserver.communitybbs.Manager.EnchantBBSManager;
import l2ft.gameserver.communitybbs.Manager.FailBBSManager;
import l2ft.gameserver.communitybbs.Manager.FavBBSManager;
import l2ft.gameserver.communitybbs.Manager.FriendsBBSManager;
import l2ft.gameserver.communitybbs.Manager.LinkBBSManager;
import l2ft.gameserver.communitybbs.Manager.MailBBSManager;
import l2ft.gameserver.communitybbs.Manager.PostBBSManager;
import l2ft.gameserver.communitybbs.Manager.RegionBBSManager;
import l2ft.gameserver.communitybbs.Manager.SmsBBSManager;
import l2ft.gameserver.communitybbs.Manager.StatBBSManager;
import l2ft.gameserver.communitybbs.Manager.TeleportBBSManager;
import l2ft.gameserver.communitybbs.Manager.TopBBSManager;
import l2ft.gameserver.communitybbs.Manager.TopicBBSManager;
import l2ft.gameserver.model.L2Multisell;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.base.Experience;
import l2ft.gameserver.model.entity.Hero;
import l2ft.gameserver.model.entity.olympiad.Olympiad;
import l2ft.gameserver.model.instances.L2NpcInstance;
import l2ft.gameserver.model.items.L2ItemInstance;
import l2ft.gameserver.network.L2GameClient;
import l2ft.gameserver.serverpackets.ExBuySellList;
import l2ft.gameserver.serverpackets.L2GameServerPacket;
import l2ft.gameserver.serverpackets.ShowBoard;
import l2ft.gameserver.serverpackets.SkillList;
import l2ft.gameserver.serverpackets.SocialAction;
import l2ft.gameserver.tables.NpcTable;
import l2ft.gameserver.tables.SkillTable;
import l2ft.gameserver.templates.L2Item;
import l2ft.gameserver.templates.L2NpcTemplate;
import l2ft.gameserver.templates.StatsSet;
import l2ft.gameserver.xml.ItemTemplates;
import l2ft.util.Files;
import l2ft.util.GArray;

public class CommunityBoard
{
	private static CommunityBoard _instance;
	private static int MONEY_ID = 4357;

	public static CommunityBoard getInstance()
	{
		if (_instance == null)
			_instance = new CommunityBoard();
		return _instance;
	}

	public void handleCommands(L2GameClient client, String command)
	{
		L2Player activeChar = client.getActiveChar();
		if (activeChar == null)
			return;

		if (!Config.ALLOW_COMMUNITYBOARD)
		{
			activeChar.sendPacket(Msg.THE_COMMUNITY_SERVER_IS_CURRENTLY_OFFLINE);
			return;
		}

		if(!Config.ALLOW_COMMUNITYBOARD_IN_COMBAT && activeChar.isInCombat())
		{
			activeChar.sendMessage(new CustomMessage("l2ft.gameserver.communitybbs.NotUse", activeChar));
			return;
		}

		if (!Config.ALLOW_COMMUNITYBOARD_IN_ABNORMAL_STATE)
		{
			if (activeChar.isDead() || activeChar.isAlikeDead() || activeChar.isCastingNow() || activeChar.isInCombat() || activeChar.isAttackingNow() || activeChar.isInOlympiadMode() || activeChar.isInVehicle() || activeChar.isFlying() || activeChar.isInFlyingTransform())
			{
				FailBBSManager.getInstance().parsecmd(command, activeChar);
				return;
			}
		}

		if (command.startsWith("_bbsclan"))
			ClanBBSManager.getInstance().parsecmd(command, activeChar);
		else if (command.startsWith("_bbsmemo"))
			TopicBBSManager.getInstance().parsecmd(command, activeChar);
		else if (command.startsWith("_bbstopics"))
			TopicBBSManager.getInstance().parsecmd(command, activeChar);
		else if (command.startsWith("_bbsposts"))
			PostBBSManager.getInstance().parsecmd(command, activeChar);
		else if (command.startsWith("_bbstop"))
			TopBBSManager.getInstance().parsecmd(command, activeChar);
		else if (command.startsWith("_bbshome"))
			TopBBSManager.getInstance().parsecmd(command, activeChar);
		else if (command.startsWith("_bbsloc"))
			RegionBBSManager.getInstance().parsecmd(command, activeChar);
		else if (command.startsWith("_friend") || command.startsWith("_block"))
			FriendsBBSManager.getInstance().parsecmd(command, activeChar);
		else if (command.startsWith("_bbsauction"))
			AuctionBBSManager.getInstance().parsecmd(command, activeChar);
		else if (command.startsWith("_bbsgetfav"))
			FavBBSManager.getInstance().parsecmd(command, activeChar);
		else if (command.startsWith("_bbslink"))
			LinkBBSManager.getInstance().parsecmd(command, activeChar);
		else if(command.startsWith("_maillist")) 
		    MailBBSManager.getInstance().parsecmd(command, activeChar);
		else if (command.startsWith("_bbsteleport;"))
		{
			if (!Config.ALLOW_COMMUNITYBOARD_TELEPORT)
			{
				FailBBSManager.getInstance().parsecmd(command, activeChar);
				return;
			}

			TeleportBBSManager.getInstance().parsecmd(command, activeChar);
		}
		else if (command.startsWith("_bbsechant"))
		{
			if (!Config.ALLOW_COMMUNITYBOARD_ENCHANT)
			{
				FailBBSManager.getInstance().parsecmd(command, activeChar);
				return;
			}

			EnchantBBSManager.getInstance().parsecmd(command, activeChar);
		}
		else if (command.startsWith("_bbsclass"))
		{
			if (!Config.ALLOW_COMMUNITYBOARD_CLASS_MASTER)
			{
				FailBBSManager.getInstance().parsecmd(command, activeChar);
				return;
			}

			ClassBBSManager.getInstance().parsecmd(command, activeChar);
		}
		else if (command.startsWith("_bbssms;"))
			SmsBBSManager.getInstance().parsecmd(command, activeChar);
		else if (command.startsWith("_bbsbuff;"))
			BuffBBSManager.getInstance().parsecmd(command, activeChar);
		else if (command.startsWith("_bbsstat;"))
			StatBBSManager.getInstance().parsecmd(command, activeChar);
		else if (command.startsWith("_bbsmultisell;"))
		{
			StringTokenizer st = new StringTokenizer(command, ";");
			st.nextToken();
			TopBBSManager.getInstance().parsecmd("_bbstop;" + st.nextToken(), activeChar);
			L2Multisell.getInstance().SeparateAndSend(Integer.parseInt(st.nextToken()), activeChar, 0);
		}
		else if(command.startsWith("_bbssell;"))
		{
			L2NpcTemplate temp = NpcTable.getTemplate(32);
			activeChar.setLastNpc(new L2NpcInstance(32, temp));
			TradeController.NpcTradeList list = TradeController.getInstance().getBuyList(-1);
			activeChar.sendPacket(new L2GameServerPacket[] { new ExBuySellList(list, activeChar, 0) }); 
		}
		else if (command.startsWith("_bbsscripts;"))
		{
			StringTokenizer st = new StringTokenizer(command, ";");
			st.nextToken();
			TopBBSManager.getInstance().parsecmd("_bbstop;" + st.nextToken(), activeChar);

			String com = st.nextToken();
			String[] word = com.split("\\s+");
			String[] args = com.substring(word[0].length()).trim().split("\\s+");
			String[] path = word[0].split(":");
			if (path.length != 2)
			{
				System.out.println("Bad Script bypass!");
				return;
			}

			HashMap<String, Object> variables = new HashMap<String, Object>();
			variables.put("npc", null);
			activeChar.callScripts(path[0], path[1], word.length == 1 ? new Object[] {} : new Object[] { args }, variables);
		}
		else if (command.startsWith("_bbsscripts_ret;"))
		{
			StringTokenizer st = new StringTokenizer(command, ";");
			st.nextToken();
			String page = st.nextToken();

			String com = st.nextToken();
			String[] word = com.split("\\s+");
			String[] args = com.substring(word[0].length()).trim().split("\\s+");
			String[] path = word[0].split(":");
			if (path.length != 2)
			{
				System.out.println("Bad Script bypass!");
				return;
			}
			HashMap<String, Object> variables = new HashMap<String, Object>();
			variables.put("npc", null);
			Object subcontent = activeChar.callScripts(path[0], path[1], word.length == 1 ? new Object[] {} : new Object[] { args }, variables);

			TopBBSManager.getInstance().showTopPage(activeChar, page, String.valueOf(subcontent));
		}
		else if (command.startsWith("_bbssps;"))
		{
			int price = 1;
			L2Item item = ItemTemplates.getInstance().getTemplate(4357);
			L2ItemInstance pay = activeChar.getInventory().getItemByItemId(item.getItemId());
			if (pay != null && pay.getCount() >= price)
			{
				activeChar.getInventory().destroyItem(pay, price, true);
				activeChar.setSp(activeChar.getSp() + 10000000);
				activeChar.sendMessage(new CustomMessage("l2ft.gameserver.communitybbs.OnSp", activeChar));
				activeChar.broadcastPacket(new SocialAction(activeChar.getObjectId(), 16));
				activeChar.broadcastUserInfo(true);
			}
			else
				activeChar.sendMessage(new CustomMessage("l2ft.gameserver.communitybbs.NoMani", activeChar));
		}
		else if (command.startsWith("_bbsspa;"))
		{
			int price = 100000000;
			L2Item item = ItemTemplates.getInstance().getTemplate(57);
			L2ItemInstance pay = activeChar.getInventory().getItemByItemId(item.getItemId());
			if (pay != null && pay.getCount() >= price)
			{
				activeChar.getInventory().destroyItem(pay, price, true);
				activeChar.setSp(activeChar.getSp() + 10000000);
				activeChar.sendMessage(new CustomMessage("l2ft.gameserver.communitybbs.OnSp", activeChar));
				activeChar.broadcastPacket(new SocialAction(activeChar.getObjectId(), 16));
				activeChar.broadcastUserInfo(true);
			}
			else
				activeChar.sendMessage(new CustomMessage("l2ft.gameserver.communitybbs.NoMani", activeChar));
		}
		else if (command.startsWith("_bbsnobles;"))
		{
			if (!activeChar.isNoble())
			{
				if (!checkCondition(activeChar, 30))
					return;

				if (activeChar.getSubLevel() < 75)
				{
					activeChar.sendMessage(new CustomMessage("l2ft.gameserver.communitybbs.NoNobles", activeChar));
					return;
				}

				L2Item item = ItemTemplates.getInstance().getTemplate(MONEY_ID);
				L2ItemInstance pay = activeChar.getInventory().getItemByItemId(item.getItemId());
				if (pay != null && pay.getCount() >= 30)
				{
					activeChar.getInventory().destroyItem(pay, 30, true);

					Olympiad.addNoble(activeChar);
					activeChar.setNoble(true);
					activeChar.broadcastPacket(new SocialAction(activeChar.getObjectId(), 3));
					activeChar.updatePledgeClass();
					activeChar.updateNobleSkills();
					activeChar.sendPacket(new SkillList(activeChar));
					activeChar.broadcastUserInfo(true);
				}
				else
					activeChar.sendMessage(new CustomMessage("l2ft.gameserver.communitybbs.NoNobles", activeChar));
			}
			else
				activeChar.sendMessage(new CustomMessage("l2ft.gameserver.communitybbs.OnNobles", activeChar));
		}
		else if (command.equals("_bbslvlup"))
		{
			String name = "None Name";
			name = ItemTemplates.getInstance().getTemplate(Config.COMMUNITYBOARD_LVL_UP_ITEM).getName();
			TextBuilder sb = new TextBuilder();
			sb.append("<html><body><br><br><center>");
			sb.append(new StringBuilder("Поднять Lvl за: <font color=\"LEVEL\">" + name + "</font>"));
			sb.append("<img src=\"l2ui.squaregray\" width=\"170\" height=\"1\">");
			if (activeChar.isSubClassActive())
			{			
				for(int i = 0; i < Config.COMMUNITYBOARD_SUB_LVL_UP.length; i++)
				{
					if(activeChar.getLevel() < Config.COMMUNITYBOARD_SUB_LVL_UP[i])
					{
						sb.append(new StringBuilder("<button value=\"Поднять Lvl до: " + Config.COMMUNITYBOARD_SUB_LVL_UP[i] + " (Цена:" + Config.COMMUNITYBOARD_SUB_LVL_UP_PRICE[i] + " " + name + ") \" action=\"bypass -h _bbslvlup;up;" + Config.COMMUNITYBOARD_SUB_LVL_UP[i] + ";" + Config.COMMUNITYBOARD_SUB_LVL_UP_PRICE[i] + "\" width=300 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">"));
						sb.append("<br1>");
					}
				}
			}
			else
			{
				for(int i = 0; i < Config.COMMUNITYBOARD_LVL_UP.length; i++)
				{
					if(activeChar.getLevel() < Config.COMMUNITYBOARD_LVL_UP[i])
					{
						sb.append(new StringBuilder("<button value=\"Поднять Lvl до: " + Config.COMMUNITYBOARD_LVL_UP[i] + " (Цена:" + Config.COMMUNITYBOARD_LVL_UP_PRICE[i] + " " + name + ") \" action=\"bypass -h _bbslvlup;up;" + Config.COMMUNITYBOARD_LVL_UP[i] + ";" + Config.COMMUNITYBOARD_LVL_UP_PRICE[i] + "\" width=300 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">"));
						sb.append("<br1>");
					}
				}
			}
			sb.append("</center><br><br></body></html>");
			String content = Files.read("data/html/CommunityBoardPVP/805.htm", activeChar);
			content = content.replace("%lvlup%", sb.toString());
			ShowBoard.separateAndSend(content, activeChar);
		}
		else if (command.startsWith("_bbslvlup;up;"))
		{
			StringTokenizer st = new StringTokenizer(command, ";");
			st.nextToken();
			st.nextToken();
			int level = Integer.parseInt(st.nextToken());
			int count = Integer.parseInt(st.nextToken());

			L2Item item = ItemTemplates.getInstance().getTemplate(Config.COMMUNITYBOARD_LVL_UP_ITEM);
			L2ItemInstance pay = activeChar.getInventory().getItemByItemId(item.getItemId());
			if (pay != null && pay.getCount() >= count)
			{
				activeChar.getInventory().destroyItem(pay, count, true);
				setLevel(activeChar, level);
			}
			else
				activeChar.sendPacket(Msg.INCORRECT_ITEM_COUNT);
		}
		else if (command.startsWith("_recoveryVitality"))
		{
			L2Item item = ItemTemplates.getInstance().getTemplate(Config.COMMUNITYBOARD_RECOVERY_VITALITY_ITEM);
			L2ItemInstance pay = activeChar.getInventory().getItemByItemId(item.getItemId());
			if (pay != null && pay.getCount() >= Config.COMMUNITYBOARD_RECOVERY_VITALITY_PRICE)
			{
				activeChar.getInventory().destroyItem(pay, Config.COMMUNITYBOARD_RECOVERY_VITALITY_PRICE, true);
				activeChar.setVitality(20000);
			}
			else
				activeChar.sendPacket(Msg.INCORRECT_ITEM_COUNT);
		}
		else if (command.startsWith("_recoveryPK"))
		{
			L2Item item = ItemTemplates.getInstance().getTemplate(Config.COMMUNITYBOARD_WASH_PK_ITEM);
			L2ItemInstance pay = activeChar.getInventory().getItemByItemId(item.getItemId());
			if (pay != null && pay.getCount() >= Config.COMMUNITYBOARD_WASH_PK_PRICE)
			{
				if (activeChar.getPkKills()>0)
				{
					activeChar.getInventory().destroyItem(pay, Config.COMMUNITYBOARD_WASH_PK_PRICE, true);
					activeChar.setKarma(0);
					activeChar.setPkKills(activeChar.getPkKills() - 1);
					activeChar.altUseSkill(SkillTable.getInstance().getInfo(21006, 1), activeChar);
					activeChar.broadcastUserInfo(true);
				}
				else 
				{
					activeChar.sendMessage(new CustomMessage("l2ft.gameserver.communitybbs.NoService", activeChar));
					return;
				}
			}
				else
					activeChar.sendPacket(Msg.INCORRECT_ITEM_COUNT);
		}
		else if (command.equals("_bbshero"))
		{
			String name = "None Name";
			name = ItemTemplates.getInstance().getTemplate(Config.COMMUNITYBOARD_HERO_ITEM).getName();
			TextBuilder sb = new TextBuilder();
			sb.append("<html><body><br><br><center>");
			sb.append("Купить статус Героя за: <font color=\"LEVEL\">" + name + "</font>");
			sb.append("<img src=\"l2ui.squaregray\" width=\"170\" height=\"1\">");
			sb.append(new StringBuilder("<button value=\"Купить статус Героя за: " + Config.COMMUNITYBOARD_HERO_ITEM_PRICE+ " " + name + " \" action=\"bypass -h _bbshero;set\" width=300 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">"));
			sb.append("<br1>");
			sb.append("</center><br><br></body></html>");
			String content = Files.read("data/html/CommunityBoardPVP/806.htm", activeChar);
			content = content.replace("%sethero%", sb.toString());
			ShowBoard.separateAndSend(content, activeChar);
		}
		else if (command.startsWith("_bbshero;set"))
		{
			int count = Config.COMMUNITYBOARD_HERO_ITEM_PRICE;

			L2Item item = ItemTemplates.getInstance().getTemplate(Config.COMMUNITYBOARD_HERO_ITEM);
			L2ItemInstance pay = activeChar.getInventory().getItemByItemId(item.getItemId());
			if (pay != null && pay.getCount() >= count)
			{
				activeChar.getInventory().destroyItem(pay, count, true);
				StatsSet hero = new StatsSet();
				hero.set("class_id", activeChar.getBaseClassId());
				hero.set("char_id", activeChar.getObjectId());
				hero.set("char_name", activeChar.getName());

				GArray<StatsSet> heroesToBe = new GArray<StatsSet>();
				heroesToBe.add(hero);
				Hero.getInstance().computeNewHeroes(heroesToBe);
				
				activeChar.setHero(true);
				activeChar.addSkill(SkillTable.getInstance().getInfo(395, 1));
				activeChar.addSkill(SkillTable.getInstance().getInfo(396, 1));
				activeChar.addSkill(SkillTable.getInstance().getInfo(1374, 1));
				activeChar.addSkill(SkillTable.getInstance().getInfo(1375, 1));
				activeChar.addSkill(SkillTable.getInstance().getInfo(1376, 1));
				activeChar.sendPacket(new SkillList(activeChar));
				if(activeChar.isHero())
					activeChar.broadcastPacket(new SocialAction(activeChar.getObjectId(), 16));
				activeChar.broadcastUserInfo(true);
			}
			else
				activeChar.sendPacket(Msg.INCORRECT_ITEM_COUNT);
		}
		else
		{
			ShowBoard.separateAndSend("<html><body><br><br><center>Функция: " + command + " пока не реализована</center><br><br></body></html>", activeChar);
		}
	}

	private void setLevel(L2Player activeChar, int level)
	{
		Long exp_add = Experience.LEVEL[level] - activeChar.getExp();
		activeChar.addExpAndSp(exp_add, 0, false, false);
	}

	public static boolean checkCondition(L2Player activeChar, int CoinCount)
	{
		synchronized (activeChar)
		{
			L2ItemInstance Coin = activeChar.getInventory().getItemByItemId(MONEY_ID);

			if (activeChar.isSitting())
				return false;
			if (Coin.getCount() < CoinCount)
			{
				activeChar.sendMessage(new CustomMessage("l2ft.gameserver.communitybbs.NoMani", activeChar));
				return false;
			}

			return true;
		}
	}

	public void handleWriteCommands(L2GameClient client, String url, String arg1, String arg2, String arg3, String arg4, String arg5)
	{
		L2Player activeChar = client.getActiveChar();
		if (activeChar == null)
			return;
		if (!Config.ALLOW_COMMUNITYBOARD)
		{
			activeChar.sendPacket(Msg.THE_COMMUNITY_SERVER_IS_CURRENTLY_OFFLINE);
			return;
		}

		if (url.equals("Topic"))
			TopicBBSManager.getInstance().parsewrite(arg1, arg2, arg3, arg4, arg5, activeChar);
		else if (url.equals("Post"))
			PostBBSManager.getInstance().parsewrite(arg1, arg2, arg3, arg4, arg5, activeChar);
		else if (url.equals("Region"))
			RegionBBSManager.getInstance().parsewrite(arg1, arg2, arg3, arg4, arg5, activeChar);
		else if (url.equals("Notice"))
		{
			if (arg4.length() > 512)
			{
				ShowBoard.separateAndSend("<html><body><br><br><center>Вы ввели слишком длинное сообщение, оно будет сохранено не полностью.</center><br><br></body></html>", activeChar);
				return;
			}
			ClanBBSManager.getInstance().parsewrite(arg1, arg2, arg3, arg4, arg5, activeChar);
		}
		else if(url.equals("Mail")) 
		    MailBBSManager.getInstance().parsewrite(arg1, arg2, arg3, arg4, arg5, activeChar);
		else
			ShowBoard.separateAndSend("<html><body><br><br><center>Функция: " + url + " пока не реализована</center><br><br></body></html>", activeChar);
	}
}