package l2ft.gameserver.communitybbs.Manager;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.logging.Logger;

import javolution.text.TextBuilder;
import l2ft.Config;
import l2ft.gameserver.model.L2Player;
import l2ft.util.Files;

public class LinkBBSManager extends BaseBBSManager
{
	private static Logger _log = Logger.getLogger(LinkBBSManager.class.getName());

	private static String IPB_SQL_QUERRY = "";
	private static String VBULLETIN_SQL_QUERRY = "";
	private static String PHPBB_SQL_QUERRY = "";
	private static String SMF_SQL_QUERRY = "";

	public static LinkBBSManager getInstance()
	{
		return SingletonHolder._instance;
	}

	@Override
	public void parsecmd(String command, L2Player player)
	{
		switch(Config.CB_EXTERNAL_FORUM_TYPE)
		{
			case 1:
				//IPB_SQL_QUERRY = "SELECT t.*, p.* FROM " + Config.CB_EXTERNAL_FORUM_DB_PREFIX + "topics t LEFT JOIN " + Config.CB_EXTERNAL_FORUM_DB_PREFIX + "posts p ON (p.topic_id=t.tid AND p.post_date >= t.last_post-30) WHERE t.state != 'closed' AND t.approved=1 AND t.last_poster_id <> 0 ORDER BY t.last_post DESC LIMIT " + Config.CB_EXTERNAL_FORUM_TOPICS_COUNT;
				IPB_SQL_QUERRY = "SELECT * FROM " + Config.CB_EXTERNAL_FORUM_DB_PREFIX + "topics WHERE state != 'closed' AND approved=1 AND last_poster_id <> 0 ORDER BY last_post DESC LIMIT " + Config.CB_EXTERNAL_FORUM_TOPICS_COUNT;
				break;
			case 2:
				VBULLETIN_SQL_QUERRY = "";
				break;
			case 3:
				PHPBB_SQL_QUERRY = "";
				break;
			case 4:
				SMF_SQL_QUERRY = "";
				break;
		}

		Connection conn = null;

		long startDate;
		String topicTitle;
		String starterName;
		int topicViews;
		int topicPosts;

		TextBuilder html = new TextBuilder();

		try
		{
			conn = DriverManager.getConnection(Config.CB_EXTERNAL_FORUM_DB_URL + "?" + "user=" + Config.CB_EXTERNAL_FORUM_DB_LOGIN + "&password=" + Config.CB_EXTERNAL_FORUM_DB_PASSWOD);
			final PreparedStatement prepareStatement = conn.prepareStatement(IPB_SQL_QUERRY);
			final ResultSet rset = prepareStatement.executeQuery();
			while(rset.next())
			{
				startDate = rset.getLong("start_date");
				topicTitle = rset.getString("title");
				starterName = rset.getString("starter_name");
				topicViews = rset.getInt("views");
				topicPosts = rset.getInt("posts");
				try
				{
					String date = new java.text.SimpleDateFormat("dd/MM/yyyy").format(new java.util.Date(startDate * 1000));

					html.append("<tr>");
					html.append("<td width=90 valign=\"top\" align=\"center\">" + date + "</td>");
					html.append("<td width=363 valign=\"top\">" + topicTitle.replaceAll("\\p{XDigit}", "").replaceAll("\\p{Punct}", "") + " ..." + "</td>");
					html.append("<td width=80 valign=\"top\" align=\"center\">" + starterName + "</td>");
					html.append("<td width=110 valign=\"top\" align=\"center\">" + topicViews + "</td>");
					html.append("<td width=80 valign=\"top\" align=\"center\">" + topicPosts + "</td>");
					html.append("</tr>");
					html.append("<img src=L2UI.SquareWhite width=722 height=1>");
				}
				catch(final Exception e)
				{
					_log.warning("Error reading forum data: " + e);
				}

				String content = Files.read(Config.COMMUNITYBOARD_HTML_ROOT + "links.htm", player);
				content = content.replace("%forum_links%", html.toString());
				separateAndSend(content, player);
			}
			rset.close();
			prepareStatement.close();
		}
		catch(final SQLException ex)
		{
			_log.warning("SQLException: " + ex.getMessage());
			_log.warning("SQLState: " + ex.getSQLState());
			_log.warning("VendorError: " + ex.getErrorCode());
			html.append("<tr>");
			html.append("<td width=723 height=200 valign=\"top\" align=\"center\" colspan=5>404 Not found</td>");
			html.append("</tr>");
			html.append("<img src=L2UI.SquareWhite width=722 height=1>");
			String content = Files.read(Config.COMMUNITYBOARD_HTML_ROOT + "links.htm", player);
			content = content.replace("%forum_links%", html.toString());
			separateAndSend(content, player);
			return;
		}
		catch(final Exception ex)
		{
			_log.warning("Exception: " + ex);
		}
		finally
		{
			try
			{
				if(conn != null)
				{
					conn.commit();
					conn.close();
				}
			}
			catch(final SQLException e)
			{}
		}
	}

	@Override
	public void parsewrite(String ar1, String ar2, String ar3, String ar4, String ar5, L2Player player)
	{}

	private static class SingletonHolder
	{
		protected static final LinkBBSManager _instance = new LinkBBSManager();
	}
}