package l2ft.gameserver.communitybbs.Manager;

import java.sql.Date;
import java.sql.ResultSet;
import java.text.SimpleDateFormat;
import java.util.StringTokenizer;

import javolution.text.TextBuilder;
import l2ft.Config;
import l2ft.database.DatabaseUtils;
import l2ft.database.FiltredPreparedStatement;
import l2ft.database.L2DatabaseFactory;
import l2ft.database.ThreadConnection;
import l2ft.extensions.scripts.Functions;
import l2ft.gameserver.instancemanager.CastleManager;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.serverpackets.ShowBoard;
import l2ft.util.Files;

public class StatBBSManager extends BaseBBSManager
{
	public static StatBBSManager getInstance()
	{
		return SingletonHolder._instance;
	}

	public void parsecmd(String command, L2Player player)
	{
		if (command.equals("_bbsstat;"))
			showPvp(player);
		else if (command.startsWith("_bbsstat;pk"))
			showPK(player);
		else if (command.startsWith("_bbsstat;clan"))
			showClan(player);
		else if (command.startsWith("_bbsstat;castle"))
			showCastle(player);
		else if (command.startsWith("_bbsstat;exps"))
			showExp(player);
		else if (command.startsWith("_bbsstat;recov;")) {
			if(!Config.EXP_TRUE) {
				player.sendMessage("Данная функция отключена");
				return;
			}
			StringTokenizer stExp = new StringTokenizer(command, ";");
			stExp.nextToken();
			stExp.nextToken();
			String ids = stExp.nextToken();
			int id = Integer.parseInt(ids.trim());
		
			if(player.getLostExp() != 0) {				
				if(checkItemExp(player, id)) {
					Functions.removeItem(player, Config.EXP_ITEM, getItemExp(id));
					player.addExpAndSp((long) (player.getLostExp() * id / 100), 0, false, false);
					player.setLostExp(0);
				} else  
					return;
			} else {
				player.sendMessage("Не чего восстанавливать");
				return;
			}
		}
		else
			ShowBoard.separateAndSend("<html><body><br><br><center>В bbsstat функция: " + command + " пока не реализована</center><br><br></body></html>", player);
	}
	
	private void showPvp(L2Player player)
	{
		ThreadConnection con = null;
		FiltredPreparedStatement statement = null;
		ResultSet rs = null;
		try
		{
			con = L2DatabaseFactory.getInstance().getConnection();
			statement = con.prepareStatement("SELECT * FROM characters WHERE accesslevel = '0' ORDER BY pvpkills DESC LIMIT 20;");
			rs = statement.executeQuery();

			TextBuilder html = new TextBuilder();
			html.append("<center>ТОП 20 PVP</center>");
			html.append("<img src=L2UI.SquareWhite width=450 height=1>");
			html.append("<table width=450 bgcolor=CCCCCC>");
			html.append("<tr>");
			html.append("<td width=250>Ник</td>");
			html.append("<td width=50>Пол</td>");
			html.append("<td width=100>Время в игре</td>");
			html.append("<td width=50>PK</td>");
			html.append("<td width=50><font color=00CC00>PVP</font></td>");
			html.append("<td width=100>Статус</td>");
			html.append("</tr>");
			html.append("</table>");
			html.append("<img src=L2UI.SquareWhite width=450 height=1>");
			html.append("<table width=450>");
			while (rs.next())
			{
				CBStatMan tp = new CBStatMan();
				tp.PlayerId = rs.getInt("obj_Id");
				tp.ChName = rs.getString("char_name");
				tp.ChSex = rs.getInt("sex");
				tp.ChGameTime = rs.getInt("onlinetime");
				tp.ChPk = rs.getInt("pkkills");
				tp.ChPvP = rs.getInt("pvpkills");
				tp.ChOnOff = rs.getInt("online");

				String sex = tp.ChSex == 1 ? "Ж" : "М";
				String color;
				String OnOff;
				if (tp.ChOnOff == 1)
				{
					OnOff = "Онлайн";
					color = "00CC00";
				}
				else
				{
					OnOff = "Оффлайн";
					color = "D70000";
				}
				html.append("<tr>");
				html.append("<td width=250>" + tp.ChName + "</td>");
				html.append("<td width=50>" + sex + "</td>");
				html.append("<td width=100>" + OnlineTime(tp.ChGameTime) + "</td>");
				html.append("<td width=50>" + tp.ChPk + "</td>");
				html.append("<td width=50><font color=00CC00>" + tp.ChPvP + "</font></td>");
				html.append("<td width=100><font color=" + color + ">" + OnOff + "</font></td>");
				html.append("</tr>");
			}
			html.append("</table>");

			String content = Files.read("data/html/CommunityBoardPVP/200.htm", player);
			content = content.replace("%stat%", html.toString());
			separateAndSend(content, player);
			return;
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		finally
		{
			DatabaseUtils.closeDatabaseCSR(con, statement, rs);
		}
	}
	
	private void showExp(L2Player player)
	{
		TextBuilder html = new TextBuilder();
		html.append(Integer.toString(player.getLostExp())+" EXP.");
		String content = Files.read("data/html/CommunityBoardPVP/455.htm", player);
		content = content.replace("%stat%", html.toString());
		separateAndSend(content, player);
		return;
	}

	private void showPK(L2Player player)
	{
		ThreadConnection con = null;
		FiltredPreparedStatement statement = null;
		ResultSet rs = null;
		try
		{
			con = L2DatabaseFactory.getInstance().getConnection();
			statement = con.prepareStatement("SELECT * FROM characters WHERE accesslevel = '0' ORDER BY pkkills DESC LIMIT 20;");
			rs = statement.executeQuery();

			TextBuilder html = new TextBuilder();
			html.append("<center>ТОП 20 PK</center>");
			html.append("<img src=L2UI.SquareWhite width=450 height=1>");
			html.append("<table width=450 bgcolor=CCCCCC>");
			html.append("<tr>");
			html.append("<td width=250>Ник</td>");
			html.append("<td width=50>Пол</td>");
			html.append("<td width=100>Время в игре</td>");
			html.append("<td width=50><font color=00CC00>PK</font></td>");
			html.append("<td width=50>PVP</td>");
			html.append("<td width=100>Статус</td>");
			html.append("</tr>");
			html.append("</table>");
			html.append("<img src=L2UI.SquareWhite width=450 height=1>");
			html.append("<table width=450>");
			while (rs.next())
			{
				CBStatMan tp = new CBStatMan();
				tp.PlayerId = rs.getInt("obj_Id");
				tp.ChName = rs.getString("char_name");
				tp.ChSex = rs.getInt("sex");
				tp.ChGameTime = rs.getInt("onlinetime");
				tp.ChPk = rs.getInt("pkkills");
				tp.ChPvP = rs.getInt("pvpkills");
				tp.ChOnOff = rs.getInt("online");

				String sex = tp.ChSex == 1 ? "Ж" : "М";
				String color;
				String OnOff;
				if (tp.ChOnOff == 1)
				{
					OnOff = "Онлайн";
					color = "00CC00";
				}
				else
				{
					OnOff = "Оффлайн";
					color = "D70000";
				}
				html.append("<tr>");
				html.append("<td width=250>" + tp.ChName + "</td>");
				html.append("<td width=50>" + sex + "</td>");
				html.append("<td width=100>" + OnlineTime(tp.ChGameTime) + "</td>");
				html.append("<td width=50><font color=00CC00>" + tp.ChPk + "</font></td>");
				html.append("<td width=50>" + tp.ChPvP + "</td>");
				html.append("<td width=100><font color=" + color + ">" + OnOff + "</font></td>");
				html.append("</tr>");
			}
			html.append("</table>");

			String content = Files.read("data/html/CommunityBoardPVP/200.htm", player);
			content = content.replace("%stat%", html.toString());
			separateAndSend(content, player);
			return;
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		finally
		{
			DatabaseUtils.closeDatabaseCSR(con, statement, rs);
		}
	}

	private void showCastle(L2Player player) 
	{ 
		SimpleDateFormat sdf = new SimpleDateFormat("dd.MM.yyyy HH:mm:ss"); 
		ThreadConnection con = null;
		FiltredPreparedStatement statement = null;
		ResultSet rs = null;
	    try 
	    { 
	    	con = L2DatabaseFactory.getInstance().getConnection(); 
	    	statement = con.prepareStatement("SELECT * FROM castle ORDER BY id DESC LIMIT 10;"); 
	    	rs = statement.executeQuery(); 
	    	TextBuilder html = new TextBuilder(); 
	    	html.append("<center>Статистика Замков</center>"); 
	    	html.append("<img src=L2UI.SquareWhite width=450 height=1>");
	    	html.append("<table width=450 bgcolor=CCCCCC>"); 
	    	html.append("<tr>"); 
	    	html.append("<td width=150>Замок</td>"); 
	    	html.append("<td width=100>Налог</td>"); 
	    	html.append("<td width=200>Владелец</td>"); 
	    	html.append("<td width=150>Дата осады</td>"); 
	    	html.append("</tr>"); 
	    	html.append("</table>"); 
	    	html.append("<img src=L2UI.SquareWhite width=450 height=1>"); 
	    	html.append("<table width=450>");
	    	String Owner = null; 
	    	String color = "FFFFFF";
	    	while (rs.next())
	    	{
	    		CBStatMan tp = new CBStatMan(); 
	    	   tp.id = rs.getInt("id");
	    	   tp.NameCastl = rs.getString("name");
	    	   tp.Percent = (rs.getString("taxPercent") + "%"); 
	    	   if (Config.ALT_SIEGE_MOD) 
	    		   tp.siegeDate = CastleManager.getInstance().getAltSiegeTime(rs.getInt("id")); 
	    	   else 
	    		   tp.siegeDate = sdf.format(new Date(rs.getLong("siegeDate"))); 
	    	   		Owner = CastleManager.getInstance().getOwner(tp.id); 
	    	   		if (Owner != null) 
	    	   		{ 
	    	   			color = "00CC00"; 
	    	   		} 
	    	   		else 
	    	   		{
	    	   			color = "FFFFFF"; 
	    	   			Owner = "Нет владельца"; 
	    	   		} 
	    	   	html.append("<tr>"); 
	    	   	html.append("<td width=150>" + tp.NameCastl + "</td>"); 
	    	   	html.append("<td width=100>" + tp.Percent + "</td>"); 
	    	   	html.append("<td width=200><font color=" + color + ">" + Owner + "</font></td>"); 
	    	   	html.append("<td width=150>" + tp.siegeDate + "</td>");
	    	   	html.append("</tr>"); 
	    	} 
	    	html.append("</table>"); 
	    	String content = Files.read("data/html/CommunityBoardPVP/200.htm", player);
	    	content = content.replace("%stat%", html.toString());
	    	separateAndSend(content, player);
	    	return;
	    }
	    catch (Exception e) 
		{ 
			e.printStackTrace(); 
		} 
		finally
		{
			DatabaseUtils.closeDatabaseCSR(con, statement, rs);
		} 
	} 
	
	
	private void showClan(L2Player player) 
		{ 
			ThreadConnection con = null;
			FiltredPreparedStatement statement = null;
			ResultSet rs = null;
			try 
			{ 
				con = L2DatabaseFactory.getInstance().getConnection();
				statement = con.prepareStatement("SELECT clan_data.clan_name,clan_data.clan_level,clan_data.reputation_score,ally_data.ally_name FROM clan_data LEFT JOIN ally_data ON clan_data.ally_id = ally_data.ally_id WHERE clan_data.clan_level>0 order by clan_data.clan_level desc limit 10;"); 
				rs = statement.executeQuery(); 
				
				TextBuilder html = new TextBuilder(); 
				html.append("<center>Топ 10 Кланов</center>"); 
				html.append("<img src=L2UI.SquareWhite width=450 height=1>");
		    	html.append("<table width=450 bgcolor=CCCCCC>"); 
		    	html.append("<tr>"); 
				html.append("<td width=200>Клан</td>"); 
				html.append("<td width=150>Альянс</td>"); 
				html.append("<td width=100>Репутация</td>"); 
				html.append("<td width=150>Уровень</td>"); 
				html.append("</tr>"); 
		    	html.append("</table>"); 
		    	html.append("<img src=L2UI.SquareWhite width=450 height=1>"); 
		    	html.append("<table width=450>"); 
				while (rs.next())
				{
					CBStatMan tp = new CBStatMan();
					tp.ClanName = rs.getString("clan_name"); 
					tp.AllyName = rs.getString("ally_name"); 
					tp.ReputationClan = rs.getInt("reputation_score"); 
					tp.ClanLevel = rs.getInt("clan_level"); 
					html.append("<tr>"); 
					html.append("<td width=200>" + tp.ClanName + "</td>"); 
					if (tp.AllyName != null) 
					{
						html.append("<td width=150>" + tp.AllyName + "</td>"); 
					}
					else 
					{
						html.append("<td width=150>Нет альянса</td>"); 
					}
					html.append("<td width=100>" + tp.ReputationClan + "</td>"); 
					html.append("<td width=150>" + tp.ClanLevel + "</td>");
					html.append("</tr>"); 
				}
				html.append("</table>"); 
						
			String content = Files.read("data/html/CommunityBoardPVP/200.htm", player);
			content = content.replace("%stat%", html.toString()); 
			separateAndSend(content, player);
			return;
		} 
		catch (Exception e) 
		{ 
			e.printStackTrace(); 
		} 
		finally
		{
			DatabaseUtils.closeDatabaseCSR(con, statement, rs);
		}
	}
		  
	String OnlineTime(int time)
	{
		long onlinetimeH;
		if (time / 60 / 60 - 0.5 <= 0)
			onlinetimeH = 0L;
		else
			onlinetimeH = Math.round(time / 60 / 60 - 0.5);
		int onlinetimeM = Math.round((float)((time / 60 / 60 - onlinetimeH) * 60));
		return "" + onlinetimeH + " ч. " + onlinetimeM + " м.";
	}

	public void parsewrite(String ar1, String ar2, String ar3, String ar4, String ar5, L2Player player)
	{
	}
	
	public boolean checkItemExp(L2Player player, int id)
	{
		if(id == 10 && Functions.getItemCount(player, Config.EXP_ITEM) < Config.EXP_10)
		{
			player.sendMessage("Не хватает монет");
			return false;
		}
		if(id == 20 && Functions.getItemCount(player, Config.EXP_ITEM) < Config.EXP_20)
		{
			player.sendMessage("Не хватает монет");
			return false;
		}
		if(id == 30 && Functions.getItemCount(player, Config.EXP_ITEM) < Config.EXP_30)
		{
			player.sendMessage("Не хватает монет");
			return false;
		}
		if(id == 40 && Functions.getItemCount(player, Config.EXP_ITEM) < Config.EXP_40)
		{
			player.sendMessage("Не хватает монет");
			return false;
		}
		if(id == 50 && Functions.getItemCount(player, Config.EXP_ITEM) < Config.EXP_50)
		{
			player.sendMessage("Не хватает монет");
			return false;
		}
		if(id == 60 && Functions.getItemCount(player, Config.EXP_ITEM) < Config.EXP_60)
		{
			player.sendMessage("Не хватает монет");
			return false;
		}
		if(id == 70 && Functions.getItemCount(player, Config.EXP_ITEM) < Config.EXP_70)
		{
			player.sendMessage("Не хватает монет");
			return false;
		}
		if(id == 80 && Functions.getItemCount(player, Config.EXP_ITEM) < Config.EXP_80)
		{
			player.sendMessage("Не хватает монет");
			return false;
		}
		if(id == 90 && Functions.getItemCount(player, Config.EXP_ITEM) < Config.EXP_90)
		{
			player.sendMessage("Не хватает монет");
			return false;
		}
		if(id == 100 && Functions.getItemCount(player, Config.EXP_ITEM) < Config.EXP_100)
		{
			player.sendMessage("Не хватает монет");
			return false;
		}
		return true;
	}
	
	public int getItemExp(int id)
	{
		if(id == 10)
			return Config.EXP_10;
		if(id == 20)
			return Config.EXP_20;
		if(id == 30)
			return Config.EXP_30;
		if(id == 40)
			return Config.EXP_40;
		if(id == 50)
			return Config.EXP_50;
		if(id == 60)
			return Config.EXP_60;
		if(id == 70)
			return Config.EXP_70;
		if(id == 80)
			return Config.EXP_80;
		if(id == 90)
			return Config.EXP_90;
		if(id == 100)
			return Config.EXP_100;
		
		return 0; 
	}

	private static class SingletonHolder
	{
		protected static final StatBBSManager _instance = new StatBBSManager();
	}

	public class CBStatMan
	{
		public String NameCastl;
		public Object siegeDate;
		public String Percent;
		public Object id2;
		public int id;
		public int ClanLevel;
		public int ReputationClan;
		public String AllyName;
		public String ClanName;
		public int PlayerId = 0;
		public String ChName = "";
		public int ChGameTime = 0;
		public int ChPk = 0;
		public int ChPvP = 0;
		public int ChOnOff = 0;
		public int ChSex = 0;

		public CBStatMan()
		{
		}
	}
}