package l2ft.gameserver.communitybbs.containers;

import l2ft.database.DatabaseUtils;
import l2ft.database.L2DatabaseFactory;
import l2ft.database.ThreadConnection;
import l2ft.extensions.scripts.Functions;
import l2ft.gameserver.Announcements;
import l2ft.gameserver.communitybbs.Manager.MercenariesManager;
import l2ft.gameserver.model.L2ObjectsStorage;
import l2ft.gameserver.model.L2Player;

import java.util.HashMap;
import java.util.Map;

public class Order {
    // Клиент
    public int client;
    public String clientName;
    // Цель
    public int target;
    public String targetName;
    // Сколько раз необходимо убить?
    public int countToKill;
    // Список награды, формата ID : Кол-во
    public HashMap<Integer, Long> reward = new HashMap<Integer, Long>();
    // Список тех, кто убивал и сколько (соответственно).
    public HashMap<Integer, Integer> kills = new HashMap<Integer, Integer>();

    String hwid = "";

    public Order(int client, String clientName, int target, String targetName, int countToKill) {
        this.client = client;
        this.clientName = clientName;
        this.target = target;
        this.targetName = targetName;
        this.countToKill = countToKill;
    }

    public void addReward(int id, long count) {
        reward.put(id, count);
    }

    public void closeOrder(L2Player player) {
        for (Map.Entry<Integer, Long> rew : reward.entrySet())
            Functions.addItem(player, rew.getKey(), rew.getValue());
        MercenariesManager.getInstance()._orders.remove(target);
        reward.clear();
        Announcements.getInstance().announceToAll(player.getName() + " выполнил заказ на убийство " + targetName + ".");
        deleteOrder();
    }

    public void onKill(L2Player player) // player - убийца.
    {
        int countKills;
        if (kills.containsKey(player.getObjectId()))
            countKills = kills.get(player.getObjectId()) + 1;
        else
            countKills = 1;

        if (countKills >= countToKill)
            closeOrder(player);

        L2Player targ = L2ObjectsStorage.getPlayer(target);
        if (targ != null) {
            if (targ.getClan() == null || (targ.getClanId() != player.getClanId() && (targ.getAlliance() == null || targ.getAllyId() != player.getAllyId())))
                kills.put(player.getObjectId(), countKills);
        }
    }

    public void deleteOrder() {
        ThreadConnection con = null;
        try {
            con = L2DatabaseFactory.getInstance().getConnection();
            con.prepareStatement("DELETE FROM `mercenaries_orders` where `target`=" + target).execute();
            con.prepareStatement("DELETE FROM `mercenaries_rewards` where `target`=" + target).execute();
            con.prepareStatement("DELETE FROM `mercenaries_kills` where `target`=" + target).execute();
        } catch (final Exception e) {
            e.printStackTrace();
        } finally {
            DatabaseUtils.closeConnection(con);
        }
    }
}