package l2ft.gameserver.handler;

import java.util.Map;
import java.util.TreeMap;

public class ItemHandler
{
	private static final ItemHandler _instance = new ItemHandler();

	private Map<Integer, IItemHandler> _datatable;

	public static ItemHandler getInstance()
	{
		return _instance;
	}

	public int size()
	{
		return _datatable.size();
	}

	private ItemHandler()
	{
		_datatable = new TreeMap<Integer, IItemHandler>();
	}

	public void registerItemHandler(IItemHandler handler)
	{
		int[] ids = handler.getItemIds(); // Get all ID corresponding to the item type of the handler
		for(int element : ids)
			_datatable.put(element, handler); // Add handler for each ID found
	}

	public IItemHandler getItemHandler(int itemId)
	{
		return _datatable.get(itemId);
	}

	public void clear()
	{
		_datatable.clear();
	}
}
