package l2ft.gameserver.instancemanager;

import l2ft.Config;
import l2ft.common.ThreadPoolManager;
import l2ft.gameserver.model.L2Spawn;
import l2ft.util.GArray;

public class DelaySpawnManager
{
	private static DelaySpawnManager _instance;
	private static GArray<L2Spawn> _delaySpawn = new GArray<L2Spawn>();
	
	public static DelaySpawnManager getInstance()
	{
		if(_instance == null)
			_instance = new DelaySpawnManager();
		return _instance;
	}

	public void addDelayMob(L2Spawn spawnDat)
	{
		_delaySpawn.add(spawnDat);
	}

	public void deleteMobs(GArray<L2Spawn> mobsSpawnsList)
	{
		for(L2Spawn spawnDat : mobsSpawnsList)
			spawnDat.despawnAll();
	}

	public void spawnDelayMobs()
	{
		ThreadPoolManager.getInstance().scheduleGeneralAtFixedRate(new spawnMobs(), Config.DELAY_SPAWN, Config.DELAY_SPAWN);
	}
	
	private class spawnMobs implements Runnable
	{
		@Override
		public void run()
		{
			spawnMobs(_delaySpawn);
		}
	}
	
	public void spawnMobs(GArray<L2Spawn> mobsSpawnsList)
	{
		for(L2Spawn spawnDat : mobsSpawnsList)
			spawnDat.init();
	}

	public void cleanUp()
	{
		deleteMobs(_delaySpawn);
		_delaySpawn.clear();
	}
}