package l2ft.gameserver.instancemanager;

import java.util.Iterator;
import java.util.concurrent.ScheduledFuture;

import l2ft.common.ThreadPoolManager;
import l2ft.gameserver.model.L2ObjectsStorage;
import l2ft.gameserver.model.L2Player;
import l2ft.util.GArray;

public class NavitManager
{
	public ScheduledFuture<?> _task;
	private static NavitManager _instance;
	private GArray<Long> _players;
	private GArray<Long> temp;

	public NavitManager()
	{
		_players = new GArray<Long>();

		this.temp = new GArray<Long>();
	}

	public static NavitManager getInstance()
	{
		if (_instance == null)
			_instance = new NavitManager();
		return _instance;
	}

	public void addPlayer(long storeId)
	{
		synchronized (_players)
		{
			_players.add(storeId);

			if (_task == null)
				_task = ThreadPoolManager.getInstance().scheduleGeneralAtFixedRate(new navitTask(), 0, 60000);
		}
	}

	public boolean containPlayer(long storeId)
	{
		return _players.contains(Long.valueOf(storeId));
	}

	private class navitTask implements Runnable
	{
		private navitTask()
		{
		}

		public void run() {
		synchronized (_players)
		{
			if (_players.size() == 0)
			{
				_task.cancel(true);
				_task = null;
			}

			try
			{
				for (Iterator<Long> i$ = _players.iterator(); i$.hasNext();)
				{ 
					long id = (i$.next()).longValue();
					try
					{
						L2Player player = L2ObjectsStorage.getAsPlayer(id);
						if (player == null || player.isDeleting() || !player.isConnected() || player.isInOfflineMode() || !player.getNevitBlessing().onNevitBonusTimeTick())
							NavitManager.this.temp.add(id);
					}
					catch (Exception e)
					{
						e.printStackTrace();
					}
				}
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}
			finally
			{
				for (Iterator<Long> i$ = NavitManager.this.temp.iterator(); i$.hasNext(); ) 
				{ 
					long id = (i$.next()).longValue();
					_players.remove(id);
				}
				NavitManager.this.temp.clearSize();
			}
		}
		}
	}
}