package l2ft.gameserver.instancemanager;

import l2ft.common.ThreadPoolManager;
import l2ft.gameserver.model.L2ObjectsStorage;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.serverpackets.ExShowScreenMessage;
import l2ft.gameserver.serverpackets.ExShowScreenMessage.ScreenMessageAlign;

public class RewardForOnline
{
	private static RewardForOnline _instance;

	public static RewardForOnline getInstance()
	{
		if(_instance == null)
			_instance = new RewardForOnline();
		return _instance;
	}

	public RewardForOnline()
	{
		ThreadPoolManager.getInstance().scheduleGeneralAtFixedRate(new giveReward(), 1200000, 1200000);
	}

	private synchronized void giveReward()
	{
		for(L2Player player : L2ObjectsStorage.getAllPlayersForIterate())
		{
			if(player.isLangRus())
				player.sendPacket(new ExShowScreenMessage("По вопросам приобретения эмулятора обращаться First-team.ru", 30000, ScreenMessageAlign.TOP_CENTER, false));
			else
				player.sendPacket(new ExShowScreenMessage("For purchase emulator contact to First-team.ru", 30000, ScreenMessageAlign.TOP_CENTER, false));
		}
	}
	
	private class giveReward implements Runnable
	{
		@Override
		public void run()
		{
			giveReward();
		}
	}

	
}