package l2ft.gameserver.model.entity.olympiad;

import java.sql.ResultSet;
import java.sql.SQLException;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.base.ClassId;

public class NobleInfo
{
	public static final String CHAR_ID = "char_id";
	public static final String CLASS_ID = "class_id";
	public static final String CHAR_NAME = "char_name";
	public static final String POINTS = "olympiad_points";
	public static final String POINTS_PAST = "olympiad_points_past";
	public static final String POINTS_PAST_STATIC = "olympiad_points_past_static";
	public static final String COMP_DONE = "competitions_done";
	public static final String COMP_WIN = "competitions_win";
	public static final String COMP_LOOSE = "competitions_loose";
	public static final String COMP_WEEK_0 = "competitions_week_0";
	public static final String COMP_WEEK_1 = "competitions_week_1";
	public static final String COMP_WEEK_2 = "competitions_week_2";
	public static final String COMP_WEEK_3 = "competitions_week_3";
	public String char_name = "";
	public int char_id;
	public int class_id;
	public int olympiad_points;
	public int olympiad_points_past;
	public int olympiad_points_past_static;
	public int competitions_done;
	public int competitions_win;
	public int competitions_loose;
	public int competitions_week_0;
	public int competitions_week_1;
	public int competitions_week_2;
	public int competitions_week_3;

	private void setClassId(int classId)
	{
		class_id = classId;
		if (classId < 88)
			for (ClassId id : ClassId.values())
			{
				if(id.level() == 3 && id.getParent((byte) 0).getId() == classId)
				{
					classId = id.getId();
					break;
				}
			}
	}

	public NobleInfo(L2Player player)
	{
		setClassId(player.getBaseClassId());
		char_id = player.getObjectId();
		char_name = player.getName();
		olympiad_points = 10;
	}

	public NobleInfo(ResultSet rset) throws SQLException
	{
		setClassId(rset.getInt("class_id"));

		char_id = rset.getInt("char_id");
		char_name = rset.getString("char_name");
		olympiad_points = rset.getInt("olympiad_points");
		olympiad_points_past = rset.getInt("olympiad_points_past");
		olympiad_points_past_static = rset.getInt("olympiad_points_past_static");
		competitions_done = rset.getInt("competitions_done");
		competitions_win = rset.getInt("competitions_win");
		competitions_loose = rset.getInt("competitions_loose");
		competitions_week_0 = rset.getInt("competitions_week_0");
		competitions_week_1 = rset.getInt("competitions_week_1");
		competitions_week_2 = rset.getInt("competitions_week_2");
		competitions_week_3 = rset.getInt("competitions_week_3");
	}

	public int getAllCompetitionCount()
	{
		return competitions_week_0 + competitions_week_1 + competitions_week_2 + competitions_week_3;
	}
}
