package l2ft.gameserver.model.entity.olympiad;

import l2ft.Config;
import l2ft.common.ThreadPoolManager;
import l2ft.gameserver.Announcements;
import l2ft.gameserver.model.entity.Hero;
import l2ft.gameserver.serverpackets.SystemMessage;

public class OlympiadEndTask implements Runnable
{
	@Override
	public void run()
	{
		if(Olympiad._inCompPeriod)
		{
			ThreadPoolManager.getInstance().scheduleGeneral(new OlympiadEndTask(), 60000);
			return;
		}

		if (Olympiad._isOlympiadEnd)
		{
			return;
		}

		Announcements.getInstance().announceToAll(new SystemMessage(1640).addNumber(Integer.valueOf(Olympiad._currentCycle)));
		Announcements.getInstance().announceToAll("Olympiad Validation Period has began");

		Olympiad._isOlympiadEnd = true;
		if (Olympiad._scheduledWeeklyTask != null) 
		{
			Olympiad._scheduledWeeklyTask.cancel(true);
		}
		Olympiad._validationEnd = Olympiad._olympiadEnd + Config.ALT_OLY_VPERIOD;

		OlympiadDatabase.saveNobleData();
		Olympiad._period = 1;
		Hero.getInstance().clearHeroes();

		try
		{
			OlympiadDatabase.save();
		}
		catch (Exception e)
		{
			Olympiad._log.warning("Olympiad System: Failed to save Olympiad configuration: " + e);
		}

		Olympiad._log.warning("Olympiad System: Starting Validation period. Time to end validation:" + Olympiad.getMillisToValidationEnd() / 60000);

		if (Olympiad._scheduledValdationTask != null)
			Olympiad._scheduledValdationTask.cancel(true);
		Olympiad._scheduledValdationTask = ThreadPoolManager.getInstance().scheduleGeneral(new ValidationTask(), Olympiad.getMillisToValidationEnd());
	}
}