package l2ft.gameserver.model.instances;

import l2ft.gameserver.instancemanager.GameHandyManager;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.serverpackets.NpcHtmlMessage;
import l2ft.gameserver.templates.L2NpcTemplate;

public class L2HandyNpcInstance extends L2NpcInstance
{
	public L2HandyNpcInstance(int objectId, L2NpcTemplate template)
	{
		super(objectId, template);
	}

	@Override
	public void onBypassFeedback(L2Player player, String command)
	{
		int _arena = 0;
		if(command.startsWith("Hendy_Register"))
		{
			try
			{
				_arena = Integer.parseInt(command.substring(15));
			}

			catch(IndexOutOfBoundsException ioobe)
			{}

			catch(NumberFormatException nfe)
			{}

			if(GameHandyManager.getPlayerArena(player) != 0)
				showHendyChat(player, 7);
				
			if(player.isCursedWeaponEquipped())
				showHendyChat(player, 3);
			else if(player.isInKrateisCube())
				showHendyChat(player, 3);
			else if(player.isInOlympiadMode())
				showHendyChat(player, 5);
			else if(player.getKarma() > 0)
				showHendyChat(player, 3);
			else if(_arena == 1 || _arena == 2 || _arena == 3 || _arena == 4)
			{
				if(GameHandyManager.registerPlayer(player, _arena))
				{
					showHendyChat(player, 1);
				}
				else
					showHendyChat(player, 2);
			}
		}
		if(command.startsWith("Hendy_PlayersList"))
		{
			try
			{
				_arena = Integer.parseInt(command.substring(18));
			}

			catch(IndexOutOfBoundsException ioobe)
			{}

			catch(NumberFormatException nfe)
			{}

			if(_arena == 1 || _arena == 2 || _arena == 3 || _arena == 4)
			{
				GameHandyManager.getInstance();
				GameHandyManager.playerList(player, _arena);
			}
		}
		super.onBypassFeedback(player, command);
	}

	@Override
	public String getHtmlPath(int npcId, int val)
	{
		String pom;
		if(val == 0)
			pom = "" + npcId;
		else
			pom = npcId + "-" + val;

		return "data/html/gamehandy/" + pom + ".htm";
	}

	private void showHendyChat(L2Player player, int par)
	{
		String filename = "";
		String html_folder = "";

		if(player.getVar("lang@").equalsIgnoreCase("ru"))
			html_folder = "html-ru";
		else
			html_folder = "html";

		if(par == 1)
			filename = "data/" + html_folder + "/gamehandy/reg-success.htm";
		else if(par == 2)
			filename = "data/" + html_folder + "/gamehandy/reg-fail.htm";
		else if(par == 3)
			filename = "data/" + html_folder + "/gamehandy/CursedWeaponEquipped.htm";
		else if(par == 4)
			filename = "data/" + html_folder + "/gamehandy/Karma.htm";
		else if(par == 5)
			filename = "data/" + html_folder + "/gamehandy/Olympiad.htm";
		else if(par == 6)
			filename = "data/" + html_folder + "/gamehandy/KrateiCube.htm";
		else if(par == 7)
			filename = "data/" + html_folder + "/gamehandy/UseReg.htm";

		NpcHtmlMessage html = new NpcHtmlMessage(getObjectId());
		html.setFile(filename);
		html.replace("%objectId%", String.valueOf(getObjectId()));
		html.replace("%npcname%", getName());
		player.sendPacket(html);
	}
}