package l2ft.gameserver.model.instances;

import l2ft.extensions.scripts.Functions;
import l2ft.gameserver.model.L2Party;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.serverpackets.L2GameServerPacket;
import l2ft.gameserver.serverpackets.NpcHtmlMessage;
import l2ft.gameserver.templates.L2NpcTemplate;
import l2ft.util.Location;
import l2ft.util.Rnd;

public class L2IngeniousContraptionInstance extends L2NpcInstance
	{
	private static int TullysPlatinumMedal = 10427;
	private static int TullysTinMedal = 10428;
	private static int TullysLeadMedal = 10429;
	private static int TullysZincMedal = 10430;
	private static int TullysCopperMedal = 10431;

	private static Location loc = new Location(27016, 247720, -3232);

	public L2IngeniousContraptionInstance(int objectId, L2NpcTemplate template)
	{
		super(objectId, template);
	}

	public void onBypassFeedback(L2Player player, String command)
	{
		if (!canBypassCheck(player, this))
			return;
		if (command.startsWith("get_medals"))
		{
			switch (Rnd.get(6))
			{
			case 1:
				Functions.addItem(player, TullysPlatinumMedal, 1);
				break;
			case 2:
				Functions.addItem(player, TullysTinMedal, 1);
				break;
			case 3:
				Functions.addItem(player, TullysLeadMedal, 1);
				break;
			case 4:
				Functions.addItem(player, TullysZincMedal, 1);
				break;
			case 5:
				Functions.addItem(player, TullysCopperMedal, 1);
			}

			deleteMe();
		}
		else if (command.startsWith("teleport"))
		{
			boolean p = false; boolean t = false; boolean l = false; boolean z = false; boolean c = false;

			L2Party party = player.getParty();
			if (party != null) {
				for (L2Player member : party.getPartyMembers())
				{
					p = check(member, p, TullysPlatinumMedal);
					t = check(member, t, TullysTinMedal);
					l = check(member, l, TullysLeadMedal);
					z = check(member, z, TullysZincMedal);
					c = check(member, c, TullysCopperMedal);
				}
			}
			else {
				p = check(player, p, TullysPlatinumMedal);
				t = check(player, t, TullysTinMedal);
				l = check(player, l, TullysLeadMedal);
				z = check(player, z, TullysZincMedal);
				c = check(player, c, TullysCopperMedal);
			}

			if ((p) && (t) && (l) && (z) && (c)) {
				if (party != null)
					party.Teleport(loc);
				else
					player.teleToLocation(loc);
			}
			else {
				String content = "<html><body><font color=\"LEVEL\">Ingenious Contraption:<br></font>You don't have all medals!</body></html>";
				NpcHtmlMessage html = new NpcHtmlMessage(player, this);
				html.setHtml(content);
				player.sendPacket(new L2GameServerPacket[] { html });
			}
		}
	}

	private boolean check(L2Player player, boolean old, int medal)
	{
		return (old) || (player.getInventory().getItemByItemId(medal) != null);
	}

	public void showChatWindow(L2Player player, int val)
	{
		player.sendPacket(new L2GameServerPacket[] { new NpcHtmlMessage(player, this, getHtmlPath(getNpcId(), val), val) });
	}
}