package l2ft.gameserver.model.instances;

import l2ft.gameserver.instancemanager.KrateisCubeManager;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.L2Summon;
import l2ft.gameserver.serverpackets.SystemMessage;
import l2ft.gameserver.templates.L2NpcTemplate;

public class L2KrateisCubeManagerInstance extends L2NpcInstance
{

	public L2KrateisCubeManagerInstance(int objectId, L2NpcTemplate template)
	{
		super(objectId, template);
	}

	@Override
	public void onBypassFeedback(L2Player player, String command)
	{
		if(command.startsWith("Register"))
		{
			if(player.getInventoryLimit() * 0.8 <= player.getInventory().getSize())
			{
				player.sendPacket(new SystemMessage(SystemMessage.PROGRESS_IN_A_QUEST_IS_POSSIBLE_ONLY_WHEN_YOUR_INVENTORYS_WEIGHT_AND_VOLUME_ARE_LESS_THAN_80_PERCENT_OF_CAPACITY));
				if(player.getVar("lang@").equalsIgnoreCase("ru"))
					showChatWindow(player, "data/html-ru/KrateiCube/32503-9.htm");
				else
					showChatWindow(player, "data/html/KrateiCube/32503-9.htm");
				return;
			}

			int cmdChoice = Integer.parseInt(command.substring(9, 10).trim());
			switch(cmdChoice)
			{
				case 1:
					if(player.getLevel() < 70 || player.getLevel() > 75)
					{
						if(player.getVar("lang@").equalsIgnoreCase("ru"))
							showChatWindow(player, "data/html-ru/KrateiCube/32503-7.htm");
						else
							showChatWindow(player, "data/html/KrateiCube/32503-7.htm");
						return;
					}
					break;
				case 2:
					if(player.getLevel() < 76 || player.getLevel() > 79)
					{
						if(player.getVar("lang@").equalsIgnoreCase("ru"))
							showChatWindow(player, "data/html-ru/KrateiCube/32503-7.htm");
						else
							showChatWindow(player, "data/html/KrateiCube/32503-7.htm");
						return;
					}
					break;
				case 3:
					if(player.getLevel() < 80)
					{
						if(player.getVar("lang@").equalsIgnoreCase("ru"))
							showChatWindow(player, "data/html-ru/KrateiCube/32503-7.htm");
						else
							showChatWindow(player, "data/html/KrateiCube/32503-7.htm");
						return;
					}
					break;
				//Case 4:
				//this option was made since there are no different instances
				//just checks for minimum level requirement
				case 4:
					if(player.getLevel() < 70)
					{
						if(player.getVar("lang@").equalsIgnoreCase("ru"))
							showChatWindow(player, "data/html-ru/KrateiCube/32503-10.htm");
						else
							showChatWindow(player, "data/html/KrateiCube/32503-10.htm");
						return;
					}
					break;
			}

			if(KrateisCubeManager.getInstance().isTimeToRegister())
			{
				if(KrateisCubeManager.getInstance().registerPlayer(player))
				{
					if(player.getVar("lang@").equalsIgnoreCase("ru"))
						showChatWindow(player, "data/html-ru/KrateiCube/32503-4.htm");
					else
						showChatWindow(player, "data/html/KrateiCube/32503-4.htm");
					return;
				}
				else
				{
					if(player.getVar("lang@").equalsIgnoreCase("ru"))
						showChatWindow(player, "data/html-ru/KrateiCube/32503-5.htm");
					else
						showChatWindow(player, "data/html/KrateiCube/32503-5.htm");
					return;
				}
			}
			else
			{
				if(player.getVar("lang@").equalsIgnoreCase("ru"))
					showChatWindow(player, "data/html-ru/KrateiCube/32503-8.htm");
				else
					showChatWindow(player, "data/html/KrateiCube/32503-8.htm");
				return;
			}
		}
		else if(command.startsWith("Cancel"))
		{
			KrateisCubeManager.getInstance().removePlayer(player);
			if(player.getVar("lang@").equalsIgnoreCase("ru"))
				showChatWindow(player, "data/html-ru/KrateiCube/32503-6.htm");
			else
				showChatWindow(player, "data/html/KrateiCube/32503-6.htm");
			return;
		}
		else if(command.startsWith("TeleportToFI"))
		{
			player.teleToLocation(-59193, -56893, -2034);
			L2Summon pet = player.getPet();
			if(pet != null)
				pet.teleToLocation(-59193, -56893, -2034);

			return;
		}
		else if(command.startsWith("TeleportIn"))
		{
			KrateisCubeManager.getInstance().teleportPlayerIn(player);
			return;
		}
		else
		{
			super.onBypassFeedback(player, command);
		}
	}

	public String getHtmlPath(L2Player player, int npcId, int val)
	{
		String pom = "";

		if(val == 0)
			pom = "" + npcId;
		else
			pom = npcId + "-" + val;
		if(player.getVar("lang@").equalsIgnoreCase("ru"))
			return "data/html-ru/KrateiCube/" + pom + ".htm";
		else
			return "data/html/KrateiCube/" + pom + ".htm";
	}
}