package l2ft.gameserver.model.instances;

import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.base.ClassId;
import l2ft.gameserver.serverpackets.L2GameServerPacket;
import l2ft.gameserver.serverpackets.NpcHtmlMessage;
import l2ft.gameserver.tables.DoorTable;
import l2ft.gameserver.templates.L2NpcTemplate;
import l2ft.util.Rnd;

public class L2TullysGatekeeperInstance extends L2NpcInstance
{
	public long _lastUse = 0L;

	public L2TullysGatekeeperInstance(int objectId, L2NpcTemplate template)
	{
		super(objectId, template);
	}

	public void onBypassFeedback(L2Player player, String command)
	{
		if (!canBypassCheck(player, this))
			return;
		if (command.startsWith("open_door"))
		{
			if (this._lastUse + 60000L > System.currentTimeMillis())
			{
				String content = "<html><body><font color=\"LEVEL\">Tully's Gatekeeper:<br></font>System is busy, please try later.</body></html>";
				NpcHtmlMessage html = new NpcHtmlMessage(player, this);
				html.setHtml(content);
				player.sendPacket(new L2GameServerPacket[] { html });
				return;
			}

			this._lastUse = System.currentTimeMillis();
			if ((Rnd.chance(20)) || (player.getClassId() == ClassId.warsmith) || (player.getClassId() == ClassId.maestro))
			{
				String content = "<html><body><font color=\"LEVEL\">Tully's Gatekeeper:<br></font>Error! System is restarting...</body></html>";
				NpcHtmlMessage html = new NpcHtmlMessage(player, this);
				html.setHtml(content);
				player.sendPacket(new L2GameServerPacket[] { html });
				return;
			}
			L2DoorInstance door = DoorTable.getInstance().getDoor(Integer.valueOf(Integer.parseInt(command.substring(10))));
			door.openMe();
			door.scheduleCloseMe(15000L);
		}
	}

	public void showChatWindow(L2Player player, int val)
	{
		player.sendPacket(new L2GameServerPacket[] { new NpcHtmlMessage(player, this, getHtmlPath(getNpcId(), val), val) });
	}
}