package l2ft.gameserver.model.instances;

import java.util.StringTokenizer;

import l2ft.extensions.scripts.Functions;
import l2ft.gameserver.instancemanager.HellboundManager;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.skills.AbnormalEffect;
import l2ft.gameserver.taskmanager.DecayTaskManager;
import l2ft.gameserver.templates.L2NpcTemplate;

public final class NativePrisonerInstance extends L2NpcInstance
{
	public NativePrisonerInstance(int objectId, L2NpcTemplate template)
	{
		super(objectId, template);
	}

	public void onSpawn()
	{
		this.startAbnormalEffect(AbnormalEffect.HOLD_2);
		super.onSpawn();
	}

	public void onBypassFeedback(L2Player player, String command)
	{
		StringTokenizer st = new StringTokenizer(command);
		if (st.nextToken().equals("rescue"))
		{
			this.stopAbnormalEffect(AbnormalEffect.HOLD_2);
			Functions.npcSay(this, "Спасибо, что спас меня! Поблизости охрана, бегите!");
			HellboundManager.getInstance().addPoints(20);
			DecayTaskManager.getInstance().addDecayTask(this);
			setBusy(true);
		}
		else
		{
			super.onBypassFeedback(player, command);
		}
	}
}