package l2ft.gameserver.model.items.listeners;

import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.L2Skill;
import l2ft.gameserver.model.items.Inventory;
import l2ft.gameserver.model.items.L2ItemInstance;
import l2ft.gameserver.serverpackets.SkillList;
import l2ft.gameserver.skills.Formulas;
import l2ft.gameserver.tables.SkillTable;
import l2ft.gameserver.templates.L2Item;

/**
 * Добавление/удалениe скилов, прописанных предметам в sql или в xml.
 */
public final class ItemSkillsListener implements PaperdollListener
{
	private Inventory _inv;

	public ItemSkillsListener(Inventory inv)
	{
		_inv = inv;
	}

	public void notifyUnequipped(int slot, L2ItemInstance item)
	{
		if(_inv.getOwner() == null || !_inv.getOwner().isPlayer())
			return;

		L2Player player = _inv.getOwner().getPlayer();
		L2Skill[] itemSkills = null;
		L2Skill enchant4Skill = null;
		
		L2Skill enchantdo4Skill = null;
		L2Skill enchantdo5Skill = null;
		L2Skill enchantdo6Skill = null;
		L2Skill enchantdo7Skill = null;
		L2Skill enchantdo71Skill = null;
		L2Skill enchantdo8Skill = null;
		L2Skill enchantdo81Skill = null;
		L2Skill enchantdo9Skill = null;
		L2Skill enchantdo91Skill = null;
		L2Skill enchantdo10Skill = null;
		L2Skill enchantdo101Skill = null;
		

		L2Item it = item.getItem();

		itemSkills = it.getAttachedSkills();

		enchant4Skill = it.getEnchant4Skill();

		enchantdo4Skill = it.getEnchantdo4Skill();
		enchantdo5Skill = it.getEnchantdo5Skill();
		enchantdo6Skill = it.getEnchantdo6Skill();
		enchantdo7Skill = it.getEnchantdo7Skill();
		enchantdo71Skill = it.getEnchantdo71Skill();
		enchantdo8Skill = it.getEnchantdo8Skill();
		enchantdo81Skill = it.getEnchantdo81Skill();
		enchantdo9Skill = it.getEnchantdo9Skill();
		enchantdo91Skill = it.getEnchantdo91Skill();
		enchantdo10Skill = it.getEnchantdo10Skill();
		enchantdo101Skill = it.getEnchantdo101Skill();
		
		if(itemSkills != null)
			for(L2Skill itemSkill : itemSkills)
				if(itemSkill.getId() >= 26046 && itemSkill.getId() <= 26048)
				{
					int level = player.getSkillLevel(itemSkill.getId());
					int newlevel = level - 1;
					if(newlevel > 0)
						player.addSkill(SkillTable.getInstance().getInfo(itemSkill.getId(), newlevel), false);
					else
						player.removeSkillById(itemSkill.getId());
				}
				else
					player.removeSkill(itemSkill, false);

		if(enchant4Skill != null)
			player.removeSkill(enchant4Skill, false);
		
		if(enchantdo4Skill != null)
			player.removeSkill(enchantdo4Skill, false);
		if(enchantdo5Skill != null)
			player.removeSkill(enchantdo5Skill, false);
		if(enchantdo6Skill != null)
			player.removeSkill(enchantdo6Skill, false);
		if(enchantdo7Skill != null)
			player.removeSkill(enchantdo7Skill, false);
		if(enchantdo71Skill != null)
			player.removeSkill(enchantdo71Skill, false);
		if(enchantdo8Skill != null)
			player.removeSkill(enchantdo8Skill, false);
		if(enchantdo81Skill != null)
			player.removeSkill(enchantdo81Skill, false);
		if(enchantdo9Skill != null)
			player.removeSkill(enchantdo9Skill, false);
		if(enchantdo91Skill != null)
			player.removeSkill(enchantdo91Skill, false);
		if(enchantdo10Skill != null)
			player.removeSkill(enchantdo10Skill, false);
		if(enchantdo101Skill != null)
			player.removeSkill(enchantdo101Skill, false);
		
		if(itemSkills != null || enchant4Skill != null || enchantdo4Skill != null || enchantdo5Skill !=null || enchantdo6Skill !=null || enchantdo7Skill != null || enchantdo8Skill !=null || enchantdo9Skill !=null || enchantdo10Skill !=null)
		{
			player.sendPacket(new SkillList(player));
			player.updateStats();
		}
	}

	public void notifyEquipped(int slot, L2ItemInstance item)
	{
		if(_inv.getOwner() == null || !_inv.getOwner().isPlayer())
			return;

		L2Player player = _inv.getOwner().getPlayer();
		L2Skill[] itemSkills = null;
		L2Skill enchant4Skill = null;
		
		L2Skill enchantdo4Skill = null;
		L2Skill enchantdo5Skill = null;
		L2Skill enchantdo6Skill = null;
		L2Skill enchantdo7Skill = null;
		L2Skill enchantdo71Skill = null;
		L2Skill enchantdo8Skill = null;
		L2Skill enchantdo81Skill = null;
		L2Skill enchantdo9Skill = null;
		L2Skill enchantdo91Skill = null;
		L2Skill enchantdo10Skill = null;
		L2Skill enchantdo101Skill = null;

		L2Item it = item.getItem();

		itemSkills = it.getAttachedSkills();

		if(item.getEnchantLevel() >= 4)
			enchant4Skill = it.getEnchant4Skill();

		if(item.getEnchantLevel() == 4)
			enchantdo4Skill = it.getEnchantdo4Skill();
		if(item.getEnchantLevel() == 5)
			enchantdo5Skill = it.getEnchantdo5Skill();
		if(item.getEnchantLevel() == 6)
			enchantdo6Skill = it.getEnchantdo6Skill();
		if(item.getEnchantLevel() == 7)
		{
			enchantdo7Skill = it.getEnchantdo7Skill();
			enchantdo71Skill = it.getEnchantdo71Skill();
		}
		if(item.getEnchantLevel() == 8)
		{
			enchantdo8Skill = it.getEnchantdo8Skill();
			enchantdo81Skill = it.getEnchantdo81Skill();
		}
		if(item.getEnchantLevel() == 9)
		{
			enchantdo9Skill = it.getEnchantdo9Skill();
			enchantdo91Skill = it.getEnchantdo91Skill();
		}
		if(item.getEnchantLevel() == 10)
		{
			enchantdo10Skill = it.getEnchantdo10Skill();
			enchantdo101Skill = it.getEnchantdo101Skill();
		}
		
		// Для оружия при несоотвествии грейда скилы не выдаем
		if(it.getType2() == L2Item.TYPE2_WEAPON && (player.getWeaponsExpertisePenalty() > 0 || player.getArmorExpertisePenalty() > 0))
		{
			itemSkills = null;
			enchant4Skill = null;
			enchantdo4Skill = null;
			enchantdo5Skill = null;
			enchantdo6Skill = null;
			enchantdo7Skill = null;
			enchantdo71Skill = null;
			enchantdo8Skill = null;
			enchantdo81Skill = null;
			enchantdo9Skill = null;
			enchantdo91Skill = null;
			enchantdo10Skill = null;
			enchantdo101Skill = null;
		}

		if(itemSkills != null && itemSkills.length > 0)
			for(L2Skill itemSkill : itemSkills)
				if(itemSkill.getId() >= 26046 && itemSkill.getId() <= 26048)
				{
					int level = player.getSkillLevel(itemSkill.getId());
					int newlevel = level;
					if(level > 0)
					{
						if(SkillTable.getInstance().getInfo(itemSkill.getId(), level + 1) != null)
							newlevel = level + 1;
					}
					else
						newlevel = 1;
					if(newlevel != level)
						player.addSkill(SkillTable.getInstance().getInfo(itemSkill.getId(), newlevel), false);
				}
				else if(player.getSkillLevel(itemSkill.getId()) < itemSkill.getLevel())
				{
					player.addSkill(itemSkill, false);
					if(itemSkill.isActive())
					{
						long reuseDelay = Formulas.calcSkillReuseDelay(player, itemSkill);
						reuseDelay = Math.min(reuseDelay, 30000);
						if(reuseDelay > 0 && !player.isSkillDisabled(itemSkill.getId()))
							player.disableSkill(itemSkill.getId(), reuseDelay);
					}
				}

		if(enchant4Skill != null)
			player.addSkill(enchant4Skill, false);

		if(enchantdo4Skill != null)
			player.addSkill(enchantdo4Skill, false);
		if(enchantdo5Skill != null)
			player.addSkill(enchantdo5Skill, false);
		if(enchantdo6Skill != null)
			player.addSkill(enchantdo6Skill, false);
		if(enchantdo7Skill != null)
			player.addSkill(enchantdo7Skill, false);
		if(enchantdo71Skill != null)
			player.addSkill(enchantdo71Skill, false);
		if(enchantdo8Skill != null)
			player.addSkill(enchantdo8Skill, false);
		if(enchantdo81Skill != null)
			player.addSkill(enchantdo81Skill, false);
		if(enchantdo9Skill != null)
			player.addSkill(enchantdo9Skill, false);
		if(enchantdo91Skill != null)
			player.addSkill(enchantdo91Skill, false);
		if(enchantdo10Skill != null)
			player.addSkill(enchantdo10Skill, false);
		if(enchantdo101Skill != null)
			player.addSkill(enchantdo101Skill, false);
		
		if(itemSkills != null || enchant4Skill != null || enchantdo4Skill != null || enchantdo5Skill !=null || enchantdo6Skill !=null || enchantdo7Skill != null || enchantdo71Skill != null || enchantdo8Skill !=null ||  enchantdo81Skill !=null || enchantdo9Skill !=null || enchantdo91Skill !=null || enchantdo10Skill !=null || enchantdo101Skill !=null)
		{
			player.sendPacket(new SkillList(player));
			player.updateStats();
		}
	}
}