package l2ft.gameserver.serverpackets;

import l2ft.util.GArray;

public class AbnormalStatusUpdate extends L2GameServerPacket
{
	public static final int INFINITIVE_EFFECT = -1;
	private GArray<Effect> _effects;

	class Effect
	{
		int skillId;
		int dat;
		int duration;

		public Effect(int skillId, int dat, int duration)
		{
			this.skillId = skillId;
			this.dat = dat;
			this.duration = duration;
		}
	}

	public AbnormalStatusUpdate()
	{
		_effects = new GArray<Effect>();
	}

	public void addEffect(int skillId, int dat, int duration)
	{
		if (skillId == 2031 ||skillId == 2032 ||skillId == 2037 || skillId == 26025 || skillId == 26026)
			return;
		_effects.add(new Effect(skillId, dat, duration));
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x85);
		writeH(_effects.size());

		for(Effect temp : _effects)
		{
			writeD(temp.skillId);
			writeH(temp.dat);
			writeD(temp.duration);
		}
	}
}