package l2ft.gameserver.serverpackets;

import java.util.Calendar;
import java.util.List;

import l2ft.Config;
import l2ft.gameserver.itemmall.ItemMall;

public class ExBR_RecentProductListPacket extends L2GameServerPacket
{
    List<ItemMall.ItemMallItem> list;

    Calendar eventItemTime = Calendar.getInstance(); 
    int hour = eventItemTime.get(Calendar.HOUR_OF_DAY); 
    int min = eventItemTime.get(Calendar.MINUTE);
    
    public ExBR_RecentProductListPacket(int objId) {
        list = ItemMall.getInstance().getRecentListByOID(objId);
    }

    @Override
    protected void writeImpl() {
        writeC(0xFE);
        writeH(0xDC);
        writeD(list.size());
        for (ItemMall.ItemMallItem item : list) {
            writeD(item.template.brId);
            writeH(item.template.category);
            writeD(item.price);
            int cat = 0;
            if (item.iSale >= Config.IM_COUNT_TO_BEST)
            	cat = 2;
            switch (item.iCategory2) 
            {
            	case 0:
            		cat = 0; 
            		break;
            	case 1:
            		if(hour >= item.iStartHour && min >= item.iStartMin && hour <= item.iEndHour && min <= item.iEndMin) 
            			cat = 1; 
            		else 
            			cat = 0; 
            		break;
            }
            writeD(cat);
            if (item.iStartSale > 0 && item.iEndSale > 0) {
                writeD(item.iStartSale);
                writeD(item.iEndSale);
            } else {
                writeD(0x12CEDE40);
                writeD(0x7ECE3CD0);
            }
            writeC(0x7F);
            writeC(item.iStartHour);
            writeC(item.iStartMin);
            writeC(item.iEndHour);
            writeC(item.iEndMin);
            writeD(item.iStock);
            writeD(item.iMaxStock);
        }
    }
}