package l2ft.gameserver.serverpackets;

import l2ft.gameserver.model.TradeItem;
import l2ft.util.GArray;

public class ExBuySellList_Buy extends L2GameServerPacket
{
	private final GArray<TradeItem> _Buylist;
	private final long _money;
	private final int _listId;
	private final double _TaxRate;
	private final double _markup;

	public ExBuySellList_Buy(GArray<TradeItem> Buylist, int listId, long money, double TaxRate, double markup)
	{
		_Buylist = Buylist;
		_listId = listId;
		_money = money;
		_TaxRate = TaxRate;
		_markup = markup;
	}

	protected final void writeImpl()
	{
		writeC(EXTENDED_PACKET);
		writeH(0xB7);
		writeD(0);

		writeQ(_money);
		writeD(_listId);

		if (_Buylist == null) 
		{
			writeH(0);
		}
		else
		{
			writeH(_Buylist.size());
			for (TradeItem item : _Buylist)
			{
				writeItem(item, true);
				writeQ(Math.round(item.getOwnersPrice() > 0L ? item.getItem().getReferencePrice() * (1 + _markup + _TaxRate) : 0));
			}
		}
	}
}