package l2ft.gameserver.serverpackets;

import l2ft.gameserver.model.instances.L2NpcInstance;

/**
 * @author : Ragnarok
 * @date : 19.12.10    15:40
 */
public class ExChangeNpcState extends L2GameServerPacket {
    public static final int NO_STATE = 0;//Ничего нет
    public static final int STATE1 = 1;//Красное пламя для npc 18928
    public static final int STATE2 = 2;//Зеленое пламя
    public static final int STATE3 = 3;//Синее пламя

    int objId;
    int state;
    private boolean can_writeImpl = false;

    public ExChangeNpcState(int id, int _state) 
    {
        objId = id;
        state = _state;
    }

    public ExChangeNpcState(L2NpcInstance npc)
    {
    	objId = npc.getObjectId();
    	state = npc.getNpcState();
    	if (state > 0)
    		can_writeImpl = true;
    }
    

    @Override
    protected void writeImpl() 
    {
    	if (!this.can_writeImpl) 
    	{
    		return;
    	}
        writeC(0xFE);
        writeH(0xBE);
        writeD(objId);
        writeD(state);
    }

	@Override
	public String getType()
	{
		return "[S] FE:BE ExChangeNpcState";
	}
}
