package l2ft.gameserver.serverpackets;

import java.util.Map;

import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.items.L2PremiumItem;

public class ExGetPremiumItemList extends L2GameServerPacket
{
	private L2Player _activeChar;
	private Map<Integer, L2PremiumItem> _list;

	public ExGetPremiumItemList(L2Player activeChar)
	{
		_activeChar = activeChar;
		_list = activeChar.getInventory().getPremiumItemList();
	}

	@Override
	protected void writeImpl()
	{
		writeC(EXTENDED_PACKET);
		writeH(0x86);
		writeD(_list.size());
	    for (Integer num : _list.keySet())
	    {
	      L2PremiumItem item = _list.get(num);

	      writeD(num.intValue());
	      writeD(_activeChar.getObjectId());

	      writeD(item.getItemId());
	      writeQ(item.getCount());
	      writeD(0);
	      writeS(item.getSender());
	    }
	}
}