package l2ft.gameserver.serverpackets;

import java.util.Map;

import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.items.L2PremiumItem;

public class ExGetPremiumItemListPacket extends L2GameServerPacket {
    private L2Player _activeChar;

    private Map<Integer, L2PremiumItem> _list;

    public ExGetPremiumItemListPacket(L2Player activeChar) {
        _activeChar = activeChar;

       // _list = _activeChar.getPremiumItemList();
    }

    @Override
    protected void writeImpl() {
        writeC(0xFE);
        writeH(0x86);
        if (!_list.isEmpty()) {
            writeD(_list.size());

            for (Integer num : _list.keySet()) {
                L2PremiumItem item = _list.get(num);

                writeD(num);
                writeD(_activeChar.getObjectId());
                writeD(item.getItemId());
                writeQ(item.getCount());
                writeD(0);
                writeS(item.getSender());
            }
        }
    }
}
