package l2ft.gameserver.serverpackets;

import l2ft.gameserver.model.entity.olympiad.Olympiad;
import l2ft.gameserver.model.entity.olympiad.OlympiadGame;
import l2ft.util.GArray;

public class ExOlympiadMatchList extends L2GameServerPacket
{
	private GArray<OlympiadGame> _games;

	public ExOlympiadMatchList()
	{
		for (OlympiadGame game : Olympiad.getOlympiadGames().values())
			if (game != null && game.getState() > 0)
			{
				if (_games == null)
					_games = new GArray<OlympiadGame>();
				_games.add(game);
			}
	}

	protected final void writeImpl()
	{
		writeC(EXTENDED_PACKET);
		writeH(0xd4);
		writeD(0);

		writeD(_games != null ? _games.size() : 0);
		writeD(0);

		if (_games != null)
		for (OlympiadGame game : _games)
		{
			if ((game != null) && (game.getState() > 0))
			{
				writeD(game.getGameId());

				switch (game.getType())
				{
					case CLASSED:
						writeD(2);
						break;
					case NON_CLASSED:
						writeD(1);
						break;
					case TEAM_RANDOM:
					case TEAM:
						writeD(-1);
						break;
					default:
						writeD(0);
				}

				writeD(game.getState());
				writeS((game.getTeam1().getMembers().get(0)).getName());
				writeS((game.getTeam2().getMembers().get(0)).getName());
			}
		}
	}
}