package l2ft.gameserver.serverpackets;

import java.util.List;

public class ExOlympiadMatchResult extends L2GameServerPacket
{
	private String _winnerName;
	private List<MatchResultMemberInfo> team1members;
	private List<MatchResultMemberInfo> team2members;

	public static class MatchResultMemberInfo
	{
		public String name;
		public String clanName;
		public int clanId;
		public int classId;
		public int damage;
		public int points;
		public int pointsDiff;

		public MatchResultMemberInfo(String _name, String _clanName, int _clanId, int _classId, int _damage, int _points, int _pointsDiff)
		{
			name = _name;
			clanName = _clanName;
			clanId = _clanId;
			classId = _classId;
			damage = _damage;
			points = _points;
			pointsDiff = _pointsDiff;
		}
	}
  
	public ExOlympiadMatchResult(String winner, List<MatchResultMemberInfo> _team1members, List<ExOlympiadMatchResult.MatchResultMemberInfo> _team2members)
	{
		_winnerName = winner;
		team1members = _team1members;
		team2members = _team2members;
	}

	protected void writeImpl()
	{
		writeC(EXTENDED_PACKET);
		writeH(0xd4);
		writeD(1);
		writeD(0);
		writeS(_winnerName);

		writeD(1);
		writeD(team1members.size());
		for (MatchResultMemberInfo member : team1members)
		{
		writeS(member.name);
		writeS(member.clanName);
		writeD(member.clanId);
		writeD(member.classId);
		writeD(member.damage);
		writeD(member.points);
		writeD(member.pointsDiff);
		}

		writeD(2);
		writeD(team2members.size());
		for (MatchResultMemberInfo member : team2members)
		{
		writeS(member.name);
		writeS(member.clanName);
		writeD(member.clanId);
		writeD(member.classId);
		writeD(member.damage);
		writeD(member.points);
		writeD(member.pointsDiff);
		}
	}
}