package l2ft.gameserver.serverpackets;

import l2ft.gameserver.model.L2Player;
import l2ft.util.GArray;

public class ExOlympiadSpelledInfo extends L2GameServerPacket
{
	private int char_obj_id;
	private GArray<Effect> _effects;

	public ExOlympiadSpelledInfo(L2Player player)
	{
		_effects = new GArray<Effect>();
		char_obj_id = player.getObjectId();
	}
	
	public void addEffect(int skillId, int level, int duration)
	{
		_effects.add(new Effect(skillId, level, duration));
  
	}

	public void addSpellRecivedPlayer(L2Player cha)
	{
		if (cha != null)
			char_obj_id = cha.getObjectId();
	}

	private static class Effect
	{
		protected int _skillId;
		protected int _level;
		protected int _duration;
		
		public Effect(int pSkillId, int pLevel, int pDuration)
		{
			_skillId = pSkillId;
			_level = pLevel;
			_duration = pDuration;
		}
	}
  
	protected final void writeImpl()
	{
		if (char_obj_id == 0)
			return;
		writeC(EXTENDED_PACKET);
		writeH(0x7b);

		writeD(char_obj_id);
		writeD(_effects.size());
		for (Effect temp : _effects)
		{
			writeD(temp._skillId);
			writeH(temp._level);
			writeD(temp._duration);
		}
	}
}