package l2ft.gameserver.serverpackets;

import l2ft.gameserver.model.L2Player;

public class ExOlympiadUserInfo extends L2GameServerPacket
{
	private int _side;
	private int class_id;
	private int curHp;
	private int maxHp;
	private int curCp;
	private int maxCp;
	private int obj_id = 0;
	private String _name;

	public ExOlympiadUserInfo(L2Player player, int side)
	{
		_side = side;
		obj_id = player.getObjectId();
		class_id = player.getClassId().getId();
		_name = player.getName();
		curHp = (int)player.getCurrentHp();
		maxHp = player.getMaxHp();
		curCp = (int)player.getCurrentCp();
		maxCp = player.getMaxCp();
	}

	protected final void writeImpl()
	{
		writeC(EXTENDED_PACKET);
		writeH(0x7a);
		writeC(_side);
		writeD(obj_id);
		writeS(_name);
		writeD(class_id);
		writeD(curHp);
		writeD(maxHp);
		writeD(curCp);
		writeD(maxCp);
	}
}