package l2ft.gameserver.serverpackets;

import l2ft.gameserver.instancemanager.KrateisCubeManager;
import l2ft.gameserver.instancemanager.KrateisCubeManager.CCPlayer;

/**
 * Sent at the end of Krateis Cube OR when you click the "Match results" icon during
 * the match.
 */
public class ExPVPMatchCCRecord extends L2GameServerPacket
{
	private final int _state;
	private final CCPlayer[] _players;
	private String playername;
	private Integer kills;
	private static String[] SCBnames;
	private static Integer[][] SCBkills;

	public ExPVPMatchCCRecord(int state, CCPlayer[] players)
	{
		_state = state;
		_players = players;
	}

	@Override
	protected void writeImpl()
	{
		writeC(EXTENDED_PACKET);
		writeH(0x89);

		writeD(_state); // 0x01 - in progress, 0x02 - finished
		writeD(_players.length);

		//Sorting the scores
		SCBnames = KrateisCubeManager.scoreboardnames;
		SCBkills = KrateisCubeManager.scoreboardkills;
		for(int i = 0; i <= 23; i++)
			if(SCBkills[i][1] < SCBkills[i + 1][1])
			{
				playername = SCBnames[i];
				SCBnames[i] = SCBnames[i + 1];
				SCBnames[i + 1] = playername;
				kills = SCBkills[i][1];
				SCBkills[i][1] = SCBkills[i + 1][1];
				SCBkills[i + 1][1] = kills;
				kills = SCBkills[i][0];
				SCBkills[i][0] = SCBkills[i + 1][0];
				SCBkills[i + 1][0] = kills;
				i = 0;
			}

		//Printing the scoreboard
		for(int i = 0; i <= 24; i++)
			if(SCBkills[i][0] > 0)
			{
				playername = SCBnames[i];
				kills = SCBkills[i][1];

				writeS(playername);
				writeD(kills);
			}

	}
}