package l2ft.gameserver.serverpackets;

import javolution.util.FastMap;
import l2ft.gameserver.model.L2Player;

public class ExShowContactList extends L2GameServerPacket
{
  private final FastMap<Integer, String> _contacts;

  public ExShowContactList(L2Player player)
  {
    this._contacts = player.getContactList().getContacts();
  }

  protected void writeImpl()
  {
	  writeC(EXTENDED_PACKET); // Id
	  writeH(0xd3); // SubId

    if ((this._contacts == null) || (this._contacts.size() < 1))
    {
      writeD(0);
      return;
    }

    writeD(this._contacts.size());

    for (String name : this._contacts.values())
      writeS(name);
  }
}