package l2ft.gameserver.serverpackets;

import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.items.L2ItemInstance;

public class ItemList extends L2GameServerPacket
{
	private final L2ItemInstance[] _items;
	private final boolean _showWindow;

	public ItemList(L2Player cha, boolean showWindow)
	{
		_items = cha.getInventory().getItems();
		_showWindow = showWindow;
	}

	public ItemList(L2ItemInstance[] items, boolean showWindow)
	{
		_items = items;
		_showWindow = showWindow;
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x11);
		writeH(_showWindow ? 1 : 0);

		writeH(_items.length);
		for(L2ItemInstance temp : _items)
		{
			writeItem(temp);
		}

        writeH(0x00);//TODO: Block Items length
        writeC(0x00);//TODO: Block Mode
        // for(;;) {
        //    writeD(0x00);//Id to block
        //}
	}
}