package l2ft.gameserver.serverpackets;

import java.util.TreeSet;
import java.util.concurrent.ConcurrentLinkedQueue;

import l2ft.gameserver.model.items.L2ItemInstance;

public class SellList extends L2GameServerPacket
{
    private byte done;
    private TreeSet<L2ItemInstance> sellList;
    private ConcurrentLinkedQueue<L2ItemInstance> refundList;

    public SellList(byte done, TreeSet<L2ItemInstance> sellList, ConcurrentLinkedQueue<L2ItemInstance> refundList) {
        this.done = done;
        this.sellList = sellList;
        this.refundList = refundList;
    }

    @Override
    protected final void writeImpl() {
        writeC(0xFE);
        writeH(0xB7);
        writeD(0x01);

        writeH(sellList.size());

        for (L2ItemInstance item : sellList) {
            writeD(item.getObjectId());
            writeD(item.getItemId());
            writeD(item.getEquipSlot());
            writeQ(item.getCount());
            writeH(item.getItem().getType2ForPackets());
            writeH(item.getCustomType1());
            writeH(item.isEquipped() ? 1 : 0);
            writeD(item.getBodyPart());
            writeH(item.getEnchantLevel());
            writeH(item.getCustomType2());
            writeD(item.getAugmentationId());
            writeD(item.isShadowItem() ? item.getLifeTimeRemaining() : -1);
            writeD(item.isTemporalItem() ? item.getLifeTimeRemaining() : 0x00);
            writeItemElements(item);
            //три значения энчант эффекта
            writeEnchantEffect(item);
            writeQ(item.getItem().getReferencePrice() / 2);
        }

        writeH(refundList.size());

		for(L2ItemInstance item : refundList)
		{
			writeD(item.getObjectId());
			writeD(item.getItemId());
			writeD(item.getEquipSlot());
			writeQ(item.getCount());
			writeH(item.getItem().getType2());
			writeH(item.getCustomType1());
			writeH(item.isEquipped() ? 1 : 0);
			writeD(item.getBodyPart());
			writeH(item.getEnchantLevel());
			writeH(item.getCustomType2());
			writeD(item.getAugmentationId());
			writeD(item.isShadowItem() ? item.getLifeTimeRemaining() : -1);
			writeD(item.isTemporalItem() ? item.getLifeTimeRemaining() : 0x00);

			writeItemElements(item);
			writeEnchantEffect(item);
			writeD(item.getObjectId());
			writeQ(item.getItem().getReferencePrice() / 2 * item.getCount());
		}
		writeC(done);
	}
}