package l2ft.gameserver.serverpackets;

import java.util.TreeSet;

import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.items.Inventory;
import l2ft.gameserver.model.items.L2ItemInstance;
import l2ft.gameserver.model.items.Warehouse.WarehouseType;

public class WareHouseDepositList extends L2GameServerPacket
{
	private int _whtype;
	private long char_adena;
	private TreeSet<L2ItemInstance> _itemslist = new TreeSet<L2ItemInstance>(Inventory.OrderComparator);

	public WareHouseDepositList(L2Player cha, WarehouseType whtype)
	{
		cha.setUsingWarehouseType(whtype);
		_whtype = whtype.getPacketValue();
		char_adena = cha.getAdena();
		for(L2ItemInstance item : cha.getInventory().getItems())
			if(item != null && item.canBeStored(cha, _whtype == 1))
				_itemslist.add(item);
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x41);
		writeH(_whtype);
		writeQ(char_adena);
		writeH(_itemslist.size());
		for(L2ItemInstance temp : _itemslist)
		{
            writeD(temp.getObjectId());
            writeD(temp.getItemId());
            writeD(0x00);
            writeQ(temp.getCount());
            writeH(temp.getItem().getType2ForPackets());
            writeH(0x00);
            writeH(temp.getCustomType1());
            writeD(temp.getItem().getBodyPart());
            writeH(temp.getEnchantLevel());
            writeH(temp.getCustomType2());
            writeD(temp.getAugmentationId());
            writeD(temp.isShadowItem() ? temp.getLifeTimeRemaining() : -1);
            writeD(temp.isTemporalItem() ? temp.getLifeTimeRemaining() : 0x00); // limited time item life remaining
			writeItemElements(temp);
			writeEnchantEffect(temp);
            writeD(temp.getObjectId());
		}
	}
}