package l2ft.gameserver.skills.effects;

import static l2ft.gameserver.ai.CtrlIntention.AI_INTENTION_ACTIVE;
import l2ft.gameserver.ai.CtrlIntention;
import l2ft.gameserver.model.L2Effect;
import l2ft.gameserver.model.L2Summon;
import l2ft.gameserver.model.instances.L2MinionInstance;
import l2ft.gameserver.model.instances.L2MonsterInstance;
import l2ft.gameserver.skills.Env;

public class EffectBetray extends L2Effect
{
	public EffectBetray(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	@Override
	public boolean checkCondition()
	{
		if(!(_effected instanceof L2Summon || _effected instanceof L2MinionInstance))
			return false;
		return super.checkCondition();
	}

	@Override
	public void onStart()
	{
		super.onStart();
		if(_effected instanceof L2Summon)
		{
			L2Summon summon = (L2Summon) _effected;
			summon.setPossessed(true);
			summon.getAI().Attack(summon.getPlayer(), true, false);
		}
		else if(_effected instanceof L2MinionInstance)
		{
			_effected.startConfused();
			onActionTime();
		}
	}

	@Override
	public void onExit()
	{
		super.onExit();
		if(_effected instanceof L2Summon)
		{
			L2Summon summon = (L2Summon) _effected;
			summon.setPossessed(false);
			summon.getAI().setIntention(AI_INTENTION_ACTIVE);
		}
		else if(_effected instanceof L2MinionInstance)
		{
			_effected.stopConfused();
			_effected.setWalking();
			_effected.getAI().setIntention(CtrlIntention.AI_INTENTION_ACTIVE);
		}
	}

	@Override
	public boolean onActionTime()
	{
		if(_effected instanceof L2MinionInstance)
		{
			L2MonsterInstance leader = ((L2MinionInstance) _effected).getLeader();
			if(leader != null)
			{
				_effected.setRunning();
				_effected.getAI().Attack(leader, true, false);
			}
		}
		return false;
	}
}