package l2ft.gameserver.skills.effects;

import l2ft.gameserver.model.L2Effect;
import l2ft.gameserver.model.L2Object;
import l2ft.gameserver.model.L2World;
import l2ft.gameserver.skills.AbnormalEffect;
import l2ft.gameserver.skills.Env;

public final class EffectImobileBuff extends L2Effect
{
	public EffectImobileBuff(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	@Override
	public boolean checkCondition()
	{
		if (_effector.getEffectList().getEffectsBySkillId(368) != null)
		{
			for(L2Object object : L2World.getAroundObjects(_effector, _skill.getSkillRadius(), 100))
			{
				if (object.isMonster() || (object.isPlayer() && object.getPlayer().getPvpFlag() > 0))
				{ 
					return super.checkCondition();
				}
			}
			return false;
		}
		return super.checkCondition();
	}
	
	@Override
	public void onStart()
	{
		super.onStart();
		_effected.startAbnormalEffect(AbnormalEffect.SOUL_SHOCK);
		_effected.setImobilised(true);
	}

	@Override
	public void onExit()
	{
		super.onExit();
		_effected.stopAbnormalEffect(AbnormalEffect.SOUL_SHOCK);
		_effected.setImobilised(false);
	}

	@Override
	public boolean onActionTime()
	{
		return false;
	}
}



