package l2ft.gameserver.skills.effects;

import l2ft.gameserver.cache.Msg;
import l2ft.gameserver.model.L2Effect;
import l2ft.gameserver.serverpackets.SystemMessage;
import l2ft.gameserver.skills.Env;
import l2ft.gameserver.skills.Stats;

public class EffectLDManaDamOverTime extends L2Effect
{
	public EffectLDManaDamOverTime(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	@Override
	public boolean onActionTime()
	{
		if(_effected.isDead())
			return false;

		double manaDam = calc();
		if(!getSkill().isOffensive())
			if(getSkill().isMagic())
				manaDam = _effected.calcStat(Stats.MP_MAGIC_SKILL_CONSUME, manaDam, null, getSkill());
			else
				manaDam = _effected.calcStat(Stats.MP_PHYSICAL_SKILL_CONSUME, manaDam, null, getSkill());

		manaDam *= _effected.getLevel() / 2.4;

		if(manaDam > _effected.getCurrentMp() && getSkill().isToggle())
		{
			_effected.sendPacket(Msg.NOT_ENOUGH_MP);
			_effected.sendPacket(new SystemMessage(SystemMessage.THE_EFFECT_OF_S1_HAS_BEEN_REMOVED).addSkillName(getSkill().getId(), getSkill().getDisplayLevel()));
			return false;
		}

		_effected.reduceCurrentMp(manaDam, null);
		return true;
	}
}