package l2ft.gameserver.skills.effects;

import l2ft.gameserver.model.L2Effect;
import l2ft.gameserver.skills.Env;
import l2ft.gameserver.skills.Formulas;
import l2ft.gameserver.skills.Formulas.AttackEnv;
import l2ft.gameserver.skills.Formulas.AttackInfo;

public class EffectPDam extends L2Effect
{
	private final int _power;
	private final int _critical;
	private final boolean _shieldIgnore;

	public EffectPDam(Env env, EffectTemplate template)
	{
		super(env, template);

		_power = template.getParam().getInteger("power", 0);
		_critical = template.getParam().getInteger("critical", 0);
		_shieldIgnore = template.getParam().getBool("shieldignore", false);
	}

	@Override
	public void onStart()
	{
		if (_effected != null && !_effected.isDead())
		{
			AttackEnv env = new AttackEnv();
			env.attacker = _effector;
			env.target = _effected;
			env.skill = getSkill();
			env.power = _power;
			env.shieldIgnore = _shieldIgnore;
			env.skillCritRate = _critical;

			AttackInfo info = Formulas.calcPhysDam(env);

			if ((!info.miss) || (info.damage >= 1.0D))
				_effected.reduceCurrentHp(info.damage, _effector, getSkill(), true, true, false, true);
			_effected.doCounterAttack(getSkill(), _effector);
		}
	}

	@Override
	public boolean isOffensive()
	{
		return true;
	}

	@Override
	public boolean onActionTime()
	{
		return false;
	}
}