package l2ft.gameserver.skills.effects;

import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.L2Effect;
import l2ft.gameserver.model.L2Object;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.skills.Env;
import l2ft.gameserver.skills.Stats;
import l2ft.gameserver.skills.funcs.Func;

public class EffectServitorShare extends L2Effect
{
	public EffectServitorShare(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	public Func[] getStatFuncs()
	{
		return new Func[] 
		{ new Func(Stats.POWER_ATTACK, 64, this)
			{
				public void calc(Env env)
				{
					L2Player pc = env.character.getPlayer();
					if (pc != null)
					{
						L2Object target = env.character.getTarget();
						env.value += pc.getPAtk((L2Character)((target != null) && (target.isCharacter()) ? target : null)) * 0.5D;
					}
				}
			}
			, new Func(Stats.POWER_DEFENCE, 64, this)
			{
				public void calc(Env env)
				{
					L2Player pc = env.character.getPlayer();
					if (pc != null)
					{
						L2Object target = env.character.getTarget();
						env.value += pc.getPDef((L2Character)((target != null) && (target.isCharacter()) ? target : null)) * 0.5D;
					}
				}
			}
			, new Func(Stats.MAGIC_ATTACK, 64, this)
			{
				public void calc(Env env)
				{
					L2Player pc = env.character.getPlayer();
					if (pc != null)
					{
						L2Object target = env.character.getTarget();
						env.value += pc.getMAtk((L2Character)((target != null) && (target.isCharacter()) ? target : null), env.skill) * 0.25D;
					}
				}
			}
			, new Func(Stats.MAGIC_DEFENCE, 64, this)
			{
				public void calc(Env env)
				{
					L2Player pc = env.character.getPlayer();
					if (pc != null)
					{
						L2Object target = env.character.getTarget();
						env.value += pc.getMDef((L2Character)((target != null) && (target.isCharacter()) ? target : null), env.skill) * 0.25D;
					}
				}
			}
			, new Func(Stats.MAX_HP, 64, this)
			{
				public void calc(Env env)
				{
					L2Player pc = env.character.getPlayer();
					if (pc != null)
						env.value += pc.getMaxHp() * 0.1D;
				}
			}
			, new Func(Stats.MAX_HP, 64, this)
			{
				public void calc(Env env)
				{
					L2Player pc = env.character.getPlayer();
					if (pc != null)
						env.value += pc.getMaxMp() * 0.1D;
				}
			}
			, new Func(Stats.CRITICAL_BASE, 64, this)
			{
				public void calc(Env env)
				{
					L2Player pc = env.character.getPlayer();
					if (pc != null)
					{
						L2Object target = env.character.getTarget();
						env.value += pc.getCriticalHit((L2Character)((target != null) && (target.isCharacter()) ? target : null), env.skill) * 0.2D;
					}
				}
			}
			, new Func(Stats.POWER_ATTACK_SPEED, 64, this)
			{
				public void calc(Env env)
				{
					L2Player pc = env.character.getPlayer();
					if (pc != null)
						env.value += pc.getPAtkSpd() * 0.1D;
				}
			}
			, new Func(Stats.MAGIC_ATTACK_SPEED, 64, this)
			{
				public void calc(Env env)
				{
					L2Player pc = env.character.getPlayer();
					if (pc != null)
						env.value += pc.getMAtkSpd() * 0.03D;
				}
			}
		};
	}

	@Override
	public void onStart()
	{
		super.onStart();
		onActionTime();
	}

	@Override
	public void onExit()
	{
		super.onExit();
	}

	@Override
	public boolean onActionTime()
	{
		return false;
	}
}