package l2ft.gameserver.skills.skillclasses;

import javolution.util.FastMap;
import l2ft.common.ThreadPoolManager;
import l2ft.gameserver.model.L2Character;
import l2ft.gameserver.model.L2Clan;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.model.L2Skill;
import l2ft.gameserver.skills.AbnormalEffect;
import l2ft.gameserver.templates.StatsSet;
import l2ft.util.GArray;

public class ClanGate extends L2Skill
{
	public static FastMap<Integer, String> _clangate = new FastMap<Integer, String>().setShared(true);
	public ClanGate(final StatsSet set)
	{
		super(set);
	}

	@Override
	public void useSkill(final L2Character activeChar, final GArray<L2Character> targets)
	{
		L2Player player = activeChar.getPlayer();
		_clangate.put(player.getClanId(), player.getName());
        player.startAbnormalEffect(AbnormalEffect.MAGIC_CIRCLE);
		player.setParalyzed(true);
		
		L2Clan clan = player.getClan();
		for(L2Player clanMember : clan.getOnlineMembers(0))
		clanMember.sendMessage("Court Magician: Портал создан!");

		ThreadPoolManager.getInstance().scheduleAi(new Runnable(){
			@Override
			public void run()
			{
				L2Player player = activeChar.getPlayer();
				_clangate.remove(5555);
				player.setParalyzed(false);
		        player.stopAbnormalEffect(AbnormalEffect.MAGIC_CIRCLE);
			}
		}, 25000, true);
	}
}