package l2ft.gameserver.taskmanager.tasks;

import java.util.logging.Logger;
import l2ft.database.mysql;
import l2ft.gameserver.model.L2ObjectsStorage;
import l2ft.gameserver.model.L2Player;
import l2ft.gameserver.taskmanager.Task;
import l2ft.gameserver.taskmanager.TaskManager;
import l2ft.gameserver.taskmanager.TaskManager.ExecutedTask;
import l2ft.gameserver.taskmanager.TaskTypes;

public class TaskRecom extends Task
{
	private static final Logger _log = Logger.getLogger(TaskRecom.class.getName());
	private static final String NAME = "sp_recommendations";

	@Override
	public String getName()
	{
		return NAME;
	}

	@Override
	public void onTimeElapsed(ExecutedTask task)
	{
		_log.config("Recommendation Global Task: launched.");
		for(L2Player player : L2ObjectsStorage.getAllPlayers())
			player.getRecommendation().restartRecom();
		mysql.set("UPDATE `characters` SET `rec_timeleft`=3600");
		_log.config("Recommendation Global Task: completed.");
	}

	@Override
	public void initializate()
	{
		TaskManager.addUniqueTask(NAME, TaskTypes.TYPE_GLOBAL_TASK, "1", "6:30:00", "");
	}
}