package l2ft.gameserver.xml.parser;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;

import l2ft.Config;
import l2ft.Server;
import l2ft.database.DatabaseUtils;
import l2ft.database.FiltredPreparedStatement;
import l2ft.database.L2DatabaseFactory;
import l2ft.database.ThreadConnection;

import org.dom4j.Element;

/**
 * @author : Kekess
 * @date : 18.09.11    12:10
 */
public class DoorParser extends Parser
{
    public static void main(String[] args)
	{
		Server.SERVER_MODE = Server.MODE_LOGINSERVER;
		Config.load();
        initialize("./data/xxx/duurs");
        ThreadConnection con = null;
        FiltredPreparedStatement st = null;
        ResultSet rs = null;
        try {
            con = L2DatabaseFactory.getInstance().getConnection();
            st = con.prepareStatement("SELECT COUNT(*) FROM doors");
            rs = st.executeQuery();
            rs.next();
            int count = rs.getInt(1);
            DatabaseUtils.closeDatabaseSR(st, rs);
            st = con.prepareStatement("SELECT * FROM doors ORDER BY id");
            rs = st.executeQuery();
            int j = 0;
            while (rs.next())
				{
					j++;
					System.out.println("%");
					Element list = getListByItemId(rs.getInt("id"));
					Element recipes = list.addElement("door");
					//recipes.addComment("Done By Kekess (c)First Team");
					//recipes.addComment("LastChange: " + new SimpleDateFormat("dd.MM.yyyy-HH:mm").format(new Date(System.currentTimeMillis())));
					recipes.addAttribute("id", rs.getString("id"));
					recipes.addAttribute("name", rs.getString("name"));
					recipes.addAttribute("hp", rs.getString("hp"));
					recipes.addAttribute("pdef", rs.getString("pdef"));
					recipes.addAttribute("mdef", rs.getString("mdef"));
					recipes.addAttribute("unlockable", rs.getString("unlockable"));
					recipes.addAttribute("key", rs.getString("key"));
					recipes.addAttribute("level", rs.getString("level"));
					recipes.addAttribute("showHp", rs.getString("showHp"));
					recipes.addAttribute("posx", rs.getString("posx"));
					recipes.addAttribute("posy", rs.getString("posy"));
					recipes.addAttribute("posz", rs.getString("posz"));
					recipes.addAttribute("ax", rs.getString("ax"));
					recipes.addAttribute("ay", rs.getString("ay"));
					recipes.addAttribute("bx", rs.getString("bx"));
					recipes.addAttribute("by", rs.getString("by"));
					recipes.addAttribute("cx", rs.getString("cx"));
					recipes.addAttribute("cy", rs.getString("cy"));
					recipes.addAttribute("dx", rs.getString("dx"));
					recipes.addAttribute("dy", rs.getString("dy"));
					recipes.addAttribute("minz", rs.getString("minz"));
					recipes.addAttribute("maxz", rs.getString("maxz"));
					recipes.addAttribute("siege_weapon", rs.getString("siege_weapon"));
					recipes.addAttribute("geodata", rs.getString("geodata"));
				}
            saveAll("./data/xxx/duurs/", "\t", true);
        } catch (SQLException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            DatabaseUtils.closeDatabaseCSR(con, st, rs);
        }
    }
}
