package l2ft.gameserver.xml.parser;

import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;

import l2ft.Config;
import l2ft.Server;
import l2ft.database.DatabaseUtils;
import l2ft.database.FiltredPreparedStatement;
import l2ft.database.L2DatabaseFactory;
import l2ft.database.ThreadConnection;

import org.dom4j.Element;

/**
 * @author : Kekess
 * @date : 18.09.11    12:10
 */
public class RecipeParser extends Parser
{
    public static void main(String[] args)
	{
		Server.SERVER_MODE = Server.MODE_LOGINSERVER;
		Config.load();
        initialize("./data/stats/items/recipes");
        ThreadConnection con = null;
        FiltredPreparedStatement st = null;
        ResultSet rs = null;
        try {
            con = L2DatabaseFactory.getInstance().getConnection();
            st = con.prepareStatement("SELECT COUNT(*) FROM recipes");
            rs = st.executeQuery();
            rs.next();
            int count = rs.getInt(1);
            DatabaseUtils.closeDatabaseSR(st, rs);
            st = con.prepareStatement("SELECT * FROM recipes ORDER BY id");
            rs = st.executeQuery();
            int j = 0;
            while (rs.next()) {
                j++;
                System.out.println("%");
                Element list = getListByItemId(rs.getInt("id"));
                Element recipes = list.addElement("recipes");
                recipes.addComment("Done By Kekess (c)First Team");
                recipes.addComment("LastChange: " + new SimpleDateFormat("dd.MM.yyyy-HH:mm").format(new Date(System.currentTimeMillis())));
                recipes.addAttribute("id", rs.getString("id"));
                recipes.addAttribute("recipeName", rs.getString("name"));
				recipes.addAttribute("itemId", rs.getString("item"));
				recipes.addAttribute("foundation", rs.getString("foundation"));
				recipes.addAttribute("count", rs.getString("q"));
				recipes.addAttribute("level", rs.getString("lvl"));
				recipes.addAttribute("successRate", rs.getString("success"));
				recipes.addAttribute("recid", rs.getString("recid"));
				recipes.addAttribute("mp", rs.getString("mp"));
				recipes.addAttribute("exp", rs.getString("exp"));
				recipes.addAttribute("sp", rs.getString("sp"));
				recipes.addAttribute("dwarven", rs.getString("dwarven"));
            }
			FiltredPreparedStatement st2 = con.prepareStatement("SELECT * FROM recitems");
			ResultSet rs2 = st2.executeQuery();
			while(rs2.next()) {
				Element list = getListByItemId(rs2.getInt("rid"));
				Element recipes = null;
				for(Iterator<Element> i = list.elementIterator("recipes");i.hasNext();) 
				{
					Element e = i.next();
					if(e.attributeValue("id").equalsIgnoreCase(rs2.getString("rid"))) 
					{
						recipes = e;
						break;
					}
				}
				if(recipes != null) {
					Element recitem = recipes.addElement("recitem");
					recitem.addAttribute("item", rs2.getString("item"));
					recitem.addAttribute("icount", rs2.getString("q"));
					recitem.addAttribute("has_recipe", rs2.getString("has_recipe"));
				}
			}
			DatabaseUtils.closeDatabaseSR(st2, rs2);
            saveAll("./data/stats/items/recipes/", "\t", true);
        } catch (SQLException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            DatabaseUtils.closeDatabaseCSR(con, st, rs);
        }
    }
}
