package l2ft.util;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.logging.Logger;

import l2ft.Base64;
import l2ft.Config;

public class LicenseManager {

	private final static Logger _log = Logger.getLogger(LicenseManager.class.getSimpleName());

	private byte[] _keyMask = {0x25,0x64,0x12,0x01,0x2f,0x48,0x73,0x39};
	private String key = null;
	private String keyt = null;
	private static String[] _sites = {
		"http://www.first-team.ru/license/npgmup.php"
	};

	private String[] _localIps = {
			"127.0.0.1",
			"localhost"
	};

	final String serverKey = Config.OWNER_NAME + Config.GAMESERVER_HOSTNAME + Config.EXTERNAL_HOSTNAME;

	private static LicenseManager _instance;

	public static LicenseManager getInstance() throws IOException {
		return _instance == null ? _instance = new LicenseManager() : _instance;
	}

	private LicenseManager() throws IOException {
		checkServer();
	}

	public int getOnlineServer()
	{
		return Integer.parseInt(keyt);
	}

	private void checkServer() {
		BufferedReader reader = null;
		for(String s : _sites)
			try {
				for(String s1 : _localIps) { 
					if (s == s1) { 
						System.out.println("Your license is a demo. Please contact to developers - http://first-team.ru"); 
						Config.MAXIMUM_ONLINE_USERS = 200; 
						return; 
					} 
				} 
				URL url = new URL(s + "?" + Base64.encodeBytes(Config.OWNER_NAME.getBytes()) + "&" + Config.EXTERNAL_HOSTNAME + "&" + Config.LICENSE_KEY);
				reader = new BufferedReader(new InputStreamReader(url.openStream()));
				break;
			} catch(Exception e) {
				reader = null;
			}
			if(reader == null) {
				System.out.println("The developer's site is unavailable. Please contact to developers - http://first-team.ru");
				Config.MAXIMUM_ONLINE_USERS = 200;
			}
			try {
				String line;
				while ((line = reader.readLine()) != null )
				{
					String result = new String(Base64.decode(line), "UTF-8");
					if(result.startsWith("Key="))
					{
						key = result.substring(4).trim();
						String keyt = new String(Base64.decode(key), "UTF-8");
						Config.MAXIMUM_ONLINE_USERS = Integer.parseInt(keyt);
						break;
					}
				}
				if(keyt == null )
					throw new Exception();
			} catch(Exception e) {
				System.out.println("Your license is a demo. Please contact to developers - http://first-team.ru");
				Config.MAXIMUM_ONLINE_USERS = 200;
				return;
			}
		}

	private void makeServerKey() throws IOException {
		if(Config.LICENSE_KEY.equals(Base64.encodeBytes(Base64.encodeBytes(getKey(serverKey, _keyMask)).getBytes())))
			return;
		else if(checkExternal() && checkInternal() && checkHostname())
			return;
		else {
			System.out.println("Wrong license key, or IP is not allowed! Please contact to developers - http://first-team.ru");
			Config.MAXIMUM_ONLINE_USERS = 200;
		}
	}

	/**
	 * @param key
	 * @param mask
	 * @return bytes
	 */
	private byte[] getKey(String key, byte[] mask) {
		byte[] bytes = key.getBytes();
		int len = key.length();
		for (int i = 0; i < len; i++)
			bytes[i] = (byte)(bytes[i] ^ (mask[i&7] & 0xff));
		return bytes;
	}

	private boolean checkExternal() {
		for(String ip : _localIps)
			if(Config.EXTERNAL_HOSTNAME.equals(ip))
				return true;
		return false;
	}

	private boolean checkInternal() {
		for(String ip : _localIps)
			if(Config.INTERNAL_HOSTNAME.equals(ip))
				return true;
		return false;
	}

	private boolean checkHostname() {
		for(String ip : _localIps)
			if(Config.GAMESERVER_HOSTNAME.equals(ip))
				return true;
		return false;
	}
}