DROP TABLE IF EXISTS `npc`;
CREATE TABLE `npc` (
  `ordinal` smallint(4) unsigned NOT NULL DEFAULT '0',
  `id` int(11) unsigned NOT NULL DEFAULT '0',
  `name` varchar(45) DEFAULT NULL,
  `title` varchar(35) NOT NULL,
  `class` varchar(50) DEFAULT NULL,
  `collision_radius` decimal(5,2) DEFAULT NULL,
  `collision_height` decimal(5,2) DEFAULT NULL,
  `level` int(11) NOT NULL DEFAULT '1',
  `sex` varchar(6) NOT NULL DEFAULT 'male',
  `type` varchar(30) NOT NULL DEFAULT 'L2Npc',
  `ai_type` varchar(50) NOT NULL DEFAULT 'npc',
  `attackrange` int(11) NOT NULL DEFAULT '40',
  `hp` int(11) NOT NULL DEFAULT '2444',
  `base_hp_regen` double(11,3) NOT NULL DEFAULT '7.500',
  `mp` int(11) NOT NULL DEFAULT '2444',
  `base_mp_regen` double(11,3) NOT NULL DEFAULT '2.700',
  `str` int(11) NOT NULL DEFAULT '40',
  `con` int(11) NOT NULL DEFAULT '43',
  `dex` int(11) NOT NULL DEFAULT '30',
  `int` int(11) NOT NULL DEFAULT '21',
  `wit` int(11) NOT NULL DEFAULT '20',
  `men` int(11) NOT NULL DEFAULT '10',
  `exp` int(11) NOT NULL DEFAULT '0',
  `sp` int(11) NOT NULL DEFAULT '0',
  `patk` int(11) NOT NULL DEFAULT '500',
  `pdef` int(11) NOT NULL DEFAULT '500',
  `matk` int(11) NOT NULL DEFAULT '500',
  `mdef` int(11) NOT NULL DEFAULT '500',
  `atkspd` int(11) NOT NULL DEFAULT '253',
  `aggro` int(11) NOT NULL DEFAULT '0',
  `matkspd` int(11) NOT NULL DEFAULT '500',
  `rhand` int(11) NOT NULL DEFAULT '0',
  `lhand` int(11) NOT NULL DEFAULT '0',
  `armor` int(11) NOT NULL DEFAULT '0',
  `walkspd` int(11) NOT NULL DEFAULT '110',
  `runspd` int(11) NOT NULL DEFAULT '180',
  `faction_id` varchar(40) NOT NULL,
  `faction_range` int(11) NOT NULL DEFAULT '0',
  `displayId` int(11) NOT NULL DEFAULT '0',
  `shield_defense_rate` int(11) NOT NULL DEFAULT '0',
  `shield_defense` int(11) NOT NULL DEFAULT '0',
  `corpse_time` int(11) NOT NULL DEFAULT '7',
  `base_rand_dam` int(11) NOT NULL DEFAULT '30',
  `base_critical` int(11) NOT NULL DEFAULT '4',
  `physical_hit_modify` int(11) NOT NULL DEFAULT '4',
  `base_reuse_delay` int(11) NOT NULL DEFAULT '0',
  `physical_avoid_modify` int(11) NOT NULL DEFAULT '0',
  `hit_time_factor` double(11,2) NOT NULL DEFAULT '0.60',
  `isDropHerbs` enum('false','true') NOT NULL DEFAULT 'true',
  `shots` enum('NONE','SOUL','SPIRIT','BSPIRIT','SOUL_SPIRIT','SOUL_BSPIRIT') NOT NULL DEFAULT 'NONE',
  `map_flag` tinyint(1) NOT NULL DEFAULT '0',
  `boss_flag` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `map_flag` (`map_flag`,`boss_flag`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `npc` VALUES (10055, 1, 'Thomas D. Turkey', '', 'LineageMonster4.br_crazy_turkey', 25.00, 35.00, 80, 'male', 'L2Npc', 'npc', 40, 680, 0.000, 2000, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 14, 101400, 10, 338000, 253, 0, 506, 0, 0, 0, 20, 160, '', 1000, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10056, 2, 'br_xmas_invisible_npc', '', 'LineageNPC.clear_npc', 0.10, 0.10, 80, 'male', 'L2Npc', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10057, 3, 'Santas Helper', '', 'LineageNPC.e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10058, 4, 'Holiday Santa', '', 'LineageNPC2.br_xmas08_santa', 8.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10059, 5, 'Holiday Santa', '', 'LineageNPC2.br_xmas08_santa', 8.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10060, 6, 'Holiday Sled', '', 'LineageNPC2.br_xmas08_sled', 0.01, 50.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 10, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10061, 7, 'Birthday Cake', '', 'LineageNPC2.br_birthday_cake', 0.01, 0.01, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 10, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10062, 8, 'Spirit of Fire', '', 'LineageMonster4.br_fire_elemental', 16.00, 22.00, 1, 'male', 'L2Npc', 'npc', 40, 20000000, 0.000, 40, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 7, 36, 5, 27, 253, 0, 506, 0, 0, 0, 25, 120, '', 300, 0, 0, 0, 12, 50, 1, 18, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10063, 9, 'Explosive Spirit of Fire', '', 'LineageMonster4.br_fire_elemental_of_fierce', 26.00, 35.00, 1, 'male', 'L2Npc', 'npc', 40, 20000000, 0.000, 40, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 7, 36, 5, 27, 253, 0, 506, 0, 0, 0, 45, 180, '', 300, 0, 0, 0, 12, 50, 1, 18, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10064, 10, 'Jack Sage', '', 'LineageNPC2.br_archbishop_of_eva', 8.00, 26.50, 85, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 723, 10, 1199, 515, 818, 378, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10065, 11, 'Evas Obelisk', '', 'LineageNPC2.br_obelisk_of_eva', 40.00, 120.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 10, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10066, 12, 'br_fire_manager', '', 'LineageNPC.clear_npc', 0.10, 0.10, 80, 'male', 'L2Npc', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10067, 13, 'Warm Hearted Sno', '', 'LineageNPC2.br_tp_actor', 9.00, 16.30, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 4, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10068, 14, 'Warm Hearted Sno', '', 'LineageNPC2.br_tp_actor', 9.00, 16.30, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 4, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10069, 15, 'Warm Hearted Sno', '', 'LineageNPC2.br_tp_actor', 9.00, 16.30, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 4, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10070, 16, 'Warm Hearted Sno', '', 'LineageNPC2.br_tp_actor', 9.00, 16.30, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 4, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10071, 17, 'Warm Hearted Sno', '', 'LineageNPC2.br_tp_actor', 9.00, 16.30, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 4, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10072, 18, 'Warm Hearted Sno', '', 'LineageNPC2.br_tp_actor', 9.00, 16.30, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 4, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10073, 19, 'Wooldy', '', 'LineageMonster5.br_wooldie', 10.00, 16.00, 80, 'male', 'L2Npc', 'npc', 40, 20000000, 8.500, 40, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 14, 68, 10, 51, 253, 0, 506, 0, 0, 0, 25, 120, '', 0, 0, 0, 0, 12, 50, 1, 18, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10074, 20, 'Verdandi', '', 'LineageMonster5.br_berdandi', 10.00, 14.00, 80, 'male', 'L2Npc', 'npc', 40, 20000000, 8.500, 40, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 14, 68, 10, 51, 253, 0, 506, 0, 0, 0, 45, 180, '', 0, 0, 0, 0, 12, 50, 1, 18, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10075, 21, 'Skooldy', '', 'LineageMonster5.br_scooldie', 10.00, 16.00, 80, 'male', 'L2Npc', 'npc', 40, 20000000, 8.500, 40, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 14, 68, 10, 51, 253, 0, 506, 0, 0, 0, 45, 180, '', 0, 0, 0, 0, 12, 50, 1, 18, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10076, 22, 'Lucky Sky Lantern', '', 'LineageNPC2.br_lamp', 4.20, 5.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 10, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 10, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10077, 23, 'Ambience Sky Lantern', '', 'LineageNPC2.br_lamp_a', 4.20, 5.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 10, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 10, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10078, 24, 'Sway Sky Lantern', '', 'LineageNPC2.br_lamp_b', 4.20, 5.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 10, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 10, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10079, 25, 'Comfort Sky Lantern', '', 'LineageNPC2.br_lamp_c', 4.20, 5.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 10, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 10, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10080, 26, 'Halloween Event Manager', '', 'LineageNPC.clear_npc', 0.10, 0.10, 80, 'male', 'L2Npc', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10081, 27, 'Kadomas', '', 'LineageNPC2.br_kadomatsu', 24.50, 14.00, 80, 'male', 'L2Npc', 'npc', 40, 1673, 0.000, 890, 0.900, 40, 43, 30, 21, 20, 25, 0, 0, 14, 101400, 10, 338000, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10082, 28, 'Kotatz', '', 'etc', 0.01, 0.01, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 1164, 500, 794, 367, 253, 1000, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10083, 29, 'Flame Box', '', 'etc', 11.00, 12.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 10, 490, 10, 1096, 471, 747, 345, 253, 1000, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10084, 30, 'Santa', '', 'dwarf', 8.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 490, 10, 1096, 471, 747, 345, 253, 1000, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10085, 31, 'br_xmas2009_invisible', '', 'construct', 0.10, 0.10, 80, 'male', 'L2Npc', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10086, 32, 'Jet Bike', '', 'LineageNPC2.br_z_bike', 30.00, 29.00, 80, 'male', 'L2Npc', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10087, 33, 'Trejuo', '', 'human', 10.00, 13.00, 80, 'male', 'L2Npc', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10088, 4309, 'Prophet', 'Sinister', 'human', 8.00, 23.00, 80, 'male', 'L2Npc', 'AdeptGiran', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 50, 50, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10089, 4310, 'Prophet', 'Sinister', 'human', 8.00, 23.00, 80, 'male', 'L2Npc', 'AdeptAden', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 50, 50, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10090, 4311, 'Prophet', 'Sinister', 'human', 8.00, 23.00, 80, 'male', 'L2Npc', 'AdeptRune', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 50, 50, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10091, 4312, 'Prophet', 'Sinister', 'human', 8.00, 23.00, 80, 'male', 'L2Npc', 'AdeptGludio', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 50, 50, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9962, 1501, 'Majo Agathion', '', 'LineageNPC2.br_agathion_mazu', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9963, 1502, 'Gold Agathion', '', 'LineageNPC2.br_agathion_mazu', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9964, 1503, 'Black Agathion', '', 'LineageNPC2.br_agathion_mazu', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9965, 1504, 'Plaipitak Agathion', '', 'LineageNPC2.br_agathion_elephant', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9966, 1505, 'Baby Panda Agathion', '', 'LineageNPC2.br_agathion_bpanda', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9967, 1506, 'Bamboo Panda Agathion', '', 'LineageNPC2.br_agathion_mpanda', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9968, 1507, 'Sexy Panda Agathion', '', 'LineageNPC2.br_agathion_wpanda', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9969, 1508, 'White Cupid Agathion', '', 'LineageNPC2.br_agathion_wcupid', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9970, 1509, 'Dark Cupid Agathion', '', 'LineageNPC2.br_agathion_dcupid', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9971, 1510, 'White Maneki Neko Agathion', '', 'LineageNPC2.br_agathion_maneki', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9972, 1511, 'Black Maneki Neko Agathion', '', 'LineageNPC2.br_agathion_maneki', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9973, 1512, 'Brown Maneki Neko Agathion', '', 'LineageNPC2.br_agathion_maneki', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9974, 1513, 'One-Eyed Bat Drove Agathion', '', 'LineageNPC2.br_agathion_bat', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9975, 1514, 'Pegasus Agathion', '', 'LineageNPC2.br_agathion_pegasus', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9976, 1515, 'Yellow-Robed Tojigong Agathion', '', 'LineageNPC2.br_agathion_tozi', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9977, 1516, 'Blue-Robed Tojigong Agathion', '', 'LineageNPC2.br_agathion_tozi', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9978, 1517, 'Green-Robed Tojigong Agathion', '', 'LineageNPC2.br_agathion_tozi', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9979, 1518, 'Bugbear Agathion', '', 'LineageNPC2.br_agathion_bugbear', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9980, 1519, 'Red Sumo Wrestler Agathion', '', 'LineageNPC2.br_agathion_redsumo', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9981, 1520, 'Blue Sumo Wrestler Agathion', '', 'LineageNPC2.br_agathion_bluesumo', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9982, 1521, 'Great Sumo Match Agathion', '', 'LineageNPC2.br_agathion_match', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9983, 1522, 'Button-Eyed Bear Doll', '', 'LineageNPC2.br_agathion_bear', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9984, 1523, 'God of Fortune', '', 'LineageNPC2.br_agathion_wealthgod', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9985, 1524, 'Dryad Agathion', '', 'LineageNPC2.br_agathion_dryad', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9986, 1525, 'Wonboso Agathion', '', 'LineageNPC2.br_agathion_cashcow', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9987, 1526, 'Daewoonso Agathion', '', 'LineageNPC2.br_agathion_luckycow', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9988, 1527, 'Pomona Agathion', '', 'LineageNPC2.br_agathion_pomona', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9989, 1528, 'Weaver Agathion', '', 'LineageNPC2.br_agathion_womanweaver', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9990, 1529, 'Chon-chon Agathion', '', 'LineageNPC2.br_agathion_luckygirl', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9991, 1530, 'Tang-tang Agathion', '', 'LineageNPC2.br_agathion_luckyboy', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9992, 1531, 'Dancing Lucky Kid Agathion ', '', 'LineageNPC2.br_agathion_dancingchild', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9993, 1532, 'Monkey King Agathion', '', 'LineageNPC2.br_agathion_sunwukong', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9994, 1533, 'Utanka Agathion', '', 'LineageNPC2.br_agathion_uthanka', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9995, 1534, 'Bonus B Agathion', '', 'LineageNPC2.br_agathion_bonus', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9996, 1535, 'Zombie Agathion', '', 'LineageNPC2.br_agathion_gangsi', 7.00, 6.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9997, 1536, 'Baekyi Hwamae Agathion', '', 'LineageNPC2.br_agathion_bluebird', 6.00, 5.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9998, 1537, 'Gwanwoo Hwamae Agathion', '', 'LineageNPC2.br_agathion_hatbird', 6.00, 5.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9999, 1538, 'Baby Rudolph', '', 'LineageNPC2.br_pet_rudolf', 21.50, 27.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 35, 37, 30, 32, 20, 25, 0, 0, 559, 86400, 382, 28800, 253, 0, 506, 0, 0, 0, 35, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10000, 1539, 'Iken Agathion', '', 'LineageNPC2.br_local_JP_Mfighter', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10001, 1540, 'Lana Agathion', '', 'LineageNPC2.br_local_JP_FFighter', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10002, 1541, 'Gnocian Agathion', '', 'LineageNPC2.br_local_JP_MElf', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10003, 1542, 'Orodriel Agathion', '', 'LineageNPC2.br_local_JP_Felf', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10004, 1543, 'Lakinos Agathion', '', 'LineageNPC2.br_local_JP_MDarkelf', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10005, 1544, 'Mortia Agathion', '', 'LineageNPC2.br_local_JP_Fdarkelf', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10006, 1545, 'Hayance Agathion', '', 'LineageNPC2.br_local_JP_MDwarf', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10007, 1546, 'Meruril Agathion', '', 'LineageNPC2.br_local_JP_FDwarf', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10008, 1547, 'Taman ze Lapatui Agathion', '', 'LineageNPC2.br_local_JP_MOrc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10009, 1548, 'Kaurin Agathion', '', 'LineageNPC2.br_local_JP_FOrc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10010, 1549, 'Ahertbein Agathion', '', 'LineageNPC2.br_local_JP_MKamael', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10011, 1550, 'Naonin Agathion', '', 'LineageNPC2.br_local_JP_FKamael', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10012, 1551, 'Guangong Agathion', '', 'LineageNPC2.br_aga_warriorgod', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10013, 1552, 'Gwanseum Nyang Nyang Agathion', '', 'LineageNPC2.br_aga_mercygod', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10014, 1553, 'Blue Opera Agathion', '', 'LineageNPC2.br_aga_blue_pekingopera', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10015, 1554, 'Red Opera Agathion', '', 'LineageNPC2.br_aga_red_pekingopera', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10016, 1555, 'Opera Agathion', '', 'LineageNPC2.br_aga_redblue_pekingopera', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10017, 1556, 'Mandarin Dress Agathion', '', 'LineageNPC2.br_aga_chinesedress', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10018, 1557, 'Nepal Snow Agathion', '', 'LineageNPC2.br_aga_suno_trumpet', 10.50, 12.50, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10019, 1558, 'Round Ball Snow Agathion', '', 'LineageNPC2.br_aga_suno_ball', 15.00, 20.50, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10020, 1559, 'Ladder Snow Agathion', '', 'LineageNPC2.br_aga_suno_tall', 20.00, 28.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10021, 1560, 'Blue Opera Agathion', '', 'LineageNPC2.br_aga_blue_pekingopera', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10022, 1561, 'Baby Rudolph', '', 'LineageNPC2.br_pet_rudolf', 21.50, 27.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 35, 37, 30, 32, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 35, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10023, 1562, 'Deseloph', '', 'LineageNPC2.br_pet_rose_lover_m_a', 13.20, 16.90, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 35, 37, 30, 32, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10024, 1563, 'Hyum', '', 'LineageNPC2.br_pet_rose_lover_m_a', 13.20, 16.90, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.67, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10025, 1564, 'Rekang', '', 'LineageNPC2.br_pet_rose_lover_m_a', 13.20, 16.90, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 38, 40, 30, 26, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 20, 180, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10026, 1565, 'Lilias', '', 'LineageNPC2.br_pet_rose_lover_f_a', 14.50, 17.50, 55, 'female', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 38, 40, 30, 26, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 20, 180, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10027, 1566, 'Lapham', '', 'LineageNPC2.br_pet_rose_lover_f_a', 14.50, 17.50, 55, 'female', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 38, 40, 30, 26, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 20, 180, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10028, 1567, 'Mafum', '', 'LineageNPC2.br_pet_rose_lover_f_a', 14.50, 17.50, 55, 'female', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 38, 40, 30, 26, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 20, 180, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10029, 1568, 'Deseloph', '', 'LineageNPC2.br_pet_rose_lover_m_b', 15.30, 16.60, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 38, 40, 30, 26, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 20, 180, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10030, 1569, 'Hyum', '', 'LineageNPC2.br_pet_rose_lover_m_b', 15.30, 16.60, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 38, 40, 30, 26, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 20, 180, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10031, 1570, 'Rekang', '', 'LineageNPC2.br_pet_rose_lover_m_b', 15.30, 16.60, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 38, 40, 30, 26, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 20, 180, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10032, 1571, 'Lilias', '', 'LineageNPC2.br_pet_rose_lover_f_b', 14.70, 17.30, 55, 'female', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 38, 40, 30, 26, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 20, 180, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10033, 1572, 'Lapham', '', 'LineageNPC2.br_pet_rose_lover_f_b', 14.70, 17.30, 55, 'female', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 38, 40, 30, 26, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 20, 180, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10034, 1573, 'Mafum', '', 'LineageNPC2.br_pet_rose_lover_f_b', 14.70, 17.30, 55, 'female', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 38, 40, 30, 26, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 20, 180, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10035, 1574, 'Phoenix', '', 'LineageNPC2.br_aga_china_phoenix', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10036, 1575, 'Three-headed Dragon', '', 'etc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10037, 1576, 'Ball Trapping Gnosian', '', 'etc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10038, 1577, 'Ball Trapping Orodriel', '', 'etc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10039, 1578, 'Penalty Kick', '', 'etc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10040, 1579, 'Ball Trapping Gnosian', '', 'etc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10041, 1580, 'Ball Trapping Orodriel', '', 'etc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10042, 1581, 'Penalty Kick', '', 'etc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10043, 1582, 'Ball Trapping Gnosian', '', 'etc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10044, 1583, 'Ball Trapping Orodriel', '', 'etc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10045, 1584, 'Penalty Kick', '', 'etc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10046, 1585, 'Granny Tiger ', '', 'etc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10047, 1586, 'Flower Fairy Spirit', '', 'etc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10048, 1587, 'Cheerleader Orodriel', '', 'etc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10049, 1588, 'Cheerleader Lana', '', 'etc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10050, 1589, 'Cheerleader Naonin', '', 'etc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10051, 1590, 'Cheerleader Mortia', '', 'etc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10052, 1591, 'Cheerleader Kaurin', '', 'etc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10053, 1592, 'Cheerleader Meruril', '', 'etc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (10054, 1593, 'Handy', '', 'etc', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9956, 4301, 'Queen of Hearts', '', 'LineageMonster2.queen_of_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 26, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9957, 4302, 'Master Dugi', '', NULL, 9.00, 16.70, 1, 'female', 'L2Npc', 'npc', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9958, 4303, 'Skooldy', '', NULL, 10.00, 16.00, 85, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 723, 10, 1199, 515, 818, 378, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9959, 4304, 'Santa', '', 'dwarf', 8.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 490, 10, 1096, 471, 747, 345, 253, 1000, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9960, 4305, 'Rosalia', '', 'LineageNPC2.message_event_master', 10.00, 20.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9961, 4306, 'Steve Shyagel', '', 'LineageNPC2.br_archbishop_of_eva', 8.00, 26.50, 85, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 723, 10, 1199, 515, 818, 378, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9648, 12077, 'Wolf', '', 'pet_wolf', 13.00, 11.50, 15, 'male', 'L2Pet', 'npc', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 25, 0, 0, 31, 77, 21, 56, 253, 0, 506, 0, 0, 0, 24, 125, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9649, 12311, 'Hatchling of the Wind', '', 'hatchling', 9.00, 10.00, 35, 'male', 'L2Pet', 'npc', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 25, 0, 0, 160, 170, 109, 124, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.27, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9650, 12312, 'Hatchling of the Stars', '', 'hatchling', 9.00, 10.00, 35, 'male', 'L2Pet', 'npc', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 25, 0, 0, 160, 170, 109, 124, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.27, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9651, 12313, 'Hatchling of Twilight', '', 'hatchling', 9.00, 10.00, 35, 'male', 'L2Pet', 'npc', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 25, 0, 0, 160, 170, 109, 124, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.27, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9652, 12526, 'Wind Strider', '', 'strider', 23.00, 31.00, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 80, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.25, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9653, 12527, 'Star Strider', '', 'strider', 23.00, 31.00, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 80, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.25, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9654, 12528, 'Twilight Strider', '', 'strider', 23.00, 31.00, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 80, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.25, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9655, 12564, 'Sin Eater', '', 'imp', 10.00, 24.00, 15, 'male', 'L2Pet', 'npc', 40, 424, 7.251, 149, 1.200, 40, 1, 30, 21, 20, 25, 0, 0, 31, 77, 21, 56, 253, 0, 506, 0, 0, 0, 60, 125, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9656, 12621, 'Wyvern', '', 'wyvern', 60.00, 80.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9660, 12774, 'Young Squash', '', 'drop_gourd_50_sm', 10.00, 10.50, 1, 'etc', 'Squash', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 10, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9661, 12775, 'High Quality Squash', '', 'drop_gourd', 23.00, 25.00, 1, 'etc', 'Squash', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 10, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9662, 12776, 'Low Quality Squash', '', 'drop_gourd_25_sm', 15.00, 16.00, 1, 'etc', 'Squash', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 10, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9663, 12777, 'Large Young Squash', '', 'drop_gourd', 23.00, 25.00, 1, 'etc', 'Squash', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 10, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9664, 12778, 'High Quality Large Squash', '', 'drop_gourd_50_bi', 34.00, 40.00, 1, 'etc', 'Squash', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 10, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9665, 12779, 'Low Quality Large Squash', '', 'drop_gourd_25_bi', 28.00, 31.00, 1, 'etc', 'Squash', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 10, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9657, 12780, 'Baby Buffalo', '', 'baby_buffalo', 12.00, 15.00, 25, 'male', 'L2Pet', 'npc', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 25, 0, 0, 74, 116, 50, 86, 253, 0, 506, 0, 0, 0, 30, 120, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9658, 12781, 'Baby Kookaburra', '', 'baby_ostrich', 7.00, 15.00, 25, 'male', 'L2Pet', 'npc', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 25, 0, 0, 74, 116, 50, 86, 253, 0, 506, 0, 0, 0, 13, 120, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9659, 12782, 'Baby Cougar', '', 'baby_tiger', 11.00, 15.70, 25, 'male', 'L2Pet', 'npc', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 25, 0, 0, 74, 116, 50, 86, 253, 0, 506, 0, 0, 0, 28, 120, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9666, 13001, 'Heart of Warding', '', 'heart_of_warding', 17.00, 120.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 10, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (9667, 13002, 'Life Control Tower', '', 'alive_castle_aden_controltower_jewel', 7.00, 35.00, 20, 'etc', 'L2ControlTower', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 10, 40, 10, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9668, 13003, 'Life Control Tower', '', 'dead_castle_aden_controltower_jewel', 7.00, 35.00, 20, 'etc', 'L2FakeTower', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 10, 40, 10, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9669, 13004, 'Flame Control Tower', '', 'alive_castle_aden_controltower_jewel', 7.00, 35.00, 20, 'etc', 'L2ControlTower', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 10, 40, 10, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9670, 13005, 'Flame Control Tower', '', 'dead_castle_aden_controltower_jewel', 7.00, 35.00, 20, 'etc', 'L2FakeTower', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 10, 40, 10, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9671, 13006, 'Christmas Tree', '', 'x_mas_tree', 0.01, 0.01, 70, 'male', 'L2XmassTree', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 10, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9672, 13007, 'Special Christmas Tree', '', 'x_mas_tree_50_bi', 0.01, 0.01, 70, 'male', 'L2XmassTree', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 10, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9673, 13014, 'effect_for_valakas', '', 'clear_npc', 0.10, 0.10, 85, 'male', 'L2Npc', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 10, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 1, 160, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9674, 13015, 'triol_camera', '', 'Evilate_weather', 16.00, 18.50, 85, 'female', 'L2Npc', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 10, 1, 'andreas_clan', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9675, 13016, 'King Squash', '', 'drop_gourd', 23.00, 25.00, 1, 'etc', 'Squash', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 10, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9676, 13017, 'Emperor Squash', '', 'drop_gourd_50_bi', 34.00, 40.00, 1, 'etc', 'Squash', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 10, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9677, 13018, 'skill_defence_up', '', 'skill_dummy_00_a', 5.00, 10.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9678, 13019, 'skill_anti_song_dance', '', 'skill_dummy_00_a', 5.00, 10.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9679, 13020, 'skill_abnormal_resist', '', 'skill_dummy_00_a', 5.00, 10.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9680, 13021, 'skill_cp_regen', '', 'skill_dummy_00_a', 5.00, 10.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9681, 13022, 'skill_energy_up', '', 'skill_dummy_00_a', 5.00, 10.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9682, 13023, 'skill_bow_hit_up', '', 'skill_dummy_00_a', 5.00, 10.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9683, 13024, 'skill_avoid_up', '', 'skill_dummy_00_a', 5.00, 10.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9684, 13025, 'skill_fire_dd', '', 'skill_dummy_01_a', 5.00, 10.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9685, 13026, 'skill_water_dd', '', 'skill_dummy_01_a', 5.00, 10.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9686, 13027, 'skill_wind_dd', '', 'skill_dummy_01_a', 5.00, 10.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9687, 13028, 'skill_multi_debuff', '', 'skill_dummy_01_a', 5.00, 10.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9688, 13029, 'skill_unholy_dd', '', 'skill_dummy_01_a', 5.00, 10.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9689, 13030, 'skill_anti_summon', '', 'skill_dummy_01_a', 5.00, 10.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9690, 13031, 'Huge Pig', '', 'E_pig_ball', 15.00, 18.30, 80, 'male', 'L2Npc', 'npc', 40, 680, 0.000, 2000, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 14, 101400, 10, 338000, 253, 0, 506, 0, 0, 0, 60, 160, 'pig_clan', 1000, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9691, 13032, 'Huge Pig', '', 'E_pig_ball', 15.00, 18.30, 80, 'male', 'L2Npc', 'npc', 40, 680, 0.000, 2000, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 14, 101400, 10, 338000, 253, 0, 506, 0, 0, 0, 60, 160, 'pig_clan', 1000, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9692, 13033, 'Huge Pig', '', 'E_pig_ball', 15.00, 18.30, 80, 'male', 'L2Npc', 'npc', 40, 680, 0.000, 2000, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 14, 101400, 10, 338000, 253, 0, 506, 0, 0, 0, 60, 160, 'pig_clan', 1000, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9693, 13034, 'Super Huge Pig', '', 'E_pig_ball_H', 29.00, 38.70, 80, 'male', 'L2Npc', 'npc', 40, 3400, 0.000, 6000, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 14, 101400, 10, 338000, 253, 0, 506, 0, 0, 0, 60, 160, 'pig_clan', 1000, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9694, 13035, 'Golden Pig', '', 'E_pig_ball', 15.00, 18.30, 80, 'male', 'L2Npc', 'npc', 40, 680, 0.000, 2000, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 14, 101400, 10, 338000, 253, 0, 506, 0, 0, 0, 60, 160, 'pig_clan', 1000, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9695, 13036, 'Alchemists Chest', '', 'mimic_even', 8.50, 8.50, 80, 'male', 'L2SpecialMonster', 'Fighter', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9696, 13037, 'Trap', '', 'trap_mark', 5.00, 10.00, 28, 'etc', 'L2Trap', 'npc', 40, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 95, 131, 64, 96, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9697, 13038, 'Trap', '', 'trap_mark', 5.00, 10.00, 36, 'etc', 'L2Trap', 'npc', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 173, 176, 118, 129, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9698, 13039, 'Trap', '', 'trap_mark', 5.00, 10.00, 43, 'etc', 'L2Trap', 'npc', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 277, 223, 189, 164, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9699, 13040, 'Trap', '', 'trap_mark', 5.00, 10.00, 49, 'etc', 'L2Trap', 'npc', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 400, 270, 273, 197, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9700, 13041, 'Trap', '', 'trap_mark', 5.00, 10.00, 55, 'etc', 'L2Trap', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9701, 13042, 'Trap', '', 'trap_mark', 5.00, 10.00, 60, 'etc', 'L2Trap', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9702, 13043, 'Trap', '', 'trap_mark', 5.00, 10.00, 64, 'etc', 'L2Trap', 'npc', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 860, 409, 588, 298, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9703, 13044, 'Trap', '', 'trap_mark', 5.00, 10.00, 68, 'etc', 'L2Trap', 'npc', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9704, 13045, 'Trap', '', 'trap_mark', 5.00, 10.00, 72, 'etc', 'L2Trap', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9705, 13046, 'Trap', '', 'trap_mark', 5.00, 10.00, 49, 'etc', 'L2Trap', 'npc', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 400, 270, 273, 197, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9706, 13047, 'Trap', '', 'trap_mark', 5.00, 10.00, 55, 'etc', 'L2Trap', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9707, 13048, 'Trap', '', 'trap_mark', 5.00, 10.00, 60, 'etc', 'L2Trap', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9708, 13049, 'Trap', '', 'trap_mark', 5.00, 10.00, 64, 'etc', 'L2Trap', 'npc', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 860, 409, 588, 298, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9709, 13050, 'Trap', '', 'trap_mark', 5.00, 10.00, 68, 'etc', 'L2Trap', 'npc', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9710, 13051, 'Trap', '', 'trap_mark', 5.00, 10.00, 72, 'etc', 'L2Trap', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9711, 13052, 'Trap', '', 'trap_mark', 5.00, 10.00, 55, 'etc', 'L2Trap', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9712, 13053, 'Trap', '', 'trap_mark', 5.00, 10.00, 60, 'etc', 'L2Trap', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9713, 13054, 'Trap', '', 'trap_mark', 5.00, 10.00, 64, 'etc', 'L2Trap', 'npc', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 860, 409, 588, 298, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9714, 13055, 'Trap', '', 'trap_mark', 5.00, 10.00, 68, 'etc', 'L2Trap', 'npc', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9715, 13056, 'Trap', '', 'trap_mark', 5.00, 10.00, 72, 'etc', 'L2Trap', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9716, 13057, 'Trap', '', 'trap_mark', 5.00, 10.00, 40, 'etc', 'L2Trap', 'npc', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 227, 203, 155, 148, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9717, 13058, 'Trap', '', 'trap_mark', 5.00, 10.00, 46, 'etc', 'L2Trap', 'npc', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 335, 246, 228, 180, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9718, 13059, 'Trap', '', 'trap_mark', 5.00, 10.00, 52, 'etc', 'L2Trap', 'npc', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 475, 296, 324, 216, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9719, 13060, 'Trap', '', 'trap_mark', 5.00, 10.00, 58, 'etc', 'L2Trap', 'npc', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 651, 350, 444, 256, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9720, 13061, 'Trap', '', 'trap_mark', 5.00, 10.00, 62, 'etc', 'L2Trap', 'npc', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 787, 388, 538, 284, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9721, 13062, 'Trap', '', 'trap_mark', 5.00, 10.00, 66, 'etc', 'L2Trap', 'npc', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 936, 429, 639, 313, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9722, 13063, 'Trap', '', 'trap_mark', 5.00, 10.00, 70, 'etc', 'L2Trap', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9723, 13064, 'Trap', '', 'trap_mark', 5.00, 10.00, 74, 'etc', 'L2Trap', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9724, 13065, 'Trap', '', 'trap_mark', 5.00, 10.00, 52, 'etc', 'L2Trap', 'npc', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 475, 296, 324, 216, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9725, 13066, 'Trap', '', 'trap_mark', 5.00, 10.00, 58, 'etc', 'L2Trap', 'npc', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 651, 350, 444, 256, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9726, 13067, 'Trap', '', 'trap_mark', 5.00, 10.00, 62, 'etc', 'L2Trap', 'npc', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 787, 388, 538, 284, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9727, 13068, 'Trap', '', 'trap_mark', 5.00, 10.00, 66, 'etc', 'L2Trap', 'npc', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 936, 429, 639, 313, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9728, 13069, 'Trap', '', 'trap_mark', 5.00, 10.00, 70, 'etc', 'L2Trap', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9729, 13070, 'Trap', '', 'trap_mark', 5.00, 10.00, 74, 'etc', 'L2Trap', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9730, 13071, 'Virtual Image', '', 'Decoy_Medium', 8.50, 25.00, 43, 'etc', 'L2Npc', 'npc', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 277, 223, 189, 164, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9731, 13072, 'Virtual Image', '', 'Decoy_Medium', 8.50, 25.00, 52, 'etc', 'L2Npc', 'npc', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 475, 296, 324, 216, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9732, 13073, 'Virtual Image', '', 'Decoy_Medium', 8.50, 25.00, 60, 'etc', 'L2Npc', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9733, 13074, 'Virtual Image', '', 'Decoy_Medium', 8.50, 25.00, 66, 'etc', 'L2Npc', 'npc', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 936, 429, 639, 313, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9734, 13075, 'Virtual Image', '', 'Decoy_Medium', 8.50, 25.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9735, 13076, 'Virtual Image', '', 'Decoy_Medium', 8.50, 25.00, 74, 'etc', 'L2Npc', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9736, 13077, 'Onyx Beast', '', 'onyx_beast', 12.00, 14.50, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.24, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9737, 13078, 'Doom Wraith', '', 'death_blader_tr', 13.00, 25.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 100, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9738, 13079, 'Grail Apostle', '', 'apostle_grail_tr', 10.00, 35.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9739, 13080, 'Grail Apostle', '', 'apostle_warrior', 8.00, 30.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9740, 13081, 'Unicorn', '', 'Unicorn_tr', 15.00, 28.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 46, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9741, 13082, 'Lilim Knight', '', 'lilim_knight_tr', 12.00, 25.50, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 56, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9742, 13083, 'Golem Guardian', '', 'golem_guardian_tr', 13.00, 25.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 53, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9743, 13084, 'Inferno Drake', '', 'inferno_drake_tr', 15.00, 24.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 57, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9744, 13085, 'Dragon Bomber', '', 'antaras_ex_b_tr', 16.00, 24.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 100, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9745, 13086, 'Zariche', '', 'Avatar_Z', 12.00, 31.57, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 8190, 0, 0, 80, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9746, 13087, 'Akamanah', '', 'Avatar_A', 10.00, 32.73, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 8689, 0, 0, 80, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9747, 13088, 'Final Form', '', 'Specular_Form', 9.00, 38.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9748, 13089, 'Final Form', '', 'Specular_Form_F', 10.00, 32.76, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9749, 13090, 'Native', '', 'a_common_peopleC_Mhuman', 10.00, 24.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9750, 13091, 'Yeti', '', 'yeti', 15.00, 27.50, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 80, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9751, 13092, 'Buffalo', '', 'buffalo', 22.00, 31.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 80, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9752, 13093, 'Pig', '', 'E_pig_ball', 15.00, 18.30, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9753, 13094, 'Zombie', '', 'zombie_laborer', 11.00, 24.60, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 36, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9754, 13095, 'Pixy', '', 'pixy', 5.00, 25.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 80, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9755, 13096, 'Rabbit', '', 'rabbit', 5.00, 4.50, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9756, 13097, 'event_search_thing', '', 'skill_dummy_00_a', 0.10, 0.10, 80, 'male', 'L2Npc', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9757, 13098, 'Event Treasure Chest', '', 'LineageMonster.mimic_even', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9758, 13099, 'Zaken', '', 'LineageMonster.zaken_tr', 16.00, 32.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 42, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9759, 13100, 'Anakim', '', 'LineageMonster2.anakim_tr', 15.50, 29.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 45, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9760, 13101, 'Benom', '', 'LineageMonster3.benom_tr', 20.00, 56.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 79, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9761, 13102, 'Gordon', '', 'LineageMonster3.Cruel_Rider_tr', 43.00, 46.60, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9762, 13103, 'Ranku', '', 'LineageMonster4.LaneCoo_tr', 13.00, 29.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 26, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9763, 13104, 'Kiyachi', '', 'LineageMonster4.Keyache_tr', 12.00, 29.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 26, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9764, 13105, 'Demon Prince', '', 'LineageMonster4.rahuu_tr', 33.00, 49.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.55, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9765, 13106, 'Heretic Male', '', 'LineageMonster3.heretic_privates_tr', 7.70, 28.40, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9766, 13107, 'Heretic Female', '', 'LineageMonster3.heretic_priest_tr', 8.00, 19.10, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9767, 13108, 'Vale master', '', 'LineageMonster.vale_master_tr', 12.00, 40.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 70, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9768, 13109, 'Saber Tooth Tiger', '', 'LineageMonster.saber_toothed_tiger_tr', 34.00, 28.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 8190, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9769, 13110, 'Ol Mahum', '', 'LineageMonster.oel_mahum_champion_tr', 23.00, 61.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 8689, 0, 0, 67, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9770, 13111, 'Doll Blader', '', 'LineageMonster.doll_blader_tr', 6.00, 12.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 22, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9771, 13112, 'Divine Knight', '', 'LineageMonster4.Divine_tanker', 16.00, 30.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 49, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9772, 13113, 'Divine Warrior', '', 'LineageMonster4.Divine_Warrior', 14.50, 29.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 46, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9773, 13114, 'Divine Rogue', '', 'LineageMonster4.Divine_Rogue', 10.00, 28.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.57, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9774, 13115, 'Divine Healer', '', 'LineageMonster4.Divine_healer', 10.00, 25.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9775, 13116, 'Divine Wizard', '', 'LineageMonster4.Divine_Wizard', 10.00, 26.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9776, 13117, 'Divine Enchanter', '', 'LineageMonster4.Divine_enchanter', 8.00, 18.25, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.53, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9777, 13118, 'Divine Summoner', '', 'LineageMonster4.Divine_healer', 10.00, 25.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9778, 13119, 'Dwarf Golem', '', 'LineageMonster3.chaos_golem_tr', 31.00, 51.80, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 18, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9779, 13120, 'Giant rat', '', 'LineageMonster4.little_mouse_120p', 15.00, 20.00, 80, 'male', 'L2Npc', 'VoteAnnouncer', 40, 680, 0.000, 2000, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 14, 101400, 10, 338000, 253, 0, 506, 0, 0, 0, 20, 160, 'rat_clan', 1000, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9780, 13121, 'Giant rat', '', 'LineageMonster4.little_mouse_120p', 15.00, 20.00, 80, 'male', 'L2Npc', 'npc', 40, 680, 0.000, 2000, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 14, 101400, 10, 338000, 253, 0, 506, 0, 0, 0, 20, 160, 'rat_clan', 1000, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9781, 13122, 'Giant rat', '', 'LineageMonster4.little_mouse_120p', 15.00, 20.00, 80, 'male', 'L2Npc', 'npc', 40, 680, 0.000, 2000, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 14, 101400, 10, 338000, 253, 0, 506, 0, 0, 0, 20, 160, 'rat_clan', 1000, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9782, 13123, 'Super giant rat', '', 'LineageMonster4.little_mouse_180p', 19.00, 33.00, 80, 'male', 'L2Npc', 'npc', 40, 3400, 0.000, 6000, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 14, 101400, 10, 338000, 253, 0, 506, 0, 0, 0, 29, 160, 'rat_clan', 1000, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9783, 13124, 'Giant rat', '', 'LineageMonster4.little_mouse_120p', 15.00, 20.00, 80, 'male', 'L2Npc', 'npc', 40, 680, 0.000, 2000, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 14, 101400, 10, 338000, 253, 0, 506, 0, 0, 0, 20, 160, 'rat_clan', 1000, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9784, 13125, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 64, 'etc', 'L2Npc', 'npc', 40, 2245, 0.000, 1220, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 12, 91800, 9, 306000, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9785, 13126, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 64, 'etc', 'L2Npc', 'npc', 40, 2444, 0.000, 1346, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 12, 91800, 9, 306000, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9786, 13127, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 68, 'etc', 'L2Npc', 'npc', 40, 2632, 0.000, 1475, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 13, 94200, 9, 314000, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9787, 13128, 'Golem Trader', '', 'LineageNPC.e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2Merchant', 'npc', 40, 2632, 0.000, 1475, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 13, 95400, 10, 318000, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9788, 13129, 'Teleporter', '', 'LineageNPC.a_teleporter_FHuman', 8.00, 25.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 0.000, 890, 0.900, 40, 43, 30, 21, 20, 25, 0, 0, 12, 86400, 9, 288000, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9789, 13130, 'Light Purple Maned Horse', '', 'LineageMonster4.gray_horse', 31.00, 32.50, 55, 'female', 'L2Npc', 'npc', 40, 1673, 0.000, 890, 0.900, 40, 43, 30, 21, 20, 25, 0, 0, 12, 86400, 9, 288000, 253, 0, 506, 0, 0, 0, 41, 180, '', 0, 0, 0, 0, 7, 10, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9790, 13131, 'Grizzly Bear', '', 'LineageMonster.grizzly', 21.00, 40.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 0.000, 890, 0.900, 40, 43, 30, 21, 20, 25, 0, 0, 12, 86400, 9, 288000, 253, 0, 506, 0, 0, 0, 40, 180, '', 0, 0, 0, 0, 7, 10, 1, 9, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9791, 13132, 'Timitran', '', 'LineageMonster.ti_mi_tran', 23.00, 90.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 0.000, 890, 0.900, 40, 43, 30, 21, 20, 25, 0, 0, 12, 86400, 9, 288000, 253, 0, 506, 0, 0, 0, 12, 180, '', 0, 0, 0, 0, 7, 10, 1, 9, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9792, 13133, 'Lava Golem', '', 'LineageMonster2.lava_golem', 38.00, 45.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 0.000, 890, 0.900, 40, 43, 30, 21, 20, 25, 0, 0, 12, 86400, 9, 288000, 253, 0, 506, 0, 0, 0, 13, 180, '', 0, 0, 0, 0, 7, 10, 1, 9, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9793, 13134, 'Yeti', '', 'LineageMonster.yeti_20_bi', 18.00, 32.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 0.000, 890, 0.900, 40, 43, 30, 21, 20, 25, 0, 0, 12, 86400, 9, 288000, 253, 0, 506, 0, 0, 0, 16, 180, '', 0, 0, 0, 0, 7, 10, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9794, 13135, 'Pumpkin Ghost', '', 'LineageNpc2.Pumpkin_Head_man', 12.00, 18.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 0.000, 890, 0.900, 40, 43, 30, 21, 20, 25, 0, 0, 12, 86400, 9, 288000, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9795, 13136, 'battle_banner_01', '', 'LineageNpcEV.battle_banner', 0.01, 36.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 0, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9796, 13137, 'battle_banner_02', '', 'LineageNpcEV.battle_banner', 0.01, 36.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 0, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9797, 13138, 'battle_banner_03', '', 'LineageNpcEV.battle_banner', 0.01, 36.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 0, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9798, 13139, 'battle_banner_04', '', 'LineageNpcEV.battle_banner', 0.01, 36.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 0, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9799, 13140, 'battle_banner_05', '', 'LineageNpcEV.battle_banner', 0.01, 36.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 0, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9800, 13141, 'battle_banner_06', '', 'LineageNpcEV.battle_banner', 0.01, 36.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 0, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9801, 13142, 'Final Form ', '', 'LineageMonster4.Specular_Form_air', 9.00, 38.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9802, 13143, 'Final Form ', '', 'LineageMonster4.Specular_Form_F_air', 10.00, 32.70, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9803, 13144, 'Aurabird-Falcon', '', 'LineageMonster4.closed_attacker', 38.00, 14.25, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 100, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9804, 13145, 'Aurabird-Owl', '', 'LineageMonster4.heavy_shooter', 40.00, 19.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 100, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9805, 13146, 'Tawny-Maned Lion', '', 'LineageMonster4.tawny_maned_lion', 25.00, 22.50, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 43, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9806, 13147, 'Steam Sledge', '', 'LineageMonster4.steam_sledge', 40.00, 27.50, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 40, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.70, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9807, 13148, 'Lindvior', '', 'LineageMonster4.lindvior_air', 190.00, 390.60, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 100, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9808, 13149, 'For Presentation 1', '', 'LineageNPC.clear_npc', 0.10, 0.10, 85, 'male', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 10, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 1, 160, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9809, 13150, 'For Presentation 2', '', 'LineageNPC.clear_npc', 0.10, 0.10, 85, 'male', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 10, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 1, 160, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9810, 13151, 'For Presentation 3', '', 'LineageNPC.clear_npc', 0.10, 0.10, 85, 'male', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 10, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 1, 160, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9811, 13152, 'For Presentation 4', '', 'LineageNPC.clear_npc', 0.10, 0.10, 85, 'male', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 10, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 1, 160, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9812, 13153, 'For Presentation 5', '', 'LineageNPC.clear_npc', 0.10, 0.10, 85, 'male', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 10, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 1, 160, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9813, 13154, 'Demon Race', '', 'LineageMonster4.summoner_demon_tr', 11.00, 27.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 25.44, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9814, 13155, 'Unicorniun', '', 'LineageMonster4.summoner_unicorn_tr', 8.00, 30.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9815, 13156, 'Myo Race', '', 'LineageMonster4.summoner_cat_tr', 10.00, 23.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 80, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9816, 13157, 'Frog', '', 'LineageMonster.poison_toad', 20.00, 10.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9817, 13158, 'Young Child', '', 'LineageNPC2.a_child_people_Mhuman', 5.00, 12.30, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 26, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9818, 13159, 'Mercenary', '', 'LineageNPC.a_fighterguild_master_Mhuman', 8.00, 23.50, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9819, 13160, 'Snowman', '', 'LineageNpc2.snow_man', 28.00, 30.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 20, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9820, 13161, 'Scarecrow', '', 'LineageNpc2.scarecrow', 13.00, 30.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 23, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9821, 13162, 'Tin Plate Golem', '', 'LineageNpc2.tin_golem', 13.00, 18.50, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 13, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9822, 13163, 'Tow', '', 'LineageNPC2.tow', 4.40, 8.25, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 155, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9823, 13164, 'Lure Tow', '', 'LineageNPC2.tow_lure', 4.40, 8.25, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 155, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9824, 13165, 'Heavy Tow', '', 'LineageNPC2.tow_heavy', 4.40, 8.25, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 165, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9825, 13166, 'Wing Tow', '', 'LineageNPC2.tow_whim', 4.40, 8.25, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 140, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9826, 13167, 'Main Role A', '', 'LineageNPC2.tp_actor', 9.00, 28.30, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 4, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9827, 13168, 'Main Role B', '', 'LineageNPC2.tp_actor', 9.00, 28.30, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 4, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9828, 13169, 'Human Male Mercenary', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9829, 13170, 'Male Elf Mercenary', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9830, 13171, 'Dark Elf Female Mercenary', '', 'LineageNPC.a_guard_FDarkelf', 7.00, 25.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9831, 13172, 'Orc Male Mercenary', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9832, 13173, 'Dwarf Male Mercenary', '', 'LineageNPC.e_guard_MDwarf', 8.00, 19.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9833, 13174, 'Kamael Male Mercenary', '', 'LineageNPC2.K_M1_guard', 13.00, 25.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 39, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9834, 13175, 'Knight Level Mercenary', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9835, 13176, 'Archer Level Mercenary', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 55, 'male', 'L2Npc', 'npc', 1100, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 15302, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9836, 13177, 'Wizard Level Mercenary', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 28, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9837, 13178, 'Trooper Level Mercenary', '', 'LineageNPC2.K_F1_guard_Master', 13.00, 22.50, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9838, 13179, 'Knight Leader Elite Mercenary', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 36, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9839, 13180, 'Commander Elite Mercenary', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9840, 13181, 'Treasure Box', '', 'LineageMonster.mimic_even', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9841, 13182, 'Free Gift Merchant', '', 'LineageMonster.silver_cat', 7.00, 15.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9842, 13183, 'Thomas D. Turkey', '', 'LineageNpc2.crazy_turkey', 25.00, 34.00, 80, 'female', 'Thomas', 'Thomas', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9843, 13184, 'Santa Claus', '', 'LineageNPC2.santa_claus', 10.00, 21.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 4, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9844, 13185, 'Santa Claus', '', 'LineageNPC2.santa_claus_120p', 12.00, 25.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 4, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9845, 13186, 'Santa Claus', '', 'LineageNPC2.santa_sled', 0.01, 50.00, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 55, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9846, 13187, 'Milk Cow', '', 'LineageMonster4.milk_cow', 16.00, 12.50, 85, 'male', 'L2Npc', 'npc', 40, 601, 0.000, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 104400, 10, 348000, 253, 0, 506, 0, 0, 0, 25, 120, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9847, 13188, 'Head Milk Cow', '', 'LineageMonster4.milk_cow_200p', 26.00, 28.50, 85, 'male', 'L2Npc', 'npc', 40, 7563, 0.000, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 104400, 10, 348000, 253, 0, 506, 0, 0, 0, 45, 180, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9848, 13189, 'Bull', '', 'LineageMonster4.yellow_cow', 16.00, 12.50, 85, 'male', 'L2Npc', 'npc', 40, 601, 0.000, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 104400, 10, 348000, 253, 0, 506, 0, 0, 0, 25, 120, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9849, 13190, 'Head Bull', '', 'LineageMonster4.yellow_cow_200p', 26.00, 28.50, 85, 'male', 'L2Npc', 'npc', 40, 7563, 0.000, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 104400, 10, 348000, 253, 0, 506, 0, 0, 0, 45, 180, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9850, 13191, 'Gloomy Milk Cow', '', 'LineageMonster4.milk_cow_e', 16.00, 12.50, 85, 'male', 'L2Npc', 'npc', 40, 601, 0.000, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 104400, 10, 348000, 253, 0, 506, 0, 0, 0, 25, 120, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9851, 13192, 'Gloomy Head Milk Cow', '', 'LineageMonster4.milk_cow_200p_e', 26.00, 28.50, 85, 'male', 'L2Npc', 'npc', 40, 7563, 0.000, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 104400, 10, 348000, 253, 0, 506, 0, 0, 0, 45, 180, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9852, 13193, 'obelisk_deco_npc', '', 'LineageNpcEV.obelisk_of_middle_square', 229.00, 177.50, 55, 'female', 'FakeObelisk', 'npc', 40, 1673, 0.000, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 1, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9853, 13194, 'event_cow_summoner1', '', 'LineageNPC.clear_npc', 0.10, 0.10, 85, 'male', 'L2Npc', 'npc', 40, 4234, 0.000, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 104400, 10, 348000, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9854, 13195, 'event_cow_summoner2', '', 'LineageNPC.clear_npc', 0.10, 0.10, 85, 'male', 'L2Npc', 'npc', 40, 4234, 0.000, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 104400, 10, 348000, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9855, 13196, 'Great Pig', '', 'LineageNPC2.E_pig_ball', 15.00, 18.30, 85, 'male', 'L2Npc', 'npc', 40, 7563, 0.000, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 104400, 10, 348000, 253, 0, 506, 0, 0, 0, 60, 120, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9856, 13197, 'Guardians Strider', '', NULL, 13.00, 40.00, 55, 'etc', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9857, 13198, 'Native', '', NULL, 10.00, 24.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9858, 13199, 'Native', '', NULL, 8.00, 20.50, 79, 'female', 'L2Npc', 'npc', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1562, 566, 1067, 415, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9859, 13200, 'Young Child', '', NULL, 5.00, 12.30, 79, 'female', 'L2Npc', 'npc', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1562, 566, 1067, 415, 253, 0, 506, 0, 0, 0, 24, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9860, 13201, 'Guards of the Dawn', '', NULL, 8.00, 21.50, 79, 'female', 'L2Npc', 'npc', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1562, 566, 1067, 415, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9861, 13202, 'Trap', '', NULL, 5.00, 10.00, 76, 'etc', 'L2Npc', 'npc', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9862, 13203, 'Trap', '', NULL, 5.00, 10.00, 77, 'etc', 'L2Npc', 'npc', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1421, 544, 971, 398, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9863, 13204, 'Trap', '', NULL, 5.00, 10.00, 78, 'etc', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9864, 13205, 'Trap', '', NULL, 5.00, 10.00, 79, 'etc', 'L2Npc', 'npc', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9865, 13206, 'Trap', '', NULL, 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9866, 13207, 'Trap', '', NULL, 5.00, 10.00, 81, 'etc', 'L2Npc', 'npc', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1720, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9867, 13208, 'Trap', '', NULL, 5.00, 10.00, 82, 'etc', 'L2Npc', 'npc', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9868, 13209, 'Trap', '', NULL, 5.00, 10.00, 83, 'etc', 'L2Npc', 'npc', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9869, 13210, 'Trap', '', NULL, 5.00, 10.00, 84, 'etc', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9870, 13211, 'Trap', '', NULL, 5.00, 10.00, 85, 'etc', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9871, 13212, 'Trap', '', NULL, 5.00, 10.00, 86, 'etc', 'L2Npc', 'npc', 40, 4440, 8.500, 1882, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2160, 641, 1475, 469, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9872, 13213, 'Trap', '', NULL, 5.00, 10.00, 76, 'etc', 'L2Npc', 'npc', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9873, 13214, 'Trap', '', NULL, 5.00, 10.00, 77, 'etc', 'L2Npc', 'npc', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1421, 544, 971, 398, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9874, 13215, 'Trap', '', NULL, 5.00, 10.00, 78, 'etc', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9875, 13216, 'Trap', '', NULL, 5.00, 10.00, 79, 'etc', 'L2Npc', 'npc', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9876, 13217, 'Trap', '', NULL, 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9877, 13218, 'Trap', '', NULL, 5.00, 10.00, 81, 'etc', 'L2Npc', 'npc', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1720, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9878, 13219, 'Trap', '', NULL, 5.00, 10.00, 82, 'etc', 'L2Npc', 'npc', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9879, 13220, 'Trap', '', NULL, 5.00, 10.00, 83, 'etc', 'L2Npc', 'npc', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9880, 13221, 'Trap', '', NULL, 5.00, 10.00, 84, 'etc', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9881, 13222, 'Trap', '', NULL, 5.00, 10.00, 85, 'etc', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9882, 13223, 'Trap', '', NULL, 5.00, 10.00, 86, 'etc', 'L2Npc', 'npc', 40, 4440, 8.500, 1882, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2160, 641, 1475, 469, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9883, 13224, 'Trap', '', NULL, 5.00, 10.00, 76, 'etc', 'L2Npc', 'npc', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9884, 13225, 'Trap', '', NULL, 5.00, 10.00, 77, 'etc', 'L2Npc', 'npc', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1421, 544, 971, 398, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9885, 13226, 'Trap', '', NULL, 5.00, 10.00, 78, 'etc', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9886, 13227, 'Trap', '', NULL, 5.00, 10.00, 79, 'etc', 'L2Npc', 'npc', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9887, 13228, 'Trap', '', NULL, 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9888, 13229, 'Trap', '', NULL, 5.00, 10.00, 81, 'etc', 'L2Npc', 'npc', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1720, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9889, 13230, 'Trap', '', NULL, 5.00, 10.00, 82, 'etc', 'L2Npc', 'npc', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9890, 13231, 'Trap', '', NULL, 5.00, 10.00, 83, 'etc', 'L2Npc', 'npc', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9891, 13232, 'Trap', '', NULL, 5.00, 10.00, 84, 'etc', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9892, 13233, 'Trap', '', NULL, 5.00, 10.00, 85, 'etc', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9893, 13234, 'Trap', '', NULL, 5.00, 10.00, 86, 'etc', 'L2Npc', 'npc', 40, 4440, 8.500, 1882, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2160, 641, 1475, 469, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9894, 13235, 'Trap', '', NULL, 5.00, 10.00, 76, 'etc', 'L2Npc', 'npc', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9895, 13236, 'Trap', '', NULL, 5.00, 10.00, 77, 'etc', 'L2Npc', 'npc', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1421, 544, 971, 398, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9896, 13237, 'Trap', '', NULL, 5.00, 10.00, 78, 'etc', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9897, 13238, 'Trap', '', NULL, 5.00, 10.00, 79, 'etc', 'L2Npc', 'npc', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9898, 13239, 'Trap', '', NULL, 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9899, 13240, 'Trap', '', NULL, 5.00, 10.00, 81, 'etc', 'L2Npc', 'npc', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1720, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9900, 13241, 'Trap', '', NULL, 5.00, 10.00, 82, 'etc', 'L2Npc', 'npc', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9901, 13242, 'Trap', '', NULL, 5.00, 10.00, 83, 'etc', 'L2Npc', 'npc', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9902, 13243, 'Trap', '', NULL, 5.00, 10.00, 84, 'etc', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9903, 13244, 'Trap', '', NULL, 5.00, 10.00, 85, 'etc', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9904, 13245, 'Trap', '', NULL, 5.00, 10.00, 86, 'etc', 'L2Npc', 'npc', 40, 4440, 8.500, 1882, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2160, 641, 1475, 469, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9905, 13246, 'Trap', '', NULL, 5.00, 10.00, 76, 'etc', 'L2Npc', 'npc', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9906, 13247, 'Trap', '', NULL, 5.00, 10.00, 77, 'etc', 'L2Npc', 'npc', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1421, 544, 971, 398, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9907, 13248, 'Trap', '', NULL, 5.00, 10.00, 78, 'etc', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9908, 13249, 'Trap', '', NULL, 5.00, 10.00, 79, 'etc', 'L2Npc', 'npc', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9909, 13250, 'Trap', '', NULL, 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9910, 13251, 'Trap', '', NULL, 5.00, 10.00, 81, 'etc', 'L2Npc', 'npc', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1720, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9911, 13252, 'Trap', '', NULL, 5.00, 10.00, 82, 'etc', 'L2Npc', 'npc', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9912, 13253, 'Trap', '', NULL, 5.00, 10.00, 83, 'etc', 'L2Npc', 'npc', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9913, 13254, 'Trap', '', NULL, 5.00, 10.00, 84, 'etc', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9914, 13255, 'Trap', '', NULL, 5.00, 10.00, 85, 'etc', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9915, 13256, 'Trap', '', NULL, 5.00, 10.00, 86, 'etc', 'L2Npc', 'npc', 40, 4440, 8.500, 1882, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2160, 641, 1475, 469, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9916, 13257, 'Virtual Image', '', 'Decoy_Medium', 8.50, 25.00, 76, 'etc', 'L2Npc', 'npc', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9917, 13258, 'Virtual Image', '', 'Decoy_Medium', 8.50, 25.00, 77, 'etc', 'L2Npc', 'npc', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1421, 544, 971, 398, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9918, 13259, 'Virtual Image', '', 'Decoy_Medium', 8.50, 25.00, 78, 'etc', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9919, 13260, 'Virtual Image', '', 'Decoy_Medium', 8.50, 25.00, 79, 'etc', 'L2Npc', 'npc', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9920, 13261, 'Virtual Image', '', 'Decoy_Medium', 8.50, 25.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9921, 13262, 'Virtual Image', '', 'Decoy_Medium', 8.50, 25.00, 81, 'etc', 'L2Npc', 'npc', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1720, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9922, 13263, 'Virtual Image', '', 'Decoy_Medium', 8.50, 25.00, 82, 'etc', 'L2Npc', 'npc', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9923, 13264, 'Virtual Image', '', 'Decoy_Medium', 8.50, 25.00, 83, 'etc', 'L2Npc', 'npc', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9924, 13265, 'Virtual Image', '', 'Decoy_Medium', 8.50, 25.00, 84, 'etc', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9925, 13266, 'Virtual Image', '', 'Decoy_Medium', 8.50, 25.00, 85, 'etc', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9926, 13267, 'Virtual Image', '', 'Decoy_Medium', 8.50, 25.00, 86, 'etc', 'L2Npc', 'npc', 40, 4440, 8.500, 1882, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2160, 641, 1475, 469, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9927, 13268, 'Aqua Elf', '', NULL, 12.00, 27.50, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9928, 13269, 'Hot Weather', '', NULL, 9.00, 14.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 17, 101400, 1120, 338000, 253, 0, 506, 0, 0, 0, 30, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9929, 13270, 'Sultriness', '', NULL, 30.00, 53.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 17, 101400, 1120, 338000, 253, 0, 506, 0, 0, 0, 30, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9930, 13271, 'Young Watermelon', '', 'etc', 11.00, 22.00, 1, 'etc', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 10, 0, 0, 7, 40, 5, 30, 253, 1000, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9931, 13272, 'Defective Watermelon', '', 'etc', 14.00, 30.00, 1, 'etc', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 10, 0, 0, 7, 40, 5, 30, 253, 1000, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9932, 13273, 'Rain Watermelon', '', 'etc', 17.00, 35.00, 1, 'etc', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 10, 0, 0, 7, 40, 5, 30, 253, 1000, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9933, 13274, 'Large Rain Watermelon', '', 'etc', 30.00, 65.00, 1, 'etc', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 10, 0, 0, 7, 40, 5, 30, 253, 1000, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9934, 13275, 'Young Honey Watermelon', '', 'etc', 10.00, 20.00, 1, 'etc', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 10, 0, 0, 7, 40, 5, 30, 253, 1000, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9935, 13276, 'Defective Honey Watermelon', '', 'etc', 20.00, 40.00, 1, 'etc', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 10, 0, 0, 7, 40, 5, 30, 253, 1000, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9936, 13277, 'Rain Honey Watermelon', '', 'etc', 26.00, 52.00, 1, 'etc', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 10, 0, 0, 7, 40, 5, 30, 253, 1000, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9937, 13278, 'Large Rain Honey Watermelon', '', 'etc', 30.00, 60.00, 1, 'etc', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 10, 0, 0, 7, 40, 5, 30, 253, 1000, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9938, 13279, 'Uldie', '', 'LineageMonster4.wooldie', 8.00, 17.00, 1, 'male', 'L2Npc', 'npc', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 10, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 18, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9939, 13280, 'Belldandy', '', 'LineageMonster4.berdandi', 9.00, 20.50, 1, 'male', 'L2Npc', 'npc', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 22, 174, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9940, 13281, 'Skooldie', '', 'LineageMonster4.scooldie', 8.00, 12.80, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 15, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9941, 13282, 'Skooldie', '', 'LineageMonster4.scooldie', 8.00, 12.80, 1, 'male', 'L2Npc', 'npc', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 15, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9942, 13283, 'Treykan', '', 'beast', 25.00, 27.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 88, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9943, 13284, 'recom_class_cheker3', '', 'construct', 0.10, 0.10, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9944, 13285, 'Santa Claus', '', 'LineageNPC2.santa_claus_120p', 12.00, 25.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9945, 13286, 'Baby White Tiger', '', 'beast', 8.00, 15.70, 85, 'male', 'L2Monster', 'Fighter', 40, 601, 0.000, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 104400, 10, 348000, 253, 0, 506, 0, 0, 0, 28, 120, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9946, 13287, 'Baby White Tiger Matriarch', '', 'beast', 22.00, 29.50, 85, 'male', 'L2Monster', 'Fighter', 40, 7563, 0.000, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 104400, 10, 348000, 253, 0, 506, 0, 0, 0, 28, 180, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9947, 13288, 'Gloomy Baby White Tiger', '', 'beast', 8.00, 15.70, 85, 'male', 'L2Monster', 'Fighter', 40, 601, 0.000, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 104400, 10, 348000, 253, 0, 506, 0, 0, 0, 28, 120, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9948, 13289, 'Gloomy Baby White Tiger Matriarch', '', 'beast', 22.00, 29.50, 85, 'male', 'L2Monster', 'Fighter', 40, 7563, 0.000, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 104400, 10, 348000, 253, 0, 506, 0, 0, 0, 28, 180, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9949, 13290, 'White Tiger', '', 'beast', 16.00, 17.20, 85, 'male', 'L2Monster', 'Fighter', 40, 601, 0.000, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 104400, 10, 348000, 253, 0, 506, 0, 0, 0, 60, 120, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9950, 13291, 'White Tiger Matriarch', '', 'beast', 50.00, 34.00, 85, 'male', 'L2Monster', 'Fighter', 40, 7563, 0.000, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 104400, 10, 348000, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9951, 13292, 'Employee of Magic Research Institute', '', 'dwarf', 8.00, 17.50, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 313, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9952, 13293, 'ev_tiger_summoner1', '', 'construct', 0.10, 0.10, 85, 'male', 'L2Monster', 'Fighter', 40, 4234, 0.000, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9953, 13294, 'ev_tiger_summoner2', '', 'construct', 0.10, 0.10, 85, 'male', 'L2Monster', 'Fighter', 40, 4234, 0.000, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9954, 13295, 'White Lady', '', 'dwarf', 8.00, 17.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9955, 13296, 'Freya', '', 'humanoid', 18.00, 36.00, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 54, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8683, 14001, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 46, 'male', 'L2Pet', 'npc', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 335, 246, 228, 180, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8684, 14002, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 54, 'male', 'L2Pet', 'npc', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 531, 313, 362, 229, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8685, 14003, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 62, 'male', 'L2Pet', 'npc', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 787, 388, 538, 284, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8686, 14004, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 66, 'male', 'L2Pet', 'npc', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 936, 429, 639, 313, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8687, 14005, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 70, 'male', 'L2Pet', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8688, 14006, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 74, 'male', 'L2Pet', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8689, 14007, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 76, 'male', 'L2Pet', 'npc', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8690, 14008, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 78, 'male', 'L2Pet', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8691, 14009, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 78, 'male', 'L2Pet', 'npc', 40, 2813, 8.500, 1616, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1438, 558, 982, 407, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8692, 14010, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 78, 'male', 'L2Pet', 'npc', 40, 2823, 8.500, 1624, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1446, 559, 987, 409, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8693, 14011, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 78, 'male', 'L2Pet', 'npc', 40, 2832, 8.500, 1633, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1455, 561, 992, 411, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8694, 14012, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 79, 'male', 'L2Pet', 'npc', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1470, 566, 1005, 415, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8695, 14013, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 79, 'male', 'L2Pet', 'npc', 40, 2852, 8.500, 1649, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1478, 568, 1010, 415, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8696, 14014, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 79, 'male', 'L2Pet', 'npc', 40, 2862, 8.500, 1658, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1487, 570, 1016, 417, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8697, 14015, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 79, 'male', 'L2Pet', 'npc', 40, 2872, 8.500, 1666, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1495, 571, 1021, 418, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8698, 14016, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8699, 14017, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 80, 'male', 'L2Pet', 'npc', 40, 2890, 8.500, 1683, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1521, 578, 1038, 424, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8700, 14018, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 80, 'male', 'L2Pet', 'npc', 40, 2899, 8.500, 1692, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1528, 581, 1044, 424, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8701, 14019, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 80, 'male', 'L2Pet', 'npc', 40, 2909, 8.500, 1700, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1536, 583, 1049, 426, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8702, 14020, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 81, 'male', 'L2Pet', 'npc', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1554, 588, 1061, 430, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8703, 14021, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 81, 'male', 'L2Pet', 'npc', 40, 2926, 8.500, 1717, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1561, 590, 1066, 432, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8704, 14022, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 81, 'male', 'L2Pet', 'npc', 40, 2935, 8.500, 1726, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1569, 592, 1071, 432, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8705, 14023, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 81, 'male', 'L2Pet', 'npc', 40, 2944, 8.500, 1734, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1578, 593, 1076, 434, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8706, 14024, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 82, 'male', 'L2Pet', 'npc', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8707, 14025, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 82, 'male', 'L2Pet', 'npc', 40, 2961, 8.500, 1752, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1601, 600, 1093, 439, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8708, 14026, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 82, 'male', 'L2Pet', 'npc', 40, 2969, 8.500, 1760, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1609, 602, 1100, 439, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8709, 14027, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 82, 'male', 'L2Pet', 'npc', 40, 2978, 8.500, 1769, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1618, 604, 1105, 441, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8710, 14028, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 83, 'male', 'L2Pet', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8711, 14029, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 83, 'male', 'L2Pet', 'npc', 40, 2994, 8.500, 1786, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1120, 447, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8712, 14030, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 83, 'male', 'L2Pet', 'npc', 40, 3002, 8.500, 1795, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1648, 612, 1125, 447, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8713, 14031, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 83, 'male', 'L2Pet', 'npc', 40, 3010, 8.500, 1803, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1656, 614, 1130, 449, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8714, 14032, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 84, 'male', 'L2Pet', 'npc', 40, 3017, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1673, 619, 1142, 453, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8715, 14033, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 84, 'male', 'L2Pet', 'npc', 40, 3025, 8.500, 1821, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 621, 1147, 455, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8716, 14034, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 84, 'male', 'L2Pet', 'npc', 40, 3033, 8.500, 1829, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1687, 623, 1152, 455, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8717, 14035, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 85, 'male', 'L2Pet', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8718, 14036, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 85, 'male', 'L2Pet', 'npc', 40, 3057, 8.500, 1858, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1721, 632, 1175, 463, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8719, 14037, 'Reanimated Man', '', 'skeleton', 11.00, 25.00, 85, 'male', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 60, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8720, 14038, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 42, 'male', 'L2Pet', 'npc', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 259, 216, 177, 159, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8721, 14039, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 50, 'male', 'L2Pet', 'npc', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 425, 278, 291, 204, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8722, 14040, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 58, 'male', 'L2Pet', 'npc', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 651, 350, 444, 256, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8723, 14041, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 64, 'male', 'L2Pet', 'npc', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 860, 409, 588, 298, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8724, 14042, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 68, 'male', 'L2Pet', 'npc', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8725, 14043, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 72, 'male', 'L2Pet', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8726, 14044, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 78, 'male', 'L2Pet', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8727, 14045, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 78, 'male', 'L2Pet', 'npc', 40, 2813, 8.500, 1616, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1438, 558, 982, 407, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8728, 14046, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 78, 'male', 'L2Pet', 'npc', 40, 2823, 8.500, 1624, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1446, 559, 987, 409, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8729, 14047, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 78, 'male', 'L2Pet', 'npc', 40, 2832, 8.500, 1633, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1455, 561, 992, 411, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8730, 14048, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 79, 'male', 'L2Pet', 'npc', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1470, 566, 1005, 415, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8731, 14049, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 79, 'male', 'L2Pet', 'npc', 40, 2852, 8.500, 1649, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1478, 568, 1010, 415, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8732, 14050, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 79, 'male', 'L2Pet', 'npc', 40, 2862, 8.500, 1658, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1487, 570, 1016, 417, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8733, 14051, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 79, 'male', 'L2Pet', 'npc', 40, 2872, 8.500, 1666, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1495, 571, 1021, 418, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8734, 14052, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8735, 14053, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 80, 'male', 'L2Pet', 'npc', 40, 2890, 8.500, 1683, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1521, 578, 1038, 424, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8736, 14054, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 80, 'male', 'L2Pet', 'npc', 40, 2899, 8.500, 1692, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1528, 581, 1044, 424, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8737, 14055, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 80, 'male', 'L2Pet', 'npc', 40, 2909, 8.500, 1700, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1536, 583, 1049, 426, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8738, 14056, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 81, 'male', 'L2Pet', 'npc', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1554, 588, 1061, 430, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8739, 14057, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 81, 'male', 'L2Pet', 'npc', 40, 2926, 8.500, 1717, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1561, 590, 1066, 432, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8740, 14058, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 81, 'male', 'L2Pet', 'npc', 40, 2935, 8.500, 1726, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1569, 592, 1071, 432, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8741, 14059, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 81, 'male', 'L2Pet', 'npc', 40, 2944, 8.500, 1734, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1578, 593, 1076, 434, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8742, 14060, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 82, 'male', 'L2Pet', 'npc', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8743, 14061, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 82, 'male', 'L2Pet', 'npc', 40, 2961, 8.500, 1752, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1601, 600, 1093, 439, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8744, 14062, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 82, 'male', 'L2Pet', 'npc', 40, 2969, 8.500, 1760, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1609, 602, 1100, 439, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8745, 14063, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 82, 'male', 'L2Pet', 'npc', 40, 2978, 8.500, 1769, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1618, 604, 1105, 441, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8746, 14064, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 83, 'male', 'L2Pet', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8747, 14065, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 83, 'male', 'L2Pet', 'npc', 40, 2994, 8.500, 1786, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1120, 447, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8748, 14066, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 83, 'male', 'L2Pet', 'npc', 40, 3002, 8.500, 1795, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1648, 612, 1125, 447, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8749, 14067, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 83, 'male', 'L2Pet', 'npc', 40, 3010, 8.500, 1803, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1656, 614, 1130, 449, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8750, 14068, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 84, 'male', 'L2Pet', 'npc', 40, 3017, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1673, 619, 1142, 453, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8751, 14069, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 84, 'male', 'L2Pet', 'npc', 40, 3025, 8.500, 1821, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 621, 1147, 455, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8752, 14070, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 84, 'male', 'L2Pet', 'npc', 40, 3033, 8.500, 1829, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1687, 623, 1152, 455, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8753, 14071, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 85, 'male', 'L2Pet', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8754, 14072, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 85, 'male', 'L2Pet', 'npc', 40, 3057, 8.500, 1858, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1721, 632, 1175, 463, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8755, 14073, 'Corrupted Man', '', 'zombie', 13.00, 21.00, 85, 'male', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8756, 14074, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 58, 'male', 'L2Pet', 'npc', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 651, 350, 444, 256, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8757, 14075, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 62, 'male', 'L2Pet', 'npc', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 787, 388, 538, 284, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8758, 14076, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 66, 'male', 'L2Pet', 'npc', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 936, 429, 639, 313, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8759, 14077, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 70, 'male', 'L2Pet', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8760, 14078, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 72, 'male', 'L2Pet', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8761, 14079, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 74, 'male', 'L2Pet', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8762, 14080, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 76, 'male', 'L2Pet', 'npc', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8763, 14081, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 78, 'male', 'L2Pet', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8764, 14082, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 78, 'male', 'L2Pet', 'npc', 40, 2813, 8.500, 1616, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1438, 558, 982, 407, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8765, 14083, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 78, 'male', 'L2Pet', 'npc', 40, 2823, 8.500, 1624, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1446, 559, 987, 409, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8766, 14084, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 78, 'male', 'L2Pet', 'npc', 40, 2832, 8.500, 1633, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1455, 561, 992, 411, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8767, 14085, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 79, 'male', 'L2Pet', 'npc', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1470, 566, 1005, 415, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8768, 14086, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 79, 'male', 'L2Pet', 'npc', 40, 2852, 8.500, 1649, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1478, 568, 1010, 415, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8769, 14087, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 79, 'male', 'L2Pet', 'npc', 40, 2862, 8.500, 1658, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1487, 570, 1016, 417, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8770, 14088, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 79, 'male', 'L2Pet', 'npc', 40, 2872, 8.500, 1666, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1495, 571, 1021, 418, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8771, 14089, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8772, 14090, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 80, 'male', 'L2Pet', 'npc', 40, 2890, 8.500, 1683, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1521, 578, 1038, 424, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8773, 14091, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 80, 'male', 'L2Pet', 'npc', 40, 2899, 8.500, 1692, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1528, 581, 1044, 424, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8774, 14092, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 80, 'male', 'L2Pet', 'npc', 40, 2909, 8.500, 1700, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1536, 583, 1049, 426, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8775, 14093, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 81, 'male', 'L2Pet', 'npc', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1554, 588, 1061, 430, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8776, 14094, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 81, 'male', 'L2Pet', 'npc', 40, 2926, 8.500, 1717, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1561, 590, 1066, 432, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8777, 14095, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 81, 'male', 'L2Pet', 'npc', 40, 2935, 8.500, 1726, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1569, 592, 1071, 432, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8778, 14096, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 81, 'male', 'L2Pet', 'npc', 40, 2944, 8.500, 1734, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1578, 593, 1076, 434, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8779, 14097, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 82, 'male', 'L2Pet', 'npc', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8780, 14098, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 82, 'male', 'L2Pet', 'npc', 40, 2961, 8.500, 1752, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1601, 600, 1093, 439, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8781, 14099, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 82, 'male', 'L2Pet', 'npc', 40, 2969, 8.500, 1760, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1609, 602, 1100, 439, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8782, 14100, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 82, 'male', 'L2Pet', 'npc', 40, 2978, 8.500, 1769, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1618, 604, 1105, 441, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8783, 14101, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 83, 'male', 'L2Pet', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8784, 14102, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 83, 'male', 'L2Pet', 'npc', 40, 2994, 8.500, 1786, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1120, 447, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8785, 14103, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 83, 'male', 'L2Pet', 'npc', 40, 3002, 8.500, 1795, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1648, 612, 1125, 447, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8786, 14104, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 83, 'male', 'L2Pet', 'npc', 40, 3010, 8.500, 1803, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1656, 614, 1130, 449, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8787, 14105, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 84, 'male', 'L2Pet', 'npc', 40, 3017, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1673, 619, 1142, 453, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8788, 14106, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 84, 'male', 'L2Pet', 'npc', 40, 3025, 8.500, 1821, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 621, 1147, 455, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8789, 14107, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 84, 'male', 'L2Pet', 'npc', 40, 3033, 8.500, 1829, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1687, 623, 1152, 455, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8790, 14108, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 85, 'male', 'L2Pet', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8791, 14109, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 85, 'male', 'L2Pet', 'npc', 40, 3057, 8.500, 1858, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1721, 632, 1175, 463, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8792, 14110, 'Cursed Man', '', 'doll_master', 20.00, 42.00, 85, 'male', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 80, 160, '', 0, 0, 0, 0, 7, 30, 8, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8793, 14111, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 22, 'male', 'L2Pet', 'npc', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 25, 0, 0, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8794, 14112, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 27, 'male', 'L2Pet', 'npc', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 25, 0, 0, 87, 125, 59, 92, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8795, 14113, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 32, 'male', 'L2Pet', 'npc', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 25, 0, 0, 128, 152, 87, 111, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8796, 14114, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 37, 'male', 'L2Pet', 'npc', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 25, 0, 0, 185, 181, 126, 134, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8797, 14115, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 42, 'male', 'L2Pet', 'npc', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 259, 216, 177, 159, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8798, 14116, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 46, 'male', 'L2Pet', 'npc', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 335, 246, 228, 180, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8799, 14117, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 50, 'male', 'L2Pet', 'npc', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 425, 278, 291, 204, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8800, 14118, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 54, 'male', 'L2Pet', 'npc', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 531, 313, 362, 229, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8801, 14119, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 58, 'male', 'L2Pet', 'npc', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 651, 350, 444, 256, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8802, 14120, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 60, 'male', 'L2Pet', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8803, 14121, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 62, 'male', 'L2Pet', 'npc', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 787, 388, 538, 284, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8804, 14122, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 64, 'male', 'L2Pet', 'npc', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 860, 409, 588, 298, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8805, 14123, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 66, 'male', 'L2Pet', 'npc', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 936, 429, 639, 313, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8806, 14124, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 68, 'male', 'L2Pet', 'npc', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8807, 14125, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 70, 'male', 'L2Pet', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8808, 14126, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 72, 'male', 'L2Pet', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8809, 14127, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 74, 'male', 'L2Pet', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8810, 14128, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 76, 'male', 'L2Pet', 'npc', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8811, 14129, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 78, 'male', 'L2Pet', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8812, 14130, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 78, 'male', 'L2Pet', 'npc', 40, 2813, 8.500, 1616, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1438, 558, 982, 407, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8813, 14131, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 78, 'male', 'L2Pet', 'npc', 40, 2823, 8.500, 1624, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1446, 559, 987, 409, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8814, 14132, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 78, 'male', 'L2Pet', 'npc', 40, 2832, 8.500, 1633, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1455, 561, 992, 411, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8815, 14133, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 79, 'male', 'L2Pet', 'npc', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1470, 566, 1005, 415, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8816, 14134, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 79, 'male', 'L2Pet', 'npc', 40, 2852, 8.500, 1649, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1478, 568, 1010, 415, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8817, 14135, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 79, 'male', 'L2Pet', 'npc', 40, 2862, 8.500, 1658, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1487, 570, 1016, 417, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8818, 14136, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 79, 'male', 'L2Pet', 'npc', 40, 2872, 8.500, 1666, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1495, 571, 1021, 418, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8819, 14137, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8820, 14138, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 80, 'male', 'L2Pet', 'npc', 40, 2890, 8.500, 1683, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1521, 578, 1038, 424, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8821, 14139, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 80, 'male', 'L2Pet', 'npc', 40, 2899, 8.500, 1692, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1528, 581, 1044, 424, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8822, 14140, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 80, 'male', 'L2Pet', 'npc', 40, 2909, 8.500, 1700, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1536, 583, 1049, 426, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8823, 14141, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 81, 'male', 'L2Pet', 'npc', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1554, 588, 1061, 430, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8824, 14142, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 81, 'male', 'L2Pet', 'npc', 40, 2926, 8.500, 1717, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1561, 590, 1066, 432, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8825, 14143, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 81, 'male', 'L2Pet', 'npc', 40, 2935, 8.500, 1726, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1569, 592, 1071, 432, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8826, 14144, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 81, 'male', 'L2Pet', 'npc', 40, 2944, 8.500, 1734, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1578, 593, 1076, 434, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8827, 14145, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 82, 'male', 'L2Pet', 'npc', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8828, 14146, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 82, 'male', 'L2Pet', 'npc', 40, 2961, 8.500, 1752, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1601, 600, 1093, 439, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8829, 14147, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 82, 'male', 'L2Pet', 'npc', 40, 2969, 8.500, 1760, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1609, 602, 1100, 439, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8830, 14148, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 82, 'male', 'L2Pet', 'npc', 40, 2978, 8.500, 1769, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1618, 604, 1105, 441, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8831, 14149, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 83, 'male', 'L2Pet', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8832, 14150, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 83, 'male', 'L2Pet', 'npc', 40, 2994, 8.500, 1786, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1120, 447, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8833, 14151, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 83, 'male', 'L2Pet', 'npc', 40, 3002, 8.500, 1795, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1648, 612, 1125, 447, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8834, 14152, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 83, 'male', 'L2Pet', 'npc', 40, 3010, 8.500, 1803, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1656, 614, 1130, 449, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8835, 14153, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 84, 'male', 'L2Pet', 'npc', 40, 3017, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1673, 619, 1142, 453, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8836, 14154, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 84, 'male', 'L2Pet', 'npc', 40, 3025, 8.500, 1821, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 621, 1147, 455, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8837, 14155, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 84, 'male', 'L2Pet', 'npc', 40, 3033, 8.500, 1829, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1687, 623, 1152, 455, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8838, 14156, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 85, 'male', 'L2Pet', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8839, 14157, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 85, 'male', 'L2Pet', 'npc', 40, 3057, 8.500, 1858, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1721, 632, 1175, 463, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8840, 14158, 'Kat the Cat', '', 'cat_the_cat', 9.00, 16.00, 85, 'male', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8841, 14159, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 22, 'female', 'L2Pet', 'npc', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 25, 0, 0, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8842, 14160, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 27, 'female', 'L2Pet', 'npc', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 25, 0, 0, 87, 125, 59, 92, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8843, 14161, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 32, 'female', 'L2Pet', 'npc', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 25, 0, 0, 128, 152, 87, 111, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8844, 14162, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 37, 'female', 'L2Pet', 'npc', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 25, 0, 0, 185, 181, 126, 134, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8845, 14163, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 42, 'female', 'L2Pet', 'npc', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 259, 216, 177, 159, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8846, 14164, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 46, 'female', 'L2Pet', 'npc', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 335, 246, 228, 180, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8847, 14165, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 50, 'female', 'L2Pet', 'npc', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 425, 278, 291, 204, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8848, 14166, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 54, 'female', 'L2Pet', 'npc', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 531, 313, 362, 229, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8849, 14167, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 58, 'female', 'L2Pet', 'npc', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 651, 350, 444, 256, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8850, 14168, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 60, 'female', 'L2Pet', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8851, 14169, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 62, 'female', 'L2Pet', 'npc', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 787, 388, 538, 284, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8852, 14170, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 64, 'female', 'L2Pet', 'npc', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 860, 409, 588, 298, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8853, 14171, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 66, 'female', 'L2Pet', 'npc', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 936, 429, 639, 313, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8854, 14172, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 68, 'female', 'L2Pet', 'npc', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8855, 14173, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Pet', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8856, 14174, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 72, 'female', 'L2Pet', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8857, 14175, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 74, 'female', 'L2Pet', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8858, 14176, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 76, 'female', 'L2Pet', 'npc', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8859, 14177, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 78, 'female', 'L2Pet', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8860, 14178, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 78, 'female', 'L2Pet', 'npc', 40, 2813, 8.500, 1616, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1438, 558, 982, 407, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8861, 14179, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 78, 'female', 'L2Pet', 'npc', 40, 2823, 8.500, 1624, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1446, 559, 987, 409, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8862, 14180, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 78, 'female', 'L2Pet', 'npc', 40, 2832, 8.500, 1633, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1455, 561, 992, 411, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8863, 14181, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 79, 'female', 'L2Pet', 'npc', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1470, 566, 1005, 415, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8864, 14182, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 79, 'female', 'L2Pet', 'npc', 40, 2852, 8.500, 1649, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1478, 568, 1010, 415, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8865, 14183, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 79, 'female', 'L2Pet', 'npc', 40, 2862, 8.500, 1658, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1487, 570, 1016, 417, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8866, 14184, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 79, 'female', 'L2Pet', 'npc', 40, 2872, 8.500, 1666, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1495, 571, 1021, 418, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8867, 14185, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 80, 'female', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8868, 14186, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 80, 'female', 'L2Pet', 'npc', 40, 2890, 8.500, 1683, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1521, 578, 1038, 424, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8869, 14187, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 80, 'female', 'L2Pet', 'npc', 40, 2899, 8.500, 1692, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1528, 581, 1044, 424, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8870, 14188, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 80, 'female', 'L2Pet', 'npc', 40, 2909, 8.500, 1700, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1536, 583, 1049, 426, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8871, 14189, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 81, 'female', 'L2Pet', 'npc', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1554, 588, 1061, 430, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8872, 14190, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 81, 'female', 'L2Pet', 'npc', 40, 2926, 8.500, 1717, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1561, 590, 1066, 432, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8873, 14191, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 81, 'female', 'L2Pet', 'npc', 40, 2935, 8.500, 1726, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1569, 592, 1071, 432, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8874, 14192, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 81, 'female', 'L2Pet', 'npc', 40, 2944, 8.500, 1734, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1578, 593, 1076, 434, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8875, 14193, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 82, 'female', 'L2Pet', 'npc', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8876, 14194, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 82, 'female', 'L2Pet', 'npc', 40, 2961, 8.500, 1752, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1601, 600, 1093, 439, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8877, 14195, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 82, 'female', 'L2Pet', 'npc', 40, 2969, 8.500, 1760, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1609, 602, 1100, 439, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8878, 14196, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 82, 'female', 'L2Pet', 'npc', 40, 2978, 8.500, 1769, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1618, 604, 1105, 441, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8879, 14197, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 83, 'female', 'L2Pet', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8880, 14198, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 83, 'female', 'L2Pet', 'npc', 40, 2994, 8.500, 1786, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1120, 447, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8881, 14199, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 83, 'female', 'L2Pet', 'npc', 40, 3002, 8.500, 1795, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1648, 612, 1125, 447, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8882, 14200, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 83, 'female', 'L2Pet', 'npc', 40, 3010, 8.500, 1803, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1656, 614, 1130, 449, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8883, 14201, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 84, 'female', 'L2Pet', 'npc', 40, 3017, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1673, 619, 1142, 453, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8884, 14202, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 84, 'female', 'L2Pet', 'npc', 40, 3025, 8.500, 1821, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 621, 1147, 455, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8885, 14203, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 84, 'female', 'L2Pet', 'npc', 40, 3033, 8.500, 1829, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1687, 623, 1152, 455, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8886, 14204, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 85, 'female', 'L2Pet', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8887, 14205, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 85, 'female', 'L2Pet', 'npc', 40, 3057, 8.500, 1858, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1721, 632, 1175, 463, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8888, 14206, 'Mew the Cat', '', 'cutie_cat', 8.00, 15.00, 85, 'female', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8889, 14207, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 42, 'male', 'L2Pet', 'npc', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 259, 216, 177, 159, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8890, 14208, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 46, 'male', 'L2Pet', 'npc', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 335, 246, 228, 180, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8891, 14209, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 50, 'male', 'L2Pet', 'npc', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 425, 278, 291, 204, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8892, 14210, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 54, 'male', 'L2Pet', 'npc', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 531, 313, 362, 229, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8893, 14211, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 58, 'male', 'L2Pet', 'npc', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 651, 350, 444, 256, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8894, 14212, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 60, 'male', 'L2Pet', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8895, 14213, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 62, 'male', 'L2Pet', 'npc', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 787, 388, 538, 284, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8896, 14214, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 64, 'male', 'L2Pet', 'npc', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 860, 409, 588, 298, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8897, 14215, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 66, 'male', 'L2Pet', 'npc', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 936, 429, 639, 313, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8898, 14216, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 68, 'male', 'L2Pet', 'npc', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8899, 14217, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 70, 'male', 'L2Pet', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8900, 14218, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 72, 'male', 'L2Pet', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8901, 14219, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 74, 'male', 'L2Pet', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8902, 14220, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 76, 'male', 'L2Pet', 'npc', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8903, 14221, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 78, 'male', 'L2Pet', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8904, 14222, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 78, 'male', 'L2Pet', 'npc', 40, 2813, 8.500, 1616, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1438, 558, 982, 407, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8905, 14223, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 78, 'male', 'L2Pet', 'npc', 40, 2823, 8.500, 1624, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1446, 559, 987, 409, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8906, 14224, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 78, 'male', 'L2Pet', 'npc', 40, 2832, 8.500, 1633, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1455, 561, 992, 411, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8907, 14225, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 79, 'male', 'L2Pet', 'npc', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1470, 566, 1005, 415, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8908, 14226, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 79, 'male', 'L2Pet', 'npc', 40, 2852, 8.500, 1649, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1478, 568, 1010, 415, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8909, 14227, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 79, 'male', 'L2Pet', 'npc', 40, 2862, 8.500, 1658, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1487, 570, 1016, 417, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8910, 14228, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 79, 'male', 'L2Pet', 'npc', 40, 2872, 8.500, 1666, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1495, 571, 1021, 418, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8911, 14229, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8912, 14230, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 80, 'male', 'L2Pet', 'npc', 40, 2890, 8.500, 1683, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1521, 578, 1038, 424, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8913, 14231, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 80, 'male', 'L2Pet', 'npc', 40, 2899, 8.500, 1692, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1528, 581, 1044, 424, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8914, 14232, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 80, 'male', 'L2Pet', 'npc', 40, 2909, 8.500, 1700, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1536, 583, 1049, 426, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8915, 14233, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 81, 'male', 'L2Pet', 'npc', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1554, 588, 1061, 430, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8916, 14234, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 81, 'male', 'L2Pet', 'npc', 40, 2926, 8.500, 1717, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1561, 590, 1066, 432, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8917, 14235, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 81, 'male', 'L2Pet', 'npc', 40, 2935, 8.500, 1726, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1569, 592, 1071, 432, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8918, 14236, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 81, 'male', 'L2Pet', 'npc', 40, 2944, 8.500, 1734, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1578, 593, 1076, 434, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8919, 14237, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 82, 'male', 'L2Pet', 'npc', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8920, 14238, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 82, 'male', 'L2Pet', 'npc', 40, 2961, 8.500, 1752, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1601, 600, 1093, 439, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8921, 14239, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 82, 'male', 'L2Pet', 'npc', 40, 2969, 8.500, 1760, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1609, 602, 1100, 439, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8922, 14240, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 82, 'male', 'L2Pet', 'npc', 40, 2978, 8.500, 1769, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1618, 604, 1105, 441, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8923, 14241, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 83, 'male', 'L2Pet', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8924, 14242, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 83, 'male', 'L2Pet', 'npc', 40, 2994, 8.500, 1786, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1120, 447, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8925, 14243, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 83, 'male', 'L2Pet', 'npc', 40, 3002, 8.500, 1795, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1648, 612, 1125, 447, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8926, 14244, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 83, 'male', 'L2Pet', 'npc', 40, 3010, 8.500, 1803, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1656, 614, 1130, 449, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8927, 14245, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 84, 'male', 'L2Pet', 'npc', 40, 3017, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1673, 619, 1142, 453, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8928, 14246, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 84, 'male', 'L2Pet', 'npc', 40, 3025, 8.500, 1821, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 621, 1147, 455, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8929, 14247, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 84, 'male', 'L2Pet', 'npc', 40, 3033, 8.500, 1829, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1687, 623, 1152, 455, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8930, 14248, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 85, 'male', 'L2Pet', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8931, 14249, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 85, 'male', 'L2Pet', 'npc', 40, 3057, 8.500, 1858, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1721, 632, 1175, 463, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8932, 14250, 'Kai the Cat', '', 'silver_cat', 7.00, 15.00, 85, 'male', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8933, 14251, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 58, 'female', 'L2Pet', 'npc', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 651, 350, 444, 256, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8934, 14252, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 60, 'female', 'L2Pet', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8935, 14253, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 62, 'female', 'L2Pet', 'npc', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 787, 388, 538, 284, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8936, 14254, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 64, 'female', 'L2Pet', 'npc', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 860, 409, 588, 298, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8937, 14255, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 66, 'female', 'L2Pet', 'npc', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 936, 429, 639, 313, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8938, 14256, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 68, 'female', 'L2Pet', 'npc', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8939, 14257, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 70, 'female', 'L2Pet', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8940, 14258, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 72, 'female', 'L2Pet', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8941, 14259, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 74, 'female', 'L2Pet', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8942, 14260, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 76, 'female', 'L2Pet', 'npc', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8943, 14265, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 78, 'female', 'L2Pet', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8944, 14266, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 78, 'female', 'L2Pet', 'npc', 40, 2813, 8.500, 1616, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1438, 558, 982, 407, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8945, 14267, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 78, 'female', 'L2Pet', 'npc', 40, 2823, 8.500, 1624, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1446, 559, 987, 409, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8946, 14268, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 78, 'female', 'L2Pet', 'npc', 40, 2832, 8.500, 1633, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1455, 561, 992, 411, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8947, 14269, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 79, 'female', 'L2Pet', 'npc', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1470, 566, 1005, 415, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8948, 14270, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 79, 'female', 'L2Pet', 'npc', 40, 2852, 8.500, 1649, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1478, 568, 1010, 415, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8949, 14271, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 79, 'female', 'L2Pet', 'npc', 40, 2862, 8.500, 1658, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1487, 570, 1016, 417, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8950, 14272, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 79, 'female', 'L2Pet', 'npc', 40, 2872, 8.500, 1666, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1495, 571, 1021, 418, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8951, 14273, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 80, 'female', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8952, 14274, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 80, 'female', 'L2Pet', 'npc', 40, 2890, 8.500, 1683, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1521, 578, 1038, 424, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8953, 14275, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 80, 'female', 'L2Pet', 'npc', 40, 2899, 8.500, 1692, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1528, 581, 1044, 424, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8954, 14276, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 80, 'female', 'L2Pet', 'npc', 40, 2909, 8.500, 1700, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1536, 583, 1049, 426, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8955, 14277, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 81, 'female', 'L2Pet', 'npc', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1554, 588, 1061, 430, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8956, 14278, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 81, 'female', 'L2Pet', 'npc', 40, 2926, 8.500, 1717, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1561, 590, 1066, 432, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8957, 14279, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 81, 'female', 'L2Pet', 'npc', 40, 2935, 8.500, 1726, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1569, 592, 1071, 432, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8958, 14280, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 81, 'female', 'L2Pet', 'npc', 40, 2944, 8.500, 1734, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1578, 593, 1076, 434, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8959, 14281, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 82, 'female', 'L2Pet', 'npc', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8960, 14282, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 82, 'female', 'L2Pet', 'npc', 40, 2961, 8.500, 1752, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1601, 600, 1093, 439, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8961, 14283, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 82, 'female', 'L2Pet', 'npc', 40, 2969, 8.500, 1760, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1609, 602, 1100, 439, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8962, 14284, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 82, 'female', 'L2Pet', 'npc', 40, 2978, 8.500, 1769, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1618, 604, 1105, 441, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8963, 14285, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 83, 'female', 'L2Pet', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8964, 14286, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 83, 'female', 'L2Pet', 'npc', 40, 2994, 8.500, 1786, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1120, 447, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8965, 14287, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 83, 'female', 'L2Pet', 'npc', 40, 3002, 8.500, 1795, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1648, 612, 1125, 447, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8966, 14288, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 83, 'female', 'L2Pet', 'npc', 40, 3010, 8.500, 1803, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1656, 614, 1130, 449, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8967, 14289, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 84, 'female', 'L2Pet', 'npc', 40, 3017, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1673, 619, 1142, 453, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8968, 14290, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 84, 'female', 'L2Pet', 'npc', 40, 3025, 8.500, 1821, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 621, 1147, 455, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8969, 14291, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 84, 'female', 'L2Pet', 'npc', 40, 3033, 8.500, 1829, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1687, 623, 1152, 455, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8970, 14292, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 85, 'female', 'L2Pet', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8971, 14293, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 85, 'female', 'L2Pet', 'npc', 40, 3057, 8.500, 1858, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1721, 632, 1175, 463, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8972, 14294, 'Feline Queen', '', 'queen_of_cat', 8.00, 15.00, 85, 'female', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 26, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8973, 14295, 'Boxer the Unicorn ', '', 'unicorn_boxer', 11.00, 18.00, 22, 'male', 'L2Pet', 'npc', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 25, 0, 0, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8974, 14296, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 27, 'male', 'L2Pet', 'npc', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 25, 0, 0, 87, 125, 59, 92, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8975, 14297, 'Boxer the Unicorn ', '', 'unicorn_boxer', 11.00, 18.00, 32, 'male', 'L2Pet', 'npc', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 25, 0, 0, 128, 152, 87, 111, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8976, 14298, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 37, 'male', 'L2Pet', 'npc', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 25, 0, 0, 185, 181, 126, 134, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8977, 14299, 'Boxer the Unicorn ', '', 'unicorn_boxer', 11.00, 18.00, 42, 'male', 'L2Pet', 'npc', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 259, 216, 177, 159, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8978, 14300, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 46, 'male', 'L2Pet', 'npc', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 335, 246, 228, 180, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8979, 14301, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 50, 'male', 'L2Pet', 'npc', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 425, 278, 291, 204, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8980, 14302, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 54, 'male', 'L2Pet', 'npc', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 531, 313, 362, 229, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8981, 14303, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 58, 'male', 'L2Pet', 'npc', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 651, 350, 444, 256, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8982, 14304, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 60, 'male', 'L2Pet', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8983, 14305, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 62, 'male', 'L2Pet', 'npc', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 787, 388, 538, 284, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8984, 14306, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 64, 'male', 'L2Pet', 'npc', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 860, 409, 588, 298, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8985, 14307, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 66, 'male', 'L2Pet', 'npc', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 936, 429, 639, 313, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8986, 14308, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 68, 'male', 'L2Pet', 'npc', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8987, 14309, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 70, 'male', 'L2Pet', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8988, 14310, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 72, 'male', 'L2Pet', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8989, 14311, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 74, 'male', 'L2Pet', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8990, 14312, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 76, 'male', 'L2Pet', 'npc', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8991, 14313, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 78, 'male', 'L2Pet', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8992, 14314, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 78, 'male', 'L2Pet', 'npc', 40, 2813, 8.500, 1616, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1438, 558, 982, 407, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8993, 14315, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 78, 'male', 'L2Pet', 'npc', 40, 2823, 8.500, 1624, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1446, 559, 987, 409, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8994, 14316, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 78, 'male', 'L2Pet', 'npc', 40, 2832, 8.500, 1633, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1455, 561, 992, 411, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8995, 14317, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 79, 'male', 'L2Pet', 'npc', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1470, 566, 1005, 415, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8996, 14318, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 79, 'male', 'L2Pet', 'npc', 40, 2852, 8.500, 1649, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1478, 568, 1010, 415, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8997, 14319, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 79, 'male', 'L2Pet', 'npc', 40, 2862, 8.500, 1658, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1487, 570, 1016, 417, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8998, 14320, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 79, 'male', 'L2Pet', 'npc', 40, 2872, 8.500, 1666, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1495, 571, 1021, 418, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8999, 14321, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9000, 14322, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 80, 'male', 'L2Pet', 'npc', 40, 2890, 8.500, 1683, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1521, 578, 1038, 424, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9001, 14323, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 80, 'male', 'L2Pet', 'npc', 40, 2899, 8.500, 1692, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1528, 581, 1044, 424, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9002, 14324, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 80, 'male', 'L2Pet', 'npc', 40, 2909, 8.500, 1700, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1536, 583, 1049, 426, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9003, 14325, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 81, 'male', 'L2Pet', 'npc', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1554, 588, 1061, 430, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9004, 14326, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 81, 'male', 'L2Pet', 'npc', 40, 2926, 8.500, 1717, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1561, 590, 1066, 432, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9005, 14327, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 81, 'male', 'L2Pet', 'npc', 40, 2935, 8.500, 1726, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1569, 592, 1071, 432, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9006, 14328, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 81, 'male', 'L2Pet', 'npc', 40, 2944, 8.500, 1734, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1578, 593, 1076, 434, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9007, 14329, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 82, 'male', 'L2Pet', 'npc', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9008, 14330, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 82, 'male', 'L2Pet', 'npc', 40, 2961, 8.500, 1752, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1601, 600, 1093, 439, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9009, 14331, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 82, 'male', 'L2Pet', 'npc', 40, 2969, 8.500, 1760, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1609, 602, 1100, 439, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9010, 14332, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 82, 'male', 'L2Pet', 'npc', 40, 2978, 8.500, 1769, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1618, 604, 1105, 441, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9011, 14333, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 83, 'male', 'L2Pet', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9012, 14334, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 83, 'male', 'L2Pet', 'npc', 40, 2994, 8.500, 1786, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1120, 447, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9013, 14335, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 83, 'male', 'L2Pet', 'npc', 40, 3002, 8.500, 1795, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1648, 612, 1125, 447, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9014, 14336, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 83, 'male', 'L2Pet', 'npc', 40, 3010, 8.500, 1803, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1656, 614, 1130, 449, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9015, 14337, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 84, 'male', 'L2Pet', 'npc', 40, 3017, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1673, 619, 1142, 453, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9016, 14338, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 84, 'male', 'L2Pet', 'npc', 40, 3025, 8.500, 1821, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 621, 1147, 455, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9017, 14339, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 84, 'male', 'L2Pet', 'npc', 40, 3033, 8.500, 1829, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1687, 623, 1152, 455, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9018, 14340, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 85, 'male', 'L2Pet', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9019, 14341, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 85, 'male', 'L2Pet', 'npc', 40, 3057, 8.500, 1858, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1721, 632, 1175, 463, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9020, 14342, 'Boxer the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 85, 'male', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9021, 14343, 'Mirage the Unicorn', '', 'unicorn_mirage', 13.00, 17.00, 22, 'male', 'L2Pet', 'npc', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 25, 0, 0, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9022, 14344, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 27, 'male', 'L2Pet', 'npc', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 25, 0, 0, 87, 125, 59, 92, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9023, 14345, 'Mirage the Unicorn', '', 'unicorn_mirage', 13.00, 17.00, 32, 'male', 'L2Pet', 'npc', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 25, 0, 0, 128, 152, 87, 111, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9024, 14346, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 37, 'male', 'L2Pet', 'npc', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 25, 0, 0, 185, 181, 126, 134, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9025, 14347, 'Mirage the Unicorn', '', 'unicorn_mirage', 13.00, 17.00, 42, 'male', 'L2Pet', 'npc', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 259, 216, 177, 159, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9026, 14348, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 46, 'male', 'L2Pet', 'npc', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 335, 246, 228, 180, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9027, 14349, 'Mirage the Unicorn', '', 'unicorn_mirage', 13.00, 17.00, 50, 'male', 'L2Pet', 'npc', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 425, 278, 291, 204, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9028, 14350, 'Mirage the Unicorn', '', 'unicorn_mirage', 13.00, 17.00, 54, 'male', 'L2Pet', 'npc', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 531, 313, 362, 229, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9029, 14351, 'Mirage the Unicorn', '', 'unicorn_mirage', 13.00, 17.00, 58, 'male', 'L2Pet', 'npc', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 651, 350, 444, 256, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9030, 14352, 'Mirage the Unicorn', '', 'unicorn_mirage', 13.00, 17.00, 60, 'male', 'L2Pet', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9031, 14353, 'Mirage the Unicorn', '', 'unicorn_mirage', 13.00, 17.00, 62, 'male', 'L2Pet', 'npc', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 787, 388, 538, 284, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9032, 14354, 'Mirage the Unicorn', '', 'unicorn_mirage', 13.00, 17.00, 64, 'male', 'L2Pet', 'npc', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 860, 409, 588, 298, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9033, 14355, 'Mirage the Unicorn', '', 'unicorn_mirage', 13.00, 17.00, 66, 'male', 'L2Pet', 'npc', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 936, 429, 639, 313, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9034, 14356, 'Mirage the Unicorn', '', 'unicorn_mirage', 13.00, 17.00, 68, 'male', 'L2Pet', 'npc', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9035, 14357, 'Mirage the Unicorn', '', 'unicorn_mirage', 13.00, 17.00, 70, 'male', 'L2Pet', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9036, 14358, 'Mirage the Unicorn', '', 'unicorn_mirage', 13.00, 17.00, 72, 'male', 'L2Pet', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9037, 14359, 'Mirage the Unicorn', '', 'unicorn_mirage', 13.00, 17.00, 74, 'male', 'L2Pet', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9038, 14360, 'Mirage the Unicorn', '', 'unicorn_mirage', 13.00, 17.00, 76, 'male', 'L2Pet', 'npc', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9039, 14361, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 78, 'male', 'L2Pet', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9040, 14362, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 78, 'male', 'L2Pet', 'npc', 40, 2813, 8.500, 1616, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1438, 558, 982, 407, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9041, 14363, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 78, 'male', 'L2Pet', 'npc', 40, 2823, 8.500, 1624, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1446, 559, 987, 409, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9042, 14364, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 78, 'male', 'L2Pet', 'npc', 40, 2832, 8.500, 1633, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1455, 561, 992, 411, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9043, 14365, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 79, 'male', 'L2Pet', 'npc', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1470, 566, 1005, 415, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9044, 14366, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 79, 'male', 'L2Pet', 'npc', 40, 2852, 8.500, 1649, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1478, 568, 1010, 415, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9045, 14367, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 79, 'male', 'L2Pet', 'npc', 40, 2862, 8.500, 1658, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1487, 570, 1016, 417, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9046, 14368, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 79, 'male', 'L2Pet', 'npc', 40, 2872, 8.500, 1666, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1495, 571, 1021, 418, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9047, 14369, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9048, 14370, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 80, 'male', 'L2Pet', 'npc', 40, 2890, 8.500, 1683, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1521, 578, 1038, 424, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9049, 14371, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 80, 'male', 'L2Pet', 'npc', 40, 2899, 8.500, 1692, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1528, 581, 1044, 424, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9050, 14372, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 80, 'male', 'L2Pet', 'npc', 40, 2909, 8.500, 1700, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1536, 583, 1049, 426, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9051, 14373, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 81, 'male', 'L2Pet', 'npc', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1554, 588, 1061, 430, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9052, 14374, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 81, 'male', 'L2Pet', 'npc', 40, 2926, 8.500, 1717, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1561, 590, 1066, 432, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9053, 14375, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 81, 'male', 'L2Pet', 'npc', 40, 2935, 8.500, 1726, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1569, 592, 1071, 432, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9054, 14376, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 81, 'male', 'L2Pet', 'npc', 40, 2944, 8.500, 1734, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1578, 593, 1076, 434, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9055, 14377, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 82, 'male', 'L2Pet', 'npc', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9056, 14378, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 82, 'male', 'L2Pet', 'npc', 40, 2961, 8.500, 1752, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1601, 600, 1093, 439, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9057, 14379, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 82, 'male', 'L2Pet', 'npc', 40, 2969, 8.500, 1760, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1609, 602, 1100, 439, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9058, 14380, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 82, 'male', 'L2Pet', 'npc', 40, 2978, 8.500, 1769, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1618, 604, 1105, 441, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9059, 14381, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 83, 'male', 'L2Pet', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9060, 14382, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 83, 'male', 'L2Pet', 'npc', 40, 2994, 8.500, 1786, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1120, 447, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9061, 14383, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 83, 'male', 'L2Pet', 'npc', 40, 3002, 8.500, 1795, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1648, 612, 1125, 447, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9062, 14384, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 83, 'male', 'L2Pet', 'npc', 40, 3010, 8.500, 1803, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1656, 614, 1130, 449, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9063, 14385, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 84, 'male', 'L2Pet', 'npc', 40, 3017, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1673, 619, 1142, 453, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9064, 14386, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 84, 'male', 'L2Pet', 'npc', 40, 3025, 8.500, 1821, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 621, 1147, 455, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9065, 14387, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 84, 'male', 'L2Pet', 'npc', 40, 3033, 8.500, 1829, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1687, 623, 1152, 455, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9066, 14388, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 85, 'male', 'L2Pet', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9067, 14389, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 85, 'male', 'L2Pet', 'npc', 40, 3057, 8.500, 1858, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1721, 632, 1175, 463, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9068, 14390, 'Mirage the Unicorn ', '', 'unicorn_mirage', 13.00, 17.00, 85, 'male', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 27, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9069, 14391, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 42, 'male', 'L2Pet', 'npc', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 259, 216, 177, 159, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9070, 14392, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 46, 'male', 'L2Pet', 'npc', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 335, 246, 228, 180, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9071, 14393, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 50, 'male', 'L2Pet', 'npc', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 425, 278, 291, 204, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9072, 14394, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 54, 'male', 'L2Pet', 'npc', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 531, 313, 362, 229, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9073, 14395, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 58, 'male', 'L2Pet', 'npc', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 651, 350, 444, 256, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9074, 14396, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 60, 'male', 'L2Pet', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9075, 14397, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 62, 'male', 'L2Pet', 'npc', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 787, 388, 538, 284, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9076, 14398, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 64, 'male', 'L2Pet', 'npc', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 860, 409, 588, 298, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9077, 14399, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 66, 'male', 'L2Pet', 'npc', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 936, 429, 639, 313, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9078, 14400, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 68, 'male', 'L2Pet', 'npc', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9079, 14401, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 70, 'male', 'L2Pet', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9080, 14402, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 72, 'male', 'L2Pet', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9081, 14403, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 74, 'male', 'L2Pet', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9082, 14404, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 76, 'male', 'L2Pet', 'npc', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9083, 14405, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 78, 'male', 'L2Pet', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9084, 14406, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 78, 'male', 'L2Pet', 'npc', 40, 2813, 8.500, 1616, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1438, 558, 982, 407, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9085, 14407, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 78, 'male', 'L2Pet', 'npc', 40, 2823, 8.500, 1624, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1446, 559, 987, 409, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9086, 14408, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 78, 'male', 'L2Pet', 'npc', 40, 2832, 8.500, 1633, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1455, 561, 992, 411, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9087, 14409, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 79, 'male', 'L2Pet', 'npc', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1470, 566, 1005, 415, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9088, 14410, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 79, 'male', 'L2Pet', 'npc', 40, 2852, 8.500, 1649, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1478, 568, 1010, 415, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9089, 14411, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 79, 'male', 'L2Pet', 'npc', 40, 2862, 8.500, 1658, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1487, 570, 1016, 417, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9090, 14412, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 79, 'male', 'L2Pet', 'npc', 40, 2872, 8.500, 1666, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1495, 571, 1021, 418, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9091, 14413, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9092, 14414, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 80, 'male', 'L2Pet', 'npc', 40, 2890, 8.500, 1683, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1521, 578, 1038, 424, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9093, 14415, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 80, 'male', 'L2Pet', 'npc', 40, 2899, 8.500, 1692, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1528, 581, 1044, 424, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9094, 14416, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 80, 'male', 'L2Pet', 'npc', 40, 2909, 8.500, 1700, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1536, 583, 1049, 426, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9095, 14417, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 81, 'male', 'L2Pet', 'npc', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1554, 588, 1061, 430, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9096, 14418, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 81, 'male', 'L2Pet', 'npc', 40, 2926, 8.500, 1717, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1561, 590, 1066, 432, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9097, 14419, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 81, 'male', 'L2Pet', 'npc', 40, 2935, 8.500, 1726, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1569, 592, 1071, 432, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9098, 14420, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 81, 'male', 'L2Pet', 'npc', 40, 2944, 8.500, 1734, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1578, 593, 1076, 434, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9099, 14421, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 82, 'male', 'L2Pet', 'npc', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9100, 14422, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 82, 'male', 'L2Pet', 'npc', 40, 2961, 8.500, 1752, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1601, 600, 1093, 439, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9101, 14423, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 82, 'male', 'L2Pet', 'npc', 40, 2969, 8.500, 1760, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1609, 602, 1100, 439, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9102, 14424, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 82, 'male', 'L2Pet', 'npc', 40, 2978, 8.500, 1769, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1618, 604, 1105, 441, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9103, 14425, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 83, 'male', 'L2Pet', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9104, 14426, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 83, 'male', 'L2Pet', 'npc', 40, 2994, 8.500, 1786, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1120, 447, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9105, 14427, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 83, 'male', 'L2Pet', 'npc', 40, 3002, 8.500, 1795, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1648, 612, 1125, 447, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9106, 14428, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 83, 'male', 'L2Pet', 'npc', 40, 3010, 8.500, 1803, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1656, 614, 1130, 449, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9107, 14429, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 84, 'male', 'L2Pet', 'npc', 40, 3017, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1673, 619, 1142, 453, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9108, 14430, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 84, 'male', 'L2Pet', 'npc', 40, 3025, 8.500, 1821, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 621, 1147, 455, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9109, 14431, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 84, 'male', 'L2Pet', 'npc', 40, 3033, 8.500, 1829, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1687, 623, 1152, 455, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9110, 14432, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 85, 'male', 'L2Pet', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9111, 14433, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 85, 'male', 'L2Pet', 'npc', 40, 3057, 8.500, 1858, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1721, 632, 1175, 463, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9112, 14434, 'Merrow the Unicorn', '', 'blue_eye', 11.00, 16.00, 85, 'male', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9113, 14435, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 58, 'male', 'L2Pet', 'npc', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 651, 350, 444, 256, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9114, 14436, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 60, 'male', 'L2Pet', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9115, 14437, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 62, 'male', 'L2Pet', 'npc', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 787, 388, 538, 284, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9116, 14438, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 64, 'male', 'L2Pet', 'npc', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 860, 409, 588, 298, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9117, 14439, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 66, 'male', 'L2Pet', 'npc', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 936, 429, 639, 313, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9118, 14440, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 68, 'male', 'L2Pet', 'npc', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9119, 14441, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 70, 'male', 'L2Pet', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9120, 14442, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 72, 'male', 'L2Pet', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9121, 14443, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 74, 'male', 'L2Pet', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9122, 14444, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 76, 'male', 'L2Pet', 'npc', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9123, 14449, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 78, 'male', 'L2Pet', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9124, 14450, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 78, 'male', 'L2Pet', 'npc', 40, 2813, 8.500, 1616, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1438, 558, 982, 407, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9125, 14451, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 78, 'male', 'L2Pet', 'npc', 40, 2823, 8.500, 1624, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1446, 559, 987, 409, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9126, 14452, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 78, 'male', 'L2Pet', 'npc', 40, 2832, 8.500, 1633, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1455, 561, 992, 411, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9127, 14453, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 79, 'male', 'L2Pet', 'npc', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1470, 566, 1005, 415, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9128, 14454, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 79, 'male', 'L2Pet', 'npc', 40, 2852, 8.500, 1649, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1478, 568, 1010, 415, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9129, 14455, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 79, 'male', 'L2Pet', 'npc', 40, 2862, 8.500, 1658, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1487, 570, 1016, 417, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9130, 14456, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 79, 'male', 'L2Pet', 'npc', 40, 2872, 8.500, 1666, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1495, 571, 1021, 418, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9131, 14457, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9132, 14458, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 80, 'male', 'L2Pet', 'npc', 40, 2890, 8.500, 1683, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1521, 578, 1038, 424, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9133, 14459, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 80, 'male', 'L2Pet', 'npc', 40, 2899, 8.500, 1692, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1528, 581, 1044, 424, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9134, 14460, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 80, 'male', 'L2Pet', 'npc', 40, 2909, 8.500, 1700, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1536, 583, 1049, 426, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9135, 14461, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 81, 'male', 'L2Pet', 'npc', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1554, 588, 1061, 430, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9136, 14462, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 81, 'male', 'L2Pet', 'npc', 40, 2926, 8.500, 1717, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1561, 590, 1066, 432, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9137, 14463, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 81, 'male', 'L2Pet', 'npc', 40, 2935, 8.500, 1726, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1569, 592, 1071, 432, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9138, 14464, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 81, 'male', 'L2Pet', 'npc', 40, 2944, 8.500, 1734, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1578, 593, 1076, 434, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9139, 14465, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 82, 'male', 'L2Pet', 'npc', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9140, 14466, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 82, 'male', 'L2Pet', 'npc', 40, 2961, 8.500, 1752, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1601, 600, 1093, 439, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9141, 14467, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 82, 'male', 'L2Pet', 'npc', 40, 2969, 8.500, 1760, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1609, 602, 1100, 439, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9142, 14468, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 82, 'male', 'L2Pet', 'npc', 40, 2978, 8.500, 1769, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1618, 604, 1105, 441, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9143, 14469, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 83, 'male', 'L2Pet', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9144, 14470, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 83, 'male', 'L2Pet', 'npc', 40, 2994, 8.500, 1786, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1120, 447, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9145, 14471, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 83, 'male', 'L2Pet', 'npc', 40, 3002, 8.500, 1795, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1648, 612, 1125, 447, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9146, 14472, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 83, 'male', 'L2Pet', 'npc', 40, 3010, 8.500, 1803, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1656, 614, 1130, 449, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9147, 14473, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 84, 'male', 'L2Pet', 'npc', 40, 3017, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1673, 619, 1142, 453, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9148, 14474, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 84, 'male', 'L2Pet', 'npc', 40, 3025, 8.500, 1821, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 621, 1147, 455, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9149, 14475, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 84, 'male', 'L2Pet', 'npc', 40, 3033, 8.500, 1829, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1687, 623, 1152, 455, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9150, 14476, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 85, 'male', 'L2Pet', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9151, 14477, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 85, 'male', 'L2Pet', 'npc', 40, 3057, 8.500, 1858, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1721, 632, 1175, 463, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9152, 14478, 'Unicorn Seraphim', '', 'angelic_unicorn', 9.00, 25.50, 85, 'male', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 27, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9153, 14479, 'Shadow', '', 'shadow', 10.00, 30.00, 22, 'male', 'L2Pet', 'npc', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 25, 0, 0, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9154, 14480, 'Shadow', '', 'shadow', 10.00, 30.00, 27, 'male', 'L2Pet', 'npc', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 25, 0, 0, 87, 125, 59, 92, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9155, 14481, 'Shadow', '', 'shadow', 10.00, 30.00, 32, 'male', 'L2Pet', 'npc', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 25, 0, 0, 128, 152, 87, 111, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9156, 14482, 'Shadow', '', 'shadow', 10.00, 30.00, 37, 'male', 'L2Pet', 'npc', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 25, 0, 0, 185, 181, 126, 134, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9157, 14483, 'Shadow', '', 'shadow', 10.00, 30.00, 42, 'male', 'L2Pet', 'npc', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 259, 216, 177, 159, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9158, 14484, 'Shadow', '', 'shadow', 10.00, 30.00, 46, 'male', 'L2Pet', 'npc', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 335, 246, 228, 180, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9159, 14485, 'Shadow', '', 'shadow', 10.00, 30.00, 50, 'male', 'L2Pet', 'npc', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 425, 278, 291, 204, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9160, 14486, 'Shadow', '', 'shadow', 10.00, 30.00, 54, 'male', 'L2Pet', 'npc', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 531, 313, 362, 229, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9161, 14487, 'Shadow', '', 'shadow', 10.00, 30.00, 58, 'male', 'L2Pet', 'npc', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 651, 350, 444, 256, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9162, 14488, 'Shadow', '', 'shadow', 10.00, 30.00, 60, 'male', 'L2Pet', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9163, 14489, 'Shadow', '', 'shadow', 10.00, 30.00, 62, 'male', 'L2Pet', 'npc', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 787, 388, 538, 284, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9164, 14490, 'Shadow', '', 'shadow', 10.00, 30.00, 64, 'male', 'L2Pet', 'npc', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 860, 409, 588, 298, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9165, 14491, 'Shadow', '', 'shadow', 10.00, 30.00, 66, 'male', 'L2Pet', 'npc', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 936, 429, 639, 313, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9166, 14492, 'Shadow', '', 'shadow', 10.00, 30.00, 68, 'male', 'L2Pet', 'npc', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9167, 14493, 'Shadow', '', 'shadow', 10.00, 30.00, 70, 'male', 'L2Pet', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9168, 14494, 'Shadow', '', 'shadow', 10.00, 30.00, 72, 'male', 'L2Pet', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9169, 14495, 'Shadow', '', 'shadow', 10.00, 30.00, 74, 'male', 'L2Pet', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9170, 14496, 'Shadow', '', 'shadow', 10.00, 30.00, 76, 'male', 'L2Pet', 'npc', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9171, 14497, 'Shadow', '', 'shadow', 10.00, 30.00, 78, 'male', 'L2Pet', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9172, 14498, 'Shadow', '', 'shadow', 10.00, 30.00, 78, 'male', 'L2Pet', 'npc', 40, 2813, 8.500, 1616, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1438, 558, 982, 407, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9173, 14499, 'Shadow', '', 'shadow', 10.00, 30.00, 78, 'male', 'L2Pet', 'npc', 40, 2823, 8.500, 1624, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1446, 559, 987, 409, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9174, 14500, 'Shadow', '', 'shadow', 10.00, 30.00, 78, 'male', 'L2Pet', 'npc', 40, 2832, 8.500, 1633, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1455, 561, 992, 411, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9175, 14501, 'Shadow', '', 'shadow', 10.00, 30.00, 79, 'male', 'L2Pet', 'npc', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1470, 566, 1005, 415, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9176, 14502, 'Shadow', '', 'shadow', 10.00, 30.00, 79, 'male', 'L2Pet', 'npc', 40, 2852, 8.500, 1649, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1478, 568, 1010, 415, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9177, 14503, 'Shadow', '', 'shadow', 10.00, 30.00, 79, 'male', 'L2Pet', 'npc', 40, 2862, 8.500, 1658, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1487, 570, 1016, 417, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9178, 14504, 'Shadow', '', 'shadow', 10.00, 30.00, 79, 'male', 'L2Pet', 'npc', 40, 2872, 8.500, 1666, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1495, 571, 1021, 418, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9179, 14505, 'Shadow', '', 'shadow', 10.00, 30.00, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9180, 14506, 'Shadow', '', 'shadow', 10.00, 30.00, 80, 'male', 'L2Pet', 'npc', 40, 2890, 8.500, 1683, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1521, 578, 1038, 424, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9181, 14507, 'Shadow', '', 'shadow', 10.00, 30.00, 80, 'male', 'L2Pet', 'npc', 40, 2899, 8.500, 1692, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1528, 581, 1044, 424, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9182, 14508, 'Shadow', '', 'shadow', 10.00, 30.00, 80, 'male', 'L2Pet', 'npc', 40, 2909, 8.500, 1700, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1536, 583, 1049, 426, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9183, 14509, 'Shadow', '', 'shadow', 10.00, 30.00, 81, 'male', 'L2Pet', 'npc', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1554, 588, 1061, 430, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9184, 14510, 'Shadow', '', 'shadow', 10.00, 30.00, 81, 'male', 'L2Pet', 'npc', 40, 2926, 8.500, 1717, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1561, 590, 1066, 432, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9185, 14511, 'Shadow', '', 'shadow', 10.00, 30.00, 81, 'male', 'L2Pet', 'npc', 40, 2935, 8.500, 1726, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1569, 592, 1071, 432, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9186, 14512, 'Shadow', '', 'shadow', 10.00, 30.00, 81, 'male', 'L2Pet', 'npc', 40, 2944, 8.500, 1734, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1578, 593, 1076, 434, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9187, 14513, 'Shadow', '', 'shadow', 10.00, 30.00, 82, 'male', 'L2Pet', 'npc', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9188, 14514, 'Shadow', '', 'shadow', 10.00, 30.00, 82, 'male', 'L2Pet', 'npc', 40, 2961, 8.500, 1752, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1601, 600, 1093, 439, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9189, 14515, 'Shadow', '', 'shadow', 10.00, 30.00, 82, 'male', 'L2Pet', 'npc', 40, 2969, 8.500, 1760, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1609, 602, 1100, 439, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9190, 14516, 'Shadow', '', 'shadow', 10.00, 30.00, 82, 'male', 'L2Pet', 'npc', 40, 2978, 8.500, 1769, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1618, 604, 1105, 441, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9191, 14517, 'Shadow', '', 'shadow', 10.00, 30.00, 83, 'male', 'L2Pet', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9192, 14518, 'Shadow', '', 'shadow', 10.00, 30.00, 83, 'male', 'L2Pet', 'npc', 40, 2994, 8.500, 1786, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1120, 447, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9193, 14519, 'Shadow', '', 'shadow', 10.00, 30.00, 83, 'male', 'L2Pet', 'npc', 40, 3002, 8.500, 1795, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1648, 612, 1125, 447, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9194, 14520, 'Shadow', '', 'shadow', 10.00, 30.00, 83, 'male', 'L2Pet', 'npc', 40, 3010, 8.500, 1803, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1656, 614, 1130, 449, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9195, 14521, 'Shadow', '', 'shadow', 10.00, 30.00, 84, 'male', 'L2Pet', 'npc', 40, 3017, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1673, 619, 1142, 453, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9196, 14522, 'Shadow', '', 'shadow', 10.00, 30.00, 84, 'male', 'L2Pet', 'npc', 40, 3025, 8.500, 1821, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 621, 1147, 455, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9197, 14523, 'Shadow', '', 'shadow', 10.00, 30.00, 84, 'male', 'L2Pet', 'npc', 40, 3033, 8.500, 1829, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1687, 623, 1152, 455, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9198, 14524, 'Shadow', '', 'shadow', 10.00, 30.00, 85, 'male', 'L2Pet', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9199, 14525, 'Shadow', '', 'shadow', 10.00, 30.00, 85, 'male', 'L2Pet', 'npc', 40, 3057, 8.500, 1858, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1721, 632, 1175, 463, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9200, 14526, 'Shadow', '', 'shadow', 10.00, 30.00, 85, 'male', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9201, 14527, 'Silhouette', '', 'silhouette', 8.00, 23.00, 22, 'female', 'L2Pet', 'npc', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 25, 0, 0, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9202, 14528, 'Silhouette', '', 'silhouette', 8.00, 23.00, 27, 'female', 'L2Pet', 'npc', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 25, 0, 0, 87, 125, 59, 92, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9203, 14529, 'Silhouette', '', 'silhouette', 8.00, 23.00, 32, 'female', 'L2Pet', 'npc', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 25, 0, 0, 128, 152, 87, 111, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9204, 14530, 'Silhouette', '', 'silhouette', 8.00, 23.00, 37, 'female', 'L2Pet', 'npc', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 25, 0, 0, 185, 181, 126, 134, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9205, 14531, 'Silhouette', '', 'silhouette', 8.00, 23.00, 42, 'female', 'L2Pet', 'npc', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 259, 216, 177, 159, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9206, 14532, 'Silhouette', '', 'silhouette', 8.00, 23.00, 46, 'female', 'L2Pet', 'npc', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 335, 246, 228, 180, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9207, 14533, 'Silhouette', '', 'silhouette', 8.00, 23.00, 50, 'female', 'L2Pet', 'npc', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 425, 278, 291, 204, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9208, 14534, 'Silhouette', '', 'silhouette', 8.00, 23.00, 54, 'female', 'L2Pet', 'npc', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 531, 313, 362, 229, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9209, 14535, 'Silhouette', '', 'silhouette', 8.00, 23.00, 58, 'female', 'L2Pet', 'npc', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 651, 350, 444, 256, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9210, 14536, 'Silhouette', '', 'silhouette', 8.00, 23.00, 60, 'female', 'L2Pet', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9211, 14537, 'Silhouette', '', 'silhouette', 8.00, 23.00, 62, 'female', 'L2Pet', 'npc', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 787, 388, 538, 284, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9212, 14538, 'Silhouette', '', 'silhouette', 8.00, 23.00, 64, 'female', 'L2Pet', 'npc', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 860, 409, 588, 298, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9213, 14539, 'Silhouette', '', 'silhouette', 8.00, 23.00, 66, 'female', 'L2Pet', 'npc', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 936, 429, 639, 313, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9214, 14540, 'Silhouette', '', 'silhouette', 8.00, 23.00, 68, 'female', 'L2Pet', 'npc', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9215, 14541, 'Silhouette', '', 'silhouette', 8.00, 23.00, 70, 'female', 'L2Pet', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9216, 14542, 'Silhouette', '', 'silhouette', 8.00, 23.00, 72, 'female', 'L2Pet', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9217, 14543, 'Silhouette', '', 'silhouette', 8.00, 23.00, 74, 'female', 'L2Pet', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9218, 14544, 'Silhouette', '', 'silhouette', 8.00, 23.00, 76, 'female', 'L2Pet', 'npc', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9219, 14545, 'Silhouette', '', 'silhouette', 8.00, 23.00, 78, 'female', 'L2Pet', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9220, 14546, 'Silhouette', '', 'silhouette', 8.00, 23.00, 78, 'female', 'L2Pet', 'npc', 40, 2813, 8.500, 1616, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1438, 558, 982, 407, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9221, 14547, 'Silhouette', '', 'silhouette', 8.00, 23.00, 78, 'female', 'L2Pet', 'npc', 40, 2823, 8.500, 1624, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1446, 559, 987, 409, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9222, 14548, 'Silhouette', '', 'silhouette', 8.00, 23.00, 78, 'female', 'L2Pet', 'npc', 40, 2832, 8.500, 1633, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1455, 561, 992, 411, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9223, 14549, 'Silhouette', '', 'silhouette', 8.00, 23.00, 79, 'female', 'L2Pet', 'npc', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1470, 566, 1005, 415, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9224, 14550, 'Silhouette', '', 'silhouette', 8.00, 23.00, 79, 'female', 'L2Pet', 'npc', 40, 2852, 8.500, 1649, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1478, 568, 1010, 415, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9225, 14551, 'Silhouette', '', 'silhouette', 8.00, 23.00, 79, 'female', 'L2Pet', 'npc', 40, 2862, 8.500, 1658, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1487, 570, 1016, 417, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9226, 14552, 'Silhouette', '', 'silhouette', 8.00, 23.00, 79, 'female', 'L2Pet', 'npc', 40, 2872, 8.500, 1666, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1495, 571, 1021, 418, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9227, 14553, 'Silhouette', '', 'silhouette', 8.00, 23.00, 80, 'female', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9228, 14554, 'Silhouette', '', 'silhouette', 8.00, 23.00, 80, 'female', 'L2Pet', 'npc', 40, 2890, 8.500, 1683, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1521, 578, 1038, 424, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9229, 14555, 'Silhouette', '', 'silhouette', 8.00, 23.00, 80, 'female', 'L2Pet', 'npc', 40, 2899, 8.500, 1692, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1528, 581, 1044, 424, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9230, 14556, 'Silhouette', '', 'silhouette', 8.00, 23.00, 80, 'female', 'L2Pet', 'npc', 40, 2909, 8.500, 1700, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1536, 583, 1049, 426, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9231, 14557, 'Silhouette', '', 'silhouette', 8.00, 23.00, 81, 'female', 'L2Pet', 'npc', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1554, 588, 1061, 430, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9232, 14558, 'Silhouette', '', 'silhouette', 8.00, 23.00, 81, 'female', 'L2Pet', 'npc', 40, 2926, 8.500, 1717, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1561, 590, 1066, 432, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9233, 14559, 'Silhouette', '', 'silhouette', 8.00, 23.00, 81, 'female', 'L2Pet', 'npc', 40, 2935, 8.500, 1726, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1569, 592, 1071, 432, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9234, 14560, 'Silhouette', '', 'silhouette', 8.00, 23.00, 81, 'female', 'L2Pet', 'npc', 40, 2944, 8.500, 1734, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1578, 593, 1076, 434, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9235, 14561, 'Silhouette', '', 'silhouette', 8.00, 23.00, 82, 'female', 'L2Pet', 'npc', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9236, 14562, 'Silhouette', '', 'silhouette', 8.00, 23.00, 82, 'female', 'L2Pet', 'npc', 40, 2961, 8.500, 1752, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1601, 600, 1093, 439, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9237, 14563, 'Silhouette', '', 'silhouette', 8.00, 23.00, 82, 'female', 'L2Pet', 'npc', 40, 2969, 8.500, 1760, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1609, 602, 1100, 439, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9238, 14564, 'Silhouette', '', 'silhouette', 8.00, 23.00, 82, 'female', 'L2Pet', 'npc', 40, 2978, 8.500, 1769, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1618, 604, 1105, 441, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9239, 14565, 'Silhouette', '', 'silhouette', 8.00, 23.00, 83, 'female', 'L2Pet', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9240, 14566, 'Silhouette', '', 'silhouette', 8.00, 23.00, 83, 'female', 'L2Pet', 'npc', 40, 2994, 8.500, 1786, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1120, 447, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9241, 14567, 'Silhouette', '', 'silhouette', 8.00, 23.00, 83, 'female', 'L2Pet', 'npc', 40, 3002, 8.500, 1795, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1648, 612, 1125, 447, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9242, 14568, 'Silhouette', '', 'silhouette', 8.00, 23.00, 83, 'female', 'L2Pet', 'npc', 40, 3010, 8.500, 1803, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1656, 614, 1130, 449, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9243, 14569, 'Silhouette', '', 'silhouette', 8.00, 23.00, 84, 'female', 'L2Pet', 'npc', 40, 3017, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1673, 619, 1142, 453, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9244, 14570, 'Silhouette', '', 'silhouette', 8.00, 23.00, 84, 'female', 'L2Pet', 'npc', 40, 3025, 8.500, 1821, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 621, 1147, 455, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9245, 14571, 'Silhouette', '', 'silhouette', 8.00, 23.00, 84, 'female', 'L2Pet', 'npc', 40, 3033, 8.500, 1829, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1687, 623, 1152, 455, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9246, 14572, 'Silhouette', '', 'silhouette', 8.00, 23.00, 85, 'female', 'L2Pet', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9247, 14573, 'Silhouette', '', 'silhouette', 8.00, 23.00, 85, 'female', 'L2Pet', 'npc', 40, 3057, 8.500, 1858, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1721, 632, 1175, 463, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9248, 14574, 'Silhouette', '', 'silhouette', 8.00, 23.00, 85, 'female', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 80, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9249, 14575, 'Soulless', '', 'shadeless', 7.00, 28.00, 42, 'male', 'L2Pet', 'npc', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 259, 216, 177, 159, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9250, 14576, 'Soulless', '', 'shadeless', 7.00, 28.00, 46, 'male', 'L2Pet', 'npc', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 335, 246, 228, 180, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9251, 14577, 'Soulless', '', 'shadeless', 7.00, 28.00, 50, 'male', 'L2Pet', 'npc', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 425, 278, 291, 204, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9252, 14578, 'Soulless', '', 'shadeless', 7.00, 28.00, 54, 'male', 'L2Pet', 'npc', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 531, 313, 362, 229, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9253, 14579, 'Soulless', '', 'shadeless', 7.00, 28.00, 58, 'male', 'L2Pet', 'npc', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 651, 350, 444, 256, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9254, 14580, 'Soulless', '', 'shadeless', 7.00, 28.00, 60, 'male', 'L2Pet', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9255, 14581, 'Soulless', '', 'shadeless', 7.00, 28.00, 62, 'male', 'L2Pet', 'npc', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 787, 388, 538, 284, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9256, 14582, 'Soulless', '', 'shadeless', 7.00, 28.00, 64, 'male', 'L2Pet', 'npc', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 860, 409, 588, 298, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9257, 14583, 'Soulless', '', 'shadeless', 7.00, 28.00, 66, 'male', 'L2Pet', 'npc', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 936, 429, 639, 313, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9258, 14584, 'Soulless', '', 'shadeless', 7.00, 28.00, 68, 'male', 'L2Pet', 'npc', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9259, 14585, 'Soulless', '', 'shadeless', 7.00, 28.00, 70, 'male', 'L2Pet', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9260, 14586, 'Soulless', '', 'shadeless', 7.00, 28.00, 72, 'male', 'L2Pet', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9261, 14587, 'Soulless', '', 'shadeless', 7.00, 28.00, 74, 'male', 'L2Pet', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9262, 14588, 'Soulless', '', 'shadeless', 7.00, 28.00, 76, 'male', 'L2Pet', 'npc', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9263, 14589, 'Soulless', '', 'shadeless', 7.00, 28.00, 78, 'male', 'L2Pet', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9264, 14590, 'Soulless', '', 'shadeless', 7.00, 28.00, 78, 'male', 'L2Pet', 'npc', 40, 2813, 8.500, 1616, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1438, 558, 982, 407, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9265, 14591, 'Soulless', '', 'shadeless', 7.00, 28.00, 78, 'male', 'L2Pet', 'npc', 40, 2823, 8.500, 1624, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1446, 559, 987, 409, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9266, 14592, 'Soulless', '', 'shadeless', 7.00, 28.00, 78, 'male', 'L2Pet', 'npc', 40, 2832, 8.500, 1633, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1455, 561, 992, 411, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9267, 14593, 'Soulless', '', 'shadeless', 7.00, 28.00, 79, 'male', 'L2Pet', 'npc', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1470, 566, 1005, 415, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9268, 14594, 'Soulless', '', 'shadeless', 7.00, 28.00, 79, 'male', 'L2Pet', 'npc', 40, 2852, 8.500, 1649, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1478, 568, 1010, 415, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9269, 14595, 'Soulless', '', 'shadeless', 7.00, 28.00, 79, 'male', 'L2Pet', 'npc', 40, 2862, 8.500, 1658, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1487, 570, 1016, 417, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9270, 14596, 'Soulless', '', 'shadeless', 7.00, 28.00, 79, 'male', 'L2Pet', 'npc', 40, 2872, 8.500, 1666, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1495, 571, 1021, 418, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9271, 14597, 'Soulless', '', 'shadeless', 7.00, 28.00, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9272, 14598, 'Soulless', '', 'shadeless', 7.00, 28.00, 80, 'male', 'L2Pet', 'npc', 40, 2890, 8.500, 1683, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1521, 578, 1038, 424, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9273, 14599, 'Soulless', '', 'shadeless', 7.00, 28.00, 80, 'male', 'L2Pet', 'npc', 40, 2899, 8.500, 1692, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1528, 581, 1044, 424, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9274, 14600, 'Soulless', '', 'shadeless', 7.00, 28.00, 80, 'male', 'L2Pet', 'npc', 40, 2909, 8.500, 1700, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1536, 583, 1049, 426, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9275, 14601, 'Soulless', '', 'shadeless', 7.00, 28.00, 81, 'male', 'L2Pet', 'npc', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1554, 588, 1061, 430, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9276, 14602, 'Soulless', '', 'shadeless', 7.00, 28.00, 81, 'male', 'L2Pet', 'npc', 40, 2926, 8.500, 1717, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1561, 590, 1066, 432, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9277, 14603, 'Soulless', '', 'shadeless', 7.00, 28.00, 81, 'male', 'L2Pet', 'npc', 40, 2935, 8.500, 1726, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1569, 592, 1071, 432, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9278, 14604, 'Soulless', '', 'shadeless', 7.00, 28.00, 81, 'male', 'L2Pet', 'npc', 40, 2944, 8.500, 1734, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1578, 593, 1076, 434, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9279, 14605, 'Soulless', '', 'shadeless', 7.00, 28.00, 82, 'male', 'L2Pet', 'npc', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9280, 14606, 'Soulless', '', 'shadeless', 7.00, 28.00, 82, 'male', 'L2Pet', 'npc', 40, 2961, 8.500, 1752, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1601, 600, 1093, 439, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9281, 14607, 'Soulless', '', 'shadeless', 7.00, 28.00, 82, 'male', 'L2Pet', 'npc', 40, 2969, 8.500, 1760, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1609, 602, 1100, 439, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9282, 14608, 'Soulless', '', 'shadeless', 7.00, 28.00, 82, 'male', 'L2Pet', 'npc', 40, 2978, 8.500, 1769, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1618, 604, 1105, 441, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9283, 14609, 'Soulless', '', 'shadeless', 7.00, 28.00, 83, 'male', 'L2Pet', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9284, 14610, 'Soulless', '', 'shadeless', 7.00, 28.00, 83, 'male', 'L2Pet', 'npc', 40, 2994, 8.500, 1786, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1120, 447, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9285, 14611, 'Soulless', '', 'shadeless', 7.00, 28.00, 83, 'male', 'L2Pet', 'npc', 40, 3002, 8.500, 1795, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1648, 612, 1125, 447, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9286, 14612, 'Soulless', '', 'shadeless', 7.00, 28.00, 83, 'male', 'L2Pet', 'npc', 40, 3010, 8.500, 1803, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1656, 614, 1130, 449, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9287, 14613, 'Soulless', '', 'shadeless', 7.00, 28.00, 84, 'male', 'L2Pet', 'npc', 40, 3017, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1673, 619, 1142, 453, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9288, 14614, 'Soulless', '', 'shadeless', 7.00, 28.00, 84, 'male', 'L2Pet', 'npc', 40, 3025, 8.500, 1821, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 621, 1147, 455, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9289, 14615, 'Soulless', '', 'shadeless', 7.00, 28.00, 84, 'male', 'L2Pet', 'npc', 40, 3033, 8.500, 1829, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1687, 623, 1152, 455, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9290, 14616, 'Soulless', '', 'shadeless', 7.00, 28.00, 85, 'male', 'L2Pet', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9291, 14617, 'Soulless', '', 'shadeless', 7.00, 28.00, 85, 'male', 'L2Pet', 'npc', 40, 3057, 8.500, 1858, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1721, 632, 1175, 463, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9292, 14618, 'Soulless', '', 'shadeless', 7.00, 28.00, 85, 'male', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9293, 14619, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 58, 'male', 'L2Pet', 'npc', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 651, 350, 444, 256, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9294, 14620, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 60, 'male', 'L2Pet', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9295, 14621, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 62, 'male', 'L2Pet', 'npc', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 787, 388, 538, 284, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9296, 14622, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 64, 'male', 'L2Pet', 'npc', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 860, 409, 588, 298, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9297, 14623, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 66, 'male', 'L2Pet', 'npc', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 936, 429, 639, 313, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9298, 14624, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 68, 'male', 'L2Pet', 'npc', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9299, 14625, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 70, 'male', 'L2Pet', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9300, 14626, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 72, 'male', 'L2Pet', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9301, 14627, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 74, 'male', 'L2Pet', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9302, 14628, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 76, 'male', 'L2Pet', 'npc', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9303, 14633, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 78, 'male', 'L2Pet', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9304, 14634, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 78, 'male', 'L2Pet', 'npc', 40, 2813, 8.500, 1616, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1438, 558, 982, 407, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9305, 14635, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 78, 'male', 'L2Pet', 'npc', 40, 2823, 8.500, 1624, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1446, 559, 987, 409, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9306, 14636, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 78, 'male', 'L2Pet', 'npc', 40, 2832, 8.500, 1633, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1455, 561, 992, 411, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9307, 14637, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 79, 'male', 'L2Pet', 'npc', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1470, 566, 1005, 415, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9308, 14638, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 79, 'male', 'L2Pet', 'npc', 40, 2852, 8.500, 1649, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1478, 568, 1010, 415, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9309, 14639, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 79, 'male', 'L2Pet', 'npc', 40, 2862, 8.500, 1658, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1487, 570, 1016, 417, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9310, 14640, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 79, 'male', 'L2Pet', 'npc', 40, 2872, 8.500, 1666, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1495, 571, 1021, 418, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9311, 14641, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9312, 14642, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 80, 'male', 'L2Pet', 'npc', 40, 2890, 8.500, 1683, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1521, 578, 1038, 424, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9313, 14643, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 80, 'male', 'L2Pet', 'npc', 40, 2899, 8.500, 1692, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1528, 581, 1044, 424, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9314, 14644, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 80, 'male', 'L2Pet', 'npc', 40, 2909, 8.500, 1700, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1536, 583, 1049, 426, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9315, 14645, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 81, 'male', 'L2Pet', 'npc', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1554, 588, 1061, 430, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9316, 14646, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 81, 'male', 'L2Pet', 'npc', 40, 2926, 8.500, 1717, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1561, 590, 1066, 432, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9317, 14647, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 81, 'male', 'L2Pet', 'npc', 40, 2935, 8.500, 1726, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1569, 592, 1071, 432, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9318, 14648, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 81, 'male', 'L2Pet', 'npc', 40, 2944, 8.500, 1734, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1578, 593, 1076, 434, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9319, 14649, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 82, 'male', 'L2Pet', 'npc', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9320, 14650, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 82, 'male', 'L2Pet', 'npc', 40, 2961, 8.500, 1752, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1601, 600, 1093, 439, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9321, 14651, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 82, 'male', 'L2Pet', 'npc', 40, 2969, 8.500, 1760, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1609, 602, 1100, 439, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9322, 14652, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 82, 'male', 'L2Pet', 'npc', 40, 2978, 8.500, 1769, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1618, 604, 1105, 441, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9323, 14653, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 83, 'male', 'L2Pet', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9324, 14654, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 83, 'male', 'L2Pet', 'npc', 40, 2994, 8.500, 1786, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1120, 447, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9325, 14655, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 83, 'male', 'L2Pet', 'npc', 40, 3002, 8.500, 1795, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1648, 612, 1125, 447, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9326, 14656, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 83, 'male', 'L2Pet', 'npc', 40, 3010, 8.500, 1803, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1656, 614, 1130, 449, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9327, 14657, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 84, 'male', 'L2Pet', 'npc', 40, 3017, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1673, 619, 1142, 453, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9328, 14658, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 84, 'male', 'L2Pet', 'npc', 40, 3025, 8.500, 1821, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 621, 1147, 455, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9329, 14659, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 84, 'male', 'L2Pet', 'npc', 40, 3033, 8.500, 1829, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1687, 623, 1152, 455, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9330, 14660, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 85, 'male', 'L2Pet', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9331, 14661, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 85, 'male', 'L2Pet', 'npc', 40, 3057, 8.500, 1858, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1721, 632, 1175, 463, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9332, 14662, 'Nightshade', '', 'knight_of_shadow', 10.00, 35.50, 85, 'male', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9333, 14663, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 30, 'male', 'L2Pet', 'npc', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 25, 0, 0, 111, 140, 75, 104, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9334, 14664, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 38, 'male', 'L2Pet', 'npc', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 25, 0, 0, 198, 188, 136, 138, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9335, 14665, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 45, 'male', 'L2Pet', 'npc', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 315, 239, 214, 174, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9336, 14666, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 51, 'male', 'L2Pet', 'npc', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 449, 287, 307, 210, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9337, 14667, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 57, 'male', 'L2Pet', 'npc', 40, 1777, 6.500, 948, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 619, 340, 423, 250, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9338, 14668, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 62, 'male', 'L2Pet', 'npc', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 787, 388, 538, 284, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9339, 14669, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 66, 'male', 'L2Pet', 'npc', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 936, 429, 639, 313, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9340, 14670, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 70, 'male', 'L2Pet', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9341, 14671, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 74, 'male', 'L2Pet', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9342, 14672, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 78, 'male', 'L2Pet', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9343, 14673, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 78, 'male', 'L2Pet', 'npc', 40, 2813, 8.500, 1616, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1438, 558, 982, 407, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9344, 14674, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 78, 'male', 'L2Pet', 'npc', 40, 2823, 8.500, 1624, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1446, 559, 987, 409, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9345, 14675, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 78, 'male', 'L2Pet', 'npc', 40, 2832, 8.500, 1633, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1455, 561, 992, 411, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9346, 14676, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 79, 'male', 'L2Pet', 'npc', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1470, 566, 1005, 415, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9347, 14677, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 79, 'male', 'L2Pet', 'npc', 40, 2852, 8.500, 1649, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1478, 568, 1010, 415, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9348, 14678, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 79, 'male', 'L2Pet', 'npc', 40, 2862, 8.500, 1658, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1487, 570, 1016, 417, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9349, 14679, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 79, 'male', 'L2Pet', 'npc', 40, 2872, 8.500, 1666, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1495, 571, 1021, 418, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9350, 14680, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9351, 14681, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 80, 'male', 'L2Pet', 'npc', 40, 2890, 8.500, 1683, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1521, 578, 1038, 424, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9352, 14682, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 80, 'male', 'L2Pet', 'npc', 40, 2899, 8.500, 1692, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1528, 581, 1044, 424, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9353, 14683, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 80, 'male', 'L2Pet', 'npc', 40, 2909, 8.500, 1700, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1536, 583, 1049, 426, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9354, 14684, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 81, 'male', 'L2Pet', 'npc', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1554, 588, 1061, 430, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9355, 14685, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 81, 'male', 'L2Pet', 'npc', 40, 2926, 8.500, 1717, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1561, 590, 1066, 432, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9356, 14686, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 81, 'male', 'L2Pet', 'npc', 40, 2935, 8.500, 1726, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1569, 592, 1071, 432, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9357, 14687, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 81, 'male', 'L2Pet', 'npc', 40, 2944, 8.500, 1734, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1578, 593, 1076, 434, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9358, 14688, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 82, 'male', 'L2Pet', 'npc', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9359, 14689, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 82, 'male', 'L2Pet', 'npc', 40, 2961, 8.500, 1752, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1601, 600, 1093, 439, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9360, 14690, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 82, 'male', 'L2Pet', 'npc', 40, 2969, 8.500, 1760, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1609, 602, 1100, 439, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9361, 14691, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 82, 'male', 'L2Pet', 'npc', 40, 2978, 8.500, 1769, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1618, 604, 1105, 441, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9362, 14692, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 83, 'male', 'L2Pet', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9363, 14693, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 83, 'male', 'L2Pet', 'npc', 40, 2994, 8.500, 1786, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1120, 447, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9364, 14694, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 83, 'male', 'L2Pet', 'npc', 40, 3002, 8.500, 1795, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1648, 612, 1125, 447, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9365, 14695, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 83, 'male', 'L2Pet', 'npc', 40, 3010, 8.500, 1803, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1656, 614, 1130, 449, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9366, 14696, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 84, 'male', 'L2Pet', 'npc', 40, 3017, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1673, 619, 1142, 453, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9367, 14697, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 84, 'male', 'L2Pet', 'npc', 40, 3025, 8.500, 1821, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 621, 1147, 455, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9368, 14698, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 84, 'male', 'L2Pet', 'npc', 40, 3033, 8.500, 1829, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1687, 623, 1152, 455, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9369, 14699, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 85, 'male', 'L2Pet', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9370, 14700, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 85, 'male', 'L2Pet', 'npc', 40, 3057, 8.500, 1858, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1721, 632, 1175, 463, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9371, 14701, 'Mechanic Golem', '', 'mechanic_golem', 5.00, 19.00, 85, 'male', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 30, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9372, 14702, 'Big Boom', '', 'big_boom', 6.00, 13.00, 60, 'male', 'L2Pet', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9373, 14703, 'Big Boom', '', 'big_boom', 6.00, 13.00, 64, 'male', 'L2Pet', 'npc', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 860, 409, 588, 298, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9374, 14704, 'Big Boom', '', 'big_boom', 6.00, 13.00, 68, 'male', 'L2Pet', 'npc', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9375, 14705, 'Big Boom', '', 'big_boom', 6.00, 13.00, 72, 'male', 'L2Pet', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9376, 14706, 'Big Boom', '', 'big_boom', 6.00, 13.00, 76, 'male', 'L2Pet', 'npc', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9377, 14707, 'Big Boom', '', 'big_boom', 6.00, 13.00, 78, 'male', 'L2Pet', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 48, 141, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9378, 14708, 'Big Boom', '', 'big_boom', 6.00, 13.00, 78, 'male', 'L2Pet', 'npc', 40, 2813, 8.500, 1616, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1438, 558, 982, 407, 253, 0, 506, 0, 0, 0, 48, 142, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9379, 14709, 'Big Boom', '', 'big_boom', 6.00, 13.00, 78, 'male', 'L2Pet', 'npc', 40, 2823, 8.500, 1624, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1446, 559, 987, 409, 253, 0, 506, 0, 0, 0, 48, 143, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9380, 14710, 'Big Boom', '', 'big_boom', 6.00, 13.00, 78, 'male', 'L2Pet', 'npc', 40, 2832, 8.500, 1633, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1455, 561, 992, 411, 253, 0, 506, 0, 0, 0, 48, 144, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9381, 14711, 'Big Boom', '', 'big_boom', 6.00, 13.00, 79, 'male', 'L2Pet', 'npc', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1470, 566, 1005, 415, 253, 0, 506, 0, 0, 0, 48, 145, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9382, 14712, 'Big Boom', '', 'big_boom', 6.00, 13.00, 79, 'male', 'L2Pet', 'npc', 40, 2852, 8.500, 1649, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1478, 568, 1010, 415, 253, 0, 506, 0, 0, 0, 48, 146, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9383, 14713, 'Big Boom', '', 'big_boom', 6.00, 13.00, 79, 'male', 'L2Pet', 'npc', 40, 2862, 8.500, 1658, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1487, 570, 1016, 417, 253, 0, 506, 0, 0, 0, 48, 147, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9384, 14714, 'Big Boom', '', 'big_boom', 6.00, 13.00, 79, 'male', 'L2Pet', 'npc', 40, 2872, 8.500, 1666, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1495, 571, 1021, 418, 253, 0, 506, 0, 0, 0, 48, 148, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9385, 14715, 'Big Boom', '', 'big_boom', 6.00, 13.00, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 48, 149, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9386, 14716, 'Big Boom', '', 'big_boom', 6.00, 13.00, 80, 'male', 'L2Pet', 'npc', 40, 2890, 8.500, 1683, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1521, 578, 1038, 424, 253, 0, 506, 0, 0, 0, 48, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9387, 14717, 'Big Boom', '', 'big_boom', 6.00, 13.00, 80, 'male', 'L2Pet', 'npc', 40, 2899, 8.500, 1692, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1528, 581, 1044, 424, 253, 0, 506, 0, 0, 0, 48, 151, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9388, 14718, 'Big Boom', '', 'big_boom', 6.00, 13.00, 80, 'male', 'L2Pet', 'npc', 40, 2909, 8.500, 1700, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1536, 583, 1049, 426, 253, 0, 506, 0, 0, 0, 48, 152, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9389, 14719, 'Big Boom', '', 'big_boom', 6.00, 13.00, 81, 'male', 'L2Pet', 'npc', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1554, 588, 1061, 430, 253, 0, 506, 0, 0, 0, 48, 153, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9390, 14720, 'Big Boom', '', 'big_boom', 6.00, 13.00, 81, 'male', 'L2Pet', 'npc', 40, 2926, 8.500, 1717, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1561, 590, 1066, 432, 253, 0, 506, 0, 0, 0, 48, 154, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9391, 14721, 'Big Boom', '', 'big_boom', 6.00, 13.00, 81, 'male', 'L2Pet', 'npc', 40, 2935, 8.500, 1726, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1569, 592, 1071, 432, 253, 0, 506, 0, 0, 0, 48, 155, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9392, 14722, 'Big Boom', '', 'big_boom', 6.00, 13.00, 81, 'male', 'L2Pet', 'npc', 40, 2944, 8.500, 1734, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1578, 593, 1076, 434, 253, 0, 506, 0, 0, 0, 48, 156, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9393, 14723, 'Big Boom', '', 'big_boom', 6.00, 13.00, 82, 'male', 'L2Pet', 'npc', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 48, 157, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9394, 14724, 'Big Boom', '', 'big_boom', 6.00, 13.00, 82, 'male', 'L2Pet', 'npc', 40, 2961, 8.500, 1752, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1601, 600, 1093, 439, 253, 0, 506, 0, 0, 0, 48, 158, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9395, 14725, 'Big Boom', '', 'big_boom', 6.00, 13.00, 82, 'male', 'L2Pet', 'npc', 40, 2969, 8.500, 1760, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1609, 602, 1100, 439, 253, 0, 506, 0, 0, 0, 48, 159, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9396, 14726, 'Big Boom', '', 'big_boom', 6.00, 13.00, 82, 'male', 'L2Pet', 'npc', 40, 2978, 8.500, 1769, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1618, 604, 1105, 441, 253, 0, 506, 0, 0, 0, 48, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9397, 14727, 'Big Boom', '', 'big_boom', 6.00, 13.00, 83, 'male', 'L2Pet', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 48, 161, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9398, 14728, 'Big Boom', '', 'big_boom', 6.00, 13.00, 83, 'male', 'L2Pet', 'npc', 40, 2994, 8.500, 1786, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1120, 447, 253, 0, 506, 0, 0, 0, 48, 162, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9399, 14729, 'Big Boom', '', 'big_boom', 6.00, 13.00, 83, 'male', 'L2Pet', 'npc', 40, 3002, 8.500, 1795, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1648, 612, 1125, 447, 253, 0, 506, 0, 0, 0, 48, 163, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9400, 14730, 'Big Boom', '', 'big_boom', 6.00, 13.00, 83, 'male', 'L2Pet', 'npc', 40, 3010, 8.500, 1803, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1656, 614, 1130, 449, 253, 0, 506, 0, 0, 0, 48, 164, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9401, 14731, 'Big Boom', '', 'big_boom', 6.00, 13.00, 84, 'male', 'L2Pet', 'npc', 40, 3017, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1673, 619, 1142, 453, 253, 0, 506, 0, 0, 0, 48, 165, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9402, 14732, 'Big Boom', '', 'big_boom', 6.00, 13.00, 84, 'male', 'L2Pet', 'npc', 40, 3025, 8.500, 1821, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 621, 1147, 455, 253, 0, 506, 0, 0, 0, 48, 166, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9403, 14733, 'Big Boom', '', 'big_boom', 6.00, 13.00, 84, 'male', 'L2Pet', 'npc', 40, 3033, 8.500, 1829, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1687, 623, 1152, 455, 253, 0, 506, 0, 0, 0, 48, 167, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9404, 14734, 'Big Boom', '', 'big_boom', 6.00, 13.00, 85, 'male', 'L2Pet', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 48, 168, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9405, 14735, 'Big Boom', '', 'big_boom', 6.00, 13.00, 85, 'male', 'L2Pet', 'npc', 40, 3057, 8.500, 1858, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1721, 632, 1175, 463, 253, 0, 506, 0, 0, 0, 48, 169, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9406, 14736, 'Big Boom', '', 'big_boom', 6.00, 13.00, 85, 'male', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 48, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9407, 14737, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 55, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 2160, 1205, 382, 971, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9408, 14738, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 78, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 2530, 1398, 443, 1126, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9409, 14739, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 78, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 2555, 1398, 443, 1126, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9410, 14740, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 78, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 2580, 1398, 443, 1126, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9411, 14741, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 78, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 2605, 1398, 443, 1126, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9412, 14742, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 79, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 2646, 1406, 445, 1132, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9413, 14743, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 79, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 2671, 1406, 445, 1132, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9414, 14744, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 79, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 2696, 1406, 445, 1132, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9415, 14745, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 79, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 2722, 1406, 445, 1132, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9416, 14746, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 80, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 2763, 1415, 448, 1139, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9417, 14747, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 80, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 2789, 1415, 448, 1139, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9418, 14748, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 80, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 2814, 1415, 448, 1139, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9419, 14749, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 80, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 2839, 1415, 448, 1139, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9420, 14750, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 81, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 2882, 1423, 451, 1146, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9421, 14751, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 81, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 2907, 1423, 451, 1146, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9422, 14752, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 81, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 2933, 1423, 451, 1146, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9423, 14753, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 81, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 2958, 1423, 451, 1146, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9424, 14754, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 82, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 3001, 1431, 453, 1153, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9425, 14755, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 82, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 3027, 1431, 453, 1153, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9426, 14756, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 82, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 3052, 1431, 453, 1153, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9427, 14757, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 82, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 3078, 1431, 453, 1153, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9428, 14758, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 83, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 3122, 1440, 456, 1159, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9429, 14759, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 83, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 3148, 1440, 456, 1159, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9430, 14760, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 83, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 3173, 1440, 456, 1159, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9431, 14761, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 83, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 3199, 1440, 456, 1159, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9432, 14762, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 84, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 3244, 1448, 458, 1166, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9433, 14763, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 84, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 3270, 1448, 458, 1166, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9434, 14764, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 84, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 3296, 1448, 458, 1166, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9435, 14765, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 85, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 3341, 1456, 461, 1173, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9436, 14766, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 85, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 3367, 1456, 461, 1173, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9437, 14767, 'Siege Golem', '', 'siege_golem', 60.00, 140.00, 85, 'male', 'L2Pet', 'npc', 80, 500000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 3393, 1456, 461, 1173, 150, 0, 300, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9438, 14768, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 60, 'male', 'L2Pet', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 717, 496, 870, 362, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9439, 14769, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 78, 'male', 'L2Pet', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1430, 558, 982, 407, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9440, 14770, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 78, 'male', 'L2Pet', 'npc', 40, 2813, 8.500, 1616, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1438, 559, 987, 409, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9441, 14771, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 78, 'male', 'L2Pet', 'npc', 40, 2823, 8.500, 1624, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1446, 561, 992, 411, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9442, 14772, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 78, 'male', 'L2Pet', 'npc', 40, 2832, 8.500, 1633, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1455, 563, 999, 412, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9443, 14773, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 79, 'male', 'L2Pet', 'npc', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1470, 568, 1010, 415, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9444, 14774, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 79, 'male', 'L2Pet', 'npc', 40, 2852, 8.500, 1649, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1478, 570, 1016, 417, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9445, 14775, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 79, 'male', 'L2Pet', 'npc', 40, 2862, 8.500, 1658, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1487, 571, 1021, 418, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9446, 14776, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 79, 'male', 'L2Pet', 'npc', 40, 2872, 8.500, 1666, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1495, 573, 1026, 420, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9447, 14777, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 578, 1038, 424, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9448, 14778, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 80, 'male', 'L2Pet', 'npc', 40, 2890, 8.500, 1683, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1521, 581, 1044, 424, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9449, 14779, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 80, 'male', 'L2Pet', 'npc', 40, 2899, 8.500, 1692, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1528, 583, 1049, 426, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9450, 14780, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 80, 'male', 'L2Pet', 'npc', 40, 2909, 8.500, 1700, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1536, 585, 1055, 428, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9451, 14781, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 81, 'male', 'L2Pet', 'npc', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1554, 590, 1066, 432, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9452, 14782, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 81, 'male', 'L2Pet', 'npc', 40, 2926, 8.500, 1717, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1561, 592, 1071, 432, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9453, 14783, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 81, 'male', 'L2Pet', 'npc', 40, 2935, 8.500, 1726, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1569, 593, 1076, 434, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9454, 14784, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 81, 'male', 'L2Pet', 'npc', 40, 2944, 8.500, 1734, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1578, 595, 1081, 435, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9455, 14785, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 82, 'male', 'L2Pet', 'npc', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1594, 600, 1093, 439, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9456, 14786, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 82, 'male', 'L2Pet', 'npc', 40, 2961, 8.500, 1752, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1601, 602, 1100, 439, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9457, 14787, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 82, 'male', 'L2Pet', 'npc', 40, 2969, 8.500, 1760, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1609, 604, 1105, 441, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9458, 14788, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 82, 'male', 'L2Pet', 'npc', 40, 2978, 8.500, 1769, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1618, 605, 1108, 443, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9459, 14789, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 83, 'male', 'L2Pet', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1634, 611, 1120, 447, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9460, 14790, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 83, 'male', 'L2Pet', 'npc', 40, 2994, 8.500, 1786, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 612, 1125, 447, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9461, 14791, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 83, 'male', 'L2Pet', 'npc', 40, 3002, 8.500, 1795, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1648, 614, 1130, 449, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9462, 14792, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 83, 'male', 'L2Pet', 'npc', 40, 3010, 8.500, 1803, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1656, 616, 1135, 451, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9463, 14793, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 84, 'male', 'L2Pet', 'npc', 40, 3017, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1673, 621, 1147, 455, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9464, 14794, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 84, 'male', 'L2Pet', 'npc', 40, 3025, 8.500, 1821, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 623, 1152, 455, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9465, 14795, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 84, 'male', 'L2Pet', 'npc', 40, 3033, 8.500, 1829, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1687, 626, 1161, 458, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9466, 14796, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 85, 'male', 'L2Pet', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 632, 1175, 463, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9467, 14797, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 85, 'male', 'L2Pet', 'npc', 40, 3057, 8.500, 1858, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1721, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9468, 14798, 'Wild Hog Cannon', '', 'range_golem', 93.00, 90.00, 85, 'male', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 593, 1063, 435, 253, 0, 506, 0, 0, 0, 10, 10, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9469, 14799, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 42, 'male', 'L2Pet', 'npc', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 25, 0, 0, 259, 216, 177, 159, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9470, 14800, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 51, 'male', 'L2Pet', 'npc', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 449, 287, 307, 210, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9471, 14801, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 60, 'male', 'L2Pet', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9472, 14802, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 64, 'male', 'L2Pet', 'npc', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 860, 409, 588, 298, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9473, 14803, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 68, 'male', 'L2Pet', 'npc', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9474, 14804, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 72, 'male', 'L2Pet', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9475, 14805, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 76, 'male', 'L2Pet', 'npc', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9476, 14806, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 78, 'male', 'L2Pet', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9477, 14807, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 78, 'male', 'L2Pet', 'npc', 40, 2813, 8.500, 1616, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1438, 558, 982, 407, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9478, 14808, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 78, 'male', 'L2Pet', 'npc', 40, 2823, 8.500, 1624, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1446, 559, 987, 409, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9479, 14809, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 78, 'male', 'L2Pet', 'npc', 40, 2832, 8.500, 1633, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1455, 561, 992, 411, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9480, 14810, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 79, 'male', 'L2Pet', 'npc', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1470, 566, 1005, 415, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9481, 14811, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 79, 'male', 'L2Pet', 'npc', 40, 2852, 8.500, 1649, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1478, 568, 1010, 415, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9482, 14812, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 79, 'male', 'L2Pet', 'npc', 40, 2862, 8.500, 1658, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1487, 570, 1016, 417, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9483, 14813, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 79, 'male', 'L2Pet', 'npc', 40, 2872, 8.500, 1666, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1495, 571, 1021, 418, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9484, 14814, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9485, 14815, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 80, 'male', 'L2Pet', 'npc', 40, 2890, 8.500, 1683, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1521, 578, 1038, 424, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9486, 14816, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 80, 'male', 'L2Pet', 'npc', 40, 2899, 8.500, 1692, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1528, 581, 1044, 424, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9487, 14817, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 80, 'male', 'L2Pet', 'npc', 40, 2909, 8.500, 1700, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1536, 583, 1049, 426, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9488, 14818, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 81, 'male', 'L2Pet', 'npc', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1554, 588, 1061, 430, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9489, 14819, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 81, 'male', 'L2Pet', 'npc', 40, 2926, 8.500, 1717, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1561, 590, 1066, 432, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9490, 14820, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 81, 'male', 'L2Pet', 'npc', 40, 2935, 8.500, 1726, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1569, 592, 1071, 432, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9491, 14821, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 81, 'male', 'L2Pet', 'npc', 40, 2944, 8.500, 1734, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1578, 593, 1076, 434, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9492, 14822, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 82, 'male', 'L2Pet', 'npc', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9493, 14823, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 82, 'male', 'L2Pet', 'npc', 40, 2961, 8.500, 1752, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1601, 600, 1093, 439, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9494, 14824, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 82, 'male', 'L2Pet', 'npc', 40, 2969, 8.500, 1760, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1609, 602, 1100, 439, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9495, 14825, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 82, 'male', 'L2Pet', 'npc', 40, 2978, 8.500, 1769, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1618, 604, 1105, 441, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9496, 14826, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 83, 'male', 'L2Pet', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9497, 14827, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 83, 'male', 'L2Pet', 'npc', 40, 2994, 8.500, 1786, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1120, 447, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9498, 14828, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 83, 'male', 'L2Pet', 'npc', 40, 3002, 8.500, 1795, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1648, 612, 1125, 447, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9499, 14829, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 83, 'male', 'L2Pet', 'npc', 40, 3010, 8.500, 1803, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1656, 614, 1130, 449, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9500, 14830, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 84, 'male', 'L2Pet', 'npc', 40, 3017, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1673, 619, 1142, 453, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9501, 14831, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 84, 'male', 'L2Pet', 'npc', 40, 3025, 8.500, 1821, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1680, 621, 1147, 455, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9502, 14832, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 84, 'male', 'L2Pet', 'npc', 40, 3033, 8.500, 1829, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1687, 623, 1152, 455, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9503, 14833, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 85, 'male', 'L2Pet', 'npc', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1710, 630, 1168, 461, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9504, 14834, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 85, 'male', 'L2Pet', 'npc', 40, 3057, 8.500, 1858, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1721, 632, 1175, 463, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9505, 14835, 'Dark Panther', '', 'dark_fencer', 7.00, 13.00, 85, 'male', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 25, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9506, 14836, 'Feline King', '', 'king_of_cat', 6.00, 16.01, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9507, 14837, 'Magnus the Unicorn', '', 'unicorn_magnus', 13.50, 17.00, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9508, 14838, 'Spectral Lord', '', 'spectral_knight', 12.50, 33.50, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9509, 14839, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 68, 'male', 'L2Pet', 'npc', 80, 50000, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 19, 1314, 416, 1058, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9510, 14840, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 78, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 20, 1398, 443, 1126, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9511, 14841, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 78, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 20, 1398, 443, 1126, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9512, 14842, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 78, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 20, 1398, 443, 1126, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9513, 14843, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 78, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 22, 1398, 443, 1126, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9514, 14844, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 79, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 22, 1406, 445, 1132, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9515, 14845, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 79, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 22, 1406, 445, 1132, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9516, 14846, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 79, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 22, 1406, 445, 1132, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9517, 14847, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 79, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 22, 1406, 445, 1132, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9518, 14848, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 80, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 22, 1415, 448, 1139, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9519, 14849, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 80, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 24, 1415, 448, 1139, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9520, 14850, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 80, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 24, 1415, 448, 1139, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9521, 14851, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 80, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 24, 1415, 448, 1139, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9522, 14852, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 81, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 24, 1423, 451, 1146, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9523, 14853, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 81, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 24, 1423, 451, 1146, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9524, 14854, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 81, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 24, 1423, 451, 1146, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9525, 14855, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 81, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 26, 1423, 451, 1146, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9526, 14856, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 82, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 26, 1431, 453, 1153, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9527, 14857, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 82, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 26, 1431, 453, 1153, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9528, 14858, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 82, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 26, 1431, 453, 1153, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9529, 14859, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 82, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 26, 1431, 453, 1153, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9530, 14860, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 83, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 26, 1440, 456, 1159, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9531, 14861, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 83, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 28, 1440, 456, 1159, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9532, 14862, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 83, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 28, 1440, 456, 1159, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9533, 14863, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 83, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 28, 1440, 456, 1159, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9534, 14864, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 84, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 28, 1448, 458, 1166, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9535, 14865, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 84, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 28, 1448, 458, 1166, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9536, 14866, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 84, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 28, 1448, 458, 1166, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9537, 14867, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 85, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 28, 1456, 461, 1173, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9538, 14868, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 85, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 28, 1456, 461, 1173, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9539, 14869, 'Swoop Cannon', '', 'toad_cannon', 45.00, 47.50, 85, 'male', 'L2Pet', 'npc', 80, 50000, 8.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 30, 1456, 461, 1173, 150, 0, 300, 0, 0, 0, 60, 40, '', 0, 0, 0, 0, 7, 1, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9540, 14870, 'Divine Beast', '', 'Divine_beast', 23.00, 15.50, 80, 'male', 'L2Pet', 'npc', 40, 2880, 8.500, 1675, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 40, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9541, 14871, 'Feline King', '', 'king_of_cat', 6.00, 16.01, 81, 'male', 'L2Pet', 'npc', 40, 2893, 8.500, 1688, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1532, 583, 1047, 427, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9542, 14872, 'Feline King', '', 'king_of_cat', 6.00, 16.01, 81, 'male', 'L2Pet', 'npc', 40, 2905, 8.500, 1701, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1544, 585, 1054, 428, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9543, 14873, 'Feline King', '', 'king_of_cat', 6.00, 16.01, 81, 'male', 'L2Pet', 'npc', 40, 2918, 8.500, 1714, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1556, 588, 1063, 430, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9544, 14874, 'Feline King', '', 'king_of_cat', 6.00, 16.01, 82, 'male', 'L2Pet', 'npc', 40, 2930, 8.500, 1727, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1575, 595, 1076, 434, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9545, 14875, 'Feline King', '', 'king_of_cat', 6.00, 16.01, 82, 'male', 'L2Pet', 'npc', 40, 2942, 8.500, 1740, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1587, 597, 1084, 436, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9546, 14876, 'Feline King', '', 'king_of_cat', 6.00, 16.01, 82, 'male', 'L2Pet', 'npc', 40, 2955, 8.500, 1753, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1597, 600, 1091, 439, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9547, 14877, 'Feline King', '', 'king_of_cat', 6.00, 16.01, 83, 'male', 'L2Pet', 'npc', 40, 2967, 8.500, 1766, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1619, 605, 1106, 444, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9548, 14878, 'Feline King', '', 'king_of_cat', 6.00, 16.01, 83, 'male', 'L2Pet', 'npc', 40, 2980, 8.500, 1779, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1631, 609, 1113, 445, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9549, 14879, 'Feline King', '', 'king_of_cat', 6.00, 16.01, 83, 'male', 'L2Pet', 'npc', 40, 2992, 8.500, 1792, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1121, 447, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9550, 14880, 'Feline King', '', 'king_of_cat', 6.00, 16.01, 84, 'male', 'L2Pet', 'npc', 40, 3005, 8.500, 1805, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1663, 618, 1135, 452, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9551, 14881, 'Feline King', '', 'king_of_cat', 6.00, 16.01, 84, 'male', 'L2Pet', 'npc', 40, 3017, 8.500, 1818, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1675, 619, 1144, 453, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9552, 14882, 'Feline King', '', 'king_of_cat', 6.00, 16.01, 84, 'male', 'L2Pet', 'npc', 40, 3029, 8.500, 1831, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1685, 623, 1150, 455, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9553, 14883, 'Feline King', '', 'king_of_cat', 6.00, 16.01, 85, 'male', 'L2Pet', 'npc', 40, 3042, 8.500, 1844, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1707, 628, 1166, 459, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9554, 14884, 'Feline King', '', 'king_of_cat', 6.00, 16.01, 85, 'male', 'L2Pet', 'npc', 40, 3054, 8.500, 1857, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1717, 632, 1173, 463, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9555, 14885, 'Feline King', '', 'king_of_cat', 6.00, 16.01, 85, 'male', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9556, 14886, 'Magnus the Unicorn', '', 'unicorn_magnus', 13.50, 17.00, 81, 'male', 'L2Pet', 'npc', 40, 2893, 8.500, 1688, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1532, 583, 1047, 427, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9557, 14887, 'Magnus the Unicorn', '', 'unicorn_magnus', 13.50, 17.00, 81, 'male', 'L2Pet', 'npc', 40, 2905, 8.500, 1701, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1544, 585, 1054, 428, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9558, 14888, 'Magnus the Unicorn', '', 'unicorn_magnus', 13.50, 17.00, 81, 'male', 'L2Pet', 'npc', 40, 2918, 8.500, 1714, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1556, 588, 1063, 430, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9559, 14889, 'Magnus the Unicorn', '', 'unicorn_magnus', 13.50, 17.00, 82, 'male', 'L2Pet', 'npc', 40, 2930, 8.500, 1727, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1575, 595, 1076, 434, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9560, 14890, 'Magnus the Unicorn', '', 'unicorn_magnus', 13.50, 17.00, 82, 'male', 'L2Pet', 'npc', 40, 2942, 8.500, 1740, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1587, 597, 1084, 436, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9561, 14891, 'Magnus the Unicorn', '', 'unicorn_magnus', 13.50, 17.00, 82, 'male', 'L2Pet', 'npc', 40, 2955, 8.500, 1753, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1597, 600, 1091, 439, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9562, 14892, 'Magnus the Unicorn', '', 'unicorn_magnus', 13.50, 17.00, 83, 'male', 'L2Pet', 'npc', 40, 2967, 8.500, 1766, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1619, 605, 1106, 444, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9563, 14893, 'Magnus the Unicorn', '', 'unicorn_magnus', 13.50, 17.00, 83, 'male', 'L2Pet', 'npc', 40, 2980, 8.500, 1779, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1631, 609, 1113, 445, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9564, 14894, 'Magnus the Unicorn', '', 'unicorn_magnus', 13.50, 17.00, 83, 'male', 'L2Pet', 'npc', 40, 2992, 8.500, 1792, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1121, 447, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9565, 14895, 'Magnus the Unicorn', '', 'unicorn_magnus', 13.50, 17.00, 84, 'male', 'L2Pet', 'npc', 40, 3005, 8.500, 1805, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1663, 618, 1135, 452, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9566, 14896, 'Magnus the Unicorn', '', 'unicorn_magnus', 13.50, 17.00, 84, 'male', 'L2Pet', 'npc', 40, 3017, 8.500, 1818, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1675, 619, 1144, 453, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9567, 14897, 'Magnus the Unicorn', '', 'unicorn_magnus', 13.50, 17.00, 84, 'male', 'L2Pet', 'npc', 40, 3029, 8.500, 1831, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1685, 623, 1150, 455, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9568, 14898, 'Magnus the Unicorn', '', 'unicorn_magnus', 13.50, 17.00, 85, 'male', 'L2Pet', 'npc', 40, 3042, 8.500, 1844, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1707, 628, 1166, 459, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9569, 14899, 'Magnus the Unicorn', '', 'unicorn_magnus', 13.50, 17.00, 85, 'male', 'L2Pet', 'npc', 40, 3054, 8.500, 1857, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1717, 632, 1173, 463, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9570, 14900, 'Magnus the Unicorn', '', 'unicorn_magnus', 13.50, 17.00, 85, 'male', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9571, 14901, 'Spectral Lord', '', 'spectral_knight', 12.50, 33.50, 81, 'male', 'L2Pet', 'npc', 40, 2893, 8.500, 1688, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1532, 583, 1047, 427, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9572, 14902, 'Spectral Lord', '', 'spectral_knight', 12.50, 33.50, 81, 'male', 'L2Pet', 'npc', 40, 2905, 8.500, 1701, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1544, 585, 1054, 428, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9573, 14903, 'Spectral Lord', '', 'spectral_knight', 12.50, 33.50, 81, 'male', 'L2Pet', 'npc', 40, 2918, 8.500, 1714, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1556, 588, 1063, 430, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9574, 14904, 'Spectral Lord', '', 'spectral_knight', 12.50, 33.50, 82, 'male', 'L2Pet', 'npc', 40, 2930, 8.500, 1727, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1575, 595, 1076, 434, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9575, 14905, 'Spectral Lord', '', 'spectral_knight', 12.50, 33.50, 82, 'male', 'L2Pet', 'npc', 40, 2942, 8.500, 1740, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1587, 597, 1084, 436, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9576, 14906, 'Spectral Lord', '', 'spectral_knight', 12.50, 33.50, 82, 'male', 'L2Pet', 'npc', 40, 2955, 8.500, 1753, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1597, 600, 1091, 439, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9577, 14907, 'Spectral Lord', '', 'spectral_knight', 12.50, 33.50, 83, 'male', 'L2Pet', 'npc', 40, 2967, 8.500, 1766, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1619, 605, 1106, 444, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9578, 14908, 'Spectral Lord', '', 'spectral_knight', 12.50, 33.50, 83, 'male', 'L2Pet', 'npc', 40, 2980, 8.500, 1779, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1631, 609, 1113, 445, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9579, 14909, 'Spectral Lord', '', 'spectral_knight', 12.50, 33.50, 83, 'male', 'L2Pet', 'npc', 40, 2992, 8.500, 1792, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1641, 611, 1121, 447, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9580, 14910, 'Spectral Lord', '', 'spectral_knight', 12.50, 33.50, 84, 'male', 'L2Pet', 'npc', 40, 3005, 8.500, 1805, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1663, 618, 1135, 452, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9581, 14911, 'Spectral Lord', '', 'spectral_knight', 12.50, 33.50, 84, 'male', 'L2Pet', 'npc', 40, 3017, 8.500, 1818, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1675, 619, 1144, 453, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9582, 14912, 'Spectral Lord', '', 'spectral_knight', 12.50, 33.50, 84, 'male', 'L2Pet', 'npc', 40, 3029, 8.500, 1831, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1685, 623, 1150, 455, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9583, 14913, 'Spectral Lord', '', 'spectral_knight', 12.50, 33.50, 85, 'male', 'L2Pet', 'npc', 40, 3042, 8.500, 1844, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1707, 628, 1166, 459, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9584, 14914, 'Spectral Lord', '', 'spectral_knight', 12.50, 33.50, 85, 'male', 'L2Pet', 'npc', 40, 3054, 8.500, 1857, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1717, 632, 1173, 463, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9585, 14915, 'Spectral Lord', '', 'spectral_knight', 12.50, 33.50, 85, 'male', 'L2Pet', 'npc', 40, 3067, 8.500, 1870, 6.000, 40, 43, 30, 21, 20, 25, 0, 0, 1730, 633, 1181, 465, 253, 0, 506, 0, 0, 0, 160, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9586, 14916, 'Tigress', '', 'LineageMonster.saber_toothed_tiger_070p', 22.00, 18.40, 61, 'male', 'L2Pet', 'npc', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 752, 378, 513, 278, 253, 0, 506, 0, 0, 0, 47, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9587, 14917, 'Tigress', '', 'LineageMonster.saber_toothed_tiger_070p', 22.00, 18.40, 61, 'male', 'L2Pet', 'npc', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 752, 378, 513, 278, 253, 0, 506, 0, 0, 0, 47, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9588, 14918, 'Imperial Phoenix', '', 'LineageMonster4.phoenix', 7.00, 34.00, 83, 'female', 'L2Pet', 'npc', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 25, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.67, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9589, 16013, 'Trained Buffalo', '', 'buffalo', 22.00, 31.00, 67, 'male', 'L2TamedBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 975, 440, 666, 321, 253, 0, 506, 0, 0, 0, 80, 120, 'nonpet_clan', 400, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9590, 16014, 'Trained Buffalo', '', 'buffalo', 22.00, 31.00, 67, 'male', 'L2TamedBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 975, 440, 666, 321, 253, 0, 506, 0, 0, 0, 80, 120, 'nonpet_clan', 400, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9591, 16015, 'Trained Cougar', '', 'saber_toothed_tiger', 34.00, 28.00, 69, 'male', 'L2TamedBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1055, 460, 720, 337, 253, 0, 506, 0, 0, 0, 60, 120, 'nonpet_clan', 400, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9592, 16016, 'Trained Cougar', '', 'saber_toothed_tiger', 34.00, 28.00, 69, 'male', 'L2TamedBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 1055, 460, 720, 337, 253, 0, 506, 0, 0, 0, 60, 120, 'nonpet_clan', 400, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9593, 16017, 'Trained Kookaburra', '', 'pet_ostrich', 10.00, 33.00, 65, 'male', 'L2TamedBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 898, 419, 613, 306, 253, 0, 506, 0, 0, 0, 23, 120, 'nonpet_clan', 400, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9594, 16018, 'Trained Kookaburra', '', 'pet_ostrich', 10.00, 33.00, 65, 'male', 'L2TamedBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 25, 0, 0, 898, 419, 613, 306, 253, 0, 506, 0, 0, 0, 23, 120, 'nonpet_clan', 400, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9595, 16019, 'Tiny Baby Buffalo', '', 'baby_buffalo', 12.00, 15.00, 67, 'male', 'L2Pet', 'npc', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 25, 2146, 200, 975, 440, 666, 321, 253, 0, 506, 0, 0, 0, 30, 120, 'nonpet_clan', 400, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (9596, 16020, 'Tame Tiny Baby Buffalo', '', 'baby_buffalo', 12.00, 15.00, 67, 'male', 'L2Pet', 'npc', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 25, 2146, 200, 975, 440, 666, 321, 253, 0, 506, 0, 0, 0, 30, 120, 'nonpet_clan', 400, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9597, 16021, 'Tiny Baby Cougar', '', 'baby_tiger', 11.00, 15.70, 69, 'male', 'L2Pet', 'npc', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 25, 2276, 218, 1055, 460, 720, 337, 253, 0, 506, 0, 0, 0, 28, 120, 'nonpet_clan', 400, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (9598, 16022, 'Tame Tiny Baby Cougar', '', 'baby_tiger', 11.00, 15.70, 69, 'male', 'L2Pet', 'npc', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 25, 2276, 218, 1055, 460, 720, 337, 253, 0, 506, 0, 0, 0, 28, 120, 'nonpet_clan', 400, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9599, 16023, 'Tiny Baby Kookaburra', '', 'baby_ostrich', 7.00, 15.00, 65, 'male', 'L2Pet', 'npc', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 25, 2020, 183, 898, 419, 613, 306, 253, 0, 506, 0, 0, 0, 13, 120, 'nonpet_clan', 400, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (9600, 16024, 'Tame Tiny Baby Kookaburra', '', 'baby_ostrich', 7.00, 15.00, 65, 'male', 'L2Pet', 'npc', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 25, 2020, 183, 898, 419, 613, 306, 253, 0, 506, 0, 0, 0, 13, 120, 'nonpet_clan', 400, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9601, 16025, 'Great Wolf', '', 'Pet_Wolf_B', 32.00, 21.41, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 45, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9602, 16026, 'Beastly Agathion', '', 'Agathion_BF', 0.01, 11.30, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9603, 16027, 'Rainbow Agathion', '', 'Agathion_RA', 0.01, 6.70, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9604, 16028, 'Lord Agathion', '', 'Agathion_CL', 0.01, 9.50, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9605, 16029, 'Fortress Agasion', '', 'Agathion_FT', 0.01, 3.50, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9606, 16030, 'Great Wolf', '', 'LineageMonster4.Pet_Wolf_ba', 25.00, 21.41, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 45, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.42, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9607, 16031, 'Little Angel Agathion', '', 'Agathion_ag', 0.01, 4.55, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9608, 16032, 'Little Devil Agathion', '', 'Agathion_st', 0.01, 5.50, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9609, 16033, 'Rudolph Agathion', '', 'Agathion_rd', 0.01, 5.27, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9610, 16034, 'Improved Baby Buffalo', '', 'LineageMonster2.baby_buffalo', 12.00, 15.00, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 30, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9611, 16035, 'Improved Baby Kookaburra', '', 'LineageMonster2.baby_ostrich', 7.00, 15.00, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 13, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9612, 16036, 'Improved Baby Cougar', '', 'LineageMonster2.baby_tiger', 11.00, 15.70, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 28, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9613, 16037, 'Great Snow Wolf', '', 'LineageMonster4.Pet_Wolf_Ba', 25.00, 21.41, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 45, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.42, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9614, 16038, 'Red Wind Strider', '', 'LineageMonster.strider', 23.00, 31.00, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 80, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.25, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9615, 16039, 'Red Star Strider', '', 'LineageMonster.strider', 23.00, 31.00, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 80, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.25, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9616, 16040, 'Red Twilight Strider', '', 'LineageMonster.strider', 23.00, 31.00, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 80, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.25, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9617, 16041, 'Fenrir', '', 'LineageMonster4.Pet_Wolf_Ba', 25.00, 21.41, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 45, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.42, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9618, 16042, 'Snow Fenrir', '', 'LineageMonster4.Pet_Wolf_Ba', 25.00, 21.41, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 45, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.42, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9619, 16043, 'Fox Shaman', '', 'LineageMonster4.foxian_wizard_pet', 10.00, 18.50, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 35, 37, 30, 32, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 35, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9620, 16044, 'Wild Beast Fighter', '', 'LineageMonster4.beast_fighter_pet', 11.00, 16.50, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 22, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9621, 16045, 'White Weasel', '', 'LineageMonster4.ferret_pet', 6.50, 12.50, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 30, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9622, 16046, 'Fairy Princess', '', 'LineageMonster4.fairy_princess_pet', 10.00, 15.00, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 35, 37, 30, 32, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 35, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9623, 16049, 'Love Agathion', '', 'LineageNpc2.agathion_love', 5.00, 3.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9624, 16050, 'Owl Monk', '', 'LineageMonster4.owl_wizard_the_pet', 13.00, 19.50, 55, 'female', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9625, 16051, 'Spirit Shaman', '', 'LineageMonster4.sprit_magician_the_pet', 12.80, 15.60, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 35, 37, 30, 32, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 30, 180, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9626, 16052, 'Toy Knight', '', 'LineageMonster4.toy_knight_the_pet', 10.00, 15.00, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.67, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9627, 16053, 'Turtle Ascetic', '', 'LineageMonster4.turtle_buffer_the_pet', 11.00, 10.00, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 38, 40, 30, 26, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 20, 180, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9628, 16054, 'Monkey', '', 'LineageNpc2.agathion_mk', 15.00, 7.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9629, 16055, 'Griffon', '', 'LineageNpc2.agathion_gr', 5.00, 5.50, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9630, 16056, 'Joy', '', 'LineageNpc2.agathion_happy', 6.50, 6.50, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9631, 16057, 'Sorrow', '', 'LineageNpc2.agathion_sorrow', 5.00, 5.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9632, 16058, 'Anger', '', 'LineageNpc2.agathion_anger', 3.00, 3.00, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9633, 16059, 'Boy Bear', '', 'LineageNPC2.teddy_bear_boy', 3.00, 7.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9634, 16060, 'Girl Bear', '', 'LineageNPC2.teddy_bear_girl', 3.00, 7.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9635, 16061, 'Collection Device', '', 'LineageNPC2.collecting_golem', 5.50, 6.25, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9636, 16062, 'Knight', '', 'LineageNPC2.agathion_pvp', 4.50, 7.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 25, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9637, 16063, 'Saerom', '', 'LineageNPC2.agathion_gift', 3.00, 5.15, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9638, 16064, 'Juju', '', 'LineageNPC2.agathion_cupi', 5.00, 7.00, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9639, 16065, 'Oink Oink', '', 'LineageNPC2.agathion_pig', 6.00, 5.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9640, 16066, 'Light of Dawn', '', 'LineageNPC2.agathion_pig', 6.00, 5.75, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9641, 16067, 'Deinonychus', '', 'LineageMonster3.deinonychus', 14.00, 14.30, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 24, 160, '', 0, 0, 0, 0, 86400, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9642, 16068, 'Guardians Strider', '', 'LineageMonster4.dragon_descendant_2a', 27.00, 33.50, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 40, 170, '', 0, 0, 0, 0, 86400, 10, 4, 5, 0, 0, 0.36, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9643, 16069, 'Pona', '', 'LineageNPC2.agathion_pona', 3.00, 5.15, 55, 'female', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9644, 16070, 'Towbat', '', 'LineageNPC2.agathion_tow', 4.00, 5.87, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9645, 16071, 'Maguen', '', 'LineageMonster5.marguene', 11.00, 13.25, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 15, 120, '', 0, 0, 0, 0, 86400, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9646, 16072, 'Elite Maguen', '', 'LineageMonster5.marguene_pet_elite', 11.00, 13.25, 55, 'male', 'L2Pet', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 15, 120, '', 0, 0, 0, 0, 86400, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (9647, 16073, 'Rudolph Agathion', '', 'LineageNpc2.Agathion_rd', 0.01, 5.27, 55, 'male', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3320, 18001, 'Blood Queen', '', 'bloody_queen', 14.00, 40.00, 60, 'female', 'L2Monster', 'Mystic', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 4536, 394, 717, 370, 490, 224, 253, 500, 506, 0, 0, 0, 80, 160, 'cave_servant_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3321, 18002, 'Blood Queen', '', 'bloody_queen', 14.00, 40.00, 60, 'female', 'L2Monster', 'Mystic', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 4320, 375, 788, 370, 490, 224, 253, 500, 506, 0, 0, 0, 80, 160, 'cave_servant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3322, 18003, 'Bearded Keltir', '', 'keltir', 9.50, 10.00, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 29, 2, 4, 40, 5, 24, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3323, 18004, 'Susceptor Prime', '', 'susceptor_prime', 45.00, 72.00, 49, 'male', 'L2Monster', 'Ranger', 1100, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 1, 400, 270, 273, 164, 253, 0, 506, 0, 0, 0, 78, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3324, 18005, 'Mimic', '', 'mimic', 8.50, 8.50, 52, 'male', 'L2Monster', 'Fighter', 40, 1570, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 3245, 251, 491, 305, 324, 179, 253, 0, 506, 0, 0, 0, 80, 156, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3325, 18006, 'Maruk Lord', '', 'death_blader', 15.00, 45.00, 68, 'male', 'L2Monster', 'Fighter', 40, 2422, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 6057, 586, 1047, 465, 692, 272, 253, 500, 506, 1472, 0, 0, 100, 170, 'malruk_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3326, 18007, 'Limal Karinness', '', 'bloody_queen', 14.00, 40.00, 69, 'female', 'L2Monster', 'Mystic', 40, 2396, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 5951, 582, 1160, 460, 792, 278, 253, 500, 506, 0, 0, 0, 80, 140, 'malruk_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3327, 18008, 'Karik', '', 'karik', 25.00, 90.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2445, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 6370, 632, 1205, 471, 822, 285, 253, 500, 506, 0, 0, 0, 37, 200, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3328, 18009, 'Offering of Branded Elder', '', 'orc_fighter_bi', 12.00, 26.40, 34, 'male', 'L2FestivalMonster', 'Fighter', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 1755, 102, 149, 164, 102, 100, 253, 1000, 506, 127, 0, 0, 45, 30, 'mercenary_siege_clan', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3329, 18010, 'Offering of the Branded', '', 'orc', 10.00, 21.00, 32, 'male', 'L2FestivalMonster', 'Fighter', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 1524, 86, 113, 129, 87, 92, 253, 1000, 506, 218, 0, 0, 45, 30, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3330, 18011, 'Offering of Branded Archer', '', 'orc_archer', 14.00, 25.00, 28, 'male', 'L2FestivalMonster', 'Ranger', 1100, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 1001, 53, 209, 111, 64, 80, 253, 1000, 506, 14, 0, 0, 45, 60, '', 500, 0, 0, 0, 3, 10, 8, 0, 1500, 10, 0.80, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3331, 18012, 'Offering of Branded Warrior', '', 'orc_champion', 10.00, 23.00, 29, 'male', 'L2FestivalMonster', 'Fighter', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 1026, 55, 101, 136, 70, 83, 253, 1000, 506, 125, 0, 0, 45, 110, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3332, 18013, 'Offering of Branded Follower', '', 'orc_fighter', 9.00, 22.00, 29, 'male', 'L2FestivalMonster', 'Fighter', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 1227, 66, 90, 116, 70, 83, 253, 1000, 506, 316, 0, 0, 45, 150, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.26, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3333, 18014, 'Offering of Branded Berserker', '', 'orc_champion_20_bi', 10.00, 23.00, 37, 'male', 'L2FestivalMonster', 'Fighter', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 2277, 140, 185, 181, 126, 111, 253, 1000, 506, 292, 0, 0, 43, 115, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3334, 18015, 'Offering of Branded Zealot', '', 'orc_fighter_bi', 12.00, 26.40, 34, 'male', 'L2FestivalMonster', 'Fighter', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 1651, 96, 130, 139, 102, 100, 253, 1000, 506, 158, 0, 0, 45, 155, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3335, 18016, 'Offering of Branded Marksman', '', 'orc_archer_20_bi', 16.00, 30.00, 32, 'male', 'L2FestivalMonster', 'Ranger', 1100, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 1266, 71, 286, 129, 87, 92, 253, 1000, 506, 273, 0, 0, 45, 130, '', 500, 0, 0, 0, 3, 10, 8, 0, 1500, 10, 0.80, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3336, 18017, 'Offering of Branded Disciple', '', 'batur_orc', 9.00, 21.50, 34, 'male', 'L2FestivalMonster', 'Fighter', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 1651, 96, 149, 164, 102, 100, 253, 1000, 506, 129, 0, 0, 80, 165, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3337, 18018, 'Offering of Branded Saint', '', 'batur_orc_20_bi', 10.00, 25.30, 39, 'male', 'L2FestivalMonster', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 2172, 138, 212, 195, 145, 118, 253, 1000, 506, 72, 0, 0, 80, 165, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3338, 18019, 'Apostates Offering Elder', '', 'orc_champion_20_bi', 12.00, 27.60, 45, 'male', 'L2FestivalMonster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 3013, 210, 315, 239, 214, 145, 253, 1000, 506, 72, 0, 0, 45, 30, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3339, 18020, 'Apostates Offering ', '', 'orc_fighter', 12.00, 22.00, 43, 'male', 'L2FestivalMonster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 2751, 186, 243, 190, 189, 135, 253, 1000, 506, 223, 0, 0, 45, 30, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3340, 18021, 'Apostates Offering Archer', '', 'batur_orc_archer', 11.00, 21.50, 39, 'male', 'L2FestivalMonster', 'Ranger', 1100, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 1880, 119, 472, 166, 145, 118, 253, 1000, 506, 275, 0, 0, 45, 60, '', 500, 0, 0, 0, 3, 10, 8, 0, 1500, 10, 0.96, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3341, 18022, 'Apostates Offering Warrior', '', 'batur_orc_warrior', 10.00, 20.00, 40, 'male', 'L2FestivalMonster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 1920, 124, 227, 203, 155, 123, 253, 1000, 506, 127, 0, 0, 80, 115, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3342, 18023, 'Apostates Offering Follower', '', 'batur_orc', 11.00, 16.00, 40, 'male', 'L2FestivalMonster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 2296, 148, 199, 172, 155, 123, 253, 1000, 506, 316, 0, 0, 50, 155, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3343, 18024, 'Apostates Offering Berserker', '', 'batur_orc_warrior_20_bi', 11.00, 32.00, 48, 'male', 'L2FestivalMonster', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 3832, 280, 378, 262, 258, 159, 253, 1000, 506, 297, 0, 0, 37, 120, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3344, 18025, 'Apostates Offering Zealot', '', 'batur_orc_20_bi', 10.00, 25.30, 45, 'male', 'L2FestivalMonster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 2892, 201, 276, 202, 214, 145, 253, 1000, 506, 172, 0, 0, 80, 160, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3345, 18026, 'Apostates Offering Marksman', '', 'batur_orc_archer_20_bi', 13.00, 25.30, 43, 'male', 'L2FestivalMonster', 'Ranger', 1100, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 2285, 154, 616, 190, 189, 135, 253, 1000, 506, 277, 0, 0, 45, 135, '', 500, 0, 0, 0, 3, 10, 8, 0, 1500, 10, 0.96, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3346, 18027, 'Apostates Offering Disciple', '', 'batur_orc_overlord', 12.00, 24.00, 45, 'male', 'L2FestivalMonster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 2892, 201, 315, 239, 214, 145, 253, 1000, 506, 74, 0, 0, 80, 170, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3347, 18028, 'Apostates Offering Saint', '', 'batur_orc_overlord_20_bi', 14.00, 28.80, 50, 'male', 'L2FestivalMonster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 3570, 269, 425, 278, 291, 168, 253, 1000, 506, 133, 0, 0, 80, 170, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3348, 18029, 'Witchs Offering Elder', '', 'batur_orc_warrior_20_bi', 12.00, 24.00, 56, 'male', 'L2FestivalMonster', 'Mystic', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 4666, 383, 589, 331, 402, 200, 253, 1000, 506, 133, 0, 0, 80, 30, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3349, 18030, 'Witchs Offering', '', 'batur_orc', 9.00, 21.50, 54, 'male', 'L2FestivalMonster', 'Mystic', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 4339, 346, 463, 266, 362, 190, 253, 1000, 506, 226, 0, 0, 80, 30, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3350, 18031, 'Witchs Offering Archer', '', 'batur_orc_archer', 11.00, 21.50, 50, 'male', 'L2FestivalMonster', 'Ranger', 1100, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 3090, 233, 944, 236, 291, 168, 253, 1000, 506, 278, 0, 0, 45, 70, '', 500, 0, 0, 0, 3, 10, 8, 0, 1500, 10, 0.96, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3351, 18032, 'Witchs Offering Warrior', '', 'batur_orc_warrior', 10.00, 20.00, 51, 'male', 'L2FestivalMonster', 'Mystic', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 3121, 238, 449, 287, 307, 174, 253, 1000, 506, 72, 0, 0, 80, 120, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3352, 18033, 'Witchs Offering Follower', '', 'batur_orc', 11.00, 16.00, 51, 'male', 'L2FestivalMonster', 'Mystic', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 3733, 285, 393, 244, 307, 174, 253, 1000, 506, 316, 0, 0, 50, 160, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3353, 18034, 'Witchs Offering Berserker', '', 'batur_orc_warrior_20_bi', 12.00, 30.00, 59, 'male', 'L2FestivalMonster', 'Mystic', 40, 1881, 6.500, 1007, 2.400, 40, 43, 30, 21, 20, 20, 5790, 495, 684, 360, 466, 218, 253, 1000, 506, 301, 0, 0, 52, 125, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3354, 18035, 'Witchs Offering Zealot', '', 'batur_orc_20_bi', 10.00, 25.30, 56, 'male', 'L2FestivalMonster', 'Mystic', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 4478, 368, 515, 281, 402, 200, 253, 1000, 506, 91, 0, 0, 80, 165, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3355, 18036, 'Witchs Offering Marksman', '', 'batur_orc_archer_20_bi', 13.00, 25.30, 54, 'male', 'L2FestivalMonster', 'Ranger', 1100, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 3604, 287, 1178, 266, 362, 190, 253, 1000, 506, 282, 0, 0, 45, 140, '', 500, 0, 0, 0, 3, 10, 8, 0, 1500, 10, 0.96, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3356, 18037, 'Witchs Offering Disciple', '', 'batur_orc_overlord', 12.00, 24.00, 56, 'male', 'L2FestivalMonster', 'Mystic', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 4478, 368, 589, 331, 402, 200, 253, 1000, 506, 135, 0, 0, 80, 175, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3357, 18038, 'Witchs Offering Saint', '', 'batur_orc_overlord_20_bi', 14.00, 28.80, 61, 'male', 'L2FestivalMonster', 'Mystic', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 5314, 468, 752, 378, 513, 230, 253, 1000, 506, 79, 0, 0, 80, 175, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3358, 18039, 'Dark Omen Offering Elder', '', 'batur_orc_warrior_20_bi', 12.00, 24.00, 67, 'male', 'L2FestivalMonster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 6680, 636, 975, 440, 666, 267, 253, 1000, 506, 79, 0, 0, 80, 30, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3359, 18040, 'Dark Omen Offering', '', 'batur_orc', 9.00, 21.50, 65, 'male', 'L2FestivalMonster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 6287, 584, 785, 356, 613, 254, 253, 1000, 506, 234, 0, 0, 80, 30, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3360, 18041, 'Dark Omen Offering Archer', '', 'batur_orc_archer', 11.00, 21.50, 61, 'male', 'L2FestivalMonster', 'Ranger', 1100, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 4599, 405, 1670, 323, 513, 230, 253, 1000, 506, 283, 0, 0, 45, 70, '', 500, 0, 0, 0, 3, 10, 8, 0, 1500, 10, 0.96, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3361, 18042, 'Dark Omen Offering Warrior', '', 'batur_orc_warrior', 10.00, 20.00, 62, 'male', 'L2FestivalMonster', 'Fighter', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 4613, 411, 787, 388, 538, 236, 253, 1000, 506, 133, 0, 0, 80, 125, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3362, 18043, 'Dark Omen Offering Follower', '', 'batur_orc', 11.00, 16.00, 62, 'male', 'L2FestivalMonster', 'Fighter', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 5517, 492, 689, 331, 538, 236, 253, 1000, 506, 316, 0, 0, 50, 165, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3363, 18044, 'Dark Omen Offering Berserker', '', 'batur_orc_warrior_20_bi', 12.00, 30.00, 70, 'male', 'L2FestivalMonster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 8150, 808, 1096, 471, 747, 285, 253, 1000, 506, 97, 0, 0, 52, 130, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3364, 18045, 'Dark Omen Offering Zealot', '', 'batur_orc_20_bi', 10.00, 25.30, 67, 'male', 'L2FestivalMonster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 6410, 610, 853, 373, 666, 267, 253, 1000, 506, 2503, 0, 0, 80, 170, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3365, 18046, 'Dark Omen Offering Marksman', '', 'batur_orc_archer_20_bi', 13.00, 25.30, 65, 'male', 'L2FestivalMonster', 'Ranger', 1100, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 5222, 485, 1994, 356, 613, 254, 253, 1000, 506, 286, 0, 0, 45, 145, '', 500, 0, 0, 0, 3, 10, 8, 0, 1500, 10, 0.96, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3366, 18047, 'Dark Omen Offering Disciple', '', 'batur_orc_overlord', 12.00, 24.00, 67, 'male', 'L2FestivalMonster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 6410, 610, 975, 440, 666, 267, 253, 1000, 506, 142, 0, 0, 80, 180, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3367, 18048, 'Dark Omen Offering Saint', '', 'batur_orc_overlord_20_bi', 14.00, 28.80, 72, 'male', 'L2FestivalMonster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 7403, 752, 1179, 491, 805, 298, 253, 1000, 506, 2500, 0, 0, 80, 180, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3368, 18049, 'Offering of Forbidden Path Elder', '', 'batur_orc_overlord_20_bi', 14.00, 28.80, 78, 'male', 'L2FestivalMonster', 'Fighter', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 9053, 991, 1430, 556, 975, 337, 253, 1000, 506, 2500, 0, 0, 80, 30, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3369, 18050, 'Offering of Forbidden Path', '', 'batur_orc_warrior', 10.00, 20.00, 76, 'male', 'L2FestivalMonster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 8595, 919, 1176, 454, 919, 323, 253, 1000, 506, 236, 0, 0, 80, 30, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3370, 18051, 'Offering of Forbidden Path Archer', '', 'ketra_orc_archer', 12.00, 27.00, 78, 'male', 'L2FestivalMonster', 'Ranger', 1100, 3011, 8.772, 1778, 3.091, 40, 43, 30, 21, 20, 20, 8311, 955, 3717, 524, 1179, 374, 253, 1000, 506, 287, 0, 0, 45, 70, '', 500, 0, 0, 0, 3, 10, 8, 4, 1500, 14, 0.91, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3371, 18052, 'Offering of Forbidden Path Warrior', '', 'ketra_orc_warrior', 12.00, 24.00, 78, 'male', 'L2FestivalMonster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 7680, 862, 1525, 581, 1062, 352, 253, 1000, 506, 79, 0, 0, 36, 130, '', 500, 0, 0, 0, 3, 30, 4, 7, 0, 2, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3372, 18053, 'Offering of Forbidden Path Follower', '', 'ketra_orc', 10.00, 23.00, 78, 'male', 'L2FestivalMonster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 9185, 1031, 1334, 494, 1062, 352, 253, 1000, 506, 316, 0, 0, 10, 180, '', 500, 0, 0, 0, 3, 10, 8, 2, 0, 12, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3373, 18054, 'Offering of Forbidden Path Berserker', '', 'ketra_orc_warrior_20_bi', 13.00, 35.00, 78, 'male', 'L2FestivalMonster', 'Fighter', 40, 2975, 8.721, 1743, 3.070, 40, 43, 30, 21, 20, 20, 10912, 1239, 1600, 600, 1119, 364, 253, 1000, 506, 305, 0, 0, 40, 135, '', 500, 0, 0, 0, 3, 30, 4, 8, 0, 3, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3374, 18055, 'Offering of Forbidden Path Zealot', '', 'ketra_orc_20_bi', 14.00, 34.80, 78, 'male', 'L2FestivalMonster', 'Fighter', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 8688, 951, 1251, 473, 975, 337, 253, 1000, 506, 175, 0, 0, 45, 195, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3375, 18056, 'Offering of Forbidden Path Marksman', '', 'ketra_orc_archer_20_bi', 14.00, 32.40, 76, 'male', 'L2FestivalMonster', 'Ranger', 1100, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 7139, 763, 2990, 454, 919, 323, 253, 1000, 506, 289, 0, 0, 45, 150, '', 500, 0, 0, 0, 3, 10, 8, 0, 1500, 10, 0.91, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3376, 18057, 'Offering of Forbidden Path Disciple', '', 'ketra_orc_overload', 12.00, 24.00, 78, 'male', 'L2FestivalMonster', 'Fighter', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 8688, 951, 1430, 556, 975, 337, 253, 1000, 506, 151, 0, 0, 33, 195, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3377, 18058, 'Offering of Forbidden Path Saint', '', 'ketra_orc_overload_20_bi', 14.00, 28.80, 78, 'male', 'L2FestivalMonster', 'Fighter', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 9837, 1144, 1747, 636, 1239, 386, 253, 1000, 506, 2500, 0, 0, 33, 195, '', 500, 0, 0, 0, 3, 30, 4, 10, 0, 5, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3378, 18059, 'Offering of Branded Elder', '', 'orc_fighter_bi', 12.00, 26.40, 34, 'male', 'L2FestivalMonster', 'Fighter', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 1720, 100, 149, 164, 102, 100, 253, 1000, 506, 127, 0, 0, 45, 30, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3379, 18060, 'Offering of the Branded', '', 'orc', 10.00, 21.00, 32, 'male', 'L2FestivalMonster', 'Fighter', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 1524, 86, 113, 129, 87, 92, 253, 1000, 506, 218, 0, 0, 45, 30, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3380, 18061, 'Offering of Branded Archer', '', 'orc_archer', 14.00, 25.00, 28, 'male', 'L2FestivalMonster', 'Ranger', 1100, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 1001, 53, 209, 111, 64, 80, 253, 1000, 506, 14, 0, 0, 45, 60, '', 500, 0, 0, 0, 3, 10, 8, 0, 1500, 10, 0.80, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3381, 18062, 'Offering of Branded Warrior', '', 'orc_champion', 10.00, 23.00, 29, 'male', 'L2FestivalMonster', 'Fighter', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 1026, 55, 101, 136, 70, 83, 253, 1000, 506, 125, 0, 0, 45, 110, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3382, 18063, 'Offering of Branded Follower', '', 'orc_fighter', 9.00, 22.00, 29, 'male', 'L2FestivalMonster', 'Fighter', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 1227, 66, 90, 116, 70, 83, 253, 1000, 506, 316, 0, 0, 45, 150, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.26, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3383, 18064, 'Offering of Branded Berserker', '', 'orc_champion_20_bi', 10.00, 23.00, 37, 'male', 'L2FestivalMonster', 'Fighter', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 2277, 140, 185, 181, 126, 111, 253, 1000, 506, 292, 0, 0, 43, 115, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3384, 18065, 'Offering of Branded Zealot', '', 'orc_fighter_bi', 12.00, 26.40, 34, 'male', 'L2FestivalMonster', 'Fighter', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 1651, 96, 130, 139, 102, 100, 253, 1000, 506, 158, 0, 0, 45, 155, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3385, 18066, 'Offering of Branded Marksman', '', 'orc_archer_20_bi', 16.00, 30.00, 32, 'male', 'L2FestivalMonster', 'Ranger', 1100, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 1266, 71, 286, 129, 87, 92, 253, 1000, 506, 273, 0, 0, 45, 130, '', 500, 0, 0, 0, 3, 10, 8, 0, 1500, 10, 0.80, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3386, 18067, 'Offering of Branded Disciple', '', 'batur_orc', 9.00, 21.50, 34, 'male', 'L2FestivalMonster', 'Fighter', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 1651, 96, 149, 164, 102, 100, 253, 1000, 506, 129, 0, 0, 80, 165, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3387, 18068, 'Offering of Branded Saint', '', 'batur_orc_20_bi', 10.00, 25.30, 39, 'male', 'L2FestivalMonster', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 2172, 138, 212, 195, 145, 118, 253, 1000, 506, 72, 0, 0, 80, 165, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3388, 18069, 'Apostates Offering Elder', '', 'orc_champion_20_bi', 12.00, 27.60, 45, 'male', 'L2FestivalMonster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 3013, 210, 315, 239, 214, 145, 253, 1000, 506, 72, 0, 0, 45, 30, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3389, 18070, 'Apostates Offering ', '', 'orc_fighter', 12.00, 22.00, 43, 'male', 'L2FestivalMonster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 2751, 186, 243, 190, 189, 135, 253, 1000, 506, 223, 0, 0, 45, 30, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3390, 18071, 'Apostates Offering Archer', '', 'batur_orc_archer', 11.00, 21.50, 39, 'male', 'L2FestivalMonster', 'Ranger', 1100, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 1880, 119, 472, 166, 145, 118, 253, 1000, 506, 275, 0, 0, 45, 60, '', 500, 0, 0, 0, 3, 10, 8, 0, 1500, 10, 0.96, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3391, 18072, 'Apostates Offering Warrior', '', 'batur_orc_warrior', 10.00, 20.00, 40, 'male', 'L2FestivalMonster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 1920, 124, 227, 203, 155, 123, 253, 1000, 506, 127, 0, 0, 80, 115, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3392, 18073, 'Apostates Offering Follower', '', 'batur_orc', 11.00, 16.00, 40, 'male', 'L2FestivalMonster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 2296, 148, 199, 172, 155, 123, 253, 1000, 506, 316, 0, 0, 50, 155, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3393, 18074, 'Apostates Offering Berserker', '', 'batur_orc_warrior_20_bi', 11.00, 32.00, 48, 'male', 'L2FestivalMonster', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 3832, 280, 378, 262, 258, 159, 253, 1000, 506, 297, 0, 0, 37, 120, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3394, 18075, 'Apostates Offering Zealot', '', 'batur_orc_20_bi', 10.00, 25.30, 45, 'male', 'L2FestivalMonster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 2892, 201, 276, 202, 214, 145, 253, 1000, 506, 172, 0, 0, 80, 160, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3395, 18076, 'Apostates Offering Marksman', '', 'batur_orc_archer_20_bi', 13.00, 25.30, 43, 'male', 'L2FestivalMonster', 'Ranger', 1100, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 2285, 154, 616, 190, 189, 135, 253, 1000, 506, 277, 0, 0, 45, 135, '', 500, 0, 0, 0, 3, 10, 8, 0, 1500, 10, 0.96, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3396, 18077, 'Apostates Offering Disciple', '', 'batur_orc_overlord', 12.00, 24.00, 45, 'male', 'L2FestivalMonster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 2892, 201, 315, 239, 214, 145, 253, 1000, 506, 74, 0, 0, 80, 170, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3397, 18078, 'Apostates Offering Saint', '', 'batur_orc_overlord_20_bi', 14.00, 28.80, 50, 'male', 'L2FestivalMonster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 3570, 269, 425, 278, 291, 168, 253, 1000, 506, 133, 0, 0, 80, 170, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3398, 18079, 'Witchs Offering Elder', '', 'batur_orc_warrior_20_bi', 12.00, 24.00, 56, 'male', 'L2FestivalMonster', 'Mystic', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 4666, 383, 589, 331, 402, 200, 253, 1000, 506, 133, 0, 0, 80, 30, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3399, 18080, 'Witchs Offering', '', 'batur_orc', 9.00, 21.50, 54, 'male', 'L2FestivalMonster', 'Mystic', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 4339, 346, 463, 266, 362, 190, 253, 1000, 506, 226, 0, 0, 80, 30, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3400, 18081, 'Witchs Offering Archer', '', 'batur_orc_archer', 11.00, 21.50, 50, 'male', 'L2FestivalMonster', 'Ranger', 1100, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 3090, 233, 944, 236, 291, 168, 253, 1000, 506, 278, 0, 0, 45, 70, '', 500, 0, 0, 0, 3, 10, 8, 0, 1500, 10, 0.96, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3401, 18082, 'Witchs Offering Warrior', '', 'batur_orc_warrior', 10.00, 20.00, 51, 'male', 'L2FestivalMonster', 'Mystic', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 3121, 238, 449, 287, 307, 174, 253, 1000, 506, 72, 0, 0, 80, 120, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3402, 18083, 'Witchs Offering Follower', '', 'batur_orc', 11.00, 16.00, 51, 'male', 'L2FestivalMonster', 'Mystic', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 3733, 285, 393, 244, 307, 174, 253, 1000, 506, 316, 0, 0, 50, 160, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3403, 18084, 'Witchs Offering Berserker', '', 'batur_orc_warrior_20_bi', 12.00, 30.00, 59, 'male', 'L2FestivalMonster', 'Mystic', 40, 1881, 6.500, 1007, 2.400, 40, 43, 30, 21, 20, 20, 5790, 495, 684, 360, 466, 218, 253, 1000, 506, 301, 0, 0, 52, 125, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3404, 18085, 'Witchs Offering Zealot', '', 'batur_orc_20_bi', 10.00, 25.30, 56, 'male', 'L2FestivalMonster', 'Mystic', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 4478, 368, 515, 281, 402, 200, 253, 1000, 506, 91, 0, 0, 80, 165, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3405, 18086, 'Witchs Offering Marksman', '', 'batur_orc_archer_20_bi', 13.00, 25.30, 54, 'male', 'L2FestivalMonster', 'Ranger', 1100, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 3604, 287, 1178, 266, 362, 190, 253, 1000, 506, 282, 0, 0, 45, 140, '', 500, 0, 0, 0, 3, 10, 8, 0, 1500, 10, 0.96, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3406, 18087, 'Witchs Offering Disciple', '', 'batur_orc_overlord', 12.00, 24.00, 56, 'male', 'L2FestivalMonster', 'Mystic', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 4478, 368, 589, 331, 402, 200, 253, 1000, 506, 135, 0, 0, 80, 175, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3407, 18088, 'Witchs Offering Saint', '', 'batur_orc_overlord_20_bi', 14.00, 28.80, 61, 'male', 'L2FestivalMonster', 'Mystic', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 5314, 468, 752, 378, 513, 230, 253, 1000, 506, 79, 0, 0, 80, 175, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3408, 18089, 'Dark Omen Offering Elder', '', 'batur_orc_warrior_20_bi', 12.00, 24.00, 67, 'male', 'L2FestivalMonster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 6680, 636, 975, 440, 666, 267, 253, 1000, 506, 79, 0, 0, 80, 30, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3409, 18090, 'Dark Omen Offering', '', 'batur_orc', 9.00, 21.50, 65, 'male', 'L2FestivalMonster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 6287, 584, 785, 356, 613, 254, 253, 1000, 506, 234, 0, 0, 80, 30, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3410, 18091, 'Dark Omen Offering Archer', '', 'batur_orc_archer', 11.00, 21.50, 61, 'male', 'L2FestivalMonster', 'Ranger', 1100, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 4599, 405, 1670, 323, 513, 230, 253, 1000, 506, 283, 0, 0, 45, 70, '', 500, 0, 0, 0, 3, 10, 8, 0, 1500, 10, 0.96, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3411, 18092, 'Dark Omen Offering Warrior', '', 'batur_orc_warrior', 10.00, 20.00, 62, 'male', 'L2FestivalMonster', 'Fighter', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 4613, 411, 787, 388, 538, 236, 253, 1000, 506, 133, 0, 0, 80, 125, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3412, 18093, 'Dark Omen Offering Follower', '', 'batur_orc', 11.00, 16.00, 62, 'male', 'L2FestivalMonster', 'Fighter', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 5517, 492, 689, 331, 538, 236, 253, 1000, 506, 316, 0, 0, 50, 165, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3413, 18094, 'Dark Omen Offering Berserker', '', 'batur_orc_warrior_20_bi', 12.00, 30.00, 70, 'male', 'L2FestivalMonster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 8150, 808, 1096, 471, 747, 285, 253, 1000, 506, 97, 0, 0, 52, 130, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3414, 18095, 'Dark Omen Offering Zealot', '', 'batur_orc_20_bi', 10.00, 25.30, 67, 'male', 'L2FestivalMonster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 6410, 610, 853, 373, 666, 267, 253, 1000, 506, 2503, 0, 0, 80, 170, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3415, 18096, 'Dark Omen Offering Marksman', '', 'batur_orc_archer_20_bi', 13.00, 25.30, 65, 'male', 'L2FestivalMonster', 'Ranger', 1100, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 5222, 485, 1994, 356, 613, 254, 253, 1000, 506, 286, 0, 0, 45, 145, '', 500, 0, 0, 0, 3, 10, 8, 0, 1500, 10, 0.96, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3416, 18097, 'Dark Omen Offering Disciple', '', 'batur_orc_overlord', 12.00, 24.00, 67, 'male', 'L2FestivalMonster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 6410, 610, 975, 440, 666, 267, 253, 1000, 506, 142, 0, 0, 80, 180, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3417, 18098, 'Dark Omen Offering Saint', '', 'batur_orc_overlord_20_bi', 14.00, 28.80, 72, 'male', 'L2FestivalMonster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 7403, 752, 1179, 491, 805, 298, 253, 1000, 506, 2500, 0, 0, 80, 180, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3418, 18099, 'Offering of Forbidden Path Elder', '', 'batur_orc_overlord_20_bi', 14.00, 28.80, 78, 'male', 'L2FestivalMonster', 'Fighter', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 9053, 991, 1430, 556, 975, 337, 253, 1000, 506, 2500, 0, 0, 80, 30, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3419, 18100, 'Offering of Forbidden Path', '', 'batur_orc_warrior', 10.00, 20.00, 76, 'male', 'L2FestivalMonster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 8595, 919, 1176, 454, 919, 323, 253, 1000, 506, 236, 0, 0, 80, 30, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3420, 18101, 'Offering of Forbidden Path Archer', '', 'ketra_orc_archer', 12.00, 27.00, 78, 'male', 'L2FestivalMonster', 'Ranger', 1100, 3011, 8.772, 1778, 3.091, 40, 43, 30, 21, 20, 20, 8311, 955, 3717, 524, 1179, 374, 253, 1000, 506, 287, 0, 0, 45, 70, '', 500, 0, 0, 0, 3, 10, 8, 4, 1500, 14, 0.91, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3421, 18102, 'Offering of Forbidden Path Warrior', '', 'ketra_orc_warrior', 12.00, 24.00, 78, 'male', 'L2FestivalMonster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 7680, 862, 1525, 581, 1062, 352, 253, 1000, 506, 79, 0, 0, 36, 130, '', 500, 0, 0, 0, 3, 30, 4, 7, 0, 2, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3422, 18103, 'Offering of Forbidden Path Follower', '', 'ketra_orc', 10.00, 23.00, 78, 'male', 'L2FestivalMonster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 9185, 1031, 1334, 494, 1062, 352, 253, 1000, 506, 316, 0, 0, 10, 180, '', 500, 0, 0, 0, 3, 10, 8, 2, 0, 12, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3423, 18104, 'Offering of Forbidden Path Berserker', '', 'ketra_orc_warrior_20_bi', 13.00, 35.00, 78, 'male', 'L2FestivalMonster', 'Fighter', 40, 2975, 8.721, 1743, 3.070, 40, 43, 30, 21, 20, 20, 10912, 1239, 1600, 600, 1119, 364, 253, 1000, 506, 305, 0, 0, 40, 135, '', 500, 0, 0, 0, 3, 30, 4, 8, 0, 3, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3424, 18105, 'Offering of Forbidden Path Zealot', '', 'ketra_orc_20_bi', 14.00, 34.80, 78, 'male', 'L2FestivalMonster', 'Fighter', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 8688, 951, 1251, 473, 975, 337, 253, 1000, 506, 175, 0, 0, 45, 195, '', 500, 0, 0, 0, 3, 10, 8, 0, 0, 10, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3425, 18106, 'Offering of Forbidden Path Marksman', '', 'ketra_orc_archer_20_bi', 14.00, 32.40, 76, 'male', 'L2FestivalMonster', 'Ranger', 1100, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 7139, 763, 2990, 454, 919, 323, 253, 1000, 506, 289, 0, 0, 45, 150, '', 500, 0, 0, 0, 3, 10, 8, 0, 1500, 10, 0.91, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3426, 18107, 'Offering of Forbidden Path Disciple', '', 'ketra_orc_overload', 12.00, 24.00, 78, 'male', 'L2FestivalMonster', 'Fighter', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 8688, 951, 1430, 556, 975, 337, 253, 1000, 506, 151, 0, 0, 33, 195, '', 500, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3427, 18108, 'Offering of Forbidden Path Saint', '', 'ketra_orc_overload_20_bi', 14.00, 28.80, 78, 'male', 'L2FestivalMonster', 'Fighter', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 9837, 1144, 1747, 636, 1239, 386, 253, 1000, 506, 2500, 0, 0, 33, 195, '', 500, 0, 0, 0, 3, 30, 4, 10, 0, 5, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3428, 18109, 'Treasures of the Festival', '', 'coffer_a', 8.50, 8.50, 30, 'male', 'L2FestivalMonster', 'Fighter', 40, 633, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 90, 0, 0, 140, 0, 86, 253, 0, 506, 0, 0, 0, 80, 195, '1', 200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3429, 18110, 'Treasures of the Festival', '', 'coffer_a', 8.50, 8.50, 41, 'male', 'L2FestivalMonster', 'Fighter', 40, 942, 5.500, 505, 2.100, 40, 43, 30, 21, 20, 20, 168, 0, 0, 209, 0, 126, 253, 0, 506, 0, 0, 0, 80, 195, '1', 200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3430, 18111, 'Treasures of the Festival', '', 'coffer_a', 8.50, 8.50, 52, 'male', 'L2FestivalMonster', 'Fighter', 40, 1303, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 270, 0, 0, 296, 0, 179, 253, 0, 506, 0, 0, 0, 80, 195, '1', 200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3431, 18112, 'Treasures of the Festival', '', 'coffer_a', 8.50, 8.50, 63, 'male', 'L2FestivalMonster', 'Fighter', 40, 1671, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 397, 0, 0, 398, 0, 242, 253, 0, 506, 0, 0, 0, 80, 195, '1', 200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3432, 18113, 'Treasures of the Festival', '', 'coffer_a', 8.50, 8.50, 72, 'male', 'L2FestivalMonster', 'Fighter', 40, 1939, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 518, 0, 0, 491, 0, 298, 253, 0, 506, 0, 0, 0, 80, 195, '1', 200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3433, 18114, 'Treasures of the Festival', '', 'coffer_a', 8.50, 8.50, 30, 'male', 'L2FestivalMonster', 'Fighter', 40, 633, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 90, 0, 0, 140, 0, 86, 253, 0, 506, 0, 0, 0, 80, 195, '1', 200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3434, 18115, 'Treasures of the Festival', '', 'coffer_a', 8.50, 8.50, 41, 'male', 'L2FestivalMonster', 'Fighter', 40, 942, 5.500, 505, 2.100, 40, 43, 30, 21, 20, 20, 168, 0, 0, 209, 0, 126, 253, 0, 506, 0, 0, 0, 80, 195, '1', 200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3435, 18116, 'Treasures of the Festival', '', 'coffer_a', 8.50, 8.50, 52, 'male', 'L2FestivalMonster', 'Fighter', 40, 1303, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 270, 0, 0, 296, 0, 179, 253, 0, 506, 0, 0, 0, 80, 195, '1', 200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3436, 18117, 'Treasures of the Festival', '', 'coffer_a', 8.50, 8.50, 63, 'male', 'L2FestivalMonster', 'Fighter', 40, 1671, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 397, 0, 0, 398, 0, 242, 253, 0, 506, 0, 0, 0, 80, 195, '1', 200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3437, 18118, 'Treasures of the Festival', '', 'coffer_a', 8.50, 8.50, 72, 'male', 'L2FestivalMonster', 'Fighter', 40, 1939, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 518, 0, 0, 491, 0, 298, 253, 0, 506, 0, 0, 0, 80, 195, '1', 200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3438, 18119, 'Corpse of Deadman', '', 'zombie_corpse', 13.00, 21.00, 63, 'male', 'L2DeadMan', 'Mystic', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 822, 398, 562, 242, 253, 0, 506, 0, 0, 0, 15, 1, '', 0, 0, 0, 0, 240, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3439, 18120, 'Halishas Officer', '', 'imperial_warlord_zombie_20_bi', 9.00, 36.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 58584, 6652, 1936, 546, 1640, 331, 253, 0, 506, 134, 6721, 0, 39, 150, 'tomb1_clan', 600, 0, 20, 173, 7, 30, 4, 8, 0, -3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3440, 18121, 'Halishas Officer', '', 'imperial_warlord_zombie_20_bi', 9.00, 36.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 55563, 6309, 1455, 726, 925, 439, 253, 0, 506, 134, 6721, 0, 39, 150, 'tomb1_clan', 600, 0, 20, 173, 7, 30, 4, 8, 0, -3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3441, 18122, 'Halishas Officer', '', 'imperial_warlord_zombie_20_bi', 9.00, 36.00, 78, 'male', 'L2SepulcherMonster', 'RndTeleportFighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 42434, 4818, 1600, 600, 1119, 364, 253, 0, 506, 134, 6721, 0, 39, 150, 'tomb1_clan', 600, 0, 20, 173, 7, 30, 4, 8, 0, -3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3442, 18123, 'Halishas Officer', '', 'imperial_warlord_zombie_20_bi', 9.00, 36.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 58584, 6652, 1936, 546, 1640, 331, 253, 0, 506, 134, 6721, 0, 39, 150, 'tomb1_clan', 600, 0, 20, 173, 7, 30, 4, 8, 0, -3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3443, 18124, 'Halishas Officer', '', 'imperial_warlord_zombie_20_bi', 9.00, 36.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 55563, 6309, 1455, 726, 925, 439, 253, 0, 506, 134, 6721, 0, 39, 150, 'tomb1_clan', 600, 0, 20, 173, 7, 30, 4, 8, 0, -3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3444, 18125, 'Halishas Officer', '', 'imperial_warlord_zombie_20_bi', 9.00, 36.00, 78, 'male', 'L2SepulcherMonster', 'RndTeleportFighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 42434, 4818, 1600, 600, 1119, 364, 253, 0, 506, 134, 6721, 0, 39, 150, 'tomb1_clan', 600, 0, 20, 173, 7, 30, 4, 8, 0, -3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3445, 18126, 'Halishas Officer', '', 'imperial_warlord_zombie_20_bi', 9.00, 36.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 58584, 6652, 1936, 546, 1640, 331, 253, 0, 506, 134, 6721, 0, 39, 150, 'tomb1_clan', 600, 0, 20, 173, 7, 30, 4, 8, 0, -3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3446, 18127, 'Halishas Officer', '', 'imperial_warlord_zombie_20_bi', 9.00, 36.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 55563, 6309, 1455, 726, 925, 439, 253, 0, 506, 134, 6721, 0, 39, 150, 'tomb1_clan', 600, 0, 20, 173, 7, 30, 4, 8, 0, -3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3447, 18128, 'Halishas Officer', '', 'imperial_warlord_zombie_20_bi', 9.00, 36.00, 78, 'male', 'L2SepulcherMonster', 'RndTeleportFighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 42434, 4818, 1600, 600, 1119, 364, 253, 0, 506, 134, 6721, 0, 39, 150, 'tomb1_clan', 600, 0, 20, 173, 7, 30, 4, 8, 0, -3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3448, 18129, 'Halishas Officer', '', 'imperial_warlord_zombie_20_bi', 9.00, 36.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 58584, 6652, 1936, 546, 1640, 331, 253, 0, 506, 134, 6721, 0, 39, 150, 'tomb1_clan', 600, 0, 20, 173, 7, 30, 4, 8, 0, -3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3449, 18130, 'Halishas Officer', '', 'imperial_warlord_zombie_20_bi', 9.00, 36.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 55563, 6309, 1455, 726, 925, 439, 253, 0, 506, 134, 6721, 0, 39, 150, 'tomb1_clan', 600, 0, 20, 173, 7, 30, 4, 8, 0, -3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3450, 18131, 'Halishas Officer', '', 'imperial_warlord_zombie_20_bi', 9.00, 36.00, 78, 'male', 'L2SepulcherMonster', 'RndTeleportFighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 42434, 4818, 1600, 600, 1119, 364, 253, 0, 506, 134, 6721, 0, 39, 150, 'tomb1_clan', 600, 0, 20, 173, 7, 30, 4, 8, 0, -3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3451, 18132, 'Imperial Healer', '', 'tera_beetle', 19.00, 54.50, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 59699, 6779, 1323, 798, 765, 484, 253, 0, 506, 0, 0, 0, 45, 170, 'tomb1_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3452, 18133, 'Imperial Mosaic', '', 'scorpion', 28.00, 66.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 55141, 6261, 1399, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 37, 170, 'tomb1_clan', 600, 0, 0, 0, 7, 10, 8, 2, 0, 3, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3453, 18134, 'Imperial Mosaic', '', 'scorpion', 28.00, 66.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 41438, 4705, 1399, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 37, 170, 'tomb1_clan', 600, 0, 0, 0, 7, 10, 8, 2, 0, 3, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3454, 18135, 'Imperial Mosaic', '', 'scorpion', 28.00, 66.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 54900, 6234, 1399, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 37, 170, 'tomb1_clan', 600, 0, 0, 0, 7, 10, 8, 2, 0, 3, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3455, 18136, 'Imperial Mosaic', '', 'scorpion', 28.00, 66.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 55141, 6261, 1273, 726, 925, 439, 253, 0, 506, 0, 0, 0, 37, 170, 'tomb1_clan', 600, 0, 0, 0, 7, 10, 8, 2, 0, 3, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3456, 18137, 'Imperial Mosaic', '', 'scarab', 14.00, 22.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 40876, 4641, 1600, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 45, 180, 'tomb1_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3457, 18138, 'Imperial Mosaic', '', 'scarab', 14.00, 22.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 54418, 6179, 1600, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 45, 180, 'tomb1_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3458, 18139, 'Imperial Mosaic', '', 'scarab', 14.00, 22.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 53615, 6088, 1600, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 45, 180, 'tomb1_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3459, 18140, 'Imperial Mosaic', '', 'scarab', 14.00, 22.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 54394, 6176, 1455, 726, 925, 439, 253, 0, 506, 0, 0, 0, 45, 180, 'tomb1_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3460, 18141, 'Beetle of Grave', '', 'scarab', 14.00, 22.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 34.884, 1743, 3.070, 40, 43, 30, 21, 20, 20, 34982, 3972, 2577, 409, 2904, 249, 253, 0, 506, 0, 0, 0, 45, 180, 'tomb2_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3461, 18142, 'Beetle of Grave', '', 'scarab', 14.00, 22.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 34.884, 1743, 3.070, 40, 43, 30, 21, 20, 20, 34982, 3972, 2577, 409, 2904, 249, 253, 0, 506, 0, 0, 0, 45, 180, 'tomb2_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3462, 18143, 'Beetle of Grave', '', 'scarab', 14.00, 22.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 34.884, 1743, 3.070, 40, 43, 30, 21, 20, 20, 34982, 3972, 2577, 409, 2904, 249, 253, 0, 506, 0, 0, 0, 45, 180, 'tomb2_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3463, 18144, 'Beetle of Grave', '', 'scarab', 14.00, 22.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 34.884, 1743, 3.070, 40, 43, 30, 21, 20, 20, 34982, 3972, 2577, 409, 2904, 249, 253, 0, 506, 0, 0, 0, 45, 180, 'tomb2_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3464, 18145, 'Beetle of Grave', '', 'scarab', 14.00, 22.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 34.884, 1743, 3.070, 40, 43, 30, 21, 20, 20, 29597, 3361, 2129, 496, 1984, 301, 253, 0, 506, 0, 0, 0, 45, 180, 'tomb2_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3465, 18146, 'Beetle of Grave', '', 'scarab', 14.00, 22.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 34.884, 1743, 3.070, 40, 43, 30, 21, 20, 20, 30276, 3438, 2129, 496, 1984, 301, 253, 0, 506, 0, 0, 0, 45, 180, 'tomb2_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3466, 18147, 'Beetle of Grave', '', 'scarab', 14.00, 22.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 34.884, 1743, 3.070, 40, 43, 30, 21, 20, 20, 28188, 3201, 2129, 496, 1984, 301, 253, 0, 506, 0, 0, 0, 45, 180, 'tomb2_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3467, 18148, 'Beetle of Grave', '', 'scarab', 14.00, 22.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 34.884, 1743, 3.070, 40, 43, 30, 21, 20, 20, 32814, 3726, 2129, 496, 1984, 301, 253, 0, 506, 0, 0, 0, 45, 180, 'tomb2_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3468, 18149, 'Beetle of Grave', '', 'scarab', 14.00, 22.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 34.884, 1743, 3.070, 40, 43, 30, 21, 20, 20, 28991, 3292, 2129, 496, 1984, 301, 253, 0, 506, 0, 0, 0, 45, 180, 'tomb2_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3469, 18150, 'Victim', '', 'a_tombkeeperA', 8.00, 23.00, 78, 'female', 'L2SepulcherMonster', 'npc', 40, 2975, 8.721, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1600, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 50, 100, 'tomb3_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3470, 18151, 'Victim', '', 'a_tombkeeperA', 8.00, 23.00, 78, 'female', 'L2SepulcherMonster', 'npc', 40, 2975, 8.721, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1600, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 50, 100, 'tomb3_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3471, 18152, 'Victim', '', 'a_tombkeeperA', 8.00, 23.00, 78, 'female', 'L2SepulcherMonster', 'npc', 40, 2975, 8.721, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1600, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 50, 100, 'tomb3_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3472, 18153, 'Victim', '', 'a_tombkeeperA', 8.00, 23.00, 78, 'female', 'L2SepulcherMonster', 'npc', 40, 2975, 8.721, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1600, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 50, 100, 'tomb3_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3473, 18154, 'Victim', '', 'a_tombkeeperA', 8.00, 23.00, 78, 'female', 'L2SepulcherMonster', 'npc', 40, 2975, 8.721, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1600, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 50, 100, 'tomb3_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3474, 18155, 'Victim', '', 'a_tombkeeperA', 8.00, 23.00, 78, 'female', 'L2SepulcherMonster', 'npc', 40, 2975, 8.721, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1600, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 50, 100, 'tomb3_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3475, 18156, 'Victim', '', 'a_tombkeeperA', 8.00, 23.00, 78, 'female', 'L2SepulcherMonster', 'npc', 40, 2975, 8.721, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1600, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 50, 100, 'tomb3_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3476, 18157, 'Victim', '', 'a_tombkeeperA', 8.00, 23.00, 78, 'female', 'L2SepulcherMonster', 'npc', 40, 2975, 8.721, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1600, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 50, 100, 'tomb3_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3477, 18158, 'Executioner of Halisha', '', 'erinyes', 21.00, 50.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 17851, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1936, 1052, 1640, 331, 253, 0, 506, 0, 0, 0, 31, 150, 'tomb3_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3478, 18159, 'Executioner of Halisha', '', 'erinyes', 21.00, 50.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 17851, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1936, 546, 1640, 636, 253, 0, 506, 0, 0, 0, 31, 150, 'tomb3_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3479, 18160, 'Executioner of Halisha', '', 'erinyes', 21.00, 50.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 17851, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1936, 1052, 1640, 331, 253, 0, 506, 0, 0, 0, 31, 150, 'tomb3_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3480, 18161, 'Executioner of Halisha', '', 'erinyes', 21.00, 50.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 17851, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1936, 546, 1640, 636, 253, 0, 506, 0, 0, 0, 31, 150, 'tomb3_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3481, 18162, 'Executioner of Halisha', '', 'erinyes', 21.00, 50.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 17851, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1936, 1052, 1640, 331, 253, 0, 506, 0, 0, 0, 31, 150, 'tomb3_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3482, 18163, 'Executioner of Halisha', '', 'erinyes', 21.00, 50.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 17851, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1936, 546, 1640, 636, 253, 0, 506, 0, 0, 0, 31, 150, 'tomb3_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3483, 18164, 'Executioner of Halisha', '', 'erinyes', 21.00, 50.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 17851, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1936, 1052, 1640, 331, 253, 0, 506, 0, 0, 0, 31, 150, 'tomb3_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3484, 18165, 'Executioner of Halisha', '', 'erinyes', 21.00, 50.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 17851, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1936, 546, 1640, 636, 253, 0, 506, 0, 0, 0, 31, 150, 'tomb3_clan', 600, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3485, 18166, 'Imperial Guard', '', 'death_knight', 12.00, 31.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 42032, 4773, 1936, 546, 1640, 331, 253, 0, 506, 142, 0, 0, 27, 110, 'tomb3_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3486, 18167, 'Imperial Guard', '', 'death_knight', 12.00, 31.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 41438, 4705, 1455, 726, 925, 439, 253, 0, 506, 142, 0, 0, 27, 110, 'tomb3_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3487, 18168, 'Imperial Guard', '', 'death_knight', 12.00, 31.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 42595, 4837, 1600, 600, 1119, 364, 253, 0, 506, 142, 0, 0, 27, 110, 'tomb3_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3488, 18169, 'Imperial Guard', '', 'death_knight', 12.00, 31.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 41237, 4683, 1455, 726, 925, 439, 253, 0, 506, 142, 0, 0, 27, 110, 'tomb3_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3489, 18170, 'Imperial Guard', '', 'death_knight', 20.00, 42.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 41278, 4687, 1864, 496, 1984, 301, 253, 0, 506, 0, 0, 0, 80, 160, 'tomb3_clan', 600, 0, 0, 0, 7, 10, 8, 2, 0, 3, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3490, 18171, 'Imperial Guard', '', 'death_knight', 20.00, 42.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 42884, 4869, 1157, 798, 765, 484, 253, 0, 506, 0, 0, 0, 80, 160, 'tomb3_clan', 600, 0, 0, 0, 7, 10, 8, 2, 0, 3, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3491, 18172, 'Imperial Guard', '', 'death_knight', 20.00, 42.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 40876, 4641, 1399, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 80, 160, 'tomb3_clan', 600, 0, 0, 0, 7, 10, 8, 2, 0, 3, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3492, 18173, 'Halishas Foreman', '', 'kaim_vanul', 24.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 45345, 5149, 1936, 546, 1640, 331, 253, 0, 506, 0, 0, 0, 37, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3493, 18174, 'Halishas Foreman', '', 'kaim_vanul', 24.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 55932, 6351, 1936, 546, 1640, 331, 253, 0, 506, 0, 0, 0, 37, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3494, 18175, 'Halishas Foreman', '', 'kaim_vanul', 24.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 42803, 4860, 1936, 546, 1640, 331, 253, 0, 506, 0, 0, 0, 37, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3495, 18176, 'Halishas Foreman', '', 'kaim_vanul', 24.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 45345, 5149, 1936, 546, 1640, 331, 253, 0, 506, 0, 0, 0, 37, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3496, 18177, 'Halishas Foreman', '', 'kaim_vanul', 24.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 55932, 6351, 1936, 546, 1640, 331, 253, 0, 506, 0, 0, 0, 37, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3497, 18178, 'Halishas Foreman', '', 'kaim_vanul', 24.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 42803, 4860, 1936, 546, 1640, 331, 253, 0, 506, 0, 0, 0, 37, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3498, 18179, 'Halishas Foreman', '', 'kaim_vanul', 24.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 45345, 5149, 1936, 546, 1640, 331, 253, 0, 506, 0, 0, 0, 37, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3499, 18180, 'Halishas Foreman', '', 'kaim_vanul', 24.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 55932, 6351, 1936, 546, 1640, 331, 253, 0, 506, 0, 0, 0, 37, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3500, 18181, 'Halishas Foreman', '', 'kaim_vanul', 24.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 42803, 4860, 1936, 546, 1640, 331, 253, 0, 506, 0, 0, 0, 37, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3501, 18182, 'Halishas Foreman', '', 'kaim_vanul', 24.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 45345, 5149, 1936, 546, 1640, 331, 253, 0, 506, 0, 0, 0, 37, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3502, 18183, 'Halishas Foreman', '', 'kaim_vanul', 24.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 55932, 6351, 1936, 546, 1640, 331, 253, 0, 506, 0, 0, 0, 37, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3503, 18184, 'Halishas Foreman', '', 'kaim_vanul', 24.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 42803, 4860, 1936, 546, 1640, 331, 253, 0, 506, 0, 0, 0, 37, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3504, 18185, 'Evil Astrologer', '', 'doll_blader', 6.00, 12.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 56482, 6414, 1455, 726, 925, 439, 253, 0, 506, 5129, 5129, 0, 22, 150, 'tomb4_clan', 600, 0, 0, 185, 7, 30, 4, 8, 0, 3, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3505, 18186, 'Evil Astrologer', '', 'doll_blader', 6.00, 12.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 56803, 6450, 1455, 726, 925, 439, 253, 0, 506, 5129, 5129, 0, 22, 150, 'tomb4_clan', 600, 0, 0, 185, 7, 30, 4, 8, 0, 3, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3506, 18187, 'Knight of Darkness', '', 'death_lord', 21.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 55141, 6261, 1936, 546, 1640, 331, 253, 0, 506, 78, 0, 0, 40, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3507, 18188, 'Knight of Darkness', '', 'death_lord', 21.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 41438, 4705, 1936, 546, 1640, 331, 253, 0, 506, 78, 0, 0, 40, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3508, 18189, 'Knight of Darkness', '', 'death_lord', 21.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 54900, 6234, 1936, 546, 1640, 331, 253, 0, 506, 78, 0, 0, 40, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3509, 18190, 'Knight of Darkness', '', 'death_lord', 21.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 55141, 6261, 1936, 546, 1640, 331, 253, 0, 506, 78, 0, 0, 40, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3510, 18191, 'Witch of dust', '', 'banshee', 9.00, 23.00, 78, 'female', 'L2SepulcherMonster', 'Mystic', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 40876, 4641, 1936, 546, 1640, 331, 253, 0, 506, 3939, 0, 0, 80, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3511, 18192, 'Witch of dust', '', 'banshee', 9.00, 23.00, 78, 'female', 'L2SepulcherMonster', 'Mystic', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 54418, 6179, 1936, 546, 1640, 331, 253, 0, 506, 3939, 0, 0, 80, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3512, 18193, 'Witch of dust', '', 'banshee', 9.00, 23.00, 78, 'female', 'L2SepulcherMonster', 'Mystic', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 53615, 6088, 1936, 546, 1640, 331, 253, 0, 506, 3939, 0, 0, 80, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3513, 18194, 'Witch of dust', '', 'banshee', 9.00, 23.00, 78, 'female', 'L2SepulcherMonster', 'Mystic', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 54394, 6176, 1936, 546, 1640, 331, 253, 0, 506, 3939, 0, 0, 80, 160, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3514, 18195, 'Signet of Emperor', '', 'ant_larva', 12.00, 8.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 41679, 4733, 2577, 409, 2904, 249, 253, 0, 506, 0, 0, 0, 40, 60, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3515, 18196, 'Charm of Corner', '', 'magmagoil_lad', 15.00, 75.00, 78, 'male', 'L2SepulcherMonster', 'PaganGuard', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 136143, 15459, 1092, 967, 523, 585, 253, 0, 506, 0, 0, 0, 1, 1, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3516, 18197, 'Charm of Corner', '', 'magmagoil_lad', 15.00, 75.00, 78, 'male', 'L2SepulcherMonster', 'PaganGuard', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 136143, 15459, 1092, 967, 523, 585, 253, 0, 506, 0, 0, 0, 1, 1, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3517, 18198, 'Charm of Corner', '', 'magmagoil_lad', 15.00, 75.00, 78, 'male', 'L2SepulcherMonster', 'PaganGuard', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 136143, 15459, 1092, 967, 523, 585, 253, 0, 506, 0, 0, 0, 1, 1, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3518, 18199, 'Charm of Corner', '', 'magmagoil_lad', 15.00, 75.00, 78, 'male', 'L2SepulcherMonster', 'PaganGuard', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 136143, 15459, 1092, 967, 523, 585, 253, 0, 506, 0, 0, 0, 1, 1, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3519, 18200, 'Charm of Corner', '', 'magmagoil_lad', 15.00, 75.00, 78, 'male', 'L2SepulcherMonster', 'PaganGuard', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 136143, 15459, 1092, 967, 523, 585, 253, 0, 506, 0, 0, 0, 1, 1, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3520, 18201, 'Charm of Corner', '', 'magmagoil_lad', 15.00, 75.00, 78, 'male', 'L2SepulcherMonster', 'PaganGuard', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 136143, 15459, 1092, 967, 523, 585, 253, 0, 506, 0, 0, 0, 1, 1, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3521, 18202, 'Charm of Corner', '', 'magmagoil_lad', 15.00, 75.00, 78, 'male', 'L2SepulcherMonster', 'PaganGuard', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 136143, 15459, 1092, 967, 523, 585, 253, 0, 506, 0, 0, 0, 1, 1, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3522, 18203, 'Charm of Corner', '', 'magmagoil_lad', 15.00, 75.00, 78, 'male', 'L2SepulcherMonster', 'PaganGuard', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 136143, 15459, 1092, 967, 523, 585, 253, 0, 506, 0, 0, 0, 1, 1, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3523, 18204, 'Charm of Corner', '', 'magmagoil_lad', 15.00, 75.00, 78, 'male', 'L2SepulcherMonster', 'PaganGuard', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 136143, 15459, 1092, 967, 523, 585, 253, 0, 506, 0, 0, 0, 1, 1, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3524, 18205, 'Charm of Corner', '', 'magmagoil_lad', 15.00, 75.00, 78, 'male', 'L2SepulcherMonster', 'PaganGuard', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 136143, 15459, 1092, 967, 523, 585, 253, 0, 506, 0, 0, 0, 1, 1, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3525, 18206, 'Charm of Corner', '', 'magmagoil_lad', 15.00, 75.00, 78, 'male', 'L2SepulcherMonster', 'PaganGuard', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 136143, 15459, 1092, 967, 523, 585, 253, 0, 506, 0, 0, 0, 1, 1, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3526, 18207, 'Charm of Corner', '', 'magmagoil_lad', 15.00, 75.00, 78, 'male', 'L2SepulcherMonster', 'PaganGuard', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 136143, 15459, 1092, 967, 523, 585, 253, 0, 506, 0, 0, 0, 1, 1, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3527, 18208, 'Charm of Corner', '', 'magmagoil_lad', 15.00, 75.00, 78, 'male', 'L2SepulcherMonster', 'PaganGuard', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 136143, 15459, 1092, 967, 523, 585, 253, 0, 506, 0, 0, 0, 1, 1, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3528, 18209, 'Charm of Corner', '', 'magmagoil_lad', 15.00, 75.00, 78, 'male', 'L2SepulcherMonster', 'PaganGuard', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 136143, 15459, 1092, 967, 523, 585, 253, 0, 506, 0, 0, 0, 1, 1, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3529, 18210, 'Charm of Corner', '', 'magmagoil_lad', 15.00, 75.00, 78, 'male', 'L2SepulcherMonster', 'PaganGuard', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 136143, 15459, 1092, 967, 523, 585, 253, 0, 506, 0, 0, 0, 1, 1, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3530, 18211, 'Charm of Corner', '', 'magmagoil_lad', 15.00, 75.00, 78, 'male', 'L2SepulcherMonster', 'PaganGuard', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 136143, 15459, 1092, 967, 523, 585, 253, 0, 506, 0, 0, 0, 1, 1, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3531, 18212, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 173610, 19713, 1323, 798, 765, 484, 253, 0, 506, 6722, 0, 0, 35, 185, 'tomb5_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3532, 18213, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 173610, 19713, 1323, 798, 765, 484, 253, 0, 506, 6722, 0, 0, 35, 185, 'tomb5_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3533, 18214, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 173610, 19713, 1323, 798, 765, 484, 253, 0, 506, 6722, 0, 0, 35, 185, 'tomb5_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3534, 18215, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 173610, 19713, 1323, 798, 765, 484, 253, 0, 506, 6722, 0, 0, 35, 185, 'tomb5_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3535, 18216, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 173610, 19713, 1323, 798, 765, 484, 253, 0, 506, 6722, 0, 0, 35, 185, 'tomb5_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3536, 18217, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 173610, 19713, 1323, 798, 765, 484, 253, 0, 506, 6722, 0, 0, 35, 185, 'tomb5_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3537, 18218, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 173610, 19713, 1323, 798, 765, 484, 253, 0, 506, 6722, 0, 0, 35, 185, 'tomb5_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3538, 18219, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 173610, 19713, 1323, 798, 765, 484, 253, 0, 506, 6722, 0, 0, 35, 185, 'tomb5_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3539, 18220, 'Shaman of Darkness', '', 'banshee', 9.00, 23.00, 78, 'female', 'L2SepulcherMonster', 'Mystic', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 56803, 6450, 1760, 600, 1354, 364, 253, 0, 506, 3939, 0, 0, 80, 160, 'tomb5_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3540, 18221, 'Shaman of Darkness', '', 'banshee', 9.00, 23.00, 78, 'female', 'L2SepulcherMonster', 'Mystic', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 58329, 6623, 1760, 600, 1354, 364, 253, 0, 506, 3939, 0, 0, 80, 160, 'tomb5_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3541, 18222, 'Assassin of Darkness', '', 'ashuras', 13.00, 37.50, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 55261, 6275, 2129, 496, 1984, 301, 253, 0, 506, 0, 0, 0, 41, 190, 'tomb5_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3542, 18223, 'Assassin of Darkness', '', 'ashuras', 13.00, 37.50, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 41438, 4705, 1600, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 41, 190, 'tomb5_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3543, 18224, 'Assassin of Darkness', '', 'ashuras', 13.00, 37.50, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 55823, 6339, 2129, 496, 1984, 301, 253, 0, 506, 0, 0, 0, 41, 190, 'tomb5_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3544, 18225, 'Assassin of Darkness', '', 'ashuras', 13.00, 37.50, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 55261, 6275, 1600, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 41, 190, 'tomb5_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3545, 18226, 'Caster of Darkness', '', 'vale_master', 12.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 40876, 4641, 2129, 496, 1984, 301, 253, 0, 506, 0, 0, 0, 70, 155, 'tomb5_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3546, 18227, 'Caster of Darkness', '', 'vale_master', 12.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 70240, 7976, 1600, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 70, 155, 'tomb5_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3547, 18228, 'Caster of Darkness', '', 'vale_master', 12.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 52812, 5997, 2129, 496, 1984, 301, 253, 0, 506, 0, 0, 0, 70, 155, 'tomb5_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3548, 18229, 'Caster of Darkness', '', 'vale_master', 12.00, 40.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 54394, 6176, 1600, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 70, 155, 'tomb5_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3549, 18230, 'Signet of Emperor', '', 'ant_larva', 12.00, 8.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 26.163, 1743, 3.070, 40, 43, 30, 21, 20, 20, 22486, 2553, 2577, 409, 2904, 249, 253, 0, 506, 0, 0, 0, 40, 60, 'tomb5_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3550, 18231, 'Statue of Protection', '', 'temple_guard_a', 15.00, 42.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 66895, 7596, 1455, 726, 925, 439, 253, 600, 506, 5795, 0, 0, 53, 140, '', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3551, 18232, 'Statue of Protection', '', 'temple_guard_a', 15.00, 42.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 66895, 7596, 1455, 726, 925, 439, 253, 600, 506, 5795, 0, 0, 53, 140, '', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3552, 18233, 'Statue of Protection', '', 'temple_guard_a', 15.00, 42.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 66895, 7596, 1455, 726, 925, 439, 253, 600, 506, 5795, 0, 0, 53, 140, '', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3553, 18234, 'Statue of Protection', '', 'temple_guard_a', 15.00, 42.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 66895, 7596, 1455, 726, 925, 439, 253, 600, 506, 5795, 0, 0, 53, 140, '', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3554, 18235, 'Statue of Protection', '', 'temple_guard_a', 15.00, 42.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 66895, 7596, 1455, 726, 925, 439, 253, 600, 506, 5795, 0, 0, 53, 140, '', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3555, 18236, 'Statue of Protection', '', 'temple_guard_a', 15.00, 42.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 66895, 7596, 1455, 726, 925, 439, 253, 600, 506, 5795, 0, 0, 53, 140, '', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3556, 18237, 'Statue of Protection', '', 'temple_guard_a', 15.00, 42.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 66895, 7596, 1455, 726, 925, 439, 253, 600, 506, 5795, 0, 0, 53, 140, '', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3557, 18238, 'Statue of Protection', '', 'temple_guard_a', 15.00, 42.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 66895, 7596, 1455, 726, 925, 439, 253, 600, 506, 5795, 0, 0, 53, 140, '', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3558, 18239, 'Statue of Protection', '', 'temple_guard_a', 15.00, 42.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 66895, 7596, 1455, 726, 925, 439, 253, 600, 506, 5795, 0, 0, 53, 140, '', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3559, 18240, 'Statue of Protection', '', 'temple_guard_a', 15.00, 42.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 66895, 7596, 1455, 726, 925, 439, 253, 600, 506, 5795, 0, 0, 53, 140, '', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3560, 18241, 'Statue of Protection', '', 'temple_guard_a', 15.00, 42.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 66895, 7596, 1455, 726, 925, 439, 253, 600, 506, 5795, 0, 0, 53, 140, '', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3561, 18242, 'Statue of Protection', '', 'temple_guard_a', 15.00, 42.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 66895, 7596, 1455, 726, 925, 439, 253, 600, 506, 5795, 0, 0, 53, 140, '', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3562, 18243, 'Statue of Protection', '', 'temple_guard_a', 15.00, 42.00, 78, 'male', 'L2SepulcherMonster', 'Fighter', 40, 2975, 52.326, 1743, 3.070, 40, 43, 30, 21, 20, 20, 66895, 7596, 1455, 726, 925, 439, 253, 600, 506, 5795, 0, 0, 53, 140, '', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3563, 18244, 'Watchman of Grave', '', 'mana_vampire', 11.00, 20.00, 78, 'male', 'L2SepulcherMonster', 'Mystic', 40, 2975, 26.163, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 2129, 496, 1984, 301, 253, 0, 506, 0, 0, 0, 90, 1, 'tomb1_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3564, 18245, 'Watchman of Grave', '', 'mana_vampire', 11.00, 20.00, 78, 'male', 'L2SepulcherMonster', 'Mystic', 40, 2975, 26.163, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1455, 726, 925, 439, 253, 0, 506, 0, 0, 0, 90, 1, 'tomb1_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3565, 18246, 'Watchman of Grave', '', 'mana_vampire', 11.00, 20.00, 78, 'male', 'L2SepulcherMonster', 'Mystic', 40, 2975, 26.163, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1600, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 90, 1, 'tomb1_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3566, 18247, 'Watchman of Grave', '', 'mana_vampire', 11.00, 20.00, 78, 'male', 'L2SepulcherMonster', 'Mystic', 40, 2975, 26.163, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 2129, 496, 1984, 301, 253, 0, 506, 0, 0, 0, 90, 1, 'tomb2_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3567, 18248, 'Watchman of Grave', '', 'mana_vampire', 11.00, 20.00, 78, 'male', 'L2SepulcherMonster', 'Mystic', 40, 2975, 26.163, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1455, 726, 925, 439, 253, 0, 506, 0, 0, 0, 90, 1, 'tomb2_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3568, 18249, 'Watchman of Grave', '', 'mana_vampire', 11.00, 20.00, 78, 'male', 'L2SepulcherMonster', 'Mystic', 40, 2975, 26.163, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1600, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 90, 1, 'tomb2_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3569, 18250, 'Watchman of Grave', '', 'mana_vampire', 11.00, 20.00, 78, 'male', 'L2SepulcherMonster', 'Mystic', 40, 2975, 26.163, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 2129, 496, 1984, 301, 253, 0, 506, 0, 0, 0, 90, 1, 'tomb3_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3570, 18251, 'Watchman of Grave', '', 'mana_vampire', 11.00, 20.00, 78, 'male', 'L2SepulcherMonster', 'Mystic', 40, 2975, 26.163, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1455, 726, 925, 439, 253, 0, 506, 0, 0, 0, 90, 1, 'tomb3_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3571, 18252, 'Watchman of Grave', '', 'mana_vampire', 11.00, 20.00, 78, 'male', 'L2SepulcherMonster', 'Mystic', 40, 2975, 26.163, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1600, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 90, 1, 'tomb3_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3572, 18253, 'Watchman of Grave', '', 'mana_vampire', 11.00, 20.00, 78, 'male', 'L2SepulcherMonster', 'Mystic', 40, 2975, 26.163, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 2129, 496, 1984, 301, 253, 0, 506, 0, 0, 0, 90, 1, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3573, 18254, 'Watchman of Grave', '', 'mana_vampire', 11.00, 20.00, 78, 'male', 'L2SepulcherMonster', 'Mystic', 40, 2975, 26.163, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1455, 726, 925, 439, 253, 0, 506, 0, 0, 0, 90, 1, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3574, 18255, 'Watchman of Grave', '', 'mana_vampire', 11.00, 20.00, 78, 'male', 'L2SepulcherMonster', 'Mystic', 40, 2975, 26.163, 1743, 3.070, 40, 43, 30, 21, 20, 20, 0, 0, 1600, 600, 1119, 364, 253, 0, 506, 0, 0, 0, 90, 1, 'tomb4_clan', 600, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3575, 18256, 'Halishas Treasure Box', '', 'mimic', 8.50, 8.50, 78, 'male', 'L2SepulcherMonster', 'npc', 40, 1, 0.000, 1, 0.000, 40, 43, 30, 21, 20, 20, 0, 0, 2, 2, 2, 2, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3576, 18257, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 78, 'male', 'L2Chest', 'Fighter', 40, 3365, 3.210, 1976, 3.210, 40, 43, 30, 21, 20, 20, 0, 0, 1757, 668, 1284, 404, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3577, 18258, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 78, 'male', 'L2Chest', 'Fighter', 40, 3365, 3.210, 1976, 3.210, 40, 43, 30, 21, 20, 20, 0, 0, 1757, 668, 1284, 404, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3578, 18259, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 78, 'male', 'L2Chest', 'Fighter', 40, 3365, 3.210, 1976, 3.210, 40, 43, 30, 21, 20, 20, 0, 0, 1757, 668, 1284, 404, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3579, 18260, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 78, 'male', 'L2Chest', 'Fighter', 40, 3365, 3.210, 1976, 3.210, 40, 43, 30, 21, 20, 20, 0, 0, 1757, 668, 1284, 404, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3580, 18261, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 78, 'male', 'L2Chest', 'Fighter', 40, 3365, 3.210, 1976, 3.210, 40, 43, 30, 21, 20, 20, 0, 0, 1757, 668, 1284, 404, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3581, 18262, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 78, 'male', 'L2Chest', 'Fighter', 40, 3365, 3.210, 1976, 3.210, 40, 43, 30, 21, 20, 20, 0, 0, 1757, 668, 1284, 404, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3582, 18263, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 78, 'male', 'L2Chest', 'Fighter', 40, 3365, 3.210, 1976, 3.210, 40, 43, 30, 21, 20, 20, 0, 0, 1757, 668, 1284, 404, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3583, 18264, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 78, 'male', 'L2Chest', 'Fighter', 40, 3365, 3.210, 1976, 3.210, 40, 43, 30, 21, 20, 20, 0, 0, 1757, 668, 1284, 404, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3584, 18265, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 21, 'male', 'L2Chest', 'Fighter', 40, 376, 1.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 53, 102, 36, 62, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3585, 18266, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 24, 'male', 'L2Chest', 'Fighter', 40, 449, 1.500, 246, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 68, 115, 46, 70, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3586, 18267, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 27, 'male', 'L2Chest', 'Fighter', 40, 532, 1.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 87, 130, 59, 79, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3587, 18268, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 30, 'male', 'L2Chest', 'Fighter', 40, 624, 1.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 111, 145, 75, 88, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3588, 18269, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 33, 'male', 'L2Chest', 'Fighter', 40, 725, 1.800, 373, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 138, 162, 94, 99, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3589, 18270, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 36, 'male', 'L2Chest', 'Fighter', 40, 836, 1.800, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 173, 181, 118, 110, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3590, 18271, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 39, 'male', 'L2Chest', 'Fighter', 40, 956, 1.800, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 212, 201, 145, 122, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3591, 18272, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 42, 'male', 'L2Chest', 'Fighter', 40, 1085, 2.100, 531, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 259, 223, 177, 135, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3592, 18273, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 45, 'male', 'L2Chest', 'Fighter', 40, 1222, 2.100, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 315, 247, 214, 149, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3593, 18274, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 48, 'male', 'L2Chest', 'Fighter', 40, 1367, 2.100, 692, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 378, 270, 258, 164, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3594, 18275, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 51, 'male', 'L2Chest', 'Fighter', 40, 1518, 2.400, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 449, 295, 307, 179, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3595, 18276, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 54, 'male', 'L2Chest', 'Fighter', 40, 1674, 2.400, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 531, 323, 362, 196, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3596, 18277, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 57, 'male', 'L2Chest', 'Fighter', 40, 1834, 2.400, 948, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 619, 352, 423, 213, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3597, 18278, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 60, 'male', 'L2Chest', 'Fighter', 40, 1996, 2.400, 1037, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 717, 381, 490, 231, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3598, 18279, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 63, 'male', 'L2Chest', 'Fighter', 40, 2157, 2.700, 1127, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 822, 412, 562, 249, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3599, 18280, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 66, 'male', 'L2Chest', 'Fighter', 40, 2317, 2.700, 1220, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 936, 443, 639, 268, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3600, 18281, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 69, 'male', 'L2Chest', 'Fighter', 40, 2473, 2.700, 1314, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1055, 476, 720, 288, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3601, 18282, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 72, 'male', 'L2Chest', 'Fighter', 40, 2622, 3.000, 1410, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1179, 507, 805, 308, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3602, 18283, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 75, 'male', 'L2Chest', 'Fighter', 40, 2763, 3.000, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 541, 891, 328, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3603, 18284, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 78, 'male', 'L2Chest', 'Fighter', 40, 2893, 3.000, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 573, 975, 347, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3604, 18285, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 78, 'male', 'L2Chest', 'Fighter', 40, 3101, 3.090, 1760, 3.100, 40, 43, 30, 21, 20, 20, 0, 0, 1615, 625, 1142, 379, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 9, 0, 4, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3605, 18286, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 78, 'male', 'L2Chest', 'Fighter', 40, 3301, 3.180, 1921, 3.180, 40, 43, 30, 21, 20, 20, 0, 0, 1712, 655, 1239, 396, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 11, 0, 6, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3606, 18287, 'Otherworldly Invader Food', '', 'mimic', 8.50, 8.50, 33, 'male', 'L2Chest', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 138, 157, 94, 95, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3607, 18288, 'Otherworldly Invader Food', '', 'mimic', 8.50, 8.50, 35, 'male', 'L2Chest', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 160, 170, 109, 103, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3608, 18289, 'Dimension Invader Food', '', 'mimic', 8.50, 8.50, 43, 'male', 'L2Chest', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 277, 223, 189, 135, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3609, 18290, 'Dimension Invader Food', '', 'mimic', 8.50, 8.50, 45, 'male', 'L2Chest', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 315, 239, 214, 145, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3610, 18291, 'Purgatory Invader Food', '', 'mimic', 8.50, 8.50, 53, 'male', 'L2Chest', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 503, 304, 344, 185, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3611, 18292, 'Purgatory Invader Food', '', 'mimic', 8.50, 8.50, 55, 'male', 'L2Chest', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 194, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3612, 18293, 'Forbidden Path Invader Food', '', 'mimic', 8.50, 8.50, 63, 'male', 'L2Chest', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 822, 398, 562, 242, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3613, 18294, 'Forbidden Path Invader Food', '', 'mimic', 8.50, 8.50, 65, 'male', 'L2Chest', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 898, 419, 613, 254, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3614, 18295, 'Dark Omen Invader Food', '', 'mimic', 8.50, 8.50, 73, 'male', 'L2Chest', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 305, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3615, 18296, 'Dark Omen Invader Food', '', 'mimic', 8.50, 8.50, 75, 'male', 'L2Chest', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 317, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3616, 18297, 'Messenger Invader Food', '', 'mimic', 8.50, 8.50, 78, 'male', 'L2Chest', 'Fighter', 40, 3134, 8.925, 1866, 3.150, 40, 43, 30, 21, 20, 20, 0, 0, 1665, 621, 1194, 376, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 10, 0, 5, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3617, 18298, 'Messenger Invader Food', '', 'mimic', 8.50, 8.50, 78, 'male', 'L2Chest', 'Fighter', 40, 3260, 9.095, 1976, 3.210, 40, 43, 30, 21, 20, 20, 0, 0, 1757, 646, 1284, 392, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3618, 18299, 'Flame of the Branded', '', 'big_boom', 6.00, 13.00, 35, 'male', 'L2Monster', 'Fighter', 40, 2318, 13.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 4894, 290, 160, 170, 109, 103, 253, 0, 506, 0, 0, 0, 48, 30, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3619, 18300, 'Offering of the Branded, Evoked Spirit', '', 'orc', 10.00, 21.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 1751, 100, 138, 157, 94, 95, 253, 0, 506, 158, 0, 0, 45, 155, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3620, 18301, 'Flame of Apostates', '', 'big_boom', 6.00, 13.00, 46, 'male', 'L2Monster', 'Fighter', 40, 3689, 16.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 8454, 599, 335, 246, 228, 149, 253, 0, 506, 0, 0, 0, 48, 30, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3621, 18302, 'Offering of Apostates, Evoked Spirit', '', 'orc_fighter', 12.00, 22.00, 44, 'male', 'L2Monster', 'Fighter', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 3113, 213, 295, 230, 202, 140, 253, 0, 506, 172, 0, 0, 45, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3622, 18303, 'Flame of the Witch', '', 'big_boom', 6.00, 13.00, 57, 'male', 'L2Monster', 'Mystic', 40, 5330, 19.500, 948, 2.400, 40, 43, 30, 21, 20, 20, 12980, 1079, 619, 340, 423, 206, 253, 0, 506, 0, 0, 0, 48, 30, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3623, 18304, 'Offering of the Witch, Evoked Spirit', '', 'batur_orc', 9.00, 21.50, 55, 'male', 'L2Monster', 'Mystic', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 4864, 393, 559, 323, 382, 194, 253, 0, 506, 91, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3624, 18305, 'Flame of Dark Omen', '', 'big_boom', 6.00, 13.00, 68, 'male', 'L2Monster', 'Fighter', 40, 7037, 22.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 18473, 1784, 1014, 449, 692, 272, 253, 0, 506, 0, 0, 0, 48, 30, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3625, 18306, 'Offering of Dark Omen, Evoked Spirit', '', 'batur_orc', 9.00, 21.50, 66, 'male', 'L2Monster', 'Fighter', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 7004, 659, 936, 429, 639, 260, 253, 0, 506, 2503, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3626, 18307, 'Flame of Forbidden Path', '', 'big_boom', 6.00, 13.00, 78, 'male', 'L2Monster', 'Fighter', 40, 8612, 25.755, 1657, 3.030, 40, 43, 30, 21, 20, 20, 24933, 2763, 1476, 568, 1019, 344, 253, 0, 506, 0, 0, 0, 48, 30, '', 300, 0, 0, 0, 7, 50, 1, 10, 0, 1, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3627, 18308, 'Offering of /Forbidden Path, Evoked Spirit', '', 'batur_orc_warrior', 10.00, 20.00, 77, 'male', 'L2Monster', 'Fighter', 40, 2762, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 9534, 1032, 1388, 544, 948, 330, 253, 0, 506, 175, 0, 0, 80, 175, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3628, 18309, 'Flame of the Branded', '', 'big_boom', 6.00, 13.00, 35, 'male', 'L2Monster', 'Fighter', 40, 2318, 13.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 4894, 290, 160, 170, 109, 103, 253, 0, 506, 0, 0, 0, 48, 30, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3629, 18310, 'Offering of the Branded, Evoked Spirit', '', 'orc', 10.00, 21.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 1751, 100, 138, 157, 94, 95, 253, 0, 506, 158, 0, 0, 45, 155, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3630, 18311, 'Flame of Apostates', '', 'big_boom', 6.00, 13.00, 46, 'male', 'L2Monster', 'Fighter', 40, 3689, 16.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 8454, 599, 335, 246, 228, 149, 253, 0, 506, 0, 0, 0, 48, 30, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3631, 18312, 'Offering of Apostates, Evoked Spirit', '', 'orc_fighter', 12.00, 22.00, 44, 'male', 'L2Monster', 'Fighter', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 3113, 213, 295, 230, 202, 140, 253, 0, 506, 172, 0, 0, 45, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3632, 18313, 'Flame of the Witch', '', 'big_boom', 6.00, 13.00, 57, 'male', 'L2Monster', 'Mystic', 40, 5330, 19.500, 948, 2.400, 40, 43, 30, 21, 20, 20, 12980, 1079, 619, 340, 423, 206, 253, 0, 506, 0, 0, 0, 48, 30, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3633, 18314, 'Offering of the Witch, Evoked Spirit', '', 'batur_orc', 9.00, 21.50, 55, 'male', 'L2Monster', 'Mystic', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 4864, 393, 559, 323, 382, 194, 253, 0, 506, 91, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3634, 18315, 'Flame of Dark Omen', '', 'big_boom', 6.00, 13.00, 68, 'male', 'L2Monster', 'Fighter', 40, 7037, 22.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 18473, 1784, 1014, 449, 692, 272, 253, 0, 506, 0, 0, 0, 48, 30, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3635, 18316, 'Offering of Dark Omen, Evoked Spirit', '', 'batur_orc', 9.00, 21.50, 66, 'male', 'L2Monster', 'Fighter', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 7004, 659, 936, 429, 639, 260, 253, 0, 506, 2503, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3636, 18317, 'Flame of Forbidden Path', '', 'big_boom', 6.00, 13.00, 78, 'male', 'L2Monster', 'Fighter', 40, 8527, 25.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 24933, 2763, 1461, 563, 1019, 341, 253, 0, 506, 0, 0, 0, 48, 30, '', 300, 0, 0, 0, 7, 50, 1, 10, 0, 1, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3637, 18318, 'Offering of Forbidden Path, Evoked Spirit', '', 'batur_orc_warrior', 10.00, 20.00, 77, 'male', 'L2Monster', 'Fighter', 40, 2762, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 9534, 1032, 1388, 544, 948, 330, 253, 0, 506, 175, 0, 0, 80, 175, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3638, 18319, 'Caught Frog', '', 'poison_toad', 20.00, 10.00, 10, 'male', 'L2PenaltyMonster', 'CaughtFighter', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 422, 14, 19, 52, 13, 37, 253, 0, 506, 0, 0, 0, 50, 110, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 10, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3639, 18320, 'Caught Undine', '', 'undine', 12.00, 27.00, 20, 'female', 'L2PenaltyMonster', 'CaughtMystic', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 844, 37, 48, 81, 33, 58, 253, 0, 506, 0, 0, 0, 60, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 10, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3640, 18321, 'Caught Rakul', '', 'rakul', 30.00, 39.00, 30, 'male', 'L2PenaltyMonster', 'CaughtFighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1550, 85, 111, 120, 75, 86, 253, 0, 506, 156, 0, 0, 60, 130, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 10, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3641, 18322, 'Caught Sea Giant', '', 'water_giant', 13.00, 44.00, 40, 'male', 'L2PenaltyMonster', 'CaughtFighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 2756, 178, 227, 172, 155, 123, 253, 0, 506, 131, 0, 0, 35, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 10, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3642, 18323, 'Caught Sea Horse Soldier', '', 'theeder', 9.00, 32.00, 50, 'male', 'L2PenaltyMonster', 'CaughtFighter', 80, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 4306, 324, 425, 236, 291, 168, 253, 0, 506, 291, 0, 0, 80, 150, '', 300, 0, 0, 0, 7, 30, 4, 0, 0, 10, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3643, 18324, 'Caught Homunculus', '', 'homunculus', 12.00, 32.50, 60, 'male', 'L2PenaltyMonster', 'CaughtFighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 6200, 538, 717, 314, 490, 224, 253, 0, 506, 0, 0, 0, 30, 160, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 10, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3644, 18325, 'Caught Flava', '', 'flava', 18.00, 34.00, 70, 'male', 'L2PenaltyMonster', 'CaughtFighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 8439, 837, 1096, 401, 747, 285, 253, 0, 506, 0, 0, 0, 30, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 10, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3645, 18326, 'Caught Gigantic Eye', '', 'hundred_eye', 21.00, 55.00, 78, 'male', 'L2PenaltyMonster', 'CaughtMystic', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 11022, 1237, 1495, 484, 1062, 346, 253, 0, 506, 0, 0, 0, 30, 180, '', 300, 0, 0, 0, 7, 50, 1, 11, 0, 12, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3646, 18327, 'Freyas Servant', '', 'gargoyle_02te', 16.00, 50.00, 58, 'male', 'L2Monster', 'Fighter', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 570, 350, 444, 232, 253, 500, 506, 0, 0, 0, 140, 140, 'ice_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3647, 18328, 'Hall Alarm Device', '', 'grave_keeper_key', 8.00, 21.00, 83, 'male', 'L2Monster', 'npc', 40, 100000, 8.800, 1847, 3.100, 40, 43, 30, 21, 20, 20, 0, 0, 1778, 652, 1309, 476, 253, 500, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3648, 18329, 'Hall Keeper Captain', '', 'death_lord', 21.00, 40.00, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 1500, 506, 78, 0, 0, 40, 160, 'hallguard_clan', 4000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3649, 18330, 'Hall Keeper Wizard', '', 'vale_master', 12.00, 40.00, 83, 'male', 'L2Monster', 'Mystic', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 1500, 506, 326, 0, 0, 70, 175, 'hallguard_clan', 4000, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3650, 18331, 'Hall Keeper Guard', '', 'death_knight', 12.00, 31.00, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 1500, 506, 142, 0, 0, 27, 110, 'hallguard_clan', 4000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3651, 18332, 'Hall Keeper Patrol', '', 'headless_knight', 21.00, 31.00, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 1500, 506, 124, 0, 0, 70, 170, 'hallguard_clan', 4000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3652, 18333, 'Hall Keeper Suicidal Soldier', '', 'self_blaster', 9.00, 25.80, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 1500, 506, 0, 0, 0, 30, 150, 'hallguard_clan', 4000, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3653, 18334, 'Dark Choir Captain', '', 'erinyes_cmd', 21.00, 50.00, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 31, 150, 'darkband_clan', 1500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3654, 18335, 'Dark Choir Prima Donna', '', 'portrait_spirit', 23.00, 40.00, 83, 'male', 'L2Monster', 'Mystic', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 3000, 506, 0, 0, 0, 30, 200, 'darkband_clan', 1500, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3655, 18336, 'Dark Choir Lancer', '', 'death_blader', 15.00, 45.00, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 3000, 506, 1472, 0, 0, 100, 180, 'darkband_clan', 1500, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3656, 18337, 'Dark Choir Archer', '', 'skeleton_archer_20_bi', 13.00, 32.50, 83, 'male', 'L2Monster', 'Ranger', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 3000, 506, 279, 0, 0, 40, 140, 'darkband_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.80, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3657, 18338, 'Dark Choir Witch Doctor', '', 'portrait_spirit_winged', 23.00, 40.00, 83, 'male', 'L2Monster', 'Mystic', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 3000, 506, 0, 0, 0, 30, 190, 'darkband_clan', 500, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3658, 18339, 'Dark Choir Player', '', 'skeleton', 11.00, 25.00, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 150, 506, 150, 103, 0, 60, 140, 'darkband_clan', 1500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3659, 18340, 'Hall Keeper Suicidal Soldier', '', 'self_blaster', 9.00, 25.80, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 2000, 506, 0, 0, 0, 30, 100, 'darkband_clan', 1000, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3660, 18341, 'Hall Keeper Suicidal Soldier', '', 'self_blaster', 9.00, 25.80, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 2000, 506, 0, 0, 0, 30, 150, 'darkband_clan', 1000, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3661, 18342, 'Gremlin', '', 'gremlin', 10.00, 15.00, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 29, 2, 7, 40, 5, 27, 253, 0, 506, 0, 0, 0, 20, 50, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3662, 18343, 'Gatekeeper Zombie', '', 'zombie_gateguard', 17.00, 30.50, 78, 'male', 'L2SpecialMonster', 'GatekeeperZombie', 40, 2985, 8.650, 1777, 3.050, 40, 43, 30, 21, 20, 20, 0, 0, 1712, 623, 1239, 456, 253, 500, 506, 8217, 0, 0, 33, 120, 'trioll_clan', 1200, 0, 0, 0, 7, 50, 1, 14, 0, 5, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3663, 18344, 'Ancient Egg', '', 'dinosaur_nest', 53.00, 11.50, 78, 'etc', 'L2SpecialMonster', 'AncientEgg', 40, 10, 8.500, 1882, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1668, 611, 1186, 448, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 50, 1, 11, 0, 2, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3664, 18345, 'Sprigant', '', 'Arachnoid', 45.00, 67.00, 78, 'female', 'L2Monster', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 8267, 961, 1488, 556, 1015, 406, 253, 500, 506, 0, 0, 0, 60, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3665, 18346, 'Sprigant', '', 'Arachnoid', 45.00, 67.00, 78, 'female', 'L2Monster', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 8267, 961, 1488, 556, 1015, 406, 253, 500, 506, 0, 0, 0, 60, 150, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3666, 18347, 'Garden Guard', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 708, 31, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 36, 120, 'ndg_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3667, 18348, 'Garden Guard', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 21, 'male', 'L2Monster', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 949, 35, 53, 99, 36, 73, 253, 0, 506, 0, 0, 0, 36, 110, 'ndg_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3668, 18349, 'Garden Guard', '', 'LineageMonster4.Mostro_Gunner', 15.00, 24.50, 21, 'male', 'L2Monster', 'Ranger', 700, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 907, 41, 53, 99, 36, 73, 253, 0, 506, 10128, 0, 0, 36, 110, 'ndg_clan', 300, 0, 0, 0, 7, 10, 10, 5, 400, 0, 0.51, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3669, 18350, 'Garden Guard', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 21, 'male', 'L2Monster', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 1000, 35, 53, 99, 36, 73, 253, 0, 506, 0, 0, 0, 36, 110, 'ndg_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3670, 18351, 'Garden Guard', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 21, 'male', 'L2Monster', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 952, 35, 53, 99, 36, 73, 253, 0, 506, 0, 0, 0, 36, 110, 'ndg_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3671, 18352, 'Kamael Guard', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 1808, 68, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 36, 130, 'ndg_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3672, 18353, 'Guardian of Records', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 2401, 99, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 36, 130, 'ndg_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3673, 18354, 'Guardian of Observation', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 1808, 68, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 36, 130, 'ndg_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3674, 18355, 'Spiculas Guard', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 2542, 99, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 36, 130, 'ndg_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3675, 18356, 'Harkilgameds Gatekeeper', '', 'LineageMonster4.Mostro_Gunner', 15.00, 24.50, 22, 'male', 'L2Monster', 'Ranger', 700, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 2470, 111, 58, 103, 39, 75, 253, 0, 506, 10128, 0, 0, 36, 130, 'ndg_clan', 300, 0, 0, 0, 7, 10, 10, 5, 400, 0, 0.51, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3676, 18357, 'Rodenpiculas Gatekeeper', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 2401, 99, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 36, 130, 'ndg_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3677, 18358, 'Guardian of Secrets', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 1808, 68, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 36, 130, 'ndg_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3678, 18359, 'Arviterres Guardian', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 1808, 68, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 36, 130, 'ndg_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3679, 18360, 'Katenars Gatekeeper', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 1808, 68, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 36, 130, 'ndg_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3680, 18361, 'Guardian of Prediction', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 2401, 99, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 36, 130, 'ndg_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3681, 18362, 'Garden Guard', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 19, 'male', 'L2Monster', 'Fighter', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 742, 30, 44, 91, 30, 67, 253, 0, 506, 0, 0, 0, 36, 120, 'ndg_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3682, 18363, 'Garden Guard', '', 'LineageMonster4.Mostro_Gunner', 15.00, 24.50, 19, 'male', 'L2Monster', 'Ranger', 700, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 670, 29, 44, 91, 30, 67, 253, 0, 506, 10128, 0, 0, 36, 110, 'ndg_clan', 300, 0, 0, 0, 7, 10, 10, 5, 400, 0, 0.51, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3683, 18364, 'Witch Warder', '', 'LineageMonster.Onyx_beast', 14.00, 14.50, 79, 'male', 'L2SpecialMonster', 'WitchWarder', 40, 2842, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1470, 566, 1005, 415, 253, 0, 506, 0, 0, 0, 30, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.24, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3684, 18365, 'Witch Warder', '', 'LineageMonster.Onyx_beast', 14.00, 14.50, 80, 'male', 'L2SpecialMonster', 'WitchWarder', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 30, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.24, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3685, 18366, 'Witch Warder', '', 'LineageMonster.Onyx_beast', 14.00, 14.50, 82, 'male', 'L2SpecialMonster', 'WitchWarder', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 30, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.24, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3686, 18367, 'Prison Guard', '', 'LineageMonster3.zombie_gateguard', 17.00, 30.50, 80, 'male', 'L2Monster', 'PrisonGuard', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1513, 576, 1033, 423, 253, 300, 506, 8217, 0, 0, 33, 50, 'oracle_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3687, 18368, 'Prison Guard', '', 'LineageMonster3.zombie_gateguard', 17.00, 30.50, 80, 'male', 'L2Monster', 'PrisonGuard', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 8579, 962, 1513, 576, 1033, 423, 253, 300, 506, 8217, 0, 0, 33, 160, 'oracle_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3688, 18369, 'Chromatic Crystalline Golem', '', 'LineageMonster4.Crystal_Golem', 34.00, 47.00, 82, 'male', 'L2Monster', 'Fighter', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 9308, 1017, 1594, 599, 1088, 438, 253, 500, 506, 0, 0, 0, 54, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3689, 18370, 'Chromatic Crystalline Golem', '', 'LineageMonster4.Crystal_Golem', 34.00, 47.00, 82, 'male', 'L2Monster', 'Fighter', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 8545, 934, 1594, 599, 1088, 438, 253, 500, 506, 0, 0, 0, 54, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3690, 18371, 'Beleth Sample', '', 'LineageMonster3.zombie_gateguard', 17.00, 30.50, 82, 'male', 'L2Monster', 'Fighter', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 7697, 841, 1594, 599, 1088, 438, 253, 0, 506, 8217, 0, 0, 33, 50, 'oracle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3691, 18372, 'Beleth Sample', '', 'LineageMonster3.Zombie_laborer', 11.00, 24.60, 82, 'male', 'L2Monster', 'Fighter', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 7697, 841, 1594, 599, 1088, 438, 253, 0, 506, 123, 0, 0, 36, 180, 'oracle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3692, 18373, 'Beleth Sample', '', 'LineageMonster3.Zombie_enlisted_man', 17.00, 22.30, 82, 'male', 'L2Monster', 'Fighter', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 7697, 841, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 38, 200, 'oracle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3693, 18374, 'Beleth Sample', '', 'LineageMonster3.Zombie_knight', 17.00, 22.30, 82, 'male', 'L2Monster', 'Fighter', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 7697, 841, 1594, 599, 1088, 438, 253, 0, 506, 8215, 0, 0, 38, 200, 'oracle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3694, 18375, 'Beleth Sample', '', 'LineageMonster.Skeleton_royal_guard', 11.00, 28.50, 82, 'male', 'L2Monster', 'Fighter', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 7697, 841, 1594, 599, 1088, 438, 253, 0, 506, 946, 945, 0, 80, 15, 'oracle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3695, 18376, 'Beleth Sample', '', 'LineageMonster.Vale_master', 12.00, 40.00, 82, 'male', 'L2Monster', 'Fighter', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 7697, 841, 1594, 599, 1088, 438, 253, 0, 506, 205, 0, 0, 70, 155, 'oracle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3696, 18377, 'Beleth Sample', '', 'LineageMonster.Skeleton_knight', 10.00, 25.00, 82, 'male', 'L2Monster', 'Fighter', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 7697, 841, 1594, 599, 1088, 438, 253, 0, 506, 150, 103, 0, 40, 160, 'oracle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3697, 18378, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_switch', 19.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3698, 18379, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3699, 18380, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3700, 18381, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3701, 18382, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3702, 18383, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3703, 18384, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3704, 18385, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3705, 18386, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3706, 18387, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3707, 18388, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3708, 18389, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3709, 18390, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3710, 18391, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3711, 18392, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3712, 18393, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3713, 18394, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3714, 18395, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3715, 18396, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3716, 18397, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3717, 18398, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3718, 18399, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3719, 18400, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3720, 18401, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3721, 18402, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3722, 18403, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3723, 18404, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3724, 18405, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3725, 18406, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3726, 18407, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3727, 18408, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3728, 18409, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3729, 18410, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3730, 18411, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3731, 18412, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3732, 18413, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3733, 18414, 'Warriors Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 18, 'etc', 'L2Npc', 'npc', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 41, 87, 28, 64, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3734, 18415, 'Midway Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 18, 'etc', 'L2Npc', 'npc', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 41, 87, 28, 64, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3735, 18416, 'Doorman', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 18, 'etc', 'L2Npc', 'npc', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 41, 87, 28, 64, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3736, 18417, 'Bridge Keeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 18, 'etc', 'L2Npc', 'npc', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 41, 87, 28, 64, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3737, 18418, 'Bridge Keeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 18, 'etc', 'L2Npc', 'npc', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 41, 87, 28, 64, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3738, 18419, 'Bridge Keeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 18, 'etc', 'L2Npc', 'npc', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 41, 87, 28, 64, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3739, 18420, 'Trap', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 18, 'etc', 'L2Npc', 'npc', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 41, 87, 28, 64, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3740, 18427, 'b_tower_1st_tel', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3741, 18428, 'b_tower_2st_tel', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3742, 18429, 'b_tower_3st_tel', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3743, 18430, 'b_tower_4st_tel', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3744, 18431, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3745, 18432, 'Trap', '', 'LineageNpcEV.Trap_device_wall_switch', 24.00, 38.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3746, 18433, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3747, 18434, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3748, 18435, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3749, 18436, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3750, 18437, 'Trap', '', 'LineageNPC.clear_npc', 0.10, 0.10, 18, 'male', 'L2Npc', 'npc', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 41, 87, 28, 64, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3751, 18438, 'Trap', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 15, 'etc', 'L2Npc', 'npc', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 40, 84, 27, 62, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3752, 18441, 'Kamael Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 18, 'etc', 'L2Npc', 'npc', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 41, 87, 28, 64, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3753, 18442, 'Trap', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 18, 'etc', 'L2Npc', 'npc', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 41, 87, 28, 64, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3754, 18443, 'Trap', '', 'LineageNpcEV.Trap_device_bottom_staff', 30.00, 13.00, 78, 'etc', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3755, 18444, 'Garden Guard', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 816, 36, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 36, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3756, 18445, 'Tullys Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 80, 'etc', 'L2TullysGatekeeper', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1447, 563, 987, 411, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3757, 18446, 'Tullys Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 80, 'etc', 'L2TullysGatekeeper', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1447, 563, 987, 411, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3758, 18447, 'Tullys Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 80, 'etc', 'L2TullysGatekeeper', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1447, 563, 987, 411, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3759, 18448, 'Tullys Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 80, 'etc', 'L2TullysGatekeeper', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1447, 563, 987, 411, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3760, 18449, 'Tullys Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 80, 'etc', 'L2TullysGatekeeper', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1447, 563, 987, 411, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3761, 18450, 'Tullys Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 80, 'etc', 'L2TullysGatekeeper', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1447, 563, 987, 411, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3762, 18451, 'Tullys Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 80, 'etc', 'L2TullysGatekeeper', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1447, 563, 987, 411, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3763, 18452, 'Tullys Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 80, 'etc', 'L2TullysGatekeeper', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1447, 563, 987, 411, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3764, 18453, 'Tullys Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 80, 'etc', 'L2TullysGatekeeper', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1447, 563, 987, 411, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3765, 18454, 'Tullys Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 80, 'etc', 'L2TullysGatekeeper', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1447, 563, 987, 411, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3766, 18455, 'Tullys Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 80, 'etc', 'L2TullysGatekeeper', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1447, 563, 987, 411, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3767, 18456, 'Tullys Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 80, 'etc', 'L2TullysGatekeeper', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1447, 563, 987, 411, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3768, 18457, 'Tullys Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 80, 'etc', 'L2TullysGatekeeper', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1447, 563, 987, 411, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3769, 18458, 'Tullys Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 80, 'etc', 'L2TullysGatekeeper', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1447, 563, 987, 411, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3770, 18459, 'Tullys Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 80, 'etc', 'L2TullysGatekeeper', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1447, 563, 987, 411, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3771, 18460, 'Tullys Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 80, 'etc', 'L2TullysGatekeeper', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1447, 563, 987, 411, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3772, 18461, 'Tullys Gatekeeper', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 80, 'etc', 'L2TullysGatekeeper', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1447, 563, 987, 411, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3773, 18463, 'Remnant Diabolist', '', 'LineageNPC.e_traderB_Fdwarf_mon_120p', 8.00, 22.00, 81, 'female', 'L2Remnant', 'Remnant', 1100, 65918, 113.265, 1709, 3.000, 40, 43, 30, 21, 20, 20, 260217, 28102, 9614, 974, 6642, 1069, 253, 0, 506, 8527, 0, 0, 49, 160, 'ruin_clan', 400, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3774, 18464, 'Remnant Diviner', '', 'LineageNPC.a_mageguild_teacher_Mhuman_mon', 8.00, 23.00, 81, 'male', 'L2Remnant', 'Remnant', 40, 65918, 113.265, 1709, 3.000, 40, 43, 30, 21, 20, 20, 254867, 27524, 9614, 974, 6642, 1069, 253, 0, 506, 8532, 0, 0, 50, 160, 'ruin_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3775, 18465, 'Derek', '', 'LineageNPC.a_mageguild_teacher_Mhuman_mon_120p', 10.00, 28.10, 81, 'male', 'L2Monster', 'HBMystic', 40, 338767, 194.030, 1709, 3.000, 40, 43, 30, 21, 20, 20, 1067320, 115266, 13301, 974, 9190, 1069, 253, 0, 506, 8678, 0, 0, 50, 160, 'ruin_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3776, 18466, 'Outpost Captain', '', 'LineageMonster3.Benom', 20.00, 56.00, 81, 'male', 'L2Monster', 'OutpostCaptain', 40, 111547, 187.261, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15830, 1006, 11064, 1105, 253, 0, 506, 8203, 8203, 0, 79, 220, 'castleout_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3777, 18467, 'Wounded Land Guard', '', 'LineageMonster4.Eyeless', 36.00, 43.50, 81, 'male', 'L2Monster', 'HBFighter', 40, 336061, 189.143, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 13527, 991, 9401, 1088, 253, 0, 506, 0, 0, 0, 60, 210, 'test_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3778, 18468, 'Doorman', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 18, 'etc', 'L2Npc', 'npc', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 41, 87, 28, 64, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3779, 18469, 'Hall Guard', '', 'LineageMonster.blade_stakato_120p', 18.00, 43.20, 83, 'male', 'L2Npc', 'npc', 40, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 253630, 26086, 10002, 974, 6830, 1068, 253, 0, 506, 0, 0, 0, 25, 180, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3780, 18470, 'Hall Guard', '', 'LineageMonster.blade_stakato_soldier_120p', 23.00, 45.50, 83, 'male', 'L2Npc', 'npc', 40, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 103029, 11126, 10002, 974, 6830, 1068, 253, 0, 506, 0, 0, 0, 25, 180, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3781, 18471, 'Hall Guard', '', 'LineageMonster4.Anthias', 20.00, 41.00, 83, 'male', 'L2Npc', 'npc', 40, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 45987, 4761, 10002, 974, 6830, 1068, 253, 0, 506, 0, 0, 0, 60, 180, 'oracle_clan', 500, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3782, 18472, 'Hall Guard', '', 'LineageMonster4.Anthias', 20.00, 41.00, 83, 'male', 'L2Npc', 'npc', 40, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 112394, 12138, 10002, 974, 6830, 1068, 253, 0, 506, 0, 0, 0, 60, 180, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3783, 18473, 'Hall Captain', '', 'LineageMonster3.cannibal_stakato_leader_120p', 34.00, 48.80, 83, 'male', 'L2Npc', 'npc', 40, 336949, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 724449, 78237, 13301, 974, 9083, 1068, 253, 0, 506, 0, 0, 0, 40, 250, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3784, 18474, 'Alarm', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 83, 'etc', 'L2Npc', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 50, 1, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3785, 18475, 'Hall Guard', '', 'LineageMonster.undine', 12.00, 27.00, 83, 'female', 'L2Npc', 'npc', 40, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 90678, 9792, 10002, 974, 6830, 1068, 253, 0, 506, 0, 0, 0, 60, 180, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3786, 18476, 'Hall Guard', '', 'LineageMonster.lienrik_210p', 12.00, 50.00, 83, 'male', 'L2Npc', 'npc', 40, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 104688, 11305, 10002, 974, 6830, 1068, 253, 0, 506, 0, 0, 0, 100, 180, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3787, 18477, 'Coral Treasure Chest', '', 'LineageMonster.mimic_even', 8.50, 8.50, 83, 'male', 'L2Npc', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 80, 1, '', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3788, 18478, 'Herb Jar', '', 'LineageNpcEV.herb_pot', 8.00, 21.50, 15, 'male', 'L2Npc', 'npc', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 31, 77, 21, 56, 253, 0, 506, 0, 0, 0, 1, 1, 'ndg_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3789, 18479, 'Inner Castle Sentry', '', 'LineageMonster.kel_mahum', 13.00, 26.00, 81, 'male', 'L2Npc', 'npc', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 629, 1445, 461, 253, 0, 506, 0, 0, 0, 50, 180, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3790, 18480, 'Inner Castle Guard', '', 'LineageMonster4.Eyeless', 36.00, 43.50, 81, 'male', 'L2Npc', 'npc', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 629, 1445, 461, 253, 0, 506, 0, 0, 0, 60, 210, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3791, 18481, 'Inner Castle Seer', '', 'LineageMonster4.Eyeless', 36.00, 43.50, 81, 'male', 'L2Npc', 'npc', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 629, 1445, 461, 253, 0, 506, 0, 0, 0, 60, 210, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3792, 18482, 'Fafurion Kindred', '', 'LineageMonster3.Water_Drake', 55.00, 80.50, 82, 'female', 'L2SpecialMonster', 'FafurionKindred', 40, 2952, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1594, 599, 1088, 438, 253, 0, 506, 0, 0, 0, 60, 160, 'dark_clan', 500, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3793, 18483, 'Garden Guard', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 19, 'male', 'L2Monster', 'Fighter', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 1353, 57, 44, 91, 30, 67, 253, 0, 506, 0, 0, 0, 36, 120, 'ndg_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3794, 18484, 'Naia Failan', '', 'LineageNPC.heart_of_warding', 17.00, 120.00, 83, 'etc', 'L2Monster', 'EnchantedMegaliths', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 50, 80, 'hell_clan', 800, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3795, 18485, 'hellbound_fieldtrap1', '', 'LineageNPC.clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3796, 18486, 'hellbound_fieldtrap2', '', 'LineageNPC.clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3797, 18487, 'hellbound_fieldtrap3', '', 'LineageNPC.clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3798, 18488, 'hellbound_fieldtrap4', '', 'LineageNPC.clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3799, 18489, 'hellbound_fieldtrap5', '', 'LineageNPC.clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3800, 18490, 'Beleths Slave', '', 'LineageMonster4.devil_doll', 8.00, 17.50, 86, 'female', 'L2Npc', 'npc', 40, 18540, 185.680, 1882, 3.000, 40, 43, 30, 21, 20, 20, 65975, 6876, 18142, 1024, 12388, 1124, 253, 0, 506, 0, 0, 0, 60, 160, 'castle_clan', 1500, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3801, 18491, 'Lock', '', 'LineageNpcEV.soulprison', 21.00, 53.00, 87, 'male', 'L2Monster', 'TowerOfNaiaLock', 40, 597542, 0.000, 1917, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2, 2288, 2, 2556, 253, 0, 506, 0, 0, 0, 1, 1, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3802, 18492, 'Controller', '', 'LineageNpcEV.elobrate_machine', 13.00, 20.00, 87, 'male', 'L2Npc', 'npc', 40, 4657, 8.500, 1917, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2253, 649, 1538, 475, 253, 0, 506, 0, 0, 0, 1, 1, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3803, 18493, 'Ward', '', 'LineageMonster2.hundred_eye', 21.00, 55.00, 87, 'male', 'L2Monster', 'Fighter', 40, 10160614, 330.315, 1917, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 23000, 1301, 15704, 1903, 253, 0, 506, 0, 0, 0, 30, 170, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3804, 18494, 'Ingenious Contraption', '', 'LineageNpcEV.elobrate_machine', 13.00, 20.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3805, 18495, 'Ingenious Contraption', '', 'LineageNpcEV.elobrate_machine', 13.00, 20.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3806, 18496, 'Ingenious Contraption', '', 'LineageNpcEV.elobrate_machine', 13.00, 20.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3807, 18497, 'Ingenious Contraption', '', 'LineageNpcEV.elobrate_machine', 13.00, 20.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3808, 18498, 'Ingenious Contraption', '', 'LineageNpcEV.elobrate_machine', 13.00, 20.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3809, 18499, 'Ingenious Contraption', '', 'LineageNpcEV.elobrate_machine', 13.00, 20.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3810, 18500, 'Ingenious Contraption', '', 'LineageNpcEV.elobrate_machine', 13.00, 20.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3811, 18501, 'Ingenious Contraption', '', 'LineageNpcEV.elobrate_machine', 13.00, 20.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3812, 18502, 'Ingenious Contraption', '', 'LineageNpcEV.elobrate_machine', 13.00, 20.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3813, 18503, 'Ingenious Contraption', '', 'LineageNpcEV.elobrate_machine', 13.00, 20.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3814, 18504, 'Ingenious Contraption', '', 'LineageNpcEV.elobrate_machine', 13.00, 20.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3815, 18505, 'Ingenious Contraption', '', 'LineageNpcEV.elobrate_machine', 13.00, 20.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3816, 18506, 'Soul Crystal Pillar', '', 'LineageNpcEV.soulprison', 21.00, 53.00, 87, 'male', 'L2Npc', 'npc', 40, 4657, 8.500, 1917, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2253, 649, 1538, 475, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3817, 18507, 'c_tower_trap_lurker1', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3818, 18508, 'c_tower_trap_lurker2', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3819, 18509, 'c_tower_trap_lurker3', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3820, 18510, 'c_tower_trap_lurker4', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3821, 18511, 'c_tower_trap_lurker5', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3822, 18512, 'c_tower_trap_lurker6', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3823, 18513, 'c_tower_trap_lurker7', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3824, 18514, 'c_tower_trap_lurker8', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3825, 18515, 'c_tower_trap_lurker9', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3826, 18516, 'c_tower_trap_poison1', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3827, 18517, 'c_tower_trap_poison2', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3828, 18518, 'c_tower_trap_poison3', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3829, 18519, 'c_tower_trap_poison4', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3830, 18520, 'c_tower_trap_poison5', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3831, 18521, 'c_tower_trap_poison6', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3832, 18522, 'c_tower_trap_poison7', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3833, 18523, 'c_tower_trap_poison8', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3834, 18524, 'c_tower_trap_poison9', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3835, 18525, 'c_tower_trap_flame1', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3836, 18526, 'c_tower_trap_flame2', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3837, 18527, 'c_tower_trap_flame3', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3838, 18528, 'c_tower_trap_flame4', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3839, 18529, 'c_tower_trap_flame5', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3840, 18530, 'c_tower_trap_flame6', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3841, 18531, 'c_tower_trap_flame7', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3842, 18532, 'c_tower_trap_flame8', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3843, 18533, 'c_tower_trap_flame9', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3844, 18534, 'Kertangs Treasure Chest', '', 'LineageMonster.mimic', 8.50, 8.50, 45, 'male', 'L2Chest', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 315, 239, 214, 174, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3845, 18535, 'Kertangs Treasure Chest', '', 'LineageMonster.mimic', 8.50, 8.50, 55, 'male', 'L2Chest', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3846, 18536, 'Kertangs Treasure Chest', '', 'LineageMonster.mimic', 8.50, 8.50, 65, 'male', 'L2Chest', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 898, 419, 613, 306, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3847, 18537, 'Kertangs Treasure Chest', '', 'LineageMonster.mimic', 8.50, 8.50, 75, 'male', 'L2Chest', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3848, 18538, 'Kertangs Treasure Chest', '', 'LineageMonster.mimic', 8.50, 8.50, 85, 'male', 'L2Chest', 'Fighter', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3849, 18539, 'Resurrection Tower', '', 'LineageNpcEV.resurrection_tower', 28.00, 50.00, 45, 'male', 'L2Npc', 'npc', 40, 24127, 52.594, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1293, 381, 883, 418, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3850, 18540, 'Resurrection Tower', '', 'LineageNpcEV.resurrection_tower', 28.00, 50.00, 55, 'male', 'L2Npc', 'npc', 40, 46220, 93.758, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 3192, 516, 2180, 566, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3851, 18541, 'Resurrection Tower', '', 'LineageNpcEV.resurrection_tower', 28.00, 50.00, 65, 'male', 'L2Npc', 'npc', 40, 64711, 122.743, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 6919, 670, 4725, 735, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3852, 18542, 'Resurrection Tower', '', 'LineageNpcEV.resurrection_tower', 28.00, 50.00, 75, 'male', 'L2Npc', 'npc', 40, 74308, 132.352, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 10476, 838, 7154, 920, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3853, 18543, 'Resurrection Tower', '', 'LineageNpcEV.resurrection_tower', 28.00, 50.00, 80, 'male', 'L2Npc', 'npc', 40, 113229, 195.709, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15218, 923, 10394, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3854, 18544, 'Cruma Border', '', 'LineageNpcEV.trap_ironcastle', 12.00, 20.40, 45, 'male', 'L2Npc', 'npc', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 315, 239, 214, 174, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3855, 18545, 'Ancient Experiment', '', 'LineageMonster.marsh_stakato_soldier', 10.00, 25.00, 45, 'male', 'L2Npc', 'npc', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 315, 239, 214, 174, 253, 0, 506, 127, 0, 0, 30, 155, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3856, 18546, 'Ancient Experiment', '', 'LineageMonster.stone_golem', 20.00, 31.00, 45, 'male', 'L2Npc', 'npc', 40, 12601, 27.469, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 721, 381, 492, 418, 253, 0, 506, 0, 0, 0, 23, 23, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3857, 18547, 'Ancient Experiment', '', 'LineageMonster.onyx_beast', 14.00, 14.50, 45, 'male', 'L2Npc', 'npc', 40, 37803, 27.469, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 450, 381, 308, 418, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.24, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3858, 18548, 'Ancient Experiment', '', 'LineageMonster.onyx_beast', 14.00, 14.50, 45, 'male', 'L2Npc', 'npc', 40, 12601, 27.469, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 721, 381, 492, 418, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.24, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3859, 18549, 'Ancient Experiment', '', 'LineageMonster.onyx_beast', 14.00, 14.50, 45, 'male', 'L2Npc', 'npc', 40, 12601, 27.469, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 721, 381, 492, 418, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.24, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3860, 18550, 'Cruma Phantom', '', 'LineageMonster.death_blader', 15.00, 45.00, 50, 'male', 'L2Npc', 'npc', 40, 17718, 37.235, 748, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1101, 445, 752, 489, 253, 0, 506, 1472, 0, 0, 100, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3861, 18551, 'Cruma Phantom', '', 'LineageMonster.susceptor', 20.00, 35.00, 50, 'male', 'L2Npc', 'npc', 40, 53155, 37.235, 748, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 682, 445, 466, 489, 253, 0, 506, 0, 0, 0, 27, 150, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3862, 18552, 'Cruma Phantom', '', 'LineageMonster.gamlin', 11.00, 32.00, 50, 'male', 'L2Npc', 'npc', 40, 17718, 37.235, 748, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1101, 445, 752, 489, 253, 0, 506, 6307, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3863, 18553, 'Cruma Phantom', '', 'LineageMonster.leogul', 15.00, 35.00, 50, 'male', 'L2Npc', 'npc', 40, 17718, 37.235, 748, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1101, 445, 752, 489, 253, 0, 506, 6307, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3864, 18554, 'Tomlan Kamos', '', 'LineageMonster.bugbear_bi', 25.00, 53.00, 23, 'male', 'L2ReflectionBoss', 'Fighter', 40, 51639, 10.662, 1160, 4.800, 40, 43, 30, 21, 20, 20, 355901, 19458, 76, 171, 52, 188, 253, 0, 506, 4, 0, 0, 55, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (3865, 18555, 'Ol Ariosh', '', 'LineageMonster.ol_mahum_champion_05te_120p', 16.00, 33.20, 26, 'male', 'Kama26Boss', 'Fighter', 40, 60567, 12.179, 1365, 4.800, 40, 43, 30, 21, 20, 20, 397272, 23285, 114, 193, 78, 212, 253, 0, 506, 67, 633, 0, 50, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (3866, 18556, 'Follower of Ariosh', '', 'LineageMonster.ol_mahum_champion', 14.00, 27.00, 26, 'male', 'L2SpecialMonster', 'Fighter', 40, 488, 3.500, 1365, 4.800, 40, 43, 30, 21, 20, 20, 0, 0, 81, 121, 55, 89, 253, 0, 506, 69, 102, 0, 50, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3867, 18557, 'Ranc Deumus', '', 'LineageMonster.virud_lizardman_warrior_bi', 12.00, 34.50, 26, 'male', 'L2Npc', 'npc', 40, 60567, 12.179, 1365, 4.800, 40, 43, 30, 21, 20, 20, 397272, 23285, 114, 193, 78, 212, 253, 500, 506, 93, 0, 0, 52, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3868, 18558, 'Crimson Hatu Otis', '', 'LineageMonster.crimson_bear', 19.00, 36.00, 33, 'male', 'L2ReflectionBoss', 'Fighter', 40, 77012, 14.598, 1865, 6.480, 40, 43, 30, 21, 20, 20, 549172, 35415, 234, 253, 160, 277, 253, 0, 506, 0, 0, 0, 37, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (3869, 18559, 'Seer Flouros', '', 'LineageMonster.monster_eye_05te_ef', 21.00, 43.00, 36, 'male', 'L2ReflectionBoss', 'Mystic', 40, 94226, 17.432, 2088, 6.480, 40, 43, 30, 21, 20, 20, 620253, 41849, 308, 281, 210, 309, 253, 0, 506, 0, 0, 0, 90, 90, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3870, 18560, 'Follower of Flouros', '', 'LineageMonster.monster_eye', 21.00, 43.00, 36, 'male', 'L2SpecialMonster', 'Mystic', 40, 810, 4.500, 2088, 6.480, 40, 43, 30, 21, 20, 20, 0, 0, 173, 176, 118, 129, 253, 0, 506, 0, 0, 0, 90, 90, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3871, 18561, 'Granitick Duerga', '', 'LineageMonster.stone_golem', 20.00, 31.00, 36, 'male', 'L2Npc', 'npc', 40, 94226, 17.432, 2088, 6.480, 40, 43, 30, 21, 20, 20, 620253, 41849, 308, 281, 210, 309, 253, 500, 506, 0, 0, 0, 23, 23, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3872, 18562, 'Blade Otis', '', 'LineageMonster.blade_stakato_drone_10_sm', 14.00, 35.10, 43, 'male', 'L2ReflectionBoss', 'Fighter', 40, 132635, 23.236, 2787, 11.550, 40, 43, 30, 21, 20, 20, 784383, 58093, 477, 358, 326, 392, 253, 0, 506, 131, 0, 0, 25, 155, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (3873, 18563, 'Follower of Otis', '', 'LineageMonster.marsh_stakato_drone', 9.00, 24.00, 43, 'male', 'L2SpecialMonster', 'Fighter', 40, 1094, 5.500, 2787, 11.550, 40, 43, 30, 21, 20, 20, 0, 0, 277, 223, 189, 164, 253, 0, 506, 223, 0, 0, 80, 155, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3874, 18564, 'Weird Bunei', '', 'LineageMonster3.Water_Drake', 55.00, 80.50, 46, 'female', 'L2ReflectionBoss', 'Mystic', 40, 165223, 28.302, 3189, 11.550, 40, 43, 30, 21, 20, 20, 848114, 69276, 636, 394, 435, 432, 253, 0, 506, 0, 0, 0, 60, 160, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3875, 18565, 'Brave Martim', '', 'LineageMonster.ogre_50_bi', 30.00, 66.00, 46, 'male', 'L2Npc', 'npc', 40, 165223, 28.302, 3189, 11.550, 40, 43, 30, 21, 20, 20, 848114, 69276, 636, 394, 435, 432, 253, 500, 506, 298, 0, 0, 33, 185, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.82, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3876, 18566, 'Kaim Abigore', '', 'LineageMonster.kaim_vanul_50_bi', 36.00, 60.00, 53, 'male', 'L2ReflectionBoss', 'Fighter', 40, 294175, 47.907, 4162, 13.200, 40, 43, 30, 21, 20, 20, 967925, 88254, 1143, 487, 781, 534, 253, 0, 506, 0, 0, 0, 60, 250, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (3877, 18567, 'Follower of Abigore', '', 'LineageMonster.liviona', 15.00, 28.00, 53, 'male', 'L2SpecialMonster', 'Fighter', 40, 1571, 6.500, 4162, 13.200, 40, 43, 30, 21, 20, 20, 0, 0, 503, 304, 344, 223, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3878, 18568, 'Knight Montagnar', '', 'LineageMonster.skeleton_royal_guard', 11.00, 28.50, 56, 'male', 'L2ReflectionBoss', 'Kama56Boss', 40, 318250, 50.755, 4594, 13.200, 40, 43, 30, 21, 20, 20, 1002611, 124970, 1617, 529, 1103, 581, 253, 0, 506, 946, 945, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (3879, 18569, 'Follower of Montagnar', '', 'LineageMonster.dark_fencer', 7.00, 13.00, 56, 'male', 'L2SpecialMonster', 'Kama56Minion', 40, 1725, 6.500, 4594, 13.200, 40, 43, 30, 21, 20, 20, 0, 0, 589, 331, 402, 242, 253, 0, 506, 0, 0, 0, 25, 150, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3880, 18570, 'Summer Yaganitan', '', 'LineageMonster2.flava_15_bi', 23.00, 39.00, 56, 'male', 'L2Npc', 'npc', 40, 318250, 50.755, 4594, 13.200, 40, 43, 30, 21, 20, 20, 1002611, 124970, 1617, 529, 1103, 581, 253, 500, 506, 0, 0, 0, 30, 165, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3881, 18571, 'Venomous Storace', '', 'LineageMonster.serpent_slave_50_bi', 25.00, 72.00, 63, 'male', 'L2ReflectionBoss', 'Fighter', 40, 420501, 63.974, 5637, 16.470, 40, 43, 30, 21, 20, 20, 1046467, 179455, 2847, 638, 1944, 699, 253, 0, 506, 73, 0, 0, 70, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (3882, 18572, 'Follower of Storace', '', 'LineageMonster.cave_maiden_080p', 12.00, 54.00, 63, 'female', 'L2SpecialMonster', 'Kama63Minion', 40, 2090, 7.500, 5637, 16.470, 40, 43, 30, 21, 20, 20, 0, 0, 822, 398, 562, 292, 253, 0, 506, 73, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3883, 18573, 'Kel Bilette', '', 'LineageMonster.kel_mahum_champion_50_bi', 19.00, 48.00, 66, 'male', 'L2ReflectionBoss', 'Fighter', 40, 445991, 66.539, 6099, 16.470, 40, 43, 30, 21, 20, 20, 1052061, 186892, 3302, 687, 2254, 753, 253, 0, 506, 75, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (3884, 18574, 'Follower of Bilette', '', 'LineageMonster.kel_mahum_witch_doctor', 13.00, 25.00, 66, 'male', 'L2SpecialMonster', 'Fighter', 40, 2245, 7.500, 6099, 16.470, 40, 43, 30, 21, 20, 20, 0, 0, 936, 429, 639, 313, 253, 0, 506, 193, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3885, 18575, 'Warlord Tamuze', '', 'LineageMonster3.Vampire_Troop_Leader_120p', 22.00, 43.00, 66, 'male', 'L2Npc', 'npc', 40, 445991, 66.539, 6099, 16.470, 40, 43, 30, 21, 20, 20, 1052061, 186892, 3302, 687, 2254, 753, 253, 500, 506, 8686, 0, 0, 60, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3886, 18576, 'Follower of Tamuze', '', 'LineageMonster3.self_blaster', 9.00, 25.80, 66, 'male', 'L2Npc', 'npc', 40, 2245, 7.500, 6099, 16.470, 40, 43, 30, 21, 20, 20, 0, 0, 936, 429, 639, 313, 253, 0, 506, 0, 0, 0, 30, 240, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3887, 18577, 'White Allosce', '', 'LineageMonster2.hundred_eye', 21.00, 55.00, 73, 'male', 'L2ReflectionBoss', 'Mystic', 40, 475290, 67.846, 7212, 18.300, 40, 43, 30, 21, 20, 20, 1169076, 202886, 4761, 804, 3251, 881, 253, 0, 506, 0, 0, 0, 30, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.54, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3888, 18578, 'Follower of Allosce', '', 'LineageMonster.monster_eye', 21.00, 43.00, 73, 'male', 'L2SpecialMonster', 'Mystic', 40, 2587, 8.500, 7212, 18.300, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 90, 90, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3889, 18579, 'Hunting Ground Keeper', '', 'LineageMonster4.employee_of_baroness', 15.00, 28.70, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 13062, 0, 0, 55, 160, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3890, 18580, 'Cursed Girl', '', 'LineageMonster4.cursed_housemaid', 8.00, 17.00, 71, 'male', 'L2Npc', 'npc', 40, 2493, 8.500, 1378, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1136, 482, 776, 352, 253, 0, 506, 0, 0, 0, 18, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3891, 18581, 'Gardener', '', 'LineageMonster4.gardener', 17.00, 26.80, 72, 'male', 'L2Npc', 'npc', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 36, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3892, 18582, 'Turned Girl', '', 'LineageMonster4.cursed_housemaid', 8.00, 17.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 18, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3893, 18583, 'Housekeeper', '', 'LineageMonster4.mad_laundry_maid', 9.00, 21.60, 74, 'male', 'L2Npc', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 33, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3894, 18584, 'Turned Boy', '', 'LineageMonster4.cursed_errand_boy', 8.00, 12.80, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 15, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3895, 18585, 'Cursed Girl', '', 'LineageMonster4.cursed_housemaid', 8.00, 17.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 18, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3896, 18586, 'Gardener', '', 'LineageMonster4.gardener', 17.00, 26.80, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 36, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3897, 18587, 'Begrudged Maid', '', 'LineageMonster4.head_parlour_maid', 25.00, 32.00, 76, 'male', 'L2Npc', 'npc', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3898, 18588, 'Hunting Ground Keeper', '', 'LineageMonster4.employee_of_baroness', 15.00, 28.70, 77, 'male', 'L2Npc', 'npc', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1421, 544, 971, 398, 253, 0, 506, 13062, 0, 0, 55, 160, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3899, 18589, 'Cursed Gardener', '', 'LineageMonster4.gardener', 17.00, 26.80, 77, 'male', 'L2SpecialMonster', 'Mystic', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1421, 544, 971, 398, 253, 0, 506, 0, 0, 0, 36, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3900, 18590, 'Baroness Employee', '', 'LineageMonster4.employee_of_baroness', 15.00, 28.70, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 13061, 0, 0, 55, 160, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3901, 18591, 'Begrudged Boy', '', 'LineageMonster4.cursed_errand_boy', 8.00, 12.80, 79, 'male', 'L2Npc', 'npc', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 0, 506, 0, 0, 0, 15, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3902, 18592, 'Krateis Steward', '', 'LineageMonster4.chief_steward', 18.00, 31.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 55, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3903, 18593, 'Housekeeper', '', 'LineageMonster4.mad_laundry_maid', 9.00, 21.60, 80, 'male', 'L2SpecialMonster', 'Mystic', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 33, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3904, 18594, 'Mansion Guide', '', 'LineageMonster4.mad_laundry_maid', 9.00, 21.60, 81, 'male', 'L2Npc', 'npc', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1720, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 33, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3905, 18595, 'Baroness Employee', '', 'LineageMonster4.employee_of_baroness', 15.00, 28.70, 82, 'male', 'L2SpecialMonster', 'Mystic', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1804, 599, 1233, 438, 253, 0, 506, 13061, 0, 0, 55, 160, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3906, 18596, 'Cursed Gardener', '', 'LineageMonster4.gardener', 17.00, 26.80, 83, 'male', 'L2SpecialMonster', 'Mystic', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 36, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3907, 18597, 'Begrudged Maid', '', 'LineageMonster4.head_parlour_maid', 25.00, 32.00, 84, 'male', 'L2SpecialMonster', 'Mystic', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3908, 18598, 'Cursed Head Maid', '', 'LineageMonster4.head_parlour_maid', 25.00, 32.00, 85, 'male', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3909, 18599, 'Mansion Manager', '', 'LineageMonster4.steward', 21.00, 25.00, 85, 'male', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 76, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3910, 18600, 'Krateis Steward', '', 'LineageMonster4.chief_steward', 18.00, 31.00, 86, 'male', 'L2Npc', 'npc', 40, 4440, 8.500, 1882, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2160, 641, 1475, 469, 253, 0, 506, 0, 0, 0, 55, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3911, 18601, 'Krateis Watcher', '', 'LineageNpcEV.trap_ironcastle_150p_a', 18.00, 32.00, 70, 'male', 'L2Npc', 'npc', 40, 1, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3912, 18602, 'Krateis Watcher', '', 'LineageNpcEV.trap_ironcastle_150p', 18.00, 32.00, 70, 'male', 'L2Npc', 'npc', 40, 1, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3913, 18603, 'wdragon_camera01', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3914, 18604, 'wdragon_camera02', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3915, 18605, 'wdragon_target01', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3916, 18606, 'wdragon_target02', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3917, 18607, 'Gargos', '', 'LineageMonster.vale_master', 12.00, 40.00, 39, 'male', 'L2Monster', 'Fighter', 40, 26166, 9.000, 388, 1.800, 40, 43, 30, 21, 20, 20, 11225, 714, 212, 170, 106, 124, 253, 0, 506, 0, 0, 0, 70, 155, 'boostup_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3918, 18608, 'Kinsus', '', 'LineageMonster4.Anthias', 20.00, 41.00, 39, 'male', 'L2Monster', 'Fighter', 40, 16291, 9.000, 388, 1.800, 40, 43, 30, 21, 20, 20, 11225, 714, 212, 170, 106, 124, 253, 0, 506, 0, 0, 0, 60, 180, 'boostup_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3919, 18609, 'Papion', '', 'LineageMonster4.Anthias', 20.00, 41.00, 36, 'male', 'L2Monster', 'Fighter', 40, 10513, 9.000, 344, 1.800, 40, 43, 30, 21, 20, 20, 10783, 652, 173, 153, 85, 111, 253, 0, 506, 0, 0, 0, 60, 180, 'boostup_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3920, 18610, 'Hillas', '', 'LineageMonster.sylph_100_bi', 20.00, 70.00, 36, 'female', 'L2Monster', 'Fighter', 40, 12143, 9.000, 344, 1.800, 40, 43, 30, 21, 20, 20, 10783, 652, 173, 153, 85, 111, 253, 0, 506, 0, 0, 0, 60, 140, 'boostup_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3921, 18611, 'Spirit of Water', '', 'LineageMonster.undine', 12.00, 27.00, 33, 'female', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 631, 22, 138, 157, 94, 116, 253, 300, 506, 0, 0, 0, 60, 100, 'boostup_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3922, 18612, 'Spirit of Water', '', 'LineageMonster.sylph', 11.00, 35.00, 36, 'female', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 726, 28, 173, 176, 118, 129, 253, 300, 506, 0, 0, 0, 60, 100, 'boostup_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3923, 18613, 'Spirit of Water', '', 'LineageMonster.sylph_110p', 12.00, 39.70, 39, 'female', 'L2Monster', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 852, 35, 212, 195, 145, 143, 253, 300, 506, 0, 0, 0, 60, 100, 'boostup_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3924, 18614, 'Spirit of Fire', '', 'LineageMonster.skeleton_knight', 10.00, 25.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 726, 28, 173, 176, 118, 129, 253, 300, 506, 150, 103, 0, 40, 160, 'boostup_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3925, 18615, 'Spirit of Fire', '', 'LineageMonster.dre_vanul', 14.00, 36.00, 39, 'male', 'L2Monster', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 852, 35, 212, 195, 145, 143, 253, 300, 506, 0, 0, 0, 80, 80, 'boostup_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3926, 18616, 'Bloom', '', 'LineageMonster.magical_weaver', 11.00, 20.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 726, 28, 173, 176, 118, 129, 253, 300, 506, 0, 0, 0, 90, 90, 'boostup_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3927, 18617, 'pa36_trap_control', '', 'LineageNPC.clear_npc', 0.10, 0.10, 36, 'male', 'L2Npc', 'npc', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 726, 28, 173, 176, 118, 129, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3928, 18618, 'trap_fishspawn1', '', 'LineageNPC.clear_npc', 0.10, 0.10, 36, 'male', 'L2Npc', 'npc', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 726, 28, 173, 176, 118, 129, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3929, 18619, 'trap_fishspawn2', '', 'LineageNPC.clear_npc', 0.10, 0.10, 36, 'male', 'L2Npc', 'npc', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 726, 28, 173, 176, 118, 129, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3930, 18620, 'Adiantum', '', 'LineageMonster.onyx_beast', 14.00, 14.50, 42, 'male', 'L2Monster', 'Fighter', 40, 27475, 9.000, 433, 1.800, 40, 43, 30, 21, 20, 20, 91640, 4070, 259, 189, 131, 139, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.24, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3931, 18621, 'adiantum_skilluse', '', 'LineageNPC.clear_npc', 0.10, 0.10, 42, 'male', 'L2Npc', 'npc', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 989, 44, 259, 216, 177, 159, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3932, 18622, 'Powder Keg', '', 'LineageNPCEV.gunpowder', 80.00, 60.00, 61, 'female', 'L2Monster', 'npc', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 2085, 174, 752, 378, 513, 278, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3933, 18623, 'Begrudged Archer', '', 'LineageMonster.skeleton_archer_20_bi', 13.00, 32.50, 61, 'male', 'L2Monster', 'Ranger', 1100, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 3210, 273, 752, 378, 513, 278, 253, 500, 506, 279, 0, 0, 40, 140, 'boostup_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3934, 18624, 'Deadmans Grudge', '', 'LineageMonster.unpleasant_humming', 12.00, 26.00, 58, 'male', 'L2Monster', 'Fighter', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 1885, 151, 651, 350, 444, 256, 253, 500, 506, 0, 0, 0, 21, 143, 'boostup_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3935, 18625, 'Deadmans Grudge', '', 'LineageMonster.skeleton_knight', 10.00, 25.00, 61, 'male', 'L2Monster', 'Fighter', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 2085, 174, 752, 378, 513, 278, 253, 500, 506, 78, 0, 0, 40, 160, 'boostup_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3936, 18626, 'Deadmans Grudge', '', 'LineageMonster.skeleton_royal_guard', 11.00, 28.50, 64, 'male', 'L2Monster', 'Fighter', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 2295, 199, 860, 409, 588, 298, 253, 500, 506, 225, 945, 0, 80, 120, 'boostup_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3937, 18627, 'Deadmans Grudge', '', 'LineageMonster.skeleton_royal_guard', 11.00, 28.50, 64, 'male', 'L2Monster', 'Fighter', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 2295, 199, 860, 409, 588, 298, 253, 500, 506, 225, 945, 0, 80, 120, 'boostup_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3938, 18628, 'Atan', '', 'LineageMonster.pirates_zombie', 10.00, 23.00, 61, 'male', 'L2Monster', 'Fighter', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 2934, 249, 752, 378, 513, 278, 253, 500, 506, 232, 0, 0, 11, 145, 'boostup_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3939, 18629, 'Kams', '', 'LineageMonster.skeleton_knight_50_bi', 15.00, 39.00, 61, 'male', 'L2Monster', 'Fighter', 40, 22093, 15.000, 1067, 2.700, 40, 43, 30, 21, 20, 20, 63183, 5562, 752, 378, 513, 278, 253, 0, 506, 150, 103, 0, 40, 160, 'boostup_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3940, 18630, 'Hikoro', '', 'LineageMonster.rakul', 30.00, 39.00, 61, 'male', 'L2Monster', 'Fighter', 40, 22093, 15.000, 1067, 2.700, 40, 43, 30, 21, 20, 20, 63183, 5562, 752, 378, 513, 278, 253, 0, 506, 3, 0, 0, 60, 150, 'boostup_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3941, 18631, 'Alkaso', '', 'LineageMonster.pirates_zombie_captain_20_bi', 20.00, 33.60, 64, 'male', 'L2Monster', 'Fighter', 40, 22861, 15.000, 1158, 2.700, 40, 43, 30, 21, 20, 20, 64881, 5952, 860, 409, 588, 298, 253, 0, 506, 232, 0, 0, 14, 155, 'boostup_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3942, 18632, 'Gerbera', '', 'LineageMonster2.imperial_warlord_zombie_20_bi', 9.00, 36.00, 64, 'male', 'L2Monster', 'Fighter', 40, 24719, 15.000, 1158, 2.700, 40, 43, 30, 21, 20, 20, 64881, 5952, 860, 409, 588, 298, 253, 0, 506, 134, 6721, 0, 39, 150, 'boostup_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3943, 18633, 'Lematan', '', 'LineageMonster4.cursed_pirate', 24.00, 37.00, 67, 'male', 'L2Monster', 'Fighter', 40, 49438, 15.000, 1251, 2.700, 40, 43, 30, 21, 20, 20, 317821, 23080, 975, 440, 666, 321, 253, 0, 506, 0, 0, 0, 26, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3944, 18634, 'Lematans Follower', '', 'LineageMonster.pirates_zombie', 10.00, 23.00, 64, 'male', 'L2Monster', 'Fighter', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 2295, 199, 860, 409, 588, 298, 253, 0, 506, 232, 0, 0, 11, 145, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3945, 18635, 'Varka Silenos Recruit', '', 'LineageMonster2.barka_silenos_hunter', 16.00, 38.00, 71, 'male', 'L2Monster', 'Fighter', 40, 7484, 17.000, 1410, 3.000, 40, 43, 30, 21, 20, 20, 31557, 2980, 586, 488, 200, 357, 253, 500, 506, 2504, 6918, 0, 44, 175, 'varka_silenos_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3946, 18636, 'Varka Silenos Footman', '', 'LineageMonster2.barka_silenos_warrior', 16.00, 41.00, 71, 'male', 'L2Monster', 'Fighter', 40, 7484, 17.000, 1410, 3.000, 40, 43, 30, 21, 20, 20, 31557, 2980, 586, 488, 200, 357, 253, 500, 506, 2504, 6918, 0, 34, 175, 'varka_silenos_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3947, 18637, 'Grazing Antelope', '', 'LineageMonster2.antelope', 17.00, 34.00, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 4087, 400, 1179, 491, 805, 359, 253, 500, 506, 0, 0, 0, 45, 185, 'varka_silenos_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3948, 18638, 'Varka Silenos Scout', '', 'LineageMonster2.barka_silenos_hunter', 16.00, 38.00, 72, 'male', 'L2Monster', 'Fighter', 80, 7578, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 3341, 338, 589, 491, 201, 359, 253, 500, 506, 2504, 6918, 0, 44, 175, 'varka_silenos_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3949, 18639, 'Varka Silenos Hunter', '', 'LineageMonster2.barka_silenos_archer', 8.00, 37.50, 72, 'male', 'L2Monster', 'Ranger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2905, 292, 1179, 491, 805, 359, 253, 500, 506, 6917, 0, 0, 30, 175, 'varka_silenos_clan', 600, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3950, 18640, 'Varka Silenos Shaman', '', 'LineageMonster2.barka_silenos_shaman', 14.00, 39.50, 72, 'male', 'L2Monster', 'Priest', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2905, 292, 1179, 491, 805, 359, 253, 500, 506, 6716, 0, 0, 36, 150, 'varka_silenos_clan', 600, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3951, 18641, 'Varka Silenos Priest', '', 'LineageMonster2.barka_silenos_priest', 9.00, 41.50, 72, 'male', 'L2Monster', 'Priest', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 4802, 513, 1179, 491, 805, 359, 253, 500, 506, 6716, 0, 0, 36, 180, 'varka_silenos_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3952, 18642, 'Varka Silenos Warrior', '', 'LineageMonster2.barka_silenos_warrior', 16.00, 41.00, 72, 'male', 'L2Monster', 'Fighter', 40, 7578, 17.000, 1475, 3.000, 40, 43, 30, 21, 20, 20, 3801, 402, 623, 507, 213, 370, 253, 500, 506, 142, 6918, 0, 34, 175, 'varka_silenos_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3953, 18643, 'Grazing Antelope', '', 'LineageMonster2.antelope', 17.00, 34.00, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 4201, 434, 1220, 502, 833, 368, 253, 500, 506, 0, 0, 0, 45, 185, 'varka_silenos_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3954, 18644, 'Varka Silenos Medium', '', 'LineageMonster2.barka_silenos_shaman', 14.00, 39.50, 72, 'male', 'L2Monster', 'Priest', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2905, 316, 1179, 491, 805, 359, 253, 500, 506, 6716, 0, 0, 36, 150, 'varka_silenos_clan', 600, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3955, 18645, 'Varka Silenos Magus', '', 'LineageMonster2.barka_silenos_mage_20_bi', 11.00, 55.20, 73, 'male', 'L2Monster', 'Mystic', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 3255, 360, 1220, 502, 833, 368, 253, 500, 506, 6716, 6918, 0, 36, 175, 'varka_silenos_clan', 600, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3956, 18646, 'Varka Silenos Officer', '', 'LineageMonster2.barka_silenos_chieftain', 18.00, 42.50, 73, 'male', 'L2Monster', 'Fighter', 40, 6661, 17.000, 1541, 3.000, 40, 43, 30, 21, 20, 20, 37623, 3932, 667, 525, 228, 384, 253, 500, 506, 2504, 6918, 0, 25, 175, 'varka_silenos_clan', 600, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3957, 18647, 'Grazing Flava', '', 'LineageMonster2.flava', 18.00, 34.00, 74, 'male', 'L2Monster', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 4133, 449, 1262, 513, 861, 375, 253, 500, 506, 0, 0, 0, 30, 165, 'varka_silenos_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3958, 18648, 'Varka Silenos Seer', '', 'LineageMonster2.barka_silenos_shaman', 14.00, 39.50, 73, 'male', 'L2Monster', 'Priest', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 2807, 308, 1220, 502, 833, 368, 253, 500, 506, 6716, 0, 0, 36, 150, 'varka_silenos_clan', 600, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3959, 18649, 'Varka Silenos Great Magus', '', 'LineageMonster2.barka_silenos_warrior_20_bi', 20.00, 49.20, 73, 'male', 'L2Monster', 'Mystic', 40, 9374, 17.000, 1574, 3.000, 40, 43, 30, 21, 20, 20, 37090, 4028, 710, 531, 237, 389, 253, 500, 506, 2500, 6918, 0, 34, 175, 'varka_silenos_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3960, 18650, 'Varka Silenos General', '', 'LineageMonster2.barka_silenos_chieftain', 18.00, 42.50, 73, 'male', 'L2Monster', 'Fighter', 40, 9374, 17.000, 1574, 3.000, 40, 43, 30, 21, 20, 20, 37090, 4028, 710, 531, 237, 389, 253, 500, 506, 2500, 6918, 0, 25, 175, 'varka_silenos_clan', 600, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3961, 18651, 'Grazing Elder Antelope', '', 'LineageMonster2.antelope', 17.00, 34.00, 74, 'male', 'L2Monster', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 4133, 467, 1262, 513, 861, 375, 253, 500, 506, 0, 0, 0, 45, 185, 'varka_silenos_clan', 600, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3962, 18652, 'Varka Silenos Great Seer', '', 'LineageMonster2.barka_silenos_shaman', 14.00, 39.50, 74, 'male', 'L2Monster', 'Priest', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 2885, 333, 1262, 513, 861, 375, 253, 500, 506, 6716, 0, 0, 36, 150, 'varka_silenos_clan', 600, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3963, 18653, 'Varkas Elite Guard', '', 'LineageMonster2.barka_silenos_warrior', 16.00, 41.00, 74, 'male', 'L2Monster', 'Fighter', 40, 6704, 17.000, 1475, 3.000, 40, 43, 30, 21, 20, 20, 39208, 3836, 631, 513, 861, 375, 253, 500, 506, 2504, 6918, 0, 34, 175, 'varka_silenos_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3964, 18654, 'Varkas Commander', '', 'LineageMonster2.barka_silenos_chieftain_20_bi', 22.00, 51.00, 72, 'male', 'L2Monster', 'Fighter', 40, 6657, 17.000, 1508, 3.000, 40, 43, 30, 21, 20, 20, 36599, 3398, 639, 514, 874, 377, 253, 500, 506, 2500, 6918, 0, 25, 175, 'varka_silenos_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3965, 18655, 'Varkas Head Guard', '', 'LineageMonster2.barka_silenos_warrior', 16.00, 41.00, 74, 'male', 'L2Monster', 'Fighter', 40, 8619, 17.000, 1574, 3.000, 40, 43, 30, 21, 20, 20, 38113, 4028, 698, 535, 238, 391, 253, 500, 506, 142, 6918, 0, 34, 175, 'varka_silenos_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3966, 18656, 'Varkas Head Magus', '', 'LineageMonster2.barka_silenos_shaman', 14.00, 39.50, 74, 'male', 'L2Monster', 'Mystic', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 2885, 333, 1262, 513, 861, 375, 253, 500, 506, 6716, 0, 0, 36, 150, 'varka_silenos_clan', 600, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3967, 18657, 'Prophet Guard', '', 'LineageMonster2.barka_silenos_warrior', 16.00, 41.00, 74, 'male', 'L2Monster', 'Priest', 40, 8619, 17.000, 1607, 3.000, 40, 43, 30, 21, 20, 20, 37565, 4122, 725, 543, 248, 396, 253, 500, 506, 2504, 6918, 0, 34, 175, 'varka_silenos_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3968, 18658, 'Disciple of Prophet', '', 'LineageMonster2.barka_silenos_priest', 9.00, 41.50, 74, 'male', 'L2Monster', 'Priest', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 2885, 333, 1262, 513, 861, 375, 253, 500, 506, 6716, 0, 0, 36, 180, 'varka_silenos_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3969, 18659, 'Varkas Prophet', '', 'LineageMonster2.barka_silenos_shaman_20_bi', 17.00, 47.50, 74, 'male', 'L2Monster', 'Priest', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 2885, 346, 1262, 513, 861, 375, 253, 500, 506, 6716, 0, 0, 36, 150, 'varka_silenos_clan', 600, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3970, 18660, 'Latana', '', 'LineageMonster4.wounded_dragon', 60.00, 60.00, 75, 'female', 'L2Monster', 'PaganGuard', 40, 60326, 17.000, 1251, 2.700, 40, 43, 30, 21, 20, 20, 453825, 4067, 7820, 523, 891, 384, 253, 500, 506, 0, 0, 0, 1, 80, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3971, 18661, 'ratana_skilluse', '', 'LineageNPC.clear_npc', 0.10, 0.10, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 8087, 614, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3972, 18662, 'pa73_guard_control', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 7661, 300, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3973, 18663, 'pa73_teleport_trap', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3974, 18664, 'LuckyPig', '', 'LineageNPC2.br_LuckyPig', 16.00, 22.50, 52, 'male', 'L2Npc', 'Luckpy', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 475, 296, 324, 216, 253, 0, 506, 0, 0, 0, 45, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3975, 18665, 'LuckyPig', '', 'LineageNPC2.br_LuckyPig', 16.00, 22.50, 70, 'male', 'L2Npc', 'Luckpy', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 45, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3976, 18666, 'LuckyPig', '', 'LineageNPC2.br_LuckyPig', 16.00, 22.50, 75, 'male', 'L2Npc', 'Luckpy', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 45, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3977, 18667, 'Ward of Death', '', 'LineageNpcEV.trap_immortality', 24.00, 48.50, 83, 'female', 'L2Npc', 'npc', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 1, 1, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3978, 18668, 'Ward of Death', '', 'LineageNpcEV.trap_immortality', 24.00, 48.50, 83, 'female', 'L2Npc', 'npc', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 1, 1, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3979, 18669, 'lindvior_camera_01', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3980, 18670, 'lindvior_camera_02', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3981, 18671, 'Block', '', 'LineageNPC2.block', 16.00, 17.00, 1, 'female', 'L2Block', 'L2Block', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3982, 18672, 'Block', '', 'LineageNPC2.block', 16.00, 17.00, 1, 'female', 'L2Block', 'L2Block', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3983, 18673, 'Block', '', 'LineageNPC2.block', 16.00, 17.00, 1, 'female', 'L2Block', 'L2Block', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3984, 18674, 'Block', '', 'LineageNPC2.block', 16.00, 17.00, 1, 'female', 'L2Block', 'L2Block', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3985, 18675, 'Block', '', 'LineageNPC2.block', 16.00, 17.00, 1, 'female', 'L2Block', 'L2Block', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3986, 18676, 'Block-Carrying GIrl', '', 'LineageNPC2.block_mother', 12.00, 31.00, 73, 'female', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 120, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3987, 18677, 'Dragon Steed Troop Messenger', '', 'LineageMonster4.dragon_peltast', 25.00, 46.50, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 89, 220, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3988, 18678, 'Energy Seed - Water', '', 'LineageNPC.seed_click_dummy_water', 10.00, 10.00, 1, 'male', 'L2EnergySeed', 'npc', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3989, 18679, 'Energy Seed - Fire', '', 'LineageNPC.seed_click_dummy_fire', 10.00, 10.00, 1, 'male', 'L2EnergySeed', 'npc', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3990, 18680, 'Energy Seed - Wind', '', 'LineageNPC.seed_click_dummy_wind', 10.00, 10.00, 2, 'male', 'L2EnergySeed', 'npc', 40, 48, 2.000, 47, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 8, 42, 5, 31, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3991, 18681, 'Energy Seed - Earth', '', 'LineageNPC.seed_click_dummy_earth', 10.00, 10.00, 2, 'male', 'L2EnergySeed', 'npc', 40, 48, 2.000, 47, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 8, 42, 5, 31, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3992, 18682, 'Energy Seed - Divinity', '', 'LineageNPC.seed_click_dummy_holy', 10.00, 10.00, 3, 'male', 'L2EnergySeed', 'npc', 40, 58, 2.000, 55, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 9, 44, 6, 32, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3993, 18683, 'Energy Seed - Darkness', '', 'LineageNPC.seed_click_dummy_dark', 10.00, 10.00, 3, 'male', 'L2EnergySeed', 'npc', 40, 58, 2.000, 55, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 9, 44, 6, 32, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3994, 18684, 'Red Star Stone', '', 'LineageNpcEV.star_stone_a', 54.00, 61.00, 1, 'female', 'L2StarStone', 'npc', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3995, 18685, 'Red Star Stone', '', 'LineageNpcEV.star_stone_b', 38.00, 43.50, 1, 'female', 'L2StarStone', 'npc', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3996, 18686, 'Red Star Stone', '', 'LineageNpcEV.star_stone_c', 38.00, 30.50, 1, 'female', 'L2StarStone', 'npc', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3997, 18687, 'Blue Star Stone', '', 'LineageNpcEV.star_stone_a', 54.00, 61.00, 1, 'female', 'L2StarStone', 'npc', 40, 48, 2.000, 47, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 8, 41, 5, 31, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3998, 18688, 'Blue Star Stone', '', 'LineageNpcEV.star_stone_b', 38.00, 43.50, 1, 'female', 'L2StarStone', 'npc', 40, 48, 2.000, 47, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 8, 41, 5, 31, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3999, 18689, 'Blue Star Stone', '', 'LineageNpcEV.star_stone_c', 38.00, 30.50, 1, 'female', 'L2StarStone', 'npc', 40, 48, 2.000, 47, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 8, 41, 5, 31, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4000, 18690, 'Green Star Stone', '', 'LineageNpcEV.star_stone_a', 54.00, 61.00, 1, 'female', 'L2StarStone', 'npc', 40, 58, 2.000, 55, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 9, 43, 6, 32, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4001, 18691, 'Green Star Stone', '', 'LineageNpcEV.star_stone_b', 38.00, 43.50, 1, 'female', 'L2StarStone', 'npc', 40, 58, 2.000, 55, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 9, 43, 6, 32, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4002, 18692, 'Green Star Stone', '', 'LineageNpcEV.star_stone_c', 38.00, 30.50, 1, 'female', 'L2StarStone', 'npc', 40, 58, 2.000, 55, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 9, 43, 6, 32, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4003, 18693, 'Treasure Box of the Ancient Giants', '', 'LineageMonster.mimic', 8.50, 8.50, 76, 'male', 'L2Npc', 'npc', 40, 1, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 1, 'ancients_treasure_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4004, 18694, 'Treasure Box Guard', '', 'LineageMonster2.magmagoil_lad_20_sm', 12.00, 60.00, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, 'ancients_treasure_clan', 600, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4005, 18695, 'Treasure Box Guard', '', 'LineageMonster2.magmagoil_20_sm', 12.00, 60.00, 78, 'male', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 1, 1, 'ancients_treasure_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4006, 18696, 'Dimension Moving Device', '', 'LineageNpcEV.teleport_gate_of_legion', 44.50, 7.00, 80, 'female', 'ImmuneMonster', 'DimensionMovingDevice', 40, 13505, 95.726, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 3285, 1455, 461, 253, 0, 506, 0, 0, 0, 1, 1, 'des_dragon', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4007, 18697, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4008, 18698, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4009, 18699, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4010, 18700, 'spawn_trap1_destruction', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4011, 18701, 'spawn_trap2_destruction', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4012, 18702, 'Dimension Moving Device', '', 'LineageNpcEV.teleport_gate_of_legion', 44.50, 7.00, 80, 'female', 'L2Npc', 'npc', 40, 113229, 195.709, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15830, 1007, 11130, 1105, 253, 0, 506, 0, 0, 0, 1, 1, 'des_dragon', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4013, 18703, 'Defeated Troops Controller', '', 'LineageNpcEV.crystal_of_secret_door', 57.00, 74.00, 80, 'female', 'L2Npc', 'npc', 40, 113229, 195.709, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15830, 1007, 11130, 1105, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4014, 18704, 'Tumor of Death', '', 'LineageNpcEV.tumor_immortality', 42.00, 55.00, 79, 'female', 'L2Monster', 'npc', 40, 340290, 197.223, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12635, 922, 8679, 1013, 253, 0, 506, 0, 0, 0, 1, 1, 'aceed_clan', 300, 0, 0, 0, 0, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4015, 18705, 'Destroyed Tumor', '', 'LineageNpcEV.tumor_immortality_a', 0.01, 55.00, 79, 'female', 'DestroyedTumor', 'npc', 40, 340290, 197.223, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12635, 922, 8679, 1013, 253, 0, 506, 0, 0, 0, 1, 1, 'aceed_clan', 300, 0, 0, 0, 0, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4016, 18706, 'Soul Coffin', '', 'LineageNpcEV.vein_immortality', 30.50, 6.00, 79, 'female', 'L2Npc', 'npc', 40, 33155, 115.296, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9712, 922, 6671, 1013, 253, 0, 506, 0, 0, 0, 1, 1, 'aceed_clan', 300, 0, 0, 0, 0, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4017, 18707, 'spc_dispatcher', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4018, 18708, 'Tumor of Death', '', 'LineageNpcEV.tumor_immortality', 42.00, 55.00, 81, 'female', 'L2Monster', 'npc', 40, 112922, 194.030, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15830, 1006, 11064, 1105, 253, 0, 506, 0, 0, 0, 1, 1, 'aceed_clan', 300, 0, 0, 0, 0, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4019, 18709, 'Soul Coffin', '', 'LineageNpcEV.vein_immortality_080p', 25.00, 6.00, 80, 'female', 'L2Npc', 'npc', 40, 33093, 114.400, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9712, 923, 6632, 1014, 253, 0, 506, 0, 0, 0, 1, 1, 'aceed_clan', 300, 0, 0, 0, 0, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4020, 18710, 'Soul Coffin', '', 'LineageNpcEV.vein_immortality', 30.50, 6.00, 81, 'female', 'L2Npc', 'npc', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9906, 957, 6805, 1051, 253, 0, 506, 0, 0, 0, 1, 1, 'aceed_clan', 300, 0, 0, 0, 0, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4021, 18711, 'Soul Coffin', '', 'LineageNpcEV.vein_immortality_120p', 36.50, 8.50, 81, 'female', 'L2Npc', 'npc', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 10193, 1006, 7125, 1105, 253, 0, 506, 0, 0, 0, 1, 1, 'aceed_clan', 300, 0, 0, 0, 0, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4022, 18712, 'Soul Coffin', '', 'LineageNpcEV.vein_immortality_080p', 25.00, 6.00, 81, 'female', 'L2Npc', 'npc', 40, 65918, 113.265, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9785, 1006, 6839, 1105, 253, 0, 506, 0, 0, 0, 1, 1, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4023, 18713, 'Soul Coffin', '', 'LineageNpcEV.vein_immortality', 30.50, 6.00, 81, 'female', 'L2Npc', 'npc', 40, 65918, 113.265, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9785, 1006, 6839, 1105, 253, 0, 506, 0, 0, 0, 1, 1, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4024, 18714, 'Soul Coffin', '', 'LineageNpcEV.vein_immortality_120p', 36.50, 8.50, 81, 'female', 'L2Npc', 'npc', 40, 65918, 113.265, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9785, 1006, 6839, 1105, 253, 0, 506, 0, 0, 0, 1, 1, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4025, 18715, 'Conquered Soul', '', 'LineageMonster4.death_knight_n_104p', 22.88, 41.60, 81, 'male', 'L2Npc', 'npc', 80, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1307, 445, 253, 0, 506, 13983, 0, 0, 43, 180, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4026, 18716, 'Conquered Soul', '', 'LineageMonster4.Death_slayer_080p', 16.00, 27.20, 81, 'male', 'L2Npc', 'npc', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1307, 445, 253, 0, 506, 13985, 0, 0, 64, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4027, 18717, 'Conquered Soul', '', 'LineageMonster4.lich_b_088p', 21.12, 40.48, 81, 'male', 'L2Npc', 'npc', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1307, 445, 253, 0, 506, 0, 0, 0, 46, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4028, 18718, 'Sacrificed Fanatic', '', 'LineageMonster4.ravager_silen_dead', 27.00, 48.50, 81, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1358, 546, 933, 400, 253, 0, 506, 13987, 0, 0, 1, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4029, 18719, 'Sacrificed Fanatic', '', 'LineageMonster4.disciple_silen_dead', 19.00, 44.00, 81, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1358, 546, 933, 400, 253, 0, 506, 0, 0, 0, 1, 170, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4030, 18720, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4031, 18721, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4032, 18722, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4033, 18723, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4034, 18724, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4035, 18725, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4036, 18726, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4037, 18727, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4038, 18728, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4039, 18729, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4040, 18730, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4041, 18731, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4042, 18732, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4043, 18733, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4044, 18734, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4045, 18735, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4046, 18736, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4047, 18737, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4048, 18738, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4049, 18739, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4050, 18740, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4051, 18741, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4052, 18742, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4053, 18743, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4054, 18744, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4055, 18745, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4056, 18746, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4057, 18747, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4058, 18748, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4059, 18749, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4060, 18750, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4061, 18751, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4062, 18752, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4063, 18753, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4064, 18754, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4065, 18755, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4066, 18756, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4067, 18757, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4068, 18758, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4069, 18759, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4070, 18760, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4071, 18761, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4072, 18762, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4073, 18763, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4074, 18764, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4075, 18765, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4076, 18766, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4077, 18767, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4078, 18768, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4079, 18769, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4080, 18770, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4081, 18771, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4082, 18772, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4083, 18773, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4084, 18774, 'Trap', '', 'LineageNpc2.trap_mark', 5.00, 10.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4085, 18775, 'Seed of Destruction Control Device', '', 'LineageNpcEV.crystal_of_secret_door', 57.00, 74.00, 81, 'female', 'L2Npc', 'npc', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 147312, 11412, 9906, 957, 6805, 1051, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4086, 18776, 'Obelisk', '', 'LineageNpcEV.obelisk_of_middle_square', 229.00, 177.50, 81, 'female', 'Obelisk', 'Obelisk', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9906, 957, 6805, 1051, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4087, 18777, 'Great Powerful Device', '', 'LineageNpcEV.crystal_of_secret_door', 57.00, 74.00, 81, 'female', 'ImmuneMonster', 'GreatPowerfulDevice', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9906, 957, 6805, 1051, 253, 0, 506, 0, 0, 0, 1, 1, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4088, 18778, 'Throne of Destruction Powerful Device', '', 'LineageNpcEV.protector_of_seed', 57.00, 74.00, 81, 'female', 'ImmuneMonster', 'ThroneofDestruction', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9906, 957, 6805, 1051, 253, 0, 506, 0, 0, 0, 1, 1, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4089, 18779, '9C', '', 'LineageNPC.clear_npc', 0.10, 0.10, 82, 'male', 'L2Npc', 'npc', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4090, 18780, 'Symbol of Cohemenes', '', 'LineageNpcEV.trap_immortality', 24.00, 48.50, 83, 'female', 'L2Monster', 'npc', 40, 65569, 111.355, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9615, 974, 6565, 1068, 253, 0, 506, 0, 0, 0, 1, 1, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4091, 18781, 'Young Drake Wing', '', 'LineageMonster4.m_drake_wing_knave', 153.00, 63.00, 83, 'male', 'L2Npc', 'npc', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 60, 150, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4092, 18782, 'Zealot of Shilen', '', 'LineageMonster4.disciple_silen', 19.00, 44.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 73, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4093, 18783, 'Defeated Troops Commander', '', 'LineageMonster4.Dragon_centurion_135p', 28.00, 46.50, 81, 'male', 'L2Npc', 'npc', 40, 112922, 194.030, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15589, 974, 10770, 1069, 253, 0, 506, 13978, 0, 0, 55, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4094, 18784, 'Defeated Troops No 1 Battalion Commander', '', 'LineageMonster4.Dragon_centurion_135p', 28.00, 46.50, 81, 'male', 'L2Npc', 'npc', 40, 112922, 194.030, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15467, 957, 10623, 1051, 253, 0, 506, 13978, 0, 0, 55, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4095, 18785, 'Defeated Troops White Dragon Leader', '', 'LineageMonster4.Dragon_centurion_120p', 22.00, 42.00, 81, 'male', 'L2Npc', 'npc', 40, 112922, 194.030, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15343, 940, 10477, 1032, 253, 0, 506, 13979, 13980, 0, 56, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4096, 18786, 'Defeated Troops Infantry', '', 'LineageMonster4.Dragon_centurion_120p', 22.00, 42.00, 80, 'male', 'L2Npc', 'npc', 40, 113229, 195.709, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15218, 923, 10394, 1014, 253, 0, 506, 13979, 13980, 0, 56, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4097, 18787, 'Defeated Troops Magic Leader', '', 'LineageMonster4.dragon_mage_075p', 28.00, 39.50, 81, 'male', 'L2Npc', 'npc', 40, 56506, 194.184, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15846, 957, 10883, 1051, 253, 0, 506, 0, 0, 0, 92, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4098, 18788, 'Defeated Troops Magician', '', 'LineageMonster4.dragon_mage_075p', 28.00, 39.50, 81, 'male', 'L2Npc', 'npc', 40, 56506, 194.184, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15713, 940, 10729, 1032, 253, 0, 506, 0, 0, 0, 92, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4099, 18789, 'Defeated Troops Magic Soldier', '', 'LineageMonster4.dragon_mage_065p', 25.00, 34.50, 80, 'male', 'L2Npc', 'npc', 40, 33093, 114.400, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9712, 923, 6632, 1014, 253, 0, 506, 13981, 0, 0, 82, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4100, 18790, 'Defeated Troops Healer', '', 'LineageMonster4.dragon_mage_065p', 25.00, 34.50, 79, 'male', 'L2Npc', 'npc', 40, 33155, 115.296, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9541, 906, 6515, 995, 253, 0, 506, 13981, 0, 0, 82, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4101, 18791, 'Defeated Troops Javelin Thrower', '', 'LineageMonster4.dragon_peltast', 25.00, 46.50, 80, 'male', 'L2Npc', 'npc', 1100, 56659, 195.864, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15578, 923, 10639, 1014, 253, 0, 506, 13843, 0, 0, 89, 220, 'des_dragon', 1000, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4102, 18792, 'Defeated Troops Javelin Thrower', '', 'LineageMonster4.dragon_peltast', 25.00, 46.50, 80, 'male', 'L2Npc', 'npc', 1100, 56659, 195.864, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15578, 923, 10639, 1014, 253, 0, 506, 13843, 0, 0, 89, 220, 'des_dragon', 1000, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4103, 18793, 'Bizarre Cocoon', '', 'LineageNpcEV.n_event_stakato_egg_a', 24.00, 27.00, 84, 'male', 'L2SpecialMonster', 'BizarreCocoon', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4104, 18794, 'Bizarre Cocoon', '', 'LineageNpcEV.n_event_stakato_egg_b', 35.00, 27.00, 84, 'male', 'L2SpecialMonster', 'BizarreCocoon', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4105, 18795, 'Bizarre Cocoon', '', 'LineageNpcEV.n_event_stakato_egg_c', 48.00, 27.00, 84, 'male', 'L2SpecialMonster', 'BizarreCocoon', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4106, 18796, 'Bizarre Cocoon', '', 'LineageNpcEV.n_event_stakato_egg_d', 24.00, 27.00, 84, 'male', 'L2SpecialMonster', 'BizarreCocoon', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4107, 18797, 'Bizarre Cocoon', '', 'LineageNpcEV.n_event_stakato_egg_e', 35.00, 27.00, 84, 'male', 'L2SpecialMonster', 'BizarreCocoon', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4108, 18798, 'Bizarre Cocoon', '', 'LineageNpcEV.n_event_stakato_egg_f', 48.00, 27.00, 84, 'male', 'L2SpecialMonster', 'BizarreCocoon', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4109, 18799, 'Newborn Lavasaurus', '', 'magmagoil_20_sm', 12.00, 60.00, 77, 'male', 'L2Monster', 'PaganGuard', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 49441, 5079, 1421, 544, 971, 398, 253, 500, 506, 0, 0, 0, 1, 1, 'fire_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4110, 18800, 'Fledgling Lavasaurus', '', 'magmagoil', 15.00, 75.00, 77, 'male', 'L2Monster', 'PaganGuard', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 49441, 5079, 1421, 544, 971, 398, 253, 500, 506, 0, 0, 0, 1, 1, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4111, 18801, 'Adult Lavasaurus', '', 'magmagoil_lad_20_sm', 12.00, 60.00, 77, 'male', 'L2Monster', 'PaganGuard', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 49441, 5079, 1421, 544, 971, 398, 253, 500, 506, 0, 0, 0, 1, 1, 'fire_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4112, 18802, 'Elderly Lavasaurus', '', 'magmagoil_lad', 15.00, 75.00, 78, 'male', 'L2Monster', 'PaganGuard', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 50733, 5271, 1488, 556, 1015, 406, 253, 500, 506, 0, 0, 0, 1, 1, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4113, 18803, 'Ancient Lavasaurus', '', 'magmagoil_lad', 15.00, 75.00, 78, 'male', 'L2Monster', 'PaganGuard', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 50733, 5271, 1488, 556, 1015, 406, 253, 500, 506, 0, 0, 0, 1, 1, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4114, 18804, 'Tar Beetle', '', 'LineageMonster2.scarab_20_sm_e', 18.00, 26.00, 78, 'male', 'L2TerrainObject', 'TarBeetle', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 45, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4115, 18805, 'Waste Landfill Machine', '', 'Epilogue', 19.00, 28.00, 83, 'female', 'L2Monster', 'FieldMachine', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4116, 18806, 'Brazier of Purity', '', 'Epilogue', 16.00, 31.00, 83, 'male', 'L2Monster', 'FieldMachine', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4117, 18807, 'Frightened Ragna Orc', '', 'Epilogue', 9.00, 21.50, 81, 'male', 'L2Monster', 'FrightenedRagnaOrc', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 2639, 292, 1720, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 80, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4118, 18808, 'Dark Shaman Varangka', '', 'ketra_orc_chieftain_20_bi', 17.00, 46.20, 82, 'male', 'L2RaidBoss', 'Fighter', 40, 21860, 41.207, 17430, 50.000, 40, 43, 30, 21, 20, 20, 142334, 15560, 841, 599, 1233, 438, 253, 0, 506, 6719, 0, 0, 24, 175, 'baranka_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.51, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (4119, 18809, 'Varangkas Retainer', '', 'Epilogue', 12.00, 28.00, 82, 'male', 'L2Minion', 'Fighter', 40, 1822, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 16412, 1794, 841, 599, 1233, 438, 253, 0, 506, 6365, 0, 0, 80, 140, 'baranka_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4120, 18810, 'Varangkas Page', '', 'Epilogue', 13.00, 20.80, 82, 'male', 'L2Minion', 'Fighter', 40, 1822, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 17412, 1904, 841, 599, 1233, 438, 253, 0, 506, 8680, 0, 0, 50, 120, 'baranka_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4121, 18811, 'Guardian of the Altar', '', 'LineageMonster2.parasitic_eye_050p_e', 17.00, 29.00, 82, 'male', 'L2Npc', 'npc', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1804, 599, 1233, 438, 253, 500, 506, 0, 0, 0, 30, 160, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4122, 18812, 'Kashas Eye', '', 'Epilogue', 17.00, 29.00, 81, 'male', 'L2Monster', 'KashasEye', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1720, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 30, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4123, 18813, 'Kashas Eye', '', 'Epilogue', 17.00, 29.00, 81, 'male', 'L2Monster', 'KashasEye', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1720, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 30, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4124, 18814, 'Kashas Eye', '', 'Epilogue', 17.00, 29.00, 81, 'male', 'L2Monster', 'KashasEye', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1720, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 30, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4125, 18815, 'Guard of the Grave', '', NULL, 12.00, 60.00, 83, 'male', 'L2Npc', 'npc', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 1, 1, 'legendorc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4126, 18816, 'Chieftains Treasure Chest', '', NULL, 8.50, 8.50, 81, 'male', 'L2Npc', 'npc', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1720, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4127, 18817, 'Invader Martyr of Nightmare', '', NULL, 20.00, 42.00, 81, 'male', 'L2Npc', 'npc', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1720, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 80, 160, 'fantasy_clan', 300, 0, 0, 0, 7, 10, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4128, 18818, 'Nihil Invader Martyr', '', NULL, 20.00, 32.50, 81, 'male', 'L2Npc', 'npc', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1720, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 45, 180, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4129, 18819, 'Nihil Invader Treasure Chest', '', NULL, 11.00, 8.00, 82, 'female', 'L2Npc', 'npc', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4130, 18820, 'Nihil Invader Treasure Chest', '', NULL, 11.00, 8.00, 82, 'female', 'L2Monster', 'InvaderBox', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4131, 18821, 'Mutant Martyr', '', NULL, 28.00, 50.00, 84, 'male', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 50, 165, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4132, 18822, 'Mutant Treasure Chest', '', NULL, 11.00, 8.00, 84, 'female', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4133, 18823, 'Mutant Treasure Chest', '', NULL, 11.00, 8.00, 84, 'female', 'L2Monster', 'InvaderBox', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4134, 18824, 'Merchant of Mammon A', '', NULL, 8.00, 17.00, 1, 'male', 'L2Npc', 'npc', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4135, 18825, 'Merchant of Mammon B', '', NULL, 8.00, 19.00, 1, 'male', 'L2Npc', 'npc', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4136, 18826, 'Shilens Evil Thoughts For Presentation', '', NULL, 14.00, 27.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 30, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4137, 18827, 'Priest Cain for Presentation', '', NULL, 8.00, 23.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4138, 18828, 'High Priest of Dawn', '', NULL, 10.00, 22.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4139, 18829, 'Shilens Evil Thoughts Leader For Presentation', '', NULL, 20.00, 40.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 45, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4140, 18830, 'ssq For Presentation Camera Dummy 1', '', NULL, 11.00, 25.00, 1, 'male', 'L2Npc', 'npc', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4141, 18831, 'ssq For Presentation Camera Dummy 2', '', NULL, 11.00, 25.00, 1, 'male', 'L2Npc', 'npc', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4142, 18832, 'ssq For Presentation Camera Dummy 3', '', NULL, 11.00, 25.00, 1, 'male', 'L2Npc', 'npc', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4143, 18833, 'Emperors Seal Device', '', NULL, 21.00, 24.00, 1, 'female', 'L2Npc', 'npc', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4144, 18834, 'Guards of the Dawn', '', 'LineageNPC.a_fighterguild_master_Mhuman', 8.00, 23.50, 85, 'male', 'L2Npc', 'GuardOfTheDawn', 80, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 16, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4145, 18835, 'Guards of the Dawn', '', 'LineageNPC.a_mageguild_master_MHuman', 8.00, 24.00, 85, 'male', 'L2Npc', 'GuardOfTheDawn', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 5, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4146, 18836, 'Varangkas Guardian', '', NULL, 14.00, 39.50, 82, 'male', 'L2Minion', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 16412, 1794, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 35, 185, 'baranka_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4147, 18837, 'legend_orc_buff', '', NULL, 0.10, 0.10, 1, 'male', 'L2Npc', 'npc', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4148, 18838, 'Treasure Chest of Invader Soldier of Nightmar', '', NULL, 11.00, 8.00, 84, 'female', 'L2Monster', 'InvaderBox', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4149, 18839, 'Wild Maguen', '', 'beast', 11.00, 13.25, 85, 'male', 'L2Monster', 'Fighter', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 300, 506, 0, 0, 0, 15, 120, '', 300, 0, 0, 0, 1, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4150, 18840, 'fc_id5_manger1', '', 'construct', 0.10, 0.10, 85, 'male', 'L2Monster', 'Fighter', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4151, 18841, 'fc_id5_manger2', '', 'construct', 0.10, 0.10, 85, 'male', 'L2Monster', 'Fighter', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4152, 18842, 'fc_id5_manger3', '', 'construct', 0.10, 0.10, 85, 'male', 'L2Monster', 'Fighter', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4153, 18843, 'Cokrakons Ward', '', 'construct', 30.00, 54.00, 85, 'male', 'L2Monster', 'Fighter', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4154, 18844, 'Reptilikons Ward', '', 'construct', 30.00, 54.00, 85, 'male', 'L2Monster', 'Fighter', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4155, 18845, 'Torumbas Telegraph', '', 'construct', 0.10, 0.10, 85, 'male', 'L2Monster', 'Fighter', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4156, 18846, 'Kegor', '', 'human', 15.00, 27.50, 85, 'male', 'L2Jinia', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 300, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4157, 18847, 'Freya', '', 'humanoid', 50.00, 98.50, 85, 'female', 'L2Monster', 'FreyaDefault', 40, 2388700, 918.196, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 300, 506, 0, 0, 0, 45, 150, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4158, 18848, 'Battalion Leader', '', 'human', 10.00, 23.75, 85, 'female', 'L2Monster', 'JiniaGuard', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 300, 506, 80, 641, 0, 30, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4159, 18849, 'Legionnaire', '', 'orc', 14.50, 30.00, 85, 'male', 'L2Monster', 'JiniaGuard', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 300, 506, 9813, 9813, 0, 40, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4160, 18850, 'Jinia ', '', 'human', 11.00, 23.50, 85, 'female', 'L2Monster', 'KegorJinia', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 300, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4161, 18851, 'Kegor', '', 'human', 15.00, 27.50, 85, 'male', 'L2Monster', 'KegorJinia', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 300, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4162, 18852, 'Sirra ', '', 'human', 10.00, 22.00, 85, 'female', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 300, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4163, 18853, 'Glacier', '', 'construct', 26.00, 27.00, 85, 'male', 'L2Monster', 'Fighter', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4164, 18854, 'Archers Breath', '', 'elemental', 20.00, 50.00, 85, 'male', 'L2Monster', 'FreyaGuard', 40, 57746, 109.443, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 10193, 1007, 6960, 1105, 253, 300, 506, 0, 0, 0, 30, 80, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4165, 18855, 'Archery Knight', '', 'humanoid', 15.00, 31.00, 85, 'male', 'L2Monster', 'FreyaGuard', 40, 32596, 109.443, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 10193, 1007, 6960, 1105, 253, 300, 506, 0, 0, 0, 20, 150, 'freya_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4166, 18856, 'Archery Knight', '', 'humanoid', 15.00, 31.00, 85, 'male', 'L2Monster', 'FreyaGuard', 40, 800666, 109.443, 18468, 300.000, 40, 43, 30, 21, 20, 20, 0, 0, 28031, 1007, 6960, 1105, 253, 300, 506, 0, 0, 0, 20, 150, 'freya_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4167, 18857, 'ice_target_dummy_1', '', 'construct', 0.10, 0.10, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4168, 18858, 'ice_target_dummy_2', '', 'construct', 0.10, 0.10, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4169, 18859, 'ice_target_dummy_3', '', 'construct', 0.10, 0.10, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4170, 18860, 'ice_target_dummy_4', '', 'construct', 0.10, 0.10, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4171, 18861, 'ice_target_dummy_5', '', 'construct', 0.10, 0.10, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4172, 18862, 'Tanta Lizardman Guard', '', 'LineageMonster.zenta_lizardman_warrior', 13.00, 35.00, 82, 'male', 'L2Monster', 'Fighter', 80, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 19616, 2145, 1804, 599, 1233, 438, 253, 0, 506, 98, 0, 0, 40, 140, '', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4173, 18863, 'Seer Ugoros', '', 'LineageMonster5.tantaar_lizardman_high_sorcerer', 40.00, 53.50, 84, 'male', 'L2ReflectionBoss', 'Ugoros', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 90, 150, 'tantaar_lizard_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4174, 18864, 'Fantasy Mushroom', '', 'LineageNpcEV.target_board_a', 16.00, 23.00, 85, 'male', 'L2Monster', 'PlainsOfLizardman', 40, 1000, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 0, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4175, 18865, 'Sticky Mushroom', '', 'LineageNpcEV.rug_fungus', 15.00, 25.00, 85, 'male', 'L2Monster', 'PlainsOfLizardman', 40, 1000, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 0, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4176, 18866, 'Rainbow Frog', '', 'LineageMonster5.poison_arrow_frog', 20.00, 18.00, 85, 'male', 'L2Monster', 'PlainsOfLizardman', 40, 1000, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 15, 40, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4177, 18867, 'Abyss Weed', '', 'LineageNpcEV.poison_plant_b', 30.00, 27.00, 85, 'male', 'L2Monster', 'PlainsOfLizardman', 40, 1000, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 1, 1, 'tantaar_lizard_clan', 300, 0, 0, 0, 0, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4178, 18868, 'Energy Plant', '', 'LineageNpcEV.rosehip_fragrant', 15.00, 33.00, 85, 'male', 'L2Monster', 'PlainsOfLizardman', 40, 1000, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 0, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4179, 18869, 'Kookaburra', '', 'LineageMonster2.baby_ostrich', 6.00, 15.00, 83, 'male', 'L2FeedableBeast', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 13, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4180, 18870, 'Cougar', '', 'LineageMonster2.baby_tiger', 8.00, 15.70, 83, 'male', 'L2FeedableBeast', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 28, 110, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4181, 18871, 'Buffalo', '', 'LineageMonster2.baby_buffalo', 8.00, 15.00, 84, 'male', 'L2FeedableBeast', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 30, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4182, 18872, 'Grendel', '', 'LineageMonster5.baby_bionic_bear', 9.00, 12.50, 84, 'male', 'L2FeedableBeast', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4183, 18873, 'Baby Alpine Kookaburra', '', 'LineageMonster2.baby_ostrich', 6.00, 15.00, 83, 'male', 'L2FeedableBeast', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 11630, 1256, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 13, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4184, 18874, 'Young Kookaburra', '', 'LineageMonster2.baby_ostrich_140p', 12.00, 21.00, 83, 'male', 'L2FeedableBeast', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 18776, 1918, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 13, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4185, 18875, 'Young Kookaburra', '', 'LineageMonster2.baby_ostrich_140p', 12.00, 21.00, 83, 'male', 'L2FeedableBeast', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 25005, 2686, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 13, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4186, 18876, 'Adult Kookaburra', '', 'LineageMonster2.youth_ostrich', 8.00, 26.40, 83, 'male', 'L2FeedableBeast', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 8516, 874, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 23, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4187, 18877, 'Adult Kookaburra', '', 'LineageMonster2.youth_ostrich', 8.00, 26.40, 83, 'male', 'L2FeedableBeast', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 72113, 7459, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 23, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4188, 18878, 'Full Grown Kookaburra', '', 'LineageMonster2.rough_ostrich', 10.00, 33.00, 83, 'male', 'L2FeedableBeast', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 11959, 1246, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 23, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4189, 18879, 'Full Grown Kookaburra', '', 'LineageMonster2.rough_ostrich', 10.00, 33.00, 83, 'male', 'L2FeedableBeast', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 76500, 6972, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 23, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4190, 18880, 'Baby Alpine Cougar', '', 'LineageMonster2.baby_tiger', 8.00, 15.70, 83, 'male', 'L2FeedableBeast', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 11630, 1256, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 28, 110, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4191, 18881, 'Young Cougar', '', 'LineageMonster2.baby_tiger_130p', 13.00, 21.00, 83, 'male', 'L2FeedableBeast', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 18776, 1918, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 28, 110, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4192, 18882, 'Young Cougar', '', 'LineageMonster2.baby_tiger_130p', 13.00, 21.00, 83, 'male', 'L2FeedableBeast', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 25005, 2686, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 28, 110, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4193, 18883, 'Adult Cougar', '', 'LineageMonster2.youth_tiger', 16.00, 17.20, 83, 'male', 'L2FeedableBeast', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 8516, 874, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4194, 18884, 'Adult Cougar', '', 'LineageMonster2.youth_tiger', 16.00, 17.20, 83, 'male', 'L2FeedableBeast', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 72113, 7459, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4195, 18885, 'Full Grown Cougar', '', 'LineageMonster.saber_toothed_tiger', 34.00, 28.00, 83, 'male', 'L2FeedableBeast', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 11959, 1246, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4196, 18886, 'Full Grown Cougar', '', 'LineageMonster.saber_toothed_tiger', 34.00, 28.00, 83, 'male', 'L2FeedableBeast', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 76500, 6972, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4197, 18887, 'Baby Alpine Buffalo', '', 'LineageMonster2.baby_buffalo', 8.00, 15.00, 84, 'male', 'L2FeedableBeast', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 12929, 1379, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 30, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4198, 18888, 'Young Buffalo', '', 'LineageMonster2.baby_buffalo_140p', 16.00, 22.00, 84, 'male', 'L2FeedableBeast', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 20911, 2111, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 30, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4199, 18889, 'Young Buffalo', '', 'LineageMonster2.baby_buffalo_140p', 16.00, 22.00, 84, 'male', 'L2FeedableBeast', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 27445, 2908, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 30, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4200, 18890, 'Adult Buffalo', '', 'LineageMonster2.youth_buffalo', 16.00, 25.20, 84, 'male', 'L2FeedableBeast', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 9438, 957, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 20, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4201, 18891, 'Adult Buffalo', '', 'LineageMonster2.youth_buffalo', 16.00, 25.20, 84, 'male', 'L2FeedableBeast', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 79302, 8101, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 20, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4202, 18892, 'Full Grown Buffalo', '', 'LineageMonster2.buffalo', 22.00, 31.00, 84, 'male', 'L2FeedableBeast', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 13050, 1342, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4203, 18893, 'Full Grown Buffalo', '', 'LineageMonster2.buffalo', 22.00, 31.00, 84, 'male', 'L2FeedableBeast', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 83904, 7596, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4204, 18894, 'Baby Alpine Grendel', '', 'LineageMonster5.baby_bionic_bear', 9.00, 12.50, 84, 'male', 'L2FeedableBeast', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 12929, 1379, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4205, 18895, 'Young Grendel', '', 'LineageMonster5.baby_bionic_bear_e', 9.00, 12.50, 84, 'male', 'L2FeedableBeast', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 20911, 2111, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4206, 18896, 'Young Grendel', '', 'LineageMonster5.baby_bionic_bear_e', 9.00, 12.50, 84, 'male', 'L2FeedableBeast', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 27445, 2908, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4207, 18897, 'Adult Grendel', '', 'LineageMonster2.bionic_bear', 15.00, 39.00, 84, 'male', 'L2FeedableBeast', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 9438, 957, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 36, 155, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4208, 18898, 'Adult Grendel', '', 'LineageMonster2.bionic_bear', 15.00, 39.00, 84, 'male', 'L2FeedableBeast', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 79302, 8101, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 36, 155, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4209, 18899, 'Full Grown Grendel', '', 'LineageMonster5.rough_bionic_bear', 34.00, 32.50, 84, 'male', 'L2FeedableBeast', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 13050, 1342, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4210, 18900, 'Full Grown Grendel', '', 'LineageMonster5.rough_bionic_bear', 34.00, 32.50, 84, 'male', 'L2FeedableBeast', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 83904, 7596, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4211, 18901, 'Kookaburra', '', 'LineageMonster2.baby_ostrich_140p_e', 12.00, 21.00, 83, 'male', 'L2Npc', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 13, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4212, 18902, 'Cougar', '', 'LineageMonster2.baby_tiger_130p_e', 13.00, 21.00, 83, 'male', 'L2Npc', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 28, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4213, 18903, 'Buffalo', '', 'LineageMonster2.baby_buffalo_140p_e', 16.00, 22.00, 84, 'male', 'L2Npc', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 30, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4214, 18904, 'Grendel', '', 'LineageMonster5.baby_bionic_bear_160p', 12.00, 17.00, 84, 'male', 'L2Npc', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4215, 18905, 'Farm Ravager', '', 'LineageMonster5.xel_mahum_warrior', 29.00, 37.00, 84, 'male', 'L2Npc', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 243976, 2243, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 60, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4216, 18906, 'Farm Bandit', '', 'LineageMonster5.xel_mahum_warrior', 29.00, 37.00, 84, 'male', 'L2Monster', 'BeastFarm', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 17662, 1884, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 60, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4217, 18907, 'Beast Devourer', '', 'LineageMonster5.xel_mahum_sniper', 27.00, 31.00, 84, 'male', 'L2Monster', 'BeastFarm', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 18652, 1990, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 60, 150, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1, 18908, 'Sel Mahum Chef', '', 'LineageMonster5.ol_mahum_cooker', 20.00, 37.00, 83, 'male', 'L2Monster', 'SelMahumCook', 40, 7671, 9.400, 1812, 3.270, 40, 43, 30, 21, 20, 20, 17546, 1759, 1891, 609, 1291, 445, 253, 0, 500, 0, 0, 0, 80, 180, '', 500, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4219, 18909, 'Solina Knights', '', 'LineageMonster3.monk_warrior', 12.00, 28.40, 83, 'male', 'L2Monster', 'SolinaGuardian', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 29810, 3060, 1890, 609, 1292, 445, 253, 200, 506, 8211, 8210, 0, 53, 150, 'n_solina_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4220, 18910, 'Solina Knight Captain', '', 'LineageMonster5.solina_knight', 14.00, 31.50, 83, 'male', 'L2Monster', 'SolinaGuardian', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 44216, 4545, 1890, 609, 1292, 445, 253, 200, 506, 0, 0, 0, 30, 66, 'n_solina_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4221, 18911, 'Abbey Treasure Chest', '', 'construct', 17.00, 13.00, 84, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 14, 76, 10, 57, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4222, 18912, 'Scarecrow', '', 'LineageNpcEV.puppet', 27.00, 37.50, 1, 'male', 'L2Npc', 'npc', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4223, 18913, 'Furnace', '', 'construct', 18.00, 30.00, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 300, 506, 0, 0, 0, 0, 0, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4224, 18914, 'Furnace', '', 'construct', 18.00, 30.00, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 300, 506, 0, 0, 0, 0, 0, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4225, 18915, 'Divine Furnace', '', 'construct', 18.00, 30.00, 1, 'male', 'L2Npc', 'DivineFurnace', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 300, 506, 0, 0, 0, 0, 0, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4226, 18916, 'n_monastery_questcheck', '', 'construct', 0.10, 0.10, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4227, 18917, 'Pavel Safety Device', '', 'LineageMonster4.giga_whirligig_40p', 12.00, 22.50, 72, 'male', 'L2Monster', 'PavelSafetyDevice', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 250, 250, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.64, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4228, 18918, 'invisible_monster', '', 'construct', 0.10, 0.10, 85, 'male', 'L2Monster', 'Fighter', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4229, 18919, 'invisible_npc', '', 'construct', 0.10, 0.10, 85, 'male', 'L2Monster', 'Fighter', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4230, 18920, 'gem_warter_cannon', '', 'construct', 0.10, 0.10, 84, 'male', 'L2Monster', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4231, 18921, 'Square Base ', '', 'construct', 23.00, 37.00, 84, 'male', 'L2Monster', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4232, 18922, 'Door Golem', '', 'beast', 8.00, 15.00, 84, 'male', 'L2Monster', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 300, 506, 0, 0, 0, 30, 80, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4233, 18923, 'Door Golem', '', 'beast', 8.00, 15.00, 84, 'male', 'L2Monster', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 300, 506, 0, 0, 0, 30, 80, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4234, 18924, 'Door Golem', '', 'beast', 8.00, 15.00, 84, 'male', 'L2Monster', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 300, 506, 0, 0, 0, 30, 80, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4235, 18925, 'Trap', '', 'construct', 30.00, 13.00, 84, 'etc', 'L2Monster', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4236, 18926, 'Mercenary Archer', '', 'elf', 10.00, 23.50, 85, 'male', 'L2Jinia', 'JiniaGuard', 1100, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 300, 506, 0, 0, 0, 30, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1, 18927, '', '', 'LineageNpcEV.camp_fire_a', 29.00, 30.50, 70, 'male', 'L2TerrainObject', 'SelMahum', 40, 5290, 9.400, 1674, 3.270, 40, 43, 30, 21, 20, 20, 14514, 2715, 3513, 840, 3564, 711, 253, 0, 500, 0, 0, 0, 0, 0, '', 500, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4238, 18928, 'Annihilation Furnace', '', 'LineageNpcEV.gracia_fire_pot', 63.00, 33.50, 85, 'male', 'L2TerrainObject', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (4239, 18929, 'Ward of the Grail', '', 'construct', 13.00, 22.00, 84, 'male', 'L2Monster', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 300, 506, 0, 0, 0, 25, 140, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.10, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4240, 18930, 'freya_controller', '', 'construct', 0.10, 0.10, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4241, 18931, 'ice_elemental_controller', '', 'construct', 0.10, 0.10, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4242, 18932, 'ice_castle_controller', '', 'construct', 0.10, 0.10, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1, 18933, '', '', 'LineageNpcEV.camp_fire_c', 29.00, 30.50, 70, 'male', 'L2TerrainObject', 'SelMahum', 40, 5290, 9.400, 1674, 3.270, 40, 43, 30, 21, 20, 20, 14514, 2715, 3513, 840, 3564, 711, 253, 0, 500, 0, 0, 0, 0, 0, '', 500, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4244, 18934, 'Abbey Treasure Chest', '', 'construct', 17.00, 13.00, 84, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 14, 76, 10, 57, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4245, 18935, 'Divine Sword Protection', '', 'construct', 0.10, 0.10, 85, 'male', 'L2Monster', 'Fighter', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4246, 18936, 'reed_herb_sower', '', 'construct', 0.10, 0.10, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 300, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1, 20001, 'Gremlin', '', 'gremlin', 10.00, 15.00, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 29, 2, 7, 40, 5, 27, 253, 0, 506, 0, 0, 0, 20, 50, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2, 20002, 'Rabbit', '', 'rabbit', 5.00, 4.50, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 29, 2, 7, 40, 5, 27, 253, 0, 506, 0, 0, 0, 50, 80, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3, 20003, 'Goblin', '', 'goblin', 10.00, 16.50, 5, 'male', 'L2Monster', 'Fighter', 40, 80, 2.000, 70, 0.900, 40, 43, 30, 21, 20, 20, 178, 5, 11, 49, 8, 32, 253, 0, 506, 4, 0, 0, 40, 110, 'goblin_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.32, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4, 20004, 'Imp', '', 'imp', 10.00, 24.00, 6, 'male', 'L2Monster', 'Fighter', 40, 94, 2.000, 77, 0.900, 40, 43, 30, 21, 20, 20, 214, 6, 13, 51, 9, 34, 253, 0, 506, 0, 0, 0, 60, 80, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5, 20005, 'Imp Elder', '', 'imp', 10.00, 24.00, 7, 'male', 'L2Monster', 'Fighter', 40, 108, 2.000, 85, 0.900, 40, 43, 30, 21, 20, 20, 249, 8, 14, 54, 10, 36, 253, 0, 506, 0, 0, 0, 60, 80, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6, 20006, 'Orc Archer', '', 'orc_archer', 14.00, 25.00, 8, 'male', 'L2Monster', 'Ranger', 1100, 125, 2.000, 93, 0.900, 40, 43, 30, 21, 20, 20, 293, 10, 16, 56, 11, 37, 253, 0, 506, 14, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7, 20007, 'Green Fungus', '', 'walking_fungus', 15.00, 22.50, 9, 'male', 'L2Monster', 'Fighter', 40, 143, 2.000, 100, 0.900, 40, 43, 30, 21, 20, 20, 321, 11, 18, 59, 12, 39, 253, 0, 506, 0, 0, 0, 70, 110, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8, 20008, 'Felim Lizardman', '', 'virud_lizardman', 10.00, 23.00, 14, 'male', 'L2Monster', 'Fighter', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 499, 19, 28, 73, 20, 48, 253, 0, 506, 1, 0, 0, 43, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (9, 20009, 'Vuku Orc', '', 'orc', 10.00, 21.00, 14, 'male', 'L2Monster', 'Fighter', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 499, 19, 28, 73, 20, 48, 253, 0, 506, 156, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (10, 20010, 'Felim Lizardman Scout', '', 'virud_lizardman', 10.00, 23.00, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 534, 22, 31, 77, 21, 51, 253, 0, 506, 16, 0, 0, 43, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (11, 20011, 'Vuku Orc Archer', '', 'orc_archer', 14.00, 25.00, 15, 'male', 'L2Monster', 'Ranger', 1100, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 551, 22, 31, 77, 21, 51, 253, 0, 506, 14, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (12, 20012, 'Gora Werewolf', '', 'werewolf', 10.00, 26.00, 16, 'male', 'L2Monster', 'Fighter', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 582, 23, 34, 80, 23, 54, 253, 500, 506, 0, 0, 0, 50, 120, 'werewolf_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (13, 20013, 'Dryad', '', 'dryad', 9.00, 20.00, 13, 'female', 'L2Monster', 'Fighter', 40, 215, 2.500, 133, 1.200, 40, 43, 30, 21, 20, 20, 463, 18, 26, 70, 17, 47, 253, 0, 506, 0, 0, 0, 40, 110, 'elemental1_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (14, 20014, 'Felim Lizardman Warrior', '', 'virud_lizardman_warrior', 12.00, 30.00, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 606, 25, 37, 84, 25, 55, 253, 0, 506, 16, 0, 0, 52, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (15, 20015, 'Marsh Zombie', '', 'zombie', 13.00, 21.00, 13, 'male', 'L2Monster', 'Mystic', 40, 215, 2.500, 133, 1.200, 40, 43, 30, 21, 20, 20, 655, 26, 26, 70, 17, 47, 253, 0, 506, 0, 0, 0, 15, 15, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (16, 20016, 'Stone Golem', '', 'stone_golem', 20.00, 31.00, 13, 'male', 'L2Monster', 'Mystic', 40, 215, 2.500, 133, 1.200, 40, 43, 30, 21, 20, 20, 655, 26, 26, 70, 17, 47, 253, 0, 506, 0, 0, 0, 23, 23, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (17, 20017, 'Vuku Orc Fighter', '', 'orc_fighter', 12.00, 22.00, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 618, 26, 37, 84, 25, 55, 253, 500, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (18, 20018, 'Carnivorous Fungus', '', 'walking_fungus', 15.00, 22.50, 14, 'male', 'L2Monster', 'Fighter', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 424, 16, 28, 73, 20, 48, 253, 500, 506, 0, 0, 0, 70, 110, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (19, 20019, 'Dryad Elder', '', 'dryad', 9.00, 20.00, 14, 'female', 'L2Monster', 'Fighter', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 499, 19, 28, 73, 20, 48, 253, 0, 506, 0, 0, 0, 40, 110, 'elemental1_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (20, 20020, 'Marsh Zombie Lord', '', 'zombie', 13.00, 21.00, 14, 'male', 'L2Monster', 'Fighter', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 705, 27, 28, 73, 20, 48, 253, 0, 506, 0, 0, 0, 15, 15, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (21, 20021, 'Red Bear', '', 'grizzly', 21.00, 40.00, 14, 'male', 'L2Monster', 'Fighter', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 499, 19, 28, 73, 20, 48, 253, 0, 506, 0, 0, 0, 40, 110, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (22, 20022, 'Misery Skeleton', '', 'skeleton', 11.00, 25.00, 14, 'male', 'L2Monster', 'Fighter', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 424, 16, 28, 73, 20, 48, 253, 500, 506, 946, 945, 0, 60, 140, 'skeleton_clan', 300, 0, 20, 36, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (23, 20023, 'Shadow Beast', '', 'onyx_beast', 14.00, 14.50, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 534, 22, 31, 77, 21, 51, 253, 0, 506, 0, 0, 0, 30, 120, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (24, 20024, 'Langk Lizardman Warrior', '', 'virud_lizardman_warrior', 12.00, 30.00, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 618, 26, 37, 84, 25, 55, 253, 500, 506, 16, 0, 0, 52, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (25, 20025, 'Lesser Dark Horror', '', 'dark_horror', 20.00, 35.00, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 545, 22, 31, 77, 21, 51, 253, 500, 506, 0, 0, 0, 100, 100, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (26, 20026, 'Ruin Zombie', '', 'zombie', 13.00, 21.00, 15, 'male', 'L2Monster', 'Mystic', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 756, 31, 31, 77, 21, 51, 253, 0, 506, 0, 0, 0, 15, 15, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (27, 20027, 'Langk Lizardman Scout', '', 'virud_lizardman', 10.00, 23.00, 16, 'male', 'L2Monster', 'Fighter', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 571, 23, 34, 80, 23, 54, 253, 0, 506, 16, 0, 0, 43, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (28, 20028, 'Pincher', '', 'giant_spider', 26.00, 25.50, 16, 'male', 'L2Monster', 'Mystic', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 571, 23, 34, 80, 23, 54, 253, 0, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (29, 20029, 'Ruin Zombie Leader', '', 'zombie', 13.00, 21.00, 16, 'male', 'L2Monster', 'Mystic', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 807, 33, 34, 80, 23, 54, 253, 0, 506, 0, 0, 0, 15, 15, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (30, 20030, 'Langk Lizardman', '', 'virud_lizardman', 10.00, 23.00, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 534, 22, 31, 77, 21, 51, 253, 0, 506, 1, 0, 0, 43, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (31, 20031, 'Omen Beast', '', 'onyx_beast', 14.00, 14.50, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 505, 21, 37, 84, 25, 55, 253, 0, 506, 0, 0, 0, 30, 120, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (32, 20032, 'Pinrul', '', 'giant_spider', 26.00, 25.50, 17, 'male', 'L2Monster', 'Mystic', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 606, 25, 37, 84, 25, 55, 253, 0, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (33, 20033, 'Shade Horror', '', 'dark_horror', 20.00, 35.00, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 505, 21, 37, 84, 25, 55, 253, 0, 506, 0, 0, 0, 100, 100, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (34, 20034, 'Prowler', '', 'giant_spider', 26.00, 25.50, 17, 'male', 'L2Monster', 'Mystic', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 618, 26, 37, 84, 25, 55, 253, 500, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (35, 20035, 'Tracker Skeleton', '', 'skeleton', 11.00, 25.00, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 606, 25, 37, 84, 25, 55, 253, 0, 506, 946, 945, 0, 60, 140, 'skeleton_clan', 300, 0, 20, 39, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (36, 20036, 'Lirein', '', 'sylph', 11.00, 35.00, 18, 'female', 'L2Monster', 'Mystic', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 653, 28, 41, 87, 28, 58, 253, 500, 506, 0, 0, 0, 60, 60, 'elemental2_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (37, 20037, 'Mana Seeker', '', 'mana_vampire', 11.00, 20.00, 18, 'male', 'L2Monster', 'Mystic', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 992, 43, 41, 87, 28, 58, 253, 0, 506, 0, 0, 0, 90, 90, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (38, 20038, 'Venomous Spider', '', 'poison_spider', 27.00, 25.50, 18, 'male', 'L2Monster', 'Mystic', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 704, 31, 41, 87, 28, 58, 253, 0, 506, 0, 0, 0, 60, 140, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (39, 20039, 'Scavenger Wererat', '', 'wererat', 14.00, 25.00, 18, 'male', 'L2Monster', 'Fighter', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 640, 28, 41, 87, 28, 58, 253, 0, 506, 12, 0, 0, 80, 120, 'wererat_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (40, 20040, 'Sukar Wererat', '', 'wererat', 14.00, 25.00, 18, 'male', 'L2Monster', 'Fighter', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 533, 23, 41, 87, 28, 58, 253, 0, 506, 216, 0, 0, 80, 120, 'wererat_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (41, 20041, 'Tainted Zombie', '', 'zombie', 13.00, 21.00, 18, 'male', 'L2Monster', 'Mystic', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 754, 33, 41, 87, 28, 58, 253, 0, 506, 0, 0, 0, 15, 15, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (42, 20042, 'Tracker Skeleton Leader', '', 'skeleton', 11.00, 25.00, 18, 'male', 'L2Monster', 'Fighter', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 653, 28, 41, 87, 28, 58, 253, 500, 506, 946, 945, 0, 60, 140, 'skeleton_clan', 300, 0, 20, 41, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (43, 20043, 'Arachnid Tracker', '', 'poison_spider', 27.00, 25.50, 19, 'male', 'L2Monster', 'Mystic', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 761, 34, 44, 91, 30, 60, 253, 500, 506, 0, 0, 0, 60, 140, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (44, 20044, 'Lirein Elder', '', 'sylph', 11.00, 35.00, 19, 'female', 'L2Monster', 'Mystic', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 692, 31, 44, 91, 30, 60, 253, 500, 506, 0, 0, 0, 60, 60, 'elemental1_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (45, 20045, 'Skeleton Scout', '', 'skeleton_archer', 11.00, 27.00, 19, 'male', 'L2Monster', 'Ranger', 1100, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 699, 31, 44, 91, 30, 60, 253, 0, 506, 275, 0, 0, 40, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (46, 20046, 'Stink Zombie', '', 'zombie', 13.00, 21.00, 19, 'male', 'L2Monster', 'Mystic', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 799, 36, 44, 91, 30, 60, 253, 0, 506, 0, 0, 0, 15, 15, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (47, 20047, 'Sukar Wererat Leader', '', 'wererat', 14.00, 25.00, 19, 'male', 'L2Monster', 'Fighter', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 576, 26, 44, 91, 30, 60, 253, 500, 506, 216, 0, 0, 80, 120, 'wererat_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (48, 20048, 'Lesser Succubus', '', 'succubus', 10.00, 36.00, 20, 'female', 'L2Monster', 'Mystic', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 606, 27, 48, 95, 33, 63, 253, 500, 506, 0, 0, 0, 60, 100, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (49, 20049, 'Lycanthrope', '', 'werewolf', 10.00, 26.00, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 727, 32, 48, 95, 33, 63, 253, 500, 506, 0, 0, 0, 50, 120, 'werewolf_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (50, 20050, 'Arachnid Predator', '', 'poison_spider', 27.00, 25.50, 20, 'male', 'L2Monster', 'Mystic', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 800, 35, 48, 95, 33, 63, 253, 500, 506, 0, 0, 0, 60, 140, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (51, 20051, 'Skeleton Bowman', '', 'skeleton_archer', 11.00, 27.00, 20, 'male', 'L2Monster', 'Ranger', 1100, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 734, 32, 48, 95, 33, 63, 253, 0, 506, 275, 0, 0, 40, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (52, 20052, 'Lesser Succubus Turen', '', 'succubus', 10.00, 36.00, 21, 'female', 'L2Monster', 'Mystic', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 780, 36, 53, 99, 36, 66, 253, 500, 506, 0, 0, 0, 60, 100, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (53, 20053, 'Ol Mahum Patrol', '', 'ol_mahum_archer', 14.00, 25.00, 21, 'male', 'L2Monster', 'Ranger', 1100, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 945, 43, 53, 99, 36, 66, 253, 0, 506, 14, 0, 0, 50, 110, 'ol_mahum_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.93, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (54, 20054, 'Ruin Spartoi', '', 'spartoi', 11.00, 27.00, 21, 'male', 'L2Monster', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 917, 42, 53, 99, 36, 66, 253, 0, 506, 73, 0, 0, 60, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (55, 20055, 'Wandering Eye', '', 'monster_eye', 21.00, 43.00, 21, 'male', 'L2Monster', 'Mystic', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 917, 42, 53, 99, 36, 66, 253, 0, 506, 0, 0, 0, 90, 159, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (56, 20056, 'Dre Vanul Disposer', '', 'dre_vanul', 14.00, 36.00, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 921, 43, 58, 103, 39, 69, 253, 500, 506, 0, 0, 0, 80, 80, 'demonic_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (57, 20057, 'Lesser Succubus Tilfo', '', 'succubus', 10.00, 36.00, 22, 'female', 'L2Monster', 'Mystic', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 838, 40, 58, 103, 39, 69, 253, 500, 506, 0, 0, 0, 60, 100, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (58, 20058, 'Ol Mahum Guard', '', 'ol_mahum', 13.50, 25.00, 22, 'male', 'L2Monster', 'WatchmanMonster', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 986, 47, 58, 103, 39, 69, 253, 0, 506, 2, 0, 0, 50, 110, 'ol_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (59, 20059, 'Hungry Eye', '', 'monster_eye', 21.00, 43.00, 22, 'male', 'L2Monster', 'Mystic', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 986, 47, 58, 103, 39, 69, 253, 0, 506, 0, 0, 0, 90, 159, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (60, 20060, 'Raging Spartoi', '', 'spartoi', 11.00, 27.00, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 1005, 48, 58, 103, 39, 69, 253, 500, 506, 946, 945, 0, 60, 140, 'skeleton_clan', 300, 0, 20, 46, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (61, 20061, 'Ol Mahum Straggler', '', 'ol_mahum', 13.50, 25.00, 23, 'male', 'L2Monster', 'Fighter', 40, 411, 3.500, 232, 1.500, 40, 43, 30, 21, 20, 20, 1075, 52, 63, 108, 43, 72, 253, 500, 506, 2, 0, 0, 50, 110, 'ol_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (62, 20062, 'Tumran Bugbear', '', 'bugbear', 17.00, 35.00, 23, 'male', 'L2Monster', 'Fighter', 40, 411, 3.500, 232, 1.500, 40, 43, 30, 21, 20, 20, 1054, 50, 63, 108, 43, 72, 253, 0, 506, 156, 0, 0, 55, 130, 'bugbear_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (63, 20063, 'Ol Mahum Shooter', '', 'ol_mahum_archer', 14.00, 25.00, 24, 'male', 'L2Monster', 'Ranger', 1100, 435, 3.500, 246, 1.500, 40, 43, 30, 21, 20, 20, 1156, 56, 68, 112, 46, 75, 253, 0, 506, 14, 0, 0, 50, 110, 'ol_mahum_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.93, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (64, 20064, 'Tumran Bugbear Warrior', '', 'bugbear', 17.00, 35.00, 24, 'male', 'L2Monster', 'Fighter', 40, 435, 3.500, 246, 1.500, 40, 43, 30, 21, 20, 20, 1145, 56, 68, 112, 46, 75, 253, 500, 506, 88, 0, 0, 55, 130, 'bugbear_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (65, 20065, 'Ol Mahum Patrolman', '', 'ol_mahum', 13.50, 25.00, 25, 'male', 'L2Monster', 'Fighter', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 992, 49, 74, 116, 50, 78, 253, 0, 506, 2, 0, 0, 50, 110, 'ol_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (66, 20066, 'Ol Mahum Captain', '', 'ol_mahum_champion', 14.00, 27.00, 25, 'male', 'L2Monster', 'Fighter', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 1263, 64, 74, 116, 50, 78, 253, 500, 506, 69, 0, 0, 50, 110, 'ol_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (67, 20067, 'Monster Eye Watcher', '', 'monster_eye', 21.00, 43.00, 25, 'male', 'L2Monster', 'Mystic', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 1191, 60, 74, 116, 50, 78, 253, 0, 506, 0, 0, 0, 90, 159, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (68, 20068, 'Monster Eye Destroyer', '', 'monster_eye', 21.00, 43.00, 26, 'male', 'L2Monster', 'Mystic', 40, 488, 3.500, 273, 1.500, 40, 43, 30, 21, 20, 20, 1294, 65, 81, 121, 55, 81, 253, 500, 506, 0, 0, 0, 90, 159, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (69, 20069, 'Selu Lizardman Scout', '', 'virud_lizardman', 10.00, 23.00, 26, 'male', 'L2Monster', 'Fighter', 40, 488, 3.500, 273, 1.500, 40, 43, 30, 21, 20, 20, 1057, 53, 81, 121, 55, 81, 253, 0, 506, 16, 0, 0, 43, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (70, 20070, 'Lesser Basilisk', '', 'lesser_basilisk', 34.00, 25.00, 27, 'male', 'L2Monster', 'Fighter', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 1349, 70, 87, 125, 59, 84, 253, 500, 506, 0, 0, 0, 35, 131, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (71, 20071, 'Selu Lizardman Warrior', '', 'virud_lizardman_warrior', 12.00, 30.00, 27, 'male', 'L2Monster', 'Fighter', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 1136, 58, 87, 125, 59, 84, 253, 500, 506, 16, 0, 0, 52, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (72, 20072, 'Basilisk', '', 'lesser_basilisk', 34.00, 25.00, 28, 'male', 'L2Monster', 'Fighter', 40, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 1428, 74, 95, 131, 64, 87, 253, 500, 506, 0, 0, 0, 35, 131, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (73, 20073, 'Ol Mahum Legionnaire', '', 'ol_mahum', 13.50, 25.00, 28, 'male', 'L2Monster', 'Fighter', 40, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 1178, 62, 95, 131, 64, 87, 253, 0, 506, 2, 0, 0, 50, 110, 'ol_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (74, 20074, 'Androscorpio', '', 'onyx_beast', 14.00, 14.50, 29, 'male', 'L2Monster', 'Fighter', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 1492, 80, 101, 136, 70, 91, 253, 0, 506, 0, 0, 0, 30, 120, 'scropio_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (75, 20075, 'Ant Larva', '', 'ant_larva', 12.00, 8.00, 29, 'male', 'L2Monster', 'Fighter', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 1368, 73, 101, 136, 70, 91, 253, 0, 506, 0, 0, 0, 40, 60, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (76, 20076, 'Ol Mahum Commander', '', 'ol_mahum_champion', 14.00, 27.00, 29, 'male', 'L2Monster', 'Fighter', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 1583, 85, 101, 136, 70, 91, 253, 500, 506, 69, 0, 0, 50, 110, 'ol_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (77, 20077, 'Androscorpio Hunter', '', 'onyx_beast', 14.00, 14.50, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1571, 86, 111, 140, 75, 94, 253, 0, 506, 0, 0, 0, 30, 120, 'scropio_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (78, 20078, 'Whispering Wind', '', 'sylph_100_bi', 20.00, 70.00, 30, 'female', 'L2Monster', 'Mystic', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1571, 86, 111, 140, 75, 94, 253, 0, 506, 0, 0, 0, 60, 60, 'elemental2_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (79, 20079, 'Ant', '', 'ant', 26.00, 15.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1571, 86, 111, 140, 75, 94, 253, 0, 506, 0, 0, 0, 40, 130, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (80, 20080, 'Ant Captain', '', 'ant', 26.00, 15.00, 31, 'male', 'L2Monster', 'Fighter', 40, 636, 4.500, 344, 1.800, 40, 43, 30, 21, 20, 20, 1711, 95, 119, 146, 82, 97, 253, 500, 506, 0, 0, 0, 40, 130, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (81, 20081, 'Ant Overseer', '', 'ant', 26.00, 15.00, 32, 'male', 'L2Monster', 'Fighter', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 2881, 162, 128, 152, 87, 102, 253, 0, 506, 0, 0, 0, 40, 130, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (82, 20082, 'Ant Recruit', '', 'ant_soldier', 35.00, 17.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 1742, 100, 138, 157, 94, 105, 253, 0, 506, 0, 0, 0, 80, 130, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (83, 20083, 'Granite Golem', '', 'stone_golem', 20.00, 31.00, 33, 'male', 'L2Monster', 'Mystic', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 2687, 155, 138, 157, 94, 105, 253, 0, 506, 0, 0, 0, 23, 23, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (84, 20084, 'Ant Patrol', '', 'ant_soldier', 35.00, 17.00, 34, 'male', 'L2Monster', 'Fighter', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 2001, 116, 149, 164, 102, 109, 253, 0, 506, 0, 0, 0, 80, 130, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (85, 20085, 'Puncher', '', 'stone_golem', 20.00, 31.00, 34, 'male', 'L2Monster', 'Mystic', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 2910, 170, 149, 164, 102, 109, 253, 500, 506, 0, 0, 0, 23, 23, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (86, 20086, 'Ant Guard', '', 'ant_soldier', 35.00, 17.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 1782, 106, 160, 170, 109, 113, 253, 0, 506, 0, 0, 0, 80, 174, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (87, 20087, 'Ant Soldier', '', 'ant_soldier', 35.00, 17.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 4274, 253, 160, 170, 109, 113, 253, 500, 506, 0, 0, 0, 80, 174, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (88, 20088, 'Ant Warrior Captain', '', 'ant_soldier', 35.00, 17.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 4763, 288, 173, 176, 118, 118, 253, 500, 506, 0, 0, 0, 80, 174, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (89, 20089, 'Noble Ant', '', 'noble_ant', 20.00, 48.00, 37, 'male', 'L2Monster', 'Fighter', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 1991, 122, 185, 181, 126, 121, 253, 0, 506, 0, 0, 0, 80, 174, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (90, 20090, 'Noble Ant Leader', '', 'noble_ant', 20.00, 48.00, 38, 'male', 'L2Monster', 'Fighter', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 4391, 274, 198, 188, 136, 126, 253, 500, 506, 0, 0, 0, 80, 174, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (91, 20091, 'Young Fox', '', 'fox', 9.50, 10.00, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 29, 2, 7, 40, 5, 27, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (92, 20092, 'Monster Eye', '', 'monster_eye', 21.00, 43.00, 10, 'male', 'L2Monster', 'Mystic', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 294, 10, 19, 61, 13, 41, 253, 0, 506, 0, 0, 0, 90, 134, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (93, 20093, 'Orc Fighter', '', 'orc_fighter', 12.00, 22.00, 10, 'male', 'L2Monster', 'Fighter', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 363, 12, 19, 61, 13, 41, 253, 500, 506, 1, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (94, 20094, 'Orc Marksman', '', 'orc_archer', 14.00, 25.00, 10, 'male', 'L2Monster', 'Ranger', 1100, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 306, 10, 19, 61, 13, 41, 253, 0, 506, 14, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (95, 20095, 'Vampire Bat', '', 'vampire_bat', 10.00, 33.50, 10, 'male', 'L2Monster', 'Mystic', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 297, 10, 19, 61, 13, 41, 253, 0, 506, 0, 0, 0, 60, 80, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (96, 20096, 'Orc Lieutenant', '', 'orc_fighter', 12.00, 22.00, 11, 'male', 'L2Monster', 'Fighter', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 392, 15, 21, 64, 14, 43, 253, 0, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (97, 20097, 'Drill Bat', '', 'vampire_bat', 10.00, 33.50, 11, 'male', 'L2Monster', 'Mystic', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 326, 12, 21, 64, 14, 43, 253, 0, 506, 0, 0, 0, 60, 80, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (98, 20098, 'Orc Fighter Leader', '', 'orc_fighter', 12.00, 22.00, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 448, 17, 23, 67, 16, 44, 253, 500, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (99, 20099, 'Skeleton', '', 'skeleton', 11.00, 25.00, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 363, 13, 23, 67, 16, 44, 253, 500, 506, 946, 945, 0, 60, 140, 'skeleton_clan', 300, 0, 20, 33, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (100, 20100, 'Skeleton Archer', '', 'skeleton_archer', 11.00, 27.00, 13, 'male', 'L2Monster', 'Ranger', 1100, 215, 2.500, 133, 1.200, 40, 43, 30, 21, 20, 20, 405, 16, 26, 70, 17, 47, 253, 500, 506, 14, 0, 0, 40, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (101, 20101, 'Crasher', '', 'stone_golem', 20.00, 31.00, 14, 'male', 'L2Monster', 'Mystic', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 705, 27, 28, 73, 20, 48, 253, 0, 506, 0, 0, 0, 23, 23, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (102, 20102, 'Skeleton Marksman', '', 'skeleton_archer', 11.00, 27.00, 14, 'male', 'L2Monster', 'Ranger', 1100, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 428, 17, 28, 73, 20, 48, 253, 0, 506, 14, 0, 0, 40, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (103, 20103, 'Giant Spider', '', 'giant_spider', 26.00, 25.50, 15, 'male', 'L2Monster', 'Mystic', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 545, 22, 31, 77, 21, 51, 253, 500, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (104, 20104, 'Skeleton Lord', '', 'skeleton', 11.00, 25.00, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 445, 18, 31, 77, 21, 51, 253, 0, 506, 946, 945, 0, 60, 140, 'skeleton_clan', 300, 0, 20, 37, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (105, 20105, 'Dark Horror', '', 'dark_horror', 20.00, 35.00, 16, 'male', 'L2Monster', 'Fighter', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 577, 23, 34, 80, 23, 54, 253, 500, 506, 0, 0, 0, 100, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (106, 20106, 'Talon Spider', '', 'giant_spider', 26.00, 25.50, 16, 'male', 'L2Monster', 'Mystic', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 571, 23, 34, 80, 23, 54, 253, 0, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (107, 20107, 'Wererat', '', 'wererat', 14.00, 25.00, 16, 'male', 'L2Monster', 'Fighter', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 476, 19, 34, 80, 23, 54, 253, 0, 506, 0, 0, 0, 80, 120, 'wererat_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (108, 20108, 'Blade Spider', '', 'giant_spider', 26.00, 25.50, 17, 'male', 'L2Monster', 'Mystic', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 618, 26, 37, 84, 25, 55, 253, 500, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (109, 20109, 'Salamander', '', 'salamander', 16.00, 6.80, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 990, 42, 37, 84, 25, 55, 253, 0, 506, 0, 0, 0, 64, 96, 'elemental3_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.20, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (110, 20110, 'Undine', '', 'undine', 12.00, 27.00, 17, 'female', 'L2Monster', 'Mystic', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 958, 40, 37, 84, 25, 55, 253, 500, 506, 0, 0, 0, 60, 60, 'elemental4_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (111, 20111, 'Wererat Leader', '', 'wererat', 14.00, 25.00, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 958, 40, 37, 84, 25, 55, 253, 500, 506, 1, 0, 0, 80, 120, 'wererat_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (112, 20112, 'Salamander Elder', '', 'salamander', 16.00, 6.80, 18, 'male', 'L2Monster', 'Fighter', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 992, 43, 41, 87, 28, 58, 253, 0, 506, 0, 0, 0, 64, 96, 'elemental3_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.20, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (113, 20113, 'Undine Elder', '', 'undine', 12.00, 27.00, 18, 'female', 'L2Monster', 'Mystic', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 1012, 44, 41, 87, 28, 58, 253, 500, 506, 0, 0, 0, 60, 60, 'elemental4_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (114, 20114, 'Salamander Noble', '', 'salamander', 16.00, 6.80, 19, 'male', 'L2Monster', 'Fighter', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 1051, 47, 44, 91, 30, 60, 253, 0, 506, 0, 0, 0, 64, 96, 'elemental3_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.20, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (115, 20115, 'Undine Noble', '', 'undine', 12.00, 27.00, 19, 'female', 'L2Monster', 'Mystic', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 1072, 48, 44, 91, 30, 60, 253, 500, 506, 0, 0, 0, 60, 60, 'elemental4_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (116, 20116, 'Fox', '', 'fox', 9.50, 10.00, 2, 'male', 'L2Monster', 'Fighter', 40, 48, 2.000, 47, 0.900, 40, 43, 30, 21, 20, 20, 59, 2, 8, 42, 5, 28, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (117, 20117, 'Dre Vanul', '', 'dre_vanul', 14.00, 36.00, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 666, 29, 48, 95, 33, 63, 253, 500, 506, 0, 0, 0, 80, 80, 'demonic_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (118, 20118, 'Dre Vanul Scout', '', 'dre_vanul', 14.00, 36.00, 21, 'male', 'L2Minion', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 780, 36, 53, 99, 36, 66, 253, 500, 506, 0, 0, 0, 80, 80, 'demonic_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (119, 20119, 'Elder Fox', '', 'fox', 9.50, 10.00, 3, 'male', 'L2Monster', 'Fighter', 40, 58, 2.000, 55, 0.900, 40, 43, 30, 21, 20, 20, 88, 2, 9, 44, 6, 29, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (120, 20120, 'Wolf', '', 'wolf', 13.00, 9.00, 4, 'male', 'L2Monster', 'Fighter', 40, 68, 2.000, 62, 0.900, 40, 43, 30, 21, 20, 20, 141, 4, 10, 47, 7, 31, 253, 0, 506, 0, 0, 0, 24, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (121, 20121, 'Giant Toad', '', 'poison_toad', 20.00, 10.00, 5, 'male', 'L2Monster', 'Fighter', 40, 80, 2.000, 70, 0.900, 40, 43, 30, 21, 20, 20, 178, 5, 11, 49, 8, 32, 253, 0, 506, 0, 0, 0, 50, 100, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (122, 20130, 'Orc', '', 'orc', 10.00, 21.00, 6, 'male', 'L2Monster', 'Fighter', 40, 94, 2.000, 77, 0.900, 40, 43, 30, 21, 20, 20, 214, 6, 13, 51, 9, 34, 253, 0, 506, 156, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (123, 20131, 'Orc Grunt', '', 'orc', 10.00, 21.00, 7, 'male', 'L2Monster', 'Fighter', 40, 108, 2.000, 85, 0.900, 40, 43, 30, 21, 20, 20, 249, 8, 14, 54, 10, 36, 253, 0, 506, 4, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (124, 20132, 'Werewolf', '', 'werewolf', 10.00, 26.00, 9, 'male', 'L2Monster', 'Fighter', 40, 143, 2.000, 100, 0.900, 40, 43, 30, 21, 20, 20, 321, 11, 18, 59, 12, 39, 253, 0, 506, 0, 0, 0, 50, 120, 'werewolf_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (125, 20133, 'Bugbear', '', 'bugbear', 17.00, 35.00, 21, 'male', 'L2Monster', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 780, 36, 53, 99, 36, 66, 253, 500, 506, 4, 0, 0, 55, 130, 'bugbear_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (126, 20134, 'Cave Maiden', '', 'cave_maiden', 25.00, 65.00, 59, 'female', 'L2Monster', 'Fighter', 40, 1881, 6.500, 1007, 2.400, 40, 43, 30, 21, 20, 20, 6135, 524, 684, 360, 466, 240, 253, 500, 506, 68, 0, 0, 70, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (127, 20135, 'Alligator', '', 'crocodile', 28.00, 11.50, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 2848, 184, 227, 203, 155, 134, 253, 500, 506, 0, 0, 0, 70, 174, 'croc_clan2', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (128, 20136, 'Death Knight', '', 'death_knight', 12.00, 31.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 14026, 1012, 425, 278, 291, 204, 253, 500, 506, 75, 0, 0, 27, 110, 'undead_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (129, 20137, 'Drake', '', 'drake', 30.00, 100.00, 57, 'male', 'L2Monster', 'Mystic', 40, 1777, 6.500, 948, 2.400, 40, 43, 30, 21, 20, 20, 5784, 481, 619, 340, 423, 226, 253, 500, 506, 0, 0, 0, 70, 174, 'dragon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (130, 20138, 'Gargoyle', '', 'gargoyle', 16.00, 50.00, 27, 'male', 'L2Monster', 'Fighter', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 1136, 58, 87, 125, 59, 84, 253, 500, 506, 0, 0, 0, 140, 140, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (131, 20139, 'Giant Bee', '', 'giant_bee', 8.00, 24.50, 16, 'male', 'L2Monster', 'Fighter', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 471, 19, 34, 80, 23, 54, 253, 0, 506, 0, 0, 0, 90, 90, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (132, 20140, 'Giant Leech', '', 'giant_leech', 70.00, 29.00, 24, 'male', 'L2Monster', 'Fighter', 40, 435, 3.500, 246, 1.500, 40, 43, 30, 21, 20, 20, 954, 47, 68, 112, 46, 75, 253, 500, 506, 0, 0, 0, 50, 110, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (133, 20141, 'Giant Wild Hog', '', 'giant_wild_hog', 35.00, 27.00, 47, 'male', 'L2Monster', 'Fighter', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 3277, 235, 356, 254, 243, 169, 253, 500, 506, 0, 0, 0, 35, 120, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (134, 20142, 'Griffon', '', 'griffin', 20.00, 44.00, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 594, 26, 48, 95, 33, 63, 253, 0, 506, 0, 0, 0, 90, 90, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (135, 20143, 'Grizzly', '', 'grizzly', 21.00, 40.00, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 436, 16, 23, 67, 16, 44, 253, 500, 506, 0, 0, 0, 40, 110, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (136, 20144, 'Hangman Tree', '', 'hanged_man_ripper', 35.00, 80.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 2181, 130, 160, 170, 109, 113, 253, 500, 506, 0, 0, 0, 55, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (137, 20145, 'Harpy', '', 'harpy', 10.00, 42.00, 32, 'female', 'L2Monster', 'Fighter', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 1805, 101, 128, 152, 87, 102, 253, 500, 506, 0, 0, 0, 60, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (138, 20146, 'Headless Knight', '', 'headless_knight', 21.00, 31.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 4450, 335, 425, 278, 291, 185, 253, 500, 506, 124, 0, 0, 70, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (139, 20147, 'Hobgoblin', '', 'hobgoblin', 12.00, 24.00, 21, 'male', 'L2Monster', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 917, 42, 53, 99, 36, 66, 253, 0, 506, 4, 0, 0, 45, 110, 'goblin_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (140, 20148, 'Hungry Spirit', '', 'hungry_spirit', 30.00, 40.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 2350, 151, 227, 203, 155, 134, 253, 500, 506, 0, 0, 0, 15, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (141, 20149, 'Iron Golem', '', 'iron_golem', 18.00, 34.00, 38, 'male', 'L2Monster', 'Mystic', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 3029, 188, 198, 188, 136, 126, 253, 500, 506, 0, 0, 0, 20, 20, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (142, 20150, 'King Bugbear', '', 'king_bugbear', 15.00, 40.00, 32, 'male', 'L2Monster', 'Fighter', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 1519, 85, 128, 152, 87, 102, 253, 500, 506, 88, 0, 0, 55, 130, 'bugbear_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (143, 20151, 'Kobold', '', 'kobold', 10.00, 15.00, 4, 'male', 'L2Monster', 'Fighter', 40, 68, 2.000, 62, 0.900, 40, 43, 30, 21, 20, 20, 119, 3, 10, 47, 7, 31, 253, 0, 506, 4, 0, 0, 47, 110, 'goblin_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (144, 20152, 'Lizardman', '', 'virud_lizardman', 10.00, 23.00, 19, 'male', 'L2Monster', 'Fighter', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 565, 25, 44, 91, 30, 60, 253, 0, 506, 291, 0, 0, 43, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (145, 20153, 'Magical Weaver', '', 'magical_weaver', 11.00, 20.00, 11, 'male', 'L2Monster', 'Mystic', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 392, 15, 21, 64, 14, 43, 253, 0, 506, 0, 0, 0, 90, 90, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (146, 20154, 'Mandragora Sprout', '', 'manadragora', 14.00, 17.80, 21, 'female', 'L2Monster', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 917, 42, 53, 99, 36, 66, 253, 0, 506, 0, 0, 0, 80, 80, 'mandragora_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (147, 20155, 'Mandragora Sapling', '', 'mandragora_a', 15.00, 26.00, 23, 'female', 'L2Monster', 'Fighter', 40, 411, 3.500, 232, 1.500, 40, 43, 30, 21, 20, 20, 1075, 52, 63, 108, 43, 72, 253, 500, 506, 0, 0, 0, 80, 120, 'mandragora_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (148, 20156, 'Mandragora Blossom', '', 'mandragora_b', 12.00, 25.50, 25, 'female', 'L2Monster', 'Fighter', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 1215, 61, 74, 116, 50, 78, 253, 500, 506, 0, 0, 0, 80, 120, 'mandragora_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.13, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (149, 20157, 'Marsh Stakato', '', 'marsh_stakato', 10.00, 20.00, 29, 'male', 'L2Monster', 'Fighter', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 1811, 97, 101, 136, 70, 91, 253, 500, 506, 223, 0, 0, 21, 120, 'stakato_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (150, 20158, 'Medusa', '', 'medusa', 10.00, 25.00, 34, 'female', 'L2Monster', 'Mystic', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 2058, 120, 149, 164, 102, 109, 253, 500, 506, 0, 0, 0, 50, 110, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (151, 20159, 'Minotaur', '', 'minotaur', 21.00, 45.50, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 2716, 184, 277, 223, 189, 149, 253, 500, 506, 300, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (152, 20160, 'Neer Crawler', '', 'neer_crawler', 14.00, 22.00, 28, 'male', 'L2Monster', 'Fighter', 40, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 1442, 76, 95, 131, 64, 87, 253, 500, 506, 0, 0, 0, 50, 90, 'neer_crawler_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (153, 20161, 'Oel Mahum', '', 'oel_mahum', 20.00, 37.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 4846, 380, 503, 304, 344, 223, 253, 500, 506, 127, 0, 0, 70, 110, 'oel_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (154, 20162, 'Ogre', '', 'ogre', 21.00, 44.00, 41, 'male', 'L2Monster', 'Fighter', 40, 1008, 5.500, 505, 2.100, 40, 43, 30, 21, 20, 20, 2469, 162, 243, 209, 166, 139, 253, 500, 506, 98, 0, 0, 22, 80, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (155, 20163, 'Ol Mahum', '', 'ol_mahum', 13.50, 25.00, 23, 'male', 'L2Monster', 'Fighter', 40, 411, 3.500, 232, 1.500, 40, 43, 30, 21, 20, 20, 878, 42, 63, 108, 43, 72, 253, 0, 506, 2, 0, 0, 50, 110, 'ol_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (156, 20164, 'Ol Mahum Archer', '', 'ol_mahum_archer', 14.00, 25.00, 25, 'male', 'L2Monster', 'Ranger', 1100, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 1043, 53, 74, 116, 50, 78, 253, 500, 506, 14, 0, 0, 50, 110, 'ol_mahum_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.93, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (157, 20165, 'Ol Mahum Champion', '', 'ol_mahum_champion', 14.00, 27.00, 29, 'male', 'L2Monster', 'Fighter', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 1509, 80, 101, 136, 70, 91, 253, 500, 506, 69, 0, 0, 50, 110, 'ol_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (158, 20166, 'Succubus', '', 'succubus', 10.00, 36.00, 32, 'female', 'L2Monster', 'Mystic', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 1519, 85, 128, 152, 87, 102, 253, 500, 506, 0, 0, 0, 60, 100, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (159, 20167, 'Serpent Slave', '', 'serpent_slave', 17.00, 46.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 2374, 154, 227, 203, 155, 134, 253, 500, 506, 73, 0, 0, 70, 110, 'serpent_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (160, 20168, 'Silenos', '', 'silenos', 14.00, 32.50, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1571, 86, 111, 140, 75, 94, 253, 0, 506, 88, 0, 0, 70, 110, 'silenos_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (161, 20169, 'Skeleton Royal Guard', '', 'skeleton_royal_guard', 11.00, 28.50, 26, 'male', 'L2Monster', 'Fighter', 40, 488, 3.500, 273, 1.500, 40, 43, 30, 21, 20, 20, 1078, 54, 81, 121, 55, 81, 253, 500, 506, 946, 945, 0, 80, 120, 'skeleton_clan', 300, 0, 20, 53, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (162, 20170, 'Spartoi', '', 'spartoi', 11.00, 27.00, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 454, 19, 31, 77, 21, 51, 253, 500, 506, 946, 945, 0, 60, 140, 'skeleton_clan', 300, 0, 20, 37, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (163, 20171, 'Specter', '', 'dark_horror', 20.00, 35.00, 26, 'male', 'L2Monster', 'Fighter', 40, 488, 3.500, 273, 1.500, 40, 43, 30, 21, 20, 20, 1294, 65, 81, 121, 55, 81, 253, 500, 506, 0, 0, 0, 100, 100, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (164, 20172, 'Sylph', '', 'sylph', 11.00, 35.00, 10, 'female', 'L2Monster', 'Mystic', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 297, 10, 19, 61, 13, 41, 253, 0, 506, 0, 0, 0, 60, 60, 'elemental2_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (165, 20173, 'Troll', '', 'troll', 21.00, 35.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 1600, 91, 138, 157, 94, 105, 253, 500, 506, 0, 0, 0, 55, 110, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (166, 20174, 'Two-Headed Giant', '', 'twin_headed_giant', 17.00, 39.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 1799, 107, 160, 170, 109, 113, 253, 500, 506, 4, 0, 0, 45, 100, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (167, 20175, 'Walking Fungus', '', 'walking_fungus', 15.00, 22.50, 8, 'male', 'L2Monster', 'Fighter', 40, 125, 2.000, 93, 0.900, 40, 43, 30, 21, 20, 20, 237, 8, 16, 56, 11, 37, 253, 0, 506, 0, 0, 0, 70, 110, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (168, 20176, 'Wyrm', '', 'wyrm', 29.00, 72.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 2181, 130, 160, 170, 109, 113, 253, 500, 506, 0, 0, 0, 70, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.19, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (169, 20177, 'Zombie', '', 'zombie', 13.00, 21.00, 6, 'male', 'L2Monster', 'Mystic', 40, 94, 2.000, 77, 0.900, 40, 43, 30, 21, 20, 20, 178, 5, 13, 51, 9, 34, 253, 0, 506, 0, 0, 0, 15, 15, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (170, 20189, 'Puma', '', 'onyx_beast', 14.00, 14.50, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 441, 18, 31, 77, 21, 51, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.24, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (171, 20190, 'Skeleton Marauder', '', 'skeleton_archer', 11.00, 27.00, 29, 'male', 'L2Monster', 'Ranger', 1100, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 1568, 84, 101, 136, 70, 91, 253, 500, 506, 14, 0, 0, 40, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (172, 20191, 'Skeleton Raider', '', 'skeleton', 11.00, 25.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1602, 88, 111, 140, 75, 94, 253, 500, 506, 946, 945, 0, 60, 140, 'skeleton_clan', 300, 0, 20, 59, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (173, 20192, 'Tyrant', '', 'grave', 15.00, 29.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 2138, 126, 160, 170, 109, 113, 253, 0, 506, 0, 0, 0, 70, 174, 'tyrant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (174, 20193, 'Tyrant Kingpin', '', 'grave', 15.00, 29.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 2307, 139, 173, 176, 118, 118, 253, 500, 506, 0, 0, 0, 70, 174, 'tyrant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (175, 20194, 'Queen Undine', '', 'undine', 12.00, 27.00, 50, 'female', 'L2Monster', 'Mystic', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 3709, 280, 425, 278, 291, 185, 253, 500, 506, 0, 0, 0, 60, 60, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (176, 20197, 'Sorrow Maiden', '', 'sylph', 11.00, 35.00, 27, 'female', 'L2Monster', 'Mystic', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 1323, 67, 87, 125, 59, 84, 253, 0, 506, 0, 0, 0, 60, 60, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (177, 20198, 'Neer Ghoul Berserker', '', 'neer_crawler', 14.00, 22.00, 29, 'male', 'L2Monster', 'Fighter', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 1522, 82, 101, 136, 70, 91, 253, 500, 506, 0, 0, 0, 50, 90, 'neer_crawler_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (178, 20199, 'Amber Basilisk', '', 'lesser_basilisk', 34.00, 25.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1869, 102, 111, 140, 75, 94, 253, 0, 506, 0, 0, 0, 35, 131, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (179, 20200, 'Strain', '', 'hungry_spirit', 30.00, 40.00, 31, 'male', 'L2Monster', 'Fighter', 40, 636, 4.500, 344, 1.800, 40, 43, 30, 21, 20, 20, 1661, 92, 119, 146, 82, 97, 253, 0, 506, 0, 0, 0, 15, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (180, 20201, 'Ghoul', '', 'zombie', 13.00, 21.00, 32, 'male', 'L2Monster', 'Mystic', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 2502, 140, 128, 152, 87, 102, 253, 0, 506, 0, 0, 0, 15, 15, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (181, 20202, 'Dead Seeker', '', 'vampire_bat', 10.00, 33.50, 34, 'male', 'L2Monster', 'Mystic', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 1998, 116, 149, 164, 102, 109, 253, 0, 506, 0, 0, 0, 60, 80, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (182, 20203, 'Dion Grizzly', '', 'grizzly', 21.00, 40.00, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 706, 31, 48, 95, 33, 63, 253, 0, 506, 0, 0, 0, 40, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (183, 20204, 'Bloody Bee', '', 'giant_bee', 8.00, 24.50, 23, 'male', 'L2Monster', 'Fighter', 40, 411, 3.500, 232, 1.500, 40, 43, 30, 21, 20, 20, 1148, 55, 63, 108, 43, 72, 253, 0, 506, 0, 0, 0, 90, 90, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (184, 20205, 'Dire Wolf', '', 'dire_wolf', 13.00, 11.00, 24, 'male', 'L2Monster', 'Fighter', 40, 435, 3.500, 246, 1.500, 40, 43, 30, 21, 20, 20, 1145, 56, 68, 112, 46, 75, 253, 500, 506, 0, 0, 0, 24, 110, 'wolf_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (185, 20206, 'Kadif Werewolf', '', 'werewolf', 10.00, 26.00, 25, 'male', 'L2Monster', 'Fighter', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 1179, 59, 74, 116, 50, 78, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (186, 20207, 'Ol Mahum Guerilla', '', 'ol_mahum', 13.50, 25.00, 26, 'male', 'L2Monster', 'Fighter', 40, 488, 3.500, 273, 1.500, 40, 43, 30, 21, 20, 20, 2359, 119, 81, 121, 55, 81, 253, 0, 506, 2, 19, 0, 50, 110, 'ol_mahum_clan', 300, 0, 20, 53, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (187, 20208, 'Ol Mahum Raider', '', 'ol_mahum', 13.50, 25.00, 27, 'male', 'L2Monster', 'Fighter', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 2485, 127, 87, 125, 59, 84, 253, 0, 506, 10, 0, 0, 50, 110, 'ol_mahum_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (188, 20209, 'Ol Mahum Marksman', '', 'ol_mahum_archer', 14.00, 25.00, 28, 'male', 'L2Monster', 'Ranger', 1100, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 2709, 142, 95, 131, 64, 87, 253, 0, 506, 275, 0, 0, 50, 110, 'ol_mahum_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.93, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (189, 20210, 'Ol Mahum Sergeant', '', 'ol_mahum', 13.50, 25.00, 29, 'male', 'L2Monster', 'Fighter', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 2776, 149, 101, 136, 70, 91, 253, 0, 506, 68, 19, 0, 50, 110, 'ol_mahum_clan', 300, 0, 20, 58, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (190, 20211, 'Ol Mahum Captain', '', 'ol_mahum_champion', 14.00, 27.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 2980, 163, 111, 140, 75, 94, 253, 500, 506, 123, 19, 0, 50, 110, 'ol_mahum_clan', 300, 0, 20, 59, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (191, 20212, 'Bloody Axe Turmak', '', 'ol_mahum_champion', 14.00, 27.00, 34, 'male', 'L2Monster', 'Fighter', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 3528, 206, 149, 164, 102, 109, 253, 500, 506, 69, 19, 0, 50, 110, 'ol_mahum_clan', 300, 0, 20, 66, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (192, 20213, 'Porta', '', 'stone_golem', 20.00, 31.00, 40, 'male', 'L2Monster', 'Mystic', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 10438, 647, 227, 203, 155, 148, 253, 0, 506, 0, 0, 0, 23, 23, 'porta_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (193, 20214, 'Excuro', '', 'mana_vampire', 11.00, 20.00, 41, 'male', 'L2Monster', 'Mystic', 40, 1008, 5.500, 505, 2.100, 40, 43, 30, 21, 20, 20, 6668, 417, 243, 209, 166, 153, 253, 0, 506, 0, 0, 0, 90, 90, 'porta_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (194, 20215, 'Mordeo', '', 'onyx_beast', 14.00, 14.50, 42, 'male', 'L2Monster', 'Fighter', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 7709, 493, 259, 216, 177, 159, 253, 500, 506, 0, 0, 0, 30, 120, 'porta_clan', 400, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (195, 20216, 'Ricenseo', '', 'monster_eye', 21.00, 43.00, 43, 'male', 'L2Monster', 'Mystic', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 6864, 442, 277, 223, 189, 164, 253, 0, 506, 0, 0, 0, 90, 90, 'porta_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (196, 20217, 'Krator', '', 'stone_golem', 20.00, 31.00, 44, 'male', 'L2Monster', 'Mystic', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 7997, 523, 295, 230, 202, 169, 253, 500, 506, 0, 0, 0, 23, 23, 'porta_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (197, 20218, 'Premo', '', 'troll', 21.00, 35.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 8303, 552, 315, 239, 214, 174, 253, 0, 506, 0, 0, 0, 55, 110, 'porta_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (198, 20219, 'Validus', '', 'grave', 15.00, 29.00, 46, 'male', 'L2Monster', 'Fighter', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 9348, 635, 335, 246, 228, 180, 253, 0, 506, 0, 0, 0, 70, 110, 'torfe_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (199, 20220, 'Dicor', '', 'mandragora_b', 12.00, 25.50, 47, 'female', 'L2Monster', 'Fighter', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 9429, 646, 356, 254, 243, 186, 253, 500, 506, 0, 0, 0, 80, 120, 'torfe_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.13, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (200, 20221, 'Perum', '', 'iron_golem', 18.00, 34.00, 48, 'male', 'L2Monster', 'Mystic', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 13708, 955, 378, 262, 258, 192, 253, 500, 506, 0, 0, 0, 20, 20, 'torfe_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (201, 20222, 'Torfe', '', 'grave', 15.00, 29.00, 49, 'male', 'L2Monster', 'Fighter', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 10330, 730, 400, 270, 273, 197, 253, 0, 506, 0, 0, 0, 70, 110, 'torfe_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (202, 20223, 'Mandragora Sprout', '', 'manadragora', 14.00, 17.80, 20, 'female', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 784, 35, 48, 95, 33, 63, 253, 0, 506, 0, 0, 0, 80, 80, 'mandragora_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (203, 20224, 'Ol Mahum Ranger', '', 'ol_mahum_archer', 14.00, 25.00, 22, 'male', 'L2Monster', 'Ranger', 1100, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 1271, 60, 58, 103, 39, 69, 253, 0, 506, 13, 0, 0, 50, 110, 'ol_mahum_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.93, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (204, 20225, 'Giant Mist Leech', '', 'giant_leech', 70.00, 29.00, 25, 'male', 'L2Monster', 'Fighter', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 1191, 60, 74, 116, 50, 78, 253, 0, 506, 0, 0, 0, 50, 110, 'giant_leech_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (205, 20226, 'Gray Ant', '', 'ant', 26.00, 15.00, 26, 'male', 'L2Monster', 'Fighter', 40, 488, 3.500, 273, 1.500, 40, 43, 30, 21, 20, 20, 1268, 64, 81, 121, 55, 81, 253, 0, 506, 0, 0, 0, 40, 130, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (206, 20227, 'Horror Mist Ripper', '', 'dark_horror', 20.00, 35.00, 27, 'male', 'L2Monster', 'Fighter', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 1349, 70, 87, 125, 59, 84, 253, 500, 506, 0, 0, 0, 100, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (207, 20228, 'Giant Crimson Ant', '', 'ant_soldier', 35.00, 17.00, 28, 'male', 'L2Monster', 'Fighter', 40, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 1555, 82, 95, 131, 64, 87, 253, 0, 506, 0, 0, 0, 80, 130, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (208, 20229, 'Stinger Wasp', '', 'giant_bee', 8.00, 24.50, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1745, 95, 111, 140, 75, 94, 253, 500, 506, 0, 0, 0, 90, 90, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (209, 20230, 'Marsh Stakato Worker', '', 'marsh_stakato_worker', 9.00, 21.00, 31, 'male', 'L2Monster', 'Fighter', 40, 636, 4.500, 344, 1.800, 40, 43, 30, 21, 20, 20, 1996, 110, 119, 146, 82, 97, 253, 0, 506, 153, 0, 0, 20, 140, 'stakato_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (210, 20231, 'Toad Lord', '', 'poison_toad', 20.00, 10.00, 32, 'male', 'L2Monster', 'Fighter', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 1946, 109, 128, 152, 87, 102, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (211, 20232, 'Marsh Stakato Soldier', '', 'marsh_stakato_soldier', 10.00, 25.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 1901, 109, 138, 157, 94, 105, 253, 0, 506, 217, 0, 0, 30, 155, 'stakato_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (212, 20233, 'Marsh Spider', '', 'poison_spider', 27.00, 25.50, 34, 'male', 'L2Monster', 'Mystic', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 2241, 131, 149, 164, 102, 109, 253, 500, 506, 0, 0, 0, 60, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (213, 20234, 'Marsh Stakato Drone', '', 'marsh_stakato_drone', 9.00, 24.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 2268, 134, 160, 170, 109, 113, 253, 500, 506, 219, 0, 0, 80, 174, 'stakato_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (214, 20235, 'Shackle', '', 'hungry_spirit', 30.00, 40.00, 45, 'male', 'L2Monster', 'Mystic', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 3569, 248, 315, 239, 214, 158, 253, 500, 506, 0, 0, 0, 15, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (215, 20236, 'Cave Servant', '', 'skeleton', 11.00, 25.00, 46, 'male', 'L2Monster', 'Fighter', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 3693, 262, 335, 246, 228, 163, 253, 0, 506, 79, 945, 0, 60, 174, 'cave_servant_clan', 300, 0, 20, 91, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (216, 20237, 'Cave Servant Archer', '', 'skeleton_archer', 11.00, 27.00, 47, 'male', 'L2Monster', 'Ranger', 1100, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 4972, 356, 356, 254, 243, 169, 253, 0, 506, 14, 0, 0, 40, 174, 'cave_servant_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (217, 20238, 'Cave Servant Warrior', '', 'skeleton', 11.00, 25.00, 48, 'male', 'L2Monster', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 4785, 349, 378, 262, 258, 174, 253, 0, 506, 77, 2495, 0, 60, 174, 'cave_servant_clan', 300, 0, 20, 96, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (218, 20239, 'Cave Servant Captain', '', 'spartoi', 11.00, 27.00, 49, 'male', 'L2Monster', 'Fighter', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 5086, 376, 400, 270, 273, 179, 253, 500, 506, 73, 2495, 0, 60, 174, 'cave_servant_clan', 300, 0, 20, 98, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (219, 20240, 'Royal Cave Servant', '', 'skeleton_royal_guard', 11.00, 28.50, 51, 'male', 'L2Monster', 'Fighter', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 5455, 416, 449, 287, 307, 190, 253, 0, 506, 946, 945, 0, 80, 174, 'cave_servant_clan', 400, 0, 20, 102, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (220, 20241, 'Hunter Gargoyle', '', 'hunter_gargoyle', 25.00, 65.00, 52, 'male', 'L2Monster', 'Fighter', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 5420, 419, 475, 296, 324, 216, 253, 0, 506, 0, 0, 0, 100, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (221, 20242, 'Dustwind Gargoyle', '', 'hunter_gargoyle', 25.00, 65.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 5776, 454, 503, 304, 344, 203, 253, 0, 506, 0, 0, 0, 100, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (222, 20243, 'Thunder Wyrm', '', 'wyrm', 29.00, 72.00, 54, 'male', 'L2Monster', 'Fighter', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 5140, 409, 531, 313, 362, 209, 253, 500, 506, 0, 0, 0, 70, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.19, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (223, 20244, 'Malruk Succubus', '', 'succubus', 10.00, 36.00, 55, 'female', 'L2Monster', 'Mystic', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 5279, 426, 559, 323, 382, 215, 253, 0, 506, 0, 0, 0, 60, 174, 'succubus_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (224, 20245, 'Malruk Succubus Turen', '', 'succubus', 10.00, 36.00, 56, 'female', 'L2Monster', 'Mystic', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 5473, 450, 589, 331, 402, 220, 253, 0, 506, 0, 0, 0, 60, 174, 'succubus_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (225, 20246, 'Cave Keeper', '', 'serpent_slave', 17.00, 46.00, 58, 'male', 'L2Monster', 'Fighter', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 6987, 590, 651, 350, 444, 232, 253, 0, 506, 223, 0, 0, 70, 174, 'cave_servant_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (226, 20248, 'Turak Bugbear', '', 'bugbear', 17.00, 35.00, 31, 'male', 'L2Monster', 'Fighter', 40, 636, 4.500, 344, 1.800, 40, 43, 30, 21, 20, 20, 1677, 94, 119, 146, 82, 97, 253, 0, 506, 88, 0, 0, 55, 130, 'bugbear_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (227, 20249, 'Turak Bugbear Warrior', '', 'bugbear', 17.00, 35.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 3606, 206, 138, 157, 94, 105, 253, 500, 506, 73, 0, 0, 55, 130, 'bugbear_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (228, 20250, 'Glass Jaguar', '', 'onyx_beast', 14.00, 14.50, 27, 'male', 'L2Monster', 'Fighter', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 1323, 67, 87, 125, 59, 84, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (229, 20251, 'Delu Lizardman', '', 'virud_lizardman', 10.00, 23.00, 28, 'male', 'L2Monster', 'Fighter', 40, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 1400, 73, 95, 131, 64, 87, 253, 0, 506, 1, 19, 0, 43, 130, '', 300, 0, 20, 56, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (230, 20252, 'Delu Lizardman Scout', '', 'virud_lizardman', 10.00, 23.00, 29, 'male', 'L2Monster', 'Fighter', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 1477, 79, 101, 136, 70, 91, 253, 0, 506, 123, 0, 0, 43, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (231, 20253, 'Delu Lizardman Warrior', '', 'virud_lizardman_warrior', 12.00, 30.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1586, 86, 111, 140, 75, 94, 253, 500, 506, 16, 0, 0, 52, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (232, 20254, 'Skeleton Axeman', '', 'skeleton', 11.00, 25.00, 28, 'male', 'L2Monster', 'Fighter', 40, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 1442, 76, 95, 131, 64, 87, 253, 500, 506, 86, 0, 0, 60, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (233, 20255, 'Batur Orc', '', 'batur_orc', 9.00, 21.50, 31, 'male', 'L2Monster', 'Fighter', 40, 636, 4.500, 344, 1.800, 40, 43, 30, 21, 20, 20, 1398, 78, 119, 146, 82, 97, 253, 0, 506, 123, 0, 0, 80, 130, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (234, 20256, 'Batur Orc Archer', '', 'batur_orc_archer', 11.00, 21.50, 32, 'male', 'L2Monster', 'Ranger', 1100, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 1921, 108, 128, 152, 87, 102, 253, 0, 506, 13, 0, 0, 45, 130, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.96, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (235, 20257, 'Batur Orc Warrior', '', 'batur_orc_warrior', 10.00, 20.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 1922, 110, 138, 157, 94, 105, 253, 500, 506, 123, 19, 0, 80, 120, 'orc_clan', 300, 0, 20, 65, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (236, 20258, 'Batur Orc Shaman', '', 'batur_orc_shaman', 11.00, 16.00, 34, 'male', 'L2Monster', 'Priest', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 1681, 98, 149, 164, 102, 109, 253, 0, 506, 7, 0, 0, 50, 120, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (237, 20259, 'Batur Orc Overlord', '', 'batur_orc_overlord', 12.00, 24.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 2163, 128, 160, 170, 109, 113, 253, 500, 506, 79, 0, 0, 80, 140, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (238, 20260, 'Orc Champion', '', 'orc_champion', 10.00, 23.00, 14, 'male', 'L2Monster', 'Fighter', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 435, 17, 28, 73, 20, 48, 253, 500, 506, 2, 0, 0, 45, 130, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (239, 20261, 'Orc Shaman', '', 'orc_shaman', 9.00, 22.00, 17, 'male', 'L2Monster', 'Priest', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 505, 21, 37, 84, 25, 55, 253, 0, 506, 7, 0, 0, 45, 120, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.26, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (240, 20265, 'Monster Eye Searcher', '', 'monster_eye', 21.00, 43.00, 22, 'male', 'L2Monster', 'Mystic', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 1833, 86, 58, 103, 39, 69, 253, 0, 506, 0, 0, 0, 90, 159, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (241, 20266, 'Monster Eye Gazer', '', 'monster_eye', 21.00, 43.00, 25, 'male', 'L2Monster', 'Mystic', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 1191, 60, 74, 116, 50, 78, 253, 0, 506, 0, 0, 0, 90, 159, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (242, 20267, 'Breka Orc', '', 'batur_orc', 9.00, 21.50, 31, 'male', 'L2Monster', 'Fighter', 40, 636, 4.500, 344, 1.800, 40, 43, 30, 21, 20, 20, 1677, 94, 119, 146, 82, 97, 253, 0, 506, 215, 0, 0, 80, 130, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (243, 20268, 'Breka Orc Archer', '', 'batur_orc_archer', 11.00, 21.50, 32, 'male', 'L2Monster', 'Ranger', 1100, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 2305, 130, 128, 152, 87, 102, 253, 0, 506, 275, 0, 0, 45, 130, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.96, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (244, 20269, 'Breka Orc Shaman', '', 'batur_orc_shaman', 11.00, 16.00, 34, 'male', 'L2Monster', 'Priest', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 2018, 118, 149, 164, 102, 109, 253, 0, 506, 7, 0, 0, 50, 120, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (245, 20270, 'Breka Orc Overlord', '', 'batur_orc_overlord', 12.00, 24.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 2857, 169, 160, 170, 109, 113, 253, 500, 506, 79, 0, 0, 80, 174, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (246, 20271, 'Breka Orc Warrior', '', 'batur_orc_warrior', 10.00, 20.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 2307, 132, 138, 157, 94, 105, 253, 500, 506, 123, 20, 0, 80, 120, 'orc_clan', 300, 0, 20, 65, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (247, 20272, 'Cave Servant', '', 'skeleton', 11.00, 25.00, 46, 'male', 'L2Monster', 'Fighter', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 3078, 218, 335, 246, 228, 163, 253, 0, 506, 79, 945, 0, 60, 140, 'cave_servant_clan', 300, 0, 20, 91, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (248, 20273, 'Cave Servant Archer', '', 'skeleton_archer', 11.00, 27.00, 47, 'male', 'L2Monster', 'Ranger', 1100, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 3309, 238, 356, 254, 243, 169, 253, 0, 506, 275, 0, 0, 40, 140, 'cave_servant_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (249, 20274, 'Cave Servant Warrior', '', 'skeleton', 11.00, 25.00, 48, 'male', 'L2Monster', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 3351, 245, 378, 262, 258, 174, 253, 0, 506, 77, 0, 0, 60, 140, 'cave_servant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (250, 20275, 'Cave Servant Captain', '', 'spartoi', 11.00, 27.00, 49, 'male', 'L2Monster', 'Fighter', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 3562, 263, 400, 270, 273, 179, 253, 500, 506, 73, 0, 0, 60, 140, 'cave_servant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (251, 20276, 'Royal Cave Servant', '', 'skeleton_royal_guard', 11.00, 28.50, 51, 'male', 'L2Monster', 'Fighter', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 3783, 288, 449, 287, 307, 190, 253, 0, 506, 946, 945, 0, 80, 120, 'cave_servant_clan', 300, 0, 20, 102, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (252, 20277, 'Cave Keeper', '', 'serpent_slave', 17.00, 46.00, 58, 'male', 'L2Monster', 'Fighter', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 4893, 413, 651, 350, 444, 232, 253, 0, 506, 223, 0, 0, 70, 110, 'cave_servant_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (253, 20279, 'Shackle', '', 'hungry_spirit', 30.00, 40.00, 45, 'male', 'L2Monster', 'Mystic', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 2974, 206, 315, 239, 214, 158, 253, 500, 506, 0, 0, 0, 15, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (254, 20280, 'Headless Knight', '', 'headless_knight', 21.00, 31.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 3709, 280, 425, 278, 291, 185, 253, 500, 506, 124, 0, 0, 70, 110, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (255, 20281, 'Dustwind Gargoyle', '', 'hunter_gargoyle', 25.00, 65.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 4045, 318, 503, 304, 344, 203, 253, 0, 506, 0, 0, 0, 100, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (256, 20282, 'Thunder Wyrm', '', 'wyrm', 29.00, 72.00, 54, 'male', 'L2Monster', 'Fighter', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 4283, 342, 531, 313, 362, 209, 253, 500, 506, 0, 0, 0, 70, 70, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.19, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (257, 20283, 'Malruk Succubus', '', 'succubus', 10.00, 36.00, 55, 'female', 'L2Monster', 'Mystic', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 4400, 355, 559, 323, 382, 215, 253, 0, 506, 0, 0, 0, 60, 100, 'succubus_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (258, 20284, 'Malruk Succubus Turen', '', 'succubus', 10.00, 36.00, 56, 'female', 'L2Monster', 'Mystic', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 4561, 374, 589, 331, 402, 220, 253, 0, 506, 0, 0, 0, 60, 100, 'succubus_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (259, 20285, 'Drake', '', 'drake', 30.00, 100.00, 57, 'male', 'L2Monster', 'Mystic', 40, 1777, 6.500, 948, 2.400, 40, 43, 30, 21, 20, 20, 4820, 401, 619, 340, 423, 226, 253, 500, 506, 0, 0, 0, 70, 70, 'dragon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (260, 20286, 'Hunter Gargoyle', '', 'hunter_gargoyle', 25.00, 65.00, 52, 'male', 'L2Monster', 'Fighter', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 3894, 301, 475, 296, 324, 196, 253, 0, 506, 0, 0, 0, 100, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (261, 20287, 'Cave Maiden', '', 'cave_maiden', 25.00, 65.00, 59, 'female', 'L2Monster', 'Fighter', 40, 1881, 6.500, 1007, 2.400, 40, 43, 30, 21, 20, 20, 5113, 437, 684, 360, 466, 240, 253, 500, 506, 68, 0, 0, 70, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (262, 20291, 'Enku Orc Champion', '', 'orc_champion', 10.00, 23.00, 21, 'male', 'L2Monster', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 1113, 52, 53, 99, 36, 66, 253, 500, 506, 2, 0, 0, 45, 130, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (263, 20292, 'Enku Orc Shaman', '', 'orc_shaman', 9.00, 22.00, 20, 'male', 'L2Monster', 'Priest', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 813, 36, 48, 95, 33, 63, 253, 0, 506, 7, 0, 0, 45, 120, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (264, 20293, 'Virud Lizardman', '', 'virud_lizardman', 10.00, 23.00, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 594, 26, 48, 95, 33, 63, 253, 0, 506, 291, 0, 0, 43, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (265, 20294, 'Virud Lizardman Matriarch', '', 'virud_lizardman_matriarch', 13.00, 37.00, 24, 'male', 'L2Monster', 'Fighter', 40, 435, 3.500, 246, 1.500, 40, 43, 30, 21, 20, 20, 1142, 56, 68, 112, 46, 75, 253, 500, 506, 2, 19, 0, 56, 130, 'lizardman_clan', 300, 0, 20, 49, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (266, 20295, 'Virud Lizardman Warrior', '', 'virud_lizardman_warrior', 12.00, 30.00, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 838, 40, 58, 103, 39, 69, 253, 500, 506, 16, 0, 0, 52, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (267, 20296, 'Virud Lizardman Scout', '', 'virud_lizardman_scout', 10.00, 22.00, 21, 'male', 'L2Monster', 'Ranger', 1100, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 787, 36, 53, 99, 36, 66, 253, 0, 506, 2507, 0, 0, 43, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (268, 20297, 'Virud Lizardman Shaman ', '', 'virud_lizardman_shaman', 10.00, 29.00, 23, 'male', 'L2Monster', 'Priest', 40, 411, 3.500, 232, 1.500, 40, 43, 30, 21, 20, 20, 878, 42, 63, 108, 43, 72, 253, 0, 506, 7, 0, 0, 43, 120, 'lizardman_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (269, 20298, 'Virud Lizardman Shaman ', '', 'virud_lizardman_shaman', 10.00, 29.00, 23, 'male', 'L2Monster', 'Priest', 40, 411, 3.500, 232, 1.500, 40, 43, 30, 21, 20, 20, 878, 42, 63, 108, 43, 72, 253, 0, 506, 7, 0, 0, 43, 120, 'lizardman_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (270, 20299, 'Zenta Lizardman', '', 'zenta_lizardman', 11.00, 32.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 2327, 150, 227, 203, 155, 134, 253, 0, 506, 68, 0, 0, 37, 140, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (271, 20300, 'Zenta Lizardman Matriarch', '', 'zenta_lizardman_matriarch', 20.00, 40.00, 44, 'male', 'L2Monster', 'Fighter', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 3418, 234, 295, 230, 202, 153, 253, 500, 506, 221, 0, 0, 53, 140, 'lizardman_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (272, 20301, 'Zenta Lizardman Scout', '', 'zenta_lizardman_scout', 11.00, 30.00, 41, 'male', 'L2Monster', 'Ranger', 1100, 1008, 5.500, 505, 2.100, 40, 43, 30, 21, 20, 20, 2518, 164, 243, 209, 166, 139, 253, 0, 506, 14, 0, 0, 37, 150, 'lizardman_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.93, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (273, 20302, 'Zenta Lizardman Warrior', '', 'zenta_lizardman_warrior', 13.00, 35.00, 42, 'male', 'L2Monster', 'Fighter', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 2617, 174, 259, 216, 177, 144, 253, 500, 506, 16, 0, 0, 40, 140, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (274, 20303, 'Zenta Lizardman Shaman', '', 'zenta_lizardman_shaman', 13.00, 35.00, 43, 'male', 'L2Monster', 'Priest', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 2689, 182, 277, 223, 189, 149, 253, 0, 506, 7, 0, 0, 43, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (275, 20304, 'Marsh Stakato Queen', '', 'marsh_stakato_queen', 15.00, 37.00, 36, 'female', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 2288, 138, 173, 176, 118, 118, 253, 500, 506, 74, 0, 0, 130, 130, 'stakato_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (276, 20305, 'Grave', '', 'grave', 15.00, 29.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 2350, 151, 227, 203, 155, 134, 253, 500, 506, 0, 0, 0, 70, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (277, 20307, 'Garum Werewolf', '', 'werewolf', 10.00, 26.00, 9, 'male', 'L2Monster', 'Fighter', 40, 143, 2.000, 100, 0.900, 40, 43, 30, 21, 20, 20, 321, 11, 18, 59, 12, 39, 253, 0, 506, 5, 0, 0, 50, 120, 'werewolf_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (278, 20308, 'Hook Spider', '', 'giant_spider', 26.00, 25.50, 16, 'male', 'L2Monster', 'Mystic', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 571, 23, 34, 80, 23, 54, 253, 0, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (279, 20309, 'Brown Fox', '', 'fox', 9.50, 10.00, 2, 'male', 'L2Monster', 'Fighter', 40, 48, 2.000, 47, 0.900, 40, 43, 30, 21, 20, 20, 59, 2, 8, 42, 5, 28, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (280, 20310, 'Brown Bear', '', 'grizzly_bi', 21.00, 50.00, 16, 'male', 'L2Monster', 'Fighter', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 577, 23, 34, 80, 23, 54, 253, 500, 506, 0, 0, 0, 40, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (281, 20311, 'Rakeclaw Imp', '', 'imp', 10.00, 24.00, 6, 'male', 'L2Monster', 'Fighter', 40, 94, 2.000, 77, 0.900, 40, 43, 30, 21, 20, 20, 214, 6, 13, 51, 9, 34, 253, 0, 506, 0, 0, 0, 60, 80, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (282, 20312, 'Rakeclaw Imp Hunter', '', 'imp', 10.00, 24.00, 7, 'male', 'L2Monster', 'Fighter', 40, 108, 2.000, 85, 0.900, 40, 43, 30, 21, 20, 20, 249, 8, 14, 54, 10, 36, 253, 0, 506, 0, 0, 0, 60, 80, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (283, 20313, 'Rakeclaw Imp Chieftain', '', 'imp_bi', 10.00, 30.00, 10, 'male', 'L2Monster', 'Fighter', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 363, 12, 19, 61, 13, 41, 253, 500, 506, 0, 0, 0, 60, 80, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (284, 20314, 'Great White Shark', '', 'great_white_shark', 20.00, 7.00, 42, 'male', 'L2Monster', 'Fighter', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 2617, 174, 259, 216, 177, 144, 253, 500, 506, 0, 0, 0, 80, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (285, 20316, 'Darkwing Bat', '', 'vampire_bat', 10.00, 33.50, 11, 'male', 'L2Monster', 'Mystic', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 392, 15, 21, 64, 14, 43, 253, 0, 506, 0, 0, 0, 60, 80, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (286, 20317, 'Black Wolf', '', 'wolf', 13.00, 9.00, 4, 'male', 'L2Monster', 'Fighter', 40, 68, 2.000, 62, 0.900, 40, 43, 30, 21, 20, 20, 141, 4, 10, 47, 7, 31, 253, 0, 506, 0, 0, 0, 24, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (287, 20318, 'Black Timber Wolf', '', 'wolf_bi', 13.00, 10.80, 6, 'male', 'L2Monster', 'Fighter', 40, 94, 2.000, 77, 0.900, 40, 43, 30, 21, 20, 20, 212, 6, 13, 51, 9, 34, 253, 0, 506, 0, 0, 0, 24, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (288, 20319, 'Goblin Grave Robber', '', 'goblin', 10.00, 16.50, 5, 'male', 'L2Monster', 'Fighter', 40, 80, 2.000, 70, 0.900, 40, 43, 30, 21, 20, 20, 178, 5, 11, 49, 8, 32, 253, 0, 506, 4, 0, 0, 40, 110, 'goblin_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.32, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (289, 20320, 'Goblin Tomb Raider Leader', '', 'goblin_bi', 10.00, 21.40, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 428, 16, 23, 67, 16, 44, 253, 0, 506, 12, 0, 0, 40, 110, 'goblin_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.32, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (290, 20321, 'Goblin Thief', '', 'goblin_bi', 10.00, 21.40, 10, 'male', 'L2Monster', 'Fighter', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 356, 12, 19, 61, 13, 41, 253, 0, 506, 217, 0, 0, 40, 110, 'goblin_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.32, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (291, 20322, 'Goblin Brigand', '', 'goblin', 10.00, 16.50, 8, 'male', 'L2Monster', 'Fighter', 40, 125, 2.000, 93, 0.900, 40, 43, 30, 21, 20, 20, 285, 10, 16, 56, 11, 37, 253, 0, 506, 4, 0, 0, 40, 110, 'goblin_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.32, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (292, 20323, 'Goblin Brigand Leader', '', 'goblin_bi', 10.00, 21.40, 14, 'male', 'L2Monster', 'Fighter', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 509, 20, 28, 73, 20, 48, 253, 500, 506, 217, 0, 0, 40, 110, 'goblin_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.32, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (293, 20324, 'Goblin Brigand Lieutenant', '', 'goblin', 10.00, 16.50, 10, 'male', 'L2Monster', 'Fighter', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 363, 12, 19, 61, 13, 41, 253, 500, 506, 10, 0, 0, 40, 110, 'goblin_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.32, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (294, 20325, 'Goblin Raider', '', 'goblin', 10.00, 16.50, 5, 'male', 'L2Monster', 'Fighter', 40, 80, 2.000, 70, 0.900, 40, 43, 30, 21, 20, 20, 178, 5, 11, 49, 8, 32, 253, 0, 506, 4, 0, 0, 40, 110, 'goblin_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.32, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (295, 20326, 'Goblin Scout', '', 'goblin', 10.00, 16.50, 8, 'male', 'L2Monster', 'Fighter', 40, 125, 2.000, 93, 0.900, 40, 43, 30, 21, 20, 20, 285, 10, 16, 56, 11, 37, 253, 0, 506, 4, 0, 0, 40, 110, 'goblin_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.32, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (296, 20327, 'Goblin Snooper', '', 'goblin', 10.00, 16.50, 5, 'male', 'L2Monster', 'Fighter', 40, 80, 2.000, 70, 0.900, 40, 43, 30, 21, 20, 20, 178, 5, 11, 49, 8, 32, 253, 0, 506, 4, 0, 0, 40, 110, 'goblin_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.32, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (297, 20328, 'Goblin Lookout', '', 'goblin', 10.00, 16.50, 8, 'male', 'L2Monster', 'Fighter', 40, 125, 2.000, 93, 0.900, 40, 43, 30, 21, 20, 20, 285, 10, 16, 56, 11, 37, 253, 0, 506, 12, 0, 0, 40, 110, 'goblin_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.32, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (298, 20329, 'Ghost Guardian', '', 'human_ghost', 8.00, 22.00, 21, 'male', 'L2Monster', 'Mystic', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 772, 36, 53, 99, 36, 66, 253, 500, 506, 0, 0, 0, 80, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (299, 20330, 'Mineshaft Bat', '', 'vampire_bat', 10.00, 33.50, 11, 'male', 'L2Monster', 'Mystic', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 326, 12, 21, 64, 14, 43, 253, 0, 506, 0, 0, 0, 60, 80, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (300, 20331, 'Monster Eye Tracker', '', 'monster_eye', 21.00, 43.00, 10, 'male', 'L2Monster', 'Mystic', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 297, 10, 19, 61, 13, 41, 253, 0, 506, 0, 0, 0, 90, 134, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (301, 20333, 'Greystone Golem', '', 'stone_golem', 20.00, 31.00, 13, 'male', 'L2Monster', 'Mystic', 40, 215, 2.500, 133, 1.200, 40, 43, 30, 21, 20, 20, 655, 26, 26, 70, 17, 47, 253, 0, 506, 0, 0, 0, 23, 23, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (302, 20334, 'Gremlin Scavenger', '', 'gremlin', 10.00, 15.00, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 29, 2, 7, 40, 5, 27, 253, 0, 506, 0, 0, 0, 20, 50, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (303, 20335, 'Grizzly Bear', '', 'grizzly_bi', 21.00, 50.00, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 600, 25, 37, 84, 25, 55, 253, 0, 506, 0, 0, 0, 40, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (304, 20336, 'Green Dryad', '', 'dryad_sm', 6.00, 15.00, 8, 'female', 'L2Monster', 'Fighter', 40, 125, 2.000, 93, 0.900, 40, 43, 30, 21, 20, 20, 285, 10, 16, 56, 11, 37, 253, 0, 506, 0, 0, 0, 40, 110, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (305, 20337, 'Longtail Fox', '', 'fox', 9.50, 10.00, 2, 'male', 'L2Monster', 'Fighter', 40, 48, 2.000, 47, 0.900, 40, 43, 30, 21, 20, 20, 59, 2, 8, 42, 5, 28, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (306, 20338, 'Nightmare Weaver', '', 'magical_weaver', 11.00, 20.00, 21, 'male', 'L2Monster', 'Mystic', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 849, 40, 53, 99, 36, 66, 253, 500, 506, 0, 0, 0, 90, 90, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (307, 20340, 'Slave Skeleton', '', 'skeleton', 11.00, 25.00, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 363, 13, 23, 67, 16, 44, 253, 500, 506, 946, 0, 0, 60, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (308, 20341, 'Undead Slave', '', 'zombie', 13.00, 21.00, 19, 'male', 'L2Monster', 'Mystic', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 799, 36, 44, 91, 30, 60, 253, 0, 506, 0, 0, 0, 15, 15, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (309, 20342, 'Werewolf Chieftain', '', 'werewolf_bi', 11.00, 29.70, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 436, 16, 23, 67, 16, 44, 253, 500, 506, 5, 0, 0, 50, 120, 'werewolf_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (310, 20343, 'Werewolf Hunter', '', 'werewolf', 10.00, 26.00, 10, 'male', 'L2Monster', 'Fighter', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 363, 12, 19, 61, 13, 41, 253, 500, 506, 5, 0, 0, 50, 120, 'werewolf_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (311, 20345, 'Dark Terror', '', 'dark_horror', 20.00, 35.00, 16, 'male', 'L2Monster', 'Fighter', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 534, 22, 34, 80, 23, 54, 253, 500, 506, 0, 0, 0, 100, 100, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (312, 20346, 'Darkstone Golem', '', 'stone_golem', 20.00, 31.00, 13, 'male', 'L2Monster', 'Mystic', 40, 215, 2.500, 133, 1.200, 40, 43, 30, 21, 20, 20, 545, 21, 26, 70, 17, 47, 253, 0, 506, 0, 0, 0, 23, 23, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (313, 20347, 'Doom Wraith', '', 'death_blader', 15.00, 45.00, 55, 'male', 'L2Monster', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 4488, 362, 559, 323, 382, 215, 253, 500, 506, 1472, 0, 0, 100, 174, 'undead_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (314, 20348, 'Cave Spider', '', 'giant_spider', 26.00, 25.50, 15, 'male', 'L2Monster', 'Mystic', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 445, 18, 31, 77, 21, 51, 253, 0, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (315, 20349, 'Cave Bat', '', 'vampire_bat', 10.00, 33.50, 13, 'male', 'L2Monster', 'NightAgressionMystic', 40, 215, 2.500, 133, 1.200, 40, 43, 30, 21, 20, 20, 386, 15, 26, 70, 17, 47, 253, 0, 506, 0, 0, 0, 60, 80, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (316, 20350, 'Cave Fang Spider', '', 'giant_spider', 26.00, 25.50, 16, 'male', 'L2Monster', 'Mystic', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 485, 20, 34, 80, 23, 54, 253, 500, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (317, 20351, 'Dre Vanul Tracker', '', 'dre_vanul', 14.00, 36.00, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 606, 27, 48, 95, 33, 63, 253, 500, 506, 0, 0, 0, 80, 80, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (318, 20352, 'Dre Vanul Slayer', '', 'dre_vanul', 14.00, 36.00, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 921, 43, 58, 103, 39, 69, 253, 500, 506, 0, 0, 0, 80, 80, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (319, 20353, 'Dre Vanul Beholder', '', 'dre_vanul', 14.00, 36.00, 21, 'male', 'L2Monster', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 780, 36, 53, 99, 36, 66, 253, 500, 506, 0, 0, 0, 80, 80, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (320, 20354, 'Dwarf Ghost', '', 'dwarf_ghost', 9.00, 16.50, 20, 'male', 'L2Monster', 'Mystic', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 606, 27, 48, 95, 33, 63, 253, 500, 506, 0, 0, 0, 80, 140, 'ghost_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (321, 20356, 'Langk Lizardman Leader', '', 'virud_lizardman_warrior_bi', 12.00, 34.50, 25, 'male', 'L2Monster', 'Fighter', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 1215, 61, 74, 116, 50, 78, 253, 500, 506, 16, 0, 0, 52, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (322, 20357, 'Langk Lizardman Lieutenant', '', 'virud_lizardman_warrior', 12.00, 30.00, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 986, 47, 58, 103, 39, 69, 253, 0, 506, 16, 0, 0, 52, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (323, 20358, 'Ratman Hunter', '', 'wererat', 14.00, 25.00, 18, 'male', 'L2Monster', 'Fighter', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 640, 28, 41, 87, 28, 58, 253, 0, 506, 11, 0, 0, 80, 120, 'wererat_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (324, 20359, 'Ratman Warrior', '', 'wererat', 14.00, 25.00, 19, 'male', 'L2Monster', 'Fighter', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 678, 30, 44, 91, 30, 60, 253, 0, 506, 2, 0, 0, 80, 120, 'wererat_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (325, 20360, 'Ratman Spy', '', 'wererat_sm', 12.00, 18.70, 16, 'male', 'L2Monster', 'Fighter', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 571, 23, 34, 80, 23, 54, 253, 0, 506, 12, 0, 0, 80, 120, 'wererat_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (326, 20361, 'Tunath Orc Marksman', '', 'orc_archer', 14.00, 25.00, 10, 'male', 'L2Monster', 'Ranger', 1100, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 306, 10, 19, 61, 13, 41, 253, 0, 506, 14, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (327, 20362, 'Tunath Orc Warrior', '', 'orc_fighter', 12.00, 22.00, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 363, 13, 23, 67, 16, 44, 253, 500, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (328, 20363, 'Maraku Werewolf', '', 'werewolf', 10.00, 26.00, 9, 'male', 'L2Monster', 'Fighter', 40, 143, 2.000, 100, 0.900, 40, 43, 30, 21, 20, 20, 321, 11, 18, 59, 12, 39, 253, 0, 506, 0, 0, 0, 50, 120, 'werewolf_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (329, 20364, 'Maraku Werewolf Chieftain', '', 'werewolf_bi', 11.00, 29.70, 14, 'male', 'L2Monster', 'Fighter', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 509, 20, 28, 73, 20, 48, 253, 500, 506, 217, 0, 0, 50, 120, 'werewolf_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (330, 20365, 'Mountain Fungus', '', 'walking_fungus', 15.00, 22.50, 8, 'male', 'L2Monster', 'Fighter', 40, 125, 2.000, 93, 0.900, 40, 43, 30, 21, 20, 20, 285, 10, 16, 56, 11, 37, 253, 0, 506, 0, 0, 0, 70, 110, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (331, 20367, 'Merkenis Escort', '', 'spartoi', 11.00, 27.00, 20, 'male', 'L2Minion', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 606, 27, 48, 95, 33, 63, 253, 500, 506, 68, 0, 0, 60, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (332, 20368, 'Grave Keeper', '', 'stone_golem', 20.00, 31.00, 13, 'male', 'L2Monster', 'Mystic', 40, 215, 2.500, 133, 1.200, 40, 43, 30, 21, 20, 20, 545, 21, 26, 70, 17, 47, 253, 0, 506, 0, 0, 0, 23, 23, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (333, 20369, 'Moonstone Beast', '', 'onyx_beast', 14.00, 14.50, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 600, 25, 37, 84, 25, 55, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (334, 20370, 'Barbed Bat', '', 'vampire_bat', 10.00, 33.50, 12, 'male', 'L2Monster', 'Mystic', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 428, 16, 23, 67, 16, 44, 253, 0, 506, 0, 0, 0, 60, 80, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (335, 20371, 'Mist Terror', '', 'dark_horror', 20.00, 35.00, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 454, 19, 31, 77, 21, 51, 253, 500, 506, 0, 0, 0, 100, 100, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (336, 20372, 'Baraq Orc Fighter', '', 'orc_fighter', 12.00, 22.00, 10, 'male', 'L2Monster', 'Fighter', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 303, 10, 19, 61, 13, 41, 253, 500, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (337, 20373, 'Baraq Orc Warrior Leader', '', 'orc_fighter', 12.00, 22.00, 11, 'male', 'L2Monster', 'Fighter', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 326, 12, 21, 64, 14, 43, 253, 0, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (338, 20374, 'Barankas Guard', '', 'spartoi', 11.00, 27.00, 22, 'male', 'L2Minion', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 1093, 52, 58, 103, 39, 69, 253, 500, 506, 68, 0, 0, 60, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (339, 20375, 'Barankas Escort', '', 'spartoi', 11.00, 27.00, 21, 'male', 'L2Minion', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 780, 36, 53, 99, 36, 66, 253, 500, 506, 946, 0, 0, 60, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (340, 20376, 'Varikan Brigand Leader', '', 'goblin_bi', 10.00, 21.40, 10, 'male', 'L2Monster', 'Fighter', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 1007, 34, 19, 61, 13, 41, 253, 500, 506, 12, 0, 0, 40, 110, 'goblin_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.32, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (341, 20377, 'Varikas Bandit', '', 'goblin', 10.00, 16.50, 7, 'male', 'L2Minion', 'Fighter', 40, 108, 2.000, 85, 0.900, 40, 43, 30, 21, 20, 20, 167, 6, 14, 54, 10, 36, 253, 0, 506, 0, 0, 0, 40, 110, 'goblin_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.32, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (342, 20378, 'Stone Giant', '', 'stone_golem', 20.00, 31.00, 13, 'male', 'L2Monster', 'Mystic', 40, 215, 2.500, 133, 1.200, 40, 43, 30, 21, 20, 20, 545, 21, 26, 70, 17, 47, 253, 0, 506, 0, 0, 0, 23, 23, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (343, 20379, 'Stone Soldier', '', 'stone_golem', 20.00, 31.00, 14, 'male', 'L2Monster', 'Mystic', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 705, 27, 28, 73, 20, 48, 253, 0, 506, 0, 0, 0, 23, 23, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (344, 20380, 'Stone Guardian', '', 'stone_golem', 20.00, 31.00, 16, 'male', 'L2Monster', 'Mystic', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 807, 33, 34, 80, 23, 54, 253, 0, 506, 0, 0, 0, 23, 23, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (345, 20381, 'Vaiss Orc', '', 'orc', 10.00, 21.00, 10, 'male', 'L2Monster', 'Fighter', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 297, 10, 19, 61, 13, 41, 253, 0, 506, 156, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (346, 20382, 'Vaiss Orc Warrior Leader', '', 'orc_fighter', 12.00, 22.00, 11, 'male', 'L2Monster', 'Fighter', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 326, 12, 21, 64, 14, 43, 253, 0, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (347, 20383, 'Arachnid Hunter', '', 'binding', 12.00, 21.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1469, 80, 111, 140, 75, 94, 253, 500, 506, 0, 0, 0, 10, 140, 'undead_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (348, 20385, 'Balor Orc Archer', '', 'orc_archer', 14.00, 25.00, 8, 'male', 'L2Monster', 'Ranger', 1100, 125, 2.000, 93, 0.900, 40, 43, 30, 21, 20, 20, 293, 10, 16, 56, 11, 37, 253, 0, 506, 14, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (349, 20386, 'Balor Orc Fighter', '', 'orc_fighter', 12.00, 22.00, 10, 'male', 'L2Monster', 'Fighter', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 363, 12, 19, 61, 13, 41, 253, 500, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (350, 20387, 'Balor Orc Fighter Leader', '', 'orc_fighter', 12.00, 22.00, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 436, 16, 23, 67, 16, 44, 253, 500, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (351, 20388, 'Balor Orc Lieutenant', '', 'orc_fighter', 12.00, 22.00, 11, 'male', 'L2Monster', 'Fighter', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 392, 15, 21, 64, 14, 43, 253, 0, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (352, 20389, 'Boogle Ratman', '', 'wererat', 14.00, 25.00, 16, 'male', 'L2Monster', 'Fighter', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 476, 19, 34, 80, 23, 54, 253, 0, 506, 12, 0, 0, 80, 120, 'wererat_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (353, 20390, 'Boogle Ratman Leader', '', 'wererat', 14.00, 25.00, 18, 'male', 'L2Monster', 'Fighter', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 533, 23, 41, 87, 28, 58, 253, 0, 506, 12, 0, 0, 80, 120, 'wererat_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (354, 20391, 'Red Fox', '', 'fox', 9.50, 10.00, 2, 'male', 'L2Monster', 'Fighter', 40, 48, 2.000, 47, 0.900, 40, 43, 30, 21, 20, 20, 59, 2, 8, 42, 5, 28, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (355, 20392, 'Redeye Bat', '', 'vampire_bat_bi', 10.00, 42.00, 15, 'male', 'L2Monster', 'Mystic', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 534, 22, 31, 77, 21, 51, 253, 0, 506, 0, 0, 0, 60, 80, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (356, 20393, 'Red Scavenger Spider', '', 'giant_spider', 26.00, 25.50, 16, 'male', 'L2Monster', 'Fighter', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 571, 23, 34, 80, 23, 54, 253, 0, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (357, 20394, 'Crimson Tarantula', '', 'giant_spider', 26.00, 25.50, 15, 'male', 'L2Monster', 'Mystic', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 450, 18, 31, 77, 21, 51, 253, 500, 506, 0, 0, 0, 72, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (358, 20398, 'Vrykolakas', '', 'werewolf_bi', 11.00, 29.70, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 1386, 57, 31, 77, 21, 51, 253, 500, 506, 0, 0, 0, 50, 120, 'werewolf_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (359, 20399, 'Vrykolakas Wolfkin', '', 'wolf_bi', 13.00, 10.80, 9, 'male', 'L2Minion', 'Fighter', 40, 143, 2.000, 100, 0.900, 40, 43, 30, 21, 20, 20, 177, 6, 18, 59, 12, 39, 253, 0, 506, 0, 0, 0, 24, 110, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (360, 20400, 'Blood Fungus', '', 'walking_fungus', 15.00, 22.50, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 428, 16, 23, 67, 16, 44, 253, 0, 506, 0, 0, 0, 70, 110, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (361, 20401, 'Veelan Bugbear', '', 'bugbear', 17.00, 35.00, 23, 'male', 'L2Monster', 'Fighter', 40, 411, 3.500, 232, 1.500, 40, 43, 30, 21, 20, 20, 1054, 50, 63, 108, 43, 72, 253, 0, 506, 156, 0, 0, 55, 130, 'bugbear_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (362, 20402, 'Veelan Bugbear Warrior', '', 'bugbear', 17.00, 35.00, 24, 'male', 'L2Monster', 'Fighter', 40, 435, 3.500, 246, 1.500, 40, 43, 30, 21, 20, 20, 1145, 56, 68, 112, 46, 75, 253, 500, 506, 88, 0, 0, 55, 130, 'bugbear_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (363, 20403, 'Hunter Tarantula', '', 'giant_spider', 26.00, 25.50, 16, 'male', 'L2Monster', 'Fighter', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 571, 23, 34, 80, 23, 54, 253, 0, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (364, 20404, 'Silent Horror', '', 'dark_horror', 20.00, 35.00, 16, 'male', 'L2Monster', 'Fighter', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 485, 20, 34, 80, 23, 54, 253, 500, 506, 0, 0, 0, 100, 100, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (365, 20405, 'Young Brown Fox', '', 'fox', 9.50, 10.00, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 29, 2, 7, 40, 5, 27, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (366, 20406, 'Young Red Fox', '', 'fox', 9.50, 10.00, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 29, 2, 7, 40, 5, 27, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (367, 20407, 'Young Crimson Fox', '', 'fox', 9.50, 10.00, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 29, 2, 7, 40, 5, 27, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (368, 20410, 'Scavenger Spider', '', 'giant_spider', 26.00, 25.50, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 545, 22, 31, 77, 21, 51, 253, 500, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (369, 20411, 'Scavenger Bat', '', 'vampire_bat', 10.00, 33.50, 18, 'male', 'L2Monster', 'Fighter', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 640, 28, 41, 87, 28, 58, 253, 0, 506, 0, 0, 0, 60, 80, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (370, 20412, 'Susceptor', '', 'susceptor', 20.00, 35.00, 49, 'male', 'L2Monster', 'Fighter', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 3492, 258, 400, 270, 273, 179, 253, 500, 506, 0, 0, 0, 27, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (371, 20415, 'Scarlet Salamander', '', 'salamander', 16.00, 6.80, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 555, 23, 37, 84, 25, 55, 253, 0, 506, 0, 0, 0, 64, 96, 'elemental3_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (372, 20416, 'Scarlet Salamander Elder', '', 'salamander', 16.00, 6.80, 18, 'male', 'L2Monster', 'Fighter', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 587, 26, 41, 87, 28, 58, 253, 0, 506, 0, 0, 0, 64, 96, 'elemental3_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (373, 20418, 'Crystalline Beast', '', 'onyx_beast', 14.00, 14.50, 18, 'male', 'L2Monster', 'Fighter', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 634, 28, 41, 87, 28, 58, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (374, 20419, 'Akaste Succubus', '', 'succubus', 10.00, 36.00, 20, 'female', 'L2Monster', 'Mystic', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 606, 27, 48, 95, 33, 63, 253, 500, 506, 0, 0, 0, 60, 100, 'succubus_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (375, 20420, 'Akaste Succubus Turen', '', 'succubus', 10.00, 36.00, 21, 'female', 'L2Monster', 'Mystic', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 780, 36, 53, 99, 36, 66, 253, 500, 506, 0, 0, 0, 60, 100, 'succubus_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (376, 20421, 'Akaste Succubus Tilfo', '', 'succubus_bi', 10.00, 43.20, 22, 'female', 'L2Monster', 'Mystic', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 838, 40, 58, 103, 39, 69, 253, 500, 506, 0, 0, 0, 60, 100, 'succubus_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (377, 20422, 'Akaste Bone Warlord', '', 'skeleton', 11.00, 25.00, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 613, 26, 37, 84, 25, 55, 253, 500, 506, 2, 18, 0, 60, 140, 'skeleton_clan', 300, 0, 20, 39, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (378, 20423, 'Akaste Bone Archer', '', 'skeleton_archer', 11.00, 27.00, 14, 'male', 'L2Monster', 'Ranger', 1100, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 428, 17, 28, 73, 20, 48, 253, 0, 506, 275, 0, 0, 40, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (379, 20424, 'Akaste Bone Lord', '', 'skeleton', 11.00, 25.00, 19, 'male', 'L2Monster', 'Fighter', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 592, 26, 44, 91, 30, 60, 253, 500, 506, 68, 19, 0, 60, 140, 'skeleton_clan', 300, 0, 20, 42, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (380, 20425, 'Akaste Bone Soldier', '', 'skeleton', 11.00, 25.00, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 363, 13, 23, 67, 16, 44, 253, 500, 506, 946, 0, 0, 60, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (381, 20426, 'Evil Eye', '', 'monster_eye', 21.00, 43.00, 10, 'male', 'L2Monster', 'Mystic', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 356, 12, 19, 61, 13, 41, 253, 0, 506, 0, 0, 0, 90, 134, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (382, 20427, 'Evil Eye Watcher', '', 'monster_eye', 21.00, 43.00, 10, 'male', 'L2Monster', 'Mystic', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 297, 10, 19, 61, 13, 41, 253, 0, 506, 0, 0, 0, 90, 134, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (383, 20428, 'Evil Eye Patroller', '', 'monster_eye', 21.00, 43.00, 14, 'male', 'L2Monster', 'Mystic', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 499, 19, 28, 73, 20, 48, 253, 0, 506, 0, 0, 0, 90, 134, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (384, 20429, 'Evil Eye Lookout', '', 'monster_eye', 21.00, 43.00, 14, 'male', 'L2Monster', 'Mystic', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 416, 16, 28, 73, 20, 48, 253, 0, 506, 0, 0, 0, 90, 134, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (385, 20431, 'Elf Ghost', '', 'elf_ghost', 7.00, 21.00, 20, 'male', 'L2Monster', 'Mystic', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 606, 27, 48, 95, 33, 63, 253, 500, 506, 0, 0, 0, 80, 140, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (386, 20432, 'Elpy', '', 'elpy', 5.00, 4.50, 1, 'male', 'L2Monster', 'Elpy', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 35, 2, 7, 40, 5, 27, 253, 0, 506, 0, 0, 0, 50, 80, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (387, 20433, 'Festering Bat', '', 'vampire_bat', 10.00, 33.50, 13, 'male', 'L2Monster', 'NightAgressionMystic', 40, 215, 2.500, 133, 1.200, 40, 43, 30, 21, 20, 20, 463, 18, 26, 70, 17, 47, 253, 500, 506, 0, 0, 0, 60, 80, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (388, 20435, 'Opal Beast', '', 'onyx_beast', 14.00, 14.50, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 450, 18, 31, 77, 21, 51, 253, 500, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (389, 20436, 'Ol Mahum Supplier', '', 'ol_mahum_bi', 14.00, 29.20, 23, 'male', 'L2Monster', 'Fighter', 40, 411, 3.500, 232, 1.500, 40, 43, 30, 21, 20, 20, 1054, 50, 63, 108, 43, 72, 253, 0, 506, 2, 19, 0, 50, 110, 'ol_mahum_clan', 300, 0, 20, 48, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (390, 20437, 'Ol Mahum Recruit', '', 'ol_mahum', 13.50, 25.00, 21, 'male', 'L2Monster', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 917, 42, 53, 99, 36, 66, 253, 0, 506, 68, 19, 0, 50, 110, 'ol_mahum_clan', 300, 0, 20, 45, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (391, 20438, 'Ol Mahum General', '', 'ol_mahum_champion', 14.00, 27.00, 26, 'male', 'L2Monster', 'OlMahumGeneral', 40, 488, 3.500, 273, 1.500, 40, 43, 30, 21, 20, 20, 1294, 65, 81, 121, 55, 81, 253, 500, 506, 67, 102, 0, 50, 110, 'ol_mahum_clan', 300, 0, 20, 53, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (392, 20439, 'Ol Mahum Officer', '', 'ol_mahum', 13.50, 25.00, 24, 'male', 'L2Monster', 'Fighter', 40, 435, 3.500, 246, 1.500, 40, 43, 30, 21, 20, 20, 1123, 55, 68, 112, 46, 75, 253, 0, 506, 66, 0, 0, 50, 110, 'ol_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (393, 20440, 'Elder Brown Fox', '', 'fox', 9.50, 10.00, 3, 'male', 'L2Monster', 'Fighter', 40, 58, 2.000, 55, 0.900, 40, 43, 30, 21, 20, 20, 88, 2, 9, 44, 6, 29, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (394, 20441, 'Elder Longtail Fox', '', 'fox', 9.50, 10.00, 3, 'male', 'L2Monster', 'Fighter', 40, 58, 2.000, 55, 0.900, 40, 43, 30, 21, 20, 20, 88, 2, 9, 44, 6, 29, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (395, 20442, 'Elder Wolf', '', 'wolf', 13.00, 9.00, 5, 'male', 'L2Monster', 'Fighter', 40, 80, 2.000, 70, 0.900, 40, 43, 30, 21, 20, 20, 176, 5, 11, 49, 8, 32, 253, 0, 506, 0, 0, 0, 24, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (396, 20443, 'Elder Red Fox', '', 'fox', 9.50, 10.00, 3, 'male', 'L2Monster', 'Fighter', 40, 58, 2.000, 55, 0.900, 40, 43, 30, 21, 20, 20, 88, 2, 9, 44, 6, 29, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (397, 20444, 'Elder Prairie Fox', '', 'fox', 9.50, 10.00, 3, 'male', 'L2Monster', 'Fighter', 40, 58, 2.000, 55, 0.900, 40, 43, 30, 21, 20, 20, 88, 2, 9, 44, 6, 29, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (398, 20445, 'Uthanka Pirate', '', 'orc', 10.00, 21.00, 7, 'male', 'L2Monster', 'Fighter', 40, 108, 2.000, 85, 0.900, 40, 43, 30, 21, 20, 20, 154, 5, 14, 54, 10, 36, 253, 0, 506, 3, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (399, 20446, 'Utuku Orc', '', 'orc', 10.00, 21.00, 6, 'male', 'L2Monster', 'Fighter', 40, 94, 2.000, 77, 0.900, 40, 43, 30, 21, 20, 20, 214, 6, 13, 51, 9, 34, 253, 0, 506, 156, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (400, 20447, 'Utuku Orc Archer', '', 'orc_archer', 14.00, 25.00, 8, 'male', 'L2Monster', 'Ranger', 1100, 125, 2.000, 93, 0.900, 40, 43, 30, 21, 20, 20, 293, 10, 16, 56, 11, 37, 253, 0, 506, 14, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (401, 20448, 'Utuku Orc Grunt', '', 'orc', 10.00, 21.00, 7, 'male', 'L2Monster', 'Fighter', 40, 108, 2.000, 85, 0.900, 40, 43, 30, 21, 20, 20, 249, 8, 14, 54, 10, 36, 253, 0, 506, 3, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (402, 20449, 'Will-O-Wisp', '', 'will_o_wisp', 13.00, 22.00, 15, 'male', 'L2Monster', 'Mystic', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 533, 22, 31, 77, 21, 51, 253, 0, 506, 0, 0, 0, 80, 140, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.10, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (403, 20450, 'Relic Werewolf', '', 'werewolf', 10.00, 26.00, 9, 'male', 'L2Monster', 'Fighter', 40, 143, 2.000, 100, 0.900, 40, 43, 30, 21, 20, 20, 268, 9, 18, 59, 12, 39, 253, 0, 506, 0, 0, 0, 50, 120, 'werewolf_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (404, 20451, 'Relic Spartoi', '', 'spartoi', 11.00, 27.00, 21, 'male', 'L2Monster', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 1422, 65, 53, 99, 36, 66, 253, 0, 506, 68, 0, 0, 60, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (405, 20453, 'Human Ghost', '', 'human_ghost', 8.00, 22.00, 20, 'male', 'L2Monster', 'Mystic', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 606, 27, 48, 95, 33, 63, 253, 500, 506, 0, 0, 0, 80, 140, 'ghost_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (406, 20454, 'Oblivion Watcher', '', 'monster_eye', 21.00, 43.00, 17, 'male', 'L2Monster', 'Mystic', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 227, 10, 37, 84, 25, 55, 253, 0, 506, 0, 0, 0, 90, 90, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (407, 20455, 'Doom Soldier', '', 'skeleton', 11.00, 25.00, 14, 'male', 'L2Monster', 'Fighter', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 424, 16, 28, 73, 20, 48, 253, 500, 506, 946, 0, 0, 60, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (408, 20456, 'Ashen Wolf', '', 'wolf', 13.00, 9.00, 4, 'male', 'L2Monster', 'Fighter', 40, 68, 2.000, 62, 0.900, 40, 43, 30, 21, 20, 20, 141, 4, 10, 47, 7, 31, 253, 0, 506, 0, 0, 0, 24, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (409, 20457, 'Zombie Soldier', '', 'zombie', 13.00, 21.00, 19, 'male', 'L2Monster', 'Mystic', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 959, 43, 44, 91, 30, 60, 253, 0, 506, 0, 0, 0, 15, 15, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (410, 20458, 'Zombie Warrior', '', 'zombie_bi', 12.00, 27.50, 22, 'male', 'L2Monster', 'Mystic', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 1421, 67, 58, 103, 39, 69, 253, 500, 506, 0, 0, 0, 15, 15, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (411, 20460, 'Crimson Spider', '', 'giant_spider', 26.00, 25.50, 15, 'male', 'L2Monster', 'Mystic', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 545, 22, 31, 77, 21, 51, 253, 500, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (412, 20461, 'Dungeon Spider', '', 'giant_spider', 26.00, 25.50, 15, 'male', 'L2Monster', 'Mystic', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 454, 19, 31, 77, 21, 51, 253, 500, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (413, 20462, 'Cave Blade Spider', '', 'giant_spider', 26.00, 25.50, 17, 'male', 'L2Monster', 'Mystic', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 515, 22, 37, 84, 25, 55, 253, 500, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (414, 20463, 'Dungeon Skeleton Archer', '', 'skeleton_archer', 11.00, 27.00, 13, 'male', 'L2Monster', 'Ranger', 1100, 215, 2.500, 133, 1.200, 40, 43, 30, 21, 20, 20, 397, 16, 26, 70, 17, 47, 253, 0, 506, 275, 0, 0, 40, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (415, 20464, 'Dungeon Skeleton', '', 'skeleton', 11.00, 25.00, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 363, 13, 23, 67, 16, 44, 253, 500, 506, 946, 0, 0, 60, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (416, 20465, 'Prairie Fox', '', 'fox', 9.50, 10.00, 2, 'male', 'L2Monster', 'Fighter', 40, 48, 2.000, 47, 0.900, 40, 43, 30, 21, 20, 20, 59, 2, 8, 42, 5, 28, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (417, 20466, 'Pincer Spider', '', 'giant_spider', 26.00, 25.50, 17, 'male', 'L2Monster', 'Mystic', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 618, 26, 37, 84, 25, 55, 253, 500, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (418, 20468, 'Kaboo Orc', '', 'orc', 10.00, 21.00, 6, 'male', 'L2Monster', 'Fighter', 40, 94, 2.000, 77, 0.900, 40, 43, 30, 21, 20, 20, 214, 6, 13, 51, 9, 34, 253, 0, 506, 156, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (419, 20469, 'Kaboo Orc Archer', '', 'orc_archer', 14.00, 25.00, 8, 'male', 'L2Monster', 'Ranger', 1100, 125, 2.000, 93, 0.900, 40, 43, 30, 21, 20, 20, 293, 10, 16, 56, 11, 37, 253, 0, 506, 14, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (420, 20470, 'Kaboo Orc Grunt', '', 'orc', 10.00, 21.00, 7, 'male', 'L2Monster', 'Fighter', 40, 108, 2.000, 85, 0.900, 40, 43, 30, 21, 20, 20, 249, 8, 14, 54, 10, 36, 253, 0, 506, 3, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (421, 20471, 'Kaboo Orc Fighter', '', 'orc_fighter', 12.00, 22.00, 10, 'male', 'L2Monster', 'Fighter', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 363, 12, 19, 61, 13, 41, 253, 500, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (422, 20472, 'Kaboo Orc Fighter Leader', '', 'orc_fighter', 12.00, 22.00, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 436, 16, 23, 67, 16, 44, 253, 500, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (423, 20473, 'Kaboo Orc Fighter Lieutenant', '', 'orc_fighter', 12.00, 22.00, 11, 'male', 'L2Monster', 'Fighter', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 392, 15, 21, 64, 14, 43, 253, 0, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (424, 20474, 'Kasha Spider', '', 'giant_spider', 26.00, 25.50, 15, 'male', 'L2Monster', 'Mystic', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 534, 22, 31, 77, 21, 51, 253, 0, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (425, 20475, 'Kasha Wolf', '', 'wolf', 13.00, 9.00, 4, 'male', 'L2Monster', 'Fighter', 40, 68, 2.000, 62, 0.900, 40, 43, 30, 21, 20, 20, 141, 4, 10, 47, 7, 31, 253, 0, 506, 0, 0, 0, 24, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (426, 20476, 'Kasha Fang Spider', '', 'giant_spider', 26.00, 25.50, 16, 'male', 'L2Monster', 'Mystic', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 571, 23, 34, 80, 23, 54, 253, 0, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (427, 20477, 'Kasha Timber Wolf', '', 'wolf_bi', 13.00, 10.80, 6, 'male', 'L2Monster', 'Fighter', 40, 94, 2.000, 77, 0.900, 40, 43, 30, 21, 20, 20, 212, 6, 13, 51, 9, 34, 253, 0, 506, 0, 0, 0, 24, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (428, 20478, 'Kasha Blade Spider', '', 'giant_spider', 26.00, 25.50, 17, 'male', 'L2Monster', 'Mystic', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 667, 28, 37, 84, 25, 55, 253, 0, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (429, 20479, 'Kasha Bear', '', 'grizzly_bi', 21.00, 50.00, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 540, 22, 31, 77, 21, 51, 253, 500, 506, 0, 0, 0, 40, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (430, 20480, 'Blade Bat', '', 'vampire_bat', 10.00, 33.50, 10, 'male', 'L2Monster', 'Mystic', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 356, 12, 19, 61, 13, 41, 253, 0, 506, 0, 0, 0, 60, 80, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (431, 20481, 'Bearded Keltir', '', 'keltir', 9.50, 10.00, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 35, 2, 7, 40, 5, 27, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (432, 20483, 'Corpse Candle', '', 'will_o_wisp', 13.00, 22.00, 17, 'male', 'L2Monster', 'Mystic', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 604, 25, 37, 84, 25, 55, 253, 0, 506, 0, 0, 0, 80, 140, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.10, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (433, 20487, 'Kuruka Ratman', '', 'wererat', 14.00, 25.00, 16, 'male', 'L2Monster', 'Fighter', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 476, 19, 34, 80, 23, 54, 253, 0, 506, 216, 0, 0, 80, 120, 'wererat_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (434, 20488, 'Kuruka Ratman Hunter', '', 'wererat', 14.00, 25.00, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 505, 21, 37, 84, 25, 55, 253, 0, 506, 3, 0, 0, 80, 120, 'wererat_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (435, 20489, 'Quicksilver Beast', '', 'onyx_beast', 14.00, 14.50, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 450, 18, 31, 77, 21, 51, 253, 500, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (436, 20490, 'Death Doll', '', 'crimson_doll', 15.00, 38.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 2611, 169, 227, 203, 155, 134, 253, 500, 506, 0, 0, 0, 60, 150, 'undead_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.67, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (437, 20491, 'Crypt Horror', '', 'dark_horror', 20.00, 35.00, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 454, 19, 31, 77, 21, 51, 253, 500, 506, 0, 0, 0, 100, 100, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (438, 20492, 'Kirunaks Guards', '', 'spartoi', 11.00, 27.00, 21, 'male', 'L2Minion', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 764, 35, 53, 99, 36, 66, 253, 0, 506, 68, 0, 0, 60, 140, 'kirunak_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (439, 20494, 'Turek War Hound', '', 'dire_wolf', 13.00, 11.00, 24, 'male', 'L2Monster', 'Fighter', 40, 435, 3.500, 246, 1.500, 40, 43, 30, 21, 20, 20, 2088, 103, 68, 112, 46, 75, 253, 0, 506, 0, 0, 0, 24, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (440, 20495, 'Turek Orc Warlord', '', 'orc_champion', 10.00, 23.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 3338, 182, 111, 140, 75, 94, 253, 500, 506, 127, 0, 0, 45, 130, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (441, 20496, 'Turek Orc Archer', '', 'orc_archer', 14.00, 25.00, 27, 'male', 'L2Monster', 'Ranger', 1100, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 2585, 132, 87, 125, 59, 84, 253, 0, 506, 14, 0, 0, 45, 110, 'orc_clan', 400, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (442, 20497, 'Turek Orc Skirmisher', '', 'orc_fighter', 12.00, 22.00, 28, 'male', 'L2Monster', 'Fighter', 40, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 2682, 140, 95, 131, 64, 87, 253, 500, 506, 121, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (443, 20498, 'Turek Orc Supplier', '', 'orc_fighter', 12.00, 22.00, 27, 'male', 'L2Monster', 'WatchmanMonster', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 2485, 127, 87, 125, 59, 84, 253, 0, 506, 11, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (444, 20499, 'Turek Orc Footman', '', 'orc', 10.00, 21.00, 26, 'male', 'L2Monster', 'WatchmanMonster', 40, 488, 3.500, 273, 1.500, 40, 43, 30, 21, 20, 20, 2359, 119, 81, 121, 55, 81, 253, 0, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (445, 20500, 'Turek Orc Sentinel', '', 'orc', 10.00, 21.00, 25, 'male', 'L2Monster', 'WatchmanMonster', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 2215, 110, 74, 116, 50, 78, 253, 0, 506, 3, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (446, 20501, 'Turek Orc Shaman', '', 'orc_shaman', 9.00, 22.00, 29, 'male', 'L2Monster', 'Priest', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 2776, 149, 101, 136, 70, 91, 253, 0, 506, 7, 0, 0, 45, 120, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (447, 20502, 'Twink Puma', '', 'onyx_beast', 14.00, 14.50, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 540, 22, 31, 77, 21, 51, 253, 500, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (448, 20504, 'Dread Soldier', '', 'skeleton', 11.00, 25.00, 14, 'male', 'L2Monster', 'Fighter', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 424, 16, 28, 73, 20, 48, 253, 500, 506, 946, 0, 0, 60, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (449, 20505, 'Ruin Bat', '', 'vampire_bat_bi', 10.00, 42.00, 20, 'male', 'L2Monster', 'NightAgressionMystic', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 713, 32, 48, 95, 33, 63, 253, 500, 506, 0, 0, 0, 60, 80, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (450, 20506, 'Ruin Imp', '', 'imp_bi', 10.00, 30.00, 17, 'male', 'L2Monster', 'Mystic', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 606, 25, 37, 84, 25, 55, 253, 0, 506, 0, 0, 0, 60, 80, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (451, 20507, 'Ruin Imp Elder', '', 'imp_bi', 10.00, 30.00, 21, 'male', 'L2Monster', 'Mystic', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 936, 43, 53, 99, 36, 66, 253, 500, 506, 0, 0, 0, 60, 80, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (452, 20508, 'Plunder Tarantula', '', 'giant_spider', 26.00, 25.50, 17, 'male', 'L2Monster', 'Mystic', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 618, 26, 37, 84, 25, 55, 253, 500, 506, 0, 0, 0, 72, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (453, 20509, 'Spore Fungus', '', 'walking_fungus', 15.00, 22.50, 9, 'male', 'L2Monster', 'Fighter', 40, 143, 2.000, 100, 0.900, 40, 43, 30, 21, 20, 20, 321, 11, 18, 59, 12, 39, 253, 0, 506, 0, 0, 0, 70, 110, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (454, 20510, 'Puma', '', 'onyx_beast', 14.00, 14.50, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 423, 16, 23, 67, 16, 44, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (455, 20511, 'Pitchstone Golem', '', 'stone_golem', 20.00, 31.00, 19, 'male', 'L2Monster', 'Mystic', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 799, 36, 44, 91, 30, 60, 253, 0, 506, 0, 0, 0, 23, 23, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (456, 20512, 'Field Stalker', '', 'field_stalker', 15.00, 30.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 2175, 128, 160, 170, 109, 113, 253, 500, 506, 0, 0, 0, 70, 110, 'monster_eye_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (457, 20513, 'Skeleton Knight', '', 'skeleton_knight', 10.00, 25.00, 32, 'male', 'L2Monster', 'Fighter', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 1519, 85, 128, 152, 87, 102, 253, 500, 506, 150, 0, 0, 40, 160, 'skeleton_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (458, 20514, 'Shield Skeleton', '', 'skeleton', 11.00, 25.00, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 534, 22, 31, 77, 21, 51, 253, 0, 506, 157, 103, 0, 60, 140, 'skeleton_clan', 300, 0, 20, 37, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (459, 20515, 'Skeleton Infantryman', '', 'skeleton', 11.00, 25.00, 16, 'male', 'L2Monster', 'Fighter', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 571, 23, 34, 80, 23, 54, 253, 0, 506, 157, 18, 0, 60, 140, 'skeleton_clan', 300, 0, 20, 38, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (460, 20516, 'Skeleton Sentinel', '', 'skeleton_bi', 11.00, 31.00, 14, 'male', 'L2Monster', 'Fighter', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 424, 16, 28, 73, 20, 48, 253, 500, 506, 946, 0, 0, 60, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (461, 20517, 'Skeleton Hunter', '', 'skeleton', 11.00, 25.00, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 363, 13, 23, 67, 16, 44, 253, 500, 506, 946, 0, 0, 60, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (462, 20518, 'Skeleton Hunter Archer', '', 'skeleton_archer', 11.00, 27.00, 13, 'male', 'L2Monster', 'Ranger', 1100, 215, 2.500, 133, 1.200, 40, 43, 30, 21, 20, 20, 397, 16, 26, 70, 17, 47, 253, 0, 506, 275, 0, 0, 40, 140, 'skeleton_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (463, 20519, 'Skeleton Pikeman', '', 'skeleton_pikeman', 10.00, 28.00, 27, 'male', 'L2Monster', 'Fighter', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 1136, 58, 87, 125, 59, 84, 253, 500, 506, 299, 0, 0, 50, 155, 'skeleton_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.21, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (464, 20520, 'Pirate Captain Uthanka', '', 'orc_fighter_bi', 12.00, 26.40, 10, 'male', 'L2Monster', 'Fighter', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 926, 32, 19, 61, 13, 41, 253, 500, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (465, 20521, 'Whinstone Golem', '', 'stone_golem', 20.00, 31.00, 14, 'male', 'L2Monster', 'Mystic', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 705, 27, 28, 73, 20, 48, 253, 0, 506, 0, 0, 0, 23, 23, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (466, 20522, 'White Fang', '', 'wolf_bi', 13.00, 10.80, 10, 'male', 'L2Monster', 'Fighter', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 917, 31, 19, 61, 13, 41, 253, 500, 506, 0, 0, 0, 24, 110, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (467, 20524, 'Grey Wolf Elder', '', 'wolf', 13.00, 9.00, 7, 'male', 'L2Minion', 'Fighter', 40, 108, 2.000, 85, 0.900, 40, 43, 30, 21, 20, 20, 152, 5, 14, 54, 10, 36, 253, 0, 506, 0, 0, 0, 24, 110, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (468, 20525, 'Gray Wolf', '', 'wolf', 13.00, 9.00, 4, 'male', 'L2Monster', 'Fighter', 40, 68, 2.000, 62, 0.900, 40, 43, 30, 21, 20, 20, 141, 4, 10, 47, 7, 31, 253, 0, 506, 0, 0, 0, 24, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (469, 20526, 'Obsidian Golem', '', 'stone_golem', 20.00, 31.00, 15, 'male', 'L2Monster', 'Mystic', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 756, 31, 31, 77, 21, 51, 253, 0, 506, 0, 0, 0, 23, 23, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (470, 20527, 'Great Snow Wolf', '', 'dire_wolf', 13.00, 11.00, 4, 'male', 'L2Monster', 'Fighter', 40, 68, 2.000, 62, 0.900, 40, 43, 30, 21, 20, 20, 121, 3, 10, 47, 7, 31, 253, 500, 506, 0, 0, 0, 24, 110, 'wolf_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (471, 20528, 'Goblin Lord', '', 'goblin', 10.00, 16.50, 13, 'male', 'L2Monster', 'Fighter', 40, 215, 2.500, 133, 1.200, 40, 43, 30, 21, 20, 20, 458, 18, 26, 70, 17, 47, 253, 0, 506, 217, 0, 0, 40, 110, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.32, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (472, 20529, 'Young Brown Keltir', '', 'keltir', 9.50, 10.00, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 35, 2, 7, 40, 5, 27, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (473, 20530, 'Young Red Keltir', '', 'keltir', 9.50, 10.00, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 35, 2, 7, 40, 5, 27, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (474, 20531, 'Young Prairie Keltir', '', 'keltir', 9.50, 10.00, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 35, 2, 7, 40, 5, 27, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (475, 20532, 'Brown Keltir', '', 'keltir', 9.50, 10.00, 2, 'male', 'L2Monster', 'Fighter', 40, 48, 2.000, 47, 0.900, 40, 43, 30, 21, 20, 20, 71, 2, 8, 42, 5, 28, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (476, 20533, 'Longtail Keltir', '', 'keltir', 9.50, 10.00, 2, 'male', 'L2Monster', 'Fighter', 40, 48, 2.000, 47, 0.900, 40, 43, 30, 21, 20, 20, 71, 2, 8, 42, 5, 28, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (477, 20534, 'Red Keltir', '', 'keltir', 9.50, 10.00, 2, 'male', 'L2Monster', 'Fighter', 40, 48, 2.000, 47, 0.900, 40, 43, 30, 21, 20, 20, 71, 2, 8, 42, 5, 28, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (478, 20535, 'Prairie Keltir', '', 'keltir', 9.50, 10.00, 2, 'male', 'L2Monster', 'Fighter', 40, 48, 2.000, 47, 0.900, 40, 43, 30, 21, 20, 20, 71, 2, 8, 42, 5, 28, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (479, 20536, 'Elder Brown Keltir', '', 'keltir', 9.50, 10.00, 3, 'male', 'L2Monster', 'Fighter', 40, 58, 2.000, 55, 0.900, 40, 43, 30, 21, 20, 20, 106, 2, 9, 44, 6, 29, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (480, 20537, 'Elder Red Keltir', '', 'keltir', 9.50, 10.00, 3, 'male', 'L2Monster', 'Fighter', 40, 58, 2.000, 55, 0.900, 40, 43, 30, 21, 20, 20, 106, 2, 9, 44, 6, 29, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (481, 20538, 'Elder Prairie Keltir', '', 'keltir', 9.50, 10.00, 3, 'male', 'L2Monster', 'Fighter', 40, 58, 2.000, 55, 0.900, 40, 43, 30, 21, 20, 20, 106, 2, 9, 44, 6, 29, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (482, 20539, 'Elder Longtail Keltir', '', 'keltir', 9.50, 10.00, 3, 'male', 'L2Monster', 'Fighter', 40, 58, 2.000, 55, 0.900, 40, 43, 30, 21, 20, 20, 106, 2, 9, 44, 6, 29, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (483, 20540, 'Gemstone Beast', '', 'onyx_beast', 14.00, 14.50, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 353, 13, 23, 67, 16, 44, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (484, 20541, 'Ore Bat', '', 'vampire_bat', 10.00, 33.50, 17, 'male', 'L2Monster', 'Mystic', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 500, 21, 37, 84, 25, 55, 253, 0, 506, 0, 0, 0, 60, 80, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (485, 20542, 'Skeleton Longbowman', '', 'skeleton_archer', 11.00, 27.00, 19, 'male', 'L2Monster', 'Ranger', 1100, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 588, 26, 44, 91, 30, 60, 253, 500, 506, 275, 0, 0, 40, 140, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (486, 20543, 'Ghost', '', 'human_ghost', 8.00, 22.00, 20, 'male', 'L2Monster', 'Mystic', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 600, 27, 48, 95, 33, 63, 253, 500, 506, 0, 0, 0, 80, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (487, 20544, 'Elder Keltir', '', 'keltir', 9.50, 10.00, 3, 'male', 'L2Monster', 'Fighter', 40, 58, 2.000, 55, 0.900, 40, 43, 30, 21, 20, 20, 106, 2, 9, 44, 6, 29, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (488, 20545, 'Young Keltir', '', 'keltir', 9.50, 10.00, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 35, 2, 7, 40, 5, 27, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (489, 20546, 'Turek Orc Elder', '', 'orc_shaman', 9.00, 22.00, 34, 'male', 'L2Monster', 'Priest', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 2058, 120, 149, 164, 102, 109, 253, 500, 506, 7, 0, 0, 45, 120, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (490, 20547, 'Ol Mahum Reserve', '', 'ol_mahum_bi', 14.00, 29.20, 23, 'male', 'L2Monster', 'Fighter', 40, 411, 3.500, 232, 1.500, 40, 43, 30, 21, 20, 20, 1054, 50, 63, 108, 43, 72, 253, 0, 506, 2, 0, 0, 50, 110, 'ol_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (491, 20548, 'Ol Mahum Deserter', '', 'ol_mahum', 13.50, 25.00, 23, 'male', 'L2Monster', 'Fighter', 40, 411, 3.500, 232, 1.500, 40, 43, 30, 21, 20, 20, 1075, 52, 63, 108, 43, 72, 253, 500, 506, 2, 0, 0, 50, 110, 'ol_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (492, 20549, 'Ol Mahum Lord', '', 'ol_mahum_champion', 14.00, 27.00, 34, 'male', 'L2Monster', 'Fighter', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 4233, 247, 149, 164, 102, 109, 253, 500, 506, 69, 19, 0, 50, 110, 'ol_mahum_clan', 300, 0, 20, 66, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (493, 20550, 'Guardian Basilisk', '', 'lesser_basilisk', 34.00, 25.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 2352, 142, 173, 176, 118, 118, 253, 0, 506, 0, 0, 0, 35, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (494, 20551, 'Road Scavenger', '', 'wererat', 14.00, 25.00, 37, 'male', 'L2Monster', 'Fighter', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 2389, 146, 185, 181, 126, 121, 253, 0, 506, 221, 0, 0, 80, 174, '1', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (495, 20552, 'Fettered Soul', '', 'binding', 12.00, 21.00, 38, 'male', 'L2Monster', 'Fighter', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 5152, 322, 198, 188, 136, 126, 253, 0, 506, 0, 0, 0, 10, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (496, 20553, 'Windsus', '', 'giant_wild_hog', 35.00, 27.00, 39, 'male', 'L2Monster', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 2655, 169, 212, 195, 145, 131, 253, 0, 506, 0, 0, 0, 35, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (497, 20554, 'Grandis', '', 'twin_headed_giant', 17.00, 39.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 3102, 200, 227, 203, 155, 134, 253, 500, 506, 0, 0, 0, 45, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (498, 20555, 'Giant Fungus', '', 'walking_fungus_bi', 15.00, 31.30, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 2792, 180, 227, 203, 155, 134, 253, 0, 506, 0, 0, 0, 70, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (499, 20556, 'Giant Monstereye', '', 'monster_eye_bi', 29.00, 60.00, 41, 'male', 'L2Monster', 'Mystic', 40, 1008, 5.500, 505, 2.100, 40, 43, 30, 21, 20, 20, 2934, 192, 243, 209, 166, 139, 253, 0, 506, 0, 0, 0, 90, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (500, 20557, 'Dire Wyrm', '', 'wyrm', 29.00, 72.00, 42, 'male', 'L2Monster', 'Fighter', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 3109, 208, 259, 216, 177, 144, 253, 500, 506, 0, 0, 0, 70, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.19, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (501, 20558, 'Rotting tree', '', 'hanged_man_ripper', 35.00, 80.00, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 3195, 216, 277, 223, 189, 149, 253, 0, 506, 0, 0, 0, 55, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (502, 20559, 'Rotting Golem', '', 'stone_golem_bi_one', 22.00, 43.40, 44, 'male', 'L2Monster', 'Mystic', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 4730, 324, 295, 230, 202, 153, 253, 0, 506, 0, 0, 0, 23, 23, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (503, 20560, 'Trisalim Spider', '', 'giant_spider', 26.00, 25.50, 45, 'male', 'L2Monster', 'Mystic', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 3499, 244, 315, 239, 214, 158, 253, 0, 506, 0, 0, 0, 72, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (504, 20561, 'Trisalim Tarantula', '', 'poison_spider', 27.00, 25.50, 46, 'male', 'L2Monster', 'Mystic', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 4144, 294, 335, 246, 228, 163, 253, 500, 506, 0, 0, 0, 60, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (505, 20562, 'Spore Zombie', '', 'zombie_bi', 12.00, 27.50, 47, 'male', 'L2Monster', 'Mystic', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 4310, 308, 356, 254, 243, 169, 253, 0, 506, 0, 0, 0, 15, 15, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (506, 20563, 'Manashen Gargoyle', '', 'gargoyle', 16.00, 50.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 3323, 215, 227, 203, 155, 134, 253, 0, 506, 0, 0, 0, 140, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (507, 20564, 'Enchanted Monstereye', '', 'monster_eye', 21.00, 43.00, 41, 'male', 'L2Monster', 'Mystic', 40, 1008, 5.500, 505, 2.100, 40, 43, 30, 21, 20, 20, 2992, 196, 243, 209, 166, 139, 253, 500, 506, 0, 0, 0, 90, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (508, 20565, 'Enchanted Stone Golem', '', 'stone_golem_bi', 20.00, 40.30, 42, 'male', 'L2Monster', 'Mystic', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 4353, 290, 259, 216, 177, 144, 253, 0, 506, 0, 0, 0, 23, 23, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (509, 20566, 'Enchanted Iron Golem', '', 'iron_golem', 18.00, 34.00, 43, 'male', 'L2Monster', 'Mystic', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 4563, 308, 277, 223, 189, 149, 253, 0, 506, 0, 0, 0, 20, 20, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (510, 20567, 'Enchanted Gargoyle', '', 'gargoyle', 16.00, 50.00, 44, 'male', 'L2Monster', 'Fighter', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 4021, 275, 295, 230, 202, 153, 253, 0, 506, 0, 0, 0, 140, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (511, 20568, 'Formor', '', 'troll', 21.00, 35.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 3534, 246, 315, 239, 214, 158, 253, 0, 506, 0, 0, 0, 55, 174, 'beast_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (512, 20569, 'Formor Elder', '', 'troll', 21.00, 35.00, 46, 'male', 'L2Monster', 'Fighter', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 3841, 272, 335, 246, 228, 163, 253, 0, 506, 0, 0, 0, 55, 174, 'beast_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (513, 20570, 'Tarlk Bugbear', '', 'bugbear', 17.00, 35.00, 47, 'male', 'L2Monster', 'Fighter', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 3855, 276, 356, 254, 243, 169, 253, 0, 506, 88, 0, 0, 55, 174, 'bugbear_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (514, 20571, 'Tarlk Bugbear Warrior', '', 'bugbear', 17.00, 35.00, 48, 'male', 'L2Monster', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 4553, 332, 378, 262, 258, 174, 253, 500, 506, 169, 0, 0, 55, 174, 'bugbear_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (515, 20572, 'Tarlk Bugbear High Warrior', '', 'king_bugbear', 15.00, 40.00, 49, 'male', 'L2Monster', 'Fighter', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 4987, 368, 400, 270, 273, 179, 253, 0, 506, 160, 0, 0, 55, 174, 'bugbear_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (516, 20573, 'Tarlk Basilisk', '', 'lesser_basilisk', 34.00, 25.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 4288, 323, 425, 278, 291, 204, 253, 0, 506, 0, 0, 0, 35, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (517, 20574, 'Elder Tarlk Basilisk ', '', 'lesser_basilisk', 34.00, 25.00, 51, 'male', 'L2Monster', 'Fighter', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 4506, 343, 449, 287, 307, 210, 253, 500, 506, 0, 0, 0, 35, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (518, 20575, 'Oel Mahum Warrior', '', 'oel_mahum_warrior', 20.00, 38.00, 54, 'male', 'L2Monster', 'Fighter', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 5051, 402, 531, 313, 362, 229, 253, 0, 506, 72, 0, 0, 70, 160, 'oel_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (519, 20576, 'Oel Mahum Witch Doctor', '', 'oel_mahum_witch_doctor', 15.00, 34.00, 55, 'male', 'L2Monster', 'Mystic', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 10289, 791, 559, 323, 382, 236, 253, 0, 506, 201, 0, 0, 70, 130, 'oel_mahum_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (520, 20577, 'Leto Lizardman', '', 'zenta_lizardman', 11.00, 32.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 2138, 126, 160, 170, 109, 113, 253, 0, 506, 66, 0, 0, 37, 174, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (521, 20578, 'Leto Lizardman Archer', '', 'zenta_lizardman_scout', 11.00, 30.00, 36, 'male', 'L2Monster', 'Ranger', 1100, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 2330, 140, 173, 176, 118, 118, 253, 0, 506, 14, 0, 0, 37, 174, 'lizardman_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.93, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (522, 20579, 'Leto Lizardman Soldier', '', 'zenta_lizardman', 11.00, 32.00, 37, 'male', 'L2Monster', 'Fighter', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 2437, 150, 185, 181, 126, 121, 253, 500, 506, 68, 0, 0, 37, 174, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (523, 20580, 'Leto Lizardman Warrior', '', 'zenta_lizardman_warrior', 13.00, 35.00, 38, 'male', 'L2Monster', 'Fighter', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 4688, 292, 198, 188, 136, 126, 253, 0, 506, 93, 0, 0, 40, 174, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (524, 20581, 'Leto Lizardman Shaman', '', 'zenta_lizardman_shaman', 13.00, 35.00, 39, 'male', 'L2Monster', 'Priest', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 2655, 169, 212, 195, 145, 131, 253, 0, 506, 159, 0, 0, 43, 174, 'lizardman_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (525, 20582, 'Leto Lizardman Overlord', '', 'zenta_lizardman_matriarch', 20.00, 40.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 5298, 342, 227, 203, 155, 134, 253, 500, 506, 221, 0, 0, 53, 174, 'lizardman_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (526, 20583, 'Timak Orc', '', 'batur_orc', 9.00, 21.50, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 2792, 180, 227, 203, 155, 134, 253, 0, 506, 2, 0, 0, 80, 174, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (527, 20584, 'Timak Orc Archer', '', 'batur_orc_archer', 11.00, 21.50, 41, 'male', 'L2Monster', 'Ranger', 1100, 1008, 5.500, 505, 2.100, 40, 43, 30, 21, 20, 20, 3783, 247, 243, 209, 166, 139, 253, 0, 506, 14, 0, 0, 45, 174, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.96, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (528, 20585, 'Timak Orc Soldier', '', 'batur_orc', 9.00, 21.50, 42, 'male', 'L2Monster', 'Fighter', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 3737, 248, 259, 216, 177, 144, 253, 500, 506, 66, 0, 0, 80, 174, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (529, 20586, 'Timak Orc Warrior', '', 'batur_orc_warrior', 10.00, 20.00, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 3582, 242, 277, 223, 189, 149, 253, 0, 506, 68, 0, 0, 80, 174, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (530, 20587, 'Timak Orc Shaman', '', 'batur_orc_shaman', 11.00, 16.00, 44, 'male', 'L2Monster', 'Priest', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 3379, 232, 295, 230, 202, 153, 253, 0, 506, 179, 0, 0, 50, 174, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (531, 20588, 'Timak Orc Overlord', '', 'batur_orc_overlord', 12.00, 24.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 4441, 308, 315, 239, 214, 158, 253, 500, 506, 127, 0, 0, 80, 174, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (532, 20589, 'Fline', '', 'sylph', 11.00, 35.00, 45, 'female', 'L2Monster', 'Mystic', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 6639, 462, 315, 239, 214, 158, 253, 0, 506, 0, 0, 0, 60, 174, 'elemental_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (533, 20590, 'Liele', '', 'undine', 12.00, 27.00, 46, 'female', 'L2Monster', 'Mystic', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 6869, 487, 335, 246, 228, 163, 253, 0, 506, 0, 0, 0, 60, 174, 'elemental_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (534, 20591, 'Valley Treant', '', 'ti_mi_tran', 23.00, 90.00, 47, 'male', 'L2Monster', 'Fighter', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 10140, 727, 356, 254, 243, 169, 253, 0, 506, 0, 0, 0, 12, 12, 'elemental_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (535, 20592, 'Satyr', '', 'pan', 14.00, 35.00, 48, 'male', 'L2Monster', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 11074, 809, 378, 262, 258, 174, 253, 500, 506, 291, 0, 0, 45, 174, 'elemental_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (536, 20593, 'Unicorn', '', 'unicorn', 14.00, 30.00, 49, 'male', 'L2Monster', 'Mystic', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 11880, 878, 400, 270, 273, 179, 253, 0, 506, 0, 0, 0, 46, 174, 'elemental_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (537, 20594, 'Forest Runner', '', 'mandragora_b', 12.00, 25.50, 50, 'female', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 8116, 611, 425, 278, 291, 185, 253, 0, 506, 0, 0, 0, 80, 174, 'elemental_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.13, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (538, 20595, 'Fline Elder', '', 'sylph', 11.00, 35.00, 51, 'female', 'L2Monster', 'Mystic', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 8443, 644, 449, 287, 307, 190, 253, 0, 506, 0, 0, 0, 60, 174, 'elemental_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (539, 20596, 'Liele Elder', '', 'undine', 12.00, 27.00, 52, 'female', 'L2Monster', 'Mystic', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 8953, 692, 475, 296, 324, 196, 253, 500, 506, 0, 0, 0, 60, 174, 'elemental_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (540, 20597, 'Valley Treant Elder', '', 'ti_mi_tran', 23.00, 90.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 18717, 1471, 503, 304, 344, 203, 253, 0, 506, 0, 0, 0, 12, 12, 'elemental_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (541, 20598, 'Satyr Elder', '', 'pan', 14.00, 35.00, 54, 'male', 'L2Monster', 'Fighter', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 13741, 1096, 531, 313, 362, 209, 253, 0, 506, 297, 0, 0, 45, 174, 'elemental_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (542, 20599, 'Unicorn Elder', '', 'unicorn', 14.00, 30.00, 55, 'male', 'L2Monster', 'Mystic', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 14255, 1151, 559, 323, 382, 215, 253, 0, 506, 0, 0, 0, 46, 174, 'elemental_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (543, 20600, 'Karul Bugbear', '', 'bugbear', 17.00, 35.00, 40, 'male', 'L2Monster', 'KarulBugbear', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 3290, 212, 227, 203, 155, 134, 253, 0, 506, 88, 0, 0, 55, 174, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (544, 20601, 'Tamlin Orc', '', 'batur_orc', 9.00, 21.50, 41, 'male', 'L2Monster', 'Fighter', 40, 1008, 5.500, 505, 2.100, 40, 43, 30, 21, 20, 20, 2934, 192, 243, 209, 166, 139, 253, 0, 506, 2, 0, 0, 80, 174, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (545, 20602, 'Tamlin Orc Archer', '', 'batur_orc_archer', 11.00, 21.50, 42, 'male', 'L2Monster', 'Ranger', 1100, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 3970, 264, 259, 216, 177, 144, 253, 0, 506, 14, 0, 0, 45, 174, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.96, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (546, 20603, 'Kronbe Spider', '', 'giant_spider', 26.00, 25.50, 43, 'male', 'L2Monster', 'Mystic', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 3259, 221, 277, 223, 189, 149, 253, 500, 506, 0, 0, 0, 72, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (547, 20604, 'Rakin', '', 'twin_headed_giant', 17.00, 39.00, 44, 'male', 'L2Monster', 'Fighter', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 3981, 272, 295, 230, 202, 153, 253, 0, 506, 89, 0, 0, 45, 174, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (548, 20605, 'Weird Drake', '', 'drake', 30.00, 100.00, 45, 'male', 'L2Monster', 'Mystic', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 3605, 251, 315, 239, 214, 158, 253, 500, 506, 0, 0, 0, 70, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (549, 20606, 'Kuran Kobold', '', 'kobold', 10.00, 15.00, 27, 'male', 'L2Monster', 'Fighter', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 2282, 116, 87, 125, 59, 84, 253, 0, 506, 0, 0, 0, 47, 110, 'kobold_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (550, 20607, 'Kuran Kobold Warrior', '', 'kobold', 10.00, 15.00, 28, 'male', 'L2Monster', 'Fighter', 40, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 2415, 127, 95, 131, 64, 87, 253, 0, 506, 0, 0, 0, 47, 110, 'kobold_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (551, 20608, 'Patin Archer', '', 'skeleton_archer', 11.00, 27.00, 29, 'male', 'L2Monster', 'Ranger', 1100, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 2454, 132, 101, 136, 70, 91, 253, 500, 506, 14, 0, 0, 40, 140, '1', 400, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (552, 20609, 'Rakin Salamander', '', 'salamander', 16.00, 6.80, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 2566, 140, 111, 140, 75, 94, 253, 0, 506, 0, 0, 0, 64, 96, 'elemental_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.20, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (553, 20610, 'Sentinel Of Water', '', 'monster_eye', 21.00, 43.00, 31, 'male', 'L2Monster', 'Mystic', 40, 636, 4.500, 344, 1.800, 40, 43, 30, 21, 20, 20, 2600, 144, 119, 146, 82, 97, 253, 0, 506, 0, 0, 0, 90, 90, 'elemental_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (554, 20611, 'Dre Vanul Warrior', '', 'dre_vanul', 14.00, 36.00, 32, 'male', 'L2Monster', 'Fighter', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 2770, 156, 128, 152, 87, 102, 253, 0, 506, 0, 0, 0, 80, 80, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (555, 20612, 'Salamander Rowin', '', 'salamander', 16.00, 6.80, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 3166, 181, 138, 157, 94, 105, 253, 500, 506, 0, 0, 0, 64, 96, 'elemental_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.20, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (556, 20613, 'Lafi Lizardman', '', 'virud_lizardman', 10.00, 23.00, 27, 'male', 'L2Monster', 'Fighter', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 2282, 116, 87, 125, 59, 84, 253, 0, 506, 291, 0, 0, 43, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (557, 20614, 'Lafi Lizardman Scout', '', 'virud_lizardman_scout', 10.00, 22.00, 28, 'male', 'L2Monster', 'Ranger', 1100, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 2257, 119, 95, 131, 64, 87, 253, 0, 506, 2507, 0, 0, 43, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (558, 20615, 'Ritmal Swordsman', '', 'spartoi', 11.00, 27.00, 29, 'male', 'L2Monster', 'Fighter', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 2626, 140, 101, 136, 70, 91, 253, 500, 506, 73, 0, 0, 60, 140, '1', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (559, 20616, 'Rakin Undine', '', 'undine', 12.00, 27.00, 30, 'female', 'L2Monster', 'Mystic', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 3443, 188, 111, 140, 75, 94, 253, 0, 506, 0, 0, 0, 60, 60, 'elemental_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (560, 20617, 'Sentinel Of Water', '', 'magical_weaver', 11.00, 20.00, 31, 'male', 'L2Monster', 'Mystic', 40, 636, 4.500, 344, 1.800, 40, 43, 30, 21, 20, 20, 2625, 145, 119, 146, 82, 97, 253, 0, 506, 0, 0, 0, 90, 90, '1', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (561, 20618, 'Kanil Succubus', '', 'succubus', 10.00, 36.00, 32, 'female', 'L2Monster', 'Mystic', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 2919, 164, 128, 152, 87, 102, 253, 0, 506, 0, 0, 0, 60, 100, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (562, 20619, 'Rowin Undine', '', 'undine', 12.00, 27.00, 33, 'female', 'L2Monster', 'Mystic', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 3005, 173, 138, 157, 94, 105, 253, 500, 506, 0, 0, 0, 60, 60, 'elemental_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (563, 20620, 'Cave Beast', '', 'troll', 21.00, 35.00, 61, 'male', 'L2Monster', 'Fighter', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 15494, 1363, 752, 378, 513, 252, 253, 500, 506, 0, 0, 0, 55, 174, '', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (564, 20621, 'Death Wave', '', 'will_o_wisp', 13.00, 22.00, 62, 'male', 'L2Monster', 'Mystic', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 16701, 1488, 787, 388, 538, 258, 253, 500, 506, 0, 0, 0, 80, 174, '1', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.10, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (565, 20622, 'Malruk Soldier', '', 'skeleton_royal_guard', 11.00, 28.50, 63, 'male', 'L2Monster', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 17833, 1610, 822, 398, 562, 266, 253, 500, 506, 221, 0, 0, 80, 174, 'malruk_clan', 500, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (566, 20623, 'Plando', '', 'virud_lizardman_scout', 10.00, 22.00, 64, 'male', 'L2Monster', 'Ranger', 1100, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 23778, 2177, 860, 409, 588, 272, 253, 500, 506, 2507, 0, 0, 43, 174, '1', 500, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (567, 20624, 'Cave Howler', '', 'twin_headed_giant', 17.00, 39.00, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 24178, 2246, 898, 419, 613, 279, 253, 500, 506, 0, 0, 0, 45, 174, '', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (568, 20625, 'Malruk Knight', '', 'skeleton_knight', 10.00, 25.00, 66, 'male', 'L2Monster', 'Fighter', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 24146, 2273, 936, 429, 639, 285, 253, 500, 506, 78, 0, 0, 40, 174, 'malruk_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (569, 20626, 'Malruk Berserker', '', 'death_knight', 12.00, 31.00, 67, 'male', 'L2Monster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 34656, 3300, 975, 440, 666, 292, 253, 500, 506, 77, 0, 0, 27, 174, 'malruk_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (570, 20627, 'Malruk Lord', '', 'death_blader', 15.00, 45.00, 68, 'male', 'L2Monster', 'Fighter', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 29789, 2878, 1014, 449, 692, 300, 253, 500, 506, 1472, 0, 0, 100, 174, 'malruk_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (571, 20628, 'Limal Karinness', '', 'bloody_queen', 14.00, 40.00, 69, 'female', 'L2Monster', 'Mystic', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 32098, 3140, 1055, 460, 720, 307, 253, 500, 506, 0, 0, 0, 80, 174, 'malruk_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (572, 20629, 'Karik', '', 'karik', 25.00, 90.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 39507, 3917, 1096, 471, 747, 313, 253, 500, 506, 0, 0, 0, 37, 174, '1', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (573, 20630, 'Taik Orc', '', 'ketra_orc', 12.00, 29.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 2792, 180, 227, 203, 155, 134, 253, 0, 506, 127, 0, 0, 45, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (574, 20631, 'Taik Orc Archer', '', 'ketra_orc_archer', 12.00, 27.00, 41, 'male', 'L2Monster', 'Ranger', 1100, 1008, 5.500, 505, 2.100, 40, 43, 30, 21, 20, 20, 3783, 247, 243, 209, 166, 139, 253, 0, 506, 14, 0, 0, 45, 174, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.91, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (575, 20632, 'Taik Orc Warrior', '', 'ketra_orc_warrior', 12.00, 24.00, 42, 'male', 'L2Monster', 'Fighter', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 3774, 251, 259, 216, 177, 144, 253, 500, 506, 75, 0, 0, 36, 174, 'orc_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (576, 20633, 'Taik Orc Shaman', '', 'ketra_orc_shaman', 10.00, 23.00, 43, 'male', 'L2Monster', 'Priest', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 3682, 248, 277, 223, 189, 149, 253, 0, 506, 9, 0, 0, 10, 174, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (577, 20634, 'Taik Orc Captain', '', 'ketra_orc_warrior', 12.00, 24.00, 44, 'male', 'L2Monster', 'Fighter', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 7065, 484, 295, 230, 202, 153, 253, 500, 506, 75, 104, 0, 36, 174, 'orc_clan', 300, 0, 20, 87, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (578, 20635, 'Carinkain', '', 'mana_vampire', 11.00, 20.00, 45, 'male', 'L2Monster', 'Mystic', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 3569, 248, 315, 239, 214, 158, 253, 500, 506, 0, 0, 0, 90, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (579, 20636, 'Forest of Mirrors Ghost', '', 'dwarf_ghost', 9.00, 16.50, 46, 'male', 'L2Monster', 'Mystic', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 3973, 282, 335, 246, 228, 163, 253, 500, 506, 0, 0, 0, 80, 174, 'mirrorforest_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (580, 20637, 'Forest of Mirrors Ghost', '', 'elf_ghost', 7.00, 21.00, 47, 'male', 'L2Monster', 'Mystic', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 4148, 298, 356, 254, 243, 169, 253, 500, 506, 0, 0, 0, 80, 174, 'mirrorforest_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (581, 20638, 'Forest of Mirrors Ghost', '', 'human_ghost', 8.00, 22.00, 48, 'male', 'L2Monster', 'Mystic', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 4326, 316, 378, 262, 258, 174, 253, 500, 506, 0, 0, 0, 80, 174, 'mirrorforest_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (582, 20639, 'Mirror', '', 'mirror', 26.00, 52.00, 49, 'male', 'L2Monster', 'Mystic', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 10210, 755, 400, 270, 273, 179, 253, 0, 506, 0, 0, 0, 80, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (583, 20640, 'Harit Lizardman', '', 'zenta_lizardman', 11.00, 32.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 4363, 329, 425, 278, 291, 185, 253, 0, 506, 88, 945, 0, 37, 174, 'lizardman_clan', 300, 0, 20, 100, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (584, 20641, 'Harit Lizardman Grunt', '', 'zenta_lizardman', 11.00, 32.00, 51, 'male', 'L2Monster', 'Fighter', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 5402, 412, 449, 287, 307, 190, 253, 0, 506, 70, 0, 0, 37, 174, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (585, 20642, 'Harit Lizardman Archer', '', 'zenta_lizardman_scout', 11.00, 30.00, 52, 'male', 'L2Monster', 'Ranger', 1100, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 5057, 391, 475, 296, 324, 196, 253, 500, 506, 14, 0, 0, 37, 174, 'lizardman_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.93, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (586, 20643, 'Harit Lizardman Warrior', '', 'zenta_lizardman_warrior', 13.00, 35.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 5199, 409, 503, 304, 344, 203, 253, 0, 506, 291, 0, 0, 40, 174, 'lizardman_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (587, 20644, 'Harit Lizardman Shaman', '', 'zenta_lizardman_shaman', 13.00, 35.00, 54, 'male', 'L2Monster', 'Priest', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 5089, 406, 531, 313, 362, 209, 253, 0, 506, 9, 0, 0, 43, 174, 'lizardman_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (588, 20645, 'Harit Lizardman Matriarch', '', 'zenta_lizardman_matriarch', 20.00, 40.00, 55, 'male', 'L2Monster', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 11444, 924, 559, 323, 382, 215, 253, 500, 506, 221, 0, 0, 53, 174, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (589, 20646, 'Halingka', '', 'saber_toothed_tiger', 34.00, 28.00, 55, 'male', 'L2Monster', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 8623, 696, 559, 323, 382, 215, 253, 0, 506, 0, 0, 0, 60, 170, 'beast_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (590, 20647, 'Yintzu', '', 'field_stalker', 15.00, 30.00, 56, 'male', 'L2Monster', 'Fighter', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 8653, 710, 589, 331, 402, 220, 253, 500, 506, 0, 0, 0, 70, 110, 'beast_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (591, 20648, 'Paliote', '', 'will_o_wisp', 13.00, 22.00, 57, 'male', 'L2Monster', 'Mystic', 40, 1777, 6.500, 948, 2.400, 40, 43, 30, 21, 20, 20, 9826, 816, 619, 340, 423, 226, 253, 0, 506, 0, 0, 0, 80, 140, 'beast_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.10, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (592, 20649, 'Hamrut', '', 'poison_spider', 27.00, 25.50, 58, 'male', 'L2Monster', 'Mystic', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 9781, 827, 651, 350, 444, 232, 253, 500, 506, 0, 0, 0, 60, 140, 'beast_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (593, 20650, 'Kranrot', '', 'crimson_bear', 19.00, 36.00, 59, 'male', 'L2Monster', 'Fighter', 40, 1881, 6.500, 1007, 2.400, 40, 43, 30, 21, 20, 20, 10586, 905, 684, 360, 466, 240, 253, 500, 506, 0, 0, 0, 37, 170, 'beast_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (594, 20651, 'Gamlin', '', 'gamlin', 11.00, 32.00, 60, 'male', 'L2Monster', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 9835, 853, 717, 370, 490, 246, 253, 0, 506, 0, 0, 0, 80, 170, 'giant_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (595, 20652, 'Leogul', '', 'leogul', 15.00, 35.00, 61, 'male', 'L2Monster', 'Fighter', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 10369, 913, 752, 378, 513, 252, 253, 500, 506, 0, 0, 0, 80, 170, 'giant_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (596, 20653, 'Lesser Giant', '', 'lesser_giant', 21.00, 44.00, 61, 'male', 'L2Monster', 'Fighter', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 14612, 1286, 752, 378, 513, 252, 253, 0, 506, 3937, 0, 0, 15, 180, 'giant_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.58, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (597, 20654, 'Lesser Giant Soldier', '', 'lesser_giant', 21.00, 44.00, 62, 'male', 'L2Monster', 'Fighter', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 22406, 1997, 787, 388, 538, 258, 253, 0, 506, 3937, 0, 0, 15, 180, 'giant_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (598, 20655, 'Lesser Giant Shooter', '', 'lesser_giant_shooter', 21.00, 44.00, 63, 'male', 'L2Monster', 'Ranger', 1100, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 18307, 1652, 822, 398, 562, 266, 253, 500, 506, 4028, 0, 0, 80, 180, 'giant_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (599, 20656, 'Lesser Giant Scout', '', 'lesser_giant_shooter', 21.00, 44.00, 63, 'male', 'L2Monster', 'Ranger', 1100, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 16702, 1508, 822, 398, 562, 266, 253, 500, 506, 4028, 0, 0, 80, 180, 'giant_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (600, 20657, 'Lesser Giant Mage', '', 'lesser_giant_mage', 21.00, 44.00, 64, 'male', 'L2Monster', 'Mystic', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 13228, 1211, 860, 409, 588, 272, 253, 0, 506, 3938, 0, 0, 15, 180, 'giant_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (601, 20658, 'Lesser Giant Elder', '', 'lesser_giant_mage', 21.00, 44.00, 65, 'male', 'L2Monster', 'Mystic', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 12778, 1187, 898, 419, 613, 279, 253, 0, 506, 3938, 0, 0, 15, 180, 'giant_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (602, 20659, 'Grave Wanderer', '', 'zombie', 13.00, 21.00, 45, 'male', 'L2Monster', 'Mystic', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 4948, 344, 315, 239, 214, 158, 253, 0, 506, 0, 0, 0, 15, 15, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (603, 20660, 'Archer of Greed', '', 'skeleton_archer', 11.00, 27.00, 46, 'male', 'L2Monster', 'Ranger', 1100, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 4858, 344, 335, 246, 228, 163, 253, 500, 506, 14, 0, 0, 40, 174, '1', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (604, 20661, 'Hatar Ratman Thief', '', 'wererat', 14.00, 25.00, 47, 'male', 'L2Monster', 'Fighter', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 4588, 329, 356, 254, 243, 169, 253, 0, 506, 946, 0, 0, 80, 174, 'hatar_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (605, 20662, 'Hatar Ratman Boss', '', 'wererat', 14.00, 25.00, 48, 'male', 'L2Monster', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 4785, 349, 378, 262, 258, 174, 253, 0, 506, 221, 0, 0, 80, 174, 'hatar_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (606, 20663, 'Hatar Hanishee', '', 'medusa', 10.00, 25.00, 49, 'female', 'L2Monster', 'Mystic', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 4190, 310, 400, 270, 273, 179, 253, 0, 506, 0, 0, 0, 50, 174, 'hatar_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (607, 20664, 'Deprive', '', 'field_stalker', 15.00, 30.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 4406, 332, 425, 278, 291, 185, 253, 500, 506, 0, 0, 0, 70, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (608, 20665, 'Taik Orc Supply', '', 'ketra_orc', 12.00, 29.00, 51, 'male', 'L2Monster', 'Priest', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 5402, 412, 449, 287, 307, 190, 253, 0, 506, 69, 0, 0, 45, 174, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (609, 20666, 'Taik Orc Seeker', '', 'ketra_orc', 12.00, 29.00, 52, 'male', 'L2Monster', 'Fighter', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 5616, 434, 475, 296, 324, 196, 253, 0, 506, 72, 0, 0, 45, 174, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (610, 20667, 'Farcran', '', 'crimson_bear', 19.00, 36.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 5776, 454, 503, 304, 344, 203, 253, 0, 506, 0, 0, 0, 37, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (611, 20668, 'Grave Guard', '', 'gargoyle', 16.00, 50.00, 54, 'male', 'L2Monster', 'Fighter', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 5140, 409, 531, 313, 362, 209, 253, 500, 506, 0, 0, 0, 140, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (612, 20669, 'Taik Orc Supply Leader', '', 'ketra_orc_warrior', 12.00, 24.00, 55, 'male', 'L2Monster', 'Priest', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 6408, 517, 559, 323, 382, 215, 253, 500, 506, 75, 0, 0, 36, 174, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (613, 20670, 'Crimson Drake', '', 'drake', 30.00, 100.00, 61, 'male', 'L2Monster', 'Mystic', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 6558, 577, 752, 378, 513, 252, 253, 500, 506, 0, 0, 0, 70, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (614, 20671, 'Kadios', '', 'devastator', 35.00, 35.00, 62, 'male', 'L2Monster', 'Fighter', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 6843, 610, 787, 388, 538, 258, 253, 500, 506, 0, 0, 0, 25, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (615, 20672, 'Trives', '', 'serpent_slave', 17.00, 46.00, 63, 'male', 'L2Monster', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 6927, 625, 822, 398, 562, 266, 253, 0, 506, 127, 0, 0, 70, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (616, 20673, 'Falibati', '', 'cave_maiden', 25.00, 65.00, 64, 'female', 'L2Monster', 'Fighter', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 7219, 661, 860, 409, 588, 272, 253, 500, 506, 73, 0, 0, 70, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (617, 20674, 'Doom Knight', '', 'death_blader', 15.00, 45.00, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 10379, 965, 898, 419, 613, 279, 253, 500, 506, 1472, 0, 0, 100, 174, 'doom_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (618, 20675, 'Tairim', '', 'will_o_wisp', 13.00, 22.00, 50, 'male', 'L2Monster', 'Mystic', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 4581, 346, 425, 278, 291, 185, 253, 0, 506, 0, 0, 0, 80, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.10, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (619, 20676, 'Judge of Marsh', '', 'hanged_man_ripper', 35.00, 80.00, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 7447, 692, 898, 419, 613, 279, 253, 500, 506, 0, 0, 0, 55, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (620, 20677, 'Tulben', '', 'vampire_bat', 10.00, 33.50, 66, 'male', 'L2Monster', 'Mystic', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 8363, 787, 936, 429, 639, 285, 253, 0, 506, 0, 0, 0, 60, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (621, 20678, 'Tortured Undead', '', 'hungry_spirit', 30.00, 40.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 4902, 385, 503, 304, 344, 203, 253, 0, 506, 0, 0, 0, 15, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (622, 20679, 'Marsh Stalker', '', 'gargoyle', 16.00, 50.00, 54, 'male', 'L2Monster', 'Fighter', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 5039, 402, 531, 313, 362, 209, 253, 0, 506, 0, 0, 0, 140, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (623, 20680, 'Marsh Drake', '', 'drake', 30.00, 100.00, 55, 'male', 'L2Monster', 'Mystic', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 5332, 431, 559, 323, 382, 215, 253, 500, 506, 0, 0, 0, 70, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (624, 20681, 'Vanor Silenos', '', 'heltor_silenos', 13.00, 29.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 3711, 258, 315, 239, 214, 158, 253, 0, 506, 88, 0, 0, 34, 174, 'silenos_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (625, 20682, 'Vanor Silenos Grunt', '', 'heltor_silenos', 13.00, 29.00, 46, 'male', 'L2Monster', 'Fighter', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 3693, 262, 335, 246, 228, 163, 253, 0, 506, 158, 18, 0, 34, 174, 'silenos_clan', 300, 0, 20, 91, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (626, 20683, 'Vanor Silenos Scout', '', 'heltor_silenos', 13.00, 29.00, 47, 'male', 'L2Monster', 'Fighter', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 4805, 344, 356, 254, 243, 169, 253, 500, 506, 5, 0, 0, 34, 174, 'silenos_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (627, 20684, 'Vanor Silenos Warrior', '', 'heltor_silenos_warrior', 13.00, 31.00, 48, 'male', 'L2Monster', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 5026, 367, 378, 262, 258, 174, 253, 0, 506, 160, 0, 0, 36, 174, 'silenos_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (628, 20685, 'Vanor Silenos Shaman', '', 'heltor_silenos_shaman', 13.00, 32.00, 49, 'male', 'L2Monster', 'Priest', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 4190, 310, 400, 270, 273, 179, 253, 0, 506, 9, 0, 0, 29, 174, 'silenos_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.22, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (629, 20686, 'Vanor Silenos Chieftain', '', 'heltor_silenos_chieftain', 13.00, 31.50, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 8731, 658, 425, 278, 291, 185, 253, 0, 506, 75, 0, 0, 27, 174, 'silenos_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (630, 20738, 'Kobold Looter Bepook', '', 'kobold_bi', 15.00, 24.00, 13, 'male', 'L2Monster', 'Fighter', 40, 215, 2.500, 133, 1.200, 40, 43, 30, 21, 20, 20, 1326, 52, 26, 70, 17, 47, 253, 500, 506, 4, 0, 0, 47, 110, 'partisan_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (631, 20739, 'Bepooks Pet', '', 'wolf', 13.00, 9.00, 10, 'male', 'L2Minion', 'Fighter', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 220, 7, 19, 61, 13, 41, 253, 0, 506, 0, 0, 0, 24, 110, 'partisan_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (632, 20742, 'Mystical Weaver', '', 'magical_weaver', 11.00, 20.00, 22, 'male', 'L2Monster', 'Mystic', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 821, 38, 58, 103, 39, 69, 253, 0, 506, 0, 0, 0, 90, 90, 'partisan_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (633, 20743, 'Howler', '', 'werewolf', 10.00, 26.00, 25, 'male', 'L2Monster', 'Fighter', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 1012, 50, 74, 116, 50, 78, 253, 500, 506, 0, 0, 0, 50, 120, 'partisan_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (634, 20744, 'Red Eye Vampire Bat', '', 'vampire_bat', 10.00, 33.50, 22, 'male', 'L2Monster', 'Mystic', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 821, 38, 58, 103, 39, 69, 253, 0, 506, 0, 0, 0, 60, 80, 'partisan_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (635, 20745, 'Gigantiops', '', 'ant_soldier', 35.00, 17.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 3218, 191, 160, 170, 109, 113, 253, 500, 506, 0, 0, 0, 80, 174, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (636, 20746, 'Young Gigantiops', '', 'ant', 26.00, 15.00, 31, 'male', 'L2Minion', 'Fighter', 40, 636, 4.500, 344, 1.800, 40, 43, 30, 21, 20, 20, 2475, 137, 119, 146, 82, 97, 253, 0, 506, 0, 0, 0, 40, 139, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (637, 20747, 'Roxide', '', 'succubus', 10.00, 36.00, 32, 'female', 'L2Monster', 'Mystic', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 3504, 197, 128, 152, 87, 102, 253, 500, 506, 0, 0, 0, 60, 159, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (638, 20748, 'Roxide Cohort', '', 'spartoi', 11.00, 27.00, 29, 'male', 'L2Minion', 'Fighter', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 3240, 174, 101, 136, 70, 91, 253, 0, 506, 73, 0, 0, 60, 159, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (639, 20749, 'Death Fire', '', 'dre_vanul', 14.00, 36.00, 32, 'male', 'L2Monster', 'Fighter', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 3504, 197, 128, 152, 87, 102, 253, 500, 506, 0, 0, 0, 80, 159, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (640, 20750, 'Fire Archer', '', 'skeleton_archer', 11.00, 27.00, 29, 'male', 'L2Minion', 'Ranger', 1100, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 3354, 180, 101, 136, 70, 91, 253, 0, 506, 14, 0, 0, 40, 159, 'demonic_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (641, 20751, 'Snipe', '', 'onyx_beast', 14.00, 14.50, 44, 'male', 'L2Monster', 'Fighter', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 13373, 880, 295, 230, 202, 169, 253, 500, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (642, 20752, 'Snipe Cohort', '', 'onyx_beast', 14.00, 14.50, 42, 'male', 'L2Minion', 'Fighter', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 7085, 451, 259, 216, 177, 159, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (643, 20753, 'Dark Lord', '', 'death_blader', 15.00, 45.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 11417, 826, 425, 278, 291, 204, 253, 500, 506, 1472, 0, 0, 100, 170, 'undead_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (644, 20754, 'Dark Knight', '', 'death_knight', 12.00, 31.00, 48, 'male', 'L2Minion', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 12549, 887, 378, 262, 258, 192, 253, 0, 506, 127, 0, 0, 27, 110, 'undead_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (645, 20755, 'Talakin', '', 'ol_mahum_champion', 14.00, 27.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 2364, 130, 111, 140, 75, 94, 253, 500, 506, 2, 0, 0, 50, 133, 'ol_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (646, 20756, 'Talakin Archer', '', 'ol_mahum_archer', 14.00, 25.00, 28, 'male', 'L2Minion', 'Ranger', 1100, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 2261, 119, 95, 131, 64, 87, 253, 0, 506, 14, 0, 0, 50, 133, 'ol_mahum_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.93, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (647, 20757, 'Talakin Raider', '', 'ol_mahum', 13.50, 25.00, 27, 'male', 'L2Minion', 'Fighter', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 1657, 85, 87, 125, 59, 84, 253, 0, 506, 3, 0, 0, 50, 133, 'ol_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (648, 20758, 'Dragon Bearer Chief', '', 'spartoi', 11.00, 27.00, 49, 'male', 'L2Monster', 'Fighter', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 6307, 467, 400, 270, 273, 179, 253, 500, 506, 123, 945, 0, 60, 174, 'cave_servant_clan', 300, 0, 20, 98, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (649, 20759, 'Dragon Bearer Warrior', '', 'skeleton', 11.00, 25.00, 48, 'male', 'L2Minion', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 5934, 433, 378, 262, 258, 174, 253, 0, 506, 2, 945, 0, 60, 174, 'cave_servant_clan', 300, 0, 20, 96, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (650, 20760, 'Dragon Bearer Archer', '', 'skeleton_archer', 11.00, 27.00, 47, 'male', 'L2Minion', 'Ranger', 1100, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 6165, 442, 356, 254, 243, 169, 253, 0, 506, 14, 0, 0, 40, 174, 'cave_servant_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (651, 20761, 'Pytan', '', 'bloody_queen', 14.00, 40.00, 69, 'female', 'L2Monster', 'Mystic', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 23881, 2336, 1055, 460, 720, 307, 253, 500, 506, 0, 0, 0, 80, 174, 'malruk_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (652, 20762, 'Pytan Knight', '', 'death_blader', 15.00, 45.00, 68, 'male', 'L2Minion', 'Fighter', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 16852, 1628, 1014, 449, 692, 300, 253, 0, 506, 1472, 0, 0, 100, 174, 'malruk_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (653, 20763, 'Lord of the Plains', '', 'zenta_lizardman_matriarch', 20.00, 40.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 4644, 300, 227, 203, 155, 134, 253, 500, 506, 221, 0, 0, 53, 174, 'lizardman_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (654, 20764, 'Shaman of the Plains', '', 'zenta_lizardman_shaman', 13.00, 35.00, 39, 'male', 'L2Minion', 'Priest', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 4150, 264, 212, 195, 145, 131, 253, 0, 506, 179, 0, 0, 43, 174, 'lizardman_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (655, 20765, 'Warrior of the Plains', '', 'zenta_lizardman_warrior', 13.00, 35.00, 38, 'male', 'L2Minion', 'Fighter', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 3591, 224, 198, 188, 136, 126, 253, 0, 506, 16, 0, 0, 40, 174, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (656, 20766, 'Scout of the Plains', '', 'zenta_lizardman_scout', 11.00, 30.00, 36, 'male', 'L2Minion', 'Ranger', 1100, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 3192, 193, 173, 176, 118, 118, 253, 0, 506, 14, 0, 0, 37, 174, 'lizardman_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.93, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (657, 20767, 'Timak Orc Troop Leader', '', 'batur_orc_overlord', 12.00, 24.00, 45, 'male', 'L2Monster', 'TimakOrcTroopLeader', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 5762, 401, 315, 239, 214, 158, 253, 0, 506, 79, 0, 0, 80, 174, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (658, 20768, 'Timak Orc Troop Shaman', '', 'batur_orc_shaman', 11.00, 16.00, 44, 'male', 'L2Monster', 'Priest', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 5559, 380, 295, 230, 202, 153, 253, 0, 506, 7, 0, 0, 50, 174, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (659, 20769, 'Timak Orc Troop Warrior', '', 'batur_orc_warrior', 10.00, 20.00, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 4421, 299, 277, 223, 189, 149, 253, 0, 506, 123, 19, 0, 80, 174, 'orc_clan', 300, 0, 20, 85, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (660, 20770, 'Timak Orc Troop Archer', '', 'batur_orc_archer', 11.00, 21.50, 41, 'male', 'L2Monster', 'Ranger', 1100, 1008, 5.500, 505, 2.100, 40, 43, 30, 21, 20, 20, 5183, 340, 243, 209, 166, 139, 253, 0, 506, 13, 0, 0, 45, 174, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.96, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (661, 20771, 'Barif', '', 'lesser_giant_mage', 21.00, 44.00, 64, 'male', 'L2Monster', 'Mystic', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 15637, 1432, 860, 409, 588, 272, 253, 500, 506, 3938, 0, 0, 15, 180, 'giant_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (662, 20772, 'Barifs Pet', '', 'leogul', 15.00, 35.00, 61, 'male', 'L2Minion', 'Fighter', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 15199, 1338, 752, 378, 513, 252, 253, 0, 506, 0, 0, 0, 80, 170, 'giant_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (663, 20773, 'Conjurer Bat Lord', '', 'vampire_bat', 10.00, 33.50, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 12643, 1284, 1179, 491, 805, 327, 253, 500, 506, 0, 0, 0, 60, 174, 'giant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (664, 20774, 'Conjurer Bat ', '', 'vampire_bat', 10.00, 33.50, 70, 'male', 'L2Minion', 'Mystic', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 13368, 1326, 1096, 471, 747, 313, 253, 0, 506, 0, 0, 0, 60, 174, 'giant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (665, 20775, 'Bugbear Raider', '', 'bugbear', 17.00, 35.00, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 600, 25, 37, 84, 25, 55, 253, 0, 506, 0, 0, 0, 55, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (666, 20776, 'Dark Succubus', '', 'succubus', 10.00, 36.00, 20, 'female', 'L2Monster', 'Mystic', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 784, 35, 48, 95, 33, 63, 253, 0, 506, 0, 0, 0, 60, 100, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (667, 20777, 'Hunter Bear', '', 'grizzly', 21.00, 40.00, 14, 'male', 'L2Monster', 'Fighter', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 499, 19, 28, 73, 20, 48, 253, 0, 506, 0, 0, 0, 40, 110, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (668, 20778, 'Ragna Orc Overlord', '', 'orc_champion', 10.00, 23.00, 39, 'male', 'L2Monster', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 2973, 188, 212, 195, 145, 131, 253, 0, 506, 2, 0, 0, 45, 174, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (669, 20779, 'Ragna Orc Seer', '', 'orc_shaman', 9.00, 22.00, 39, 'male', 'L2Monster', 'Priest', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 2655, 169, 212, 195, 145, 131, 253, 0, 506, 7, 0, 0, 45, 174, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (670, 20780, 'Bloody Axe Elite', '', 'ol_mahum_champion', 14.00, 27.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 2159, 127, 160, 170, 109, 113, 253, 500, 506, 2, 0, 0, 50, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (671, 20781, 'Delu Lizardman Shaman', '', 'virud_lizardman_shaman', 10.00, 29.00, 35, 'male', 'L2Monster', 'Priest', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 2138, 126, 160, 170, 109, 113, 253, 0, 506, 7, 0, 0, 43, 174, 'lizardman_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (672, 20782, 'Ol Mahum Novice', '', 'ol_mahum', 13.50, 25.00, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 618, 26, 37, 84, 25, 55, 253, 500, 506, 1, 0, 0, 50, 110, 'ol_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (673, 20783, 'Dread Wolf', '', 'dire_wolf', 13.00, 11.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 981, 58, 160, 170, 109, 113, 253, 500, 506, 0, 0, 0, 24, 140, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (674, 20784, 'Tasaba Lizardman', '', 'virud_lizardman_scout', 10.00, 22.00, 36, 'male', 'L2Monster', 'Ranger', 1100, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 1111, 67, 173, 176, 118, 118, 253, 0, 506, 2507, 0, 0, 43, 140, 'lizardman_clan1', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (675, 20785, 'Tasaba Lizardman Shaman', '', 'virud_lizardman_shaman', 10.00, 29.00, 37, 'male', 'L2Monster', 'Priest', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 1075, 66, 185, 181, 126, 121, 253, 0, 506, 7, 0, 0, 43, 140, 'lizardman_clan1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (676, 20786, 'Lienrik', '', 'lienrik', 12.00, 50.00, 39, 'male', 'L2Monster', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 1195, 76, 212, 195, 145, 131, 253, 0, 506, 0, 0, 0, 100, 150, 'lienrik_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (677, 20787, 'Lienrik Lad', '', 'lienrik', 12.00, 50.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 1453, 94, 227, 203, 155, 134, 253, 500, 506, 0, 0, 0, 100, 174, 'lienrik_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (678, 20788, 'Rakul', '', 'rakul', 30.00, 39.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 2544, 150, 160, 170, 109, 113, 253, 0, 506, 3, 0, 0, 60, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (679, 20789, 'Crokian', '', 'crokian', 18.00, 29.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 2399, 145, 173, 176, 118, 118, 253, 500, 506, 5128, 0, 0, 18, 174, 'croc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.78, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (680, 20790, 'Dailaon', '', 'dailaon', 20.00, 28.00, 37, 'male', 'L2Monster', 'Ranger', 1100, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 3081, 190, 185, 181, 126, 121, 253, 0, 506, 5127, 0, 0, 18, 174, 'croc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.91, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (681, 20791, 'Crokian Warrior', '', 'crokian', 18.00, 29.00, 38, 'male', 'L2Monster', 'Fighter', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 5307, 331, 198, 188, 136, 126, 253, 500, 506, 5128, 0, 0, 18, 174, 'croc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.78, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (682, 20792, 'Farhite', '', 'farhite', 16.00, 31.00, 39, 'male', 'L2Monster', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 4938, 314, 212, 195, 145, 131, 253, 0, 506, 5131, 0, 0, 15, 174, 'croc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (683, 20793, 'Nos', '', 'nos', 26.00, 42.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 5404, 349, 227, 203, 155, 134, 253, 500, 506, 5130, 0, 0, 18, 174, 'croc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.78, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (684, 20794, 'Blade Stakato', '', 'blade_stakato', 15.00, 36.00, 41, 'male', 'L2Monster', 'Fighter', 40, 1008, 5.500, 505, 2.100, 40, 43, 30, 21, 20, 20, 5048, 330, 243, 209, 166, 139, 253, 0, 506, 223, 0, 0, 25, 174, 'stakato_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (685, 20795, 'Blade Stakato Worker', '', 'blade_stakato_worker', 13.00, 40.00, 42, 'male', 'L2Monster', 'Fighter', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 4772, 318, 259, 216, 177, 144, 253, 0, 506, 226, 0, 0, 25, 174, 'stakato_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (686, 20796, 'Blade Stakato Warrior', '', 'blade_stakato_soldier', 15.00, 38.00, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 5102, 344, 277, 223, 189, 149, 253, 500, 506, 232, 0, 0, 25, 174, 'stakato_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (687, 20797, 'Blade Stakato Drone', '', 'blade_stakato_drone', 15.00, 39.00, 44, 'male', 'L2Monster', 'Fighter', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 7754, 530, 295, 230, 202, 153, 253, 0, 506, 74, 0, 0, 25, 174, 'stakato_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (688, 20798, 'Water Giant', '', 'water_giant', 13.00, 44.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 6270, 436, 315, 239, 214, 158, 253, 500, 506, 5132, 0, 0, 35, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (689, 20799, 'Queen Undine Lad', '', 'undine', 12.00, 27.00, 46, 'female', 'L2Monster', 'Mystic', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 6312, 448, 335, 246, 228, 163, 253, 0, 506, 0, 0, 0, 60, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (690, 20800, 'Evas Seeker', '', 'field_stalker', 15.00, 30.00, 47, 'male', 'L2Monster', 'Fighter', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 5917, 424, 356, 254, 243, 169, 253, 0, 506, 0, 0, 0, 70, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (691, 20801, 'Theeder Piker', '', 'theeder', 9.00, 32.00, 48, 'male', 'L2Monster', 'Fighter', 80, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 7134, 521, 378, 262, 258, 174, 253, 500, 506, 302, 0, 0, 80, 174, 'theeder_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (692, 20802, 'Theeder Mage', '', 'theeder', 9.00, 32.00, 49, 'male', 'L2Monster', 'Mystic', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 7262, 536, 400, 270, 273, 179, 253, 0, 506, 192, 0, 0, 80, 174, 'theeder_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (693, 20803, 'Doll Master', '', 'doll_master', 20.00, 42.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 14218, 1072, 425, 278, 291, 185, 253, 500, 506, 0, 0, 0, 80, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (694, 20804, 'Crokian Lad', '', 'crokian_100_bi', 36.00, 61.00, 41, 'male', 'L2Monster', 'Fighter', 40, 1008, 5.500, 505, 2.100, 40, 43, 30, 21, 20, 20, 6178, 404, 243, 209, 166, 139, 253, 500, 506, 5128, 0, 0, 18, 174, 'croc_clan2', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.78, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (695, 20805, 'Dailaon Lad', '', 'dailaon_100_bi', 40.00, 58.00, 42, 'male', 'L2Monster', 'Ranger', 1100, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 6697, 446, 259, 216, 177, 144, 253, 0, 506, 5127, 0, 0, 18, 174, 'croc_clan2', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.91, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (696, 20806, 'Crokian Lad Warrior', '', 'crokian_100_bi', 36.00, 61.00, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 6428, 434, 277, 223, 189, 149, 253, 500, 506, 5128, 0, 0, 18, 174, 'croc_clan2', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.78, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (697, 20807, 'Farhite Lad', '', 'farhite_50_bi', 24.00, 48.00, 44, 'male', 'L2Monster', 'Fighter', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 6761, 463, 295, 230, 202, 153, 253, 0, 506, 5131, 0, 0, 15, 174, 'croc_clan2', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (698, 20808, 'Nos Lad', '', 'nos_100_bi', 52.00, 86.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 8371, 582, 315, 239, 214, 158, 253, 500, 506, 128, 0, 0, 18, 174, 'croc_clan2', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.78, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (699, 20809, 'Ghost of the Tower', '', 'human_ghost', 8.00, 22.00, 60, 'male', 'L2Monster', 'Mystic', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 14562, 1264, 717, 370, 490, 246, 253, 500, 506, 0, 0, 0, 80, 143, 'tower_ghost_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (700, 20810, 'Seer of Hallate', '', 'field_stalker', 15.00, 30.00, 60, 'male', 'L2Monster', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 14562, 1264, 717, 370, 490, 246, 253, 500, 506, 0, 0, 0, 70, 170, 'hallate_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (701, 20811, 'Ghastly Warrior', '', 'unpleasant_humming', 12.00, 26.00, 61, 'male', 'L2Monster', 'Fighter', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 17170, 1511, 752, 378, 513, 252, 253, 500, 506, 0, 0, 0, 21, 150, 'tower_ghost_clan', 400, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (702, 20812, 'Archer of Despair', '', 'skeleton_archer', 11.00, 27.00, 61, 'male', 'L2Monster', 'Ranger', 1100, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 16950, 1492, 752, 378, 513, 252, 253, 500, 506, 284, 0, 0, 40, 160, 'tower_ghost_clan', 400, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (703, 20813, 'Crendion', '', 'liviona', 15.00, 28.00, 62, 'male', 'L2Monster', 'Fighter', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 15397, 1372, 787, 388, 538, 258, 253, 500, 506, 0, 0, 0, 80, 160, 'tower_ghost_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (704, 20814, 'Blader of Despair', '', 'spartoi', 11.00, 27.00, 62, 'male', 'L2Monster', 'Fighter', 80, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 17778, 1584, 787, 388, 538, 258, 253, 500, 506, 79, 0, 0, 60, 143, 'tower_ghost_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (705, 20815, 'Hound Dog of Hallate', '', 'dire_wolf', 13.00, 11.00, 63, 'male', 'L2Monster', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 22001, 1986, 822, 398, 562, 266, 253, 500, 506, 0, 0, 0, 24, 165, 'hallate_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (706, 20816, 'Hallates Royal Guard', '', 'skeleton_royal_guard', 11.00, 28.50, 63, 'male', 'L2Monster', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 18356, 1657, 822, 398, 562, 266, 253, 500, 506, 946, 945, 0, 80, 164, 'hallate_clan', 400, 0, 20, 131, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (707, 20817, 'Corrupt Sage', '', 'vale_master', 12.00, 40.00, 64, 'male', 'L2Monster', 'Mystic', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 19137, 1752, 860, 409, 588, 272, 253, 500, 506, 210, 0, 0, 70, 160, 'tower_ghost_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (708, 20818, 'Hallates Warrior', '', 'skeleton_knight', 10.00, 25.00, 64, 'male', 'L2Monster', 'Fighter', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 17735, 1624, 860, 409, 588, 272, 253, 500, 506, 78, 0, 0, 40, 160, 'hallate_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (709, 20819, 'Archer of Abyss', '', 'fiend_archer', 17.00, 55.00, 65, 'male', 'L2Monster', 'Ranger', 1100, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 17603, 1636, 898, 419, 613, 279, 253, 500, 506, 0, 0, 0, 70, 165, 'tower_ghost_clan', 400, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (710, 20820, 'Hallates Knight', '', 'death_knight', 12.00, 31.00, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 35090, 3260, 898, 419, 613, 279, 253, 500, 506, 80, 0, 0, 27, 160, 'hallate_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (711, 20821, 'Erin Ediunce', '', 'banshee', 9.00, 23.00, 66, 'female', 'L2Monster', 'Mystic', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 25609, 2411, 936, 429, 639, 285, 253, 500, 506, 3939, 0, 0, 80, 165, 'tower_guard_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (712, 20822, 'Hallates Maid', '', 'bloody_queen', 14.00, 40.00, 66, 'female', 'L2Monster', 'Mystic', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 23832, 2243, 936, 429, 639, 285, 253, 500, 506, 0, 0, 0, 80, 160, 'hallate_clan', 400, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (713, 20823, 'Platinum Tribe Soldier', '', 'kel_mahum', 13.00, 26.00, 67, 'male', 'L2Monster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 27669, 2635, 975, 440, 666, 292, 253, 500, 506, 242, 0, 0, 50, 160, 'tower_guard_clan', 400, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (714, 20824, 'Hallates Commander', '', 'death_blader', 15.00, 45.00, 67, 'male', 'L2Monster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 24884, 2370, 975, 440, 666, 292, 253, 500, 506, 1472, 0, 0, 100, 170, 'hallate_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (715, 20825, 'Hallates Inspector', '', 'karik_25_bi', 31.00, 110.00, 68, 'male', 'L2Monster', 'Fighter', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 25991, 2510, 1014, 449, 692, 300, 253, 500, 506, 0, 0, 0, 37, 170, 'hallate_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (716, 20826, 'Platinum Tribe Archer', '', 'kel_mahum_archer', 13.00, 27.00, 68, 'male', 'L2Monster', 'Ranger', 1100, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 27541, 2660, 1014, 449, 692, 300, 253, 500, 506, 288, 0, 0, 50, 160, 'tower_guard_clan', 400, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.91, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (717, 20827, 'Platinum Tribe Warrior', '', 'kel_mahum_warrior', 13.00, 28.00, 69, 'male', 'L2Monster', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 28758, 2814, 1055, 460, 720, 307, 253, 500, 506, 148, 0, 0, 50, 160, 'tower_guard_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (718, 20828, 'Platinum Tribe Shaman', '', 'kel_mahum_witch_doctor', 13.00, 25.00, 70, 'male', 'L2Minion', 'Priest', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 35291, 3499, 1096, 471, 747, 313, 253, 500, 506, 202, 0, 0, 50, 160, 'tower_guard_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (719, 20829, 'Platinum Tribe Overlord', '', 'kel_mahum_champion', 13.00, 32.00, 71, 'male', 'L2Monster', 'Fighter', 40, 2493, 8.500, 1378, 3.000, 40, 43, 30, 21, 20, 20, 50697, 5087, 1136, 482, 776, 320, 253, 500, 506, 147, 0, 0, 50, 170, 'tower_guard_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (720, 20830, 'Guardian Angel', '', 'angel', 13.50, 36.50, 72, 'male', 'L2Minion', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1179, 491, 805, 327, 253, 500, 506, 148, 0, 0, 30, 170, 'tower_guard_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (721, 20831, 'Seal Angel', '', 'angel', 13.50, 36.50, 73, 'male', 'L2Minion', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 334, 253, 500, 506, 148, 0, 0, 30, 170, 'tower_guard_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (722, 20832, 'Zakens Pikeman', '', 'skeleton_pikeman', 10.00, 28.00, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 3264, 221, 277, 223, 189, 149, 253, 500, 506, 292, 0, 0, 50, 174, 'undead_clan1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.21, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (723, 20833, 'Zakens Archer', '', 'skeleton_archer', 11.00, 27.00, 44, 'male', 'L2Monster', 'Ranger', 1100, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 3631, 248, 295, 230, 202, 153, 253, 0, 506, 279, 0, 0, 40, 174, 'undead_clan1', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (724, 20834, 'Mardian', '', 'giant_spider', 26.00, 25.50, 42, 'male', 'L2Monster', 'Mystic', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 5403, 360, 259, 216, 177, 144, 253, 500, 506, 0, 0, 0, 72, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (725, 20835, 'Zakens Seer', '', 'liviona', 15.00, 28.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 2974, 206, 315, 239, 214, 158, 253, 500, 506, 0, 0, 0, 80, 174, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (726, 20836, 'Pirate Zombie', '', 'pirates_zombie', 10.00, 23.00, 44, 'male', 'L2Monster', 'Mystic', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 6799, 466, 295, 230, 202, 153, 253, 0, 506, 225, 0, 0, 11, 174, 'undead_clan1', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (727, 20837, 'Tainted Ogre', '', 'ogre', 21.00, 44.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 6158, 428, 315, 239, 214, 158, 253, 500, 506, 194, 0, 0, 22, 174, 'undead_clan1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (728, 20838, 'Bloody Bat', '', 'vampire_bat', 10.00, 33.50, 45, 'male', 'L2Monster', 'Mystic', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 5773, 402, 315, 239, 214, 158, 253, 0, 506, 0, 0, 0, 60, 174, '1', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (729, 20839, 'Unpleasant Humming', '', 'unpleasant_humming', 12.00, 26.00, 46, 'male', 'L2Monster', 'Fighter', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 3453, 245, 335, 246, 228, 163, 253, 500, 506, 0, 0, 0, 21, 174, 'undead_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (730, 20840, 'Death Flyer', '', 'dark_horror', 20.00, 35.00, 47, 'male', 'L2Monster', 'Fighter', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 3566, 256, 356, 254, 243, 169, 253, 0, 506, 0, 0, 0, 100, 174, 'undead_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (731, 20841, 'Fiend Archer', '', 'fiend_archer', 17.00, 55.00, 48, 'male', 'L2Monster', 'Ranger', 1100, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 3663, 268, 378, 262, 258, 174, 253, 500, 506, 0, 0, 0, 70, 174, 'demonic_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (732, 20842, 'Musveren', '', 'field_stalker', 15.00, 30.00, 49, 'male', 'L2Monster', 'Fighter', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 3492, 258, 400, 270, 273, 179, 253, 0, 506, 0, 0, 0, 70, 174, 'undead_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (733, 20843, 'Zakens Royal Guard', '', 'skeleton_royal_guard', 11.00, 28.50, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 4413, 332, 425, 278, 291, 185, 253, 500, 506, 225, 945, 0, 80, 174, 'undead_clan', 300, 0, 20, 100, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (734, 20844, 'Kaim Vanul', '', 'kaim_vanul', 24.00, 40.00, 51, 'male', 'L2Monster', 'Fighter', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 3936, 300, 449, 287, 307, 190, 253, 0, 506, 0, 0, 0, 37, 174, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (735, 20845, 'Pirates Zombie Captain', '', 'pirates_zombie_captain', 17.00, 28.00, 52, 'male', 'L2Monster', 'Fighter', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 5945, 460, 475, 296, 324, 196, 253, 500, 506, 232, 0, 0, 14, 174, 'zaken_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (736, 20846, 'Doll Blader', '', 'doll_blader', 6.00, 12.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 4718, 371, 503, 304, 344, 203, 253, 0, 506, 5129, 5129, 0, 22, 174, 'zaken_clan', 300, 0, 0, 94, 7, 10, 8, 0, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (737, 20847, 'Vale Master', '', 'vale_master', 12.00, 40.00, 54, 'male', 'L2Monster', 'Fighter', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 4501, 359, 531, 313, 362, 209, 253, 500, 506, 0, 0, 0, 70, 174, 'zaken_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (738, 20848, 'Light Bringer', '', 'light_bringer', 10.00, 23.00, 46, 'male', 'L2Monster', 'Fighter', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 5839, 414, 335, 246, 228, 163, 253, 500, 506, 0, 0, 0, 60, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (739, 20849, 'Light Worm', '', 'light_worm', 5.00, 16.00, 41, 'male', 'L2Monster', 'Fighter', 40, 1008, 5.500, 505, 2.100, 40, 43, 30, 21, 20, 20, 4638, 304, 243, 209, 166, 139, 253, 500, 506, 0, 0, 0, 60, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.06, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (740, 20850, 'Golden Stag Lord', '', 'golden_stag_lord', 25.00, 30.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 3783, 284, 425, 278, 291, 185, 253, 0, 506, 0, 0, 0, 35, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (741, 20851, 'Theeder', '', 'theeder', 9.00, 32.00, 47, 'male', 'L2Monster', 'Fighter', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 3409, 245, 356, 254, 243, 169, 253, 500, 506, 0, 0, 0, 80, 174, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (742, 20852, 'Banshee', '', 'banshee', 9.00, 23.00, 60, 'female', 'L2Monster', 'Mystic', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 5341, 463, 717, 370, 490, 246, 253, 500, 506, 3939, 0, 0, 80, 174, '1', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (743, 20853, 'Kel Mahum', '', 'kel_mahum', 13.00, 26.00, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 9389, 872, 898, 419, 613, 279, 253, 500, 506, 242, 0, 0, 50, 174, 'kel_mahum_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (744, 20854, 'Kel Mahum Warrior', '', 'kel_mahum_warrior', 13.00, 28.00, 66, 'male', 'L2Monster', 'Fighter', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 9224, 868, 936, 429, 639, 285, 253, 500, 506, 148, 0, 0, 50, 174, 'kel_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (745, 20855, 'Kel Mahum Archer', '', 'kel_mahum_archer', 13.00, 27.00, 67, 'male', 'L2Monster', 'Ranger', 1100, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 10680, 1018, 975, 440, 666, 292, 253, 0, 506, 288, 0, 0, 50, 174, 'kel_mahum_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.91, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (746, 20856, 'Kel Mahum Shaman', '', 'kel_mahum_witch_doctor', 13.00, 25.00, 68, 'male', 'L2Monster', 'Priest', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 7669, 740, 1014, 449, 692, 300, 253, 500, 506, 202, 0, 0, 50, 174, 'kel_mahum_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (747, 20857, 'Kel Mahum Champion', '', 'kel_mahum_champion', 13.00, 32.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 9780, 970, 1096, 471, 747, 313, 253, 500, 506, 147, 0, 0, 50, 174, 'kel_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (748, 20858, 'Angel', '', 'angel', 13.50, 36.50, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 10923, 1110, 1179, 491, 805, 327, 253, 500, 506, 148, 0, 0, 30, 174, 'tower_guard_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (749, 20859, 'Guardian Angel', '', 'angel', 13.50, 36.50, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 59729, 6068, 1179, 491, 805, 359, 253, 500, 506, 148, 0, 0, 30, 170, 'tower_guard_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (750, 20860, 'Seal Angel', '', 'angel', 13.50, 36.50, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 83696, 8612, 1220, 502, 833, 368, 253, 500, 506, 148, 0, 0, 30, 170, 'tower_guard_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (751, 20861, 'Oel Mahum Champion', '', 'oel_mahum_champion', 23.00, 61.00, 56, 'male', 'L2Monster', 'Fighter', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 6641, 545, 589, 331, 402, 220, 253, 500, 506, 127, 0, 0, 67, 174, 'oel_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (752, 20862, 'Death Lord', '', 'death_lord', 21.00, 40.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 9330, 984, 1304, 523, 891, 349, 253, 0, 506, 78, 0, 0, 40, 174, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (753, 20919, 'Maille Lizardman', '', 'virud_lizardman', 10.00, 23.00, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 321, 14, 48, 95, 33, 63, 253, 0, 506, 291, 0, 0, 43, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (754, 20920, 'Maille Lizardman Scout', '', 'virud_lizardman_scout', 10.00, 22.00, 22, 'male', 'L2Monster', 'Ranger', 1100, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 713, 34, 58, 103, 39, 69, 253, 0, 506, 2507, 0, 0, 43, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (755, 20921, 'Maille Lizardman Guard', '', 'virud_lizardman', 10.00, 23.00, 24, 'male', 'L2Monster', 'Fighter', 40, 435, 3.500, 246, 1.500, 40, 43, 30, 21, 20, 20, 515, 25, 68, 112, 46, 75, 253, 500, 506, 291, 0, 0, 43, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (756, 20922, 'Maille Lizardman Warrior', '', 'virud_lizardman_warrior', 12.00, 30.00, 26, 'male', 'L2Monster', 'Fighter', 40, 488, 3.500, 273, 1.500, 40, 43, 30, 21, 20, 20, 571, 29, 81, 121, 55, 81, 253, 0, 506, 16, 0, 0, 52, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (757, 20923, 'Maille Lizardman Shaman', '', 'virud_lizardman_shaman', 10.00, 29.00, 28, 'male', 'L2Monster', 'Priest', 40, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 836, 44, 95, 131, 64, 87, 253, 0, 506, 7, 0, 0, 43, 120, 'lizardman_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (758, 20924, 'Maille Lizardman Matriarch', '', 'virud_lizardman_matriarch', 13.00, 37.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1025, 56, 111, 140, 75, 94, 253, 500, 506, 69, 627, 0, 56, 130, 'lizardman_clan', 300, 0, 20, 59, 7, 50, 1, 9, 0, 0, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (759, 20925, 'Giant Araneid', '', 'giant_spider', 26.00, 25.50, 24, 'male', 'L2Monster', 'Mystic', 40, 435, 3.500, 246, 1.500, 40, 43, 30, 21, 20, 20, 525, 26, 68, 112, 46, 75, 253, 0, 506, 0, 0, 0, 72, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (760, 20926, 'Poison Araneid', '', 'poison_spider', 27.00, 25.50, 25, 'male', 'L2Monster', 'Mystic', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 607, 30, 74, 116, 50, 78, 253, 0, 506, 0, 0, 0, 60, 140, 'lizardman_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (761, 20927, 'King of the Araneid', '', 'giant_spider_50_bi', 39.00, 38.00, 27, 'male', 'L2Monster', 'Mystic', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 872, 44, 87, 125, 59, 84, 253, 500, 506, 0, 0, 0, 72, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (762, 20928, 'Hatu Weird Bee', '', 'giant_bee', 8.00, 24.50, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 881, 48, 111, 140, 75, 94, 253, 500, 506, 0, 0, 0, 90, 120, 'hatu_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (763, 20929, 'Hatu Dire Wolf', '', 'dire_wolf', 13.00, 11.00, 32, 'male', 'L2Monster', 'Fighter', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 836, 47, 128, 152, 87, 102, 253, 0, 506, 0, 0, 0, 24, 110, 'hatu_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (764, 20930, 'Hatu Brown Bear', '', 'grizzly', 21.00, 40.00, 34, 'male', 'L2Monster', 'Fighter', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 1317, 77, 149, 164, 102, 109, 253, 500, 506, 0, 0, 0, 40, 143, 'hatu_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (765, 20931, 'Hatu Onyx Beast', '', 'onyx_beast', 14.00, 14.50, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 1221, 74, 173, 176, 118, 118, 253, 0, 506, 0, 0, 0, 30, 174, 'hatu_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (766, 20932, 'Hatu Crimson Bear', '', 'crimson_bear', 19.00, 36.00, 38, 'male', 'L2Monster', 'Fighter', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 1613, 101, 198, 188, 136, 126, 253, 0, 506, 0, 0, 0, 37, 174, 'hatu_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (767, 20933, 'Hatu Windsus', '', 'giant_wild_hog', 35.00, 27.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 1849, 119, 227, 203, 155, 134, 253, 500, 506, 0, 0, 0, 35, 174, 'hatu_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (768, 20934, 'Wasp Worker', '', 'giant_bee_bi', 8.00, 32.00, 35, 'male', 'L2Minion', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 991, 59, 160, 170, 109, 113, 253, 0, 506, 0, 0, 0, 90, 174, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (769, 20935, 'Wasp Leader', '', 'giant_bee_100_bi', 16.00, 49.00, 37, 'male', 'L2Monster', 'Fighter', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 1086, 67, 185, 181, 126, 121, 253, 500, 506, 0, 0, 0, 90, 174, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (770, 20936, 'Tanor Silenos', '', 'heltor_silenos', 13.00, 29.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 2066, 133, 227, 203, 155, 134, 253, 0, 506, 88, 0, 0, 34, 174, 'silenos_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (771, 20937, 'Tanor Silenos Grunt', '', 'heltor_silenos', 13.00, 29.00, 42, 'male', 'L2Minion', 'Fighter', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 2699, 180, 259, 216, 177, 144, 253, 0, 506, 158, 18, 0, 34, 174, 'silenos_clan', 300, 0, 20, 82, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (772, 20938, 'Tanor Silenos Scout', '', 'heltor_silenos', 13.00, 29.00, 44, 'male', 'L2Minion', 'Fighter', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 2963, 203, 295, 230, 202, 153, 253, 0, 506, 5, 0, 0, 34, 174, 'silenos_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (773, 20939, 'Tanor Silenos Warrior', '', 'heltor_silenos_warrior', 13.00, 31.00, 46, 'male', 'L2Minion', 'Fighter', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 3303, 234, 335, 246, 228, 163, 253, 500, 506, 160, 0, 0, 36, 174, 'silenos_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (774, 20940, 'Tanor Silenos Shaman', '', 'heltor_silenos_shaman', 13.00, 32.00, 48, 'male', 'L2Minion', 'Priest', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 4024, 294, 378, 262, 258, 174, 253, 0, 506, 9, 0, 0, 29, 174, 'silenos_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.22, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (775, 20941, 'Tanor Silenos Chieftain', '', 'heltor_silenos_chieftain', 13.00, 31.50, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 3902, 294, 425, 278, 291, 185, 253, 500, 506, 75, 0, 0, 27, 174, 'silenos_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (776, 20942, 'Nightmare Guide', '', 'harpy', 10.00, 42.00, 43, 'female', 'L2Minion', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 1970, 133, 277, 223, 189, 149, 253, 0, 506, 0, 0, 0, 60, 174, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (777, 20943, 'Nightmare Keeper', '', 'harpy', 10.00, 42.00, 45, 'female', 'L2Minion', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 2833, 197, 315, 239, 214, 158, 253, 0, 506, 0, 0, 0, 60, 174, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (778, 20944, 'Nightmare Lord', '', 'succubus_100_bi', 20.00, 75.00, 47, 'female', 'L2Monster', 'Fighter', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 2400, 172, 356, 254, 243, 169, 253, 500, 506, 0, 0, 0, 60, 174, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (779, 20945, 'Cadeine', '', 'hobgoblin', 12.00, 24.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 2690, 203, 425, 278, 291, 185, 253, 0, 506, 127, 625, 0, 45, 174, 'green_clan', 300, 0, 20, 100, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (780, 20946, 'Sanhidro', '', 'troll', 21.00, 35.00, 52, 'male', 'L2Monster', 'Fighter', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 4138, 320, 475, 296, 324, 196, 253, 0, 506, 0, 0, 0, 55, 174, 'green_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (781, 20947, 'Connabi', '', 'bugbear', 17.00, 35.00, 54, 'male', 'L2Monster', 'Fighter', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 4462, 355, 531, 313, 362, 209, 253, 0, 506, 88, 0, 0, 55, 174, 'green_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (782, 20948, 'Bartal', '', 'liviona', 15.00, 28.00, 56, 'male', 'L2Minion', 'Fighter', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 4431, 364, 589, 331, 402, 220, 253, 0, 506, 0, 0, 0, 80, 174, 'green_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (783, 20949, 'Luminun', '', 'twin_headed_giant', 17.00, 39.00, 58, 'male', 'L2Minion', 'Fighter', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 5220, 440, 651, 350, 444, 232, 253, 0, 506, 157, 0, 0, 45, 174, 'green_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (784, 20950, 'Innersen', '', 'king_bugbear', 15.00, 40.00, 60, 'male', 'L2Monster', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 5619, 487, 717, 370, 490, 246, 253, 500, 506, 160, 0, 0, 55, 174, 'green_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (785, 20951, 'Pobbys Maid', '', 'manadragora', 14.00, 17.80, 53, 'female', 'L2Minion', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 3022, 238, 503, 304, 344, 203, 253, 0, 506, 0, 0, 0, 80, 174, 'green_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (786, 20952, 'Pobby Escort', '', 'mandragora_b', 12.00, 25.50, 55, 'female', 'L2Minion', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 5461, 440, 559, 323, 382, 215, 253, 0, 506, 0, 0, 0, 80, 174, 'green_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.13, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (787, 20953, 'Pobby', '', 'mandragora_a', 15.00, 26.00, 57, 'female', 'L2Monster', 'Fighter', 40, 1777, 6.500, 948, 2.400, 40, 43, 30, 21, 20, 20, 5071, 421, 619, 340, 423, 226, 253, 500, 506, 0, 0, 0, 80, 174, 'green_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.20, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (788, 20954, 'Hungered Corpse', '', 'skeleton', 11.00, 25.00, 60, 'male', 'L2Minion', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 5991, 520, 717, 370, 490, 246, 253, 0, 506, 123, 945, 0, 60, 180, 'bloody_clan', 300, 0, 20, 124, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (789, 20955, 'Ghostly Warrior', '', 'skeleton_pikeman', 10.00, 28.00, 62, 'male', 'L2Minion', 'Fighter', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 6398, 570, 787, 388, 538, 258, 253, 0, 506, 299, 0, 0, 50, 180, 'bloody_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.21, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (790, 20956, 'Past Knight', '', 'skeleton_knight', 10.00, 25.00, 64, 'male', 'L2Monster', 'Fighter', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 6953, 636, 860, 409, 588, 272, 253, 500, 506, 150, 103, 0, 40, 174, 'bloody_clan', 300, 0, 20, 134, 7, 50, 1, 9, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (791, 20957, 'Nihil Invader', '', 'skeleton_royal_guard', 11.00, 28.50, 66, 'male', 'L2Minion', 'Fighter', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 7250, 683, 936, 429, 639, 285, 253, 0, 506, 946, 945, 0, 80, 185, 'bloody_clan', 300, 0, 20, 138, 7, 50, 1, 9, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (792, 20958, 'Death Agent', '', 'death_blader', 15.00, 45.00, 68, 'male', 'L2Minion', 'Fighter', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 5411, 523, 1014, 449, 692, 300, 253, 0, 506, 1472, 0, 0, 100, 195, 'bloody_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (793, 20959, 'Dark Guard', '', 'headless_knight', 21.00, 31.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 8318, 824, 1096, 471, 747, 313, 253, 500, 506, 124, 0, 0, 70, 170, 'bloody_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (794, 20960, 'Bloody Ghost', '', 'succubus', 10.00, 36.00, 64, 'female', 'L2Minion', 'Mystic', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 4793, 439, 860, 409, 588, 272, 253, 0, 506, 0, 0, 0, 60, 175, 'bloody_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (795, 20961, 'Bloody Knight', '', 'doll_blader', 6.00, 12.00, 65, 'male', 'L2Minion', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 7032, 653, 898, 419, 613, 279, 253, 0, 506, 5129, 5129, 0, 22, 175, 'bloody_clan', 300, 0, 0, 119, 7, 50, 1, 9, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (796, 20962, 'Bloody Priest', '', 'bloody_queen', 14.00, 40.00, 66, 'female', 'L2Minion', 'Priest', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 7827, 737, 936, 429, 639, 285, 253, 0, 506, 0, 0, 0, 80, 185, 'bloody_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (797, 20963, 'Bloody Lord', '', 'banshee', 9.00, 23.00, 68, 'female', 'L2Monster', 'Fighter', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 5630, 544, 1014, 449, 692, 300, 253, 500, 506, 3939, 0, 0, 80, 180, 'bloody_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (798, 20964, 'Huge Footmark', '', 'stone_golem', 20.00, 31.00, 70, 'male', 'L2Monster', 'Mystic', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 23, 23, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (799, 20965, 'Chimera Piece', '', 'will_o_wisp', 13.00, 22.00, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 22599, 2237, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 80, 140, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.10, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (800, 20966, 'Changed Creation', '', 'leogul', 15.00, 35.00, 74, 'male', 'L2Monster', 'Mystic', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 31161, 3114, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (801, 20967, 'Past Creature', '', 'gamlin', 11.00, 32.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 22942, 2360, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (802, 20968, 'Nonexistent Man', '', 'susceptor', 20.00, 35.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 27816, 2944, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 27, 150, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (803, 20969, 'Giants Shadow', '', 'lesser_giant_shooter', 50.00, 44.00, 78, 'male', 'L2Monster', 'Ranger', 1100, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 36095, 3804, 1488, 556, 1015, 406, 253, 0, 506, 4028, 0, 0, 80, 180, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (804, 20970, 'Soldier of Ancient Times', '', 'lesser_giant', 50.00, 44.00, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 22599, 2237, 1220, 502, 833, 368, 253, 0, 506, 3937, 0, 0, 15, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (805, 20971, 'Warrior of Ancient Times', '', 'lesser_giant', 50.00, 44.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 23855, 2420, 1304, 523, 891, 384, 253, 0, 506, 3937, 0, 0, 15, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (806, 20972, 'Shaman of Ancient Times', '', 'lesser_giant_mage', 50.00, 44.00, 75, 'male', 'L2Monster', 'Mystic', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 24719, 2511, 1304, 523, 891, 384, 253, 0, 506, 3938, 0, 0, 15, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (807, 20973, 'Forgotten Ancient People', '', 'lesser_giant_mage', 50.00, 44.00, 77, 'male', 'L2Monster', 'Mystic', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 31618, 3281, 1421, 544, 971, 398, 253, 0, 506, 3938, 0, 0, 15, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (808, 20974, 'Spiteful Soul Leader', '', 'skeleton_royal_guard_bi', 16.00, 44.00, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 14127, 1313, 898, 419, 613, 306, 253, 0, 506, 946, 945, 0, 80, 174, 'undead_clan', 300, 0, 20, 136, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (809, 20975, 'Spiteful Soul Wizard', '', 'elf_ghost_50_bi', 10.00, 32.00, 63, 'male', 'L2Minion', 'Mystic', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 12599, 1138, 822, 398, 562, 266, 253, 0, 506, 0, 0, 0, 80, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (810, 20976, 'Spiteful Soul Fighter', '', 'human_ghost_50_bi', 12.00, 33.00, 62, 'male', 'L2Minion', 'Mystic', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 10694, 953, 787, 388, 538, 258, 253, 0, 506, 0, 0, 0, 80, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (811, 20977, 'Elmoradans Lady', '', 'banshee_50_bi', 13.50, 38.00, 65, 'female', 'L2Monster', 'Mystic', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 18033, 1675, 898, 419, 613, 279, 253, 500, 506, 3939, 0, 0, 80, 160, 'tower_ghost_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (812, 20978, 'Elmoradans Archer Escort', '', 'skeleton_archer', 11.00, 27.00, 64, 'male', 'L2Minion', 'Ranger', 1100, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 17930, 1642, 860, 409, 588, 272, 253, 0, 506, 284, 0, 0, 40, 140, 'tower_ghost_clan', 400, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (813, 20979, 'Elmoradans Maid', '', 'doll_blader', 6.00, 12.00, 64, 'male', 'L2Minion', 'Fighter', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 17139, 1570, 860, 409, 588, 272, 253, 0, 506, 5129, 5129, 0, 22, 170, 'tower_ghost_clan', 400, 0, 0, 138, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (814, 20980, 'Hallates Follower Mul', '', 'vale_master', 12.00, 40.00, 68, 'male', 'L2Monster', 'Fighter', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 18255, 1764, 1014, 449, 692, 300, 253, 500, 506, 210, 0, 0, 70, 170, 'hallate_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (815, 20981, 'Muls Wizard', '', 'kaim_vanul_50_bi', 36.00, 60.00, 67, 'male', 'L2Minion', 'Mystic', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 18154, 1729, 975, 440, 666, 292, 253, 0, 506, 0, 0, 0, 37, 160, 'hallate_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (816, 20982, 'Muls Knight', '', 'dre_vanul_100_bi', 28.00, 75.00, 67, 'male', 'L2Minion', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 16025, 1526, 975, 440, 666, 292, 253, 0, 506, 0, 0, 0, 80, 143, 'hallate_clan', 400, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (817, 20983, 'Binder', '', 'kel_mahum_champion_50_bi', 19.00, 48.00, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 24823, 2554, 1220, 502, 833, 334, 253, 500, 506, 147, 0, 0, 50, 170, 'tower_guard_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (818, 20984, 'Bound Warrior', '', 'kel_mahum_warrior', 13.00, 28.00, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 23326, 2370, 1179, 491, 805, 327, 253, 0, 506, 148, 0, 0, 50, 160, 'tower_guard_clan', 50, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (819, 20985, 'Bound Archer', '', 'kel_mahum_archer', 13.00, 27.00, 72, 'male', 'L2Minion', 'Ranger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 23154, 2352, 1179, 491, 805, 327, 253, 0, 506, 288, 0, 0, 50, 170, 'tower_guard_clan', 50, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.91, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (820, 20986, 'Sairon', '', 'doll_blader_50_bi', 9.00, 20.50, 54, 'male', 'L2Monster', 'Fighter', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 13258, 1057, 531, 313, 362, 209, 253, 500, 506, 5129, 5129, 0, 22, 174, 'demonic_clan', 300, 0, 0, 113, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (821, 20987, 'Sairons Doll', '', 'doll_blader', 6.00, 12.00, 53, 'male', 'L2Minion', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 12060, 948, 503, 304, 344, 203, 253, 0, 506, 5129, 5129, 0, 22, 174, '', 300, 0, 0, 111, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (822, 20988, 'Sairons Puppet', '', 'doll_blader', 6.00, 12.00, 53, 'male', 'L2Minion', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 13265, 1043, 503, 304, 344, 203, 253, 0, 506, 5129, 5129, 0, 22, 174, '', 300, 0, 0, 111, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (823, 20989, 'Lageos', '', 'marsh_stakato_drone_50_bi', 13.00, 37.00, 38, 'male', 'L2Monster', 'Fighter', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 3299, 205, 198, 188, 136, 126, 253, 0, 506, 182, 0, 0, 80, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (824, 20990, 'Pageos', '', 'marsh_stakato_soldier', 10.00, 25.00, 38, 'male', 'L2Monster', 'Fighter', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 3132, 196, 198, 188, 136, 126, 253, 0, 506, 128, 0, 0, 30, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (825, 20991, 'Swamp Tribe', '', 'farhite_50_bi', 24.00, 48.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 12334, 858, 315, 239, 214, 158, 253, 500, 506, 5131, 0, 0, 15, 174, 'croc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (826, 20992, 'Swamp Alligator', '', 'crokian', 18.00, 29.00, 44, 'male', 'L2Minion', 'Fighter', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 11042, 756, 295, 230, 202, 153, 253, 0, 506, 5128, 0, 0, 18, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.78, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (827, 20993, 'Swamp Warrior', '', 'dailaon', 20.00, 28.00, 44, 'male', 'L2Minion', 'Ranger', 1100, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 11717, 802, 295, 230, 202, 153, 253, 0, 506, 5127, 0, 0, 18, 174, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.91, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (828, 20994, 'Garden Guard Leader', '', 'doll_master_50_bi', 30.00, 63.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 14866, 1120, 425, 278, 291, 185, 253, 500, 506, 0, 0, 0, 80, 174, 'theeder_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (829, 20995, 'Garden Guard', '', 'theeder', 9.00, 32.00, 48, 'male', 'L2Minion', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 10134, 740, 378, 262, 258, 174, 253, 0, 506, 94, 0, 0, 80, 174, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (830, 20996, 'Spiteful Ghost of Ruins', '', 'zombie', 13.00, 21.00, 50, 'male', 'L2Monster', 'Mystic', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 6419, 484, 425, 278, 291, 185, 253, 500, 506, 0, 0, 0, 15, 15, 'undead_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (831, 20997, 'Soldier of Grief', '', 'unpleasant_humming', 12.00, 26.00, 51, 'male', 'L2Monster', 'Fighter', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 4539, 346, 449, 287, 307, 190, 253, 0, 506, 0, 0, 0, 21, 150, 'undead_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (832, 20998, 'Cruel Punisher', '', 'hungry_spirit', 30.00, 40.00, 52, 'male', 'L2Monster', 'Fighter', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 5002, 386, 475, 296, 324, 196, 253, 0, 506, 0, 0, 0, 15, 120, 'undead_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (833, 20999, 'Roving Soul', '', 'skeleton', 11.00, 25.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 5932, 467, 503, 304, 344, 203, 253, 0, 506, 75, 0, 0, 60, 160, 'undead_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (834, 21000, 'Soul of Ruins', '', 'human_ghost', 8.00, 22.00, 54, 'male', 'L2Monster', 'Mystic', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 5191, 414, 531, 313, 362, 209, 253, 500, 506, 0, 0, 0, 80, 174, 'undead_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (835, 21001, 'Wretched Archer', '', 'skeleton_archer', 11.00, 27.00, 55, 'male', 'L2Monster', 'Ranger', 1100, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 7028, 568, 559, 323, 382, 215, 253, 0, 506, 282, 0, 0, 40, 174, 'undead_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (836, 21002, 'Doom Scout', '', 'skeleton_royal_guard', 11.00, 28.50, 56, 'male', 'L2Monster', 'Fighter', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 6197, 509, 589, 331, 402, 220, 253, 500, 506, 242, 2496, 0, 80, 174, 'doom_clan', 300, 0, 20, 114, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (837, 21003, 'Grave Lich', '', 'liviona', 15.00, 28.00, 57, 'male', 'L2Monster', 'Mystic', 40, 1777, 6.500, 948, 2.400, 40, 43, 30, 21, 20, 20, 5670, 472, 619, 340, 423, 226, 253, 0, 506, 0, 0, 0, 80, 174, 'undead_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (838, 21004, 'Dismal Pole', '', 'hanged_man_ripper', 35.00, 80.00, 58, 'male', 'L2Monster', 'Fighter', 80, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 6288, 532, 651, 350, 444, 232, 253, 500, 506, 0, 0, 0, 55, 174, 'undead_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (839, 21005, 'Grave Predator', '', 'devastator', 35.00, 35.00, 59, 'male', 'L2Monster', 'Fighter', 40, 1881, 6.500, 1007, 2.400, 40, 43, 30, 21, 20, 20, 6878, 588, 684, 360, 466, 240, 253, 500, 506, 0, 0, 0, 25, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (840, 21006, 'Doom Servant', '', 'hungry_spirit', 30.00, 40.00, 60, 'male', 'L2Monster', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 6537, 568, 717, 370, 490, 246, 253, 500, 506, 0, 0, 0, 15, 174, 'doom_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (841, 21007, 'Doom Guard', '', 'hungry_spirit', 30.00, 40.00, 61, 'male', 'L2Monster', 'Fighter', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 7014, 617, 752, 378, 513, 252, 253, 0, 506, 0, 0, 0, 15, 174, 'doom_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (842, 21008, 'Doom Archer', '', 'skeleton_archer', 11.00, 27.00, 62, 'male', 'L2Monster', 'Ranger', 1100, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 8965, 799, 787, 388, 538, 258, 253, 500, 506, 286, 0, 0, 40, 174, 'doom_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (843, 21009, 'Doom Trooper ', '', 'skeleton_pikeman', 10.00, 28.00, 63, 'male', 'L2Monster', 'Fighter', 80, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 9559, 863, 822, 398, 562, 266, 253, 0, 506, 301, 0, 0, 50, 174, 'doom_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.21, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (844, 21010, 'Doom Warrior', '', 'skeleton_knight', 10.00, 25.00, 64, 'male', 'L2Monster', 'Fighter', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 7656, 701, 860, 409, 588, 272, 253, 0, 506, 71, 0, 0, 40, 174, 'doom_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (845, 21011, 'Ol Mahum Van Grunt', '', 'ol_mahum', 13.50, 25.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1571, 86, 111, 140, 75, 94, 253, 0, 506, 5, 0, 0, 50, 150, 'wererat_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (846, 21012, 'Magical Eye', '', 'magical_weaver', 11.00, 20.00, 31, 'male', 'L2Monster', 'Mystic', 40, 636, 4.500, 344, 1.800, 40, 43, 30, 21, 20, 20, 2084, 115, 119, 146, 82, 97, 253, 500, 506, 0, 0, 0, 90, 150, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (847, 21013, 'Ol Mahum Van Archer', '', 'ol_mahum_archer', 14.00, 25.00, 32, 'male', 'L2Monster', 'Ranger', 1100, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 2305, 130, 128, 152, 87, 102, 253, 0, 506, 273, 0, 0, 50, 150, 'wererat_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.93, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (848, 21014, 'Lesser Warlike Tyrant', '', 'grave', 15.00, 29.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 2385, 137, 138, 157, 94, 105, 253, 500, 506, 0, 0, 0, 70, 150, 'kinpin_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (849, 21015, 'Ol Mahum Van Leader', '', 'ol_mahum_champion', 14.00, 27.00, 34, 'male', 'L2Monster', 'Fighter', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 2449, 143, 149, 164, 102, 109, 253, 500, 506, 67, 0, 0, 50, 150, 'wererat_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (850, 21016, 'Warlike Tyrant', '', 'grave', 15.00, 29.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 2631, 156, 160, 170, 109, 113, 253, 0, 506, 0, 0, 0, 70, 174, 'kinpin_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (851, 21017, 'Fallen Orc', '', 'ketra_orc', 12.00, 29.00, 55, 'male', 'L2Monster', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 5279, 426, 559, 323, 382, 215, 253, 0, 506, 127, 0, 0, 45, 174, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (852, 21018, 'Ancient Gargoyle', '', 'hunter_gargoyle', 25.00, 65.00, 56, 'male', 'L2Monster', 'Fighter', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 6643, 546, 589, 331, 402, 220, 253, 500, 506, 0, 0, 0, 100, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (853, 21019, 'Fallen Orc Archer', '', 'ketra_orc_archer', 12.00, 27.00, 57, 'male', 'L2Monster', 'Ranger', 1100, 1777, 6.500, 948, 2.400, 40, 43, 30, 21, 20, 20, 7312, 607, 619, 340, 423, 226, 253, 0, 506, 279, 0, 0, 45, 174, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.91, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (854, 21020, 'Fallen Orc Shaman', '', 'ketra_orc_shaman', 10.00, 23.00, 58, 'male', 'L2Monster', 'Priest', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 8278, 700, 651, 350, 444, 232, 253, 0, 506, 9, 0, 0, 10, 174, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (855, 21021, 'Sharp Talon Tiger', '', 'saber_toothed_tiger', 34.00, 28.00, 59, 'male', 'L2Monster', 'Fighter', 40, 1881, 6.500, 1007, 2.400, 40, 43, 30, 21, 20, 20, 7625, 652, 684, 360, 466, 240, 253, 500, 506, 0, 0, 0, 60, 174, 'beast_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (856, 21022, 'Fallen Orc Captain', '', 'ketra_orc_warrior', 12.00, 24.00, 60, 'male', 'L2Monster', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 7754, 673, 717, 370, 490, 246, 253, 500, 506, 160, 0, 0, 36, 174, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (857, 21023, 'Sobbing Wind', '', 'sylph', 11.00, 35.00, 26, 'female', 'L2Monster', 'Mystic', 40, 488, 3.500, 273, 1.500, 40, 43, 30, 21, 20, 20, 1268, 64, 81, 121, 55, 81, 253, 0, 506, 0, 0, 0, 60, 150, 'elemental2_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (858, 21024, 'Babbling Wind', '', 'sylph', 11.00, 35.00, 27, 'female', 'L2Monster', 'Mystic', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 1336, 68, 87, 125, 59, 84, 253, 0, 506, 0, 0, 0, 60, 150, 'elemental2_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (859, 21025, 'Giggling Wind', '', 'sylph', 11.00, 35.00, 28, 'female', 'L2Monster', 'Mystic', 40, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 1414, 74, 95, 131, 64, 87, 253, 0, 506, 0, 0, 0, 60, 150, 'elemental2_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (860, 21026, 'Singing Wind', '', 'sylph', 11.00, 35.00, 29, 'female', 'L2Monster', 'Mystic', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 1522, 82, 101, 136, 70, 91, 253, 500, 506, 0, 0, 0, 60, 150, 'elemental2_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (861, 21034, 'Ogre', '', 'ogre', 21.00, 44.00, 38, 'male', 'L2Monster', 'Fighter', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 2157, 134, 198, 188, 136, 126, 253, 500, 506, 98, 0, 0, 22, 174, 'lizardman_clan1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.69, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (862, 21035, 'Catherok', '', 'marsh_stakato_soldier', 10.00, 25.00, 42, 'male', 'L2Monster', 'Fighter', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 6978, 443, 259, 216, 177, 159, 253, 500, 506, 144, 0, 0, 30, 155, 'porta_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (863, 21036, 'Shindebarn', '', 'magical_weaver', 11.00, 20.00, 44, 'male', 'L2Monster', 'Mystic', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 8166, 536, 295, 230, 202, 169, 253, 500, 506, 0, 0, 0, 90, 90, 'porta_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (864, 21037, 'Ossiud', '', 'field_stalker', 15.00, 30.00, 47, 'male', 'L2Monster', 'Fighter', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 10557, 727, 356, 254, 243, 186, 253, 500, 506, 0, 0, 0, 70, 110, 'torfe_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (865, 21038, 'Liangma', '', 'will_o_wisp', 13.00, 22.00, 49, 'male', 'L2Monster', 'Mystic', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 8025, 560, 400, 270, 273, 197, 253, 500, 506, 0, 0, 0, 80, 140, 'undead_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.10, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (866, 21039, 'Snipe Cohort', '', 'onyx_beast', 14.00, 14.50, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 7953, 515, 277, 223, 189, 164, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.24, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (867, 21040, 'Soldier of Darkness', '', 'death_knight', 12.00, 31.00, 49, 'male', 'L2Minion', 'Fighter', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 12649, 899, 400, 270, 273, 197, 253, 0, 506, 127, 0, 0, 27, 110, 'undead_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (868, 21058, 'Beast Lord', '', 'saber_toothed_tiger', 34.00, 28.00, 60, 'male', 'L2Monster', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 18913, 1642, 717, 370, 490, 246, 253, 500, 506, 0, 0, 0, 60, 174, 'beast_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (869, 21059, 'Beast Guardian', '', 'onyx_beast', 14.00, 14.50, 59, 'male', 'L2Minion', 'Fighter', 40, 1881, 6.500, 1007, 2.400, 40, 43, 30, 21, 20, 20, 15095, 1290, 684, 360, 466, 240, 253, 0, 506, 0, 0, 0, 30, 174, 'beast_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (870, 21060, 'Beast Seer', '', 'field_stalker', 15.00, 30.00, 59, 'male', 'L2Minion', 'Fighter', 40, 1881, 6.500, 1007, 2.400, 40, 43, 30, 21, 20, 20, 15095, 1290, 684, 360, 466, 240, 253, 0, 506, 0, 0, 0, 70, 174, 'beast_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (871, 21061, 'Hallates Guardian', '', 'kaim_vanul', 24.00, 40.00, 69, 'male', 'L2Minion', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 30701, 3004, 1055, 460, 720, 307, 253, 500, 506, 0, 0, 0, 37, 174, 'hallate_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (872, 21062, 'Messenger Angel', '', 'angel', 13.50, 36.50, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 313, 253, 500, 506, 148, 0, 0, 30, 174, 'tower_guard_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (873, 21063, 'Messenger Angel', '', 'angel', 13.50, 36.50, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 62784, 6226, 1096, 471, 747, 313, 253, 500, 506, 148, 0, 0, 30, 174, 'tower_guard_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (874, 21064, 'Platinum Guardian Archer', '', 'kel_mahum_archer', 13.00, 27.00, 71, 'male', 'L2Minion', 'Ranger', 1100, 2493, 8.500, 1378, 3.000, 40, 43, 30, 21, 20, 20, 38444, 3858, 1136, 482, 776, 320, 253, 500, 506, 288, 0, 0, 50, 174, 'tower_guard_clan', 400, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.91, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (875, 21065, 'Platinum Guardian Warrior', '', 'kel_mahum_warrior', 13.00, 28.00, 72, 'male', 'L2Minion', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 36221, 3680, 1179, 491, 805, 327, 253, 500, 506, 148, 0, 0, 50, 174, 'tower_guard_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (876, 21066, 'Platinum Guardian Shaman', '', 'kel_mahum_witch_doctor', 13.00, 25.00, 73, 'male', 'L2Minion', 'Priest', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 39180, 4032, 1220, 502, 833, 334, 253, 500, 506, 202, 0, 0, 50, 174, 'tower_guard_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (877, 21067, 'Guardian Archangel', '', 'angel', 13.50, 36.50, 74, 'male', 'L2Monster', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1262, 513, 861, 342, 253, 500, 506, 148, 0, 0, 30, 174, 'tower_guard_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (878, 21068, 'Guardian Archangel', '', 'angel', 13.50, 36.50, 74, 'male', 'L2Monster', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 85242, 8886, 1262, 513, 861, 342, 253, 500, 506, 148, 0, 0, 30, 174, 'tower_guard_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (879, 21069, 'Platinum Guardian Prefect', '', 'kel_mahum_champion', 13.00, 32.00, 74, 'male', 'L2Minion', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 53456, 5573, 1262, 513, 861, 342, 253, 500, 506, 147, 0, 0, 50, 174, 'tower_guard_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (880, 21070, 'Seal Archangel', '', 'angel', 13.50, 36.50, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 349, 253, 500, 506, 148, 0, 0, 30, 174, 'tower_guard_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (881, 21071, 'Seal Archangel', '', 'angel', 13.50, 36.50, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 88404, 9325, 1304, 523, 891, 384, 253, 500, 506, 148, 0, 0, 30, 174, 'tower_guard_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (882, 21072, 'Platinum Guardian Chief', '', 'kel_mahum_witch_doctor', 13.00, 25.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 40513, 4273, 1304, 523, 891, 349, 253, 500, 506, 202, 0, 0, 50, 174, 'tower_guard_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (883, 21073, 'Guardian Warrior of Elmoreden', '', 'skeleton_knight', 10.00, 25.00, 64, 'male', 'L2Minion', 'Fighter', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 16897, 1547, 860, 409, 588, 272, 253, 0, 506, 84, 0, 0, 40, 174, 'tower_ghost_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (884, 21074, 'Bound Shaman', '', 'kel_mahum_witch_doctor', 13.00, 25.00, 72, 'male', 'L2Minion', 'Priest', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 23163, 2353, 1179, 491, 805, 327, 253, 0, 506, 202, 0, 0, 50, 174, 'tower_guard_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (885, 21075, 'Slaughter Bathin', '', 'death_knight', 12.00, 31.00, 63, 'male', 'L2Monster', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 16790, 1516, 822, 398, 562, 266, 253, 500, 506, 84, 0, 0, 27, 174, 'hallate_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (886, 21076, 'Bathins Knight', '', 'skeleton_knight', 10.00, 25.00, 62, 'male', 'L2Minion', 'Fighter', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 16516, 1471, 787, 388, 538, 258, 253, 0, 506, 78, 0, 0, 40, 174, 'hallate_clan', 200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (887, 21077, 'Bathins Wizard', '', 'banshee', 9.00, 23.00, 62, 'female', 'L2Minion', 'Mystic', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 16007, 1427, 787, 388, 538, 258, 253, 0, 506, 3939, 0, 0, 80, 174, 'hallate_clan', 200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (888, 21078, 'Magus Valac', '', 'vale_master', 12.00, 40.00, 70, 'male', 'L2Monster', 'Mystic', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 20355, 2018, 1096, 471, 747, 313, 253, 500, 506, 198, 0, 0, 70, 174, 'hallate_clan', 200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (889, 21079, 'Valacs Creature', '', 'serpent_slave', 17.00, 46.00, 69, 'male', 'L2Minion', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 18497, 1810, 1055, 460, 720, 307, 253, 0, 506, 150, 0, 0, 70, 174, 'hallate_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (890, 21080, 'Valacs Guardian Spirit', '', 'shadow', 10.00, 30.00, 69, 'male', 'L2Minion', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 17096, 1673, 1055, 460, 720, 307, 253, 0, 506, 0, 0, 0, 80, 174, 'hallate_clan', 200, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (891, 21081, 'Power Angel Amon', '', 'angel', 13.50, 36.50, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 21329, 2250, 1304, 523, 891, 349, 253, 500, 506, 4700, 0, 0, 30, 174, 'tower_guard_clan', 200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (892, 21082, 'Amons Captain of the Guards', '', 'kel_mahum_champion', 13.00, 32.00, 74, 'male', 'L2Minion', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 20511, 2138, 1262, 513, 861, 342, 253, 0, 506, 150, 0, 0, 50, 174, 'tower_guard_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (893, 21083, 'Amons Spirits', '', 'pixy', 5.00, 25.00, 74, 'female', 'L2Minion', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 24232, 2526, 1262, 513, 861, 342, 253, 0, 506, 0, 0, 0, 80, 174, 'tower_guard_clan', 200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (894, 21084, 'Bloody Lady', '', 'bloody_queen', 14.00, 40.00, 60, 'female', 'L2Monster', 'Mystic', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 14806, 1285, 717, 370, 490, 246, 253, 500, 506, 0, 0, 0, 80, 174, 'bloody_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (895, 21085, 'Bloody Sniper', '', 'fiend_archer', 17.00, 55.00, 71, 'male', 'L2Monster', 'Ranger', 1100, 2493, 8.500, 1378, 3.000, 40, 43, 30, 21, 20, 20, 33449, 3356, 1136, 482, 776, 320, 253, 500, 506, 0, 0, 0, 70, 174, 'bloody_clan', 400, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (896, 21086, 'Bloody Liviona', '', 'liviona', 15.00, 28.00, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 33396, 3392, 1179, 491, 805, 327, 253, 500, 506, 0, 0, 0, 80, 174, 'bloody_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (897, 21087, 'Bloody Knight', '', 'death_knight', 12.00, 31.00, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 53594, 5514, 1220, 502, 833, 334, 253, 500, 506, 84, 0, 0, 27, 174, 'bloody_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (898, 21088, 'Bloody Banshee', '', 'banshee', 9.00, 23.00, 74, 'female', 'L2Monster', 'Mystic', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 35277, 3677, 1262, 513, 861, 342, 253, 500, 506, 3939, 0, 0, 80, 174, 'bloody_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (899, 21089, 'Bloody Lord', '', 'karik', 25.00, 90.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 40903, 4314, 1304, 523, 891, 349, 253, 500, 506, 0, 0, 0, 37, 174, 'bloody_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (900, 21090, 'Bloody Guardian', '', 'death_blader', 15.00, 45.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 31444, 3317, 1304, 523, 891, 349, 253, 500, 506, 1472, 0, 0, 100, 174, 'bloody_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (901, 21091, 'Bloody Keeper', '', 'kaim_vanul', 24.00, 40.00, 74, 'male', 'L2Minion', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 21195, 2209, 1262, 513, 861, 342, 253, 0, 506, 0, 0, 0, 37, 174, 'bloody_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (902, 21092, 'Bloody Mystic', '', 'banshee', 9.00, 23.00, 74, 'female', 'L2Minion', 'Mystic', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 20706, 2159, 1262, 513, 861, 342, 253, 0, 506, 3939, 0, 0, 80, 174, 'bloody_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (903, 21093, 'Ratman Sub Chieftain', '', 'wererat', 14.00, 25.00, 19, 'male', 'L2Monster', 'Fighter', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 692, 31, 44, 91, 30, 60, 253, 400, 506, 216, 0, 0, 80, 150, 'wererat_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (904, 21094, 'Ratman Chieftain', '', 'wererat', 14.00, 25.00, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 713, 32, 48, 95, 33, 63, 253, 0, 506, 3, 0, 0, 80, 155, 'wererat_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (905, 21095, 'Giant Poison Bee', '', 'giant_bee', 8.00, 24.50, 21, 'male', 'L2Monster', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 1009, 47, 53, 99, 36, 66, 253, 0, 506, 0, 0, 0, 90, 90, '1', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (906, 21096, 'Cloudy Beast ', '', 'onyx_beast', 14.00, 14.50, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 1005, 48, 58, 103, 39, 69, 253, 400, 506, 0, 0, 0, 30, 140, 'beast_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (907, 21097, 'Young Araneid', '', 'poison_spider', 27.00, 25.50, 23, 'male', 'L2Monster', 'Mystic', 40, 411, 3.500, 232, 1.500, 40, 43, 30, 21, 20, 20, 1183, 58, 63, 108, 43, 72, 253, 400, 506, 0, 0, 0, 60, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (908, 21098, 'Plain Grizzly', '', 'grizzly', 21.00, 40.00, 24, 'male', 'L2Monster', 'Fighter', 40, 435, 3.500, 246, 1.500, 40, 43, 30, 21, 20, 20, 1123, 55, 68, 112, 46, 75, 253, 0, 506, 0, 0, 0, 40, 115, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (909, 21099, 'Cloudy Beast Turen', '', 'onyx_beast', 14.00, 14.50, 25, 'male', 'L2Monster', 'Fighter', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 1215, 61, 74, 116, 50, 78, 253, 400, 506, 0, 0, 0, 30, 145, 'beast_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (910, 21100, 'Langk Lizardman Sentinel', '', 'virud_lizardman', 10.00, 23.00, 19, 'male', 'L2Monster', 'Fighter', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 692, 31, 44, 91, 30, 60, 253, 500, 506, 2, 0, 0, 43, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (911, 21101, 'Langk Lizardman Shaman', '', 'virud_lizardman_shaman', 10.00, 29.00, 24, 'male', 'L2Monster', 'Priest', 40, 435, 3.500, 246, 1.500, 40, 43, 30, 21, 20, 20, 1123, 55, 68, 112, 46, 75, 253, 0, 506, 6, 0, 0, 43, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (912, 21102, 'Watchman of the Plains', '', 'magical_weaver', 11.00, 20.00, 30, 'male', 'L2Monster', 'Mystic', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1602, 88, 111, 140, 75, 94, 253, 500, 506, 0, 0, 0, 90, 160, 'monster_eye_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (913, 21103, 'Roughly Hewn Rock Golem', '', 'stone_golem_bi', 20.00, 40.30, 31, 'male', 'L2Monster', 'Mystic', 40, 636, 4.500, 344, 1.800, 40, 43, 30, 21, 20, 20, 1677, 94, 119, 146, 82, 97, 253, 0, 506, 0, 0, 0, 23, 23, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (914, 21104, 'Delu Lizardman Supplier', '', 'virud_lizardman', 10.00, 23.00, 32, 'male', 'L2Monster', 'Fighter', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 2106, 119, 128, 152, 87, 102, 253, 0, 506, 223, 0, 0, 43, 135, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (915, 21105, 'Delu Lizardman Special Agent', '', 'virud_lizardman_scout', 10.00, 22.00, 33, 'male', 'L2Monster', 'DeluLizardmanSpecialAgent', 1100, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 2427, 139, 138, 157, 94, 105, 253, 0, 506, 2507, 0, 0, 43, 135, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (916, 21106, 'Cursed Seer', '', 'magical_weaver', 11.00, 20.00, 34, 'male', 'L2Monster', 'Mystic', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 2058, 120, 149, 164, 102, 109, 253, 500, 506, 0, 0, 0, 90, 160, 'monster_eye_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (917, 21107, 'Delu Lizardman Commander', '', 'virud_lizardman_warrior', 12.00, 30.00, 35, 'male', 'L2Monster', 'DeluLizardmanSpecialCommander', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 4354, 258, 160, 170, 109, 113, 253, 0, 506, 93, 0, 0, 52, 135, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (918, 21108, 'Glow Wisp', '', 'will_o_wisp', 13.00, 22.00, 67, 'male', 'L2Monster', 'Mystic', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 7835, 746, 975, 440, 666, 292, 253, 0, 506, 0, 0, 0, 80, 160, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.10, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (919, 21109, 'Hames Orc Scout', '', 'ketra_orc', 12.00, 29.00, 68, 'male', 'L2Monster', 'Fighter', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 9699, 937, 1014, 449, 692, 300, 253, 0, 506, 229, 0, 0, 45, 185, 'orc_clan', 400, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (920, 21110, 'Marsh Predator', '', 'devastator', 35.00, 35.00, 69, 'male', 'L2Monster', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 8268, 809, 1055, 460, 720, 307, 253, 0, 506, 0, 0, 0, 25, 175, '1', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (921, 21111, 'Lava Wyrm', '', 'wyrm', 29.00, 72.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 8637, 857, 1096, 471, 747, 313, 253, 500, 506, 0, 0, 0, 70, 175, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.19, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (922, 21112, 'Hames Orc Footman', '', 'ketra_orc', 12.00, 29.00, 71, 'male', 'L2Monster', 'Fighter', 40, 2493, 8.500, 1378, 3.000, 40, 43, 30, 21, 20, 20, 10470, 1050, 1136, 482, 776, 320, 253, 0, 506, 233, 110, 0, 45, 180, 'orc_clan', 300, 0, 20, 150, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (923, 21113, 'Hames Orc Sniper', '', 'ketra_orc_archer', 12.00, 27.00, 72, 'male', 'L2Monster', 'Ranger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 11667, 1186, 1179, 491, 805, 327, 253, 0, 506, 287, 0, 0, 45, 160, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.91, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (924, 21114, 'Cursed Guardian', '', 'death_blader', 15.00, 45.00, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 11078, 1140, 1220, 502, 833, 334, 253, 0, 506, 1472, 0, 0, 100, 175, '1', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (925, 21115, 'Hames Orc Shaman', '', 'ketra_orc_shaman', 10.00, 23.00, 74, 'male', 'L2Monster', 'Priest', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 9652, 1006, 1262, 513, 861, 342, 253, 0, 506, 186, 0, 0, 10, 145, 'orc_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (926, 21116, 'Hames Orc Overlord', '', 'ketra_orc_warrior', 12.00, 24.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 15240, 1608, 1304, 523, 891, 349, 253, 500, 506, 75, 103, 0, 36, 175, 'orc_clan', 500, 0, 20, 160, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (927, 21117, 'Kasha Imp', '', 'imp_bi', 10.00, 30.00, 19, 'male', 'L2Monster', 'Fighter', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 678, 30, 44, 91, 30, 60, 253, 0, 506, 0, 0, 0, 60, 85, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (928, 21118, 'Baar Dre Vanul', '', 'dre_vanul', 14.00, 36.00, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 727, 32, 48, 95, 33, 63, 253, 400, 506, 0, 0, 0, 80, 85, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (929, 21119, 'Hobgoblin', '', 'hobgoblin', 12.00, 24.00, 21, 'male', 'L2Monster', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 917, 42, 53, 99, 36, 66, 253, 0, 506, 4, 0, 0, 45, 110, 'goblin_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (930, 21120, 'Kasha Imp Turen', '', 'imp_bi', 10.00, 30.00, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 1196, 56, 58, 103, 39, 69, 253, 400, 506, 0, 0, 0, 60, 85, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (931, 21121, 'Kasha Dire Wolf', '', 'dire_wolf', 13.00, 11.00, 23, 'male', 'L2Monster', 'Fighter', 40, 411, 3.500, 232, 1.500, 40, 43, 30, 21, 20, 20, 1075, 52, 63, 108, 43, 72, 253, 400, 506, 0, 0, 0, 24, 135, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (932, 21122, 'Kasha Bugbear', '', 'bugbear', 17.00, 35.00, 24, 'male', 'L2Monster', 'Fighter', 40, 435, 3.500, 246, 1.500, 40, 43, 30, 21, 20, 20, 1145, 56, 68, 112, 46, 75, 253, 400, 506, 169, 0, 0, 55, 130, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (933, 21123, 'Baar Dre Vanul Destroyer', '', 'dre_vanul', 14.00, 36.00, 25, 'male', 'L2Monster', 'Fighter', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 1521, 76, 74, 116, 50, 78, 253, 400, 506, 0, 0, 0, 80, 85, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (934, 21124, 'Red Eye Barbed Bat', '', 'vampire_bat', 10.00, 33.50, 18, 'male', 'L2Monster', 'Mystic', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 640, 28, 41, 87, 28, 58, 253, 0, 506, 0, 0, 0, 60, 90, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (935, 21125, 'Northern Trimden', '', 'poison_spider', 27.00, 25.50, 19, 'male', 'L2Monster', 'Mystic', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 685, 31, 44, 91, 30, 60, 253, 400, 506, 0, 0, 0, 60, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (936, 21126, 'Kerope Werewolf', '', 'werewolf_bi', 11.00, 29.70, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 713, 32, 48, 95, 33, 63, 253, 0, 506, 0, 0, 0, 50, 125, 'werewolf_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (937, 21127, 'Northern Goblin', '', 'northern_goblin', 4.00, 15.00, 21, 'male', 'L2Monster', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 917, 42, 53, 99, 36, 66, 253, 0, 506, 152, 0, 0, 30, 120, 'goblin_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (938, 21128, 'Spine Golem', '', 'stone_golem_bi', 20.00, 40.30, 22, 'male', 'L2Monster', 'Mystic', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 986, 47, 58, 103, 39, 69, 253, 0, 506, 0, 0, 0, 23, 23, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (939, 21129, 'Kerope Werewolf Chief', '', 'werewolf_bi', 11.00, 29.70, 23, 'male', 'L2Monster', 'Fighter', 40, 411, 3.500, 232, 1.500, 40, 43, 30, 21, 20, 20, 1075, 52, 63, 108, 43, 72, 253, 400, 506, 0, 0, 0, 50, 140, 'werewolf_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (940, 21130, 'Northern Goblin Leader', '', 'northern_goblin', 4.00, 15.00, 24, 'male', 'L2Monster', 'Fighter', 40, 435, 3.500, 246, 1.500, 40, 43, 30, 21, 20, 20, 1145, 56, 68, 112, 46, 75, 253, 400, 506, 66, 102, 0, 30, 125, 'goblin_clan', 300, 0, 20, 49, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (941, 21131, 'Enchanted Spine Golem', '', 'stone_golem_bi', 20.00, 40.30, 25, 'male', 'L2Monster', 'Mystic', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 1191, 60, 74, 116, 50, 78, 253, 0, 506, 0, 0, 0, 23, 29, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (942, 21132, 'Underground Kobold', '', 'kobold', 10.00, 15.00, 24, 'male', 'L2Monster', 'Fighter', 40, 435, 3.500, 246, 1.500, 40, 43, 30, 21, 20, 20, 935, 46, 68, 112, 46, 75, 253, 0, 506, 0, 0, 0, 47, 110, 'kobold_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (943, 21133, 'Dead Pit Skeleton Archer', '', 'skeleton_archer', 11.00, 27.00, 25, 'male', 'L2Monster', 'Ranger', 1100, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 1022, 52, 74, 116, 50, 78, 253, 0, 506, 274, 0, 0, 40, 130, 'undead_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (944, 21134, 'Dead Pit Spartoi', '', 'spartoi', 11.00, 27.00, 26, 'male', 'L2Monster', 'Fighter', 40, 488, 3.500, 273, 1.500, 40, 43, 30, 21, 20, 20, 1078, 54, 81, 121, 55, 81, 253, 400, 506, 219, 0, 0, 60, 145, 'undead_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (945, 21135, 'Underground Kobold Warrior', '', 'kobold', 10.00, 15.00, 27, 'male', 'L2Monster', 'Fighter', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 1325, 67, 87, 125, 59, 84, 253, 0, 506, 0, 0, 0, 47, 115, 'kobold_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (946, 21136, 'Dead Pit Horror', '', 'dark_horror', 20.00, 35.00, 28, 'male', 'L2Monster', 'Fighter', 40, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 1178, 62, 95, 131, 64, 87, 253, 0, 506, 0, 0, 0, 100, 100, 'undead_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (947, 21137, 'Iron Ore Golem', '', 'iron_golem', 18.00, 34.00, 29, 'male', 'L2Monster', 'Mystic', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 1268, 68, 101, 136, 70, 91, 253, 400, 506, 0, 0, 0, 20, 21, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (948, 21138, 'Greedy Geist', '', 'hungry_spirit', 30.00, 40.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1361, 74, 111, 140, 75, 94, 253, 0, 506, 0, 0, 0, 15, 150, 'undead_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (949, 21139, 'Catacomb Barbed Bat', '', 'vampire_bat', 10.00, 33.50, 23, 'male', 'L2Monster', 'Mystic', 40, 411, 3.500, 232, 1.500, 40, 43, 30, 21, 20, 20, 2621, 127, 63, 108, 43, 72, 253, 500, 506, 0, 0, 0, 60, 130, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (950, 21140, 'Catacomb Wisp', '', 'will_o_wisp', 13.00, 22.00, 26, 'male', 'L2Monster', 'Mystic', 40, 488, 3.500, 273, 1.500, 40, 43, 30, 21, 20, 20, 3153, 159, 81, 121, 55, 81, 253, 500, 506, 0, 0, 0, 80, 120, 'c_dungeon_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.10, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (951, 21141, 'Catacomb Serpent', '', 'serpent_slave', 17.00, 46.00, 28, 'male', 'L2Monster', 'Fighter', 40, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 3706, 194, 95, 131, 64, 87, 253, 500, 506, 73, 0, 0, 70, 130, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (952, 21142, 'Grave Keeper Spartoi', '', 'spartoi', 11.00, 27.00, 29, 'male', 'L2Monster', 'Fighter', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 3710, 199, 101, 136, 70, 91, 253, 500, 506, 221, 0, 0, 60, 140, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (953, 21143, 'Catacomb Scavenger Bat', '', 'vampire_bat', 10.00, 33.50, 31, 'male', 'L2Monster', 'Fighter', 40, 636, 4.500, 344, 1.800, 40, 43, 30, 21, 20, 20, 4170, 231, 119, 146, 82, 97, 253, 500, 506, 0, 0, 0, 60, 140, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (954, 21144, 'Catacomb Shadow', '', 'shadow', 10.00, 30.00, 34, 'male', 'L2Monster', 'Mystic', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 5016, 293, 149, 164, 102, 109, 253, 500, 506, 0, 0, 0, 80, 130, 'c_dungeon_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (955, 21145, 'Catacomb Stakato Soldier', '', 'blade_stakato_soldier', 15.00, 38.00, 38, 'male', 'L2Monster', 'Fighter', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 6444, 402, 198, 188, 136, 126, 253, 500, 506, 232, 0, 0, 25, 150, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (956, 21146, 'Grave Keeper Dark Horror', '', 'dark_horror', 20.00, 35.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 6943, 448, 227, 203, 155, 134, 253, 500, 506, 0, 0, 0, 100, 160, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (957, 21147, 'Catacomb Gargoyle', '', 'gargoyle', 16.00, 50.00, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 8457, 572, 277, 223, 189, 149, 253, 500, 506, 0, 0, 0, 140, 170, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (958, 21148, 'Catacomb Liviona', '', 'liviona', 15.00, 28.00, 44, 'male', 'L2Monster', 'Fighter', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 8401, 575, 295, 230, 202, 153, 253, 500, 506, 0, 0, 0, 80, 140, 'c_dungeon_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (959, 21149, 'Decayed Ancient Pikeman', '', 'skeleton_pikeman', 10.00, 28.00, 46, 'male', 'L2Monster', 'Fighter', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 9679, 686, 335, 246, 228, 163, 253, 500, 506, 96, 0, 0, 50, 170, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.21, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (960, 21150, 'Decayed Ancient Soldier', '', 'skeleton_knight', 10.00, 25.00, 49, 'male', 'L2Monster', 'Fighter', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 10982, 812, 400, 270, 273, 179, 253, 500, 506, 125, 0, 0, 40, 160, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (961, 21151, 'Decayed Ancient Knight', '', 'skeleton_royal_guard', 11.00, 28.50, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 11435, 861, 425, 278, 291, 185, 253, 500, 506, 227, 0, 0, 80, 170, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (962, 21152, 'Purgatory Wisp', '', 'will_o_wisp', 13.00, 22.00, 53, 'male', 'L2Monster', 'Mystic', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 12189, 958, 503, 304, 344, 203, 253, 500, 506, 0, 0, 0, 80, 150, 'c_dungeon_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.10, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (963, 21153, 'Purgatory Serpent', '', 'serpent_slave', 17.00, 46.00, 56, 'male', 'L2Monster', 'Fighter', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 14344, 1178, 589, 331, 402, 220, 253, 500, 506, 73, 0, 0, 70, 175, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (964, 21154, 'Hell Keeper Medusa', '', 'medusa', 10.00, 25.00, 58, 'female', 'L2Monster', 'Mystic', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 15013, 1268, 651, 350, 444, 232, 253, 500, 506, 0, 0, 0, 50, 165, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (965, 21155, 'Purgatory Conjurer', '', 'vampire_bat', 10.00, 33.50, 59, 'male', 'L2Monster', 'Mystic', 40, 1881, 6.500, 1007, 2.400, 40, 43, 30, 21, 20, 20, 15105, 1291, 684, 360, 466, 240, 253, 500, 506, 0, 0, 0, 60, 175, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (966, 21156, 'Purgatory Shadow', '', 'shadow', 10.00, 30.00, 61, 'male', 'L2Monster', 'Mystic', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 16146, 1421, 752, 378, 513, 252, 253, 500, 506, 0, 0, 0, 80, 155, 'c_dungeon_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (967, 21157, 'Purgatory Tarantula', '', 'poison_spider', 27.00, 25.50, 64, 'male', 'L2Monster', 'Mystic', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 18280, 1674, 860, 409, 588, 272, 253, 500, 506, 0, 0, 0, 60, 175, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (968, 21158, 'Hell Keeper Crimson Doll', '', 'crimson_doll', 15.00, 38.00, 67, 'male', 'L2Monster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 20533, 1955, 975, 440, 666, 292, 253, 500, 506, 0, 0, 0, 60, 180, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.67, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (969, 21159, 'Purgatory Gargoyle', '', 'gargoyle', 16.00, 50.00, 68, 'male', 'L2Monster', 'Fighter', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 21151, 2043, 1014, 449, 692, 300, 253, 500, 506, 0, 0, 0, 140, 175, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (970, 21160, 'Purgatory Liviona', '', 'liviona', 15.00, 28.00, 71, 'male', 'L2Monster', 'Fighter', 40, 2493, 8.500, 1378, 3.000, 40, 43, 30, 21, 20, 20, 21874, 2195, 1136, 482, 776, 320, 253, 500, 506, 0, 0, 0, 80, 160, 'c_dungeon_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (971, 21161, 'Lesser Ancient Soldier', '', 'medusa', 10.00, 25.00, 73, 'female', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 23782, 2447, 1220, 502, 833, 334, 253, 500, 506, 0, 0, 0, 50, 180, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (972, 21162, 'Lesser Ancient Scout', '', 'blade_stakato_drone', 15.00, 39.00, 74, 'male', 'L2Monster', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 23761, 2477, 1262, 513, 861, 342, 253, 500, 506, 135, 0, 0, 25, 160, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (973, 21163, 'Lesser Ancient Shaman', '', 'silhouette', 8.00, 23.00, 76, 'female', 'L2Monster', 'Priest', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 25063, 2679, 1345, 535, 919, 356, 253, 500, 506, 0, 0, 0, 80, 200, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (974, 21164, 'Guardian Spirit of Ancient Holy Ground', '', 'death_lord', 21.00, 40.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2871, 8.585, 1657, 3.030, 40, 43, 30, 21, 20, 20, 28547, 3164, 1476, 568, 1019, 379, 253, 500, 506, 78, 0, 0, 40, 190, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 6, 0, 1, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (975, 21165, 'Lesser Ancient Warrior', '', 'shadeless', 7.00, 28.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 31048, 3485, 1525, 581, 1062, 387, 253, 500, 506, 0, 0, 0, 48, 200, 'c_dungeon_clan', 300, 0, 0, 0, 7, 50, 1, 11, 0, 2, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (976, 21166, 'Lith Scout', '', 'temple_guard_a_20_sm', 12.00, 33.60, 21, 'male', 'L2Monster', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 2380, 109, 53, 99, 36, 66, 253, 0, 506, 5795, 0, 0, 53, 130, 'c_dungeon_clan', 400, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (977, 21167, 'Lith Witch', '', 'temple_savant_a_20_sm', 8.00, 32.00, 24, 'male', 'L2Monster', 'Mystic', 40, 435, 3.500, 246, 1.500, 40, 43, 30, 21, 20, 20, 2763, 136, 68, 112, 46, 75, 253, 0, 506, 5797, 0, 0, 25, 110, 'c_dungeon_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (978, 21168, 'Lith Warrior', '', 'temple_guard_b_20_sm', 12.00, 33.60, 27, 'male', 'L2Monster', 'Fighter', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 3420, 175, 87, 125, 59, 84, 253, 0, 506, 5796, 0, 0, 53, 130, 'c_dungeon_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (979, 21169, 'Lith Guard', '', 'temple_guard_a', 15.00, 42.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 4532, 248, 111, 140, 75, 94, 253, 0, 506, 5795, 0, 0, 53, 140, 'c_dungeon_clan', 400, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (980, 21170, 'Lith Medium', '', 'temple_savant_a', 10.00, 40.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 5231, 300, 138, 157, 94, 105, 253, 0, 506, 5797, 0, 0, 25, 120, 'c_dungeon_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (981, 21171, 'Lith Overlord', '', 'temple_guard_b', 15.00, 42.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 6677, 404, 173, 176, 118, 118, 253, 0, 506, 5796, 0, 0, 53, 140, 'c_dungeon_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (982, 21172, 'Lith Patrolman', '', 'temple_guard_a', 15.00, 42.00, 39, 'male', 'L2Monster', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 7888, 501, 212, 195, 145, 131, 253, 0, 506, 5795, 0, 0, 53, 150, 'c_dungeon_clan', 400, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (983, 21173, 'Lith Shaman', '', 'temple_savant_a', 10.00, 40.00, 42, 'male', 'L2Monster', 'Priest', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 8473, 564, 259, 216, 177, 144, 253, 0, 506, 5798, 0, 0, 25, 130, 'c_dungeon_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (984, 21174, 'Lith Commander', '', 'temple_guard_b', 15.00, 42.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 10925, 760, 315, 239, 214, 158, 253, 0, 506, 5796, 0, 0, 53, 150, 'c_dungeon_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (985, 21175, 'Lilim Butcher', '', 'lilim_assassin_10_sm', 11.00, 36.00, 48, 'male', 'L2Monster', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 12374, 904, 378, 262, 258, 174, 253, 0, 506, 232, 232, 0, 36, 170, 'c_dungeon_clan', 400, 0, 0, 84, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (986, 21176, 'Lilim Magus', '', 'lilim_wizard_10_sm', 8.00, 30.60, 51, 'female', 'L2Monster', 'Mystic', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 12493, 953, 449, 287, 307, 190, 253, 0, 506, 0, 0, 0, 50, 140, 'c_dungeon_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (987, 21177, 'Lilim Knight Errant', '', 'lilim_knight_10_sm', 11.00, 45.00, 54, 'male', 'L2Monster', 'Fighter', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 17542, 1399, 531, 313, 362, 209, 253, 0, 506, 5800, 5799, 0, 56, 170, 'c_dungeon_clan', 400, 0, 20, 109, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (988, 21178, 'Lilim Marauder', '', 'lilim_assassin_10_sm', 11.00, 36.00, 57, 'male', 'L2Monster', 'Fighter', 40, 1777, 6.500, 948, 2.400, 40, 43, 30, 21, 20, 20, 18790, 1561, 619, 340, 423, 226, 253, 0, 506, 229, 229, 0, 36, 180, 'c_dungeon_clan', 400, 0, 0, 102, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (989, 21179, 'Lilim Priest', '', 'lilim_wizard_10_sm', 8.00, 30.60, 60, 'female', 'L2Monster', 'Priest', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 17292, 1501, 717, 370, 490, 246, 253, 0, 506, 0, 0, 0, 50, 160, 'c_dungeon_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (990, 21180, 'Lilim Knight', '', 'lilim_knight_10_sm', 11.00, 45.00, 63, 'male', 'L2Monster', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 25957, 2344, 822, 398, 562, 266, 253, 0, 506, 5800, 5799, 0, 56, 180, 'c_dungeon_clan', 400, 0, 20, 131, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (991, 21181, 'Lilim Assassin', '', 'lilim_assassin_10_bi', 13.00, 44.00, 66, 'male', 'L2Monster', 'Fighter', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 27475, 2586, 936, 429, 639, 285, 253, 0, 506, 234, 234, 0, 36, 190, 'c_dungeon_clan', 400, 0, 0, 121, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (992, 21182, 'Lilim Soldier', '', 'lilim_wizard_10_bi', 10.00, 37.50, 69, 'female', 'L2Monster', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 22868, 2237, 1055, 460, 720, 307, 253, 0, 506, 0, 0, 0, 50, 170, 'c_dungeon_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (993, 21183, 'Lilim Knight Commander', '', 'lilim_knight_10_bi', 13.00, 55.00, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 33903, 3444, 1179, 491, 805, 327, 253, 0, 506, 5800, 5799, 0, 56, 190, 'c_dungeon_clan', 400, 0, 20, 153, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (994, 21184, 'Lilim Slayer', '', 'lilim_assassin_10_bi', 13.00, 44.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 35479, 3742, 1304, 523, 891, 349, 253, 0, 506, 236, 236, 0, 36, 200, 'c_dungeon_clan', 400, 0, 0, 140, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (995, 21185, 'Lilim Great Mystic', '', 'lilim_wizard_10_bi', 10.00, 37.50, 78, 'female', 'L2Monster', 'Mystic', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 29223, 3198, 1430, 556, 975, 371, 253, 0, 506, 0, 0, 0, 50, 180, 'c_dungeon_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (996, 21186, 'Lilim Court Knight', '', 'lilim_knight_10_bi', 13.00, 55.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 41856, 4698, 1525, 581, 1062, 387, 253, 0, 506, 5800, 5799, 0, 56, 200, 'c_dungeon_clan', 400, 0, 20, 171, 7, 30, 4, 7, 0, 2, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (997, 21187, 'Gigant Slave', '', 'tomb_guard_a_20_sm', 8.00, 32.00, 21, 'male', 'L2Monster', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 2380, 109, 53, 99, 36, 66, 253, 0, 506, 5791, 0, 0, 49, 130, 'c_dungeon_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (998, 21188, 'Gigant Acolyte', '', 'tomb_savant_a_20_sm', 8.00, 32.00, 24, 'male', 'L2Monster', 'Fighter', 40, 435, 3.500, 246, 1.500, 40, 43, 30, 21, 20, 20, 2763, 136, 68, 112, 46, 75, 253, 0, 506, 5793, 0, 0, 49, 110, 'c_dungeon_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (999, 21189, 'Gigant Overseer', '', 'tomb_guard_b_20_sm', 12.00, 34.00, 27, 'male', 'L2Monster', 'Fighter', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 3420, 175, 87, 125, 59, 84, 253, 0, 506, 5792, 0, 0, 49, 130, 'c_dungeon_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1000, 21190, 'Gigant Footman', '', 'tomb_guard_a', 10.00, 40.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 4532, 248, 111, 140, 75, 94, 253, 0, 506, 5791, 0, 0, 49, 140, 'c_dungeon_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1001, 21191, 'Gigant Cleric', '', 'tomb_savant_a', 10.00, 40.00, 33, 'male', 'L2Monster', 'Priest', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 5231, 300, 138, 157, 94, 105, 253, 0, 506, 5793, 0, 0, 49, 120, 'c_dungeon_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1002, 21192, 'Gigant Officer', '', 'tomb_guard_b', 15.00, 42.50, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 6677, 404, 173, 176, 118, 118, 253, 0, 506, 5792, 0, 0, 49, 140, 'c_dungeon_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1003, 21193, 'Gigant Raider', '', 'tomb_guard_a', 10.00, 40.00, 39, 'male', 'L2Monster', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 7888, 501, 212, 195, 145, 131, 253, 0, 506, 5791, 0, 0, 49, 150, 'c_dungeon_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1004, 21194, 'Gigant Confessor', '', 'tomb_savant_a', 10.00, 40.00, 42, 'male', 'L2Monster', 'Fighter', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 8473, 564, 259, 216, 177, 144, 253, 0, 506, 5794, 0, 0, 49, 130, 'c_dungeon_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1005, 21195, 'Gigant Commander', '', 'tomb_guard_b', 15.00, 42.50, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 10925, 760, 315, 239, 214, 158, 253, 0, 506, 5792, 0, 0, 49, 150, 'c_dungeon_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1006, 21196, 'Nephilim Sentinel', '', 'nephilim_slayer_10_sm', 11.00, 32.40, 48, 'male', 'L2Monster', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 12374, 904, 378, 262, 258, 174, 253, 0, 506, 0, 0, 0, 65, 170, 'c_dungeon_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1007, 21197, 'Nephilim Priest', '', 'nephilim_priest_10_sm', 21.00, 36.50, 51, 'male', 'L2Monster', 'Priest', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 13567, 1034, 449, 287, 307, 190, 253, 0, 506, 0, 0, 0, 50, 140, 'c_dungeon_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1008, 21198, 'Nephilim Swordsman', '', 'nephilim_lord_10_sm', 11.00, 39.00, 54, 'male', 'L2Monster', 'Fighter', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 17542, 1399, 531, 313, 362, 209, 253, 0, 506, 0, 0, 0, 65, 170, 'c_dungeon_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1009, 21199, 'Nephilim Guard', '', 'nephilim_slayer_10_sm', 11.00, 32.40, 57, 'male', 'L2Monster', 'Fighter', 40, 1777, 6.500, 948, 2.400, 40, 43, 30, 21, 20, 20, 18790, 1561, 619, 340, 423, 226, 253, 0, 506, 0, 0, 0, 65, 180, 'c_dungeon_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1010, 21200, 'Nephilim Bishop', '', 'nephilim_priest_10_sm', 21.00, 36.50, 60, 'male', 'L2Monster', 'Priest', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 18777, 1630, 717, 370, 490, 246, 253, 0, 506, 0, 0, 0, 50, 160, 'c_dungeon_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1011, 21201, 'Nephilim Centurion', '', 'nephilim_lord_10_sm', 11.00, 39.00, 63, 'male', 'L2Monster', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 25957, 2344, 822, 398, 562, 266, 253, 0, 506, 0, 0, 0, 65, 180, 'c_dungeon_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1012, 21202, 'Nephilim Scout', '', 'nephilim_slayer_10_bi', 13.00, 39.60, 66, 'male', 'L2Monster', 'Fighter', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 27475, 2586, 936, 429, 639, 285, 253, 0, 506, 0, 0, 0, 65, 190, 'c_dungeon_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1013, 21203, 'Nephilim Archbishop', '', 'nephilim_priest_10_bi', 21.00, 44.00, 69, 'male', 'L2Monster', 'Priest', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 24833, 2430, 1055, 460, 720, 307, 253, 0, 506, 0, 0, 0, 50, 170, 'c_dungeon_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1014, 21204, 'Nephilim Praetorian', '', 'nephilim_lord_10_bi', 13.00, 48.00, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 33903, 3444, 1179, 491, 805, 327, 253, 0, 506, 0, 0, 0, 65, 190, 'c_dungeon_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1015, 21205, 'Nephilim Royal Guard', '', 'nephilim_slayer_10_bi', 13.00, 39.60, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 35479, 3742, 1304, 523, 891, 349, 253, 0, 506, 0, 0, 0, 65, 200, 'c_dungeon_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1016, 21206, 'Nephilim Cardinal', '', 'nephilim_priest_10_bi', 21.00, 44.00, 78, 'male', 'L2Monster', 'Priest', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 31734, 3473, 1430, 556, 975, 371, 253, 0, 506, 0, 0, 0, 50, 180, 'c_dungeon_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1017, 21207, 'Nephilim Commander', '', 'nephilim_lord_10_bi', 13.00, 48.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 41856, 4698, 1525, 581, 1062, 387, 253, 0, 506, 0, 0, 0, 65, 200, 'c_dungeon_clan', 400, 0, 0, 0, 7, 30, 4, 7, 0, 2, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1018, 21208, 'Hallowed Watchman', '', 'skeleton', 11.00, 25.00, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 2085, 92, 48, 95, 33, 63, 253, 0, 506, 216, 111, 0, 60, 130, 'c_dungeon_clan', 300, 0, 20, 43, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1019, 21209, 'Hallowed Seer', '', 'binding', 12.00, 21.00, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 2450, 116, 58, 103, 39, 69, 253, 500, 506, 0, 0, 0, 10, 110, 'c_dungeon_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1020, 21210, 'Vault Guardian', '', 'dre_vanul', 10.00, 24.00, 25, 'male', 'L2Monster', 'Fighter', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 3121, 156, 74, 116, 50, 78, 253, 500, 506, 0, 0, 0, 60, 130, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1021, 21211, 'Vault Seer', '', 'succubus', 10.00, 36.00, 27, 'female', 'L2Monster', 'Mystic', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 3321, 170, 87, 125, 59, 84, 253, 500, 506, 0, 0, 0, 60, 110, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1022, 21212, 'Hallowed Sentinel', '', 'skeleton_bi', 11.00, 31.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 3829, 209, 111, 140, 75, 94, 253, 0, 506, 69, 646, 0, 60, 140, 'c_dungeon_clan', 300, 0, 20, 59, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1023, 21213, 'Hallowed Monk', '', 'binding_20_bi', 14.00, 25.30, 32, 'male', 'L2Monster', 'Fighter', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 4443, 250, 128, 152, 87, 102, 253, 500, 506, 0, 0, 0, 10, 110, 'c_dungeon_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1024, 21214, 'Vault Sentinel', '', 'imp_bi', 10.00, 30.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 5603, 332, 160, 170, 109, 113, 253, 500, 506, 0, 0, 0, 60, 140, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1025, 21215, 'Vault Monk', '', 'succubus_bi', 10.00, 43.20, 37, 'female', 'L2Monster', 'Mystic', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 5940, 365, 185, 181, 126, 121, 253, 500, 506, 0, 0, 0, 60, 120, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1026, 21216, 'Overlord of the Holy Lands', '', 'skeleton_knight_20_bi', 12.00, 30.50, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 6807, 440, 227, 203, 155, 134, 253, 0, 506, 129, 646, 0, 40, 160, 'c_dungeon_clan', 300, 0, 20, 78, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1027, 21217, 'Hallowed Priest', '', 'banshee_20_bi', 10.00, 27.50, 42, 'female', 'L2Monster', 'Priest', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 7654, 510, 259, 216, 177, 144, 253, 500, 506, 0, 0, 0, 80, 135, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1028, 21218, 'Vault Overlord', '', 'death_blader_10_sm', 14.00, 40.50, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 9263, 644, 315, 239, 214, 158, 253, 500, 506, 297, 0, 0, 100, 160, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1029, 21219, 'Vault Priest', '', 'bloody_queen_10_sm', 13.00, 38.00, 47, 'female', 'L2Monster', 'Priest', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 9585, 687, 356, 254, 243, 169, 253, 500, 506, 0, 0, 0, 80, 135, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1030, 21220, 'Sepulcher Archon', '', 'skeleton_knight_30_bi', 13.00, 33.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 10635, 801, 425, 278, 291, 185, 253, 0, 506, 131, 107, 0, 40, 170, 'c_dungeon_clan', 300, 0, 20, 100, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1031, 21221, 'Sepulcher Inquisitor', '', 'banshee_30_bi', 11.00, 30.00, 52, 'female', 'L2Monster', 'Mystic', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 11733, 908, 475, 296, 324, 196, 253, 500, 506, 0, 0, 0, 80, 145, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1032, 21222, 'Sepulcher Archon', '', 'death_blader_10_bi', 16.00, 49.50, 55, 'male', 'L2Monster', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 13837, 1117, 559, 323, 382, 215, 253, 500, 506, 298, 0, 0, 100, 170, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1033, 21223, 'Sepulcher Inquisitor', '', 'bloody_queen_10_bi', 15.00, 46.00, 57, 'female', 'L2Monster', 'Mystic', 40, 1777, 6.500, 948, 2.400, 40, 43, 30, 21, 20, 20, 14098, 1172, 619, 340, 423, 226, 253, 500, 506, 0, 0, 0, 80, 145, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1034, 21224, 'Sepulcher Guardian', '', 'skeleton_royal_guard_20_bi', 13.00, 34.50, 60, 'male', 'L2Monster', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 15315, 1329, 717, 370, 490, 246, 253, 0, 506, 233, 0, 0, 80, 190, 'c_dungeon_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1035, 21225, 'Sepulcher Sage', '', 'vale_master_10_bi', 13.00, 44.00, 62, 'male', 'L2Monster', 'Fighter', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 16680, 1486, 787, 388, 538, 258, 253, 500, 506, 311, 0, 0, 70, 160, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1036, 21226, 'Sepulcher Guardian', '', 'death_knight', 12.00, 31.00, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 19326, 1795, 898, 419, 613, 279, 253, 500, 506, 0, 0, 0, 27, 190, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1037, 21227, 'Sepulcher Sage', '', 'doll_master', 20.00, 42.00, 67, 'male', 'L2Monster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 21777, 2074, 975, 440, 666, 292, 253, 500, 506, 0, 0, 0, 80, 160, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1038, 21228, 'Sepulcher Guard ', '', 'skeleton_royal_guard_30_bi', 14.00, 37.50, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 20845, 2067, 1096, 471, 747, 313, 253, 0, 506, 236, 0, 0, 80, 200, 'c_dungeon_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1039, 21229, 'Sepulcher Preacher', '', 'vale_master_30_bi', 15.00, 52.00, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 22494, 2285, 1179, 491, 805, 327, 253, 500, 506, 326, 0, 0, 70, 165, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1040, 21230, 'Sepulcher Guard', '', 'death_knight', 12.00, 31.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 25729, 2714, 1304, 523, 891, 349, 253, 500, 506, 0, 0, 0, 27, 200, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1041, 21231, 'Sepulcher Preacher', '', 'doll_master_20_bi', 24.00, 50.40, 77, 'male', 'L2Monster', 'Fighter', 40, 2762, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 25727, 2784, 1388, 544, 948, 364, 253, 500, 506, 0, 0, 0, 80, 165, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1042, 21232, 'Barrow Guardian', '', 'skeleton', 11.00, 25.00, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 2085, 92, 48, 95, 33, 63, 253, 0, 506, 216, 0, 0, 60, 130, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1043, 21233, 'Barrow Seer', '', 'binding', 12.00, 21.00, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 2450, 116, 58, 103, 39, 69, 253, 500, 506, 0, 0, 0, 10, 110, 'c_dungeon_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1044, 21234, 'Grave Guardian', '', 'imp', 10.00, 24.00, 25, 'male', 'L2Monster', 'Fighter', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 3121, 156, 74, 116, 50, 78, 253, 500, 506, 0, 0, 0, 60, 130, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1045, 21235, 'Grave Seer', '', 'succubus', 10.00, 36.00, 27, 'female', 'L2Monster', 'Fighter', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 3321, 170, 87, 125, 59, 84, 253, 500, 506, 0, 0, 0, 60, 110, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1046, 21236, 'Barrow Sentinel', '', 'skeleton_bi', 11.00, 31.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 3829, 209, 111, 140, 75, 94, 253, 0, 506, 69, 0, 0, 60, 140, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1047, 21237, 'Barrow Monk', '', 'binding_20_bi', 14.00, 25.30, 32, 'male', 'L2Monster', 'Fighter', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 4443, 250, 128, 152, 87, 102, 253, 500, 506, 0, 0, 0, 10, 110, 'c_dungeon_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1048, 21238, 'Grave Sentinel', '', 'imp_bi', 10.00, 30.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 5603, 332, 160, 170, 109, 113, 253, 500, 506, 0, 0, 0, 60, 140, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1049, 21239, 'Grave Monk', '', 'succubus_bi', 10.00, 43.20, 37, 'female', 'L2Monster', 'Mystic', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 5940, 365, 185, 181, 126, 121, 253, 500, 506, 0, 0, 0, 60, 120, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1050, 21240, 'Barrow Overlord', '', 'skeleton_knight_20_bi', 12.00, 30.50, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 6807, 440, 227, 203, 155, 134, 253, 0, 506, 129, 0, 0, 40, 160, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1051, 21241, 'Barrow Priest', '', 'banshee_20_bi', 10.00, 27.50, 42, 'female', 'L2Monster', 'Priest', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 7654, 510, 259, 216, 177, 144, 253, 500, 506, 0, 0, 0, 80, 135, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1052, 21242, 'Grave Overlord', '', 'death_blader_10_sm', 14.00, 40.50, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 9263, 644, 315, 239, 214, 158, 253, 500, 506, 297, 0, 0, 100, 160, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1053, 21243, 'Grave Priest', '', 'bloody_queen_10_sm', 13.00, 38.00, 47, 'female', 'L2Monster', 'Priest', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 9585, 687, 356, 254, 243, 169, 253, 500, 506, 0, 0, 0, 80, 135, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1054, 21244, 'Crypt Archon', '', 'skeleton_knight_30_bi', 13.00, 33.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 10635, 801, 425, 278, 291, 185, 253, 0, 506, 131, 0, 0, 40, 170, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1055, 21245, 'Crypt Inquisitor', '', 'banshee_30_bi', 11.00, 30.00, 52, 'female', 'L2Monster', 'Mystic', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 11733, 908, 475, 296, 324, 196, 253, 500, 506, 0, 0, 0, 80, 145, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1056, 21246, 'Tomb Archon', '', 'death_blader_10_bi', 16.00, 49.50, 55, 'male', 'L2Monster', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 13837, 1117, 559, 323, 382, 215, 253, 500, 506, 298, 0, 0, 100, 170, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1057, 21247, 'Tomb Inquisitor', '', 'bloody_queen_10_bi', 15.00, 46.00, 57, 'female', 'L2Monster', 'Mystic', 40, 1777, 6.500, 948, 2.400, 40, 43, 30, 21, 20, 20, 14098, 1172, 619, 340, 423, 226, 253, 500, 506, 0, 0, 0, 80, 145, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1058, 21248, 'Crypt Guardian', '', 'skeleton_royal_guard_20_bi', 13.00, 34.50, 60, 'male', 'L2Monster', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 15315, 1329, 717, 370, 490, 246, 253, 0, 506, 233, 0, 0, 80, 190, 'c_dungeon_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1059, 21249, 'Crypt Sage', '', 'vale_master_10_bi', 13.00, 44.00, 62, 'male', 'L2Monster', 'Fighter', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 16680, 1486, 787, 388, 538, 258, 253, 500, 506, 311, 0, 0, 70, 160, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1060, 21250, 'Tomb Guardian', '', 'death_knight', 12.00, 31.00, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 19326, 1795, 898, 419, 613, 279, 253, 500, 506, 0, 0, 0, 27, 190, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1061, 21251, 'Tomb Sage', '', 'doll_master', 20.00, 42.00, 67, 'male', 'L2Monster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 21777, 2074, 975, 440, 666, 292, 253, 500, 506, 0, 0, 0, 80, 160, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1062, 21252, 'Crypt Guard ', '', 'skeleton_royal_guard_30_bi', 14.00, 37.50, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 20845, 2067, 1096, 471, 747, 313, 253, 0, 506, 236, 0, 0, 80, 200, 'c_dungeon_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1063, 21253, 'Crypt Preacher', '', 'vale_master_30_bi', 15.00, 52.00, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 22494, 2285, 1179, 491, 805, 327, 253, 500, 506, 326, 0, 0, 70, 165, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1064, 21254, 'Tomb Guard', '', 'death_knight', 12.00, 31.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 25729, 2714, 1304, 523, 891, 349, 253, 500, 506, 78, 0, 0, 27, 200, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1065, 21255, 'Tomb Preacher', '', 'doll_master_20_bi', 24.00, 50.40, 77, 'male', 'L2Monster', 'Fighter', 40, 2762, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 28763, 3113, 1388, 544, 948, 364, 253, 500, 506, 0, 0, 0, 80, 165, 'c_dungeon_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1066, 21256, 'Underground Werewolf', '', 'werewolf_bi', 11.00, 29.70, 23, 'male', 'L2Monster', 'Fighter', 40, 411, 3.500, 232, 1.500, 40, 43, 30, 21, 20, 20, 905, 43, 63, 108, 43, 72, 253, 400, 506, 0, 0, 0, 50, 135, '1', 600, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1067, 21257, 'Evil Eye Seer', '', 'monster_eye', 21.00, 43.00, 18, 'male', 'L2Monster', 'Mystic', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 646, 28, 41, 87, 28, 58, 253, 0, 506, 0, 0, 0, 90, 155, '1', 600, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1068, 21258, 'Fallen Orc Shaman', '', 'ketra_orc_shaman', 10.00, 23.00, 58, 'male', 'L2Monster', 'Mystic', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 651, 350, 444, 232, 253, 0, 506, 9, 0, 0, 10, 130, '', 1000, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1069, 21259, 'Fallen Orc Shaman', '', 'Saber_toothed_Tiger', 34.00, 28.00, 59, 'male', 'L2Monster', 'Fighter', 40, 1881, 6.500, 1007, 2.400, 40, 43, 30, 21, 20, 20, 15580, 1332, 684, 360, 466, 240, 253, 500, 506, 0, 0, 0, 60, 180, 'beast_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1070, 21260, 'Betrayer Orc Hero', '', 'Ketra_Orc_Warrior', 12.00, 24.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 4429, 334, 425, 278, 291, 185, 253, 0, 506, 74, 0, 0, 36, 170, '', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1071, 21261, 'Ol Mahum Transcender', '', 'ol_mahum', 13.50, 25.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 4954, 372, 425, 278, 291, 204, 253, 0, 506, 127, 0, 0, 50, 110, '', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1072, 21262, 'Ol Mahum Transcender', '', 'ol_mahum_champion', 14.00, 27.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 6631, 496, 503, 304, 344, 223, 253, 500, 506, 127, 102, 0, 50, 110, '', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1073, 21263, 'Ol Mahum Transcender', '', 'oel_mahum', 20.00, 37.00, 55, 'male', 'L2Monster', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 9634, 691, 559, 323, 382, 236, 253, 500, 506, 127, 0, 0, 70, 110, '', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1074, 21264, 'Ol Mahum Transcender', '', 'kel_mahum', 13.00, 26.00, 58, 'male', 'L2Monster', 'Fighter', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 13535, 933, 651, 350, 444, 256, 253, 500, 506, 127, 0, 0, 50, 160, '', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1075, 21265, 'Cave Ant Larva', '', 'ant_larva', 12.00, 8.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 1904, 115, 173, 176, 118, 118, 253, 0, 506, 0, 0, 0, 40, 60, 'ant_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1076, 21266, 'Cave Ant Larva', '', 'ant_larva', 12.00, 8.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 173, 176, 118, 118, 253, 0, 506, 0, 0, 0, 40, 60, 'ant_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1077, 21267, 'Cave Ant Larva', '', 'ant_larva', 12.00, 8.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 173, 176, 118, 118, 253, 0, 506, 0, 0, 0, 40, 60, 'ant_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1078, 21268, 'Cave Ant Larva', '', 'ant_larva', 12.00, 8.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 3541, 214, 173, 176, 118, 118, 253, 0, 506, 0, 0, 0, 40, 60, 'ant_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1079, 21269, 'Cave Ant', '', 'ant', 26.00, 15.00, 37, 'male', 'L2Monster', 'Fighter', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 4042, 248, 185, 181, 126, 121, 253, 500, 506, 0, 0, 0, 40, 130, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1080, 21270, 'Cave Ant Soldier', '', 'ant_soldier', 35.00, 17.00, 38, 'male', 'L2Monster', 'Fighter', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 4670, 292, 198, 188, 136, 126, 253, 500, 506, 0, 0, 0, 80, 130, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1081, 21271, 'Cave Ant', '', 'ant', 26.00, 15.00, 37, 'male', 'L2Monster', 'Fighter', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 2758, 169, 185, 181, 126, 121, 253, 500, 506, 0, 0, 0, 40, 130, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1082, 21272, 'Cave Ant Soldier', '', 'ant_soldier', 35.00, 17.00, 38, 'male', 'L2Monster', 'Fighter', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 4902, 306, 198, 188, 136, 126, 253, 500, 506, 0, 0, 0, 80, 130, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1083, 21273, 'Cave Noble Ant', '', 'noble_ant', 20.00, 48.00, 39, 'male', 'L2Monster', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 14204, 902, 212, 195, 145, 131, 253, 500, 506, 0, 0, 0, 80, 174, 'ant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1084, 21274, 'Kookaburra', '', 'youth_ostrich', 8.00, 26.40, 67, 'male', 'L2Monster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 8972, 854, 975, 440, 666, 321, 253, 0, 506, 0, 0, 0, 23, 190, 'animal_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1085, 21275, 'Kookaburra', '', 'youth_ostrich', 8.00, 26.40, 67, 'male', 'L2Monster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 9030, 859, 975, 440, 666, 321, 253, 0, 506, 0, 0, 0, 23, 190, 'animal_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1086, 21276, 'Kookaburra', '', 'youth_ostrich', 8.00, 26.40, 67, 'male', 'L2Monster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 8921, 848, 975, 440, 666, 321, 253, 0, 506, 0, 0, 0, 23, 190, 'animal_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1087, 21278, 'Antelope', '', 'antelope', 17.00, 34.00, 68, 'male', 'L2Monster', 'Fighter', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 9242, 892, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 45, 185, 'antelope_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1088, 21279, 'Antelope', '', 'antelope', 17.00, 34.00, 68, 'male', 'L2Monster', 'Fighter', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 9189, 887, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 45, 185, 'antelope_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1089, 21280, 'Antelope', '', 'antelope', 17.00, 34.00, 68, 'male', 'L2Monster', 'Mystic', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 9302, 898, 1014, 449, 692, 330, 253, 0, 506, 0, 0, 0, 45, 185, 'antelope_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1090, 21282, 'Bandersnatch', '', 'bandersnatch', 18.00, 25.00, 69, 'male', 'L2Monster', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 9516, 930, 1055, 460, 720, 337, 253, 150, 506, 0, 0, 0, 30, 170, 'bandersnatch_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1091, 21283, 'Bandersnatch', '', 'bandersnatch', 18.00, 25.00, 69, 'male', 'L2Monster', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 9578, 936, 1055, 460, 720, 337, 253, 150, 506, 0, 0, 0, 30, 170, 'bandersnatch_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1092, 21284, 'Bandersnatch', '', 'bandersnatch', 18.00, 25.00, 69, 'male', 'L2Monster', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 9461, 925, 1055, 460, 720, 337, 253, 150, 506, 0, 0, 0, 30, 170, 'bandersnatch_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1093, 21286, 'Buffalo', '', 'buffalo', 22.00, 31.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 9794, 971, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 170, 'buffalo_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1094, 21287, 'Buffalo', '', 'buffalo', 22.00, 31.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 9737, 965, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 170, 'buffalo_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1095, 21288, 'Buffalo', '', 'buffalo', 22.00, 31.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 9857, 977, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 170, 'buffalo_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1096, 21290, 'Grendel', '', 'bionic_bear', 15.00, 39.00, 71, 'male', 'L2Monster', 'Fighter', 40, 2493, 8.500, 1378, 3.000, 40, 43, 30, 21, 20, 20, 10076, 1010, 1136, 482, 776, 352, 253, 150, 506, 0, 0, 0, 36, 155, 'grendel_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1097, 21291, 'Grendel', '', 'bionic_bear', 15.00, 39.00, 71, 'male', 'L2Monster', 'Fighter', 40, 2493, 8.500, 1378, 3.000, 40, 43, 30, 21, 20, 20, 10017, 1004, 1136, 482, 776, 352, 253, 150, 506, 0, 0, 0, 36, 155, 'grendel_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1098, 21292, 'Grendel', '', 'bionic_bear', 15.00, 39.00, 71, 'male', 'L2Monster', 'Fighter', 40, 2493, 8.500, 1378, 3.000, 40, 43, 30, 21, 20, 20, 10141, 1016, 1136, 482, 776, 352, 253, 150, 506, 0, 0, 0, 36, 155, 'grendel_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1099, 21294, 'Canyon Antelope', '', 'antelope', 17.00, 34.00, 68, 'male', 'L2Monster', 'Fighter', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 16544, 1598, 1014, 449, 692, 300, 253, 0, 506, 0, 0, 0, 45, 185, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1100, 21295, 'Canyon Antelope Slave', '', 'antelope', 17.00, 34.00, 69, 'male', 'L2Monster', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 17547, 1717, 1055, 460, 720, 307, 253, 150, 506, 0, 0, 0, 45, 165, 'eye_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1101, 21296, 'Canyon Bandersnatch ', '', 'bandersnatch', 18.00, 25.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 26081, 2586, 1096, 471, 747, 313, 253, 150, 506, 0, 0, 0, 30, 180, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1102, 21297, 'Canyon Bandersnatch Slave', '', 'bandersnatch', 18.00, 25.00, 71, 'male', 'L2Monster', 'Fighter', 40, 2493, 8.500, 1378, 3.000, 40, 43, 30, 21, 20, 20, 26191, 2628, 1136, 482, 776, 320, 253, 150, 506, 0, 0, 0, 30, 170, 'eye_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1103, 21298, 'Eye of Restrainer ', '', 'monster_eye', 21.00, 43.00, 71, 'male', 'L2Monster', 'Mystic', 40, 2493, 8.500, 1378, 3.000, 40, 43, 30, 21, 20, 20, 16857, 1692, 1136, 482, 776, 320, 253, 150, 506, 0, 0, 0, 90, 140, 'eye_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1104, 21299, 'Buffalo Slave', '', 'buffalo_ec', 22.00, 31.00, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 26934, 2736, 1179, 491, 805, 327, 253, 150, 506, 0, 0, 0, 20, 160, 'eye_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1105, 21300, 'Eye of Guide', '', 'parasitic_eye_20_sm', 20.00, 50.50, 72, 'male', 'L2Monster', 'Mystic', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 26498, 2692, 1179, 491, 805, 327, 253, 0, 506, 0, 0, 0, 30, 155, 'eye_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1106, 21301, 'Gaze of Nightmare', '', 'field_stalker', 15.00, 30.00, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 31797, 3230, 1179, 491, 805, 327, 253, 0, 506, 0, 0, 0, 70, 195, 'eye_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1107, 21302, 'Eye of Watchman', '', 'parasitic_eye', 25.00, 63.00, 73, 'male', 'L2Monster', 'Mystic', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 25580, 2632, 1220, 502, 833, 334, 253, 150, 506, 0, 0, 0, 30, 160, 'eye_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1108, 21303, 'Homunculus', '', 'homunculus_20_sm', 10.00, 26.00, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 25867, 2662, 1220, 502, 833, 334, 253, 150, 506, 0, 0, 0, 30, 185, 'eye_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1109, 21304, 'Grendel Slave', '', 'bionic_bear', 15.00, 39.00, 74, 'male', 'L2Monster', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 38011, 3962, 1262, 513, 861, 342, 253, 150, 506, 0, 0, 0, 36, 140, 'eye_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1110, 21305, 'Eye of Pilgrim', '', 'parasitic_eye_20_sm', 20.00, 50.50, 74, 'male', 'L2Monster', 'Mystic', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 27990, 2917, 1262, 513, 861, 342, 253, 0, 506, 0, 0, 0, 30, 165, 'eye_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1111, 21306, 'Disciples of Protection', '', 'apostle_warrior', 8.00, 30.00, 74, 'female', 'L2Monster', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 50649, 5280, 1262, 513, 861, 342, 253, 150, 506, 6717, 0, 0, 50, 160, 'divine_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1112, 21307, 'Elder Homunculus', '', 'homunculus', 12.00, 32.50, 75, 'male', 'L2Monster', 'Mystic', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 35496, 3744, 1304, 523, 891, 349, 253, 150, 506, 0, 0, 0, 30, 200, 'eye_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1113, 21308, 'Disciples of Punishment', '', 'apostle_warrior', 8.00, 30.00, 75, 'female', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 47163, 4975, 1304, 523, 891, 349, 253, 150, 506, 6717, 0, 0, 50, 190, 'divine_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1114, 21309, 'Disciples of Punishment', '', 'apostle_warrior', 8.00, 30.00, 75, 'female', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 49155, 5185, 1304, 523, 891, 349, 253, 150, 506, 6717, 0, 0, 50, 190, 'divine_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1115, 21310, 'Disciples of Authority', '', 'apostle_mage', 11.00, 38.50, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 40357, 4315, 1345, 535, 919, 356, 253, 150, 506, 6718, 0, 0, 50, 155, 'divine_clan', 600, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1116, 21311, 'Disciples of Authority', '', 'apostle_mage', 11.00, 38.50, 76, 'male', 'L2Monster', 'Mystic', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 37210, 3978, 1345, 535, 919, 356, 253, 150, 506, 6718, 0, 0, 50, 155, 'divine_clan', 600, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1117, 21312, 'Eye of Ruler', '', 'parasitic_eye', 25.00, 63.00, 74, 'male', 'L2Monster', 'Mystic', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 38709, 4036, 1262, 513, 861, 342, 253, 150, 506, 0, 0, 0, 30, 160, 'eye_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1118, 21313, 'Sly Hound Dog', '', 'bandersnatch', 18.00, 25.00, 72, 'male', 'L2Minion', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 37061, 3766, 1179, 491, 805, 327, 253, 0, 506, 0, 0, 0, 30, 185, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1119, 21314, 'Hot Springs Bandersnatchling', '', 'bandersnatch', 18.00, 25.00, 73, 'male', 'L2Monster', 'HotSpringsMob', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 20662, 2126, 1220, 502, 833, 334, 253, 150, 506, 0, 0, 0, 30, 170, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1120, 21315, 'Hot Springs Buffalo', '', 'buffalo', 22.00, 31.00, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 21532, 2215, 1220, 502, 833, 334, 253, 0, 506, 0, 0, 0, 20, 170, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1121, 21316, 'Hot Springs Flava', '', 'flava', 18.00, 34.00, 74, 'male', 'L2Monster', 'HotSpringsMob', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 25336, 2641, 1262, 513, 861, 342, 253, 150, 506, 0, 0, 0, 30, 165, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1122, 21317, 'Hot Springs Atroxspawn', '', 'kailiharim', 45.00, 39.00, 74, 'male', 'L2Monster', 'HotSpringsMob', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 21232, 2213, 1262, 513, 861, 342, 253, 150, 506, 0, 0, 0, 105, 175, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1123, 21318, 'Hot Springs Antelope', '', 'antelope', 17.00, 34.00, 74, 'male', 'L2Monster', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 22193, 2314, 1262, 513, 861, 342, 253, 0, 506, 0, 0, 0, 45, 185, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1124, 21319, 'Hot Springs Nepenthes', '', 'nephenthes', 28.00, 43.50, 75, 'male', 'L2Monster', 'HotSpringsMob', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 27928, 2946, 1304, 523, 891, 349, 253, 150, 506, 0, 0, 0, 48, 170, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1125, 21320, 'Hot Springs Yeti', '', 'yeti_20_bi', 18.00, 32.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 22728, 2398, 1304, 523, 891, 349, 253, 0, 506, 0, 0, 0, 16, 170, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1126, 21321, 'Hot Springs Atrox', '', 'kailiharim', 45.00, 39.00, 76, 'male', 'L2Monster', 'HotSpringsMob', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 22270, 2381, 1345, 535, 919, 356, 253, 150, 506, 0, 0, 0, 105, 175, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1127, 21322, 'Hot Springs Bandersnatch', '', 'bandersnatch', 18.00, 25.00, 76, 'male', 'L2Monster', 'HotSpringsMob', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 22270, 2381, 1345, 535, 919, 356, 253, 150, 506, 0, 0, 0, 30, 170, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1128, 21323, 'Hot Springs Grendel', '', 'bionic_bear', 15.00, 39.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 19507, 2085, 1345, 535, 919, 356, 253, 0, 506, 0, 0, 0, 36, 165, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1129, 21324, 'Ketra Orc Footman', '', 'ketra_orc', 12.00, 29.00, 77, 'male', 'L2Monster', 'Fighter', 40, 2762, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 18647, 2018, 1388, 544, 948, 364, 253, 150, 506, 79, 0, 0, 45, 175, 'ketra_orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1130, 21325, 'Ketras War Hound', '', 'bandersnatch', 18.00, 25.00, 77, 'male', 'L2Monster', 'Fighter', 40, 2762, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 18031, 1951, 1388, 544, 948, 364, 253, 150, 506, 0, 0, 0, 30, 185, 'ketra_orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1131, 21326, 'Grazing Kookaburra', '', 'youth_ostrich', 8.00, 26.40, 77, 'male', 'L2Monster', 'Fighter', 40, 2762, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 18031, 1951, 1388, 544, 948, 364, 253, 150, 506, 0, 0, 0, 23, 190, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1132, 21327, 'Ketra Orc Raider', '', 'ketra_orc_warrior', 12.00, 24.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 20480, 2241, 1430, 556, 975, 371, 253, 150, 506, 79, 6919, 0, 36, 175, 'ketra_orc_clan', 300, 0, 20, 166, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1133, 21328, 'Ketra Orc Scout', '', 'ketra_orc_archer', 12.00, 27.00, 78, 'male', 'L2Monster', 'Ranger', 1100, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 19634, 2149, 1430, 556, 975, 371, 253, 150, 506, 288, 0, 0, 45, 175, 'ketra_orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.91, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1134, 21329, 'Ketra Orc Shaman', '', 'ketra_orc_shaman', 10.00, 23.00, 78, 'male', 'L2Monster', 'Priest', 40, 2871, 8.585, 1657, 3.030, 40, 43, 30, 21, 20, 20, 19912, 2207, 1476, 568, 1019, 379, 253, 150, 506, 92, 0, 0, 10, 150, 'ketra_orc_clan', 300, 0, 0, 0, 7, 50, 1, 10, 0, 1, 0.34, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1135, 21330, 'Grazing Buffalo', '', 'buffalo', 22.00, 31.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2871, 8.585, 1657, 3.030, 40, 43, 30, 21, 20, 20, 18980, 2103, 1476, 568, 1019, 379, 253, 150, 506, 0, 0, 0, 20, 165, '1', 300, 0, 0, 0, 7, 50, 1, 10, 0, 1, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1136, 21331, 'Ketra Orc Warrior', '', 'ketra_orc_warrior', 12.00, 24.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 18609, 2089, 1525, 581, 1062, 387, 253, 150, 506, 79, 6919, 0, 36, 175, 'ketra_orc_clan', 300, 0, 20, 171, 7, 30, 4, 7, 0, 2, 0.54, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1137, 21332, 'Ketra Orc Lieutenant', '', 'ketra_orc_chieftain', 11.00, 38.50, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 20841, 2339, 1525, 581, 1062, 387, 253, 150, 506, 6719, 0, 0, 24, 175, 'ketra_orc_clan', 300, 0, 0, 0, 7, 50, 1, 11, 0, 2, 0.51, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1138, 21333, 'Grazing Windsus', '', 'giant_wild_hog', 35.00, 27.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 19953, 2266, 1566, 593, 1097, 399, 253, 150, 506, 0, 0, 0, 35, 170, '1', 300, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1139, 21334, 'Ketra Orc Medium', '', 'ketra_orc_shaman', 10.00, 23.00, 78, 'male', 'L2Monster', 'Priest', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 29867, 3391, 1566, 593, 1097, 399, 253, 150, 506, 92, 0, 0, 10, 150, 'ketra_orc_clan', 300, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.34, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1140, 21335, 'Ketra Orc Elite Soldier', '', 'ketra_orc', 12.00, 29.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 19252, 2212, 1607, 603, 1132, 411, 253, 150, 506, 79, 0, 0, 45, 175, 'ketra_orc_clan', 300, 0, 0, 0, 7, 30, 4, 9, 0, 4, 0.46, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1141, 21336, 'Ketra Orc White Captain', '', 'ketra_orc_overload_20_bi', 14.00, 28.80, 78, 'male', 'L2Monster', 'Fighter', 40, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 22635, 2600, 1607, 603, 1132, 411, 253, 150, 506, 80, 0, 0, 33, 175, 'ketra_orc_clan', 300, 0, 0, 0, 7, 30, 4, 9, 0, 4, 0.48, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1142, 21337, 'Grazing Elder Buffalo', '', 'buffalo', 22.00, 31.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 20950, 2435, 1647, 613, 1167, 424, 253, 150, 506, 0, 0, 0, 20, 165, '1', 300, 0, 0, 0, 7, 50, 1, 14, 0, 5, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1143, 21338, 'Ketra Orc Seer', '', 'ketra_orc_shaman', 10.00, 23.00, 78, 'male', 'L2Monster', 'Priest', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 27568, 3205, 1647, 613, 1167, 424, 253, 150, 506, 213, 0, 0, 10, 160, 'ketra_orc_clan', 300, 0, 0, 0, 7, 30, 4, 10, 0, 5, 0.34, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1144, 21339, 'Ketra Orc General', '', 'ketra_orc_chieftain_20_bi', 17.00, 46.20, 78, 'male', 'L2Monster', 'Fighter', 40, 3077, 8.874, 1848, 3.131, 40, 43, 30, 21, 20, 20, 20989, 2469, 1685, 625, 1202, 436, 253, 150, 506, 6719, 0, 0, 24, 175, 'ketra_orc_clan', 300, 0, 0, 0, 7, 50, 1, 15, 0, 2, 0.51, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1145, 21340, 'Ketra Orc Battalion Commander', '', 'ketra_orc_warlord', 12.00, 30.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3077, 8.874, 1848, 3.131, 40, 43, 30, 21, 20, 20, 20989, 2469, 1685, 625, 1202, 436, 253, 150, 506, 80, 6919, 0, 27, 175, 'ketra_orc_clan', 300, 0, 20, 179, 7, 30, 4, 11, 0, 2, 0.48, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1146, 21341, 'Grazing Elder Kookaburra', '', 'youth_ostrich', 8.00, 26.40, 78, 'male', 'L2Monster', 'Fighter', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 21972, 2615, 1725, 635, 1237, 448, 253, 150, 506, 0, 0, 0, 23, 190, '1', 300, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1147, 21342, 'Ketra Orc Grand Seer', '', 'ketra_orc_shaman', 10.00, 23.00, 78, 'male', 'L2Monster', 'Priest', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 28912, 3441, 1725, 635, 1237, 448, 253, 150, 506, 213, 0, 0, 10, 160, 'ketra_orc_clan', 300, 0, 0, 0, 7, 50, 1, 16, 0, 7, 0.34, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1148, 21343, 'Ketra Commander', '', 'ketra_orc_warlord_20_bi', 15.00, 36.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 32801, 3725, 1566, 593, 1097, 399, 253, 150, 506, 80, 6919, 0, 27, 175, 'ketra_orc_clan', 300, 0, 20, 173, 7, 10, 8, 3, 0, 3, 0.48, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1149, 21344, 'Ketra Elite Guard', '', 'ketra_orc_overload', 12.00, 24.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 22276, 2500, 1525, 581, 1062, 387, 253, 0, 506, 80, 0, 0, 33, 180, 'ketra_orc_clan', 300, 0, 0, 0, 7, 30, 4, 7, 0, 2, 0.48, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (1150, 21345, 'Ketras Head Shaman', '', 'ketra_orc_shaman', 10.00, 23.00, 78, 'male', 'L2Monster', 'Priest', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 24720, 2943, 1725, 635, 1237, 448, 253, 150, 506, 210, 0, 0, 10, 175, 'ketra_orc_clan', 300, 0, 0, 0, 7, 50, 1, 16, 0, 7, 0.34, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1151, 21346, 'Ketras Head Guard', '', 'ketra_orc_chieftain', 11.00, 38.50, 78, 'male', 'L2Minion', 'Fighter', 40, 3077, 8.874, 1848, 3.131, 40, 43, 30, 21, 20, 20, 24560, 2889, 1685, 625, 1202, 436, 253, 0, 506, 6719, 0, 0, 24, 175, 'ketra_orc_clan', 300, 0, 0, 0, 7, 50, 1, 15, 0, 2, 0.51, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1152, 21347, 'Ketra Prophet', '', 'ketra_orc_shaman', 10.00, 23.00, 78, 'male', 'L2Monster', 'Priest', 40, 3163, 9.027, 1955, 3.182, 40, 43, 30, 21, 20, 20, 37558, 4578, 1799, 686, 1304, 494, 253, 150, 506, 213, 0, 0, 10, 175, 'ketra_orc_clan', 300, 0, 0, 0, 7, 50, 1, 18, 0, 9, 0.34, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1153, 21348, 'Prophets Guard', '', 'ketra_orc_chieftain', 11.00, 38.50, 78, 'male', 'L2Minion', 'Fighter', 40, 3136, 8.976, 1919, 3.168, 40, 43, 30, 21, 20, 20, 25743, 3101, 1762, 646, 1271, 461, 253, 0, 506, 6719, 0, 0, 24, 180, 'ketra_orc_clan', 300, 0, 0, 0, 7, 50, 1, 17, 0, 8, 0.51, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1154, 21349, 'Prophets Aide', '', 'ketra_orc_shaman', 10.00, 23.00, 78, 'male', 'L2Minion', 'Priest', 40, 3136, 8.976, 1919, 3.168, 40, 43, 30, 21, 20, 20, 26143, 3149, 1762, 646, 1271, 461, 253, 0, 506, 210, 0, 0, 10, 180, 'ketra_orc_clan', 300, 0, 0, 0, 7, 50, 1, 17, 0, 8, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1155, 21350, 'Varka Silenos Recruit', '', 'barka_silenos_hunter', 16.00, 38.00, 77, 'male', 'L2Monster', 'Fighter', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 21105, 2186, 1421, 544, 971, 398, 253, 150, 506, 2504, 6918, 0, 44, 175, 'varka_silenos_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1156, 21351, 'Varka Silenos Footman', '', 'barka_silenos_warrior', 16.00, 41.00, 77, 'male', 'L2Monster', 'Fighter', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 18501, 1904, 1421, 544, 971, 398, 253, 150, 506, 2504, 6918, 0, 34, 175, 'varka_silenos_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1157, 21352, 'Grazing Antelope', '', 'antelope', 17.00, 34.00, 77, 'male', 'L2Monster', 'Fighter', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 11091, 1200, 1421, 544, 971, 398, 253, 0, 506, 0, 0, 0, 45, 185, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1158, 21353, 'Varka Silenos Scout', '', 'barka_silenos_hunter', 16.00, 38.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 25065, 2642, 1488, 556, 1015, 406, 253, 150, 506, 142, 6918, 0, 44, 175, 'varka_silenos_clan', 300, 0, 20, 166, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1159, 21354, 'Varka Silenos Hunter', '', 'barka_silenos_archer', 8.00, 37.50, 78, 'male', 'L2Monster', 'Ranger', 1100, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 24846, 2618, 1488, 556, 1015, 406, 253, 150, 506, 6917, 0, 0, 30, 175, 'varka_silenos_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.59, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1160, 21355, 'Varka Silenos Shaman', '', 'barka_silenos_shaman', 14.00, 39.50, 78, 'male', 'L2Monster', 'Priest', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 24583, 2580, 1488, 556, 1015, 406, 253, 150, 506, 6716, 0, 0, 36, 150, 'varka_silenos_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.49, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1161, 21356, 'Grazing Nepenthes', '', 'nephenthes', 28.00, 43.50, 78, 'male', 'L2Monster', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 15612, 1708, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 48, 150, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.47, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1162, 21357, 'Varka Silenos Priest', '', 'barka_silenos_priest', 9.00, 41.50, 78, 'male', 'L2Monster', 'Mystic', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 25424, 2681, 1488, 556, 1015, 406, 253, 150, 506, 6716, 0, 0, 36, 180, 'varka_silenos_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1163, 21358, 'Varka Silenos Warrior', '', 'barka_silenos_warrior', 16.00, 41.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 25564, 2696, 1488, 556, 1015, 406, 253, 150, 506, 142, 6918, 0, 34, 175, 'varka_silenos_clan', 300, 0, 20, 171, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1164, 21359, 'Grazing Bandersnatch', '', 'bandersnatch', 18.00, 25.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 15761, 1724, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 30, 170, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1165, 21360, 'Varka Silenos Medium', '', 'barka_silenos_shaman', 14.00, 39.50, 78, 'male', 'L2Monster', 'Priest', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 33108, 3490, 1488, 556, 1015, 406, 253, 150, 506, 6716, 0, 0, 36, 150, 'varka_silenos_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.49, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1166, 21361, 'Varka Silenos Magus', '', 'barka_silenos_mage_20_bi', 11.00, 55.20, 78, 'male', 'L2Monster', 'Mystic', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 23322, 2452, 1488, 556, 1015, 406, 253, 150, 506, 6716, 0, 0, 36, 175, 'varka_silenos_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1167, 21362, 'Varka Silenos Officer', '', 'barka_silenos_chieftain', 18.00, 42.50, 78, 'male', 'L2Monster', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 25564, 2696, 1488, 556, 1015, 406, 253, 150, 506, 2504, 0, 0, 25, 175, 'varka_silenos_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1168, 21363, 'Grazing Flava', '', 'flava', 18.00, 34.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 23952, 2522, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 30, 165, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1169, 21364, 'Varka Silenos Seer', '', 'barka_silenos_shaman', 14.00, 39.50, 78, 'male', 'L2Monster', 'Priest', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 18179, 1988, 1488, 556, 1015, 406, 253, 150, 506, 6716, 0, 0, 36, 150, 'varka_silenos_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.49, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1170, 21365, 'Varka Silenos Great Magus', '', 'barka_silenos_warrior_20_bi', 20.00, 49.20, 78, 'male', 'L2Monster', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 25065, 2642, 1488, 556, 1015, 406, 253, 150, 506, 2500, 0, 0, 34, 175, 'varka_silenos_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1171, 21366, 'Varka Silenos General', '', 'barka_silenos_chieftain', 18.00, 42.50, 78, 'male', 'L2Monster', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 27045, 2858, 1488, 556, 1015, 406, 253, 150, 506, 2500, 0, 0, 25, 175, 'varka_silenos_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1172, 21367, 'Grazing Elder Antelope', '', 'antelope', 17.00, 34.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 15761, 1724, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 45, 185, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1173, 21368, 'Varka Silenos Great Seer', '', 'barka_silenos_shaman', 14.00, 39.50, 78, 'male', 'L2Monster', 'Priest', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 32232, 3394, 1488, 556, 1015, 406, 253, 150, 506, 6716, 0, 0, 36, 150, 'varka_silenos_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.49, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1174, 21369, 'Varkas Commander', '', 'barka_silenos_chieftain_20_bi', 22.00, 51.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 31469, 3310, 1488, 556, 1015, 406, 253, 150, 506, 2500, 0, 0, 25, 175, 'varka_silenos_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1175, 21370, 'Varkas Elite Guard', '', 'barka_silenos_warrior', 16.00, 41.00, 78, 'male', 'L2Minion', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 26151, 2761, 1488, 556, 1015, 406, 253, 0, 506, 2500, 6918, 0, 34, 175, 'varka_silenos_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1176, 21371, 'Varkas Head Magus', '', 'barka_silenos_shaman', 14.00, 39.50, 78, 'male', 'L2Monster', 'Priest', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 24846, 2618, 1488, 556, 1015, 406, 253, 150, 506, 6716, 0, 0, 36, 150, 'varka_silenos_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.49, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1177, 21372, 'Varkas Head Guard', '', 'barka_silenos_hunter', 16.00, 38.00, 78, 'male', 'L2Minion', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 16812, 1840, 1488, 556, 1015, 406, 253, 0, 506, 2500, 6918, 0, 44, 175, 'varka_silenos_clan', 300, 0, 20, 179, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (1178, 21373, 'Varkas Prophet', '', 'barka_silenos_shaman_20_bi', 17.00, 47.50, 78, 'male', 'L2Monster', 'Priest', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 32074, 3370, 1488, 556, 1015, 406, 253, 150, 506, 6716, 0, 0, 36, 150, 'varka_silenos_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.54, 'false', 'SOUL_BSPIRIT', 1, 0);
INSERT INTO `npc` VALUES (1179, 21374, 'Prophet Guard', '', 'barka_silenos_warrior', 16.00, 41.00, 78, 'male', 'L2Minion', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 16952, 1855, 1488, 556, 1015, 406, 253, 0, 506, 2500, 6918, 0, 34, 175, 'varka_silenos_clan', 300, 0, 20, 183, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1180, 21375, 'Disciple of Prophet', '', 'barka_silenos_priest', 9.00, 41.50, 78, 'male', 'L2Minion', 'Priest', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 16339, 1788, 1488, 556, 1015, 406, 253, 0, 506, 6716, 0, 0, 36, 180, 'varka_silenos_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1181, 21376, 'Scarlet Stakato Worker', '', 'blade_stakato_worker', 13.00, 40.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 35275, 3860, 1430, 556, 975, 371, 253, 150, 506, 235, 0, 0, 25, 130, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1182, 21377, 'Scarlet Stakato Soldier', '', 'blade_stakato_soldier', 15.00, 38.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 34523, 3778, 1430, 556, 975, 371, 253, 150, 506, 148, 0, 0, 25, 180, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1183, 21378, 'Scarlet Stakato Noble', '', 'blade_stakato_drone', 15.00, 39.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2871, 8.585, 1657, 3.030, 40, 43, 30, 21, 20, 20, 49148, 5447, 1476, 568, 1019, 379, 253, 150, 506, 235, 0, 0, 25, 180, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 6, 0, 1, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1184, 21379, 'Tepra Scorpion', '', 'scorpion_20_sm', 24.00, 52.80, 78, 'male', 'L2Monster', 'Fighter', 40, 2871, 8.585, 1657, 3.030, 40, 43, 30, 21, 20, 20, 35491, 3933, 1476, 568, 1019, 379, 253, 150, 506, 0, 0, 0, 37, 125, 'fire_clan', 300, 0, 0, 0, 7, 10, 8, 1, 0, 1, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1185, 21380, 'Tepra Scarab', '', 'scarab', 14.00, 22.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2871, 8.585, 1657, 3.030, 40, 43, 30, 21, 20, 20, 36185, 4010, 1476, 568, 1019, 379, 253, 150, 506, 0, 0, 0, 45, 175, 'fire_clan', 300, 0, 0, 0, 7, 50, 1, 10, 0, 1, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1186, 21381, 'Assassin Beetle', '', 'tera_beetle', 19.00, 54.50, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 42075, 4722, 1525, 581, 1062, 387, 253, 150, 506, 0, 0, 0, 45, 145, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 7, 0, 2, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1187, 21382, 'Mercenary of Destruction', '', 'skeleton_knight', 10.00, 25.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 51904, 5826, 1525, 581, 1062, 387, 253, 150, 506, 150, 103, 0, 40, 165, 'fire_clan', 300, 0, 20, 171, 7, 30, 4, 7, 0, 2, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1188, 21383, 'Knight of Destruction', '', 'skeleton_royal_guard', 11.00, 28.50, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 51983, 5835, 1525, 581, 1062, 387, 253, 150, 506, 946, 945, 0, 80, 185, 'fire_clan', 300, 0, 20, 171, 7, 30, 4, 7, 0, 2, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1189, 21384, 'Necromancer of Destruction', '', 'vale_master_20_bi', 14.50, 48.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 44576, 5062, 1566, 593, 1097, 399, 253, 150, 506, 0, 0, 0, 70, 145, 'fire_clan', 300, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1190, 21385, 'Lavastone Golem', '', 'stone_golem', 20.00, 31.00, 78, 'male', 'L2Monster', 'Mystic', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 42930, 4875, 1566, 593, 1097, 399, 253, 150, 506, 0, 0, 0, 23, 40, 'fire_clan', 300, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1191, 21386, 'Magma Golem', '', 'lava_golem', 22.00, 45.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 45872, 5209, 1566, 593, 1097, 399, 253, 150, 506, 0, 0, 0, 13, 60, 'fire_clan', 300, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1192, 21387, 'Arimanes of Destruction', '', 'ahrimanes', 14.00, 57.75, 78, 'male', 'L2Monster', 'Mystic', 40, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 36575, 4202, 1607, 603, 1132, 411, 253, 150, 506, 6722, 0, 0, 35, 185, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 9, 0, 4, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1193, 21388, 'Iblis of Destruction', '', 'fiend_archer', 17.00, 55.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 55327, 6356, 1607, 603, 1132, 411, 253, 150, 506, 0, 0, 0, 70, 150, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 9, 0, 4, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1194, 21389, 'Balrog of Destruction', '', 'kaim_vanul', 24.00, 40.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 59328, 6897, 1647, 613, 1167, 424, 253, 150, 506, 0, 0, 0, 37, 155, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 10, 0, 5, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1195, 21390, 'Ashuras of Destruction', '', 'ashuras_30_bi', 17.00, 49.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3077, 8.874, 1848, 3.131, 40, 43, 30, 21, 20, 20, 68450, 8052, 1685, 625, 1202, 436, 253, 150, 506, 0, 0, 0, 41, 190, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 11, 0, 2, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1196, 21391, 'Lavasillisk', '', 'lesser_basilisk', 34.00, 25.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 47322, 5501, 1647, 613, 1167, 424, 253, 150, 506, 0, 0, 0, 35, 140, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 10, 0, 5, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1197, 21392, 'Blazing Ifrit', '', 'ifrit_30_bi', 13.00, 55.00, 78, 'male', 'L2Monster', 'Mystic', 40, 3077, 8.874, 1848, 3.131, 40, 43, 30, 21, 20, 20, 67509, 7941, 1685, 625, 1202, 436, 253, 150, 506, 0, 0, 0, 38, 150, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 11, 0, 2, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1198, 21393, 'Magma Drake', '', 'inferno_drake_20_bi', 29.00, 42.00, 78, 'male', 'L2Monster', 'Mystic', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 56964, 6780, 1725, 635, 1237, 448, 253, 150, 506, 0, 0, 0, 57, 195, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1199, 21394, 'Lavasaurus', '', 'magmagoil', 15.00, 75.00, 78, 'male', 'L2SpecialMonster', 'PaganGuard', 1100, 2871, 8.585, 1657, 3.030, 40, 43, 30, 21, 20, 20, 44944, 4981, 1476, 568, 1019, 379, 253, 500, 506, 0, 0, 0, 1, 1, 'fire_clan', 300, 0, 0, 0, 7, 10, 8, 1, 1500, 1, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1200, 21395, 'Elder Lavasaurus', '', 'magmagoil_lad', 15.00, 75.00, 78, 'male', 'L2SpecialMonster', 'PaganGuard', 1100, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 58564, 6808, 1647, 613, 1167, 424, 253, 500, 506, 0, 0, 0, 1, 1, 'fire_clan', 300, 0, 0, 0, 7, 10, 8, 5, 1500, 5, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1201, 21396, 'Carrion Scarab', '', 'scarab', 14.00, 22.00, 78, 'male', 'L2Monster', 'CarrionScarab', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 24549, 2687, 1430, 556, 975, 371, 253, 0, 506, 0, 0, 0, 45, 130, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1202, 21397, 'Carrion Scarab', '', 'scarab', 14.00, 22.00, 78, 'male', 'L2Monster', 'CarrionScarab', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 21310, 2332, 1430, 556, 975, 371, 253, 0, 506, 0, 0, 0, 45, 130, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1203, 21398, 'Soldier Scarab', '', 'scarab', 14.00, 22.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 40465, 4428, 1430, 556, 975, 371, 253, 150, 506, 0, 0, 0, 45, 180, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1204, 21399, 'Soldier Scarab', '', 'scarab', 14.00, 22.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 38680, 4233, 1430, 556, 975, 371, 253, 150, 506, 0, 0, 0, 45, 180, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1205, 21400, 'Hexa Beetle', '', 'tera_beetle', 25.00, 54.50, 78, 'male', 'L2Monster', 'Fighter', 40, 2871, 8.585, 1657, 3.030, 40, 43, 30, 21, 20, 20, 33055, 3663, 1476, 568, 1019, 379, 253, 0, 506, 0, 0, 0, 45, 145, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 6, 0, 1, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1206, 21401, 'Hexa Beetle', '', 'tera_beetle', 25.00, 54.50, 78, 'male', 'L2Monster', 'Fighter', 40, 2871, 8.585, 1657, 3.030, 40, 43, 30, 21, 20, 20, 29087, 3224, 1476, 568, 1019, 379, 253, 150, 506, 0, 0, 0, 45, 145, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 6, 0, 1, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1207, 21402, 'Katraxis', '', 'scorpion_20_sm', 24.00, 52.80, 78, 'male', 'L2Monster', 'Fighter', 40, 2871, 8.585, 1657, 3.030, 40, 43, 30, 21, 20, 20, 30013, 3326, 1476, 568, 1019, 379, 253, 150, 506, 0, 0, 0, 37, 165, 'tomb_clan', 300, 0, 0, 0, 7, 10, 8, 1, 0, 1, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1208, 21403, 'Katraxis', '', 'scorpion_20_sm', 24.00, 52.80, 78, 'male', 'L2Monster', 'Fighter', 40, 2871, 8.585, 1657, 3.030, 40, 43, 30, 21, 20, 20, 34642, 3839, 1476, 568, 1019, 379, 253, 150, 506, 0, 0, 0, 37, 165, 'tomb_clan', 300, 0, 0, 0, 7, 10, 8, 1, 0, 1, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1209, 21404, 'Tera Beetle', '', 'tera_beetle', 25.00, 54.50, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 59626, 6692, 1525, 581, 1062, 387, 253, 0, 506, 0, 0, 0, 45, 185, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 7, 0, 2, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1210, 21405, 'Tera Beetle', '', 'tera_beetle', 25.00, 54.50, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 28588, 3209, 1525, 581, 1062, 387, 253, 0, 506, 0, 0, 0, 45, 185, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 7, 0, 2, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1211, 21406, 'Knight of Empire', '', 'skeleton_knight', 10.00, 25.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 42272, 4745, 1525, 581, 1062, 387, 253, 150, 506, 150, 103, 0, 40, 145, 'tomb_clan', 300, 0, 20, 171, 7, 30, 4, 7, 0, 2, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1212, 21407, 'Knight of Empire', '', 'skeleton_knight', 10.00, 25.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 27052, 3036, 1525, 581, 1062, 387, 253, 150, 506, 150, 103, 0, 40, 145, 'tomb_clan', 300, 0, 20, 171, 7, 30, 4, 7, 0, 2, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1213, 21408, 'Royal Guard of Empire', '', 'skeleton_pikeman', 10.00, 28.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 36791, 4129, 1525, 581, 1062, 387, 253, 150, 506, 304, 0, 0, 50, 190, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 7, 0, 2, 0.21, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1214, 21409, 'Royal Guard of Empire', '', 'skeleton_pikeman', 10.00, 28.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 41142, 4618, 1525, 581, 1062, 387, 253, 150, 506, 304, 0, 0, 50, 190, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 7, 0, 2, 0.21, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1215, 21410, 'Guardian Scarab', '', 'scarab_20_bi', 17.00, 26.50, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 38010, 4316, 1566, 593, 1097, 399, 253, 0, 506, 0, 0, 0, 45, 195, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1216, 21411, 'Guardian Scarab', '', 'scarab_20_bi', 17.00, 26.50, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 30337, 3445, 1566, 593, 1097, 399, 253, 0, 506, 0, 0, 0, 45, 195, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1217, 21412, 'Ustralith', '', 'scorpion', 28.00, 66.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 48414, 5497, 1566, 593, 1097, 399, 253, 150, 506, 0, 0, 0, 37, 130, 'tomb_clan', 300, 0, 0, 0, 7, 10, 8, 3, 0, 3, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1218, 21413, 'Ustralith', '', 'scorpion', 28.00, 66.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 37229, 4227, 1566, 593, 1097, 399, 253, 150, 506, 0, 0, 0, 37, 130, 'tomb_clan', 300, 0, 0, 0, 7, 10, 8, 3, 0, 3, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1219, 21414, 'Assassin of Empire', '', 'skeleton_royal_guard', 11.00, 28.50, 78, 'male', 'L2Monster', 'AssassinofEmpire', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 36181, 4108, 1566, 593, 1097, 399, 253, 0, 506, 946, 945, 0, 80, 175, 'tomb_clan', 300, 0, 20, 173, 7, 10, 8, 3, 0, 3, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1220, 21415, 'Assassin of Empire', '', 'skeleton_royal_guard', 11.00, 28.50, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 36499, 4144, 1566, 593, 1097, 399, 253, 0, 506, 946, 945, 0, 80, 175, 'tomb_clan', 300, 0, 20, 173, 7, 10, 8, 3, 0, 3, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1221, 21416, 'Imperial Commander', '', 'imperial_warlord_zombie', 7.00, 30.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 43189, 4904, 1566, 593, 1097, 399, 253, 150, 506, 134, 6721, 0, 39, 140, 'tomb_clan', 300, 0, 20, 173, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1222, 21417, 'Imperial Commander', '', 'imperial_warlord_zombie', 7.00, 30.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 75345, 8555, 1566, 593, 1097, 399, 253, 150, 506, 134, 6721, 0, 39, 140, 'tomb_clan', 300, 0, 20, 173, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1223, 21418, 'Imperial Royal Guard', '', 'death_knight', 12.00, 31.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 32124, 3691, 1607, 603, 1132, 411, 253, 0, 506, 142, 0, 0, 27, 160, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 9, 0, 4, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1224, 21419, 'Imperial Royal Guard', '', 'death_knight', 12.00, 31.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 32694, 3756, 1607, 603, 1132, 411, 253, 0, 506, 142, 0, 0, 27, 160, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 9, 0, 4, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1225, 21420, 'Ashuras', '', 'ashuras', 13.00, 37.50, 78, 'male', 'L2Monster', 'Ashuras', 40, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 38520, 4425, 1607, 603, 1132, 411, 253, 150, 506, 0, 0, 0, 41, 200, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 9, 0, 4, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1226, 21421, 'Ashuras', '', 'ashuras', 13.00, 37.50, 78, 'male', 'L2Monster', 'Fighter', 40, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 36159, 4154, 1607, 603, 1132, 411, 253, 150, 506, 0, 0, 0, 41, 200, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 9, 0, 4, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1227, 21422, 'Dancer of Empire', '', 'banshee', 9.00, 23.00, 78, 'female', 'L2Monster', 'Mystic', 40, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 41481, 4766, 1607, 603, 1132, 411, 253, 0, 506, 0, 0, 0, 80, 120, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 9, 0, 4, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1228, 21423, 'Dancer of Empire', '', 'banshee', 9.00, 23.00, 78, 'female', 'L2Monster', 'Mystic', 40, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 43973, 5052, 1607, 603, 1132, 411, 253, 150, 506, 0, 0, 0, 80, 120, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 9, 0, 4, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1229, 21424, 'Ashkenas', '', 'ashuras', 13.00, 37.50, 78, 'male', 'L2Monster', 'Ashkenas', 40, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 55732, 6403, 1607, 603, 1132, 411, 253, 0, 506, 0, 0, 0, 41, 190, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 9, 0, 4, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1230, 21425, 'Ashkenas', '', 'ashuras', 13.00, 37.50, 78, 'male', 'L2Monster', 'Fighter', 40, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 56668, 6510, 1607, 603, 1132, 411, 253, 150, 506, 0, 0, 0, 41, 190, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 9, 0, 4, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1231, 21426, 'Abraxion', '', 'erinyes', 21.00, 50.00, 78, 'male', 'L2Monster', 'Abraxion', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 65250, 7585, 1647, 613, 1167, 424, 253, 150, 506, 0, 0, 0, 31, 130, 'tomb_clan', 300, 0, 0, 0, 7, 50, 1, 14, 0, 5, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1232, 21427, 'Abraxion', '', 'erinyes', 21.00, 50.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 38349, 4458, 1647, 613, 1167, 424, 253, 150, 506, 0, 0, 0, 31, 130, 'tomb_clan', 300, 0, 0, 0, 7, 50, 1, 14, 0, 5, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1233, 21428, 'Hasturan', '', 'erinyes', 21.00, 50.00, 78, 'male', 'L2Monster', 'Hasturan', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 36621, 4257, 1647, 613, 1167, 424, 253, 150, 506, 0, 0, 0, 31, 150, 'tomb_clan', 300, 0, 0, 0, 7, 50, 1, 14, 0, 5, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1234, 21429, 'Hasturan', '', 'erinyes', 21.00, 50.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 38239, 4445, 1647, 613, 1167, 424, 253, 150, 506, 0, 0, 0, 31, 150, 'tomb_clan', 300, 0, 0, 0, 7, 50, 1, 14, 0, 5, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1235, 21430, 'Arimanes', '', 'ahrimanes', 14.00, 57.75, 78, 'male', 'L2Monster', 'Arimanes', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 52810, 6139, 1647, 613, 1167, 424, 253, 0, 506, 6722, 0, 0, 35, 210, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 10, 0, 5, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1236, 21431, 'Arimanes', '', 'ahrimanes', 14.00, 57.75, 78, 'male', 'L2Monster', 'Mystic', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 45045, 5236, 1647, 613, 1167, 424, 253, 0, 506, 6722, 0, 0, 35, 210, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 10, 0, 5, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1237, 21432, 'Chakram Beetle', '', 'tera_beetle', 19.00, 54.50, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 72932, 8186, 1525, 581, 1062, 387, 253, 0, 506, 0, 0, 0, 45, 170, 'tomb_clan', 300, 0, 0, 0, 7, 30, 4, 7, 0, 2, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1238, 21433, 'Jamadar Beetle', '', 'tera_beetle_20_sm', 20.00, 43.60, 78, 'male', 'L2Monster', 'Fighter', 40, 2871, 8.585, 1657, 3.030, 40, 43, 30, 21, 20, 20, 70729, 7839, 1476, 568, 1019, 379, 253, 0, 506, 0, 0, 0, 45, 175, '', 300, 0, 0, 0, 7, 30, 4, 6, 0, 1, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1239, 21434, 'Seer of Blood ', '', 'erinyes', 21.00, 50.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 141369, 16242, 1607, 603, 1132, 411, 253, 0, 506, 0, 0, 0, 31, 150, 'tomb_clan', 300, 0, 0, 0, 7, 50, 1, 13, 0, 4, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1240, 21435, 'Guide of Offering', '', 'imperial_warlord_zombie', 7.00, 30.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 71537, 8029, 1525, 581, 1062, 387, 253, 0, 506, 134, 6721, 0, 39, 150, '', 300, 0, 20, 171, 7, 30, 4, 7, 0, 2, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1241, 21436, 'Leader of Offering', '', 'imperial_warlord_zombie', 7.00, 30.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 74207, 8329, 1525, 581, 1062, 387, 253, 0, 506, 134, 6721, 0, 39, 150, '', 300, 0, 20, 171, 7, 30, 4, 7, 0, 2, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1242, 21437, 'Offering Bug', '', 'scarab', 14.00, 22.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2871, 8.585, 1657, 3.030, 40, 43, 30, 21, 20, 20, 29957, 3320, 1476, 568, 1019, 379, 253, 0, 506, 0, 0, 0, 45, 180, '', 300, 0, 0, 0, 7, 30, 4, 6, 0, 1, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1243, 21438, 'Heathen Warrior', '', 'skeleton_royal_guard', 11.00, 28.50, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 1790, 167, 898, 419, 613, 279, 253, 150, 506, 946, 945, 0, 80, 175, 'undead_clan', 300, 0, 20, 136, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1244, 21439, 'Heathen Executed ', '', 'hungry_spirit', 30.00, 40.00, 66, 'male', 'L2Monster', 'Fighter', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 1846, 174, 936, 429, 639, 285, 253, 150, 506, 0, 0, 0, 15, 175, 'undead_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1245, 21440, 'Heathen Archer', '', 'skeleton_archer', 11.00, 27.00, 67, 'male', 'L2Monster', 'Ranger', 1100, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 2021, 192, 975, 440, 666, 292, 253, 0, 506, 284, 0, 0, 40, 155, 'undead_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1246, 21441, 'Heathen Grunt', '', 'skeleton_pikeman', 10.00, 28.00, 68, 'male', 'L2Monster', 'Fighter', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 1959, 190, 1014, 449, 692, 300, 253, 150, 506, 96, 0, 0, 50, 170, 'undead_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.21, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1247, 21442, 'Heathen Knight', '', 'skeleton_knight', 10.00, 25.00, 69, 'male', 'L2Monster', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 2017, 197, 1055, 460, 720, 307, 253, 150, 506, 150, 103, 0, 40, 165, 'undead_clan', 300, 0, 20, 146, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1248, 21443, 'Raider of Pastureland', '', 'dark_mahum', 13.00, 26.00, 63, 'male', 'L2Monster', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 8408, 760, 822, 398, 562, 266, 253, 150, 506, 153, 0, 0, 50, 165, 'nonpet_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1249, 21444, 'Raider of Pastureland', '', 'dark_mahum', 13.00, 26.00, 63, 'male', 'L2Monster', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 7066, 638, 822, 398, 562, 266, 253, 150, 506, 153, 0, 0, 50, 165, 'nonpet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1250, 21445, 'Alpine Bandersnatch', '', 'bandersnatch', 18.00, 25.00, 64, 'male', 'L2Monster', 'Fighter', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 7292, 667, 860, 409, 588, 272, 253, 150, 506, 0, 0, 0, 30, 170, 'nonpet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1251, 21446, 'Raider of Pastureland', '', 'dark_mahum', 13.00, 26.00, 64, 'male', 'L2Monster', 'Fighter', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 8972, 821, 860, 409, 588, 272, 253, 150, 506, 160, 0, 0, 50, 165, 'nonpet_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1252, 21447, 'Raider of Pastureland', '', 'dark_mahum', 13.00, 26.00, 66, 'male', 'L2Monster', 'Fighter', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 9228, 869, 936, 429, 639, 285, 253, 150, 506, 229, 0, 0, 50, 165, 'nonpet_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1253, 21448, 'Raider of Pastureland', '', 'dark_mahum', 13.00, 26.00, 66, 'male', 'L2Monster', 'Fighter', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 7754, 730, 936, 429, 639, 285, 253, 150, 506, 229, 0, 0, 50, 165, 'nonpet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1254, 21449, 'Raider of Pastureland', '', 'dark_mahum', 13.00, 26.00, 68, 'male', 'L2Monster', 'Fighter', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 10128, 978, 1014, 449, 692, 300, 253, 150, 506, 234, 0, 0, 50, 165, 'nonpet_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1255, 21450, 'Alpine Grendel', '', 'bionic_bear', 15.00, 39.00, 68, 'male', 'L2Monster', 'Fighter', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 9796, 947, 1014, 449, 692, 300, 253, 150, 506, 0, 0, 0, 36, 155, 'nonpet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1256, 21451, 'Alpine Kookaburra', '', 'baby_ostrich', 7.00, 15.00, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 3318, 308, 898, 419, 613, 279, 253, 0, 506, 0, 0, 0, 13, 110, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1257, 21452, 'Alpine Kookaburra', '', 'baby_ostrich', 7.00, 15.00, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 8775, 815, 898, 419, 613, 279, 253, 0, 506, 0, 0, 0, 13, 140, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1258, 21453, 'Alpine Kookaburra', '', 'baby_ostrich', 7.00, 15.00, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 7374, 685, 898, 419, 613, 279, 253, 0, 506, 0, 0, 0, 13, 140, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1259, 21454, 'Alpine Kookaburra', '', 'baby_ostrich', 7.00, 15.00, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 8775, 815, 898, 419, 613, 279, 253, 0, 506, 0, 0, 0, 13, 140, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1260, 21455, 'Alpine Kookaburra', '', 'baby_ostrich', 7.00, 15.00, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 7374, 685, 898, 419, 613, 279, 253, 0, 506, 0, 0, 0, 13, 140, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1261, 21456, 'Alpine Kookaburra', '', 'baby_ostrich', 7.00, 15.00, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 8775, 815, 898, 419, 613, 279, 253, 0, 506, 0, 0, 0, 13, 140, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1262, 21457, 'Alpine Kookaburra', '', 'baby_ostrich', 7.00, 15.00, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 7374, 685, 898, 419, 613, 279, 253, 0, 506, 0, 0, 0, 13, 140, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1263, 21458, 'Alpine Kookaburra', '', 'baby_ostrich', 7.00, 15.00, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 8775, 815, 898, 419, 613, 279, 253, 0, 506, 0, 0, 0, 13, 140, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1264, 21459, 'Alpine Kookaburra', '', 'baby_ostrich', 7.00, 15.00, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 7374, 685, 898, 419, 613, 279, 253, 0, 506, 0, 0, 0, 13, 140, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1265, 21460, 'Alpine Kookaburra', '', 'youth_ostrich', 8.00, 26.40, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 18387, 1708, 898, 419, 613, 279, 253, 150, 506, 0, 0, 0, 23, 190, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1266, 21461, 'Alpine Kookaburra', '', 'youth_ostrich', 8.00, 26.40, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 19112, 1776, 898, 419, 613, 279, 253, 150, 506, 0, 0, 0, 23, 190, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1267, 21462, 'Alpine Kookaburra', '', 'youth_ostrich', 8.00, 26.40, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 18387, 1708, 898, 419, 613, 279, 253, 150, 506, 0, 0, 0, 23, 190, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1268, 21463, 'Alpine Kookaburra', '', 'youth_ostrich', 8.00, 26.40, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 17683, 1643, 898, 419, 613, 279, 253, 150, 506, 0, 0, 0, 23, 190, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1269, 21464, 'Alpine Kookaburra', '', 'youth_ostrich', 8.00, 26.40, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 18387, 1708, 898, 419, 613, 279, 253, 150, 506, 0, 0, 0, 23, 190, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1270, 21465, 'Alpine Kookaburra', '', 'youth_ostrich', 8.00, 26.40, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 19112, 1776, 898, 419, 613, 279, 253, 150, 506, 0, 0, 0, 23, 190, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1271, 21466, 'Alpine Kookaburra', '', 'youth_ostrich', 8.00, 26.40, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 18387, 1708, 898, 419, 613, 279, 253, 150, 506, 0, 0, 0, 23, 190, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1272, 21467, 'Alpine Kookaburra', '', 'youth_ostrich', 8.00, 26.40, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 17683, 1643, 898, 419, 613, 279, 253, 150, 506, 0, 0, 0, 23, 190, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1273, 21468, 'Alpine Kookaburra', '', 'rough_ostrich', 10.00, 33.00, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 30997, 2880, 898, 419, 613, 279, 253, 150, 506, 0, 0, 0, 23, 210, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1274, 21469, 'Alpine Kookaburra', '', 'rough_ostrich', 10.00, 33.00, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 29568, 2747, 898, 419, 613, 279, 253, 150, 506, 0, 0, 0, 23, 210, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1275, 21470, 'Alpine Buffalo', '', 'baby_buffalo', 12.00, 15.00, 67, 'male', 'L2FeedableBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 3526, 336, 975, 440, 666, 292, 253, 0, 506, 0, 0, 0, 30, 110, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1276, 21471, 'Alpine Buffalo', '', 'baby_buffalo', 12.00, 15.00, 67, 'male', 'L2FeedableBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 9323, 888, 975, 440, 666, 292, 253, 0, 506, 0, 0, 0, 30, 130, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1277, 21472, 'Alpine Buffalo', '', 'baby_buffalo', 12.00, 15.00, 67, 'male', 'L2FeedableBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 7835, 746, 975, 440, 666, 292, 253, 0, 506, 0, 0, 0, 30, 130, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1278, 21473, 'Alpine Buffalo', '', 'baby_buffalo', 12.00, 15.00, 67, 'male', 'L2FeedableBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 9323, 888, 975, 440, 666, 292, 253, 0, 506, 0, 0, 0, 30, 130, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1279, 21474, 'Alpine Buffalo', '', 'baby_buffalo', 12.00, 15.00, 67, 'male', 'L2FeedableBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 7835, 746, 975, 440, 666, 292, 253, 0, 506, 0, 0, 0, 30, 130, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1280, 21475, 'Alpine Buffalo', '', 'baby_buffalo', 12.00, 15.00, 67, 'male', 'L2FeedableBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 9323, 888, 975, 440, 666, 292, 253, 0, 506, 0, 0, 0, 30, 130, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1281, 21476, 'Alpine Buffalo', '', 'baby_buffalo', 12.00, 15.00, 67, 'male', 'L2FeedableBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 7835, 746, 975, 440, 666, 292, 253, 0, 506, 0, 0, 0, 30, 130, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1282, 21477, 'Alpine Buffalo', '', 'baby_buffalo', 12.00, 15.00, 67, 'male', 'L2FeedableBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 9323, 888, 975, 440, 666, 292, 253, 0, 506, 0, 0, 0, 30, 130, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1283, 21478, 'Alpine Buffalo', '', 'baby_buffalo', 12.00, 15.00, 67, 'male', 'L2FeedableBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 7835, 746, 975, 440, 666, 292, 253, 0, 506, 0, 0, 0, 30, 130, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1284, 21479, 'Alpine Buffalo', '', 'youth_buffalo', 16.00, 25.20, 67, 'male', 'L2FeedableBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 19535, 1860, 975, 440, 666, 292, 253, 150, 506, 0, 0, 0, 20, 170, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1285, 21480, 'Alpine Buffalo', '', 'youth_buffalo', 16.00, 25.20, 67, 'male', 'L2FeedableBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 20306, 1934, 975, 440, 666, 292, 253, 150, 506, 0, 0, 0, 20, 170, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1286, 21481, 'Alpine Buffalo', '', 'youth_buffalo', 16.00, 25.20, 67, 'male', 'L2FeedableBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 19535, 1860, 975, 440, 666, 292, 253, 150, 506, 0, 0, 0, 20, 170, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1287, 21482, 'Alpine Buffalo', '', 'youth_buffalo', 16.00, 25.20, 67, 'male', 'L2FeedableBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 18788, 1789, 975, 440, 666, 292, 253, 150, 506, 0, 0, 0, 20, 170, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1288, 21483, 'Alpine Buffalo', '', 'youth_buffalo', 16.00, 25.20, 67, 'male', 'L2FeedableBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 19535, 1860, 975, 440, 666, 292, 253, 150, 506, 0, 0, 0, 20, 170, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1289, 21484, 'Alpine Buffalo', '', 'youth_buffalo', 16.00, 25.20, 67, 'male', 'L2FeedableBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 20306, 1934, 975, 440, 666, 292, 253, 150, 506, 0, 0, 0, 20, 170, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1290, 21485, 'Alpine Buffalo', '', 'youth_buffalo', 16.00, 25.20, 67, 'male', 'L2FeedableBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 19535, 1860, 975, 440, 666, 292, 253, 150, 506, 0, 0, 0, 20, 170, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1291, 21486, 'Alpine Buffalo', '', 'youth_buffalo', 16.00, 25.20, 67, 'male', 'L2FeedableBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 18788, 1789, 975, 440, 666, 292, 253, 150, 506, 0, 0, 0, 20, 170, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1292, 21487, 'Alpine Buffalo', '', 'buffalo', 22.00, 31.00, 67, 'male', 'L2Monster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 32934, 3137, 975, 440, 666, 292, 253, 150, 506, 0, 0, 0, 20, 170, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1293, 21488, 'Alpine Buffalo', '', 'buffalo', 22.00, 31.00, 67, 'male', 'L2Monster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 31415, 2992, 975, 440, 666, 292, 253, 150, 506, 0, 0, 0, 20, 170, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1294, 21489, 'Alpine Cougar', '', 'baby_tiger', 11.00, 15.70, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 3739, 366, 1055, 460, 720, 307, 253, 0, 506, 0, 0, 0, 28, 110, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1295, 21490, 'Alpine Cougar', '', 'baby_tiger', 11.00, 15.70, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 9888, 967, 1055, 460, 720, 307, 253, 0, 506, 0, 0, 0, 28, 130, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1296, 21491, 'Alpine Cougar', '', 'baby_tiger', 11.00, 15.70, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 8309, 814, 1055, 460, 720, 307, 253, 0, 506, 0, 0, 0, 28, 130, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1297, 21492, 'Alpine Cougar', '', 'baby_tiger', 11.00, 15.70, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 9888, 967, 1055, 460, 720, 307, 253, 0, 506, 0, 0, 0, 28, 130, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1298, 21493, 'Alpine Cougar', '', 'baby_tiger', 11.00, 15.70, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 8309, 814, 1055, 460, 720, 307, 253, 0, 506, 0, 0, 0, 28, 130, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1299, 21494, 'Alpine Cougar', '', 'baby_tiger', 11.00, 15.70, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 9888, 967, 1055, 460, 720, 307, 253, 0, 506, 0, 0, 0, 28, 130, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1300, 21495, 'Alpine Cougar', '', 'baby_tiger', 11.00, 15.70, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 8309, 814, 1055, 460, 720, 307, 253, 0, 506, 0, 0, 0, 28, 130, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1301, 21496, 'Alpine Cougar', '', 'baby_tiger', 11.00, 15.70, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 9888, 967, 1055, 460, 720, 307, 253, 0, 506, 0, 0, 0, 28, 130, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1302, 21497, 'Alpine Cougar', '', 'baby_tiger', 11.00, 15.70, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 8309, 814, 1055, 460, 720, 307, 253, 0, 506, 0, 0, 0, 28, 130, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1303, 21498, 'Alpine Cougar', '', 'youth_tiger', 16.00, 17.20, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 20719, 2027, 1055, 460, 720, 307, 253, 150, 506, 0, 0, 0, 60, 175, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1304, 21499, 'Alpine Cougar', '', 'youth_tiger', 16.00, 17.20, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 21536, 2107, 1055, 460, 720, 307, 253, 150, 506, 0, 0, 0, 60, 175, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1305, 21500, 'Alpine Cougar', '', 'youth_tiger', 16.00, 17.20, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 20719, 2027, 1055, 460, 720, 307, 253, 150, 506, 0, 0, 0, 60, 175, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1306, 21501, 'Alpine Cougar', '', 'youth_tiger', 16.00, 17.20, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 19926, 1950, 1055, 460, 720, 307, 253, 150, 506, 0, 0, 0, 60, 175, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1307, 21502, 'Alpine Cougar', '', 'youth_tiger', 16.00, 17.20, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 20719, 2027, 1055, 460, 720, 307, 253, 150, 506, 0, 0, 0, 60, 175, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1308, 21503, 'Alpine Cougar', '', 'youth_tiger', 16.00, 17.20, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 21536, 2107, 1055, 460, 720, 307, 253, 150, 506, 0, 0, 0, 60, 175, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1309, 21504, 'Alpine Cougar', '', 'youth_tiger', 16.00, 17.20, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 20719, 2027, 1055, 460, 720, 307, 253, 150, 506, 0, 0, 0, 60, 175, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1310, 21505, 'Alpine Cougar', '', 'youth_tiger', 16.00, 17.20, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 19926, 1950, 1055, 460, 720, 307, 253, 150, 506, 0, 0, 0, 60, 175, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1311, 21506, 'Alpine Cougar', '', 'saber_toothed_tiger', 34.00, 28.00, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 34929, 3418, 1055, 460, 720, 307, 253, 150, 506, 0, 0, 0, 60, 200, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1312, 21507, 'Alpine Cougar', '', 'saber_toothed_tiger', 34.00, 28.00, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 33319, 3260, 1055, 460, 720, 307, 253, 150, 506, 0, 0, 0, 60, 200, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1313, 21508, 'Splinter Stakato', '', 'blade_stakato', 15.00, 36.00, 66, 'male', 'L2Monster', 'Fighter', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 8771, 825, 936, 429, 639, 313, 253, 150, 506, 235, 0, 0, 25, 175, 'stakato_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1314, 21509, 'Splinter Stakato Worker', '', 'blade_stakato_worker', 13.00, 40.00, 67, 'male', 'L2Monster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 8134, 774, 975, 440, 666, 321, 253, 150, 506, 0, 0, 0, 25, 180, 'stakato_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1315, 21510, 'Splinter Stakato Soldier', '', 'blade_stakato_soldier', 15.00, 38.00, 68, 'male', 'L2Monster', 'Fighter', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 9561, 923, 1014, 449, 692, 330, 253, 150, 506, 148, 0, 0, 25, 180, 'stakato_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1316, 21511, 'Splinter Stakato Drone', '', 'blade_stakato_drone', 15.00, 39.00, 69, 'male', 'L2Monster', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 10158, 993, 1055, 460, 720, 337, 253, 150, 506, 132, 0, 0, 25, 185, 'stakato_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1317, 21512, 'Splinter Stakato Drone', '', 'blade_stakato_drone', 15.00, 39.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 9379, 929, 1096, 471, 747, 345, 253, 0, 506, 132, 0, 0, 25, 185, 'stakato_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1318, 21513, 'Needle Stakato', '', 'blade_stakato', 15.00, 36.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 9867, 978, 1096, 471, 747, 345, 253, 150, 506, 235, 0, 0, 25, 185, 'stakatonew_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1319, 21514, 'Needle Stakato Worker', '', 'blade_stakato_worker', 13.00, 40.00, 71, 'male', 'L2Monster', 'Fighter', 40, 2493, 8.500, 1378, 3.000, 40, 43, 30, 21, 20, 20, 9134, 916, 1136, 482, 776, 352, 253, 150, 506, 0, 0, 0, 25, 190, 'stakatonew_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1320, 21515, 'Needle Stakato Soldier', '', 'blade_stakato_soldier', 15.00, 38.00, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 10718, 1088, 1179, 491, 805, 359, 253, 150, 506, 148, 0, 0, 25, 190, 'stakatonew_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1321, 21516, 'Needle Stakato Drone', '', 'blade_stakato_drone', 15.00, 39.00, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 10730, 1104, 1220, 502, 833, 368, 253, 150, 506, 132, 0, 0, 25, 195, 'stakatonew_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1322, 21517, 'Needle Stakato Drone', '', 'blade_stakato_drone', 15.00, 39.00, 74, 'male', 'L2Monster', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 10481, 1092, 1262, 513, 861, 375, 253, 0, 506, 132, 0, 0, 25, 195, 'stakatonew_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1323, 21518, 'Frenzy Stakato Soldier', '', 'blade_stakato_soldier', 15.00, 38.00, 68, 'male', 'L2Monster', 'Fighter', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 9228, 891, 1014, 449, 692, 330, 253, 0, 506, 235, 0, 0, 25, 185, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1324, 21519, 'Frenzy Stakato Drone', '', 'blade_stakato_drone', 15.00, 39.00, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 10345, 1051, 1179, 491, 805, 359, 253, 0, 506, 235, 0, 0, 25, 195, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1325, 21520, 'Eye of Splendor', '', 'kel_mahum', 13.00, 26.00, 60, 'male', 'L2Monster', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 8960, 778, 717, 370, 490, 246, 253, 0, 506, 326, 0, 0, 50, 160, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1326, 21521, 'Claws of Splendor', '', 'kel_mahum_warrior', 13.00, 28.00, 60, 'male', 'L2Monster', 'ClawsOfSplendor', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 8809, 764, 717, 370, 490, 246, 253, 0, 506, 326, 0, 0, 50, 160, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1327, 21522, 'Claws of Splendor', '', 'dark_fencer', 7.00, 13.00, 60, 'male', 'L2Monster', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 10498, 911, 717, 370, 490, 246, 253, 0, 506, 0, 0, 0, 25, 155, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1328, 21523, 'Flash of Splendor', '', 'kel_mahum_witch_doctor', 13.00, 25.00, 61, 'male', 'L2Monster', 'Fighter', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 9035, 796, 752, 378, 513, 252, 253, 150, 506, 326, 0, 0, 50, 150, 'saint_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1329, 21524, 'Blade of Splendor', '', 'kel_mahum', 13.00, 26.00, 61, 'male', 'L2Monster', 'BladeOfSplendor', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 9634, 848, 752, 378, 513, 252, 253, 0, 506, 242, 0, 0, 50, 165, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1330, 21525, 'Blade of Splendor', '', 'kel_mahum', 13.00, 26.00, 61, 'male', 'L2Monster', 'RndTeleportFighter', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 9634, 848, 752, 378, 513, 252, 253, 0, 506, 242, 0, 0, 50, 165, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1331, 21526, 'Wisdom of Splendor', '', 'kel_mahum_warrior', 13.00, 28.00, 62, 'male', 'L2Monster', 'Fighter', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 11065, 986, 787, 388, 538, 258, 253, 150, 506, 193, 0, 0, 50, 160, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1332, 21527, 'Anger of Splendor', '', 'kel_mahum_champion', 13.00, 32.00, 63, 'male', 'L2Monster', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 9759, 881, 822, 398, 562, 266, 253, 0, 506, 193, 0, 0, 50, 150, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1333, 21528, 'Anger of Splendor', '', 'dark_fencer', 7.00, 13.00, 63, 'male', 'L2Monster', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 11574, 1045, 822, 398, 562, 266, 253, 0, 506, 0, 0, 0, 25, 155, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1334, 21529, 'Soul of Splendor', '', 'kel_mahum_witch_doctor', 13.00, 25.00, 63, 'male', 'L2Monster', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 8853, 799, 822, 398, 562, 266, 253, 150, 506, 193, 0, 0, 50, 160, 'saint_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1335, 21530, 'Victory of Splendor', '', 'kel_mahum', 13.00, 26.00, 64, 'male', 'L2Monster', 'Fighter', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 9608, 880, 860, 409, 588, 272, 253, 0, 506, 196, 0, 0, 50, 160, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1336, 21531, 'Punishment of Splendor', '', 'kel_mahum_warrior', 13.00, 28.00, 64, 'male', 'L2Monster', 'RndTeleportFighter', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 10605, 971, 860, 409, 588, 272, 253, 0, 506, 242, 0, 0, 50, 165, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1337, 21532, 'Shout of Splendor', '', 'kel_mahum_champion', 13.00, 32.00, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 11348, 1055, 898, 419, 613, 279, 253, 150, 506, 196, 0, 0, 50, 150, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1338, 21533, 'Alliance of Splendor', '', 'kel_mahum_witch_doctor', 13.00, 25.00, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 9320, 866, 898, 419, 613, 279, 253, 0, 506, 196, 0, 0, 50, 160, 'saint_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1339, 21534, 'Alliance of Splendor', '', 'dark_fencer', 7.00, 13.00, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 12321, 1145, 898, 419, 613, 279, 253, 0, 506, 0, 0, 0, 25, 155, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1340, 21535, 'Signet of Splendor', '', 'kel_mahum_warrior', 13.00, 28.00, 66, 'male', 'L2Monster', 'Fighter', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 11197, 1054, 936, 429, 639, 285, 253, 150, 506, 189, 0, 0, 50, 160, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1341, 21536, 'Crown of Splendor', '', 'kel_mahum_champion', 13.00, 32.00, 66, 'male', 'L2Monster', 'Fighter', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 11385, 1072, 936, 429, 639, 285, 253, 0, 506, 189, 0, 0, 50, 165, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1342, 21537, 'Fang of Splendor', '', 'kel_mahum_witch_doctor', 13.00, 25.00, 67, 'male', 'L2Monster', 'FangOfSplendor', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 10686, 1018, 975, 440, 666, 292, 253, 0, 506, 189, 0, 0, 50, 155, 'saint_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1343, 21538, 'Fang of Splendor', '', 'dark_fencer', 7.00, 13.00, 67, 'male', 'L2Monster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 13091, 1247, 975, 440, 666, 292, 253, 0, 506, 0, 0, 0, 25, 155, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1344, 21539, 'Wailing of Splendor', '', 'kel_mahum', 13.00, 26.00, 67, 'male', 'L2Monster', 'RndTeleportFighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 11622, 1106, 975, 440, 666, 292, 253, 0, 506, 242, 0, 0, 50, 170, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1345, 21540, 'Wailing of Splendor', '', 'kel_mahum', 13.00, 26.00, 67, 'male', 'L2Monster', 'RndTeleportFighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 11622, 1106, 975, 440, 666, 292, 253, 0, 506, 242, 0, 0, 50, 170, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1346, 21541, 'Pilgrim of Splendor', '', 'kel_mahum_witch_doctor', 13.00, 25.00, 63, 'male', 'L2Monster', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 11933, 1078, 822, 398, 562, 266, 253, 150, 506, 315, 0, 0, 50, 165, 'saint_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1347, 21542, 'Disciple of Pilgrim', '', 'kel_mahum_warrior', 13.00, 28.00, 62, 'male', 'L2Monster', 'Fighter', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 8319, 742, 787, 388, 538, 258, 253, 0, 506, 193, 0, 0, 50, 165, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1348, 21543, 'Page of Pilgrim', '', 'kel_mahum', 13.00, 26.00, 62, 'male', 'L2Monster', 'Fighter', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 9492, 846, 787, 388, 538, 258, 253, 0, 506, 326, 0, 0, 50, 165, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1349, 21544, 'Judge of Splendor', '', 'kel_mahum_champion', 13.00, 32.00, 67, 'male', 'L2Monster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 13598, 1295, 975, 440, 666, 292, 253, 150, 506, 150, 0, 0, 50, 160, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1350, 21545, 'Judge of Fire', '', 'kel_mahum_witch_doctor', 13.00, 25.00, 66, 'male', 'L2Minion', 'Fighter', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 9427, 887, 936, 429, 639, 285, 253, 0, 506, 189, 0, 0, 50, 165, 'saint_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1351, 21546, 'Judge of Light', '', 'kel_mahum', 13.00, 26.00, 66, 'male', 'L2Minion', 'Fighter', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 10756, 1013, 936, 429, 639, 285, 253, 0, 506, 196, 0, 0, 50, 165, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1352, 21547, 'Corrupted Knight', '', 'skeleton_knight', 10.00, 25.00, 63, 'male', 'L2Monster', 'RndTeleportFighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 9739, 880, 822, 398, 562, 292, 253, 0, 506, 150, 103, 0, 40, 165, 'necro_clan', 300, 0, 20, 131, 30, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1353, 21548, 'Resurrected Knight', '', 'skeleton_knight', 10.00, 25.00, 63, 'male', 'L2Monster', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 8423, 761, 822, 398, 562, 292, 253, 0, 506, 150, 103, 0, 40, 165, 'necro_clan', 300, 0, 20, 131, 30, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1354, 21549, 'Corrupted Guard', '', 'skeleton_royal_guard', 11.00, 28.50, 64, 'male', 'L2Monster', 'Fighter', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 10051, 920, 860, 409, 588, 298, 253, 0, 506, 946, 0, 0, 80, 175, 'necro_clan', 300, 0, 0, 0, 30, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1355, 21550, 'Corrupted Guard', '', 'skeleton_royal_guard', 11.00, 28.50, 64, 'male', 'L2Monster', 'RndTeleportFighter', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 10252, 938, 860, 409, 588, 298, 253, 150, 506, 946, 945, 0, 80, 175, 'necro_clan', 300, 0, 20, 134, 30, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1356, 21551, 'Resurrected Guard', '', 'skeleton_royal_guard', 11.00, 28.50, 66, 'male', 'L2Monster', 'Fighter', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 11449, 1078, 936, 429, 639, 313, 253, 0, 506, 221, 0, 0, 80, 175, 'necro_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1357, 21552, 'Resurrected Guard', '', 'skeleton_royal_guard', 11.00, 28.50, 66, 'male', 'L2Monster', 'RndTeleportFighter', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 10903, 1026, 936, 429, 639, 313, 253, 150, 506, 221, 945, 0, 80, 175, 'necro_clan', 300, 0, 20, 138, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1358, 21553, 'Trampled Man', '', 'zombie', 13.00, 21.00, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 7521, 698, 898, 419, 613, 279, 253, 0, 506, 0, 0, 0, 15, 40, 'necro_clan', 300, 0, 0, 0, 30, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1359, 21554, 'Trampled Man', '', 'zombie', 13.00, 21.00, 65, 'male', 'L2Monster', 'RndTeleportFighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 7521, 698, 898, 419, 613, 279, 253, 0, 506, 0, 0, 0, 15, 40, 'necro_clan', 300, 0, 0, 0, 30, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1360, 21555, 'Slaughter Executioner', '', 'dark_horror', 20.00, 35.00, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 9144, 850, 898, 419, 613, 279, 253, 0, 506, 0, 0, 0, 100, 160, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1361, 21556, 'Slaughter Executioner', '', 'dark_horror', 20.00, 35.00, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 8922, 829, 898, 419, 613, 279, 253, 0, 506, 0, 0, 0, 100, 160, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1362, 21557, 'Bone Snatcher', '', 'black_magician', 8.00, 30.00, 66, 'male', 'L2Monster', 'CorpseCollector', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 10529, 991, 936, 429, 639, 285, 253, 0, 506, 178, 0, 0, 19, 180, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1363, 21558, 'Bone Snatcher', '', 'black_magician', 8.00, 30.00, 66, 'male', 'L2Monster', 'CorpseCollector', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 10529, 991, 936, 429, 639, 285, 253, 0, 506, 178, 0, 0, 19, 180, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1364, 21559, 'Bone Maker', '', 'black_magician', 8.00, 30.00, 66, 'male', 'L2Monster', 'CorpseCollector', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 11515, 1084, 936, 429, 639, 285, 253, 150, 506, 178, 0, 0, 19, 180, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1365, 21560, 'Bone Shaper', '', 'black_magician', 8.00, 30.00, 66, 'male', 'L2Monster', 'CorpseCollector', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 11515, 1084, 936, 429, 639, 285, 253, 150, 506, 178, 0, 0, 19, 180, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1366, 21561, 'Sacrificed Man', '', 'zombie', 13.00, 21.00, 67, 'male', 'L2Monster', 'RndTeleportFighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 9669, 920, 975, 440, 666, 292, 253, 150, 506, 0, 0, 0, 15, 40, 'necro_clan', 300, 0, 0, 0, 30, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1367, 21562, 'Guillotines Ghost', '', 'liviona', 15.00, 28.00, 67, 'male', 'L2Monster', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 10013, 954, 975, 440, 666, 292, 253, 150, 506, 0, 0, 0, 80, 150, 'necro_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1368, 21563, 'Bone Collector', '', 'black_magician', 8.00, 30.00, 67, 'male', 'L2Monster', 'CorpseCollector', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 11634, 1108, 975, 440, 666, 292, 253, 0, 506, 178, 0, 0, 19, 180, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1369, 21564, 'Skull Collector', '', 'black_magician', 8.00, 30.00, 67, 'male', 'L2Monster', 'CorpseCollector', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 11068, 1054, 975, 440, 666, 292, 253, 150, 506, 178, 0, 0, 19, 180, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1370, 21565, 'Bone Animator', '', 'black_magician', 8.00, 30.00, 68, 'male', 'L2Monster', 'CorpseCollector', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 11177, 1080, 1014, 449, 692, 300, 253, 0, 506, 178, 0, 0, 19, 180, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1371, 21566, 'Skull Animator', '', 'black_magician', 8.00, 30.00, 68, 'male', 'L2Monster', 'CorpseCollector', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 12224, 1181, 1014, 449, 692, 300, 253, 150, 506, 178, 0, 0, 19, 180, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1372, 21567, 'Bone Slayer', '', 'black_magician', 8.00, 30.00, 68, 'male', 'L2Monster', 'CorpseCollector', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 14611, 1411, 1014, 449, 692, 300, 253, 150, 506, 178, 0, 0, 19, 180, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1373, 21568, 'Devil Bat', '', 'vampire_bat', 10.00, 33.50, 68, 'male', 'L2Monster', 'Mystic', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 12528, 1211, 1014, 449, 692, 300, 253, 150, 506, 0, 0, 0, 60, 170, 'vampire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1374, 21569, 'Devil Bat', '', 'vampire_bat', 10.00, 33.50, 68, 'male', 'L2Monster', 'Mystic', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 9730, 940, 1014, 449, 692, 300, 253, 150, 506, 0, 0, 0, 60, 170, 'vampire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1375, 21570, 'Ghost of Betrayer', '', 'binding', 12.00, 21.00, 69, 'male', 'L2Monster', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 9069, 887, 1055, 460, 720, 307, 253, 150, 506, 0, 0, 0, 10, 174, 'necro_clan', 300, 0, 0, 0, 30, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1376, 21571, 'Ghost of Rebellion Soldier', '', 'skeleton_knight', 10.00, 25.00, 69, 'male', 'L2Monster', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 12862, 1259, 1055, 460, 720, 307, 253, 150, 506, 150, 103, 0, 40, 165, 'necro_clan', 300, 0, 20, 146, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1377, 21572, 'Bone Sweeper', '', 'black_magician', 8.00, 30.00, 69, 'male', 'L2Monster', 'CorpseCollector', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 12339, 1207, 1055, 460, 720, 307, 253, 0, 506, 178, 0, 0, 19, 185, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1378, 21573, 'Atrox', '', 'kailiharim', 45.00, 39.00, 69, 'male', 'L2Monster', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 13747, 1345, 1055, 460, 720, 307, 253, 150, 506, 0, 0, 0, 105, 185, 'vampire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1379, 21574, 'Bone Grinder', '', 'black_magician', 8.00, 30.00, 70, 'male', 'L2Monster', 'CorpseCollector', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 15483, 1535, 1096, 471, 747, 313, 253, 150, 506, 178, 0, 0, 19, 185, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1380, 21575, 'Bone Grinder', '', 'black_magician', 8.00, 30.00, 70, 'male', 'L2Monster', 'CorpseCollector', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 8723, 865, 1096, 471, 747, 313, 253, 150, 506, 178, 0, 0, 19, 185, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1381, 21576, 'Ghost of Guillotine ', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 11220, 1112, 1096, 471, 747, 313, 253, 0, 506, 0, 0, 0, 80, 150, 'vampire_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1382, 21577, 'Ghost of Guillotine ', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 9835, 976, 1096, 471, 747, 313, 253, 0, 506, 0, 0, 0, 80, 150, 'vampire_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1383, 21578, 'Behemoth Zombie', '', 'giant_zombie', 13.00, 40.00, 71, 'male', 'L2Monster', 'RndTeleportFighter', 40, 2493, 8.500, 1378, 3.000, 40, 43, 30, 21, 20, 20, 12370, 1241, 1136, 482, 776, 320, 253, 0, 506, 0, 0, 0, 20, 90, 'necro_clan', 300, 0, 0, 0, 30, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1384, 21579, 'Ghost of Rebellion Leader', '', 'skeleton_royal_guard', 11.00, 28.50, 71, 'male', 'L2Monster', 'Fighter', 40, 2493, 8.500, 1378, 3.000, 40, 43, 30, 21, 20, 20, 13012, 1306, 1136, 482, 776, 320, 253, 0, 506, 221, 945, 0, 80, 175, 'necro_clan', 300, 0, 20, 150, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1385, 21580, 'Bone Caster', '', 'black_magician', 8.00, 30.00, 71, 'male', 'L2Monster', 'CorpseCollector', 40, 2493, 8.500, 1378, 3.000, 40, 43, 30, 21, 20, 20, 12185, 1223, 1136, 482, 776, 320, 253, 0, 506, 178, 0, 0, 19, 185, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1386, 21581, 'Bone Puppeteer', '', 'black_magician', 8.00, 30.00, 71, 'male', 'L2Monster', 'CorpseCollector', 40, 2493, 8.500, 1378, 3.000, 40, 43, 30, 21, 20, 20, 13326, 1337, 1136, 482, 776, 320, 253, 150, 506, 178, 0, 0, 19, 185, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1387, 21582, 'Vampire Soldier', '', 'vampire_soldier', 8.00, 23.50, 71, 'male', 'L2Monster', 'Fighter', 40, 2493, 8.500, 1378, 3.000, 40, 43, 30, 21, 20, 20, 14270, 1432, 1136, 482, 776, 320, 253, 0, 506, 234, 0, 0, 60, 190, 'vampire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1388, 21583, 'Bone Scavenger', '', 'black_magician', 8.00, 30.00, 72, 'male', 'L2Monster', 'CorpseCollector', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 13436, 1364, 1179, 491, 805, 327, 253, 0, 506, 178, 0, 0, 19, 185, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1389, 21584, 'Bone Scavenger', '', 'black_magician', 8.00, 30.00, 72, 'male', 'L2Monster', 'CorpseCollector', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 12531, 1273, 1179, 491, 805, 327, 253, 0, 506, 178, 0, 0, 19, 185, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1390, 21585, 'Vampire Magician', '', 'vampire_witch', 6.00, 21.50, 72, 'female', 'L2Monster', 'Mystic', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 11554, 1174, 1179, 491, 805, 327, 253, 150, 506, 946, 0, 0, 64, 180, 'vampire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1391, 21586, 'Vampire Adept', '', 'vampire_wizard', 5.50, 28.00, 72, 'female', 'L2Monster', 'Mystic', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 13649, 1387, 1179, 491, 805, 327, 253, 150, 506, 99, 0, 0, 46, 180, 'vampire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1392, 21587, 'Vampire Warrior', '', 'vampire_soldier_20_bi', 10.00, 29.00, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 14223, 1445, 1179, 491, 805, 327, 253, 0, 506, 234, 0, 0, 60, 190, 'vampire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1393, 21588, 'Vampire Wizard', '', 'vampire_witch', 6.00, 21.50, 73, 'female', 'L2Monster', 'RndTeleportFighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 11923, 1226, 1220, 502, 833, 334, 253, 0, 506, 946, 0, 0, 64, 180, 'vampire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1394, 21589, 'Vampire Wizard', '', 'vampire_witch', 6.00, 21.50, 73, 'female', 'L2Monster', 'RndTeleportFighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 12202, 1255, 1220, 502, 833, 334, 253, 0, 506, 946, 0, 0, 64, 180, 'vampire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1395, 21590, 'Vampire Magister', '', 'vampire_wizard', 5.50, 28.00, 73, 'female', 'L2Monster', 'Mystic', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 11923, 1226, 1220, 502, 833, 334, 253, 0, 506, 99, 0, 0, 46, 180, 'vampire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1396, 21591, 'Vampire Magister', '', 'vampire_wizard', 5.50, 28.00, 73, 'female', 'L2Monster', 'Mystic', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 13756, 1415, 1220, 502, 833, 334, 253, 0, 506, 99, 0, 0, 46, 180, 'vampire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1397, 21592, 'Vampire Magister', '', 'vampire_wizard', 5.50, 28.00, 73, 'female', 'L2Monster', 'Mystic', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 9301, 956, 1220, 502, 833, 334, 253, 0, 506, 99, 0, 0, 46, 180, 'vampire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1398, 21593, 'Vampire Warlord', '', 'vampire_warrior', 9.00, 31.50, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 16016, 1648, 1220, 502, 833, 334, 253, 0, 506, 6723, 0, 0, 43, 190, 'vampire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1399, 21594, 'Vampire Warlord', '', 'vampire_warrior', 9.00, 31.50, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 15086, 1553, 1220, 502, 833, 334, 253, 0, 506, 6723, 0, 0, 43, 190, 'vampire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1400, 21595, 'Vampire Warlord', '', 'vampire_warrior', 9.00, 31.50, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 10993, 1132, 1220, 502, 833, 334, 253, 0, 506, 6723, 0, 0, 43, 190, 'vampire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1401, 21596, 'Requiem Lord', '', 'black_magician', 8.00, 30.00, 68, 'male', 'L2Monster', 'CorpseCollector', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 14446, 1396, 1014, 449, 692, 300, 253, 150, 506, 178, 0, 0, 19, 185, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1402, 21597, 'Requiem Behemoth', '', 'giant_zombie', 13.00, 40.00, 67, 'male', 'L2Minion', 'RndTeleportFighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 9919, 944, 975, 440, 666, 292, 253, 0, 506, 0, 0, 0, 20, 100, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1403, 21598, 'Requiem Behemoth', '', 'giant_zombie', 13.00, 40.00, 67, 'male', 'L2Minion', 'RndTeleportFighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 11015, 1049, 975, 440, 666, 292, 253, 0, 506, 0, 0, 0, 20, 100, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1404, 21599, 'Requiem Priest', '', 'black_magician', 8.00, 30.00, 71, 'male', 'L2Monster', 'CorpseCollector', 40, 2493, 8.500, 1378, 3.000, 40, 43, 30, 21, 20, 20, 15301, 1535, 1136, 482, 776, 320, 253, 150, 506, 178, 0, 0, 19, 185, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1405, 21600, 'Requiem Behemoth', '', 'giant_zombie', 13.00, 40.00, 70, 'male', 'L2Minion', 'RndTeleportFighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 10827, 1074, 1096, 471, 747, 313, 253, 0, 506, 0, 0, 0, 20, 100, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1406, 21601, 'Requiem Behemoth', '', 'giant_zombie', 13.00, 40.00, 70, 'male', 'L2Minion', 'RndTeleportFighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 12879, 1277, 1096, 471, 747, 313, 253, 0, 506, 0, 0, 0, 20, 100, 'necro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1407, 21602, 'Zakens Pikeman', '', 'skeleton_pikeman', 10.00, 28.00, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 4433, 300, 277, 223, 189, 149, 253, 150, 506, 292, 0, 0, 50, 174, 'undead_clan1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.21, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1408, 21603, 'Zakens Pikeman', '', 'skeleton_pikeman', 10.00, 28.00, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 6277, 425, 277, 223, 189, 149, 253, 150, 506, 292, 0, 0, 50, 174, 'undead_clan1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.21, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1409, 21604, 'Zakens Elite Pikeman', '', 'skeleton_pikeman_20_bi', 12.00, 33.60, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 10149, 686, 277, 223, 189, 149, 253, 150, 506, 292, 0, 0, 50, 174, 'undead_clan1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.21, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1410, 21605, 'Zakens Archer', '', 'skeleton_archer', 11.00, 27.00, 44, 'male', 'L2Monster', 'Ranger', 1100, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 4931, 337, 295, 230, 202, 153, 253, 0, 506, 279, 0, 0, 40, 174, 'undead_clan1', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1411, 21606, 'Zakens Archer', '', 'skeleton_archer', 11.00, 27.00, 44, 'male', 'L2Monster', 'Ranger', 1100, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 6982, 478, 295, 230, 202, 153, 253, 0, 506, 279, 0, 0, 40, 174, 'undead_clan1', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1412, 21607, 'Zakens Elite Archer', '', 'skeleton_archer_20_bi', 13.00, 32.50, 44, 'male', 'L2Monster', 'Ranger', 1100, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 10911, 746, 295, 230, 202, 153, 253, 0, 506, 279, 0, 0, 40, 174, 'undead_clan1', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1413, 21608, 'Zakens Watchman', '', 'liviona', 15.00, 28.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 4039, 281, 315, 239, 214, 158, 253, 150, 506, 0, 0, 0, 80, 174, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1414, 21609, 'Zakens Watchman', '', 'liviona', 15.00, 28.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 5720, 397, 315, 239, 214, 158, 253, 150, 506, 0, 0, 0, 80, 174, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1415, 21610, 'Zakens High Grade Watchman', '', 'liviona_20_bi', 18.00, 33.60, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 10440, 726, 315, 239, 214, 158, 253, 150, 506, 0, 0, 0, 80, 174, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1416, 21611, 'Unpleasant Humming', '', 'unpleasant_humming', 12.00, 26.00, 46, 'male', 'L2Monster', 'Fighter', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 4689, 332, 335, 246, 228, 163, 253, 150, 506, 0, 0, 0, 21, 174, 'undead_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1417, 21612, 'Unpleasant Humming', '', 'unpleasant_humming', 12.00, 26.00, 46, 'male', 'L2Monster', 'Fighter', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 6640, 470, 335, 246, 228, 163, 253, 150, 506, 0, 0, 0, 21, 174, 'undead_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1418, 21613, 'Unpleasant Shout', '', 'unpleasant_humming_20_bi', 13.50, 31.20, 46, 'male', 'L2Monster', 'Fighter', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 11332, 803, 335, 246, 228, 163, 253, 150, 506, 0, 0, 0, 21, 174, 'undead_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1419, 21614, 'Death Flyer', '', 'dark_horror', 20.00, 35.00, 47, 'male', 'L2Monster', 'Fighter', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 4843, 347, 356, 254, 243, 169, 253, 0, 506, 0, 0, 0, 100, 174, 'undead_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1420, 21615, 'Death Flyer', '', 'dark_horror', 20.00, 35.00, 47, 'male', 'L2Monster', 'Fighter', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 6858, 492, 356, 254, 243, 169, 253, 0, 506, 0, 0, 0, 100, 174, 'undead_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1421, 21616, 'Gigantic Flyer', '', 'dark_horror_bi', 20.00, 42.00, 47, 'male', 'L2Monster', 'Fighter', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 12517, 898, 356, 254, 243, 169, 253, 0, 506, 0, 0, 0, 100, 174, 'undead_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1422, 21617, 'Fiend Archer', '', 'fiend_archer', 17.00, 55.00, 48, 'male', 'L2Monster', 'Ranger', 1100, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 4925, 360, 378, 262, 258, 174, 253, 150, 506, 0, 0, 0, 70, 174, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1423, 21618, 'Fiend Archer', '', 'fiend_archer', 17.00, 55.00, 48, 'male', 'L2Monster', 'Ranger', 1100, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 6974, 510, 378, 262, 258, 174, 253, 150, 506, 0, 0, 0, 70, 174, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1424, 21619, 'Pit Archer', '', 'fiend_archer_20_bi', 20.00, 66.00, 48, 'male', 'L2Monster', 'Ranger', 1100, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 12729, 930, 378, 262, 258, 174, 253, 150, 506, 0, 0, 0, 70, 174, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1425, 21620, 'Musveren', '', 'field_stalker', 15.00, 30.00, 49, 'male', 'L2Monster', 'Fighter', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 4742, 350, 400, 270, 273, 179, 253, 0, 506, 0, 0, 0, 70, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1426, 21621, 'Musveren', '', 'field_stalker', 15.00, 30.00, 49, 'male', 'L2Monster', 'Fighter', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 6715, 497, 400, 270, 273, 179, 253, 0, 506, 0, 0, 0, 70, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1427, 21622, 'Greater Musveren', '', 'field_stalker_20_bi', 18.00, 36.00, 49, 'male', 'L2Monster', 'Fighter', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 12257, 906, 400, 270, 273, 179, 253, 0, 506, 0, 0, 0, 70, 174, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1428, 21623, 'Zakens Guard', '', 'skeleton_royal_guard', 11.00, 28.50, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 5993, 451, 425, 278, 291, 185, 253, 150, 506, 225, 945, 0, 80, 174, 'undead_clan', 300, 0, 20, 100, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1429, 21624, 'Zakens Guard', '', 'skeleton_royal_guard', 11.00, 28.50, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 8487, 640, 425, 278, 291, 185, 253, 150, 506, 225, 945, 0, 80, 174, 'undead_clan', 300, 0, 20, 100, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1430, 21625, 'Zakens Elite Guard', '', 'skeleton_royal_guard_20_bi', 13.00, 34.50, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 13722, 1033, 425, 278, 291, 185, 253, 150, 506, 225, 945, 0, 80, 174, 'undead_clan', 300, 0, 20, 100, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1431, 21626, 'Kaim Vanul', '', 'kaim_vanul', 24.00, 40.00, 51, 'male', 'L2Monster', 'Fighter', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 5345, 408, 449, 287, 307, 190, 253, 0, 506, 0, 0, 0, 37, 174, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1432, 21627, 'Kaim Vanul', '', 'kaim_vanul', 24.00, 40.00, 51, 'male', 'L2Monster', 'Fighter', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 7568, 577, 449, 287, 307, 190, 253, 0, 506, 0, 0, 0, 37, 174, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1433, 21628, 'Kaim Vanul Lad', '', 'kaim_vanul_20_bi', 28.00, 48.00, 51, 'male', 'L2Monster', 'Fighter', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 13814, 1054, 449, 287, 307, 190, 253, 0, 506, 0, 0, 0, 37, 174, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1434, 21629, 'Pirate Zombie Captain', '', 'pirates_zombie_captain', 17.00, 28.00, 52, 'male', 'L2Monster', 'Fighter', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 8073, 624, 475, 296, 324, 196, 253, 150, 506, 232, 0, 0, 14, 174, 'zaken_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1435, 21630, 'Pirate Zombie Captain', '', 'pirates_zombie_captain', 17.00, 28.00, 52, 'male', 'L2Monster', 'Fighter', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 11432, 884, 475, 296, 324, 196, 253, 150, 506, 232, 0, 0, 14, 174, 'zaken_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1436, 21631, 'Zombie Captains Spiritual Body', '', 'pirates_zombie_captain_20_bi', 20.00, 33.60, 52, 'male', 'L2Monster', 'Fighter', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 18953, 1466, 475, 296, 324, 196, 253, 150, 506, 232, 0, 0, 14, 174, 'zaken_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1437, 21632, 'Doll Blader', '', 'doll_blader', 6.00, 12.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 6407, 504, 503, 304, 344, 203, 253, 0, 506, 5129, 5129, 0, 22, 174, 'zaken_clan', 300, 0, 0, 94, 7, 10, 8, 0, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1438, 21633, 'Doll Blader', '', 'doll_blader', 6.00, 12.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 9073, 713, 503, 304, 344, 203, 253, 0, 506, 5129, 5129, 0, 22, 174, 'zaken_clan', 300, 0, 0, 94, 7, 10, 8, 0, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1439, 21634, 'Crimson Doll Blader', '', 'doll_blader_20_bi', 7.00, 15.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 16560, 1302, 503, 304, 344, 203, 253, 0, 506, 5129, 5129, 0, 22, 174, 'zaken_clan', 300, 0, 0, 94, 7, 10, 8, 0, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1440, 21635, 'Vale Master', '', 'vale_master', 12.00, 40.00, 54, 'male', 'L2Monster', 'Fighter', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 6112, 487, 531, 313, 362, 209, 253, 150, 506, 0, 0, 0, 70, 174, 'zaken_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1441, 21636, 'Vale Master', '', 'vale_master', 12.00, 40.00, 54, 'male', 'L2Monster', 'Fighter', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 8655, 690, 531, 313, 362, 209, 253, 150, 506, 0, 0, 0, 70, 174, 'zaken_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1442, 21637, 'Crimson Vale Master', '', 'vale_master_20_bi', 14.50, 48.00, 54, 'male', 'L2Monster', 'Fighter', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 15797, 1260, 531, 313, 362, 209, 253, 150, 506, 0, 0, 0, 70, 174, 'zaken_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1443, 21638, 'Dread Wolf', '', 'dire_wolf', 13.00, 11.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 1382, 82, 160, 170, 109, 113, 253, 150, 506, 0, 0, 0, 24, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1444, 21639, 'Tasaba Lizardman', '', 'virud_lizardman_scout', 10.00, 22.00, 36, 'male', 'L2Monster', 'Ranger', 1100, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 1635, 98, 173, 176, 118, 118, 253, 0, 506, 2507, 0, 0, 43, 140, 'lizardman_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1445, 21640, 'Tasaba Lizardman Shaman ', '', 'virud_lizardman_shaman', 10.00, 29.00, 37, 'male', 'L2Monster', 'Priest', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 1202, 74, 185, 181, 126, 121, 253, 0, 506, 7, 0, 0, 43, 140, 'lizardman_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1446, 21641, 'Ogre', '', 'ogre', 21.00, 44.00, 38, 'male', 'L2Monster', 'Fighter', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 2134, 133, 198, 188, 136, 126, 253, 150, 506, 98, 0, 0, 22, 174, 'lizardman_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.69, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1447, 21642, 'Tasaba Lizardman Sniper', '', 'virud_lizardman_scout', 10.00, 22.00, 39, 'male', 'L2Monster', 'Ranger', 1100, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 1958, 125, 212, 195, 145, 131, 253, 150, 506, 2507, 0, 0, 43, 140, 'lizardman_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1448, 21643, 'Tasaba Lizardman Sniper', '', 'virud_lizardman_scout', 10.00, 22.00, 39, 'male', 'L2Monster', 'Ranger', 1100, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 2488, 158, 212, 195, 145, 131, 253, 150, 506, 2507, 0, 0, 43, 140, 'lizardman_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1449, 21644, 'Lienrik', '', 'lienrik', 12.00, 50.00, 39, 'male', 'L2Monster', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 1195, 76, 212, 195, 145, 131, 253, 0, 506, 0, 0, 0, 100, 150, 'lienrik_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1450, 21645, 'Lienrik Lad', '', 'lienrik', 12.00, 50.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 2302, 149, 227, 203, 155, 134, 253, 150, 506, 0, 0, 0, 100, 174, 'lienrik_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1451, 21646, 'Grave Scarab', '', 'scarab', 14.00, 22.00, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 12247, 1260, 1220, 502, 833, 334, 253, 0, 506, 0, 0, 0, 45, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1452, 21647, 'Scavenger Scarab', '', 'scarab', 14.00, 22.00, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 10332, 1063, 1220, 502, 833, 334, 253, 150, 506, 0, 0, 0, 45, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1453, 21648, 'Grave Ant', '', 'ant_soldier', 35.00, 17.00, 74, 'male', 'L2Monster', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 11260, 1174, 1262, 513, 861, 342, 253, 0, 506, 0, 0, 0, 80, 150, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1454, 21649, 'Scavenger Ant', '', 'ant_soldier', 35.00, 17.00, 74, 'male', 'L2Monster', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 13319, 1388, 1262, 513, 861, 342, 253, 150, 506, 0, 0, 0, 80, 150, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1455, 21650, 'Shrine Knight', '', 'skeleton_knight', 10.00, 25.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 12179, 1285, 1304, 523, 891, 349, 253, 0, 506, 150, 103, 0, 40, 165, '', 300, 0, 20, 160, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1456, 21651, 'Shrine Guard', '', 'skeleton_pikeman', 10.00, 28.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 11635, 1228, 1304, 523, 891, 349, 253, 0, 506, 98, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.21, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1457, 21652, 'Scarlet Stakato Noble', '', 'blade_stakato_drone', 15.00, 39.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2871, 8.585, 1657, 3.030, 40, 43, 30, 21, 20, 20, 46911, 5199, 1476, 568, 1019, 379, 253, 150, 506, 235, 0, 0, 25, 165, 'fire_clan', 300, 0, 0, 0, 7, 10, 8, 1, 0, 1, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1458, 21653, 'Assassin Beetle', '', 'tera_beetle', 19.00, 54.50, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 34021, 3819, 1525, 581, 1062, 387, 253, 150, 506, 0, 0, 0, 45, 165, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 7, 0, 2, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1459, 21654, 'Necromancer of Destruction', '', 'vale_master_20_bi', 14.50, 48.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 40213, 4566, 1566, 593, 1097, 399, 253, 150, 506, 0, 0, 0, 70, 140, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1460, 21655, 'Arimanes of Destruction', '', 'ahrimanes', 14.00, 57.75, 78, 'male', 'L2Monster', 'Mystic', 40, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 35744, 4106, 1607, 603, 1132, 411, 253, 150, 506, 6722, 0, 0, 35, 185, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 9, 0, 4, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1461, 21656, 'Ashuras of Destruction', '', 'ashuras_30_bi', 17.00, 49.00, 78, 'male', 'L2Monster', 'AshurasofDestruction', 40, 3077, 8.874, 1848, 3.131, 40, 43, 30, 21, 20, 20, 62781, 7385, 1685, 625, 1202, 436, 253, 150, 506, 0, 0, 0, 41, 190, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 11, 0, 2, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1462, 21657, 'Magma Drake', '', 'inferno_drake_20_bi', 29.00, 42.00, 78, 'male', 'L2Monster', 'Mystic', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 54374, 6472, 1725, 635, 1237, 448, 253, 150, 506, 0, 0, 0, 57, 185, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1463, 21658, 'Punishment of Splendor', '', 'kel_mahum_warrior', 13.00, 28.00, 64, 'male', 'L2Monster', 'RndTeleportFighter', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 10605, 971, 860, 409, 588, 272, 253, 0, 506, 242, 0, 0, 50, 165, 'saint_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1464, 21659, 'Otherworldly Invader Soldier', '', 'neer_crawler', 14.00, 22.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 4372, 239, 111, 140, 75, 94, 253, 0, 506, 0, 0, 0, 50, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1465, 21660, 'Otherworldly Invader Soldier', '', 'neer_crawler', 14.00, 22.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 6221, 368, 160, 170, 109, 113, 253, 1000, 506, 0, 0, 0, 50, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1466, 21661, 'Otherworldly Invader Archer', '', 'skeleton_archer', 11.00, 27.00, 33, 'male', 'L2Monster', 'Ranger', 1100, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 4478, 257, 138, 157, 94, 105, 253, 1000, 506, 275, 0, 0, 40, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1467, 21662, 'Otherworldly Invader Elite Soldier', '', 'dark_horror', 20.00, 35.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 5178, 306, 160, 170, 109, 113, 253, 1000, 506, 0, 0, 0, 100, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1468, 21663, 'Otherworldly Invader Shaman', '', 'dark_horror', 20.00, 35.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 5654, 324, 138, 157, 94, 105, 253, 1000, 506, 0, 0, 0, 100, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1469, 21664, 'Otherworldly Invader Priest', '', 'dark_horror', 20.00, 35.00, 30, 'male', 'L2Monster', 'Priest', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 3023, 165, 111, 140, 75, 94, 253, 0, 506, 0, 0, 0, 100, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1470, 21665, 'Otherworldly Invader Magus', '', 'dark_horror', 20.00, 35.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 4089, 242, 160, 170, 109, 113, 253, 1000, 506, 0, 0, 0, 100, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1471, 21666, 'Otherworldly Invader Martyrs', '', 'dark_horror', 20.00, 35.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 3054, 167, 111, 140, 75, 94, 253, 0, 506, 0, 0, 0, 100, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1472, 21667, 'Otherworldly Invader Warrior', '', 'skeleton', 11.00, 25.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 3635, 209, 138, 157, 94, 105, 253, 1000, 506, 220, 0, 0, 60, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1473, 21668, 'Otherworldly Invader Soldier', '', 'neer_crawler', 14.00, 22.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 3215, 176, 111, 140, 75, 94, 253, 1000, 506, 0, 0, 0, 50, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1474, 21669, 'Otherworldly Invader Discipline', '', 'skeleton', 11.00, 25.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 3828, 220, 138, 157, 94, 105, 253, 0, 506, 220, 0, 0, 60, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1475, 21670, 'Otherworldly Invader Berserker', '', 'skeleton', 11.00, 25.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 5356, 317, 160, 170, 109, 113, 253, 1000, 506, 220, 0, 0, 60, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1476, 21671, 'Otherworldly Invader Food', '', 'mimic', 8.50, 8.50, 30, 'male', 'L2Chest', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1309, 72, 111, 140, 75, 94, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1477, 21672, 'Otherworldly Invader Elite Soldier', '', 'skeleton_pikeman', 10.00, 28.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 9595, 568, 160, 170, 109, 113, 253, 1000, 506, 96, 0, 0, 50, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.21, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1478, 21673, 'Otherworldly Invader Elite Soldier', '', 'skeleton_pikeman', 10.00, 28.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 9777, 579, 160, 170, 109, 113, 253, 1000, 506, 96, 0, 0, 50, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.21, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1479, 21674, 'Otherworldly Invader Elite Soldier', '', 'skeleton_pikeman', 10.00, 28.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 381, 23, 160, 170, 109, 113, 253, 0, 506, 96, 0, 0, 50, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.21, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1480, 21675, 'Otherworldly Invader Elite Soldier', '', 'skeleton_pikeman', 10.00, 28.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 778, 42, 111, 140, 75, 94, 253, 0, 506, 96, 0, 0, 50, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.21, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1481, 21676, 'Otherworldly Invader Warrior', '', 'skeleton', 11.00, 25.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 8716, 500, 138, 157, 94, 105, 253, 1000, 506, 220, 0, 0, 60, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1482, 21677, 'Otherworldly Invader Elite Soldier', '', 'skeleton_pikeman', 10.00, 28.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 6988, 382, 111, 140, 75, 94, 253, 1000, 506, 96, 0, 0, 50, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.21, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1483, 21678, 'Otherworldly Invader Elite Soldier', '', 'skeleton_pikeman', 10.00, 28.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 8456, 485, 138, 157, 94, 105, 253, 1000, 506, 96, 0, 0, 50, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.21, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1484, 21679, 'Otherworldly Invader Elite Soldier', '', 'skeleton_pikeman', 10.00, 28.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 6889, 376, 111, 140, 75, 94, 253, 1000, 506, 96, 0, 0, 50, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.21, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1485, 21680, 'Otherworldly Invader Elite Soldier', '', 'skeleton_pikeman', 10.00, 28.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 9377, 555, 160, 170, 109, 113, 253, 1000, 506, 96, 0, 0, 50, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.21, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1486, 21681, 'Otherworldly Invader Magus', '', 'dark_horror', 20.00, 35.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 8062, 463, 138, 157, 94, 105, 253, 0, 506, 0, 0, 0, 100, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1487, 21682, 'Dimension Invader Soldier', '', 'neer_crawler', 14.00, 22.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 7772, 502, 227, 203, 155, 134, 253, 0, 506, 0, 0, 0, 50, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1488, 21683, 'Dimension Invader Soldier', '', 'neer_crawler', 14.00, 22.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 10283, 715, 315, 239, 214, 158, 253, 1000, 506, 0, 0, 0, 50, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1489, 21684, 'Dimension Invader Archer', '', 'skeleton_archer', 11.00, 27.00, 43, 'male', 'L2Monster', 'Ranger', 1100, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 7603, 514, 277, 223, 189, 149, 253, 1000, 506, 279, 0, 0, 40, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1490, 21685, 'Dimension Invader Elite Soldier', '', 'crimson_doll', 15.00, 38.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 8560, 595, 315, 239, 214, 158, 253, 1000, 506, 0, 0, 0, 60, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.67, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1491, 21686, 'Dimension Invader Shaman', '', 'crimson_doll', 15.00, 38.00, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 9599, 649, 277, 223, 189, 149, 253, 1000, 506, 0, 0, 0, 60, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.67, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1492, 21687, 'Dimension Invader Priest', '', 'crimson_doll', 15.00, 38.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 5374, 347, 227, 203, 155, 134, 253, 0, 506, 0, 0, 0, 60, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.67, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1493, 21688, 'Dimension Invader Magus', '', 'crimson_doll', 15.00, 38.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 6759, 470, 315, 239, 214, 158, 253, 1000, 506, 0, 0, 0, 60, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.67, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1494, 21689, 'Dimension Invader Martyrs', '', 'crimson_doll', 15.00, 38.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 5430, 351, 227, 203, 155, 134, 253, 0, 506, 0, 0, 0, 60, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.67, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1495, 21690, 'Dimension Invader Warrior', '', 'skeleton_knight', 10.00, 25.00, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 6172, 417, 277, 223, 189, 149, 253, 1000, 506, 70, 0, 0, 40, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1496, 21691, 'Dimension Invader Soldier', '', 'neer_crawler', 14.00, 22.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 5716, 369, 227, 203, 155, 134, 253, 1000, 506, 0, 0, 0, 50, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1497, 21692, 'Dimension Invader Discipline', '', 'skeleton_knight', 10.00, 25.00, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 6499, 439, 277, 223, 189, 149, 253, 0, 506, 70, 0, 0, 40, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1498, 21693, 'Dimension Invader Berserker ', '', 'skeleton_knight', 10.00, 25.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 8854, 616, 315, 239, 214, 158, 253, 1000, 506, 70, 0, 0, 40, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1499, 21694, 'Dimension Invader Food', '', 'mimic', 8.50, 8.50, 40, 'male', 'L2Chest', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 2327, 150, 227, 203, 155, 134, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1500, 21695, 'Dimension Invader Elite Soldier', '', 'headless_knight', 21.00, 31.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 15861, 1103, 315, 239, 214, 158, 253, 1000, 506, 135, 0, 0, 70, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1501, 21696, 'Dimension Invader Elite Soldier', '', 'headless_knight', 21.00, 31.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 16162, 1124, 315, 239, 214, 158, 253, 1000, 506, 135, 0, 0, 70, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1502, 21697, 'Dimension Invader Elite Soldier', '', 'headless_knight', 21.00, 31.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 630, 44, 315, 239, 214, 158, 253, 0, 506, 135, 0, 0, 70, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1503, 21698, 'Dimension Invader Elite Soldier', '', 'headless_knight', 21.00, 31.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 1382, 89, 227, 203, 155, 134, 253, 0, 506, 135, 0, 0, 70, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1504, 21699, 'Dimension Invader Warrior', '', 'skeleton_knight', 10.00, 25.00, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 14798, 1000, 277, 223, 189, 149, 253, 1000, 506, 70, 0, 0, 40, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1505, 21700, 'Dimension Invader Elite Soldier', '', 'headless_knight', 21.00, 31.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 12423, 802, 227, 203, 155, 134, 253, 1000, 506, 135, 0, 0, 70, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1506, 21701, 'Dimension Invader Elite Soldier', '', 'headless_knight', 21.00, 31.00, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 14357, 971, 277, 223, 189, 149, 253, 1000, 506, 135, 0, 0, 70, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1507, 21702, 'Dimension Invader Elite Soldier', '', 'headless_knight', 21.00, 31.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 12248, 791, 227, 203, 155, 134, 253, 1000, 506, 135, 0, 0, 70, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1508, 21703, 'Dimension Invader Elite Soldier', '', 'headless_knight', 21.00, 31.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 15501, 1078, 315, 239, 214, 158, 253, 1000, 506, 135, 0, 0, 70, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1509, 21704, 'Dimension Invader Magus', '', 'crimson_doll', 15.00, 38.00, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 13688, 925, 277, 223, 189, 149, 253, 0, 506, 0, 0, 0, 60, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.67, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1510, 21705, 'Purgatory Invader Soldier', '', 'doll_blader', 6.00, 12.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 12144, 915, 425, 278, 291, 185, 253, 0, 506, 5129, 5129, 0, 22, 165, 'ssq_clan', 300, 0, 0, 88, 7, 10, 8, 0, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1511, 21706, 'Purgatory Invader Soldier', '', 'doll_blader', 6.00, 12.00, 55, 'male', 'L2Monster', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 15362, 1240, 559, 323, 382, 215, 253, 1000, 506, 5129, 5129, 0, 22, 165, 'ssq_clan', 300, 0, 0, 98, 7, 10, 8, 0, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1512, 21707, 'Purgatory Invader Archer', '', 'skeleton_archer', 11.00, 27.00, 53, 'male', 'L2Monster', 'Ranger', 1100, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 11550, 908, 503, 304, 344, 203, 253, 1000, 506, 282, 0, 0, 40, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1513, 21708, 'Purgatory Invader Elite Soldier', '', 'banshee', 9.00, 23.00, 55, 'female', 'L2Monster', 'Mystic', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 12787, 1032, 559, 323, 382, 215, 253, 1000, 506, 3939, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1514, 21709, 'Purgatory Invader Shaman', '', 'banshee', 9.00, 23.00, 53, 'female', 'L2Monster', 'Mystic', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 14583, 1146, 503, 304, 344, 203, 253, 1000, 506, 3939, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1515, 21710, 'Purgatory Invader Priest', '', 'banshee', 9.00, 23.00, 50, 'female', 'L2Monster', 'Priest', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 8396, 633, 425, 278, 291, 185, 253, 0, 506, 3939, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1516, 21711, 'Purgatory Invader Magus', '', 'banshee', 9.00, 23.00, 55, 'female', 'L2Monster', 'Mystic', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 10097, 815, 559, 323, 382, 215, 253, 1000, 506, 3939, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1517, 21712, 'Purgatory Invader Martyrs', '', 'banshee', 9.00, 23.00, 50, 'female', 'L2Monster', 'Mystic', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 8484, 639, 425, 278, 291, 185, 253, 0, 506, 3939, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1518, 21713, 'Purgatory Invader Warrior', '', 'skeleton_royal_guard', 11.00, 28.50, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 9376, 737, 503, 304, 344, 203, 253, 1000, 506, 946, 946, 0, 80, 165, 'ssq_clan', 300, 0, 20, 107, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1519, 21714, 'Purgatory Invader Soldier', '', 'doll_blader', 6.00, 12.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 8932, 673, 425, 278, 291, 185, 253, 1000, 506, 5129, 5129, 0, 22, 165, 'ssq_clan', 300, 0, 0, 88, 7, 10, 8, 0, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1520, 21715, 'Purgatory Invader Disciples', '', 'skeleton_royal_guard', 11.00, 28.50, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 9873, 776, 503, 304, 344, 203, 253, 0, 506, 946, 946, 0, 80, 165, 'ssq_clan', 300, 0, 20, 107, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1521, 21716, 'Purgatory Invader Berserker', '', 'skeleton_royal_guard', 11.00, 28.50, 55, 'male', 'L2Monster', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 13227, 1068, 559, 323, 382, 215, 253, 1000, 506, 946, 946, 0, 80, 165, 'ssq_clan', 300, 0, 20, 112, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1522, 21717, 'Purgatory Invader Food', '', 'mimic', 8.50, 8.50, 50, 'male', 'L2Chest', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 3636, 274, 425, 278, 291, 185, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1523, 21718, 'Purgatory Invader Elite Soldier', '', 'bloody_queen', 14.00, 40.00, 55, 'female', 'L2Monster', 'Mystic', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 23694, 1913, 559, 323, 382, 215, 253, 1000, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1524, 21719, 'Purgatory Invader Elite Soldier', '', 'bloody_queen', 14.00, 40.00, 55, 'female', 'L2Monster', 'Mystic', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 24143, 1949, 559, 323, 382, 215, 253, 1000, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1525, 21720, 'Purgatory Invader Elite Soldier', '', 'bloody_queen', 14.00, 40.00, 55, 'female', 'L2Monster', 'Mystic', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 942, 76, 559, 323, 382, 215, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1526, 21721, 'Purgatory Invader Elite Soldier', '', 'bloody_queen', 14.00, 40.00, 50, 'female', 'L2Monster', 'Mystic', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 2160, 163, 425, 278, 291, 185, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1527, 21722, 'Purgatory Invader Warrior', '', 'skeleton_royal_guard', 11.00, 28.50, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 22482, 1767, 503, 304, 344, 203, 253, 1000, 506, 946, 946, 0, 80, 165, 'ssq_clan', 300, 0, 20, 107, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1528, 21723, 'Purgatory Invader Elite Soldier', '', 'bloody_queen', 14.00, 40.00, 50, 'female', 'L2Monster', 'Mystic', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 19411, 1462, 425, 278, 291, 185, 253, 1000, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1529, 21724, 'Purgatory Invader Elite Soldier', '', 'bloody_queen', 14.00, 40.00, 53, 'female', 'L2Monster', 'Mystic', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 21811, 1715, 503, 304, 344, 203, 253, 1000, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1530, 21725, 'Purgatory Invader Elite Soldier', '', 'bloody_queen', 14.00, 40.00, 50, 'female', 'L2Monster', 'Mystic', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 19137, 1442, 425, 278, 291, 185, 253, 1000, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1531, 21726, 'Purgatory Invader Elite Soldier', '', 'bloody_queen', 14.00, 40.00, 55, 'female', 'L2Monster', 'Mystic', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 23156, 1869, 559, 323, 382, 215, 253, 1000, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1532, 21727, 'Purgatory Invader Magus', '', 'banshee', 9.00, 23.00, 53, 'female', 'L2Monster', 'Mystic', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 20795, 1635, 503, 304, 344, 203, 253, 0, 506, 3939, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1533, 21728, 'Forbidden Path Invader Elite Soldier', '', 'doll_blader', 6.00, 12.00, 60, 'male', 'L2Monster', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 17487, 1518, 717, 370, 490, 246, 253, 0, 506, 5129, 5129, 0, 22, 165, 'ssq_clan', 300, 0, 0, 109, 7, 10, 8, 0, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1534, 21729, 'Forbidden Path Invader Elite Soldier', '', 'doll_blader', 6.00, 12.00, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 21456, 1993, 898, 419, 613, 279, 253, 1000, 506, 5129, 5129, 0, 22, 165, 'ssq_clan', 300, 0, 0, 119, 7, 10, 8, 0, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1535, 21730, 'Forbidden Path Invader Archer', '', 'skeleton_archer', 11.00, 27.00, 63, 'male', 'L2Monster', 'Ranger', 1100, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 16320, 1473, 822, 398, 562, 266, 253, 1000, 506, 284, 0, 0, 40, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1536, 21731, 'Forbidden Path Invader Elite Soldier', '', 'banshee', 9.00, 23.00, 65, 'female', 'L2Monster', 'Mystic', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 17859, 1659, 898, 419, 613, 279, 253, 1000, 506, 3939, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1537, 21732, 'Forbidden Path Invader Shaman', '', 'banshee', 9.00, 23.00, 63, 'female', 'L2Monster', 'Mystic', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 20606, 1860, 822, 398, 562, 266, 253, 1000, 506, 3939, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1538, 21733, 'Forbidden Path Invader Priest', '', 'banshee', 9.00, 23.00, 60, 'female', 'L2Monster', 'Priest', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 12091, 1050, 717, 370, 490, 246, 253, 0, 506, 3939, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1539, 21734, 'Forbidden Path Invader Magus', '', 'banshee', 9.00, 23.00, 65, 'female', 'L2Monster', 'Mystic', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 14102, 1310, 898, 419, 613, 279, 253, 1000, 506, 3939, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1540, 21735, 'Forbidden Path Invader Martyrs', '', 'banshee', 9.00, 23.00, 60, 'female', 'L2Monster', 'Mystic', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 12217, 1060, 717, 370, 490, 246, 253, 0, 506, 3939, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1541, 21736, 'Forbidden Path Invader Warrior', '', 'skeleton_royal_guard', 11.00, 28.50, 63, 'male', 'L2Monster', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 13248, 1196, 822, 398, 562, 266, 253, 1000, 506, 946, 946, 0, 80, 165, 'ssq_clan', 300, 0, 20, 131, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1542, 21737, 'Forbidden Path Invader Soldier', '', 'doll_blader', 6.00, 12.00, 60, 'male', 'L2Monster', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 12862, 1116, 717, 370, 490, 246, 253, 1000, 506, 5129, 5129, 0, 22, 165, 'ssq_clan', 300, 0, 0, 109, 7, 10, 8, 0, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1543, 21738, 'Forbidden Path Invader Disciple', '', 'skeleton_royal_guard', 11.00, 28.50, 63, 'male', 'L2Monster', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 13950, 1259, 822, 398, 562, 266, 253, 0, 506, 946, 946, 0, 80, 165, 'ssq_clan', 300, 0, 20, 131, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1544, 21739, 'Forbidden Path Invader Berserker', '', 'skeleton_royal_guard', 11.00, 28.50, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 18474, 1716, 898, 419, 613, 279, 253, 1000, 506, 946, 946, 0, 80, 165, 'ssq_clan', 300, 0, 20, 136, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1545, 21740, 'Forbidden Path Invader Food', '', 'mimic', 8.50, 8.50, 60, 'male', 'L2Chest', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 5236, 454, 717, 370, 490, 246, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1546, 21741, 'Forbidden Path Invader Elite Soldier', '', 'bloody_queen', 14.00, 40.00, 65, 'female', 'L2Monster', 'Mystic', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 33094, 3074, 898, 419, 613, 279, 253, 1000, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1547, 21742, 'Forbidden Path Invader Elite Soldier', '', 'bloody_queen', 14.00, 40.00, 65, 'female', 'L2Monster', 'Mystic', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 33720, 3133, 898, 419, 613, 279, 253, 1000, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1548, 21743, 'Forbidden Path Invader Elite Soldier', '', 'bloody_queen', 14.00, 40.00, 65, 'female', 'L2Monster', 'Mystic', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 1315, 122, 898, 419, 613, 279, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1549, 21744, 'Forbidden Path Invader Elite Soldier', '', 'bloody_queen', 14.00, 40.00, 60, 'female', 'L2Monster', 'Mystic', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 3110, 270, 717, 370, 490, 246, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1550, 21745, 'Forbidden Path Invader Warrior', '', 'skeleton_royal_guard', 11.00, 28.50, 63, 'male', 'L2Monster', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 31766, 2868, 822, 398, 562, 266, 253, 1000, 506, 946, 946, 0, 80, 165, 'ssq_clan', 300, 0, 20, 131, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1551, 21746, 'Forbidden Path Invader Elite Soldier', '', 'bloody_queen', 14.00, 40.00, 60, 'female', 'L2Monster', 'Mystic', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 27952, 2426, 717, 370, 490, 246, 253, 1000, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1552, 21747, 'Forbidden Path Invader Elite Soldier', '', 'bloody_queen', 14.00, 40.00, 63, 'female', 'L2Monster', 'Mystic', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 30818, 2782, 822, 398, 562, 266, 253, 1000, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1553, 21748, 'Forbidden Path Invader Elite Soldier', '', 'bloody_queen', 14.00, 40.00, 60, 'female', 'L2Monster', 'Mystic', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 27557, 2392, 717, 370, 490, 246, 253, 1000, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1554, 21749, 'Forbidden Path Invader Elite Soldier', '', 'bloody_queen', 14.00, 40.00, 65, 'female', 'L2Monster', 'Mystic', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 32342, 3005, 898, 419, 613, 279, 253, 1000, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1555, 21750, 'Forbidden Path Invader Magus', '', 'banshee', 9.00, 23.00, 63, 'female', 'L2Monster', 'Mystic', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 29382, 2653, 822, 398, 562, 266, 253, 0, 506, 3939, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1556, 21751, 'Dark Omen Invader Soldier', '', 'giant_zombie', 13.00, 40.00, 70, 'male', 'L2Monster', 'Mystic', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 23802, 2360, 1096, 471, 747, 313, 253, 0, 506, 0, 0, 0, 20, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1557, 21752, 'Dark Omen Invader Soldier', '', 'giant_zombie', 13.00, 40.00, 75, 'male', 'L2Monster', 'Mystic', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 28565, 3013, 1304, 523, 891, 349, 253, 1000, 506, 0, 0, 0, 20, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1558, 21753, 'Dark Omen Invader Archer', '', 'skeleton_archer', 11.00, 27.00, 73, 'male', 'L2Monster', 'Ranger', 1100, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 21912, 2255, 1220, 502, 833, 334, 253, 1000, 506, 288, 0, 0, 40, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1559, 21754, 'Dark Omen Invader Elite Soldier', '', 'doll_master', 20.00, 42.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 23777, 2508, 1304, 523, 891, 349, 253, 1000, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1560, 21755, 'Dark Omen Invader Shaman', '', 'doll_master', 20.00, 42.00, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 27667, 2847, 1220, 502, 833, 334, 253, 1000, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1561, 21756, 'Dark Omen Invader Priest', '', 'doll_master', 20.00, 42.00, 70, 'male', 'L2Monster', 'Priest', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 16457, 1632, 1096, 471, 747, 313, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1562, 21757, 'Dark Omen Invader Magus', '', 'doll_master', 20.00, 42.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 18775, 1980, 1304, 523, 891, 349, 253, 1000, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1563, 21758, 'Dark Omen Invader Martyrs', '', 'doll_master', 20.00, 42.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 16629, 1649, 1096, 471, 747, 313, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1564, 21759, 'Dark Omen Invader Warrior', '', 'imperial_warlord_zombie', 7.00, 30.00, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 17787, 1830, 1220, 502, 833, 334, 253, 1000, 506, 134, 6721, 0, 39, 165, 'ssq_clan', 300, 0, 20, 155, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1565, 21760, 'Dark Omen Invader Soldier', '', 'giant_zombie', 13.00, 40.00, 70, 'male', 'L2Monster', 'Mystic', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 17506, 1736, 1096, 471, 747, 313, 253, 1000, 506, 0, 0, 0, 20, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1566, 21761, 'Dark Omen Invader Disciple', '', 'imperial_warlord_zombie', 7.00, 30.00, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 18730, 1927, 1220, 502, 833, 334, 253, 0, 506, 134, 6721, 0, 39, 165, 'ssq_clan', 300, 0, 20, 155, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1567, 21762, 'Dark Omen Invader Berserker', '', 'imperial_warlord_zombie', 7.00, 30.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 24596, 2594, 1304, 523, 891, 349, 253, 1000, 506, 134, 6721, 0, 39, 165, 'ssq_clan', 300, 0, 20, 160, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1568, 21763, 'Dark Omen Invader Food', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2Chest', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 7127, 707, 1096, 471, 747, 313, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1569, 21764, 'Dark Omen Invader Elite Soldier', '', 'death_blader', 15.00, 45.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 44060, 4647, 1304, 523, 891, 349, 253, 1000, 506, 1472, 0, 0, 100, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1570, 21765, 'Dark Omen Invader Elite Soldier', '', 'death_blader', 15.00, 45.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 44894, 4735, 1304, 523, 891, 349, 253, 1000, 506, 1472, 0, 0, 100, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1571, 21766, 'Dark Omen Invader Elite Soldier', '', 'death_blader', 15.00, 45.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 1751, 185, 1304, 523, 891, 349, 253, 0, 506, 1472, 0, 0, 100, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1572, 21767, 'Dark Omen Invader Elite Soldier', '', 'death_blader', 15.00, 45.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 4233, 420, 1096, 471, 747, 313, 253, 0, 506, 1472, 0, 0, 100, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1573, 21768, 'Dark Omen Invader Warrior', '', 'imperial_warlord_zombie', 7.00, 30.00, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 42650, 4389, 1220, 502, 833, 334, 253, 1000, 506, 134, 6721, 0, 39, 165, 'ssq_clan', 300, 0, 20, 155, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1574, 21769, 'Dark Omen Invader Elite Soldier', '', 'death_blader', 15.00, 45.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 38046, 3772, 1096, 471, 747, 313, 253, 1000, 506, 1472, 0, 0, 100, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1575, 21770, 'Dark Omen Invader Elite Soldier', '', 'death_blader', 15.00, 45.00, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 41377, 4258, 1220, 502, 833, 334, 253, 1000, 506, 1472, 0, 0, 100, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1576, 21771, 'Dark Omen Invader Elite Soldier', '', 'death_blader', 15.00, 45.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 37509, 3719, 1096, 471, 747, 313, 253, 1000, 506, 1472, 0, 0, 100, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1577, 21772, 'Dark Omen Invader Elite Soldier', '', 'death_blader', 15.00, 45.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 43058, 4542, 1304, 523, 891, 349, 253, 1000, 506, 1472, 0, 0, 100, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1578, 21773, 'Dark Omen Invader Magus', '', 'doll_master', 20.00, 42.00, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 39450, 4059, 1220, 502, 833, 334, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1579, 21774, 'Messenger Invader Soldier', '', 'giant_zombie', 13.00, 40.00, 78, 'male', 'L2Monster', 'Mystic', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 31088, 3489, 1525, 581, 1062, 387, 253, 0, 506, 0, 0, 0, 20, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 7, 0, 2, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1580, 21775, 'Messenger Invader Soldier', '', 'giant_zombie', 13.00, 40.00, 78, 'male', 'L2Monster', 'Mystic', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 36690, 4367, 1725, 635, 1237, 448, 253, 1000, 506, 0, 0, 0, 20, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1581, 21776, 'Messenger Invader Archer', '', 'skeleton_archer', 11.00, 27.00, 78, 'male', 'L2Monster', 'Ranger', 1100, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 28326, 3293, 1647, 613, 1167, 424, 253, 1000, 506, 289, 0, 0, 40, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 5, 1500, 5, 0.80, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1582, 21777, 'Messenger Invader Elite Soldier', '', 'doll_master', 20.00, 42.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 30540, 3635, 1725, 635, 1237, 448, 253, 1000, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 7, 0, 7, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1583, 21778, 'Messenger Invader Shaman', '', 'doll_master', 20.00, 42.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 35766, 4158, 1647, 613, 1167, 424, 253, 1000, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 5, 0, 5, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1584, 21779, 'Messenger Invader Priest', '', 'doll_master', 20.00, 42.00, 78, 'male', 'L2Monster', 'Priest', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 21494, 2413, 1525, 581, 1062, 387, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 2, 0, 2, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1585, 21780, 'Messenger Invader Magus', '', 'doll_master', 20.00, 42.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 24116, 2871, 1725, 635, 1237, 448, 253, 1000, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 7, 0, 7, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1586, 21781, 'Messenger Invader Martyrs', '', 'doll_master', 20.00, 42.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 21719, 2438, 1525, 581, 1062, 387, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 2, 0, 2, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1587, 21782, 'Messenger Invader Warrior', '', 'imperial_warlord_zombie', 7.00, 30.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 22994, 2673, 1647, 613, 1167, 424, 253, 1000, 506, 134, 6721, 0, 39, 165, 'ssq_clan', 300, 0, 20, 177, 7, 30, 4, 10, 0, 5, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1588, 21783, 'Messenger Invader Soldier', '', 'giant_zombie', 13.00, 40.00, 78, 'male', 'L2Monster', 'Mystic', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 22865, 2566, 1525, 581, 1062, 387, 253, 1000, 506, 0, 0, 0, 20, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 7, 0, 2, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1589, 21784, 'Messenger Invader Disciple', '', 'imperial_warlord_zombie', 7.00, 30.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 24213, 2815, 1647, 613, 1167, 424, 253, 0, 506, 134, 6721, 0, 39, 165, 'ssq_clan', 300, 0, 20, 177, 7, 30, 4, 10, 0, 5, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1590, 21785, 'Messenger Invader Berserker', '', 'imperial_warlord_zombie', 7.00, 30.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 31592, 3760, 1725, 635, 1237, 448, 253, 1000, 506, 134, 6721, 0, 39, 165, 'ssq_clan', 300, 0, 20, 181, 7, 30, 4, 12, 0, 7, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1591, 21786, 'Messenger Invader Food', '', 'mimic', 8.50, 8.50, 78, 'male', 'L2Chest', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 9308, 1045, 1525, 581, 1062, 387, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 7, 0, 2, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1592, 21787, 'Messenger Invader Elite Soldier', '', 'death_lord', 21.00, 40.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 56592, 6736, 1725, 635, 1237, 448, 253, 1000, 506, 78, 0, 0, 40, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1593, 21788, 'Messenger Invader Elite Soldier', '', 'death_lord', 21.00, 40.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 57664, 6864, 1725, 635, 1237, 448, 253, 1000, 506, 78, 0, 0, 40, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1594, 21789, 'Messenger Invader Elite Soldier', '', 'death_lord', 21.00, 40.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 2249, 268, 1725, 635, 1237, 448, 253, 0, 506, 78, 0, 0, 40, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1595, 21790, 'Messenger Invader Elite Soldier', '', 'death_lord', 21.00, 40.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 5529, 621, 1525, 581, 1062, 387, 253, 0, 506, 78, 0, 0, 40, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 7, 0, 2, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1596, 21791, 'Messenger Invader Warrior', '', 'imperial_warlord_zombie', 7.00, 30.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 55136, 6409, 1647, 613, 1167, 424, 253, 1000, 506, 134, 6721, 0, 39, 165, 'ssq_clan', 300, 0, 20, 177, 7, 30, 4, 10, 0, 5, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1597, 21792, 'Messenger Invader Elite Soldier', '', 'death_lord', 21.00, 40.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 49693, 5578, 1525, 581, 1062, 387, 253, 1000, 506, 78, 0, 0, 40, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 7, 0, 2, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1598, 21793, 'Messenger Invader Elite Soldier', '', 'death_lord', 21.00, 40.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 53490, 6218, 1647, 613, 1167, 424, 253, 1000, 506, 78, 0, 0, 40, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 10, 0, 5, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1599, 21794, 'Messenger Invader Elite Soldier', '', 'death_lord', 21.00, 40.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 48991, 5499, 1525, 581, 1062, 387, 253, 1000, 506, 78, 0, 0, 40, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 7, 0, 2, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1600, 21795, 'Messenger Invader Elite Soldier', '', 'death_lord', 21.00, 40.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 55306, 6583, 1725, 635, 1237, 448, 253, 1000, 506, 78, 0, 0, 40, 165, 'ssq_clan', 300, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1601, 21796, 'Messenger Invader Magus', '', 'doll_master', 20.00, 42.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 50999, 5928, 1647, 613, 1167, 424, 253, 0, 506, 0, 0, 0, 80, 165, 'ssq_clan', 300, 0, 0, 0, 7, 10, 8, 5, 0, 5, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1602, 21797, 'Spirit of Timiniel', '', 'pixy', 5.00, 25.00, 55, 'female', 'L2Monster', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 2376, 192, 559, 323, 382, 215, 253, 0, 506, 0, 0, 0, 80, 165, 'timiniel_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1603, 21798, 'Ghost of a Gatekeeper', '', 'skeleton_knight', 10.00, 25.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 14209, 1519, 1345, 535, 919, 356, 253, 0, 506, 150, 103, 0, 40, 165, '', 300, 0, 20, 162, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1604, 21799, 'Ghost of a Gatekeeper', '', 'skeleton_knight', 10.00, 25.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 26132, 2794, 1345, 535, 919, 356, 253, 0, 506, 150, 103, 0, 40, 165, '', 300, 0, 20, 162, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1605, 21800, 'Vassal Ghost', '', 'zombie', 13.00, 21.00, 77, 'male', 'L2Monster', 'Mystic', 40, 2762, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 13234, 1432, 1388, 544, 948, 364, 253, 0, 506, 0, 0, 0, 15, 15, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1606, 21801, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 21, 'male', 'L2Chest', 'Fighter', 40, 364, 3.500, 205, 1.500, 40, 43, 30, 21, 20, 20, 631, 29, 53, 99, 36, 66, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1607, 21802, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 24, 'male', 'L2Chest', 'Fighter', 40, 435, 3.500, 246, 1.500, 40, 43, 30, 21, 20, 20, 772, 38, 68, 112, 46, 75, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1608, 21803, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 27, 'male', 'L2Chest', 'Fighter', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 919, 47, 87, 125, 59, 84, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1609, 21804, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 30, 'male', 'L2Chest', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1080, 59, 111, 140, 75, 94, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1610, 21805, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 33, 'male', 'L2Chest', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 1307, 75, 138, 157, 94, 105, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1611, 21806, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 36, 'male', 'L2Chest', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 1555, 94, 173, 176, 118, 118, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1612, 21807, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 39, 'male', 'L2Chest', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 1825, 116, 212, 195, 145, 131, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1613, 21808, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 42, 'male', 'L2Chest', 'Fighter', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 2117, 141, 259, 216, 177, 144, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1614, 21809, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 45, 'male', 'L2Chest', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 2430, 169, 315, 239, 214, 158, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1615, 21810, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 48, 'male', 'L2Chest', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 2765, 202, 378, 262, 258, 174, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1616, 21811, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 51, 'male', 'L2Chest', 'Fighter', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 3121, 238, 449, 287, 307, 190, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1617, 21812, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 54, 'male', 'L2Chest', 'Fighter', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 3499, 279, 531, 313, 362, 209, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1618, 21813, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 57, 'male', 'L2Chest', 'Fighter', 40, 1777, 6.500, 948, 2.400, 40, 43, 30, 21, 20, 20, 3899, 324, 619, 340, 423, 226, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1619, 21814, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 60, 'male', 'L2Chest', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 4320, 375, 717, 370, 490, 246, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1620, 21815, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 63, 'male', 'L2Chest', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 4763, 430, 822, 398, 562, 266, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1621, 21816, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 66, 'male', 'L2Chest', 'Fighter', 40, 2245, 7.500, 1220, 2.700, 40, 43, 30, 21, 20, 20, 5227, 492, 936, 429, 639, 285, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1622, 21817, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 69, 'male', 'L2Chest', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 5713, 559, 1055, 460, 720, 307, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1623, 21818, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 72, 'male', 'L2Chest', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 6221, 632, 1179, 491, 805, 327, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1624, 21819, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 75, 'male', 'L2Chest', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 6750, 712, 1304, 523, 891, 349, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1625, 21820, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 78, 'male', 'L2Chest', 'Fighter', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 7301, 799, 1430, 556, 975, 371, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1626, 21821, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 78, 'male', 'L2Chest', 'Fighter', 40, 3004, 8.755, 1760, 3.090, 40, 43, 30, 21, 20, 20, 7873, 894, 1571, 595, 1106, 396, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 12, 0, 4, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1627, 21822, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 80, 'male', 'L2Chest', 'Fighter', 40, 3137, 8.840, 1884, 3.120, 40, 43, 30, 21, 20, 20, 8467, 996, 1698, 629, 1207, 419, 253, 0, 506, 0, 0, 0, 80, 165, '', 300, 0, 0, 0, 7, 50, 1, 17, 0, 4, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1628, 21823, 'Executor of Sacrificial Offerings', '', 'imperial_warlord_zombie', 7.00, 30.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 72252, 8110, 1525, 581, 1062, 387, 253, 0, 506, 134, 6721, 0, 39, 190, 'tomb_clan', 300, 0, 20, 171, 7, 30, 4, 7, 0, 2, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1629, 21824, 'Alpine Kookaburra', '', 'rough_ostrich', 10.00, 33.00, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 30997, 2880, 898, 419, 613, 279, 253, 150, 506, 0, 0, 0, 23, 210, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1630, 21825, 'Alpine Kookaburra', '', 'rough_ostrich', 10.00, 33.00, 65, 'male', 'L2FeedableBeast', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 29568, 2747, 898, 419, 613, 279, 253, 150, 506, 0, 0, 0, 23, 210, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1631, 21826, 'Alpine Buffalo', '', 'buffalo', 22.00, 31.00, 67, 'male', 'L2FeedableBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 32934, 3137, 975, 440, 666, 292, 253, 150, 506, 0, 0, 0, 20, 170, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1632, 21827, 'Alpine Buffalo', '', 'buffalo', 22.00, 31.00, 67, 'male', 'L2FeedableBeast', 'Fighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 31415, 2992, 975, 440, 666, 292, 253, 150, 506, 0, 0, 0, 20, 170, 'pet_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1633, 21828, 'Alpine Cougar', '', 'saber_toothed_tiger', 34.00, 28.00, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 34929, 3418, 1055, 460, 720, 307, 253, 150, 506, 0, 0, 0, 60, 200, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1634, 21829, 'Alpine Cougar', '', 'saber_toothed_tiger', 34.00, 28.00, 69, 'male', 'L2FeedableBeast', 'Fighter', 40, 2395, 7.500, 1314, 2.700, 40, 43, 30, 21, 20, 20, 33319, 3260, 1055, 460, 720, 307, 253, 150, 506, 0, 0, 0, 60, 200, 'pet_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1635, 22001, 'Grim Wolf', '', 'dire_wolf', 13.00, 11.00, 25, 'male', 'L2Monster', 'Fighter', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 1052, 52, 74, 116, 50, 86, 253, 0, 506, 0, 0, 0, 24, 130, '1', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1636, 22002, 'Grim Grizzly', '', 'grizzly', 21.00, 40.00, 26, 'male', 'L2Monster', 'Fighter', 40, 488, 3.500, 273, 1.500, 40, 43, 30, 21, 20, 20, 1120, 56, 81, 121, 55, 89, 253, 500, 506, 0, 0, 0, 40, 110, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1637, 22003, 'Grave Robber Scout', '', 'e_traderB_Fdwarf_mon', 7.00, 18.00, 27, 'female', 'L2Monster', 'Ranger', 1100, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 1395, 71, 87, 125, 59, 92, 253, 0, 506, 8527, 0, 0, 49, 110, 'thief_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1638, 22004, 'Grave Robber Lookout', '', 'dwarf_ghost', 9.00, 16.50, 27, 'male', 'L2Monster', 'Fighter', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 1659, 84, 87, 125, 59, 92, 253, 500, 506, 0, 0, 0, 80, 120, 'thief_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1639, 22005, 'Grave Robber Ranger', '', 'e_collector_teacher_Fdwarf_mon', 8.00, 17.50, 28, 'female', 'L2Monster', 'Fighter', 40, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 1477, 77, 95, 131, 64, 96, 253, 0, 506, 8529, 0, 0, 45, 110, 'thief_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1640, 22006, 'Grave Robber Guard', '', 'e_collector_teacher_Mdwarf_mon', 8.00, 17.50, 29, 'male', 'L2Monster', 'Fighter', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 1559, 83, 101, 136, 70, 99, 253, 500, 506, 8528, 0, 0, 36, 110, 'thief_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1641, 22007, 'Ghost of a Soldier', '', 'orc', 10.00, 21.00, 29, 'male', 'L2Monster', 'Fighter', 40, 573, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 1699, 90, 101, 136, 70, 99, 253, 500, 506, 8530, 0, 0, 45, 120, 'grudge_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1642, 22008, 'Grave Robber Fighter', '', 'e_collector_teacher_Mdwarf_mon', 8.00, 17.50, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1641, 89, 111, 140, 75, 104, 253, 0, 506, 8528, 0, 0, 36, 110, 'thief_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1643, 22009, 'Ghost of a Loyal Vassal', '', 'orc_shaman', 9.00, 22.00, 31, 'male', 'L2Monster', 'Mystic', 40, 636, 4.500, 344, 1.800, 40, 43, 30, 21, 20, 20, 1910, 106, 119, 146, 82, 107, 253, 0, 506, 8532, 0, 0, 45, 120, 'grudge_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1644, 22010, 'Ghost of a General', '', 'orc_fighter', 12.00, 22.00, 32, 'male', 'L2Monster', 'Fighter', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 2035, 114, 128, 152, 87, 111, 253, 500, 506, 8532, 0, 0, 45, 120, 'grudge_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1645, 22011, 'Ghost of a Batur Chief', '', 'orc_champion', 10.00, 23.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 2337, 133, 138, 157, 94, 116, 253, 500, 506, 8533, 0, 0, 45, 130, 'grudge_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1646, 22012, 'Ghost of a Batur Chief', '', 'orc_champion', 10.00, 23.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 2337, 133, 138, 157, 94, 116, 253, 500, 506, 8533, 0, 0, 45, 130, 'grudge_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1647, 22013, 'Ghost of a Morek Chief', '', 'orc_champion', 10.00, 23.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 2337, 133, 138, 157, 94, 116, 253, 500, 506, 8533, 0, 0, 45, 130, 'grudge_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1648, 22014, 'Ghost of a Morek Chief', '', 'orc_champion', 10.00, 23.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 2337, 133, 138, 157, 94, 116, 253, 500, 506, 8533, 0, 0, 45, 130, 'grudge_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1649, 22015, 'Ghost of a Turka Chief', '', 'orc_champion', 10.00, 23.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 2337, 133, 138, 157, 94, 116, 253, 500, 506, 8533, 0, 0, 45, 130, 'grudge_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1650, 22016, 'Ghost of a Turka Chief', '', 'orc_champion', 10.00, 23.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 2337, 133, 138, 157, 94, 116, 253, 500, 506, 8533, 0, 0, 45, 130, 'grudge_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1651, 22017, 'Bandit Sweeper', '', 'northern_goblin', 4.00, 15.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1750, 95, 111, 140, 75, 104, 253, 500, 506, 152, 0, 0, 30, 145, 'brigand_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1652, 22018, 'Bandit Hound', '', 'dire_wolf', 13.00, 11.00, 31, 'male', 'L2Monster', 'Fighter', 40, 636, 4.500, 344, 1.800, 40, 43, 30, 21, 20, 20, 1501, 83, 119, 146, 82, 107, 253, 500, 506, 0, 0, 0, 24, 130, 'brigand_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1653, 22019, 'Bandit Watchman', '', 'ol_mahum_archer_04te', 14.00, 25.00, 32, 'male', 'L2Monster', 'Ranger', 1100, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 2056, 115, 128, 152, 87, 111, 253, 500, 506, 273, 0, 0, 50, 130, 'brigand_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.93, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1654, 22020, 'Snow Lynx', '', 'onyx_beast', 14.00, 14.50, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 1701, 97, 138, 157, 94, 116, 253, 0, 506, 0, 0, 0, 30, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1655, 22021, 'Bandit Undertaker', '', 'northern_goblin_110p', 6.00, 16.60, 34, 'male', 'L2Monster', 'Fighter', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 2081, 121, 149, 164, 102, 119, 253, 0, 506, 66, 102, 0, 30, 140, 'brigand_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1656, 22022, 'Bandit Assassin', '', 'wererat_01te', 14.00, 25.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 2470, 145, 160, 170, 109, 124, 253, 500, 506, 221, 0, 0, 80, 150, 'brigand_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1657, 22023, 'Bandit Warrior', '', 'ol_mahum_04te', 13.50, 25.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 2825, 170, 173, 176, 118, 129, 253, 500, 506, 2, 0, 0, 50, 135, 'brigand_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1658, 22024, 'Bandit Inspector', '', 'northern_goblin_120p', 7.00, 18.50, 37, 'male', 'L2Monster', 'Fighter', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 2661, 163, 185, 181, 126, 134, 253, 500, 506, 66, 0, 0, 30, 145, 'brigand_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1659, 22025, 'Frozen Wasteland Werewolf', '', 'werewolf', 10.00, 26.00, 38, 'male', 'L2Monster', 'Fighter', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 2662, 166, 198, 188, 136, 138, 253, 0, 506, 0, 0, 0, 50, 145, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1660, 22026, 'Bandit Captain', '', 'ol_mahum_champion_04te', 14.00, 27.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 3488, 224, 227, 203, 155, 148, 253, 500, 506, 69, 19, 0, 50, 145, 'brigand_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1661, 22027, 'Forgotten Crewman', '', 'dwarf_ghost', 9.00, 16.50, 39, 'male', 'L2Monster', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 6847, 416, 212, 195, 145, 143, 253, 0, 506, 0, 0, 0, 80, 140, 'undead_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1662, 22028, 'Vagabond of the Ruins', '', 'a_mageguild_teacher_Mhuman_mon', 8.00, 23.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 6162, 380, 227, 203, 155, 148, 253, 500, 506, 8530, 0, 0, 50, 140, 'undead_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1663, 22029, 'Ragna Orc', '', 'batur_orc_03te', 9.00, 21.50, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 3620, 233, 227, 203, 155, 148, 253, 500, 506, 2, 0, 0, 80, 140, 'ragna_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1664, 22030, 'Ragna Orc Shaman', '', 'batur_orc_shaman_a_03te', 11.00, 16.00, 42, 'male', 'L2Monster', 'Mystic', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 3782, 251, 259, 216, 177, 159, 253, 500, 506, 159, 0, 0, 50, 140, 'ragna_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1665, 22031, 'Ragna Orc Archer', '', 'batur_orc_archer_03te', 11.00, 21.50, 43, 'male', 'L2Monster', 'Ranger', 1100, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 3499, 236, 277, 223, 189, 164, 253, 500, 506, 13, 0, 0, 45, 130, 'ragna_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.96, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1666, 22032, 'Ragna Orc Warrior', '', 'batur_orc_warrior_03te', 10.00, 20.00, 44, 'male', 'L2Monster', 'Fighter', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 4380, 299, 295, 230, 202, 169, 253, 500, 506, 68, 0, 0, 80, 140, 'ragna_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1667, 22033, 'Ragna Orc Mage', '', 'batur_orc_shaman_a_01te', 11.00, 16.00, 45, 'male', 'L2Monster', 'Mystic', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 5625, 391, 315, 239, 214, 174, 253, 500, 506, 179, 0, 0, 50, 140, 'ragna_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1668, 22034, 'Ragna Orc Mage', '', 'batur_orc_shaman_a_01te', 11.00, 16.00, 45, 'male', 'L2Monster', 'Mystic', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 5158, 358, 315, 239, 214, 174, 253, 500, 506, 179, 0, 0, 50, 140, 'ragna_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1669, 22035, 'Ragna Orc Mage', '', 'batur_orc_shaman_a_01te', 11.00, 16.00, 45, 'male', 'L2Monster', 'Mystic', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 5625, 391, 315, 239, 214, 174, 253, 500, 506, 179, 0, 0, 50, 140, 'ragna_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1670, 22036, 'Ragna Orc Mage', '', 'batur_orc_shaman_a_01te', 11.00, 16.00, 45, 'male', 'L2Monster', 'Mystic', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 3963, 275, 315, 239, 214, 174, 253, 500, 506, 179, 0, 0, 50, 140, 'ragna_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1671, 22037, 'Ragna Orc Healer', '', 'batur_orc_shaman_a_03te', 11.00, 16.00, 45, 'male', 'L2Monster', 'Priest', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 4342, 301, 315, 239, 214, 174, 253, 500, 506, 316, 0, 0, 50, 140, 'ragna_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1672, 22038, 'Ragna Orc Hero', '', 'batur_orc_overlord_03te', 12.00, 24.00, 48, 'male', 'L2Monster', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 5213, 380, 378, 262, 258, 192, 253, 500, 506, 74, 0, 0, 80, 140, 'ragna_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1673, 22039, 'Ragna Orc Commander', '', 'batur_orc_overlord_01te', 12.00, 24.00, 49, 'male', 'L2Monster', 'Fighter', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 5432, 401, 400, 270, 273, 197, 253, 500, 506, 135, 0, 0, 80, 140, 'ragna_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1674, 22040, 'Ragna Orc Sniper', '', 'batur_orc_archer_01te', 11.00, 21.50, 47, 'male', 'L2Monster', 'Ranger', 1100, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 4180, 299, 356, 254, 243, 186, 253, 500, 506, 275, 0, 0, 45, 140, 'ragna_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.96, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1675, 22041, 'Ragna Orc Sorcerer', '', 'batur_orc_shaman_a_01te', 11.00, 16.00, 50, 'male', 'L2Monster', 'Mystic', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 6944, 522, 425, 278, 291, 204, 253, 500, 506, 7, 0, 0, 50, 140, 'ragna_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1676, 22042, 'Ragna Orc Sorcerer', '', 'batur_orc_shaman_a_01te', 11.00, 16.00, 50, 'male', 'L2Monster', 'Mystic', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 6368, 479, 425, 278, 291, 204, 253, 500, 506, 7, 0, 0, 50, 140, 'ragna_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1677, 22043, 'Ragna Orc Sorcerer', '', 'batur_orc_shaman_a_01te', 11.00, 16.00, 50, 'male', 'L2Monster', 'Mystic', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 6944, 522, 425, 278, 291, 204, 253, 500, 506, 7, 0, 0, 50, 140, 'ragna_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1678, 22044, 'Ragna Orc Sorcerer', '', 'batur_orc_shaman_a_01te', 11.00, 16.00, 50, 'male', 'L2Monster', 'Mystic', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 4892, 368, 425, 278, 291, 204, 253, 500, 506, 7, 0, 0, 50, 140, 'ragna_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1679, 22045, 'Dark Corpse', '', 'zombie_02te', 13.00, 21.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 1555, 96, 227, 203, 155, 148, 253, 500, 506, 0, 0, 0, 15, 15, 'ragna_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1680, 22046, 'Varangkas Dre Vanul', '', 'dre_vanul', 14.00, 36.00, 46, 'male', 'L2Monster', 'Fighter', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 1720, 116, 335, 246, 228, 180, 253, 0, 506, 0, 0, 0, 80, 100, 'ragna_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1681, 22047, 'Guardian of the Ghost Town', '', 'monster_eye_05te', 21.00, 43.00, 44, 'male', 'L2Monster', 'Mystic', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 1499, 98, 295, 230, 202, 169, 253, 500, 506, 0, 0, 0, 90, 100, 'ragna_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1682, 22048, 'Dark Spider', '', 'giant_spider_04te', 26.00, 25.50, 42, 'male', 'L2Monster', 'Fighter', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 1433, 91, 259, 216, 177, 159, 253, 500, 506, 0, 0, 0, 72, 150, 'ragna_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1683, 22049, 'Varangkas Succubus', '', 'succubus_05te', 10.00, 36.00, 49, 'female', 'L2Monster', 'Fighter', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 1951, 138, 400, 270, 273, 197, 253, 0, 506, 0, 0, 0, 60, 120, 'ragna_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1684, 22050, 'Probe Golem Prodigy IV', '', 'golem_microscout', 12.00, 43.50, 46, 'male', 'L2Monster', 'Fighter', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 4787, 338, 335, 246, 228, 180, 253, 500, 506, 0, 0, 0, 30, 190, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1685, 22051, 'Spelunking Spider', '', 'giant_spider_05te', 26.00, 25.50, 47, 'male', 'L2Monster', 'Fighter', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 3673, 263, 356, 254, 243, 186, 253, 0, 506, 0, 0, 0, 72, 150, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1686, 22052, 'Menacing Jackhammer Golem', '', 'golem_prop', 23.00, 32.80, 47, 'male', 'L2Monster', 'Fighter', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 5386, 385, 356, 254, 243, 186, 253, 500, 506, 0, 0, 0, 72, 180, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1687, 22053, 'Horrifying Cannon Golem I', '', 'golem_cannon_catapult', 23.50, 34.70, 48, 'male', 'L2Monster', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 5286, 385, 378, 262, 258, 192, 253, 500, 506, 0, 0, 0, 130, 180, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1688, 22054, 'Horrifying Cannon Golem IV', '', 'golem_cannon_catapult', 23.50, 34.70, 48, 'male', 'L2Monster', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 5451, 397, 378, 262, 258, 192, 253, 500, 506, 0, 0, 0, 130, 180, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1689, 22055, 'Cruel Vice Golem', '', 'golem_repair', 23.00, 32.80, 49, 'male', 'L2Monster', 'Fighter', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 5854, 432, 400, 270, 273, 197, 253, 500, 506, 0, 0, 0, 72, 140, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1690, 22056, 'Probe Golem Champion I', '', 'golem_microscout', 12.00, 43.50, 49, 'male', 'L2Monster', 'Fighter', 40, 1372, 5.500, 720, 2.100, 40, 43, 30, 21, 20, 20, 5266, 389, 400, 270, 273, 197, 253, 500, 506, 0, 0, 0, 30, 140, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1691, 22057, 'Spelunking Ant', '', 'ant_soldier', 35.00, 17.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 4157, 312, 425, 278, 291, 204, 253, 500, 506, 0, 0, 0, 80, 150, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1692, 22058, 'Horrifying Excavator Golem III', '', 'golem_carrier', 23.00, 32.80, 51, 'male', 'L2Monster', 'Fighter', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 6341, 482, 449, 287, 307, 210, 253, 500, 506, 0, 0, 0, 72, 150, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1693, 22059, 'Bloodthirsty Ginzu Golem VII', '', 'golem_guardian_090p', 16.00, 37.20, 51, 'male', 'L2Monster', 'Fighter', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 17098, 1244, 449, 287, 307, 210, 253, 500, 506, 0, 0, 0, 50, 150, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1694, 22060, 'Horrifying Cannon Golem', '', 'golem_cannon_catapult_a', 23.50, 34.70, 52, 'male', 'L2Monster', 'Fighter', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 14861, 1116, 475, 296, 324, 216, 253, 500, 506, 0, 0, 0, 130, 180, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1695, 22061, 'Horrifying Cannon Golem III', '', 'golem_microscout_a', 12.00, 43.50, 51, 'male', 'L2Monster', 'Fighter', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 9404, 716, 449, 287, 307, 210, 253, 0, 506, 0, 0, 0, 30, 140, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1696, 22062, 'Horrifying Jackhammer Golem', '', 'golem_prop', 23.00, 32.80, 52, 'male', 'L2Monster', 'Fighter', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 13973, 1032, 475, 296, 324, 216, 253, 500, 506, 0, 0, 0, 72, 140, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1697, 22063, 'Ginzu Golem Prodigy X', '', 'golem_guardian_090p', 16.00, 37.20, 52, 'male', 'L2Monster', 'Fighter', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 18933, 1394, 475, 296, 324, 216, 253, 500, 506, 0, 0, 0, 50, 150, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1698, 22064, 'Bloodthirsty Ginzu Golem II', '', 'golem_guardian_a_090p', 16.00, 37.20, 52, 'male', 'L2Monster', 'Fighter', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 17775, 1312, 475, 296, 324, 216, 253, 500, 506, 0, 0, 0, 50, 150, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1699, 22065, 'Horrifying Ginzu Golem V', '', 'golem_guardian', 18.00, 41.50, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 18465, 1385, 503, 304, 344, 223, 253, 500, 506, 0, 0, 0, 53, 150, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1700, 22066, 'Horrifying Cannon Golem VI', '', 'golem_cannon_catapult_a_090p', 21.00, 30.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 9936, 745, 503, 304, 344, 223, 253, 0, 506, 0, 0, 0, 130, 180, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1701, 22067, 'Horrifying Cannon Golem VI', '', 'golem_cannon_catapult_a_090p', 21.00, 30.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 9936, 745, 503, 304, 344, 223, 253, 0, 506, 0, 0, 0, 130, 180, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1702, 22068, 'Horrifying Cannon Golem VI', '', 'golem_cannon_catapult_a_090p', 21.00, 30.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 9936, 745, 503, 304, 344, 223, 253, 0, 506, 0, 0, 0, 130, 180, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1703, 22069, 'Horrifying Cannon Golem VI', '', 'golem_cannon_catapult_a_090p', 21.00, 30.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 9936, 745, 503, 304, 344, 223, 253, 0, 506, 0, 0, 0, 130, 180, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1704, 22070, 'Horrifying Cannon Golem VI', '', 'golem_cannon_catapult_a_090p', 21.00, 30.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 9936, 745, 503, 304, 344, 223, 253, 0, 506, 0, 0, 0, 130, 180, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1705, 22071, 'Horrifying Cannon Golem VI', '', 'golem_cannon_catapult_a_090p', 21.00, 30.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 9936, 745, 503, 304, 344, 223, 253, 0, 506, 0, 0, 0, 130, 180, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1706, 22072, 'Horrifying Cannon Golem VI', '', 'golem_cannon_catapult_a_090p', 21.00, 30.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 9936, 745, 503, 304, 344, 223, 253, 0, 506, 0, 0, 0, 130, 180, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1707, 22073, 'Horrifying Cannon Golem VI', '', 'golem_cannon_catapult_a_090p', 21.00, 30.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 9936, 745, 503, 304, 344, 223, 253, 0, 506, 0, 0, 0, 130, 180, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1708, 22074, 'Epic Cannon Golem', '', 'golem_cannon_catapult_a_090p', 21.00, 30.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 15438, 1178, 503, 304, 344, 223, 253, 500, 506, 0, 0, 0, 130, 180, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1709, 22075, 'Epic Cannon Golem Adjunct', '', 'golem_microscout_a', 12.00, 43.50, 52, 'male', 'L2Monster', 'Fighter', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 9777, 756, 475, 296, 324, 216, 253, 0, 506, 0, 0, 0, 30, 200, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1710, 22076, 'Deadly Ginzu Golem V', '', 'golem_guardian', 18.00, 41.50, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 18465, 1385, 503, 304, 344, 223, 253, 500, 506, 0, 0, 0, 53, 150, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1711, 22077, 'Horrifying Ginzu Golem VIII', '', 'golem_guardian_a', 18.00, 41.50, 54, 'male', 'L2Monster', 'Fighter', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 19169, 1458, 531, 313, 362, 229, 253, 500, 506, 0, 0, 0, 53, 150, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1712, 22078, 'Deadly Ginzu Golem VIII', '', 'golem_guardian_a', 18.00, 41.50, 54, 'male', 'L2Monster', 'Fighter', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 19169, 1458, 531, 313, 362, 229, 253, 500, 506, 0, 0, 0, 53, 150, 'golem_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1713, 22079, 'Lost Bandersnatch', '', 'bandersnatch_c', 18.00, 25.00, 53, 'male', 'L2Minion', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 4295, 331, 503, 304, 344, 223, 253, 0, 506, 0, 0, 0, 30, 170, 'wanimal_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1714, 22080, 'Massive Maze Bandersnatch', '', 'bandersnatch', 18.00, 25.00, 54, 'male', 'L2Monster', 'Fighter', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 4710, 368, 531, 313, 362, 229, 253, 0, 506, 0, 0, 0, 30, 170, 'wanimal_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1715, 22081, 'Lost Watcher', '', 'field_stalker', 15.00, 30.00, 53, 'male', 'L2Monster', 'Mystic', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 4393, 344, 503, 304, 344, 223, 253, 0, 506, 0, 0, 0, 70, 130, 'winter_maze_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1716, 22082, 'Elder Lost Watcher', '', 'field_stalker_110p', 16.00, 36.00, 54, 'male', 'L2Monster', 'Mystic', 40, 1622, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 5039, 401, 531, 313, 362, 229, 253, 0, 506, 0, 0, 0, 70, 170, 'winter_maze_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1717, 22083, 'Baby Panthera', '', 'saber_toothed_tiger_080p', 29.00, 22.70, 55, 'male', 'L2Minion', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 4625, 366, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 60, 170, 'wanimal_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1718, 22084, 'Panthera', '', 'saber_toothed_tiger', 34.00, 28.00, 56, 'male', 'L2Monster', 'Fighter', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 4795, 386, 589, 331, 402, 242, 253, 500, 506, 0, 0, 0, 60, 170, 'wanimal_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1719, 22085, 'Lost Gargoyle', '', 'gargoyle_02te', 16.00, 50.00, 55, 'male', 'L2Monster', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 4157, 335, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 140, 140, 'winter_maze_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1720, 22086, 'Lost Gargoyle Youngling', '', 'gargoyle_02te_110p', 17.50, 56.00, 56, 'male', 'L2Monster', 'Mystic', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 4824, 396, 589, 331, 402, 242, 253, 500, 506, 0, 0, 0, 140, 140, 'winter_maze_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1721, 22087, 'Pronghorn Spirit', '', 'antelope', 17.00, 34.00, 56, 'male', 'L2Monster', 'Fighter', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 7743, 635, 589, 331, 402, 242, 253, 0, 506, 0, 0, 0, 45, 185, 'wanimal_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1722, 22088, 'Pronghorn', '', 'antelope_110p', 19.00, 37.80, 57, 'male', 'L2Monster', 'Pronghorn', 40, 1777, 6.500, 948, 2.400, 40, 43, 30, 21, 20, 20, 4700, 390, 619, 340, 423, 250, 253, 0, 506, 0, 0, 0, 45, 185, 'wanimal_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1723, 22089, 'Ice Tarantula', '', 'giant_spider', 26.00, 25.50, 57, 'male', 'L2Monster', 'Fighter', 40, 1777, 6.500, 948, 2.400, 40, 43, 30, 21, 20, 20, 5402, 449, 619, 340, 423, 250, 253, 0, 506, 0, 0, 0, 72, 120, 'winter_maze_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1724, 22090, 'Frost Tarantula', '', 'giant_spider_110p', 32.00, 28.00, 58, 'male', 'L2Monster', 'Fighter', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 5593, 472, 651, 350, 444, 256, 253, 0, 506, 0, 0, 0, 72, 120, 'winter_maze_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1725, 22091, 'Lost Iron Golem', '', 'iron_golem_120p', 22.00, 42.50, 58, 'male', 'L2Minion', 'Fighter', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 6029, 498, 651, 350, 444, 256, 253, 0, 506, 0, 0, 0, 20, 20, 'winter_maze_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1726, 22092, 'Frost Iron Golem', '', 'iron_golem_130p', 24.00, 46.40, 59, 'male', 'L2Monster', 'Fighter', 40, 1881, 6.500, 1007, 2.400, 40, 43, 30, 21, 20, 20, 6239, 521, 684, 360, 466, 263, 253, 500, 506, 0, 0, 0, 20, 20, 'winter_maze_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1727, 22093, 'Lost Buffalo', '', 'buffalo', 22.00, 31.00, 60, 'male', 'L2Monster', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 8888, 770, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 20, 170, 'wanimal_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1728, 22094, 'Frost Buffalo', '', 'buffalo_a_110p', 24.00, 34.70, 61, 'male', 'L2Monster', 'FrostBuffalo', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 5383, 473, 752, 378, 513, 278, 253, 500, 506, 0, 0, 0, 20, 170, 'wanimal_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1729, 22095, 'Ursus Cub', '', 'grizzly', 21.00, 40.00, 61, 'male', 'L2Minion', 'Fighter', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 5689, 491, 752, 378, 513, 278, 253, 0, 506, 0, 0, 0, 40, 120, 'wanimal_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1730, 22096, 'Ursus', '', 'grizzly_120p', 21.00, 40.00, 62, 'male', 'L2Monster', 'Fighter', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 5877, 514, 787, 388, 538, 284, 253, 0, 506, 0, 0, 0, 40, 120, 'wanimal_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1731, 22097, 'Lost Yeti', '', 'yeti', 15.00, 27.50, 62, 'male', 'L2Monster', 'Fighter', 40, 2038, 7.500, 1097, 2.700, 40, 43, 30, 21, 20, 20, 6728, 599, 787, 388, 538, 284, 253, 0, 506, 0, 0, 0, 16, 170, 'winter_maze_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1732, 22098, 'Frost Yeti', '', 'yeti_110p', 20.00, 29.80, 63, 'male', 'L2Monster', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 6947, 626, 822, 398, 562, 292, 253, 0, 506, 0, 0, 0, 16, 170, 'winter_maze_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1733, 22099, 'Freyas Buffalo', '', 'buffalo', 22.00, 31.00, 57, 'male', 'L2Monster', 'Fighter', 40, 1777, 6.500, 948, 2.400, 40, 43, 30, 21, 20, 20, 31854, 2570, 619, 340, 423, 250, 253, 500, 506, 0, 0, 0, 20, 170, 'ice_clan', 700, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1734, 22100, 'Freyas Gardener', '', 'field_stalker', 15.00, 30.00, 58, 'male', 'L2Monster', 'Fighter', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 37927, 3113, 651, 350, 444, 256, 253, 500, 506, 0, 0, 0, 70, 130, 'ice_clan', 700, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1735, 22101, 'Freyas Servant', '', 'gargoyle_02te', 16.00, 50.00, 58, 'male', 'L2Monster', 'Fighter', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 33143, 2723, 651, 350, 444, 256, 253, 500, 506, 0, 0, 0, 140, 168, 'ice_clan', 700, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1736, 22102, 'Freyas Servant', '', 'gargoyle_02te', 16.00, 50.00, 58, 'male', 'L2Monster', 'Fighter', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 33143, 2723, 651, 350, 444, 256, 253, 500, 506, 0, 0, 0, 140, 140, 'ice_clan', 700, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1737, 22103, 'Freyas White Bear', '', 'grizzly', 21.00, 40.00, 57, 'male', 'L2Monster', 'Fighter', 40, 1777, 6.500, 948, 2.400, 40, 43, 30, 21, 20, 20, 33473, 2705, 619, 340, 423, 250, 253, 500, 506, 0, 0, 0, 40, 165, 'ice_clan', 700, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1738, 22104, 'Freyas Dog', '', 'bandersnatch', 18.00, 25.00, 58, 'male', 'L2Monster', 'Fighter', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 34900, 2867, 651, 350, 444, 256, 253, 500, 506, 0, 0, 0, 30, 170, 'ice_clan', 700, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1739, 22105, 'Spiked Stakato', '', 'blade_stakato_120p', 18.00, 43.20, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 30856, 2988, 1179, 491, 805, 359, 253, 500, 506, 0, 0, 0, 25, 200, 'spike_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1740, 22106, 'Spiked Stakato Worker', '', 'blade_stakato_worker_120p', 22.00, 48.30, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 31719, 3112, 1220, 502, 833, 368, 253, 500, 506, 221, 0, 0, 25, 200, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1741, 22107, 'Spiked Stakato Guard', '', 'spike_stakato', 16.00, 22.80, 74, 'male', 'L2Monster', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 32594, 3239, 1262, 513, 861, 375, 253, 500, 506, 123, 0, 0, 23, 200, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1742, 22108, 'Female Spiked Stakato', '', 'spike_stakato_soldier', 17.00, 30.00, 74, 'male', 'L2Monster', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 45208, 4534, 1262, 513, 861, 375, 253, 500, 506, 123, 0, 0, 60, 220, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1743, 22109, 'Male Spiked Stakato', '', 'marsh_stakato_soldier_120p', 18.00, 31.00, 74, 'male', 'L2Monster', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 44602, 4474, 1262, 513, 861, 375, 253, 500, 506, 135, 0, 0, 30, 200, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1744, 22110, 'Male Spiked Stakato', '', 'marsh_stakato_soldier_tran', 16.00, 28.40, 74, 'male', 'L2Monster', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 33935, 3379, 1262, 513, 861, 375, 253, 500, 506, 135, 0, 0, 32, 220, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1745, 22111, 'Spiked Stakato Sorcerer', '', 'blade_stakato_queen_120p', 24.00, 43.60, 75, 'female', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 32663, 3281, 1304, 523, 891, 384, 253, 500, 506, 221, 0, 0, 25, 170, 'spike_clan', 500, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.69, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1746, 22112, 'Cannibalistic Stakato Follower ', '', 'spike_stakato_worker', 17.00, 29.80, 74, 'male', 'L2Minion', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 41268, 4144, 1262, 513, 861, 375, 253, 500, 506, 223, 0, 0, 23, 200, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1747, 22113, 'Cannibalistic Stakato Leader', '', 'cannibal_stakato_leader_120p', 34.00, 48.80, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 51731, 5243, 1304, 523, 891, 384, 253, 500, 506, 0, 0, 0, 40, 200, 'spike_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1748, 22114, 'Cannibalistic Stakato Leader ', '', 'cannibal_stakato_leader_tran', 40.00, 42.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 34858, 3512, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 34, 220, 'spike_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1749, 22115, 'Spiked Stakato Soldier', '', 'blade_stakato_120p', 18.00, 43.20, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 28650, 2920, 1345, 535, 919, 391, 253, 500, 506, 0, 0, 0, 25, 200, 'spike_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1750, 22116, 'Spiked Stakato Drone', '', 'blade_stakato_drone_120p', 28.00, 47.30, 77, 'male', 'L2Monster', 'Fighter', 40, 2762, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 29409, 3034, 1388, 544, 948, 398, 253, 500, 506, 235, 0, 0, 25, 200, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1751, 22117, 'Spiked Stakato Captain', '', 'marsh_stakato_drone_120p', 14.00, 29.10, 78, 'male', 'L2Monster', 'Fighter', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 30177, 3149, 1430, 556, 975, 406, 253, 500, 506, 234, 0, 0, 80, 200, 'spike_clan', 500, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1752, 22118, 'Spiked Stakato Nurse', '', 'marsh_stakato_queen_120p', 26.00, 43.80, 78, 'female', 'L2Monster', 'Fighter', 40, 2871, 8.585, 1657, 3.030, 40, 43, 30, 21, 20, 20, 41892, 4464, 1476, 568, 1019, 416, 253, 150, 506, 132, 0, 0, 130, 200, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 6, 0, 1, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1753, 22119, 'Spiked Stakato Nurse', '', 'marsh_stakato_queen_tran', 18.00, 36.40, 78, 'female', 'L2Monster', 'Fighter', 40, 2871, 8.585, 1657, 3.030, 40, 43, 30, 21, 20, 20, 31155, 3293, 1476, 568, 1019, 416, 253, 150, 506, 0, 0, 0, 55, 220, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 6, 0, 1, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1754, 22120, 'Spiked Stakato Baby', '', 'spike_stakato_drone', 16.00, 29.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2871, 8.585, 1657, 3.030, 40, 43, 30, 21, 20, 20, 39719, 4242, 1476, 568, 1019, 416, 253, 150, 506, 235, 0, 0, 60, 220, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 6, 0, 1, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1755, 22121, 'Spiked Stakato Shaman', '', 'blade_stakato_queen_120p', 24.00, 43.60, 78, 'female', 'L2Monster', 'Mystic', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 30969, 3310, 1525, 581, 1062, 426, 253, 500, 506, 221, 0, 0, 25, 170, 'spike_clan', 500, 0, 0, 0, 7, 10, 8, 2, 0, 2, 0.69, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1756, 22122, 'Monastic Pilgrim', '', 'angel_080p', 12.00, 27.80, 78, 'male', 'L2Minion', 'Fighter', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 41281, 4464, 1525, 581, 1062, 426, 253, 0, 506, 148, 0, 0, 30, 120, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 7, 0, 2, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1757, 22123, 'Monastic Crusader', '', 'archangel_050p', 13.00, 37.50, 78, 'male', 'L2Monster', 'Fighter', 80, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 41690, 4558, 1566, 593, 1097, 434, 253, 150, 506, 97, 0, 0, 50, 120, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 3, 0, 3, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1758, 22124, 'Solina Brother', '', 'solina_brother', 9.00, 23.40, 78, 'male', 'L2Monster', 'MoSMonk', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 33265, 3601, 1566, 593, 1097, 434, 253, 200, 506, 8212, 0, 0, 61, 180, 'solina_clan', 300, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1759, 22125, 'Solina Lay Brother', '', 'solina_brother', 9.00, 23.40, 78, 'male', 'L2Monster', 'MoSMonk', 40, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 33305, 3644, 1607, 603, 1132, 441, 253, 200, 506, 8212, 0, 0, 61, 180, 'solina_clan', 300, 0, 0, 0, 7, 50, 1, 13, 0, 4, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1760, 22126, 'Silent Seeker', '', 'solina_father', 11.00, 25.40, 78, 'male', 'L2Monster', 'MoSMonk', 40, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 34092, 3734, 1607, 603, 1132, 441, 253, 200, 506, 8213, 0, 0, 70, 180, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 9, 0, 4, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1761, 22127, 'Silent Brother', '', 'solina_father', 11.00, 25.40, 78, 'male', 'L2Monster', 'MoSMonk', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 34122, 3778, 1647, 613, 1167, 449, 253, 200, 506, 8213, 0, 0, 70, 180, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 10, 0, 5, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1762, 22128, 'Monastery Guardian', '', 'grail_protection', 9.00, 15.60, 78, 'male', 'L2Monster', 'RndTeleportFighter', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 9741, 1132, 1647, 613, 1167, 449, 253, 150, 506, 0, 0, 0, 65, 180, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 10, 0, 5, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1763, 22129, 'Warrior Monk', '', 'monk_warrior', 12.00, 28.40, 78, 'male', 'L2Monster', 'MoSMonk', 40, 3077, 8.874, 1848, 3.131, 40, 43, 30, 21, 20, 20, 35775, 4012, 1685, 625, 1202, 458, 253, 200, 506, 8211, 8210, 0, 53, 180, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 11, 0, 2, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1764, 22130, 'Divine Advocate', '', 'apostle_warrior', 8.00, 30.00, 78, 'female', 'L2Minion', 'Fighter', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 52227, 5990, 1725, 635, 1237, 464, 253, 0, 506, 6717, 0, 0, 50, 180, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1765, 22131, 'Pilgrim of Light', '', 'apostle_mage', 11.00, 38.50, 78, 'male', 'L2Minion', 'Mystic', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 56598, 6488, 1725, 635, 1237, 464, 253, 0, 506, 6718, 0, 0, 50, 165, 'solina_clan', 300, 0, 0, 0, 7, 50, 1, 16, 0, 7, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1766, 22132, 'Judge of Light', '', 'apostle_grail_a', 13.00, 47.00, 78, 'male', 'L2Monster', 'Fighter', 40, 3136, 8.976, 1919, 3.168, 40, 43, 30, 21, 20, 20, 37163, 4257, 1762, 646, 1271, 473, 253, 500, 506, 0, 0, 0, 30, 120, 'solina_clan', 300, 0, 0, 0, 7, 50, 1, 17, 0, 8, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1767, 22133, 'Guardian of the Grail', '', 'will_o_wisp', 13.00, 22.00, 78, 'male', 'L2Monster', 'RndTeleportFighter', 40, 3136, 8.976, 1919, 3.168, 40, 43, 30, 21, 20, 20, 13890, 1672, 1762, 646, 1271, 473, 253, 500, 506, 0, 0, 0, 80, 140, 'solina_clan', 300, 0, 0, 0, 7, 10, 8, 8, 0, 8, 0.10, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1768, 22134, 'Guardian of the Holy Land', '', 'solina_priest', 14.00, 34.50, 78, 'male', 'L2Monster', 'Fighter', 40, 3163, 9.027, 1955, 3.182, 40, 43, 30, 21, 20, 20, 37490, 4352, 1799, 686, 1304, 503, 253, 0, 506, 8214, 0, 0, 30, 120, 'solina_clan', 300, 0, 0, 0, 7, 50, 1, 18, 0, 9, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1769, 22135, 'Beholder of Light', '', 'apostle_grail', 13.00, 47.00, 78, 'male', 'L2Monster', 'Fighter', 80, 3163, 9.027, 1955, 3.182, 40, 43, 30, 21, 20, 20, 60962, 7152, 1799, 686, 1304, 503, 253, 500, 506, 8221, 0, 0, 30, 120, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 9, 0, 9, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1770, 22136, 'Gatekeeper Zombie', '', 'zombie_gateguard', 17.00, 30.50, 78, 'male', 'L2Npc', 'npc', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 35842, 3964, 1647, 613, 1167, 449, 253, 300, 506, 8217, 0, 0, 33, 120, 'trioll_clan', 1000, 0, 0, 0, 7, 50, 1, 14, 0, 5, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1771, 22137, 'Penance Guard', '', 'zombie_gateguard_brd', 40.00, 30.50, 78, 'male', 'L2Monster', 'PaganGuard', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 3681, 397, 1566, 593, 1097, 434, 253, 100, 506, 8217, 0, 0, 33, 120, '1', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1772, 22138, 'Chapel Guard', '', 'zombie_gateguard_brd', 40.00, 30.50, 78, 'male', 'L2Monster', 'PaganGuard', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 4054, 458, 1725, 635, 1237, 464, 253, 100, 506, 8217, 0, 0, 33, 120, '1', 300, 0, 0, 0, 7, 50, 1, 16, 0, 7, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1773, 22139, 'Old Aristocrats Soldier', '', 'zombie_enlisted_man', 17.00, 22.30, 78, 'male', 'L2Monster', 'Mystic', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 33132, 3573, 1566, 593, 1097, 434, 253, 0, 506, 0, 0, 0, 38, 200, 'trioll_clan', 300, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1774, 22140, 'Zombie Worker', '', 'zombie_laborer', 11.00, 24.60, 78, 'male', 'L2Monster', 'Mystic', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 32319, 3446, 1525, 581, 1062, 426, 253, 0, 506, 123, 0, 0, 36, 120, 'trioll_clan', 300, 0, 0, 0, 7, 30, 4, 7, 0, 2, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1775, 22141, 'Forgotten Victim', '', 'zombie_laborer', 11.00, 24.60, 78, 'male', 'L2Monster', 'Mystic', 40, 2938, 8.670, 1708, 3.060, 40, 43, 30, 21, 20, 20, 33394, 3566, 1525, 581, 1062, 426, 253, 0, 506, 123, 0, 0, 36, 120, 'trioll_clan', 300, 0, 0, 0, 7, 30, 4, 7, 0, 2, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1776, 22142, 'Triols Layperson', '', 'heretic_privates_a', 7.70, 28.40, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 33855, 3651, 1566, 593, 1097, 434, 253, 300, 506, 8207, 8207, 0, 58, 200, 'trioll_clan', 300, 0, 0, 0, 7, 10, 4, 8, 0, 3, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1777, 22143, 'Triols Believer', '', 'heretic_privates', 7.70, 28.40, 78, 'male', 'L2Monster', 'Mystic', 80, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 39134, 4296, 1607, 603, 1132, 441, 253, 0, 506, 8205, 0, 0, 60, 200, 'trioll_clan', 300, 0, 0, 0, 7, 30, 4, 4, 0, 4, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1778, 22144, 'Resurrected Temple Knight', '', 'zombie_enlisted_man', 17.00, 22.30, 78, 'male', 'L2Monster', 'Fighter', 40, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 33955, 3705, 1607, 603, 1132, 441, 253, 300, 506, 0, 0, 0, 38, 200, 'trioll_clan', 300, 0, 0, 0, 7, 50, 1, 13, 0, 4, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1779, 22145, 'Ritual Sacrifice', '', 'self_blaster', 9.00, 25.80, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 32635, 3520, 1566, 593, 1097, 434, 253, 0, 506, 0, 0, 0, 30, 200, 'trioll_clan', 300, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1780, 22146, 'Triols Priest', '', 'heretic_privates', 7.70, 28.40, 78, 'male', 'L2Monster', 'Mystic', 80, 3077, 8.874, 1848, 3.131, 40, 43, 30, 21, 20, 20, 36409, 4068, 1685, 625, 1202, 458, 253, 300, 506, 8205, 0, 0, 60, 200, 'trioll_clan', 300, 0, 0, 0, 7, 30, 4, 6, 0, 2, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1781, 22147, 'Ritual Offering', '', 'zombie_enlisted_man', 17.00, 22.30, 78, 'male', 'L2Monster', 'Fighter', 40, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 35945, 3976, 1647, 613, 1167, 449, 253, 0, 506, 0, 0, 0, 38, 180, 'trioll_clan', 300, 0, 0, 0, 7, 50, 1, 14, 0, 5, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1782, 22148, 'Triols Believer', '', 'heretic_privates', 7.70, 28.40, 78, 'male', 'L2Monster', 'Fighter', 80, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 28321, 3091, 1607, 603, 1132, 441, 253, 300, 506, 8205, 0, 0, 60, 180, 'trioll_clan', 300, 0, 0, 0, 7, 30, 4, 4, 0, 4, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1783, 22149, 'Ritual Offering', '', 'zombie_enlisted_man', 17.00, 22.30, 78, 'male', 'L2Monster', 'Fighter', 40, 3011, 8.772, 1778, 3.101, 40, 43, 30, 21, 20, 20, 33955, 3705, 1607, 603, 1132, 441, 253, 0, 506, 0, 0, 0, 38, 180, 'trioll_clan', 300, 0, 0, 0, 7, 50, 1, 13, 0, 4, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1784, 22150, 'Triols Believer', '', 'heretic_privates', 7.70, 28.40, 78, 'male', 'L2Monster', 'Fighter', 80, 3045, 8.823, 1813, 3.111, 40, 43, 30, 21, 20, 20, 29760, 3290, 1647, 613, 1167, 449, 253, 300, 506, 8205, 0, 0, 60, 180, 'trioll_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 5, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1785, 22151, 'Triols Priest', '', 'heretic_privates', 7.70, 28.40, 78, 'male', 'L2Monster', 'Mystic', 80, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 42050, 4783, 1725, 635, 1237, 464, 253, 300, 506, 8205, 0, 0, 60, 180, 'trioll_clan', 300, 0, 0, 0, 7, 30, 4, 7, 0, 7, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1786, 22152, 'Temple Guard', '', 'zombie_em_knight', 17.00, 22.30, 78, 'male', 'L2Monster', 'Fighter', 80, 3077, 8.874, 1848, 3.131, 40, 43, 30, 21, 20, 20, 36817, 4121, 1685, 625, 1202, 458, 253, 300, 506, 8215, 0, 0, 38, 180, 'trioll_clan', 300, 0, 0, 0, 7, 30, 4, 11, 0, 2, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1787, 22153, 'Temple Guard Captain', '', 'zombie_em_knight', 17.00, 22.30, 78, 'male', 'L2Monster', 'Fighter', 80, 3077, 8.874, 1848, 3.131, 40, 43, 30, 21, 20, 20, 35631, 3981, 1685, 625, 1202, 458, 253, 300, 506, 8215, 0, 0, 38, 180, 'trioll_clan', 300, 0, 0, 0, 7, 30, 4, 11, 0, 2, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1788, 22154, 'Ritual Sacrifice', '', 'self_blaster', 9.00, 25.80, 78, 'male', 'L2Monster', 'Fighter', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 35937, 4063, 1725, 635, 1237, 464, 253, 0, 506, 0, 0, 0, 30, 200, 'trioll_clan', 300, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1789, 22155, 'Triols High Priest', '', 'heretic_priest_a', 8.00, 19.10, 78, 'male', 'L2Monster', 'Fighter', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 51240, 5877, 1725, 635, 1237, 464, 253, 300, 506, 8206, 8206, 0, 30, 180, 'trioll_clan', 300, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1790, 22156, 'Triols Priest', '', 'heretic_privates', 7.70, 28.40, 78, 'male', 'L2Monster', 'Mystic', 80, 3136, 8.976, 1919, 3.168, 40, 43, 30, 21, 20, 20, 46329, 5392, 1762, 646, 1271, 473, 253, 300, 506, 8205, 0, 0, 60, 180, 'trioll_clan', 500, 0, 0, 0, 7, 30, 4, 8, 0, 8, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1791, 22157, 'Triols Priest', '', 'heretic_privates', 7.70, 28.40, 78, 'male', 'L2Monster', 'Mystic', 80, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 44390, 5102, 1725, 635, 1237, 464, 253, 300, 506, 8205, 0, 0, 60, 180, 'trioll_clan', 500, 0, 0, 0, 7, 30, 4, 7, 0, 7, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1792, 22158, 'Triols Believer', '', 'heretic_privates_a', 7.70, 28.40, 78, 'male', 'L2Monster', 'Fighter', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 45257, 5205, 1725, 635, 1237, 464, 253, 300, 506, 8207, 8207, 0, 58, 180, 'trioll_clan', 500, 0, 0, 0, 7, 10, 4, 12, 0, 7, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1793, 22159, 'Triols High Priest', '', 'heretic_priest_a', 8.00, 19.10, 78, 'male', 'L2Monster', 'Fighter', 40, 3136, 8.976, 1919, 3.168, 40, 43, 30, 21, 20, 20, 52452, 6087, 1762, 646, 1271, 473, 253, 300, 506, 8206, 8206, 0, 30, 180, 'trioll_clan', 300, 0, 0, 0, 7, 30, 4, 17, 0, 8, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1794, 22160, 'Triols Priest', '', 'heretic_privates', 7.70, 28.40, 78, 'male', 'L2Monster', 'Mystic', 80, 3136, 8.976, 1919, 3.168, 40, 43, 30, 21, 20, 20, 46329, 5392, 1762, 646, 1271, 473, 253, 300, 506, 8205, 0, 0, 60, 180, 'trioll_clan', 500, 0, 0, 0, 7, 30, 4, 8, 0, 8, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1795, 22161, 'Ritual Sacrifice', '', 'self_blaster', 9.00, 25.80, 78, 'male', 'L2Monster', 'Fighter', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 52497, 6034, 1725, 635, 1237, 464, 253, 0, 506, 0, 0, 0, 30, 200, 'trioll_clan', 500, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1796, 22162, 'Triols Believer', '', 'heretic_privates_a', 7.70, 28.40, 78, 'male', 'L2Monster', 'Fighter', 40, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 45257, 5205, 1725, 635, 1237, 464, 253, 300, 506, 8207, 8207, 0, 58, 180, 'trioll_clan', 500, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1797, 22163, 'Triols High Priest', '', 'heretic_priest', 8.00, 19.10, 78, 'male', 'L2Monster', 'Fighter', 40, 3136, 8.976, 1919, 3.168, 40, 43, 30, 21, 20, 20, 60848, 7048, 1762, 646, 1271, 473, 253, 300, 506, 8208, 0, 0, 30, 180, 'trioll_clan', 300, 0, 0, 0, 7, 50, 1, 17, 0, 8, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1798, 22164, 'Triols Believer', '', 'heretic_privates_a', 7.70, 28.40, 78, 'male', 'L2Monster', 'Fighter', 40, 3136, 8.976, 1919, 3.168, 40, 43, 30, 21, 20, 20, 46329, 5392, 1762, 646, 1271, 473, 253, 300, 506, 8207, 8207, 0, 58, 180, 'trioll_clan', 500, 0, 0, 0, 7, 30, 4, 13, 0, 8, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1799, 22165, 'Triols Priest', '', 'heretic_privates', 7.70, 28.40, 78, 'male', 'L2Monster', 'Mystic', 80, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 44390, 5102, 1725, 635, 1237, 464, 253, 300, 506, 8205, 0, 0, 60, 180, 'trioll_clan', 500, 0, 0, 0, 7, 30, 4, 7, 0, 7, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1800, 22166, 'Triols Believer', '', 'heretic_privates', 7.70, 28.40, 78, 'male', 'L2Monster', 'Mystic', 80, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 44390, 5102, 1725, 635, 1237, 464, 253, 300, 506, 8205, 0, 0, 60, 180, 'trioll_clan', 500, 0, 0, 0, 7, 30, 4, 7, 0, 7, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1801, 22167, 'Triols High Priest', '', 'heretic_priest_a', 8.00, 19.10, 78, 'male', 'L2Monster', 'Fighter', 40, 3163, 9.027, 1955, 3.182, 40, 43, 30, 21, 20, 20, 53679, 6304, 1799, 686, 1304, 503, 253, 300, 506, 8206, 8206, 0, 30, 180, 'trioll_clan', 300, 0, 0, 0, 7, 30, 4, 14, 0, 9, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1802, 22168, 'Triols Priest', '', 'heretic_privates', 7.70, 28.40, 78, 'male', 'L2Monster', 'Mystic', 80, 3163, 9.027, 1955, 3.182, 40, 43, 30, 21, 20, 20, 46504, 5473, 1799, 686, 1304, 503, 253, 300, 506, 8205, 0, 0, 60, 180, 'trioll_clan', 500, 0, 0, 0, 7, 30, 4, 9, 0, 9, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1803, 22169, 'Ritual Sacrifice', '', 'self_blaster', 9.00, 25.80, 78, 'male', 'L2Monster', 'Fighter', 40, 3136, 8.976, 1919, 3.168, 40, 43, 30, 21, 20, 20, 53740, 6251, 1762, 646, 1271, 473, 253, 0, 506, 0, 0, 0, 30, 200, 'trioll_clan', 500, 0, 0, 0, 7, 30, 4, 13, 0, 8, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1804, 22170, 'Triols Believer', '', 'heretic_privates_a', 7.70, 28.40, 78, 'male', 'L2Monster', 'Fighter', 40, 3136, 8.976, 1919, 3.168, 40, 43, 30, 21, 20, 20, 46329, 5392, 1762, 646, 1271, 473, 253, 300, 506, 8207, 8207, 0, 58, 180, 'trioll_clan', 500, 0, 0, 0, 7, 30, 4, 13, 0, 8, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1805, 22171, 'Triols High Priest', '', 'heretic_priest', 8.00, 19.10, 78, 'male', 'L2Monster', 'Fighter', 40, 3163, 9.027, 1955, 3.182, 40, 43, 30, 21, 20, 20, 62272, 7299, 1799, 686, 1304, 503, 253, 300, 506, 8208, 0, 0, 30, 180, 'trioll_clan', 300, 0, 0, 0, 7, 50, 1, 18, 0, 9, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1806, 22172, 'Ritual Sacrifice', '', 'self_blaster', 9.00, 25.80, 78, 'male', 'L2Monster', 'Fighter', 40, 3136, 8.976, 1919, 3.168, 40, 43, 30, 21, 20, 20, 53740, 6251, 1762, 646, 1271, 473, 253, 0, 506, 0, 0, 0, 30, 200, 'trioll_clan', 500, 0, 0, 0, 7, 30, 4, 13, 0, 8, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1807, 22173, 'Triols Priest', '', 'heretic_privates', 7.70, 28.40, 78, 'male', 'L2Monster', 'Mystic', 80, 3136, 8.976, 1919, 3.168, 40, 43, 30, 21, 20, 20, 45441, 5285, 1762, 646, 1271, 473, 253, 300, 506, 8205, 0, 0, 60, 180, 'trioll_clan', 500, 0, 0, 0, 7, 30, 4, 8, 0, 8, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1808, 22174, 'Triols Priest', '', 'heretic_privates', 7.70, 28.40, 78, 'male', 'L2Monster', 'Mystic', 80, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 45257, 5205, 1725, 635, 1237, 464, 253, 300, 506, 8205, 0, 0, 60, 180, 'trioll_clan', 500, 0, 0, 0, 7, 30, 4, 7, 0, 7, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1809, 22175, 'Andreas Captain of the Royal Guard', '', 'zombie_em_knight', 17.00, 22.30, 78, 'male', 'L2Monster', 'Fighter', 80, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 1871, 211, 1725, 635, 1237, 464, 253, 500, 506, 8215, 0, 0, 38, 180, 'andreas_clan', 300, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1810, 22176, 'Andreas Royal Guards', '', 'zombie_em_knight', 17.00, 22.30, 78, 'male', 'L2Monster', 'Fighter', 80, 3108, 8.925, 1884, 3.152, 40, 43, 30, 21, 20, 20, 1871, 211, 1725, 635, 1237, 464, 253, 500, 506, 8215, 0, 0, 38, 180, 'andreas_clan', 300, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1811, 22188, 'Andreas Captain of the Royal Guard', '', 'heretic_priest_120p', 13.00, 23.20, 78, 'male', 'L2Monster', 'Fighter', 40, 3163, 9.027, 1955, 3.182, 40, 43, 30, 21, 20, 20, 36967, 4356, 1799, 686, 1304, 503, 253, 500, 506, 8208, 0, 0, 30, 180, 'andreas_clan', 300, 0, 0, 0, 7, 50, 1, 18, 0, 9, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1812, 22189, 'Andreas Royal Guards', '', 'heretic_privates_120p', 13.00, 34.00, 78, 'male', 'L2Monster', 'Mystic', 80, 3136, 8.976, 1919, 3.168, 40, 43, 30, 21, 20, 20, 29554, 3460, 1762, 646, 1271, 473, 253, 500, 506, 8205, 0, 0, 60, 180, 'andreas_clan', 300, 0, 0, 0, 7, 30, 4, 8, 0, 8, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1813, 22190, 'Ritual Sacrifice', '', 'self_blaster', 9.00, 25.80, 78, 'male', 'L2Monster', 'Fighter', 40, 3136, 8.976, 1919, 3.168, 40, 43, 30, 21, 20, 20, 34316, 4015, 1762, 646, 1271, 473, 253, 0, 506, 0, 0, 0, 30, 200, 'andreas_clan', 300, 0, 0, 0, 7, 30, 4, 13, 0, 8, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1814, 22191, 'Andreas Captain of the Royal Guard', '', 'heretic_priest_120p', 13.00, 23.20, 78, 'male', 'L2Monster', 'Fighter', 40, 3163, 9.027, 1955, 3.182, 40, 43, 30, 21, 20, 20, 16894, 1956, 1799, 686, 1304, 503, 253, 300, 506, 8208, 0, 0, 30, 180, 'andreas_clan', 1000, 0, 0, 0, 7, 50, 1, 18, 0, 9, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1815, 22192, 'Andreas Royal Guards', '', 'heretic_privates_120p', 13.00, 34.00, 78, 'male', 'L2Monster', 'Fighter', 80, 3136, 8.976, 1919, 3.168, 40, 43, 30, 21, 20, 20, 8875, 1069, 1762, 646, 1271, 473, 253, 500, 506, 8205, 0, 0, 60, 180, 'andreas_clan', 1000, 0, 0, 0, 7, 30, 4, 8, 0, 8, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1816, 22193, 'Andreas Royal Guards', '', 'heretic_privates_120p', 13.00, 34.00, 78, 'male', 'L2Monster', 'Fighter', 80, 3136, 8.976, 1919, 3.168, 40, 43, 30, 21, 20, 20, 8875, 1069, 1762, 646, 1271, 473, 253, 500, 506, 8205, 0, 0, 60, 180, 'andreas_clan', 1000, 0, 0, 0, 7, 30, 4, 8, 0, 8, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1817, 22194, 'Penance Guard', '', 'zombie_gateguard_slp', 40.00, 22.00, 78, 'male', 'L2Monster', 'PaganGuard', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 3681, 397, 1566, 593, 1097, 434, 253, 100, 506, 8217, 0, 0, 33, 120, '1', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1818, 22195, 'Ritual Sacrifice', '', 'self_blaster', 9.00, 25.80, 78, 'male', 'L2SpecialMonster', 'Mystic', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 32635, 3520, 1566, 593, 1097, 434, 253, 0, 506, 0, 0, 0, 30, 200, 'andreas_clan', 300, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1819, 22196, 'Velociraptor', '', 'velociraptor', 20.00, 47.20, 80, 'male', 'L2SpecialMonster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 24830, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 33, 180, 'velociraptor_clan', 600, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1820, 22197, 'Velociraptor', '', 'velociraptor', 20.00, 47.20, 80, 'male', 'L2Minion', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 24830, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 33, 210, 'velociraptor_clan', 600, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1821, 22198, 'Velociraptor', '', 'velociraptor', 20.00, 47.20, 80, 'male', 'L2SpecialMonster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 24830, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 33, 170, 'velociraptor_clan', 600, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1822, 22199, 'Pterosaur', '', 'rhamphorhynchus', 36.00, 43.70, 80, 'male', 'L2SpecialMonster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 24830, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 54, 210, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1823, 22200, 'Ornithomimus', '', 'ornithomimus', 15.00, 37.20, 80, 'male', 'L2SpecialMonster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 36, 170, 'ornithomimus_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1824, 22201, 'Ornithomimus', '', 'ornithomimus', 15.00, 37.20, 80, 'male', 'L2Minion', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 36, 200, 'ornithomimus_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1825, 22202, 'Ornithomimus', '', 'ornithomimus', 15.00, 37.20, 80, 'male', 'L2Minion', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 36, 160, 'ornithomimus_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1826, 22203, 'Deinonychus', '', 'deinonychus', 14.00, 14.30, 80, 'male', 'L2SpecialMonster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 24, 160, 'deinonychus_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1827, 22204, 'Deinonychus', '', 'deinonychus', 14.00, 14.30, 80, 'male', 'L2Minion', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 24, 190, 'deinonychus_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1828, 22205, 'Deinonychus', '', 'deinonychus', 14.00, 14.30, 80, 'male', 'L2Minion', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 24, 160, 'deinonychus_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1829, 22208, 'Pachycephalosaurus', '', 'pachycephalosaurus', 22.00, 40.00, 80, 'male', 'L2SpecialMonster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 33, 150, '', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1830, 22209, 'Pachycephalosaurus', '', 'pachycephalosaurus', 22.00, 40.00, 80, 'male', 'L2Minion', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 33, 170, '', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1831, 22210, 'Pachycephalosaurus', '', 'pachycephalosaurus', 22.00, 40.00, 80, 'male', 'L2Minion', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 33, 150, '', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1832, 22211, 'Wild Strider', '', 'wild_giant_strider', 32.00, 44.20, 80, 'male', 'L2SpecialMonster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 50, 150, '', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1833, 22212, 'Wild Strider', '', 'wild_giant_strider', 32.00, 44.20, 80, 'male', 'L2Minion', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 50, 170, '', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1834, 22213, 'Wild Strider', '', 'wild_giant_strider', 32.00, 44.20, 80, 'male', 'L2Minion', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 50, 150, '', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1835, 22214, 'Elroki', '', 'Crokian_Officer', 25.00, 33.00, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 60, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1836, 22215, 'Tyrannosaurus', '', 'tyranosaurus', 60.00, 89.70, 80, 'male', 'L2SpecialMonster', 'Fighter', 40, 339687, 195.709, 1675, 3.000, 40, 43, 30, 21, 20, 20, 727610, 81666, 12636, 923, 8627, 1014, 253, 1000, 506, 0, 0, 0, 105, 220, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1837, 22216, 'Tyrannosaurus', '', 'tyranosaurus', 60.00, 89.70, 80, 'male', 'L2SpecialMonster', 'Fighter', 40, 339687, 195.709, 1675, 3.000, 40, 43, 30, 21, 20, 20, 727610, 81666, 12636, 923, 8627, 1014, 253, 1000, 506, 0, 0, 0, 105, 220, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1838, 22217, 'Tyrannosaurus', '', 'tyranosaurus', 60.00, 89.70, 80, 'male', 'L2SpecialMonster', 'Fighter', 40, 339687, 195.709, 1675, 3.000, 40, 43, 30, 21, 20, 20, 727610, 81666, 12636, 923, 8627, 1014, 253, 1000, 506, 0, 0, 0, 105, 220, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1839, 22218, 'Velociraptor', '', 'velociraptor', 20.00, 47.20, 80, 'male', 'L2Minion', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 24830, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 33, 200, 'velociraptor_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1840, 22219, 'Ornithomimus', '', 'ornithomimus', 15.00, 37.20, 80, 'male', 'L2Minion', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 36, 190, 'ornithomimus_clan', 100, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1841, 22220, 'Deinonychus', '', 'deinonychus', 14.00, 14.30, 80, 'male', 'L2Minion', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 24, 180, 'deinonychus_clan', 100, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1842, 22221, 'Pachycephalosaurus', '', 'pachycephalosaurus', 22.00, 40.00, 80, 'male', 'L2Minion', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 33, 150, '', 100, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1843, 22222, 'Wild Strider', '', 'wild_giant_strider', 32.00, 44.20, 80, 'male', 'L2Minion', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 50, 150, '', 100, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1844, 22223, 'Velociraptor', '', 'velociraptor', 20.00, 47.20, 80, 'male', 'L2Minion', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 24830, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 33, 180, 'velociraptor_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1845, 22224, 'Ornithomimus', '', 'ornithomimus', 15.00, 37.20, 80, 'male', 'L2SpecialMonster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 36, 170, 'ornithomimus_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1846, 22225, 'Deinonychus', '', 'deinonychus', 14.00, 14.30, 80, 'male', 'L2Minion', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 24, 160, 'deinonychus_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1847, 22226, 'Pachycephalosaurus', '', 'pachycephalosaurus', 22.00, 40.00, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 500, 506, 0, 0, 0, 33, 140, '', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1848, 22227, 'Wild Strider', '', 'wild_giant_strider', 32.00, 44.20, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14515, 2715, 1641, 576, 1120, 423, 253, 500, 506, 0, 0, 0, 50, 140, '', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1849, 22228, 'Grey Elpy', '', 'LineageMonster.elpy', 5.00, 4.50, 1, 'male', 'L2Monster', 'Elpy', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 35, 2, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 50, 80, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1850, 22229, 'Young Grey Keltir', '', 'LineageMonster.keltir', 9.50, 10.00, 1, 'male', 'L2Monster', 'Fighter', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 35, 2, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1851, 22230, 'Grey Keltir', '', 'LineageMonster.keltir', 9.50, 10.00, 2, 'male', 'L2Monster', 'Fighter', 40, 48, 2.000, 47, 0.900, 40, 43, 30, 21, 20, 20, 70, 2, 8, 42, 5, 31, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1852, 22231, 'Dominant Grey Keltir', '', 'LineageMonster.keltir', 9.50, 10.00, 3, 'male', 'L2Monster', 'Fighter', 40, 58, 2.000, 55, 0.900, 40, 43, 30, 21, 20, 20, 106, 2, 9, 44, 6, 32, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1853, 22232, 'Black Wolf', '', 'LineageMonster.wolf', 13.00, 9.00, 4, 'male', 'L2Monster', 'Fighter', 40, 68, 2.000, 62, 0.900, 40, 43, 30, 21, 20, 20, 141, 3, 10, 47, 7, 33, 253, 0, 506, 0, 0, 0, 24, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1854, 22233, 'Dominant Black Wolf', '', 'LineageMonster.wolf_bi', 13.00, 10.80, 5, 'male', 'L2Monster', 'Fighter', 40, 80, 2.000, 70, 0.900, 40, 43, 30, 21, 20, 20, 176, 4, 11, 49, 8, 36, 253, 0, 506, 0, 0, 0, 24, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1855, 22234, 'Green Goblin', '', 'LineageMonster.goblin', 10.00, 16.50, 6, 'male', 'L2Monster', 'Fighter', 40, 94, 2.000, 77, 0.900, 40, 43, 30, 21, 20, 20, 211, 5, 13, 51, 9, 37, 253, 0, 506, 4, 0, 0, 40, 110, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.32, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1856, 22235, 'Mountain Werewolf', '', 'LineageMonster.werewolf', 10.00, 26.00, 7, 'male', 'L2Monster', 'Fighter', 40, 108, 2.000, 85, 0.900, 40, 43, 30, 21, 20, 20, 248, 8, 14, 54, 10, 39, 253, 0, 506, 5, 0, 0, 50, 120, 'werewolf_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1857, 22236, 'Muertos Archer', '', 'LineageMonster4.Mostro_Gunner', 15.00, 24.50, 8, 'male', 'L2Monster', 'Ranger', 700, 125, 2.000, 93, 0.900, 40, 43, 30, 21, 20, 20, 281, 9, 16, 56, 11, 41, 253, 0, 506, 10128, 0, 0, 36, 110, 'mostro_clan', 300, 0, 0, 0, 7, 10, 10, 5, 400, 0, 0.51, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1858, 22237, 'Mountain Fungus', '', 'LineageMonster.walking_fungus', 15.00, 22.50, 9, 'male', 'L2Monster', 'Fighter', 40, 143, 2.000, 100, 0.900, 40, 43, 30, 21, 20, 20, 319, 10, 18, 59, 12, 43, 253, 0, 506, 0, 0, 0, 70, 110, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1859, 22238, 'Mountain Werewolf Chief', '', 'LineageMonster.werewolf_bi', 11.00, 29.70, 10, 'male', 'L2Monster', 'Fighter', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 354, 12, 19, 61, 13, 45, 253, 500, 506, 5, 0, 0, 50, 120, 'werewolf_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1860, 22239, 'Muertos Guard', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 11, 'male', 'L2Monster', 'Fighter', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 387, 14, 21, 64, 14, 47, 253, 0, 506, 0, 0, 0, 36, 120, 'mostro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1861, 22240, 'Muertos Scout', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 423, 15, 23, 67, 16, 49, 253, 0, 506, 0, 0, 0, 36, 120, 'mostro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1862, 22241, 'Colossus', '', 'LineageMonster.Stone_golem', 20.00, 31.00, 13, 'male', 'L2Monster', 'Mystic', 40, 215, 2.500, 133, 1.200, 40, 43, 30, 21, 20, 20, 566, 22, 26, 70, 17, 51, 253, 0, 506, 0, 0, 0, 23, 23, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1863, 22242, 'Muertos Warrior', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 14, 'male', 'L2Monster', 'Fighter', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 490, 19, 28, 73, 20, 54, 253, 300, 506, 0, 0, 0, 36, 110, 'mostro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1864, 22243, 'Muertos Captain', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 528, 21, 31, 77, 21, 56, 253, 0, 506, 0, 0, 0, 36, 110, 'mostro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1865, 22244, 'Crimson Spider', '', 'LineageMonster.giant_spider_05te', 26.00, 25.50, 16, 'male', 'L2Monster', 'Fighter', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 564, 22, 34, 80, 23, 59, 253, 0, 506, 0, 0, 0, 72, 130, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1866, 22245, 'Muertos Lieutenant', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 599, 25, 37, 84, 25, 61, 253, 300, 506, 0, 0, 0, 36, 120, 'mostro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1867, 22246, 'Muertos Commander', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 18, 'male', 'L2Monster', 'Fighter', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 633, 27, 41, 87, 28, 64, 253, 500, 506, 0, 0, 0, 36, 120, 'mostro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1868, 22247, 'Grotto Golem', '', 'LineageMonster.Stone_golem', 20.00, 31.00, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 1108, 43, 31, 77, 21, 56, 253, 500, 506, 0, 0, 0, 23, 23, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1869, 22248, 'Shady Muertos', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 821, 31, 31, 77, 21, 56, 253, 0, 506, 0, 0, 0, 36, 110, 'mostro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1870, 22249, 'Shady Muertos Guard', '', 'LineageMonster4.Mostro_Gunner', 15.00, 24.50, 16, 'male', 'L2Monster', 'Ranger', 700, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 877, 33, 34, 80, 23, 59, 253, 0, 506, 10128, 0, 0, 36, 110, 'mostro_clan', 300, 0, 0, 0, 7, 10, 10, 5, 400, 0, 0.51, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1871, 22250, 'Grotto Leopard', '', 'LineageMonster.Onyx_beast', 14.00, 14.50, 16, 'male', 'L2Monster', 'Fighter', 40, 264, 2.500, 158, 1.200, 40, 43, 30, 21, 20, 20, 877, 33, 34, 80, 23, 59, 253, 0, 506, 0, 0, 0, 30, 120, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1872, 22251, 'Shady Muertos Captain', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 928, 37, 37, 84, 25, 61, 253, 0, 506, 0, 0, 0, 36, 110, 'mostro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1873, 22252, 'Grotto Grizzly', '', 'LineageMonster.Grizzly', 21.00, 40.00, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 925, 36, 37, 84, 25, 61, 253, 0, 506, 0, 0, 0, 40, 110, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1874, 22253, 'Shady Muertos Warrior', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 18, 'male', 'L2Monster', 'Fighter', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 981, 40, 41, 87, 28, 64, 253, 0, 506, 0, 0, 0, 36, 110, 'mostro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1875, 22254, 'Shady Muertos Archer', '', 'LineageMonster4.Mostro_Gunner', 15.00, 24.50, 18, 'male', 'L2Monster', 'Ranger', 700, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 983, 40, 41, 87, 28, 64, 253, 0, 506, 10128, 0, 0, 36, 110, 'mostro_clan', 300, 0, 0, 0, 7, 10, 10, 5, 400, 0, 0.51, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1876, 22255, 'Shady Muertos Commander', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 19, 'male', 'L2Monster', 'Fighter', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 1039, 44, 44, 91, 30, 67, 253, 0, 506, 0, 0, 0, 36, 110, 'mostro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1877, 22256, 'Shady Muertos Wizard', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 19, 'male', 'L2Monster', 'Mystic', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 1145, 48, 44, 91, 30, 67, 253, 0, 506, 0, 0, 0, 36, 110, 'mostro_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1878, 22257, 'Island Guardian', '', 'LineageMonster.light_worm_250p', 12.00, 45.00, 78, 'male', 'L2Monster', 'IsleOfPrayerMystic', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 12616, 1380, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 60, 160, 'oracle_clan', 500, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.06, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1879, 22258, 'White Sand Mirage', '', 'LineageMonster.undine', 12.00, 27.00, 79, 'female', 'L2Monster', 'IsleOfPrayerMystic', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 12941, 1434, 1562, 566, 1067, 415, 253, 300, 506, 0, 0, 0, 60, 160, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1880, 22259, 'Muddy Coral', '', 'LineageMonster.theeder_120p', 13.00, 38.00, 80, 'male', 'L2Monster', 'IsleOfPrayerFighter', 80, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 14100, 1582, 1641, 576, 1120, 423, 253, 100, 506, 192, 0, 0, 80, 160, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1881, 22260, 'Kleopora', '', 'LineageMonster.gargoyle_02te', 16.00, 50.00, 80, 'male', 'L2Monster', 'IsleOfPrayerMystic', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 11681, 1311, 1641, 576, 1120, 423, 253, 100, 506, 0, 0, 0, 140, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1882, 22261, 'Seychelles', '', 'LineageMonster.water_giant_120p', 15.00, 52.00, 81, 'male', 'L2Monster', 'IsleOfPrayerMystic', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 12333, 1366, 1720, 588, 1175, 430, 253, 0, 506, 5132, 0, 0, 75, 160, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1883, 22262, 'Naiad', '', 'LineageMonster4.tears', 20.00, 27.50, 81, 'female', 'L2Monster', 'IsleOfPrayerMystic', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 12486, 1383, 1720, 588, 1175, 430, 253, 0, 506, 9638, 9638, 0, 60, 180, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1884, 22263, 'Sonneratia', '', 'LineageMonster.onyx_beast_bi', 14.00, 18.70, 82, 'male', 'L2Monster', 'IsleOfPrayerFighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 14725, 1610, 1804, 599, 1233, 438, 253, 100, 506, 0, 0, 0, 30, 180, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1885, 22264, 'Castalia', '', 'LineageMonster4.tears_d', 20.00, 27.50, 82, 'female', 'L2Monster', 'IsleOfPrayerFighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 13089, 1431, 1804, 599, 1233, 438, 253, 100, 506, 9638, 9638, 0, 60, 180, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1886, 22265, 'Chrysocolla', '', 'LineageMonster4.Crystal_Golem', 34.00, 47.00, 83, 'male', 'L2Monster', 'IsleOfPrayerMystic', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 15492, 1673, 1890, 609, 1292, 445, 253, 300, 506, 0, 0, 0, 54, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1887, 22266, 'Pythia', '', 'LineageMonster4.tears', 20.00, 27.50, 83, 'female', 'L2Monster', 'IsleOfPrayerMystic', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 13801, 1490, 1890, 609, 1292, 445, 253, 150, 506, 9638, 9638, 0, 60, 180, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1888, 22267, 'Dark Water Dragon', '', 'LineageMonster3.antaras_ex_b', 42.00, 34.50, 83, 'male', 'L2SpecialMonster', 'DarkWaterDragon', 40, 65569, 111.355, 1777, 3.000, 40, 43, 30, 21, 20, 20, 158536, 17121, 9615, 974, 6565, 1068, 253, 300, 506, 0, 0, 0, 200, 200, 'dark_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1889, 22268, 'Shade', '', 'LineageMonster4.eyeless', 36.00, 43.50, 82, 'male', 'L2Monster', 'Shade', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 10249, 1120, 1804, 599, 1233, 438, 253, 420, 506, 0, 0, 0, 60, 200, 'dark_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1890, 22269, 'Shade', '', 'LineageMonster4.eyeless', 36.00, 43.50, 82, 'male', 'L2Monster', 'Shade', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 10351, 1131, 1804, 599, 1233, 438, 253, 420, 506, 0, 0, 0, 60, 200, 'dark_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1891, 22270, 'Water Dragon Detractor', '', 'LineageMonster4.Eyeless', 36.00, 43.50, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 11436, 1250, 1804, 599, 1233, 438, 253, 500, 506, 0, 0, 0, 60, 200, 'dark_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1892, 22271, 'Water Dragon Detractor', '', 'LineageMonster4.Eyeless', 36.00, 43.50, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 11436, 1250, 1804, 599, 1233, 438, 253, 500, 506, 0, 0, 0, 60, 200, 'dark_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1893, 22272, 'Beleths Minion', '', 'LineageMonster.vale_master', 12.00, 40.00, 82, 'male', 'L2SpecialMonster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 16531, 1728, 1804, 599, 1233, 438, 253, 500, 506, 210, 0, 0, 70, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1894, 22273, 'Beleths Minion', '', 'LineageMonster.silhouette', 8.00, 23.00, 82, 'female', 'L2SpecialMonster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 15997, 1670, 1804, 599, 1233, 438, 253, 500, 506, 0, 0, 0, 80, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1895, 22274, 'Beleths Minion', '', 'LineageMonster.shadeless', 7.00, 33.00, 82, 'male', 'L2SpecialMonster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 16319, 1705, 1804, 599, 1233, 438, 253, 500, 506, 0, 0, 0, 48, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1896, 22275, 'Gatekeeper Lohan', '', 'LineageMonster3.Jungle_Bleeze', 60.00, 47.00, 81, 'female', 'L2SpecialMonster', 'Fighter', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 96272, 10663, 9809, 940, 6698, 1032, 253, 0, 506, 0, 0, 0, 60, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1897, 22276, 'Gatekeeper of the Square', '', 'LineageMonster4.Crystal_Golem', 34.00, 47.00, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 28314, 2999, 1720, 588, 1175, 430, 253, 300, 506, 0, 0, 0, 54, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1898, 22277, 'Gatekeeper Provo', '', 'LineageMonster2.lava_golem', 38.00, 45.00, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 96272, 10663, 9809, 940, 6698, 1032, 253, 0, 506, 0, 0, 0, 13, 80, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1899, 22278, 'Gatekeeper of Fire', '', 'LineageMonster4.Crystal_Golem', 34.00, 47.00, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 28314, 2999, 1720, 588, 1175, 430, 253, 300, 506, 0, 0, 0, 54, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1900, 22279, 'Chromatic Detainee', '', 'LineageMonster3.Crokian_Officer', 25.00, 33.00, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 27781, 2932, 1720, 588, 1175, 430, 253, 300, 506, 0, 0, 0, 60, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1901, 22280, 'Rodo Knight', '', 'LineageMonster4.Crystal_Golem', 34.00, 47.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 15937, 1663, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 54, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1902, 22281, 'Plaza Caiman', '', 'LineageMonster3.Crokian_Officer', 25.00, 33.00, 82, 'male', 'L2SpecialMonster', 'Fighter', 40, 10982, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 13121, 1370, 11515, 958, 7864, 1050, 253, 0, 506, 0, 0, 0, 60, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1903, 22282, 'Chromatic Detainee', '', 'LineageMonster3.Crokian_Officer', 25.00, 33.00, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 27781, 2932, 1720, 588, 1175, 430, 253, 300, 506, 0, 0, 0, 60, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1904, 22283, 'Emerald Alligar', '', 'LineageMonster3.Crokian_Officer', 25.00, 33.00, 82, 'male', 'L2Monster', 'Fighter', 40, 10982, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 13121, 1370, 11515, 958, 7864, 1050, 253, 0, 506, 0, 0, 0, 60, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1905, 22284, 'Chromatic Detainee', '', 'LineageMonster.blade_stakato', 15.00, 36.00, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 26651, 2807, 1720, 588, 1175, 430, 253, 300, 506, 0, 0, 0, 25, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1906, 22285, 'Chromatic Detainee', '', 'LineageMonster.blade_stakato', 15.00, 36.00, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 28709, 3035, 1720, 588, 1175, 430, 253, 300, 506, 0, 0, 0, 25, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1907, 22286, 'Plaza Gaviel', '', 'LineageMonster3.Crokian_Officer', 25.00, 33.00, 82, 'male', 'L2Monster', 'Fighter', 40, 10982, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 13121, 1370, 11515, 958, 7864, 1050, 253, 0, 506, 0, 0, 0, 60, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1908, 22287, 'Crystalline Unicorn', '', 'LineageMonster.unicorn', 14.00, 30.00, 82, 'male', 'L2SpecialMonster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 34503, 3583, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 46, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1909, 22288, 'Emerald Boar', '', 'LineageMonster.giant_wild_hog', 35.00, 27.00, 82, 'male', 'L2SpecialMonster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 37724, 3936, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 35, 130, 'oracle_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1910, 22289, 'Plaza Helm', '', 'LineageMonster2.ketra_warbeast', 20.00, 33.50, 82, 'male', 'L2SpecialMonster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 36334, 3792, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 26, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1911, 22290, 'Terods Minion', '', 'LineageMonster4.eyeless_080p', 34.00, 35.00, 82, 'male', 'L2SpecialMonster', 'Fighter', 40, 32946, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 101261, 11072, 9906, 958, 6765, 1050, 253, 0, 506, 0, 0, 0, 60, 200, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1912, 22291, 'Weylins Minion', '', 'LineageMonster4.eyeless_080p', 34.00, 35.00, 82, 'male', 'L2SpecialMonster', 'Fighter', 40, 32946, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 95185, 10408, 9906, 958, 6765, 1050, 253, 0, 506, 0, 0, 0, 60, 210, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1913, 22292, 'Tourmaline', '', 'LineageMonster4.Crystal_Golem', 34.00, 47.00, 82, 'male', 'L2Monster', 'Fighter', 40, 10982, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 34122, 3731, 11515, 958, 7864, 1050, 253, 0, 506, 0, 0, 0, 54, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1914, 22293, 'Spinel', '', 'LineageMonster.stone_golem', 20.00, 31.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 30840, 3224, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 23, 50, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1915, 22294, 'Fire Opal', '', 'LineageMonster4.Crystal_Golem', 34.00, 47.00, 82, 'male', 'L2Monster', 'Fighter', 40, 10982, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 34122, 3731, 11515, 958, 7864, 1050, 253, 0, 506, 0, 0, 0, 54, 170, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1916, 22295, 'Reef Golem', '', 'LineageMonster4.Crystal_Golem', 34.00, 47.00, 82, 'male', 'L2Monster', 'Fighter', 40, 32946, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 99513, 10881, 9906, 958, 6765, 1050, 253, 0, 506, 0, 0, 0, 54, 170, 'oracle_clan', 700, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1917, 22296, 'Reef Golem', '', 'LineageMonster4.Crystal_Golem', 34.00, 47.00, 82, 'male', 'L2Monster', 'Fighter', 40, 32946, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 104675, 11446, 9906, 958, 6765, 1050, 253, 0, 506, 0, 0, 0, 54, 170, 'oracle_clan', 700, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1918, 22297, 'Reef Golem', '', 'LineageMonster4.Crystal_Golem', 34.00, 47.00, 82, 'male', 'L2Monster', 'Fighter', 40, 32946, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 103023, 11265, 9906, 958, 6765, 1050, 253, 0, 506, 0, 0, 0, 54, 170, 'oracle_clan', 700, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1919, 22298, 'Weylin', '', 'LineageMonster.banshee_30_bi', 11.00, 30.00, 82, 'female', 'L2Monster', 'Fighter', 40, 65803, 112.405, 1743, 3.000, 40, 43, 30, 21, 20, 20, 164166, 17951, 9528, 958, 6507, 1050, 253, 0, 506, 3939, 0, 0, 80, 200, 'oracle_clan', 700, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1920, 22299, 'Dolph', '', 'LineageMonster.pan_100_bi', 42.00, 73.00, 82, 'male', 'L2Monster', 'Fighter', 80, 65803, 112.405, 1743, 3.000, 40, 43, 30, 21, 20, 20, 189054, 20673, 9528, 958, 6507, 1050, 253, 0, 506, 213, 0, 0, 45, 170, 'oracle_clan', 700, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.58, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1921, 22300, 'Dolphs Minion', '', 'LineageMonster4.eyeless_080p', 34.00, 35.00, 82, 'male', 'L2Monster', 'Fighter', 40, 10982, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 34451, 3767, 11515, 958, 7864, 1050, 253, 0, 506, 0, 0, 0, 60, 210, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1922, 22301, 'Terod', '', 'LineageMonster.doll_master_20_bi', 24.00, 50.40, 82, 'male', 'L2Monster', 'Fighter', 40, 65803, 112.405, 1743, 3.000, 40, 43, 30, 21, 20, 20, 190311, 20810, 9528, 958, 6507, 1050, 253, 0, 506, 0, 0, 0, 80, 170, 'oracle_clan', 700, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1923, 22302, 'Darnels Guardian', '', 'LineageMonster.pixy_bi', 10.00, 54.00, 82, 'female', 'L2Minion', 'Fighter', 40, 56403, 192.698, 1743, 3.000, 40, 43, 30, 21, 20, 20, 182298, 19934, 15845, 958, 10821, 1050, 253, 0, 506, 0, 0, 0, 80, 150, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1924, 22303, 'Guardian of the Square', '', 'LineageMonster3.ice_fairy', 16.00, 35.60, 82, 'female', 'L2Monster', 'Fighter', 40, 56403, 192.698, 1743, 3.000, 40, 43, 30, 21, 20, 20, 190116, 20789, 15845, 958, 10821, 1050, 253, 0, 506, 0, 0, 0, 30, 250, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1925, 22304, 'Guardian of the Emerald', '', 'LineageMonster.blue_eye_150p', 13.00, 26.00, 82, 'male', 'L2Monster', 'Fighter', 40, 56403, 192.698, 1743, 3.000, 40, 43, 30, 21, 20, 20, 190922, 20877, 15845, 958, 10821, 1050, 253, 0, 506, 0, 0, 0, 35, 200, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1926, 22305, 'Kechis Captain', '', 'LineageMonster.field_stalker_110p', 16.00, 36.00, 82, 'male', 'L2Monster', 'Fighter', 40, 10982, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 34650, 3789, 11515, 958, 7864, 1050, 253, 0, 506, 0, 0, 0, 70, 150, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1927, 22306, 'Kechis Captain', '', 'LineageMonster2.lava_golem', 38.00, 45.00, 82, 'male', 'L2Monster', 'Fighter', 40, 10982, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 88071, 9156, 11515, 958, 7864, 1050, 253, 0, 506, 0, 0, 0, 13, 60, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1928, 22307, 'Kechis Captain', '', 'LineageMonster3.Steel_Trapper', 35.00, 46.38, 82, 'male', 'L2Monster', 'Fighter', 40, 32946, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 190926, 19906, 9906, 958, 6765, 1050, 253, 0, 506, 0, 0, 0, 60, 200, 'oracle_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1929, 22308, 'Kechis Guard', '', 'LineageMonster.mana_vampire_120p', 11.00, 27.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 30391, 3173, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 90, 110, 'oracle_clan', 500, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1930, 22309, 'Kechis Guard', '', 'LineageMonster.blade_stakato_soldier', 15.00, 38.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 42319, 4434, 1804, 599, 1233, 438, 253, 0, 506, 148, 0, 0, 25, 170, 'oracle_clan', 500, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1931, 22310, 'Kechis Guard', '', 'LineageMonster3.portrait_spirit_150p', 23.00, 52.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 39903, 4170, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 30, 200, 'oracle_clan', 500, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1932, 22311, 'Parmes Guardian', '', 'LineageMonster.riba', 25.00, 72.00, 83, 'female', 'L2Monster', 'Fighter', 40, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 180237, 18511, 10002, 974, 6830, 1068, 253, 0, 506, 0, 0, 0, 60, 180, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1933, 22312, 'Fafurions Henchman', '', 'LineageMonster.raikel', 37.00, 64.00, 83, 'male', 'L2Monster', 'Fighter', 40, 65569, 111.355, 1777, 3.000, 40, 43, 30, 21, 20, 20, 190928, 20619, 9615, 974, 6565, 1068, 253, 0, 506, 0, 0, 0, 60, 180, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1934, 22313, 'Garden Stakato', '', 'LineageMonster.blade_stakato_drone', 15.00, 39.00, 83, 'male', 'L2Monster', 'Fighter', 40, 10943, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 60929, 6262, 11653, 974, 7957, 1068, 253, 0, 506, 134, 0, 0, 25, 180, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1935, 22314, 'Garden Poison Moth', '', 'LineageMonster4.Anthias', 20.00, 41.00, 83, 'male', 'L2Monster', 'Fighter', 40, 10943, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 59615, 6120, 11653, 974, 7957, 1068, 253, 0, 506, 0, 0, 0, 60, 180, 'oracle_clan', 500, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1936, 22315, 'Garden Guard ', '', 'LineageMonster.water_giant', 13.00, 44.00, 83, 'male', 'L2Monster', 'Fighter', 80, 10943, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 34896, 3768, 11653, 974, 7957, 1068, 253, 0, 506, 5132, 0, 0, 35, 160, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1937, 22316, 'Garden Guardian Tree', '', 'LineageMonster3.Jungle_Bleeze', 60.00, 47.00, 83, 'female', 'L2Monster', 'Fighter', 40, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 100984, 10905, 10002, 974, 6830, 1068, 253, 0, 506, 0, 0, 0, 60, 180, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1938, 22317, 'Garden Castalia', '', 'LineageMonster4.tears_d', 20.00, 27.50, 83, 'female', 'L2Monster', 'Fighter', 40, 10943, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 14993, 1556, 11653, 974, 7957, 1068, 253, 0, 506, 9639, 9639, 0, 60, 180, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1939, 22320, 'Junior Watchman', '', 'LineageMonster4.eyeless', 36.00, 43.50, 81, 'male', 'L2SpecialMonster', 'HBNative', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 163197, 17624, 10003, 974, 6911, 1069, 253, 500, 506, 0, 0, 0, 60, 180, 'hell_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1940, 22321, 'Junior Summoner', '', 'LineageMonster2.vampire_witch', 6.00, 21.50, 81, 'female', 'L2SpecialMonster', 'HBNative', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 155632, 16807, 10003, 974, 6911, 1069, 253, 500, 506, 946, 0, 0, 64, 180, 'hell_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1941, 22322, 'Subjugated Native', '', 'LineageNPC.a_common_peopleC_Mhuman', 10.00, 24.00, 81, 'male', 'L2Monster', 'HBFighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 11381, 1207, 1890, 609, 1307, 445, 253, 0, 506, 8219, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1942, 22323, 'Charmed Native', '', 'LineageNPC.a_common_peopleC_Mhuman', 10.00, 24.00, 81, 'male', 'L2Monster', 'HBFighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 11746, 1247, 1890, 609, 1307, 445, 253, 0, 506, 8528, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1943, 22324, 'Blind Huntsman', '', 'LineageMonster4.eyeless_080p', 34.00, 35.00, 81, 'male', 'L2SpecialMonster', 'HBFighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 28644, 2983, 1890, 609, 1307, 445, 253, 500, 506, 0, 0, 0, 60, 200, 'hell_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1944, 22325, 'Blind Watchman', '', 'LineageMonster4.eyeless_080p', 34.00, 35.00, 81, 'male', 'L2SpecialMonster', 'HBFighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 25716, 2667, 1890, 609, 1307, 445, 253, 500, 506, 0, 0, 0, 60, 200, 'hell_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1945, 22326, 'Hellinark', '', 'LineageMonster.karik', 25.00, 90.00, 81, 'male', 'L2RaidBoss', 'EnchantedMegaliths', 40, 338767, 194.030, 1709, 3.000, 40, 43, 30, 21, 20, 20, 2629658, 267913, 13527, 991, 9401, 1088, 253, 0, 506, 0, 0, 0, 37, 200, 'hell_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (1946, 22327, 'Arcane Scout', '', 'LineageMonster.dark_mahum', 13.00, 26.00, 81, 'male', 'L2SpecialMonster', 'HBFighter', 40, 65918, 113.265, 1709, 3.000, 40, 43, 30, 21, 20, 20, 320392, 34601, 9614, 974, 6642, 1069, 253, 500, 506, 234, 0, 0, 50, 160, 'hell_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1947, 22328, 'Arcane Guardian', '', 'LineageMonster3.Succubus_Raid', 12.00, 30.70, 81, 'female', 'L2SpecialMonster', 'EnchantedMegaliths', 40, 65918, 113.265, 1709, 3.000, 40, 43, 30, 21, 20, 20, 134976, 13992, 9614, 974, 6642, 1069, 253, 500, 506, 0, 0, 0, 60, 170, 'hell_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1948, 22329, 'Arcane Watchman', '', 'LineageMonster3.Death_Blader_Raid', 15.00, 32.50, 81, 'male', 'L2SpecialMonster', 'HBFighter', 40, 65918, 113.265, 1709, 3.000, 40, 43, 30, 21, 20, 20, 331002, 35747, 9614, 974, 6642, 1069, 253, 500, 506, 0, 0, 0, 60, 170, 'hell_clan', 400, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1949, 22330, 'Remnant Wraith', '', 'LineageMonster3.zombie_laborer', 11.00, 24.60, 81, 'male', 'L2Monster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 17815, 1923, 1890, 609, 1307, 445, 253, 500, 506, 123, 0, 0, 36, 180, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1950, 22334, 'Sand Scorpion', '', 'LineageMonster2.SandScorpion', 28.00, 66.00, 81, 'male', 'L2SpecialMonster', 'HBFighter', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 147904, 15780, 10098, 991, 7018, 1088, 253, 500, 506, 0, 0, 0, 37, 170, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1951, 22335, 'Desert Scorpion', '', 'LineageMonster2.SandScorpion', 28.00, 66.00, 81, 'male', 'L2SpecialMonster', 'HBFighter', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 151636, 16178, 10098, 991, 7018, 1088, 253, 500, 506, 0, 0, 0, 37, 170, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1952, 22336, 'Sand Devil', '', 'LineageMonster2.imperial_warlord_zombie_sand', 7.00, 30.00, 81, 'male', 'L2SpecialMonster', 'HBFighter', 40, 11001, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 50320, 5368, 11790, 991, 8192, 1088, 253, 500, 506, 0, 0, 0, 39, 150, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1953, 22337, 'Desiccator', '', 'LineageMonster.skeleton_knight_sand', 10.00, 25.00, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 11001, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 47148, 5030, 11790, 991, 8192, 1088, 253, 500, 506, 0, 0, 0, 40, 160, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1954, 22339, 'Wandering Caravan', '', 'LineageMonster4.Caravan', 33.00, 58.50, 81, 'male', 'L2Monster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 18810, 2006, 1981, 619, 1377, 452, 253, 500, 506, 0, 0, 0, 56, 160, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1955, 22340, 'Sandstorm', '', 'LineageMonster4.SandTourbillon', 10.00, 28.00, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 146853, 15668, 10098, 991, 7018, 1088, 253, 500, 506, 0, 0, 0, 180, 250, '1', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.21, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1956, 22341, 'Keltas', '', 'LineageMonster3.Vampire_Troop_Leader', 19.00, 35.00, 81, 'male', 'L2SpecialMonster', 'HBFighter', 40, 197755, 113.265, 1709, 3.000, 40, 43, 30, 21, 20, 20, 449480, 47956, 7803, 991, 5423, 1088, 253, 0, 506, 8686, 0, 0, 60, 160, 'hell_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1957, 22342, 'Darions Enforcer', '', 'LineageMonster.silhouette', 8.00, 23.00, 81, 'female', 'L2Monster', 'HBMystic', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 12425, 1325, 1981, 619, 1377, 452, 253, 500, 506, 0, 0, 0, 80, 140, 'hell_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1958, 22343, 'Darions Executioner', '', 'LineageMonster.shadeless', 7.00, 33.00, 81, 'male', 'L2Monster', 'HBMystic', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 9998, 1066, 1981, 619, 1377, 452, 253, 500, 506, 0, 0, 0, 48, 190, 'hell_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1959, 22344, 'Quarry Supervisor', '', 'LineageMonster2.vampire_warrior', 9.00, 31.50, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 70970, 7317, 10098, 991, 7018, 1088, 253, 0, 506, 6723, 0, 0, 43, 165, 'hell_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1960, 22345, 'Quarry Bowman', '', 'LineageMonster2.vampire_wizard', 5.50, 28.00, 81, 'female', 'L2SpecialMonster', 'Fighter', 40, 11001, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 22390, 2303, 11790, 991, 8192, 1088, 253, 0, 506, 99, 0, 0, 46, 165, 'hell_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1961, 22346, 'Quarry Foreman', '', 'LineageMonster3.Vampire_Troop_Leader_120p', 22.00, 43.00, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 65918, 113.265, 1709, 3.000, 40, 43, 30, 21, 20, 20, 274810, 29320, 9700, 991, 6741, 1088, 253, 0, 506, 8686, 0, 0, 60, 165, 'hell_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1962, 22347, 'Quarry Patrolman', '', 'LineageMonster4.eyeless_080p', 34.00, 35.00, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 150397, 16046, 10098, 991, 7018, 1088, 253, 0, 506, 0, 0, 0, 60, 210, 'hell_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1963, 22349, 'Chimera of Earth', '', 'LineageMonster4.Chimera', 35.00, 36.00, 81, 'male', 'L2SpecialMonster', 'Chimera', 40, 65918, 113.265, 1709, 3.000, 40, 43, 30, 21, 20, 20, 282094, 30097, 9700, 991, 6741, 1088, 253, 500, 506, 0, 0, 0, 36, 170, 'test_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1964, 22350, 'Chimera of Darkness', '', 'LineageMonster4.Chimera', 35.00, 36.00, 81, 'male', 'L2SpecialMonster', 'Chimera', 40, 65918, 113.265, 1709, 3.000, 40, 43, 30, 21, 20, 20, 293014, 31262, 9700, 991, 6741, 1088, 253, 500, 506, 0, 0, 0, 36, 170, 'test_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1965, 22351, 'Chimera of Wind', '', 'LineageMonster4.Chimera', 35.00, 36.00, 81, 'male', 'L2SpecialMonster', 'Chimera', 40, 65918, 113.265, 1709, 3.000, 40, 43, 30, 21, 20, 20, 293014, 31262, 9700, 991, 6741, 1088, 253, 500, 506, 0, 0, 0, 36, 170, 'test_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1966, 22352, 'Chimera of Fire', '', 'LineageMonster4.Chimera', 35.00, 36.00, 81, 'male', 'L2SpecialMonster', 'Chimera', 40, 65918, 113.265, 1709, 3.000, 40, 43, 30, 21, 20, 20, 283131, 30208, 9700, 991, 6741, 1088, 253, 500, 506, 0, 0, 0, 36, 170, 'test_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1967, 22353, 'Celtus', '', 'LineageMonster4.Chimera', 35.00, 36.00, 81, 'male', 'L2SpecialMonster', 'Chimera', 40, 338767, 194.030, 1709, 3.000, 40, 43, 30, 21, 20, 20, 1089802, 116275, 13527, 991, 9401, 1088, 253, 500, 506, 0, 0, 0, 36, 170, 'test_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1968, 22355, 'Enceinte Defender', '', 'LineageMonster4.eyeless', 36.00, 43.50, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 18835, 194.184, 1709, 3.000, 40, 43, 30, 21, 20, 20, 81905, 8636, 17971, 1006, 12560, 1105, 253, 500, 506, 0, 0, 0, 60, 210, 'castleout_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1969, 22356, 'Enceinte Defender', '', 'LineageMonster4.eyeless', 36.00, 43.50, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 112922, 194.030, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15830, 1006, 11064, 1105, 253, 500, 506, 0, 0, 0, 60, 210, 'castleout_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1970, 22357, 'Enceinte Defender', '', 'LineageMonster4.eyeless', 36.00, 43.50, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 65918, 113.265, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9785, 1006, 6839, 1105, 253, 500, 506, 0, 0, 0, 60, 210, 'castleout_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1971, 22358, 'Enceinte Defender', '', 'LineageMonster4.eyeless', 36.00, 43.50, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 56506, 194.184, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 16238, 1006, 11349, 1105, 253, 500, 506, 0, 0, 0, 60, 210, 'castleout_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1972, 22359, 'Town Guard', '', 'LineageMonster4.eyeless', 36.00, 43.50, 81, 'male', 'L2SpecialMonster', 'TownGuard', 40, 11001, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 49499, 5219, 11926, 1006, 8335, 1105, 253, 500, 506, 0, 0, 0, 60, 210, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1973, 22360, 'Town Patrolman', '', 'LineageMonster.kel_mahum', 13.00, 26.00, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 143958, 15178, 10193, 1006, 7125, 1105, 253, 500, 506, 7887, 0, 0, 50, 180, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1974, 22361, 'Steel Citadel Keymaster', '', 'LineageMonster4.eyeless', 36.00, 43.50, 81, 'male', 'L2SpecialMonster', 'SteelCitadelKeymaster', 40, 112922, 194.030, 1709, 3.000, 40, 43, 30, 21, 20, 20, 552530, 58258, 15830, 1006, 11064, 1105, 253, 500, 506, 0, 0, 0, 60, 210, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1975, 22362, 'Guzen', '', 'LineageMonster4.rahuu', 33.00, 49.00, 83, 'male', 'L2SpecialMonster', 'Fighter', 40, 336949, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 1086080, 114515, 13753, 1008, 9501, 1106, 253, 500, 506, 0, 0, 0, 60, 170, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.55, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1976, 22363, 'Body Destroyer', '', 'LineageMonster4.finished_malignant', 14.00, 31.50, 83, 'male', 'L2SpecialMonster', 'BodyDestroyer', 40, 56203, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 314158, 33124, 16239, 1008, 11218, 1106, 253, 500, 506, 0, 0, 0, 51, 160, 'castle_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1977, 22364, 'Soul Dominator', '', 'LineageMonster.death_blader', 15.00, 45.00, 83, 'male', 'L2Minion', 'Mystic', 40, 18734, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 106372, 11215, 17971, 1008, 12413, 1106, 253, 0, 506, 1472, 0, 0, 100, 170, 'castle_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1978, 22365, 'Labyrinth Watchman', '', 'LineageMonster4.eyeless_080p', 34.00, 35.00, 83, 'male', 'L2SpecialMonster', 'Fighter', 40, 56203, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 258123, 27216, 16239, 1008, 11218, 1106, 253, 500, 506, 0, 0, 0, 60, 210, 'castle_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.49, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1979, 22366, 'Labyrinth Watchman', '', 'LineageMonster4.eyeless_080p', 34.00, 35.00, 83, 'male', 'L2SpecialMonster', 'Fighter', 40, 56203, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 258123, 27216, 16239, 1008, 11218, 1106, 253, 500, 506, 0, 0, 0, 60, 210, 'castle_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.49, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1980, 22367, 'Labyrinth Mystic', '', 'LineageMonster.vale_master', 12.00, 40.00, 83, 'male', 'L2SpecialMonster', 'Mystic', 40, 18734, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 87693, 9246, 17971, 1008, 12413, 1106, 253, 500, 506, 210, 0, 0, 70, 155, 'castle_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.74, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1981, 22368, 'Labyrinth Captain', '', 'LineageMonster.death_lord', 21.00, 40.00, 83, 'male', 'L2SpecialMonster', 'Fighter', 40, 112316, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 978685, 98149, 15831, 1008, 10936, 1106, 253, 500, 506, 78, 0, 0, 40, 160, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1982, 22369, 'Labyrinth Seer', '', 'LineageMonster2.vampire_wizard', 5.50, 28.00, 83, 'female', 'L2SpecialMonster', 'Mystic', 40, 56203, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 102130, 10259, 16239, 1008, 11218, 1106, 253, 500, 506, 99, 0, 0, 46, 165, 'castle_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1983, 22370, 'Passageway Captain', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 83, 'male', 'PassagewayMobWithHerb', 'Fighter', 40, 56203, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 271142, 28589, 16239, 1008, 11218, 1106, 253, 0, 506, 0, 0, 0, 80, 160, 'castle_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.54, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1984, 22371, 'Passageway Guards', '', 'LineageMonster2.vampire_soldier_20_bi', 10.00, 29.00, 83, 'male', 'L2Monster', 'Fighter', 40, 18734, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 88217, 9301, 17971, 1008, 12413, 1106, 253, 0, 506, 234, 0, 0, 60, 190, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1985, 22372, 'Passageway Mystic', '', 'LineageMonster2.vampire_wizard', 5.50, 28.00, 83, 'female', 'PassagewayMobWithHerb', 'Mystic', 40, 56203, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 257790, 27181, 16239, 1008, 11218, 1106, 253, 0, 506, 99, 0, 0, 46, 165, 'castle_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1986, 22373, 'Cosmic Scout', '', 'LineageMonster.crimson_doll', 15.00, 38.00, 83, 'male', 'L2SpecialMonster', 'Fighter', 40, 18734, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 91940, 9694, 17971, 1008, 12413, 1106, 253, 500, 506, 0, 0, 0, 60, 150, 'castle_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.67, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1987, 22374, 'Cosmic Watcher', '', 'LineageMonster3.zombie_enlisted_man', 17.00, 22.30, 83, 'male', 'L2SpecialMonster', 'Fighter', 40, 56203, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 256950, 27092, 16239, 1008, 11218, 1106, 253, 500, 506, 0, 0, 0, 38, 180, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1988, 22375, 'Cosmic Priest', '', 'LineageMonster2.vampire_wizard', 5.50, 28.00, 83, 'female', 'L2SpecialMonster', 'Mystic', 40, 112316, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 533950, 56299, 15831, 1008, 10936, 1106, 253, 500, 506, 99, 0, 0, 46, 165, 'castle_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1989, 22376, 'Cosmic Lord', '', 'LineageMonster4.rahuu', 33.00, 49.00, 83, 'male', 'L2SpecialMonster', 'Fighter', 40, 336949, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 1086080, 114515, 13753, 1008, 9501, 1106, 253, 500, 506, 0, 0, 0, 60, 170, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.55, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1990, 22377, 'Master Zelos', '', 'LineageMonster4.rahuu', 33.00, 49.00, 83, 'male', 'L2SpecialMonster', 'MasterZelos', 40, 336949, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 1410902, 147054, 13980, 1023, 9713, 1123, 253, 500, 506, 0, 0, 0, 60, 170, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.55, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1991, 22378, 'Masters Minion', '', 'LineageMonster3.Vampire_Troop_Leader', 19.00, 35.00, 83, 'male', 'L2Minion', 'Fighter', 40, 65569, 111.355, 1777, 3.000, 40, 43, 30, 21, 20, 20, 312777, 32599, 9871, 1023, 6858, 1123, 253, 0, 506, 0, 0, 0, 60, 160, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1992, 22379, 'Masters Minion', '', 'LineageMonster2.vampire_witch', 6.00, 21.50, 83, 'female', 'L2Minion', 'Fighter', 40, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 163810, 17073, 10289, 1023, 7148, 1123, 253, 0, 506, 946, 0, 0, 64, 180, 'castle_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.50, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1993, 22380, 'Master Festina', '', 'LineageMonster4.rah', 20.00, 40.60, 83, 'female', 'L2SpecialMonster', 'MasterFestina', 40, 336949, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 1317481, 137317, 13980, 1023, 9713, 1123, 253, 0, 506, 0, 0, 0, 60, 170, 'castle_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.58, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1994, 22381, 'Masters Guard', '', 'LineageMonster3.portrait_spirit', 23.00, 40.00, 83, 'male', 'L2Minion', 'Fighter', 40, 56203, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 297386, 30995, 16368, 1023, 11373, 1123, 253, 0, 506, 0, 0, 0, 30, 200, 'castle_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1995, 22382, 'Masters Guard', '', 'LineageMonster3.portrait_spirit_winged', 23.00, 40.00, 83, 'male', 'L2Minion', 'Fighter', 40, 56203, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 292521, 30488, 16368, 1023, 11373, 1123, 253, 0, 506, 0, 0, 0, 30, 200, 'castle_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1996, 22383, 'Tullys Toy', '', 'LineageMonster3.golem_repair', 23.00, 32.80, 83, 'male', 'L2SpecialMonster', 'Fighter', 40, 56203, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 67470, 6768, 16368, 1023, 11373, 1123, 253, 500, 506, 0, 0, 0, 72, 190, 'castle_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1997, 22384, 'Mystics Toy', '', 'LineageMonster3.golem_microscout', 12.00, 43.50, 83, 'male', 'L2Monster', 'Fighter', 40, 56203, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 50927, 5124, 16368, 1023, 11373, 1123, 253, 0, 506, 0, 0, 0, 30, 250, 'castle_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1998, 22385, 'Tullys Golem Guard', '', 'LineageMonster3.golem_guardian_a', 18.00, 41.50, 83, 'male', 'L2SpecialMonster', 'Fighter', 40, 112316, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 476711, 49686, 15950, 1023, 11082, 1123, 253, 500, 506, 0, 0, 0, 53, 200, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (1999, 22386, 'Foundry Mystic', '', 'LineageMonster.doll_master', 20.00, 42.00, 83, 'male', 'L2SpecialMonster', 'Mystic', 40, 56203, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 291223, 30353, 16368, 1023, 11373, 1123, 253, 500, 506, 0, 0, 0, 80, 160, 'castle_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.56, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2000, 22387, 'Foundry Mystic', '', 'LineageMonster.doll_master', 20.00, 42.00, 83, 'male', 'L2SpecialMonster', 'Fighter', 40, 56203, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 291223, 30353, 16368, 1023, 11373, 1123, 253, 0, 506, 0, 0, 0, 80, 160, 'castle_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.56, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2001, 22388, 'Foundry Spirit Guard', '', 'LineageMonster4.finished_malignant', 14.00, 31.50, 83, 'male', 'L2SpecialMonster', 'Fighter', 40, 112316, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 640012, 66706, 15950, 1023, 11082, 1123, 253, 500, 506, 0, 0, 0, 51, 160, 'castle_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.47, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2002, 22389, 'Foundry Spirit Guard', '', 'LineageMonster4.finished_malignant', 14.00, 31.50, 83, 'male', 'L2SpecialMonster', 'Fighter', 40, 112316, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 640012, 66706, 15950, 1023, 11082, 1123, 253, 0, 506, 0, 0, 0, 51, 160, 'castle_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.47, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2003, 22390, 'Foundry Foreman', '', 'LineageMonster2.ahrimanes_20_sm', 13.00, 47.20, 83, 'male', 'L2SpecialMonster', 'Fighter', 80, 112316, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 609074, 65777, 15588, 974, 10645, 1068, 253, 500, 506, 0, 0, 0, 35, 185, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2004, 22391, 'Foundry Assistant Overseer', '', 'LineageMonster2.ashuras', 13.00, 37.50, 83, 'male', 'L2Minion', 'Fighter', 40, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 286741, 29436, 10002, 974, 6830, 1068, 253, 0, 506, 0, 0, 0, 41, 190, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2005, 22392, 'Failed Experimental Timetwister Golem', '', 'LineageMonster3.golem_microscout_a', 28.00, 52.50, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 45682, 4530, 2160, 640, 1500, 468, 253, 0, 506, 0, 0, 0, 46, 250, 'castle_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.51, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2006, 22393, 'Beleths Follower', '', 'LineageMonster3.zombie_gateguard', 17.00, 30.50, 83, 'male', 'L2Monster', 'Fighter', 40, 65569, 111.355, 1777, 3.000, 40, 43, 30, 21, 20, 20, 358097, 37323, 9871, 1023, 6858, 1123, 253, 0, 506, 8217, 0, 0, 33, 160, 'castle_clan', 1500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2007, 22394, 'Beleths Devotee', '', 'LineageMonster3.portrait_spirit_winged', 23.00, 40.00, 83, 'male', 'L2Monster', 'Fighter', 40, 196708, 111.355, 1777, 3.000, 40, 43, 30, 21, 20, 20, 304451, 30461, 8087, 1023, 5619, 1123, 253, 0, 506, 0, 0, 0, 30, 200, 'castle_clan', 1500, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2008, 22395, 'Beleths Projection', '', 'LineageMonster4.behamah', 25.00, 37.50, 83, 'male', 'L2Monster', 'Fighter', 40, 56203, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 652377, 64757, 16368, 1023, 11373, 1123, 253, 0, 506, 10278, 10278, 0, 70, 190, 'castle_clan', 1500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2009, 22396, 'Foundry Laborer', '', 'LineageMonster4.Caravan_Slave', 35.00, 47.50, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 11272, 1174, 2160, 640, 1500, 468, 253, 0, 506, 0, 0, 0, 46, 160, 'castle_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2010, 22397, 'Foundry Foreman  ', '', 'LineageMonster4.rahuu', 33.00, 49.00, 83, 'male', 'L2Monster', 'Fighter', 40, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 145669, 15182, 10289, 1023, 7148, 1123, 253, 0, 506, 0, 0, 0, 60, 180, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.55, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2011, 22398, 'Lesser Evil', '', 'LineageMonster3.zombie_gateguard', 17.00, 30.50, 83, 'male', 'L2Monster', 'Fighter', 80, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 268445, 26626, 10289, 1023, 7148, 1123, 253, 0, 506, 8217, 0, 0, 33, 120, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2012, 22399, 'Greater Evil', '', 'LineageMonster3.zombie_gateguard_120p', 18.00, 37.00, 83, 'male', 'L2Monster', 'Fighter', 80, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 385754, 38241, 10289, 1023, 7148, 1123, 253, 0, 506, 8217, 0, 0, 43, 120, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2013, 22400, 'Parmes Healer', '', 'LineageMonster4.tears_d', 20.00, 27.50, 83, 'female', 'L2Monster', 'Priest', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 8893, 972, 1804, 599, 1225, 437, 253, 0, 506, 9639, 9639, 0, 60, 180, 'oracle_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2014, 22401, 'Parmes Healer', '', 'LineageMonster4.tears_d', 20.00, 27.50, 83, 'female', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 8893, 972, 1804, 599, 1225, 437, 253, 0, 506, 9639, 9639, 0, 60, 180, 'oracle_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2015, 22402, 'Shadow Column', '', 'LineageNpcEV.dark_clouds_chessman', 68.00, 80.00, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 8545, 934, 1804, 599, 1225, 437, 253, 0, 506, 0, 0, 0, 1, 100, 'oracle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2016, 22403, 'Foundry Foreman  ', '', 'LineageMonster4.rahuu', 20.00, 40.60, 83, 'female', 'L2Monster', 'Fighter', 40, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 147344, 15357, 10289, 1023, 7148, 1123, 253, 0, 506, 0, 0, 0, 60, 170, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2017, 22404, 'Arcane Captain', '', 'LineageMonster.kaim_vanul', 24.00, 40.00, 83, 'male', 'L2Monster', 'Fighter', 40, 65569, 111.355, 1777, 3.000, 40, 43, 30, 21, 20, 20, 589351, 60722, 9615, 974, 6565, 1068, 253, 0, 506, 0, 0, 0, 37, 160, 'hell_clan', 700, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2018, 22405, 'Darions Faithful Servant', '', 'LineageMonster4.demon_darion_fgt', 12.00, 43.50, 83, 'male', 'L2Monster', 'Fighter', 80, 10943, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 105809, 10510, 12062, 1023, 8382, 1123, 253, 0, 506, 0, 0, 0, 30, 180, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2019, 22406, 'Darions Faithful Servant', '', 'LineageMonster4.demon_darion_fgt', 28.00, 52.50, 83, 'male', 'L2Monster', 'Fighter', 80, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 183265, 19101, 10289, 1023, 7148, 1123, 253, 0, 506, 0, 0, 0, 46, 180, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.51, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2020, 22407, 'Darions Faithful Servant', '', 'LineageMonster4.demon_darion_fgt', 28.00, 52.50, 83, 'male', 'L2Monster', 'Fighter', 80, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 323450, 32158, 10289, 1023, 7148, 1123, 253, 0, 506, 0, 0, 0, 46, 180, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.51, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2021, 22408, 'Darions Faithful Servant', '', 'LineageMonster4.demon_darion_fgt', 28.00, 52.50, 83, 'male', 'L2Monster', 'Fighter', 80, 56203, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 306237, 31559, 16495, 1041, 11526, 1142, 253, 0, 506, 0, 0, 0, 46, 180, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.51, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2022, 22409, 'Darions Faithful Servant', '', 'LineageMonster4.demon_darion_fgt', 28.00, 52.50, 83, 'male', 'L2Monster', 'Fighter', 80, 112316, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 677999, 69871, 16068, 1041, 11228, 1142, 253, 0, 506, 0, 0, 0, 46, 180, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.51, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2023, 22410, 'Darions Faithful Servant', '', 'LineageMonster4.demon_darion_fgt', 28.00, 52.50, 83, 'male', 'L2Monster', 'Fighter', 80, 112316, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 796818, 82116, 16068, 1041, 11228, 1142, 253, 0, 506, 0, 0, 0, 46, 180, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.51, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2024, 22411, 'Beleths Retainer', '', 'LineageMonster4.demon_darion_fgt', 28.00, 52.50, 83, 'male', 'L2Monster', 'Fighter', 80, 18734, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 483637, 47912, 18143, 1023, 12604, 1123, 253, 0, 506, 0, 0, 0, 46, 180, 'castle_clan', 1500, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.51, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2025, 22412, 'Beleths Fighter', '', 'LineageMonster4.behamah_120p', 32.00, 46.80, 83, 'male', 'L2Monster', 'Fighter', 40, 112316, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 1387469, 137882, 15950, 1023, 11082, 1123, 253, 0, 506, 10278, 10278, 0, 80, 190, 'castle_clan', 1500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2026, 22413, 'Beleths Low Servant', '', 'LineageMonster3.spectral_knight', 12.50, 33.50, 83, 'male', 'L2Monster', 'Fighter', 80, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 541934, 53798, 10289, 1023, 7148, 1123, 253, 0, 506, 0, 0, 0, 160, 160, 'castle_clan', 1500, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2027, 22414, 'Beleths Follower', '', 'LineageMonster3.zombie_gateguard', 17.00, 30.50, 83, 'male', 'L2Monster', 'Fighter', 40, 65569, 111.355, 1777, 3.000, 40, 43, 30, 21, 20, 20, 358097, 37323, 9871, 1023, 6858, 1123, 253, 0, 506, 8217, 0, 0, 33, 160, 'castle_clan', 1500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2028, 22415, 'Beleths Devotee', '', 'LineageMonster3.portrait_spirit_winged', 23.00, 40.00, 83, 'male', 'L2Monster', 'Fighter', 40, 196708, 111.355, 1777, 3.000, 40, 43, 30, 21, 20, 20, 304451, 30461, 8087, 1023, 5619, 1123, 253, 0, 506, 0, 0, 0, 30, 200, 'castle_clan', 1500, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2029, 22416, 'Kechis Captain', '', 'LineageMonster2.ifrit_30_bi', 13.00, 55.00, 82, 'male', 'L2Monster', 'Fighter', 40, 65803, 112.405, 1743, 3.000, 40, 43, 30, 21, 20, 20, 199714, 21838, 9528, 958, 6507, 1050, 253, 0, 506, 0, 0, 0, 38, 200, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2030, 22417, 'Kechis Guard', '', 'LineageMonster3.portrait_spirit_winged_150p', 23.00, 52.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 41505, 4345, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 30, 200, 'oracle_clan', 500, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2031, 22418, 'Burning Iris', '', 'LineageMonster4.eyeless_080p', 34.00, 35.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 28000, 2921, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 60, 200, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2032, 22419, 'Flame Iris', '', 'LineageMonster4.eyeless_080p', 34.00, 35.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 26322, 2738, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 60, 200, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2033, 22420, 'Brimstone Iris', '', 'LineageMonster4.eyeless_080p', 34.00, 35.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 28704, 2998, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 60, 200, 'oracle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2034, 22422, 'Failans Guard', '', 'LineageMonster3.Death_Blader_Raid', 15.00, 32.50, 83, 'male', 'L2SpecialMonster', 'EnchantedMegaliths', 40, 10943, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 63485, 6856, 11653, 974, 7957, 1068, 253, 0, 506, 0, 0, 0, 60, 170, 'hell_clan', 400, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2035, 22423, 'Original Sin Warden', '', 'LineageMonster4.behamah', 28.00, 52.50, 83, 'male', 'L2Monster', 'Fighter', 40, 65569, 111.355, 1777, 3.000, 40, 43, 30, 21, 20, 20, 69803, 6996, 9871, 1023, 6858, 1123, 253, 0, 506, 0, 0, 0, 46, 190, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.51, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2036, 22424, 'Slave of Greed', '', 'LineageMonster2.ashuras', 13.00, 37.50, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 60503, 6075, 2160, 640, 1500, 468, 253, 0, 506, 0, 0, 0, 41, 190, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2037, 22425, 'Slave of Lust', '', 'LineageMonster3.Succubus_Raid', 12.00, 30.70, 83, 'female', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 60503, 6075, 2160, 640, 1500, 468, 253, 0, 506, 0, 0, 0, 60, 170, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2038, 22426, 'Slave of Wrath', '', 'LineageMonster.vale_master_10_bi', 13.00, 44.00, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 60503, 6075, 2160, 640, 1500, 468, 253, 0, 506, 0, 0, 0, 70, 160, 'castle_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2039, 22427, 'Slave of Sloth', '', 'LineageMonster2.giant_zombie', 13.00, 40.00, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 60503, 6075, 2160, 640, 1500, 468, 253, 0, 506, 0, 0, 0, 20, 100, 'castle_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2040, 22428, 'Slave of Envy', '', 'LineageMonster3.Bloody_Queen_Raid', 11.00, 34.00, 83, 'female', 'L2Monster', 'Fighter', 80, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 60503, 6075, 2160, 640, 1500, 468, 253, 0, 506, 0, 0, 0, 60, 170, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2041, 22429, 'Slave of Pride', '', 'LineageMonster2.knight_of_shadow', 10.00, 35.50, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 60503, 6075, 2160, 640, 1500, 468, 253, 0, 506, 0, 0, 0, 30, 170, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2042, 22430, 'Slave of Gluttony', '', 'LineageMonster3.Death_Blader_Raid', 15.00, 32.50, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 60503, 6075, 2160, 640, 1500, 468, 253, 0, 506, 0, 0, 0, 60, 170, 'castle_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2043, 22431, 'Original Sin Warden', '', 'LineageMonster4.behamah', 25.00, 37.50, 83, 'male', 'L2Monster', 'Fighter', 40, 112316, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 139297, 13961, 15950, 1023, 11082, 1123, 253, 0, 506, 10278, 10278, 0, 70, 190, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2044, 22432, 'Slave of Greed', '', 'LineageMonster2.ashuras', 13.00, 37.50, 83, 'male', 'L2Monster', 'Fighter', 40, 10943, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 35640, 3714, 12062, 1023, 8382, 1123, 253, 0, 506, 0, 0, 0, 41, 190, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2045, 22433, 'Slave of Lust', '', 'LineageMonster3.Succubus_Raid', 12.00, 30.70, 83, 'female', 'L2Monster', 'Fighter', 40, 10943, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 35640, 3714, 12062, 1023, 8382, 1123, 253, 0, 506, 0, 0, 0, 60, 170, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2046, 22434, 'Slave of Wrath', '', 'LineageMonster.vale_master_10_bi', 13.00, 44.00, 83, 'male', 'L2Monster', 'Fighter', 40, 10943, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 35640, 3714, 12062, 1023, 8382, 1123, 253, 0, 506, 0, 0, 0, 70, 160, 'castle_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2047, 22435, 'Slave of Sloth', '', 'LineageMonster2.giant_zombie', 13.00, 40.00, 83, 'male', 'L2Monster', 'Fighter', 40, 10943, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 35640, 3714, 12062, 1023, 8382, 1123, 253, 0, 506, 0, 0, 0, 20, 100, 'castle_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2048, 22436, 'Slave of Envy', '', 'LineageMonster3.Bloody_Queen_Raid', 11.00, 34.00, 83, 'female', 'L2Monster', 'Fighter', 80, 10943, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 35640, 3714, 12062, 1023, 8382, 1123, 253, 0, 506, 0, 0, 0, 60, 170, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2049, 22437, 'Slave of Pride', '', 'LineageMonster2.knight_of_shadow', 10.00, 35.50, 83, 'male', 'L2Monster', 'Fighter', 40, 10943, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 35640, 3714, 12062, 1023, 8382, 1123, 253, 0, 506, 0, 0, 0, 30, 170, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2050, 22438, 'Slave of Gluttony', '', 'LineageMonster3.Death_Blader_Raid', 15.00, 32.50, 83, 'male', 'L2Monster', 'Fighter', 40, 10943, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 35640, 3714, 12062, 1023, 8382, 1123, 253, 0, 506, 0, 0, 0, 60, 170, 'castle_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2051, 22439, 'Beleths Assassin', '', 'LineageMonster.dark_mahum', 13.00, 26.00, 83, 'male', 'L2Monster', 'Fighter', 40, 112316, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 733679, 76469, 15950, 1023, 11082, 1123, 253, 0, 506, 234, 0, 0, 50, 180, '', 1500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2052, 22440, 'Beleths Assassin', '', 'LineageMonster.dark_mahum', 13.00, 26.00, 83, 'male', 'L2Monster', 'Fighter', 40, 112316, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 755088, 78701, 15950, 1023, 11082, 1123, 253, 0, 506, 234, 0, 0, 50, 180, '', 1500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2053, 22441, 'Beleths Minion', '', 'LineageMonster3.Vampire_Troop_Leader_120p', 22.00, 43.00, 83, 'male', 'L2Monster', 'Fighter', 40, 56203, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 638455, 63306, 16368, 1023, 11373, 1123, 253, 0, 506, 8686, 0, 0, 60, 160, '', 1500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2054, 22442, 'Beleths Minion', '', 'LineageMonster3.Vampire_Troop_Leader_120p', 22.00, 43.00, 83, 'male', 'L2Monster', 'Fighter', 40, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 363488, 36034, 10289, 1023, 7148, 1123, 253, 0, 506, 8686, 0, 0, 60, 160, '', 1500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2055, 22443, 'Kertangs Messenger', '', 'LineageMonster4.snake_head_man', 20.00, 36.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 3835, 266, 315, 239, 214, 174, 253, 0, 506, 0, 0, 0, 35, 160, '1', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2056, 22444, 'Kertangs Messenger', '', 'LineageMonster4.snake_head_man', 20.00, 36.00, 55, 'male', 'L2Monster', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 5728, 462, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 35, 160, '1', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2057, 22445, 'Kertangs Messenger', '', 'LineageMonster4.snake_head_man', 20.00, 36.00, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 7798, 724, 898, 419, 613, 306, 253, 0, 506, 0, 0, 0, 35, 160, '1', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2058, 22446, 'Kertangs Messenger', '', 'LineageMonster4.snake_head_man', 20.00, 36.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 9659, 1018, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 15, 160, '1', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2059, 22447, 'Kertangs Messenger', '', 'LineageMonster4.snake_head_man', 20.00, 36.00, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 10184, 1143, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 15, 160, '1', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2060, 22448, 'Leodas', '', 'LineageNPC.a_fighterguild_master_Mhuman_old', 8.00, 23.50, 86, 'male', 'L2Monster', 'Leodas', 40, 194673, 108.314, 1882, 3.000, 40, 43, 30, 21, 20, 20, 944308, 93684, 8087, 1024, 5523, 1124, 253, 0, 506, 6611, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2061, 22449, 'Amaskari', '', 'LineageMonster2.ahrimanes', 14.00, 57.75, 86, 'male', 'L2Monster', 'HBMystic', 40, 64891, 108.314, 1882, 3.000, 40, 43, 30, 21, 20, 20, 213008, 22201, 9870, 1024, 6741, 1124, 253, 0, 506, 6722, 0, 0, 35, 185, 'castle_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2062, 22450, 'Tortured Native', '', 'LineageNPC.a_common_peopleC_Mhuman', 10.00, 24.00, 86, 'male', 'L2Monster', 'Fighter', 40, 4440, 8.500, 1882, 3.000, 40, 43, 30, 21, 20, 20, 9210, 959, 2160, 641, 1475, 469, 253, 0, 506, 946, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2063, 22451, 'Native Elite Soldier', '', 'LineageNPC.a_common_peopleC_Mhuman', 10.00, 24.00, 86, 'male', 'L2Monster', 'Fighter', 40, 4440, 8.500, 1882, 3.000, 40, 43, 30, 21, 20, 20, 16123, 1680, 2160, 641, 1475, 469, 253, 0, 506, 135, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2064, 22452, 'White Skull Kanabion', '', 'LineageMonster.skeleton_pikeman', 10.00, 28.00, 25, 'male', 'Kanabion', 'Fighter', 80, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 1136, 56, 74, 116, 50, 86, 253, 0, 506, 292, 0, 0, 50, 155, 'rim_clan', 200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.21, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2065, 22453, 'White Skull Kanabion', 'Doppler', 'LineageMonster.skeleton_knight_20_bi', 12.00, 30.50, 25, 'male', 'Kanabion', 'Fighter', 80, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 1136, 56, 74, 116, 50, 86, 253, 0, 506, 5285, 0, 0, 40, 160, 'rim_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2066, 22454, 'White Skull Kanabion', 'Void', 'LineageMonster.skeleton_royal_guard_30_bi', 14.00, 37.50, 27, 'male', 'Kanabion', 'Fighter', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 1463, 62, 75, 118, 51, 87, 253, 0, 506, 236, 0, 0, 80, 120, 'rim_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2067, 22455, 'Begrudged Kanabion', '', 'LineageMonster.orc', 10.00, 21.00, 30, 'male', 'Kanabion', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1499, 81, 111, 140, 75, 104, 253, 0, 506, 127, 0, 0, 45, 110, 'rim_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2068, 22456, 'Begrudged Kanabion', 'Doppler', 'LineageMonster.orc_fighter', 12.00, 22.00, 30, 'male', 'Kanabion', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1499, 81, 111, 140, 75, 104, 253, 0, 506, 129, 0, 0, 45, 110, 'rim_clan', 200, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2069, 22457, 'Begrudged Kanabion', 'Void', 'LineageMonster.orc_champion', 10.00, 23.00, 32, 'male', 'Kanabion', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 1883, 90, 113, 143, 76, 105, 253, 0, 506, 7886, 0, 0, 45, 130, 'rim_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2070, 22458, 'Rotten Kanabion', '', 'LineageMonster.zombie_bi_one', 13.00, 30.50, 35, 'male', 'Kanabion', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 2040, 120, 160, 170, 109, 124, 253, 0, 506, 0, 0, 0, 15, 15, 'rim_clan', 200, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2071, 22459, 'Rotten Kanabion', 'Doppler', 'LineageMonster.neer_crawler', 14.00, 22.00, 35, 'male', 'Kanabion', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 2040, 120, 160, 170, 109, 124, 253, 0, 506, 0, 0, 0, 50, 90, 'rim_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2072, 22460, 'Rotten Kanabion', 'Void', 'LineageMonster3.Zombie_Raid', 30.00, 21.25, 37, 'male', 'Kanabion', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 2517, 133, 163, 173, 111, 126, 253, 0, 506, 0, 0, 0, 60, 170, 'rim_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2073, 22461, 'Gluttonous Kanabion', '', 'LineageMonster.crokian', 18.00, 29.00, 40, 'male', 'Kanabion', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 2665, 172, 227, 203, 155, 148, 253, 0, 506, 5128, 0, 0, 18, 150, 'rim_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.78, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2074, 22462, 'Gluttonous Kanabion', 'Doppler', 'LineageMonster3.Crokian_Officer', 25.00, 33.00, 40, 'male', 'Kanabion', 'Fighter', 80, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 2665, 172, 227, 203, 155, 148, 253, 0, 506, 0, 0, 0, 60, 160, 'rim_clan', 200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2075, 22463, 'Gluttonous Kanabion', 'Void', 'LineageMonster.nos', 26.00, 42.00, 42, 'male', 'Kanabion', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 3243, 189, 231, 206, 157, 151, 253, 0, 506, 5130, 0, 0, 18, 150, 'rim_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.78, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2076, 22464, 'Callous Kanabion', '', 'LineageMonster.zenta_lizardman', 11.00, 32.00, 45, 'male', 'Kanabion', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 3373, 234, 315, 239, 214, 174, 253, 0, 506, 7887, 0, 0, 37, 140, 'rim_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2077, 22465, 'Callous Kanabion', 'Doppler', 'LineageMonster.zenta_lizardman_warrior', 13.00, 35.00, 45, 'male', 'Kanabion', 'Fighter', 80, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 3373, 234, 315, 239, 214, 174, 253, 0, 506, 298, 0, 0, 40, 140, 'rim_clan', 200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2078, 22466, 'Callous Kanabion', 'Void', 'LineageMonster.zenta_lizardman_matriarch', 20.00, 40.00, 47, 'male', 'Kanabion', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 4061, 258, 320, 242, 218, 177, 253, 0, 506, 226, 0, 0, 53, 140, 'rim_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2079, 22467, 'Savage Kanabion', '', 'LineageMonster.heltor_silenos', 13.00, 29.00, 50, 'male', 'Kanabion', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 3984, 300, 425, 278, 291, 204, 253, 0, 506, 77, 0, 0, 34, 160, 'rim_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2080, 22468, 'Savage Kanabion', 'Doppler', 'LineageMonster.heltor_silenos_warrior', 13.00, 31.00, 50, 'male', 'Kanabion', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 3984, 300, 425, 278, 291, 204, 253, 0, 506, 75, 0, 0, 36, 160, 'rim_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2081, 22469, 'Savage Kanabion', 'Void', 'LineageMonster.heltor_silenos_chieftain', 13.00, 31.50, 52, 'male', 'Kanabion', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 4776, 332, 431, 282, 295, 207, 253, 0, 506, 84, 0, 0, 27, 160, 'rim_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2082, 22470, 'Peerless Kanabion', '', 'LineageMonster.batur_orc_20_bi', 10.00, 25.30, 55, 'male', 'Kanabion', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 4821, 389, 559, 323, 382, 236, 253, 0, 506, 7888, 0, 0, 80, 130, 'rim_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2083, 22471, 'Peerless Kanabion', 'Doppler', 'LineageMonster.batur_orc_warrior_20_bi', 12.00, 24.00, 55, 'male', 'Kanabion', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 4821, 389, 559, 323, 382, 236, 253, 0, 506, 84, 0, 0, 80, 120, 'rim_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2084, 22472, 'Peerless Kanabion', 'Void', 'LineageMonster.batur_orc_overlord_20_bi', 14.00, 28.80, 57, 'male', 'Kanabion', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 5739, 431, 566, 327, 387, 239, 253, 0, 506, 135, 0, 0, 80, 140, 'rim_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2085, 22473, 'Massive Kanabion', '', 'LineageMonster.kel_mahum', 13.00, 26.00, 60, 'male', 'Kanabion', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 5737, 497, 717, 370, 490, 270, 253, 0, 506, 127, 0, 0, 50, 160, 'rim_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2086, 22474, 'Massive Kanabion', 'Doppler', 'LineageMonster.kel_mahum_warrior', 13.00, 28.00, 60, 'male', 'Kanabion', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 5737, 497, 717, 370, 490, 270, 253, 0, 506, 148, 0, 0, 50, 160, 'rim_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2087, 22475, 'Massive Kanabion', 'Void', 'LineageMonster.kel_mahum_champion', 13.00, 32.00, 62, 'male', 'Kanabion', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 6790, 552, 726, 374, 497, 273, 253, 0, 506, 161, 0, 0, 50, 170, 'rim_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2088, 22476, 'Fervent Kanabion', '', 'LineageMonster2.vampire_soldier', 8.00, 23.50, 65, 'male', 'Kanabion', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 6733, 625, 898, 419, 613, 306, 253, 0, 506, 85, 0, 0, 60, 190, 'rim_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2089, 22477, 'Fervent Kanabion', 'Doppler', 'LineageMonster2.vampire_warrior', 9.00, 31.50, 65, 'male', 'Kanabion', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 6733, 625, 898, 419, 613, 306, 253, 0, 506, 6723, 0, 0, 43, 165, 'rim_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2090, 22478, 'Fervent Kanabion', 'Void', 'LineageMonster3.Vampire_Troop_Leader', 19.00, 35.00, 67, 'male', 'Kanabion', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 7929, 693, 909, 424, 621, 310, 253, 0, 506, 8686, 0, 0, 60, 160, 'rim_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2091, 22479, 'Ruptured Kanabion', '', 'LineageMonster4.eyeless_080p', 34.00, 35.00, 70, 'male', 'Kanabion', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 7597, 753, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 210, 'rim_clan', 200, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2092, 22480, 'Ruptured Kanabion', 'Doppler', 'LineageMonster4.eyeless', 36.00, 43.50, 70, 'male', 'Kanabion', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 7597, 753, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 210, 'rim_clan', 200, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2093, 22481, 'Ruptured Kanabion', 'Void', 'LineageMonster4.eyeless_120p', 38.00, 54.00, 72, 'male', 'Kanabion', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 8933, 837, 1109, 477, 757, 349, 253, 0, 506, 0, 0, 0, 60, 210, 'rim_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2094, 22482, 'Sword Kanabion', '', 'LineageMonster4.rah', 20.00, 40.60, 75, 'female', 'Kanabion', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 8721, 919, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 170, 'rim_clan', 200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.58, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2095, 22483, 'Sword Kanabion', 'Doppler', 'LineageMonster4.rahuu', 33.00, 49.00, 75, 'male', 'Kanabion', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 8721, 919, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 170, 'rim_clan', 200, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.55, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2096, 22484, 'Sword Kanabion', 'Void', 'LineageMonster4.rahuu', 33.00, 49.00, 77, 'male', 'Kanabion', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 10217, 1022, 1320, 530, 901, 388, 253, 0, 506, 0, 0, 0, 60, 180, 'rim_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.55, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2097, 22485, 'Lost Watcher', '', 'LineageMonster.oel_mahum', 20.00, 37.00, 29, 'male', 'L2SpecialMonster', 'Fighter', 40, 4970, 24.604, 315, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 389, 217, 266, 238, 253, 1000, 506, 127, 0, 0, 70, 110, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2098, 22486, 'Lost Watcher', '', 'LineageMonster.oel_mahum', 20.00, 37.00, 29, 'male', 'L2SpecialMonster', 'Fighter', 40, 4970, 24.604, 315, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 389, 217, 266, 238, 253, 1000, 506, 127, 0, 0, 70, 110, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2099, 22487, 'Lost Beholder', '', 'LineageMonster.oel_mahum_warrior', 20.00, 38.00, 29, 'male', 'L2SpecialMonster', 'Fighter', 40, 9939, 24.604, 315, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 320, 217, 218, 238, 253, 1000, 506, 72, 0, 0, 70, 160, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2100, 22488, 'Lost Watcher', '', 'LineageMonster.zenta_lizardman', 11.00, 32.00, 39, 'male', 'L2SpecialMonster', 'Fighter', 40, 7317, 33.396, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 312, 833, 343, 253, 1000, 506, 68, 0, 0, 37, 140, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2101, 22489, 'Lost Watcher', '', 'LineageMonster.zenta_lizardman', 11.00, 32.00, 39, 'male', 'L2SpecialMonster', 'Fighter', 40, 7317, 33.396, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 312, 833, 343, 253, 1000, 506, 68, 0, 0, 37, 140, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2102, 22490, 'Lost Beholder', '', 'LineageMonster.zenta_lizardman_warrior', 13.00, 35.00, 39, 'male', 'L2SpecialMonster', 'Fighter', 40, 14607, 33.335, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 1010, 312, 690, 343, 253, 1000, 506, 16, 0, 0, 40, 140, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2103, 22491, 'Lost Watcher', '', 'LineageMonster.stone_golem', 20.00, 31.00, 49, 'male', 'L2SpecialMonster', 'Fighter', 40, 16606, 70.299, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 2160, 432, 1475, 475, 253, 1000, 506, 0, 0, 0, 23, 23, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2104, 22492, 'Lost Watcher', '', 'LineageMonster.stone_golem', 20.00, 31.00, 49, 'male', 'L2SpecialMonster', 'Fighter', 40, 16606, 70.299, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 2160, 432, 1475, 475, 253, 1000, 506, 0, 0, 0, 23, 23, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2105, 22493, 'Lost Beholder', '', 'LineageMonster.iron_golem_bi', 27.00, 52.00, 49, 'male', 'L2SpecialMonster', 'Fighter', 40, 33211, 70.299, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1815, 432, 1239, 475, 253, 1000, 506, 0, 0, 0, 20, 20, 'abyss_clan', 1000, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2106, 22494, 'Lost Watcher', '', 'LineageMonster.skeleton_royal_guard', 11.00, 28.50, 59, 'male', 'L2SpecialMonster', 'Fighter', 40, 29969, 118.297, 1007, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 5241, 576, 3579, 630, 253, 1000, 506, 946, 945, 0, 80, 120, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2107, 22495, 'Lost Watcher', '', 'LineageMonster.skeleton_royal_guard', 11.00, 28.50, 59, 'male', 'L2SpecialMonster', 'Fighter', 40, 29969, 118.297, 1007, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 5241, 576, 3579, 630, 253, 1000, 506, 946, 945, 0, 80, 120, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2108, 22496, 'Lost Beholder', '', 'LineageMonster.doll_master', 20.00, 42.00, 59, 'male', 'L2SpecialMonster', 'Fighter', 40, 59874, 118.173, 1007, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 4751, 576, 3244, 630, 253, 1000, 506, 0, 0, 0, 80, 160, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2109, 22497, 'Lost Watcher', '', 'LineageMonster2.bandersnatch', 18.00, 25.00, 69, 'male', 'L2SpecialMonster', 'Fighter', 40, 34684, 128.244, 1314, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 8488, 736, 5795, 807, 253, 1000, 506, 0, 0, 0, 30, 170, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2110, 22498, 'Lost Watcher', '', 'LineageMonster2.bandersnatch', 18.00, 25.00, 69, 'male', 'L2SpecialMonster', 'Fighter', 40, 34684, 128.244, 1314, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 8488, 736, 5795, 807, 253, 1000, 506, 0, 0, 0, 30, 170, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2111, 22499, 'Lost Beholder', '', 'LineageMonster.onyx_beast_150p', 20.00, 23.50, 69, 'male', 'L2SpecialMonster', 'Fighter', 40, 69294, 128.109, 1314, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 8320, 736, 5682, 807, 253, 1000, 506, 0, 0, 0, 30, 170, 'abyss_clan', 1000, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.24, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2112, 22500, 'Lost Watcher', '', 'LineageMonster.angel', 13.50, 36.50, 78, 'male', 'L2SpecialMonster', 'Fighter', 40, 56858, 198.905, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15063, 888, 10286, 975, 253, 1000, 506, 148, 0, 0, 30, 170, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2113, 22501, 'Lost Watcher', '', 'LineageMonster.angel', 13.50, 36.50, 78, 'male', 'L2SpecialMonster', 'Fighter', 40, 56858, 198.905, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15063, 888, 10286, 975, 253, 1000, 506, 148, 0, 0, 30, 170, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2114, 22502, 'Lost Beholder', '', 'LineageMonster2.apostle_warrior', 8.00, 30.00, 78, 'female', 'L2SpecialMonster', 'Fighter', 40, 113627, 198.749, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 14726, 888, 10057, 975, 253, 1000, 506, 6717, 0, 0, 50, 180, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2115, 22503, 'Lost Watcher', '', 'LineageMonster4.behamah', 25.00, 37.50, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 56506, 194.184, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15713, 940, 10729, 1032, 253, 1000, 506, 10278, 10278, 0, 70, 190, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2116, 22504, 'Lost Watcher', '', 'LineageMonster4.behamah', 25.00, 37.50, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 56506, 194.184, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15713, 940, 10729, 1032, 253, 1000, 506, 10278, 10278, 0, 70, 190, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2117, 22505, 'Lost Beholder', '', 'LineageMonster2.hundred_eye', 21.00, 55.00, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 112922, 194.030, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15343, 940, 10477, 1032, 253, 1000, 506, 0, 0, 0, 30, 170, 'abyss_clan', 1000, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2118, 22506, 'Boom - Child', '', 'LineageMonster4.boom_eye', 33.00, 13.50, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 10044, 1059, 782, 471, 535, 344, 253, 0, 506, 0, 0, 0, 250, 300, '', 300, 0, 0, 0, 0, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2119, 22507, 'Boom - Child', '', 'LineageMonster4.boom_eye', 33.00, 13.50, 77, 'male', 'L2Monster', 'Fighter', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 10067, 1089, 853, 490, 583, 359, 253, 0, 506, 0, 0, 0, 250, 300, '', 300, 0, 0, 0, 0, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2120, 22508, 'Boom - Child', '', 'LineageMonster4.boom_eye', 33.00, 13.50, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 10499, 1178, 984, 519, 673, 380, 253, 0, 506, 0, 0, 0, 250, 300, '', 300, 0, 0, 0, 0, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2121, 22509, 'Fanatic of Infinity', '', 'LineageMonster4.ravager_silen', 27.00, 48.50, 76, 'male', 'L2Monster', 'Fighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 75564, 7698, 1360, 535, 929, 391, 253, 500, 506, 0, 0, 0, 92, 200, 'aceed_clan', 1500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2122, 22510, 'Rotten Messenger', '', 'LineageMonster4.death_scout_088p', 14.40, 22.00, 77, 'female', 'L2Monster', 'Fighter', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 68060, 7007, 1421, 544, 971, 398, 253, 500, 506, 0, 0, 0, 45, 160, 'aceed_clan', 1500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2123, 22511, 'Zealot of Infinity', '', 'LineageMonster4.disciple_silen', 19.00, 44.00, 77, 'male', 'L2Monster', 'Fighter', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 69384, 7150, 1421, 544, 971, 398, 253, 500, 506, 0, 0, 0, 73, 170, 'aceed_clan', 1500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2124, 22512, 'Body Severer', '', 'LineageMonster4.bonecreeper', 43.00, 47.50, 78, 'male', 'L2Monster', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 72891, 7605, 1488, 556, 1015, 406, 253, 500, 506, 0, 0, 0, 50, 200, 'aceed_clan', 1500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2125, 22513, 'Body Harvester', '', 'LineageMonster4.corpseshambler', 34.00, 34.00, 79, 'male', 'L2Monster', 'Fighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 74772, 7900, 1562, 566, 1067, 415, 253, 500, 506, 0, 0, 0, 50, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2126, 22514, 'Soul Exploiter', '', 'LineageMonster4.soul_harvester', 23.00, 31.00, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 66417, 7094, 1641, 576, 1120, 423, 253, 500, 506, 0, 0, 0, 46, 200, 'aceed_clan', 1500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2127, 22515, 'Soul Devourer', '', 'LineageMonster4.soul_wagon_104p', 56.00, 35.36, 80, 'male', 'L2Monster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 63246, 6665, 1720, 588, 1181, 429, 253, 500, 506, 0, 0, 0, 100, 200, 'aceed_clan', 1500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2128, 22516, 'Butcher of Infinity', '', 'LineageMonster4.ravager_silen', 27.00, 48.50, 80, 'male', 'L2Monster', 'AbstractSOIMonster', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 55248, 5826, 1720, 588, 1181, 429, 253, 0, 506, 0, 0, 0, 92, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2129, 22517, 'Disciple of Infinity', '', 'LineageMonster4.disciple_silen', 19.00, 44.00, 80, 'male', 'L2Monster', 'AbstractSOIMonster', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 48912, 5151, 1720, 588, 1181, 429, 253, 0, 506, 0, 0, 0, 73, 170, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2130, 22518, 'Rotten Messenger', '', 'LineageMonster4.death_scout_088p', 14.40, 22.00, 80, 'female', 'L2Monster', 'AbstractSOIMonster', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 51135, 5315, 1805, 598, 1247, 438, 253, 0, 506, 0, 0, 0, 45, 160, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2131, 22519, 'Body Harvester', '', 'LineageMonster4.corpseshambler', 34.00, 34.00, 81, 'male', 'L2Monster', 'AbstractSOIMonster', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 58036, 5981, 1890, 609, 1307, 445, 253, 0, 506, 0, 0, 0, 50, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2132, 22520, 'Body Severer', '', 'LineageMonster4.bonecreeper', 43.00, 47.50, 81, 'male', 'L2Monster', 'AbstractSOIMonster', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 56345, 5798, 1890, 609, 1307, 445, 253, 0, 506, 0, 0, 0, 50, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2133, 22521, 'Soul Exploiter', '', 'LineageMonster4.soul_harvester', 23.00, 31.00, 81, 'male', 'L2Monster', 'AbstractSOIMonster', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 55722, 5702, 1890, 609, 1307, 445, 253, 0, 506, 0, 0, 0, 46, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2134, 22522, 'Soul Devourer', '', 'LineageMonster4.soul_wagon_104p', 56.00, 35.36, 81, 'male', 'L2Monster', 'AbstractSOIMonster', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 50431, 5238, 1804, 598, 1239, 437, 253, 0, 506, 0, 0, 0, 100, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2135, 22523, 'Soul Devourer', '', 'LineageMonster4.soul_wagon_130p', 70.00, 44.20, 81, 'male', 'L2Monster', 'AbstractSOIMonster', 40, 112020, 189.143, 1812, 3.000, 40, 43, 30, 21, 20, 20, 1168301, 118417, 15710, 991, 10917, 1088, 253, 0, 506, 0, 0, 0, 110, 200, 'aceed_clan', 1500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.44, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2136, 22524, 'Emissary of Death', '', 'LineageMonster4.Death_slayer_080p', 16.00, 27.20, 81, 'male', 'L2Monster', 'AbstractSOIMonster', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 57235, 5894, 1890, 609, 1307, 445, 253, 0, 506, 13984, 0, 0, 64, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2137, 22525, 'Emissary of Death', '', 'LineageMonster4.Death_slayer', 20.00, 34.00, 81, 'male', 'L2Monster', 'AbstractSOIMonster', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 60043, 6109, 1981, 619, 1377, 452, 253, 0, 506, 13984, 0, 0, 68, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2138, 22526, 'Emissary of Death', '', 'LineageMonster4.Death_slayer_080p', 16.00, 27.20, 81, 'male', 'L2Monster', 'AbstractSOIMonster', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 58819, 6058, 1890, 609, 1307, 445, 253, 0, 506, 13985, 13986, 0, 64, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2139, 22527, 'Emissary of Death', '', 'LineageMonster4.Death_slayer', 20.00, 34.00, 81, 'male', 'L2Monster', 'AbstractSOIMonster', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 61705, 6278, 1981, 619, 1377, 452, 253, 0, 506, 13985, 13986, 0, 68, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2140, 22528, 'Cursed Prefect', '', 'LineageMonster4.death_knight_n_104p', 22.88, 41.60, 81, 'male', 'L2Monster', 'AbstractSOIMonster', 80, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 74222, 7643, 1890, 609, 1307, 445, 253, 0, 506, 13982, 0, 0, 43, 180, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2141, 22529, 'Cursed Prefect', '', 'LineageMonster4.death_knight_n_130p', 28.60, 52.00, 81, 'male', 'L2Monster', 'AbstractSOIMonster', 80, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 77864, 7922, 1981, 619, 1377, 452, 253, 0, 506, 13982, 0, 0, 47, 180, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2142, 22530, 'Cursed Prefect', '', 'LineageMonster4.death_knight_n_104p', 22.88, 41.60, 81, 'male', 'L2Monster', 'AbstractSOIMonster', 80, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 59237, 6106, 1890, 609, 1307, 445, 253, 0, 506, 13983, 0, 0, 43, 180, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2143, 22531, 'Cursed Prefect', '', 'LineageMonster4.death_knight_n_130p', 28.60, 52.00, 81, 'male', 'L2Monster', 'AbstractSOIMonster', 80, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 62144, 6328, 1981, 619, 1377, 452, 253, 0, 506, 13983, 0, 0, 47, 180, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2144, 22532, 'Law Scholar of Conclusions', '', 'LineageMonster4.lich_A_088p', 21.12, 40.48, 81, 'male', 'L2Monster', 'AbstractSOIMonster', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 56060, 5767, 1890, 609, 1307, 445, 253, 0, 506, 0, 0, 0, 46, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2145, 22533, 'Law Scholar of Conclusions', '', 'LineageMonster4.lich_A_110p', 26.40, 50.60, 81, 'male', 'L2Monster', 'AbstractSOIMonster', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 58811, 5977, 1981, 619, 1377, 452, 253, 0, 506, 0, 0, 0, 46, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2146, 22534, 'Law Scholar of Conclusions', '', 'LineageMonster4.lich_b_088p', 21.12, 40.48, 81, 'male', 'L2Monster', 'AbstractSOIMonster', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 53542, 5495, 1890, 609, 1307, 445, 253, 0, 506, 0, 0, 0, 46, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2147, 22535, 'Law Scholar of Conclusions', '', 'LineageMonster4.lich_b_110p', 26.40, 50.60, 81, 'male', 'L2Monster', 'AbstractSOIMonster', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 56169, 5696, 1981, 619, 1377, 452, 253, 0, 506, 0, 0, 0, 46, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2148, 22536, 'Royal Guard Captain', '', 'LineageMonster4.Dragon_eliteguard_075p', 40.00, 55.00, 81, 'male', 'L2Monster', 'Fighter', 80, 32745, 110.577, 1812, 3.000, 40, 43, 30, 21, 20, 20, 333644, 33883, 10098, 991, 7018, 1088, 253, 800, 506, 0, 0, 0, 100, 200, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2149, 22537, 'Dragon Steed Troop Grand Magician', '', 'LineageMonster4.Dragon_archmage_135p', 29.00, 49.90, 81, 'male', 'L2Monster', 'Mystic', 40, 32745, 110.577, 1812, 3.000, 40, 43, 30, 21, 20, 20, 73171, 7447, 10098, 991, 7018, 1088, 253, 800, 506, 0, 0, 0, 43, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.42, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2150, 22538, 'Dragon Steed Troop Commander', '', 'LineageMonster4.Dragon_centurion_135p', 28.00, 46.50, 81, 'male', 'L2Monster', 'Fighter', 80, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 96783, 10083, 10003, 974, 6911, 1069, 253, 800, 506, 13978, 0, 0, 55, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2151, 22539, 'Dragon Steed Troops No 1 Battalion Commander', '', 'LineageMonster4.Dragon_centurion_135p', 28.00, 46.50, 81, 'male', 'L2Monster', 'Fighter', 80, 32946, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 98080, 10347, 9906, 957, 6805, 1051, 253, 800, 506, 13978, 0, 0, 55, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2152, 22540, 'White Dragon Leader', '', 'LineageMonster4.Dragon_centurion_120p', 22.00, 42.00, 81, 'male', 'L2Monster', 'Fighter', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 82134, 8708, 9809, 940, 6698, 1032, 253, 800, 506, 13979, 13980, 0, 56, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2153, 22541, 'Dragon Steed Troop Infantry', '', 'LineageMonster4.Dragon_centurion_120p', 22.00, 42.00, 80, 'male', 'L2Monster', 'Fighter', 40, 33093, 114.400, 1675, 3.000, 40, 43, 30, 21, 20, 20, 83347, 8955, 9712, 923, 6632, 1014, 253, 800, 506, 13979, 13980, 0, 56, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2154, 22542, 'Dragon Steed Troop Magic Leader', '', 'LineageMonster4.dragon_mage_075p', 28.00, 39.50, 81, 'male', 'L2Monster', 'Mystic', 40, 32946, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 193521, 21161, 9906, 957, 6805, 1051, 253, 800, 506, 0, 0, 0, 92, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2155, 22543, 'Dragon Steed Troop Magician', '', 'LineageMonster4.dragon_mage_075p', 28.00, 39.50, 81, 'male', 'L2Monster', 'Mystic', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 79493, 8397, 9809, 940, 6698, 1032, 253, 800, 506, 0, 0, 0, 92, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2156, 22544, 'Dragon Steed Troop Magic Soldier', '', 'LineageMonster4.dragon_mage_065p', 25.00, 34.50, 80, 'male', 'L2Monster', 'Mystic', 40, 33093, 114.400, 1675, 3.000, 40, 43, 30, 21, 20, 20, 84936, 9090, 9712, 923, 6632, 1014, 253, 800, 506, 13981, 0, 0, 82, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2157, 22545, 'Wife of the Dragon of Darkness', '', 'LineageMonster4.dragon_shadow_110p', 60.00, 66.00, 81, 'male', 'L2Monster', 'Fighter', 40, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 203716, 22000, 10003, 974, 6911, 1069, 253, 800, 506, 0, 0, 0, 46, 160, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2158, 22546, 'Warrior of Light', '', 'LineageMonster4.dragon_berserker_090p', 50.00, 55.00, 79, 'male', 'L2Monster', 'Fighter', 40, 33155, 115.296, 1641, 3.000, 40, 43, 30, 21, 20, 20, 82511, 8653, 9541, 906, 6515, 995, 253, 800, 506, 0, 0, 0, 100, 200, 'des_dragon', 1000, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.57, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2159, 22547, 'Dragon Steed Troop Healer', '', 'LineageMonster4.dragon_mage_065p', 25.00, 34.50, 79, 'male', 'L2Monster', 'Priest', 40, 33155, 115.296, 1641, 3.000, 40, 43, 30, 21, 20, 20, 59035, 6215, 9541, 906, 6515, 995, 253, 800, 506, 13981, 0, 0, 82, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2160, 22548, 'Dragon Steed Troop Javelin Thrower', '', 'LineageMonster4.dragon_peltast', 25.00, 46.50, 80, 'male', 'L2Monster', 'Ranger', 1100, 33093, 114.400, 1675, 3.000, 40, 43, 30, 21, 20, 20, 94968, 10260, 9712, 923, 6632, 1014, 253, 800, 506, 13843, 0, 0, 89, 220, 'des_dragon', 1000, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2161, 22549, 'Dragon Steed Troop Javelin Thrower', '', 'LineageMonster4.dragon_peltast', 25.00, 46.50, 80, 'male', 'L2Monster', 'Ranger', 1100, 33093, 114.400, 1675, 3.000, 40, 43, 30, 21, 20, 20, 94968, 10260, 9712, 923, 6632, 1014, 253, 800, 506, 13843, 0, 0, 89, 220, 'des_dragon', 1000, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2162, 22550, 'Savage Warrior', '', 'LineageMonster4.ravager_silen', 27.00, 48.50, 77, 'male', 'L2Monster', 'Fighter', 40, 19627, 69.074, 1574, 3.000, 40, 43, 30, 21, 20, 20, 103619, 10725, 6889, 872, 4704, 958, 253, 800, 506, 13987, 0, 0, 92, 200, 'des_dragon', 1000, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2163, 22551, 'Priest of Darkness', '', 'LineageMonster4.disciple_silen', 19.00, 44.00, 76, 'male', 'L2Monster', 'Mystic', 40, 19633, 69.515, 1541, 3.000, 40, 43, 30, 21, 20, 20, 95778, 9756, 6749, 855, 4608, 939, 253, 800, 506, 0, 0, 0, 73, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2164, 22552, 'Mutation Drake', '', 'LineageMonster4.Mutant_drake', 48.00, 53.50, 78, 'male', 'L2Monster', 'Fighter', 40, 33213, 116.187, 1607, 3.000, 40, 43, 30, 21, 20, 20, 92347, 9614, 9362, 888, 6393, 975, 253, 500, 506, 0, 0, 0, 46, 200, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2165, 22553, 'Large Crystal Core', '', 'LineageNpcEV.source_facility', 62.00, 140.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 8087, 852, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2166, 22554, 'Small Crystal Core', '', 'LineageNpcEV.source_facility', 62.00, 140.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 8087, 852, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2167, 22555, 'Small Crystal Core', '', 'LineageNpcEV.source_facility', 62.00, 140.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 8087, 852, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2168, 22556, 'Small Crystal Core', '', 'LineageNpcEV.source_facility', 62.00, 140.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 8087, 852, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2169, 22557, 'Defense Mechanism', '', 'LineageMonster4.defence_mech', 86.00, 133.50, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 8087, 852, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 45, 300, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2170, 22558, 'Defense Battery', '', 'LineageMonster4.defence_mech', 86.00, 133.50, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 8087, 852, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 45, 300, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2171, 22559, 'Defeated Troops Commander', '', 'LineageMonster4.Dragon_centurion_135p', 28.00, 46.50, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 500, 506, 0, 0, 0, 55, 210, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2172, 22560, 'Defeated Troops No 1 Battalion Commander', '', 'LineageMonster4.Dragon_centurion_135p', 28.00, 46.50, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1804, 599, 1233, 438, 253, 500, 506, 0, 0, 0, 55, 210, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2173, 22561, 'Defeated Troops White Dragon Leader', '', 'LineageMonster4.Dragon_centurion_120p', 22.00, 42.00, 81, 'male', 'L2Monster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1720, 588, 1175, 430, 253, 500, 506, 0, 0, 0, 56, 210, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2174, 22562, 'Defeated Troops Infantry', '', 'LineageMonster4.Dragon_centurion_120p', 22.00, 42.00, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 500, 506, 0, 0, 0, 56, 210, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2175, 22563, 'Defeated Troops Magic Leader', '', 'LineageMonster4.dragon_mage_075p', 28.00, 39.50, 82, 'male', 'L2Monster', 'Mystic', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 92, 170, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2176, 22564, 'Defeated Troops Magician', '', 'LineageMonster4.dragon_mage_075p', 28.00, 39.50, 81, 'male', 'L2Monster', 'Mystic', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1720, 588, 1175, 430, 253, 500, 506, 0, 0, 0, 92, 170, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2177, 22565, 'Defeated Troops Magic Soldier', '', 'LineageMonster4.dragon_mage_065p', 25.00, 34.50, 80, 'male', 'L2Monster', 'Mystic', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 500, 506, 0, 0, 0, 82, 170, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2178, 22566, 'Defeated Troops Healer', '', 'LineageMonster4.dragon_mage_065p', 25.00, 34.50, 79, 'male', 'L2Monster', 'Mystic', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 500, 506, 0, 0, 0, 82, 170, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2179, 22567, 'Defeated Troops Javelin Thrower', '', 'LineageMonster4.dragon_peltast', 25.00, 46.50, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 500, 506, 0, 0, 0, 89, 220, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2180, 22568, 'Defeated Troops Javelin Thrower', '', 'LineageMonster4.dragon_peltast', 25.00, 46.50, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 500, 506, 0, 0, 0, 89, 220, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2181, 22569, 'Soldiers of Bravery', '', 'LineageMonster4.dragon_rider', 36.00, 51.00, 81, 'male', 'L2Monster', 'Fighter', 80, 334640, 187.261, 1847, 3.000, 40, 43, 30, 21, 20, 20, 1322725, 139467, 13753, 1006, 9612, 1105, 253, 500, 506, 0, 0, 0, 60, 200, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.53, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2182, 22570, 'Royal Guard Captain', '', 'LineageMonster4.Dragon_eliteguard_075p', 40.00, 55.00, 81, 'male', 'L2Monster', 'Fighter', 40, 336061, 189.143, 1812, 3.000, 40, 43, 30, 21, 20, 20, 2410562, 244753, 13527, 991, 9401, 1088, 253, 500, 506, 0, 0, 0, 100, 200, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2183, 22571, 'Dragon Steed Troop Grand Magician', '', 'LineageMonster4.Dragon_archmage_135p', 29.00, 49.90, 81, 'male', 'L2Monster', 'Fighter', 40, 56055, 189.294, 1812, 3.000, 40, 43, 30, 21, 20, 20, 565516, 57381, 16109, 991, 11195, 1088, 253, 500, 506, 0, 0, 0, 43, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.42, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2184, 22572, 'Dragon Steed Troop Commander', '', 'LineageMonster4.Dragon_centurion_135p', 28.00, 46.50, 81, 'male', 'L2Monster', 'Fighter', 80, 112316, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 1277122, 131629, 15589, 974, 10770, 1069, 253, 500, 506, 13978, 0, 0, 55, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2185, 22573, 'Dragon Steed Troops No 1 Battalion Commander', '', 'LineageMonster4.Dragon_centurion_135p', 28.00, 46.50, 81, 'male', 'L2Monster', 'Fighter', 80, 112717, 192.545, 1743, 3.000, 40, 43, 30, 21, 20, 20, 352899, 37237, 15467, 957, 10623, 1051, 253, 500, 506, 13978, 0, 0, 55, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2186, 22574, 'White Dragon Leader', '', 'LineageMonster4.Dragon_centurion_120p', 22.00, 42.00, 81, 'male', 'L2Monster', 'Fighter', 40, 112922, 194.030, 1709, 3.000, 40, 43, 30, 21, 20, 20, 294906, 31273, 15343, 940, 10477, 1032, 253, 500, 506, 13979, 13980, 0, 56, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2187, 22575, 'Dragon Steed Troop Infantry', '', 'LineageMonster4.Dragon_centurion_120p', 22.00, 42.00, 80, 'male', 'L2Monster', 'Fighter', 40, 113229, 195.709, 1675, 3.000, 40, 43, 30, 21, 20, 20, 299241, 32156, 15218, 923, 10394, 1014, 253, 500, 506, 13979, 13980, 0, 56, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2188, 22576, 'Dragon Steed Troop Magic Leader', '', 'LineageMonster4.dragon_mage_075p', 28.00, 39.50, 81, 'male', 'L2Monster', 'Mystic', 40, 56403, 192.698, 1743, 3.000, 40, 43, 30, 21, 20, 20, 136941, 14290, 15846, 957, 10883, 1051, 253, 500, 506, 0, 0, 0, 92, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2189, 22577, 'Dragon Steed Troop Magician', '', 'LineageMonster4.dragon_mage_075p', 28.00, 39.50, 81, 'male', 'L2Monster', 'Mystic', 40, 56506, 194.184, 1709, 3.000, 40, 43, 30, 21, 20, 20, 136094, 14370, 15713, 940, 10729, 1032, 253, 500, 506, 0, 0, 0, 92, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2190, 22578, 'Dragon Steed Troop Magic Soldier', '', 'LineageMonster4.dragon_mage_065p', 25.00, 34.50, 80, 'male', 'L2Monster', 'Mystic', 40, 56659, 195.864, 1675, 3.000, 40, 43, 30, 21, 20, 20, 151605, 16251, 15578, 923, 10639, 1014, 253, 500, 506, 13981, 0, 0, 82, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2191, 22579, 'Warrior of Light', '', 'LineageMonster4.dragon_berserker_090p', 50.00, 55.00, 79, 'male', 'L2Monster', 'Fighter', 40, 56760, 197.379, 1641, 3.000, 40, 43, 30, 21, 20, 20, 156549, 16504, 15327, 906, 10466, 995, 253, 500, 506, 0, 0, 0, 100, 200, 'des_dragon', 1000, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.57, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2192, 22580, 'Dragon Steed Troop Healer', '', 'LineageMonster4.dragon_mage_065p', 25.00, 34.50, 79, 'male', 'L2Monster', 'Mystic', 40, 56760, 197.379, 1641, 3.000, 40, 43, 30, 21, 20, 20, 102203, 10760, 15327, 906, 10466, 995, 253, 500, 506, 13981, 0, 0, 82, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2193, 22581, 'Dragon Steed Troop Javelin Thrower', '', 'LineageMonster4.dragon_peltast', 25.00, 46.50, 80, 'male', 'L2Monster', 'Fighter', 1100, 56659, 195.864, 1675, 3.000, 40, 43, 30, 21, 20, 20, 170995, 18501, 15578, 923, 10639, 1014, 253, 500, 506, 13843, 0, 0, 89, 220, 'des_dragon', 1000, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2194, 22582, 'Dragon Steed Troop Javelin Thrower', '', 'LineageMonster4.dragon_peltast', 25.00, 46.50, 80, 'male', 'L2Monster', 'Fighter', 1100, 56659, 195.864, 1675, 3.000, 40, 43, 30, 21, 20, 20, 170995, 18501, 15578, 923, 10639, 1014, 253, 500, 506, 13843, 0, 0, 89, 220, 'des_dragon', 1000, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2195, 22583, 'Dragon Steed Troop Magic Leader', '', 'LineageMonster4.dragon_mage_075p', 28.00, 39.50, 81, 'male', 'L2Monster', 'Mystic', 40, 56403, 192.698, 1743, 3.000, 40, 43, 30, 21, 20, 20, 140831, 14711, 15846, 957, 10883, 1051, 253, 500, 506, 0, 0, 0, 92, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2196, 22584, 'Dragon Steed Troop Magician', '', 'LineageMonster4.dragon_mage_075p', 28.00, 39.50, 81, 'male', 'L2Monster', 'Mystic', 40, 56506, 194.184, 1709, 3.000, 40, 43, 30, 21, 20, 20, 142800, 15110, 15713, 940, 10729, 1032, 253, 500, 506, 0, 0, 0, 92, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2197, 22585, 'Dragon Steed Troop Magic Soldier', '', 'LineageMonster4.dragon_mage_065p', 25.00, 34.50, 80, 'male', 'L2Monster', 'Mystic', 40, 33093, 114.400, 1675, 3.000, 40, 43, 30, 21, 20, 20, 87030, 9329, 9712, 923, 6632, 1014, 253, 500, 506, 13981, 0, 0, 82, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2198, 22586, 'Dragon Steed Troop Commander', '', 'LineageMonster4.Dragon_centurion_135p', 28.00, 46.50, 81, 'male', 'L2Monster', 'Fighter', 80, 112316, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 1295378, 133568, 15589, 974, 10770, 1069, 253, 500, 506, 13978, 0, 0, 55, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2199, 22587, 'Dragon Steed Troop Captain #1', '', 'LineageMonster4.Dragon_centurion_135p', 28.00, 46.50, 81, 'male', 'L2Monster', 'Fighter', 80, 112717, 192.545, 1743, 3.000, 40, 43, 30, 21, 20, 20, 365328, 38596, 15467, 957, 10623, 1051, 253, 500, 506, 13978, 0, 0, 55, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2200, 22588, 'White Dragon Leader', '', 'LineageMonster4.Dragon_centurion_120p', 22.00, 42.00, 81, 'male', 'L2Monster', 'Fighter', 40, 112922, 194.030, 1709, 3.000, 40, 43, 30, 21, 20, 20, 272419, 28783, 15343, 940, 10477, 1032, 253, 500, 506, 13979, 13980, 0, 56, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2201, 22589, 'Dragon Steed Troop Infantry', '', 'LineageMonster4.Dragon_centurion_120p', 22.00, 42.00, 80, 'male', 'L2Monster', 'Fighter', 40, 113229, 195.709, 1675, 3.000, 40, 43, 30, 21, 20, 20, 276411, 29594, 15218, 923, 10394, 1014, 253, 500, 506, 13979, 13980, 0, 56, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2202, 22590, '9C', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 18851, 67.981, 1442, 3.000, 40, 43, 30, 21, 20, 20, 116750, 11412, 6133, 804, 4188, 881, 253, 0, 506, 0, 0, 0, 1, 1, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2203, 22591, 'Dragon Steed Troop Magic Leader', '', 'LineageMonster4.dragon_mage_075p', 28.00, 39.50, 81, 'male', 'L2Monster', 'Mystic', 40, 32946, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 82741, 8651, 9906, 957, 6805, 1051, 253, 500, 506, 0, 0, 0, 92, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2204, 22592, 'Dragon Steed Troop Magician', '', 'LineageMonster4.dragon_mage_075p', 28.00, 39.50, 81, 'male', 'L2Monster', 'Mystic', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 82322, 8710, 9809, 940, 6698, 1032, 253, 500, 506, 0, 0, 0, 92, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2205, 22593, 'Dragon Steed Troop Magic Soldier', '', 'LineageMonster4.dragon_mage_065p', 25.00, 34.50, 80, 'male', 'L2Monster', 'Mystic', 40, 33093, 114.400, 1675, 3.000, 40, 43, 30, 21, 20, 20, 87800, 9411, 9712, 923, 6632, 1014, 253, 500, 506, 13981, 0, 0, 82, 170, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2206, 22594, 'Dragon Steed Troop Commander', '', 'LineageMonster4.Dragon_centurion_135p', 28.00, 46.50, 81, 'male', 'L2Monster', 'Fighter', 80, 32829, 111.507, 1777, 3.000, 40, 43, 30, 21, 20, 20, 359407, 37057, 10003, 974, 6911, 1069, 253, 500, 506, 13978, 0, 0, 55, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2207, 22595, 'Dragon Steed Troops No 1 Battalion Commander', '', 'LineageMonster4.Dragon_centurion_135p', 28.00, 46.50, 81, 'male', 'L2Monster', 'Fighter', 80, 32946, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 362118, 37795, 9906, 957, 6805, 1051, 253, 500, 506, 13978, 0, 0, 55, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2208, 22596, 'White Dragon Leader', '', 'LineageMonster4.Dragon_centurion_120p', 22.00, 42.00, 81, 'male', 'L2Monster', 'WhiteDragonLeader', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 87965, 9354, 9809, 940, 6698, 1032, 253, 500, 506, 13979, 13980, 0, 56, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2209, 22597, 'Dragon Steed Troop Infantry', '', 'LineageMonster4.Dragon_centurion_120p', 22.00, 42.00, 80, 'male', 'L2Monster', 'Fighter', 40, 33093, 114.400, 1675, 3.000, 40, 43, 30, 21, 20, 20, 89268, 9620, 9712, 923, 6632, 1014, 253, 500, 506, 13979, 13980, 0, 56, 210, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2210, 22598, 'Obelisk', '', 'LineageNpcEV.obelisk_of_middle_square', 229.00, 177.50, 82, 'female', 'L2Npc', 'npc', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2211, 22599, 'Great Powerful Device', '', 'LineageNpcEV.crystal_of_secret_door', 57.00, 74.00, 82, 'female', 'L2Monster', 'npc', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2212, 22600, 'Throne of Destruction Powerful Device', '', 'LineageNpcEV.protector_of_seed', 57.00, 74.00, 82, 'female', 'L2Monster', 'npc', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2213, 22601, 'Heart Protection Device', '', 'LineageNpcEV.crystal_of_secret_door', 57.00, 74.00, 73, 'female', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2214, 22602, 'Mutant - Bird', '', 'LineageMonster4.mutant_hawk', 100.00, 85.00, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 14171, 1458, 732, 452, 499, 330, 253, 0, 506, 0, 0, 0, 60, 300, 'loc_clan', 1000, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2215, 22603, 'Mutant - Bird', '', 'LineageMonster4.mutant_hawk', 100.00, 85.00, 74, 'male', 'L2Monster', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 14562, 1517, 756, 461, 517, 337, 253, 0, 506, 0, 0, 0, 60, 300, 'loc_clan', 1000, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2216, 22604, 'Dra Hawk', '', 'LineageMonster4.drahawk', 110.00, 35.00, 74, 'female', 'L2Monster', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 9167, 955, 756, 461, 517, 337, 253, 0, 506, 0, 0, 0, 60, 300, 'loc_clan', 1000, 0, 0, 0, 4, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2217, 22605, 'Dra Hawk', '', 'LineageMonster4.drahawk', 110.00, 35.00, 75, 'female', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 9416, 993, 782, 471, 535, 344, 253, 0, 506, 0, 0, 0, 60, 300, 'loc_clan', 1000, 0, 0, 0, 4, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2218, 22606, 'Floating Skull', '', 'LineageMonster4.floating_skeleton', 28.00, 39.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 10528, 1125, 817, 480, 558, 351, 253, 0, 506, 0, 0, 0, 45, 300, 'bansheequeen_clan', 1000, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2219, 22607, 'Floating Skull', '', 'LineageMonster4.floating_skeleton', 28.00, 39.00, 77, 'male', 'L2Monster', 'Fighter', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 17574, 1901, 853, 490, 583, 359, 253, 0, 506, 0, 0, 0, 45, 300, 'bansheequeen_clan', 1000, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2220, 22608, 'Floating Zombie', '', 'LineageMonster4.floating_zombie', 70.00, 50.00, 75, 'female', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 9720, 1025, 782, 471, 535, 344, 253, 0, 506, 0, 0, 0, 60, 300, 'bansheequeen_clan', 1000, 0, 0, 0, 5, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2221, 22609, 'Floating Zombie', '', 'LineageMonster4.floating_zombie', 70.00, 50.00, 76, 'female', 'L2Monster', 'Fighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 9475, 1012, 817, 480, 558, 351, 253, 0, 506, 0, 0, 0, 60, 300, 'bansheequeen_clan', 1000, 0, 0, 0, 5, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2222, 22610, 'Mutated Drake Wing', '', 'LineageMonster4.m_drake_wing_knave', 153.00, 63.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 11981, 1263, 782, 471, 535, 344, 253, 0, 506, 0, 0, 0, 60, 300, 'mutantdrakewing_clan', 1000, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2223, 22611, 'Mutated Drake Wing', '', 'LineageMonster4.m_drake_wing_knave', 153.00, 63.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 11797, 1261, 817, 480, 558, 351, 253, 0, 506, 0, 0, 0, 60, 300, 'mutantdrakewing_clan', 1000, 0, 0, 0, 3, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2224, 22612, 'Drak', '', 'LineageMonster4.drac', 100.00, 40.00, 76, 'female', 'L2Monster', 'Fighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 11485, 1227, 817, 480, 558, 351, 253, 0, 506, 0, 0, 0, 60, 300, 'mutantdrakewing_clan', 1000, 0, 0, 0, 5, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2225, 22613, 'Drak', '', 'LineageMonster4.drac', 100.00, 40.00, 77, 'female', 'L2Monster', 'Fighter', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 11789, 1275, 853, 490, 583, 359, 253, 0, 506, 0, 0, 0, 60, 300, 'mutantdrakewing_clan', 1000, 0, 0, 0, 5, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2226, 22614, 'Vulture Rider', '', 'LineageMonster4.master_rider', 123.00, 90.00, 74, 'male', 'L2Monster', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 10093, 1052, 756, 461, 517, 337, 253, 0, 506, 0, 0, 0, 60, 300, 'masterrider_clan', 1000, 0, 0, 0, 4, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2227, 22615, 'Vulture Rider', '', 'LineageMonster4.master_rider', 123.00, 90.00, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 10368, 1093, 782, 471, 535, 344, 253, 0, 506, 0, 0, 0, 60, 300, 'masterrider_clan', 1000, 0, 0, 0, 4, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2228, 22616, 'Seed of Pain', '', 'LineageMonster4.death_claw_054p', 14.00, 42.00, 81, 'male', 'L2Monster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 46442, 4907, 1720, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 45, 180, 'aceed_clan', 1500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2229, 22617, 'Spiked Stakato', '', 'blade_stakato_120p', 18.00, 43.20, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 92371, 9623, 1804, 599, 1233, 438, 253, 500, 506, 0, 0, 0, 25, 200, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2230, 22618, 'Spiked Stakato Worker', '', 'blade_stakato_worker_120p', 22.00, 48.30, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 92371, 9623, 1804, 599, 1233, 438, 253, 500, 506, 221, 0, 0, 25, 200, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2231, 22619, 'Spiked Stakato Guard', '', 'spike_stakato', 16.00, 22.80, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 61248, 6382, 1804, 599, 1233, 438, 253, 500, 506, 123, 0, 0, 23, 200, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2232, 22620, 'Female Spiked Stakato', '', 'spike_stakato_soldier', 17.00, 30.00, 82, 'male', 'L2Monster', 'FemaleSpikedStakato', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 95359, 9925, 1804, 599, 1233, 438, 253, 500, 506, 123, 0, 0, 60, 220, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2233, 22621, 'Male Spiked Stakato', '', 'marsh_stakato_soldier_120p', 18.00, 31.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 90357, 9403, 1804, 599, 1233, 438, 253, 500, 506, 135, 0, 0, 30, 200, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2234, 22622, 'Male Spiked Stakato', '', 'marsh_stakato_soldier_tran', 16.00, 28.40, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 137592, 14151, 1890, 609, 1292, 445, 253, 500, 506, 135, 0, 0, 32, 220, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2235, 22623, 'Spiked Stakato Sorcerer', '', 'blade_stakato_queen_120p', 24.00, 43.60, 82, 'female', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 89287, 9285, 1804, 599, 1233, 438, 253, 500, 506, 221, 0, 0, 25, 170, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2236, 22624, 'Cannibalistic Stakato Follower', '', 'spike_stakato_worker', 17.00, 29.80, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 90357, 9403, 1804, 599, 1233, 438, 253, 500, 506, 223, 0, 0, 23, 200, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2237, 22625, 'Cannibalistic Stakato Leader', '', 'cannibal_stakato_leader_120p', 34.00, 48.80, 83, 'male', 'L2Monster', 'StakatoNest', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 99429, 10218, 1890, 609, 1292, 445, 253, 500, 506, 0, 0, 0, 40, 200, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2238, 22626, 'Cannibalistic Stakato Leader', '', 'cannibal_stakato_leader_tran', 40.00, 42.00, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 137592, 14151, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 34, 220, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2239, 22627, 'Spiked Stakato Soldier', '', 'blade_stakato_120p', 18.00, 43.20, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 94846, 9748, 1890, 609, 1292, 445, 253, 500, 506, 0, 0, 0, 25, 200, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2240, 22628, 'Spiked Stakato Drone', '', 'blade_stakato_drone_120p', 28.00, 47.30, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 94846, 9748, 1890, 609, 1292, 445, 253, 500, 506, 235, 0, 0, 25, 200, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2241, 22629, 'Spiked Stakato Captain', '', 'marsh_stakato_drone_120p', 14.00, 29.10, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 94846, 9748, 1890, 609, 1292, 445, 253, 500, 506, 234, 0, 0, 80, 200, 'spike_clan', 500, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2242, 22630, 'Spike Stakato Nurse', '', 'marsh_stakato_queen_120p', 26.00, 43.80, 83, 'female', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 93723, 9626, 1890, 609, 1292, 445, 253, 150, 506, 132, 0, 0, 130, 200, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2243, 22631, 'Spike Stakato Nurse', '', 'marsh_stakato_queen_tran', 18.00, 36.40, 83, 'female', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 129194, 13279, 1890, 609, 1292, 445, 253, 150, 506, 0, 0, 0, 55, 220, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2244, 22632, 'Spiked Stakato Baby', '', 'spike_stakato_drone', 16.00, 29.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 103444, 10763, 1804, 599, 1233, 438, 253, 150, 506, 235, 0, 0, 60, 220, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2245, 22633, 'Spiked Stakato Shaman', '', 'blade_stakato_queen_120p', 24.00, 43.60, 83, 'female', 'L2Monster', 'Mystic', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 93723, 9626, 1890, 609, 1292, 445, 253, 500, 506, 221, 0, 0, 25, 170, 'spike_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2246, 22634, 'Scarlet Stakato Worker', '', 'blade_stakato_worker', 13.00, 40.00, 78, 'male', 'ForgeOfGods', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 37570, 3918, 1488, 556, 1015, 406, 253, 150, 506, 235, 0, 0, 25, 150, 'fire_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2247, 22635, 'Scarlet Stakato Soldier', '', 'blade_stakato_soldier', 15.00, 38.00, 78, 'male', 'ForgeOfGods', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 36723, 3825, 1488, 556, 1015, 406, 253, 150, 506, 148, 0, 0, 25, 180, 'fire_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2248, 22636, 'Scarlet Stakato Noble', '', 'blade_stakato_drone', 15.00, 39.00, 78, 'male', 'ForgeOfGods', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 37891, 3953, 1488, 556, 1015, 406, 253, 150, 506, 235, 0, 0, 25, 180, 'fire_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2249, 22637, 'Tepra Scorpion', '', 'scorpion_20_sm', 24.00, 52.80, 78, 'male', 'ForgeOfGods', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 37570, 3918, 1488, 556, 1015, 406, 253, 150, 506, 0, 0, 0, 37, 150, 'fire_clan', 1000, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2250, 22638, 'Tepra Scarab', '', 'scarab', 14.00, 22.00, 78, 'male', 'ForgeOfGods', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 37570, 3918, 1488, 556, 1015, 406, 253, 150, 506, 0, 0, 0, 45, 170, 'fire_clan', 1000, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2251, 22639, 'Assassin Beetle', '', 'tera_beetle', 19.00, 54.50, 78, 'male', 'ForgeOfGods', 'AssassinBeetle', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 37745, 3937, 1488, 556, 1015, 406, 253, 150, 506, 0, 0, 0, 45, 145, 'fire_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2252, 22640, 'Mercenary of Destruction', '', 'skeleton_knight', 10.00, 25.00, 78, 'male', 'ForgeOfGods', 'Fighter', 80, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 36803, 3835, 1488, 556, 1015, 406, 253, 150, 506, 84, 0, 0, 40, 165, 'fire_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2253, 22641, 'Knight of Destruction', '', 'skeleton_royal_guard', 11.00, 28.50, 78, 'male', 'ForgeOfGods', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 37694, 3933, 1488, 556, 1015, 406, 253, 0, 506, 946, 945, 0, 80, 150, 'fire_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2254, 22642, 'Lavastone Golem', '', 'stone_golem', 20.00, 31.00, 78, 'male', 'ForgeOfGods', 'Mystic', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 48492, 5048, 1488, 556, 1015, 406, 253, 150, 506, 0, 0, 0, 23, 40, 'fire_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2255, 22643, 'Magma Golem', '', 'lava_golem', 38.00, 45.00, 78, 'male', 'ForgeOfGods', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 51018, 5313, 1488, 556, 1015, 406, 253, 150, 506, 0, 0, 0, 13, 60, 'fire_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2256, 22644, 'Arimanes of Destruction', '', 'ahrimanes', 14.00, 57.75, 78, 'male', 'ForgeOfGods', 'Mystic', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 51456, 5361, 1488, 556, 1015, 406, 253, 150, 506, 6722, 0, 0, 35, 170, 'fire_clan', 1000, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2257, 22645, 'Balrog of Destruction', '', 'kaim_vanul', 17.00, 55.00, 78, 'male', 'ForgeOfGods', 'Fighter', 80, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 48850, 5087, 1488, 556, 1015, 406, 253, 150, 506, 0, 0, 0, 70, 150, 'fire_clan', 1000, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2258, 22646, 'Ashuras of Destruction', '', 'ashuras_30_bi', 17.00, 49.00, 78, 'male', 'ForgeOfGods', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 50835, 5293, 1488, 556, 1015, 406, 253, 150, 506, 0, 0, 0, 41, 170, 'fire_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2259, 22647, 'Lavasillisk', '', 'lesser_basilisk', 34.00, 25.00, 78, 'male', 'ForgeOfGods', 'Fighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 53077, 5538, 1488, 556, 1015, 406, 253, 150, 506, 0, 0, 0, 35, 150, 'fire_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2260, 22648, 'Blazing Ifrit', '', 'ifrit_30_bi', 13.00, 55.00, 78, 'male', 'ForgeOfGods', 'Mystic', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 52004, 5421, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 38, 150, 'fire_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2261, 22649, 'Magma Drake', '', 'inferno_drake_20_bi', 29.00, 42.00, 78, 'male', 'ForgeOfGods', 'Mystic', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 53712, 5596, 1488, 556, 1015, 406, 253, 150, 506, 0, 0, 0, 57, 170, 'fire_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2262, 22650, 'Mucrokian Fanatic', '', 'LineageMonster3.Crokian_Officer_blue_b_120p', 25.00, 41.00, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 23243, 2402, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 60, 185, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2263, 22651, 'Mucrokian Ascetic', '', 'LineageMonster3.Crokian_Officer_red_a_120p', 25.00, 41.00, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 24133, 2498, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 60, 185, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2264, 22652, 'Mucrokian Savior', '', 'LineageMonster3.Crokian_Officer_blue_a_120p', 25.00, 41.00, 84, 'male', 'L2Monster', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 24383, 2490, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 60, 185, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2265, 22653, 'Mucrokian Preacher', '', 'LineageMonster3.Crokian_Officer_red_b_120p', 25.00, 41.00, 84, 'male', 'L2Monster', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 25317, 2589, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 60, 185, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2266, 22654, 'Contaminated Mucrokian', '', 'LineageMonster.crokian_e', 18.00, 29.00, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 6887, 743, 1890, 609, 1292, 445, 253, 150, 506, 5128, 0, 0, 18, 250, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.78, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2267, 22655, 'Awakened Mucrokian', '', 'LineageMonster3.Crokian_Elder_raid_120p', 30.00, 52.00, 84, 'male', 'L2Monster', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 42120, 4283, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2268, 22656, 'Suppressor', '', 'LineageMonster3.golem_cannon_catapult_a_120p', 23.50, 41.50, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 21552, 2219, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 60, 185, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2269, 22657, 'Exterminator', '', 'LineageMonster3.golem_carrier_120p', 23.00, 41.00, 84, 'male', 'L2Monster', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 22610, 2300, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 60, 185, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2270, 22658, 'Sentinel Waterspirit', '', 'LineageMonster4.Anthias', 20.00, 41.00, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 22442, 2316, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 60, 185, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2271, 22659, 'Guardian Waterspirit', '', 'LineageMonster4.tears_d', 20.00, 27.50, 84, 'female', 'L2Monster', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 23543, 2400, 1981, 619, 1353, 453, 253, 0, 506, 9638, 9638, 0, 60, 185, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2272, 22660, 'Lesser Giant', '', 'lesser_giant', 31.50, 69.00, 81, 'male', 'L2Monster', 'Fighter', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 332209, 34962, 9809, 940, 6698, 1032, 253, 0, 506, 3937, 0, 0, 15, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2273, 22661, 'Lesser Giant Soldier', '', 'lesser_giant', 31.50, 69.00, 81, 'male', 'L2Monster', 'Fighter', 40, 33004, 113.419, 1709, 3.000, 40, 43, 30, 21, 20, 20, 340299, 35858, 9809, 940, 6698, 1032, 253, 0, 506, 3937, 0, 0, 15, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2274, 22662, 'Lesser Giant Shooter', '', 'lesser_giant_shooter', 30.00, 66.00, 82, 'male', 'L2Monster', 'Ranger', 1100, 32946, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 327339, 34009, 9906, 958, 6765, 1050, 253, 0, 506, 4028, 0, 0, 80, 180, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2275, 22663, 'Lesser Giant Scout', '', 'lesser_giant_shooter', 30.00, 66.00, 82, 'male', 'L2Monster', 'Ranger', 1100, 32946, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 327339, 34009, 9906, 958, 6765, 1050, 253, 0, 506, 4028, 0, 0, 80, 180, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2276, 22664, 'Lesser Giant Mage', '', 'lesser_giant_mage', 50.00, 66.00, 82, 'male', 'L2Monster', 'Mystic', 40, 32946, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 334292, 34769, 9906, 958, 6765, 1050, 253, 0, 506, 3938, 0, 0, 15, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2277, 22665, 'Lesser Giant Elder', '', 'lesser_giant_mage', 50.00, 66.00, 82, 'male', 'L2Monster', 'Mystic', 40, 32946, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 330424, 34346, 9906, 958, 6765, 1050, 253, 0, 506, 3938, 0, 0, 15, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2278, 22666, 'Barif', '', 'lesser_giant_mage', 50.00, 66.00, 82, 'male', 'L2Monster', 'Mystic', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 29543, 3085, 1804, 599, 1233, 438, 253, 500, 506, 3938, 0, 0, 15, 180, 'giant_clan', 400, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2279, 22667, 'Barifs Pet', '', 'leogul', 15.00, 35.00, 81, 'male', 'L2Minion', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 29759, 3156, 1720, 588, 1175, 430, 253, 500, 506, 0, 0, 0, 80, 170, 'giant_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2280, 22668, 'Gamlin', '', 'gamlin', 11.00, 32.00, 81, 'male', 'L2Monster', 'Leogul', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 25150, 2646, 1720, 588, 1175, 430, 253, 750, 506, 0, 0, 0, 80, 170, 'giant_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2281, 22669, 'Leogul', '', 'leogul', 15.00, 35.00, 81, 'male', 'L2Monster', 'Leogul', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 25150, 2646, 1720, 588, 1175, 430, 253, 750, 506, 0, 0, 0, 80, 170, 'giant_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2282, 22670, 'Cursed Lord', '', 'LineageMonster.vampire_bat_bi_120p', 10.00, 56.00, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 30252, 3260, 1641, 576, 1120, 423, 253, 500, 506, 0, 0, 0, 60, 140, 'beast_clan', 400, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2283, 22671, 'Cursed Guardian!', '', 'LineageMonster.onyx_beast', 14.00, 14.50, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 28869, 3105, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 30, 140, 'beast_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.24, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2284, 22672, 'Cursed Seer', '', 'LineageMonster.gargoyle_bi', 16.00, 65.00, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 28777, 3095, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 140, 150, 'beast_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2285, 22673, 'Hirokai', '', 'LineageMonster.vampire_bat_bi', 10.00, 42.00, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 24791, 2648, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 60, 140, 'beast_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2286, 22674, 'Imagro', '', 'LineageMonster.gargoyle_bi', 16.00, 65.00, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 24023, 2561, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 140, 150, 'beast_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2287, 22675, 'Palit', '', 'LineageMonster2.brain_buster', 20.00, 29.00, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 25229, 2697, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 40, 150, 'beast_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2288, 22676, 'Hamlet', '', 'LineageMonster.hunter_gargoyle', 25.00, 65.00, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 24791, 2648, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 100, 150, 'beast_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2289, 22677, 'Klennot', '', 'LineageMonster.ogre', 21.00, 44.00, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 25475, 2724, 1641, 576, 1120, 423, 253, 500, 506, 194, 0, 0, 22, 140, 'beast_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2290, 22678, 'Grave Robber Summoner', '', 'LineageMonster.wererat_e', 14.00, 27.50, 81, 'male', 'L2Monster', 'GraveRobberSummoner', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 18635, 2063, 1720, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 80, 120, 'robber_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2291, 22679, 'Grave Robber Magician', '', 'LineageMonster.wererat_e', 14.00, 27.50, 82, 'male', 'L2Monster', 'GraveRobberSummoner', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 19572, 2140, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 80, 120, 'robber_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2292, 22680, 'Grave Robber Worker', '', 'LineageMonster.wererat_110p', 14.00, 27.50, 81, 'male', 'L2Monster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 16064, 1778, 1720, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2293, 22681, 'Grave Robber Warrior', '', 'LineageMonster.wererat_110p', 14.00, 27.50, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 16872, 1845, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2294, 22682, 'Grave Robber Warrior of Light', '', 'LineageMonster.wererat_110p', 14.00, 27.50, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 18660, 2040, 1804, 599, 1233, 438, 253, 500, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2295, 22683, 'Servitor of Darkness', '', 'LineageMonster.shadeless', 7.00, 33.00, 81, 'male', 'L2Monster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 20454, 2266, 1720, 588, 1175, 430, 253, 500, 506, 0, 0, 0, 48, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2296, 22684, 'Servitor of Darkness', '', 'LineageMonster.shadow_a_110p', 10.00, 25.00, 81, 'male', 'L2Monster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 19379, 2146, 1720, 588, 1175, 430, 253, 500, 506, 0, 0, 0, 80, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2297, 22685, 'Servitor of Darkness', '', 'LineageMonster2.knight_of_shadow', 10.00, 40.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 20353, 2226, 1804, 599, 1233, 438, 253, 500, 506, 0, 0, 0, 30, 150, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2298, 22686, 'Servitor of Darkness', '', 'LineageMonster3.spectral_knight', 12.50, 33.50, 82, 'male', 'L2Monster', 'Fighter', 80, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 20353, 2226, 1804, 599, 1233, 438, 253, 500, 506, 0, 0, 0, 160, 150, '', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2299, 22687, 'Phantoms of the Mine', '', 'LineageMonster.banshee_20_bi', 10.00, 27.50, 81, 'female', 'L2Monster', 'Mystic', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 18303, 2027, 1720, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 80, 160, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2300, 22688, 'Evil Spirits of the Mine', '', 'LineageMonster.vale_master', 12.00, 40.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 19224, 2101, 1804, 599, 1233, 438, 253, 500, 506, 0, 0, 0, 70, 155, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2301, 22689, 'Mine Bug', '', 'LineageMonster.ant_larva_e', 12.00, 9.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 10501, 1132, 1804, 599, 1233, 438, 253, 500, 506, 0, 0, 0, 40, 60, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2302, 22690, 'Earthworms Descendant', '', 'LineageMonster.devastator_e', 35.00, 35.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 20165, 2204, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 25, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2303, 22691, 'Ragna Orc', '', 'LineageMonster.batur_orc_03te_120p', 9.00, 25.25, 81, 'male', 'L2Monster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 19788, 2191, 1720, 588, 1175, 430, 253, 0, 506, 2, 0, 0, 80, 130, 'ragnaorc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2304, 22692, 'Ragna Orc Warrior', '', 'LineageMonster.batur_orc_warrior_03te_120p', 10.00, 24.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 20944, 2263, 1804, 599, 1233, 438, 253, 0, 506, 127, 0, 0, 80, 120, 'ragnaorc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2305, 22693, 'Ragna Orc Hero', '', 'LineageMonster.batur_orc_overlord_03te_120p', 12.00, 28.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 21464, 2346, 1804, 599, 1233, 438, 253, 0, 506, 6365, 0, 0, 80, 140, 'ragnaorc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2306, 22694, 'Ragna Orc Commander', '', 'LineageMonster.orc_champion_20_bi_e', 12.00, 27.60, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 20783, 2272, 1804, 599, 1233, 438, 253, 0, 506, 7892, 0, 0, 45, 130, 'ragnaorc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2307, 22695, 'Ragna Orc Healer', '', 'LineageMonster.batur_orc_shaman_a_03te_120p_e', 13.00, 20.80, 81, 'male', 'L2Monster', 'RagnaHealer', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 19884, 2202, 1720, 588, 1175, 430, 253, 0, 506, 8680, 0, 0, 50, 120, 'ragnaorc_clan', 700, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2308, 22696, 'Ragna Orc Shaman', '', 'LineageMonster.batur_orc_shaman_a_01te_120p_e', 13.00, 20.80, 81, 'male', 'L2Monster', 'Mystic', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 19739, 2185, 1720, 588, 1175, 430, 253, 0, 506, 8680, 0, 0, 50, 120, 'ragnaorc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2309, 22697, 'Ragna Orc Seer', '', 'LineageMonster.orc_shaman_120p', 9.00, 27.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 18697, 2044, 1804, 599, 1233, 438, 253, 0, 506, 8687, 0, 0, 45, 120, 'ragnaorc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.26, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2310, 22698, 'Ragna Orc Archer', '', 'LineageMonster.batur_orc_archer_03te_120p', 11.00, 26.00, 81, 'male', 'L2Monster', 'Ranger', 1100, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 20388, 2257, 1720, 588, 1175, 430, 253, 0, 506, 8684, 0, 0, 45, 110, 'ragnaorc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.96, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2311, 22699, 'Ragna Orc Sniper', '', 'LineageMonster.batur_orc_archer_01te_120p', 11.00, 26.00, 82, 'male', 'L2Monster', 'Ranger', 1100, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 21414, 2341, 1804, 599, 1233, 438, 253, 0, 506, 8684, 0, 0, 45, 110, 'ragnaorc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.96, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2312, 22700, 'Varangkas Guardian', '', 'LineageMonster2.ahrimanes_70p', 14.00, 39.50, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 35, 185, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2313, 22701, 'Varangkas Dre Vanul', '', 'LineageMonster.fiend_archer_20_sm', 14.00, 44.00, 81, 'male', 'L2Monster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 16974, 1880, 1720, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 70, 155, 'barankad_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2314, 22702, 'Varangkas Destroyer', '', 'LineageMonster.kaim_vanul_20_sm', 19.00, 32.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 16090, 1759, 1804, 599, 1233, 438, 253, 0, 506, 0, 0, 0, 37, 160, 'barankad_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2315, 22703, 'Contaminated Morek Warrior', '', 'LineageMonster.batur_orc_overlord_20_bi', 14.00, 28.80, 81, 'male', 'L2Monster', 'ContaminatedOrc', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 47031, 4946, 1720, 588, 1175, 430, 253, 0, 506, 135, 0, 0, 80, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2316, 22704, 'Contaminated Batur Warrior', '', 'LineageMonster.ketra_orc_20_bi', 14.00, 34.80, 81, 'male', 'L2Monster', 'ContaminatedOrc', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 58791, 6189, 1720, 588, 1175, 430, 253, 0, 506, 127, 0, 0, 45, 170, 'legendorc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2317, 22705, 'Contaminated Batur Commander', '', 'LineageMonster.ketra_orc_warrior_20_bi', 14.00, 28.80, 82, 'male', 'L2Monster', 'ContaminatedOrc', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 62054, 6450, 1804, 599, 1233, 438, 253, 0, 506, 127, 0, 0, 36, 170, 'legendorc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2318, 22706, 'Turka Followers Ghost', '', 'LineageMonster.ketra_orc_overload_20_bi_op', 14.00, 28.80, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 67199, 6999, 1804, 599, 1233, 438, 253, 0, 506, 80, 0, 0, 33, 190, 'legendorc_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2319, 22707, 'Turka Commanders Ghost', '', 'LineageMonster2.ketra_orc_chieftain_20_bi_op', 17.00, 46.20, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 66140, 6866, 1804, 599, 1233, 438, 253, 0, 506, 6719, 0, 0, 24, 185, 'legendorc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.51, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2320, 22708, 'Invader Warrior of Nightmare', '', 'imperial_warlord_zombie', 7.00, 30.00, 81, 'male', 'L2Monster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 86802, 9470, 1720, 588, 1175, 430, 253, 500, 506, 134, 6721, 0, 39, 150, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2321, 22709, 'Invader Healer of Nightmare', '', 'doll_master', 20.00, 42.00, 81, 'male', 'L2Monster', 'Priest', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 86976, 9490, 1720, 588, 1175, 430, 253, 500, 506, 0, 0, 0, 80, 160, 'fantasy_clan', 300, 0, 0, 0, 7, 10, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2322, 22710, 'Invader Guide of Nightmare', '', 'doll_master', 20.00, 42.00, 81, 'male', 'L2Monster', 'Mystic', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 55432, 6053, 1720, 588, 1175, 430, 253, 500, 506, 0, 0, 0, 80, 160, 'fantasy_clan', 300, 0, 0, 0, 7, 10, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2323, 22711, 'Invader Destroyer of Nightmare', '', 'death_blader', 15.00, 45.00, 81, 'male', 'L2Monster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 76351, 8361, 1720, 588, 1175, 430, 253, 500, 506, 1472, 0, 0, 100, 170, 'fantasy_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2324, 22712, 'Invader Assassin of Nightmare', '', 'LineageMonster5.doll_degenerated', 15.00, 20.00, 81, 'male', 'L2Monster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 56907, 6223, 1720, 588, 1175, 430, 253, 500, 506, 0, 0, 0, 45, 180, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2325, 22713, 'Invader Shaman of Nightmare', '', 'LineageMonster5.twisted_banshee', 15.00, 26.50, 81, 'male', 'L2Monster', 'Mystic', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 71490, 7803, 1720, 588, 1175, 430, 253, 500, 506, 0, 0, 0, 45, 150, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2326, 22714, 'Invader Archer of Nightmare', '', 'LineageMonster5.skeleton_hunter', 13.00, 26.00, 81, 'male', 'L2Monster', 'Ranger', 1100, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 54104, 5901, 1720, 588, 1175, 430, 253, 500, 506, 15302, 0, 0, 45, 180, 'fantasy_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2327, 22715, 'Invader Soldier of Nightmare', '', 'giant_zombie', 13.00, 40.00, 81, 'male', 'L2Monster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 86802, 9470, 1720, 588, 1175, 430, 253, 500, 506, 0, 0, 0, 20, 90, 'fantasy_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2328, 22716, 'Invader Soldier of Nightmare', '', 'giant_zombie', 13.00, 40.00, 81, 'male', 'L2Monster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 21388, 2454, 1720, 588, 1175, 430, 253, 500, 506, 0, 0, 0, 20, 90, 'fantasy_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2329, 22717, 'Invader Disciple of Nightmare', '', 'neer_crawler', 14.00, 22.00, 81, 'male', 'L2Monster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 94736, 10335, 1720, 588, 1175, 430, 253, 500, 506, 0, 0, 0, 50, 70, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2330, 22718, 'Invader Elite Soldier of Nightmare', '', 'death_lord', 21.00, 40.00, 81, 'male', 'L2Monster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 102166, 11188, 1720, 588, 1175, 430, 253, 500, 506, 78, 0, 0, 40, 140, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2331, 22719, 'Nihil Invader Warrior', '', 'LineageMonster5.dimension_caller', 25.00, 40.00, 82, 'male', 'L2Monster', 'Fighter', 80, 65803, 112.405, 1743, 3.000, 40, 43, 30, 21, 20, 20, 173525, 19428, 9528, 958, 6507, 1050, 253, 500, 506, 0, 0, 0, 60, 160, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2332, 22720, 'Nihil Invader Healer', '', 'LineageMonster5.scapegoat', 20.00, 32.50, 82, 'male', 'L2Monster', 'Priest', 40, 65803, 112.405, 1743, 3.000, 40, 43, 30, 21, 20, 20, 165990, 18584, 9528, 958, 6507, 1050, 253, 500, 506, 0, 0, 0, 45, 180, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2333, 22721, 'Nihil Invader Guide', '', 'LineageMonster5.scapegoat', 20.00, 32.50, 82, 'male', 'L2Monster', 'Mystic', 40, 32946, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 91555, 10250, 9906, 958, 6765, 1050, 253, 500, 506, 0, 0, 0, 45, 180, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2334, 22722, 'Nihil Invader Destroyer', '', 'LineageMonster5.mixed_skeleton_guard', 29.00, 40.00, 82, 'male', 'L2Monster', 'Fighter', 40, 65803, 112.405, 1743, 3.000, 40, 43, 30, 21, 20, 20, 165521, 18532, 9528, 958, 6507, 1050, 253, 500, 506, 0, 0, 0, 45, 150, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2335, 22723, 'Nihil Invader Assassin', '', 'LineageMonster5.zombie_guadian', 14.00, 32.50, 82, 'male', 'L2Monster', 'Fighter', 40, 32946, 112.558, 1743, 3.000, 40, 43, 30, 21, 20, 20, 93238, 10439, 9906, 958, 6765, 1050, 253, 500, 506, 0, 0, 0, 45, 150, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2336, 22724, 'Nihil Invader Shaman', '', 'LineageMonster5.scapegoat', 20.00, 32.50, 82, 'male', 'L2Monster', 'Mystic', 40, 65803, 112.405, 1743, 3.000, 40, 43, 30, 21, 20, 20, 166466, 18638, 9528, 958, 6507, 1050, 253, 500, 506, 0, 0, 0, 45, 180, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2337, 22725, 'Nihil Invader Archer', '', 'LineageMonster5.skeleton_boneshooter', 18.00, 27.50, 82, 'male', 'L2Monster', 'Ranger', 1100, 65803, 112.405, 1743, 3.000, 40, 43, 30, 21, 20, 20, 162859, 18234, 9528, 958, 6507, 1050, 253, 500, 506, 15302, 0, 0, 45, 170, 'fantasy_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2338, 22726, 'Nihil Invader Soldier', '', 'LineageMonster5.chaos_zombie', 28.00, 41.00, 82, 'male', 'L2Monster', 'Fighter', 40, 65803, 112.405, 1743, 3.000, 40, 43, 30, 21, 20, 20, 165521, 18532, 9528, 958, 6507, 1050, 253, 500, 506, 0, 0, 0, 30, 100, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2339, 22727, 'Nihil Invader Soldier', '', 'LineageMonster5.chaos_zombie', 28.00, 41.00, 82, 'male', 'L2Monster', 'Fighter', 40, 65803, 112.405, 1743, 3.000, 40, 43, 30, 21, 20, 20, 33270, 3562, 9528, 958, 6507, 1050, 253, 500, 506, 0, 0, 0, 30, 100, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2340, 22728, 'Nihil Invader Disciple', '', 'LineageMonster5.bloody_princess', 18.00, 33.00, 82, 'female', 'L2Monster', 'Mystic', 40, 65803, 112.405, 1743, 3.000, 40, 43, 30, 21, 20, 20, 165521, 18532, 9528, 958, 6507, 1050, 253, 500, 506, 0, 0, 0, 45, 160, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2341, 22729, 'Nihil Invader Elite Soldier', '', 'LineageMonster5.dimension_caller', 25.00, 40.00, 82, 'male', 'L2Monster', 'Fighter', 80, 65803, 112.405, 1743, 3.000, 40, 43, 30, 21, 20, 20, 310253, 33057, 9528, 958, 6507, 1050, 253, 500, 506, 0, 0, 0, 60, 140, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2342, 22730, 'Mutant Warrior', '', 'LineageMonster5.dimension_caller', 25.00, 40.00, 84, 'male', 'L2Monster', 'Fighter', 80, 112020, 189.143, 1812, 3.000, 40, 43, 30, 21, 20, 20, 357615, 38610, 15710, 991, 10728, 1086, 253, 500, 506, 0, 0, 0, 60, 160, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2343, 22731, 'Mutant Healer', '', 'LineageMonster5.doll_claw', 28.00, 50.00, 84, 'male', 'L2Monster', 'Priest', 40, 112020, 189.143, 1812, 3.000, 40, 43, 30, 21, 20, 20, 337518, 36440, 15710, 991, 10728, 1086, 253, 500, 506, 0, 0, 0, 50, 165, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2344, 22732, 'Mutant Guide', '', 'LineageMonster5.doll_claw', 28.00, 50.00, 84, 'male', 'L2Monster', 'Mystic', 40, 112020, 189.143, 1812, 3.000, 40, 43, 30, 21, 20, 20, 338470, 36543, 15710, 991, 10728, 1086, 253, 500, 506, 0, 0, 0, 50, 165, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2345, 22733, 'Mutant Destroyer', '', 'LineageMonster5.mixed_skeleton_guard', 29.00, 40.00, 84, 'male', 'L2Monster', 'Fighter', 40, 112020, 189.143, 1812, 3.000, 40, 43, 30, 21, 20, 20, 356663, 38507, 15710, 991, 10728, 1086, 253, 500, 506, 0, 0, 0, 45, 150, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2346, 22734, 'Mutant Assassin', '', 'LineageMonster5.zombie_guadian', 14.00, 32.50, 84, 'male', 'L2Monster', 'Fighter', 40, 56055, 189.294, 1812, 3.000, 40, 43, 30, 21, 20, 20, 166806, 18009, 16108, 991, 10999, 1086, 253, 500, 506, 0, 0, 0, 45, 150, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2347, 22735, 'Mutant Shaman', '', 'LineageMonster5.doll_claw', 28.00, 50.00, 84, 'male', 'L2Monster', 'Mystic', 40, 112020, 189.143, 1812, 3.000, 40, 43, 30, 21, 20, 20, 338470, 36543, 15710, 991, 10728, 1086, 253, 500, 506, 0, 0, 0, 50, 165, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2348, 22736, 'Mutant Overlord', '', 'LineageMonster5.skeleton_sniper', 20.00, 34.00, 84, 'male', 'L2Monster', 'Ranger', 1100, 56055, 189.294, 1812, 3.000, 40, 43, 30, 21, 20, 20, 159361, 17205, 16108, 991, 10999, 1086, 253, 500, 506, 15302, 0, 0, 55, 150, 'fantasy_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2349, 22737, 'Mutant Soldier', '', 'LineageMonster5.chaos_zombie', 28.00, 41.00, 84, 'male', 'L2Monster', 'Fighter', 40, 112020, 189.143, 1812, 3.000, 40, 43, 30, 21, 20, 20, 336555, 36336, 15710, 991, 10728, 1086, 253, 500, 506, 0, 0, 0, 30, 100, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2350, 22738, 'Mutant Soldier', '', 'LineageMonster5.chaos_zombie', 28.00, 41.00, 84, 'male', 'L2Monster', 'Fighter', 40, 112020, 189.143, 1812, 3.000, 40, 43, 30, 21, 20, 20, 67644, 6984, 15710, 991, 10728, 1086, 253, 500, 506, 0, 0, 0, 30, 100, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2351, 22739, 'Mutant Disciple', '', 'LineageMonster5.bloody_king', 30.00, 45.00, 84, 'male', 'L2Monster', 'Mystic', 40, 112020, 189.143, 1812, 3.000, 40, 43, 30, 21, 20, 20, 618577, 63492, 15710, 991, 10728, 1086, 253, 500, 506, 0, 0, 0, 45, 160, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2352, 22740, 'Mutant Elite Soldier', '', 'LineageMonster5.mistress_of_dimension', 15.00, 35.00, 84, 'male', 'L2Monster', 'Fighter', 40, 112020, 189.143, 1812, 3.000, 40, 43, 30, 21, 20, 20, 650930, 66985, 15710, 991, 10728, 1086, 253, 500, 506, 0, 0, 0, 45, 160, 'fantasy_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2353, 22741, 'Grave Robber Warrior', '', 'LineageMonster.wererat_110p', 14.00, 27.50, 81, 'male', 'L2Monster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 13552, 1501, 1720, 588, 1175, 430, 253, 0, 506, 12, 0, 0, 80, 120, 'robber_clan', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2354, 22742, 'Ornithomimus', '', 'ornithomimus', 15.00, 37.20, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 5701, 862, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 36, 160, '', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2355, 22743, 'Deinonychus', '', 'deinonychus', 14.00, 14.30, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 5701, 862, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 24, 160, '', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2356, 22744, 'Ornithomimus', '', 'ornithomimus', 15.00, 37.20, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 5701, 862, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 36, 200, '', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2357, 22745, 'Deinonychus', '', 'deinonychus', 14.00, 14.30, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 5701, 862, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 24, 190, '', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2358, 22746, 'Bgurent', '', 'LineageMonster5.bgurent', 23.00, 30.50, 85, 'male', 'L2Minion', 'Fighter', 40, 55818, 187.410, 1847, 3.000, 40, 43, 30, 21, 20, 20, 579304, 58205, 20894, 1007, 15152, 1105, 253, 400, 506, 0, 0, 0, 56, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2359, 22747, 'Brakian', '', 'LineageMonster5.brakian', 28.00, 30.00, 85, 'male', 'L2Minion', 'Fighter', 40, 55818, 187.410, 1847, 3.000, 40, 43, 30, 21, 20, 20, 579304, 58205, 20894, 1007, 15152, 1105, 253, 400, 506, 0, 0, 0, 38, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2360, 22748, 'Groikan', '', 'LineageMonster5.groykhan', 32.00, 31.00, 85, 'male', 'L2Minion', 'Fighter', 40, 55818, 187.410, 1847, 3.000, 40, 43, 30, 21, 20, 20, 579450, 58220, 20894, 1007, 15152, 1105, 253, 400, 506, 0, 0, 0, 56, 154, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2361, 22749, 'Treykan', '', 'LineageMonster5.traikan', 25.00, 27.00, 85, 'male', 'L2Minion', 'Fighter', 40, 55818, 187.410, 1847, 3.000, 40, 43, 30, 21, 20, 20, 585940, 58904, 20894, 1007, 15152, 1105, 253, 400, 506, 0, 0, 0, 88, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2362, 22750, 'Elite Bgurent', '', 'LineageMonster5.bgurent_e', 23.00, 40.50, 85, 'male', 'L2Monster', 'Fighter', 40, 111547, 187.261, 1847, 3.000, 40, 43, 30, 21, 20, 20, 1209444, 121549, 20428, 1007, 14814, 1105, 253, 400, 506, 0, 0, 0, 56, 180, 'bestacon_elite_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2363, 22751, 'Elite Brakian', '', 'LineageMonster5.brakian_e', 35.00, 41.50, 85, 'male', 'L2Monster', 'Fighter', 40, 111547, 187.261, 1847, 3.000, 40, 43, 30, 21, 20, 20, 1209444, 121549, 20428, 1007, 14814, 1105, 253, 400, 506, 0, 0, 0, 38, 90, 'bestacon_elite_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2364, 22752, 'Elite Groikan', '', 'LineageMonster5.groykhan_e', 40.00, 47.00, 85, 'male', 'L2Monster', 'Fighter', 40, 111547, 187.261, 1847, 3.000, 40, 43, 30, 21, 20, 20, 1206702, 121260, 20428, 1007, 14814, 1105, 253, 400, 506, 0, 0, 0, 56, 154, 'bestacon_elite_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2365, 22753, 'Elite Treykan', '', 'LineageMonster5.traikan_e', 30.00, 42.00, 85, 'male', 'L2Monster', 'Fighter', 40, 111547, 187.261, 1847, 3.000, 40, 43, 30, 21, 20, 20, 1209444, 121549, 20428, 1007, 14814, 1105, 253, 400, 506, 0, 0, 0, 88, 180, 'bestacon_elite_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2366, 22754, 'Turtlelian', '', 'LineageMonster5.turtlian', 28.00, 28.50, 85, 'male', 'L2Minion', 'Fighter', 40, 55818, 187.410, 1847, 3.000, 40, 43, 30, 21, 20, 20, 579304, 58205, 20894, 1007, 15152, 1105, 253, 400, 506, 0, 0, 0, 29, 93, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2367, 22755, 'Krajian', '', 'LineageMonster5.krakian', 26.00, 36.00, 85, 'male', 'L2Minion', 'Fighter', 40, 55818, 187.410, 1847, 3.000, 40, 43, 30, 21, 20, 20, 579304, 58205, 20894, 1007, 15152, 1105, 253, 400, 506, 0, 0, 0, 42, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2368, 22756, 'Tardyon', '', 'LineageMonster5.tardion', 30.00, 35.00, 85, 'male', 'L2Minion', 'Fighter', 40, 55818, 187.410, 1847, 3.000, 40, 43, 30, 21, 20, 20, 579450, 58220, 20894, 1007, 15152, 1105, 253, 400, 506, 0, 0, 0, 25, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2369, 22757, 'Elite Turtlelian', '', 'LineageMonster5.turtlian_e', 38.00, 42.00, 85, 'male', 'L2Monster', 'Fighter', 40, 111547, 187.261, 1847, 3.000, 40, 43, 30, 21, 20, 20, 1209444, 121549, 20428, 1007, 14814, 1105, 253, 400, 506, 0, 0, 0, 29, 93, 'raptilicon_elite_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2370, 22758, 'Elite Krajian', '', 'LineageMonster5.krakian_e', 26.00, 48.00, 85, 'male', 'L2Monster', 'Fighter', 40, 111547, 187.261, 1847, 3.000, 40, 43, 30, 21, 20, 20, 1206702, 121260, 20428, 1007, 14814, 1105, 253, 400, 506, 0, 0, 0, 42, 180, 'raptilicon_elite_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2371, 22759, 'Elite Tardyon', '', 'LineageMonster5.tardion_e', 30.00, 47.00, 85, 'male', 'L2Monster', 'Fighter', 40, 111547, 187.261, 1847, 3.000, 40, 43, 30, 21, 20, 20, 1209444, 121549, 20428, 1007, 14814, 1105, 253, 400, 506, 0, 0, 0, 25, 180, 'raptilicon_elite_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2372, 22760, 'Kanibi', '', 'LineageMonster5.karnibi', 22.00, 45.50, 85, 'male', 'L2Minion', 'Fighter', 40, 55818, 187.410, 1847, 3.000, 40, 43, 30, 21, 20, 20, 579304, 58205, 20894, 1007, 15152, 1105, 253, 400, 506, 0, 0, 0, 75, 270, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2373, 22761, 'Kiriona', '', 'LineageMonster5.cariona', 33.00, 33.00, 85, 'male', 'L2Minion', 'Fighter', 40, 55818, 187.410, 1847, 3.000, 40, 43, 30, 21, 20, 20, 579304, 58205, 20894, 1007, 15152, 1105, 253, 400, 506, 0, 0, 0, 24, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2374, 22762, 'Kaiona', '', 'LineageMonster5.kaiona', 32.00, 37.50, 85, 'male', 'L2Minion', 'Fighter', 40, 55818, 187.410, 1847, 3.000, 40, 43, 30, 21, 20, 20, 579450, 58220, 20894, 1007, 15152, 1105, 253, 400, 506, 0, 0, 0, 94, 204, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2375, 22763, 'Elite Kanibi', '', 'LineageMonster5.karnibi_e', 32.00, 69.50, 85, 'male', 'L2Monster', 'Fighter', 40, 111547, 187.261, 1847, 3.000, 40, 43, 30, 21, 20, 20, 1209444, 121549, 20428, 1007, 14814, 1105, 253, 400, 506, 0, 0, 0, 75, 270, 'cocracon_elite_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2376, 22764, 'Elite Kiriona', '', 'LineageMonster5.cariona_e', 48.00, 46.00, 85, 'male', 'L2Monster', 'Fighter', 40, 111547, 187.261, 1847, 3.000, 40, 43, 30, 21, 20, 20, 1206702, 121260, 20428, 1007, 14814, 1105, 253, 400, 506, 0, 0, 0, 24, 180, 'cocracon_elite_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2377, 22765, 'Elite Kaiona', '', 'LineageMonster5.kaiona_e', 35.00, 49.50, 85, 'male', 'L2Monster', 'Fighter', 40, 111547, 187.261, 1847, 3.000, 40, 43, 30, 21, 20, 20, 1209444, 121549, 20428, 1007, 14814, 1105, 253, 400, 506, 0, 0, 0, 94, 204, 'cocracon_elite_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2378, 22766, 'Mithril Millipede', '', 'bug', 45.00, 8.00, 85, 'male', 'L2Monster', 'Grima', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 4502, 474, 2069, 630, 1413, 461, 253, 300, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2379, 22767, 'Archery Knight', '', 'humanoid', 15.00, 31.00, 85, 'male', 'L2Monster', 'JiniaGuard', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 31712, 3176, 2069, 630, 1413, 461, 253, 300, 506, 0, 0, 0, 20, 150, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2380, 22768, 'Tanta Lizardman Scout', '', 'LineageMonster.zenta_lizardman_warrior', 13.00, 35.00, 82, 'male', 'L2Monster', 'Fighter', 80, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 17792, 1945, 1804, 599, 1233, 438, 253, 400, 506, 98, 0, 0, 40, 140, '', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2381, 22769, 'Tanta Lizardman Warrior', '', 'LineageMonster.zenta_lizardman_matriarch', 20.00, 40.00, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 23866, 2576, 1890, 609, 1292, 445, 253, 0, 506, 8682, 0, 0, 53, 140, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2382, 22770, 'Tanta Lizardman Soldier', '', 'LineageMonster5.tantaar_lizardman_rogue', 20.00, 40.25, 84, 'male', 'L2Monster', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 41235, 4198, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2383, 22771, 'Tanta Lizardman Berserker', '', 'LineageMonster5.tantaar_lizardman_warrior', 28.00, 37.50, 84, 'male', 'L2Monster', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 42355, 4318, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 58, 150, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2384, 22772, 'Tanta Lizardman Archer', '', 'LineageMonster5.tantaar_lizardman_archer', 20.00, 40.25, 83, 'male', 'L2Monster', 'Ranger', 1100, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 25361, 2738, 1890, 609, 1292, 445, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2385, 22773, 'Tanta Lizardman Magician', '', 'LineageMonster.zenta_lizardman_shaman', 13.00, 35.00, 83, 'male', 'L2Monster', 'Mystic', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 25094, 2709, 1890, 609, 1292, 445, 253, 0, 506, 7, 0, 0, 43, 120, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2386, 22774, 'Tanta Lizardman Summoner', '', 'LineageMonster5.tantaar_lizardman_sorcerer', 29.00, 44.00, 84, 'male', 'L2Monster', 'PlainsOfLizardmanSummon', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 46590, 4740, 1981, 619, 1353, 453, 253, 0, 506, 0, 0, 0, 75, 150, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (1, 22775, 'Sel Mahum Drill Sergeant', '', 'LineageMonster5.xel_mahum_sorcerer', 27.00, 31.50, 84, 'male', 'L2Monster', 'SelMahumLeader', 40, 8078, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 25111, 2528, 1980, 619, 1352, 453, 253, 0, 500, 0, 0, 0, 110, 180, 'selmahum_clan', 700, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1, 22776, 'Sel Mahum Training Officer', '', 'LineageMonster5.xel_mahum_high_sorcerer', 29.00, 33.50, 84, 'male', 'L2Monster', 'SelMahumLeader', 40, 12117, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 37863, 3820, 1980, 619, 1352, 453, 253, 0, 500, 0, 0, 0, 110, 180, 'selmahum_clan', 700, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1, 22777, 'Sel Mahum Drill Sergeant', '', 'LineageMonster5.xel_mahum_warrior', 29.00, 37.00, 84, 'male', 'L2Monster', 'SelMahumLeader', 40, 8078, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 25111, 2528, 1980, 619, 1352, 453, 253, 0, 500, 0, 0, 0, 110, 180, 'selmahum_clan', 700, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1, 22778, 'Sel Mahum Drill Sergeant', '', 'LineageMonster5.xel_mahum_sniper', 27.00, 31.00, 84, 'male', 'L2Monster', 'SelMahumLeader', 40, 8078, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 25111, 2528, 1980, 619, 1352, 453, 253, 0, 500, 0, 0, 0, 110, 180, 'selmahum_clan', 700, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1, 22779, 'Sel Mahum Escort Guard', '', 'LineageMonster5.xel_mahum_warrior', 29.00, 37.00, 84, 'male', 'L2Monster', 'SelMahumGuard', 40, 8078, 9.400, 1812, 3.270, 40, 43, 30, 21, 20, 20, 24663, 2481, 1980, 619, 1352, 453, 253, 0, 500, 0, 0, 0, 110, 180, '', 500, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1, 22780, 'Sel Mahum Recruit', '', 'LineageMonster5.xel_mahum_sorcerer', 27.00, 31.50, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 9.400, 1812, 3.270, 40, 43, 30, 21, 20, 20, 8454, 912, 1891, 609, 1291, 445, 253, 0, 500, 0, 0, 0, 110, 180, 'selmahum_clan', 700, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1, 22781, 'Sel Mahum Soldier', '', 'LineageMonster5.xel_mahum_high_sorcerer', 29.00, 33.50, 84, 'male', 'L2Monster', 'Fighter', 40, 4039, 9.400, 1812, 3.270, 40, 43, 30, 21, 20, 20, 11193, 1194, 1980, 619, 1352, 453, 253, 0, 500, 0, 0, 0, 110, 180, '', 500, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1, 22782, 'Sel Mahum Recruit', '', 'LineageMonster5.xel_mahum_warrior', 29.00, 37.00, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 9.400, 1812, 3.270, 40, 43, 30, 21, 20, 20, 8454, 912, 1891, 609, 1291, 445, 253, 0, 500, 0, 0, 0, 110, 180, 'selmahum_clan', 700, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1, 22783, 'Sel Mahum Soldier', '', 'LineageMonster5.xel_mahum_warrior', 29.00, 37.00, 84, 'male', 'L2Monster', 'Fighter', 40, 4039, 9.400, 1812, 3.270, 40, 43, 30, 21, 20, 20, 8532, 910, 1980, 619, 1352, 453, 253, 0, 500, 0, 0, 0, 110, 180, 'selmahum_clan', 700, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1, 22784, 'Sel Mahum Recruit', '', 'LineageMonster5.xel_mahum_sniper', 27.00, 31.00, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 9.400, 1812, 3.270, 40, 43, 30, 21, 20, 20, 8454, 912, 1891, 609, 1291, 445, 253, 0, 500, 0, 0, 0, 110, 180, 'selmahum_clan', 700, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1, 22785, 'Sel Mahum Soldier', '', 'LineageMonster5.xel_mahum_sniper', 27.00, 31.00, 84, 'male', 'L2Monster', 'Fighter', 40, 4039, 9.400, 1812, 3.270, 40, 43, 30, 21, 20, 20, 4808, 512, 1980, 619, 1352, 453, 253, 0, 500, 0, 0, 0, 110, 180, 'selmahum_clan', 700, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1, 22786, 'Sel Mahum Squad Leader', '', 'LineageMonster5.xel_mahum_sorcerer', 27.00, 31.50, 84, 'male', 'L2Monster', 'Fighter', 40, 8078, 9.400, 1812, 3.270, 40, 43, 30, 21, 20, 20, 20752, 2063, 1980, 619, 1352, 453, 253, 0, 500, 0, 0, 0, 110, 180, '', 500, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1, 22787, 'Sel Mahum Squad Leader', '', 'LineageMonster5.xel_mahum_warrior', 29.00, 37.00, 84, 'male', 'L2Monster', 'Fighter', 40, 8078, 9.400, 1812, 3.270, 40, 43, 30, 21, 20, 20, 20752, 2063, 1980, 619, 1352, 453, 253, 0, 500, 0, 0, 0, 110, 180, '', 500, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (1, 22788, 'Sel Mahum Squad Leader', '', 'LineageMonster5.xel_mahum_sniper', 27.00, 31.00, 84, 'male', 'L2Monster', 'Fighter', 40, 8078, 9.400, 1812, 3.270, 40, 43, 30, 21, 20, 20, 20752, 2063, 1980, 619, 1352, 453, 253, 0, 500, 0, 0, 0, 110, 180, '', 500, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2401, 22789, 'Guide Solina', '', 'LineageMonster3.solina_brother', 9.00, 23.40, 83, 'male', 'L2Monster', 'MoSMonk', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 25556, 2611, 1890, 609, 1292, 445, 253, 200, 506, 8212, 0, 0, 61, 180, 'solina_n_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2402, 22790, 'Seeker Solina', '', 'LineageMonster3.solina_father', 11.00, 25.40, 83, 'male', 'L2Monster', 'MoSMonk', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 26927, 2759, 1890, 609, 1292, 445, 253, 200, 506, 8213, 0, 0, 70, 170, 'solina_n_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2403, 22791, 'Savior Solina', '', 'LineageMonster3.grail_protection', 9.00, 15.60, 83, 'male', 'L2Monster', 'MoSMonk', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 26927, 2759, 1890, 609, 1292, 445, 253, 200, 506, 0, 0, 0, 65, 180, 'solina_n_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2404, 22792, 'Disciple Solina', '', 'LineageMonster5.solina_old_brother', 15.00, 30.00, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 27176, 2785, 1890, 609, 1292, 445, 253, 200, 506, 0, 0, 0, 40, 120, 'solina_n_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2405, 22793, 'Ascetic Solina', '', 'LineageMonster3.solina_brother', 9.00, 23.40, 83, 'male', 'L2Monster', 'MoSMonk', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 27532, 2824, 1890, 609, 1292, 445, 253, 200, 506, 8212, 0, 0, 61, 180, 'solina_n_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2406, 22794, 'Divinity Judge', '', 'divine', 13.50, 36.50, 84, 'male', 'L2Monster', 'Fighter', 40, 32745, 110.577, 1812, 3.000, 40, 43, 30, 21, 20, 20, 159424, 17009, 10098, 991, 6896, 1086, 253, 300, 506, 148, 0, 0, 30, 170, 'divine_n_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2407, 22795, 'Divinity Manager', '', 'divine', 15.00, 80.00, 84, 'male', 'L2Monster', 'Fighter', 80, 32745, 110.577, 1812, 3.000, 40, 43, 30, 21, 20, 20, 165898, 17700, 10098, 991, 6896, 1086, 253, 300, 506, 97, 0, 0, 50, 170, 'divine_n_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2408, 22796, 'Divinity Supervisor', '', 'divine', 13.00, 47.00, 84, 'male', 'L2Monster', 'Fighter', 80, 32745, 110.577, 1812, 3.000, 40, 43, 30, 21, 20, 20, 184779, 19714, 10098, 991, 6896, 1086, 253, 300, 506, 8221, 0, 0, 30, 220, 'divine_n_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2409, 22797, 'Divinity Worshipper', '', 'divine', 24.00, 49.00, 84, 'female', 'L2Monster', 'Fighter', 40, 32745, 110.577, 1812, 3.000, 40, 43, 30, 21, 20, 20, 170832, 18226, 10098, 991, 6896, 1086, 253, 300, 506, 0, 0, 0, 50, 150, 'divine_n_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2410, 22798, 'Divinity Protector', '', 'divine', 18.00, 44.00, 84, 'male', 'L2Monster', 'Fighter', 40, 32745, 110.577, 1812, 3.000, 40, 43, 30, 21, 20, 20, 325623, 33084, 10098, 991, 6896, 1086, 253, 300, 506, 0, 0, 0, 40, 150, 'n_divine_clan', 500, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2411, 22799, 'Divinity Fighter', '', 'divine', 24.00, 49.00, 84, 'female', 'L2Monster', 'Fighter', 40, 32745, 110.577, 1812, 3.000, 40, 43, 30, 21, 20, 20, 325931, 33117, 10098, 991, 6896, 1086, 253, 300, 506, 0, 0, 0, 50, 150, 'n_divine_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2412, 22800, 'Divinity Magus', '', 'divine', 18.00, 44.00, 84, 'male', 'L2Monster', 'Fighter', 40, 32745, 110.577, 1812, 3.000, 40, 43, 30, 21, 20, 20, 349400, 35497, 10098, 991, 6896, 1086, 253, 300, 506, 0, 0, 0, 40, 150, 'n_divine_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2413, 22801, 'Cruel Pincer Golem', '', 'LineageMonster3.golem_cannon_catapult_a_e', 23.50, 34.70, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 10109, 1027, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 130, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2414, 22802, 'Cruel Pincer Golem', '', 'LineageMonster3.golem_cannon_catapult_a_e', 23.50, 34.70, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 7216, 733, 1179, 491, 805, 359, 253, 300, 506, 0, 0, 0, 130, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2415, 22803, 'Cruel Pincer Golem', '', 'LineageMonster3.golem_cannon_catapult_a_e', 23.50, 34.70, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 9269, 941, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 130, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2416, 22804, 'Drill Golem of Terror', '', 'LineageMonster3.golem_prop_e', 23.00, 32.80, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 10392, 1069, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 72, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2417, 22805, 'Drill Golem of Terror', '', 'LineageMonster3.golem_prop_e', 23.00, 32.80, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 7418, 763, 1220, 502, 833, 368, 253, 300, 506, 0, 0, 0, 72, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2418, 22806, 'Drill Golem of Terror', '', 'LineageMonster3.golem_prop_e', 23.00, 32.80, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 9528, 980, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 72, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2419, 22807, 'Scout-type Golem No. 28', '', 'LineageMonster3.golem_carrier_70p', 20.00, 23.00, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 9904, 1006, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 72, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2420, 22808, 'Scout-type Golem No. 2', '', 'LineageMonster.mechanic_golem_a_e', 5.00, 19.00, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 5922, 601, 1179, 491, 805, 359, 253, 0, 506, 0, 0, 0, 30, 170, 'golem_p_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2421, 22809, 'Guard Golem', '', 'LineageMonster3.golem_guardian_a_090p_e', 16.00, 37.20, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 20937, 2066, 1220, 502, 833, 368, 253, 400, 506, 0, 0, 0, 50, 160, 'golem_p_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2422, 22810, 'Micro Scout Golem', '', 'LineageMonster3.golem_microscout_a_e', 12.00, 43.50, 72, 'male', 'L2Monster', 'Fighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 17331, 1676, 1179, 491, 805, 359, 253, 400, 506, 0, 0, 0, 30, 180, 'golem_p_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2423, 22811, 'Great Chaos Golem', '', 'LineageMonster3.Steel_Trapper_e', 35.00, 46.38, 73, 'male', 'L2Monster', 'Fighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 30036, 2962, 1220, 502, 833, 368, 253, 400, 506, 0, 0, 0, 60, 160, 'golem_p_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2424, 22812, 'Boom Golem', '', 'LineageMonster.big_boom_e', 6.00, 13.00, 72, 'male', 'L2Monster', 'BoomGolem', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 17281, 1671, 1179, 491, 805, 359, 253, 400, 506, 0, 0, 0, 48, 160, 'golem_p_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2425, 25001, 'Greyclaw Kutus', '', 'ol_mahum_champion_50_bi', 21.00, 43.50, 23, 'male', 'L2RaidBoss', 'Fighter', 40, 40330, 17.535, 232, 1.500, 60, 57, 73, 76, 70, 80, 2690117, 69902, 71, 321, 4, 157, 253, 0, 506, 67, 633, 0, 50, 170, '', 300, 0, 20, 383, 7, 30, 4, 5, 0, -18, 0.63, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2426, 25002, 'Guard of Kutus', '', 'ol_mahum', 13.50, 25.00, 22, 'male', 'L2Minion', 'Fighter', 40, 4186, 17.158, 219, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 171, 154, 29, 151, 253, 0, 506, 7, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2427, 25003, 'Pawn of Kutus', '', 'ol_mahum', 13.50, 25.00, 22, 'male', 'L2Minion', 'Fighter', 40, 6247, 17.158, 219, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 256, 154, 64, 151, 253, 0, 506, 123, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2428, 25004, 'Turek Mercenary Captain', '', 'orc_champion_50_bi', 15.00, 35.00, 30, 'male', 'L2RaidBoss', 'Fighter', 40, 70742, 28.565, 329, 1.500, 60, 57, 73, 76, 70, 80, 1868579, 150667, 248, 422, 30, 206, 253, 0, 506, 124, 0, 0, 45, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.76, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2429, 25005, 'Turek Mercenary Archer', '', 'orc_archer', 14.00, 25.00, 29, 'male', 'L2Minion', 'Ranger', 1100, 7224, 27.487, 315, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 453, 204, 107, 198, 253, 0, 506, 271, 0, 0, 45, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2430, 25006, 'Turek Mercenary Warrior', '', 'orc_fighter', 12.00, 22.00, 29, 'male', 'L2Minion', 'Fighter', 40, 5391, 27.487, 315, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 453, 204, 107, 198, 253, 0, 506, 2, 0, 0, 45, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2431, 25007, 'Retreat Spider Cletu', '', 'poison_spider', 27.00, 25.50, 42, 'male', 'L2RaidBoss', 'Mystic', 40, 139295, 50.722, 531, 2.100, 60, 57, 73, 76, 70, 80, 3062105, 303198, 667, 648, 123, 316, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.65, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2432, 25008, 'Cletus Retainer', '', 'giant_spider', 26.00, 25.50, 41, 'male', 'L2Minion', 'Mystic', 40, 21023, 48.186, 505, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1234, 313, 438, 306, 253, 0, 506, 0, 0, 0, 72, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2433, 25009, 'Cletus Pawn', '', 'giant_spider', 26.00, 25.50, 41, 'male', 'L2Minion', 'Mystic', 40, 10512, 48.186, 505, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1234, 313, 438, 306, 253, 0, 506, 0, 0, 0, 72, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2434, 25010, 'Furious Thieles', '', 'ti_mi_tran', 23.00, 90.00, 55, 'male', 'L2RaidBoss', 'Fighter', 40, 262380, 88.695, 890, 2.400, 60, 57, 73, 76, 70, 80, 3983098, 535296, 1646, 966, 468, 471, 253, 0, 506, 0, 0, 0, 12, 50, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.61, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2435, 25011, 'Guard of Thieles', '', 'zenta_lizardman_scout', 11.00, 30.00, 54, 'male', 'L2Minion', 'Ranger', 1100, 27093, 85.864, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 3095, 469, 1729, 458, 253, 0, 506, 279, 0, 0, 37, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.93, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2436, 25012, 'Follower of Thieles', '', 'dryad', 9.00, 20.00, 54, 'female', 'L2Minion', 'Fighter', 40, 20219, 85.864, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 3095, 469, 1729, 458, 253, 0, 506, 0, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2437, 25013, 'Ghost of Peasant Leader', '', 'skeleton_knight_50_bi', 15.00, 39.00, 50, 'male', 'L2RaidBoss', 'Fighter', 40, 213145, 73.934, 748, 2.100, 60, 57, 73, 76, 70, 80, 3551193, 422350, 1193, 835, 272, 407, 253, 0, 506, 145, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.17, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2438, 25014, 'Ghost of Peasant', '', 'skeleton', 11.00, 25.00, 49, 'male', 'L2Minion', 'Fighter', 40, 32519, 70.884, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 4453, 404, 3976, 395, 253, 0, 506, 68, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2439, 25015, 'Ghost of Peasant', '', 'skeleton_archer', 11.00, 27.00, 49, 'male', 'L2Minion', 'Ranger', 1100, 16260, 70.884, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 2227, 404, 994, 395, 253, 0, 506, 14, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2440, 25016, 'The 3rd Underwater Guardian', '', 'susceptor_100_bi', 40.00, 73.00, 60, 'male', 'L2RaidBoss', 'Fighter', 40, 307125, 101.298, 1037, 2.400, 60, 57, 73, 76, 70, 80, 4154684, 587467, 2189, 1107, 690, 539, 253, 0, 506, 0, 0, 0, 27, 150, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.43, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2441, 25017, 'Escort of the 3rd Guardian', '', 'will_o_wisp', 13.00, 22.00, 59, 'male', 'L2Minion', 'Fighter', 40, 47799, 99.014, 1007, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 4147, 539, 2517, 525, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.10, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2442, 25018, 'Support of the 3rd Guardian', '', 'will_o_wisp', 13.00, 22.00, 59, 'male', 'L2Minion', 'Fighter', 40, 23899, 99.014, 1007, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 4147, 539, 2517, 525, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.10, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2443, 25019, 'Pan Dryad', '', 'pan_100_bi', 42.00, 73.00, 25, 'male', 'L2RaidBoss', 'Fighter', 40, 86633, 46.096, 259, 1.500, 60, 57, 73, 76, 70, 80, 2541013, 79280, 169, 349, 22, 170, 253, 0, 506, 291, 0, 0, 45, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.58, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2444, 25020, 'Breka Warlock Pastu', '', 'batur_orc_shaman_100_bi', 22.00, 35.00, 34, 'male', 'L2RaidBoss', 'Priest', 40, 65792, 25.613, 388, 1.800, 60, 57, 73, 76, 70, 80, 1918617, 135504, 187, 491, 15, 240, 253, 0, 506, 8, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.30, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2445, 25021, 'Pastus Silhouette', '', 'silhouette', 8.00, 23.00, 33, 'female', 'L2Minion', 'Fighter', 40, 9984, 24.517, 373, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 343, 237, 55, 231, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2446, 25022, 'Pastus Shadow', '', 'shadow', 10.00, 30.00, 33, 'male', 'L2Minion', 'Mystic', 40, 4992, 24.517, 373, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 343, 237, 55, 231, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2447, 25023, 'Stakato Queen Zyrnna', '', 'marsh_stakato_queen_100_bi', 30.00, 76.00, 34, 'female', 'L2RaidBoss', 'Fighter', 40, 87403, 33.959, 388, 1.800, 60, 57, 73, 76, 70, 80, 2316590, 188679, 349, 491, 52, 240, 253, 0, 506, 150, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.41, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2448, 25024, 'Jerunas Guard Captain', '', 'marsh_stakato_drone', 9.00, 24.00, 33, 'male', 'L2Minion', 'Fighter', 40, 13234, 32.437, 373, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 1283, 237, 758, 231, 253, 0, 506, 238, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2449, 25025, 'Jerunas Guard', '', 'marsh_stakato_soldier', 10.00, 25.00, 33, 'male', 'L2Minion', 'Fighter', 40, 6617, 32.437, 373, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 642, 237, 189, 231, 253, 0, 506, 144, 0, 0, 30, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2450, 25026, 'Katu Van Leader Atui', '', 'ketra_orc_overload', 12.00, 24.00, 49, 'male', 'L2RaidBoss', 'Fighter', 40, 148076, 51.719, 720, 2.100, 60, 57, 73, 76, 70, 80, 2328069, 284981, 595, 810, 72, 395, 253, 0, 506, 84, 0, 0, 33, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.48, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2451, 25027, 'Katu Van Marksman', '', 'ketra_orc_archer', 12.00, 27.00, 48, 'male', 'L2Minion', 'Ranger', 1100, 15134, 49.588, 692, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1110, 393, 262, 384, 253, 0, 506, 279, 0, 0, 45, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.91, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2452, 25028, 'Katu Van Raider', '', 'ketra_orc_warrior', 12.00, 24.00, 48, 'male', 'L2Minion', 'Fighter', 40, 11294, 49.588, 692, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1110, 393, 262, 384, 253, 0, 506, 128, 0, 0, 36, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2453, 25029, 'Atraiban', '', 'field_stalker_200_bi', 45.00, 96.00, 53, 'male', 'L2RaidBoss', 'Fighter', 40, 242937, 82.956, 832, 2.400, 60, 57, 73, 76, 70, 80, 3895772, 516213, 1453, 913, 398, 444, 253, 0, 506, 0, 0, 0, 70, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.41, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2454, 25030, 'Atraibans Top Disciple', '', 'will_o_wisp', 13.00, 22.00, 52, 'male', 'L2Minion', 'Mystic', 40, 37287, 79.987, 804, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2724, 443, 1434, 433, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.10, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2455, 25031, 'Atraibans Disciple', '', 'liviona', 15.00, 28.00, 52, 'male', 'L2Minion', 'Fighter', 40, 18643, 79.987, 804, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2724, 443, 1434, 433, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2456, 25032, 'Evas Guardian Millenu', '', 'banshee_50_bi', 13.50, 38.00, 58, 'female', 'L2RaidBoss', 'Mystic', 40, 290050, 96.605, 977, 2.400, 60, 57, 73, 76, 70, 80, 4092905, 566683, 1961, 1050, 587, 512, 253, 0, 506, 3939, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.56, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2457, 25033, 'Millenu Guard Shaman', '', 'heltor_silenos_shaman', 13.00, 32.00, 57, 'male', 'L2Minion', 'Priest', 40, 30131, 94.077, 948, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 4941, 511, 3857, 498, 253, 0, 506, 5131, 0, 0, 29, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.22, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2458, 25034, 'Mellenu Guard Warrior', '', 'skeleton_royal_guard', 11.00, 28.50, 57, 'male', 'L2Minion', 'Fighter', 40, 44972, 94.077, 948, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 7411, 511, 8680, 498, 253, 0, 506, 946, 945, 0, 80, 170, '', 300, 0, 20, 534, 7, 10, 8, 0, 0, -18, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2459, 25035, 'Shilens Messenger Cabrio', '', 'vale_master_50_bi', 18.00, 63.00, 70, 'male', 'L2RaidBoss', 'Fighter', 40, 373386, 117.684, 1346, 2.700, 60, 57, 73, 76, 70, 80, 4596480, 802604, 3426, 1412, 1140, 688, 253, 0, 506, 189, 0, 0, 70, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.74, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2460, 25036, 'Cabrio Captor', '', 'skeleton_archer', 11.00, 27.00, 69, 'male', 'L2Minion', 'Ranger', 1100, 39455, 116.469, 1314, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 6603, 690, 4383, 673, 253, 0, 506, 279, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2461, 25037, 'Cabrio Blader', '', 'doll_blader', 6.00, 12.00, 69, 'male', 'L2Minion', 'Fighter', 40, 29444, 116.469, 1314, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 6603, 690, 4383, 673, 253, 0, 506, 5129, 5129, 0, 22, 170, '', 300, 0, 0, 582, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2462, 25038, 'Tirak', '', 'dre_vanul_100_bi', 28.00, 75.00, 28, 'male', 'L2RaidBoss', 'Fighter', 40, 48984, 20.213, 301, 1.500, 60, 57, 73, 76, 70, 80, 2390045, 97281, 111, 392, 7, 191, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.35, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2463, 25039, 'Tiraks Guard', '', 'spartoi', 11.00, 27.00, 27, 'male', 'L2Minion', 'Fighter', 40, 7507, 19.561, 287, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 406, 188, 104, 183, 253, 0, 506, 68, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2464, 25040, 'Tiraks Knight', '', 'skeleton', 11.00, 25.00, 27, 'male', 'L2Minion', 'Fighter', 40, 3754, 19.561, 287, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 203, 188, 26, 183, 253, 0, 506, 2, 945, 0, 60, 170, '', 300, 0, 20, 217, 7, 30, 4, 5, 0, -18, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2465, 25041, 'Remmel', '', 'marsh_stakato_queen_100_bi', 30.00, 76.00, 35, 'female', 'L2RaidBoss', 'Fighter', 40, 69450, 26.794, 403, 1.800, 60, 57, 73, 76, 70, 80, 1912395, 144137, 203, 508, 16, 248, 253, 0, 506, 221, 109, 0, 50, 170, '', 300, 0, 20, 547, 7, 10, 8, 0, 0, -18, 0.41, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2466, 25042, 'Remmels Archer', '', 'batur_orc_archer', 11.00, 21.50, 34, 'male', 'L2Minion', 'Ranger', 1100, 7053, 25.613, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 373, 245, 59, 240, 253, 0, 506, 275, 0, 0, 45, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.96, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2467, 25043, 'Remmels Guard', '', 'marsh_stakato', 10.00, 20.00, 34, 'male', 'L2Minion', 'Fighter', 40, 5263, 25.613, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 373, 245, 59, 240, 253, 0, 506, 127, 0, 0, 21, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2468, 25044, 'Barion', '', 'skeleton_knight_50_bi', 15.00, 39.00, 47, 'male', 'L2RaidBoss', 'Fighter', 40, 134366, 47.474, 665, 2.100, 60, 57, 73, 76, 70, 80, 2205665, 257531, 517, 762, 58, 371, 253, 0, 506, 70, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.17, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2469, 25045, 'Dark Mages of Barion', '', 'batur_orc_shaman', 11.00, 16.00, 46, 'male', 'L2Minion', 'Priest', 40, 20431, 45.388, 638, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 963, 369, 211, 360, 253, 0, 506, 159, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2470, 25046, 'Barions Grunt', '', 'spartoi', 11.00, 27.00, 46, 'male', 'L2Minion', 'Fighter', 40, 10215, 45.388, 638, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 963, 369, 211, 360, 253, 0, 506, 129, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2471, 25047, 'Karte', '', 'death_knight_50_bi', 18.00, 47.50, 49, 'male', 'L2RaidBoss', 'Fighter', 40, 148076, 51.719, 720, 2.100, 60, 57, 73, 76, 70, 80, 2328069, 284981, 595, 810, 72, 395, 253, 0, 506, 131, 0, 0, 27, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.71, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2472, 25048, 'Kartes Chief Knight', '', 'skeleton_knight', 10.00, 25.00, 48, 'male', 'L2Minion', 'Fighter', 40, 22587, 49.588, 692, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 2221, 393, 1048, 384, 253, 0, 506, 71, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2473, 25049, 'Kartes Royal Guard', '', 'spartoi', 11.00, 27.00, 48, 'male', 'L2Minion', 'Fighter', 40, 11294, 49.588, 692, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1110, 393, 262, 384, 253, 0, 506, 74, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2474, 25050, 'Verfa', '', 'death_blader_200_bi', 45.00, 141.00, 51, 'male', 'L2RaidBoss', 'Fighter', 40, 324093, 139.955, 776, 2.400, 60, 57, 73, 76, 70, 80, 2256714, 285537, 1364, 861, 381, 420, 253, 0, 506, 1472, 0, 0, 100, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2475, 25051, 'Rahha', '', 'Bloody_Queen_Raid', 11.00, 34.00, 65, 'female', 'L2RaidBoss', 'Mystic', 40, 344101, 110.823, 1189, 2.700, 60, 57, 73, 76, 70, 80, 4489693, 746626, 2797, 1257, 933, 613, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2476, 25052, 'Priestess of Rahha', '', 'medusa', 10.00, 25.00, 64, 'female', 'L2Minion', 'Priest', 40, 53979, 109.162, 1158, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 5341, 614, 3597, 598, 253, 0, 506, 0, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2477, 25053, 'Fanatics of Rahha', '', 'harpy', 10.00, 42.00, 64, 'female', 'L2Minion', 'Fighter', 40, 26989, 109.162, 1158, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 5341, 614, 3597, 598, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2478, 25054, 'Kernon', '', 'kaim_vanul', 24.00, 40.00, 75, 'male', 'L2RaidBoss', 'Kernon', 40, 397437, 123.216, 1508, 3.000, 60, 57, 73, 76, 70, 80, 5231148, 864099, 4020, 1571, 1425, 766, 253, 0, 506, 0, 0, 0, 37, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2479, 25055, 'Taliadon', '', 'death_blader', 15.00, 45.00, 74, 'male', 'L2Minion', 'Fighter', 40, 62863, 122.143, 1475, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15628, 769, 22217, 751, 253, 0, 506, 1472, 0, 0, 100, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2480, 25056, 'Vemsk', '', 'death_knight', 12.00, 31.00, 74, 'male', 'L2Minion', 'Fighter', 40, 31432, 122.143, 1475, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 7814, 769, 5555, 751, 253, 0, 506, 142, 0, 0, 27, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2481, 25057, 'Biconne of Blue Sky', '', 'lienrik', 12.00, 50.00, 45, 'male', 'L2RaidBoss', 'Fighter', 40, 121183, 43.343, 611, 2.100, 60, 57, 73, 76, 70, 80, 2085510, 229987, 448, 714, 48, 348, 253, 0, 506, 0, 0, 0, 100, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2482, 25058, 'Biconnes Shooter', '', 'skeleton_archer', 11.00, 27.00, 44, 'male', 'L2Minion', 'Ranger', 1100, 12313, 41.347, 584, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 830, 346, 174, 338, 253, 0, 506, 279, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2483, 25059, 'Biconnes Warrior', '', 'skeleton_knight', 10.00, 25.00, 44, 'male', 'L2Minion', 'Fighter', 40, 9189, 41.347, 584, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 830, 346, 174, 338, 253, 0, 506, 150, 0, 0, 40, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2484, 25060, 'Unrequited Kael', '', 'succubus_100_bi', 20.00, 75.00, 24, 'female', 'L2RaidBoss', 'Mystic', 40, 41751, 17.961, 246, 1.500, 60, 57, 73, 76, 70, 80, 2584114, 74037, 77, 334, 5, 163, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.84, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2485, 25061, 'Kaels Bead', '', 'will_o_wisp', 13.00, 22.00, 23, 'male', 'L2Minion', 'Mystic', 40, 4323, 17.535, 232, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 188, 160, 31, 157, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.10, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2486, 25062, 'Kaels Escort', '', 'harpy', 10.00, 42.00, 23, 'female', 'L2Minion', 'Fighter', 40, 6453, 17.535, 232, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 281, 160, 71, 157, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2487, 25063, 'Chertuba of Great Soul', '', 'ketra_orc_warrior_100_bi', 24.00, 51.00, 35, 'male', 'L2RaidBoss', 'Fighter', 40, 138899, 66.986, 403, 1.800, 60, 57, 73, 76, 70, 80, 1912395, 144137, 405, 508, 64, 248, 253, 0, 506, 78, 0, 0, 36, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.54, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2488, 25064, 'Wizard of Storm Teruk', '', 'zenta_lizardman_shaman_50_bi', 19.00, 55.00, 40, 'male', 'L2RaidBoss', 'Priest', 40, 91937, 34.039, 479, 1.800, 60, 57, 73, 76, 70, 80, 2030965, 181264, 304, 606, 25, 295, 253, 0, 506, 90, 0, 0, 43, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.63, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2489, 25065, 'Teruks Escort', '', 'zenta_lizardman', 11.00, 32.00, 39, 'male', 'L2Minion', 'Fighter', 40, 13899, 32.412, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 1126, 293, 355, 285, 253, 0, 506, 123, 0, 0, 37, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2490, 25066, 'Teruks Knight', '', 'zenta_lizardman_warrior', 13.00, 35.00, 39, 'male', 'L2Minion', 'Fighter', 40, 6950, 32.412, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 563, 293, 88, 285, 253, 0, 506, 291, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2491, 25067, 'Captain of Red Flag Shaka', '', 'oel_mahum_warrior_50_bi', 30.00, 60.00, 52, 'male', 'L2RaidBoss', 'Fighter', 40, 233042, 79.987, 804, 2.400, 60, 57, 73, 76, 70, 80, 3849013, 503876, 1362, 887, 358, 433, 253, 0, 506, 71, 0, 0, 70, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.65, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2492, 25068, 'Shakas Shooter', '', 'ol_mahum_archer', 14.00, 25.00, 51, 'male', 'L2Minion', 'Ranger', 1100, 23916, 76.974, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2551, 430, 1320, 420, 253, 0, 506, 277, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.93, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2493, 25069, 'Shakas Follower', '', 'oel_mahum_champion', 23.00, 61.00, 51, 'male', 'L2Minion', 'Fighter', 40, 17848, 76.974, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2551, 430, 1320, 420, 253, 0, 506, 128, 633, 0, 67, 170, '', 300, 0, 20, 410, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2494, 25070, 'Enchanted Forest Watcher Ruell', '', 'ti_mi_tran', 23.00, 90.00, 55, 'male', 'L2RaidBoss', 'Fighter', 40, 189660, 64.171, 890, 2.400, 60, 57, 73, 76, 70, 80, 2477107, 327038, 878, 966, 135, 471, 253, 0, 506, 0, 0, 0, 12, 50, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.61, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2495, 25071, 'Ruells Wind', '', 'sylph', 11.00, 35.00, 54, 'female', 'L2Minion', 'Mystic', 40, 19605, 62.194, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2204, 469, 885, 458, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2496, 25072, 'Ruells Unicorn', '', 'unicorn', 14.00, 30.00, 54, 'male', 'L2Minion', 'Mystic', 40, 29261, 62.194, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 3306, 469, 1993, 458, 253, 0, 506, 0, 0, 0, 46, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2497, 25073, 'Bloody Priest Rudelto', '', 'karik_100_bi', 50.00, 180.00, 69, 'male', 'L2RaidBoss', 'Priest', 40, 368046, 116.469, 1314, 2.700, 60, 57, 73, 76, 70, 80, 4576841, 791290, 3301, 1379, 1095, 673, 253, 0, 506, 0, 0, 0, 37, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2498, 25074, 'Rudeltos Banshee', '', 'banshee', 9.00, 23.00, 68, 'female', 'L2Minion', 'Mystic', 40, 57995, 115.186, 1282, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 6349, 675, 4173, 658, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2499, 25075, 'Rudeltos Dre Vanul', '', 'dre_vanul', 14.00, 36.00, 68, 'male', 'L2Minion', 'Fighter', 40, 28998, 115.186, 1282, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 6349, 675, 4173, 658, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2500, 25076, 'Princess Molrang', '', 'poison_toad_100_bi', 40.00, 20.00, 25, 'male', 'L2RaidBoss', 'Fighter', 40, 43316, 18.439, 259, 1.500, 60, 57, 73, 76, 70, 80, 2541013, 79280, 84, 349, 6, 170, 253, 0, 506, 0, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.35, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2501, 25077, 'Captain Dogun', '', 'grizzly', 21.00, 40.00, 24, 'male', 'L2Minion', 'Fighter', 40, 6680, 17.961, 246, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 308, 167, 78, 163, 253, 0, 506, 0, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2502, 25078, 'Princess Guard', '', 'grizzly', 21.00, 40.00, 24, 'male', 'L2Minion', 'Fighter', 40, 3340, 17.961, 246, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 155, 167, 19, 163, 253, 0, 506, 0, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2503, 25079, 'Cats Eye Bandit', '', 'Ol_Mahum_Raid', 15.00, 25.00, 30, 'male', 'L2RaidBoss', 'Fighter', 40, 70742, 28.565, 329, 1.500, 60, 57, 73, 76, 70, 80, 1868579, 150667, 248, 422, 30, 206, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2504, 25080, 'Mercenary', '', 'orc_shaman', 9.00, 22.00, 29, 'male', 'L2Minion', 'Priest', 40, 10782, 27.487, 315, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 453, 204, 107, 198, 253, 0, 506, 179, 0, 0, 45, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2505, 25081, 'Cats Eye Bandit', '', 'ol_mahum', 13.50, 25.00, 29, 'male', 'L2Minion', 'Fighter', 40, 5391, 27.487, 315, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 453, 204, 107, 198, 253, 0, 506, 218, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2506, 25082, 'Leader of Cat Gang', '', 'cat_the_cat_50_bi', 13.50, 26.00, 39, 'male', 'L2RaidBoss', 'Fighter', 40, 86871, 32.412, 463, 1.800, 60, 57, 73, 76, 70, 80, 1988451, 173127, 282, 585, 22, 285, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.61, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2507, 25083, 'Cat Gang', '', 'cutie_cat', 8.00, 15.00, 38, 'female', 'L2Minion', 'Fighter', 40, 8800, 30.873, 448, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 692, 283, 146, 276, 253, 0, 506, 0, 0, 0, 48, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2508, 25084, 'Cat Gang', '', 'cat_the_cat', 9.00, 16.00, 38, 'male', 'L2Minion', 'Fighter', 40, 13134, 30.873, 448, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 1039, 283, 328, 276, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2509, 25085, 'Timak Orc Chief Ranger', '', 'ketra_orc_warrior_100_bi', 24.00, 51.00, 44, 'male', 'L2RaidBoss', 'Fighter', 40, 156185, 56.114, 584, 2.100, 60, 57, 73, 76, 70, 80, 3196387, 320242, 775, 692, 150, 338, 253, 0, 506, 157, 0, 0, 36, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.54, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2510, 25086, 'Timak Orc Ranger', '', 'ketra_orc_archer', 12.00, 27.00, 43, 'male', 'L2Minion', 'Ranger', 1100, 15819, 53.367, 557, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1439, 335, 545, 327, 253, 0, 506, 14, 0, 0, 45, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.91, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2511, 25087, 'Timak Orc Ranger', '', 'ketra_orc', 12.00, 29.00, 43, 'male', 'L2Minion', 'Fighter', 40, 11805, 53.367, 557, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1439, 335, 545, 327, 253, 0, 506, 68, 0, 0, 45, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2512, 25088, 'Crazy Mechanic Golem', '', 'mechanic_golem_200_bi', 15.00, 63.00, 43, 'male', 'L2RaidBoss', 'Mystic', 40, 295134, 133.418, 557, 2.100, 60, 57, 73, 76, 70, 80, 3128858, 311947, 1439, 669, 545, 327, 253, 0, 506, 0, 0, 0, 30, 150, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.72, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2513, 25089, 'Soulless Wild Boar', '', 'giant_wild_hog', 35.00, 27.00, 59, 'male', 'L2RaidBoss', 'Fighter', 40, 215208, 71.371, 1007, 2.400, 60, 57, 73, 76, 70, 80, 2684275, 381459, 1109, 1077, 182, 525, 253, 0, 506, 0, 0, 0, 35, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.54, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2514, 25090, 'Soulless Wolf', '', 'dire_wolf', 13.00, 11.00, 58, 'male', 'L2Minion', 'Fighter', 40, 22416, 69.691, 977, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2794, 525, 1202, 512, 253, 0, 506, 0, 0, 0, 24, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2515, 25091, 'Soulless Bear', '', 'crimson_bear', 19.00, 36.00, 58, 'male', 'L2Minion', 'Fighter', 40, 33456, 69.691, 977, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 4192, 525, 2705, 512, 253, 0, 506, 0, 0, 0, 37, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2516, 25092, 'Korim', '', 'heltor_silenos_shaman_50_bi', 19.50, 51.00, 70, 'male', 'L2RaidBoss', 'Priest', 40, 373386, 117.684, 1346, 2.700, 60, 57, 73, 76, 70, 80, 4596480, 802604, 3426, 1412, 1140, 688, 253, 0, 506, 201, 0, 0, 29, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.22, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2517, 25093, 'Korim Chief Guard Kaywon', '', 'heltor_silenos_warrior', 13.00, 31.00, 69, 'male', 'L2Minion', 'Fighter', 40, 58887, 116.469, 1314, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 13204, 690, 17529, 673, 253, 0, 506, 162, 0, 0, 36, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2518, 25094, 'Korim Guards', '', 'heltor_silenos', 13.00, 29.00, 69, 'male', 'L2Minion', 'Fighter', 40, 29444, 116.469, 1314, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 6603, 690, 4383, 673, 253, 0, 506, 86, 0, 0, 34, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2519, 25095, 'Elf Renoa', '', 'elf_ghost', 7.00, 21.00, 29, 'male', 'L2RaidBoss', 'Mystic', 40, 51236, 20.929, 315, 1.500, 60, 57, 73, 76, 70, 80, 2345716, 104160, 122, 407, 8, 198, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.41, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2520, 25096, 'Renoas Elpy', '', 'elpy', 5.00, 4.50, 28, 'male', 'L2Minion', 'Fighter', 40, 5251, 20.213, 301, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 296, 195, 50, 191, 253, 0, 506, 0, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2521, 25097, 'Renoas Hog', '', 'giant_wild_hog', 35.00, 27.00, 28, 'male', 'L2Minion', 'Fighter', 40, 7837, 20.213, 301, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 443, 195, 113, 191, 253, 0, 506, 0, 0, 0, 35, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2522, 25098, 'Sejarrs Servitor', '', 'dark_fencer_200_bi', 30.00, 43.00, 35, 'male', 'L2RaidBoss', 'Fighter', 40, 138899, 66.986, 403, 1.800, 60, 57, 73, 76, 70, 80, 1912395, 144137, 405, 508, 64, 248, 253, 0, 506, 0, 0, 0, 25, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.20, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2523, 25099, 'Rotten Tree Repiro', '', 'hanged_man_ripper', 35.00, 80.00, 44, 'male', 'L2RaidBoss', 'Fighter', 40, 114864, 41.347, 584, 2.100, 60, 57, 73, 76, 70, 80, 2030767, 217826, 415, 692, 44, 338, 253, 0, 506, 0, 0, 0, 55, 55, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.48, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2524, 25100, 'Spirit of Sea of Spores', '', 'pixy', 5.00, 25.00, 43, 'female', 'L2Minion', 'Fighter', 40, 17402, 39.411, 557, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 770, 335, 157, 327, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2525, 25101, 'Fighter of Sea of Spores', '', 'troll', 21.00, 35.00, 43, 'male', 'L2Minion', 'Fighter', 40, 8701, 39.411, 557, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 770, 335, 157, 327, 253, 0, 506, 0, 0, 0, 55, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2526, 25102, 'Shacram', '', 'minotaur_100_bi', 42.00, 94.00, 45, 'male', 'L2RaidBoss', 'Fighter', 40, 242366, 108.356, 611, 2.100, 60, 57, 73, 76, 70, 80, 2085510, 229987, 894, 714, 192, 348, 253, 0, 506, 300, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.59, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2527, 25103, 'Sorcerer Isirr', '', 'zenta_lizardman_matriarch_50_bi', 30.00, 63.00, 55, 'male', 'L2RaidBoss', 'Mystic', 40, 189660, 64.171, 890, 2.400, 60, 57, 73, 76, 70, 80, 2477107, 327038, 878, 966, 135, 471, 253, 0, 506, 195, 0, 0, 53, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.46, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2528, 25104, 'Isirrs Guard', '', 'zenta_lizardman_warrior', 13.00, 35.00, 54, 'male', 'L2Minion', 'Fighter', 40, 29261, 62.194, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 3306, 469, 1993, 458, 253, 0, 506, 95, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2529, 25105, 'Isirrs Guards', '', 'zenta_lizardman', 11.00, 32.00, 54, 'male', 'L2Minion', 'Fighter', 40, 14630, 62.194, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 1653, 469, 498, 458, 253, 0, 506, 131, 0, 0, 37, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2530, 25106, 'Ghost of the Well Lidia', '', 'bloody_queen_100_bi', 28.00, 85.00, 60, 'female', 'L2RaidBoss', 'Mystic', 40, 221100, 72.964, 1037, 2.400, 60, 57, 73, 76, 70, 80, 2735033, 394692, 1170, 1107, 200, 539, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2531, 25107, 'Lidias Archer', '', 'skeleton_archer', 11.00, 27.00, 59, 'male', 'L2Minion', 'Ranger', 1100, 23070, 71.371, 1007, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2217, 539, 727, 525, 253, 0, 506, 279, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2532, 25108, 'Lidias Fighter', '', 'death_blader', 15.00, 45.00, 59, 'male', 'L2Minion', 'Fighter', 40, 17217, 71.371, 1007, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2217, 539, 727, 525, 253, 0, 506, 1472, 0, 0, 100, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2533, 25109, 'Antharas Priest Cloe', '', 'succubus_100_bi', 20.00, 75.00, 74, 'female', 'L2RaidBoss', 'Priest', 40, 392896, 122.143, 1475, 3.000, 60, 57, 73, 76, 70, 80, 5199407, 852059, 3907, 1539, 1389, 751, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.84, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2534, 25110, 'Cloes Servitor', '', 'silhouette', 8.00, 23.00, 73, 'female', 'L2Minion', 'Fighter', 40, 41620, 121.064, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 10109, 753, 9613, 735, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2535, 25111, 'Cloes Servitor', '', 'shadow', 10.00, 30.00, 73, 'male', 'L2Minion', 'Mystic', 40, 62119, 121.064, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15163, 753, 21632, 735, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2536, 25112, 'Agent of Beres, Meana', '', 'medusa_100_bi', 20.00, 53.00, 30, 'female', 'L2RaidBoss', 'Fighter', 40, 53690, 21.714, 329, 1.500, 60, 57, 73, 76, 70, 80, 2308288, 111484, 132, 422, 8, 206, 253, 0, 506, 0, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.52, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2537, 25113, 'Meanas Maid', '', 'succubus', 10.00, 36.00, 29, 'female', 'L2Minion', 'Mystic', 40, 5492, 20.929, 315, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 323, 204, 55, 198, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2538, 25114, 'Meanas Guard Doll', '', 'crimson_doll', 15.00, 38.00, 29, 'male', 'L2Minion', 'Fighter', 40, 8198, 20.929, 315, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 485, 204, 124, 198, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.67, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2539, 25115, 'Icarus Sample 1', '', 'mana_vampire_200_bi', 42.00, 45.00, 40, 'male', 'L2RaidBoss', 'Mystic', 40, 123885, 45.769, 479, 1.800, 60, 57, 73, 76, 70, 80, 2741414, 271385, 570, 606, 84, 295, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2540, 25116, 'Icarus Sample 2', '', 'skeleton_archer', 11.00, 27.00, 39, 'male', 'L2Minion', 'Ranger', 1100, 12519, 43.477, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 1053, 293, 307, 285, 253, 0, 506, 273, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2541, 25117, 'Icarus Sample 3', '', 'magical_weaver', 11.00, 20.00, 39, 'male', 'L2Minion', 'Mystic', 40, 9342, 43.477, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 1053, 293, 307, 285, 253, 0, 506, 0, 0, 0, 90, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2542, 25118, 'Guilotine, Warden of the Execution Grounds', '', 'skeleton_pikeman_100_bi', 20.00, 58.00, 35, 'male', 'L2RaidBoss', 'Fighter', 40, 138899, 66.986, 403, 1.800, 60, 57, 73, 76, 70, 80, 1912395, 144137, 405, 508, 64, 248, 253, 0, 506, 96, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.21, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2543, 25119, 'Messenger of Fairy Queen Berun', '', 'pan_100_bi', 42.00, 73.00, 50, 'male', 'L2RaidBoss', 'Fighter', 40, 213145, 73.934, 748, 2.100, 60, 57, 73, 76, 70, 80, 3551193, 422350, 1193, 835, 272, 407, 253, 0, 506, 213, 0, 0, 45, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.58, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2544, 25120, 'Beruns Officer', '', 'pan', 14.00, 35.00, 49, 'male', 'L2Minion', 'Fighter', 40, 21788, 70.884, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 2968, 404, 1766, 395, 253, 0, 506, 90, 0, 0, 45, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2545, 25121, 'Beruns Prattler', '', 'pixy', 5.00, 25.00, 49, 'female', 'L2Minion', 'Fighter', 40, 32519, 70.884, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 4453, 404, 3976, 395, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2546, 25122, 'Refugee Hopeful Leo', '', 'oel_mahum_witch_doctor_50_bi', 22.50, 54.00, 56, 'male', 'L2RaidBoss', 'Fighter', 40, 196307, 66.085, 919, 2.400, 60, 57, 73, 76, 70, 80, 2529799, 340561, 934, 993, 145, 484, 253, 0, 506, 201, 0, 0, 70, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.26, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2547, 25123, 'Leos Servant', '', 'lesser_giant', 21.00, 44.00, 55, 'male', 'L2Minion', 'Fighter', 40, 30346, 64.171, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 3516, 482, 2154, 471, 253, 0, 506, 3937, 0, 0, 15, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2548, 25124, 'Leos Steward', '', 'lesser_giant_mage', 21.00, 44.00, 55, 'male', 'L2Minion', 'Mystic', 40, 15173, 64.171, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 1758, 482, 539, 471, 253, 0, 506, 3938, 0, 0, 15, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2549, 25125, 'Fierce Tiger King Angel', '', 'saber_toothed_tiger_200_bi', 72.00, 87.00, 65, 'male', 'L2RaidBoss', 'Fighter', 40, 688201, 277.058, 1189, 2.700, 60, 57, 73, 76, 70, 80, 4489693, 746626, 5592, 1257, 3735, 613, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2550, 25126, 'Longhorn Golkonda', '', 'minotaur_100_bi', 42.00, 94.00, 79, 'male', 'L2RaidBoss', 'Golkonda', 40, 829807, 319.229, 1641, 3.000, 60, 57, 73, 76, 70, 80, 5390003, 1205333, 8849, 1698, 6367, 828, 253, 0, 506, 91, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.59, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2551, 25127, 'Langk Matriarch Rashkos', '', 'virud_lizardman_matriarch_50_bi', 19.00, 57.00, 24, 'male', 'L2RaidBoss', 'Fighter', 40, 83502, 44.902, 246, 1.500, 60, 57, 73, 76, 70, 80, 2584114, 74037, 155, 334, 19, 163, 253, 0, 506, 124, 0, 0, 56, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.65, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2552, 25128, 'Vuku Grand Seer Gharmash', '', 'batur_orc_shaman_100_bi', 22.00, 35.00, 33, 'male', 'L2RaidBoss', 'Priest', 40, 62398, 24.517, 373, 1.800, 60, 57, 73, 76, 70, 80, 1932560, 127255, 172, 473, 13, 231, 253, 0, 506, 195, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.30, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2553, 25129, 'Vuku Shaman', '', 'orc_shaman', 9.00, 22.00, 32, 'male', 'L2Minion', 'Priest', 40, 6352, 23.504, 358, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 420, 227, 90, 223, 253, 0, 506, 7, 0, 0, 45, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2554, 25130, 'Gharmashs Pet Trimden', '', 'poison_spider', 27.00, 25.50, 32, 'male', 'L2Minion', 'Mystic', 40, 9481, 23.504, 358, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 629, 227, 202, 223, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2555, 25131, 'Carnage Lord Gato', '', 'oel_mahum_50_bi', 30.00, 57.00, 50, 'male', 'L2RaidBoss', 'Fighter', 40, 155046, 53.855, 748, 2.100, 60, 57, 73, 76, 70, 80, 2389767, 281312, 637, 835, 79, 407, 253, 0, 506, 71, 0, 0, 70, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.48, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2556, 25132, 'Gatos Marksman', '', 'ol_mahum_archer', 14.00, 25.00, 49, 'male', 'L2Minion', 'Ranger', 1100, 15874, 51.719, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1191, 404, 287, 395, 253, 0, 506, 273, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.93, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2557, 25133, 'Gatos Troop Leader', '', 'ol_mahum_champion', 14.00, 27.00, 49, 'male', 'L2Minion', 'Fighter', 40, 11846, 51.719, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1191, 404, 287, 395, 253, 0, 506, 69, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2558, 25134, 'Leto Chief Talkin', '', 'Zenta_Lizardman_Raid', 37.50, 30.00, 40, 'female', 'L2RaidBoss', 'Fighter', 40, 91937, 34.039, 479, 1.800, 60, 57, 73, 76, 70, 80, 2030965, 181264, 304, 606, 25, 295, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2559, 25135, 'Talkins Seer', '', 'virud_lizardman_shaman', 10.00, 29.00, 39, 'male', 'L2Minion', 'Priest', 40, 13899, 32.412, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 563, 293, 88, 285, 253, 0, 506, 7, 0, 0, 43, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2560, 25136, 'Talkins Bodyguard', '', 'zenta_lizardman_warrior', 13.00, 35.00, 39, 'male', 'L2Minion', 'Fighter', 40, 6950, 32.412, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 563, 293, 88, 285, 253, 0, 506, 16, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2561, 25137, 'Beleths Seer Sephia', '', 'bloody_queen_100_bi', 28.00, 85.00, 55, 'female', 'L2RaidBoss', 'Mystic', 40, 189660, 64.171, 890, 2.400, 60, 57, 73, 76, 70, 80, 2477107, 327038, 878, 966, 135, 471, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2562, 25138, 'Soul Drinker', '', 'mana_vampire', 11.00, 20.00, 54, 'male', 'L2Minion', 'Mystic', 40, 19605, 62.194, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2204, 469, 885, 458, 253, 0, 506, 0, 0, 0, 90, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2563, 25139, 'Sephias Salve', '', 'kaim_vanul', 24.00, 40.00, 54, 'male', 'L2Minion', 'Fighter', 40, 29261, 62.194, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 3306, 469, 1993, 458, 253, 0, 506, 0, 0, 0, 37, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2564, 25140, 'Hekaton Prime', '', 'susceptor', 20.00, 35.00, 65, 'male', 'L2RaidBoss', 'Fighter', 40, 344101, 110.823, 1189, 2.700, 60, 57, 73, 76, 70, 80, 4489693, 746626, 2797, 1257, 933, 613, 253, 0, 506, 0, 0, 0, 27, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.43, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2565, 25141, 'Hekaton Cottus', '', 'gamlin', 11.00, 32.00, 64, 'male', 'L2Minion', 'Fighter', 40, 53979, 109.162, 1158, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 10684, 614, 14390, 598, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2566, 25142, 'Hekaton Chires', '', 'lesser_giant', 21.00, 44.00, 64, 'male', 'L2Minion', 'Fighter', 40, 26989, 109.162, 1158, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 5341, 614, 3597, 598, 253, 0, 506, 3937, 0, 0, 15, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2567, 25143, 'Fire of Wrath Shuriel', '', 'angel', 13.50, 36.50, 78, 'male', 'L2RaidBoss', 'Fighter', 40, 410601, 126.536, 1607, 3.000, 60, 57, 73, 76, 70, 80, 5346496, 1193017, 4330, 1667, 1553, 813, 253, 0, 506, 2500, 0, 0, 30, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.52, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2568, 25144, 'Shuriels Oracle', '', 'oel_mahum_witch_doctor', 15.00, 34.00, 78, 'male', 'L2Minion', 'Fighter', 40, 65696, 126.536, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 8659, 833, 6209, 813, 253, 0, 506, 201, 0, 0, 70, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2569, 25145, 'Shuriels Paladin', '', 'kel_mahum_champion', 13.00, 32.00, 78, 'male', 'L2Minion', 'Fighter', 40, 32848, 126.536, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 8659, 833, 6209, 813, 253, 0, 506, 147, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2570, 25146, 'Serpent Demon Bifrons', '', 'serpent_slave_50_bi', 25.00, 72.00, 21, 'male', 'L2RaidBoss', 'Fighter', 40, 37886, 16.827, 205, 1.500, 60, 57, 73, 76, 70, 80, 2646358, 60367, 58, 296, 3, 144, 253, 0, 506, 73, 0, 0, 70, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2571, 25147, 'Assassin of Bifrons', '', 'virud_lizardman_scout', 10.00, 22.00, 20, 'male', 'L2Minion', 'Ranger', 1100, 3950, 16.540, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 107, 142, 11, 138, 253, 0, 506, 2507, 0, 0, 43, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2572, 25148, 'Butcher of Bifrons', '', 'virud_lizardman_warrior', 12.00, 30.00, 20, 'male', 'L2Minion', 'Fighter', 40, 2948, 16.540, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 107, 142, 11, 138, 253, 0, 506, 16, 0, 0, 52, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2573, 25149, 'Zombie Lord Crowl', '', 'zombie_100_bi', 30.00, 21.25, 25, 'male', 'L2RaidBoss', 'Fighter', 40, 43316, 18.439, 259, 1.500, 60, 57, 73, 76, 70, 80, 2541013, 79280, 84, 349, 6, 170, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2574, 25150, 'Evil Spirit Archer', '', 'skeleton_archer', 11.00, 27.00, 24, 'male', 'L2Minion', 'Ranger', 1100, 4476, 17.961, 246, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 155, 167, 19, 163, 253, 0, 506, 14, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2575, 25151, 'Evil Spirit Warrior', '', 'skeleton', 11.00, 25.00, 24, 'male', 'L2Minion', 'Fighter', 40, 3340, 17.961, 246, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 155, 167, 19, 163, 253, 0, 506, 946, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2576, 25152, 'Flame Lord Shadar', '', 'dre_vanul_100_bi', 28.00, 75.00, 35, 'male', 'L2RaidBoss', 'Fighter', 40, 69450, 26.794, 403, 1.800, 60, 57, 73, 76, 70, 80, 1912395, 144137, 203, 508, 16, 248, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.35, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2577, 25153, 'Claws of Shadar', '', 'imp', 10.00, 24.00, 34, 'male', 'L2Minion', 'Fighter', 40, 10527, 25.613, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 747, 245, 237, 240, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2578, 25154, 'Whip of Shadar', '', 'succubus', 10.00, 36.00, 34, 'female', 'L2Minion', 'Mystic', 40, 5263, 25.613, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 373, 245, 59, 240, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2579, 25155, 'Shaman King Selu', '', 'batur_orc_overlord_100_bi', 24.00, 52.00, 40, 'male', 'L2RaidBoss', 'Fighter', 40, 123885, 45.769, 479, 1.800, 60, 57, 73, 76, 70, 80, 2741414, 271385, 570, 606, 84, 295, 253, 0, 506, 79, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.28, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2580, 25156, 'Fanatic Shaman', '', 'batur_orc_shaman', 11.00, 16.00, 39, 'male', 'L2Minion', 'Priest', 40, 12519, 43.477, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 1404, 293, 545, 285, 253, 0, 506, 123, 19, 0, 50, 170, '', 300, 0, 20, 305, 7, 30, 4, 5, 0, -18, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2581, 25157, 'Fanatic Soldier', '', 'batur_orc_warrior', 10.00, 20.00, 39, 'male', 'L2Minion', 'Fighter', 40, 18685, 43.477, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 2106, 293, 1229, 285, 253, 0, 506, 7, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2582, 25158, 'King Tarlk', '', 'king_bugbear_200_bi', 45.00, 126.00, 48, 'male', 'L2RaidBoss', 'Fighter', 40, 386887, 169.609, 692, 2.100, 60, 57, 73, 76, 70, 80, 3443212, 354989, 2077, 785, 908, 384, 253, 0, 506, 160, 0, 0, 55, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.28, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2583, 25159, 'Paniel the Unicorn', '', 'unicorn', 14.00, 30.00, 54, 'male', 'L2RaidBoss', 'Fighter', 40, 182881, 62.194, 861, 2.400, 60, 57, 73, 76, 70, 80, 2422283, 313577, 827, 940, 124, 458, 253, 0, 506, 0, 0, 0, 46, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.74, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2584, 25160, 'Rapini the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 53, 'male', 'L2Minion', 'Mystic', 40, 28160, 60.163, 832, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 1552, 456, 457, 444, 253, 0, 506, 0, 0, 0, 27, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2585, 25161, 'Ririf the Unicorn', '', 'unicorn_mirage', 13.00, 17.00, 53, 'male', 'L2Minion', 'Mystic', 40, 14080, 60.163, 832, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 1552, 456, 457, 444, 253, 0, 506, 0, 0, 0, 27, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.69, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2586, 25162, 'Giant Marpanak', '', 'lesser_giant_100_bi', 42.00, 91.00, 60, 'male', 'L2RaidBoss', 'Fighter', 40, 614249, 253.244, 1037, 2.400, 60, 57, 73, 76, 70, 80, 4154684, 587467, 4376, 1107, 2759, 539, 253, 0, 506, 3937, 0, 0, 15, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.58, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2587, 25163, 'Roaring Skylancer', '', 'Drake_Raid', 44.00, 51.50, 70, 'male', 'L2RaidBoss', 'Fighter', 40, 746772, 294.211, 1346, 2.700, 60, 57, 73, 76, 70, 80, 4596480, 802604, 6853, 1412, 4563, 688, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2588, 25166, 'Ikuntai', '', 'skeleton_knight_50_bi', 15.00, 39.00, 25, 'male', 'L2RaidBoss', 'Fighter', 40, 56644, 24.086, 259, 1.500, 60, 57, 73, 76, 70, 80, 1589296, 122871, 157, 349, 18, 170, 253, 0, 506, 150, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.17, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2589, 25167, 'Ikuntais Servitor', '', 'silhouette', 8.00, 23.00, 24, 'female', 'L2Minion', 'Priest', 40, 8726, 23.437, 246, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 287, 167, 67, 163, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2590, 25168, 'Pawn of Ikuntai', '', 'skeleton_pikeman', 10.00, 28.00, 24, 'male', 'L2Minion', 'Fighter', 40, 4363, 23.437, 246, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 287, 167, 67, 163, 253, 0, 506, 299, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.21, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2591, 25169, 'Ragraman', '', 'batur_orc_overlord_100_bi', 24.00, 52.00, 30, 'male', 'L2RaidBoss', 'Fighter', 40, 141484, 71.412, 329, 1.500, 60, 57, 73, 76, 70, 80, 1868579, 150667, 495, 422, 119, 206, 253, 0, 506, 72, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.28, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2592, 25170, 'Lizardmen Leader Hellion', '', 'zenta_lizardman_matriarch_50_bi', 30.00, 63.00, 38, 'male', 'L2RaidBoss', 'Fighter', 40, 82089, 30.873, 448, 1.800, 60, 57, 73, 76, 70, 80, 1957608, 163199, 260, 565, 20, 276, 253, 0, 506, 223, 0, 0, 53, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.46, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2593, 25171, 'Hellions Archers', '', 'zenta_lizardman_scout', 11.00, 30.00, 37, 'male', 'L2Minion', 'Ranger', 1100, 8318, 29.423, 433, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 479, 273, 76, 266, 253, 0, 506, 278, 0, 0, 37, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.93, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2594, 25172, 'Hellions Guards', '', 'zenta_lizardman_warrior', 13.00, 35.00, 37, 'male', 'L2Minion', 'Fighter', 40, 6207, 29.423, 433, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 479, 273, 76, 266, 253, 0, 506, 291, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2595, 25173, 'Tiger King Karuta', '', 'saber_toothed_tiger_200_bi', 72.00, 87.00, 45, 'male', 'L2RaidBoss', 'Fighter', 40, 121183, 43.343, 611, 2.100, 60, 57, 73, 76, 70, 80, 2085510, 229987, 448, 714, 48, 348, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2596, 25174, 'Karutas Follower', '', 'heltor_silenos_chieftain', 13.00, 31.50, 44, 'male', 'L2Minion', 'Fighter', 40, 18378, 41.347, 584, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 830, 346, 174, 338, 253, 0, 506, 127, 0, 0, 27, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2597, 25175, 'Karutas Inferiors', '', 'crimson_bear', 19.00, 36.00, 44, 'male', 'L2Minion', 'Fighter', 40, 9189, 41.347, 584, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 830, 346, 174, 338, 253, 0, 506, 0, 0, 0, 37, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2598, 25176, 'Black Lily', '', 'Succubus_Raid', 12.00, 30.70, 55, 'female', 'L2RaidBoss', 'Mystic', 40, 189660, 64.171, 890, 2.400, 60, 57, 73, 76, 70, 80, 2477107, 327038, 878, 966, 135, 471, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2599, 25177, 'Guardian Knight of Black Lily', '', 'death_knight', 12.00, 31.00, 54, 'male', 'L2Minion', 'Fighter', 40, 29261, 62.194, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 3306, 469, 1993, 458, 253, 0, 506, 75, 0, 0, 27, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2600, 25178, 'Servitor of Black Lily', '', 'silhouette', 8.00, 23.00, 54, 'female', 'L2Minion', 'Fighter', 40, 14630, 62.194, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 1653, 469, 498, 458, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2601, 25179, 'Guardian of the Statue of Giant Karum', '', 'lesser_giant_50_bi', 30.00, 66.00, 60, 'male', 'L2RaidBoss', 'Fighter', 1100, 221100, 72.964, 1037, 2.400, 60, 57, 73, 76, 70, 80, 2735033, 394692, 1170, 1107, 200, 539, 253, 0, 506, 4028, 0, 0, 80, 180, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.63, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2602, 25180, 'Karums Guard', '', 'lesser_giant_mage', 21.00, 44.00, 59, 'male', 'L2Minion', 'Mystic', 40, 23070, 71.371, 1007, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2956, 539, 1291, 525, 253, 0, 506, 3938, 0, 0, 15, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2603, 25181, 'Karums Warrior', '', 'susceptor', 20.00, 35.00, 59, 'male', 'L2Minion', 'Fighter', 40, 34433, 71.371, 1007, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 4433, 539, 2904, 525, 253, 0, 506, 0, 0, 0, 27, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2604, 25182, 'Demon Kurikups', '', 'karik_100_bi', 50.00, 180.00, 59, 'male', 'L2RaidBoss', 'Fighter', 40, 215208, 71.371, 1007, 2.400, 60, 57, 73, 76, 70, 80, 2684275, 381459, 1109, 1077, 182, 525, 253, 0, 506, 0, 0, 0, 37, 200, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2605, 25183, 'Kurikups Wife', '', 'bloody_queen', 14.00, 40.00, 58, 'female', 'L2Minion', 'Mystic', 40, 33456, 69.691, 977, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2096, 525, 676, 512, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2606, 25184, 'Devil Blader of Chaos', '', 'death_blader', 15.00, 45.00, 58, 'male', 'L2Minion', 'Fighter', 40, 16728, 69.691, 977, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2096, 525, 676, 512, 253, 0, 506, 1472, 0, 0, 100, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2607, 25185, 'Tasaba Patriarch Hellena', '', 'zenta_lizardman_matriarch', 20.00, 40.00, 35, 'male', 'L2RaidBoss', 'Fighter', 40, 69450, 26.794, 403, 1.800, 60, 57, 73, 76, 70, 80, 1912395, 144137, 203, 508, 16, 248, 253, 0, 506, 225, 0, 0, 53, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.46, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2608, 25186, 'Hellenas Marksman', '', 'zenta_lizardman_scout', 11.00, 30.00, 34, 'male', 'L2Minion', 'Ranger', 1100, 7053, 25.613, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 373, 245, 59, 240, 253, 0, 506, 272, 0, 0, 37, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.93, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2609, 25187, 'Helenas Soldier', '', 'zenta_lizardman_warrior', 13.00, 35.00, 34, 'male', 'L2Minion', 'Fighter', 40, 5263, 25.613, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 373, 245, 59, 240, 253, 0, 506, 16, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2610, 25188, 'Apepi', '', 'lienrik', 12.00, 50.00, 30, 'male', 'L2RaidBoss', 'Fighter', 40, 107380, 54.285, 329, 1.500, 60, 57, 73, 76, 70, 80, 2308288, 111484, 264, 422, 35, 206, 253, 0, 506, 0, 0, 0, 100, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2611, 25189, 'Cronoss Servitor Mumu', '', 'cutie_cat', 8.00, 15.00, 34, 'female', 'L2RaidBoss', 'Fighter', 40, 65792, 25.613, 388, 1.800, 60, 57, 73, 76, 70, 80, 1918617, 135504, 187, 491, 15, 240, 253, 0, 506, 0, 0, 0, 48, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.34, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2612, 25190, 'Mumus Wizard', '', 'cutie_cat', 8.00, 15.00, 33, 'female', 'L2Minion', 'Mystic', 40, 6689, 24.517, 373, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 458, 237, 98, 231, 253, 0, 506, 0, 0, 0, 48, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2613, 25191, 'Mumus Warrior', '', 'cat_the_cat', 9.00, 16.00, 33, 'male', 'L2Minion', 'Fighter', 40, 9984, 24.517, 373, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 686, 237, 218, 231, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2614, 25192, 'Earth Protector Panathen', '', 'farhite', 16.00, 31.00, 43, 'male', 'L2RaidBoss', 'Fighter', 40, 108760, 39.411, 557, 2.100, 60, 57, 73, 76, 70, 80, 1976893, 206038, 385, 669, 40, 327, 253, 0, 506, 183, 0, 0, 15, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.74, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2615, 25193, 'Panathens Knight', '', 'nos', 26.00, 42.00, 42, 'male', 'L2Minion', 'Fighter', 40, 16463, 37.544, 531, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1425, 324, 567, 316, 253, 0, 506, 5130, 0, 0, 18, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.78, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2616, 25194, 'Panathens Protectors', '', 'dailaon', 20.00, 28.00, 42, 'male', 'L2Minion', 'Ranger', 1100, 8231, 37.544, 531, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 713, 324, 141, 316, 253, 0, 506, 5127, 0, 0, 18, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.91, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2617, 25198, 'Fafurions Herald Lokness', '', 'devastator_200_bi', 55.00, 80.50, 70, 'female', 'L2RaidBoss', 'Fighter', 40, 746772, 294.211, 1346, 2.700, 60, 57, 73, 76, 70, 80, 4596480, 802604, 6853, 1412, 4563, 688, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2618, 25199, 'Water Dragon Seer Sheshark', '', 'kaim_vanul', 10.00, 29.00, 72, 'male', 'L2RaidBoss', 'Fighter', 40, 383460, 119.969, 1410, 3.000, 60, 57, 73, 76, 70, 80, 5140647, 827123, 3672, 1475, 1311, 720, 253, 0, 506, 181, 0, 0, 43, 200, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.48, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2619, 25200, 'Family of Sheshark', '', 'hunter_gargoyle', 12.00, 50.00, 71, 'male', 'L2Minion', 'Fighter', 40, 40577, 118.847, 1378, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9467, 722, 9050, 704, 253, 0, 506, 0, 0, 0, 100, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2620, 25201, 'Guard of Sheshark', '', 'serpent_slave', 12.00, 30.00, 71, 'male', 'L2Minion', 'Fighter', 40, 60562, 118.847, 1378, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 14200, 722, 20363, 704, 253, 0, 506, 6370, 0, 0, 52, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2621, 25202, 'Krokian Padisha Sobekk', '', 'ant_soldier_200_bi', 52.00, 86.00, 74, 'male', 'L2RaidBoss', 'Fighter', 40, 392896, 122.143, 1475, 3.000, 60, 57, 73, 76, 70, 80, 5199407, 852059, 3907, 1539, 1389, 751, 253, 0, 506, 5130, 0, 0, 18, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.78, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2622, 25203, 'Parhit Padisha Sobekk', '', 'aracne', 32.00, 65.00, 73, 'male', 'L2Minion', 'Fighter', 40, 62119, 121.064, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 7582, 753, 5408, 735, 253, 0, 506, 5131, 0, 0, 15, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2623, 25204, 'Krokian Padisha Sobekk', '', 'vampire_bat', 36.00, 61.00, 73, 'male', 'L2Minion', 'Mystic', 40, 31060, 121.064, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 7582, 753, 5408, 735, 253, 0, 506, 5128, 0, 0, 18, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.78, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2624, 25205, 'Ocean Flame Ashakiel', '', 'saber_toothed_tiger_200_bi', 22.00, 120.00, 76, 'male', 'L2RaidBoss', 'Fighter', 40, 401887, 124.303, 1541, 3.000, 60, 57, 73, 76, 70, 80, 5267108, 1171763, 4128, 1602, 1465, 782, 253, 0, 506, 98, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.76, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2625, 25206, 'Ashakiels Blade', '', 'dark_fencer_200_bi', 8.00, 30.00, 75, 'female', 'L2Minion', 'Fighter', 40, 63590, 123.216, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 16080, 786, 22799, 766, 253, 0, 506, 6717, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2626, 25207, 'Ashakiels Rod', '', 'unicorn', 11.00, 38.50, 75, 'male', 'L2Minion', 'Mystic', 40, 31795, 123.216, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 8039, 786, 5701, 766, 253, 0, 506, 6718, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2627, 25208, 'Water Couatle Ateka', '', 'lienrik', 12.00, 50.00, 40, 'male', 'L2RaidBoss', 'Fighter', 40, 91937, 34.039, 479, 1.800, 60, 57, 73, 76, 70, 80, 2030965, 181264, 304, 606, 25, 295, 253, 0, 506, 0, 0, 0, 100, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2628, 25209, 'Atekas Shaman', '', 'lienrik', 12.00, 50.00, 39, 'male', 'L2Minion', 'Priest', 40, 9313, 32.412, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 751, 293, 157, 285, 253, 0, 506, 0, 0, 0, 100, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2629, 25210, 'Atekas Grunt', '', 'lienrik', 12.00, 50.00, 39, 'male', 'L2Minion', 'Fighter', 40, 13899, 32.412, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 1126, 293, 355, 285, 253, 0, 506, 0, 0, 0, 100, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2630, 25211, 'Sebek', '', 'nos', 26.00, 42.00, 36, 'male', 'L2RaidBoss', 'Fighter', 40, 73381, 28.064, 418, 1.800, 60, 57, 73, 76, 70, 80, 1916442, 153260, 220, 528, 18, 258, 253, 0, 506, 5130, 0, 0, 18, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.78, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2631, 25212, 'Sebeks Priest', '', 'zenta_lizardman_scout', 11.00, 30.00, 35, 'male', 'L2Minion', 'Ranger', 1100, 7445, 26.794, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 405, 254, 64, 248, 253, 0, 506, 279, 0, 0, 37, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.93, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2632, 25213, 'Sebeks Fanatic', '', 'dailaon', 20.00, 28.00, 35, 'male', 'L2Minion', 'Ranger', 1100, 5556, 26.794, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 405, 254, 64, 248, 253, 0, 506, 5127, 0, 0, 18, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.91, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2633, 25214, 'Fafurions Page Sika', '', 'water_giant', 13.00, 44.00, 40, 'male', 'L2RaidBoss', 'Fighter', 80, 91937, 34.039, 479, 1.800, 60, 57, 73, 76, 70, 80, 2030965, 181264, 304, 606, 25, 295, 253, 0, 506, 5132, 0, 0, 35, 170, '', 300, 0, 0, 0, 7, 30, 4, 0, 0, -18, 0.45, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2634, 25215, 'Sikas Wizard', '', 'undine', 12.00, 27.00, 39, 'female', 'L2Minion', 'Mystic', 40, 9313, 32.412, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 751, 293, 157, 285, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2635, 25216, 'Sikas Fighter', '', 'undine', 12.00, 27.00, 39, 'female', 'L2Minion', 'Mystic', 40, 13899, 32.412, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 1126, 293, 355, 285, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2636, 25217, 'Cursed Clara', '', 'medusa', 10.00, 25.00, 50, 'female', 'L2RaidBoss', 'Fighter', 40, 155046, 53.855, 748, 2.100, 60, 57, 73, 76, 70, 80, 2389767, 281312, 637, 835, 79, 407, 253, 0, 506, 0, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.52, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2637, 25218, 'Claras Marksman', '', 'virud_lizardman_scout', 10.00, 22.00, 49, 'male', 'L2Minion', 'Ranger', 1100, 15874, 51.719, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1191, 404, 287, 395, 253, 0, 506, 2507, 0, 0, 43, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2638, 25219, 'Claras Pawn', '', 'virud_lizardman_warrior', 12.00, 30.00, 49, 'male', 'L2Minion', 'Fighter', 40, 11846, 51.719, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1191, 404, 287, 395, 253, 0, 506, 94, 0, 0, 52, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.59, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2639, 25220, 'Death Lord Hallate', '', 'death_lord', 21.00, 40.00, 73, 'male', 'L2RaidBoss', 'Hallate', 40, 388245, 121.064, 1442, 3.000, 60, 57, 73, 76, 70, 80, 5168419, 839126, 3791, 1507, 1353, 735, 253, 0, 506, 78, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2640, 25221, 'Death Mage Krician', '', 'death_blader', 15.00, 45.00, 72, 'male', 'L2Minion', 'Fighter', 40, 41107, 119.969, 1410, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9790, 737, 9315, 720, 253, 0, 506, 1472, 0, 0, 100, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2641, 25222, 'Death Fighter Harik', '', 'death_knight', 12.00, 31.00, 72, 'male', 'L2Minion', 'Fighter', 40, 61354, 119.969, 1410, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 14686, 737, 20959, 720, 253, 0, 506, 75, 0, 0, 27, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2642, 25223, 'Soul Collector Acheron', '', 'vale_master_50_bi', 18.00, 63.00, 35, 'male', 'L2RaidBoss', 'Fighter', 40, 69450, 26.794, 403, 1.800, 60, 57, 73, 76, 70, 80, 1912395, 144137, 203, 508, 16, 248, 253, 0, 506, 192, 0, 0, 70, 160, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.74, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2643, 25224, 'Soul Slasher', '', 'dark_horror', 20.00, 35.00, 34, 'male', 'L2Minion', 'Fighter', 40, 7053, 25.613, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 498, 245, 106, 240, 253, 0, 506, 0, 0, 0, 100, 140, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2644, 25225, 'Soul Strainer', '', 'hungry_spirit', 30.00, 40.00, 34, 'male', 'L2Minion', 'Fighter', 40, 10527, 25.613, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 747, 245, 237, 240, 253, 0, 506, 0, 0, 0, 15, 155, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2645, 25226, 'Roaring Lord Kastor', '', 'oel_mahum_witch_doctor_50_bi', 22.50, 54.00, 62, 'male', 'L2RaidBoss', 'Fighter', 40, 322915, 105.482, 1097, 2.700, 60, 57, 73, 76, 70, 80, 4417539, 712205, 2425, 1166, 814, 569, 253, 0, 506, 186, 0, 0, 70, 180, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.26, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2646, 25227, 'Kastors Seer', '', 'oel_mahum_witch_doctor', 15.00, 34.00, 61, 'male', 'L2Minion', 'Fighter', 40, 50430, 103.454, 1067, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 4611, 569, 3125, 555, 253, 0, 506, 9, 0, 0, 70, 170, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2647, 25228, 'Kastors Prefect', '', 'oel_mahum_warrior', 20.00, 38.00, 61, 'male', 'L2Minion', 'Fighter', 40, 25215, 103.454, 1067, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 4611, 569, 3125, 555, 253, 0, 506, 79, 0, 0, 70, 190, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2648, 25229, 'Storm Winged Naga', '', 'wyrm_50_bi', 58.00, 108.00, 75, 'male', 'L2RaidBoss', 'Fighter', 40, 794875, 308.041, 1508, 3.000, 60, 57, 73, 76, 70, 80, 5231148, 864099, 8039, 1571, 5701, 766, 253, 0, 506, 0, 0, 0, 70, 200, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.19, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2649, 25230, 'Timak Seer Ragoth', '', 'batur_orc_shaman_50_bi', 15.00, 25.00, 57, 'male', 'L2RaidBoss', 'Priest', 40, 202794, 67.927, 948, 2.400, 60, 57, 73, 76, 70, 80, 2581681, 354156, 990, 1022, 156, 498, 253, 0, 506, 201, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.30, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2650, 25231, 'Ragoths Guard', '', 'batur_orc_warrior', 10.00, 20.00, 56, 'male', 'L2Minion', 'Fighter', 40, 31409, 66.085, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 3734, 497, 2324, 484, 253, 0, 506, 74, 657, 0, 80, 175, '', 0, 0, 20, 457, 7, 30, 4, 5, 0, -18, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2651, 25232, 'Ragoths Herald', '', 'batur_orc', 9.00, 21.50, 56, 'male', 'L2Minion', 'Fighter', 40, 15705, 66.085, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 1868, 497, 581, 484, 253, 0, 506, 74, 0, 0, 80, 165, '', 0, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2652, 25233, 'Spirit of Andras, the Betrayer', '', 'headless_knight_50_bi', 30.00, 46.50, 69, 'male', 'L2RaidBoss', 'Fighter', 40, 528013, 208.901, 1314, 2.700, 60, 57, 73, 76, 70, 80, 2969653, 474928, 3550, 1379, 1272, 673, 253, 0, 506, 2500, 0, 0, 70, 190, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.52, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2653, 25234, 'Ancient Weird Drake', '', 'drake_50_bi', 45.00, 150.00, 60, 'male', 'L2RaidBoss', 'Fighter', 40, 442200, 182.411, 1037, 2.400, 60, 57, 73, 76, 70, 80, 2735033, 394692, 2339, 1107, 796, 539, 253, 0, 506, 0, 0, 0, 70, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.84, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2654, 25235, 'Vanor Chief Kandra', '', 'heltor_silenos_50_bi', 19.00, 43.50, 72, 'male', 'L2RaidBoss', 'Fighter', 40, 383460, 119.969, 1410, 3.000, 60, 57, 73, 76, 70, 80, 5140647, 827123, 3672, 1475, 1311, 720, 253, 0, 506, 135, 0, 0, 34, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2655, 25236, 'Kandras Healer', '', 'heltor_silenos_shaman', 13.00, 32.00, 71, 'male', 'L2Minion', 'Priest', 40, 60562, 118.847, 1378, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 7101, 722, 5091, 704, 253, 0, 506, 200, 0, 0, 29, 170, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.22, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2656, 25237, 'Kandras Guard', '', 'heltor_silenos_warrior', 13.00, 31.00, 71, 'male', 'L2Minion', 'Fighter', 40, 30281, 118.847, 1378, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 7101, 722, 5091, 704, 253, 0, 506, 228, 0, 0, 36, 190, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2657, 25238, 'Abyss Brukunt', '', 'drake_50_bi', 45.00, 150.00, 59, 'male', 'L2RaidBoss', 'Fighter', 40, 215208, 71.371, 1007, 2.400, 60, 57, 73, 76, 70, 80, 2684275, 381459, 1109, 1077, 182, 525, 253, 0, 506, 0, 0, 0, 70, 185, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.84, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2658, 25239, 'Monstrous Beast of Abyss Brukunt', '', 'hunter_gargoyle', 25.00, 65.00, 58, 'male', 'L2Minion', 'Priest', 40, 33456, 69.691, 977, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2096, 525, 676, 512, 253, 0, 506, 0, 0, 0, 100, 180, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2659, 25240, 'Wild Beast of Abyss Brukunt', '', 'saber_toothed_tiger', 34.00, 28.00, 58, 'male', 'L2Minion', 'Fighter', 40, 16728, 69.691, 977, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2096, 525, 676, 512, 253, 0, 506, 0, 0, 0, 60, 190, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2660, 25241, 'Harit Hero Tamash', '', 'zenta_lizardman_warrior_50_bi', 18.00, 53.00, 55, 'male', 'L2RaidBoss', 'Fighter', 40, 262380, 88.695, 890, 2.400, 60, 57, 73, 76, 70, 80, 3983098, 535296, 1646, 966, 468, 471, 253, 0, 506, 298, 0, 0, 40, 175, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.56, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2661, 25242, 'Tamashs Advisor', '', 'zenta_lizardman_shaman', 13.00, 35.00, 54, 'male', 'L2Minion', 'Priest', 40, 27093, 85.864, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 4126, 469, 3075, 458, 253, 0, 506, 193, 0, 0, 43, 155, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2662, 25243, 'Tamashs Servant', '', 'zenta_lizardman', 11.00, 32.00, 54, 'male', 'L2Minion', 'Fighter', 40, 40437, 85.864, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 6189, 469, 6917, 458, 253, 0, 506, 234, 0, 0, 37, 170, '', 0, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2663, 25244, 'Last Lesser Giant Olkuth', '', 'lesser_giant_50_bi', 31.50, 69.00, 75, 'male', 'L2RaidBoss', 'Fighter', 40, 794875, 308.041, 1508, 3.000, 60, 57, 73, 76, 70, 80, 5231148, 864099, 8039, 1571, 5701, 766, 253, 0, 506, 78, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.58, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2664, 25245, 'Last Lesser Giant Glaki', '', 'lesser_giant_mage_50_bi', 30.00, 66.00, 78, 'male', 'L2RaidBoss', 'Mystic', 40, 410601, 126.536, 1607, 3.000, 60, 57, 73, 76, 70, 80, 5346496, 1193017, 4330, 1667, 1553, 813, 253, 0, 506, 179, 0, 0, 15, 95, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.56, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2665, 25246, 'Glakis Henchman', '', 'lesser_giant', 21.00, 44.00, 77, 'male', 'L2Minion', 'Fighter', 40, 65003, 125.408, 1574, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 16925, 817, 24314, 797, 253, 0, 506, 169, 0, 0, 15, 150, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2666, 25247, 'Glakis Servant', '', 'lesser_giant', 21.00, 44.00, 77, 'male', 'L2Minion', 'Fighter', 40, 32501, 125.408, 1574, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 8463, 817, 6079, 797, 253, 0, 506, 166, 0, 0, 15, 140, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2667, 25248, 'Doom Blade Tanatos', '', 'death_blader_bi', 15.00, 32.50, 72, 'male', 'L2RaidBoss', 'Fighter', 40, 766920, 299.923, 1410, 3.000, 60, 57, 73, 76, 70, 80, 5140647, 827123, 7343, 1475, 5241, 720, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2668, 25249, 'Palatanos of Horrific Power', '', 'Jungle_Bleeze', 60.00, 47.00, 75, 'female', 'L2RaidBoss', 'Fighter', 40, 397437, 123.216, 1508, 3.000, 60, 57, 73, 76, 70, 80, 5231148, 864099, 4020, 1571, 1425, 766, 253, 0, 506, 0, 0, 0, 60, 190, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2669, 25250, 'Man-Eating Plant of Palatanos', '', 'magical_weaver', 15.00, 26.00, 74, 'female', 'L2Minion', 'Mystic', 40, 42118, 122.143, 1475, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 10419, 769, 9875, 751, 253, 0, 506, 0, 0, 0, 80, 170, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.20, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2670, 25251, 'Sapling of Palatanos', '', 'skeleton_knight', 15.00, 26.00, 74, 'female', 'L2Minion', 'Fighter', 40, 62863, 122.143, 1475, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15628, 769, 22217, 751, 253, 0, 506, 0, 0, 0, 80, 170, '', 0, 0, 20, 629, 7, 30, 4, 5, 0, -18, 0.20, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2671, 25252, 'Palibati Queen Themis', '', 'cave_maiden_50_bi', 37.00, 98.00, 70, 'female', 'L2RaidBoss', 'Fighter', 40, 373386, 117.684, 1346, 2.700, 60, 57, 73, 76, 70, 80, 4596480, 802604, 3426, 1412, 1140, 688, 253, 0, 506, 234, 0, 0, 70, 160, '', 0, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.43, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2672, 25253, 'Handmaiden of Themis', '', 'succubus', 10.00, 36.00, 69, 'female', 'L2Minion', 'Mystic', 40, 39455, 116.469, 1314, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 8802, 690, 7789, 673, 253, 0, 506, 0, 0, 0, 60, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2673, 25254, 'Themiss Sentinel', '', 'death_blader', 15.00, 45.00, 69, 'male', 'L2Minion', 'Fighter', 40, 58887, 116.469, 1314, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 13204, 690, 17529, 673, 253, 0, 506, 1472, 0, 0, 100, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2674, 25255, 'Gargoyle Lord Tiphon', '', 'hunter_gargoyle_50_bi', 37.00, 98.00, 65, 'male', 'L2RaidBoss', 'Fighter', 40, 688201, 277.058, 1189, 2.700, 60, 57, 73, 76, 70, 80, 4489693, 746626, 5592, 1257, 3735, 613, 253, 0, 506, 0, 0, 0, 100, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.37, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2675, 25256, 'Taik High Prefect Arak', '', 'ketra_orc_warrior_50_bi', 18.00, 37.00, 60, 'male', 'L2RaidBoss', 'Fighter', 40, 221100, 72.964, 1037, 2.400, 60, 57, 73, 76, 70, 80, 2735033, 394692, 1170, 1107, 200, 539, 253, 0, 506, 71, 0, 0, 36, 175, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.54, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2676, 25257, 'Araks Archer', '', 'ketra_orc_archer', 12.00, 27.00, 59, 'male', 'L2Minion', 'Ranger', 1100, 23070, 71.371, 1007, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2217, 539, 727, 525, 253, 0, 506, 283, 0, 0, 45, 160, '', 0, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.91, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2677, 25258, 'Araks Footman', '', 'ketra_orc', 12.00, 29.00, 59, 'male', 'L2Minion', 'Fighter', 40, 17217, 71.371, 1007, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2217, 539, 727, 525, 253, 0, 506, 127, 0, 0, 45, 175, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2678, 25259, 'Zakens Butcher Krantz', '', 'ogre_50_bi', 30.00, 66.00, 55, 'male', 'L2RaidBoss', 'Fighter', 40, 524760, 221.738, 890, 2.400, 60, 57, 73, 76, 70, 80, 3983098, 535296, 3292, 966, 1869, 471, 253, 0, 506, 297, 0, 0, 22, 160, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.82, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2679, 25260, 'Iron Giant Totem', '', 'iron_golem_bi', 35.00, 46.38, 45, 'male', 'L2RaidBoss', 'Mystic', 40, 165120, 58.949, 611, 2.100, 60, 57, 73, 76, 70, 80, 3259016, 329439, 836, 714, 166, 348, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2680, 25261, 'Totem Guard Archer', '', 'batur_orc_archer', 11.00, 21.50, 44, 'male', 'L2Minion', 'Ranger', 1100, 16743, 56.114, 584, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1552, 346, 601, 338, 253, 0, 506, 282, 0, 0, 45, 170, '', 0, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.96, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2681, 25262, 'Totem Guard', '', 'batur_orc', 9.00, 21.50, 44, 'male', 'L2Minion', 'Fighter', 40, 12495, 56.114, 584, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1552, 346, 601, 338, 253, 0, 506, 215, 0, 0, 80, 170, '', 0, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2682, 25263, 'Kernons Faithful Servant Kelone', '', 'medusa_100_bi', 20.00, 53.00, 67, 'female', 'L2RaidBoss', 'Mystic', 40, 356634, 113.825, 1251, 2.700, 60, 57, 73, 76, 70, 80, 4534433, 767699, 3048, 1318, 1008, 643, 253, 0, 506, 0, 0, 0, 50, 165, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.52, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2683, 25264, 'Kelones Assassin', '', 'skeleton_royal_guard', 11.00, 28.50, 66, 'male', 'L2Minion', 'Fighter', 40, 37575, 112.374, 1220, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 7792, 643, 6887, 628, 253, 0, 506, 229, 0, 0, 80, 190, '', 0, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2684, 25265, 'Kelones Secret Knight', '', 'drake', 11.00, 28.50, 66, 'male', 'L2Minion', 'Mystic', 40, 56083, 112.374, 1220, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 11687, 643, 15497, 628, 253, 0, 506, 229, 0, 0, 80, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2685, 25266, 'Bloody Empress Decarbia', '', 'bloody_queen_50_bi', 14.00, 31.00, 75, 'female', 'L2RaidBoss', 'Mystic', 40, 397437, 123.216, 1508, 3.000, 60, 57, 73, 76, 70, 80, 5231148, 864099, 4020, 1571, 1425, 766, 253, 0, 506, 0, 0, 0, 20, 190, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.43, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2686, 25267, 'Decarbias Royal Guard', '', 'death_knight', 12.00, 31.00, 74, 'male', 'L2Minion', 'Fighter', 40, 31432, 122.143, 1475, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 7814, 769, 5555, 751, 253, 0, 506, 5286, 0, 0, 27, 200, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2687, 25268, 'Decarbias Escort', '', 'skeleton_royal_guard', 11.00, 28.50, 74, 'male', 'L2Minion', 'Fighter', 40, 62863, 122.143, 1475, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15628, 769, 22217, 751, 253, 0, 506, 234, 0, 0, 80, 210, '', 0, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2688, 25269, 'Beast Lord Behemoth', '', 'Elder_Troll', 46.00, 71.50, 70, 'male', 'L2RaidBoss', 'Fighter', 40, 373386, 117.684, 1346, 2.700, 60, 57, 73, 76, 70, 80, 4596480, 802604, 3426, 1412, 1140, 688, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2689, 25270, 'Behemoth Javeliner', '', 'virud_lizardman_scout', 10.00, 22.00, 69, 'male', 'L2Minion', 'Ranger', 1100, 39455, 116.469, 1314, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 6603, 690, 4383, 673, 253, 0, 506, 2507, 0, 0, 43, 170, '', 0, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2690, 25271, 'Behemoth Flare', '', 'will_o_wisp', 13.00, 22.00, 69, 'male', 'L2Minion', 'Mystic', 40, 29444, 116.469, 1314, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 6603, 690, 4383, 673, 253, 0, 506, 0, 0, 0, 80, 165, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.10, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2691, 25272, 'Partisan Leader Talakin', '', 'ol_mahum_champion_50_bi', 21.00, 43.50, 28, 'male', 'L2RaidBoss', 'Fighter', 40, 97968, 50.532, 301, 1.500, 60, 57, 73, 76, 70, 80, 2390045, 97281, 222, 392, 28, 191, 253, 0, 506, 77, 0, 0, 50, 190, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.63, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2692, 25273, 'Carnamakos', '', 'iron_golem_bi', 35.00, 46.38, 50, 'male', 'L2RaidBoss', 'Mystic', 40, 213145, 73.934, 748, 2.100, 60, 57, 73, 76, 70, 80, 3551193, 422350, 1193, 835, 272, 407, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.60, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2693, 25274, 'Carnabarun', '', 'magical_weaver', 11.00, 20.00, 49, 'male', 'L2Minion', 'Mystic', 40, 21788, 70.884, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 2968, 404, 1766, 395, 253, 0, 506, 0, 0, 0, 90, 170, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2694, 25275, 'Carnassiud', '', 'field_stalker', 15.00, 30.00, 49, 'male', 'L2Minion', 'Fighter', 40, 32519, 70.884, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 4453, 404, 3976, 395, 253, 0, 506, 0, 0, 0, 70, 170, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2695, 25276, 'Death Lord Ipos', '', 'death_lord_50_bi', 31.00, 61.50, 75, 'male', 'L2RaidBoss', 'Fighter', 40, 794875, 308.041, 1508, 3.000, 60, 57, 73, 76, 70, 80, 5231148, 864099, 8039, 1571, 5701, 766, 253, 0, 506, 78, 0, 0, 40, 190, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2696, 25277, 'Liliths Witch Marilion', '', 'bloody_queen_50_bi', 21.00, 64.00, 50, 'female', 'L2RaidBoss', 'Mystic', 40, 213145, 73.934, 748, 2.100, 60, 57, 73, 76, 70, 80, 3551193, 422350, 1193, 835, 272, 407, 253, 0, 506, 0, 0, 0, 80, 190, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.50, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2697, 25278, 'Dead Soul of Stigma', '', 'mana_vampire', 11.00, 20.00, 49, 'male', 'L2Minion', 'Mystic', 40, 32519, 70.884, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 2227, 404, 994, 395, 253, 0, 506, 0, 0, 0, 90, 180, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2698, 25279, 'Evil Spirit of Stigma', '', 'magical_weaver', 11.00, 20.00, 49, 'male', 'L2Minion', 'Mystic', 40, 16260, 70.884, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 2227, 404, 994, 395, 253, 0, 506, 0, 0, 0, 90, 180, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2699, 25280, 'Pagan Watcher Cerberon', '', 'kel_mahum_champion_50_bi', 19.00, 48.00, 55, 'male', 'L2RaidBoss', 'Fighter', 40, 524760, 221.738, 890, 2.400, 60, 57, 73, 76, 70, 80, 3983098, 535296, 3292, 966, 1869, 471, 253, 0, 506, 75, 0, 0, 50, 210, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.56, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2700, 25281, 'Anakims Nemesis Zakaron', '', 'karik_50_bi', 37.00, 136.50, 70, 'male', 'L2RaidBoss', 'Fighter', 40, 746772, 294.211, 1346, 2.700, 60, 57, 73, 76, 70, 80, 4596480, 802604, 6853, 1412, 4563, 688, 253, 0, 506, 0, 0, 0, 37, 215, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2701, 25282, 'Death Lord Shax', '', 'death_lord_50_bi', 31.00, 61.50, 75, 'male', 'L2RaidBoss', 'Fighter', 40, 794875, 308.041, 1508, 3.000, 60, 57, 73, 76, 70, 80, 5231148, 864099, 8039, 1571, 5701, 766, 253, 0, 506, 2500, 0, 0, 40, 210, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2702, 25283, 'Lilith', '', 'lilith', 42.50, 55.00, 80, 'female', 'L2RaidBoss', 'Fighter', 40, 688717, 211.789, 1675, 3.000, 60, 57, 73, 76, 70, 80, 9911897, 1421059, 6579, 1731, 1066, 845, 253, 0, 506, 0, 0, 0, 45, 200, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2703, 25284, 'Liliths Agent', '', 'lilim_wizard', 9.00, 34.00, 79, 'female', 'L2Minion', 'Mystic', 40, 73064, 209.833, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 17190, 850, 7489, 828, 253, 0, 506, 0, 0, 0, 50, 190, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2704, 25285, 'Liliths Escort', '', 'lilim_knight', 12.00, 50.00, 79, 'male', 'L2Minion', 'Fighter', 40, 109051, 209.833, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 25786, 850, 16852, 828, 253, 0, 506, 5800, 5799, 0, 56, 220, '', 0, 0, 20, 674, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2705, 25286, 'Anakim', '', 'anakim', 15.50, 29.00, 80, 'female', 'L2RaidBoss', 'Fighter', 40, 688717, 211.789, 1675, 3.000, 60, 57, 73, 76, 70, 80, 9911897, 1421059, 6579, 1731, 1066, 845, 253, 0, 506, 0, 0, 0, 45, 200, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.56, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2706, 25287, 'Anakims Guardian', '', 'nephilim_priest', 23.00, 40.50, 79, 'male', 'L2Minion', 'Priest', 40, 109051, 209.833, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12892, 850, 4213, 828, 253, 0, 506, 0, 0, 0, 50, 190, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2707, 25288, 'Anakims Royal Guard', '', 'nephilim_lord', 12.00, 43.00, 79, 'male', 'L2Minion', 'Fighter', 40, 54525, 209.833, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12892, 850, 4213, 828, 253, 0, 506, 0, 0, 0, 65, 220, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2708, 25289, 'Anakims Executor', '', 'nephilim_slayer', 12.00, 36.00, 79, 'male', 'L2SpecialMonster', 'Fighter', 40, 54525, 209.833, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12892, 850, 4213, 828, 253, 0, 506, 0, 0, 0, 65, 190, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2709, 25290, 'Daimon the White-Eyed', '', 'hundred_eye', 21.00, 55.00, 78, 'male', 'L2RaidBoss', 'Fighter', 40, 410601, 126.536, 1607, 3.000, 60, 57, 73, 76, 70, 80, 5346496, 1193017, 4330, 1667, 1553, 813, 253, 0, 506, 0, 0, 0, 30, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.54, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2710, 25291, 'Family of Daimon', '', 'field_stalker', 15.00, 30.00, 77, 'male', 'L2Minion', 'Fighter', 40, 43552, 125.408, 1574, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 11283, 817, 10805, 797, 253, 0, 506, 0, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2711, 25292, 'Family of Daimon', '', 'parasitic_eye', 25.00, 63.00, 77, 'male', 'L2Minion', 'Mystic', 40, 65003, 125.408, 1574, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 8463, 817, 6079, 797, 253, 0, 506, 0, 0, 0, 30, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2712, 25293, 'Hesti Guardian Deity of the Hot Springs', '', 'pixy_bi', 10.00, 54.00, 78, 'female', 'L2RaidBoss', 'Fighter', 40, 410601, 126.536, 1607, 3.000, 60, 57, 73, 76, 70, 80, 5346496, 1193017, 4330, 1667, 1553, 813, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.72, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2713, 25294, 'Fighter of Hestia', '', 'yeti', 15.00, 27.50, 77, 'male', 'L2Minion', 'Fighter', 40, 65003, 125.408, 1574, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 16925, 817, 24314, 797, 253, 0, 506, 0, 0, 0, 16, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2714, 25295, 'Follower of Hestia', '', 'yeti', 15.00, 27.50, 77, 'male', 'L2Minion', 'Fighter', 40, 32501, 125.408, 1574, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 8463, 817, 6079, 797, 253, 0, 506, 0, 0, 0, 16, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2715, 25296, 'Icicle Emperor Bumbalump', '', 'yeti_20_bi', 18.00, 32.00, 74, 'male', 'L2RaidBoss', 'Fighter', 40, 392896, 122.143, 1475, 3.000, 60, 57, 73, 76, 70, 80, 5199407, 852059, 3907, 1539, 1389, 751, 253, 0, 506, 0, 0, 0, 16, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.48, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2716, 25297, 'Icicle Giant', '', 'stone_golem', 20.00, 31.00, 73, 'male', 'L2Minion', 'Mystic', 40, 41620, 121.064, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 10109, 753, 9613, 735, 253, 0, 506, 0, 0, 0, 23, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2717, 25298, 'Icicle Giant', '', 'stone_golem', 20.00, 31.00, 73, 'male', 'L2Minion', 'Mystic', 40, 62119, 121.064, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15163, 753, 21632, 735, 253, 0, 506, 0, 0, 0, 23, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2718, 25299, 'Ketras Hero Hekaton', '', 'ketra_orc_chieftain_20_bi', 17.00, 46.20, 80, 'male', 'L2RaidBoss', 'Fighter', 40, 300327, 92.339, 1675, 3.000, 60, 57, 73, 76, 70, 80, 3775961, 557272, 2442, 1731, 475, 845, 253, 0, 506, 6719, 0, 0, 24, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.51, 'false', 'SOUL', 1, 1);
INSERT INTO `npc` VALUES (2719, 25300, 'Scout of Hekaton', '', 'ketra_orc_archer', 12.00, 27.00, 79, 'male', 'L2Minion', 'Ranger', 1100, 31867, 91.493, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4786, 850, 1858, 828, 253, 0, 506, 288, 0, 0, 45, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.91, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2720, 25301, 'Servant of Hekaton', '', 'ketra_orc', 12.00, 29.00, 79, 'male', 'L2Minion', 'Fighter', 40, 23781, 91.493, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4786, 850, 1858, 828, 253, 0, 506, 79, 0, 0, 45, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2721, 25302, 'Ketras Commander Tayr', '', 'ketra_orc_warlord_20_bi', 15.00, 36.00, 80, 'male', 'L2RaidBoss', 'Fighter', 40, 325022, 99.932, 1884, 3.120, 60, 57, 73, 76, 70, 80, 3775961, 557272, 2542, 1888, 546, 921, 253, 0, 506, 80, 0, 0, 27, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -14, 0.48, 'false', 'SOUL', 1, 1);
INSERT INTO `npc` VALUES (2722, 25303, 'Tayrs Aide', '', 'ketra_orc_shaman', 10.00, 23.00, 80, 'male', 'L2Minion', 'Priest', 40, 34166, 97.991, 1831, 3.090, 40, 43, 30, 21, 20, 20, 0, 0, 6711, 924, 3757, 901, 253, 0, 506, 213, 0, 0, 10, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -15, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2723, 25304, 'Tayrs Guard', '', 'ketra_orc', 12.00, 29.00, 80, 'male', 'L2Minion', 'Fighter', 40, 50994, 97.991, 1831, 3.090, 40, 43, 30, 21, 20, 20, 0, 0, 10067, 924, 8452, 901, 253, 0, 506, 79, 6919, 0, 45, 190, '', 300, 0, 20, 708, 7, 30, 4, 5, 0, -15, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2724, 25305, 'Ketras Chief Brakki', '', 'ketra_warbeast', 20.00, 33.50, 80, 'male', 'L2RaidBoss', 'Fighter', 40, 689061, 264.824, 2051, 3.210, 60, 57, 73, 76, 70, 80, 3775961, 557272, 5237, 2004, 2412, 977, 253, 0, 506, 0, 0, 0, 26, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -11, 0.50, 'false', 'SOUL', 1, 1);
INSERT INTO `npc` VALUES (2725, 25306, 'Soul of Fire Nastron', '', 'ifrit', 10.00, 42.00, 80, 'male', 'L2RaidBoss', 'Fighter', 40, 240490, 82.155, 2051, 3.210, 60, 57, 73, 76, 70, 80, 2643173, 390090, 1555, 2004, 524, 977, 253, 0, 506, 0, 0, 0, 38, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -11, 0.48, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2726, 25307, 'Family of Nastron', '', 'mana_vampire', 11.00, 20.00, 80, 'male', 'L2Minion', 'Mystic', 40, 37741, 80.581, 1995, 3.180, 40, 43, 30, 21, 20, 20, 0, 0, 6157, 982, 8112, 958, 253, 0, 506, 0, 0, 0, 90, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -12, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2727, 25308, 'Family of Nastron', '', 'mana_vampire', 11.00, 20.00, 80, 'male', 'L2Minion', 'Mystic', 40, 18871, 80.581, 1995, 3.180, 40, 43, 30, 21, 20, 20, 0, 0, 3077, 982, 2028, 958, 253, 0, 506, 0, 0, 0, 90, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -12, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2728, 25309, 'Varkas Hero Shadith', '', 'barka_silenos_shaman_20_bi', 17.00, 47.50, 80, 'male', 'L2RaidBoss', 'Mystic', 40, 300327, 92.339, 1675, 3.000, 60, 57, 73, 76, 70, 80, 3775961, 557272, 2442, 1731, 475, 845, 253, 0, 506, 6716, 0, 0, 36, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.54, 'false', 'SOUL_BSPIRIT', 1, 1);
INSERT INTO `npc` VALUES (2729, 25310, 'Shadiths Royal Guard Captain', '', 'barka_silenos_warrior', 16.00, 41.00, 79, 'male', 'L2Minion', 'Fighter', 40, 47562, 91.493, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9573, 850, 7432, 828, 253, 0, 506, 142, 6918, 0, 34, 190, '', 300, 0, 20, 674, 7, 30, 4, 5, 0, -18, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2730, 25311, 'Shadiths Sentinel', '', 'barka_silenos_hunter', 16.00, 38.00, 79, 'male', 'L2Minion', 'Fighter', 40, 23781, 91.493, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4786, 850, 1858, 828, 253, 0, 506, 2504, 0, 0, 44, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2731, 25312, 'Varkas Commander Mos', '', 'barka_silenos_chieftain_20_bi', 22.00, 51.00, 80, 'male', 'L2RaidBoss', 'Fighter', 40, 325022, 99.932, 1884, 3.120, 60, 57, 73, 76, 70, 80, 3775961, 557272, 2542, 1888, 546, 921, 253, 0, 506, 2500, 0, 0, 25, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -14, 0.48, 'false', 'SOUL', 1, 1);
INSERT INTO `npc` VALUES (2732, 25313, 'Mos Aide', '', 'barka_silenos_priest', 9.00, 41.50, 80, 'male', 'L2Minion', 'Priest', 40, 50994, 97.991, 1831, 3.090, 40, 43, 30, 21, 20, 20, 0, 0, 5033, 924, 2113, 901, 253, 0, 506, 6716, 0, 0, 36, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -15, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2733, 25314, 'Mos Guard', '', 'barka_silenos_hunter', 16.00, 38.00, 80, 'male', 'L2Minion', 'Fighter', 40, 25497, 97.991, 1831, 3.090, 40, 43, 30, 21, 20, 20, 0, 0, 5033, 924, 2113, 901, 253, 0, 506, 142, 0, 0, 44, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -15, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2734, 25315, 'Varkas Chief Horus', '', 'barka_silenos_chieftain_20_bi', 22.00, 51.00, 80, 'male', 'L2RaidBoss', 'Fighter', 40, 689061, 264.824, 2051, 3.210, 60, 57, 73, 76, 70, 80, 3775961, 557272, 5237, 2004, 2412, 977, 253, 0, 506, 2500, 0, 0, 25, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -11, 0.48, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2735, 25316, 'Soul of Water Ashutar', '', 'undine', 12.00, 27.00, 80, 'female', 'L2RaidBoss', 'Mystic', 40, 240490, 82.155, 2051, 3.210, 60, 57, 73, 76, 70, 80, 2643173, 390090, 1555, 2004, 524, 977, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -11, 0.35, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2736, 25317, 'Family of Ashutar', '', 'magical_weaver', 11.00, 20.00, 80, 'male', 'L2Minion', 'Mystic', 40, 37741, 80.581, 1995, 3.180, 40, 43, 30, 21, 20, 20, 0, 0, 6157, 982, 8112, 958, 253, 0, 506, 0, 0, 0, 90, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -12, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2737, 25318, 'Family of Ashutar', '', 'magical_weaver', 11.00, 20.00, 80, 'male', 'L2Minion', 'Mystic', 40, 18871, 80.581, 1995, 3.180, 40, 43, 30, 21, 20, 20, 0, 0, 3077, 982, 2028, 958, 253, 0, 506, 0, 0, 0, 90, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -12, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2738, 25319, 'Ember', '', 'inferno_drake_100_bi', 48.00, 73.00, 80, 'male', 'L2RaidBoss', 'Fighter', 40, 462603, 142.223, 1939, 3.150, 60, 57, 73, 76, 70, 80, 5437589, 1219007, 4746, 1927, 1935, 940, 253, 0, 506, 0, 0, 0, 57, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -13, 0.48, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2739, 25320, 'Sentinel of Ember', '', 'lava_golem', 22.00, 45.00, 80, 'male', 'L2Minion', 'Fighter', 40, 48632, 139.474, 1884, 3.120, 40, 43, 30, 21, 20, 20, 0, 0, 12528, 943, 13282, 921, 253, 0, 506, 0, 0, 0, 13, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -14, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2740, 25321, 'Messenger of Ember', '', 'ifrit', 10.00, 42.00, 80, 'male', 'L2Minion', 'Mystic', 40, 72586, 139.474, 1884, 3.120, 40, 43, 30, 21, 20, 20, 0, 0, 9396, 943, 7471, 921, 253, 0, 506, 0, 0, 0, 38, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -14, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2741, 25322, 'Demons Agent Falston', '', 'vampire_warrior', 9.00, 31.50, 66, 'male', 'L2RaidBoss', 'Fighter', 40, 350517, 112.374, 1220, 2.700, 60, 57, 73, 76, 70, 80, 4512325, 757636, 2922, 1287, 969, 628, 253, 0, 506, 6723, 0, 0, 43, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2742, 25323, 'Falstons Disciple', '', 'vampire_wizard', 5.50, 28.00, 65, 'female', 'L2Minion', 'Mystic', 40, 36888, 110.823, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 7455, 628, 6639, 613, 253, 0, 506, 99, 0, 0, 46, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2743, 25324, 'Servant of Falston', '', 'black_magician', 8.00, 30.00, 65, 'male', 'L2Minion', 'Mystic', 40, 55056, 110.823, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 11183, 628, 14940, 613, 253, 0, 506, 178, 0, 0, 19, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2744, 25325, 'Flame of Splendor Barakiel', '', 'apostle_warrior', 8.00, 30.00, 70, 'female', 'L2RaidBoss', 'Fighter', 40, 373386, 117.684, 1346, 2.700, 60, 57, 73, 76, 70, 80, 4596480, 802604, 3426, 1412, 1140, 688, 253, 0, 506, 6717, 0, 0, 50, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2745, 25326, 'Barakiels Disciple', '', 'apostle_mage', 11.00, 38.50, 69, 'male', 'L2Minion', 'Mystic', 40, 58887, 116.469, 1314, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 13204, 690, 17529, 673, 253, 0, 506, 6718, 0, 0, 50, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2746, 25327, 'Barakiels Acolyte', '', 'apostle_mage', 11.00, 38.50, 69, 'male', 'L2Minion', 'Mystic', 40, 29444, 116.469, 1314, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 6603, 690, 4383, 673, 253, 0, 506, 6718, 0, 0, 50, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2747, 25328, 'Eilhalder von Hellmann', '', 'vampire_lord', 7.50, 25.80, 71, 'male', 'L2RaidBoss', 'Quest024Fighter', 40, 378516, 118.847, 1378, 3.000, 60, 57, 73, 76, 70, 80, 5113018, 815421, 3550, 1443, 1272, 704, 253, 0, 506, 0, 0, 0, 15, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.56, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2748, 25329, 'Violet', '', 'vampire_witch', 6.00, 21.50, 70, 'female', 'L2Minion', 'Quest024Mystic', 40, 40027, 117.684, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 9136, 706, 8111, 688, 253, 0, 506, 946, 0, 0, 64, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2749, 25330, 'Kurstin', '', 'vampire_witch', 6.00, 21.50, 70, 'female', 'L2Minion', 'Quest024Mystic', 40, 40027, 117.684, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 9136, 706, 8111, 688, 253, 0, 506, 946, 0, 0, 64, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2750, 25331, 'Mina', '', 'vampire_witch', 6.00, 21.50, 70, 'female', 'L2Minion', 'Quest024Mystic', 40, 40027, 117.684, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 9136, 706, 8111, 688, 253, 0, 506, 946, 0, 0, 64, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2751, 25332, 'Dorian', '', 'vampire_soldier', 8.00, 23.50, 70, 'male', 'L2Minion', 'Quest024Fighter', 40, 59742, 117.684, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 13706, 706, 18250, 688, 253, 0, 506, 234, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2752, 25333, 'Anakazel', '', 'dre_vanul_bi_one', 21.00, 54.00, 28, 'male', 'L2RaidBoss', 'Fighter', 40, 81413, 46.813, 301, 1.500, 60, 57, 73, 76, 70, 80, 1673031, 68097, 111, 392, 18, 191, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.35, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2753, 25334, 'Anakazel', '', 'dre_vanul_bi_one', 21.00, 54.00, 38, 'male', 'L2RaidBoss', 'Fighter', 40, 128865, 67.730, 448, 1.800, 60, 57, 73, 76, 70, 80, 1370326, 114239, 287, 565, 62, 276, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.35, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2754, 25335, 'Anakazel', '', 'kaim_vanul_20_bi', 28.00, 48.00, 48, 'male', 'L2RaidBoss', 'Fighter', 40, 207716, 101.830, 692, 2.100, 60, 57, 73, 76, 70, 80, 1586608, 189699, 636, 785, 216, 384, 253, 0, 506, 0, 0, 0, 37, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.45, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2755, 25336, 'Anakazel', '', 'kaim_vanul_20_bi', 28.00, 48.00, 58, 'male', 'L2RaidBoss', 'Fighter', 40, 296250, 137.415, 977, 2.400, 60, 57, 73, 76, 70, 80, 1843815, 257493, 1208, 1050, 572, 512, 253, 0, 506, 0, 0, 0, 37, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.45, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2756, 25337, 'Anakazel', '', 'karik', 25.00, 90.00, 68, 'male', 'L2RaidBoss', 'Fighter', 40, 363785, 160.662, 1282, 2.700, 60, 57, 73, 76, 70, 80, 2044017, 324825, 1994, 1349, 1036, 658, 253, 0, 506, 0, 0, 0, 37, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.45, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2757, 25338, 'Anakazel', '', 'karik', 25.00, 90.00, 78, 'male', 'L2RaidBoss', 'Fighter', 40, 410724, 175.808, 1607, 3.000, 60, 57, 73, 76, 70, 80, 2504378, 380180, 2776, 1667, 1571, 813, 253, 0, 506, 0, 0, 0, 37, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.45, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2758, 25339, 'Shadow of Halisha', '', 'halisha_a', 23.00, 60.00, 80, 'female', 'L2SepulcherRaid', 'Ranger', 1100, 213849, 73.054, 1726, 3.030, 60, 57, 73, 76, 70, 80, 2643173, 390090, 1464, 1769, 424, 864, 253, 0, 506, 6720, 0, 0, 43, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -17, 0.48, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2759, 25340, 'Knight of Shadow', '', 'vale_master', 12.00, 40.00, 80, 'male', 'L2Minion', 'Fighter', 40, 33542, 71.614, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2900, 865, 1648, 845, 253, 0, 506, 0, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2760, 25341, 'Knight of Shadow', '', 'eligor', 21.00, 35.00, 80, 'male', 'L2Minion', 'Fighter', 40, 16771, 71.614, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2900, 865, 1648, 845, 253, 0, 506, 0, 0, 0, 35, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2761, 25342, 'Shadow of Halisha', '', 'halisha_b', 23.00, 60.00, 80, 'female', 'L2SepulcherRaid', 'Ranger', 1100, 213849, 73.054, 1726, 3.030, 60, 57, 73, 76, 70, 80, 2643173, 390090, 1464, 1769, 424, 864, 253, 0, 506, 6720, 0, 0, 43, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -17, 0.48, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2762, 25343, 'Knight of Shadow', '', 'vale_master', 12.00, 40.00, 80, 'male', 'L2Minion', 'Fighter', 40, 33542, 71.614, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2900, 865, 1648, 845, 253, 0, 506, 0, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2763, 25344, 'Knight of Shadow', '', 'fiend_archer', 17.00, 55.00, 80, 'male', 'L2Minion', 'Ranger', 1100, 22473, 71.614, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2900, 865, 1648, 845, 253, 0, 506, 0, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2764, 25345, 'Knight of shadow', '', 'lilim_wizard', 9.00, 34.00, 80, 'female', 'L2Minion', 'Mystic', 40, 22473, 71.614, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3867, 865, 2929, 845, 253, 0, 506, 0, 0, 0, 50, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2765, 25346, 'Shadow of Halisha', '', 'halisha_c', 23.00, 60.00, 80, 'female', 'L2SepulcherRaid', 'Ranger', 1100, 213849, 73.054, 1726, 3.030, 60, 57, 73, 76, 70, 80, 2643173, 390090, 1464, 1769, 424, 864, 253, 0, 506, 6720, 0, 0, 43, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -17, 0.48, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2766, 25347, 'Knight of Shadow', '', 'lilim_wizard', 9.00, 34.00, 80, 'female', 'L2Minion', 'Mystic', 40, 22473, 71.614, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3867, 865, 2929, 845, 253, 0, 506, 0, 0, 0, 50, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2767, 25348, 'Knight of Shadow', '', 'death_lord', 21.00, 40.00, 80, 'male', 'L2Minion', 'Fighter', 40, 33542, 71.614, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 5798, 865, 6589, 845, 253, 0, 506, 78, 0, 0, 40, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2768, 25349, 'Shadow of Halisha', '', 'halisha_d', 23.00, 60.00, 80, 'female', 'L2SepulcherRaid', 'Ranger', 1100, 213849, 73.054, 1726, 3.030, 60, 57, 73, 76, 70, 80, 2643173, 390090, 1464, 1769, 424, 864, 253, 0, 506, 6720, 0, 0, 43, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -17, 0.48, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2769, 25350, 'Knight of Shadow', '', 'lilim_wizard', 9.00, 34.00, 80, 'female', 'L2Minion', 'Mystic', 40, 22473, 71.614, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3867, 865, 2929, 845, 253, 0, 506, 0, 0, 0, 50, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2770, 25351, 'Knight of Shadow', '', 'vale_master', 12.00, 40.00, 80, 'male', 'L2Minion', 'Fighter', 40, 33542, 71.614, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2900, 865, 1648, 845, 253, 0, 506, 0, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2771, 25352, 'Giant Wasteland Basilisk', '', 'lesser_basilisk', 34.00, 25.00, 30, 'male', 'L2RaidBoss', 'Fighter', 40, 53690, 21.714, 329, 1.500, 60, 57, 73, 76, 70, 80, 2308288, 111484, 132, 422, 8, 206, 253, 0, 506, 0, 0, 0, 35, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.39, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2772, 25353, 'Giant Wasteland Basilisk', '', 'lesser_basilisk_sm', 32.00, 22.00, 29, 'male', 'L2Minion', 'Fighter', 40, 8198, 20.929, 315, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 485, 204, 124, 198, 253, 0, 506, 0, 0, 0, 35, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2773, 25354, 'Gargoyle Lord Sirocco', '', 'gargoyle_bi', 16.00, 65.00, 35, 'male', 'L2RaidBoss', 'Fighter', 40, 69450, 26.794, 403, 1.800, 60, 57, 73, 76, 70, 80, 1912395, 144137, 203, 508, 16, 248, 253, 0, 506, 0, 0, 0, 140, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.37, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2774, 25355, 'Siroccos Gargoyle', '', 'gargoyle', 16.00, 50.00, 34, 'male', 'L2Minion', 'Fighter', 40, 5263, 25.613, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 373, 245, 59, 240, 253, 0, 506, 0, 0, 0, 140, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2775, 25356, 'Siroccos Guards', '', 'gargoyle', 16.00, 50.00, 34, 'male', 'L2Minion', 'Fighter', 40, 10527, 25.613, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 747, 245, 237, 240, 253, 0, 506, 0, 0, 0, 140, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2776, 25357, 'Sukar Wererat Chief', '', 'wererat', 14.00, 25.00, 21, 'male', 'L2RaidBoss', 'Fighter', 40, 37886, 16.827, 205, 1.500, 60, 57, 73, 76, 70, 80, 2646358, 60367, 58, 296, 3, 144, 253, 0, 506, 216, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.61, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2777, 25358, 'Sukar Wererat Guard', '', 'wererat_sm', 12.00, 18.70, 20, 'male', 'L2Minion', 'Fighter', 40, 5896, 16.540, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 213, 142, 41, 138, 253, 0, 506, 216, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2778, 25359, 'Sukar Wererat Priest', '', 'wererat_sm', 12.00, 18.70, 20, 'male', 'L2Minion', 'Priest', 40, 5896, 16.540, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 107, 142, 11, 138, 253, 0, 506, 179, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2779, 25360, 'Tiger Hornet', '', 'giant_bee_bi', 8.00, 32.00, 26, 'male', 'L2RaidBoss', 'Fighter', 40, 45036, 18.971, 273, 1.500, 60, 57, 73, 76, 70, 80, 2487618, 84828, 93, 362, 6, 177, 253, 0, 506, 0, 0, 0, 90, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.50, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2780, 25361, 'Yellow Hornet', '', 'giant_bee', 8.00, 24.50, 25, 'male', 'L2Minion', 'Fighter', 40, 6931, 18.439, 259, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 339, 174, 86, 170, 253, 0, 506, 0, 0, 0, 90, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2781, 25362, 'Tracker Leader Sharuk', '', 'virud_lizardman_warrior', 12.00, 30.00, 23, 'male', 'L2RaidBoss', 'Fighter', 40, 40330, 17.535, 232, 1.500, 60, 57, 73, 76, 70, 80, 2690117, 69902, 71, 321, 4, 157, 253, 0, 506, 291, 0, 0, 52, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.59, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2782, 25363, 'Sharuks Tracker', '', 'virud_lizardman', 10.00, 23.00, 22, 'male', 'L2Minion', 'Fighter', 40, 3124, 17.158, 219, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 129, 154, 17, 151, 253, 0, 506, 2, 0, 0, 43, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2783, 25364, 'Sharuks Marksman', '', 'virud_lizardman_scout', 10.00, 22.00, 22, 'male', 'L2Minion', 'Ranger', 1100, 4186, 17.158, 219, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 129, 154, 17, 151, 253, 0, 506, 2507, 0, 0, 43, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2784, 25365, 'Patriarch Kuroboros', '', 'virud_lizardman_warrior_bi', 12.00, 34.50, 26, 'male', 'L2RaidBoss', 'Priest', 40, 90072, 47.427, 273, 1.500, 60, 57, 73, 76, 70, 80, 2487618, 84828, 185, 362, 23, 177, 253, 0, 506, 93, 0, 0, 52, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.59, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2785, 25366, 'Kuroboros Priest', '', 'virud_lizardman_matriarch', 13.00, 37.00, 23, 'male', 'L2RaidBoss', 'Priest', 40, 40330, 17.535, 232, 1.500, 60, 57, 73, 76, 70, 80, 2690117, 69902, 71, 321, 4, 157, 253, 0, 506, 2, 0, 0, 56, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.65, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2786, 25367, 'Kuroboros Follower', '', 'virud_lizardman', 10.00, 23.00, 22, 'male', 'L2Minion', 'Fighter', 40, 6247, 17.158, 219, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 256, 154, 64, 151, 253, 0, 506, 1, 102, 0, 43, 190, '', 300, 0, 20, 185, 7, 30, 4, 5, 0, -18, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2787, 25368, 'Kuroboros Discipline', '', 'virud_lizardman_shaman', 10.00, 29.00, 22, 'male', 'L2Minion', 'Priest', 40, 6247, 17.158, 219, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 129, 154, 17, 151, 253, 0, 506, 179, 0, 0, 43, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2788, 25369, 'Soul Scavenger', '', 'dark_horror_bi', 20.00, 42.00, 25, 'male', 'L2RaidBoss', 'Fighter', 40, 43316, 18.439, 259, 1.500, 60, 57, 73, 76, 70, 80, 2541013, 79280, 84, 349, 6, 170, 253, 0, 506, 0, 0, 0, 100, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.37, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2789, 25370, 'Corpse Scavenger', '', 'skeleton_bi', 11.00, 31.00, 24, 'male', 'L2Minion', 'Fighter', 40, 6680, 17.961, 246, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 308, 167, 78, 163, 253, 0, 506, 946, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2790, 25371, 'Anima Scavenger', '', 'spartoi', 11.00, 27.00, 24, 'male', 'L2Minion', 'Fighter', 40, 3340, 17.961, 246, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 155, 167, 19, 163, 253, 0, 506, 946, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2791, 25372, 'Discarded Guardian', '', 'stone_golem_bi', 20.00, 40.30, 20, 'male', 'L2RaidBoss', 'Mystic', 40, 73694, 41.350, 192, 1.200, 60, 57, 73, 76, 70, 80, 3041767, 59634, 107, 284, 11, 138, 253, 0, 506, 0, 0, 0, 23, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.41, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2792, 25373, 'Malex Herald of Dagoniel ', '', 'dre_vanul_bi_one', 21.00, 54.00, 21, 'male', 'L2RaidBoss', 'Fighter', 40, 37886, 16.827, 205, 1.500, 60, 57, 73, 76, 70, 80, 2646358, 60367, 58, 296, 3, 144, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.35, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2793, 25374, 'Abyss Flyer', '', 'vampire_bat', 10.00, 33.50, 20, 'male', 'L2Minion', 'Fighter', 40, 5896, 16.540, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 213, 142, 41, 138, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2794, 25375, 'Zombie Lord Farakelsus', '', 'zombie_bi', 12.00, 27.50, 20, 'male', 'L2RaidBoss', 'Fighter', 40, 36847, 16.540, 192, 1.200, 60, 57, 73, 76, 70, 80, 3041767, 59634, 53, 284, 2, 138, 253, 0, 506, 0, 0, 0, 15, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.43, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2795, 25376, 'Warrior Zombie of Farakelsus', '', 'zombie', 13.00, 21.00, 19, 'male', 'L2Minion', 'Mystic', 40, 5747, 16.294, 183, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 193, 136, 37, 133, 253, 0, 506, 0, 0, 0, 15, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2796, 25377, 'Priest Zombie of Farakelsus', '', 'zombie', 13.00, 21.00, 19, 'male', 'L2Minion', 'Priest', 40, 5747, 16.294, 183, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 97, 136, 9, 133, 253, 0, 506, 0, 0, 0, 15, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2797, 25378, 'Madness Beast', '', 'onyx_beast_bi', 14.00, 18.70, 20, 'male', 'L2RaidBoss', 'Fighter', 40, 36847, 16.540, 192, 1.200, 60, 57, 73, 76, 70, 80, 3041767, 59634, 53, 284, 2, 138, 253, 0, 506, 0, 0, 0, 30, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.24, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2798, 25379, 'Dementia Beast', '', 'onyx_beast', 14.00, 14.50, 19, 'male', 'L2Minion', 'Fighter', 40, 5747, 16.294, 183, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 193, 136, 37, 133, 253, 0, 506, 0, 0, 0, 30, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2799, 25380, 'Kaysha Herald of Icarus', '', 'succubus_bi', 10.00, 43.20, 21, 'female', 'L2RaidBoss', 'Mystic', 40, 37886, 16.827, 205, 1.500, 60, 57, 73, 76, 70, 80, 2646358, 60367, 58, 296, 3, 144, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.84, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2800, 25381, 'Nightmare Flyer', '', 'vampire_bat_bi', 10.00, 42.00, 19, 'male', 'L2Minion', 'Fighter', 40, 5747, 16.294, 183, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 193, 136, 37, 133, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2801, 25382, 'Hostile Flyer', '', 'vampire_bat', 10.00, 33.50, 19, 'male', 'L2Minion', 'Fighter', 40, 2874, 16.294, 183, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 97, 136, 9, 133, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2802, 25383, 'Revenant of Sir Calibus', '', 'death_knight_bi', 24.00, 29.00, 34, 'male', 'L2RaidBoss', 'Fighter', 40, 65792, 25.613, 388, 1.800, 60, 57, 73, 76, 70, 80, 1918617, 135504, 187, 491, 15, 240, 253, 0, 506, 75, 0, 0, 27, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.71, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2803, 25384, 'Servant of Calibus', '', 'spartoi', 11.00, 27.00, 33, 'male', 'L2Minion', 'Fighter', 40, 9984, 24.517, 373, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 686, 237, 218, 231, 253, 0, 506, 946, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2804, 25385, 'Evil Spirit Tempest', '', 'dre_vanul_bi_one', 21.00, 54.00, 36, 'male', 'L2RaidBoss', 'Fighter', 40, 73381, 28.064, 418, 1.800, 60, 57, 73, 76, 70, 80, 1916442, 153260, 220, 528, 18, 258, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.35, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2805, 25386, 'Ghost of the Execution Grounds', '', 'skeleton_bi', 11.00, 31.00, 35, 'male', 'L2Minion', 'Fighter', 40, 11112, 26.794, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 812, 254, 257, 248, 253, 0, 506, 128, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2806, 25387, 'Malignant Spirit of the Execution Grounds', '', 'skeleton', 11.00, 25.00, 35, 'male', 'L2Minion', 'Fighter', 40, 5556, 26.794, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 405, 254, 64, 248, 253, 0, 506, 946, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2807, 25388, 'Red Eye Captain Trakia', '', 'oel_mahum_bi', 30.00, 55.00, 35, 'male', 'L2RaidBoss', 'Fighter', 40, 69450, 26.794, 403, 1.800, 60, 57, 73, 76, 70, 80, 1912395, 144137, 203, 508, 16, 248, 253, 0, 506, 70, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.48, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2808, 25389, 'Red Eye Archer ', '', 'ol_mahum_archer', 14.00, 25.00, 34, 'male', 'L2Minion', 'Ranger', 1100, 7053, 25.613, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 373, 245, 59, 240, 253, 0, 506, 279, 0, 0, 50, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.93, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2809, 25390, 'Red Eye Guards', '', 'ol_mahum_champion', 14.00, 27.00, 34, 'male', 'L2Minion', 'Fighter', 40, 5263, 25.613, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 373, 245, 59, 240, 253, 0, 506, 128, 0, 0, 50, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2810, 25391, 'Nurkas Messenger', '', 'ol_mahum_champion_bi', 21.00, 40.50, 33, 'male', 'L2RaidBoss', 'Fighter', 40, 124796, 61.293, 373, 1.800, 60, 57, 73, 76, 70, 80, 1932560, 127255, 343, 473, 55, 231, 253, 0, 506, 127, 0, 0, 50, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.63, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2811, 25392, 'Captain of Queens Royal Guards', '', 'marsh_stakato_queen', 15.00, 37.00, 32, 'female', 'L2RaidBoss', 'Fighter', 40, 59258, 23.504, 358, 1.800, 60, 57, 73, 76, 70, 80, 1962692, 119633, 157, 456, 12, 223, 253, 0, 506, 129, 0, 0, 130, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.41, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2812, 25393, 'Marsh Stakato Noble', '', 'marsh_stakato_drone', 9.00, 24.00, 31, 'male', 'L2Minion', 'Fighter', 40, 9018, 22.571, 344, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 577, 220, 179, 215, 253, 0, 506, 223, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2813, 25394, 'Premo Prime', '', 'twin_headed_giant', 17.00, 39.00, 38, 'male', 'L2RaidBoss', 'Fighter', 40, 164178, 77.182, 448, 1.800, 60, 57, 73, 76, 70, 80, 1957608, 163199, 519, 565, 83, 276, 253, 0, 506, 88, 0, 0, 45, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.46, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2814, 25395, 'Archon Suscepter', '', 'susceptor_prime', 45.00, 72.00, 45, 'male', 'L2RaidBoss', 'Fighter', 40, 121183, 43.343, 611, 2.100, 60, 57, 73, 76, 70, 80, 2085510, 229987, 448, 714, 48, 348, 253, 0, 506, 0, 0, 0, 78, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.52, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2815, 25396, 'Kusion Suscepter', '', 'susceptor', 20.00, 35.00, 44, 'male', 'L2Minion', 'Fighter', 40, 18378, 41.347, 584, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 830, 346, 174, 338, 253, 0, 506, 0, 0, 0, 27, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2816, 25397, 'Gustos Suscepter', '', 'susceptor', 20.00, 35.00, 44, 'male', 'L2Minion', 'Fighter', 40, 18378, 41.347, 584, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1660, 346, 694, 338, 253, 0, 506, 0, 0, 0, 27, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2817, 25398, 'Eye of Beleth', '', 'monster_eye', 21.00, 43.00, 35, 'male', 'L2RaidBoss', 'Mystic', 40, 69450, 26.794, 403, 1.800, 60, 57, 73, 76, 70, 80, 1912395, 144137, 203, 508, 16, 248, 253, 0, 506, 0, 0, 0, 90, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.30, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2818, 25399, 'Apprentice of Watchman', '', 'mana_vampire', 11.00, 20.00, 34, 'male', 'L2Minion', 'Mystic', 40, 7053, 25.613, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 498, 245, 106, 240, 253, 0, 506, 0, 0, 0, 90, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2819, 25400, 'Page of Watchman', '', 'magical_weaver', 11.00, 20.00, 34, 'male', 'L2Minion', 'Mystic', 40, 10527, 25.613, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 373, 245, 59, 240, 253, 0, 506, 0, 0, 0, 90, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2820, 25401, 'Skyla', '', 'zenta_lizardman_matriarch_bi', 30.00, 63.00, 32, 'male', 'L2RaidBoss', 'Fighter', 40, 59258, 23.504, 358, 1.800, 60, 57, 73, 76, 70, 80, 1962692, 119633, 157, 456, 12, 223, 253, 0, 506, 215, 0, 0, 53, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.46, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2821, 25402, 'Retainer of Skyla', '', 'zenta_lizardman', 11.00, 32.00, 31, 'male', 'L2Minion', 'Fighter', 40, 9018, 22.571, 344, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 577, 220, 179, 215, 253, 0, 506, 221, 0, 0, 37, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2822, 25403, 'Follower of Skyla', '', 'zenta_lizardman_shaman', 13.00, 35.00, 31, 'male', 'L2Minion', 'Priest', 40, 6042, 22.571, 344, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 385, 220, 79, 215, 253, 0, 506, 180, 0, 0, 43, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2823, 25404, 'Corsair Captain Kylon', '', 'pirates_zombie_captain', 17.00, 28.00, 33, 'male', 'L2RaidBoss', 'Fighter', 40, 62398, 24.517, 373, 1.800, 60, 57, 73, 76, 70, 80, 1932560, 127255, 172, 473, 13, 231, 253, 0, 506, 231, 0, 0, 14, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.76, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2824, 25405, 'Kylons Pirate', '', 'skeleton_bi_one', 16.00, 40.00, 32, 'male', 'L2Minion', 'Fighter', 40, 9481, 23.504, 358, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 629, 227, 202, 223, 253, 0, 506, 946, 945, 0, 60, 190, '', 300, 0, 20, 251, 7, 10, 8, 0, 0, -18, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2825, 25406, 'Kylons Mate', '', 'skeleton_knight_50_bi', 15.00, 39.00, 32, 'male', 'L2Minion', 'Fighter', 40, 9481, 23.504, 358, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 629, 227, 202, 223, 253, 0, 506, 130, 103, 0, 40, 190, '', 300, 0, 20, 251, 7, 30, 4, 5, 0, -18, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2826, 25407, 'Lord Ishka ', '', 'death_blader_bi', 22.00, 67.00, 60, 'male', 'L2RaidBoss', 'Fighter', 40, 221100, 72.964, 1037, 2.400, 60, 57, 73, 76, 70, 80, 2735033, 394692, 1170, 1107, 200, 539, 253, 0, 506, 1472, 0, 0, 100, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2827, 25408, 'Ishkas Elite Officer', '', 'skeleton_royal_guard', 11.00, 28.50, 59, 'male', 'L2Minion', 'Fighter', 40, 34433, 71.371, 1007, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 4433, 539, 2904, 525, 253, 0, 506, 946, 945, 0, 80, 190, '', 300, 0, 20, 486, 7, 10, 8, 0, 0, -18, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2828, 25409, 'Ishkas Elite Soldier', '', 'skeleton_knight_20_bi', 12.00, 30.50, 59, 'male', 'L2Minion', 'Fighter', 40, 34433, 71.371, 1007, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 4433, 539, 2904, 525, 253, 0, 506, 150, 103, 0, 40, 190, '', 300, 0, 20, 486, 7, 30, 4, 5, 0, -18, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2829, 25410, 'Road Scavenger Leader', '', 'wererat_bi', 21.00, 38.00, 40, 'male', 'L2RaidBoss', 'Fighter', 40, 91937, 34.039, 479, 1.800, 60, 57, 73, 76, 70, 80, 2030965, 181264, 304, 606, 25, 295, 253, 0, 506, 88, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.61, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2830, 25411, 'Road Scavenger Henchman', '', 'kobold_bi', 15.00, 24.00, 39, 'male', 'L2Minion', 'Fighter', 40, 13899, 32.412, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 1126, 293, 355, 285, 253, 0, 506, 0, 0, 0, 47, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2831, 25412, 'Necrosentinel Royal Guard', '', 'skeleton_royal_guard', 11.00, 28.50, 47, 'male', 'L2RaidBoss', 'Fighter', 40, 134366, 47.474, 665, 2.100, 60, 57, 73, 76, 70, 80, 2205665, 257531, 517, 762, 58, 371, 253, 0, 506, 946, 946, 0, 80, 190, '', 300, 0, 0, 747, 7, 10, 8, 0, 0, -18, 0.52, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2832, 25413, 'Necrosentinel Archer', '', 'skeleton_archer', 11.00, 27.00, 46, 'male', 'L2Minion', 'Ranger', 1100, 13689, 45.388, 638, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 963, 369, 211, 360, 253, 0, 506, 279, 0, 0, 40, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2833, 25414, 'Necrosentinel Soldier', '', 'skeleton_knight', 10.00, 25.00, 46, 'male', 'L2Minion', 'Fighter', 40, 10215, 45.388, 638, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 963, 369, 211, 360, 253, 0, 506, 150, 103, 0, 40, 190, '', 300, 0, 20, 364, 7, 30, 4, 5, 0, -18, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2834, 25415, 'Nakondas', '', 'drake_bi', 37.00, 125.00, 40, 'male', 'L2RaidBoss', 'Fighter', 40, 91937, 34.039, 479, 1.800, 60, 57, 73, 76, 70, 80, 2030965, 181264, 304, 606, 25, 295, 253, 0, 506, 0, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.84, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2835, 25416, 'Nakondas Slave ', '', 'wyrm', 29.00, 72.00, 39, 'male', 'L2Minion', 'Fighter', 40, 9313, 32.412, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 751, 293, 157, 285, 253, 0, 506, 0, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.19, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2836, 25417, 'Nakondas Chain ', '', 'succubus', 10.00, 36.00, 39, 'female', 'L2Minion', 'Mystic', 40, 13899, 32.412, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 563, 293, 88, 285, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2837, 25418, 'Dread Avenger Kraven', '', 'death_knight_bi', 24.00, 29.00, 44, 'male', 'L2RaidBoss', 'Fighter', 40, 114864, 41.347, 584, 2.100, 60, 57, 73, 76, 70, 80, 2030767, 217826, 415, 692, 44, 338, 253, 0, 506, 75, 0, 0, 27, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.71, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2838, 25419, 'Dread Panther', '', 'onyx_beast', 14.00, 14.50, 43, 'male', 'L2Minion', 'Fighter', 40, 17402, 39.411, 557, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1539, 335, 628, 327, 253, 0, 506, 0, 0, 0, 30, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2839, 25420, 'Orfens Handmaiden', '', 'riba', 25.00, 72.00, 48, 'female', 'L2RaidBoss', 'Fighter', 40, 141171, 49.588, 692, 2.100, 60, 57, 73, 76, 70, 80, 2266583, 270998, 555, 785, 66, 384, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.45, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2840, 25421, 'Trisalim Escort', '', 'poison_spider_bi', 40.00, 38.00, 47, 'male', 'L2Minion', 'Mystic', 40, 14404, 47.474, 665, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1379, 381, 415, 371, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2841, 25422, 'Page of Rotting Tree', '', 'hanged_man_ripper', 35.00, 80.00, 47, 'male', 'L2Minion', 'Fighter', 40, 21499, 47.474, 665, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1034, 381, 234, 371, 253, 0, 506, 0, 0, 0, 55, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2842, 25423, 'Fairy Queen Timiniel', '', 'pixy_bi', 10.00, 54.00, 61, 'female', 'L2RaidBoss', 'Fighter', 40, 226767, 74.469, 1067, 2.700, 60, 57, 73, 76, 70, 80, 2601295, 380861, 1233, 1136, 225, 555, 253, 0, 506, 0, 0, 0, 80, 190, 'timiniel_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.72, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2843, 25424, 'Timiniels Royal Guards', '', 'pixy', 5.00, 25.00, 60, 'female', 'L2Minion', 'Fighter', 40, 17688, 72.964, 1037, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2339, 553, 796, 539, 253, 0, 506, 0, 0, 0, 80, 190, 'timiniel_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2844, 25425, 'Timiniels Royal Guard Captain', '', 'pixy', 5.00, 25.00, 60, 'female', 'L2Minion', 'Fighter', 40, 35376, 72.964, 1037, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 4680, 553, 3183, 539, 253, 0, 506, 0, 0, 0, 80, 190, 'timiniel_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2845, 25426, 'Betrayer of Urutu Freki', '', 'werewolf_bi', 11.00, 29.70, 25, 'male', 'L2RaidBoss', 'Fighter', 40, 43316, 18.439, 259, 1.500, 60, 57, 73, 76, 70, 80, 2541013, 79280, 84, 349, 6, 170, 253, 0, 506, 0, 0, 0, 50, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.43, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2846, 25427, 'Frekis Vampire Bat', '', 'vampire_bat', 10.00, 33.50, 24, 'male', 'L2Minion', 'Mystic', 40, 6680, 17.961, 246, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 308, 167, 78, 163, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2847, 25428, 'Frekis Wild Bear', '', 'grizzly', 21.00, 40.00, 24, 'male', 'L2Minion', 'Fighter', 40, 6680, 17.961, 246, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 308, 167, 78, 163, 253, 0, 506, 0, 0, 0, 40, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2848, 25429, 'Mammon Collector Talos', '', 'ashuras', 13.00, 37.50, 25, 'male', 'L2RaidBoss', 'Fighter', 40, 43316, 18.439, 259, 1.500, 60, 57, 73, 76, 70, 80, 2541013, 79280, 84, 349, 6, 170, 253, 0, 506, 0, 0, 0, 41, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.50, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2849, 25430, 'Talos Cohort', '', 'dre_vanul', 14.00, 36.00, 22, 'male', 'L2Minion', 'Fighter', 40, 6247, 17.158, 219, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 256, 154, 64, 151, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2850, 25431, 'Flamestone Golem', '', 'lava_golem', 22.00, 45.00, 44, 'male', 'L2RaidBoss', 'Fighter', 40, 114864, 41.347, 584, 2.100, 60, 57, 73, 76, 70, 80, 2030767, 217826, 415, 692, 44, 338, 253, 0, 506, 0, 0, 0, 13, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.47, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2851, 25432, 'Elemental of Flame', '', 'mana_vampire', 11.00, 20.00, 43, 'male', 'L2Minion', 'Mystic', 40, 17402, 39.411, 557, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 770, 335, 157, 327, 253, 0, 506, 0, 0, 0, 90, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2852, 25433, 'Elemental of Spark', '', 'magical_weaver', 11.00, 20.00, 43, 'male', 'L2Minion', 'Mystic', 40, 8701, 39.411, 557, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 770, 335, 157, 327, 253, 0, 506, 0, 0, 0, 90, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2853, 25434, 'Bandit Leader Barda', '', 'oel_mahum_warrior_50_bi', 30.00, 60.00, 55, 'male', 'L2RaidBoss', 'Fighter', 40, 189660, 64.171, 890, 2.400, 60, 57, 73, 76, 70, 80, 2477107, 327038, 878, 966, 135, 471, 253, 0, 506, 121, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.65, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2854, 25435, 'Bardas Bandit', '', 'oel_mahum', 20.00, 37.00, 54, 'male', 'L2Minion', 'Fighter', 40, 29261, 62.194, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 3306, 469, 1993, 458, 253, 0, 506, 145, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2855, 25436, 'Bardas Shaman', '', 'oel_mahum_witch_doctor', 15.00, 34.00, 54, 'male', 'L2Minion', 'Priest', 40, 19605, 62.194, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2204, 469, 885, 458, 253, 0, 506, 201, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2856, 25437, 'Timak Orc Gosmos', '', 'batur_orc_overlord_100_bi', 24.00, 52.00, 45, 'male', 'L2RaidBoss', 'Fighter', 40, 242366, 108.356, 611, 2.100, 60, 57, 73, 76, 70, 80, 2085510, 229987, 894, 714, 192, 348, 253, 0, 506, 145, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.28, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2857, 25438, 'Thief Kelbar', '', 'wererat_100_bi', 25.00, 50.00, 44, 'male', 'L2RaidBoss', 'Fighter', 40, 114864, 41.347, 584, 2.100, 60, 57, 73, 76, 70, 80, 2030767, 217826, 415, 692, 44, 338, 253, 0, 506, 239, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.61, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2858, 25439, 'Kelbars Inferior', '', 'wererat_bi', 21.00, 38.00, 43, 'male', 'L2Minion', 'Fighter', 40, 17402, 39.411, 557, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1539, 335, 628, 327, 253, 0, 506, 130, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2859, 25440, 'Kelbars Wizard', '', 'wererat', 14.00, 25.00, 43, 'male', 'L2Minion', 'Fighter', 40, 11659, 39.411, 557, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1026, 335, 280, 327, 253, 0, 506, 99, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2860, 25441, 'Evil Spirit Cyrion', '', 'drake_50_bi', 45.00, 150.00, 45, 'male', 'L2RaidBoss', 'Fighter', 40, 121183, 43.343, 611, 2.100, 60, 57, 73, 76, 70, 80, 2085510, 229987, 448, 714, 48, 348, 253, 0, 506, 0, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.84, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2861, 25442, 'Evil Creature of Forest', '', 'crimson_bear', 19.00, 36.00, 44, 'male', 'L2Minion', 'Fighter', 40, 9189, 41.347, 584, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 830, 346, 174, 338, 253, 0, 506, 0, 0, 0, 37, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2862, 25443, 'Anger of Forest', '', 'giant_wild_hog', 35.00, 27.00, 44, 'male', 'L2Minion', 'Fighter', 40, 18378, 41.347, 584, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1660, 346, 694, 338, 253, 0, 506, 0, 0, 0, 35, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2863, 25444, 'Enmity Ghost Ramdal', '', 'dark_horror_100_bi', 40.00, 70.00, 65, 'male', 'L2RaidBoss', 'Fighter', 40, 247116, 79.612, 1189, 2.700, 60, 57, 73, 76, 70, 80, 2780578, 429547, 1498, 1257, 270, 613, 253, 0, 506, 0, 0, 0, 100, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.37, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2864, 25445, 'Enmity Ghosts', '', 'crimson_doll', 15.00, 38.00, 64, 'male', 'L2Minion', 'Fighter', 40, 19390, 78.452, 1158, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 2863, 614, 1040, 598, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.67, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2865, 25446, 'Shooter of Enmity', '', 'skeleton_archer', 11.00, 27.00, 64, 'male', 'L2Minion', 'Ranger', 1100, 25983, 78.452, 1158, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 2863, 614, 1040, 598, 253, 0, 506, 279, 0, 0, 40, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2866, 25447, 'Immortal Savior Mardil', '', 'banshee_50_bi', 13.50, 38.00, 71, 'female', 'L2RaidBoss', 'Mystic', 40, 271409, 85.229, 1378, 3.000, 60, 57, 73, 76, 70, 80, 3074085, 495533, 1912, 1443, 370, 704, 253, 0, 506, 3939, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.56, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2867, 25448, 'Immortal Savior ', '', 'binding', 12.00, 21.00, 70, 'male', 'L2Minion', 'Fighter', 40, 21422, 84.413, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 3687, 706, 1324, 688, 253, 0, 506, 0, 0, 0, 10, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2868, 25449, 'Immortal Guide', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Minion', 'Fighter', 40, 42845, 84.413, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 3687, 706, 1324, 688, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2869, 25450, 'Cherub Galaxia', '', 'archangel_50_bi', 22.00, 120.00, 79, 'male', 'L2RaidBoss', 'Fighter', 40, 414903, 127.692, 1641, 3.000, 60, 57, 73, 76, 70, 80, 5390003, 1205333, 4425, 1698, 1593, 828, 253, 0, 506, 97, 0, 0, 50, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.76, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2870, 25451, 'Galaxias Guards', '', 'angel', 13.50, 36.50, 78, 'male', 'L2Minion', 'Fighter', 40, 44016, 126.536, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 11546, 833, 11039, 813, 253, 0, 506, 148, 0, 0, 30, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2871, 25452, 'Messenger of Angel', '', 'angel', 13.50, 36.50, 79, 'male', 'L2Minion', 'Fighter', 40, 66385, 127.692, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 8849, 850, 6367, 828, 253, 0, 506, 148, 0, 0, 30, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2872, 25453, 'Meanas Anor', '', 'wyrm_50_bi', 58.00, 108.00, 70, 'male', 'L2RaidBoss', 'Fighter', 40, 373386, 117.684, 1346, 2.700, 60, 57, 73, 76, 70, 80, 4596480, 802604, 3426, 1412, 1140, 688, 253, 0, 506, 0, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.19, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2873, 25454, 'Wyvern of Marsh', '', 'wyrm', 29.00, 72.00, 69, 'male', 'L2Minion', 'Fighter', 40, 39455, 116.469, 1314, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 8802, 690, 7789, 673, 253, 0, 506, 0, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.19, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2874, 25455, 'Succubus of Marsh', '', 'succubus', 10.00, 36.00, 69, 'female', 'L2Minion', 'Mystic', 40, 58887, 116.469, 1314, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 6603, 690, 4383, 673, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2875, 25456, 'Mirror of Oblivion', '', 'mirror_50_bi', 45.00, 78.00, 49, 'male', 'L2RaidBoss', 'Mystic', 40, 148076, 51.719, 720, 2.100, 60, 57, 73, 76, 70, 80, 2328069, 284981, 595, 810, 72, 395, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.39, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2876, 25457, 'Shards of Oblivion', '', 'human_ghost', 8.00, 22.00, 48, 'male', 'L2Minion', 'Mystic', 40, 11294, 49.588, 692, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1110, 393, 262, 384, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2877, 25458, 'Shadow of Oblivion', '', 'elf_ghost', 7.00, 21.00, 48, 'male', 'L2Minion', 'Mystic', 40, 22587, 49.588, 692, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1110, 393, 262, 384, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2878, 25459, 'Shards of Oblivion', '', 'dwarf_ghost', 9.00, 16.50, 48, 'male', 'L2Minion', 'Mystic', 40, 11294, 49.588, 692, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1110, 393, 262, 384, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2879, 25460, 'Deadman Ereve', '', 'death_blader_200_bi', 45.00, 141.00, 51, 'male', 'L2RaidBoss', 'Fighter', 40, 162046, 55.982, 776, 2.400, 60, 57, 73, 76, 70, 80, 2256714, 285537, 682, 861, 95, 420, 253, 0, 506, 194, 0, 0, 100, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.45, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2880, 25461, 'Ereves Knight', '', 'skeleton_knight', 10.00, 25.00, 50, 'male', 'L2Minion', 'Fighter', 40, 24807, 53.855, 748, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 2549, 417, 1257, 407, 253, 0, 506, 70, 0, 0, 40, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2881, 25462, 'Ereves Squire', '', 'skeleton_pikeman', 10.00, 28.00, 50, 'male', 'L2Minion', 'Fighter', 40, 24807, 53.855, 748, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 2549, 417, 1257, 407, 253, 0, 506, 98, 0, 0, 50, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.21, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2882, 25463, 'Harit Guardian Garangky', '', 'saber_toothed_tiger', 34.00, 28.00, 56, 'male', 'L2RaidBoss', 'Fighter', 40, 196307, 66.085, 919, 2.400, 60, 57, 73, 76, 70, 80, 2529799, 340561, 934, 993, 145, 484, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2883, 25464, 'Garangky Guard Captain', '', 'zenta_lizardman_warrior', 13.00, 35.00, 55, 'male', 'L2Minion', 'Fighter', 40, 30346, 64.171, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 3516, 482, 2154, 471, 253, 0, 506, 303, 0, 0, 40, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2884, 25465, 'Garangky Guard Shaman', '', 'zenta_lizardman_shaman', 13.00, 35.00, 55, 'male', 'L2Minion', 'Priest', 40, 30346, 64.171, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 1758, 482, 539, 471, 253, 0, 506, 206, 0, 0, 43, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2885, 25466, 'Garangky Guard ', '', 'zenta_lizardman', 11.00, 32.00, 55, 'male', 'L2Minion', 'Fighter', 40, 30346, 64.171, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 3516, 482, 2154, 471, 253, 0, 506, 77, 0, 0, 37, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2886, 25467, 'Gorgolos', '', 'field_stalker_200_bi', 45.00, 96.00, 64, 'male', 'L2RaidBoss', 'Fighter', 40, 242375, 78.452, 1158, 2.700, 60, 57, 73, 76, 70, 80, 2736355, 417632, 1431, 1226, 260, 598, 253, 0, 506, 0, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.41, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2887, 25468, 'Cursed Life', '', 'field_stalker', 15.00, 30.00, 63, 'male', 'L2Minion', 'Fighter', 40, 18992, 77.210, 1127, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 2728, 597, 1000, 584, 253, 0, 506, 0, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2888, 25469, 'Cursed Soul', '', 'field_stalker', 15.00, 30.00, 63, 'male', 'L2Minion', 'Fighter', 40, 37985, 77.210, 1127, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 5455, 597, 4001, 584, 253, 0, 506, 0, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2889, 25470, 'Last Titan Utenus', '', 'lesser_giant_mage', 21.00, 44.00, 66, 'male', 'L2RaidBoss', 'Mystic', 40, 251638, 80.695, 1220, 2.700, 60, 57, 73, 76, 70, 80, 2826358, 441301, 1567, 1287, 281, 628, 253, 0, 506, 3938, 0, 0, 15, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.56, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2890, 25471, 'Utenuss Wizard', '', 'lesser_giant', 21.00, 44.00, 65, 'male', 'L2Minion', 'Mystic', 40, 26491, 79.612, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 3998, 628, 1920, 613, 253, 0, 506, 0, 0, 0, 15, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.58, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2891, 25472, 'Utenuss Guard', '', 'leogul', 15.00, 35.00, 65, 'male', 'L2Minion', 'Fighter', 40, 39539, 79.612, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 5995, 628, 4321, 613, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2892, 25473, 'Grave Robber Kim', '', 'batur_orc_warrior_100_bi', 20.00, 42.00, 52, 'male', 'L2RaidBoss', 'Fighter', 40, 169042, 58.089, 804, 2.400, 60, 57, 73, 76, 70, 80, 2313340, 287521, 728, 887, 103, 433, 253, 0, 506, 160, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.30, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2893, 25474, 'Kims Gang', '', 'batur_orc', 9.00, 21.50, 51, 'male', 'L2Minion', 'Fighter', 40, 25927, 55.982, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2726, 430, 1522, 420, 253, 0, 506, 89, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2894, 25475, 'Ghost Knight Kabed', '', 'headless_knight_50_bi', 30.00, 46.50, 55, 'male', 'L2RaidBoss', 'Fighter', 40, 189660, 64.171, 890, 2.400, 60, 57, 73, 76, 70, 80, 2477107, 327038, 878, 966, 135, 471, 253, 0, 506, 145, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.52, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2895, 25476, 'Kabeds Soldier', '', 'skeleton_knight', 10.00, 25.00, 54, 'male', 'L2Minion', 'Fighter', 40, 14630, 62.194, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 1653, 469, 498, 458, 253, 0, 506, 125, 0, 0, 40, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2896, 25477, 'Kabeds Archer', '', 'skeleton_archer', 11.00, 27.00, 54, 'male', 'L2Minion', 'Ranger', 1100, 19605, 62.194, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 1653, 469, 498, 458, 253, 0, 506, 279, 0, 0, 40, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2897, 25478, 'Shilens Priest Hisilrome', '', 'cave_maiden', 25.00, 65.00, 65, 'female', 'L2RaidBoss', 'Priest', 40, 247116, 79.612, 1189, 2.700, 60, 57, 73, 76, 70, 80, 2780578, 429547, 1498, 1257, 270, 613, 253, 0, 506, 230, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.43, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2898, 25479, 'Hisilromes Servitor', '', 'serpent_slave', 17.00, 46.00, 64, 'male', 'L2Minion', 'Fighter', 40, 25983, 78.452, 1158, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 3816, 614, 1848, 598, 253, 0, 506, 68, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2899, 25480, 'Hisilromes Page', '', 'lienrik', 12.00, 50.00, 64, 'male', 'L2Minion', 'Fighter', 40, 38780, 78.452, 1158, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 2863, 614, 1040, 598, 253, 0, 506, 0, 0, 0, 100, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2900, 25481, 'Magus Kenishee', '', 'banshee_50_bi', 13.50, 38.00, 53, 'female', 'L2RaidBoss', 'Mystic', 40, 175998, 60.163, 832, 2.400, 60, 57, 73, 76, 70, 80, 2368104, 300304, 777, 913, 115, 444, 253, 0, 506, 3939, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.56, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2901, 25482, 'Shadow of Kenishee', '', 'shadow', 10.00, 30.00, 52, 'male', 'L2Minion', 'Mystic', 40, 27047, 58.089, 804, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2912, 443, 1653, 433, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2902, 25483, 'Phantom of Kenishee', '', 'silhouette', 8.00, 23.00, 52, 'female', 'L2Minion', 'Fighter', 40, 27047, 58.089, 804, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 1455, 443, 413, 433, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2903, 25484, 'Zakens Chief Mate Tillion', '', 'skeleton_knight_50_bi', 15.00, 39.00, 50, 'male', 'L2RaidBoss', 'Fighter', 40, 155046, 53.855, 748, 2.100, 60, 57, 73, 76, 70, 80, 2389767, 281312, 637, 835, 79, 407, 253, 0, 506, 160, 0, 0, 40, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.17, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2904, 25485, 'Tillions Inferior', '', 'skeleton_bi', 11.00, 31.00, 49, 'male', 'L2Minion', 'Fighter', 40, 23692, 51.719, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 2381, 404, 1147, 395, 253, 0, 506, 131, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2905, 25486, 'Tillions Bat', '', 'vampire_bat', 10.00, 33.50, 49, 'male', 'L2Minion', 'Mystic', 40, 23692, 51.719, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 2381, 404, 1147, 395, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2906, 25487, 'Water Spirit Lian', '', 'pixy_bi', 10.00, 54.00, 40, 'female', 'L2RaidBoss', 'Fighter', 40, 91937, 34.039, 479, 1.800, 60, 57, 73, 76, 70, 80, 2030965, 181264, 304, 606, 25, 295, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.72, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2907, 25488, 'Spirit of Gildor', '', 'pixy', 5.00, 25.00, 39, 'female', 'L2Minion', 'Fighter', 40, 9313, 32.412, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 751, 293, 157, 285, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2908, 25489, 'Guardian of Gildor', '', 'pixy', 5.00, 25.00, 39, 'female', 'L2Minion', 'Fighter', 40, 13899, 32.412, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 1126, 293, 355, 285, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2909, 25490, 'Gwindorr', '', 'serpent_slave', 17.00, 46.00, 40, 'male', 'L2RaidBoss', 'Fighter', 40, 91937, 34.039, 479, 1.800, 60, 57, 73, 76, 70, 80, 2030965, 181264, 304, 606, 25, 295, 253, 0, 506, 129, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2910, 25491, 'Guard of Gwindorr', '', 'virud_lizardman_scout', 10.00, 22.00, 39, 'male', 'L2Minion', 'Ranger', 1100, 9313, 32.412, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 563, 293, 88, 285, 253, 0, 506, 2507, 0, 0, 43, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2911, 25492, 'Follower of Gwindorr', '', 'virud_lizardman', 10.00, 23.00, 39, 'male', 'L2Minion', 'Fighter', 40, 6950, 32.412, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 563, 293, 88, 285, 253, 0, 506, 2, 0, 0, 43, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2912, 25493, 'Evas Spirit Niniel', '', 'cutie_cat', 8.00, 15.00, 55, 'female', 'L2RaidBoss', 'Fighter', 40, 189660, 64.171, 890, 2.400, 60, 57, 73, 76, 70, 80, 2477107, 327038, 878, 966, 135, 471, 253, 0, 506, 0, 0, 0, 48, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.34, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2913, 25494, 'Spirit of Niniel', '', 'pixy', 5.00, 25.00, 54, 'female', 'L2Minion', 'Fighter', 40, 29261, 62.194, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 3306, 469, 1993, 458, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2914, 25495, 'Spirit of Niniel', '', 'pixy', 5.00, 25.00, 54, 'female', 'L2Minion', 'Fighter', 40, 14630, 62.194, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 1653, 469, 498, 458, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2915, 25496, 'Fafurions Envoy Pingolpin', '', 'riba', 25.00, 72.00, 52, 'female', 'L2RaidBoss', 'Fighter', 40, 169042, 58.089, 804, 2.400, 60, 57, 73, 76, 70, 80, 2313340, 287521, 728, 887, 103, 433, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.45, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2916, 25497, 'Fafurions Envoy   ', '', 'marsh_stakato_soldier', 10.00, 25.00, 51, 'male', 'L2Minion', 'Fighter', 40, 25927, 55.982, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2726, 430, 1522, 420, 253, 0, 506, 76, 0, 0, 30, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2917, 25498, 'Fafurions Henchman Istary', '', 'farhite_50_bi', 24.00, 48.00, 45, 'male', 'L2RaidBoss', 'Fighter', 40, 121183, 43.343, 611, 2.100, 60, 57, 73, 76, 70, 80, 2085510, 229987, 448, 714, 48, 348, 253, 0, 506, 5131, 0, 0, 15, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.74, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2918, 25499, 'Alligator of Istary', '', 'crocodile', 28.00, 11.50, 44, 'male', 'L2Minion', 'Fighter', 40, 18378, 41.347, 584, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1660, 346, 694, 338, 253, 0, 506, 0, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2919, 25500, 'Alligator of Istary', '', 'crocodile', 28.00, 11.50, 44, 'male', 'L2Minion', 'Fighter', 40, 9189, 41.347, 584, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 830, 346, 174, 338, 253, 0, 506, 0, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2920, 25501, 'Boss Akata', '', 'e_collector_teacher_Mdwarf_mon_130p', 11.00, 23.60, 30, 'male', 'L2RaidBoss', 'Fighter', 40, 53690, 21.714, 329, 1.500, 60, 57, 73, 76, 70, 80, 2308288, 111484, 132, 422, 8, 206, 253, 0, 506, 8528, 0, 0, 36, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.63, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2921, 25502, 'Akatas Thug', '', 'e_traderB_Fdwarf_mon_120p', 8.00, 22.00, 30, 'female', 'L2Minion', 'Fighter', 1100, 5756, 21.714, 329, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 264, 212, 35, 206, 253, 0, 506, 8527, 0, 0, 49, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2922, 25503, 'Akatas Lackey', '', 'e_collector_teacher_Fdwarf_mon_120p', 9.00, 21.40, 30, 'female', 'L2Minion', 'Fighter', 40, 4295, 21.714, 329, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 264, 212, 35, 206, 253, 0, 506, 8529, 0, 0, 45, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2923, 25504, 'Nellis Vengeful Spirit', '', 'a_mageguild_teacher_Mhuman_mon_120p', 10.00, 28.10, 39, 'male', 'L2RaidBoss', 'Fighter', 40, 86871, 32.412, 463, 1.800, 60, 57, 73, 76, 70, 80, 1988451, 173127, 282, 585, 22, 285, 253, 0, 506, 8532, 0, 0, 50, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.63, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2924, 25505, 'Nellis Follower', '', 'dwarf_ghost', 9.00, 16.50, 38, 'male', 'L2Minion', 'Fighter', 40, 13134, 30.873, 448, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 1039, 283, 328, 276, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2925, 25506, 'Rayito the Looter', '', 'ol_mahum_champion_05te_120p', 16.00, 33.20, 37, 'male', 'L2RaidBoss', 'Fighter', 40, 77593, 29.423, 433, 1.800, 60, 57, 73, 76, 70, 80, 1932589, 153693, 239, 546, 19, 266, 253, 0, 506, 67, 633, 0, 50, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.63, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2926, 25507, 'Rayitos Henchman', '', 'ol_mahum_05te_110p', 14.50, 28.00, 36, 'male', 'L2Minion', 'Fighter', 40, 11741, 28.064, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 883, 264, 281, 258, 253, 0, 506, 123, 19, 0, 50, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2927, 25508, 'Rayitos Henchman', '', 'northern_goblin_110p', 6.00, 16.60, 36, 'male', 'L2Minion', 'Fighter', 40, 7866, 28.064, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 589, 264, 125, 258, 253, 0, 506, 66, 102, 0, 30, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2928, 25509, 'Dark Shaman Varangka ', '', 'batur_orc_shaman_a_01te_120p', 13.00, 20.80, 53, 'male', 'L2RaidBoss', 'Fighter', 40, 175998, 60.163, 832, 2.400, 60, 57, 73, 76, 70, 80, 2368104, 300304, 777, 913, 115, 444, 253, 0, 506, 316, 0, 0, 50, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.30, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2929, 25510, 'Varangkas Descendant', '', 'batur_orc_overlord_01te_110p', 13.00, 26.90, 52, 'male', 'L2Minion', 'Fighter', 40, 27047, 58.089, 804, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2912, 443, 1653, 433, 253, 0, 506, 74, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2930, 25511, 'Varangkas Page', '', 'batur_orc_shaman_a_01te_110p', 12.00, 18.80, 52, 'male', 'L2Minion', 'Fighter', 40, 13523, 58.089, 804, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 1455, 443, 413, 433, 253, 0, 506, 179, 0, 0, 50, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2931, 25512, 'Gigantic Chaos Golem', '', 'chaos_golem', 31.00, 51.80, 52, 'male', 'L2RaidBoss', 'Fighter', 40, 338083, 145.222, 804, 2.400, 60, 57, 73, 76, 70, 80, 2313340, 287521, 1455, 887, 413, 433, 253, 0, 506, 0, 0, 0, 18, 190, 'golem_clan', 300, 0, 0, 0, 8, 30, 4, 5, 0, -18, 0.43, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2932, 25514, 'Queen Shyeed', '', 'cannibal_stakato_leader_tran_120p', 45.00, 50.80, 80, 'male', 'L2RaidBoss', 'Fighter', 40, 300327, 92.339, 1675, 3.000, 60, 57, 73, 76, 70, 80, 3775961, 557272, 2442, 1731, 475, 845, 253, 0, 506, 0, 0, 0, 45, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.43, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2933, 25515, 'Spiked Stakato  ', '', 'spike_stakato_110p', 13.00, 21.00, 79, 'male', 'L2Minion', 'Fighter', 40, 31867, 91.493, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 6381, 850, 3303, 828, 253, 0, 506, 123, 0, 0, 23, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2934, 25516, 'Spiked Stakato  ', '', 'spike_stakato_worker_110p', 13.00, 22.20, 79, 'male', 'L2Minion', 'Fighter', 40, 47562, 91.493, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9573, 850, 7432, 828, 253, 0, 506, 0, 0, 0, 23, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2935, 25523, 'Plague Golem', '', 'stone_golem_bi', 35.00, 46.38, 73, 'male', 'L2RaidBoss', 'Fighter', 40, 776490, 302.660, 1442, 3.000, 60, 57, 73, 76, 70, 80, 5168419, 839126, 7582, 1507, 5408, 735, 253, 0, 506, 0, 0, 0, 60, 160, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2936, 25524, 'Flamestone Giant', '', 'lava_golem', 22.00, 45.00, 76, 'male', 'L2RaidBoss', 'Fighter', 40, 401887, 124.303, 1541, 3.000, 60, 57, 73, 76, 70, 80, 5267108, 1171763, 4128, 1602, 1465, 782, 253, 0, 506, 0, 0, 0, 13, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.47, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2937, 25525, 'Flame Spirit', '', 'mana_vampire', 11.00, 20.00, 75, 'male', 'L2Minion', 'Fighter', 40, 63590, 123.216, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 8039, 786, 5701, 766, 253, 0, 506, 0, 0, 0, 90, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2938, 25526, 'Charged Spirit', '', 'magical_weaver', 11.00, 20.00, 75, 'male', 'L2Minion', 'Fighter', 40, 31795, 123.216, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 8039, 786, 5701, 766, 253, 0, 506, 0, 0, 0, 90, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2939, 25527, 'Uruka', '', 'Crokian_Elder', 30.00, 42.51, 80, 'male', 'L2RaidBoss', 'Fighter', 40, 675863, 259.752, 204, 3.180, 60, 57, 73, 76, 70, 80, 3775961, 557272, 5185, 1965, 2334, 958, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -12, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2940, 25528, 'Tiberias', '', 'LineageMonster4.K_Examiner', 10.00, 24.62, 22, 'male', 'L2Npc', 'npc', 40, 31107, 16.372, 219, 1.500, 40, 43, 30, 21, 20, 20, 225568, 18408, 98, 205, 43, 151, 253, 0, 506, 0, 0, 0, 28, 150, 'ndg_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2941, 25529, 'Garden Guard', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 22, 'male', 'L2Npc', 'npc', 40, 2489, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 36, 120, 'ndg_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2942, 25530, 'Garden Guard', '', 'LineageMonster4.Mostro_Fighter', 15.50, 22.50, 22, 'male', 'L2Npc', 'npc', 40, 1244, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 36, 120, 'ndg_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2943, 25531, 'Darnel', '', 'LineageMonster4.Rah', 20.00, 40.60, 81, 'female', 'L2RaidBoss', 'Darnel', 40, 1354780, 155.192, 1709, 3.000, 40, 43, 30, 21, 20, 80, 1713495, 1026728, 8862, 1057, 6052, 568, 253, 500, 506, 0, 0, 0, 60, 180, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.58, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2944, 25532, 'Kechi', '', 'LineageMonster4.Keyache', 12.00, 29.00, 82, 'male', 'L2RaidBoss', 'Kechi', 40, 338151, 192.545, 1743, 3.000, 40, 43, 30, 21, 20, 80, 2586436, 1438503, 7733, 1077, 5280, 578, 253, 500, 506, 0, 0, 0, 26, 180, 'granisko_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2945, 25533, 'Kechis Henchman', '', 'LineageMonster3.Death_Blader_Raid', 15.00, 32.50, 82, 'male', 'L2Minion', 'Fighter', 40, 18801, 192.698, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3656, 1077, 2497, 1050, 253, 0, 506, 0, 0, 0, 60, 170, 'granisko_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2946, 25534, 'Tears', '', 'LineageMonster4.tears', 20.00, 27.50, 83, 'female', 'L2RaidBoss', 'Tears', 40, 1347511, 152.564, 1777, 3.000, 40, 43, 30, 21, 20, 80, 2010425, 1208631, 9162, 1096, 6257, 588, 253, 500, 506, 9638, 9638, 0, 60, 180, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2947, 25535, 'Tears', '', 'LineageMonster4.tears', 20.00, 27.50, 83, 'female', 'L2SpecialMonster', 'Fighter', 40, 1347511, 152.564, 1777, 3.000, 40, 43, 30, 21, 20, 80, 0, 0, 366, 1096, 251, 588, 253, 0, 506, 9638, 9638, 0, 60, 180, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2948, 25536, 'Hannibal', '', 'LineageMonster4.rah', 20.00, 40.60, 81, 'female', 'L2RaidBoss', 'HBFighter', 40, 431894, 132.782, 1777, 3.000, 60, 57, 73, 76, 70, 80, 5614732, 1265702, 4735, 1826, 1756, 891, 253, 0, 506, 0, 0, 0, 60, 100, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.58, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2949, 25537, 'Enmity', '', 'LineageMonster4.eyeless', 36.00, 43.50, 81, 'male', 'L2Npc', 'npc', 40, 34551, 132.782, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9469, 913, 7028, 891, 253, 0, 506, 0, 0, 0, 60, 100, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2950, 25538, 'Vengeance', '', 'LineageMonster4.eyeless', 36.00, 43.50, 81, 'male', 'L2Npc', 'npc', 40, 69103, 132.782, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9469, 913, 7028, 891, 253, 0, 506, 0, 0, 0, 60, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2951, 25539, 'Typhoon', '', 'LineageMonster3.Death_Blader_Raid_sand', 15.00, 32.50, 81, 'male', 'L2RaidBoss', 'Fighter', 40, 872425, 335.274, 1812, 3.000, 60, 57, 73, 76, 70, 80, 5678638, 1283185, 9619, 1858, 7196, 906, 253, 500, 506, 0, 0, 0, 60, 180, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2952, 25540, 'Demon Prince', '', 'LineageMonster4.Rahuu', 33.00, 49.00, 83, 'male', 'L2ReflectionBoss', 'DemonPrince', 40, 2230489, 187.223, 1847, 3.000, 40, 43, 30, 21, 20, 80, 3100452, 410692, 8963, 1259, 6192, 609, 253, 500, 506, 0, 0, 0, 60, 180, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.55, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2953, 25541, 'Fiend', '', 'LineageMonster3.Self_blaster', 9.00, 25.80, 83, 'male', 'L2Minion', 'Fighter', 40, 55818, 187.410, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 16239, 1259, 11218, 609, 253, 0, 506, 0, 0, 0, 200, 240, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2954, 25542, 'Ranku', '', 'LineageMonster4.LaneCoo', 13.00, 29.00, 83, 'male', 'L2ReflectionBoss', 'Ranku', 40, 2230489, 187.223, 1847, 3.000, 40, 43, 30, 21, 20, 80, 3100452, 410692, 6142, 1259, 4243, 609, 253, 500, 506, 0, 0, 0, 26, 180, 'ranku_clan', 2000, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.49, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2955, 25543, 'Eidolon', '', 'LineageMonster4.eyeless_080p', 34.00, 35.00, 83, 'male', 'L2Minion', 'Mystic', 40, 55818, 187.410, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 16239, 1259, 11218, 609, 253, 0, 506, 0, 0, 0, 60, 210, 'ranku_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.49, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (2956, 25544, 'Tully', '', 'LineageMonster4.Tollese', 19.00, 32.50, 83, 'male', 'L2Npc', 'npc', 40, 1697736, 171.838, 1882, 3.000, 40, 43, 30, 21, 20, 80, 2522625, 1749150, 9092, 1280, 6318, 619, 253, 0, 506, 0, 0, 0, 60, 180, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2957, 25545, 'Tullys Banshee', '', 'LineageMonster4.Giga_whirligig', 33.00, 47.50, 83, 'male', 'L2Npc', 'npc', 40, 4334645, 185.532, 1882, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9092, 1280, 6318, 1123, 253, 0, 506, 0, 0, 0, 250, 250, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.64, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2958, 25546, 'Rhianna the Traitor', '', 'LineageMonster.banshee_50_bi', 13.50, 38.00, 75, 'female', 'L2Monster', 'Fighter', 40, 198852, 85.635, 1508, 3.000, 60, 57, 73, 76, 70, 80, 2329614, 373311, 8764, 1571, 1437, 766, 253, 0, 506, 3939, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2959, 25547, 'Rhiannas Escort', '', 'LineageMonster.Binding', 12.00, 21.00, 74, 'male', 'L2Minion', 'Fighter', 40, 26322, 8.500, 4425, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3783, 513, 861, 375, 253, 0, 506, 0, 0, 0, 10, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2960, 25548, 'Rhiannas Healer', '', 'LineageMonster.Liviona', 15.00, 28.00, 74, 'male', 'L2Minion', 'Fighter', 40, 26322, 8.500, 4425, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3783, 513, 861, 375, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2961, 25549, 'Tesla the Deceiver', '', 'LineageMonster.Virud_lizardman_shaman', 10.00, 29.00, 75, 'male', 'L2Monster', 'Priest', 40, 198852, 85.635, 1508, 3.000, 60, 57, 73, 76, 70, 80, 2329614, 373311, 8764, 1571, 1437, 766, 253, 0, 506, 7, 0, 0, 43, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2962, 25550, 'Teslas Apprentice', '', 'LineageMonster.Zenta_lizardman_warrior', 13.00, 35.00, 74, 'male', 'L2Minion', 'Fighter', 40, 26322, 8.500, 4425, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3783, 513, 861, 375, 253, 0, 506, 291, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2963, 25551, 'Teslas Herald', '', 'LineageMonster.Virud_lizardman_warrior', 12.00, 30.00, 74, 'male', 'L2Minion', 'Fighter', 40, 26322, 8.500, 4425, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3783, 513, 861, 375, 253, 0, 506, 16, 0, 0, 52, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2964, 25552, 'Soul Hunter Chakundel', '', 'LineageMonster3.Death_Blader_Raid', 15.00, 32.50, 76, 'male', 'L2Monster', 'Fighter', 40, 402093, 172.748, 1541, 3.000, 60, 57, 73, 76, 70, 80, 2383519, 369370, 9049, 1602, 1480, 782, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2965, 25553, 'Durango the Crusher', '', 'LineageMonster3.Steel_Trapper', 35.00, 46.38, 77, 'male', 'L2Monster', 'Fighter', 40, 406427, 174.259, 1574, 3.000, 60, 57, 73, 76, 70, 80, 2441393, 374864, 10058, 1635, 1537, 797, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2966, 25554, 'Brutus the Obstinate', '', 'LineageMonster.Kaim_vanul', 24.00, 40.00, 78, 'male', 'L2Monster', 'Fighter', 40, 205362, 87.904, 1607, 3.000, 60, 57, 73, 76, 70, 80, 2504378, 380180, 11939, 1667, 1571, 813, 253, 0, 506, 0, 0, 0, 37, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2967, 25555, 'Brutus Right Hand', '', 'LineageMonster.Death_blader', 15.00, 45.00, 77, 'male', 'L2Minion', 'Fighter', 40, 28568, 8.500, 4722, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4265, 544, 971, 398, 253, 0, 506, 1472, 0, 0, 100, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2968, 25556, 'Brutus Left Hand', '', 'LineageMonster.Death_knight', 12.00, 31.00, 77, 'male', 'L2Minion', 'Fighter', 40, 28568, 8.500, 4722, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4265, 544, 971, 398, 253, 0, 506, 142, 0, 0, 27, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2969, 25557, 'Ranger Karankawa', '', 'LineageMonster3.Jungle_Bleeze', 60.00, 47.00, 79, 'female', 'L2Monster', 'Priest', 40, 207501, 88.700, 1641, 3.000, 60, 57, 73, 76, 70, 80, 2571289, 385228, 12289, 1698, 1613, 828, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2970, 25558, 'Karankawas Root', '', 'LineageMonster.mandragora_a', 15.00, 26.00, 78, 'female', 'L2Minion', 'Fighter', 40, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2971, 25559, 'Karankawas Blossom', '', 'LineageMonster.mandragora_b', 12.00, 25.50, 78, 'female', 'L2Minion', 'Fighter', 40, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.13, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2972, 25560, 'Sargon the Mad', '', 'LineageMonster.heltor_silenos_50_bi', 19.00, 43.50, 79, 'male', 'L2Monster', 'Fighter', 40, 207501, 88.700, 1641, 3.000, 60, 57, 73, 76, 70, 80, 2571289, 385228, 12289, 1698, 1613, 828, 253, 0, 506, 135, 0, 0, 34, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2973, 25561, 'Sargon Attendant', '', 'LineageMonster.Heltor_silenos_shaman', 13.00, 32.00, 78, 'male', 'L2Minion', 'Priest', 40, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 200, 0, 0, 29, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.22, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2974, 25562, 'Sargons Squire', '', 'LineageMonster.Heltor_silenos_warrior', 13.00, 31.00, 78, 'male', 'L2Minion', 'Fighter', 40, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 228, 0, 0, 36, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2975, 25563, 'Beautiful Atrielle', '', 'LineageMonster.succubus_100_bi', 20.00, 75.00, 81, 'female', 'L2Monster', 'Mystic', 40, 211732, 90.413, 1709, 3.000, 60, 57, 73, 76, 70, 80, 2730279, 394141, 12855, 1763, 1675, 860, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.84, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2976, 25564, 'Atrielles Follower', '', 'LineageMonster.Bloody_queen', 14.00, 40.00, 80, 'female', 'L2Minion', 'Priest', 40, 32901, 8.500, 5024, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4921, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2977, 25565, 'Atrielles Minion', '', 'LineageMonster.Silhouette', 8.00, 23.00, 80, 'female', 'L2Minion', 'Fighter', 40, 32901, 8.500, 5024, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4921, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2978, 25566, 'Nagen the Tomboy', '', 'LineageMonster.pixy_bi', 10.00, 54.00, 82, 'female', 'L2Monster', 'Fighter', 40, 213849, 91.317, 1743, 3.000, 60, 57, 73, 76, 70, 80, 2819565, 398177, 13080, 1794, 1731, 876, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2979, 25567, 'Nagens Cohort', '', 'LineageMonster.Dryad', 9.00, 20.00, 81, 'female', 'L2Minion', 'Fighter', 40, 34618, 8.500, 5126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 5163, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2980, 25568, 'Nagens Friend', '', 'LineageMonster.Dryad', 9.00, 20.00, 81, 'female', 'L2Minion', 'Fighter', 40, 34618, 8.500, 5126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 5163, 588, 1175, 430, 253, 0, 506, 0, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2981, 25569, 'Jax the Destroyer', '', 'LineageMonster2.ketra_orc_chieftain_20_bi', 17.00, 46.20, 82, 'male', 'L2Monster', 'Fighter', 40, 213849, 91.317, 1743, 3.000, 60, 57, 73, 76, 70, 80, 2819565, 398177, 13080, 1794, 1731, 876, 253, 0, 506, 6719, 0, 0, 24, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.51, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2982, 25570, 'Jaxs Vanguard', '', 'LineageMonster.Ketra_orc_archer', 12.00, 27.00, 81, 'male', 'L2Minion', 'Ranger', 1100, 34618, 8.500, 5126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 5163, 588, 1175, 430, 253, 0, 506, 279, 0, 0, 45, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.91, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2983, 25571, 'Jaxs Raider', '', 'LineageMonster.Ketra_orc', 12.00, 29.00, 81, 'male', 'L2Minion', 'Fighter', 40, 34618, 8.500, 5126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 5163, 588, 1175, 430, 253, 0, 506, 68, 0, 0, 45, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2984, 25572, 'Hager the Outlaw', '', 'LineageMonster.oel_mahum_witch_doctor_50_bi', 22.50, 54.00, 72, 'male', 'L2Monster', 'Priest', 40, 192009, 83.456, 1410, 3.000, 60, 57, 73, 76, 70, 80, 2192267, 353878, 7293, 1475, 1314, 720, 253, 0, 506, 201, 0, 0, 70, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.26, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2985, 25573, 'Hagers Henchman', '', 'LineageMonster.oel_mahum_witch_doctor', 15.00, 34.00, 71, 'male', 'L2Minion', 'Priest', 40, 24927, 8.500, 4133, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3410, 482, 776, 352, 253, 0, 506, 9, 0, 0, 70, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2986, 25574, 'Hagers Bodyguard', '', 'LineageMonster.oel_mahum_warrior', 20.00, 38.00, 71, 'male', 'L2Minion', 'Fighter', 40, 24927, 8.500, 4133, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3410, 482, 776, 352, 253, 0, 506, 79, 0, 0, 70, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2987, 25575, 'All-Seeing Rango', '', 'LineageMonster3.Kernon_Raider', 42.00, 45.00, 73, 'male', 'L2Monster', 'Fighter', 40, 194342, 84.186, 1442, 3.000, 60, 57, 73, 76, 70, 80, 2234730, 360602, 7548, 1507, 1358, 735, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2988, 25576, 'Rangos Iris', '', 'LineageMonster.Monster_eye', 21.00, 43.00, 72, 'male', 'L2Minion', 'Mystic', 40, 25402, 8.500, 4230, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3534, 491, 805, 359, 253, 0, 506, 0, 0, 0, 90, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2989, 25577, 'Rangos Lens', '', 'LineageMonster.Field_stalker', 15.00, 30.00, 72, 'male', 'L2Minion', 'Fighter', 40, 25402, 8.500, 4230, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3534, 491, 805, 359, 253, 0, 506, 0, 0, 0, 70, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2990, 25578, 'Jakard', '', 'LineageMonster.hunter_gargoyle_50_bi', 37.00, 98.00, 73, 'male', 'L2Monster', 'Fighter', 40, 388685, 168.371, 1442, 3.000, 60, 57, 73, 76, 70, 80, 2234730, 360602, 7548, 1507, 1358, 735, 253, 0, 506, 0, 0, 0, 100, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2991, 25579, 'Helsing', '', 'LineageMonster3.lidia_von_helmann_120p', 14.00, 31.00, 74, 'female', 'L2Monster', 'Fighter', 40, 196620, 84.910, 1475, 3.000, 60, 57, 73, 76, 70, 80, 2280801, 367102, 8478, 1539, 1399, 751, 253, 0, 506, 0, 0, 0, 20, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2992, 25580, 'Helsings Guard', '', 'LineageMonster.Death_knight', 12.00, 31.00, 73, 'male', 'L2Minion', 'Fighter', 40, 25867, 8.500, 4327, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3658, 502, 833, 368, 253, 0, 506, 142, 0, 0, 27, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2993, 25581, 'Helsings Assassin', '', 'LineageMonster.skeleton_royal_guard', 11.00, 28.50, 73, 'male', 'L2Minion', 'Fighter', 40, 25867, 8.500, 4327, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3658, 502, 833, 368, 253, 0, 506, 229, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2994, 25582, 'Gillien', '', 'LineageMonster2.Vampire_warrior', 9.00, 31.50, 75, 'male', 'L2Monster', 'Fighter', 40, 198852, 85.635, 1508, 3.000, 60, 57, 73, 76, 70, 80, 2329614, 373311, 8764, 1571, 1437, 766, 253, 0, 506, 6723, 0, 0, 43, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2995, 25583, 'Gilliens Daughter', '', 'LineageMonster2.Vampire_wizard', 5.50, 28.00, 74, 'female', 'L2Minion', 'Mystic', 40, 26322, 8.500, 4425, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3783, 513, 861, 375, 253, 0, 506, 99, 0, 0, 46, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2996, 25584, 'Gilliens Attendant', '', 'LineageMonster2.Black_magician', 8.00, 30.00, 74, 'male', 'L2Minion', 'Mystic', 40, 26322, 8.500, 4425, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3783, 513, 861, 375, 253, 0, 506, 178, 0, 0, 19, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2997, 25585, 'Medici', '', 'LineageMonster.medusa_100_bi', 20.00, 53.00, 76, 'female', 'L2Monster', 'Fighter', 40, 201046, 86.374, 1541, 3.000, 60, 57, 73, 76, 70, 80, 2383519, 369370, 9049, 1602, 1480, 782, 253, 0, 506, 0, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2998, 25586, 'Medicis Sister', '', 'LineageMonster2.Lilim_wizard', 9.00, 34.00, 75, 'female', 'L2Minion', 'Fighter', 40, 26767, 8.500, 4523, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3910, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2999, 25587, 'Medicis Brother', '', 'LineageMonster.Skeleton_royal_guard', 11.00, 28.50, 75, 'male', 'L2Minion', 'Fighter', 40, 26767, 8.500, 4523, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3910, 523, 891, 384, 253, 0, 506, 229, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3000, 25588, 'Immortal Muus', '', 'LineageMonster.headless_knight_50_bi', 30.00, 46.50, 77, 'male', 'L2Monster', 'Fighter', 40, 406427, 174.259, 1574, 3.000, 60, 57, 73, 76, 70, 80, 2441393, 374864, 10058, 1635, 1537, 797, 253, 0, 506, 2500, 0, 0, 70, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3001, 25589, 'Brand the Exile', '', 'LineageMonster.heltor_silenos_shaman_50_bi', 19.50, 51.00, 78, 'male', 'L2Monster', 'Priest', 40, 205362, 87.904, 1607, 3.000, 60, 57, 73, 76, 70, 80, 2504378, 380180, 11939, 1667, 1571, 813, 253, 0, 506, 5131, 0, 0, 29, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.22, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3002, 25590, 'Brands Chamberlain', '', 'LineageMonster.Heltor_silenos_warrior', 13.00, 31.00, 77, 'male', 'L2Minion', 'Fighter', 40, 28568, 8.500, 4722, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4265, 544, 971, 398, 253, 0, 506, 162, 0, 0, 36, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3003, 25591, 'Brands Servant', '', 'LineageMonster.Heltor_silenos_shaman', 13.00, 32.00, 77, 'male', 'L2Minion', 'Priest', 40, 28568, 8.500, 4722, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4265, 544, 971, 398, 253, 0, 506, 200, 0, 0, 29, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.22, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3004, 25592, 'Commander Koenig', '', 'LineageMonster2.Ketra_warbeast', 20.00, 33.50, 79, 'male', 'L2Monster', 'Fighter', 40, 415001, 177.400, 1641, 3.000, 60, 57, 73, 76, 70, 80, 2571289, 385228, 12289, 1698, 1613, 828, 253, 0, 506, 0, 0, 0, 26, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3005, 25593, 'Gerg the Hunter', '', 'LineageMonster3.Elder_Troll', 46.00, 71.50, 80, 'male', 'L2Monster', 'Fighter', 40, 209635, 89.518, 1675, 3.000, 60, 57, 73, 76, 70, 80, 2643173, 390090, 12636, 1731, 1648, 845, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3006, 25594, 'Gergs Follower', '', 'LineageMonster.Virud_lizardman_scout', 10.00, 22.00, 79, 'male', 'L2Minion', 'Fighter', 1100, 31278, 8.500, 4923, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4687, 566, 1067, 415, 253, 0, 506, 2507, 0, 0, 43, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3007, 25595, 'Gergs Henchman', '', 'LineageMonster.Batur_orc', 9.00, 21.50, 79, 'male', 'L2Minion', 'Fighter', 40, 31278, 8.500, 4923, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4687, 566, 1067, 415, 253, 0, 506, 74, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3008, 25596, 'Ocular Servitor', '', 'Monster2.parasitic_eye_20_sm', 20.00, 50.50, 82, 'male', 'L2Npc', 'npc', 40, 4657, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2252, 650, 1583, 475, 253, 0, 506, 0, 0, 0, 30, 160, 'castle_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3009, 25597, 'Heurel', '', 'Monster2.erinyes', 21.00, 50.00, 82, 'male', 'L2Npc', 'npc', 40, 4657, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2252, 650, 1583, 475, 253, 0, 506, 0, 0, 0, 31, 1, 'castle_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3010, 25598, 'Gegei', '', 'Monster3.Elder_Troll', 46.00, 71.50, 82, 'male', 'L2Npc', 'npc', 40, 4657, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2252, 650, 1583, 475, 253, 0, 506, 0, 0, 0, 60, 1, 'castle_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3011, 25599, 'Iglas', '', 'Monster2.magmagoil_lad_20_sm', 12.00, 60.00, 82, 'male', 'L2Npc', 'npc', 40, 4657, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2252, 650, 1583, 475, 253, 0, 506, 0, 0, 0, 1, 1, 'castle_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3012, 25600, 'Temenir', '', 'Monster4.behamah', 25.00, 37.50, 82, 'male', 'L2Npc', 'npc', 80, 254047, 55.059, 1917, 3.000, 40, 43, 30, 21, 20, 20, 1404180, 488611, 10038, 2601, 7054, 1428, 253, 0, 506, 10277, 0, 0, 68, 180, 'castle_clan', 500, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3013, 25601, 'Draksius', '', 'Monster2.ahrimanes_20_sm', 13.00, 47.20, 82, 'male', 'L2Npc', 'npc', 80, 270971, 44.046, 1917, 3.000, 40, 43, 30, 21, 20, 20, 1463241, 575349, 9034, 3251, 6349, 2379, 253, 0, 506, 6722, 0, 0, 35, 185, 'castle_clan', 500, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3014, 25602, 'Kiretcenah', '', 'Monster.rakul', 30.00, 39.00, 82, 'male', 'L2Npc', 'npc', 40, 254047, 55.059, 1917, 3.000, 40, 43, 30, 21, 20, 20, 1384493, 459564, 10038, 1300, 7054, 1903, 253, 0, 506, 9442, 0, 0, 60, 150, 'castle_clan', 500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3015, 25603, 'Darion', '', 'Monster4.darion', 50.00, 81.22, 84, 'male', 'L2Npc', 'npc', 80, 970000, 100.000, 1917, 3.000, 60, 57, 73, 76, 70, 80, 4712139, 598881, 5455, 1950, 2232, 952, 253, 0, 506, 0, 10548, 0, 44, 220, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.44, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3016, 25604, 'Mutated Elpy', '', 'Monster.elpy', 5.00, 4.50, 50, 'male', 'L2Npc', 'npc', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 425, 278, 291, 204, 253, 0, 506, 0, 0, 0, 50, 80, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3017, 25605, 'Naia Spore', '', 'Monster4.guard_naia_b1t', 17.00, 9.00, 82, 'male', 'L2Monster', 'NaiaSpore', 40, 18606, 187.410, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3765, 1007, 3121, 1106, 253, 0, 506, 0, 0, 0, 40, 80, 'castle_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3018, 25606, 'Naia Spore', '', 'Monster4.guard_naia_b2t', 12.00, 27.00, 82, 'female', 'L2Monster', 'NaiaSpore', 40, 18606, 187.410, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3765, 1007, 3121, 1106, 253, 0, 506, 0, 0, 0, 40, 80, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3019, 25607, 'Naia Spore', '', 'Monster4.guard_naia_b3t', 11.00, 35.00, 82, 'female', 'L2Monster', 'NaiaSpore', 40, 18606, 187.410, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3765, 1007, 3121, 1106, 253, 0, 506, 0, 0, 0, 40, 80, 'castle_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3020, 25608, 'Naia Spore', '', 'Monster4.guard_naia_b4t', 20.00, 31.00, 82, 'male', 'L2Monster', 'NaiaSpore', 40, 18606, 187.410, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3765, 1007, 3121, 1106, 253, 0, 506, 0, 0, 0, 23, 80, 'castle_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3021, 25609, 'Epidos', '', 'Monster4.guard_naia_c', 60.00, 99.50, 82, 'male', 'L2Npc', 'npc', 40, 986097, 287.940, 1917, 3.000, 60, 57, 73, 76, 70, 80, 13455636, 2851570, 9918, 1949, 8217, 1428, 253, 0, 506, 0, 0, 0, 100, 100, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.53, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3022, 25610, 'Epidos', '', 'Monster4.guard_naia_c', 60.00, 99.50, 82, 'male', 'L2Npc', 'npc', 40, 986097, 287.940, 1917, 3.000, 60, 57, 73, 76, 70, 80, 13455636, 2851570, 9918, 1949, 8217, 1428, 253, 0, 506, 0, 0, 0, 100, 100, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.53, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3023, 25611, 'Epidos', '', 'Monster4.guard_naia_c', 60.00, 99.50, 82, 'male', 'L2Npc', 'npc', 40, 986097, 287.940, 1917, 3.000, 60, 57, 73, 76, 70, 80, 13455636, 2851570, 9918, 1949, 8217, 1428, 253, 0, 506, 0, 0, 0, 100, 100, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.53, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3024, 25612, 'Epidos', '', 'Monster4.guard_naia_c', 60.00, 99.50, 82, 'male', 'L2Npc', 'npc', 40, 986097, 287.940, 1917, 3.000, 60, 57, 73, 76, 70, 80, 13455636, 2851570, 9918, 1949, 8217, 1428, 253, 0, 506, 0, 0, 0, 100, 100, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.53, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3025, 25613, 'Naia Spore', '', 'Monster4.guard_naia_a', 8.50, 25.00, 83, 'male', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1429, 461, 253, 0, 506, 0, 0, 0, 40, 80, 'castle_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3026, 25614, 'Floating Ghost', '', 'Monster4.roaming_Msoul', 6.00, 26.00, 82, 'male', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 629, 1438, 460, 253, 0, 506, 0, 0, 0, 50, 50, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3027, 25615, 'Floating Ghost', '', 'Monster4.roaming_Fsoul', 8.00, 25.50, 82, 'female', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 629, 1438, 460, 253, 0, 506, 0, 0, 0, 50, 50, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3028, 25616, 'Lost Warden', '', 'LineageMonster.oel_mahum_witch_doctor', 15.00, 34.00, 29, 'male', 'L2SpecialMonster', 'Fighter', 40, 42937, 24.148, 315, 1.500, 60, 57, 73, 76, 70, 80, 821000, 36456, 256, 407, 175, 198, 253, 600, 506, 201, 0, 0, 70, 130, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.26, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3029, 25617, 'Lost Warden', '', 'LineageMonster.zenta_lizardman_matriarch', 20.00, 40.00, 39, 'male', 'L2SpecialMonster', 'Fighter', 40, 68563, 35.311, 463, 1.800, 60, 57, 73, 76, 70, 80, 695958, 60594, 586, 585, 399, 285, 253, 600, 506, 221, 0, 0, 53, 140, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.46, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3030, 25618, 'Lost Warden', '', 'LineageMonster.gargoyle_bi', 16.00, 65.00, 49, 'male', 'L2SpecialMonster', 'Fighter', 40, 109736, 52.817, 720, 2.100, 60, 57, 73, 76, 70, 80, 814824, 99743, 1238, 810, 846, 395, 253, 600, 506, 0, 0, 0, 140, 140, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.37, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3031, 25619, 'Lost Warden', '', 'LineageMonster.death_knight_120p', 22.00, 35.30, 59, 'male', 'L2SpecialMonster', 'Fighter', 40, 154030, 70.199, 1007, 2.400, 60, 57, 73, 76, 70, 80, 939496, 133511, 2331, 1077, 1591, 525, 253, 600, 506, 75, 0, 0, 33, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.71, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3032, 25620, 'Lost Warden', '', 'LineageMonster2.eligor', 21.00, 35.00, 69, 'male', 'L2SpecialMonster', 'Fighter', 40, 186878, 81.164, 1314, 2.700, 60, 57, 73, 76, 70, 80, 1039378, 166225, 3768, 1379, 2574, 673, 253, 600, 506, 0, 0, 0, 35, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3033, 25621, 'Lost Warden', '', 'LineageMonster3.apostle_grail', 13.00, 47.00, 78, 'male', 'L2SpecialMonster', 'Fighter', 80, 207940, 87.909, 1607, 3.000, 60, 57, 73, 76, 70, 80, 1252189, 190090, 4988, 1667, 3407, 813, 253, 600, 506, 8221, 0, 0, 30, 200, '', 300, 0, 0, 0, 7, 30, 4, 0, 0, -18, 0.43, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3034, 25622, 'Lost Warden', '', 'LineageMonster.death_lord', 21.00, 40.00, 81, 'male', 'L2SpecialMonster', 'Fighter', 40, 214389, 90.418, 1709, 3.000, 60, 57, 73, 76, 70, 80, 1365139, 197071, 5289, 1763, 3613, 860, 253, 600, 506, 78, 0, 0, 40, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3035, 25623, 'Valdstone', '', 'LineageMonster4.master_rider', 123.00, 90.00, 80, 'male', 'L2Npc', 'npc', 40, 309908, 33.248, 1675, 3.000, 60, 57, 73, 76, 70, 80, 3539613, 991696, 1004, 1558, 194, 761, 253, 0, 506, 0, 0, 0, 60, 300, 'masterrider_clan', 1000, 0, 0, 0, 4, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3036, 25624, 'Rok', '', 'LineageMonster4.loc', 197.00, 130.50, 80, 'female', 'L2RaidBoss', 'Mystic', 40, 319298, 34.255, 1777, 3.000, 60, 57, 73, 76, 70, 80, 3658390, 1026322, 1053, 1643, 211, 801, 253, 0, 506, 0, 0, 0, 60, 300, 'loc_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (3037, 25625, 'Enira', '', 'LineageMonster4.banshee_queen', 11.00, 33.50, 80, 'female', 'L2Npc', 'npc', 40, 325716, 34.944, 1847, 3.000, 60, 57, 73, 76, 70, 80, 3745534, 1082907, 1087, 1700, 223, 830, 253, 0, 506, 0, 0, 0, 60, 300, 'bansheequeen_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3038, 25626, 'Dius', '', 'LineageMonster4.mutant_drake_wing', 112.00, 60.00, 80, 'male', 'L2Npc', 'npc', 40, 325716, 34.944, 1847, 3.000, 40, 43, 30, 21, 20, 20, 3745534, 1082907, 1087, 1700, 223, 830, 253, 0, 506, 0, 0, 0, 60, 300, 'mutantdrakewing_clan', 1000, 0, 0, 0, 5, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3039, 25627, 'Mutant Bird', '', 'LineageMonster4.mutant_hawk', 100.00, 85.00, 75, 'male', 'L2Npc', 'npc', 40, 57630, 7.789, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 704, 707, 169, 689, 253, 0, 506, 0, 0, 0, 60, 300, 'loc_clan', 1000, 0, 0, 0, 3, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3040, 25628, 'Dra Hawk', '', 'LineageMonster4.drahawk', 110.00, 35.00, 76, 'female', 'L2Npc', 'npc', 40, 58592, 7.901, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 726, 721, 173, 703, 253, 0, 506, 0, 0, 0, 60, 300, 'loc_clan', 1000, 0, 0, 0, 4, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3041, 25629, 'Floating Skull', '', 'LineageMonster4.floating_skeleton', 28.00, 39.00, 78, 'male', 'L2Npc', 'npc', 40, 60371, 8.114, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 767, 750, 185, 731, 253, 0, 506, 0, 0, 0, 45, 300, 'bansheequeen_clan', 1000, 0, 0, 0, 3, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3042, 25630, 'Floating Zombie', '', 'LineageMonster4.floating_zombie', 70.00, 50.00, 77, 'female', 'L2Npc', 'npc', 40, 59504, 8.009, 1574, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 747, 735, 181, 717, 253, 0, 506, 0, 0, 0, 60, 300, 'bansheequeen_clan', 1000, 0, 0, 0, 5, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3043, 25631, 'Drake Wing', '', 'LineageMonster4.m_drake_wing_knave', 153.00, 63.00, 77, 'male', 'L2Npc', 'npc', 40, 59504, 8.009, 1574, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 747, 735, 181, 717, 253, 0, 506, 0, 0, 0, 60, 300, 'mutantdrakewing_clan', 1000, 0, 0, 0, 3, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3044, 25632, 'Drak', '', 'LineageMonster4.drac', 100.00, 40.00, 78, 'female', 'L2Minion', 'Fighter', 40, 60371, 8.114, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 767, 750, 185, 731, 253, 0, 506, 0, 0, 0, 60, 300, 'mutantdrakewing_clan', 1000, 0, 0, 0, 5, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3045, 25633, 'Elite Rider', '', 'LineageMonster4.master_rider', 123.00, 90.00, 76, 'male', 'L2Minion', 'Fighter', 40, 58592, 7.901, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 726, 721, 173, 703, 253, 0, 506, 0, 0, 0, 60, 300, 'masterrider_clan', 1000, 0, 0, 0, 4, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3046, 25634, 'Cohemenes', '', 'LineageMonster4.lich_A_132p', 31.68, 60.72, 81, 'male', 'L2RaidBoss', 'Cohemenes', 40, 436295, 186.306, 1812, 3.000, 60, 57, 73, 76, 70, 80, 3004658, 406483, 3089, 1858, 1824, 906, 253, 0, 506, 0, 0, 0, 46, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3047, 25635, 'Argekunte', '', 'LineageMonster4.lich_A_132p', 24.00, 40.80, 81, 'male', 'L2RaidBoss', 'Fighter', 40, 436295, 186.306, 1812, 3.000, 60, 57, 73, 76, 70, 80, 3004658, 406483, 3089, 1858, 1824, 906, 253, 0, 506, 13985, 13986, 0, 80, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3048, 25636, 'Ravenous Soul Devourer', '', 'LineageMonster4.soul_wagon_130p', 70.00, 44.20, 81, 'male', 'L2Npc', 'npc', 40, 440658, 188.169, 1847, 3.000, 60, 57, 73, 76, 70, 80, 3100452, 410692, 3138, 1889, 1877, 921, 253, 0, 506, 0, 0, 0, 110, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.44, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3049, 25637, 'Karpencharr', '', 'LineageMonster4.lich_A_132p', 31.68, 60.72, 81, 'male', 'L2Npc', 'npc', 40, 440658, 188.169, 1847, 3.000, 60, 57, 73, 76, 70, 80, 3100452, 410692, 3138, 1889, 1877, 921, 253, 0, 506, 0, 0, 0, 46, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3050, 25638, 'Romerohiv', '', 'LineageMonster4.lich_b_132p', 31.68, 60.72, 81, 'male', 'L2Npc', 'npc', 40, 440658, 188.169, 1847, 3.000, 60, 57, 73, 76, 70, 80, 3100452, 410692, 3138, 1889, 1877, 921, 253, 0, 506, 0, 0, 0, 46, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3051, 25639, 'Hitchkarshiek', '', 'LineageMonster4.Death_slayer_120p', 24.00, 40.80, 81, 'male', 'L2Npc', 'npc', 40, 440658, 188.169, 1847, 3.000, 60, 57, 73, 76, 70, 80, 3100452, 410692, 3138, 1889, 1877, 921, 253, 0, 506, 13985, 13986, 0, 80, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3052, 25640, 'Freedkyilla', '', 'LineageMonster4.Death_slayer_120p', 24.00, 40.80, 81, 'male', 'L2Npc', 'npc', 40, 440658, 188.169, 1847, 3.000, 60, 57, 73, 76, 70, 80, 3100452, 410692, 3138, 1889, 1877, 921, 253, 0, 506, 13984, 0, 0, 80, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3053, 25641, 'Yehan Cravenizad', '', 'LineageMonster4.death_knight_n_156p', 34.32, 62.40, 81, 'male', 'L2Npc', 'npc', 80, 440658, 188.169, 1847, 3.000, 60, 57, 73, 76, 70, 80, 3100452, 410692, 3138, 1889, 1877, 921, 253, 0, 506, 13982, 0, 0, 73, 180, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3054, 25642, 'Yehan Jaxsibhan', '', 'LineageMonster4.death_knight_n_156p', 34.32, 62.40, 81, 'male', 'L2Npc', 'npc', 80, 440658, 188.169, 1847, 3.000, 60, 57, 73, 76, 70, 80, 3100452, 410692, 3138, 1889, 1877, 921, 253, 0, 506, 13983, 0, 0, 73, 180, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3055, 25643, 'Awakened Ancient Sentry', '', 'LineageMonster4.death_scout_110p', 18.00, 27.50, 81, 'female', 'L2Npc', 'npc', 40, 440658, 188.169, 1847, 3.000, 60, 57, 73, 76, 70, 80, 3100452, 410692, 3138, 1889, 1877, 921, 253, 0, 506, 0, 0, 0, 45, 160, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3056, 25644, 'Awakened Ancient Severer', '', 'LineageMonster4.bonecreeper_120p', 51.60, 57.00, 81, 'male', 'L2Npc', 'npc', 40, 440658, 188.169, 1847, 3.000, 60, 57, 73, 76, 70, 80, 3100452, 410692, 3138, 1889, 1877, 921, 253, 0, 506, 0, 0, 0, 60, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3057, 25645, 'Awakened Ancient Soul Extractor', '', 'LineageMonster4.soul_harvester_120p', 27.60, 37.20, 81, 'male', 'L2Npc', 'npc', 40, 440658, 188.169, 1847, 3.000, 60, 57, 73, 76, 70, 80, 3100452, 410692, 3138, 1889, 1877, 921, 253, 0, 506, 0, 0, 0, 46, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3058, 25646, 'Awakened Ancient Soul Devourer', '', 'LineageMonster4.soul_wagon_130p', 70.00, 44.20, 81, 'male', 'L2Npc', 'npc', 40, 440658, 188.169, 1847, 3.000, 60, 57, 73, 76, 70, 80, 3100452, 410692, 3138, 1889, 1877, 921, 253, 0, 506, 0, 0, 0, 110, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.44, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3059, 25647, 'Awakened Ancient Fighter', '', 'LineageMonster4.death_knight_n_156p', 34.32, 62.40, 81, 'male', 'L2Npc', 'npc', 80, 440658, 188.169, 1847, 3.000, 60, 57, 73, 76, 70, 80, 3100452, 410692, 3138, 1889, 1877, 921, 253, 0, 506, 13982, 0, 0, 73, 180, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3060, 25648, 'Awakened Ancient Fighter', '', 'LineageMonster4.death_knight_n_156p', 34.32, 62.40, 81, 'male', 'L2Npc', 'npc', 80, 440658, 188.169, 1847, 3.000, 60, 57, 73, 76, 70, 80, 3100452, 410692, 3138, 1889, 1877, 921, 253, 0, 506, 13983, 0, 0, 73, 180, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3061, 25649, 'Awakened Ancient Executor', '', 'LineageMonster4.Death_slayer_120p', 24.00, 40.80, 81, 'male', 'L2Npc', 'npc', 40, 440658, 188.169, 1847, 3.000, 60, 57, 73, 76, 70, 80, 3100452, 410692, 3138, 1889, 1877, 921, 253, 0, 506, 13985, 13986, 0, 80, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3062, 25650, 'Awakened Ancient Executor', '', 'LineageMonster4.Death_slayer_120p', 24.00, 40.80, 81, 'male', 'L2Npc', 'npc', 40, 440658, 188.169, 1847, 3.000, 60, 57, 73, 76, 70, 80, 3100452, 410692, 3138, 1889, 1877, 921, 253, 0, 506, 13984, 0, 0, 80, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3063, 25651, 'Awakened Ancient Prophet', '', 'LineageMonster4.lich_A_132p', 31.68, 60.72, 81, 'male', 'L2Npc', 'npc', 40, 440658, 188.169, 1847, 3.000, 60, 57, 73, 76, 70, 80, 3100452, 410692, 3138, 1889, 1877, 921, 253, 0, 506, 0, 0, 0, 46, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3064, 25652, 'Awakened Ancient Prophet', '', 'LineageMonster4.lich_b_132p', 31.68, 60.72, 81, 'male', 'L2Npc', 'npc', 40, 440658, 188.169, 1847, 3.000, 60, 57, 73, 76, 70, 80, 3100452, 410692, 3138, 1889, 1877, 921, 253, 0, 506, 0, 0, 0, 46, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3065, 25653, 'Kanadis Herald', '', 'LineageMonster4.pailaka_invader', 30.00, 33.00, 81, 'male', 'L2Npc', 'npc', 80, 423463, 180.826, 1709, 3.000, 60, 57, 73, 76, 70, 80, 2730279, 394141, 2946, 1763, 1675, 860, 253, 0, 506, 0, 0, 0, 60, 200, 'rune_pailaka_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, -18, 0.58, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3066, 25654, 'Kanadis Herald', '', 'LineageMonster4.pailaka_invader', 30.00, 33.00, 83, 'male', 'L2Npc', 'npc', 40, 431975, 184.461, 1777, 3.000, 60, 57, 73, 76, 70, 80, 2911026, 402310, 3041, 1827, 1761, 891, 253, 0, 506, 0, 0, 0, 60, 200, 'rune_pailaka_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3067, 25655, 'Kanadis Herald', '', 'LineageMonster4.pailaka_invader', 30.00, 33.00, 85, 'male', 'L2Npc', 'npc', 40, 440658, 188.169, 1847, 3.000, 60, 57, 73, 76, 70, 80, 3100452, 410692, 3137, 1888, 1832, 920, 253, 0, 506, 0, 0, 0, 60, 200, 'rune_pailaka_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3068, 25656, 'Kanadis Fanatic', '', 'LineageMonster3.solina_brother', 9.00, 23.40, 79, 'male', 'L2Npc', 'npc', 80, 8711, 115.221, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 8262, 2265, 5946, 828, 253, 0, 506, 152, 0, 0, 61, 220, 'rune_pailaka_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3069, 25657, 'Kanadis Fanatic', '', 'LineageMonster3.solina_brother', 9.00, 23.40, 81, 'male', 'L2Npc', 'npc', 40, 8761, 114.516, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 8724, 2349, 6278, 860, 253, 0, 506, 8212, 0, 0, 61, 220, 'rune_pailaka_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3070, 25658, 'Kanadis Fanatic', '', 'LineageMonster3.solina_brother', 9.00, 23.40, 83, 'male', 'L2Npc', 'npc', 40, 8790, 113.563, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9352, 2434, 6859, 891, 253, 0, 506, 0, 0, 0, 61, 220, 'rune_pailaka_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3071, 25659, 'Kanadis Guide', '', 'LineageMonster4.pailaka_invader', 30.00, 33.00, 77, 'male', 'L2Npc', 'npc', 80, 406427, 174.259, 1574, 3.000, 60, 57, 73, 76, 70, 80, 2588731, 332450, 2709, 1635, 1537, 797, 253, 0, 506, 0, 0, 0, 60, 200, 'rune_pailaka_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, -18, 0.58, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3072, 25660, 'Kanadis Guide', '', 'LineageMonster4.pailaka_invader', 30.00, 33.00, 80, 'male', 'L2Npc', 'npc', 40, 419271, 179.036, 1675, 3.000, 60, 57, 73, 76, 70, 80, 2706503, 353878, 2900, 1731, 1648, 845, 253, 0, 506, 0, 0, 0, 60, 200, 'rune_pailaka_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3073, 25661, 'Kanadis Guide', '', 'LineageMonster4.pailaka_invader', 30.00, 33.00, 83, 'male', 'L2Npc', 'npc', 40, 431975, 184.461, 1777, 3.000, 60, 57, 73, 76, 70, 80, 2853104, 373311, 3041, 1827, 1761, 891, 253, 0, 506, 0, 0, 0, 60, 200, 'rune_pailaka_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3074, 25662, 'Kanadis Follower', '', 'LineageMonster3.solina_brother', 9.00, 23.40, 75, 'male', 'L2Npc', 'npc', 80, 8552, 115.880, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 7213, 2094, 5114, 766, 253, 0, 506, 152, 0, 0, 61, 220, 'rune_pailaka_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3075, 25663, 'Kanadis Follower', '', 'LineageMonster3.solina_brother', 9.00, 23.40, 78, 'male', 'L2Npc', 'npc', 40, 8678, 115.482, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 8001, 2223, 5738, 813, 253, 0, 506, 8212, 0, 0, 61, 220, 'rune_pailaka_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3076, 25664, 'Kanadis Follower', '', 'LineageMonster3.solina_brother', 9.00, 23.40, 81, 'male', 'L2Npc', 'npc', 40, 8761, 114.516, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 8724, 2349, 6278, 860, 253, 0, 506, 0, 0, 0, 61, 220, 'rune_pailaka_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3077, 25665, 'Yehan Klodekus', '', 'LineageMonster4.death_knight_n_raid', 34.32, 62.40, 81, 'male', 'HoSBoss', 'HallOfSufferingBoss', 80, 148936, 53.219, 1743, 3.000, 60, 57, 73, 76, 70, 80, 5044000, 1152586, 3660, 1197, 2761, 876, 253, 500, 506, 13982, 0, 0, 73, 180, 'aceed_clan', 1500, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3078, 25666, 'Yehan Klanikus', '', 'LineageMonster4.death_knight_n_raid', 34.32, 62.40, 81, 'male', 'HoSBoss', 'HallOfSufferingBoss', 80, 148936, 53.219, 1743, 3.000, 60, 57, 73, 76, 70, 80, 5044000, 1152586, 3660, 1197, 2761, 876, 253, 500, 506, 13983, 0, 0, 73, 180, 'aceed_clan', 1500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3079, 25667, 'Cannibalistic Stakato Chief', '', 'LineageMonster3.cannibal_stakato_leader_80p', 34.00, 40.00, 82, 'male', 'L2RaidBoss', 'StakatoCheif', 40, 436295, 18.631, 1812, 3.000, 60, 57, 73, 76, 70, 80, 4292368, 580689, 5204, 1857, 2088, 906, 253, 0, 506, 0, 0, 0, 40, 200, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3080, 25668, 'Cannibalistic Stakato Chief', '', 'LineageMonster3.cannibal_stakato_leader_80p', 34.00, 40.00, 82, 'male', 'L2RaidBoss', 'StakatoCheif', 40, 436295, 18.631, 1812, 3.000, 60, 57, 73, 76, 70, 80, 4292368, 580689, 5204, 1857, 2088, 906, 253, 0, 506, 0, 0, 0, 40, 200, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3081, 25669, 'Cannibalistic Stakato Chief', '', 'LineageMonster3.cannibal_stakato_leader_80p', 34.00, 40.00, 82, 'male', 'L2RaidBoss', 'StakatoCheif', 40, 373967, 18.631, 1812, 3.000, 60, 57, 73, 76, 70, 80, 4292368, 580689, 5204, 1857, 2088, 906, 253, 0, 506, 0, 0, 0, 40, 200, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3082, 25670, 'Cannibalistic Stakato Chief', '', 'LineageMonster3.cannibal_stakato_leader_80p', 34.00, 40.00, 82, 'male', 'L2RaidBoss', 'StakatoCheif', 40, 373967, 18.631, 1812, 3.000, 60, 57, 73, 76, 70, 80, 4292368, 580689, 5204, 1857, 2088, 906, 253, 0, 506, 0, 0, 0, 40, 200, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3083, 25671, 'Queen Shyeed', '', 'LineageMonster3.cannibal_stakato_leader_tran_120p', 45.00, 50.80, 84, 'male', 'L2RaidBoss', 'QueenShyeed', 40, 312522, 96.088, 1812, 3.000, 60, 57, 73, 76, 70, 80, 4292368, 580689, 2602, 1858, 516, 907, 253, 0, 506, 0, 0, 0, 45, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3084, 25672, 'Spiked Stakato', '', 'spike_stakato_110p', 13.00, 21.00, 84, 'male', 'L2Minion', 'Fighter', 40, 33502, 96.088, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 6939, 929, 3669, 907, 253, 0, 506, 123, 0, 0, 23, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3085, 25673, 'Spiked Stakato', '', 'spike_stakato_worker_110p', 13.00, 22.20, 84, 'male', 'L2Minion', 'Fighter', 40, 50003, 96.088, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 10408, 929, 8256, 907, 253, 0, 506, 0, 0, 0, 23, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3086, 25674, 'Gwindorr', '', 'LineageMonster.serpent_slave', 17.00, 46.00, 83, 'male', 'L2Npc', 'npc', 40, 309427, 95.137, 1777, 3.000, 60, 57, 73, 76, 70, 80, 4158609, 574729, 5122, 1827, 507, 891, 253, 0, 506, 129, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3087, 25675, 'Guard of Gwindorr', '', 'LineageMonster.virud_lizardman_scout', 10.00, 22.00, 82, 'male', 'L2Npc', 'npc', 1100, 32842, 94.195, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 6724, 898, 3541, 876, 253, 0, 506, 2507, 0, 0, 43, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3088, 25676, 'Follower of Gwindorr', '', 'LineageMonster.virud_lizardman', 10.00, 23.00, 82, 'male', 'L2Npc', 'npc', 40, 49018, 94.195, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 10086, 898, 7970, 876, 253, 0, 506, 2, 0, 0, 43, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3089, 25677, 'Water Spirit Lian', '', 'LineageMonster.pixy_bi', 10.00, 54.00, 84, 'female', 'L2Npc', 'npc', 40, 312522, 96.088, 1812, 3.000, 60, 57, 73, 76, 70, 80, 4292368, 580689, 5204, 1858, 2064, 907, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3090, 25678, 'Sprite of Gildor', '', 'LineageMonster.pixy', 5.00, 25.00, 83, 'female', 'L2Npc', 'npc', 40, 33171, 95.137, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 6830, 913, 3603, 891, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3091, 25679, 'Guardian of Gildor', '', 'LineageMonster.pixy', 5.00, 25.00, 83, 'female', 'L2Npc', 'npc', 40, 49508, 95.137, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 10246, 913, 8108, 891, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3092, 25680, 'Giant Marpanak', '', 'lesser_giant_100_bi', 50.00, 91.00, 82, 'male', 'L2RaidBoss', 'Fighter', 40, 855235, 328.668, 1743, 3.000, 60, 57, 73, 76, 70, 80, 5553283, 1249267, 9321, 1794, 6826, 876, 253, 0, 506, 3937, 0, 0, 15, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3093, 25681, 'Gorgolos', '', 'LineageMonster.hunter_gargoyle', 25.00, 65.00, 82, 'male', 'L2RaidBoss', 'Fighter', 40, 306364, 94.195, 1743, 3.000, 60, 57, 73, 76, 70, 80, 4027950, 568824, 5043, 898, 3541, 876, 253, 0, 506, 0, 0, 0, 100, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3094, 25682, 'Cursed Life', '', 'LineageMonster.gargoyle_bi', 16.00, 65.00, 82, 'male', 'L2Minion', 'Fighter', 40, 32842, 94.195, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 6724, 898, 7970, 876, 253, 0, 506, 0, 0, 0, 140, 140, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3095, 25683, 'Cursed Soul', '', 'LineageMonster.gargoyle_bi', 16.00, 65.00, 82, 'male', 'L2Minion', 'Fighter', 40, 49018, 94.195, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 10086, 898, 7970, 876, 253, 0, 506, 0, 0, 0, 140, 140, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3096, 25684, 'Last Titan Utenus', '', 'lesser_giant_mage', 50.00, 66.00, 83, 'male', 'L2RaidBoss', 'Fighter', 40, 309427, 95.137, 1777, 3.000, 60, 57, 73, 76, 70, 80, 4158609, 574729, 5122, 1827, 2028, 891, 253, 0, 506, 3938, 0, 0, 15, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3097, 25685, 'Utenuss Wizard', '', 'lesser_giant', 50.00, 91.00, 82, 'male', 'L2Minion', 'Mystic', 40, 32842, 94.195, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 6724, 898, 3541, 876, 253, 0, 506, 0, 0, 0, 15, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3098, 25686, 'Utenuss Guard', '', 'leogul', 15.00, 35.00, 82, 'male', 'L2Minion', 'Fighter', 40, 49018, 94.195, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 10086, 898, 7970, 876, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3099, 25687, 'Hekaton Prime', '', 'susceptor', 20.00, 35.00, 83, 'male', 'L2RaidBoss', 'Fighter', 40, 431894, 132.782, 1777, 3.000, 60, 57, 73, 76, 70, 80, 5614732, 1265702, 4735, 1827, 6945, 891, 253, 0, 506, 0, 0, 0, 27, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3100, 25688, 'Hekaton Cottus', '', 'gamlin', 11.00, 32.00, 83, 'male', 'L2Minion', 'Fighter', 40, 46299, 132.782, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12625, 913, 12348, 891, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3101, 25689, 'Hekaton Chires', '', 'lesser_giant', 31.50, 69.00, 83, 'male', 'L2Minion', 'Fighter', 40, 69103, 132.782, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 18937, 913, 27781, 891, 253, 0, 506, 3937, 0, 0, 15, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3102, 25690, 'Aenkinel', '', 'LineageMonster5.leader_anakazel_low', 30.00, 31.50, 81, 'male', 'L2RaidBoss', 'Aenkinel', 40, 436295, 186.306, 18120, 30.000, 60, 57, 73, 76, 70, 80, 3327991, 394141, 3035, 1826, 1761, 891, 253, 0, 506, 0, 0, 0, 25, 150, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3103, 25691, 'Aenkinel', '', 'LineageMonster5.leader_anakazel_low', 30.00, 31.50, 81, 'male', 'L2RaidBoss', 'Aenkinel', 40, 436295, 186.306, 18120, 30.000, 60, 57, 73, 76, 70, 80, 3327991, 394141, 3035, 1826, 1761, 891, 253, 0, 506, 0, 0, 0, 25, 150, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3104, 25692, 'Aenkinel', '', 'LineageMonster5.leader_anakazel_low', 30.00, 31.50, 81, 'male', 'L2RaidBoss', 'Aenkinel', 40, 436295, 186.306, 18120, 30.000, 60, 57, 73, 76, 70, 80, 3327991, 394141, 3035, 1826, 1761, 891, 253, 0, 506, 0, 0, 0, 25, 150, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3105, 25693, 'Aenkinel', '', 'LineageMonster5.leader_anakazel_low', 30.00, 31.50, 81, 'male', 'L2RaidBoss', 'Aenkinel', 40, 436295, 186.306, 18120, 30.000, 60, 57, 73, 76, 70, 80, 3327991, 394141, 3035, 1826, 1761, 891, 253, 0, 506, 0, 0, 0, 25, 150, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3106, 25694, 'Aenkinel', '', 'LineageMonster5.leader_anakazel_low', 14.00, 28.00, 82, 'male', 'L2RaidBoss', 'Aenkinel', 40, 436295, 186.306, 18120, 30.000, 60, 57, 73, 76, 70, 80, 37775744, 1117041, 3052, 1837, 1772, 896, 253, 0, 506, 0, 0, 0, 60, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3107, 25695, 'Aenkinel', '', 'LineageMonster5.leader_anakazel_high', 21.00, 40.00, 84, 'male', 'L2RaidBoss', 'Aenkinel', 40, 449515, 191.951, 19170, 30.000, 60, 57, 73, 76, 70, 80, 42720364, 1206690, 3183, 1917, 1874, 936, 253, 1500, 506, 0, 0, 0, 50, 140, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3108, 25696, 'Taklacan', '', 'LineageMonster5.tarcrakahn_e', 40.00, 57.00, 85, 'male', 'L2ReflectionBoss', 'Mystic', 40, 763865, 242.622, 18468, 300.000, 60, 57, 73, 76, 70, 80, 3078749, 399008, 19759, 30415, 2111, 14837, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3109, 25697, 'Torumba', '', 'beast', 40.00, 64.00, 85, 'male', 'L2Npc', 'npc', 40, 6312935, 242.622, 18468, 300.000, 60, 57, 73, 76, 70, 80, 0, 0, 5286, 1888, 2111, 920, 253, 300, 506, 0, 0, 0, 23, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3110, 25698, 'Dopagen', '', 'LineageMonster5.dorpagen_e', 45.00, 75.00, 85, 'male', 'L2ReflectionBoss', 'Mystic', 40, 631294, 242.622, 18468, 300.000, 60, 57, 73, 76, 70, 80, 3233771, 403115, 19759, 30415, 2111, 14837, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3111, 25699, 'Glakias', '', 'LineageMonster5.ice_heavy_knight', 28.00, 67.50, 85, 'male', 'L2Boss', 'Glakias', 40, 780462, 139.121, 18468, 500.000, 60, 57, 73, 76, 70, 80, 0, 0, 14240, 3264, 4487, 1115, 253, 0, 506, 0, 0, 0, 40, 120, 'freya_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3112, 25700, 'Glakias', '', 'LineageMonster5.ice_heavy_knight', 28.00, 67.50, 85, 'male', 'L2Boss', 'Glakias', 40, 15015056, 1947.687, 92340, 500.000, 60, 57, 73, 76, 70, 80, 0, 0, 37842, 3591, 6570, 1895, 253, 0, 506, 0, 0, 0, 40, 120, 'freya_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 4, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3113, 25701, 'Anays', '', 'divine', 24.00, 55.00, 84, 'male', 'L2RaidBoss', 'Anais', 40, 937565, 240.220, 21812, 500.000, 60, 57, 73, 76, 70, 80, 6653170, 900069, 19194, 2472, 2064, 996, 253, 300, 506, 8214, 0, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3114, 25702, 'Guard of the Grail', '', 'construct', 13.00, 22.00, 84, 'male', 'L2Monster', 'Fighter', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 300, 506, 0, 0, 0, 25, 140, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.10, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3115, 25703, 'Gigantic Golem', '', 'chaos_golem', 31.00, 51.80, 76, 'male', 'L2RaidBoss', 'Fighter', 40, 402093, 172.748, 15408, 300.000, 60, 57, 73, 76, 70, 80, 3429147, 530149, 14911, 1602, 1480, 782, 253, 0, 506, 0, 0, 0, 18, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.43, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3116, 25704, 'Gigantic Golem Subordinate', '', 'LineageMonster3.golem_guardian', 18.00, 41.50, 75, 'male', 'L2Minion', 'Fighter', 40, 4605, 62.397, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3890, 2094, 1487, 766, 253, 0, 506, 0, 0, 0, 53, 200, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3117, 25705, 'Gigantic Boom Golem', '', 'LineageMonster.big_boom_e', 6.00, 13.00, 74, 'male', 'L2Minion', 'Fighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 48, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3118, 25706, 'Lost Watcher', '', 'humanoid', 27.00, 48.50, 83, 'male', 'L2Monster', 'Fighter', 40, 56203, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15977, 974, 10910, 1068, 253, 300, 506, 0, 0, 0, 92, 200, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3119, 25707, 'Lost Watcher', '', 'LineageMonster4.ravager_silen', 27.00, 48.50, 83, 'male', 'L2SpecialMonster', 'Fighter', 40, 56203, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15977, 974, 10910, 1068, 253, 0, 506, 0, 0, 0, 92, 200, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3120, 25708, 'Lost Beholder', '', 'LineageMonster4.Death_slayer_080p', 16.00, 27.20, 83, 'male', 'L2SpecialMonster', 'Fighter', 40, 112316, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15588, 974, 10645, 1068, 253, 0, 506, 0, 0, 0, 64, 200, 'abyss_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3121, 25709, 'Lost Warden', '', 'LineageMonster4.bonecreeper_120p', 51.60, 57.00, 83, 'male', 'L2SpecialMonster', 'Fighter', 40, 618855, 237.842, 1777, 20.000, 60, 57, 73, 76, 70, 80, 1455513, 201155, 18703, 1827, 3799, 891, 253, 0, 506, 0, 0, 0, 60, 200, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3122, 25710, 'Lost Captain', '', 'LineageMonster4.death_knight_n_156p', 34.32, 62.40, 83, 'male', 'L2ReflectionBoss', 'LabyrinthOfTheAbyss', 40, 280912, 36.892, 17774, 400.000, 60, 57, 73, 76, 70, 80, 16653944, 2116126, 17594, 5478, 2893, 2673, 253, 0, 506, 0, 0, 0, 73, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3123, 25711, 'Lost Guard', '', 'LineageMonster4.corpseshambler', 34.00, 34.00, 83, 'male', 'L2Minion', 'Fighter', 40, 16110, 17.776, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 6163, 913, 4209, 445, 253, 0, 506, 0, 0, 0, 50, 200, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3124, 25712, 'Lost Assistant Guard', '', 'LineageMonster4.disciple_silen', 19.00, 44.00, 83, 'male', 'L2Minion', 'Priest', 40, 16110, 17.776, 1777, 20.000, 40, 43, 30, 21, 20, 20, 0, 0, 4107, 913, 2805, 445, 253, 0, 506, 0, 0, 0, 73, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3125, 25713, 'Darnels', '', 'demonic', 20.00, 40.60, 84, 'female', 'L2Npc', 'npc', 40, 1395831, 159.894, 18120, 30.000, 60, 57, 73, 76, 70, 80, 1789794, 1050642, 9292, 1114, 6481, 599, 253, 300, 506, 0, 0, 0, 60, 180, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.58, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3126, 25714, 'Kietch', '', 'demonic', 12.00, 29.00, 84, 'male', 'L2Npc', 'npc', 40, 344948, 196.415, 18120, 30.000, 60, 57, 73, 76, 70, 80, 2662111, 1460807, 7980, 1114, 5470, 599, 253, 300, 506, 0, 0, 0, 26, 180, 'granisko_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3127, 25715, 'Kietchs Subordinate', '', 'demonic', 15.00, 32.50, 84, 'male', 'L2Monster', 'Fighter', 40, 19179, 196.571, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3773, 1114, 2586, 1086, 253, 300, 506, 0, 0, 0, 60, 170, 'granisko_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3128, 25716, 'Tears', '', 'elemental', 20.00, 27.50, 84, 'female', 'L2Npc', 'npc', 40, 1360986, 154.090, 18120, 30.000, 60, 57, 73, 76, 70, 80, 2039317, 1217980, 9309, 1114, 6370, 599, 253, 300, 506, 9638, 9638, 0, 60, 180, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3129, 25717, 'Tears', '', 'elemental', 20.00, 27.50, 84, 'female', 'L2Monster', 'Fighter', 40, 1360986, 154.090, 18120, 30.000, 40, 43, 30, 21, 20, 20, 0, 0, 372, 1114, 254, 599, 253, 300, 506, 9638, 9638, 0, 60, 180, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4247, 27001, 'Orc Sniper', '', 'orc_archer', 14.00, 25.00, 10, 'male', 'L2Monster', 'Ranger', 1100, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 19, 61, 13, 45, 253, 0, 506, 14, 0, 0, 45, 110, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4248, 27002, 'Orc Fighter', '', 'orc_fighter', 12.00, 22.00, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 23, 67, 16, 49, 253, 0, 506, 1, 0, 0, 45, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4249, 27003, 'Spirit Of Mirrors', '', 'poison_toad', 20.00, 10.00, 9, 'male', 'L2Monster', 'Fighter', 40, 143, 2.000, 100, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 18, 59, 12, 43, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4250, 27004, 'Spirit Of Mirrors', '', 'orc_fighter', 12.00, 22.00, 10, 'male', 'L2Monster', 'Fighter', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 19, 61, 13, 45, 253, 0, 506, 0, 0, 0, 45, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4251, 27005, 'Spirit Of Mirrors', '', 'werewolf', 10.00, 26.00, 11, 'male', 'L2Monster', 'Fighter', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 21, 64, 14, 47, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4252, 27006, 'Bhato Bloodspear', '', 'orc_fighter', 12.00, 22.00, 11, 'male', 'L2Monster', 'Fighter', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 21, 64, 14, 47, 253, 0, 506, 0, 0, 0, 45, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4253, 27007, 'Tanuki Skullcrusher', '', 'orc_fighter', 12.00, 22.00, 11, 'male', 'L2Monster', 'Fighter', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 21, 64, 14, 47, 253, 0, 506, 0, 0, 0, 45, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4254, 27008, 'Kraacul Blackskull', '', 'orc_fighter', 12.00, 22.00, 11, 'male', 'L2Monster', 'Fighter', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 21, 64, 14, 47, 253, 0, 506, 0, 0, 0, 45, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4255, 27009, 'Taarq Blackskull', '', 'orc_archer', 14.00, 25.00, 11, 'male', 'L2Monster', 'Fighter', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 21, 64, 14, 47, 253, 0, 506, 0, 0, 0, 45, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.80, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4256, 27016, 'Nerkas', '', 'dre_vanul', 14.00, 36.00, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 80, 80, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4257, 27017, 'Plague Zombie', '', 'zombie', 13.00, 21.00, 14, 'male', 'L2Monster', 'Mystic', 40, 230, 2.500, 141, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 28, 73, 20, 54, 253, 0, 506, 0, 0, 0, 15, 15, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4258, 27018, 'Orc Warrior', '', 'orc_fighter', 12.00, 22.00, 10, 'male', 'L2Monster', 'Fighter', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 19, 61, 13, 45, 253, 0, 506, 0, 0, 0, 45, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4259, 27019, 'Orc Warrior Leader', '', 'orc_fighter', 12.00, 22.00, 11, 'male', 'L2Monster', 'Fighter', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 21, 64, 14, 47, 253, 0, 506, 0, 0, 0, 45, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4260, 27020, 'Varool Foulclaw', '', 'wererat', 14.00, 25.00, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4261, 27021, 'Kirunak', '', 'dre_vanul', 14.00, 36.00, 22, 'male', 'L2Monster', 'Fighter', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 80, 80, 'kirunak_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4262, 27022, 'Merkenis', '', 'succubus', 10.00, 36.00, 22, 'female', 'L2Monster', 'Mystic', 40, 387, 3.500, 219, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 58, 103, 39, 75, 253, 0, 506, 0, 0, 0, 60, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4263, 27024, 'Undead Priest', '', 'zombie', 13.00, 21.00, 17, 'male', 'L2Monster', 'Priest', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 37, 84, 25, 61, 253, 0, 506, 0, 0, 0, 15, 15, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4264, 27029, 'Phantom Salamander', '', 'salamander', 16.00, 6.80, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 37, 84, 25, 61, 253, 500, 506, 0, 0, 0, 64, 96, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4265, 27030, 'Water Seer', '', 'monster_eye', 21.00, 43.00, 17, 'male', 'L2Monster', 'Mystic', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 37, 84, 25, 61, 253, 500, 506, 0, 0, 0, 90, 90, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4266, 27031, 'Ol Mahum Sentry', '', 'ol_mahum', 13.50, 25.00, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 37, 84, 25, 61, 253, 0, 506, 2, 0, 0, 50, 110, 'ol_mahum_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4267, 27032, 'Lizardman Warrior', '', 'virud_lizardman_warrior', 12.00, 30.00, 13, 'male', 'L2Monster', 'Fighter', 80, 215, 2.500, 133, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 26, 70, 17, 51, 253, 500, 506, 16, 0, 0, 52, 130, '', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4268, 27033, 'Lizardman Scout', '', 'virud_lizardman', 10.00, 23.00, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 23, 67, 16, 49, 253, 500, 506, 1, 0, 0, 43, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4269, 27034, 'Lizardman', '', 'virud_lizardman', 10.00, 23.00, 11, 'male', 'L2Monster', 'Fighter', 80, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 21, 64, 14, 47, 253, 500, 506, 291, 0, 0, 43, 130, '', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4270, 27035, 'Tamil', '', 'bugbear', 17.00, 35.00, 19, 'male', 'L2Monster', 'Fighter', 40, 322, 2.500, 183, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 44, 91, 30, 67, 253, 500, 506, 4, 0, 0, 55, 130, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4271, 27036, 'Calpico', '', 'orc_fighter', 12.00, 22.00, 13, 'male', 'L2Monster', 'Fighter', 40, 215, 2.500, 133, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 26, 70, 17, 51, 253, 0, 506, 2, 0, 0, 45, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4272, 27037, 'Calpicos Goons', '', 'orc', 10.00, 21.00, 10, 'male', 'L2Minion', 'Fighter', 40, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 19, 61, 13, 45, 253, 0, 506, 1, 0, 0, 45, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4273, 27038, 'Cats Eye Bandit', '', 'ol_mahum', 13.50, 25.00, 15, 'male', 'L2Monster', 'Fighter', 40, 247, 2.500, 149, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 31, 77, 21, 56, 253, 0, 506, 218, 0, 0, 50, 110, '1', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4274, 27041, 'Barankas Messenger', '', 'orc_fighter', 12.00, 22.00, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 23, 67, 16, 49, 253, 0, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4275, 27042, 'Orc Escort', '', 'orc_fighter', 12.00, 22.00, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 23, 67, 16, 49, 253, 0, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4276, 27043, 'Varangkas Tracker', '', 'vampire_bat', 10.00, 33.50, 11, 'male', 'L2Monster', 'Mystic', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 21, 64, 14, 47, 253, 500, 506, 0, 0, 0, 60, 80, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4277, 27044, 'Kasha Bear Totem Spirit', '', 'grizzly', 21.00, 40.00, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 37, 84, 25, 61, 253, 500, 506, 0, 0, 0, 40, 110, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4278, 27045, 'Kuruka Ratman Leader', '', 'wererat', 14.00, 25.00, 18, 'male', 'L2Monster', 'Fighter', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 41, 87, 28, 64, 253, 500, 506, 1, 0, 0, 80, 120, 'wererat_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4279, 27046, 'Sumi', '', 'batur_orc', 9.00, 21.50, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 2, 0, 0, 80, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4280, 27047, 'Wanuk', '', 'batur_orc', 9.00, 21.50, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 2, 0, 0, 80, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4281, 27048, 'Chewba', '', 'batur_orc', 9.00, 21.50, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 2, 0, 0, 80, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4282, 27049, 'Heitafu', '', 'batur_orc', 9.00, 21.50, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 2, 0, 0, 80, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4283, 27050, 'Picubo', '', 'batur_orc', 9.00, 21.50, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 2, 0, 0, 80, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4284, 27051, 'Bumbum', '', 'batur_orc', 9.00, 21.50, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 2, 0, 0, 80, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4285, 27052, 'Minsku', '', 'batur_orc', 9.00, 21.50, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 2, 0, 0, 80, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4286, 27053, 'Chuchu', '', 'batur_orc', 9.00, 21.50, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 2, 0, 0, 80, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4287, 27054, 'Umbar Orc', '', 'batur_orc', 9.00, 21.50, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 2, 0, 0, 80, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4288, 27055, 'Zakan', '', 'batur_orc', 9.00, 21.50, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 2, 0, 0, 80, 130, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4289, 27056, 'Durka Spirit', '', 'magical_weaver', 11.00, 20.00, 18, 'male', 'L2Monster', 'Mystic', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 41, 87, 28, 64, 253, 500, 506, 0, 0, 0, 90, 90, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4290, 27058, 'Honey Bear', '', 'grizzly', 21.00, 40.00, 17, 'male', 'L2Monster', 'Fighter', 40, 283, 2.500, 166, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 37, 84, 25, 61, 253, 0, 506, 0, 0, 0, 40, 110, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4291, 27059, 'Uoph', '', 'orc_fighter', 12.00, 22.00, 11, 'male', 'L2Monster', 'Fighter', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 21, 64, 14, 47, 253, 0, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4292, 27060, 'Kracha', '', 'orc_archer', 14.00, 25.00, 11, 'male', 'L2Monster', 'Ranger', 1100, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 21, 64, 14, 47, 253, 0, 506, 275, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4293, 27061, 'Batoh', '', 'orc_fighter', 12.00, 22.00, 11, 'male', 'L2Monster', 'Fighter', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 21, 64, 14, 47, 253, 0, 506, 86, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4294, 27062, 'Tanukia', '', 'orc_fighter', 12.00, 22.00, 8, 'male', 'L2Monster', 'Fighter', 40, 125, 2.000, 93, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 16, 56, 11, 41, 253, 0, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4295, 27063, 'Tanukias Warhound', '', 'wolf', 13.00, 9.00, 4, 'male', 'L2Monster', 'Fighter', 40, 68, 2.000, 62, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 10, 47, 7, 33, 253, 0, 506, 0, 0, 0, 24, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4296, 27064, 'Turel', '', 'orc_fighter', 12.00, 22.00, 11, 'male', 'L2Monster', 'Fighter', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 21, 64, 14, 47, 253, 0, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4297, 27065, 'Roko', '', 'orc_archer', 14.00, 25.00, 8, 'male', 'L2Monster', 'Ranger', 1100, 125, 2.000, 93, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 16, 56, 11, 41, 253, 0, 506, 275, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4298, 27066, 'Rokos Warhound', '', 'wolf', 13.00, 9.00, 4, 'male', 'L2Monster', 'Fighter', 40, 68, 2.000, 62, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 10, 47, 7, 33, 253, 0, 506, 0, 0, 0, 24, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4299, 27067, 'Kamut', '', 'orc_fighter', 12.00, 22.00, 11, 'male', 'L2Monster', 'Fighter', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 21, 64, 14, 47, 253, 0, 506, 86, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4300, 27068, 'Murtika', '', 'orc_archer', 14.00, 25.00, 8, 'male', 'L2Monster', 'Ranger', 1100, 125, 2.000, 93, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 16, 56, 11, 41, 253, 0, 506, 275, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4301, 27069, 'Murtikas Warhound', '', 'wolf', 13.00, 9.00, 4, 'male', 'L2Monster', 'Fighter', 40, 68, 2.000, 62, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 10, 47, 7, 33, 253, 0, 506, 0, 0, 0, 24, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4302, 27070, 'Tumran Orc Brigand', '', 'orc_fighter', 12.00, 22.00, 11, 'male', 'L2Monster', 'Fighter', 40, 185, 2.500, 116, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 21, 64, 14, 47, 253, 0, 506, 2, 0, 0, 45, 110, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4303, 27077, 'Unicorn Of Eva', '', 'unicorn', 14.00, 30.00, 30, 'male', 'L2Monster', 'Mystic', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 111, 140, 75, 104, 253, 0, 506, 0, 0, 0, 46, 150, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4304, 27078, 'Trimden Lord ', '', 'poison_spider', 27.00, 25.50, 39, 'male', 'L2Monster', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 212, 195, 145, 143, 253, 0, 506, 0, 0, 0, 60, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4305, 27079, 'Black Willow Lurker', '', 'hanged_man_ripper', 35.00, 80.00, 39, 'male', 'L2Monster', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 212, 195, 145, 143, 253, 0, 506, 0, 0, 0, 55, 55, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4306, 27080, 'Pashika Son Of Voltar', '', 'batur_orc_warrior', 10.00, 20.00, 37, 'male', 'L2Monster', 'Fighter', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 185, 181, 126, 134, 253, 500, 506, 2, 0, 0, 80, 120, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4307, 27081, 'Vultus Son Of Voltar', '', 'batur_orc_warrior', 10.00, 20.00, 37, 'male', 'L2Monster', 'Fighter', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 185, 181, 126, 134, 253, 500, 506, 2, 0, 0, 80, 120, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4308, 27082, 'Enku Orc Overlord', '', 'batur_orc_warrior', 10.00, 20.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 138, 157, 94, 116, 253, 500, 506, 2, 0, 0, 80, 120, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4309, 27083, 'Makum Bugbear Thug', '', 'bugbear', 17.00, 35.00, 37, 'male', 'L2Monster', 'Fighter', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 185, 181, 126, 134, 253, 500, 506, 2, 0, 0, 55, 130, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4310, 27086, 'Revenant of Tantos Chief', '', 'batur_orc_overlord', 12.00, 24.00, 39, 'male', 'L2Monster', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 212, 195, 145, 143, 253, 0, 506, 66, 0, 0, 80, 140, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4311, 27088, 'Harpy Matriarch', '', 'harpy', 10.00, 42.00, 34, 'female', 'L2Monster', 'Fighter', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 149, 164, 102, 119, 253, 500, 506, 0, 0, 0, 60, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4312, 27089, 'Road Collector', '', 'wererat', 14.00, 25.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 173, 176, 118, 129, 253, 500, 506, 12, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4313, 27090, 'Serpent Demon Kadesh', '', 'serpent_slave', 17.00, 46.00, 41, 'male', 'L2Monster', 'Fighter', 40, 1008, 5.500, 505, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 243, 209, 166, 153, 253, 0, 506, 73, 0, 0, 70, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4314, 27092, 'Neer Bodyguard', '', 'neer_crawler', 14.00, 22.00, 33, 'male', 'L2Monster', 'Fighter', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 138, 157, 94, 116, 253, 500, 506, 0, 0, 0, 50, 90, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4315, 27093, 'Delu Chief Kalkis', '', 'virud_lizardman_matriarch', 13.00, 37.00, 37, 'male', 'L2Monster', 'Fighter', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 185, 181, 126, 134, 253, 0, 506, 12, 0, 0, 56, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4316, 27094, 'Delu Lizardman Assassin', '', 'virud_lizardman', 10.00, 23.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 173, 176, 118, 129, 253, 500, 506, 2, 0, 0, 43, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4317, 27095, 'Singing Flower Phantasm', '', 'mandragora_b', 12.00, 25.50, 44, 'female', 'L2Monster', 'Fighter', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 295, 230, 202, 169, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.13, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4318, 27096, 'Singing Flower Nightmare', '', 'mandragora_b', 12.00, 25.50, 44, 'female', 'L2Monster', 'Fighter', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 295, 230, 202, 169, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.13, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4319, 27097, 'Singing Flower Darkling', '', 'mandragora_b', 12.00, 25.50, 44, 'female', 'L2Monster', 'Fighter', 40, 1139, 5.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 295, 230, 202, 169, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.13, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4320, 27098, 'Ghost Fire', '', 'will_o_wisp', 13.00, 22.00, 42, 'male', 'L2Monster', 'Mystic', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 259, 216, 177, 159, 253, 0, 506, 0, 0, 0, 80, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.10, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4321, 27099, 'Nameless Revenant', '', 'zombie', 13.00, 21.00, 38, 'male', 'L2Monster', 'Mystic', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 198, 188, 136, 138, 253, 0, 506, 0, 0, 0, 15, 15, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4322, 27100, 'Skeletal Mercenary', '', 'skeleton_knight', 10.00, 25.00, 39, 'male', 'L2Monster', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 212, 195, 145, 143, 253, 0, 506, 69, 0, 0, 40, 160, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4323, 27101, 'Drevanul Prince Zeruel', '', 'dre_vanul', 14.00, 36.00, 42, 'male', 'L2Monster', 'Fighter', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 259, 216, 177, 159, 253, 0, 506, 0, 0, 0, 80, 80, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4324, 27102, 'Pako The Cat', '', 'cat_the_cat', 9.00, 16.00, 38, 'male', 'L2Monster', 'Fighter', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 198, 188, 136, 138, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4325, 27103, 'Unicorn Racer', '', 'unicorn_boxer', 11.00, 18.00, 38, 'male', 'L2Monster', 'Mystic', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 198, 188, 136, 138, 253, 0, 506, 0, 0, 0, 27, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4326, 27104, 'Shadow Turen', '', 'shadow', 10.00, 30.00, 39, 'male', 'L2Monster', 'Mystic', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 212, 195, 145, 143, 253, 0, 506, 0, 0, 0, 80, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4327, 27105, 'Mimi The Cat', '', 'cutie_cat', 8.00, 15.00, 39, 'female', 'L2Monster', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 212, 195, 145, 143, 253, 0, 506, 0, 0, 0, 48, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4328, 27106, 'Unicorn Phantasm', '', 'unicorn_mirage', 13.00, 17.00, 40, 'male', 'L2Monster', 'Mystic', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 227, 203, 155, 148, 253, 0, 506, 0, 0, 0, 27, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4329, 27107, 'Silhouette Tilfo', '', 'silhouette', 8.00, 23.00, 40, 'female', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 227, 203, 155, 148, 253, 0, 506, 0, 0, 0, 80, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4330, 27108, 'Stenoa Gorgon Queen', '', 'cave_maiden', 25.00, 65.00, 37, 'female', 'L2Monster', 'Fighter', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 185, 181, 126, 134, 253, 0, 506, 127, 0, 0, 70, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4331, 27109, 'Handmaiden Of Stenoa', '', 'medusa', 10.00, 25.00, 33, 'female', 'L2Monster', 'Mystic', 40, 702, 4.500, 373, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 138, 157, 94, 116, 253, 0, 506, 0, 0, 0, 50, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4332, 27110, 'Shyslassys', '', 'medusa', 10.00, 25.00, 36, 'female', 'L2Monster', 'Mystic', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 173, 176, 118, 129, 253, 0, 506, 0, 0, 0, 50, 110, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4333, 27111, 'Cave Basilisk', '', 'lesser_basilisk', 34.00, 25.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 111, 140, 75, 104, 253, 0, 506, 0, 0, 0, 35, 54, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4334, 27112, 'Gorr', '', 'medusa', 10.00, 25.00, 36, 'female', 'L2Monster', 'Mystic', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 173, 176, 118, 129, 253, 0, 506, 0, 0, 0, 50, 110, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4335, 27113, 'Baraham', '', 'medusa', 10.00, 25.00, 36, 'female', 'L2Monster', 'Mystic', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 173, 176, 118, 129, 253, 0, 506, 0, 0, 0, 50, 110, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4336, 27114, 'Succubus Queen', '', 'succubus', 10.00, 36.00, 34, 'female', 'L2Monster', 'Mystic', 40, 737, 4.500, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 149, 164, 102, 119, 253, 0, 506, 0, 0, 0, 60, 100, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4337, 27115, 'Claw Of Succubus', '', 'succubus', 10.00, 36.00, 28, 'female', 'L2Minion', 'Mystic', 40, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 95, 131, 64, 96, 253, 0, 506, 0, 0, 0, 60, 100, 'demonic_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4338, 27116, 'Lava Salamander', '', 'salamander', 16.00, 6.80, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 160, 170, 109, 124, 253, 0, 506, 0, 0, 0, 64, 96, 'elemental3_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4339, 27117, 'Nahir', '', 'dre_vanul', 14.00, 36.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 160, 170, 109, 124, 253, 0, 506, 0, 0, 0, 80, 80, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4340, 27118, 'Black Willow', '', 'hanged_man_ripper', 35.00, 80.00, 30, 'male', 'L2Monster', 'Fighter', 40, 604, 3.500, 329, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 111, 140, 75, 104, 253, 0, 506, 0, 0, 0, 55, 55, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4341, 27119, 'Spirit of Sir Herod', '', 'skeleton_royal_guard', 11.00, 28.50, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 160, 170, 109, 124, 253, 0, 506, 69, 0, 0, 80, 120, 'skeleton_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4342, 27120, 'Luell Of Zephyr Winds', '', 'sylph', 11.00, 35.00, 37, 'female', 'L2Monster', 'Mystic', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 185, 181, 126, 134, 253, 0, 506, 0, 0, 0, 60, 60, 'elemental2_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4343, 27121, 'Actea Of Verdant Wilds', '', 'dryad', 9.00, 20.00, 37, 'female', 'L2Monster', 'Fighter', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 185, 181, 126, 134, 253, 0, 506, 0, 0, 0, 40, 110, 'elemental1_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4344, 27122, 'Leto Lizardman Agent', '', 'zenta_lizardman', 11.00, 32.00, 35, 'male', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 160, 170, 109, 124, 253, 0, 506, 1, 0, 0, 37, 140, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4345, 27123, 'Leto Lizardman Leader', '', 'zenta_lizardman_warrior', 13.00, 35.00, 38, 'male', 'L2Monster', 'Fighter', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 198, 188, 136, 138, 253, 0, 506, 66, 0, 0, 40, 140, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4346, 27124, 'Leto Lizardman Assassin', '', 'zenta_lizardman', 11.00, 32.00, 37, 'male', 'L2Monster', 'Fighter', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 185, 181, 126, 134, 253, 500, 506, 217, 0, 0, 37, 140, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4347, 27125, 'Leto Lizardman Sniper', '', 'zenta_lizardman_scout', 11.00, 30.00, 36, 'male', 'L2Monster', 'Ranger', 1100, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 173, 176, 118, 129, 253, 0, 506, 14, 0, 0, 37, 150, 'lizardman_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.93, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4348, 27126, 'Leto Lizardman Wizard', '', 'zenta_lizardman_shaman', 13.00, 35.00, 39, 'male', 'L2Monster', 'Priest', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 212, 195, 145, 143, 253, 0, 506, 7, 0, 0, 43, 130, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4349, 27127, 'Leto Lizardman Lord', '', 'zenta_lizardman_matriarch', 20.00, 40.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 227, 203, 155, 148, 253, 500, 506, 69, 0, 0, 53, 140, 'lizardman_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4350, 27128, 'Aruraune', '', 'mandragora_b', 12.00, 25.50, 40, 'female', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 227, 203, 155, 148, 253, 500, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.13, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4351, 27129, 'Ol Mahum Inspector', '', 'ol_mahum', 13.50, 25.00, 38, 'male', 'L2Monster', 'Fighter', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 198, 188, 136, 138, 253, 500, 506, 2, 0, 0, 50, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4352, 27130, 'Ol Mahum Betrayer', '', 'ol_mahum', 13.50, 25.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 173, 176, 118, 129, 253, 0, 506, 12, 0, 0, 50, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4353, 27131, 'Crimson Werewolf', '', 'werewolf', 10.00, 26.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 173, 176, 118, 129, 253, 500, 506, 0, 0, 0, 50, 120, 'werewolf_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4354, 27132, 'Krudel Lizardman', '', 'virud_lizardman', 10.00, 23.00, 36, 'male', 'L2Monster', 'Fighter', 80, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 173, 176, 118, 129, 253, 500, 506, 291, 0, 0, 43, 130, 'elemental1_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4355, 27133, 'Evil Eye Lord', '', 'monster_eye', 21.00, 43.00, 37, 'male', 'L2Monster', 'Fighter', 40, 847, 4.500, 433, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 185, 181, 126, 134, 253, 500, 506, 0, 0, 0, 90, 90, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4356, 27134, 'Tatoma', '', 'king_bugbear', 15.00, 40.00, 32, 'male', 'L2Monster', 'Fighter', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 128, 152, 87, 111, 253, 500, 506, 88, 0, 0, 55, 130, 'orc_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4357, 27135, 'Grima', '', 'devastator', 35.00, 35.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 425, 278, 291, 204, 253, 500, 506, 0, 0, 0, 25, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4358, 27136, 'Succubus Of Seduction', '', 'succubus', 10.00, 36.00, 40, 'female', 'L2Monster', 'Mystic', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 227, 203, 155, 148, 253, 500, 506, 0, 0, 0, 60, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4359, 27137, 'Demon King', '', 'dre_vanul', 14.00, 36.00, 50, 'male', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 425, 278, 291, 204, 253, 500, 506, 0, 0, 0, 80, 80, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4360, 27138, 'Great Demon King', '', 'death_knight', 12.00, 31.00, 60, 'male', 'L2Monster', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 717, 370, 490, 270, 253, 500, 506, 127, 0, 0, 27, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4361, 27139, 'Secret Keeper Tree', '', 'ti_mi_tran', 23.00, 90.00, 47, 'male', 'L2Monster', 'Fighter', 40, 1277, 5.500, 665, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 356, 254, 243, 186, 253, 0, 506, 0, 0, 0, 12, 12, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4362, 27140, 'Breka Overlord Haka', '', 'batur_orc_overlord', 12.00, 24.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 173, 176, 118, 129, 253, 500, 506, 66, 0, 0, 80, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4363, 27141, 'Breka Overlord Jaka', '', 'batur_orc_overlord', 12.00, 24.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 173, 176, 118, 129, 253, 500, 506, 66, 0, 0, 80, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4364, 27142, 'Breka Overlord Marka', '', 'batur_orc_overlord', 12.00, 24.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 173, 176, 118, 129, 253, 500, 506, 66, 0, 0, 80, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4365, 27143, 'Windsus Aleph', '', 'giant_wild_hog', 35.00, 27.00, 42, 'male', 'L2Monster', 'Fighter', 40, 1051, 5.500, 531, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 259, 216, 177, 159, 253, 500, 506, 0, 0, 0, 35, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4366, 27144, 'Tarlk Raider Athu', '', 'king_bugbear', 15.00, 40.00, 48, 'male', 'L2Monster', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 378, 262, 258, 192, 253, 500, 506, 88, 0, 0, 55, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4367, 27145, 'Tarlk Raider Lanka', '', 'king_bugbear', 15.00, 40.00, 48, 'male', 'L2Monster', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 378, 262, 258, 192, 253, 500, 506, 88, 0, 0, 55, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4368, 27146, 'Tarlk Raider Triska', '', 'king_bugbear', 15.00, 40.00, 48, 'male', 'L2Monster', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 378, 262, 258, 192, 253, 500, 506, 88, 0, 0, 55, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4369, 27147, 'Tarlk Raider Motura', '', 'king_bugbear', 15.00, 40.00, 48, 'male', 'L2Monster', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 378, 262, 258, 192, 253, 500, 506, 88, 0, 0, 55, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4370, 27148, 'Tarlk Raider Kalath', '', 'king_bugbear', 15.00, 40.00, 48, 'male', 'L2Monster', 'Fighter', 40, 1324, 5.500, 692, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 378, 262, 258, 192, 253, 500, 506, 88, 0, 0, 55, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4371, 27149, 'Gremlin Filcher', '', 'gremlin', 10.00, 15.00, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 23, 67, 16, 49, 253, 500, 506, 0, 0, 0, 20, 50, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4372, 27150, 'Black Legion Stormtrooper', '', 'skeleton_royal_guard', 11.00, 28.50, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 277, 223, 189, 164, 253, 500, 506, 217, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4373, 27151, 'Delu Lizardman Headhunter', '', 'virud_lizardman_scout', 10.00, 22.00, 28, 'male', 'L2Monster', 'Ranger', 1100, 544, 3.500, 301, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 95, 131, 64, 96, 253, 500, 506, 2507, 0, 0, 43, 130, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4374, 27152, 'Marsh Stakato Marquess', '', 'marsh_stakato_queen', 15.00, 37.00, 35, 'female', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 160, 170, 109, 124, 253, 500, 506, 0, 0, 0, 130, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4375, 27153, 'Alexandro Sanches ', '', 'imp', 10.00, 24.00, 3, 'male', 'L2Monster', 'Fighter', 40, 58, 2.000, 55, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 9, 44, 6, 32, 253, 0, 506, 0, 0, 0, 60, 80, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4376, 27154, 'Bonaparterius', '', 'goblin', 10.00, 16.50, 3, 'male', 'L2Monster', 'Fighter', 40, 58, 2.000, 55, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 9, 44, 6, 32, 253, 0, 506, 4, 0, 0, 40, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.32, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4377, 27155, 'Ramsebalius', '', 'orc', 10.00, 21.00, 3, 'male', 'L2Monster', 'Fighter', 40, 58, 2.000, 55, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 9, 44, 6, 32, 253, 0, 506, 2, 0, 0, 45, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4378, 27156, 'Leto Shaman Ketz', '', 'zenta_lizardman_shaman', 13.00, 35.00, 40, 'male', 'L2Monster', 'Priest', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 227, 203, 155, 148, 253, 500, 506, 159, 0, 0, 43, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4379, 27157, 'Leto Chief Narak', '', 'zenta_lizardman_matriarch', 20.00, 40.00, 41, 'male', 'L2Monster', 'Fighter', 40, 1008, 5.500, 505, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 243, 209, 166, 153, 253, 500, 506, 221, 0, 0, 53, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4380, 27158, 'Timak Raider Kaikee', '', 'batur_orc', 9.00, 21.50, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 277, 223, 189, 164, 253, 500, 506, 66, 0, 0, 80, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4381, 27159, 'Timak Overlord Okun', '', 'batur_orc_overlord', 12.00, 24.00, 46, 'male', 'L2Monster', 'Fighter', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 335, 246, 228, 180, 253, 500, 506, 127, 0, 0, 80, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4382, 27160, 'Gok Magok', '', 'twin_headed_giant', 17.00, 39.00, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 277, 223, 189, 164, 253, 500, 506, 0, 0, 0, 45, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4383, 27161, 'Taik Overlord Kakran', '', 'ketra_orc_warrior', 12.00, 24.00, 45, 'male', 'L2Monster', 'Fighter', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 315, 239, 214, 174, 253, 500, 506, 69, 0, 0, 36, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4384, 27162, 'Hatar Chieftain Kubel', '', 'medusa', 10.00, 25.00, 52, 'female', 'L2Monster', 'Mystic', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 475, 296, 324, 216, 253, 500, 506, 0, 0, 0, 50, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4385, 27163, 'Vanor Elder Kerunos', '', 'heltor_silenos_chieftain', 13.00, 31.50, 51, 'male', 'L2Monster', 'Fighter', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 449, 287, 307, 210, 253, 500, 506, 179, 0, 0, 27, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4386, 27164, 'Karul Chief Orooto', '', 'bugbear', 17.00, 35.00, 43, 'male', 'L2Monster', 'Fighter', 40, 1094, 5.500, 557, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 277, 223, 189, 164, 253, 500, 506, 88, 0, 0, 55, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4387, 27165, 'Abyssal Jewel 1', '', 'mirror', 26.00, 52.00, 60, 'male', 'L2Monster', 'Mystic', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 80, 165, 'abyss_jewel_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4388, 27166, 'Abyssal Jewel 2', '', 'mirror', 26.00, 52.00, 60, 'male', 'L2Monster', 'Mystic', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 80, 165, 'abyss_jewel_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4389, 27167, 'Abyssal Jewel 3', '', 'mirror', 26.00, 52.00, 60, 'male', 'L2Monster', 'Mystic', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 80, 165, 'abyss_jewel_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4390, 27168, 'Jewel Guardian Mara', '', 'succubus', 10.00, 36.00, 53, 'female', 'L2Monster', 'Mystic', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 503, 304, 344, 223, 253, 500, 506, 0, 0, 0, 60, 100, 'abyss_jewel_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4391, 27169, 'Jewel Guardian Musfel', '', 'dre_vanul', 14.00, 36.00, 53, 'male', 'L2Monster', 'Fighter', 40, 1571, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 503, 304, 344, 223, 253, 500, 506, 0, 0, 0, 80, 80, 'abyss_jewel_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4392, 27170, 'Jewel Guardian Pyton', '', 'serpent_slave', 17.00, 46.00, 58, 'male', 'L2Monster', 'Fighter', 40, 1829, 6.500, 977, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 651, 350, 444, 256, 253, 500, 506, 223, 0, 0, 70, 110, 'abyss_jewel_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4393, 27171, 'Sacrifice Of The Sacrificed', '', 'magical_weaver', 11.00, 20.00, 20, 'male', 'L2Monster', 'Mystic', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 90, 90, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4394, 27172, 'Harit Lizardman Zealot', '', 'zenta_lizardman_warrior', 13.00, 35.00, 55, 'male', 'L2Monster', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 500, 506, 16, 0, 0, 40, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4395, 27173, 'Box Of Athrea 1', '', 'coffer_a', 12.00, 9.50, 50, 'etc', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 425, 278, 291, 204, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4396, 27174, 'Box Of Athrea 2', '', 'coffer_a', 12.00, 9.50, 50, 'etc', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 425, 278, 291, 204, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4397, 27175, 'Box Of Athrea 3', '', 'coffer_a', 12.00, 9.50, 50, 'etc', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 425, 278, 291, 204, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4398, 27176, 'Box Of Athrea 4', '', 'coffer_a', 12.00, 9.50, 50, 'etc', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 425, 278, 291, 204, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4399, 27177, 'Box Of Athrea 5', '', 'coffer_a', 12.00, 9.50, 50, 'etc', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 425, 278, 291, 204, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4400, 27178, 'Blitz Wyrm', '', 'wyrm', 29.00, 72.00, 60, 'male', 'L2Monster', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 717, 370, 490, 270, 253, 500, 506, 0, 0, 0, 70, 70, '1', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.19, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4401, 27179, 'Grave Keymaster', '', 'gargoyle', 16.00, 50.00, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 898, 419, 613, 306, 253, 0, 506, 0, 0, 0, 140, 140, 'grave_guard_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4402, 27180, 'Imperial Slave', '', 'binding', 12.00, 21.00, 56, 'male', 'L2Monster', 'ImperialSlave', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 589, 331, 402, 242, 253, 500, 506, 0, 0, 0, 10, 140, 'grave_keeper_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4403, 27181, 'Imperial Gravekeeper', '', 'death_blader', 15.00, 45.00, 60, 'male', 'L2Monster', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 717, 370, 490, 270, 253, 0, 506, 1472, 0, 0, 100, 170, 'grave_keeper_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4404, 27182, 'Ark Guardian Elberoth', '', 'archangel', 15.00, 80.00, 60, 'male', 'L2Monster', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 717, 370, 490, 270, 253, 0, 506, 6370, 0, 0, 50, 200, '', 100, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4405, 27183, 'Ark Guardian Shadowfang', '', 'kel_mahum_archer', 13.00, 27.00, 60, 'male', 'L2Monster', 'Ranger', 1100, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 717, 370, 490, 270, 253, 0, 506, 288, 0, 0, 50, 160, '', 100, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.91, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4406, 27184, 'Angel Killer', '', 'death_lord', 21.00, 40.00, 60, 'male', 'L2Monster', 'Fighter', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 717, 370, 490, 270, 253, 0, 506, 130, 0, 0, 40, 200, '', 100, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4407, 27185, 'Fairy Tree of Wind', '', 'human_tree', 35.00, 90.00, 55, 'etc', 'L2SpecialMonster', 'Quest421FairyTree', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 1, 'q421_tree_clan', 100, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4408, 27186, 'Fairy Tree of Star', '', 'human_tree', 35.00, 90.00, 55, 'etc', 'L2SpecialMonster', 'Quest421FairyTree', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 1, 'q421_tree_clan', 100, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4409, 27187, 'Fairy Tree of Twilight', '', 'human_tree', 35.00, 90.00, 55, 'etc', 'L2SpecialMonster', 'Quest421FairyTree', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 1, 'q421_tree_clan', 100, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4410, 27188, 'Fairy Tree of Abyss', '', 'human_tree', 35.00, 90.00, 55, 'etc', 'L2SpecialMonster', 'Quest421FairyTree', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 1, 'q421_tree_clan', 100, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4411, 27189, 'Soul of Tree Guardian', '', 'elf_ghost', 7.00, 21.00, 50, 'male', 'L2Monster', 'Mystic', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 425, 278, 291, 204, 253, 500, 506, 0, 0, 0, 80, 140, 'q421_tree_clan', 100, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4412, 27190, 'Ol Mahum Support Troop', '', 'ol_mahum_champion', 14.00, 27.00, 26, 'male', 'L2Monster', 'Fighter', 40, 488, 3.500, 273, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 81, 121, 55, 89, 253, 500, 506, 69, 0, 0, 50, 150, 'orc_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4413, 27191, 'Malcom', '', 'grizzly', 21.00, 40.00, 25, 'male', 'L2Monster', 'Fighter', 40, 461, 3.500, 259, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 74, 116, 50, 86, 253, 500, 506, 0, 0, 0, 40, 159, '', 100, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4414, 27192, 'Succubus Handmaiden', '', 'succubus', 10.00, 36.00, 18, 'female', 'L2Monster', 'Mystic', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 41, 87, 28, 64, 253, 500, 506, 0, 0, 0, 60, 134, '', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4415, 27193, 'Goblin Servant', '', 'goblin', 10.00, 16.50, 12, 'male', 'L2Monster', 'Fighter', 40, 200, 2.500, 124, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 23, 67, 16, 49, 253, 500, 506, 0, 0, 0, 40, 120, '', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.32, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4416, 27194, 'Julie the Ripper', '', 'doll_blader', 6.00, 12.00, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 227, 203, 155, 148, 253, 500, 506, 5129, 5129, 0, 22, 174, '', 100, 0, 0, 61, 7, 10, 8, 0, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4417, 27195, 'Male Ant', '', 'noble_ant', 20.00, 48.00, 32, 'male', 'L2Monster', 'Fighter', 40, 668, 4.500, 358, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 128, 152, 87, 111, 253, 0, 506, 0, 0, 0, 80, 150, '', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4418, 27196, 'Bluebacked Alligator', '', 'crocodile', 28.00, 11.50, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 227, 203, 155, 148, 253, 500, 506, 0, 0, 0, 70, 110, 'croc_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4419, 27197, 'Bejewelled Alligator', '', 'crocodile', 28.00, 11.50, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 227, 203, 155, 148, 253, 500, 506, 0, 0, 0, 70, 110, 'croc_clan', 200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4420, 27199, 'Crimson Werewolf', '', 'werewolf', 10.00, 26.00, 36, 'male', 'L2Monster', 'Fighter', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 173, 176, 118, 129, 253, 0, 506, 0, 0, 0, 50, 120, 'werewolf_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4421, 27200, 'Krudel Lizardman', '', 'virud_lizardman', 10.00, 23.00, 36, 'male', 'L2Monster', 'Fighter', 80, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 173, 176, 118, 129, 253, 0, 506, 291, 0, 0, 43, 130, 'elemental1_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4422, 27201, 'dummy_monster_1', '', 'bugbear', 17.00, 35.00, 10, 'male', 'L2Monster', 'Fighter', 80, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 19, 61, 13, 45, 253, 0, 506, 291, 0, 0, 55, 180, 'elemental1_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4423, 27202, 'dummy_monster_2', '', 'bugbear', 17.00, 35.00, 10, 'male', 'L2Monster', 'Fighter', 80, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 19, 61, 13, 45, 253, 0, 506, 291, 0, 0, 55, 180, 'elemental1_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4424, 27203, 'dummy_monster_3', '', 'bugbear', 17.00, 35.00, 10, 'male', 'L2Monster', 'Fighter', 80, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 19, 61, 13, 45, 253, 0, 506, 291, 0, 0, 55, 180, 'elemental1_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4425, 27204, 'dummy_monster_4', '', 'bugbear', 17.00, 35.00, 10, 'male', 'L2Monster', 'Fighter', 80, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 19, 61, 13, 45, 253, 0, 506, 291, 0, 0, 55, 180, 'elemental1_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4426, 27205, 'dummy_monster_5', '', 'bugbear', 17.00, 35.00, 10, 'male', 'L2Monster', 'Fighter', 80, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 19, 61, 13, 45, 253, 0, 506, 291, 0, 0, 55, 180, 'elemental1_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4427, 27206, 'dummy_monster_6', '', 'bugbear', 17.00, 35.00, 10, 'male', 'L2Monster', 'Fighter', 80, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 19, 61, 13, 45, 253, 0, 506, 291, 0, 0, 55, 180, 'elemental1_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4428, 27207, 'dummy_monster_7', '', 'bugbear', 17.00, 35.00, 10, 'male', 'L2Monster', 'Fighter', 80, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 19, 61, 13, 45, 253, 0, 506, 291, 0, 0, 55, 180, 'elemental1_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4429, 27208, 'dummy_monster_8', '', 'bugbear', 17.00, 35.00, 10, 'male', 'L2Monster', 'Fighter', 80, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 19, 61, 13, 45, 253, 0, 506, 291, 0, 0, 55, 180, 'elemental1_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4430, 27209, 'dummy_monster_9', '', 'bugbear', 17.00, 35.00, 10, 'male', 'L2Monster', 'Fighter', 80, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 19, 61, 13, 45, 253, 0, 506, 291, 0, 0, 55, 180, 'elemental1_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4431, 27210, 'dummy_monster_10', '', 'bugbear', 17.00, 35.00, 10, 'male', 'L2Monster', 'Fighter', 80, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 19, 61, 13, 45, 253, 0, 506, 291, 0, 0, 55, 180, 'elemental1_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4432, 27211, 'dummy_monster_11', '', 'bugbear', 17.00, 35.00, 10, 'male', 'L2Monster', 'Fighter', 80, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 19, 61, 13, 45, 253, 0, 506, 291, 0, 0, 55, 180, 'elemental1_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4433, 27212, 'dummy_monster_12', '', 'bugbear', 17.00, 35.00, 10, 'male', 'L2Monster', 'Fighter', 80, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 19, 61, 13, 45, 253, 0, 506, 291, 0, 0, 55, 180, 'elemental1_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4434, 27213, 'dummy_monster_13', '', 'bugbear', 17.00, 35.00, 10, 'male', 'L2Monster', 'Fighter', 80, 163, 2.000, 108, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 19, 61, 13, 45, 253, 0, 506, 291, 0, 0, 55, 180, 'elemental1_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4435, 27214, 'Guardian of Forbidden Knowledge', '', 'apostle_warrior', 8.00, 30.00, 76, 'female', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 80, 0, 0, 50, 180, 'guard_of_secrets_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4436, 27215, 'Guardian of Forbidden Knowledge', '', 'apostle_warrior', 8.00, 30.00, 76, 'female', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 80, 0, 0, 50, 180, 'guard_of_secrets_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4437, 27216, 'Guardian of Forbidden Knowledge', '', 'apostle_warrior', 8.00, 30.00, 76, 'female', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 80, 0, 0, 50, 180, 'guard_of_secrets_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4438, 27217, 'Soul of Well', '', 'dark_horror', 20.00, 35.00, 63, 'male', 'L2Monster', 'Fighter', 40, 2090, 7.500, 1127, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 822, 398, 562, 292, 253, 150, 506, 0, 0, 0, 100, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4439, 27218, 'Triols Pawn', '', 'dre_vanul', 14.00, 36.00, 65, 'male', 'L2Monster', 'Fighter', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 898, 419, 613, 306, 253, 150, 506, 0, 0, 0, 80, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4440, 27219, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4441, 27220, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4442, 27221, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4443, 27222, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4444, 27223, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4445, 27224, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4446, 27225, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4447, 27226, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4448, 27227, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4449, 27228, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4450, 27229, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4451, 27230, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4452, 27231, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4453, 27232, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4454, 27233, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4455, 27234, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4456, 27235, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4457, 27236, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4458, 27237, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4459, 27238, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4460, 27239, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4461, 27240, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4462, 27241, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4463, 27242, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4464, 27243, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4465, 27244, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4466, 27245, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4467, 27246, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4468, 27247, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4469, 27248, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4470, 27249, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4471, 27250, 'Fallen Angel Allector', '', 'karik', 25.00, 90.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 37, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4472, 27251, 'Fallen Angel Allector', '', 'karik', 25.00, 90.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 37, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4473, 27252, 'Fallen Angel Allector', '', 'karik', 25.00, 90.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 37, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4474, 27253, 'Hell Fire', '', 'will_o_wisp', 13.00, 22.00, 76, 'male', 'L2Monster', 'Mystic', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.10, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4475, 27254, 'Unknown Stopper', '', 'fiend_archer', 17.00, 55.00, 78, 'male', 'L2Monster', 'Ranger', 1100, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 0, 0, 0, 70, 180, '', 300, 0, 0, 0, 7, 10, 8, 3, 1500, 3, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4476, 27255, 'Unknown Stopper', '', 'fiend_archer', 17.00, 55.00, 78, 'male', 'L2Monster', 'Ranger', 1100, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 0, 0, 0, 70, 180, '', 300, 0, 0, 0, 7, 10, 8, 3, 1500, 3, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4477, 27256, 'Unknown Stopper', '', 'fiend_archer', 17.00, 55.00, 78, 'male', 'L2Monster', 'Ranger', 1100, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 0, 0, 0, 70, 180, '', 300, 0, 0, 0, 7, 10, 8, 3, 1500, 3, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4478, 27257, 'Archangel Iconoclasis', '', 'apostle_mage', 11.00, 38.50, 76, 'male', 'L2Monster', 'Mystic', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 161, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4479, 27258, 'Archangel Iconoclasis', '', 'apostle_mage', 11.00, 38.50, 76, 'male', 'L2Monster', 'Mystic', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 161, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4480, 27259, 'Archangel Iconoclasis', '', 'apostle_mage', 11.00, 38.50, 76, 'male', 'L2Monster', 'Mystic', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 161, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4481, 27260, 'Archangel Iconoclasis', '', 'apostle_mage', 11.00, 38.50, 76, 'male', 'L2Monster', 'Mystic', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 161, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4482, 27261, 'Bead of Sacred Flame', '', 'will_o_wisp', 13.00, 22.00, 76, 'male', 'L2Monster', 'Mystic', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 80, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.10, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4483, 27262, 'Death Lord Hallate', '', 'death_lord', 21.00, 40.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 78, 0, 0, 40, 180, '', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4484, 27263, 'Death Lord Hallate', '', 'death_lord', 21.00, 40.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 78, 0, 0, 40, 180, '', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4485, 27264, 'Death Lord Hallate', '', 'death_lord', 21.00, 40.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 78, 0, 0, 40, 180, '', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4486, 27265, 'Lich King Icarus', '', 'vale_master', 12.00, 40.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 205, 0, 0, 70, 180, '', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4487, 27266, 'Fallen Angel Haures', '', 'doll_master', 20.00, 42.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 80, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4488, 27267, 'Fallen Angel Haures', '', 'doll_master', 20.00, 42.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 80, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4489, 27268, 'Guard of Haures', '', 'neer_crawler', 14.00, 22.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4490, 27269, 'Fallen Angel Naverius', '', 'banshee', 9.00, 23.00, 76, 'female', 'L2Monster', 'Mystic', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 3939, 0, 0, 80, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4491, 27270, 'Fallen Angel Naverius', '', 'banshee', 9.00, 23.00, 76, 'female', 'L2Monster', 'Mystic', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 3939, 0, 0, 80, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4492, 27271, 'Chimera Golem', '', 'lava_golem', 22.00, 45.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 13, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4493, 27272, 'Hallates Dancer Lillian', '', 'banshee', 9.00, 23.00, 76, 'female', 'L2Monster', 'Mystic', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 3939, 0, 0, 80, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4494, 27273, 'Assassin Pezel', '', 'skeleton_royal_guard', 11.00, 28.50, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 242, 0, 0, 80, 180, '', 300, 0, 0, 0, 7, 10, 8, 3, 0, 3, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4495, 27274, 'Fallen Angel Tanakia', '', 'halisha_d', 23.00, 60.00, 78, 'female', 'L2Monster', 'Ranger', 1100, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 286, 0, 0, 43, 180, '', 300, 0, 0, 0, 7, 10, 8, 3, 1500, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4496, 27275, 'Fallen Angel Tanakia', '', 'halisha_d', 23.00, 60.00, 78, 'female', 'L2Monster', 'Ranger', 1100, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 286, 0, 0, 43, 180, '', 300, 0, 0, 0, 7, 10, 8, 3, 1500, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4497, 27276, 'Fallen Angel Tanakia', '', 'halisha_d', 23.00, 60.00, 78, 'female', 'L2Monster', 'Ranger', 1100, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 286, 0, 0, 43, 180, '', 300, 0, 0, 0, 7, 10, 8, 3, 1500, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4498, 27277, 'Fallen Angel Tanakia', '', 'halisha_d', 23.00, 60.00, 78, 'female', 'L2Monster', 'Ranger', 1100, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 286, 0, 0, 43, 180, '', 300, 0, 0, 0, 7, 10, 8, 3, 1500, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4499, 27278, 'Shadow of Beleth', '', 'vale_master', 12.00, 40.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 205, 0, 0, 70, 180, '', 300, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4500, 27279, 'Cursed Kesadein', '', 'doll_master', 20.00, 42.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 0, 0, 0, 80, 180, '', 300, 0, 0, 0, 7, 10, 8, 3, 0, 3, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4501, 27280, 'Fallen Angel Narcissus', '', 'karik', 25.00, 90.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 0, 0, 0, 37, 180, '', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4502, 27281, 'Fallen Angel Metellus', '', 'karik', 25.00, 90.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 0, 0, 0, 37, 180, '', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4503, 27282, 'Dark Angel Othiel', '', 'archangel', 15.00, 80.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 97, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4504, 27283, 'Grandpapa Askalius', '', 'susceptor_prime', 45.00, 72.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 0, 0, 0, 78, 180, '', 300, 0, 0, 0, 7, 50, 1, 12, 0, 3, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4505, 27284, 'Flame Evil Spirit Azira', '', 'ifrit', 10.00, 42.00, 78, 'male', 'L2Monster', 'Mystic', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 0, 0, 0, 38, 180, '', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4506, 27285, 'Lizards Totem Sharuhi', '', 'serpent_slave', 17.00, 46.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 72, 0, 0, 70, 180, '', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4507, 27286, 'Fallen Knight Adhil', '', 'a_guard_MHuman', 8.00, 24.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 79, 107, 0, 50, 180, '', 300, 0, 20, 162, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4508, 27287, 'Bound Elf Panacea', '', 'a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 145, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4509, 27288, 'Sword Player Biel', '', 'a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 74, 74, 0, 50, 180, '', 300, 0, 0, 167, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4510, 27289, 'Ancient Sword Master Iron', '', 'lilim_knight_10_bi', 13.00, 55.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 5800, 5799, 0, 56, 180, '', 300, 0, 20, 162, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4511, 27290, 'White Wing Commander ', '', 'archangel', 15.00, 80.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 97, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4512, 27291, 'White Wing Fighter', '', 'apostle_warrior', 8.00, 30.00, 76, 'female', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 80, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4513, 27292, 'Fallen Noble Orc Muhark', '', 'ketra_orc_warrior', 12.00, 24.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 7834, 0, 0, 36, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4514, 27293, 'Khavatari Uruz', '', 'ketra_orc_warrior', 12.00, 24.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 36, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4515, 27294, 'Overlord Atrus', '', 'ketra_orc_chieftain', 11.00, 38.50, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 6719, 0, 0, 24, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.51, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4516, 27295, 'Sharuhi Mouth Mudaha', '', 'ketra_orc_chieftain', 11.00, 38.50, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 6719, 0, 0, 24, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.51, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4517, 27296, 'Monument Watcher Ezekiel', '', 'archangel', 15.00, 80.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 97, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4518, 27297, 'Monument Watcher Ezekiel', '', 'archangel', 15.00, 80.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 97, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4519, 27298, 'Monument Watcher Ezekiel', '', 'archangel', 15.00, 80.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 97, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4520, 27299, 'Monument Watcher Ezekiel', '', 'archangel', 15.00, 80.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 97, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4521, 27300, 'Monument Watcher Ezekiel', '', 'archangel', 15.00, 80.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 97, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4522, 27301, 'Monument Watcher Ezekiel', '', 'archangel', 15.00, 80.00, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 97, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4523, 27302, 'Monument Defender Azrael', '', 'archangel', 15.00, 80.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 97, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4524, 27303, 'Monument Defender Azrael', '', 'archangel', 15.00, 80.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 97, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4525, 27304, 'Monument Defender Azrael', '', 'archangel', 15.00, 80.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 97, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4526, 27305, 'Monument Defender Azrael', '', 'archangel', 15.00, 80.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 97, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4527, 27306, 'Monument Defender Azrael', '', 'archangel', 15.00, 80.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 97, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4528, 27307, 'Monument Defender Azrael', '', 'archangel', 15.00, 80.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 97, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4529, 27308, 'Assassin Frost', '', 'vampire_soldier', 8.00, 23.50, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 229, 0, 0, 60, 180, '', 300, 0, 0, 0, 7, 10, 8, 3, 0, 3, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4530, 27309, 'Minervia Van Hacken', '', 'vampire_witch', 6.00, 21.50, 78, 'female', 'L2Monster', 'Mystic', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 229, 0, 0, 64, 180, '', 300, 0, 0, 0, 7, 10, 8, 3, 0, 3, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4531, 27310, 'Kitanis Van Hacken', '', 'vampire_lord', 7.50, 25.80, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 0, 0, 0, 15, 180, '', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4532, 27311, 'Judgment Hound Dog Kelvas', '', 'eligor', 21.00, 35.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 0, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4533, 27312, 'Mysterious Servitor', '', 'shadeless', 7.00, 28.00, 78, 'male', 'L2Monster', 'Fighter', 40, 2975, 8.721, 1743, 3.080, 40, 43, 30, 21, 20, 20, 0, 0, 1566, 593, 1097, 434, 253, 150, 506, 0, 0, 0, 48, 180, '', 300, 0, 0, 0, 7, 30, 4, 8, 0, 3, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4534, 27313, 'Vision Guardian Shakiel', '', 'apostle_mage', 11.00, 38.50, 76, 'male', 'L2Monster', 'Mystic', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 161, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4535, 27314, 'Vision Guardian Shakiel', '', 'apostle_mage', 11.00, 38.50, 76, 'male', 'L2Monster', 'Mystic', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 161, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4536, 27315, 'Vision Guardian Shakiel', '', 'apostle_mage', 11.00, 38.50, 76, 'male', 'L2Monster', 'Mystic', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 161, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4537, 27316, 'Fallen Chieftain Vegus', '', 'ketra_orc_warrior', 12.00, 24.00, 55, 'male', 'L2Monster', 'Fighter', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 161, 0, 0, 36, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4538, 27317, 'Restrainer of Glory', '', 'kel_mahum_champion', 13.00, 32.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 161, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4539, 27318, 'Wendys Guardian', '', 'golem_guardian_090p', 16.00, 37.20, 46, 'male', 'L2Monster', 'Fighter', 40, 1230, 5.500, 638, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 335, 246, 228, 180, 253, 500, 506, 0, 0, 0, 50, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4540, 27319, 'Black Leopard', '', 'onyx_beast', 14.00, 14.50, 18, 'male', 'L2Monster', 'Fighter', 40, 302, 2.500, 175, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 41, 87, 28, 64, 253, 0, 506, 0, 0, 0, 30, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4541, 27320, 'Timora Orc', '', 'batur_orc', 9.00, 21.50, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 500, 506, 2, 0, 0, 80, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4542, 27321, 'Bruin Lizardman', '', 'virud_lizardman', 10.00, 23.00, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 291, 0, 0, 43, 130, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4543, 27322, 'Picot Araneid', '', 'giant_spider_50_bi', 39.00, 38.00, 27, 'male', 'L2Monster', 'Mystic', 40, 515, 3.500, 287, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 87, 125, 59, 92, 253, 500, 506, 0, 0, 0, 72, 130, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4544, 27323, 'Divine Emissary', '', 'LineageMonster.Angel', 13.50, 36.50, 40, 'male', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 227, 203, 155, 148, 253, 0, 506, 148, 0, 0, 30, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4545, 27324, 'Vision Guard Eranus', '', 'LineageMonster2.Apostle_warrior', 8.00, 30.00, 76, 'female', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 6717, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4546, 27325, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4547, 27326, 'Archangel Kanriel', '', 'archangel_050p', 13.00, 37.50, 81, 'male', 'L2Monster', 'Fighter', 80, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1554, 588, 1061, 430, 253, 150, 506, 97, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4548, 27327, 'Zakorels Executor', '', 'LineageMonster2.Apostle_mage', 11.00, 38.50, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 6718, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4549, 27328, 'Zakorel', '', 'LineageMonster3.Apostle_grail', 13.00, 47.00, 81, 'male', 'L2Monster', 'Fighter', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1554, 588, 1061, 430, 253, 0, 506, 6717, 0, 0, 30, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4550, 27329, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4551, 27332, 'Guardian Angel', '', 'LineageMonster.Angel', 13.50, 36.50, 35, 'male', 'L2Monster', 'GuardianAngel', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 160, 170, 109, 124, 253, 0, 506, 196, 0, 0, 30, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4552, 27333, 'Crimson Duchess', '', 'LineageMonster3.Lidia_von_helmann', 10.00, 25.40, 76, 'female', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 0, 506, 0, 0, 0, 20, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4553, 27334, 'Archon of Halisha', '', 'ahrimanes', 14.00, 57.75, 76, 'male', 'L2Monster', 'Fighter', 40, 2720, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1345, 535, 919, 391, 253, 150, 506, 6722, 0, 0, 35, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4554, 27335, 'Dark Angel Othiel', '', 'LineageMonster.Archangel', 15.00, 80.00, 81, 'male', 'L2Monster', 'Fighter', 40, 2917, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1554, 588, 1061, 430, 253, 150, 506, 97, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4555, 27336, 'Crimson Lady', '', 'LineageMonster.Succubus', 10.00, 36.00, 40, 'female', 'L2Monster', 'Fighter', 40, 967, 4.500, 479, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 227, 203, 155, 148, 253, 0, 506, 0, 0, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4556, 27337, 'Ol Mahum Officer Tak', '', 'LineageMonster.ol_mahum_champion', 14.00, 27.00, 20, 'male', 'L2Monster', 'Fighter', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 69, 0, 0, 50, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4557, 27338, 'Fallen Angel', '', 'LineageMonster.ol_mahum_champion', 8.00, 30.00, 38, 'female', 'L2Monster', 'Fighter', 40, 886, 4.500, 448, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 198, 188, 136, 138, 253, 0, 506, 6717, 0, 0, 50, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4558, 27339, 'Cruma Marshlands Traitor', '', 'LineageMonster.ol_mahum_champion', 6.00, 21.50, 35, 'female', 'L2Monster', 'Fighter', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 160, 170, 109, 124, 253, 0, 506, 946, 0, 0, 64, 180, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4559, 27340, 'Pursuer', '', 'LineageMonster.ol_mahum', 13.50, 25.00, 39, 'male', 'L2Monster', 'Fighter', 40, 926, 4.500, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 212, 195, 145, 143, 253, 150, 506, 219, 0, 0, 50, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4560, 27341, 'Shilens Evil Thoughts', '', 'LineageNPC.training_doll_150p', 13.00, 40.00, 51, 'etc', 'L2Monster', 'Fighter', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 449, 287, 307, 210, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4561, 27342, 'Shilens Evil Thoughts', '', 'LineageNPC.training_doll_150p', 13.00, 40.00, 61, 'etc', 'L2Monster', 'Fighter', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 752, 378, 513, 278, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4562, 27343, 'Shilens Evil Thoughts', '', 'LineageNPC.training_doll_150p', 14.00, 27.50, 79, 'male', 'L2Monster', 'Fighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 0, 506, 0, 0, 0, 30, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4563, 27344, 'Shilens Evil Thoughts', '', 'LineageNPC.training_doll_150p', 13.00, 40.00, 51, 'etc', 'L2Monster', 'Fighter', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 449, 287, 307, 210, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4564, 27345, 'Shilens Evil Thoughts', '', 'LineageNPC.training_doll_150p', 13.00, 40.00, 61, 'etc', 'L2Monster', 'Fighter', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 752, 378, 513, 278, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4565, 27346, 'Shilens Evil Thoughts', '', 'LineageNPC.training_doll_150p', 20.00, 40.00, 79, 'male', 'L2Monster', 'Fighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 0, 506, 0, 0, 0, 45, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4566, 27347, 'Guards of the Dawn Oracle', '', 'LineageNPC.a_fighterguild_master_Mhuman', 8.00, 23.50, 85, 'male', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4567, 27348, 'Guards of the Dawn Oracle', '', 'LineageNPC.a_fighterguild_master_Mhuman', 8.00, 23.50, 85, 'male', 'L2Npc', 'npc', 80, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 16, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4568, 27349, 'Guards of the Dawn Oracle', '', 'LineageNPC.a_mageguild_master_MHuman', 8.00, 24.00, 85, 'male', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4569, 27350, 'Guards of the Dawn Oracle', '', 'LineageNPC.a_mageguild_master_MHuman', 8.00, 24.00, 85, 'male', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 5, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4570, 27351, 'Guards of the Dawn', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 85, 'female', 'L2Npc', 'GuardOfTheDawn', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 6, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4571, 27352, 'Guards of the Dawn Oracle', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 85, 'female', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 6, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4572, 27353, 'Lilim Butcher', '', 'LineageMonster2.lilim_assassin_10_sm', 11.00, 36.00, 51, 'male', 'L2Npc', 'npc', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 449, 287, 307, 210, 253, 0, 506, 232, 232, 0, 36, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4573, 27354, 'Lilim Magus', '', 'LineageMonster2.lilim_wizard_10_sm', 8.00, 30.60, 51, 'female', 'L2Npc', 'npc', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 449, 287, 307, 210, 253, 0, 506, 0, 0, 0, 50, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4574, 27355, 'Lilim Slave Knight', '', 'LineageMonster2.lilim_knight_10_sm', 11.00, 45.00, 51, 'male', 'L2Npc', 'npc', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 449, 287, 307, 210, 253, 0, 506, 5800, 5799, 0, 56, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4575, 27356, 'Lilim Stabber', '', 'LineageMonster2.lilim_assassin_10_sm', 11.00, 36.00, 51, 'male', 'L2Npc', 'npc', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 449, 287, 307, 210, 253, 0, 506, 229, 229, 0, 36, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4576, 27357, 'Lilim Seer', '', 'LineageMonster2.lilim_wizard_10_sm', 8.00, 30.60, 51, 'female', 'L2Npc', 'npc', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 449, 287, 307, 210, 253, 0, 506, 0, 0, 0, 50, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4577, 27358, 'Lilim Knight', '', 'LineageMonster2.lilim_knight_10_sm', 11.00, 45.00, 51, 'male', 'L2Npc', 'npc', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 449, 287, 307, 210, 253, 0, 506, 5800, 5799, 0, 56, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4578, 27359, 'Lilim Assassin', '', 'LineageMonster2.lilim_assassin_10_bi', 13.00, 44.00, 51, 'male', 'L2Npc', 'npc', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 449, 287, 307, 210, 253, 0, 506, 234, 234, 0, 36, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4579, 27360, 'Lilim Great Magus', '', 'LineageMonster2.lilim_wizard_10_bi', 10.00, 37.50, 51, 'female', 'L2Npc', 'npc', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 449, 287, 307, 210, 253, 0, 506, 0, 0, 0, 50, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4580, 27361, 'Lilim Guard Knight', '', 'LineageMonster2.lilim_knight_10_bi', 13.00, 55.00, 51, 'male', 'L2Npc', 'npc', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 449, 287, 307, 210, 253, 0, 506, 5800, 5799, 0, 56, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4581, 27362, 'Lilim Butcher', '', 'LineageMonster2.lilim_assassin_10_sm', 11.00, 36.00, 61, 'male', 'L2Npc', 'npc', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 752, 378, 513, 278, 253, 0, 506, 232, 232, 0, 36, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4582, 27363, 'Lilim Magus', '', 'LineageMonster2.lilim_wizard_10_sm', 8.00, 30.60, 61, 'female', 'L2Npc', 'npc', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 752, 378, 513, 278, 253, 0, 506, 0, 0, 0, 50, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4583, 27364, 'Lilim Slave Knight', '', 'LineageMonster2.lilim_knight_10_sm', 11.00, 45.00, 61, 'male', 'L2Npc', 'npc', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 752, 378, 513, 278, 253, 0, 506, 5800, 5799, 0, 56, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4584, 27365, 'Lilim Stabber', '', 'LineageMonster2.lilim_assassin_10_sm', 11.00, 36.00, 61, 'male', 'L2Npc', 'npc', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 752, 378, 513, 278, 253, 0, 506, 229, 229, 0, 36, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4585, 27366, 'Lilim Seer', '', 'LineageMonster2.lilim_wizard_10_sm', 8.00, 30.60, 61, 'female', 'L2Npc', 'npc', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 752, 378, 513, 278, 253, 0, 506, 0, 0, 0, 50, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4586, 27367, 'Lilim Knight', '', 'LineageMonster2.lilim_knight_10_sm', 11.00, 45.00, 61, 'male', 'L2Npc', 'npc', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 752, 378, 513, 278, 253, 0, 506, 5800, 5799, 0, 56, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4587, 27368, 'Lilim Assassin', '', 'LineageMonster2.lilim_assassin_10_bi', 13.00, 44.00, 61, 'male', 'L2Npc', 'npc', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 752, 378, 513, 278, 253, 0, 506, 234, 234, 0, 36, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4588, 27369, 'Lilim Great Magus', '', 'LineageMonster2.lilim_wizard_10_bi', 10.00, 37.50, 61, 'female', 'L2Npc', 'npc', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 752, 378, 513, 278, 253, 0, 506, 0, 0, 0, 50, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4589, 27370, 'Lilim Guard Knight', '', 'LineageMonster2.lilim_knight_10_bi', 13.00, 55.00, 61, 'male', 'L2Npc', 'npc', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 752, 378, 513, 278, 253, 0, 506, 5800, 5799, 0, 56, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4590, 27371, 'Lilim Butcher', '', 'LineageMonster2.lilim_assassin_10_sm', 11.00, 36.00, 79, 'male', 'L2Monster', 'EpicQuestFighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 400, 506, 232, 232, 0, 36, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4591, 27372, 'Lilim Magus', '', 'LineageMonster2.lilim_wizard_10_sm', 8.00, 30.60, 79, 'female', 'L2Monster', 'EpicQuestMage', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 400, 506, 0, 0, 0, 50, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4592, 27373, 'Lilim Slave Knight', '', 'LineageMonster2.lilim_knight_10_sm', 11.00, 45.00, 79, 'male', 'L2Monster', 'EpicQuestFighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 400, 506, 5800, 5799, 0, 56, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4593, 27374, 'Shilens Evil Thoughts', '', 'LineageMonster2.lilim_assassin_10_sm', 20.00, 40.00, 79, 'male', 'L2Monster', 'Fighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 400, 506, 0, 0, 0, 45, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4594, 27375, 'Shilens Evil Thoughts', '', 'LineageMonster2.lilim_wizard_10_sm', 14.00, 27.50, 79, 'male', 'L2Monster', 'Fighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 400, 506, 0, 0, 0, 30, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4595, 27376, 'Lilim Knight', '', 'LineageMonster2.lilim_knight_10_sm', 11.00, 45.00, 79, 'male', 'L2Monster', 'Fighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 400, 506, 5800, 5799, 0, 56, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4596, 27377, 'Lilim Assassin', '', 'LineageMonster2.lilim_assassin_10_bi', 13.00, 44.00, 79, 'male', 'L2Monster', 'EpicQuestFighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 400, 506, 234, 234, 0, 36, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4597, 27378, 'Lilim Great Magus', '', 'LineageMonster2.lilim_wizard_10_bi', 10.00, 37.50, 79, 'female', 'L2Monster', 'EpicQuestMage', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 400, 506, 0, 0, 0, 50, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4598, 27379, 'Lilim Guard Knight', '', 'LineageMonster2.lilim_knight_10_bi', 13.00, 55.00, 79, 'male', 'L2Monster', 'EpicQuestFighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 400, 506, 5800, 5799, 0, 56, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4599, 27380, 'Reckless Sprite of Water', '', 'LineageMonster.undine', 12.00, 27.00, 76, 'female', 'L2Monster', 'Fighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 60, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4600, 27381, 'Reckless Sprite of Air', '', 'LineageMonster.sylph', 11.00, 35.00, 76, 'female', 'L2Monster', 'Fighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 60, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4601, 27382, 'Power of Seal Isolation', '', 'LineageNPC.training_doll_150p', 13.00, 40.00, 51, 'etc', 'L2Npc', 'npc', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 449, 287, 307, 210, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4602, 27383, 'Power of Seal Isolation', '', 'LineageNPC.training_doll_150p', 13.00, 40.00, 61, 'etc', 'L2Npc', 'npc', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 752, 378, 513, 278, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4603, 27384, 'Seal Device', '', 'LineageNPCsEV.ssq_sealing_emperor_m00', 21.00, 24.00, 79, 'female', 'L2Monster', 'SealDevice', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4604, 27385, 'Lilith', '', 'LineageMonster2.lilith', 42.50, 55.00, 85, 'female', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 45, 200, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4605, 27386, 'Liliths Steward', '', 'LineageMonster2.lilim_wizard', 9.00, 34.00, 85, 'female', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 190, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4606, 27387, 'Liliths Elite', '', 'LineageMonster2.lilim_knight', 12.00, 50.00, 85, 'male', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 56, 220, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4607, 27388, 'Anakim', '', 'LineageMonster2.anakim', 15.50, 29.00, 85, 'female', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 45, 200, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4608, 27389, 'Anakims Guardian', '', 'LineageMonster2.nephilim_priest', 23.00, 40.50, 85, 'male', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 190, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4609, 27390, 'Anakims Guard', '', 'LineageMonster2.nephilim_lord', 12.00, 43.00, 85, 'male', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 65, 220, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4610, 27391, 'Anakims Executor', '', 'LineageMonster2.nephilim_slayer', 12.00, 36.00, 85, 'male', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 65, 190, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4611, 27392, 'Bloody Axe Aide', '', 'LineageMonster.ol_mahum_champion', 14.00, 27.00, 65, 'male', 'L2Npc', 'npc', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 898, 419, 613, 306, 253, 0, 506, 69, 19, 0, 50, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4612, 27393, 'Headless Knight', '', 'LineageMonster.headless_knight', 21.00, 31.00, 65, 'male', 'L2Npc', 'npc', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 898, 419, 613, 306, 253, 0, 506, 135, 0, 0, 70, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4613, 27394, 'Shilens Evil Thoughts', '', 'LineageNPC.training_doll_150p', 13.00, 40.00, 51, 'etc', 'L2Npc', 'npc', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 449, 287, 307, 210, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4614, 27395, 'Shilens Evil Thoughts', '', 'LineageNPC.training_doll_150p', 13.00, 40.00, 61, 'etc', 'L2Npc', 'npc', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 752, 378, 513, 278, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4615, 27396, 'Shilens Evil Thoughts', '', 'LineageNPC.training_doll_150p', 14.00, 27.50, 79, 'male', 'L2Minion', 'npc', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 0, 506, 0, 0, 0, 30, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4616, 27397, 'Shilens Evil Thoughts', '', 'LineageNPC.training_doll_150p', 13.00, 40.00, 51, 'etc', 'L2Npc', 'npc', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 449, 287, 307, 210, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4617, 27398, 'Shilens Evil Thoughts', '', 'LineageNPC.training_doll_150p', 13.00, 40.00, 61, 'etc', 'L2Npc', 'npc', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 752, 378, 513, 278, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4618, 27399, 'Shilens Evil Thoughts', '', 'LineageNPC.training_doll_150p', 14.00, 27.50, 79, 'male', 'L2Npc', 'npc', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 0, 506, 0, 0, 0, 30, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4619, 27400, 'Shilens Evil Thoughts', '', 'LineageNPC.training_doll_150p', 13.00, 40.00, 51, 'etc', 'L2Npc', 'npc', 40, 1470, 6.500, 776, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 449, 287, 307, 210, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4620, 27401, 'Shilens Evil Thoughts', '', 'LineageNPC.training_doll_150p', 13.00, 40.00, 61, 'etc', 'L2Npc', 'npc', 40, 1986, 7.500, 1067, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 752, 378, 513, 278, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4621, 27402, 'Shilens Evil Thoughts', '', 'LineageNPC.training_doll_150p', 14.00, 27.50, 79, 'male', 'L2Npc', 'npc', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 0, 506, 0, 0, 0, 30, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3130, 29001, 'Queen Ant', '', 'queen_ant', 45.00, 53.00, 40, 'female', 'QueenAnt', 'Mystic', 40, 96596, 208.000, 301, 2.100, 60, 57, 73, 76, 70, 80, 2179536, 140740, 135, 1615, 10, 295, 253, 0, 506, 0, 0, 0, 80, 230, 'queen_ant_clan', 2000, 0, 0, 0, 300, 30, 4, 5, 0, -18, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3131, 29002, 'Queen Ant Larva', '', 'ant_larva', 12.00, 8.00, 38, 'male', 'QueenAntLarva', 'Fighter', 40, 592, 3.500, 315, 1.500, 40, 43, 30, 21, 20, 20, 0, 1, 113, 151, 75, 107, 253, 0, 506, 0, 0, 0, 40, 60, 'queen_ant_clan', 4500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3132, 29003, 'Nurse Ant', '', 'ant', 26.00, 15.00, 35, 'male', 'L2Minion', 'Queen_Ant_Nurse', 40, 4000, 108.000, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 1, 790, 678, 490, 248, 253, 0, 506, 0, 0, 0, 40, 130, 'queen_ant_clan', 700, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3133, 29004, 'Guard Ant', '', 'ant', 26.00, 15.00, 37, 'male', 'L2SpecialMonster', 'Fighter', 40, 4343, 115.000, 433, 1.800, 40, 43, 30, 21, 20, 20, 0, 1, 224, 728, 34, 266, 253, 500, 506, 0, 0, 0, 40, 230, 'queen_ant_clan', 700, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3134, 29005, 'Royal Guard Ant', '', 'ant', 26.00, 15.00, 39, 'male', 'L2Minion', 'Fighter', 40, 7051, 122.000, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 1, 1523, 781, 1375, 285, 253, 0, 506, 0, 0, 0, 40, 230, 'queen_ant_clan', 700, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3135, 29006, 'Core', '', 'core', 140.00, 75.00, 50, 'male', 'L2Boss', 'Core', 40, 261552, 441.650, 1709, 20.000, 60, 57, 73, 76, 70, 80, 2041407, 153786, 1004, 2227, 1945, 407, 253, 0, 506, 0, 0, 0, 50, 110, 'curma_core_clan', 4500, 0, 0, 0, 10, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3136, 29007, 'Death Knight', '', 'death_knight', 12.00, 31.00, 50, 'male', 'L2Minion', 'Fighter', 40, 13817, 166.000, 748, 2.100, 40, 43, 30, 21, 20, 20, 0, 1, 570, 1113, 96, 407, 253, 1050, 506, 75, 0, 0, 27, 110, 'curma_core_clan', 2300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3137, 29008, 'Doom Wraith', '', 'death_blader', 15.00, 45.00, 55, 'male', 'L2Minion', 'Fighter', 40, 16012, 185.000, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 1, 677, 1289, 1030, 471, 253, 950, 506, 1472, 0, 0, 100, 230, 'curma_core_clan', 700, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3138, 29009, 'Dicor', '', 'mandragora_b', 12.00, 25.50, 47, 'female', 'L2SpecialMonster', 'Fighter', 40, 12544, 154.000, 665, 2.100, 40, 43, 30, 21, 20, 20, 0, 1, 481, 1016, 82, 371, 253, 650, 506, 0, 0, 0, 80, 120, 'curma_core_clan', 800, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.13, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3139, 29010, 'Validus', '', 'grave', 15.00, 29.00, 46, 'male', 'L2SpecialMonster', 'Fighter', 40, 12130, 150.000, 638, 2.100, 40, 43, 30, 21, 20, 20, 0, 1, 455, 984, 78, 360, 253, 750, 506, 0, 0, 0, 70, 110, 'curma_core_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3140, 29011, 'Susceptor', '', 'susceptor', 20.00, 35.00, 49, 'male', 'L2Minion', 'Fighter', 40, 13389, 162.000, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 1, 540, 1081, 91, 395, 253, 850, 506, 0, 0, 0, 27, 150, 'curma_core_clan', 1500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3141, 29012, 'Perum', '', 'iron_golem', 18.00, 34.00, 48, 'male', 'L2SpecialMonster', 'Mystic', 40, 12964, 158.000, 692, 2.100, 40, 43, 30, 21, 20, 20, 0, 1, 510, 1048, 86, 384, 253, 750, 506, 0, 0, 0, 20, 20, 'curma_core_clan', 800, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3142, 29013, 'Premo', '', 'troll', 21.00, 35.00, 45, 'male', 'L2SpecialMonster', 'Fighter', 40, 11721, 146.000, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 1, 429, 953, 74, 348, 253, 0, 506, 0, 0, 0, 55, 110, 'curma_core_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3143, 29014, 'Orfen', '', 'orfen', 35.00, 143.00, 50, 'female', 'Orfen', 'Orfen', 40, 261552, 441.650, 1709, 20.000, 60, 57, 73, 76, 70, 80, 2041407, 153786, 1004, 2227, 1945, 407, 253, 500, 506, 0, 0, 0, 60, 230, 'orfen_clan', 3500, 0, 0, 0, 300, 30, 4, 5, 0, -18, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3144, 29015, 'Raikel', '', 'raikel', 37.00, 64.00, 48, 'male', 'L2SpecialMonster', 'Mystic', 40, 6482, 158.000, 692, 2.100, 40, 43, 30, 21, 20, 20, 0, 1, 408, 1048, 55, 384, 253, 0, 506, 0, 0, 0, 60, 230, 'orfen_clan', 2500, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3145, 29016, 'Raikel Leos', '', 'raikel', 37.00, 64.00, 49, 'male', 'L2Minion', 'Fighter', 40, 6694, 162.000, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 1, 1460, 1081, 2157, 395, 253, 0, 506, 0, 0, 0, 60, 230, 'orfen_clan', 2700, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3146, 29017, 'Riba', '', 'riba', 25.00, 72.00, 48, 'female', 'L2SpecialMonster', 'Mystic', 40, 6482, 158.000, 692, 2.100, 40, 43, 30, 21, 20, 20, 0, 1, 408, 1048, 55, 384, 253, 0, 506, 0, 0, 0, 60, 230, 'orfen_clan', 2700, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3147, 29018, 'Riba Iren', '', 'riba', 25.00, 72.00, 49, 'female', 'L2SpecialMonster', 'Orfen_RibaIren', 40, 13389, 162.000, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 1, 1460, 1081, 2157, 395, 253, 500, 506, 0, 0, 0, 60, 230, 'orfen_clan', 2900, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3148, 29019, 'Antharas', '', 'antaras', 300.00, 300.00, 79, 'male', 'L2Boss', 'Antharas', 40, 7500000, 1100.000, 18000, 99.000, 60, 57, 73, 76, 70, 80, 262720912, 29116376, 8232, 6451, 4284, 1386, 253, 2000, 506, 0, 0, 0, 50, 186, '', 300, 0, 0, 0, 14, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (3149, 29020, 'Baium', '', 'baium', 65.00, 174.00, 75, 'male', 'L2Boss', 'Baium', 40, 1709400, 750.000, 18000, 99.000, 60, 57, 73, 76, 70, 80, 10253401, 1081544, 5533, 5412, 3608, 3608, 253, 1000, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 13, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (3150, 29021, 'Archangel', '', 'archangel', 15.00, 80.00, 74, 'male', 'L2Minion', 'Fighter', 80, 186915, 158.000, 1475, 3.000, 40, 43, 30, 21, 20, 20, 6571, 343, 2274, 8326, 605, 2748, 253, 500, 506, 93, 0, 0, 50, 170, 'archangel_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, -18, 0.76, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3151, 29022, 'Zaken', '', 'zaken', 16.00, 32.00, 60, 'male', 'L2Boss', 'Zaken', 40, 360722, 346.800, 180000, 100.000, 60, 57, 73, 76, 70, 80, 4879746, 423589, 5388, 2952, 2265, 1439, 253, 500, 506, 0, 0, 0, 42, 190, '', 300, 0, 0, 0, 300, 30, 4, 5, 0, -18, 0.59, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3152, 29023, 'Doll Blader', '', 'doll_blader', 6.00, 12.00, 58, 'male', 'L2Monster', 'Fighter', 40, 1828, 6.500, 832, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 650, 384, 444, 281, 253, 150, 506, 5129, 0, 0, 22, 150, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3153, 29024, 'Vale master', '', 'vale_master', 12.00, 40.00, 59, 'male', 'L2Monster', 'Fighter', 40, 1880, 6.500, 861, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 682, 395, 466, 289, 253, 150, 506, 0, 0, 0, 70, 155, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3154, 29025, 'Baium', '', 'baium_npc', 65.00, 82.00, 75, 'male', 'L2Npc', 'BaiumNpc', 40, 1709400, 718.000, 18000, 99.000, 60, 57, 73, 76, 70, 80, 0, 0, 3073, 5412, 2619, 3608, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3155, 29026, 'Pirate Zombie Captain', '', 'pirates_zombie_captain', 17.00, 28.00, 60, 'male', 'L2Monster', 'Fighter', 40, 1933, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 626, 405, 489, 297, 253, 150, 506, 232, 0, 0, 14, 140, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.76, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3156, 29027, 'Pirate Zombie', '', 'pirates_zombie', 10.00, 23.00, 57, 'male', 'L2Monster', 'Mystic', 40, 1776, 6.500, 584, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 542, 374, 422, 273, 253, 150, 506, 225, 0, 0, 11, 140, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3157, 29028, 'Valakas', '', 'valakas', 190.00, 335.00, 85, 'male', 'L2Boss', 'Valakas', 40, 93742616, 1836.000, 2025740, 1000.000, 60, 57, 73, 76, 70, 80, 296105312, 29014318, 28016, 7604, 11606, 2064, 253, 1500, 506, 0, 0, 0, 120, 300, 'valakas_clan', 300, 0, 0, 0, 21, 50, 1, 9, 0, 3, 0.60, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (3158, 29029, 'Lavasaurus Pustbon', '', 'golem', 15.00, 75.00, 85, 'male', 'L2SpecialMonster', 'PaganGuard', 1100, 4130, 67.007, 1980, 3.960, 40, 43, 30, 21, 20, 20, 0, 0, 4646, 675, 1413, 494, 253, 1200, 506, 0, 0, 0, 1, 1, 'valakas_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -1, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3159, 29030, 'Fenril Hound Kerinne', '', 'bandersnatch_20_bi', 21.00, 30.00, 84, 'male', 'L2RaidBoss', 'Fighter', 40, 104586, 170.720, 1658, 9.700, 60, 57, 73, 76, 70, 80, 2407887, 1226568, 4346, 4640, 1016, 849, 253, 1500, 506, 0, 0, 0, 30, 200, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -21, 0.49, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3160, 29031, 'Kerinnes Ifrit', '', 'ifrit', 10.00, 42.00, 84, 'male', 'L2Minion', 'Priest', 40, 20649, 33.792, 1608, 3.840, 40, 43, 30, 21, 20, 20, 0, 0, 8415, 2268, 5860, 830, 253, 1500, 506, 0, 0, 0, 38, 170, 'fire_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, -4, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3161, 29032, 'Kerinnes Golem', '', 'lava_golem', 22.00, 45.00, 84, 'male', 'L2Minion', 'Fighter', 40, 2854, 48.000, 1608, 3.840, 40, 43, 30, 21, 20, 20, 0, 0, 8415, 2268, 5860, 830, 253, 1500, 506, 0, 0, 0, 13, 60, 'fire_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, -4, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3162, 29033, 'Fenril Hound Freki', '', 'bandersnatch_20_bi', 21.00, 30.00, 84, 'male', 'L2RaidBoss', 'Fighter', 40, 105872, 171.990, 1708, 9.800, 60, 57, 73, 76, 70, 80, 2434088, 1257012, 4488, 4744, 1057, 868, 253, 1500, 506, 0, 0, 0, 30, 200, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -20, 0.49, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3163, 29034, 'Frekis Ifrit', '', 'ifrit', 10.00, 42.00, 84, 'male', 'L2Minion', 'Mystic', 40, 20917, 34.920, 1658, 3.880, 40, 43, 30, 21, 20, 20, 0, 0, 11562, 2320, 10889, 849, 253, 1500, 506, 0, 0, 0, 38, 170, 'fire_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, -3, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3164, 29035, 'Frekis Golem', '', 'lava_golem', 22.00, 45.00, 84, 'male', 'L2Minion', 'Fighter', 40, 20917, 34.920, 1658, 3.880, 40, 43, 30, 21, 20, 20, 0, 0, 8693, 2320, 6124, 849, 253, 1500, 506, 0, 0, 0, 13, 60, 'fire_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, -3, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3165, 29036, 'Fenril Hound Uruz', '', 'bandersnatch_20_bi', 21.00, 30.00, 84, 'male', 'L2RaidBoss', 'Fighter', 40, 214199, 345.510, 1760, 9.900, 60, 57, 73, 76, 70, 80, 2466262, 1289662, 9259, 4849, 1099, 887, 253, 1500, 506, 0, 0, 0, 30, 200, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -19, 0.49, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3166, 29037, 'Fenril Hound Kinaz', '', 'bandersnatch_20_bi', 21.00, 30.00, 84, 'male', 'L2RaidBoss', 'Fighter', 40, 108267, 174.000, 1812, 10.000, 60, 57, 73, 76, 70, 80, 2504880, 1322688, 4775, 4953, 1142, 907, 253, 1500, 506, 0, 0, 0, 30, 200, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.49, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3167, 29038, 'Kinazs Ifrit', '', 'ifrit', 10.00, 42.00, 84, 'male', 'L2Minion', 'Mystic', 40, 20917, 34.920, 1658, 3.880, 40, 43, 30, 21, 20, 20, 0, 0, 11562, 2320, 10889, 849, 253, 1500, 506, 0, 0, 0, 38, 170, 'fire_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, -3, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3168, 29039, 'Kinazs Ifrit', '', 'ifrit', 10.00, 42.00, 84, 'male', 'L2Minion', 'Priest', 40, 20917, 34.920, 1658, 3.880, 40, 43, 30, 21, 20, 20, 0, 0, 8693, 2320, 6124, 849, 253, 1500, 506, 0, 0, 0, 38, 170, 'fire_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, -3, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3169, 29040, 'Wings of Flame, Ixion', '', 'inferno_drake_20_bi', 29.00, 42.00, 84, 'male', 'L2RaidBoss', 'Fighter', 40, 218742, 349.460, 1865, 10.100, 60, 57, 73, 76, 70, 80, 2535975, 1356048, 9840, 5057, 1185, 926, 253, 1500, 506, 0, 0, 0, 57, 200, 'fire_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -17, 0.48, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3170, 29041, 'Inferno Golem', '', 'lava_golem', 22.00, 45.00, 84, 'male', 'L2Minion', 'Fighter', 40, 20917, 34.920, 1658, 3.880, 40, 43, 30, 21, 20, 20, 0, 0, 17385, 2320, 24495, 849, 253, 1500, 506, 0, 0, 0, 13, 60, 'fire_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, -3, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3171, 29042, 'Inferno Golem', '', 'lava_golem', 22.00, 45.00, 84, 'male', 'L2Minion', 'Fighter', 40, 20917, 34.920, 1658, 3.880, 40, 43, 30, 21, 20, 20, 0, 0, 8693, 2320, 6124, 849, 253, 1500, 506, 0, 0, 0, 13, 60, 'fire_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, -3, 0.47, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3172, 29043, 'Howling Ifrit', '', 'ifrit', 10.00, 42.00, 84, 'male', 'L2Minion', 'Mystic', 40, 20917, 34.920, 1658, 3.880, 40, 43, 30, 21, 20, 20, 0, 0, 8693, 2320, 6124, 849, 253, 1500, 506, 0, 0, 0, 38, 170, 'fire_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, -3, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3173, 29044, 'Howling Ifrit', '', 'ifrit', 10.00, 42.00, 84, 'male', 'L2Minion', 'Priest', 40, 20917, 34.920, 1658, 3.880, 40, 43, 30, 21, 20, 20, 0, 0, 11562, 2320, 10889, 849, 253, 1500, 506, 0, 0, 0, 38, 170, 'fire_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, -3, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3174, 29045, 'Frintezza', '', 'frintessa', 45.00, 42.70, 85, 'male', 'L2Npc', 'npc', 40, 428076, 2484.300, 23424, 3.150, 60, 57, 73, 76, 43, 80, 0, 0, 4597, 7341, 1691, 5384, 253, 0, 506, 0, 0, 0, 30, 31, 'frintessa_clan', 0, 0, 0, 0, 15, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (3175, 29046, 'Scarlet van Halisha', '', 'follower_of_frintessa', 45.00, 90.70, 85, 'male', 'L2Boss', 'Scarlet', 40, 2254518, 248.430, 11027, 109.000, 60, 57, 73, 76, 43, 80, 0, 0, 5457, 2337, 2511, 3635, 253, 6000, 506, 8204, 0, 0, 240, 111, 'frintessa_clan', 2000, 0, 0, 0, 18, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (3176, 29047, 'Scarlet van Halisha', '', 'follower_of_frintessa_tran', 92.00, 112.80, 85, 'male', 'L2Boss', 'Scarlet', 40, 3842433, 248.430, 23157, 109.000, 60, 57, 73, 76, 43, 80, 130849000, 10028450, 15469, 2727, 15641, 3818, 253, 6000, 506, 8222, 0, 0, 250, 155, 'frintessa_clan', 2000, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (3177, 29048, 'Evil Spirit', '', 'Evilate', 40.00, 100.00, 85, 'female', 'L2SpecialMonster', 'Fighter', 40, 82845, 1.030, 2177, 1.030, 40, 43, 30, 21, 20, 20, 0, 0, 2848, 2848, 2004, 1900, 253, 6000, 506, 0, 0, 0, 10, 1, 'frintessa_clan', 1000, 0, 0, 0, 7, 10, 4, 5, 0, 3, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3178, 29049, 'Evil Spirit', '', 'Evilate', 40.00, 100.00, 85, 'female', 'L2SpecialMonster', 'Fighter', 40, 82845, 1.030, 2177, 1.030, 40, 43, 30, 21, 20, 20, 0, 0, 2848, 2848, 2004, 1900, 253, 6000, 506, 0, 0, 0, 10, 1, 'frintessa_clan', 1000, 0, 0, 0, 7, 10, 4, 5, 0, 3, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3179, 29050, 'Breath of Halisha', '', 'portrait_spirit', 23.00, 40.00, 85, 'male', 'L2SpecialMonster', 'Fighter', 40, 12996, 1.010, 20560, 3.030, 40, 43, 30, 21, 20, 20, 0, 0, 2709, 1117, 1869, 745, 253, 6000, 506, 0, 0, 0, 30, 200, 'frintessa_clan', 2000, 0, 0, 0, 7, 10, 4, 5, 0, 1, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3180, 29051, 'Breath of Halisha', '', 'portrait_spirit_winged', 23.00, 40.00, 85, 'male', 'L2SpecialMonster', 'Fighter', 40, 12996, 1.010, 20560, 3.030, 40, 43, 30, 21, 20, 20, 0, 0, 2709, 1117, 1869, 745, 253, 6000, 506, 0, 0, 0, 30, 200, 'frintessa_clan', 2000, 0, 0, 0, 7, 10, 4, 5, 0, 1, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3181, 29052, 'organ_dummy', '', 'ti_mi_tran', 1.00, 35.00, 85, 'female', 'L2Npc', 'Turnir', 40, 3960, 8.585, 2057, 3.030, 40, 43, 30, 21, 20, 20, 0, 0, 2116, 6725, 1460, 4919, 253, 0, 506, 0, 0, 0, 10, 1, 'frintessa_clan', 0, 0, 0, 0, 7, 10, 4, 5, 0, 1, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3182, 29053, 'follower_dummy', '', 'Follower_Dummy', 1.00, 58.00, 85, 'female', 'L2SpecialMonster', 'Fighter', 40, 5449, 8.500, 2036, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2533, 666, 1730, 489, 253, 0, 506, 0, 0, 0, 10, 1, 'frintessa_clan', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3183, 29054, 'Benom', '', 'benom', 20.00, 56.00, 75, 'male', 'L2RaidBoss', 'Fighter', 40, 568382, 357.000, 4071, 8.100, 60, 57, 73, 76, 70, 80, 2499951, 1757872, 7396, 4189, 5378, 766, 253, 0, 506, 8203, 8203, 0, 79, 220, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.43, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3184, 29055, 'Teleportation Cubic', '', 'teleport_npc', 40.00, 80.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 6000, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3185, 29056, 'Ice Fairy Sirra', '', 'ice_fairy', 16.00, 35.60, 60, 'female', 'L2RaidBoss', 'Fighter', 40, 79150, 147.558, 1037, 2.400, 60, 57, 73, 76, 70, 80, 1610848, 371722, 1904, 2952, 648, 539, 253, 500, 506, 0, 0, 0, 30, 190, 'ice_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.43, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (3186, 29057, 'Sirras Page', '', 'sylph_110p', 12.00, 39.70, 59, 'female', 'L2Minion', 'Fighter', 40, 7721, 57.969, 1007, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 1748, 1437, 573, 525, 253, 0, 506, 0, 0, 0, 60, 190, 'ice_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3187, 29058, 'Sirras Beholder', '', 'field_stalker_20_bi', 18.00, 36.00, 59, 'male', 'L2Minion', 'Fighter', 40, 3861, 57.969, 1007, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 1748, 1437, 573, 525, 253, 0, 506, 0, 0, 0, 70, 190, 'ice_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3188, 29059, '9C', '', 'clear_npc', 0.10, 0.10, 80, 'male', 'L2Npc', 'npc', 40, 3199, 8.925, 1939, 3.150, 40, 43, 30, 21, 20, 20, 0, 0, 1744, 642, 1251, 470, 253, 0, 506, 0, 0, 0, 1, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 5, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3189, 29060, 'Captain of the Ice Queens Royal Guard', '', 'gargoyle_02te_120p', 19.00, 61.00, 59, 'male', 'L2RaidBoss', 'Fighter', 40, 66184, 124.219, 1007, 2.400, 60, 57, 73, 76, 70, 80, 1749007, 397080, 1575, 2876, 465, 525, 253, 0, 506, 0, 0, 0, 140, 190, 'ice_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.37, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3190, 29061, 'Teleportation Cubic', '', 'teleport_npc_frin', 40.00, 80.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 500, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3191, 29062, 'Andreas Van Halter', '', 'heretic_priest_110p', 9.00, 21.30, 80, 'male', 'L2RaidBoss', 'Fighter', 40, 115708, 364.870, 2051, 3.210, 60, 57, 73, 76, 70, 80, 2915973, 2380617, 5298, 5344, 2099, 977, 253, 500, 506, 8208, 0, 0, 30, 210, 'andreas_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -11, 0.43, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3192, 29063, 'Andreas Acolyte', '', 'heretic_privates', 7.70, 28.40, 80, 'male', 'L2Minion', 'Fighter', 40, 15283, 145.856, 1995, 3.180, 40, 43, 30, 21, 20, 20, 0, 0, 13724, 2620, 14292, 958, 253, 500, 506, 8205, 0, 0, 60, 200, 'andreas_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 6, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3193, 29064, 'Andreas Acolyte', '', 'heretic_privates_a', 7.70, 28.40, 80, 'male', 'L2Minion', 'Fighter', 40, 22740, 145.320, 1939, 3.150, 40, 43, 30, 21, 20, 20, 0, 0, 9995, 2569, 7703, 940, 253, 500, 506, 8207, 8207, 0, 58, 200, 'andreas_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 5, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3194, 29065, 'Sailren', '', 'sailren', 100.00, 82.10, 80, 'male', 'L2Boss', 'Fighter', 40, 689061, 264.824, 2051, 3.210, 60, 57, 73, 76, 70, 80, 4569145, 592766, 5604, 2004, 2412, 977, 253, 0, 506, 0, 0, 0, 41, 185, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.66, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3195, 29066, 'Antharas', '', 'antaras', 300.00, 300.00, 79, 'male', 'L2Boss', 'Antharas', 40, 6100000, 1100.000, 1800000, 1000.000, 60, 57, 73, 76, 70, 80, 262720912, 29116376, 8232, 5806, 4284, 1450, 253, 2000, 506, 0, 0, 0, 50, 186, '', 300, 0, 0, 0, 14, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (3196, 29067, 'Antharas', '', 'antaras', 300.00, 300.00, 79, 'male', 'L2Boss', 'Antharas', 40, 6800000, 1100.000, 1800000, 1000.000, 60, 57, 73, 76, 70, 80, 354676032, 39307416, 8232, 5806, 4284, 1450, 253, 2000, 506, 0, 0, 0, 50, 186, '', 300, 0, 0, 0, 14, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (3197, 29068, 'Antharas', '', 'antaras', 300.00, 300.00, 85, 'male', 'L2Boss', 'Antharas', 40, 85998876, 1830.000, 1800000, 1000.000, 60, 57, 73, 76, 70, 80, 538538560, 52769503, 23234, 8262, 7999, 2062, 253, 2000, 506, 0, 0, 0, 50, 186, '', 300, 0, 0, 0, 14, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (3198, 29069, 'Behemoth Dragon', '', 'antaras_ex_a', 63.00, 54.00, 85, 'male', 'L2SpecialMonster', 'BehemothDragon', 40, 401552, 76.710, 1809, 3.000, 60, 57, 73, 76, 70, 80, 0, 0, 6238, 1864, 2413, 910, 253, 2000, 506, 0, 0, 0, 180, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3199, 29070, 'Dragon Bomber', '', 'antaras_ex_b_80p', 37.00, 28.00, 85, 'male', 'L2SpecialMonster', 'Fighter', 40, 1354, 8.500, 1809, 3.000, 60, 57, 73, 76, 70, 80, 0, 0, 1904, 621, 8529, 454, 253, 2000, 506, 0, 0, 0, 200, 250, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3200, 29071, 'Dragon Bomber', '', 'antaras_ex_b_80p', 37.00, 28.00, 78, 'male', 'L2SpecialMonster', 'Fighter', 40, 1000, 8.500, 1607, 3.000, 60, 57, 73, 76, 70, 80, 0, 0, 1430, 556, 975, 406, 253, 2000, 506, 0, 0, 0, 200, 245, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3201, 29072, 'Dragon Bomber', '', 'antaras_ex_b_80p', 37.00, 28.00, 78, 'male', 'L2SpecialMonster', 'Fighter', 40, 1000, 8.500, 1607, 3.000, 60, 57, 73, 76, 70, 80, 0, 0, 1430, 556, 975, 406, 253, 2000, 506, 0, 0, 0, 200, 255, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3202, 29073, 'Dragon Bomber', '', 'antaras_ex_b_80p', 37.00, 28.00, 78, 'male', 'L2SpecialMonster', 'Fighter', 40, 1000, 8.500, 1607, 3.000, 60, 57, 73, 76, 70, 80, 0, 0, 1430, 556, 975, 406, 253, 2000, 506, 0, 0, 0, 200, 247, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3203, 29074, 'Dragon Bomber', '', 'antaras_ex_b_80p', 37.00, 28.00, 78, 'male', 'L2SpecialMonster', 'Fighter', 40, 1000, 8.500, 1607, 3.000, 60, 57, 73, 76, 70, 80, 0, 0, 1430, 556, 975, 406, 253, 2000, 506, 0, 0, 0, 200, 252, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3204, 29075, 'Dragon Bomber', '', 'antaras_ex_b_80p', 37.00, 28.00, 78, 'male', 'L2SpecialMonster', 'Fighter', 40, 1000, 8.500, 1607, 3.000, 60, 57, 73, 76, 70, 80, 0, 0, 1430, 556, 975, 406, 253, 2000, 506, 0, 0, 0, 200, 243, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3205, 29076, 'Dragon Bomber', '', 'antaras_ex_b', 42.00, 34.50, 85, 'male', 'L2SpecialMonster', 'Fighter', 40, 1354, 8.500, 1809, 3.000, 60, 57, 73, 76, 70, 80, 0, 0, 1904, 621, 8529, 454, 253, 2000, 506, 0, 0, 0, 200, 250, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3206, 29077, 'antaras_clear_npc_1', '', 'clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3207, 29078, 'antaras_clear_npc_2', '', 'clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3208, 29079, 'antaras_clear_npc_3', '', 'clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3209, 29080, 'antaras_clear_npc_4', '', 'clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3210, 29081, 'antaras_clear_npc_5', '', 'clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3211, 29082, 'antaras_clear_npc_6', '', 'clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3212, 29083, 'antaras_clear_npc_7', '', 'clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3213, 29084, 'antaras_clear_npc_8', '', 'clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3214, 29085, 'antaras_clear_npc_9', '', 'clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3215, 29086, 'antaras_clear_npc_10', '', 'clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3216, 29087, 'antaras_clear_npc_11', '', 'clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3217, 29088, 'antaras_clear_npc_12', '', 'clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3218, 29089, 'antaras_clear_npc_13', '', 'clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3219, 29090, 'antaras_clear_npc_14', '', 'clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3220, 29091, 'antaras_clear_npc_15', '', 'clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3221, 29092, 'antaras_clear_npc_16', '', 'clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3222, 29093, 'antaras_clear_npc_17', '', 'clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3223, 29094, 'antaras_clear_npc_18', '', 'clear_npc', 0.10, 0.10, 78, 'male', 'L2Npc', 'npc', 40, 2803, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1430, 556, 975, 406, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3224, 29095, 'Gordon', '', 'Cruel_Rider', 43.00, 46.60, 80, 'male', 'L2RaidBoss', 'Gordon', 40, 961781, 369.614, 2051, 3.210, 60, 57, 73, 76, 70, 80, 5885017, 1455305, 10360, 2004, 8261, 977, 253, 1000, 506, 0, 0, 0, 60, 190, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -11, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3225, 29096, 'Anais', '', 'solina_priest_120p', 16.00, 41.80, 80, 'male', 'L2RaidBoss', 'Anais', 40, 480890, 147.845, 2051, 3.210, 60, 57, 73, 76, 70, 80, 8827525, 2036475, 5180, 2004, 2065, 977, 253, 1000, 506, 8214, 0, 0, 60, 160, 'solina_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, -11, 0.43, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3226, 29097, 'Splendor Disciple', '', 'apostle_grail', 13.00, 47.00, 80, 'male', 'L2Minion', 'Fighter', 40, 37734, 145.014, 1995, 3.180, 40, 43, 30, 21, 20, 20, 0, 0, 10160, 982, 7997, 958, 253, 0, 506, 8221, 0, 0, 30, 190, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, -12, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3227, 29098, 'Splendor Worshiper', '', 'apostle_grail_a', 13.00, 47.00, 80, 'male', 'L2Minion', 'Fighter', 40, 50564, 145.014, 1995, 3.180, 40, 43, 30, 21, 20, 20, 0, 0, 10160, 982, 7997, 958, 253, 0, 506, 0, 0, 0, 30, 190, 'solina_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, -12, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3228, 29099, 'Baylor', '', 'LineageMonster4.Barler', 54.00, 77.50, 83, 'male', 'L2Boss', 'Baylor', 40, 1078413, 100.863, 100000, 1000.000, 60, 57, 73, 76, 70, 80, 3190205, 2191683, 3610, 2434, 2465, 1782, 253, 2000, 506, 0, 0, 0, 34, 180, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.47, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (3229, 29100, 'Crystal Prison Guard', '', 'LineageMonster4.Eyeless', 36.00, 43.50, 83, 'male', 'L2Monster', 'Fighter', 40, 18734, 190.897, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3048, 974, 2081, 712, 253, 750, 506, 0, 0, 0, 60, 210, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (3230, 29101, 'Crystalline Golem', '', 'LineageMonster4.Crystal_Golem', 34.00, 47.00, 83, 'male', 'L2Monster', 'Fighter', 40, 112316, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 54, 170, 'door_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3231, 29102, 'Crystalline Golem', '', 'LineageMonster4.Crystal_Golem', 34.00, 47.00, 83, 'male', 'L2Monster', 'Fighter', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 54, 170, 'door_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3232, 29103, 'Baylor', '', 'LineageMonster4.Barler', 54.00, 77.50, 83, 'male', 'L2Boss', 'Baylor', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1634, 609, 1115, 445, 253, 2000, 506, 0, 0, 0, 34, 180, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (3233, 29104, 'Crystal Prison Guard', '', 'LineageMonster4.Eyeless', 36.00, 43.50, 83, 'male', 'L2Monster', 'Fighter', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 60, 210, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3234, 29105, 'Crystalline Golem', '', 'LineageMonster4.Crystal_Golem', 34.00, 47.00, 83, 'male', 'L2Monster', 'Fighter', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 54, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3235, 29106, 'barler_effect_npc', '', 'LineageNPC.clear_npc', 0.10, 0.10, 83, 'male', 'L2Npc', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 1, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3236, 29107, 'barler_effect_npc02', '', 'LineageNPC.clear_npc', 0.10, 0.10, 83, 'male', 'L2Npc', 'npc', 40, 1, 1.000, 1, 1.000, 40, 43, 30, 21, 20, 20, 0, 0, 2, 2, 2, 2, 253, 0, 506, 0, 0, 0, 1, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3237, 29108, 'barler_effect_npc03', '', 'LineageNPC.clear_npc', 0.10, 0.10, 83, 'male', 'L2Npc', 'npc', 40, 1, 1.000, 1, 1.000, 40, 43, 30, 21, 20, 20, 0, 0, 2, 2, 2, 2, 253, 0, 506, 0, 0, 0, 1, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3238, 29109, 'barler_effect_npc04', '', 'LineageNPC.clear_npc', 0.10, 0.10, 83, 'male', 'L2Npc', 'npc', 40, 1, 1.000, 1, 1.000, 40, 43, 30, 21, 20, 20, 0, 0, 2, 2, 2, 2, 253, 0, 506, 0, 0, 0, 1, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3239, 29110, 'barler_effect_npc05', '', 'LineageNPC.clear_npc', 0.10, 0.10, 83, 'male', 'L2Npc', 'npc', 40, 1, 1.000, 1, 1.000, 40, 43, 30, 21, 20, 20, 0, 0, 2, 2, 2, 2, 253, 0, 506, 0, 0, 0, 1, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3240, 29111, 'barler_effect_npc06', '', 'LineageNPC.clear_npc', 0.10, 0.10, 83, 'male', 'L2Npc', 'npc', 40, 1, 1.000, 1, 1.000, 40, 43, 30, 21, 20, 20, 0, 0, 2, 2, 2, 2, 253, 0, 506, 0, 0, 0, 1, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3241, 29112, 'barler_effect_npc07', '', 'LineageNPC.clear_npc', 0.10, 0.10, 83, 'male', 'L2Npc', 'npc', 40, 1, 1.000, 1, 1.000, 40, 43, 30, 21, 20, 20, 0, 0, 2, 2, 2, 2, 253, 0, 506, 0, 0, 0, 1, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3242, 29113, 'barler_effect_npc08', '', 'LineageNPC.clear_npc', 0.10, 0.10, 83, 'male', 'L2Npc', 'npc', 40, 1, 1.000, 1, 1.000, 40, 43, 30, 21, 20, 20, 0, 0, 2, 2, 2, 2, 253, 0, 506, 0, 0, 0, 1, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3243, 29114, 'barler_effect_npc09', '', 'LineageNPC.clear_npc', 0.10, 0.10, 83, 'male', 'L2Npc', 'npc', 40, 1, 1.000, 1, 1.000, 40, 43, 30, 21, 20, 20, 0, 0, 2, 2, 2, 2, 253, 0, 506, 0, 0, 0, 1, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3244, 29115, 'Crystal Prison Guard', '', 'LineageMonster4.eyeless_080p', 34.00, 35.00, 83, 'male', 'L2Npc', 'npc', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 60, 210, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3245, 29116, 'Baylors Treasure Chest', '', 'LineageMonster.Mimic_even', 8.50, 8.50, 83, 'male', 'L2Monster', 'Fighter', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3246, 29117, 'Baylors Treasure Chest', '', 'LineageMonster.Mimic_even', 8.50, 8.50, 83, 'male', 'L2Monster', 'Fighter', 40, 2985, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1634, 609, 1115, 445, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3247, 29118, 'Beleth', '', 'LineageMonster4.bereth_key', 15.00, 30.00, 83, 'male', 'L2RaidBoss', 'Beleth', 40, 2603600, 200.000, 1000000, 1000.000, 40, 43, 30, 21, 20, 20, 16447437, 1362651, 6880, 1015, 3956, 1118, 253, 800, 506, 0, 0, 0, 60, 160, 'beres_clan', 2000, 0, 0, 0, 20, 50, 4, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3248, 29119, 'Beleth', '', 'LineageMonster4.bereth', 15.00, 30.00, 83, 'male', 'L2RaidBoss', 'Beleth', 40, 994600, 200.000, 1000000, 1000.000, 40, 43, 30, 21, 20, 20, 0, 0, 6880, 1015, 3956, 1118, 253, 800, 506, 0, 0, 0, 60, 160, 'beres_clan', 2000, 0, 0, 0, 7, 50, 4, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3249, 29120, 'Beleth Camera 1', '', 'LineageNPC.clear_npc', 0.10, 0.10, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3250, 29121, 'Beleth Camera 2', '', 'LineageNPC.clear_npc', 0.10, 0.10, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3251, 29122, 'Beleth Camera 3', '', 'LineageNPC.clear_npc', 0.10, 0.10, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3252, 29123, 'Beleth Camera 4', '', 'LineageNPC.clear_npc', 0.10, 0.10, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3253, 29124, 'Beleth Camera 5', '', 'LineageNPC.clear_npc', 0.10, 0.10, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3254, 29125, 'Beleth Camera 6', '', 'LineageNPC2.bereth_entry', 8.50, 25.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 60, 150, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3255, 29126, 'Beleth Presentation Incarnation 1', '', 'LineageMonster4.bereth', 15.00, 30.00, 80, 'male', 'L2Npc', 'npc', 80, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 60, 160, '', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3256, 29127, 'Beleth Presentation Incarnation 2', '', 'LineageMonster4.bereth', 15.00, 30.00, 80, 'male', 'L2Npc', 'npc', 80, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 60, 160, '', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3257, 29128, 'Beleth Presentation Elf', '', 'LineageNPC2.bereth_fake', 7.00, 22.20, 80, 'male', 'L2Npc', 'npc', 40, 2880, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1513, 576, 1033, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3258, 29129, 'Lost Captain', '', 'LineageMonster.oel_mahum_champion_05te_120p', 48.00, 73.50, 29, 'male', 'L2ReflectionBoss', 'Fighter', 40, 51628, 9.659, 315, 1.500, 60, 57, 73, 76, 70, 80, 5013133, 233765, 590, 1221, 135, 596, 253, 0, 506, 0, 0, 0, 84, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.46, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3259, 29130, 'Lost Guard', '', 'LineageMonster.oel_mahum_warrior', 20.00, 38.00, 29, 'male', 'L2Minion', 'Fighter', 40, 3244, 4.829, 315, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 295, 204, 202, 99, 253, 0, 506, 72, 0, 0, 70, 160, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.65, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3260, 29131, 'Lost Assistant Guard', '', 'LineageMonster.oel_mahum_witch_doctor', 15.00, 34.00, 29, 'male', 'L2Minion', 'Priest', 40, 3244, 4.829, 315, 7.500, 40, 43, 30, 21, 20, 20, 0, 0, 197, 204, 135, 99, 253, 0, 506, 201, 0, 0, 70, 130, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.26, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3261, 29132, 'Lost Captain', '', 'LineageMonster3.Zenta_Lizardman_Raid_120p', 40.00, 45.50, 39, 'female', 'L2ReflectionBoss', 'Fighter', 40, 84512, 14.123, 463, 1.800, 60, 57, 73, 76, 70, 80, 4952216, 390467, 1366, 1756, 311, 856, 253, 0, 506, 0, 0, 0, 48, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3262, 29133, 'Lost Guard', '', 'LineageMonster.zenta_lizardman_warrior', 13.00, 35.00, 39, 'male', 'L2Minion', 'Fighter', 80, 5180, 7.062, 463, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 684, 293, 466, 143, 253, 0, 506, 16, 0, 0, 40, 140, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.56, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3263, 29134, 'Lost Assistant Guard', '', 'LineageMonster.zenta_lizardman_shaman', 13.00, 35.00, 39, 'male', 'L2Minion', 'Priest', 40, 5180, 7.062, 463, 9.000, 40, 43, 30, 21, 20, 20, 0, 0, 456, 293, 311, 143, 253, 0, 506, 7, 0, 0, 43, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.63, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3264, 29135, 'Lost Captain', '', 'LineageMonster3.Steel_Trapper_120p', 45.00, 56.00, 49, 'male', 'L2ReflectionBoss', 'Fighter', 40, 138394, 21.125, 720, 2.100, 60, 57, 73, 76, 70, 80, 6038763, 629275, 2887, 2430, 657, 1185, 253, 0, 506, 0, 0, 0, 60, 160, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3265, 29136, 'Lost Guard', '', 'LineageMonster3.golem_cannon_catapult_a', 23.50, 34.70, 49, 'male', 'L2Minion', 'Fighter', 40, 8291, 10.563, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1443, 404, 985, 197, 253, 0, 506, 0, 0, 0, 130, 160, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3266, 29137, 'Lost Assistant Guard', '', 'LineageMonster3.golem_repair', 23.00, 32.80, 49, 'male', 'L2Minion', 'Priest', 40, 8291, 10.563, 720, 10.500, 40, 43, 30, 21, 20, 20, 0, 0, 962, 404, 657, 197, 253, 0, 506, 0, 0, 0, 72, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3267, 29138, 'Lost Captain', '', 'LineageMonster.headless_knight_170p', 35.00, 54.50, 59, 'male', 'L2ReflectionBoss', 'Fighter', 40, 196695, 28.078, 1007, 2.400, 60, 57, 73, 76, 70, 80, 7188264, 860647, 5384, 3234, 1225, 1578, 253, 0, 506, 135, 0, 0, 70, 150, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.52, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3268, 29139, 'Lost Guard', '', 'LineageMonster.dark_horror_bi', 20.00, 42.00, 59, 'male', 'L2Minion', 'Fighter', 40, 11637, 14.039, 1007, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2692, 539, 1838, 263, 253, 0, 506, 0, 0, 0, 100, 100, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.37, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3269, 29140, 'Lost Assistant Guard', '', 'LineageMonster.dark_horror_bi', 20.00, 42.00, 59, 'male', 'L2Minion', 'Priest', 40, 11637, 14.039, 1007, 12.000, 40, 43, 30, 21, 20, 20, 0, 0, 1795, 539, 1225, 263, 253, 0, 506, 0, 0, 0, 100, 100, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.37, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3270, 29141, 'Lost Captain', '', 'LineageMonster2.ketra_warbeast_130p', 40.00, 45.00, 69, 'male', 'L2ReflectionBoss', 'Fighter', 40, 239747, 32.464, 1314, 2.700, 60, 57, 73, 76, 70, 80, 8315797, 1112310, 8638, 4140, 1966, 2019, 253, 0, 506, 0, 0, 0, 38, 150, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3271, 29142, 'Lost Guard', '', 'LineageMonster4.eyeless', 36.00, 43.50, 69, 'male', 'L2Minion', 'Fighter', 40, 14119, 16.232, 1314, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 4318, 690, 2948, 337, 253, 0, 506, 0, 0, 0, 60, 210, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.49, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3272, 29143, 'Lost Assistant Guard', '', 'LineageMonster4.eyeless', 36.00, 43.50, 69, 'male', 'L2Minion', 'Priest', 40, 14119, 16.232, 1314, 13.500, 40, 43, 30, 21, 20, 20, 0, 0, 2879, 690, 1966, 337, 253, 0, 506, 0, 0, 0, 60, 210, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.49, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3273, 29144, 'Lost Captain', '', 'LineageMonster.archangel', 15.00, 80.00, 78, 'male', 'L2ReflectionBoss', 'Fighter', 80, 267073, 35.161, 1607, 3.000, 60, 57, 73, 76, 70, 80, 12606595, 1625206, 11399, 5000, 2595, 2440, 253, 0, 506, 97, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.76, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3274, 29145, 'Lost Guard', '', 'LineageMonster3.apostle_grail', 13.00, 47.00, 78, 'male', 'L2Minion', 'Fighter', 40, 15710, 17.581, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 5700, 833, 3893, 406, 253, 0, 506, 8221, 0, 0, 30, 220, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3275, 29146, 'Lost Assistant Guard', '', 'LineageMonster2.apostle_mage', 11.00, 38.50, 78, 'male', 'L2Minion', 'Priest', 40, 15710, 17.581, 1607, 15.000, 40, 43, 30, 21, 20, 20, 0, 0, 3799, 833, 2595, 406, 253, 0, 506, 6718, 0, 0, 50, 165, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3276, 29147, 'Lost Captain', '', 'LineageMonster3.Drake_Raid', 44.00, 51.50, 81, 'male', 'L2ReflectionBoss', 'Fighter', 40, 275377, 36.165, 1709, 3.000, 60, 57, 73, 76, 70, 80, 12961356, 1669147, 12084, 5289, 2751, 2579, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3277, 29148, 'Lost Guard', '', 'LineageMonster3.antaras_ex_b', 42.00, 34.50, 81, 'male', 'L2Minion', 'Fighter', 40, 16197, 18.082, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 6042, 881, 4126, 430, 253, 0, 506, 0, 0, 0, 200, 200, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3278, 29149, 'Lost Assistant Guard', '', 'LineageMonster3.antaras_ex_b', 42.00, 34.50, 81, 'male', 'L2Minion', 'Priest', 40, 16197, 18.082, 1709, 15.000, 40, 43, 30, 21, 20, 20, 0, 0, 4027, 881, 2751, 430, 253, 0, 506, 0, 0, 0, 200, 200, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3279, 29150, 'Ekimus', 'Lord of Immortality', 'LineageMonster4.echmus', 25.00, 70.00, 82, 'male', 'L2RaidBoss', 'Mystic', 40, 1178417, 1754.501, 184680, 1000.000, 60, 57, 73, 76, 70, 80, 0, 0, 3512, 21777, 2575, 14487, 253, 0, 506, 0, 0, 0, 60, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3280, 29151, 'Feral Hound of the Netherworld', '', 'LineageMonster4.voidhound_080p', 64.00, 48.40, 82, 'male', 'L2Monster', 'FeralHound', 40, 4234, 8.500, 184680, 1000.000, 40, 43, 30, 21, 20, 20, 0, 0, 2033, 619, 1389, 453, 253, 0, 506, 0, 0, 0, 60, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3281, 29152, 'Feral Hound of the Netherworld', '', 'LineageMonster4.voidhound_080p', 64.00, 48.40, 82, 'male', 'L2Npc', 'npc', 40, 4234, 8.500, 184680, 1000.000, 40, 43, 30, 21, 20, 20, 0, 0, 3562, 619, 1389, 453, 253, 0, 506, 0, 0, 0, 60, 200, 'aceed_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3282, 29153, 'echmus_camera_01', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3283, 29154, 'echmus_camera_02', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3284, 29155, 'echmus_camera_03', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3285, 29156, 'echmus_camera_04', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3286, 29157, 'echmus_camera_05', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3287, 29158, 'echmus_camera_06', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3288, 29159, 'echmus_camera_07', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3289, 29160, 'echmus_camera_08', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3290, 29161, 'Pre-Awakened Ekimus', '', 'LineageMonster4.echmus_born', 25.00, 70.00, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 60, 200, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3291, 29162, 'Soldiers of Bravery', '', 'LineageMonster4.dragon_rider', 36.00, 51.00, 82, 'male', 'L2SpecialMonster', 'Mystic', 80, 334640, 187.261, 184680, 1000.000, 40, 43, 30, 21, 20, 20, 0, 0, 13516, 990, 9229, 1086, 253, 800, 506, 0, 0, 0, 60, 200, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.53, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3292, 29163, 'Tiat', '', 'LineageMonster4.tiat', 55.00, 104.00, 82, 'female', 'L2ReflectionBoss', 'Tiat', 40, 5523846, 548.284, 184680, 1000.000, 60, 57, 73, 76, 70, 80, 0, 0, 5291, 908, 3613, 604, 253, 0, 506, 0, 0, 0, 80, 200, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (3293, 29164, 'tiat_camera_01', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3294, 29165, 'tiat_camera_02', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3295, 29166, 'tiat_camera_03', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3296, 29167, 'tiat_camera_04', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3297, 29168, 'tiat_camera_05', '', 'LineageMonster4.tiat', 55.00, 104.00, 73, 'female', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 80, 200, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3298, 29169, 'tiat_camera_06', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3299, 29170, 'tiat_camera_07', '', 'LineageNPC.clear_npc', 0.10, 0.10, 73, 'male', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3300, 29171, 'tiat_camera_08', '', 'LineageNpcEV.tiat_release_effect', 0.01, 160.00, 73, 'female', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3301, 29172, 'tiat_camera_09', '', 'LineageNpcEV.tiat_change_effect', 0.01, 160.00, 73, 'female', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3302, 29173, 'Tiat Priest', '', 'LineageNPC2.tiat_oracle', 8.00, 25.00, 73, 'female', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 50, 50, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3303, 29174, 'Tiat Priest', '', 'LineageNPC2.tiat_oracle', 8.00, 25.00, 73, 'female', 'L2Npc', 'npc', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1220, 502, 833, 368, 253, 0, 506, 0, 0, 0, 50, 50, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3304, 29175, 'Tiat', '', 'LineageMonster4.tiat', 55.00, 104.00, 82, 'female', 'L2Npc', 'npc', 40, 5523846, 548.284, 184680, 1000.000, 60, 57, 73, 76, 70, 80, 11480335, 4460470, 5291, 908, 3613, 604, 253, 0, 506, 0, 0, 0, 80, 200, 'des_dragon', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3305, 29176, 'Zaken', '', 'LineageMonster.zaken', 16.00, 32.00, 60, 'male', 'L2Boss', 'Zaken', 40, 90457, 337.000, 30000, 200.000, 60, 57, 73, 76, 70, 80, 4154684, 587467, 1806, 370, 490, 270, 253, 500, 506, 0, 0, 0, 42, 190, '', 300, 0, 0, 0, 300, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3306, 29177, 'Freya', '', '', 50.00, 98.50, 85, 'female', 'L2Monster', 'Freya', 40, 4734070, 1324.428, 409990, 666.000, 60, 57, 73, 76, 70, 80, 0, 0, 34603, 1888, 45729, 2045, 410, 0, 3820, 0, 0, 0, 45, 243, 'freya_clan', 300, 0, 0, 0, 7, 30, 6, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3307, 29178, 'Freya', '', '', 50.00, 98.50, 85, 'female', 'L2Monster', 'Freya', 40, 4734070, 1324.428, 409990, 666.000, 60, 57, 73, 76, 70, 80, 0, 0, 34603, 1888, 45729, 2045, 410, 0, 3820, 0, 0, 0, 45, 243, 'freya_clan', 300, 0, 0, 0, 7, 30, 6, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3308, 29179, 'Freya', '', '', 22.00, 55.00, 85, 'female', 'L2ReflectionBoss', 'Freya', 40, 6335563, 1456.870, 409990, 666.000, 60, 57, 73, 76, 70, 80, 51569936, 6164678, 38064, 2078, 55329, 2250, 410, 0, 3820, 0, 0, 0, 54, 292, 'freya_clan', 300, 0, 0, 0, 7, 30, 6, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3309, 29180, 'Freya', '', '', 22.00, 55.00, 85, 'female', 'L2ReflectionBoss', 'Freya', 40, 112366560, 43706.105, 409990, 2220.000, 60, 57, 73, 76, 70, 80, 108799552, 12524212, 89674, 2765, 98022, 4611, 410, 0, 3820, 0, 0, 0, 54, 292, 'freya_clan', 300, 0, 0, 0, 7, 30, 6, 7, 0, 11, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3310, 29181, 'Zaken', '', 'LineageMonster.zaken', 16.00, 32.00, 83, 'male', 'L2Boss', 'Zaken', 40, 3155900, 818.276, 177740, 300.000, 60, 57, 73, 76, 70, 80, 15282888, 2051807, 13800, 1827, 4403, 891, 253, 500, 506, 0, 0, 0, 42, 190, '', 300, 0, 0, 0, 7, 30, 4, 7, 0, -18, 0.59, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (3311, 29182, 'Doll Blader', '', 'LineageMonster.doll_blader', 6.00, 12.00, 81, 'male', 'L2Monster', 'Fighter', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1720, 588, 1175, 430, 253, 150, 506, 5129, 0, 0, 22, 150, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3312, 29183, 'Veil Master', '', 'LineageMonster.vale_master', 12.00, 40.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 8.500, 1743, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1804, 599, 1233, 438, 253, 150, 506, 0, 0, 0, 70, 155, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3313, 29184, 'Pirate Zombie Captain', '', 'LineageMonster4.cursed_pirate', 24.00, 37.00, 83, 'male', 'L2Monster', 'Fighter', 40, 3836, 8.500, 1777, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1890, 609, 1292, 445, 253, 150, 506, 0, 0, 0, 26, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3314, 29185, 'Pirate Zombie', '', 'LineageMonster.pirates_zombie', 10.00, 23.00, 81, 'male', 'L2Monster', 'Mystic', 40, 3462, 8.500, 1709, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1720, 588, 1175, 430, 253, 150, 506, 225, 0, 0, 11, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3315, 29186, 'Balor', '', 'demonic', 54.00, 77.50, 85, 'male', 'L2Npc', 'npc', 40, 985293, 378.674, 1955, 300.000, 60, 57, 73, 76, 70, 80, 9930636, 1322209, 6656, 2880, 3238, 2057, 253, 300, 506, 0, 0, 0, 34, 180, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.47, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3316, 29187, 'Crystal Prison Guard', '', 'demonic', 36.00, 43.50, 85, 'male', 'L2Monster', 'Fighter', 40, 18816, 187.368, 1955, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3193, 1049, 2180, 767, 253, 300, 506, 0, 0, 0, 60, 210, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.49, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3317, 29188, 'Crystal Golem', '', 'construct', 34.00, 47.00, 85, 'male', 'L2Monster', 'Fighter', 40, 114631, 187.368, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1710, 630, 1168, 461, 253, 300, 506, 0, 0, 0, 54, 170, 'door_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3318, 29189, 'Crystal Golem', '', 'construct', 34.00, 47.00, 85, 'male', 'L2Monster', 'Fighter', 40, 3047, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1710, 630, 1168, 461, 253, 300, 506, 0, 0, 0, 54, 170, 'door_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3319, 29190, 'Tarask Dragon', '', 'dragon', 63.00, 54.00, 85, 'male', 'L2Monster', 'Fighter', 40, 401552, 76.710, 1809, 3.000, 60, 57, 73, 76, 70, 80, 0, 0, 6238, 1864, 2413, 910, 253, 300, 506, 0, 0, 0, 180, 180, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4622, 30001, 'Lector', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4623, 30002, 'Jackson', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4624, 30003, 'Silvia', '', 'a_traderA_FHuman', 7.00, 23.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4625, 30004, 'Katerina', '', 'a_traderB_FHuman', 8.00, 24.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4626, 30005, 'Wilford', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4627, 30006, 'Roxxy', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4628, 30008, 'Roien', '', 'a_fighterguild_master_Mhuman_old', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4629, 30009, 'Newbie Helper', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4630, 30010, 'Auron', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4631, 30014, 'Celma', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4632, 30017, 'Gallint', '', 'a_mageguild_master_MHuman', 8.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4633, 30019, 'Newbie Helper', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4634, 30022, 'Zigaunt', '', 'a_sanctuary_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4635, 30026, 'Bitz', '', 'a_fighterguild_master_Mhuman_old', 8.00, 23.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4636, 30027, 'Gwinter', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4637, 30028, 'Pintage', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4638, 30029, 'Minia', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4639, 30030, 'Vivyan', '', 'a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4640, 30031, 'Biotin', '', 'a_sanctuary_master_MHuman', 8.00, 24.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4641, 30032, 'Yohanes', '', 'a_sanctuary_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4642, 30033, 'Baulro', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4643, 30034, 'Iris', '', 'a_mageguild_teacher_FHuman', 8.00, 23.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4644, 30035, 'Harrys', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4645, 30036, 'Petron', '', 'a_sanctuary_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4646, 30037, 'Levian', '', 'a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4647, 30039, 'Gilbert', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 129, 102, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4648, 30040, 'Leon', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4649, 30041, 'Arnold', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4650, 30042, 'Abellos', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4651, 30043, 'Johnstone', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4652, 30044, 'Chiperan', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4653, 30045, 'Kenyos', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4654, 30046, 'Hanks', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4655, 30047, 'Firon', '', 'a_wharfinger_MHuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4656, 30048, 'Darin', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4657, 30049, 'Bonnie', '', 'a_common_peopleB_FHuman', 8.00, 20.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4658, 30050, 'Elias', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4659, 30051, 'Cristel', '', 'a_common_peopleA_FHuman', 8.00, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4660, 30054, 'Rant', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4661, 30055, 'Rolfe', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4662, 30057, 'Aldo', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4663, 30058, 'Holvas', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4664, 30059, 'Trisha', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4665, 30060, 'Sabrin', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4666, 30061, 'Casey', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4667, 30062, 'Sonia', '', 'a_traderA_FHuman', 7.00, 23.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4668, 30063, 'Lara', '', 'a_traderB_FHuman', 8.00, 24.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4669, 30064, 'Terry', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4670, 30065, 'Arnelle', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4671, 30066, 'Pabris', '', 'a_fighterguild_master_Mhuman_old', 8.00, 23.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4672, 30067, 'Glyvka', '', 'a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4673, 30068, 'Shegfield', '', 'a_patriarch_MElf', 7.00, 22.20, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4674, 30069, 'Rollant', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4675, 30070, 'Sylvain', '', 'a_sanctuary_master_MHuman', 8.00, 24.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4676, 30071, 'Lucas', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 129, 102, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4677, 30072, 'Metty', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4678, 30073, 'Jacob', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4679, 30074, 'Harlan', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4680, 30075, 'Xaber', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4681, 30076, 'Liam', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4682, 30078, 'Pano', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4683, 30079, 'Barder', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4684, 30080, 'Clarissa', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4685, 30081, 'Helvetia', '', 'a_traderB_FHuman', 8.00, 24.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4686, 30082, 'Denkus', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4687, 30083, 'Pochi', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4688, 30084, 'Graham', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4689, 30085, 'Stanford', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4690, 30086, 'Taurin', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4691, 30087, 'Peta', '', 'a_traderA_FHuman', 7.00, 23.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4692, 30088, 'Radia', '', 'a_traderB_FHuman', 8.00, 24.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4693, 30090, 'Sandra', '', 'a_traderB_FHuman', 8.00, 24.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4694, 30091, 'Ellie', '', 'a_traderA_FHuman', 7.00, 23.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4695, 30092, 'Collob', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4696, 30093, 'Groot', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4697, 30094, 'Gentler', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4698, 30095, 'Randolf', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4699, 30097, 'Galladucci', '', 'a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4700, 30098, 'Alexandria', '', 'a_traderB_FHuman', 8.00, 24.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4701, 30103, 'Valkon', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4702, 30104, 'Parman', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4703, 30105, 'Genwitter', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4704, 30106, 'Dufner', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4705, 30107, 'Goldian', '', 'a_guard_MElf', 7.00, 22.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4706, 30108, 'Macken', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4707, 30109, 'Hannavalt', '', 'a_fighterguild_master_Mhuman_old', 8.00, 23.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4708, 30110, 'Iker', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4709, 30111, 'Dieter', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4710, 30112, 'Maurius', '', 'a_patriarch_MElf', 7.00, 22.20, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4711, 30113, 'Juris', '', 'a_trader_FElf', 7.00, 21.20, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4712, 30114, 'Roa', '', 'a_mageguild_teacher_FHuman', 8.00, 23.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4713, 30115, 'Jurek', '', 'a_mageguild_master_MHuman', 8.00, 24.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4714, 30116, 'Dustin', '', 'a_sanctuary_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4715, 30117, 'Primos', '', 'a_sanctuary_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4716, 30118, 'Pupina', '', 'a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4717, 30119, 'Isabellin', '', 'a_trader_FElf', 7.00, 22.20, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4718, 30120, 'Maximilian', '', 'a_sanctuary_master_MHuman', 8.00, 24.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4719, 30121, 'Jeronin', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 129, 102, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4720, 30122, 'Bane', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4721, 30123, 'Vesa', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4722, 30124, 'Zerome', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4723, 30125, 'Belton', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4724, 30126, 'Rath', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4725, 30128, 'Atanas', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4726, 30129, 'Mitraell', '', 'a_clergyman_MDarkElf', 6.00, 23.80, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4727, 30130, 'Undrias', '', 'a_clergyman_MDarkElf', 8.00, 22.30, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4728, 30131, 'Newbie Helper', '', 'a_clergyman_FDarkElf', 8.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4729, 30132, 'Cecktinon', '', 'a_clergyman_MDarkElf', 8.00, 22.30, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4730, 30133, 'Kartia', '', 'a_clergyman_FDarkElf', 8.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4731, 30134, 'Jasmine', '', 'a_teleporter_FDarkElf', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4732, 30135, 'Iria', '', 'a_trader_Fdarkelf', 8.00, 24.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4733, 30136, 'Payne', '', 'a_trader_MDarkElf', 8.00, 22.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4734, 30137, 'Vollodos', '', 'a_trader_MDarkElf', 8.00, 22.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4735, 30138, 'Minaless', '', 'a_trader_Fdarkelf', 8.00, 24.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4736, 30139, 'Dorankus', '', 'a_trader_MDarkElf', 8.00, 22.50, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4737, 30140, 'Erviante', '', 'a_trader_MDarkElf', 8.00, 22.50, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4738, 30141, 'Talloth', '', 'a_clergyman_MDarkElf', 6.00, 23.80, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4739, 30143, 'Trudy', '', 'a_fighterguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4740, 30144, 'Harne', '', 'a_mageguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4741, 30145, 'Vlasty', '', 'a_mageguild_teacher_MDarkElf', 8.00, 22.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4742, 30146, 'Mirabel', '', 'a_common_people_FElf', 8.50, 23.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4743, 30147, 'Unoren', '', 'a_trader_MElf', 6.00, 24.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4744, 30148, 'Ariel', '', 'a_trader_FElf', 8.00, 24.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4745, 30149, 'Creamees', '', 'a_trader_MElf', 6.00, 24.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4746, 30150, 'Herbiel', '', 'a_trader_MElf', 6.00, 24.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4747, 30151, 'Chad', '', 'a_trader_MElf', 6.00, 24.50, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4748, 30152, 'Julia', '', 'a_common_people_FElf', 7.00, 25.50, 70, 'female', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4749, 30153, 'Markius', '', 'a_trader_MElf', 6.00, 21.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4750, 30154, 'Asterios', '', 'a_patriarch_MElf', 8.00, 22.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4751, 30155, 'Ellenia', '', 'a_fighterguild_teacher_FElf', 8.00, 22.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4752, 30156, 'Cobendell', '', 'a_guard_MElf', 7.00, 22.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4753, 30157, 'Greenis', '', 'a_trader_FElf', 7.00, 21.20, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4754, 30158, 'Esrandell', '', 'a_patriarch_MElf', 7.00, 22.20, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4755, 30162, 'Karin', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4756, 30163, 'Rex', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4757, 30164, 'Ian', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4758, 30165, 'Ralford', '', 'a_trader_FElf', 8.00, 24.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4759, 30166, 'Wesley', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4760, 30169, 'Marty', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4761, 30170, 'Radic', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4762, 30171, 'Gaius', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4763, 30174, 'Arkenias', '', 'a_mageguild_teacher_FElf', 7.00, 21.20, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4764, 30175, 'Fairen', '', 'a_mageguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4765, 30176, 'Valleria', '', 'a_mageguild_master_FHuman', 8.00, 23.00, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4766, 30177, 'Valentina', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4767, 30178, 'Zenkin', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4768, 30179, 'Raudia', '', 'a_traderB_FHuman', 8.00, 24.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4769, 30180, 'Sara', '', 'a_traderA_FHuman', 7.00, 23.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4770, 30181, 'Galibredo', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4771, 30182, 'Cliff', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4772, 30183, 'Hagger', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4773, 30184, 'Rigol', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4774, 30185, 'Taniac Blackbird', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4775, 30186, 'Bhan', '', 'a_guard_MElf', 7.00, 22.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4776, 30187, 'Klaus Blackbird', '', 'a_fighterguild_master_Mhuman_old', 8.00, 23.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4777, 30188, 'Vadin', '', 'a_sanctuary_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4778, 30189, 'Rovia', '', 'a_mageguild_teacher_FElf', 7.00, 21.20, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4779, 30190, 'Phanovia', '', 'a_mageguild_teacher_FHuman', 8.00, 23.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4780, 30191, 'Hollint', '', 'a_sanctuary_master_MHuman', 8.00, 24.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4781, 30192, 'Darya', '', 'a_fighterguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4782, 30194, 'Gideon', '', 'a_mageguild_teacher_MDarkElf', 8.00, 22.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4783, 30195, 'Brecson', '', 'a_guild_master_MDarkElf', 8.00, 23.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4784, 30196, 'Mouen', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 129, 102, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4785, 30197, 'Hector', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4786, 30198, 'Jerin', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4787, 30199, 'Yates', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4788, 30200, 'Stan', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4789, 30201, 'Pinaps', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4790, 30207, 'Arodin', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4791, 30208, 'Damion', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4792, 30209, 'Colleen', '', 'a_traderB_FHuman', 8.00, 24.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4793, 30210, 'Norman', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4794, 30216, 'Wheeler', '', 'a_guard_MElf', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 130, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4795, 30217, 'Berros', '', 'a_guard_MElf', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 276, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4796, 30218, 'Kendell', '', 'a_guard_MElf', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 276, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4797, 30219, 'Veltress', '', 'a_guard_MElf', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 130, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4798, 30220, 'Starden', '', 'a_guard_MElf', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 276, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4799, 30221, 'Rayen', '', 'a_guard_MElf', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 130, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4800, 30222, 'Alshupes', '', 'a_common_people_MElf', 6.00, 21.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4801, 30223, 'Arujien', '', 'a_trader_MElf', 6.00, 21.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4802, 30224, 'Rayla', '', 'a_guard_FDarkelf', 7.00, 25.00, 80, 'female', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 79, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4803, 30230, 'Edroc', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4804, 30231, 'Garette', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4805, 30232, 'Sorint', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4806, 30233, 'Esmeralda', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4807, 30253, 'Simplon', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4808, 30254, 'Harmony', '', 'a_traderA_FHuman', 7.00, 23.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4809, 30255, 'Haprock', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4810, 30256, 'Bella', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4811, 30283, 'Altran', '', 'e_smith_master_MDwarf', 7.00, 16.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4812, 30284, 'Alberius', '', 'a_guard_MElf', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 150, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4813, 30285, 'Gartrandell', '', 'a_guard_MElf', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 130, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4814, 30288, 'Rains', '', 'a_fighterguild_master_Mhuman_old', 8.00, 23.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4815, 30289, 'Raymond', '', 'a_sanctuary_master_MHuman', 8.00, 24.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4816, 30290, 'Xenos', '', 'a_guild_master_MDarkElf', 8.00, 23.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4817, 30291, 'Alex', '', 'a_guard_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 1000, 506, 68, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4818, 30293, 'Manuel', '', 'a_patriarch_MElf', 7.00, 22.20, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4819, 30294, 'Varan', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4820, 30297, 'Tobias', '', 'a_guild_master_MDarkElf', 8.00, 23.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4821, 30298, 'Pinter', '', 'e_smith_master_MDwarf', 7.00, 16.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4822, 30300, 'Pushkin', '', 'e_smith_master_MDwarf', 7.00, 16.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4823, 30301, 'Hally', '', 'a_traderA_FHuman', 7.00, 23.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4824, 30305, 'Vellior', '', 'a_clergyman_MDarkElf', 6.00, 23.80, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4825, 30307, 'Karrod', '', 'a_common_people_MDarkElf', 7.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4826, 30311, 'Sir Collin Windawood', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4827, 30312, 'Rockswell', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4828, 30313, 'Asha', '', 'a_traderA_FHuman', 7.00, 23.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4829, 30314, 'Nestle', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4830, 30315, 'Poesia', '', 'a_traderA_FHuman', 7.00, 23.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4831, 30316, 'Raut', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4832, 30317, 'Kluto', '', 'e_smith_master_MDwarf', 7.00, 16.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4833, 30320, 'Richlin', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4834, 30321, 'Sydnia', '', 'a_traderA_FHuman', 7.00, 23.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4835, 30322, 'Ballin', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4836, 30325, 'Audiberti', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4837, 30326, 'Leona', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4838, 30327, 'Sorius', '', 'a_guard_MElf', 7.00, 22.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4839, 30328, 'Reisa', '', 'a_common_people_FElf', 8.00, 22.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4840, 30329, 'Virgil', '', 'a_fighterguild_teacher_MDarkElf', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4841, 30330, 'Sidra', '', 'a_mageguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4842, 30331, 'Toma', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4843, 30332, 'Bathis', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 129, 102, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4844, 30333, 'Praga', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4845, 30334, 'Babenco', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4846, 30335, 'Brynn', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4847, 30336, 'Curtis', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4848, 30337, 'Moretti', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4849, 30338, 'Melville', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4850, 30342, 'Varsak', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4851, 30344, 'Rohmer', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4852, 30345, 'Ramoniell', '', 'a_trader_FElf', 7.00, 21.20, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4853, 30346, 'Kayleen', '', 'a_guard_FDarkelf', 7.00, 25.00, 80, 'female', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 277, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4854, 30347, 'Marion', '', 'a_guard_FDarkelf', 7.00, 25.00, 80, 'female', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 132, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4855, 30348, 'Nelsya', '', 'a_guard_FDarkelf', 7.00, 25.00, 80, 'female', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 132, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4856, 30349, 'Jenna', '', 'a_guard_FDarkelf', 7.00, 25.00, 80, 'female', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 277, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4857, 30350, 'Carlon', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4858, 30351, 'Astaron', '', 'a_common_people_MDarkElf', 7.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4859, 30352, 'Karina', '', 'a_common_people_FDarkElf', 8.00, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4860, 30353, 'Jughead', '', 'a_common_people_MDarkElf', 7.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4861, 30354, 'Jewel', '', 'a_common_people_FDarkElf', 8.00, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4862, 30355, 'Roselyn', '', 'a_guard_FDarkelf', 7.00, 25.00, 80, 'female', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 277, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4863, 30356, 'Altima', '', 'a_guard_FDarkelf', 7.00, 25.00, 80, 'female', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 277, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4864, 30357, 'Kristin', '', 'a_guard_FDarkelf', 7.00, 25.00, 80, 'female', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 132, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4865, 30358, 'Thifiell', '', 'a_clergyman_MDarkElf', 6.00, 23.80, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4866, 30359, 'Kaitar', '', 'a_clergyman_MDarkElf', 6.00, 23.80, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4867, 30360, 'Harant', '', 'a_fighterguild_teacher_MDarkElf', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4868, 30361, 'Rizraell', '', 'a_common_people_FElf', 7.00, 25.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4869, 30362, 'Andellia', '', 'a_common_people_FElf', 7.00, 25.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4870, 30363, 'Aios', '', 'a_trader_MElf', 6.00, 21.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4871, 30368, 'Lilith', '', 'a_common_people_FElf', 7.00, 25.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4872, 30369, 'Baenedes', '', 'a_guard_MElf', 7.00, 22.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4873, 30370, 'Nerupa', '', 'aracne', 15.00, 26.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 64, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4874, 30371, 'Thalia', '', 'a_common_people_FElf', 7.00, 25.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4875, 30373, 'Ramos', '', 'a_fighterguild_master_Mhuman_old', 8.00, 23.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4876, 30374, 'Rhodiell', '', 'a_common_people_FElf', 8.00, 22.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4877, 30375, 'Adonius', '', 'a_patriarch_MElf', 7.00, 22.20, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4878, 30376, 'Nell', '', 'a_trader_FElf', 7.00, 21.20, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4879, 30377, 'Talbot', '', 'a_mageguild_teacher_MDarkElf', 8.00, 22.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4880, 30378, 'Estella', '', 'a_fighterguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4881, 30379, 'Bezique', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 280, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4882, 30380, 'Plink', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4883, 30381, 'Alvah', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4884, 30382, 'Leikan', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4885, 30383, 'Scott', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4886, 30384, 'Linus', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4887, 30385, 'Weisz', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4888, 30386, 'Luis', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4889, 30387, 'Clancy', '', 'a_wharfinger_MHuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4890, 30391, 'Parina', '', 'a_common_peopleB_FHuman', 8.00, 20.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4891, 30400, 'Newbie Helper', '', 'a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4892, 30401, 'Newbie Helper', '', 'a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4893, 30402, 'Newbie Helper', '', 'a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4894, 30403, 'Newbie Helper', '', 'a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4895, 30404, 'Newbie Helper', '', 'a_clergyman_MDarkElf', 8.00, 22.30, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (4896, 30405, 'Marius', '', 'a_trader_MElf', 6.00, 21.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4897, 30406, 'Matheo', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4898, 30407, 'Mesella', '', 'a_common_peopleA_FHuman', 8.00, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4899, 30408, 'Lionel', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4900, 30409, 'Earth Snake', '', 'lesser_basilisk', 34.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 35, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4901, 30410, 'Wasteland Lizardman', '', 'virud_lizardman', 10.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 43, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4902, 30411, 'Flame Salamander', '', 'salamander', 16.00, 6.80, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 64, 96, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4903, 30412, 'Wind Sylph', '', 'sylph', 11.00, 35.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 60, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4904, 30413, 'Water Undine', '', 'undine', 12.00, 27.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 60, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4905, 30414, 'Rosella', '', 'a_common_people_FElf', 7.00, 25.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4906, 30415, 'Charkeren', '', 'a_common_people_MDarkElf', 7.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4907, 30416, 'Triskel', '', 'a_common_people_MDarkElf', 7.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4908, 30417, 'Sir Klaus Vasper', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4909, 30418, 'Annika', '', 'a_common_people_FDarkElf', 8.00, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4910, 30419, 'Arkenia', '', 'a_clergyman_FDarkElf', 8.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4911, 30420, 'Tyra', '', 'a_trader_Fdarkelf', 8.00, 24.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4912, 30421, 'Varika', '', 'a_clergyman_FDarkElf', 8.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4913, 30422, 'Kalinta', '', 'a_clergyman_FDarkElf', 8.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4914, 30423, 'Northwind', '', 'a_trader_MElf', 6.00, 21.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4915, 30424, 'Allana', '', 'a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4916, 30425, 'Neti', '', 'a_common_peopleA_FHuman', 8.00, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4917, 30426, 'Prias', '', 'a_wharfinger_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4918, 30427, 'Siff', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4919, 30428, 'Perrin', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4920, 30429, 'Tiramisa', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4921, 30430, 'Trionell', '', 'a_guard_MElf', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 130, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4922, 30431, 'Eriel', '', 'a_guard_MElf', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 130, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4923, 30432, 'Irene', '', 'a_guard_FDarkelf', 7.00, 25.00, 80, 'female', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 132, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4924, 30433, 'Kathaway', '', 'a_guard_FDarkelf', 7.00, 25.00, 80, 'female', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 132, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4925, 30434, 'Samed', '', 'a_wharfinger_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4926, 30435, 'Leopold', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4927, 30436, 'Sarien', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4928, 30437, 'Rolento', '', 'a_traderA_MDwarf', 8.00, 17.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4929, 30452, 'Kurt', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4930, 30458, 'Poitan', '', 'e_smith_master_MDwarf', 7.00, 16.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4931, 30459, 'Wandius', '', 'a_guard_MElf', 7.00, 22.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4932, 30460, 'Cardien', '', 'a_fighterguild_teacher_FElf', 8.00, 22.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4933, 30461, 'Mirien', '', 'a_mageguild_teacher_FElf', 7.00, 21.20, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4934, 30462, 'Tronix', '', 'a_guild_master_MDarkElf', 8.00, 23.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4935, 30463, 'Ixia', '', 'a_fighterguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4936, 30464, 'Clayton', '', 'a_mageguild_teacher_MDarkElf', 8.00, 22.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4937, 30465, 'Herven', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4938, 30466, 'Bright', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4939, 30469, 'Jonas', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4940, 30471, 'Rupio', '', 'e_smith_master_MDwarf', 7.00, 16.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4941, 30472, 'Rosheria', '', 'a_common_people_FElf', 8.00, 22.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4942, 30473, 'Bandellos', '', 'a_patriarch_MElf', 7.00, 22.20, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4943, 30474, 'Angus', '', 'a_guild_master_MDarkElf', 8.00, 23.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4944, 30475, 'Stapin', '', 'a_fighterguild_teacher_MDarkElf', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4945, 30476, 'Kaira', '', 'a_mageguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4946, 30477, 'Sir Ortho Lancer', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4947, 30478, 'Reikin', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4948, 30483, 'Mozella', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4949, 30484, 'Ponti', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4950, 30485, 'Capella', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4951, 30486, 'Hanna', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4952, 30487, 'Penelope', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4953, 30497, 'Edmond', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4954, 30498, 'Moke', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4955, 30499, 'Tapoy', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4956, 30500, 'Osborn', '', 'e_guard_MOrc', 8.00, 26.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4957, 30501, 'Kasman', '', 'e_fighterguild_teacher_MOrc', 8.00, 28.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4958, 30502, 'Umos', '', 'e_clergyman_MOrc', 8.00, 29.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4959, 30503, 'Rikadio', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4960, 30504, 'Mendio', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4961, 30505, 'Drikus', '', 'e_guard_MOrc', 8.00, 26.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4962, 30506, 'Buka', '', 'e_fighterguild_teacher_MOrc', 8.00, 28.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4963, 30507, 'Racoy', '', 'e_clergyman_MOrc', 8.00, 29.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4964, 30508, 'Castor', '', 'e_guard_MOrc', 8.00, 26.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4965, 30509, 'Dowki', '', 'e_fighterguild_teacher_MOrc', 8.00, 28.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4966, 30510, 'Somak', '', 'e_clergyman_MOrc', 8.00, 29.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4967, 30511, 'Gesto', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4968, 30512, 'Kusto', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4969, 30513, 'Penatus', '', 'e_guard_MOrc', 8.00, 26.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4970, 30514, 'Vokian', '', 'e_fighterguild_teacher_MOrc', 8.00, 28.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4971, 30515, 'Manakia', '', 'e_clergyman_MOrc', 8.00, 29.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4972, 30516, 'Reep', '', 'a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4973, 30517, 'Shari', '', 'e_traderA_FDwarf', 7.00, 18.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4974, 30518, 'Garita', '', 'a_traderA_MDwarf', 8.00, 17.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4975, 30519, 'Mion', '', 'e_traderA_FDwarf', 7.00, 18.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4976, 30520, 'Reed', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4977, 30521, 'Murdoc', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4978, 30522, 'Airy', '', 'e_traderA_FDwarf', 7.00, 18.00, 70, 'female', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4979, 30523, 'Gouph', '', 'e_collector_teacher_MDwarf', 8.00, 17.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4980, 30524, 'Pippi', '', 'e_collector_teacher_FDwarf', 8.00, 17.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4981, 30525, 'Bronk', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4982, 30526, 'Brunon', '', 'e_smith_master_MDwarf', 7.00, 16.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4983, 30527, 'Silvera', '', 'e_smith_Fdwarf', 8.00, 17.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4984, 30528, 'Laferon', '', 'e_guard_MDwarf', 8.00, 19.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4985, 30529, 'Maron', '', 'e_mine_master_MDwarf', 8.00, 18.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4986, 30530, 'Newbie Helper', '', 'e_mine_teacher_FDwarf', 8.00, 18.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4987, 30531, 'Lockirin', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4988, 30532, 'Spiron', '', 'a_traderA_MDwarf', 8.00, 18.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4989, 30533, 'Balanki', '', 'a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4990, 30534, 'Keef', '', 'e_collector_master_MDwarf', 8.00, 18.40, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4991, 30535, 'Filaur', '', 'e_mine_master_MDwarf', 8.00, 19.70, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4992, 30536, 'Arin', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4993, 30537, 'Daichir', '', 'e_clergyman_MDwarf', 8.00, 19.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4994, 30538, 'Zimenf', '', 'e_clergyman_MDwarf', 8.00, 17.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4995, 30539, 'Chichirin', '', 'e_traderA_FDwarf', 7.00, 18.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4996, 30540, 'Wirphy', '', 'e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4997, 30541, 'Paion', '', 'e_guard_MDwarf', 8.00, 19.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 282, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4998, 30542, 'Runant', '', 'e_guard_MDwarf', 8.00, 19.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 273, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (4999, 30543, 'Ethan', '', 'e_guard_MDwarf', 8.00, 19.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 296, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5000, 30544, 'Cromwell', '', 'e_guard_MDwarf', 8.00, 19.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 296, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5001, 30545, 'Proton', '', 'e_guard_MDwarf', 8.00, 19.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 296, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5002, 30546, 'Dinkey', '', 'e_guard_MDwarf', 8.00, 19.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 273, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5003, 30547, 'Tardyon', '', 'e_guard_MDwarf', 8.00, 19.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 273, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5004, 30548, 'Nathan', '', 'e_guard_MDwarf', 8.00, 19.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 296, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5005, 30549, 'Ghouliff Droopstone', '', 'a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5006, 30550, 'Gauri Twinklerock', '', 'e_traderA_FDwarf', 7.00, 18.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5007, 30551, 'Tink Wandergold', '', 'a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5008, 30552, 'Kiril Sparkystone', '', 'e_traderA_FDwarf', 7.00, 18.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5009, 30553, 'Maryse Redbonnet', '', 'e_traderA_FDwarf', 7.00, 18.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5010, 30554, 'Bolter', '', 'e_mine_master_MDwarf', 8.00, 18.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5011, 30555, 'Torocco', '', 'a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5012, 30556, 'Toma', '', 'e_collector_master_MDwarf', 8.00, 18.40, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5013, 30557, 'Torai', '', 'a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5014, 30558, 'Jakal', '', 'e_trader_MOrc', 8.00, 23.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5015, 30559, 'Kunai', '', 'e_trader_FOrc', 8.00, 24.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5016, 30560, 'Uska', '', 'e_trader_MOrc', 8.00, 23.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5017, 30561, 'Papuma', '', 'e_trader_MOrc', 8.00, 23.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5018, 30562, 'Grookin', '', 'e_trader_MOrc', 8.00, 23.50, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5019, 30563, 'Imantu', '', 'e_trader_MOrc', 8.00, 23.50, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5020, 30564, 'Sumari', '', 'e_trader_MOrc', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5021, 30565, 'Kakai', '', 'e_fighterguild_teacher_MOrc', 8.00, 26.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5022, 30566, 'Varkees', '', 'e_guard_MOrc', 8.00, 28.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 81, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5023, 30567, 'Tantus', '', 'e_guard_MOrc', 8.00, 28.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 175, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5024, 30568, 'Hatos', '', 'e_guard_MOrc', 8.00, 28.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 202, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5025, 30569, 'Brukurse', '', 'e_fighterguild_teacher_MOrc', 8.00, 28.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5026, 30570, 'Karukia', '', 'e_trader_FOrc', 8.00, 24.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5027, 30571, 'Tanapi', '', 'e_clergyman_MOrc', 8.00, 29.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5028, 30572, 'Livina', '', 'e_clergyman_FOrc', 7.00, 28.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5029, 30573, 'Vulkus', '', 'e_fighterguild_teacher_MOrc', 8.00, 29.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5030, 30575, 'Newbie Helper', '', 'e_clergyman_FOrc', 7.00, 28.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5031, 30576, 'Tamil', '', 'e_teleporter_FOrc', 8.00, 32.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5032, 30577, 'Rukain', '', 'e_guard_MOrc', 8.00, 27.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 279, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5033, 30578, 'Nakusin', '', 'e_guard_MOrc', 8.00, 27.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5034, 30579, 'Tamai', '', 'e_guard_MOrc', 8.00, 27.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5035, 30580, 'Parugon', '', 'e_guard_MOrc', 8.00, 27.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 91, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5036, 30581, 'Orinak', '', 'e_guard_MOrc', 8.00, 27.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5037, 30582, 'Tiku', '', 'e_guard_MOrc', 8.00, 27.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 91, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5038, 30583, 'Petukai', '', 'e_guard_MOrc', 8.00, 27.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 91, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5039, 30584, 'Vapook', '', 'e_guard_MOrc', 8.00, 27.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 91, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5040, 30585, 'Tataru Zu Hestui', '', 'e_common_people_MOrc', 8.00, 26.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5041, 30586, 'Anai Zu Neruga', '', 'e_trader_FOrc', 8.00, 24.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5042, 30587, 'Gantaki Zu Urutu', '', 'e_common_people_MOrc', 8.00, 26.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5043, 30588, 'Takia Zu Duda-Mara', '', 'e_trader_FOrc', 8.00, 24.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5044, 30589, 'Kazkin Zu Gandi', '', 'e_trader_MOrc', 8.00, 26.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5045, 30590, 'Rosheek', '', 'e_fighterguild_teacher_MOrc', 8.00, 28.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5046, 30591, 'Toruku', '', 'e_fighterguild_teacher_MOrc', 8.00, 28.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5047, 30592, 'Hestui Totem Spirit', '', 'grizzly', 21.00, 40.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5048, 30593, 'Duda-Mara Totem Spirit', '', 'giant_spider', 26.00, 25.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 72, 130, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5049, 30594, 'Ranspo', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5050, 30595, 'Opix', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5051, 30596, 'Harkel', '', 'ol_mahum', 13.50, 25.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5052, 30597, 'Piotur', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5053, 30598, 'Newbie Guide', '', 'a_sanctuary_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2NewbieGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5054, 30599, 'Newbie Guide', '', 'a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2NewbieGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5055, 30600, 'Newbie Guide', '', 'a_guild_master_MDarkElf', 8.00, 23.00, 70, 'male', 'L2NewbieGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5056, 30601, 'Newbie Guide', '', 'e_guard_MDwarf', 8.00, 19.00, 70, 'male', 'L2NewbieGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5057, 30602, 'Newbie Guide', '', 'e_guard_MOrc', 8.00, 27.00, 70, 'male', 'L2NewbieGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5058, 30608, 'Maria', '', 'a_common_peopleB_FHuman', 8.00, 20.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5059, 30609, 'Creta', '', 'a_mageguild_teacher_FHuman', 8.00, 23.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5060, 30610, 'Cronos', '', 'a_mageguild_master_MHuman', 8.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5061, 30611, 'Triff', '', 'a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5062, 30612, 'Casian', '', 'a_mageguild_master_MHuman', 8.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5063, 30613, 'Alders Spirit', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5064, 30614, 'Metheus', '', 'a_sanctuary_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5065, 30615, 'Voltar', '', 'e_guard_MOrc', 12.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 173, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5066, 30616, 'Kepra', '', 'e_guard_MOrc', 10.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 162, 0, 0, 45, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.76, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5067, 30617, 'Burai', '', 'e_guard_MOrc', 9.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 172, 0, 0, 45, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5068, 30618, 'Harak', '', 'e_guard_MOrc', 12.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 172, 0, 0, 45, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5069, 30619, 'Driko', '', 'e_guard_MOrc', 11.00, 16.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 183, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5070, 30620, 'Emily', '', 'a_common_peopleA_FHuman', 8.00, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5071, 30621, 'Nikola', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5072, 30622, 'Box Of Titan', '', 'coffer_b', 12.00, 9.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5073, 30623, 'Kaien', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 135, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5074, 30624, 'Ascalon', '', 'a_wharfinger_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 16, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5075, 30625, 'Mason', '', 'a_wharfinger_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5076, 30626, 'Hamil', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5077, 30627, 'Tree', '', 'human_tree', 35.00, 90.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5078, 30628, 'Strong Wooden Chest', '', 'box', 18.00, 14.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5079, 30629, 'Rukal', '', 'a_common_people_MElf', 6.00, 21.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 4202, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5080, 30630, 'Orim', '', 'a_hardins_pupil_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5081, 30631, 'Roderik', '', 'a_guard_MHuman', 8.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 2, 20, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5082, 30632, 'Endrigo', '', 'a_guard_MHuman', 8.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 2, 20, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5083, 30633, 'Evert', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5084, 30634, 'Galatea', '', 'a_mageguild_master_FHuman', 8.00, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5085, 30635, 'Almors', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5086, 30636, 'Camoniell', '', 'a_trader_FElf', 7.00, 21.20, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5087, 30637, 'Belthus', '', 'a_mageguild_teacher_MDarkElf', 8.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5088, 30638, 'Basilla', '', 'a_mageguild_teacher_FHuman', 8.00, 23.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5089, 30639, 'Celestiel', '', 'a_patriarch_MElf', 7.00, 22.20, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5090, 30640, 'Brynthea', '', 'a_mageguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5091, 30641, 'Takuna', '', 'e_guard_MOrc', 8.00, 28.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 202, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5092, 30642, 'Chianta', '', 'e_guard_MOrc', 8.00, 28.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 175, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5093, 30643, 'First Orc', '', 'e_fighterguild_teacher_MOrc', 8.00, 26.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5094, 30644, 'Kash', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5095, 30645, 'Martien', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5096, 30646, 'Raldo', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5097, 30647, 'Chest Of Shyslassys', '', 'coffer_c', 12.00, 9.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5098, 30648, 'Santiago', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5099, 30649, 'Ancestor Martankus', '', 'orc_head', 110.00, 103.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5100, 30650, 'Gerald', '', 'e_traderA_FDwarf', 8.00, 17.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5101, 30651, 'Dorf', '', 'a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5102, 30652, 'Uruha', '', 'a_common_people_FDarkElf', 8.00, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5103, 30653, 'Sir Aron Tanford', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5104, 30654, 'Sir Kiel Nighthawk', '', 'a_fighterguild_teacher_MDarkElf', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 74, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5105, 30655, 'Isael Silvershadow', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5106, 30656, 'Spirit Of Sir Talianus', '', 'a_royal_guardA_MHuman', 8.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5107, 30657, 'Seresin', '', 'a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5108, 30658, 'Gupu', '', 'a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5109, 30659, 'Orphan Girl', '', 'e_traderA_FDwarf', 7.00, 18.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5110, 30660, 'Windy Shaoring', '', 'e_collector_teacher_FDwarf', 8.00, 17.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5111, 30661, 'Mysterious Dark Elf', '', 'a_casino_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5112, 30662, 'Piper Longbow', '', 'a_common_people_FElf', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5113, 30663, 'Slein Shining Blade', '', 'a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 69, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5114, 30664, 'Cain Flying Knife', '', 'a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 217, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5115, 30665, 'Kristina', '', 'a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5116, 30666, 'Sla', '', 'a_mageguild_teacher_FHuman', 8.00, 23.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5117, 30667, 'Ramus', '', 'a_common_peopleA_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5118, 30668, 'Katari', '', 'a_common_people_FDarkElf', 8.00, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5119, 30669, 'Kakan', '', 'e_trader_FOrc', 8.00, 24.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5120, 30670, 'Nyakuri', '', 'e_traderA_FDwarf', 7.00, 18.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5121, 30671, 'Croto', '', 'e_guard_MOrc', 8.00, 27.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5122, 30672, 'Dubabah', '', 'e_guard_MOrc', 8.00, 27.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5123, 30673, 'Lorain', '', 'e_collector_teacher_FDwarf', 8.00, 17.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5124, 30674, 'Daurin Hammercrush', '', 'a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5125, 30675, 'Corpse Of Kamur', '', 'e_trader_Morc_death', 22.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5126, 30676, 'Croop', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5127, 30677, 'Flutter', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5128, 30678, 'Helton', '', 'e_smith_master_MDwarf', 7.00, 16.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5129, 30679, 'Roameria', '', 'a_fighterguild_teacher_FElf', 8.00, 22.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5130, 30680, 'Egnos', '', 'a_patriarch_MElf', 7.00, 22.20, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5131, 30681, 'Karia', '', 'e_trader_FOrc', 8.00, 24.00, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5132, 30682, 'Pekiron', '', 'e_clergyman_MOrc', 8.00, 29.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5133, 30683, 'Daunt', '', 'e_fighterguild_teacher_MOrc', 8.00, 28.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5134, 30684, 'Viktor', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5135, 30685, 'Baxt', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5136, 30686, 'Silva', '', 'e_traderA_FDwarf', 7.00, 18.00, 70, 'female', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5137, 30687, 'Vergara', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5138, 30688, 'Duning', '', 'e_smith_master_MDwarf', 7.00, 16.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5139, 30689, 'Siria', '', 'a_fighterguild_master_FHuman', 8.00, 21.50, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5140, 30690, 'Luther', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5141, 30691, 'Aren Athebaldt', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5142, 30692, 'Stedmiel', '', 'a_guard_MElf', 7.00, 22.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5143, 30693, 'Queenien', '', 'a_common_people_FElf', 8.00, 22.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5144, 30694, 'Scraide', '', 'a_mageguild_master_MHuman', 8.00, 24.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5145, 30695, 'Moses', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5146, 30696, 'Page', '', 'a_mageguild_teacher_FHuman', 8.00, 23.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5147, 30697, 'Videlrien', '', 'a_trader_FElf', 7.00, 21.20, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5148, 30698, 'Evelyn', '', 'a_trader_FElf', 7.00, 21.20, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5149, 30699, 'Medown', '', 'a_guild_master_MDarkElf', 8.00, 23.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5150, 30700, 'Prestan', '', 'a_fighterguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5151, 30701, 'Errickin', '', 'a_mageguild_teacher_MDarkElf', 8.00, 22.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5152, 30702, 'Bernard', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5153, 30703, 'Colin', '', 'a_wharfinger_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5154, 30704, 'Garvarentz', '', 'e_guard_MOrc', 8.00, 26.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5155, 30705, 'Chakiris', '', 'e_fighterguild_teacher_MOrc', 8.00, 28.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5156, 30706, 'Lazenby', '', 'e_clergyman_MOrc', 8.00, 29.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5157, 30707, 'Raigen', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 129, 102, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5158, 30708, 'Nasign', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5159, 30709, 'Norton', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5160, 30710, 'Weston', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5161, 30711, 'Byron', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5162, 30712, 'Makhis', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5163, 30713, 'Gardner', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5164, 30714, 'Paros', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5165, 30715, 'Marina', '', 'a_mageguild_teacher_FHuman', 8.00, 23.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5166, 30716, 'Cecile', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5167, 30717, 'Gauen', '', 'a_patriarch_MElf', 7.00, 22.20, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5168, 30718, 'Joan', '', 'a_trader_FElf', 7.00, 21.20, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5169, 30719, 'Mariell', '', 'a_common_people_FElf', 8.50, 23.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5170, 30720, 'Kaiena', '', 'a_mageguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5171, 30721, 'Ladd', '', 'a_mageguild_teacher_MDarkElf', 8.00, 22.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5172, 30722, 'Merian', '', 'a_teleporter_FDarkElf', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5173, 30723, 'Roy', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 129, 102, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5174, 30724, 'Tavillian', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5175, 30725, 'Yening', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5176, 30726, 'Tebose', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 20, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5177, 30727, 'Verona', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5178, 30728, 'Leirynn', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 93, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5179, 30729, 'Borys', '', 'a_wharfinger_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5180, 30730, 'Jax', '', 'a_guard_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 232, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5181, 30731, 'Martin', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5182, 30732, 'Ol Mahum Pilgrim', '', 'ol_mahum', 13.50, 25.00, 36, 'male', 'L2Npc', 'npc', 40, 810, 4.500, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 173, 176, 118, 129, 253, 0, 506, 1, 0, 0, 50, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5183, 30733, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5184, 30734, 'Supply Box On Wharf', '', 'box', 18.00, 14.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5185, 30735, 'Sophya', '', 'a_fighterguild_master_FHuman', 8.00, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5186, 30736, 'Redfoot', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5187, 30737, 'Morgan', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5188, 30738, 'Matild', '', 'e_traderA_FDwarf', 7.00, 18.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5189, 30739, 'Keltir', '', 'fox', 9.50, 10.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 23, 110, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5190, 30740, 'Toad', '', 'poison_toad', 20.00, 10.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5191, 30741, 'Rabbit', '', 'rabbit', 5.00, 4.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 80, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5192, 30742, 'Rupina', '', 'pixy', 5.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5193, 30743, 'Wisdom Chest', '', 'coffer_c', 12.00, 9.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5194, 30744, 'Grey', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5195, 30745, 'Tor', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5196, 30746, 'Cybellin', '', 'a_teleporter_FDarkElf', 8.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5197, 30747, 'Mimyu', '', 'pixy', 5.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5198, 30748, 'Exarion', '', 'drake', 30.00, 100.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 70, 70, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5199, 30749, 'Zwov', '', 'drake', 30.00, 100.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 70, 70, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5200, 30750, 'Kalibran', '', 'drake', 30.00, 100.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 70, 70, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5201, 30751, 'Suzet', '', 'wyrm', 29.00, 72.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 70, 70, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.19, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5202, 30752, 'Shamhai', '', 'wyrm', 29.00, 72.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 70, 70, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.19, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5203, 30753, 'Gabrielle', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5204, 30754, 'Gilmore', '', 'skeleton_knight', 10.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 150, 0, 0, 40, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5205, 30755, 'Theodric', '', 'skeleton_knight', 10.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 127, 0, 0, 40, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5206, 30756, 'Sir Kristof Rodemai', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5207, 30757, 'Statue Of Offering', '', 'castle_kent_statue_jewel', 25.00, 98.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5208, 30758, 'Athrea', '', 'a_hardins_pupil_FHuman', 8.00, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5209, 30759, 'Kalis', '', 'a_hardins_pupil_FHuman', 8.00, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5210, 30760, 'Sir Gustav Athebaldt', '', 'a_royal_guardA_MHuman', 14.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5211, 30761, 'Corpse Of Fritz', '', 'e_guard_MDwarf_death', 13.00, 19.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5212, 30762, 'Corpse Of Lutz', '', 'e_guard_MDwarf_death', 13.00, 19.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5213, 30763, 'Corpse Of Kurtz', '', 'e_guard_MDwarf_death', 13.00, 19.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5214, 30764, 'Balthazar', '', 'a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5215, 30765, 'Imperial Coffer', '', 'coffer_d', 12.00, 9.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5216, 30766, 'Cleo', '', 'a_hardins_pupil_FHuman', 8.00, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5217, 30767, 'Auctioneer', '', 'a_maidB_FHuman', 8.00, 22.00, 70, 'female', 'L2Auctioneer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5218, 30768, 'Auctioneer', '', 'a_trader_FElf', 8.00, 24.00, 70, 'female', 'L2Auctioneer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5219, 30769, 'Auctioneer', '', 'a_maidB_FHuman', 8.00, 21.50, 70, 'female', 'L2Auctioneer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5220, 30770, 'Auctioneer', '', 'e_traderA_FDwarf', 7.00, 18.50, 70, 'female', 'L2Auctioneer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5221, 30771, 'Auctioneer', '', 'e_trader_FOrc', 8.00, 24.00, 70, 'female', 'L2Auctioneer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5222, 30772, 'Wilson', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5223, 30773, 'Todd', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5224, 30827, 'Lundy', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5225, 30828, 'Waters', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5226, 30829, 'Cooper', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5227, 30830, 'Joey', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5228, 30831, 'Nelson', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5229, 30832, 'Hardin', '', 'a_hardin_MHuman', 8.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5230, 30833, 'Kaspar', '', 'a_hardins_pupil_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5231, 30834, 'Cema', '', 'a_hardins_pupil_FHuman', 8.00, 23.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5232, 30835, 'Icarus', '', 'liviona', 12.00, 40.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 212, 0, 0, 70, 15, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5233, 30836, 'Minerva', '', 'a_teleporter_FDarkElf', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5234, 30837, 'Woodrow', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5235, 30838, 'Woodley', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5236, 30839, 'Holly', '', 'a_traderA_FHuman', 7.00, 23.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5237, 30840, 'Lorenzo', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5238, 30841, 'Carson', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5239, 30842, 'Alexis', '', 'a_trader_FElf', 8.00, 24.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5240, 30843, 'Romp', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5241, 30844, 'Walderal', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5242, 30845, 'Klump', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5243, 30846, 'Wilbert', '', 'e_smith_master_MDwarf', 7.00, 16.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5244, 30847, 'Ferris', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5245, 30848, 'Elisa', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5246, 30849, 'Sedrick', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5247, 30850, 'Aiken', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5248, 30851, 'Kendra', '', 'a_fighterguild_master_FHuman', 8.00, 21.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5249, 30852, 'Sinden', '', 'a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5250, 30853, 'Raien', '', 'a_common_people_FElf', 7.00, 25.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5251, 30854, 'Drikiyan', '', 'a_mageguild_master_MHuman', 8.00, 24.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5252, 30855, 'Desmond', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5253, 30856, 'Winonin', '', 'a_common_people_FElf', 7.00, 25.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5254, 30857, 'Orven', '', 'a_sanctuary_master_MHuman', 8.00, 24.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5255, 30858, 'Ross', '', 'a_sanctuary_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5256, 30859, 'Vivyan', '', 'a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5257, 30860, 'Flownia', '', 'a_trader_FElf', 8.00, 24.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5258, 30861, 'Leonard', '', 'a_patriarch_MElf', 8.00, 22.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5259, 30862, 'Oltran', '', 'a_guild_master_MDarkElf', 8.00, 23.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5260, 30863, 'Ghest', '', 'a_fighterguild_teacher_MDarkElf', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5261, 30864, 'Hanellin', '', 'a_mageguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5262, 30865, 'Ladanza', '', 'e_fighterguild_teacher_MOrc', 8.00, 26.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5263, 30866, 'Marestella', '', 'e_trader_FOrc', 8.00, 24.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5264, 30867, 'Reva', '', 'e_trader_MOrc', 8.00, 23.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5265, 30868, 'Sir Eric Rodemai', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 128, 632, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5266, 30869, 'Lemper', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5267, 30870, 'Kurtiz', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 129, 102, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5268, 30871, 'Bret', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5269, 30872, 'Conroy', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 102, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5270, 30873, 'Coleman', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5271, 30874, 'Aldis', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 102, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5272, 30875, 'Carlton', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5273, 30876, 'Eastan', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 102, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5274, 30877, 'Grayson', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5275, 30878, 'Angelina', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5276, 30879, 'Felton', '', 'a_wharfinger_MHuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5277, 30880, 'Viktor Van Dake', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5278, 30881, 'Sanders', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5279, 30882, 'Frontier Guard', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5280, 30883, 'Frontier Guard', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 14, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5281, 30884, 'Frontier Guard', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5282, 30885, 'Frontier Guard', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 14, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5283, 30886, 'Frontier Guard', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5284, 30887, 'Frontier Guard', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 14, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5285, 30888, 'Frontier Guard', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5286, 30889, 'Frontier Guard', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 14, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5287, 30890, 'Espen', '', 'a_trader_MElf', 6.00, 24.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5288, 30891, 'Verona', '', 'a_traderB_FHuman', 8.00, 24.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5289, 30892, 'Enverun', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5290, 30893, 'Payel', '', 'a_trader_FElf', 8.00, 24.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5291, 30894, 'Natools', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5292, 30895, 'Kluck', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5293, 30896, 'Mia', '', 'e_traderA_FDwarf', 7.00, 18.00, 70, 'female', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5294, 30897, 'Roman', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5295, 30898, 'Morning', '', 'e_smith_Fdwarf', 8.00, 17.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5296, 30899, 'Flauen', '', 'a_common_people_FElf', 8.50, 23.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5297, 30900, 'Marcus', '', 'a_fighterguild_master_FHuman', 8.00, 21.50, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5298, 30901, 'Arti', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5299, 30902, 'Karuna', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5300, 30903, 'Traus', '', 'a_guard_MElf', 7.00, 22.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5301, 30904, 'Naiel', '', 'a_common_people_FElf', 8.00, 22.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5302, 30905, 'Squillari', '', 'a_sanctuary_master_MHuman', 8.00, 24.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5303, 30906, 'Ranton', '', 'a_sanctuary_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5304, 30907, 'Minevia', '', 'a_mageguild_teacher_FHuman', 8.00, 23.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5305, 30908, 'Tanios', '', 'a_patriarch_MElf', 7.00, 22.20, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5306, 30909, 'Anabel', '', 'a_trader_FElf', 7.00, 21.20, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5307, 30910, 'Xairakin', '', 'a_guild_master_MDarkElf', 8.00, 23.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5308, 30911, 'Brikus', '', 'a_fighterguild_teacher_MDarkElf', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5309, 30912, 'Xenovia', '', 'a_mageguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5310, 30913, 'Tushku', '', 'e_fighterguild_teacher_MOrc', 8.00, 26.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5311, 30914, 'Sorbo', '', 'e_trader_FOrc', 8.00, 24.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5312, 30915, 'Takina', '', 'e_mageguild_teacher_FOrc', 8.00, 28.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5313, 30916, 'Gosta', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 129, 102, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5314, 30917, 'Dupuis', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5315, 30918, 'Kent', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 102, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5316, 30919, 'Rodic', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5317, 30920, 'Kraisen', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 102, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5318, 30921, 'Timos', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5319, 30922, 'Cage', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 2, 102, 0, 50, 160, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5320, 30923, 'Dunst', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5321, 30924, 'Nedy', '', 'a_wharfinger_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5322, 30925, 'Morelyn', '', 'a_trader_FElf', 7.00, 22.20, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5323, 30926, 'Restina', '', 'a_trader_FElf', 7.00, 22.20, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5324, 30927, 'Alicia', '', 'a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5325, 30928, 'Fenster', '', 'e_collector_teacher_MDwarf', 8.00, 17.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5326, 30929, 'Patrin', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5327, 30930, 'Rogent', '', 'e_mine_master_MDwarf', 8.00, 19.70, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5328, 30931, 'Bentley', '', 'a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5329, 30932, 'Benica', '', 'e_collector_teacher_FDwarf', 8.00, 17.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5330, 30933, 'Braki', '', 'e_collector_teacher_MDwarf', 8.00, 17.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5331, 30934, 'Marsha', '', 'e_collector_teacher_FDwarf', 8.00, 17.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5332, 30935, 'Trumpin', '', 'e_collector_teacher_MDwarf', 8.00, 17.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5333, 30936, 'Malcom1', '', 'poison_toad', 20.00, 10.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5334, 30937, 'Malcom2', '', 'giant_wild_hog', 35.00, 27.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 35, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5335, 30938, 'Malcom3', '', 'ketra_orc', 12.00, 29.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 45, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5336, 30939, 'Malcom4', '', 'skeleton_royal_guard', 11.00, 28.50, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5337, 30940, 'Malcom5', '', 'gremlin', 10.00, 15.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 20, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5338, 30941, 'Malcom6', '', 'saber_toothed_tiger', 34.00, 28.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5339, 30942, 'Malcom7', '', 'monster_eye', 21.00, 43.00, 70, 'male', 'L2Monster', 'Mystic', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 90, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5340, 30943, 'Malcom8', '', 'rabbit', 5.00, 4.50, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5341, 30944, 'Malcom9', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5342, 30945, 'Malcom10', '', 'e_collector_master_MDwarf', 8.00, 18.40, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5343, 30946, 'Lucianne Tanford', '', 'a_fighterguild_master_FHuman', 8.00, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5344, 30947, 'Rerikya', '', 'e_trader_FOrc', 8.00, 24.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5345, 30948, 'Meridien', '', 'a_common_people_FElf', 7.00, 25.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5346, 30949, 'Keplon', '', 'e_mine_master_MDwarf', 8.00, 19.70, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5347, 30950, 'Euclie', '', 'e_mine_teacher_FDwarf', 8.00, 18.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5348, 30951, 'Pithgon', '', 'e_mine_master_MDwarf', 8.00, 19.70, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5349, 30952, 'Dimensional Vortex 1', '', 'broadcasting_tower', 7.00, 35.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5350, 30953, 'Dimensional Vortex 2', '', 'broadcasting_tower', 7.00, 35.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5351, 30954, 'Dimensional Vortex 3', '', 'broadcasting_tower', 7.00, 35.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5352, 30955, 'Gillians Revenant', '', 'zombie', 13.00, 21.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 15, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5353, 30956, 'Nanarin', '', 'a_fighterguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 325, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5354, 30957, 'Swan', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 4202, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5355, 30958, 'Galion', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5356, 30959, 'Barbado', '', 'e_collector_teacher_MDwarf', 8.00, 17.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 5133, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5357, 30960, 'Beer Chest', '', 'box', 18.00, 14.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5358, 30961, 'Cloth Chest', '', 'coffer_d', 12.00, 9.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5359, 30962, 'Statue of Water', '', 'coffer_d', 12.00, 9.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5360, 30963, 'Statue of Fire', '', 'coffer_d', 12.00, 9.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5361, 30964, 'Statue of Wind', '', 'coffer_d', 12.00, 9.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5362, 30965, 'Statue of Earth', '', 'coffer_d', 12.00, 9.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5363, 30966, 'Statue of Darkness', '', 'coffer_d', 12.00, 9.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5364, 30967, 'Statue of Light', '', 'coffer_d', 12.00, 9.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5365, 30968, 'Jennifer', '', 'e_trader_FOrc', 8.00, 24.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5366, 30969, 'Iason Heine', '', 'a_chamberlain_MHuman', 13.50, 20.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5367, 30970, 'Dorothy', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5368, 30971, 'Orpheus', '', 'e_mine_master_MDwarf', 8.00, 18.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5369, 30972, 'Orpheus Resurrecter', '', 'susceptor', 20.00, 35.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 27, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5370, 30973, 'Medium Jar', '', 'pot', 10.00, 15.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5371, 30974, 'Oliver', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5372, 30975, 'Clarine', '', 'e_collector_teacher_FDwarf', 8.00, 17.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5373, 30976, 'Resurrected Town Maiden', '', 'a_common_peopleB_FHuman', 8.00, 20.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5374, 30977, 'Holy Ark of Secrecy 1', '', 'coffer_a', 12.00, 9.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5375, 30978, 'Holy Ark of Secrecy 2', '', 'coffer_b', 12.00, 9.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5376, 30979, 'Holy Ark of Secrecy 3', '', 'coffer_c', 12.00, 9.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5377, 30980, 'Ark Guardians Corpse', '', 'angel_death', 25.00, 36.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5378, 30981, 'Black Judge', '', 'a_clergyman_FDarkElf', 8.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5379, 30982, 'Sleeping Ant Larva1', '', 'ant_larva', 12.00, 8.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5380, 30983, 'Sleeping Ant Larva2', '', 'ant_larva', 12.00, 8.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5381, 30984, 'Sleeping Ant Larva3', '', 'ant_larva', 12.00, 8.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5382, 30985, 'Sleeping Ant Larva4', '', 'ant_larva', 12.00, 8.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5383, 30986, 'Sleeping Ant Larva5', '', 'ant_larva', 12.00, 8.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5384, 30987, 'Sleeping Ant Larva6', '', 'ant_larva', 12.00, 8.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5385, 30988, 'Verce', '', 'a_patriarch_MElf', 8.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5386, 30989, 'Chest of Bifrons', '', 'coffer_c', 12.00, 9.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5387, 30990, 'Lottery Ticket Seller', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5388, 30991, 'Lottery Ticket Seller', '', 'a_trader_MElf', 6.00, 24.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5389, 30992, 'Lottery Ticket Seller', '', 'a_trader_MDarkElf', 8.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5390, 30993, 'Lottery Ticket Seller', '', 'a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5391, 30994, 'Lottery Ticket Seller', '', 'e_trader_MOrc', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5392, 30995, 'Race Manager', '', 'e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2RaceManager', 'RaceManager', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5393, 31001, 'Claudia Athebaldt', '', 'a_mageguild_master_FHuman', 10.00, 22.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5394, 31002, 'Reorin', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5395, 31003, 'Here I Come', '', 'cat_the_cat', 9.00, 16.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5396, 31004, 'Half Moon Love', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5397, 31005, 'Everlasting', '', 'mechanic_golem', 5.00, 19.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5398, 31006, 'Dark Side of the Moon', '', 'silhouette', 8.00, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5399, 31007, 'Wind Rider', '', 'unicorn_boxer', 11.00, 18.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 27, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5400, 31008, 'Shooting Star', '', 'unicorn_mirage', 13.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 27, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5401, 31009, 'Cyclone Thunder', '', 'dark_fencer', 7.00, 13.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 25, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5402, 31010, 'Hungry Baby', '', 'hatchling', 9.00, 10.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.27, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5403, 31011, 'Salty Dog', '', 'pet_wolf', 13.00, 11.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 24, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5404, 31012, 'Raging Revolution', '', 'silver_cat', 7.00, 15.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5405, 31013, 'Valentine Blue', '', 'blue_eye', 11.00, 16.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5406, 31014, 'Light My Fire', '', 'big_boom', 6.00, 13.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5407, 31015, 'Red Bullet', '', 'fox', 9.50, 10.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 23, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5408, 31016, 'Shining Silver', '', 'rabbit', 5.00, 4.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5409, 31017, 'Over the top', '', 'ant_larva', 12.00, 8.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5410, 31018, 'Royal Straight', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5411, 31019, 'All Seven', '', 'wererat', 14.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5412, 31020, 'Nasty Green', '', 'dryad', 9.00, 20.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5413, 31021, 'Shortcut', '', 'goblin', 10.00, 16.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.32, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5414, 31022, 'Typhoon Tiger', '', 'giant_bee', 8.00, 24.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 90, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5415, 31023, 'Red Hot', '', 'salamander', 16.00, 6.80, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 64, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.20, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5416, 31024, 'Galaxy Express', '', 'onyx_beast', 14.00, 14.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.24, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5417, 31025, 'Best Condition', '', 'manadragora', 14.00, 17.80, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5418, 31026, 'Albatross', '', 'orc', 10.00, 21.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 45, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5419, 31027, 'Coffer of the Dead', '', 'coffer_b', 12.00, 9.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5420, 31028, 'Chest of Kernon', '', 'coffer_c', 12.00, 9.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5421, 31029, 'Chest of Golkonda', '', 'coffer_c', 12.00, 9.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5422, 31030, 'Chest of Hallate', '', 'coffer_c', 12.00, 9.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5423, 31031, 'Broadcasting Tower', '', 'broadcasting_tower', 7.00, 35.00, 70, 'etc', 'L2Observation', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5424, 31032, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'GuardRndWalkAndAnim', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5425, 31033, 'Sentinel', '', 'a_guard_MElf', 8.00, 23.50, 80, 'male', 'L2Guard', 'GuardRndWalkAndAnim', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 276, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5426, 31034, 'Sentry', '', 'a_guard_FDarkelf', 7.00, 25.00, 80, 'female', 'L2Guard', 'GuardRndWalkAndAnim', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 277, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5427, 31035, 'Defender', '', 'e_guard_MDwarf', 8.00, 19.00, 80, 'male', 'L2Guard', 'GuardRndWalkAndAnim', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5428, 31036, 'Centurion', '', 'e_guard_MOrc', 8.00, 27.00, 80, 'male', 'L2Guard', 'GuardRndWalkAndAnim', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 273, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5429, 31042, 'Kantabilon', '', 'a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5430, 31043, 'Octavia', '', 'e_traderA_FDwarf', 7.00, 18.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5431, 31044, 'Galman', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5432, 31045, 'Kitzka', '', 'e_collector_teacher_FDwarf', 8.00, 17.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5433, 31046, 'Marsden', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2SymbolMaker', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5434, 31047, 'Kell', '', 'a_mageguild_teacher_FHuman', 8.00, 23.00, 70, 'male', 'L2SymbolMaker', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5435, 31048, 'McDermott', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2SymbolMaker', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5436, 31049, 'Pepper', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2SymbolMaker', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5437, 31050, 'Thora', '', 'a_mageguild_teacher_FHuman', 8.00, 23.00, 70, 'male', 'L2SymbolMaker', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5438, 31051, 'Keach', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2SymbolMaker', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5439, 31052, 'Heid', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2SymbolMaker', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5440, 31053, 'Kidder', '', 'a_mageguild_teacher_FHuman', 8.00, 23.50, 70, 'female', 'L2SymbolMaker', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5441, 31067, 'Rood', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5442, 31074, 'Corpse of Hutaku', '', 'e_trader_Morc_death', 22.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5443, 31075, 'Sales Cat of Ivory Tower', '', 'cat_the_cat', 9.00, 16.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5444, 31076, 'Newbie Guide', '', 'a_common_peopleB_FHuman', 8.00, 20.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5445, 31077, 'Newbie Guide', '', 'a_common_peopleB_FHuman', 8.00, 20.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5446, 31078, 'Priest of Dawn', '', 'priest_of_dawn', 8.00, 30.50, 70, 'male', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 5802, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5447, 31079, 'Priest of Dawn', '', 'priest_of_dawn', 8.00, 30.50, 70, 'male', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 5802, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5448, 31080, 'Priest of Dawn', '', 'priest_of_dawn', 8.00, 30.50, 70, 'male', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 5802, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5449, 31081, 'Priest of Dawn', '', 'priest_of_dawn', 8.00, 30.50, 70, 'male', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 5802, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5450, 31082, 'Priest of Dawn', '', 'priest_of_dawn', 8.00, 30.50, 70, 'male', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 5802, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5451, 31083, 'Priest of Dawn', '', 'priest_of_dawn', 8.00, 30.50, 70, 'male', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 5802, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5452, 31084, 'Priest of Dawn', '', 'priest_of_dawn', 8.00, 30.50, 70, 'male', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 5802, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5453, 31085, 'Dusk Priestess', '', 'priest_of_dusk', 8.00, 22.00, 70, 'female', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 5801, 0, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5454, 31086, 'Dusk Priestess', '', 'priest_of_dusk', 8.00, 22.00, 70, 'female', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 5801, 0, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5455, 31087, 'Dusk Priestess', '', 'priest_of_dusk', 8.00, 22.00, 70, 'female', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 5801, 0, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5456, 31088, 'Dusk Priestess', '', 'priest_of_dusk', 8.00, 22.00, 70, 'female', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 5801, 0, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5457, 31089, 'Dusk Priestess', '', 'priest_of_dusk', 8.00, 22.00, 70, 'female', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 5801, 0, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5458, 31090, 'Dusk Priestess', '', 'priest_of_dusk', 8.00, 22.00, 70, 'female', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 5801, 0, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5459, 31091, 'Dusk Priestess', '', 'priest_of_dusk', 8.00, 22.00, 70, 'female', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 5801, 0, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5460, 31092, 'Black Marketeer of Mammon', '', 'black_market_trader_MDwarf', 8.00, 18.00, 70, 'male', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5461, 31093, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5462, 31094, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5463, 31095, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5464, 31096, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5465, 31097, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5466, 31098, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5467, 31099, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5468, 31100, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5469, 31101, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5470, 31102, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5471, 31103, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5472, 31104, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5473, 31105, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5474, 31106, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5475, 31107, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5476, 31108, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5477, 31109, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5478, 31110, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5479, 31111, 'Gatekeeper Spirit', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5480, 31112, 'Gatekeeper Spirit', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5481, 31113, 'Merchant of Mammon', '', 'black_market_trader_MDwarf_set', 22.00, 18.00, 70, 'male', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5482, 31114, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5483, 31115, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5484, 31116, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5485, 31117, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5486, 31118, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5487, 31119, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5488, 31120, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5489, 31121, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5490, 31122, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5491, 31123, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5492, 31124, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5493, 31125, 'Gatekeeper Ziggurat', '', 'teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5494, 31126, 'Blacksmith of Mammon', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5495, 31127, 'Festival Guide', '', 'priest_of_dawn', 8.00, 30.50, 70, 'male', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 5802, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5496, 31128, 'Festival Guide', '', 'priest_of_dawn', 8.00, 30.50, 70, 'male', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 5802, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5497, 31129, 'Festival Guide', '', 'priest_of_dawn', 8.00, 30.50, 70, 'male', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 5802, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5498, 31130, 'Festival Guide', '', 'priest_of_dawn', 8.00, 30.50, 70, 'male', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 5802, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5499, 31131, 'Festival Guide', '', 'priest_of_dawn', 8.00, 30.50, 70, 'male', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 5802, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5500, 31132, 'Festival Witch', '', 'a_guard_FDarkelf', 7.00, 25.00, 70, 'female', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5501, 31133, 'Festival Witch', '', 'a_guard_FDarkelf', 7.00, 25.00, 70, 'female', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5502, 31134, 'Festival Witch', '', 'a_guard_FDarkelf', 7.00, 25.00, 70, 'female', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5503, 31135, 'Festival Witch', '', 'a_guard_FDarkelf', 7.00, 25.00, 70, 'female', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5504, 31136, 'Festival Witch', '', 'a_guard_FDarkelf', 7.00, 25.00, 70, 'female', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5505, 31137, 'Festival Guide', '', 'priest_of_dusk', 8.00, 22.00, 70, 'female', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 5801, 0, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5506, 31138, 'Festival Guide', '', 'priest_of_dusk', 8.00, 22.00, 70, 'female', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 5801, 0, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5507, 31139, 'Festival Guide', '', 'priest_of_dusk', 8.00, 22.00, 70, 'female', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 5801, 0, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5508, 31140, 'Festival Guide', '', 'priest_of_dusk', 8.00, 22.00, 70, 'female', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 5801, 0, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5509, 31141, 'Festival Guide', '', 'priest_of_dusk', 8.00, 22.00, 70, 'female', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 5801, 0, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5510, 31142, 'Festival Witch', '', 'a_guard_FDarkelf', 7.00, 25.00, 70, 'female', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5511, 31143, 'Festival Witch', '', 'a_guard_FDarkelf', 7.00, 25.00, 70, 'female', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5512, 31144, 'Festival Witch', '', 'a_guard_FDarkelf', 7.00, 25.00, 70, 'female', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5513, 31145, 'Festival Witch', '', 'a_guard_FDarkelf', 7.00, 25.00, 70, 'female', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5514, 31146, 'Festival Witch', '', 'a_guard_FDarkelf', 7.00, 25.00, 70, 'female', 'L2FestivalGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5515, 31147, 'Sobling', '', 'e_mine_master_MDwarf', 8.00, 19.70, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5516, 31148, 'Pirates Chest', '', 'coffer_c', 12.00, 9.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5517, 31149, 'Alchemists Mixing Urn', '', 'pot', 10.00, 15.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5518, 31168, 'Priest of Dawn', '', 'priest_of_dawn', 8.00, 30.50, 70, 'male', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 5802, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5519, 31169, 'Dusk Priestess', '', 'priest_of_dusk', 8.00, 22.00, 70, 'female', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 5801, 0, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5520, 31170, 'Crest of Dawn', '', 'flag_ssq', 0.01, 0.01, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5521, 31171, 'Crest of Dusk', '', 'flag_ssq', 0.01, 0.01, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5522, 31172, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5523, 31173, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5524, 31174, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5525, 31175, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5526, 31176, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5527, 31177, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5528, 31178, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5529, 31179, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5530, 31180, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5531, 31181, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5532, 31182, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5533, 31183, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5534, 31184, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5535, 31185, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5536, 31186, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5537, 31187, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5538, 31188, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5539, 31189, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5540, 31190, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5541, 31191, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5542, 31192, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5543, 31193, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5544, 31194, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5545, 31195, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5546, 31196, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5547, 31197, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5548, 31198, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5549, 31199, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5550, 31200, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5551, 31201, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5552, 31202, 'Maximus', '', 'pet_wolf', 13.00, 11.50, 70, 'male', 'L2Npc', 'RndWalkAndAnim', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 24, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5553, 31203, 'Moon Dancer', '', 'pet_wolf', 13.00, 11.50, 70, 'male', 'L2Npc', 'RndWalkAndAnim', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 24, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5554, 31204, 'Georgio', '', 'pet_wolf', 13.00, 11.50, 70, 'male', 'L2Npc', 'RndWalkAndAnim', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 24, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5555, 31205, 'Katz', '', 'hatchling', 9.00, 10.00, 70, 'male', 'L2Npc', 'RndWalkAndAnim', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.27, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5556, 31206, 'Ten Ten', '', 'hatchling', 9.00, 10.00, 70, 'male', 'L2Npc', 'RndWalkAndAnim', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.27, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5557, 31207, 'Sardinia', '', 'hatchling', 9.00, 10.00, 70, 'male', 'L2Npc', 'RndWalkAndAnim', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.27, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5558, 31208, 'La Grange', '', 'hatchling', 9.00, 10.00, 70, 'male', 'L2Npc', 'RndWalkAndAnim', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.27, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5559, 31209, 'Misty Rain', '', 'pet_wolf', 13.00, 11.50, 70, 'male', 'L2Npc', 'RndWalkAndAnim', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 24, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5560, 31210, 'Race Track Gatekeeper', '', 'e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5561, 31211, 'Race Track Guide', '', 'e_traderA_FDwarf', 7.00, 18.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5562, 31212, 'Event Gatekeeper', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5563, 31213, 'Event Gatekeeper', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5564, 31214, 'Event Gatekeeper', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5565, 31215, 'Event Gatekeeper', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5566, 31216, 'Event Gatekeeper', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5567, 31217, 'Event Gatekeeper', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5568, 31218, 'Event Gatekeeper', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5569, 31219, 'Event Gatekeeper', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5570, 31220, 'Event Gatekeeper', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5571, 31221, 'Event Gatekeeper', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5572, 31222, 'Event Gatekeeper', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5573, 31223, 'Event Gatekeeper', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5574, 31224, 'Event Gatekeeper', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5575, 31225, 'Arena Manager', '', 'e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5576, 31226, 'Arena Director', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5577, 31227, 'Buzz the Cat', '', 'cat_the_cat', 9.00, 16.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5578, 31228, 'Roy the Cat', '', 'cat_the_cat', 9.00, 16.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5579, 31229, 'Winnie the Cat', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5580, 31230, 'Louie the Cat', '', 'silver_cat', 7.00, 15.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5581, 31231, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5582, 31232, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5583, 31233, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5584, 31234, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5585, 31235, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5586, 31236, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5587, 31237, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5588, 31238, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5589, 31239, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5590, 31240, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5591, 31241, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5592, 31242, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5593, 31243, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5594, 31244, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5595, 31245, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5596, 31246, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5597, 31247, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5598, 31248, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5599, 31249, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5600, 31250, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5601, 31251, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5602, 31252, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5603, 31253, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5604, 31254, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5605, 31255, 'Buzz the Cat', '', 'cat_the_cat', 9.00, 16.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5606, 31256, 'Leon', '', 'a_traderC_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5607, 31257, 'Veronica', '', 'a_traderD_Fhuman', 8.00, 25.30, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5608, 31258, 'Helmut', '', 'a_common_peopleC_Mhuman', 10.00, 24.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5609, 31259, 'Janne', '', 'a_common_peopleC_Fhuman', 8.00, 22.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5610, 31260, 'Judith', '', 'a_traderD_Fhuman', 8.00, 25.30, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5611, 31261, 'Renee', '', 'e_warehouse_keeper_FDwarf', 7.00, 18.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5612, 31262, 'Rupert', '', 'a_traderD_Mhuman', 8.00, 21.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5613, 31263, 'Liesel', '', 'a_common_peopleC_Fhuman', 8.00, 22.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5614, 31264, 'Olsun', '', 'a_traderC_Mhuman', 8.00, 23.00, 70, 'male', 'L2SymbolMaker', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5615, 31265, 'Annette', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5616, 31266, 'Kaiser', '', 'youth_tiger', 16.00, 17.20, 70, 'male', 'L2Npc', 'RndWalkAndAnim', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5617, 31267, 'Lietta', '', 'e_warehouse_keeper_FDwarf', 7.00, 18.00, 70, 'female', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5618, 31268, 'Hakon', '', 'e_warehouse_master_MDwarf', 8.00, 17.50, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5619, 31269, 'Mona', '', 'e_traderB_FDwarf', 7.00, 18.00, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5620, 31270, 'Stefano', '', 'e_collector_teacher_MDwarf', 8.00, 17.50, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5621, 31271, 'Hilda', '', 'e_smith_Fdwarf', 8.00, 17.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 87, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5622, 31272, 'Noel', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5623, 31273, 'Borodin', '', 'e_mine_teacher_MDwarf', 8.00, 18.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5624, 31274, 'Fundin', '', 'a_smith_MDwarf', 7.00, 16.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5625, 31275, 'Tatiana', '', 'e_teleporter_Fhuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5626, 31276, 'Bernhard', '', 'a_fighterguild_master_Mhuman', 8.00, 23.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 76, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5627, 31277, 'Felix', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 125, 20, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5628, 31278, 'Bronwyn', '', 'a_fighterguild_teacher_MElf', 7.00, 22.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 130, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5629, 31279, 'Gregory', '', 'a_temple_master_Mhuman', 8.00, 22.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 193, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5630, 31280, 'Bastian', '', 'a_temple_teacher_Mhuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5631, 31281, 'Cerenas', '', 'a_patriarch_MElf', 8.00, 22.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5632, 31282, 'Justin', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5633, 31283, 'Alminas', '', 'a_patriarch_MElf', 8.00, 22.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5634, 31284, 'Elena', '', 'a_traderD_Fhuman', 8.00, 25.30, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5635, 31285, 'Samael', '', 'a_patriarch_MDarkElf', 6.00, 23.80, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5636, 31286, 'Drakon', '', 'a_guild_master_MDarkElf', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 143, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5637, 31287, 'Kamilen', '', 'a_casino_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 204, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5638, 31288, 'Aklan', '', 'e_patriarch_MOrc', 8.00, 26.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5639, 31289, 'Lakan', '', 'e_fighterguild_teacher_MOrc', 8.00, 28.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 161, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5640, 31290, 'Skahi', '', 'e_clergyman_MOrc', 8.00, 29.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 202, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5641, 31291, 'Terava', '', 'e_clergyman_FOrc', 7.00, 28.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5642, 31292, 'Andrei', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 133, 632, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5643, 31293, 'Gunter', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 126, 628, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5644, 31294, 'Sven', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 94, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5645, 31295, 'Henrik', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 126, 628, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5646, 31296, 'Cadmon', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 94, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5647, 31297, 'Bayard', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 126, 628, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5648, 31298, 'Ulrich', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 94, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5649, 31299, 'Eugen', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 126, 628, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5650, 31300, 'Drumond', '', 'e_traderB_master_MDwarf', 8.00, 17.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5651, 31301, 'Nils', '', 'a_traderD_Mhuman', 8.00, 21.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5652, 31302, 'Vladimir', '', 'a_common_peopleC_Mhuman', 10.00, 24.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5653, 31303, 'Alisha', '', 'a_traderD_Fhuman', 8.00, 25.30, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5654, 31304, 'Astrid', '', 'a_traderC_Fhuman', 8.00, 22.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5655, 31305, 'Candice', '', 'e_traderA_FDwarf', 7.00, 18.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5656, 31306, 'Natasha', '', 'a_traderB_FHuman', 8.00, 24.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5657, 31307, 'Weber', '', 'a_traderD_Mhuman', 8.00, 21.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5658, 31308, 'Achim', '', 'a_traderC_Mhuman', 8.00, 23.00, 70, 'male', 'L2SymbolMaker', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5659, 31309, 'Woods', '', 'a_traderD_Mhuman', 8.00, 21.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5660, 31310, 'Rafael', '', 'strider', 23.00, 31.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.25, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5661, 31311, 'Hugin', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5662, 31312, 'Durin', '', 'a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5663, 31313, 'Lunin', '', 'e_traderB_MDwarf', 8.00, 17.50, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5664, 31314, 'Donal', '', 'e_warehouse_master_MDwarf', 8.00, 17.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5665, 31315, 'Daisy', '', 'e_warehouse_keeper_FDwarf', 7.00, 18.00, 70, 'female', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5666, 31316, 'Vincenz', '', 'a_smith_MDwarf', 7.00, 16.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5667, 31317, 'Lombert', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5668, 31318, 'Greta', '', 'e_mine_teacher_FDwarf', 8.00, 18.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5669, 31319, 'Hans', '', 'e_traderB_master_MDwarf', 8.00, 17.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5670, 31320, 'Ilyana', '', 'e_teleporter_Fhuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5671, 31321, 'Siegmund', '', 'a_fighterguild_master_Mhuman', 8.00, 23.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 76, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5672, 31322, 'Erian', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 125, 20, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5673, 31323, 'Beryl', '', 'a_fighterguild_teacher_FElf', 8.00, 22.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 130, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5674, 31324, 'Andromeda', '', 'a_casino_FDarkElf', 8.00, 23.00, 70, 'female', 'L2WeddingManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 316, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5675, 31325, 'Themis', '', 'a_fighterguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 227, 627, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5676, 31326, 'Lambac', '', 'e_patriarch_MOrc', 8.00, 26.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5677, 31327, 'Tazki', '', 'e_fighterguild_teacher_MOrc', 8.00, 28.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 161, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5678, 31328, 'Innocentin', '', 'a_temple_master_Mhuman', 8.00, 22.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 193, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5679, 31329, 'Eliyah', '', 'a_temple_teacher_Mhuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5680, 31330, 'Wagner', '', 'a_patriarch_MElf', 8.00, 22.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5681, 31331, 'Valdis', '', 'a_mageguild_master_MHuman', 8.00, 24.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5682, 31332, 'Amelia', '', 'a_mageguild_teacher_FHuman', 8.00, 23.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5683, 31333, 'Rumiel', '', 'a_mageguild_teacher_FElf', 7.00, 21.20, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5684, 31334, 'Tifaren', '', 'a_teleporter_FDarkElf', 8.00, 25.00, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5685, 31335, 'Kayan', '', 'a_clergyman_MDarkElf', 8.00, 22.30, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 317, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5686, 31336, 'Rahorakti', '', 'e_clergyman_MOrc', 8.00, 29.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 202, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5687, 31337, 'Mekara', '', 'e_mageguild_teacher_FOrc', 8.00, 28.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5688, 31338, 'Anton', '', 'a_traderD_Mhuman', 8.00, 21.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5689, 31339, 'Hakran', '', 'e_mageguild_teacher_MOrc', 8.00, 29.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5690, 31340, 'Mathias', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 133, 632, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5691, 31341, 'Richtor', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 126, 628, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5692, 31342, 'Dimitri', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 94, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5693, 31343, 'Bellard', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 126, 628, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5694, 31344, 'Schmidt', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 94, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5695, 31345, 'Ian', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 126, 628, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5696, 31346, 'Sirius', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 94, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5697, 31347, 'Burke', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 126, 628, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5698, 31348, 'Agripel', '', 'a_temple_master_Mhuman', 8.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5699, 31349, 'Benedict', '', 'a_temple_master_Mhuman', 8.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5700, 31350, 'Dominic', '', 'a_temple_master_Mhuman', 8.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5701, 31351, 'Volker', '', 'a_traderC_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5702, 31356, 'Remy', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Npc', 'Remy', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5703, 31357, 'Leandro', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2Npc', 'Leandro', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5704, 31358, 'Kasiel', '', 'a_trader_MElf', 6.00, 24.50, 70, 'male', 'L2Npc', 'Kasiel', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 4202, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5705, 31359, 'Jaradine', '', 'a_patriarch_MElf', 8.00, 22.50, 70, 'male', 'L2Npc', 'Jaradine', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 189, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5706, 31360, 'Alhena', '', 'a_casino_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Npc', 'Alhena', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 315, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5707, 31361, 'Kreed', '', 'a_trader_MDarkElf', 8.00, 22.50, 70, 'male', 'L2Npc', 'Kreed', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 151, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5708, 31362, 'Tate', '', 'a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'Tate', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5709, 31363, 'Rogin', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'Rogin', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5710, 31364, 'Rokar', '', 'e_guard_MOrc', 8.00, 27.00, 70, 'male', 'L2Npc', 'Rokar', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 203, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5711, 31365, 'Yakand', '', 'e_guard_MOrc', 8.00, 27.00, 70, 'male', 'L2Npc', 'Yakand', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 203, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5712, 31366, 'Feed Seller', '', 'a_traderD_Mhuman', 8.00, 21.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5713, 31367, 'Voice of Glory', '', 'kel_mahum_witch_doctor', 13.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 193, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5714, 31368, 'Mikellan', '', 'a_temple_teacher_Mhuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5715, 31369, 'Mennon', '', 'a_temple_teacher_Mhuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5716, 31370, 'Kadun Zu Ketra', '', 'ketra_orc_chieftain', 11.00, 38.50, 70, 'male', 'L2NpcFriend', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 6719, 0, 0, 24, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.51, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5717, 31371, 'Wahkan', '', 'ketra_orc', 12.00, 29.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 175, 0, 0, 45, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5718, 31372, 'Asefa', '', 'ketra_orc_shaman', 10.00, 23.00, 70, 'male', 'L2NpcFriend', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 205, 0, 0, 10, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5719, 31373, 'Atan', '', 'ketra_orc_warrior', 12.00, 24.00, 70, 'male', 'L2NpcFriend', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 36, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5720, 31374, 'Jaff', '', 'ketra_orc_warrior', 12.00, 24.00, 70, 'male', 'L2NpcFriend', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 36, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5721, 31375, 'Jumara', '', 'ketra_orc_warrior', 12.00, 24.00, 70, 'male', 'L2NpcFriend', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 36, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5722, 31376, 'Kurfa', '', 'ketra_orc_shaman', 10.00, 23.00, 70, 'male', 'L2NpcFriend', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 205, 0, 0, 10, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5723, 31377, 'Ashas Varka Durai', '', 'barka_silenos_chieftain', 18.00, 42.50, 70, 'male', 'L2NpcFriend', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 145, 0, 0, 25, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5724, 31378, 'Naran Ashanuk', '', 'barka_silenos_warrior', 16.00, 41.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 173, 0, 0, 34, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5725, 31379, 'Udan Mardui', '', 'barka_silenos_shaman', 14.00, 39.50, 70, 'male', 'L2NpcFriend', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 6716, 0, 0, 36, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5726, 31380, 'Diyabu', '', 'barka_silenos_hunter', 16.00, 38.00, 70, 'male', 'L2NpcFriend', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 44, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5727, 31381, 'Hagos', '', 'barka_silenos_warrior', 16.00, 41.00, 70, 'male', 'L2NpcFriend', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 34, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5728, 31382, 'Shikon', '', 'barka_silenos_hunter', 16.00, 38.00, 70, 'male', 'L2NpcFriend', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 44, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5729, 31383, 'Teranu Mardui', '', 'barka_silenos_shaman', 14.00, 39.50, 70, 'male', 'L2NpcFriend', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 6716, 0, 0, 36, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5730, 31384, 'Gatekeeper of Fire Dragon', '', 'skeleton_knight', 10.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 84, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5731, 31385, 'Heart of Volcano', '', 'heart_of_warding', 17.00, 120.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5732, 31386, 'Violet', '', 'a_traderD_Fhuman', 8.00, 25.30, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5733, 31387, 'Kurstin', '', 'a_traderB_FHuman', 8.00, 24.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5734, 31388, 'Mina', '', 'a_traderB_FHuman', 8.00, 24.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5735, 31389, 'Dorian', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 297, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5736, 31390, 'Dummy - Boy A', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5737, 31391, 'Dummy  - Boy B', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5738, 31392, 'Dummy  - Boy C', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5739, 31393, 'Dummy - Boy D', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5740, 31394, 'Dummy - Boy E', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5741, 31395, 'Dummy - Lady F', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5742, 31396, 'Dummy - Lady G', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5743, 31397, 'Dummy - Lady H', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5744, 31398, 'Dummy - Lady I', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5745, 31399, 'Dummy - Lady J', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5746, 31400, 'Dummy - Sword Guard', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 2, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5747, 31401, 'Dummy - Bow Guard', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 14, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5748, 31404, 'Monster Race Guide', '', 'e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5749, 31405, 'Monster Race Guide', '', 'e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5750, 31406, 'Monster Race Guide', '', 'e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5751, 31407, 'Monster Race Guide', '', 'e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5752, 31408, 'Monster Race Guide', '', 'e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5753, 31409, 'Monster Race Guide', '', 'e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5754, 31410, 'Monster Race Guide', '', 'e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5755, 31411, 'Monster Race Guide', '', 'e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5756, 31412, 'Monster Race Guide', '', 'e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5757, 31413, 'Antonio', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5758, 31414, 'Lynn', '', 'a_common_people_FElf', 7.00, 25.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5759, 31415, 'Triya', '', 'a_mageguild_teacher_MDarkElf', 8.00, 22.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5760, 31416, 'Aren', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5761, 31417, 'Berynel', '', 'a_common_people_MElf', 6.00, 21.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5762, 31418, 'Rouke', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5763, 31419, 'Lorel', '', 'a_common_people_MElf', 6.00, 21.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5764, 31420, 'Tomanel', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5765, 31421, 'Ratriya', '', 'a_common_people_FElf', 7.00, 25.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5766, 31422, 'Migel', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5767, 31423, 'Romas', '', 'a_traderB_MHuman', 8.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5768, 31424, 'Shantra', '', 'e_clergyman_FOrc', 7.00, 28.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5769, 31425, 'Koram', '', 'e_mageguild_teacher_MOrc', 8.00, 29.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5770, 31426, 'Jaka', '', 'e_mageguild_teacher_MOrc', 8.00, 29.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5771, 31427, 'Urgal', '', 'e_mageguild_teacher_MOrc', 8.00, 29.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5772, 31428, 'Shafa', '', 'e_clergyman_FOrc', 7.00, 28.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5773, 31429, 'Shitara', '', 'e_clergyman_FOrc', 7.00, 28.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5774, 31430, 'Donai', '', 'e_mageguild_teacher_MOrc', 8.00, 29.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5775, 31431, 'Karai', '', 'e_mageguild_teacher_MOrc', 8.00, 29.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5776, 31432, 'Reeya', '', 'e_mine_teacher_FDwarf', 8.00, 18.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5777, 31433, 'Ronaldo', '', 'e_mine_master_MDwarf', 8.00, 19.70, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5778, 31434, 'Shaling', '', 'e_mine_teacher_FDwarf', 8.00, 18.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5779, 31435, 'Daeger', '', 'e_traderA_master_MDwarf', 8.00, 18.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5780, 31436, 'Dani', '', 'e_mine_teacher_FDwarf', 8.00, 18.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5781, 31437, 'Luka', '', 'e_mine_master_MDwarf', 8.00, 19.70, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5782, 31438, 'Lara', '', 'e_mine_teacher_FDwarf', 8.00, 18.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5783, 31439, 'Rogen', '', 'e_collector_teacher_MDwarf', 8.00, 17.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5784, 31440, 'Lanna', '', 'e_collector_teacher_FDwarf', 8.00, 17.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5785, 31441, 'Gordo', '', 'e_traderB_master_MDwarf', 8.00, 17.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5786, 31442, 'Kiki', '', 'e_traderB_FDwarf', 7.00, 18.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5787, 31443, 'Raban', '', 'e_collector_teacher_MDwarf', 8.00, 17.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5788, 31444, 'Cona', '', 'e_warehouse_keeper_FDwarf', 7.00, 18.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5789, 31445, 'Shutner', '', 'e_traderB_MDwarf', 8.00, 17.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5790, 31452, 'Ghost of Wigoth', '', 'a_temple_master_Mhuman', 8.00, 22.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5791, 31453, 'Nameless Spirit', '', 'a_king_MHuman', 8.00, 21.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5792, 31454, 'Ghost of Wigoth', '', 'a_temple_master_Mhuman', 8.00, 22.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5793, 31455, 'Key Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5794, 31456, 'Key Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5795, 31457, 'Key Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5796, 31458, 'Key Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5797, 31459, 'Key Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5798, 31460, 'Key Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5799, 31461, 'Key Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5800, 31462, 'Key Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5801, 31463, 'Key Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5802, 31464, 'Key Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5803, 31465, 'Key Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5804, 31466, 'Key Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5805, 31467, 'Key Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5806, 31468, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5807, 31469, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5808, 31470, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5809, 31471, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5810, 31472, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5811, 31473, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5812, 31474, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5813, 31475, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5814, 31476, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5815, 31477, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5816, 31478, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5817, 31479, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5818, 31480, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5819, 31481, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5820, 31482, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5821, 31483, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5822, 31484, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5823, 31485, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5824, 31486, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5825, 31487, 'Mysterious Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5826, 31488, 'Rift Post Recruit', '', 'a_royal_guardB_MHuman', 7.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 94, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5827, 31489, 'Rift Post Private', '', 'a_royal_guardB_MHuman', 7.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 304, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5828, 31490, 'Rift Post Officer', '', 'a_royal_guardB_MHuman', 7.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 79, 111, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5829, 31491, 'Rift Post Captain', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 76, 660, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5830, 31492, 'Rift Post Commander', '', 'a_lord_MHuman', 7.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 80, 655, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5831, 31493, 'Rift Post Hero', '', 'a_fighterguild_master_Mhuman', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 135, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5832, 31494, 'Dimensional Gate Keeper', '', 'rift_keeper', 38.00, 120.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5833, 31495, 'Dimensional Gate Keeper', '', 'rift_keeper', 38.00, 120.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5834, 31496, 'Dimensional Gate Keeper', '', 'rift_keeper', 38.00, 120.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5835, 31497, 'Dimensional Gate Keeper', '', 'rift_keeper', 38.00, 120.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5836, 31498, 'Dimensional Gate Keeper', '', 'rift_keeper', 38.00, 120.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5837, 31499, 'Dimensional Gate Keeper', '', 'rift_keeper', 38.00, 120.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5838, 31500, 'Dimensional Gate Keeper', '', 'rift_keeper', 38.00, 120.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5839, 31501, 'Dimensional Gate Keeper', '', 'rift_keeper', 38.00, 120.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5840, 31502, 'Dimensional Gate Keeper', '', 'rift_keeper', 38.00, 120.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5841, 31503, 'Dimensional Gate Keeper', '', 'rift_keeper', 38.00, 120.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5842, 31504, 'Dimensional Gate Keeper', '', 'rift_keeper', 38.00, 120.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5843, 31505, 'Dimensional Gate Keeper', '', 'rift_keeper', 38.00, 120.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5844, 31506, 'Dimensional Gate Keeper', '', 'rift_keeper', 38.00, 120.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5845, 31507, 'Dimensional Gate Keeper', '', 'rift_keeper', 38.00, 120.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5846, 31508, 'Altar of Saints', '', 'holy_altar', 14.00, 45.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5847, 31509, 'Altar of Saints', '', 'holy_altar', 14.00, 45.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5848, 31510, 'Altar of Saints', '', 'holy_altar', 14.00, 45.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5849, 31511, 'Altar of Saints', '', 'holy_altar', 14.00, 45.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5850, 31512, 'Evil Altar', '', 'evil_altar', 11.00, 45.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5851, 31513, 'Evil Altar', '', 'evil_altar', 11.00, 45.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5852, 31514, 'Evil Altar', '', 'evil_altar', 11.00, 45.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5853, 31515, 'Evil Altar', '', 'evil_altar', 11.00, 45.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5854, 31516, 'Evil Altar', '', 'evil_altar', 11.00, 45.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5855, 31517, 'Hierarch', '', 'a_hardin_MHuman', 8.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5856, 31518, 'Mysterious Necromancer', '', 'a_hardins_pupil_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5857, 31519, 'Enfeux', '', 'saints_coffin', 20.00, 60.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5858, 31520, 'Leikar', '', 'a_maidA_FHuman', 8.00, 20.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5859, 31521, 'Jeremy', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5860, 31522, 'Mysterious Wizard', '', 'a_hardin_MHuman', 8.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5861, 31523, 'Tombstone', '', 'old_tomb_stone', 20.00, 30.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5862, 31524, 'Ghost of von Hellmann', '', 'a_temple_master_Mhuman', 8.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5863, 31525, 'Ghost of von Hellmanns Page', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2Npc', 'GhostOfVonHellmannsPage', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5864, 31526, 'Broken Bookshelf', '', 'old_bookshelf', 15.00, 33.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5865, 31527, 'Well', '', 'umul', 33.00, 37.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5866, 31528, 'Ghost of Priest', '', 'elf_ghost', 7.00, 21.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5867, 31529, 'Ghost of Adventurer', '', 'human_ghost', 8.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5868, 31530, 'Box', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5869, 31531, 'Tombstone', '', 'old_tomb_stone', 20.00, 30.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5870, 31532, 'Maid of Lidia', '', 'vampire_witch', 6.00, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 64, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5871, 31533, 'Broken Bookshelf', '', 'old_bookshelf', 15.00, 33.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5872, 31534, 'Broken Bookshelf', '', 'old_bookshelf', 15.00, 33.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5873, 31535, 'Broken Bookshelf', '', 'old_bookshelf', 15.00, 33.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5874, 31536, 'Coffin', '', 'mimic', 8.50, 8.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5875, 31537, 'Tunatun', '', 'a_common_peopleC_Mhuman', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5876, 31538, 'Ghost of Adventurer', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5877, 31539, 'Vulcan', '', 'a_smith_MDwarf', 7.00, 16.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5878, 31540, 'Klein', '', 'skeleton_royal_guard', 11.00, 28.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5879, 31541, 'Daimons Altar', '', 'gianteye_altar', 40.00, 45.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5880, 31542, 'Yetis Table', '', 'yetis_dinner_table', 23.00, 16.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5881, 31543, 'Pulin', '', 'e_bath_MDwarf', 6.00, 16.30, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5882, 31544, 'Naff', '', 'e_bath_MDwarf', 6.00, 16.30, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5883, 31545, 'Crocus', '', 'e_bath_MDwarf', 6.00, 16.30, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5884, 31546, 'Kuber', '', 'e_bath_MDwarf', 6.00, 16.30, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5885, 31547, 'Beolin', '', 'e_bath_MDwarf', 6.00, 16.30, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5886, 31548, 'Mysterious Ancient Tablet', '', 'old_tablet', 32.00, 46.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5887, 31549, 'Mysterious Ancient Tablet', '', 'old_tablet', 32.00, 46.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5888, 31550, 'Mysterious Ancient Tablet', '', 'old_tablet', 32.00, 46.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5889, 31551, 'Mysterious Ancient Tablet', '', 'old_tablet', 32.00, 46.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5890, 31552, 'Mysterious Ancient Tablet', '', 'old_tablet', 32.00, 46.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5891, 31553, 'Pierce', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 70, 'male', 'L2NpcFriend', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 135, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5892, 31554, 'Kahman', '', 'e_fighterguild_teacher_MOrc', 8.00, 28.50, 70, 'male', 'L2NpcFriend', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 161, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5893, 31555, 'Abercrombie', '', 'e_collector_teacher_MDwarf', 8.00, 17.50, 70, 'male', 'L2NpcFriend', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5894, 31556, 'Selina', '', 'a_traderC_Fhuman', 8.00, 22.50, 70, 'female', 'L2NpcFriend', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 189, 659, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5895, 31557, 'Mercenary Sentry', '', 'a_royal_guardB_MHuman', 7.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 298, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5896, 31558, 'Ketras Holy Altar', '', 'orcish_totem', 25.00, 47.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5897, 31559, 'Box of Asefa', '', 'coffer_d', 12.00, 9.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5898, 31560, 'Varkas Holy Altar', '', 'silenos_totem', 28.00, 55.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5899, 31561, 'Udan Marduis Box', '', 'coffer_b', 12.00, 9.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5900, 31562, 'Klufe', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5901, 31563, 'Perelin', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5902, 31564, 'Mishini', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5903, 31565, 'Ogord', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5904, 31566, 'Ropfi', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5905, 31567, 'Bleaker', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5906, 31568, 'Pamfus', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5907, 31569, 'Cyano', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5908, 31570, 'Lanosco', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5909, 31571, 'Hufs', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5910, 31572, 'OFulle', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5911, 31573, 'Monakan', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5912, 31574, 'Willie', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5913, 31575, 'Litulon', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5914, 31576, 'Berix', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5915, 31577, 'Linnaeus', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5916, 31578, 'Hilgendorf', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5917, 31579, 'Klaus', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5918, 31580, 'Galadrid', '', 'a_fighterguild_teacher_MDarkElf', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 132, 110, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5919, 31581, 'Anastia', '', 'a_clergyman_FDarkElf', 8.00, 25.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 202, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5920, 31582, 'Mordred', '', 'vampire_soldier', 8.00, 23.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 84, 634, 0, 60, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5921, 31583, 'Feynn', '', 'a_smith_MDwarf', 7.00, 16.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 168, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5922, 31584, 'Valentine', '', 'e_traderB_MDwarf', 8.00, 17.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5923, 31585, 'Sparky the Cat', '', 'cat_the_cat', 9.00, 16.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5924, 31586, 'Sparky the Cat', '', 'cat_the_cat', 9.00, 16.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5925, 31587, 'Gedrik', '', 'e_traderB_master_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5926, 31588, 'Agnes', '', 'a_teleporter_FElf', 8.50, 23.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5927, 31589, 'Duda-Mara Totem Spirit ', '', 'giant_spider', 26.00, 25.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 72, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5928, 31590, 'Truth Scholar Devianne', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 192, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5929, 31591, 'Sunset Guide Luna', '', 'a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 189, 633, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5930, 31592, 'Telson', '', 'e_mine_master_MDwarf', 8.00, 19.70, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5931, 31593, 'Dorothy', '', 'mechanic_golem', 5.00, 19.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5932, 31594, 'Mond', '', 'e_celebrant_MDwarf', 8.00, 19.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5933, 31595, 'Leona Blackbird', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 79, 110, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5934, 31596, 'Tobald', '', 'e_guard_MDwarf', 8.00, 19.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 187, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5935, 31597, 'Tobald', '', 'e_guard_MDwarf', 8.00, 19.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 187, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5936, 31598, 'Medina Blackheart', '', 'a_trader_Fdarkelf', 8.00, 24.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 206, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5937, 31599, 'Disgraced Knight Waldstein', '', 'a_fighterguild_master_Mhuman', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 81, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5938, 31600, 'Pamela Aprodia', '', 'a_casino_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 151, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5939, 31601, 'Pamela Aprodia', '', 'a_guard_FDarkelf', 7.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 151, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5940, 31602, 'Sharona Artemia', '', 'a_clergyman_FDarkElf', 8.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 232, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5941, 31603, 'Black Cat', '', 'a_common_people_FDarkElf', 8.00, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 227, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5942, 31604, 'Grimst', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5943, 31605, 'Kinsley', '', 'a_mageguild_master_MHuman', 8.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 212, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5944, 31606, 'Alice de Catrina', '', 'queen_of_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 26, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5945, 31607, 'Sake Dun Zu Hestui', '', 'e_guard_MOrc', 8.00, 27.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 298, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5946, 31608, 'Belinda', '', 'a_mageguild_teacher_FElf', 7.00, 21.20, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5947, 31609, 'Aurora the Unicorn', '', 'unicorn_boxer', 11.00, 18.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 27, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5948, 31610, 'Shiken Gloomdrake', '', 'a_common_people_MDarkElf', 7.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 80, 633, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5949, 31611, 'Scryde Heartseeker', '', 'a_common_people_MDarkElf', 7.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 81, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5950, 31612, 'Eternity Wanderer Staris', '', 'a_trader_MElf', 6.00, 24.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 150, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5951, 31613, 'Noctisse', '', 'a_clergyman_FDarkElf', 8.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 204, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5952, 31614, 'Radyss', '', 'a_patriarch_MElf', 8.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5953, 31615, 'Hermit', '', 'a_common_peopleC_Mhuman', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5954, 31616, 'Hermit', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5955, 31617, 'Aria Firstmatter', '', 'a_guard_FDarkelf', 7.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 236, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5956, 31618, 'Moon Voice Irene', '', 'a_common_people_FElf', 7.00, 25.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 130, 109, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5957, 31619, 'Erica Ken Weber', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 236, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5958, 31620, 'Verdure Elder Elikia', '', 'a_patriarch_MElf', 8.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 189, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5959, 31621, 'Abyss Saint Elcardia', '', 'a_guard_FDarkelf', 7.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 206, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5960, 31622, 'Keats', '', 'poison_toad', 20.00, 10.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5961, 31623, 'Bavarin', '', 'e_bath_MDwarf', 6.00, 16.30, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5962, 31624, 'Donath', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5963, 31625, 'Yeti', '', 'yeti_cute', 5.00, 10.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 5129, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5964, 31626, 'Duncan', '', 'a_smith_MDwarf', 7.00, 16.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 5129, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5965, 31627, 'Mist', '', 'e_bath_MDwarf', 6.00, 16.30, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5966, 31628, 'Lilly', '', 'e_traderA_FDwarf', 7.00, 18.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5967, 31629, 'Kaleidos the Unicorn', '', 'blue_eye', 11.00, 16.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5968, 31630, 'Kaleidos the Unicorn', '', 'blue_eye', 11.00, 16.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5969, 31631, 'Eric Ramsheart', '', 'a_fighterguild_master_Mhuman', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 79, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5970, 31632, 'Mysterious Servitor', '', 'shadeless', 7.00, 28.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5971, 31633, 'Winter Hunter Kadyth', '', 'a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 285, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5972, 31634, 'Winter Hunter Kadyth', '', 'a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 285, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5973, 31635, 'Winter Hunter Kadyth', '', 'a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 285, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5974, 31636, 'Flame Successor Akkan', '', 'e_guard_MOrc', 8.00, 27.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 305, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5975, 31637, 'Khavatari Kashu', '', 'e_guard_MOrc', 8.00, 27.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 267, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5976, 31638, 'Starling Knight Kastien', '', 'a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 142, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5977, 31639, 'Kain Van Halter', '', 'a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 2626, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5978, 31640, 'Pilgrim of Darkness', '', 'a_hardins_pupil_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 318, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5979, 31641, 'Pilgrim of Darkness', '', 'a_hardins_pupil_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 318, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5980, 31642, 'Tarkai Zu Duda-Mara', '', 'e_guard_MOrc', 8.00, 27.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 210, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5981, 31643, 'Silver Feyshar', '', 'a_patriarch_MElf', 8.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 148, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5982, 31644, 'Dawn Witness Franz', '', 'a_sanctuary_master_MHuman', 8.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 205, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5983, 31645, 'Hindemith Truevoice', '', 'a_traderD_Mhuman', 8.00, 21.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 195, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5984, 31646, 'Tablet of Vision', '', 'codex_stone', 7.00, 24.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5985, 31647, 'Tablet of Vision', '', 'codex_stone', 7.00, 24.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5986, 31648, 'Tablet of Vision', '', 'codex_stone', 7.00, 24.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5987, 31649, 'Tablet of Vision', '', 'codex_stone', 7.00, 24.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5988, 31650, 'Tablet of Vision', '', 'codex_stone', 7.00, 24.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5989, 31651, 'Tablet of Vision', '', 'codex_stone', 7.00, 24.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5990, 31652, 'Tablet of Vision', '', 'codex_stone', 7.00, 24.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5991, 31653, 'Tablet of Vision', '', 'codex_stone', 7.00, 24.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5992, 31654, 'Tablet of Vision', '', 'codex_stone', 7.00, 24.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5993, 31655, 'Tablet of Vision', '', 'codex_stone', 7.00, 24.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5994, 31656, 'Tablet of Vision', '', 'codex_stone', 7.00, 24.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5995, 31657, 'Tablet of Vision', '', 'codex_stone', 7.00, 24.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5996, 31658, 'Tablet of Vision', '', 'codex_stone', 7.00, 24.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5997, 31659, 'Tablet of Vision', '', 'codex_stone', 7.00, 24.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (5998, 31660, 'Tablet of Vision', '', 'codex_stone', 7.00, 24.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (5999, 31661, 'Forgotten Monument', '', 'old_tablet', 32.00, 46.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6000, 31662, 'Forgotten Monument', '', 'old_tablet', 32.00, 46.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6001, 31663, 'Forgotten Monument', '', 'old_tablet', 32.00, 46.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6002, 31664, 'Forgotten Monument', '', 'old_tablet', 32.00, 46.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6003, 31665, 'Corpse of Dwarf', '', 'e_guard_MDwarf_death', 13.00, 19.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6004, 31666, 'Lumen', '', 'a_traderD_Mhuman', 8.00, 21.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6005, 31667, 'Raik', '', 'e_trader_MOrc', 8.00, 23.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6006, 31668, 'Tangen', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6007, 31669, 'Onyx', '', 'e_mine_teacher_MDwarf', 8.00, 18.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6008, 31670, 'Burns', '', 'a_traderD_Mhuman', 8.00, 21.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6009, 31671, 'Patrol', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6010, 31672, 'Patrol', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 94, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6011, 31673, 'Patrol', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 275, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6012, 31674, 'Patrol', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 94, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6013, 31675, 'Viktor Van Deik', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 70, 'male', 'L2Guard', 'Guard', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 128, 632, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6014, 31676, 'Gregory Athebaldt', '', 'a_fighterguild_master_Mhuman', 8.00, 23.50, 70, 'male', 'L2Guard', 'Guard', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 70, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6015, 31677, 'Border Patrol', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 94, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6016, 31678, 'Border Patrol', '', 'a_guard_MHuman', 8.00, 24.00, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 94, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6017, 31679, 'Eustace Van Essen', '', 'a_fighterguild_master_Mhuman', 8.00, 23.50, 70, 'male', 'L2Guard', 'Guard', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 70, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6018, 31680, 'Fleming Van Issen', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 70, 'male', 'L2Guard', 'Guard', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 128, 632, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6019, 31681, 'Frontier Guard', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 94, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6020, 31682, 'Frontier Guard', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 94, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6021, 31683, 'Eye of Argos', '', 'argos_eye', 205.00, 305.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6022, 31684, 'Eye of Udan Mardui', '', 'mana_vampire', 11.00, 20.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 90, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6023, 31685, 'Asefas Eye', '', 'magical_weaver', 11.00, 20.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 90, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6024, 31686, 'Gatekeeper of Fire Dragon', '', 'skeleton_knight', 10.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 84, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6025, 31687, 'Gatekeeper of Fire Dragon', '', 'skeleton_knight', 10.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 84, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6026, 31688, 'Grand Olympiad Manager', '', 'a_fighterguild_master_Mhuman', 8.00, 23.50, 70, 'male', 'L2OlympiadManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 70, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6027, 31689, 'Olympiad Finisher', '', 'a_fighterguild_master_Mhuman', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 70, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6028, 31690, 'Monument of Heroes ', '', 'heroes_obelisk_human', 24.00, 69.00, 70, 'etc', 'L2OlympiadManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6029, 31691, 'Training Dummy', '', 'training_doll', 9.00, 22.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6030, 31692, 'Priest of Dawn', '', 'priest_of_dawn', 8.00, 30.50, 70, 'male', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 5802, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6031, 31693, 'Priest of Dusk', '', 'priest_of_dusk', 8.00, 22.00, 70, 'female', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 5801, 0, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6032, 31694, 'Priest of Dawn', '', 'priest_of_dawn', 8.00, 30.50, 70, 'male', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 5802, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6033, 31695, 'Priest of Dusk', '', 'priest_of_dusk', 8.00, 22.00, 70, 'female', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 5801, 0, 0, 50, 120, '', 300, 0, 20, 148, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6034, 31696, 'Platis', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6035, 31697, 'Eindarkner', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6036, 31698, 'Arisha', '', 'e_teleporter_Fhuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6037, 31699, 'Stanislava', '', 'e_teleporter_Fhuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6038, 31700, 'Saints Follower', '', 'e_warehouse_keeper_FDwarf', 7.00, 18.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6039, 31701, 'Saints Follower', '', 'a_common_people_MElf', 6.00, 21.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6040, 31702, 'Saints Follower', '', 'e_common_people_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6041, 31703, 'Saints Follower', '', 'a_common_peopleC_Fhuman', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6042, 31704, 'Saints Follower', '', 'a_common_peopleA_FHuman', 8.00, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6043, 31705, 'Daimon the White-Eyed', '', 'hundred_eye', 21.00, 55.00, 70, 'male', 'L2Npc', 'DaimonTheWhiteEyed', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6044, 31706, 'Miki the Cat', '', 'cat_the_cat', 9.00, 16.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6045, 31707, 'Ketra Van Grunt', '', 'ketra_orc_chieftain', 11.00, 38.50, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 6719, 0, 0, 24, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.51, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (6046, 31708, 'Ketra Van Shaman', '', 'ketra_orc_shaman', 10.00, 23.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 92, 0, 0, 10, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (6047, 31709, 'Ketra Van Captain ', '', 'ketra_orc_warlord', 12.00, 30.00, 70, 'male', 'L2Monster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 80, 0, 0, 27, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'SOUL', 1, 0);
INSERT INTO `npc` VALUES (6048, 31710, 'Ketra Van Commander', '', 'barka_silenos_chieftain', 18.00, 42.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 2500, 0, 0, 25, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6049, 31711, 'Ketra Van Shaman', '', 'barka_silenos_shaman', 14.00, 39.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 6716, 0, 0, 36, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6050, 31712, 'Varka Raider', '', 'barka_silenos_warrior', 16.00, 41.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 142, 0, 0, 34, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6051, 31713, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6052, 31714, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6053, 31715, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6054, 31716, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6055, 31717, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6056, 31718, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6057, 31719, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6058, 31720, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6059, 31721, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6060, 31722, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6061, 31723, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6062, 31724, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6063, 31725, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6064, 31726, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6065, 31727, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6066, 31728, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6067, 31729, 'Adventurer Guildsman', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 156, 20, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6068, 31730, 'Adventurer Guildsman', '', 'a_common_people_MElf', 6.00, 21.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 130, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6069, 31731, 'Adventurer Guildsman', '', 'a_fighterguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 224, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6070, 31732, 'Adventurer Guildsman', '', 'e_common_people_MOrc', 8.00, 26.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6071, 31733, 'Adventurer Guildsman', '', 'e_collector_teacher_FDwarf', 8.00, 17.50, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6072, 31734, 'Adventurer Guildsman', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 129, 102, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6073, 31735, 'Adventurer Guildsman', '', 'a_fighterguild_teacher_FElf', 8.00, 22.50, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 231, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6074, 31736, 'Adventurer Guildsman', '', 'a_trader_MDarkElf', 8.00, 22.50, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 151, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6075, 31737, 'Adventurer Guildsman', '', 'e_trader_FOrc', 8.00, 24.00, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 99, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6076, 31738, 'Adventurer Guildsman', '', 'e_common_people_MDwarf', 8.00, 17.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 99, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6077, 31739, 'Talien', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 4202, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6078, 31740, 'Caradine', '', 'a_mageguild_teacher_FElf', 7.00, 21.20, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 285, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6079, 31741, 'Ossian', '', 'a_common_peopleC_Mhuman', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 129, 102, 0, 50, 120, '', 300, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6080, 31742, 'Virgil', '', 'e_common_people_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6081, 31743, 'Kassandra', '', 'e_warehouse_keeper_FDwarf', 7.00, 18.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6082, 31744, 'Ogmar', '', 'e_common_people_MOrc', 8.00, 26.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6083, 31745, 'Lady of the Lake', '', 'a_teleporter_FElf', 8.50, 23.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6084, 31746, 'Fallen Unicorn', '', 'death_unicorn', 14.00, 30.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 46, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6085, 31747, 'Pure White Unicorn', '', 'unicorn', 14.00, 30.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 46, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.74, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6086, 31748, 'Cornerstone of Restraining', '', 'grave_keeper', 8.00, 21.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6087, 31750, 'Mysterious Woman', '', 'a_teleporter_FElf', 8.50, 23.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6088, 31751, 'Mysterious Dark Knight', '', 'death_lord', 21.00, 40.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 78, 0, 0, 40, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6089, 31752, 'Corpse of Angel', '', 'angel_death', 25.00, 36.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6090, 31755, 'Halaster', '', 'a_mageguild_master_MHuman', 8.00, 24.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6091, 31756, 'Mr. Cat', '', 'cat_the_cat', 9.00, 16.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6092, 31757, 'Miss Queen', '', 'queen_of_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 26, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6093, 31758, 'Rafi', '', 'hatchling', 9.00, 10.00, 70, 'male', 'L2Trainer', 'RndWalkAndAnim', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.27, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6094, 31759, 'Teleportation Cubic', '', 'teleport_npc', 40.00, 80.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6095, 31760, 'Miss Queen', '', 'queen_of_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 26, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6096, 31761, 'Miss Queen', '', 'queen_of_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 26, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6097, 31762, 'Miss Queen', '', 'queen_of_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 26, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6098, 31763, 'Miss Queen', '', 'queen_of_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 26, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6099, 31764, 'Miss Queen', '', 'queen_of_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 26, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6100, 31765, 'Miss Queen', '', 'queen_of_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 26, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6101, 31766, 'Miss Queen', '', 'queen_of_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 26, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6102, 31767, 'Event Gatekeeper', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6103, 31768, 'Event Gatekeeper', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6104, 31769, 'Monument of Heroes', '', 'heroes_obelisk_elf', 24.00, 77.50, 70, 'etc', 'L2OlympiadManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6105, 31770, 'Monument of Heroes', '', 'heroes_obelisk_darkelf', 25.00, 77.00, 70, 'etc', 'L2OlympiadManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6106, 31771, 'Monument of Heroes', '', 'heroes_obelisk_orc', 24.00, 72.50, 70, 'etc', 'L2OlympiadManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6107, 31772, 'Monument of Heroes', '', 'heroes_obelisk_dwarf', 23.00, 80.00, 70, 'etc', 'L2OlympiadManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6108, 31773, 'Sonin', '', 'e_warehouse_keeper_FDwarf', 7.00, 18.00, 70, 'female', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6109, 31774, 'Beryl the Cat', '', 'queen_of_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 26, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6110, 31775, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 129, 102, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6111, 31776, 'Adventure Guildsman', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 156, 20, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6112, 31777, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 224, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6113, 31778, 'Adventure Guildsman', '', 'a_trader_MDarkElf', 8.00, 22.50, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 151, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6114, 31779, 'Adventure Guildsman', '', 'a_trader_MDarkElf', 8.00, 22.50, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 151, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6115, 31780, 'Adventure Guildsman', '', 'a_common_people_MElf', 6.00, 21.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 130, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6116, 31781, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FElf', 8.00, 22.50, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 231, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6117, 31782, 'Adventure Guildsman', '', 'a_common_peopleA_MHuman', 8.00, 17.50, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6118, 31783, 'Adventure Guildsman', '', 'e_common_people_MDwarf', 8.00, 17.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 99, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6119, 31784, 'Adventure Guildsman', '', 'e_common_people_MOrc', 8.00, 26.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6120, 31785, 'Adventure Guildsman', '', 'e_trader_FOrc', 8.00, 24.00, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 99, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6121, 31786, 'Adventure Guildsman', '', 'e_trader_FOrc', 8.00, 24.00, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 99, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6122, 31787, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 129, 102, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6123, 31788, 'Adventure Guildsman', '', 'e_common_people_MOrc', 8.00, 26.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6124, 31789, 'Adventure Guildsman', '', 'e_common_people_MDwarf', 8.00, 17.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 99, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6125, 31790, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FElf', 8.00, 22.50, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 231, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6126, 31791, 'Adventure Guildsman', '', 'a_trader_MDarkElf', 8.00, 22.50, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 151, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6127, 31792, 'Adventure Guildsman', '', 'a_common_people_MElf', 6.00, 21.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 130, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6128, 31793, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 224, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6129, 31794, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FElf', 8.00, 22.50, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 231, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6130, 31795, 'Adventure Guildsman', '', 'e_common_people_MOrc', 8.00, 26.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6131, 31796, 'Adventure Guildsman', '', 'e_collector_teacher_FDwarf', 8.00, 17.50, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6132, 31797, 'Adventure Guildsman', '', 'e_common_people_MDwarf', 8.00, 17.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 99, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6133, 31798, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 129, 102, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6134, 31799, 'Adventure Guildsman', '', 'e_common_people_MOrc', 8.00, 26.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6135, 31800, 'Adventure Guildsman', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 156, 20, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6136, 31801, 'Adventure Guildsman', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 156, 20, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6137, 31802, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 129, 102, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6138, 31803, 'Adventure Guildsman', '', 'e_common_people_MOrc', 8.00, 26.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6139, 31804, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 224, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6140, 31805, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FElf', 8.00, 22.50, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 231, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6141, 31806, 'Adventure Guildsman', '', 'a_common_people_MElf', 6.00, 21.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 130, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6142, 31807, 'Adventure Guildsman', '', 'e_common_people_MDwarf', 8.00, 17.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 99, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6143, 31808, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 129, 102, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6144, 31809, 'Adventure Guildsman', '', 'e_common_people_MOrc', 8.00, 26.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6145, 31810, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 224, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6146, 31811, 'Adventure Guildsman', '', 'a_common_people_MElf', 6.00, 21.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 130, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6147, 31812, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 224, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6148, 31813, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FElf', 8.00, 22.50, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 231, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6149, 31814, 'Adventure Guildsman', '', 'e_collector_teacher_FDwarf', 8.00, 17.50, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6150, 31815, 'Adventure Guildsman', '', 'e_common_people_MOrc', 8.00, 26.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6151, 31816, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 224, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6152, 31817, 'Adventure Guildsman', '', 'a_common_people_MElf', 6.00, 21.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 130, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6153, 31818, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 129, 102, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6154, 31819, 'Adventure Guildsman', '', 'e_collector_teacher_FDwarf', 8.00, 17.50, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6155, 31820, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FElf', 8.00, 22.50, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 231, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6156, 31821, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 224, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6157, 31822, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 129, 102, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6158, 31823, 'Adventure Guildsman', '', 'a_common_people_MElf', 6.00, 21.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 130, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6159, 31824, 'Adventure Guildsman', '', 'e_collector_teacher_FDwarf', 8.00, 17.50, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6160, 31825, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 224, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6161, 31826, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FElf', 8.00, 22.50, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 231, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6162, 31827, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FElf', 8.00, 22.50, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 231, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6163, 31828, 'Adventure Guildsman', '', 'a_common_people_MElf', 6.00, 21.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 130, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6164, 31829, 'Adventure Guildsman', '', 'a_trader_MDarkElf', 8.00, 22.50, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 151, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6165, 31830, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 224, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6166, 31831, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 129, 102, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6167, 31832, 'Adventure Guildsman', '', 'e_common_people_MOrc', 8.00, 26.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6168, 31833, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FElf', 8.00, 22.50, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 231, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6169, 31834, 'Adventure Guildsman', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 156, 20, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6170, 31835, 'Adventure Guildsman', '', 'e_collector_teacher_FDwarf', 8.00, 17.50, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6171, 31836, 'Adventure Guildsman', '', 'a_common_people_MElf', 6.00, 21.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 130, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6172, 31837, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 224, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6173, 31838, 'Adventure Guildsman', '', 'e_common_people_MDwarf', 8.00, 17.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 99, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6174, 31839, 'Adventure Guildsman', '', 'a_common_people_MElf', 6.00, 21.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 130, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6175, 31840, 'Adventure Guildsman', '', 'e_common_people_MOrc', 8.00, 26.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6176, 31841, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 129, 102, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6177, 31842, 'Teleportation Cubic', '', 'teleport_cube', 40.00, 80.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 1, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6178, 31843, 'Teleportation Cubic', '', 'teleport_cube', 40.00, 80.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 490, 1, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6179, 31844, 'Aracna', '', 'aracne', 15.00, 26.00, 50, 'female', 'L2Monster', 'Fighter', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 3000, 226, 425, 278, 291, 204, 253, 0, 506, 0, 0, 0, 64, 120, 'all_elemental_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6180, 31845, 'Bloody Pixy', '', 'pixy', 5.00, 25.00, 80, 'female', 'L2Guard', 'GuardRndWalkAndAnim', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 7680, 226, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 80, 120, 'all_elemental2_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6181, 31846, 'Satyros', '', 'pan', 14.00, 35.00, 80, 'male', 'L2Monster', 'Fighter', 80, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 7680, 226, 1641, 576, 1120, 423, 253, 0, 506, 291, 0, 0, 45, 110, 'all_elemental2_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.58, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6182, 31847, 'Pan', '', 'pan', 14.00, 35.00, 80, 'male', 'L2Monster', 'Fighter', 80, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 7680, 226, 1641, 576, 1120, 423, 253, 0, 506, 291, 0, 0, 45, 110, 'all_elemental_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.58, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6183, 31848, 'Pixy', '', 'pixy', 5.00, 25.00, 80, 'female', 'L2Guard', 'GuardRndWalkAndAnim', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 7680, 226, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 120, 'all_elemental_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6184, 31849, 'Red Arachne', '', 'aracne', 15.00, 26.00, 80, 'female', 'L2Monster', 'Fighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 7680, 226, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 64, 120, 'all_elemental2_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6185, 31850, 'Blight Treant', '', 'ti_mi_riran', 23.00, 90.00, 80, 'male', 'L2Guard', 'GuardRndWalkAndAnim', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 7680, 226, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 12, 12, 'all_elemental2_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6186, 31851, 'Treant', '', 'ti_mi_tran', 23.00, 90.00, 80, 'male', 'L2Guard', 'GuardRndWalkAndAnim', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 7680, 226, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 12, 12, 'all_elemental_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6187, 31852, 'Pixy Murika', '', 'pixy', 5.00, 25.00, 50, 'female', 'L2Guard', 'GuardRndWalkAndAnim', 40, 1421, 5.500, 748, 2.100, 40, 43, 30, 21, 20, 20, 3000, 226, 425, 278, 291, 204, 253, 0, 506, 0, 0, 0, 80, 120, 'all_elemental_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6188, 31853, 'Treant Bremec', '', 'ti_mi_tran', 23.00, 90.00, 80, 'male', 'L2Guard', 'GuardRndWalkAndAnim', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 7680, 226, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 12, 12, 'all_elemental_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6189, 31854, 'Event Manager', '', 'a_traderB_MHuman', 8.00, 20.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6190, 31855, 'Event Manager', '', 'a_trader_FElf', 8.00, 24.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6191, 31856, 'Event Manager', '', 'a_clergyman_FDarkElf', 8.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6192, 31857, 'Event Manager', '', 'e_traderA_FDwarf', 7.00, 18.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6193, 31858, 'Event Manager', '', 'e_trader_FOrc', 8.00, 24.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6194, 31859, 'Teleportation Cubic', '', 'teleport_cube', 40.00, 80.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 490, 1, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6195, 31860, 'Buzz the Cat', '', 'cat_the_cat', 9.00, 16.00, 70, 'male', 'L2ClassMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6196, 31861, 'Gatekeeper', '', 'a_teleporter_FHuman', 8.00, 25.00, 56, 'female', 'L2CastleTeleporter', 'npc', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 314, 10, 589, 331, 402, 242, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6197, 31862, 'Angelic Vortex', '', 'alive_castle_aden_controltower_jewel', 7.00, 35.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6198, 31863, 'Santa Trainee', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6199, 31864, 'Santa Trainee', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 490, 10, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6200, 31865, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 35, 'etc', 'L2Npc', 'npc', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 160, 170, 109, 124, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6201, 31866, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 35, 'etc', 'L2Npc', 'npc', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 160, 170, 109, 124, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6202, 31867, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 35, 'etc', 'L2Npc', 'npc', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 160, 170, 109, 124, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6203, 31868, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 35, 'etc', 'L2Npc', 'npc', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 160, 170, 109, 124, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6204, 31869, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 35, 'etc', 'L2Npc', 'npc', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 160, 170, 109, 124, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6205, 31870, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 35, 'etc', 'L2Npc', 'npc', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 160, 170, 109, 124, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6206, 31871, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 35, 'etc', 'L2Npc', 'npc', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 160, 170, 109, 124, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6207, 31872, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 35, 'etc', 'L2Npc', 'npc', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 160, 170, 109, 124, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6208, 31873, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 35, 'etc', 'L2Npc', 'npc', 40, 773, 4.500, 403, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 160, 170, 109, 124, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6209, 31874, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 45, 'etc', 'L2Npc', 'npc', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 315, 239, 214, 174, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6210, 31875, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 45, 'etc', 'L2Npc', 'npc', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 315, 239, 214, 174, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6211, 31876, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 45, 'etc', 'L2Npc', 'npc', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 315, 239, 214, 174, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6212, 31877, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 45, 'etc', 'L2Npc', 'npc', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 315, 239, 214, 174, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6213, 31878, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 45, 'etc', 'L2Npc', 'npc', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 315, 239, 214, 174, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6214, 31879, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 45, 'etc', 'L2Npc', 'npc', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 315, 239, 214, 174, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6215, 31880, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 45, 'etc', 'L2Npc', 'npc', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 315, 239, 214, 174, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6216, 31881, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 45, 'etc', 'L2Npc', 'npc', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 315, 239, 214, 174, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6217, 31882, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 45, 'etc', 'L2Npc', 'npc', 40, 1184, 5.500, 611, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 315, 239, 214, 174, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6218, 31883, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 55, 'etc', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6219, 31884, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 55, 'etc', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6220, 31885, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 55, 'etc', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6221, 31886, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 55, 'etc', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6222, 31887, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 55, 'etc', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6223, 31888, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 55, 'etc', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6224, 31889, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 55, 'etc', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6225, 31890, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 55, 'etc', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6226, 31891, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 55, 'etc', 'L2Npc', 'npc', 40, 1673, 6.500, 890, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 559, 323, 382, 236, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6227, 31892, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 65, 'etc', 'L2Npc', 'npc', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 898, 419, 613, 306, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6228, 31893, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 65, 'etc', 'L2Npc', 'npc', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 898, 419, 613, 306, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6229, 31894, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 65, 'etc', 'L2Npc', 'npc', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 898, 419, 613, 306, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6230, 31895, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 65, 'etc', 'L2Npc', 'npc', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 898, 419, 613, 306, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6231, 31896, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 65, 'etc', 'L2Npc', 'npc', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 898, 419, 613, 306, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6232, 31897, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 65, 'etc', 'L2Npc', 'npc', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 898, 419, 613, 306, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6233, 31898, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 65, 'etc', 'L2Npc', 'npc', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 898, 419, 613, 306, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6234, 31899, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 65, 'etc', 'L2Npc', 'npc', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 898, 419, 613, 306, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6235, 31900, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 65, 'etc', 'L2Npc', 'npc', 40, 2193, 7.500, 1189, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 898, 419, 613, 306, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6236, 31901, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6237, 31902, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6238, 31903, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6239, 31904, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6240, 31905, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6241, 31906, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6242, 31907, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6243, 31908, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6244, 31909, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6245, 31910, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 85, 'etc', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6246, 31911, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 85, 'etc', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6247, 31912, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 85, 'etc', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6248, 31913, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 85, 'etc', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6249, 31914, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 85, 'etc', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6250, 31915, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 85, 'etc', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6251, 31916, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 85, 'etc', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6252, 31917, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 85, 'etc', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6253, 31918, 'Guardian of Border', '', 'teleport_npc_sm', 7.00, 15.00, 85, 'etc', 'L2Npc', 'npc', 40, 4234, 8.500, 1847, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2069, 630, 1413, 461, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6254, 31919, 'Ghost Chamberlain of Elmoreden', '', 'a_tombkeeperA', 8.00, 23.00, 70, 'female', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6255, 31920, 'Ghost Chamberlain of Elmoreden', '', 'a_tombkeeperA', 8.00, 23.00, 70, 'female', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6256, 31921, 'Conquerors Sepulcher Manager', '', 'grave_keeper', 8.00, 21.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6257, 31922, 'Emperors Sepulcher Manager', '', 'grave_keeper', 8.00, 21.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6258, 31923, 'Great Sages Sepulcher Manager', '', 'grave_keeper', 8.00, 21.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6259, 31924, 'Judges Sepulcher Manager', '', 'grave_keeper', 8.00, 21.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6260, 31925, 'Barons Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6261, 31926, 'Viscounts Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6262, 31927, 'Counts Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6263, 31928, 'Marquis Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6264, 31929, 'Dukes Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6265, 31930, 'Barons Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6266, 31931, 'Viscounts Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6267, 31932, 'Counts Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6268, 31933, 'Marquis Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6269, 31934, 'Dukes Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6270, 31935, 'Barons Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6271, 31936, 'Viscounts Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6272, 31937, 'Counts Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6273, 31938, 'Marquis Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6274, 31939, 'Dukes Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6275, 31940, 'Barons Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6276, 31941, 'Viscounts Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6277, 31942, 'Counts Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6278, 31943, 'Marquis Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6279, 31944, 'Dukes Hall Gatekeeper', '', 'rift_keeper_25_sm', 9.50, 29.00, 70, 'male', 'L2SepulcherNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6280, 31945, 'Auzendorff', '', 'e_traderB_MDwarf', 8.00, 17.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6281, 31946, 'Hombre', '', 'a_traderD_Mhuman', 8.00, 21.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6282, 31947, 'Owaki', '', 'e_trader_MOrc', 8.00, 23.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6283, 31948, 'Adrian', '', 'a_traderC_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6284, 31949, 'Rouge', '', 'a_traderC_Fhuman', 8.00, 22.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6285, 31950, 'Mailland', '', 'e_traderB_FDwarf', 7.00, 18.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6286, 31951, 'Jose', '', 'a_traderD_Fhuman', 8.00, 25.30, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6287, 31952, 'Pele', '', 'a_common_peopleC_Fhuman', 8.00, 22.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6288, 31953, 'Rankar', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2SymbolMaker', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6289, 31954, 'Saroyan', '', 'a_traderD_Mhuman', 8.00, 21.50, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6290, 31955, 'Ruby', '', 'baby_tiger', 11.00, 15.70, 70, 'male', 'L2Npc', 'RndWalkAndAnim', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 28, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6291, 31956, 'Rydel', '', 'e_warehouse_keeper_FDwarf', 7.00, 18.00, 70, 'female', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6292, 31957, 'Cherbal', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6293, 31958, 'Yasheni', '', 'e_warehouse_master_MDwarf', 7.00, 18.00, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6294, 31959, 'Axel', '', 'e_warehouse_master_MDwarf', 8.00, 17.50, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6295, 31960, 'Buryun', '', 'e_smith_Fdwarf', 8.00, 17.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 87, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6296, 31961, 'Newyear', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 89, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6297, 31962, 'Altair', '', 'a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6298, 31963, 'Hitchi', '', 'e_traderB_master_MDwarf', 8.00, 17.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6299, 31964, 'Bilia', '', 'a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6300, 31965, 'Hector', '', 'a_fighterguild_master_Mhuman', 8.00, 23.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 76, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6301, 31966, 'Karamon', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 125, 20, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6302, 31967, 'Euline', '', 'a_fighterguild_teacher_FElf', 8.00, 22.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 130, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6303, 31968, 'Baryl', '', 'a_temple_master_Mhuman', 8.00, 22.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 193, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6304, 31969, 'Evelyn', '', 'a_mageguild_master_FHuman', 8.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6305, 31970, 'Sinis', '', 'a_mageguild_teacher_MElf', 7.00, 22.20, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6306, 31971, 'Otillo', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6307, 31972, 'Atraxia', '', 'a_mageguild_teacher_FElf', 7.00, 21.20, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6308, 31973, 'Raheel', '', 'a_sanctuary_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6309, 31974, 'Drizzit', '', 'a_guild_master_MDarkElf', 8.00, 23.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 143, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6310, 31975, 'Aerina', '', 'a_fighterguild_teacher_MDarkElf', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 143, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6311, 31976, 'Talia', '', 'a_mageguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 204, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6312, 31977, 'Shaka', '', 'e_patriarch_MOrc', 8.00, 26.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6313, 31978, 'Tazeer', '', 'e_fighterguild_teacher_MOrc', 8.00, 28.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 161, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6314, 31979, 'Moira', '', 'e_clergyman_FOrc', 7.00, 28.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 202, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6315, 31980, 'Rumba', '', 'e_clergyman_FOrc', 7.00, 28.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6316, 31981, 'Vishotsky', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 133, 632, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6317, 31982, 'Glen', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 126, 628, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6318, 31983, 'Friggar', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 94, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6319, 31984, 'Sherring', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 126, 628, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6320, 31985, 'Kosmos', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 94, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6321, 31986, 'Erstack', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 126, 628, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6322, 31987, 'Gotter', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 94, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6323, 31988, 'Singa', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Guard', 'Guard', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 126, 628, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6324, 31989, 'Batidae', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6325, 31990, 'Siger', '', 'a_smith_MDwarf', 7.00, 16.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6326, 31991, 'Adventure Guildsman', '', 'e_collector_teacher_FDwarf', 8.00, 17.50, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6327, 31992, 'Adventure Guildsman', '', 'a_fighterguild_teacher_FHuman', 9.50, 22.40, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 129, 102, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6328, 31993, 'Adventure Guildsman', '', 'e_common_people_MDwarf', 8.00, 17.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 99, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6329, 31994, 'Adventure Guildsman', '', 'e_common_people_MOrc', 8.00, 26.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6330, 31995, 'Adventure Guildsman', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 156, 20, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6331, 31996, 'Javier', '', 'a_mageguild_master_MHuman', 8.00, 24.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6332, 31997, 'Priest of Dawn', '', 'priest_of_dawn', 8.00, 30.50, 70, 'male', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 5802, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6333, 31998, 'Dusk Priestess', '', 'priest_of_dusk', 8.00, 22.00, 70, 'female', 'L2SignsPriest', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 5801, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6334, 31999, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6335, 32000, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6336, 32001, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6337, 32002, 'Preacher of Doom', '', 'dark_horror', 20.00, 35.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 100, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6338, 32003, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6339, 32004, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6340, 32005, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6341, 32006, 'Orator of Revelations', '', 'liviona', 15.00, 28.00, 70, 'male', 'L2CabaleBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6342, 32007, 'Galba', '', 'a_fisherA_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6343, 32008, 'Greymore', '', 'a_temple_master_Mhuman', 8.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6344, 32009, 'Devorin', '', 'e_common_people_FDwarf', 7.00, 17.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6345, 32010, 'Flauron', '', 'a_temple_master_Mhuman', 8.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6346, 32011, 'Imperial Tomb Guide', '', 'a_tombkeeperA', 8.00, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6347, 32012, 'Tantan', '', 'a_old_people_Mhuman', 9.00, 17.30, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 6, 32, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6348, 32013, 'Suki', '', 'a_common_peopleB_FHuman', 8.00, 20.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6349, 32014, 'Ivan ', '', 'a_traderD_Mhuman', 8.00, 21.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6350, 32015, 'Scouts Corpse', '', 'e_guard_MDwarf_death', 13.00, 19.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6351, 32016, 'Torrant', '', 'e_guard_MOrc', 8.00, 27.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 95, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6352, 32017, 'Karuda', '', 'e_guard_MOrc', 8.00, 27.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 93, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6353, 32018, 'Misa', '', 'a_maidB_FHuman', 8.00, 22.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6354, 32019, 'Suspicious Man', '', 'a_sanctuary_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6355, 32020, 'Rafforty', '', 'a_common_peopleC_Mhuman', 10.00, 24.00, 70, 'male', 'Rafforty', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6356, 32021, 'Ice Sculpture', '', 'ice_sculpture_c', 16.00, 20.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6357, 32022, 'Kier', '', 'ice_sculpture_b', 12.00, 24.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6358, 32023, 'Ice Shelf', '', 'ice_shelf', 35.00, 14.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6359, 32024, 'Mulia', '', 'e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2ClanTrader', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6360, 32025, 'Ilia', '', 'e_smith_Fdwarf', 8.00, 17.50, 70, 'female', 'L2ClanTrader', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6361, 32026, 'Hestui Guard', '', 'e_fighterguild_teacher_MOrc', 8.00, 28.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6362, 32027, 'Holy Brazier', '', 'grail_brazier_b', 30.00, 31.00, 78, 'etc', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6363, 32028, 'Holy Grail', '', 'holy_grail', 6.20, 7.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6364, 32029, 'Freyas Steward', '', 'a_common_people_MElf', 6.00, 21.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6365, 32030, 'Garden Sculpture', '', 'ice_sculpture_c', 16.00, 20.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, 'ice_clan', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6366, 32031, 'Ice Fairy Sculpture', '', 'ice_sculpture_b', 12.00, 24.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, 'ice_clan', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6367, 32032, 'Strange Machine', '', 'strange_mechanical_instrument', 16.00, 15.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6368, 32033, 'Doctor Chaos', '', 'doctor_chaos', 9.00, 15.60, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6369, 32034, 'Temple Gatekeeper', '', 'heretical_sanctuary_gatekeeper_a', 80.00, 181.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6370, 32035, 'Temple Gatekeeper', '', 'heretical_sanctuary_openner_a', 28.00, 70.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6371, 32036, 'Temple Gatekeeper', '', 'heretical_sanctuary_gatekeeper_b', 80.00, 203.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6372, 32037, 'Temple Gatekeeper', '', 'heretical_sanctuary_openner_b', 28.00, 70.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6373, 32038, 'Ritual Offering', '', 'a_traderA_Mhuman_deco', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6374, 32039, 'Triols Mirror', '', 'heretical_devil_mirror', 28.00, 70.00, 70, 'etc', 'L2TriolsMirror', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6375, 32040, 'Triols Mirror', '', 'heretical_devil_mirror', 28.00, 70.00, 70, 'etc', 'L2TriolsMirror', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6376, 32041, 'Yumi', '', 'e_collector_teacher_FDwarf', 8.00, 17.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6377, 32042, 'Weathermaster', '', 'pavel_weather_controller', 14.50, 18.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6378, 32043, 'Weathermaster', '', 'pavel_weather_controller', 14.50, 18.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6379, 32044, 'Weathermaster', '', 'Evilate_weather', 16.00, 18.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 10, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6380, 32045, 'Doctor Chaos Secret Bookshelf', '', 'Evilate_doc_chaos', 25.00, 33.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 10, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6381, 32046, 'Suspicious-Looking Pile of Stones', '', 'susceptor_env', 20.00, 35.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 27, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6382, 32047, 'Wendy', '', 'e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6383, 32048, 'Event Gatekeeper', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6384, 32049, 'Rooney', '', 'a_smith_MDwarf', 7.00, 16.50, 70, 'male', 'L2Npc', 'Rooney', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6385, 32050, 'Parts Box', '', 'box', 18.00, 14.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6386, 32051, 'Altar Gatekeeper', '', 'trioll_altar', 9.00, 33.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6387, 32052, 'Obi', '', 'e_mine_teacher_MDwarf', 8.00, 18.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6388, 32053, 'Abey', '', 'e_mine_teacher_FDwarf', 8.00, 18.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6389, 32054, 'Ghost of a Railroad Engineer', '', 'dwarf_ghost', 9.00, 16.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6390, 32055, 'Ghost of an Ancient Railroad Engineer', '', 'dwarf_ghost', 9.00, 16.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6391, 32056, 'Aren', '', 'e_mageguild_teacher_FOrc', 8.00, 28.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6392, 32057, 'Totem Spirit of Gandi', '', 'onyx_beast', 14.00, 14.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 30, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6393, 32058, 'Triols Revelation', '', 'trioll_altar', 9.00, 33.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, 'trioll_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6394, 32059, 'Triols Revelation', '', 'trioll_altar', 9.00, 33.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, 'trioll_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6395, 32060, 'Triols Revelation', '', 'trioll_altar', 9.00, 33.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, 'trioll_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6396, 32061, 'Triols Revelation', '', 'trioll_altar', 9.00, 33.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, 'trioll_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6397, 32062, 'Triols Revelation', '', 'trioll_altar', 9.00, 33.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, 'trioll_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6398, 32063, 'Triols Revelation', '', 'trioll_altar', 9.00, 33.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, 'trioll_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6399, 32064, 'Triols Revelation', '', 'trioll_altar', 9.00, 33.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, 'trioll_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6400, 32065, 'Triols Revelation', '', 'trioll_altar', 9.00, 33.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, 'trioll_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6401, 32066, 'Triols Revelation', '', 'trioll_altar', 9.00, 33.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, 'trioll_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6402, 32067, 'Triols Revelation', '', 'trioll_altar', 9.00, 33.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, 'trioll_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6403, 32068, 'Triols Revelation', '', 'trioll_altar', 9.00, 33.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, 'andreas_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6404, 32069, 'Gutenhagen', '', 'e_guard_MDwarf', 8.00, 19.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6405, 32070, 'Adolph', '', 'a_child_people_Mhuman', 5.00, 12.30, 70, 'male', 'L2Npc', 'EdwinFollower', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 26, 45, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6406, 32071, 'Linda', '', 'a_child_people_Fhuman', 5.00, 12.30, 70, 'female', 'L2Npc', 'EdwinFollower', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 24, 50, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6407, 32072, 'Edwin', '', 'a_old_people_Mhuman', 9.00, 17.30, 70, 'male', 'L2Npc', 'Edwin', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 6, 32, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6408, 32073, 'Old Female Drifter', '', 'a_old_people_Fhuman', 9.00, 17.30, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 9, 34, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6409, 32074, 'Gludio Territory Manager', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6410, 32075, 'Sandy the Cat', '', 'queen_of_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 26, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6411, 32076, 'Box', '', 'box', 18.00, 14.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6412, 32077, 'Ice Sculpture', '', 'ice_sculpture_c', 16.00, 20.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6413, 32078, 'Ice Sculpture', '', 'ice_sculpture_c', 16.00, 20.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6414, 32079, 'Ice Sculpture', '', 'ice_sculpture_c', 16.00, 20.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6415, 32082, 'Dion Territory Manager', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6416, 32083, 'Giran Territory Manager', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6417, 32084, 'Oren Territory Manager', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6418, 32085, 'Aden Territory Manager', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6419, 32086, 'Innadril Territory Manager', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6420, 32087, 'Schuttgart Territory Manager', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6421, 32088, 'Goddard Territory Manager', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6422, 32089, 'Rune Territory Manager', '', 'a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6423, 32090, 'Dead Leopards Carcass', '', 'onyx_beast_ns', 14.00, 14.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 30, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.24, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6424, 32091, 'Omegas Cat', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6425, 32092, 'Alder', '', 'e_warehouse_master_MDwarf', 8.00, 17.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6426, 32093, 'Bolin', '', 'e_common_people_MDwarf', 8.00, 17.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6427, 32094, 'Schule', '', 'a_fighterguild_master_FHuman', 8.00, 21.50, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 76, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6428, 32095, 'Marie', '', 'a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 193, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6429, 32096, 'Helminter', '', 'a_fighterguild_teacher_FDarkElf', 8.00, 23.00, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 143, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6430, 32097, 'Finker', '', 'e_trader_FOrc', 8.00, 24.00, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6431, 32098, 'Celes', '', 'a_mageguild_master_FHuman', 8.00, 23.00, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6432, 32099, 'Tony the Cat', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6433, 32100, 'Tony the Cat', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6434, 32101, 'Tony the Cat', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6435, 32102, 'Tony the Cat', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6436, 32103, 'Telling the Cat', '', 'cutie_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6437, 32104, 'Vervato', '', 'Crokian_Sorcerer', 25.00, 33.00, 70, 'male', 'L2Npc', 'Mystic', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6438, 32105, 'Dinn', '', 'a_traderC_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6439, 32106, 'Singsing', '', 'a_wharfinger_MHuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6440, 32107, 'Teleportation Cubic', '', 'teleport_npc', 40.00, 80.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6441, 32108, '', '', 'rhamphorhynchus_npc', 1.00, 800.00, 70, 'male', 'L2Npc', 'Pterosaur', 40, 3862, 8.400, 1494, 2.970, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 88, 132, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6442, 32109, 'Shilens Stone Statue', '', 'primeval_raid_teleporter', 24.00, 72.50, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6443, 32110, 'sailren_dummy', '', 'clear_npc', 0.10, 0.10, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6444, 32111, 'Orahochin', '', 'Crokian_Sorcerer', 25.00, 33.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8217, 0, 0, 60, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6445, 32112, 'Gariachin', '', 'Crokian_Sorcerer', 25.00, 33.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6446, 32113, 'Marquez', '', 'a_wharfinger_MHuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6447, 32114, 'Mushika', '', 'Crokian_Elder', 30.00, 42.51, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6448, 32115, 'Asamah', '', 'Crokian_Vice_Elder', 45.00, 41.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6449, 32116, 'Kirikachin', '', 'Crokian_Vice_Elder', 45.00, 41.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6450, 32117, 'Karakawei', '', 'Crokian_Sorcerer', 25.00, 33.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6451, 32118, 'Mantarasa Egg', '', 'dinosaur_nest', 53.00, 11.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6452, 32119, 'Ulu Kaimu', '', 'Evilate_doc_chaos', 25.00, 33.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 10, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6453, 32120, 'Balu Kaimu', '', 'Evilate_doc_chaos', 25.00, 33.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 10, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6454, 32121, 'Chuta Kaimu', '', 'Evilate_doc_chaos', 25.00, 33.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 10, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6455, 32122, 'Warriors Grave', '', 'Evilate_weather', 16.00, 18.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 10, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6456, 32123, 'Valakas', '', 'valakas_f', 190.00, 335.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 120, 290, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6457, 32124, 'Great Soul', '', 'Soul_Collector_Npc', 14.00, 25.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6458, 32125, 'Great Soul', '', 'Soul_Collector_Npc', 14.00, 25.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6459, 32126, 'Priest Guard', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 1100, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7824, 0, 0, 50, 140, '', 0, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6460, 32127, 'Priest Guard', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 1100, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7824, 0, 0, 50, 140, '', 0, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6461, 32128, 'Guardian Wizard of the Cloth', '', 'a_traderB_FHuman', 8.00, 24.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 4900, 0, 0, 50, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6462, 32129, 'valakas_skill_deco', '', 'valakas_f_dummy', 5.00, 10.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6463, 32130, 'Strategist Lucien', '', 'king_of_cat', 6.00, 16.01, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 160, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6464, 32131, 'Magic Laboratory Worker', '', 'e_smith_Fdwarf', 8.00, 17.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 313, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6465, 32132, 'Alchemists Servitor', '', 'LineageNPC.teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6466, 32133, 'Perwan', '', 'LineageNPC2.K_M1_elder', 17.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 20, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6467, 32134, 'Newbie Helper', '', 'LineageNPC2.K_F1_elder', 13.00, 22.25, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 10, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6468, 32135, 'Newbie Guide', '', 'LineageNPC2.K_M1_elder', 17.00, 25.00, 70, 'male', 'L2NewbieGuide', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 20, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6469, 32136, 'Basil', '', 'LineageNPC2.K_M1_guard', 13.00, 25.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 9645, 0, 0, 39, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6470, 32137, 'Sucrete', '', 'LineageNPC2.K_M1_guard', 13.00, 25.00, 80, 'male', 'L2Guard', 'Guard', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 9645, 0, 0, 39, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6471, 32138, 'Kekropus', '', 'LineageNPC2.K_kekrops', 18.00, 28.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 20, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6472, 32139, 'Casca', '', 'LineageNPC2.K_M1_elder', 17.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 20, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6473, 32140, 'Zenya', '', 'LineageNPC2.K_F1_elder', 13.00, 22.25, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 10, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6474, 32141, 'Nerga', '', 'LineageNPC2.K_M1_master', 15.00, 25.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 30, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6475, 32142, 'Tenor', '', 'LineageNPC2.K_M1_master', 15.00, 25.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 30, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6476, 32143, 'Belkis', '', 'LineageNPC2.K_F1_master', 12.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 24, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6477, 32144, 'Xonia', '', 'LineageNPC2.K_F1_master', 12.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 24, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6478, 32145, 'Maynard', '', 'LineageNPC2.K_F1_grand', 11.00, 22.25, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6479, 32146, 'Valpor', '', 'LineageNPC2.K_M1_grand', 13.00, 25.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9645, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6480, 32147, 'Rivian', '', 'LineageNPC.a_mageguild_teacher_FElf', 7.00, 21.20, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6481, 32148, 'Cindet', '', 'LineageNPC.a_fighterguild_teacher_MElf', 7.00, 22.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6482, 32149, 'Ennear', '', 'LineageNPC.a_fighterguild_teacher_FElf', 8.00, 22.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6483, 32150, 'Took', '', 'LineageNPC.e_patriarch_MOrc', 8.00, 26.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6484, 32151, 'Herz', '', 'LineageNPC.e_fighterguild_teacher_MOrc', 8.00, 28.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6485, 32152, 'Henri', '', 'LineageNPC.e_clergyman_FOrc', 7.00, 28.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6486, 32153, 'Prana', '', 'LineageNPC.a_temple_master_Mhuman', 8.00, 22.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6487, 32154, 'Aldenia', '', 'LineageNPC.a_fighterguild_master_FHuman', 8.00, 21.50, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6488, 32155, 'Nabot', '', 'LineageNPC.a_temple_teacher_Mhuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6489, 32156, 'Talbot', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6490, 32157, 'Moka', '', 'LineageNPC.e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6491, 32158, 'Fisler', '', 'LineageNPC.e_collector_master_MDwarf', 8.00, 18.40, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6492, 32159, 'Kincaid', '', 'LineageNPC.a_smith_MDwarf', 7.00, 16.50, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6493, 32160, 'Devon', '', 'LineageNPC.a_mageguild_teacher_MDarkElf', 8.00, 22.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6494, 32161, 'Black', '', 'LineageNPC.a_fighterguild_teacher_MDarkElf', 8.00, 23.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6495, 32162, 'Martika', '', 'LineageNPC.a_clergyman_FDarkElf', 8.00, 25.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6496, 32163, 'Ragara', '', 'LineageNPC2.K_F1_teleporter', 13.00, 23.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6497, 32164, 'Erinu', '', 'LineageNPC2.K_M1_normal', 13.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 28, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6498, 32165, 'Zakone', '', 'LineageNPC2.K_M1_normal', 13.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 28, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6499, 32166, 'Trevor', '', 'LineageNPC2.K_M1_normal', 13.00, 25.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 28, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6500, 32167, 'Nika', '', 'LineageNPC2.K_F1_normal', 11.00, 22.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 20, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6501, 32168, 'Zenith', '', 'LineageNPC2.K_F1_normal', 11.00, 22.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 20, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6502, 32169, 'Mila', '', 'LineageNPC2.K_F1_normal', 11.00, 22.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 20, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6503, 32170, 'Benis', '', 'LineageNPC.a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6504, 32171, 'Hoffa', '', 'LineageNPC.a_warehouse_keeper_MDwarf', 8.00, 17.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6505, 32172, 'Saylem', '', 'LineageNPC.e_warehouse_keeper_FDwarf', 7.00, 18.00, 70, 'female', 'L2Warehouse', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6506, 32173, 'Marcela', '', 'LineageNPC2.K_F1_guard_Master', 13.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6507, 32174, 'Maddy', '', 'LineageNPC2.K_F1_guard', 13.00, 22.50, 70, 'female', 'L2Guard', 'Guard', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6508, 32175, 'Bixon', '', 'LineageNPC2.K_M1_guard', 13.00, 25.00, 70, 'male', 'L2Guard', 'Guard', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9645, 0, 0, 39, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6509, 32176, 'Ambra', '', 'LineageNPC2.K_F1_guard', 13.00, 22.50, 70, 'female', 'L2Guard', 'Guard', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6510, 32177, 'Syzar', '', 'LineageNPC2.K_M1_guard', 13.00, 25.00, 70, 'male', 'L2Guard', 'Guard', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9645, 0, 0, 39, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6511, 32178, 'Carver', '', 'LineageNPC2.K_F1_guard', 13.00, 22.50, 70, 'female', 'L2Guard', 'Guard', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6512, 32179, 'Putin', '', 'LineageNPC2.K_M1_guard', 13.00, 25.00, 70, 'male', 'L2Guard', 'Guard', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9645, 0, 0, 39, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6513, 32180, 'Kato', '', 'LineageNPC2.K_M1_guard', 13.00, 25.00, 70, 'male', 'L2Guard', 'Guard', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9645, 0, 0, 39, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6514, 32181, 'Mellon', '', 'LineageNPC2.K_F1_teleporter', 13.00, 23.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6515, 32182, 'Coplan', '', 'LineageNPC2.K_M1_master', 15.00, 25.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 30, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6516, 32183, 'Yunha', '', 'LineageNPC2.K_F1_master', 12.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 24, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6517, 32184, 'Yinir', '', 'LineageNPC2.K_F1_teleporter', 13.00, 23.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6518, 32185, 'Peregrine', '', 'LineageNPC2.K_M1_guard', 13.00, 25.00, 70, 'male', 'L2Guard', 'Guard', 1100, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9645, 0, 0, 39, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6519, 32186, 'Yung', '', 'LineageNPC2.K_F1_teleporter', 13.00, 23.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6520, 32187, 'Nadir', '', 'LineageNPC2.K_F1_elder', 13.00, 22.25, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 10, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6521, 32188, 'Morelin', '', 'LineageNPC2.K_F1_guard', 13.00, 22.50, 70, 'female', 'L2Guard', 'Guard', 1100, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 60, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6522, 32189, 'Largo', '', 'LineageNPC2.K_F1_teleporter', 13.00, 23.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6523, 32190, 'Mao', '', 'LineageNPC2.K_M1_elder', 17.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 20, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6524, 32191, 'Hanarin', '', 'LineageNPC2.K_F1_grand', 11.00, 22.25, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6525, 32192, 'Falken', '', 'LineageNPC2.K_M1_guard', 13.00, 25.00, 70, 'male', 'L2Guard', 'Guard', 1100, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9645, 0, 0, 39, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.49, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6526, 32193, 'Yeniche', '', 'LineageNPC2.K_F1_grand', 11.00, 22.25, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6527, 32194, 'Shubain', '', 'LineageNPC2.K_M1_master', 15.00, 25.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 30, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6528, 32195, 'Sione', '', 'LineageNPC2.K_F1_master', 12.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 24, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6529, 32196, 'Gershwin', '', 'LineageNPC2.K_M1_grand', 13.00, 25.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6530, 32197, 'Gwain', '', 'LineageNPC2.K_M1_master', 15.00, 25.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 30, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6531, 32198, 'Gobie', '', 'LineageNPC2.K_F1_master', 12.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 24, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6532, 32199, 'Holst', '', 'LineageNPC2.K_M1_grand', 13.00, 25.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9645, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6533, 32200, 'Entien', '', 'LineageNPC2.K_M1_master', 15.00, 25.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 30, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6534, 32201, 'Rindy', '', 'LineageNPC2.K_F1_master', 12.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 24, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6535, 32202, 'Khadava', '', 'LineageNPC2.K_F1_grand', 11.00, 22.25, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6536, 32203, 'Ramen', '', 'LineageNPC2.K_M1_master', 15.00, 25.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 30, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6537, 32204, 'Fiske', '', 'LineageNPC2.K_F1_master', 12.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 24, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6538, 32205, 'Aetonic', '', 'LineageNPC2.K_M1_grand', 13.00, 25.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6539, 32206, 'Pieche', '', 'LineageNPC2.K_F1_grand', 11.00, 22.25, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6540, 32207, 'Orkurus', '', 'LineageNPC2.K_M1_master', 15.00, 25.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 30, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6541, 32208, 'Rasha', '', 'LineageNPC2.K_F1_master', 12.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 24, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6542, 32209, 'Ferdinand', '', 'LineageNPC2.K_M1_grand', 13.00, 25.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9645, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6543, 32210, 'Eddy', '', 'LineageNPC2.K_F1_grand', 11.00, 22.25, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6544, 32211, 'Jueno', '', 'LineageNPC2.K_M1_master', 15.00, 25.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 30, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6545, 32212, 'Rishtar', '', 'LineageNPC2.K_F1_master', 12.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 24, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6546, 32213, 'Vitus', '', 'LineageNPC2.K_M1_grand', 13.00, 25.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6547, 32214, 'Meldina', '', 'LineageNPC2.K_F1_grand', 11.00, 22.25, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6548, 32215, 'Tenain', '', 'LineageNPC2.K_M1_master', 15.00, 25.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 30, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6549, 32216, 'Noir', '', 'LineageNPC2.K_F1_master', 12.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 24, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6550, 32217, 'Barta', '', 'LineageNPC2.K_M1_grand', 13.00, 25.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9645, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6551, 32218, 'Miya', '', 'LineageNPC2.K_F1_grand', 11.00, 22.25, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6552, 32219, 'Fabnor', '', 'LineageNPC2.K_M1_master', 15.00, 25.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 30, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6553, 32220, 'Selsia', '', 'LineageNPC2.K_F1_master', 12.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 24, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6554, 32221, 'Brome', '', 'LineageNPC2.K_M1_grand', 13.00, 25.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6555, 32222, 'Liane', '', 'LineageNPC2.K_F1_grand', 11.00, 22.25, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6556, 32223, 'Duroga', '', 'LineageNPC2.K_M1_master', 15.00, 25.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 30, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6557, 32224, 'Auren', '', 'LineageNPC2.K_F1_master', 12.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 24, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6558, 32225, 'Taine', '', 'LineageNPC2.K_M1_grand', 13.00, 25.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9645, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6559, 32226, 'Raula', '', 'LineageNPC2.K_F1_grand', 11.00, 22.25, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6560, 32227, 'Digler', '', 'LineageNPC2.K_M1_master', 15.00, 25.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 30, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6561, 32228, 'Medea', '', 'LineageNPC2.K_F1_master', 12.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 24, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6562, 32229, 'Hagel', '', 'LineageNPC2.K_M1_grand', 13.00, 25.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6563, 32230, 'Ceci', '', 'LineageNPC2.K_F1_grand', 11.00, 22.25, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6564, 32231, 'Luben', '', 'LineageNPC2.K_M1_master', 15.00, 25.00, 70, 'male', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 30, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6565, 32232, 'Minuet', '', 'LineageNPC2.K_F1_master', 12.00, 23.00, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 24, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6566, 32233, 'Zoldart', '', 'LineageNPC2.K_M1_grand', 13.00, 25.00, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9645, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6567, 32234, 'Nizer', '', 'LineageNPC2.K_F1_grand', 11.00, 22.25, 70, 'female', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6568, 32235, 'Katenar', '', 'LineageNPC2.k_hero_rapire', 10.00, 24.62, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 28, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6569, 32236, 'Harkilgamed', '', 'LineageNPC2.k_hero_bigsword', 11.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9645, 0, 0, 42, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6570, 32237, 'Rodenpicula', '', 'LineageNPC2.k_hero_bowgun', 9.00, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 47, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6571, 32238, 'Rock', '', 'LineageNpcEV.stone_q0236_p', 60.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6572, 32239, 'Mother Nornil', '', 'LineageNpcEV.mother_nornil', 50.00, 253.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6573, 32240, 'Katenar', '', 'LineageNPC2.k_hero_rapire', 10.00, 24.62, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 28, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6574, 32241, 'Berka', '', 'LineageNPC2.K_M1_master', 15.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 30, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6575, 32242, 'Katenar', '', 'LineageNPC2.k_hero_rapire', 10.00, 24.62, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 28, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6576, 32243, 'Cargo Box', '', 'LineageNPC.Box', 18.00, 14.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6577, 32244, 'Suspicious Man', '', 'LineageNPC2.K_M1_normal', 13.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 28, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6578, 32245, 'Matras', '', 'LineageNPC.e_mine_teacher_MDwarf', 8.00, 18.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6579, 32246, 'Rua', '', 'LineageNPC2.a_child_people_Fhuman', 5.00, 12.30, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 24, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6580, 32247, 'Serian', '', 'LineageNPC.a_common_peopleA_FHuman', 8.00, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6581, 32248, 'First Reaction', '', 'LineageNPC.a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6582, 32249, 'Chief Jarron', '', 'LineageNPC.a_wharfinger_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6583, 32250, 'Ario', '', 'LineageNPC.a_common_peopleA_MHuman', 8.00, 21.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6584, 32251, 'Saria', '', 'LineageNPC.a_common_peopleA_FHuman', 8.00, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6585, 32252, 'Caravaner Gort', '', 'LineageNPC2.K_M1_normal', 13.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 28, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6586, 32253, 'Harkilgamed', '', 'LineageNPC2.k_hero_bigsword', 11.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9645, 0, 0, 42, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6587, 32254, 'Harkilgamed', '', 'LineageNPC2.k_hero_bigsword', 11.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9645, 0, 0, 42, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6588, 32255, 'Icon of the Past', '', 'LineageNpcEV.godness_of_the_past', 54.00, 245.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6589, 32256, 'Icon of the Present', '', 'LineageNpcEV.godness_of_the_being', 54.00, 245.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6590, 32257, 'Icon of the Future', '', 'LineageNpcEV.godness_of_the_come', 54.00, 245.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6591, 32258, 'Menacing Machine', '', 'LineageNpcEV.mother_nornil', 50.00, 253.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6592, 32259, 'Vault Door Controller', '', 'LineageNPC.teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6593, 32260, 'Gatemaster of the Past', '', 'LineageNPC.teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6594, 32261, 'Gatemaster of the Present', '', 'LineageNPC.teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6595, 32262, 'Gatemaster of the Future', '', 'LineageNPC.teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6596, 32263, 'Rodenpicula', '', 'LineageNPC2.k_hero_bowgun', 9.00, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 47, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6597, 32264, 'Kanis', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6598, 32271, 'Parme', '', 'LineageNPC.a_teleporter_FElf', 65.00, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6599, 32272, 'Akyaka', '', 'LineageNPC.a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6600, 32273, 'Oracle Guide', '', 'LineageNpcEV.teleport_device', 16.00, 42.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6601, 32274, 'Oracle Guide', '', 'LineageNpcEV.teleport_device', 16.00, 42.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6602, 32275, 'Oracle Guide', '', 'LineageNpcEV.teleport_device', 16.00, 42.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6603, 32276, 'Oracle Guide', '', 'LineageNpcEV.teleport_device', 16.00, 42.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6604, 32277, 'Oracle Guide', '', 'LineageNpcEV.teleport_device', 16.00, 42.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6605, 32278, 'Oracle Guide', '', 'LineageNpcEV.teleport_device', 16.00, 42.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6606, 32279, 'Oracle Guide', '', 'LineageNpcEV.teleport_device', 16.00, 42.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6607, 32280, 'Oracle Guide', '', 'LineageNpcEV.teleport_device', 16.00, 42.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6608, 32281, 'Oracle Guide', '', 'LineageNpcEV.teleport_device', 16.00, 42.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6609, 32282, 'Yiyen', '', 'LineageNPC.e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6610, 32284, 'Evas Protector', '', 'LineageNpcEV.teleport_device', 16.00, 42.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 0.000, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6611, 32285, 'Evas Protector', '', 'LineageNpcEV.teleport_device', 16.00, 42.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 0.000, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6612, 32286, 'Evas Protector', '', 'LineageNpcEV.teleport_device', 16.00, 42.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 0.000, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6613, 32287, 'Evas Protector', '', 'LineageNpcEV.teleport_device', 16.00, 42.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 0.000, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6614, 32288, 'Symbol of Faith', '', 'LineageNpcEV.dark_clouds_crystal', 23.00, 37.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6615, 32289, 'Symbol of Adversity', '', 'LineageNpcEV.dark_clouds_crystal', 23.00, 37.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6616, 32290, 'Symbol of Adventure', '', 'LineageNpcEV.dark_clouds_crystal', 23.00, 37.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6617, 32291, 'Symbol of Truth', '', 'LineageNpcEV.truth_lie_crystal', 23.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6618, 32292, 'Galate', '', 'LineageNPC.a_mageguild_teacher_FHuman', 8.00, 23.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6619, 32293, 'Jirrone', '', 'LineageNPC.a_common_peopleC_Mhuman', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6620, 32294, 'Budenka', '', 'LineageMonster4.caravan', 33.00, 58.50, 70, 'male', 'L2HellboundNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 56, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6621, 32296, 'Seruzia', '', 'LineageMonster.human_ghost', 8.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6622, 32297, 'Falk', '', 'LineageMonster4.caravan', 33.00, 58.50, 70, 'male', 'L2HellboundNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 56, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6623, 32298, 'Hude', '', 'LineageMonster4.caravan', 33.00, 58.50, 70, 'male', 'L2HellboundNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 56, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6624, 32299, 'Quarry Slave', '', 'LineageMonster4.caravan_slave', 35.00, 47.50, 70, 'male', 'L2Rab', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 46, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6625, 32300, 'Bernarde', '', 'LineageNPC.a_common_peopleC_Mhuman', 10.00, 24.00, 70, 'male', 'L2HellboundNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6626, 32301, 'Kendal', '', 'LineageMonster.human_ghost', 8.00, 22.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6627, 32302, 'Jerian', '', 'LineageNPC.a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6628, 32303, 'Machine', '', 'LineageNpcEV.strange_mechanical_instrument', 16.00, 31.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6629, 32304, 'Oasis', '', 'LineageNPC.training_doll_150p', 13.00, 40.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6630, 32305, 'Rankus Scapegoat', '', 'LineageMonster4.caravan_slave', 35.00, 47.50, 70, 'male', 'L2Minion', 'RankuScapegoat', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 46, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6631, 32306, 'Natives Corpse', '', 'LineageMonster.Zombie_corpse', 13.00, 21.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 15, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6632, 32307, 'Dolmen', '', 'LineageNpcEV.Huge_dolmen', 220.00, 450.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6633, 32308, 'Ming', '', 'LineageMonster.Cutie_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6634, 32312, 'Rat Hole', '', 'LineageNPC.training_doll_150p', 13.00, 40.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6635, 32313, 'Deltuva', '', 'LineageNPC.a_common_peopleC_Mhuman', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6636, 32314, 'Warpgate', '', 'LineageNpcEV.warp_gate_a', 16.00, 31.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6637, 32315, 'Warpgate', '', 'LineageNpcEV.warp_gate_a', 16.00, 31.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6638, 32316, 'Warpgate', '', 'LineageNpcEV.warp_gate_b', 16.00, 31.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6639, 32317, 'Warpgate', '', 'LineageNpcEV.warp_gate_c', 16.00, 31.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6640, 32318, 'Warpgate', '', 'LineageNpcEV.warp_gate_d', 16.00, 31.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6641, 32319, 'Warpgate', '', 'LineageNpcEV.warp_gate_e', 16.00, 31.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6642, 32320, 'Item Broker', '', 'LineageNPC.a_traderC_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6643, 32321, 'Item Broker', '', 'LineageNPC.a_traderC_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6644, 32322, 'Item Broker', '', 'LineageNPC.a_traderC_Mhuman', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6645, 32323, 'Avant-Garde', '', 'LineageNPC.a_traderB_FHuman', 8.00, 24.50, 70, 'female', 'L2Trainer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6646, 32324, 'Black Stone Monolith', '', 'LineageNpcEV.Dark_clouds_stonehenge', 19.00, 24.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6647, 32325, 'Yin', '', 'LineageNPC.Mage_master', 8.00, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6648, 32326, 'Yang', '', 'LineageNPC.Mage_master', 8.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6649, 32327, 'Adventurers Guide', '', 'LineageNPC.Sanctuary_teacher', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6650, 32328, 'Crystalline Golem', '', 'LineageMonster4.Crystal_Golem', 34.00, 47.00, 70, 'male', 'L2Npc', 'CrystallineGolem', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 54, 30, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6651, 32330, 'Garden Guard', '', 'LineageNPC2.Keny_guard', 13.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 60, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6652, 32331, 'Arcane Nucleus', '', 'LineageNpcEV.Circle_core', 0.10, 0.10, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6653, 32332, 'Katenar', '', 'LineageNPC2.Rapire', 10.00, 24.62, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 28, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6654, 32333, 'Katenar', '', 'LineageNPC2.Rapire', 10.00, 24.62, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9646, 0, 0, 28, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6655, 32334, 'Harkilgamed', '', 'LineageNPC2.Rapire', 11.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9645, 0, 0, 42, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6656, 32335, 'Marksman', '', 'LineageNPC2.Keny_guard', 13.00, 22.50, 70, 'female', 'L2Guard', 'GuardRndWalkAndAnim', 1100, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 60, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6657, 32336, 'Marksman', '', 'LineageNPC2.Keny_guard', 13.00, 22.50, 70, 'female', 'L2Guard', 'GuardRndWalkAndAnim', 1100, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 9644, 0, 0, 60, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6658, 32337, 'Adventure Guildsman', '', 'LineageNPC.MElf', 6.00, 21.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 130, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6659, 32338, 'Adventure Guildsman', '', 'LineageNPC.Collector_teacher', 8.00, 17.50, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6660, 32339, 'Adventure Guildsman', '', 'LineageNPC.Fighter_teacher', 9.50, 22.40, 70, 'female', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 129, 102, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6661, 32340, 'Adventure Guildsman', '', 'LineageNPC.Markus', 8.00, 26.00, 70, 'male', 'L2Adventurer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6662, 32342, 'Evas Gift Box', '', 'LineageMonster.Cotlon', 8.50, 8.50, 70, 'male', 'L2Monster', 'EvasGiftBox', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6663, 32343, 'Moonlight Tombstone', '', 'LineageNPC.Evil', 11.00, 45.00, 70, 'etc', 'MoonlightTombstone', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6664, 32344, 'Spooky Tombstone', '', 'LineageNPC.Evil', 11.00, 45.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6665, 32345, 'Buron', '', 'LineageNPC.Filemo', 10.00, 24.00, 70, 'male', 'L2HellboundNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6666, 32346, 'Kanaf', '', 'LineageNPC.Filemor', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6667, 32347, 'Shadai', '', 'LineageNPC.Smith_master', 8.00, 16.50, 70, 'male', 'L2Merchant', 'Shadai', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6668, 32348, 'Burang', '', 'LineageNPC.Fisher', 8.00, 23.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 7560, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6669, 32349, 'Rignos', '', 'LineageMonster3.Zombie_guard', 17.00, 30.50, 70, 'male', 'L2HellboundNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 173, 0, 0, 33, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6670, 32350, 'Sandstorm', '', 'LineageMonster4.SandTourbillon', 0.01, 35.00, 84, 'etc', 'Sandstorm', 'Sandstorm', 40, 4039, 8.500, 1812, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1981, 619, 1353, 453, 253, 300, 506, 0, 0, 0, 50, 220, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6671, 32351, 'Enceinte Insurgent', '', 'LineageNPC.Aspero', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 291, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6672, 32352, 'Desert Heatmaster', '', 'LineageNPC.Aspero', 0.10, 0.10, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6673, 32353, 'Event Gatekeeper', '', 'LineageMonster.Cutie_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6674, 32354, 'Kief', '', 'LineageNPC.Zomo', 10.00, 24.00, 70, 'male', 'L2HellboundNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6675, 32355, 'Solomon', '', 'LineageNPC.Zomo', 10.00, 24.00, 70, 'male', 'L2HellboundNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6676, 32356, 'Jude', '', 'LineageMonster4.caravan', 33.00, 58.50, 70, 'male', 'L2HellboundNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 56, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6677, 32357, 'Native Slave', '', 'LineageNPC.Zomo', 10.00, 24.00, 70, 'male', 'L2HellboundNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6678, 32358, 'Native Prisoner', '', 'LineageNPC.Zomo', 10.00, 24.00, 70, 'male', 'NativePrisoner', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6679, 32359, 'Lahm', '', 'LineageNPC.Zomo', 8.00, 16.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6680, 32361, 'Caravan Supporter', '', 'LineageNPC.box', 18.00, 14.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6681, 32362, 'Hellbound Native ', '', 'LineageNPC.a_common_peopleC_Mhuman', 10.00, 24.00, 70, 'male', 'L2Npc', 'RndWalkAndAnim', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 1, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6682, 32363, 'Hellbound Insurgent', '', 'LineageNPC.a_common_peopleC_Mhuman', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 129, 102, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6683, 32364, 'Hellbound Traitor', '', 'LineageNPC.a_common_peopleC_Mhuman', 10.00, 24.00, 70, 'male', 'L2HellboundNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6684, 32365, 'Snow', '', 'LineageNPC2.TP_game_staff', 5.00, 12.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 75, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6685, 32366, 'Destroyed Device', '', 'LineageMonster.susceptor_env', 20.00, 35.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 27, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6686, 32367, 'Alarm', '', 'LineageNpcEV.pavel_weather_controller', 14.50, 18.50, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6687, 32368, 'Weathered Rock', '', 'LineageNpcEV.stone_q0236_p', 60.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6688, 32369, 'Fallen Angel', '', 'LineageMonster2.apostle_warrior', 8.00, 30.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 6717, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6689, 32370, 'Old Dwarven Ghost', '', 'LineageNPC.e_collector_teacher_Mdwarf_mon', 8.00, 17.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8528, 0, 0, 36, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6690, 32371, 'Ingenious Contraption', '', 'LineageNpcEV.elobrate_machine', 13.00, 20.00, 70, 'male', 'L2IngeniousContraption', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6691, 32372, 'Mysterious Agent', '', 'LineageMonster.kel_mahum_witch_doctor', 13.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 202, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.28, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6692, 32373, 'Dorian', '', 'LineageNPC.a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6693, 32374, 'Teleportation Cubic', '', 'LineageNPC.teleport_cube', 30.00, 65.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6694, 32375, 'Teleportation Cubic', '', 'LineageNPC.teleport_cube', 30.00, 65.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6695, 32376, 'Teleportation Cubic', '', 'LineageNPC.teleport_cube', 30.00, 65.00, 70, 'etc', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6696, 32377, 'Kuram', '', 'LineageNPC2.TP_battlezone_staff', 7.80, 17.29, 70, 'male', 'L2UngergroundColiseum', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 60, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6697, 32378, 'Fantasy Isle Paddies', '', 'LineageNPC.e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6698, 32379, 'pr_flag_boy', '', 'LineageNPC2.TP_flag', 0.01, 12.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6699, 32380, 'pr_trumpet_boy', '', 'LineageNPC2.TP_trumpet', 0.01, 12.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6700, 32381, 'pr_longleg_boy', '', 'LineageNPC2.TP_clown_tall', 0.01, 26.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6701, 32382, 'pr_flower_boy', '', 'LineageNPC2.TP_wedding_maid', 0.01, 9.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6702, 32383, 'pr_juggling_boy', '', 'LineageNPC2.TP_juggler', 0.01, 10.25, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6703, 32384, 'pr_dish_spinning_boy', '', 'LineageNPC2.TP_unicycler', 0.01, 10.25, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6704, 32385, 'pr_ball_acrobat', '', 'LineageNPC2.TP_acrobat_ball', 0.01, 20.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6705, 32386, 'pr_darkelf_f_guard', '', 'LineageNPC.pr_a_guard_FDarkelf', 0.01, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6706, 32387, 'pr_darkelf_f_casino', '', 'LineageNPC.pr_a_casino_FDarkElf', 0.01, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6707, 32388, 'pr_darkelf__trader', '', 'LineageNPC.pr_a_trader_Fdarkelf', 0.01, 24.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6708, 32389, 'pr_darkelf_f_teleporter', '', 'LineageNPC.pr_a_teleporter_FDarkElf', 0.01, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6709, 32390, 'pr_darkelf_f_people', '', 'LineageNPC.pr_a_common_people_FDarkElf', 0.01, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6710, 32391, 'pr_dwarf_m_guard', '', 'LineageNPC.pr_e_guard_MDwarf', 0.01, 19.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6711, 32392, 'pr_dwarf_m_warehskeeper', '', 'LineageNPC.pr_a_warehouse_keeper_MDwarf', 0.01, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6712, 32393, 'pr_dwarf_f_trader_a', '', 'LineageNPC.pr_e_traderA_FDwarf', 0.01, 18.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6713, 32394, 'pr_dwarf_f_warehskeeper', '', 'LineageNPC.pr_e_warehouse_keeper_FDwarf', 0.01, 18.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6714, 32395, 'pr_dwarf_m_teleport', '', 'LineageNPC.pr_e_teleporter_FDwarf', 0.01, 21.30, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6715, 32396, 'pr_elf_m_guard', '', 'LineageNPC.pr_a_guard_MElf', 0.01, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6716, 32397, 'pr_elf_m_elder', '', 'LineageNPC.pr_a_patriarch_MElf', 0.01, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6717, 32398, 'pr_elf_f_trader', '', 'LineageNPC.pr_a_trader_FElf', 0.01, 24.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6718, 32399, 'pr_elf_f_teleporter', '', 'LineageNPC.pr_a_teleporter_FElf', 0.01, 23.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6719, 32400, 'pr_elf_f_people', '', 'LineageNPC.pr_a_common_people_FElf', 0.01, 25.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6720, 32401, 'pr_orc_m_guard', '', 'LineageNPC.pr_e_guard_MOrc', 0.01, 27.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6721, 32402, 'pr_orc_m_smith', '', 'LineageNPC.pr_e_smith_MOrc', 0.01, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6722, 32403, 'pr_orc_m_king', '', 'LineageNPC.pr_e_patriarch_MOrc', 0.01, 26.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6723, 32404, 'pr_orc_f_teleporter', '', 'LineageNPC.pr_e_teleporter_FOrc', 0.01, 32.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6724, 32405, 'pr_human_m_magemaster', '', 'LineageNPC.pr_a_mageguild_master_MHuman', 0.01, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6725, 32406, 'pr_human_f_magemaster', '', 'LineageNPC.pr_a_mageguild_master_FHuman', 0.01, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6726, 32407, 'pr_human_f_fightermaster', '', 'LineageNPC.pr_a_fighterguild_master_FHuman', 0.01, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6727, 32408, 'pr_human_f_teleporter', '', 'LineageNPC.pr_a_teleporter_FHuman', 0.01, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6728, 32409, 'pr_mue_the_cat', '', 'LineageMonster.pr_cutie_cat', 0.01, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6729, 32410, 'pr_baby_buffalo', '', 'LineageMonster2.pr_baby_buffalo', 0.01, 15.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6730, 32411, 'pr_baby_kukaburo', '', 'LineageMonster2.pr_baby_tiger', 0.01, 15.70, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6731, 32412, 'pr_baby_cougar', '', 'LineageMonster2.pr_baby_ostrich', 0.01, 15.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6732, 32413, 'pr_yeti', '', 'LineageMonster.pr_yeti', 0.01, 27.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6733, 32414, 'pr_yeti_cute', '', 'LineageNPC.pr_yeti_cute', 0.01, 10.80, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6734, 32415, 'pr_following_yeti_cute', '', 'LineageNPC.pr_yeti_cute_r', 0.01, 10.80, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6735, 32416, 'pr_unicorn_magnus', '', 'LineageMonster3.pr_unicorn_magnus', 0.01, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6736, 32417, 'pr_unicorn_marrow', '', 'LineageMonster.pr_blue_eye', 0.01, 16.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6737, 32418, 'pr_unicorn_mirage', '', 'LineageMonster.pr_unicorn_mirage', 0.01, 17.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.69, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6738, 32419, 'pr_unicorn_boxer', '', 'LineageMonster.pr_unicorn_boxer', 0.01, 18.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6739, 32420, 'pr_unicorn_seraphim', '', 'LineageMonster2.pr_angelic_unicorn', 0.01, 25.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.71, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6740, 32421, 'pr_kai_the_cat', '', 'LineageMonster.pr_silver_cat', 0.01, 15.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6741, 32422, 'pr_cat_the_cat', '', 'LineageMonster.pr_cat_the_cat', 0.01, 16.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6742, 32423, 'pr_queen_of_cat', '', 'LineageMonster2.pr_queen_of_cat', 0.01, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6743, 32424, 'Show Staff', '', 'LineageNPC.sw_e_mine_teacher_FDwarf', 0.01, 18.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6744, 32425, 'Show Staff', '', 'LineageNPC.sw_e_smith_Fdwarf', 0.01, 17.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6745, 32426, 'Show Staff', '', 'LineageNPC.sw_e_traderB_FDwarf', 0.01, 18.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6746, 32427, 'Show Staff', '', 'LineageNPC.sw_e_collector_teacher_FDwarf', 0.01, 17.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6747, 32428, 'Show Staff', '', 'LineageNPC.pr_e_warehouse_keeper_FDwarf', 0.01, 18.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6748, 32429, 'sw_batur_orc_dancer', '', 'LineageMonster.sw_batur_orc_shaman', 0.01, 16.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 30, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6749, 32430, 'sw_dance_doll', '', 'LineageNPC.pr_e_teleporter_FDwarf', 0.01, 21.30, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6750, 32431, 'Leyla Mira', '', 'LineageNPC.pr_a_teleporter_FElf', 0.01, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6751, 32432, 'sw_elf_chorus', '', 'LineageNPC.pr_a_teleporter_FElf', 0.01, 23.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6752, 32433, 'MC', '', 'LineageNPC.pr_a_casino_MHuman', 0.01, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6753, 32437, 'pr_musicbox', '', 'LineageNPC.clear_npc', 0.10, 0.10, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6754, 32438, 'sw_musicbox', '', 'LineageNPC.clear_npc', 0.10, 0.10, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6755, 32439, 'Backflip Expert', '', 'LineageMonster.sw_ant_larva', 0.01, 8.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6756, 32440, 'Backflip Originator', '', 'LineageMonster.pr_harpy', 0.01, 42.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6757, 32441, 'Backflip Superman', '', 'LineageMonster2.pr_knight_of_shadow', 0.01, 35.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.59, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6758, 32442, 'sw_tp_skillteam01', '', 'LineageNPC2.TP_juggler', 0.01, 10.25, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6759, 32443, 'sw_tp_skillteam02', '', 'LineageNPC2.TP_unicycler', 0.01, 10.25, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6760, 32444, 'sw_tp_skillteam03', '', 'LineageNPC2.TP_acrobat_ball', 0.01, 20.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6761, 32445, 'sw_tp_skillteam04', '', 'LineageNPC2.TP_clown_tall', 0.01, 26.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6762, 32446, 'sw_tp_skillteam05', '', 'LineageNPC2.TP_trumpet', 0.01, 12.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6763, 32447, 'pr_monster_beauty01', '', 'LineageMonster.pr_medusa', 0.01, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6764, 32448, 'pr_monster_beauty02', '', 'LineageMonster2.pr_vampire_witch', 0.01, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6765, 32449, 'pr_monster_beauty03', '', 'LineageMonster2.pr_vampire_wizard', 0.01, 28.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6766, 32450, 'pr_monster_beauty04', '', 'LineageMonster3.pr_lidia_von_helmann', 0.01, 25.40, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6767, 32451, 'pr_monster_beauty05', '', 'LineageMonster.pr_cave_maiden', 0.01, 65.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6768, 32452, 'pr_monster_beauty06', '', 'LineageMonster3.pr_Succubus_Raid', 0.01, 30.70, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6769, 32453, 'pr_monster_beauty07', '', 'LineageMonster3.pr_Bloody_Queen_Raid', 0.01, 34.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6770, 32454, 'pr_monster_beauty08', '', 'LineageMonster4.pr_rah', 0.01, 40.60, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.58, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6771, 32455, 'pr_monster_beauty09', '', 'LineageMonster4.pr_tears', 0.01, 27.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6772, 32456, 'pr_monster_beauty10', '', 'LineageMonster.pr_succubus', 0.01, 36.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.84, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6773, 32457, 'kerthang_clear_npc', '', 'LineageNPC.clear_npc', 0.10, 0.10, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6774, 32458, 'steel_castle_announcer', '', 'LineageNPC.clear_npc', 0.10, 0.10, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6775, 32464, 'c_tower_trapper_lurker', '', 'LineageNPC.clear_npc', 0.10, 0.10, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6776, 32465, 'c_tower_trapper_flame', '', 'LineageNPC.clear_npc', 0.10, 0.10, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6777, 32466, 'c_tower_trapper_poison', '', 'LineageNPC.clear_npc', 0.10, 0.10, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6778, 32467, 'Teleportation Cubic', '', 'LineageNPC.teleport_cube', 30.00, 65.00, 70, 'etc', 'L2TullyCube', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6779, 32468, 'bridge_controller', '', 'LineageNPC.clear_npc', 0.10, 0.10, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6780, 32469, 'Eindburgh', '', 'LineageNPC2.K_M1_elder', 17.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 20, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6781, 32470, 'Stone Coffin', '', 'LineageNpcEV.stone_coffin', 109.00, 11.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6782, 32471, 'pr_team01', '', 'LineageNPC2.pr_K_F1_teleporter', 0.01, 23.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6783, 32472, 'pr_team02', '', 'LineageNPC2.pr_K_F1_master', 0.01, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6784, 32473, 'pr_team03', '', 'LineageNPC2.pr_K_F1_guard_Master', 0.01, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6785, 32474, 'pr_team04', '', 'LineageNPC2.pr_k_hero_bowgun', 0.01, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 40, 40, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6786, 32475, 'Subclass Certification Helper', '', 'LineageMonster3.king_of_cat', 6.00, 16.01, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 160, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6787, 32476, 'Employee of Magic Research Institute', '', 'LineageNPC.e_smith_Fdwarf', 8.00, 17.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 313, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6788, 32477, 'Volunteer', '', 'LineageNPC.a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6789, 32478, 'Dimensional Merchant', '', 'LineageNPC2.premium_master', 10.00, 23.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 60, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6790, 32479, 'Adios', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 70, 'male', 'L2Guard', 'Guard', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 129, 102, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6791, 32480, 'Ronde', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 70, 'male', 'L2Guard', 'Guard', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 129, 102, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6792, 32481, 'Saige', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 70, 'male', 'L2Guard', 'Guard', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 129, 102, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6793, 32482, 'Emdrere', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 70, 'male', 'L2Guard', 'Guard', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 129, 102, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6794, 32483, 'kamaloka_obelisk', '', 'LineageNpcEV.kamaloka_obelisk', 16.00, 46.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6795, 32484, 'Pathfinder Worker', '', 'LineageNPC.a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Pathfinder', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6796, 32485, 'Pathfinder Worker', '', 'LineageNPC.a_mageguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Pathfinder', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6797, 32486, 'Inventor Maru', '', 'LineageNPC.e_collector_teacher_FDwarf', 8.00, 17.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6798, 32487, 'Mark', '', 'LineageNPC.a_fighterguild_teacher_MDarkElf_dead', 10.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6799, 32488, 'Mark', '', 'LineageNPC.a_fighterguild_teacher_MDarkElf', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6800, 32490, 'cruma_ev_spawn', '', 'LineageNPC.clear_npc', 0.10, 0.10, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6801, 32491, 'Underground Coliseum Helper', '', 'LineageNPC2.TP_battlezone_staff', 7.80, 17.29, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6802, 32492, 'Crystal Water Bottle', '', 'LineageNPCEV.crystal_pint', 13.00, 14.00, 36, 'female', 'L2Monster', 'Fighter', 40, 1, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 861, 370, 588, 271, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6803, 32493, 'Burning Brazier', '', 'LineageNPCEV.blazing_brazier', 15.00, 11.50, 36, 'female', 'L2Monster', 'Fighter', 40, 1, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 861, 370, 588, 271, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6804, 32494, 'Skull', '', 'LineageNPC.clear_npc', 0.10, 0.10, 61, 'male', 'L2Npc', 'npc', 40, 1, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1034, 444, 705, 326, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6805, 32495, 'Treasure Box', '', 'LineageNPC.coffer_d', 12.00, 9.50, 61, 'etc', 'L2Monster', 'Fighter', 40, 1, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1034, 444, 705, 326, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6806, 32496, 'Escape Device', '', 'LineageNPCEV.dark_obelisk', 15.00, 51.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6807, 32497, 'Inspector Adler', '', 'LineageNPC.a_mageguild_teacher_MElf', 7.00, 22.20, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6808, 32498, 'Devils Isle Survivor', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6809, 32499, 'Ketra Orc Shaman ', '', 'LineageMonster.ketra_orc_shaman_20_bi', 12.00, 27.60, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 10, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6810, 32500, 'Inspector Sinai', '', 'LineageNPC.a_mageguild_teacher_FElf', 7.00, 22.20, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6811, 32501, 'Devils Isle Supporter', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6812, 32502, 'Ketra Orc Supporter', '', 'LineageMonster.ketra_orc_shaman', 10.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 10, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6813, 32503, 'Entrance Manager', '', 'LineageNPC.e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2KrateisCubeManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (6814, 32504, 'Match Manager', '', 'LineageNPC.a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2KrateisCubeManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6815, 32505, 'Match Manager', '', 'LineageNPC.a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2KrateisCubeManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6816, 32506, 'Match Manager', '', 'LineageNPC.a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2KrateisCubeManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6817, 32507, 'Temple Inspector', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6818, 32508, 'Dwarf Adventurer', '', 'LineageNPC.e_mine_teacher_MDwarf', 8.00, 18.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6819, 32509, 'Ketra Orc Intelligence Officer', '', 'LineageMonster.ketra_orc', 12.00, 29.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 45, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6820, 32510, 'Inspector Adler', '', 'LineageNPC.a_mageguild_teacher_MElf', 7.00, 22.20, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6821, 32511, 'Dwarf Adventurer', '', 'LineageNPC.e_mine_teacher_MDwarf', 8.00, 18.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6822, 32512, 'Ketra Orc Supporter', '', 'LineageMonster2.ketra_orc_warlord', 12.00, 30.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 27, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6823, 32513, 'Kun', '', 'LineageNPC2.TP_battlezone_staff', 7.80, 17.29, 70, 'male', 'L2UngergroundColiseum', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6824, 32514, 'Tarion', '', 'LineageNPC2.TP_battlezone_staff', 7.80, 17.29, 70, 'male', 'L2UngergroundColiseum', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6825, 32515, 'Leo', '', 'LineageNPC2.TP_battlezone_staff', 7.80, 17.29, 70, 'male', 'L2UngergroundColiseum', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6826, 32516, 'Candice', '', 'LineageNPC2.TP_battlezone_staff', 7.80, 17.29, 70, 'male', 'L2UngergroundColiseum', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 60, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6827, 32517, 'Airship Controller', '', 'LineageNpcEV.riding_control_unit', 19.00, 28.00, 70, 'female', 'L2AirShipController', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6828, 32518, 'Vortex Gate ', '', 'LineageNpcEV.war_gate', 300.00, 130.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6829, 32519, 'Vortex Gate ', '', 'LineageNpcEV.war_gate', 300.00, 130.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6830, 32520, 'Emery Converter', '', 'LineageNPC.teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6831, 32521, 'Entrance Manager', '', 'LineageNPC.e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2HandyNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6832, 32522, 'Entrance Manager', '', 'LineageNPC.e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2HandyNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6833, 32523, 'Entrance Manager', '', 'LineageNPC.e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2HandyNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6834, 32524, 'Entrance Manager', '', 'LineageNPC.e_teleporter_FDwarf', 8.00, 21.30, 70, 'female', 'L2HandyNpc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6835, 32525, 'Tiat', '', 'LineageNPC2.tiat_oracle', 8.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 50, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6836, 32526, 'Allenos', '', 'LineageNPC2.gracia_soldier', 11.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 13524, 13525, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6837, 32527, 'Edric', '', 'LineageNPC2.gracia_remnants_a', 9.50, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6838, 32528, 'Medibals Corpse', '', 'LineageNPC.a_mageguild_teacher_Mhuman_dead', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6839, 32529, 'glaze_a_npc', '', 'LineageNPC.clear_npc', 0.10, 0.10, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6840, 32530, 'Tepios', '', 'LineageNPC2.gracia_soldier', 11.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 13524, 13525, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6841, 32531, 'Destroyed Tumor', '', 'LineageNpcEV.tumor_immortality_a', 0.01, 55.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6842, 32532, 'ai_is_combat_manager_a', '', 'LineageNPC.clear_npc', 0.10, 0.10, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6843, 32533, 'ai_is_combat_manager_b', '', 'LineageNPC.clear_npc', 0.10, 0.10, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6844, 32534, 'Jaedin', '', 'LineageMonster4.disciple_silen', 19.00, 44.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 73, 170, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6845, 32535, 'Destroyed Tumor', '', 'LineageNpcEV.tumor_immortality_a', 42.00, 55.00, 70, 'female', 'L2Npc', 'DestroyedTumor', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6846, 32536, 'Destroyed Tumor', '', 'LineageNpcEV.tumor_immortality_a', 42.00, 55.00, 70, 'female', 'DestroyedTumorEntrance', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6847, 32537, 'Mouth of Ekimus', '', 'LineageNpcEV.mouth_immotality_a', 80.00, 14.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6848, 32538, 'Closed Mouth of Ekimus', '', 'LineageNpcEV.mouth_immotality', 80.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6849, 32539, 'Gatekeeper of Abyss', '', 'LineageNpcEV.vigil_immortality', 70.00, 119.00, 70, 'female', 'GatekeeperOfAbyss', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6850, 32540, 'Gatekeeper of Abyss', '', 'LineageNpcEV.vigil_immortality_dis', 70.00, 119.00, 70, 'female', 'GatekeeperOfAbyss', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6851, 32541, 'Unstable Seed of Generation', '', 'LineageNpcEV.life_seed', 57.75, 65.63, 70, 'female', 'L2Npc', 'UnstableSeed', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6852, 32542, 'Stabilized Seed of Generation', '', 'LineageNpcEV.life_seed', 57.75, 65.63, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6853, 32543, 'Energy of Generation', '', 'LineageNPC.training_doll_150p', 13.00, 40.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6854, 32544, 'Seed of Generation', '', 'LineageNpcEV.artificial_life_seed', 57.75, 65.63, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6855, 32545, 'Kurkle', '', 'LineageNPC.training_doll_150p', 13.00, 40.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6856, 32546, 'Asyatei', '', 'LineageMonster4.death_scout_088p', 14.40, 22.00, 70, 'female', 'SoulTrader', 'RndWalkAndAnim', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 45, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6857, 32547, 'Center Tumor', '', 'LineageNpcEV.tumor_immortality_a_120p', 50.40, 65.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6858, 32548, 'Keucereus', '', 'LineageNPC2.xers', 12.50, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6859, 32549, 'Dilios', '', 'LineageNPC2.dilios', 10.00, 21.50, 70, 'female', 'L2Npc', 'Dilios', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6860, 32550, 'Kirklan', '', 'LineageNPC.a_traderA_MHuman', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6861, 32551, 'Noiless', '', 'LineageNPC2.gracia_soldier', 11.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 13524, 13525, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6862, 32552, 'Tomaris', '', 'LineageNPC2.gracia_soldier', 11.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 13524, 13525, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6863, 32553, 'Jisans', '', 'LineageNPC2.gracia_soldier', 11.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 13524, 13525, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6864, 32554, 'Moira', '', 'LineageNPC.a_fighterguild_master_FHuman', 8.00, 21.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 13524, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6865, 32555, 'Tenius', '', 'LineageNPC2.gracia_remnants_a', 9.50, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6866, 32556, 'El', '', 'LineageNPC2.gracia_remnants_b', 9.50, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6867, 32557, 'Lekon', '', 'LineageNPC.a_smith_MDwarf', 7.00, 16.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6868, 32558, 'Barrier Orb', '', 'LineageNpcEV.dark_clouds_crystal', 23.00, 37.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6869, 32559, 'Artius', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6870, 32560, 'Orbyu', '', 'LineageNPC2.gracia_soldier', 11.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 13524, 13525, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6871, 32561, 'Kunota', '', 'LineageNPC2.gracia_soldier', 11.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 13524, 13525, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6872, 32562, 'Siest', '', 'LineageNPC2.gracia_soldier', 11.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 13524, 13525, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6873, 32563, 'Plenos', '', 'LineageNPC2.gracia_soldier', 11.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 13524, 13525, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6874, 32564, 'Papiku', '', 'LineageNPC.a_mageguild_teacher_FElf', 7.00, 21.20, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6875, 32565, 'Felix', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6876, 32566, 'Ginby', '', 'LineageNPC2.gracia_soldier', 11.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 13524, 13525, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6877, 32567, 'Lelrikia', '', 'LineageNPC2.disciple_silen_b', 15.75, 25.73, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6878, 32568, 'Unidentified Body', '', 'LineageNPC.e_guard_MDwarf_death', 13.00, 19.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6879, 32569, 'Cain', '', 'LineageNPC.a_sanctuary_teacher_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6880, 32570, 'Eric', '', 'LineageNPC.e_collector_master_MDwarf', 8.00, 21.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6881, 32571, 'Colin', '', 'LineageNPC.a_common_peopleA_MHuman', 10.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 50, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6882, 32572, 'Frog', '', 'LineageMonster.poison_toad_100_bi', 40.00, 20.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.35, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6883, 32573, 'Tess', '', 'LineageNPC2.a_old_people_Fhuman', 9.00, 17.30, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 9, 34, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6884, 32574, 'Kuta', '', 'LineageNPC.a_common_peopleC_Mhuman', 10.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6885, 32575, 'Light of Dawn', '', 'LineageNPC.teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6886, 32576, 'John', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 36, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6887, 32577, 'Password Entry Device', '', 'LineageNpcEV.pavel_weather_controller', 35.00, 50.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6888, 32578, 'Identity Confirm Device', '', 'LineageNpcEV.elobrate_machine', 35.00, 50.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6889, 32579, 'Darkness of Dawn', '', 'LineageNPC.teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6890, 32580, 'bookshelf1_dawn', '', 'LineageNpcEV.bookcase_of_pray', 11.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6891, 32581, 'bookshelf2_dawn', '', 'LineageNpcEV.bookcase_of_pray', 18.00, 50.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6892, 32582, 'Jaina', '', 'LineageNPC.a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6893, 32583, 'bookshelf4_dawn', '', 'LineageNpcEV.bookcase_of_pray', 11.00, 25.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6894, 32584, 'Merchant of Mammon', '', 'LineageNPC.black_market_trader_MDwarf_set', 22.00, 18.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6895, 32585, 'Promise of Mammon', '', 'LineageNPC.teleport_npc_sm', 7.00, 15.00, 70, 'etc', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6896, 32586, 'Shunaiman', '', 'LineageNPC.a_king_MHuman', 15.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 50, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6897, 32587, 'Leon', '', 'LineageNPC.a_royal_guardA_MHuman', 15.00, 24.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 50, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6898, 32588, 'Emperors Seal Device', '', 'LineageNpcEV.orb_of_kaizer', 37.00, 49.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6899, 32589, 'Emperors Seal Device', '', 'LineageNpcEV.orb_of_kaizer', 37.00, 49.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6900, 32590, 'Emperors Seal Device', '', 'LineageNpcEV.orb_of_kaizer', 37.00, 49.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6901, 32591, 'Emperors Seal Device', '', 'LineageNpcEV.orb_of_kaizer', 37.00, 49.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6902, 32592, 'controler_of_sealing', '', 'LineageNPC.clear_npc', 0.10, 0.10, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6903, 32593, 'Wood', '', 'LineageNPC.a_mageguild_master_MHuman', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6904, 32594, 'Leopard', '', 'LineageNPC.a_guild_master_MDarkElf', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6905, 32595, 'Lawrence', '', 'LineageNPC.a_patriarch_MDarkElf', 6.00, 23.80, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6906, 32596, 'Sophia', '', 'LineageNPC.a_mageguild_teacher_FElf', 7.00, 21.20, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6907, 32597, 'Franz', '', 'LineageNPC2.leader_of_dawn_franz_abel', 12.00, 23.75, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6908, 32598, 'Court Magician', '', 'LineageNPC.a_temple_master_Mhuman', 8.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 50, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6909, 32599, 'Master Yogi', '', 'LineageNPC2.event_comic_masteryogy', 9.00, 16.70, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6910, 32600, 'Alegria', '', 'LineageNPC2.event_birth_alegria', 5.00, 21.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6911, 32601, 'Instant Moving Device', '', 'LineageNpcEV.crystal_of_secret_door', 57.00, 74.00, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6912, 32602, 'Temporary Teleporter', '', 'LineageNpcEV.teleport_device', 16.00, 42.00, 70, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6913, 32603, 'Tepios', '', 'LineageNPC2.gracia_soldier', 11.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 13524, 13525, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6914, 32604, 'Airship Controller', '', 'LineageNpcEV.riding_control_unit', 19.00, 28.00, 70, 'female', 'L2AirShipController', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6915, 32605, 'Airship Controller', '', 'LineageNpcEV.riding_control_unit', 19.00, 28.00, 70, 'female', 'L2AirShipController', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6916, 32606, 'Airship Controller', '', 'LineageNpcEV.riding_control_unit', 19.00, 28.00, 70, 'female', 'L2AirShipController', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6917, 32607, 'Airship Controller', '', 'LineageNpcEV.riding_control_unit', 19.00, 28.00, 70, 'female', 'L2AirShipController', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6918, 32608, 'Airship Controller', '', 'LineageNpcEV.riding_control_unit', 19.00, 28.00, 70, 'female', 'L2AirShipController', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6919, 32609, 'Airship Controller', '', 'LineageNpcEV.riding_control_unit', 19.00, 28.00, 70, 'female', 'L2AirShipController', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6920, 32610, 'Olf Kanore', '', 'LineageNPC.a_mageguild_teacher_MElf', 7.00, 22.20, 70, 'male', 'L2Weaver', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6921, 32611, 'Tolonis', '', 'LineageNPC2.gracia_remnants_a', 9.50, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6922, 32612, 'Olf Adams', '', 'LineageNPC.a_mageguild_teacher_MElf', 7.00, 22.20, 70, 'male', 'L2Weaver', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6923, 32613, 'Handy', '', 'LineageNPC2.block_mother_staff', 12.00, 31.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 120, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6924, 32614, 'Lamcedas', '', 'LineageNPC.a_teleporter_FHuman', 8.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6925, 32615, 'Ishuma', '', 'LineageNPC.e_smith_master_MDwarf', 8.00, 16.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6926, 32616, 'Mine', '', 'LineageNPC.a_casino_FDarkElf', 8.00, 23.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6927, 32617, 'Jaina', '', 'LineageNPC.a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6928, 32618, 'Thyimi', '', 'LineageNPC.e_warehouse_keeper_FDwarf', 7.00, 18.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6929, 32619, 'deco_ksoldier_follow', '', 'LineageNPC2.gracia_soldier', 11.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 13524, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6930, 32620, 'deco_ksoldier_leader1', '', 'LineageNPC2.gracia_soldier', 11.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 13524, 13525, 0, 50, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6931, 32621, 'deco_ksoldier_leader2', '', 'LineageNPC2.gracia_soldier', 11.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 13524, 13525, 0, 50, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6932, 32622, 'Anatole', '', 'LineageNPC2.gracia_soldier', 11.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6933, 32623, 'Morenki', '', 'LineageNPC.a_fighterguild_teacher_MDarkElf', 8.00, 23.00, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6934, 32624, 'Anbram', '', 'LineageNPC2.gracia_soldier', 11.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6935, 32625, 'Anciel', '', 'LineageNPC.a_fighterguild_teacher_MElf', 7.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6936, 32626, 'Royal Guard', '', 'LineageNPC2.gracia_soldier', 11.00, 25.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 13524, 13525, 0, 50, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6937, 32627, 'Nottingale', '', 'LineageNPC.a_teleporter_FElf', 8.50, 23.50, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6938, 32628, 'Wharf Patrol', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 70, 'male', 'L2Guard', 'AirshipGuard1', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 94, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6939, 32629, 'Wharf Patrol', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 70, 'male', 'L2Guard', 'AirshipGuard2', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 94, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6940, 32630, 'Gracia Server Helper', '', 'LineageNPC2.message_event_master', 10.00, 20.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6941, 32631, 'Gracia Server Proof Exchanger', '', 'LineageNPC2.message_event_master', 10.00, 20.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6942, 32632, 'Gracia Survivor', '', 'LineageNPC2.gracia_remnants_a', 9.50, 22.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6943, 32633, 'Cat of Christmas', '', 'LineageMonster.cutie_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6944, 32634, 'Cat of Christmas', '', 'LineageMonster.cutie_cat', 8.00, 15.00, 70, 'female', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 48, 140, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6945, 32635, 'Master Dugi', '', 'LineageNPC2.event_comic_masteryogy', 9.00, 16.70, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6946, 32636, 'Employee of Magic Research Institute', '', 'LineageNPC.e_smith_Fdwarf', 8.00, 17.50, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 313, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6947, 32637, 'Workshop Teleporter', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 50, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6948, 32638, 'Roni the cat', '', 'LineageMonster.cutie_cat', 8.00, 15.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 48, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.34, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6949, 32639, 'Pierre Baguette', '', NULL, 8.00, 17.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6950, 32640, 'Kintaijin', '', 'e_collector_teacher_FDwarf', 8.00, 23.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6951, 32641, 'Dr. Helvetica', '', 'LineageNPC.e_smith_master_MDwarf', 7.00, 16.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6952, 32642, 'Broken Golem Control Device', '', '', 16.00, 15.50, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6953, 32643, 'Athenia', '', NULL, 8.00, 24.00, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6954, 32644, 'Piazza', '', NULL, 8.00, 22.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6955, 32645, 'Chandra', '', 'e_collector_teacher_FDwarf', 8.00, 18.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6956, 32646, 'Katensa', '', 'a_traderA_MDwarf', 8.00, 17.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6957, 32647, 'Atra', '', NULL, 8.00, 23.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 135, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6958, 32648, 'News Informer', '', NULL, 5.00, 12.50, 80, 'male', 'L2Merchant', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 75, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6959, 32649, 'Dwyph', '', 'LineageNPC.e_mine_teacher_MDwarf', 8.00, 18.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6960, 32650, 'Kanemika', '', NULL, 14.00, 25.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6961, 32651, 'Grave Robber Warrior', '', NULL, 14.00, 25.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6962, 32652, 'Teleport Crystal', '', NULL, 30.00, 32.50, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6963, 32653, 'Krun', '', NULL, 8.00, 19.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6964, 32654, 'Tarun', '', NULL, 8.00, 19.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6965, 32655, 'Chairen', '', NULL, 8.00, 28.00, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6966, 32656, 'nest_controller', '', NULL, 0.10, 0.10, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 20, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6967, 32657, 'Disciples Gatekeeper', '', 'teleport_npc_sm', 7.00, 15.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6968, 32658, 'Guardian of Eastern Seal', '', 'teleport_npc_sm', 7.00, 15.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6969, 32659, 'Guardian of Western Seal', '', 'teleport_npc_sm', 7.00, 15.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6970, 32660, 'Guardian of Southern Seal', '', 'teleport_npc_sm', 7.00, 15.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6971, 32661, 'Guardian of Northern Seal', '', 'teleport_npc_sm', 7.00, 15.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6972, 32662, 'Guardian of Great Seal', '', 'teleport_npc_sm', 7.00, 15.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6973, 32663, 'Guardian of Tower of Seal', '', 'teleport_npc_sm', 7.00, 15.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6974, 32664, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6975, 32665, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6976, 32666, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6977, 32667, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6978, 32668, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6979, 32669, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6980, 32670, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6981, 32671, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6982, 32672, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6983, 32673, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6984, 32674, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6985, 32675, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6986, 32676, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6987, 32677, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6988, 32678, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6989, 32679, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6990, 32680, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6991, 32681, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6992, 32682, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6993, 32683, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6994, 32684, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6995, 32685, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6996, 32686, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6997, 32687, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6998, 32688, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6999, 32689, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7000, 32690, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7001, 32691, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7002, 32692, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7003, 32693, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7004, 32694, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7005, 32695, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7006, 32696, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7007, 32697, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7008, 32698, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7009, 32699, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7010, 32700, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7011, 32701, 'Delusion Manager', '', NULL, 25.00, 47.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7012, 32702, 'recom_class_cheker1', '', NULL, 0.10, 0.10, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7013, 32703, 'recom_class_cheker2', '', NULL, 0.10, 0.10, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7014, 32704, 'Somulitan', '', NULL, 8.00, 22.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7015, 32705, 'Zakens Candle', '', NULL, 8.00, 13.50, 80, 'female', 'ZakenKandle', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7016, 32706, 'Luciens Altar', '', NULL, 90.00, 38.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7017, 32707, 'Luciens Altar', '', NULL, 90.00, 38.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7018, 32708, 'Luciens Altar', '', NULL, 90.00, 38.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7019, 32709, 'Luciens Altar', '', NULL, 90.00, 38.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7020, 32710, 'Luciens Altar', '', NULL, 90.00, 38.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7021, 32711, 'Droph', '', 'LineageNPC.e_mine_teacher_MDwarf', 8.00, 18.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7022, 32712, 'Somulitan', '', NULL, 8.00, 22.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7023, 32713, 'Pathfinder Worker', '', 'LineageNPC.a_mageguild_teacher_MHuman', 8.00, 23.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7024, 32714, 'Asher ', '', NULL, 8.00, 23.00, 80, 'male', 'L2Merchant', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7025, 32715, 'Lilith', '', NULL, 42.50, 55.00, 80, 'female', 'L2Npc', 'Lilith', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 45, 200, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7026, 32716, 'Liliths Steward', '', NULL, 9.00, 34.00, 80, 'female', 'L2Npc', 'EpicQuestMage', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 190, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7027, 32717, 'Liliths Elite', '', NULL, 12.00, 50.00, 80, 'male', 'L2Npc', 'EpicQuestFighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 5800, 5799, 0, 56, 220, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7028, 32718, 'Anakim', '', NULL, 15.50, 29.00, 80, 'female', 'L2Npc', 'Anakim', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 45, 200, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7029, 32719, 'Anakims Guardian', '', NULL, 23.00, 40.50, 80, 'male', 'L2Npc', 'EpicQuestFighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 190, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7030, 32720, 'Anakims Guard', '', NULL, 12.00, 43.00, 80, 'male', 'L2Npc', 'EpicQuestFighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 65, 220, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7031, 32721, 'Anakims Executor', '', NULL, 12.00, 36.00, 80, 'male', 'L2Npc', 'EpicQuestFighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 65, 190, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7032, 32722, 'Battle League Helper', '', NULL, 5.00, 12.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 75, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7033, 32723, 'gcbt_npc', '', NULL, 0.10, 0.10, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7034, 32724, 'gcbt_clear_npc', '', NULL, 0.10, 0.10, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7035, 32725, 'Priest of Resurrection', '', NULL, 13.00, 26.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 50, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7036, 32726, 'Dr. Ice', '', NULL, 8.00, 21.30, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7037, 32727, 'Puss the Cat', '', 'elemental', 9.00, 16.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.61, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7038, 32728, 'Heavenly Bridge Keeper', '', 'dwarf', 8.00, 17.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7039, 32729, 'kerthang_banner_1', '', 'construct', 0.10, 152.00, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7040, 32730, 'kerthang_banner_2', '', 'construct', 0.10, 365.00, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7041, 32731, 'Hardin', '', 'human', 8.00, 22.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7042, 32732, 'Sixth Anniversary Party Manager', '', 'LineageNPC2.event_birth_alegria', 5.00, 21.00, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7043, 32733, 'Kbaldir', '', 'LineageNpc2.gracia_ocommander_1hs', 15.00, 27.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 57, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7044, 32734, 'Klemis', '', 'LineageNpc2.gracia_meofficer_1hs', 9.00, 23.50, 80, 'male', 'L2Merchant', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7045, 32735, 'Nemo', '', 'LineageNpc.a_hardins_pupil_MHuman', 8.00, 23.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 13465, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7046, 32736, 'Ermian', '', 'LineageNpc2.dilios', 10.00, 21.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7047, 32737, 'Seyo', '', 'LineageNpc.a_traderB_MHuman', 8.00, 25.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7048, 32738, 'Injured Soldier', '', 'LineageMonsters5.glacia_tired_soldier_m00', 7.00, 22.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 40, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7049, 32739, 'Bomona', '', 'LineageNPC.a_hardins_pupil_FHuman', 8.00, 23.00, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 100, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7050, 32740, 'Batracos', '', 'tantaar_lizardman_sorcerer', 29.00, 44.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 75, 150, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7051, 32741, 'Ankumi', '', 'e_collector_teacher_FDwarf', 8.00, 17.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7052, 32742, 'Laki', '', 'mage_of_insurgents', 9.00, 23.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 28, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7053, 32743, 'Sally', '', 'e_trader_FOrc', 8.00, 24.00, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7054, 32744, 'Johnny', '', 'a_hardins_pupil_MHuman', 8.00, 23.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7055, 32745, 'Teleport Device', '', 'etc', 9.00, 33.50, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7056, 32746, 'Teleport Device', '', 'etc', 9.00, 33.50, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7057, 32747, 'Teleport Device', '', 'etc', 9.00, 33.50, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7058, 32748, 'Teleport Device', '', 'etc', 9.00, 33.50, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7059, 32749, 'Teleport Device', '', 'etc', 9.00, 33.50, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7060, 32750, 'Teleport Device', '', 'etc', 9.00, 33.50, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7061, 32751, 'Teleport Device', '', 'etc', 9.00, 33.50, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7062, 32752, 'Teleport Device', '', 'etc', 9.00, 33.50, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7063, 32753, 'Floor Teleport Device', '', 'LineageNpcEV.trioll_altar', 9.00, 33.50, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7064, 32754, 'Floor Teleport Device', '', 'etc', 9.00, 33.50, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7065, 32755, 'Floor Teleport Device', '', 'etc', 9.00, 33.50, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7066, 32756, 'Floor Teleport Device', '', 'etc', 9.00, 33.50, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7067, 32757, 'Greymore', '', 'human', 8.00, 22.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7068, 32758, 'Sumiel', '', 'human', 15.00, 30.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 40, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7069, 32759, 'Gumiel', '', 'human', 15.00, 30.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 40, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7070, 32760, 'Jinia ', '', 'LineageMonster5.guildmaster_jinia', 11.00, 23.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 40, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7071, 32761, 'Kegor', '', 'human', 15.00, 27.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 40, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7072, 32762, 'Sirra ', '', 'human', 10.00, 22.00, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 40, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7073, 32763, 'Sirra ', '', 'elemental', 16.00, 35.60, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 30, 250, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7074, 32764, 'escort_checker_q0457', '', 'construct', 0.10, 0.10, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7075, 32765, 'Box of Doubt', '', 'etc', 18.00, 14.00, 80, 'etc', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7076, 32766, 'Ilvenis', '', 'human', 11.00, 25.00, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 13524, 13525, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7077, 32767, 'McLaren', '', 'elf', 8.00, 23.00, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 34, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7078, 32768, 'Kelleyia', '', 'human', 8.00, 22.50, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 1000, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7079, 32769, 'Gracian Soldiers Corpse', '', 'LineageNpc2.gracia_fsoldier_corpse', 15.00, 23.00, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7080, 32770, 'Gracian Soldiers Corpse', '', 'LineageNpc2.gracia_feofficer_corpse', 15.00, 23.00, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7081, 32771, 'Gracian Soldiers Corpse', '', 'LineageNpc2.gracia_meofficer_corpse', 15.00, 23.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7082, 32772, 'Gracian Soldiers Corpse', '', 'LineageNpc2.gracia_ocommander_corpse', 25.00, 27.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7083, 32773, 'Jakan', '', 'LineageNpc2.gracia_ocommander_pole', 15.00, 27.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 43, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7084, 32774, 'Elmina', '', 'LineageNpc2.gracia_fsoldier_1hs', 8.00, 23.00, 80, 'female', 'L2Merchant', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 48, 180, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7085, 32775, 'Gracian Soldier', '', 'LineageNPC2.gracia_remnants_a', 9.50, 22.50, 80, 'female', 'L2TerrainObject', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7086, 32776, 'Gracian Soldier', '', 'LineageNPC2.gracia_remnants_b', 9.50, 22.50, 80, 'female', 'L2TerrainObject', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7087, 32777, 'Battalion Leader', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 80, 641, 0, 30, 160, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7088, 32778, 'Legionnaire', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 9813, 9813, 0, 40, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7089, 32779, 'Airship Controller', '', 'LineageNpcEV.riding_control_unit', 19.00, 28.00, 80, 'female', 'L2AirShipController', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7090, 32780, 'Aquilani', '', 'human', 8.00, 23.00, 80, 'male', 'L2Aquilani', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7091, 32781, 'Jinia ', '', 'human', 11.00, 23.50, 80, 'female', 'L2Jinia', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 40, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7092, 32782, 'Lionel', '', 'LineageNpcEV.riding_control_unit', 19.00, 28.00, 80, 'female', 'L2Merchant', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7093, 32783, 'Priest of Blessing', '', 'LineageNPC.a_temple_master_Mhuman', 8.00, 22.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (32804, 32804, 'Relic Watcher', '', 'LineageMonster2.youth_buffalo', 16.00, 20.20, 84, 'male', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 79302, 8101, 1962, 619, 1353, 412, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32805, 32805, 'Relic Watcher', '', 'LineageMonster2.buffalo', 22.00, 20.20, 84, 'male', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 13050, 1342, 1962, 619, 1353, 412, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32806, 32806, 'Relic Watcher', '', 'LineageMonster2.buffalo', 22.00, 20.20, 84, 'male', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 83904, 7596, 1962, 619, 1353, 412, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32807, 32807, 'Relic Watcher', '', 'LineageMonster5.baby_bionic_bear', 9.00, 20.20, 84, 'male', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 12929, 1379, 1962, 619, 1353, 412, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32815, 32815, 'Odd Globe', '', 'LineageNPC.a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32816, 32816, 'Teleport Control Device', '', 'LineageMonster2.youth_buffalo', 16.00, 25.20, 84, 'male', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 79302, 8101, 1962, 619, 1353, 412, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32817, 32817, 'Teleport Control Device', '', 'LineageMonster2.buffalo', 22.00, 31.00, 84, 'male', 'L2Npc', 'Fighter', 40, 4039, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 13050, 1342, 1962, 619, 1353, 412, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32818, 32818, 'Teleport Control Device', '', 'LineageMonster2.buffalo', 22.00, 31.00, 84, 'male', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 83904, 7596, 1962, 619, 1353, 412, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32819, 32819, 'Teleport Control Device', '', 'LineageMonster5.baby_bionic_bear', 9.00, 12.50, 84, 'male', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 12929, 1379, 1962, 619, 1353, 412, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32821, 32821, 'Reading Desk', '', 'LineageMonster5.baby_bionic_bear_e', 9.00, 52.00, 84, 'male', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 20911, 2111, 1962, 619, 1353, 412, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32822, 32822, 'Reading Desk', '', 'LineageMonster5.baby_bionic_bear_e', 9.00, 52.00, 84, 'male', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 27445, 2908, 1962, 619, 1353, 412, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32823, 32823, 'Reading Desk', '', 'LineageMonster2.bionic_bear', 15.00, 52.00, 84, 'male', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 9438, 957, 1962, 619, 1353, 412, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32824, 32824, 'Reading Desk', '', 'LineageMonster2.bionic_bear', 15.00, 52.00, 84, 'male', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 79302, 8101, 1962, 619, 1353, 412, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32825, 32825, 'Reading Desk', '', 'LineageMonster5.rough_bionic_bear', 42.00, 52.00, 84, 'male', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 13050, 1342, 1962, 619, 1353, 412, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32826, 32826, 'Reading Desk', '', 'LineageMonster5.rough_bionic_bear', 42.00, 52.00, 84, 'male', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 83904, 7596, 1962, 619, 1353, 412, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32827, 32827, 'Reading Desk', '', 'LineageMonster2.baby_ostrich_140p_e', 12.00, 52.00, 83, 'male', 'L2Npc', 'npc', 40, 3862, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 0, 0, 1874, 609, 1292, 405, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32828, 32828, 'Reading Desk', '', 'LineageMonster2.baby_tiger_130p_e', 13.00, 52.00, 83, 'male', 'L2Npc', 'npc', 40, 3862, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 0, 0, 1874, 609, 1292, 405, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32829, 32829, 'Reading Desk', '', 'LineageMonster2.baby_buffalo_140p_e', 16.00, 52.00, 84, 'male', 'L2Npc', 'npc', 40, 3862, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 0, 0, 1962, 619, 1353, 412, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32830, 32830, 'Reading Desk', '', 'LineageMonster5.baby_bionic_bear_160p', 12.00, 52.00, 84, 'male', 'L2Npc', 'npc', 40, 3862, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 0, 0, 1962, 619, 1353, 412, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32831, 32831, 'Reading Desk', '', 'LineageMonster5.xel_mahum_warrior', 29.00, 52.00, 84, 'male', 'L2Npc', 'npc', 40, 3862, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 243976, 2243, 1962, 609, 1353, 412, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32832, 32832, 'Reading Desk', '', 'LineageMonster5.xel_mahum_warrior', 29.00, 52.00, 84, 'male', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 17662, 1884, 1962, 609, 1353, 412, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32833, 32833, 'Reading Desk', '', 'LineageMonster5.xel_mahum_sniper', 27.00, 52.00, 84, 'male', 'L2Npc', 'npc', 40, 4039, 8.500, 1812, 2.900, 40, 43, 30, 21, 20, 20, 18652, 1990, 1962, 609, 1292, 412, 278, 0, 333, 0, 0, 0, 0, 50, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.37, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32834, 32834, 'Reading Desk', '', 'LineageNpcEV.riding_control_unit', 19.00, 52.00, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32835, 32835, 'Reading Desk', '', 'e_traderB_FDwarf', 7.00, 52.00, 70, 'female', 'L2Npc', 'npc', 40, 3862, 8.400, 1494, 2.970, 40, 43, 30, 21, 20, 20, 0, 0, 1314, 471, 780, 382, 253, 0, 333, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (32836, 32836, 'Reading Desk', '', 'e_traderB_FDwarf', 7.00, 52.00, 70, 'female', 'L2Npc', 'npc', 40, 3862, 8.400, 1494, 2.970, 40, 43, 30, 21, 20, 20, 0, 0, 1314, 471, 780, 382, 253, 0, 333, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (32874, 32874, 'Lyann', 'Recipe Merchant', 'e_traderB_FDwarf', 7.00, 18.00, 70, 'female', 'L2Merchant', 'npc', 40, 3862, 8.400, 1494, 2.970, 40, 43, 30, 21, 20, 20, 0, 0, 1314, 471, 780, 382, 253, 0, 333, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (32875, 32875, 'Tahoo', 'Recipe Merchant', 'e_traderB_FDwarf', 7.00, 18.00, 70, 'female', 'L2Merchant', 'npc', 40, 3862, 8.400, 1494, 2.970, 40, 43, 30, 21, 20, 20, 0, 0, 1314, 471, 780, 382, 253, 0, 333, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (32876, 32876, 'Desian', 'Recipe Merchant', 'e_traderB_FDwarf', 7.00, 18.00, 70, 'female', 'L2Merchant', 'npc', 40, 3862, 8.400, 1494, 2.970, 40, 43, 30, 21, 20, 20, 0, 0, 1314, 471, 780, 382, 253, 0, 333, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (32877, 32877, 'Plani', 'Recipe Merchant', 'e_traderB_FDwarf', 7.00, 18.00, 70, 'female', 'L2Merchant', 'npc', 40, 3862, 8.400, 1494, 2.970, 40, 43, 30, 21, 20, 20, 0, 0, 1314, 471, 780, 382, 253, 0, 333, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (32878, 32878, 'Sparky', 'Recipe Merchant', 'e_traderB_FDwarf', 7.00, 18.00, 70, 'female', 'L2Merchant', 'npc', 40, 3862, 8.400, 1494, 2.970, 40, 43, 30, 21, 20, 20, 0, 0, 1314, 471, 780, 382, 253, 0, 333, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (32879, 32879, 'Drawin', 'Recipe Merchant', 'e_traderB_FDwarf', 7.00, 18.00, 70, 'female', 'L2Merchant', 'npc', 40, 3862, 8.400, 1494, 2.970, 40, 43, 30, 21, 20, 20, 0, 0, 1314, 471, 780, 382, 253, 0, 333, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (32880, 32880, 'Dolphren', 'Recipe Merchant', 'e_traderB_FDwarf', 7.00, 18.00, 70, 'female', 'L2Merchant', 'npc', 40, 3862, 8.400, 1494, 2.970, 40, 43, 30, 21, 20, 20, 0, 0, 1314, 471, 780, 382, 253, 0, 333, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (32881, 32881, 'Denver', 'Recipe Merchant', 'e_traderB_FDwarf', 7.00, 18.00, 70, 'female', 'L2Merchant', 'npc', 40, 3862, 8.400, 1494, 2.970, 40, 43, 30, 21, 20, 20, 0, 0, 1314, 471, 780, 382, 253, 0, 333, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (32882, 32882, 'Prouse', 'Recipe Merchant', 'e_traderB_FDwarf', 7.00, 18.00, 70, 'female', 'L2Merchant', 'npc', 40, 3862, 8.400, 1494, 2.970, 40, 43, 30, 21, 20, 20, 0, 0, 1314, 471, 780, 382, 253, 0, 333, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (32883, 32883, 'Hedinger', 'Recipe Merchant', 'e_traderB_FDwarf', 7.00, 18.00, 70, 'female', 'L2Merchant', 'npc', 40, 3862, 8.400, 1494, 2.970, 40, 43, 30, 21, 20, 20, 0, 0, 1314, 471, 780, 382, 253, 0, 333, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (32887, 32887, 'Metar', 'Recipe Merchant', 'e_traderB_FDwarf', 7.00, 18.00, 70, 'female', 'L2Merchant', 'npc', 40, 3862, 8.400, 1494, 2.970, 40, 43, 30, 21, 20, 20, 0, 0, 1314, 471, 780, 382, 253, 0, 333, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7094, 35010, 'Mercenary', '', 'a_guard_MHuman', 8.00, 24.00, 67, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 449, 1, 975, 440, 666, 321, 253, 0, 506, 128, 628, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 20, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7095, 35011, 'Mercenary', '', 'a_guard_MHuman', 8.00, 24.00, 67, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 449, 1, 975, 440, 666, 321, 253, 0, 506, 93, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7096, 35012, 'Mercenary', '', 'a_guard_MHuman', 8.00, 24.00, 67, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 449, 1, 975, 440, 666, 321, 253, 0, 506, 280, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7097, 35013, 'Mercenary', '', 'a_royal_guardA_MHuman', 8.00, 23.50, 67, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 449, 1, 975, 440, 666, 321, 253, 0, 506, 316, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7098, 35014, 'Mercenary', '', 'a_royal_guardA_MHuman', 8.00, 23.00, 67, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 449, 1, 975, 440, 666, 321, 253, 0, 506, 179, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7099, 35015, 'Mercenary', '', 'a_guard_MHuman', 8.00, 24.00, 67, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 449, 1, 975, 440, 666, 321, 253, 0, 506, 128, 628, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 20, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7100, 35016, 'Mercenary', '', 'a_guard_MHuman', 8.00, 24.00, 67, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 449, 1, 975, 440, 666, 321, 253, 0, 506, 93, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7101, 35017, 'Mercenary', '', 'a_guard_MHuman', 8.00, 24.00, 67, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 449, 1, 975, 440, 666, 321, 253, 0, 506, 280, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7102, 35018, 'Mercenary', '', 'a_royal_guardA_MHuman', 8.00, 23.50, 67, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 449, 1, 975, 440, 666, 321, 253, 0, 506, 316, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7103, 35019, 'Mercenary', '', 'a_royal_guardA_MHuman', 8.00, 23.00, 67, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2295, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 449, 1, 975, 440, 666, 321, 253, 0, 506, 179, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7104, 35020, 'Mercenary of Dawn', '', 'a_guard_MHuman', 8.00, 23.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 640, 1, 1641, 576, 1120, 423, 253, 0, 506, 150, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7105, 35021, 'Mercenary of Dawn', '', 'a_guard_MHuman', 8.00, 23.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 640, 1, 1641, 576, 1120, 423, 253, 0, 506, 97, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7106, 35022, 'Mercenary of Dawn', '', 'a_guard_MHuman', 8.00, 23.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 640, 1, 1641, 576, 1120, 423, 253, 0, 506, 288, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7107, 35023, 'Mercenary of Dawn', '', 'a_royal_guardA_MHuman', 8.00, 23.00, 80, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 640, 1, 1641, 576, 1120, 423, 253, 0, 506, 325, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7108, 35024, 'Mercenary of Dawn', '', 'a_royal_guardA_MHuman', 8.00, 24.00, 80, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 640, 1, 1641, 576, 1120, 423, 253, 0, 506, 196, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7109, 35025, 'Mercenary of Dawn', '', 'a_guard_MHuman', 8.00, 23.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 640, 1, 1641, 576, 1120, 423, 253, 0, 506, 150, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7110, 35026, 'Mercenary of Dawn', '', 'a_guard_MHuman', 8.00, 23.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 640, 1, 1641, 576, 1120, 423, 253, 0, 506, 97, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7111, 35027, 'Mercenary of Dawn', '', 'a_guard_MHuman', 8.00, 23.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 640, 1, 1641, 576, 1120, 423, 253, 0, 506, 288, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7112, 35028, 'Mercenary of Dawn', '', 'a_royal_guardA_MHuman', 8.00, 23.00, 80, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 640, 1, 1641, 576, 1120, 423, 253, 0, 506, 325, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7113, 35029, 'Mercenary of Dawn', '', 'a_royal_guardA_MHuman', 8.00, 24.00, 80, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 640, 1, 1641, 576, 1120, 423, 253, 0, 506, 196, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7114, 35030, 'Elite Mercenary Guild Member', '', 'a_guard_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 578, 1, 1360, 535, 929, 391, 253, 0, 506, 132, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7115, 35031, 'Elite Mercenary Guild Member', '', 'a_guard_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 578, 1, 1360, 535, 929, 391, 253, 0, 506, 301, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7116, 35032, 'Elite Mercenary Guild Member', '', 'a_guard_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 578, 1, 1360, 535, 929, 391, 253, 0, 506, 280, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7117, 35033, 'Elite Mercenary Guild Member', '', 'a_royal_guardA_MHuman', 8.00, 22.50, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 578, 1, 1360, 535, 929, 391, 253, 0, 506, 316, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7118, 35034, 'Elite Mercenary Guild Member', '', 'a_royal_guardA_MHuman', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 578, 1, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7119, 35035, 'Elite Mercenary Guild Member', '', 'a_guard_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 578, 1, 1360, 535, 929, 391, 253, 0, 506, 132, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7120, 35036, 'Elite Mercenary Guild Member', '', 'a_guard_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 578, 1, 1360, 535, 929, 391, 253, 0, 506, 301, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7121, 35037, 'Elite Mercenary Guild Member', '', 'a_guard_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 578, 1, 1360, 535, 929, 391, 253, 0, 506, 280, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7122, 35038, 'Elite Mercenary Guild Member', '', 'a_royal_guardA_MHuman', 8.00, 22.50, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 578, 1, 1360, 535, 929, 391, 253, 0, 506, 316, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7123, 35039, 'Elite Mercenary Guild Member', '', 'a_royal_guardA_MHuman', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 578, 1, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7124, 35040, 'Greater Recruit', '', 'a_guard_MHuman', 8.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 518, 1, 1179, 491, 805, 359, 253, 0, 506, 66, 20, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 20, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7125, 35041, 'Greater Recruit', '', 'a_guard_MHuman', 8.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 518, 1, 1179, 491, 805, 359, 253, 0, 506, 16, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7126, 35042, 'Greater Recruit', '', 'a_guard_MHuman', 8.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 518, 1, 1179, 491, 805, 359, 253, 0, 506, 274, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7127, 35043, 'Greater Recruit', '', 'a_royal_guardA_MHuman', 8.00, 23.50, 72, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2540, 8.500, 1410, 3.000, 22, 27, 21, 41, 20, 20, 518, 1, 1179, 491, 805, 359, 253, 0, 506, 7, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7128, 35044, 'Greater Recruit', '', 'a_royal_guardA_MHuman', 8.00, 23.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2540, 8.500, 1410, 3.000, 22, 27, 21, 41, 20, 20, 518, 1, 1179, 491, 805, 359, 253, 0, 506, 154, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7129, 35045, 'Greater Recruit', '', 'a_guard_MHuman', 8.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 518, 1, 1179, 491, 805, 359, 253, 0, 506, 66, 20, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 20, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7130, 35046, 'Greater Recruit', '', 'a_guard_MHuman', 8.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 518, 1, 1179, 491, 805, 359, 253, 0, 506, 16, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7131, 35047, 'Greater Recruit', '', 'a_guard_MHuman', 8.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 518, 1, 1179, 491, 805, 359, 253, 0, 506, 274, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7132, 35048, 'Greater Recruit', '', 'a_royal_guardA_MHuman', 8.00, 23.50, 72, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2540, 8.500, 1410, 3.000, 22, 27, 21, 41, 20, 20, 518, 1, 1179, 491, 805, 359, 253, 0, 506, 7, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7133, 35049, 'Greater Recruit', '', 'a_royal_guardA_MHuman', 8.00, 23.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2540, 8.500, 1410, 3.000, 22, 27, 21, 41, 20, 20, 518, 1, 1179, 491, 805, 359, 253, 0, 506, 154, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7134, 35050, 'Recruit', '', 'a_guard_MHuman', 8.00, 24.00, 64, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 410, 1, 860, 409, 588, 298, 253, 0, 506, 66, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7135, 35051, 'Recruit', '', 'a_guard_MHuman', 8.00, 24.00, 64, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 410, 1, 860, 409, 588, 298, 253, 0, 506, 16, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7136, 35052, 'Recruit', '', 'a_guard_MHuman', 8.00, 24.00, 64, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 410, 1, 860, 409, 588, 298, 253, 0, 506, 14, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7137, 35053, 'Recruit', '', 'a_royal_guardA_MHuman', 8.00, 24.50, 64, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2142, 7.500, 1158, 2.700, 22, 27, 21, 41, 20, 20, 410, 1, 860, 409, 588, 298, 253, 0, 506, 6, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7138, 35054, 'Recruit', '', 'a_royal_guardA_MHuman', 8.00, 23.00, 64, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2142, 7.500, 1158, 2.700, 22, 27, 21, 41, 20, 20, 410, 1, 860, 409, 588, 298, 253, 0, 506, 99, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7139, 35055, 'Recruit', '', 'a_guard_MHuman', 8.00, 24.00, 64, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 410, 1, 860, 409, 588, 298, 253, 0, 506, 66, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7140, 35056, 'Recruit', '', 'a_guard_MHuman', 8.00, 24.00, 64, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 410, 1, 860, 409, 588, 298, 253, 0, 506, 16, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7141, 35057, 'Recruit', '', 'a_guard_MHuman', 8.00, 24.00, 64, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2142, 7.500, 1158, 2.700, 40, 43, 30, 21, 20, 20, 410, 1, 860, 409, 588, 298, 253, 0, 506, 14, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7142, 35058, 'Recruit', '', 'a_royal_guardA_MHuman', 8.00, 24.50, 64, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2142, 7.500, 1158, 2.700, 22, 27, 21, 41, 20, 20, 410, 1, 860, 409, 588, 298, 253, 0, 506, 6, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7143, 35059, 'Recruit', '', 'a_royal_guardA_MHuman', 8.00, 23.00, 64, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2142, 7.500, 1158, 2.700, 22, 27, 21, 41, 20, 20, 410, 1, 860, 409, 588, 298, 253, 0, 506, 99, 0, 0, 50, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7144, 35060, 'Nephilim Mercenary', '', 'a_guard_MHuman', 12.00, 24.50, 85, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 596964, 981.000, 1663, 3.000, 40, 43, 30, 21, 20, 20, 723, 1, 5081, 630, 10410, 461, 253, 0, 506, 2500, 6377, 0, 36, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7145, 35061, 'Nephilim Mercenary', '', 'a_royal_guardA_MHuman', 6.50, 21.96, 82, 'female', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 585704, 989.000, 1561, 3.000, 22, 27, 21, 41, 20, 20, 672, 1, 4624, 599, 9473, 438, 253, 0, 506, 8687, 0, 0, 33, 195, 'mercenary_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7146, 35062, 'Headquarters', '', 'flag_a', 10.00, 80.00, 1, 'etc', 'L2Npc', 'npc', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 50, 120, '', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7147, 35063, 'Gludio Holy Artifact', '', 'castle_kent_statue_jewel', 25.00, 98.00, 20, 'etc', 'L2Artefact', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7148, 35064, 'Baron Lewin Waldner', '', 'a_lord_MHuman', 7.00, 23.00, 83, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 38356, 8.500, 5332, 3.000, 40, 43, 30, 21, 20, 20, 689, 1, 5673, 609, 1292, 445, 253, 0, 506, 79, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7149, 35065, 'Cronenberg', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 81, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 34618, 8.500, 5126, 3.000, 40, 43, 30, 21, 20, 20, 656, 1, 5163, 588, 1175, 430, 253, 0, 506, 142, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7150, 35066, 'Royal Knight', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 79, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 624, 1, 1562, 566, 1067, 415, 253, 0, 506, 76, 2497, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 20, 124, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7151, 35067, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 22.50, 77, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 325, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7152, 35068, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 23.00, 77, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 193, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7153, 35069, 'Court Guard', '', 'a_royal_guardB_MHuman', 7.00, 24.00, 77, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 94, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7154, 35070, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7155, 35071, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2499, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7156, 35072, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 276, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7157, 35073, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7158, 35074, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7159, 35075, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7160, 35076, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7161, 35077, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7162, 35078, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7163, 35079, 'Royal Knight', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 79, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 624, 1, 1562, 566, 1067, 415, 253, 0, 506, 76, 2497, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 20, 124, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7164, 35080, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 22.50, 77, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 325, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7165, 35081, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 23.00, 77, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 193, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7166, 35082, 'Court Guard', '', 'a_royal_guardB_MHuman', 7.00, 24.00, 77, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 94, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7167, 35083, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 93, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7168, 35084, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2499, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7169, 35085, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 276, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7170, 35086, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7171, 35087, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7172, 35088, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7173, 35089, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7174, 35090, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7175, 35091, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7176, 35092, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 1, 'gludio_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7177, 35093, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 1, 'gludio_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7178, 35094, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 1, 'gludio_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7179, 35095, 'Mass Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7180, 35096, 'Outer Doorman', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7181, 35097, 'Inner Doorman', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7182, 35098, 'Blacksmith', '', 'e_smith_master_MDwarf', 7.00, 16.50, 75, 'male', 'L2CastleBlacksmith', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7183, 35099, 'Warehouse Keeper', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 75, 'male', 'L2CastleWarehouse', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7184, 35100, 'Sayres', '', 'a_chamberlain_MHuman', 9.50, 22.50, 75, 'male', 'L2CastleChamberlain', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7185, 35101, 'Grad', '', 'a_traderB_MHuman', 8.00, 25.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7186, 35102, 'Greenspan', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 75, 'male', 'L2MercManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7187, 35103, 'Manor Manager', '', 'a_chamberlain_MHuman', 9.50, 22.50, 75, 'male', 'L2ManorManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7188, 35104, 'Tyron', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleMessenger', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 74, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7189, 35105, 'Dion Holy Artifact', '', 'castle_kent_statue_jewel', 25.00, 98.00, 20, 'etc', 'L2Artefact', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 40, 10, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7190, 35106, 'Duke Byron Ashton', '', 'a_lord_MHuman', 7.00, 23.00, 83, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 38356, 8.500, 5332, 3.000, 40, 43, 30, 21, 20, 20, 689, 1, 5673, 609, 1292, 445, 253, 0, 506, 79, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7191, 35107, 'Ivano', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 81, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 34618, 8.500, 5126, 3.000, 40, 43, 30, 21, 20, 20, 656, 1, 5163, 588, 1175, 430, 253, 0, 506, 142, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7192, 35108, 'Royal Knight', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 79, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 624, 1, 1562, 566, 1067, 415, 253, 0, 506, 76, 2497, 0, 50, 120, 'dion_siege_clan', 1200, 0, 20, 124, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7193, 35109, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 22.50, 77, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 325, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7194, 35110, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 23.00, 77, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 193, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7195, 35111, 'Court Guard', '', 'a_royal_guardB_MHuman', 7.00, 24.00, 77, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 94, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7196, 35112, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7197, 35113, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2499, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7198, 35114, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 276, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7199, 35115, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7200, 35116, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7201, 35117, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7202, 35118, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7203, 35119, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7204, 35120, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7205, 35121, 'Royal Knight', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 79, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 624, 1, 1562, 566, 1067, 415, 253, 0, 506, 76, 2497, 0, 50, 120, 'dion_siege_clan', 1200, 0, 20, 124, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7206, 35122, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 22.50, 77, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 325, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7207, 35123, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 23.00, 77, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 193, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7208, 35124, 'Court Guard', '', 'a_royal_guardB_MHuman', 7.00, 24.00, 77, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 94, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7209, 35125, 'Court Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 93, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7210, 35126, 'Court Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2499, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7211, 35127, 'Court Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 276, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7212, 35128, 'Court Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7213, 35129, 'Court Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7214, 35130, 'Court Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7215, 35131, 'Court Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7216, 35132, 'Court Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7217, 35133, 'Court Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7218, 35134, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7219, 35135, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7220, 35136, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7221, 35137, 'Mass Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7222, 35138, 'Outer Doorman', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7223, 35139, 'Inner Doorman', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7224, 35140, 'Blacksmith', '', 'e_smith_master_MDwarf', 7.00, 16.50, 75, 'male', 'L2CastleBlacksmith', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7225, 35141, 'Warehouse Keeper', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 75, 'male', 'L2CastleWarehouse', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7226, 35142, 'Crosby', '', 'a_chamberlain_MHuman', 9.50, 22.50, 75, 'male', 'L2CastleChamberlain', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7227, 35143, 'Hodler', '', 'a_traderB_MHuman', 8.00, 25.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7228, 35144, 'Mercenary Manager Sanford', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 75, 'male', 'L2MercManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7229, 35145, 'Manor Manager', '', 'a_chamberlain_MHuman', 9.50, 22.50, 75, 'male', 'L2ManorManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7230, 35146, 'Gibbson', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleMessenger', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 74, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7231, 35147, 'Giran Holy Artifact', '', 'castle_kent_statue_jewel', 25.00, 98.00, 20, 'etc', 'L2Artefact', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 40, 10, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7232, 35148, 'Baron Carmon Esthus', '', 'a_lord_MHuman', 7.00, 23.00, 83, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 38356, 8.500, 5332, 3.000, 40, 43, 30, 21, 20, 20, 689, 1, 5673, 609, 1292, 445, 253, 0, 506, 79, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7233, 35149, 'Ulric', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 81, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 34618, 8.500, 5126, 3.000, 40, 43, 30, 21, 20, 20, 656, 1, 5163, 588, 1175, 430, 253, 0, 506, 142, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7234, 35150, 'Royal Knight', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 79, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 624, 1, 1562, 566, 1067, 415, 253, 0, 506, 76, 2497, 0, 50, 120, 'giran_siege_clan', 1200, 0, 20, 124, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7235, 35151, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 22.50, 77, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 325, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7236, 35152, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 23.00, 77, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 193, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7237, 35153, 'Court Guard', '', 'a_royal_guardB_MHuman', 7.00, 24.00, 77, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 94, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7238, 35154, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7239, 35155, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2499, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7240, 35156, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 276, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7241, 35157, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7242, 35158, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7243, 35159, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7244, 35160, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7245, 35161, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7246, 35162, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7247, 35163, 'Royal Knight', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 79, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 624, 1, 1562, 566, 1067, 415, 253, 0, 506, 76, 2497, 0, 50, 120, 'giran_siege_clan', 1200, 0, 20, 124, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7248, 35164, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 22.50, 77, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 325, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7249, 35165, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 23.00, 77, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 193, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7250, 35166, 'Court Guard', '', 'a_royal_guardB_MHuman', 7.00, 24.00, 77, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 94, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7251, 35167, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 93, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7252, 35168, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2499, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7253, 35169, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 276, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7254, 35170, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7255, 35171, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7256, 35172, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7257, 35173, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7258, 35174, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7259, 35175, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7260, 35176, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'giran_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7261, 35177, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'giran_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7262, 35178, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'giran_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7263, 35179, 'Mass Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7264, 35180, 'Outer Doorman', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7265, 35181, 'Inner Doorman', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7266, 35182, 'Blacksmith', '', 'a_smith_MDwarf', 7.00, 16.50, 75, 'male', 'L2CastleBlacksmith', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7267, 35183, 'Warehouse Keeper', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 75, 'male', 'L2CastleWarehouse', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7268, 35184, 'Saul', '', 'a_chamberlain_MHuman', 9.50, 22.50, 75, 'male', 'L2CastleChamberlain', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7269, 35185, 'Bryce', '', 'a_traderB_MHuman', 8.00, 25.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7270, 35186, 'Arvid', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 75, 'male', 'L2MercManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7271, 35187, 'Manor Manager', '', 'a_chamberlain_MHuman', 9.50, 22.50, 75, 'male', 'L2ManorManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7272, 35188, 'Holmes', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleMessenger', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 74, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7273, 35189, 'Oren Holy Artifact', '', 'castle_kent_statue_jewel', 25.00, 98.00, 20, 'etc', 'L2Artefact', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 40, 10, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7274, 35190, 'Balthus Van Dyke', '', 'a_lord_MHuman', 7.00, 23.00, 83, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 38356, 8.500, 5332, 3.000, 40, 43, 30, 21, 20, 20, 689, 1, 5673, 609, 1292, 445, 253, 0, 506, 79, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7275, 35191, 'Quant', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 81, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 34618, 8.500, 5126, 3.000, 40, 43, 30, 21, 20, 20, 656, 1, 5163, 588, 1175, 430, 253, 0, 506, 142, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7276, 35192, 'Royal Knight', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 79, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 624, 1, 1562, 566, 1067, 415, 253, 0, 506, 76, 2497, 0, 50, 120, 'oren_siege_clan', 1200, 0, 20, 124, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7277, 35193, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 22.50, 77, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 325, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7278, 35194, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 23.00, 77, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 193, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7279, 35195, 'Court Guard', '', 'a_royal_guardB_MHuman', 7.00, 24.00, 77, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 94, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7280, 35196, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7281, 35197, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2499, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7282, 35198, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 276, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7283, 35199, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7284, 35200, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7285, 35201, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7286, 35202, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7287, 35203, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7288, 35204, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7289, 35205, 'Royal Knight', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 79, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 624, 1, 1562, 566, 1067, 415, 253, 0, 506, 76, 2497, 0, 50, 120, 'oren_siege_clan', 1200, 0, 20, 124, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7290, 35206, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 22.50, 77, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 325, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7291, 35207, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 23.00, 77, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 193, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7292, 35208, 'Court Guard', '', 'a_royal_guardB_MHuman', 7.00, 24.00, 77, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 94, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7293, 35209, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 93, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7294, 35210, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2499, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7295, 35211, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 276, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7296, 35212, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7297, 35213, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7298, 35214, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7299, 35215, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7300, 35216, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7301, 35217, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7302, 35218, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'oren_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7303, 35219, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'oren_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7304, 35220, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'oren_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7305, 35221, 'Mass Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7306, 35222, 'Outer Doorman', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7307, 35223, 'Inner Doorman', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7308, 35224, 'Blacksmith', '', 'a_guard_MHuman', 7.00, 16.50, 75, 'male', 'L2CastleBlacksmith', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7309, 35225, 'Warehouse Keeper', '', 'a_guard_MHuman', 8.00, 17.00, 75, 'male', 'L2CastleWarehouse', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7310, 35226, 'Brasseur', '', 'a_chamberlain_MHuman', 9.50, 22.50, 75, 'male', 'L2CastleChamberlain', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7311, 35227, 'Finrod', '', 'a_royal_guardA_MHuman', 6.00, 24.50, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7312, 35228, 'Morrison', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 75, 'male', 'L2MercManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7313, 35229, 'Manor Manager', '', 'a_chamberlain_MHuman', 9.50, 22.50, 75, 'male', 'L2ManorManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7314, 35230, 'Manor Manager', '', 'a_trader_MElf', 6.00, 24.50, 75, 'male', 'L2ManorManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7315, 35231, 'Manor Manager', '', 'a_common_people_MDarkElf', 7.00, 23.00, 75, 'male', 'L2ManorManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7316, 35232, 'Sherwood', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleMessenger', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 74, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7317, 35233, 'Aden Holy Artifact', '', 'castle_kent_statue_jewel', 25.00, 98.00, 20, 'etc', 'L2Artefact', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 40, 10, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7318, 35234, 'Amadeo Cadmus', '', 'a_lord_MHuman', 7.00, 23.00, 85, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 42341, 8.500, 5540, 3.000, 40, 43, 30, 21, 20, 20, 723, 1, 6207, 630, 1413, 461, 253, 0, 506, 80, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7319, 35235, 'Royal Knight', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 81, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 34618, 8.500, 5126, 3.000, 40, 43, 30, 21, 20, 20, 656, 1, 5163, 588, 1175, 430, 253, 0, 506, 2, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7320, 35236, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 79, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 31278, 8.500, 4923, 3.000, 22, 27, 21, 41, 20, 20, 624, 1, 4687, 566, 1067, 415, 253, 0, 506, 7, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7321, 35237, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 79, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 31278, 8.500, 4923, 3.000, 22, 27, 21, 41, 20, 20, 624, 1, 4687, 566, 1067, 415, 253, 0, 506, 92, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7322, 35238, 'Court Guard', '', 'a_royal_guardB_MHuman', 7.00, 24.00, 79, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 31278, 8.500, 4923, 3.000, 40, 43, 30, 21, 20, 20, 624, 1, 4687, 566, 1067, 415, 253, 0, 506, 1376, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7323, 35239, 'Guard', '', 'a_guard_MElf', 7.00, 24.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 608, 1, 4462, 556, 1015, 406, 253, 0, 506, 300, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7324, 35240, 'Guard', '', 'a_guard_MElf', 7.00, 24.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 608, 1, 4462, 556, 1015, 406, 253, 0, 506, 132, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7325, 35241, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 78, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 608, 1, 4462, 556, 1015, 406, 253, 0, 506, 14, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7326, 35242, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 78, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 608, 1, 4462, 556, 1015, 406, 253, 0, 506, 16, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7327, 35243, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 78, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 608, 1, 4462, 556, 1015, 406, 253, 0, 506, 2, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7328, 35244, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 78, 'female', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 608, 1, 4462, 556, 1015, 406, 253, 0, 506, 14, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7329, 35245, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 608, 1, 4462, 556, 1015, 406, 253, 0, 506, 16, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7330, 35246, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 608, 1, 4462, 556, 1015, 406, 253, 0, 506, 2, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7331, 35247, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 608, 1, 4462, 556, 1015, 406, 253, 0, 506, 14, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7332, 35248, 'Royal Knight', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 81, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 34618, 8.500, 5126, 3.000, 40, 43, 30, 21, 20, 20, 656, 1, 5163, 588, 1175, 430, 253, 0, 506, 142, 633, 0, 50, 120, 'aden_siege_clan', 1200, 0, 20, 148, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7333, 35249, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 22.50, 79, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 31278, 8.500, 4923, 3.000, 22, 27, 21, 41, 20, 20, 624, 1, 4687, 566, 1067, 415, 253, 0, 506, 326, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7334, 35250, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 23.00, 79, 'female', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 31278, 8.500, 4923, 3.000, 22, 27, 21, 41, 20, 20, 624, 1, 4687, 566, 1067, 415, 253, 0, 506, 325, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7335, 35251, 'Court Guard', '', 'a_royal_guardB_MHuman', 7.00, 24.00, 79, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 31278, 8.500, 4923, 3.000, 40, 43, 30, 21, 20, 20, 624, 1, 4687, 566, 1067, 415, 253, 0, 506, 300, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7336, 35252, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 608, 1, 4462, 556, 1015, 406, 253, 0, 506, 16, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7337, 35253, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 608, 1, 4462, 556, 1015, 406, 253, 0, 506, 2, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7338, 35254, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 78, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 608, 1, 4462, 556, 1015, 406, 253, 0, 506, 285, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7339, 35255, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 78, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 608, 1, 4462, 556, 1015, 406, 253, 0, 506, 16, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7340, 35256, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 78, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 608, 1, 4462, 556, 1015, 406, 253, 0, 506, 2, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7341, 35257, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 78, 'female', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 608, 1, 4462, 556, 1015, 406, 253, 0, 506, 14, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7342, 35258, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 608, 1, 4462, 556, 1015, 406, 253, 0, 506, 16, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7343, 35259, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 608, 1, 4462, 556, 1015, 406, 253, 0, 506, 2, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7344, 35260, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 608, 1, 4462, 556, 1015, 406, 253, 0, 506, 14, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7345, 35261, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'aden_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7346, 35262, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'aden_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7347, 35263, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'aden_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7348, 35264, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'aden_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7349, 35265, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'aden_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7350, 35266, 'Mass Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7351, 35267, 'Outer Doorman', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7352, 35268, 'Inner Doorman', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7353, 35269, 'Hall Doorman', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7354, 35270, 'Inner Doorman', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7355, 35271, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7356, 35272, 'Blacksmith', '', 'a_guard_FDarkelf', 7.00, 16.50, 75, 'male', 'L2CastleBlacksmith', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7357, 35273, 'Warehouse Keeper', '', 'a_guard_FDarkelf', 8.00, 17.00, 75, 'male', 'L2CastleWarehouse', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7358, 35274, 'Logan', '', 'a_chamberlain_MHuman', 9.50, 22.50, 75, 'male', 'L2CastleChamberlain', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7359, 35275, 'Kruger', '', 'a_guard_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7360, 35276, 'Eldon', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 75, 'male', 'L2MercManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7361, 35277, 'Manor Manager', '', 'a_guard_MHuman', 9.50, 22.50, 75, 'male', 'L2ManorManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7362, 35278, 'Messenger Ruford', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleMessenger', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 135, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7363, 35279, 'Innadril Holy Artifact', '', 'castle_kent_statue_jewel', 25.00, 98.00, 20, 'etc', 'L2Artefact', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 40, 10, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7364, 35280, 'Baron Lionel Hunter', '', 'a_lord_MHuman', 7.00, 23.00, 83, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 38356, 8.500, 5332, 3.000, 40, 43, 30, 21, 20, 20, 689, 1, 5673, 609, 1292, 445, 253, 0, 506, 79, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7365, 35281, 'Schaht', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 81, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 34618, 8.500, 5126, 3.000, 40, 43, 30, 21, 20, 20, 656, 1, 5163, 588, 1175, 430, 253, 0, 506, 142, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7366, 35282, 'Royal Knight', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 79, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 624, 1, 1562, 566, 1067, 415, 253, 0, 506, 76, 2497, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 20, 124, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7367, 35283, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 22.50, 77, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 325, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7368, 35284, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 23.00, 77, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 193, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7369, 35285, 'Court Guard', '', 'a_royal_guardB_MHuman', 7.00, 24.00, 77, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 94, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7370, 35286, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7371, 35287, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2499, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7372, 35288, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 276, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7373, 35289, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7374, 35290, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7375, 35291, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7376, 35292, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7377, 35293, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7378, 35294, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7379, 35295, 'Royal Knight', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 79, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 624, 1, 1562, 566, 1067, 415, 253, 0, 506, 76, 2497, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 20, 124, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7380, 35296, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 22.50, 77, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 325, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7381, 35297, 'Court Sorcerer', '', 'a_royal_guardA_MHuman', 8.00, 23.00, 77, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 193, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7382, 35298, 'Court Guard', '', 'a_royal_guardB_MHuman', 7.00, 24.00, 77, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 94, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7383, 35299, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 93, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7384, 35300, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2499, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7385, 35301, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 276, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7386, 35302, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7387, 35303, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7388, 35304, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7389, 35305, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7390, 35306, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7391, 35307, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7392, 35308, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'innadrile_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7393, 35309, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'innadrile_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7394, 35310, 'Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'innadrile_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7395, 35311, 'Mass Gatekeeper', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7396, 35312, 'Outer Doorman', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7397, 35313, 'Inner Doorman', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7398, 35314, 'Blacksmith', '', 'a_smith_MDwarf', 7.00, 16.50, 75, 'male', 'L2CastleBlacksmith', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7399, 35315, 'Warehouse Keeper', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 75, 'male', 'L2CastleWarehouse', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7400, 35316, 'Neurath', '', 'a_chamberlain_MHuman', 9.50, 22.50, 75, 'male', 'L2CastleChamberlain', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7401, 35317, 'Tate', '', 'a_traderB_MHuman', 8.00, 25.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7402, 35318, 'Solinus', '', 'a_common_peopleA_MHuman', 8.00, 21.50, 75, 'male', 'L2MercManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7403, 35319, 'Manor Manager', '', 'a_chamberlain_MHuman', 9.50, 22.50, 75, 'male', 'L2ManorManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7404, 35320, 'Raybell', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2CastleMessenger', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 74, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7405, 35322, 'Altar of Fire', '', 'godad_holything', 34.00, 65.00, 20, 'etc', 'L2Artefact', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7406, 35323, 'Altar of Water', '', 'godad_holything', 34.00, 65.00, 20, 'etc', 'L2Artefact', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7407, 35324, 'Heinz', '', 'teleport_cube', 8.00, 23.50, 81, 'male', 'L2Merchant', 'npc', 40, 34618, 8.500, 5126, 3.000, 40, 43, 30, 21, 20, 20, 656, 1, 5163, 588, 1175, 430, 253, 0, 506, 142, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7408, 35325, 'Duke Mora Ken Abygail', '', 'a_lord_MHuman', 7.00, 23.00, 83, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 38356, 8.500, 5332, 3.000, 40, 43, 30, 21, 20, 20, 689, 1, 5673, 609, 1292, 445, 253, 0, 506, 79, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7409, 35326, 'Royal Knight', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 79, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 624, 1, 1562, 566, 1067, 415, 253, 0, 506, 76, 2497, 0, 50, 120, 'godad_siege_clan', 1200, 0, 20, 124, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7410, 35327, 'Court Sorcerer', '', 'a_patriarch_MElf', 8.00, 22.50, 77, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 325, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7411, 35328, 'Court Sorcerer', '', 'a_mageguild_master_FHuman', 8.00, 23.00, 77, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 193, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7412, 35329, 'Guard', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 77, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 1376, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7413, 35330, 'Bodyguard', '', 'e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 93, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7414, 35331, 'Bodyguard', '', 'e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7415, 35332, 'Bodyguard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7416, 35333, 'Bodyguard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7417, 35334, 'Bodyguard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7418, 35335, 'Bodyguard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7419, 35336, 'Bodyguard', '', 'e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7420, 35337, 'Bodyguard', '', 'e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7421, 35338, 'Bodyguard', '', 'a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 280, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7422, 35339, 'Royal Knight', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 79, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 624, 1, 1562, 566, 1067, 415, 253, 0, 506, 76, 2497, 0, 50, 120, 'godad_siege_clan', 1200, 0, 20, 124, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7423, 35340, 'Court Sorcerer', '', 'a_patriarch_MElf', 8.00, 22.50, 77, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 325, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7424, 35341, 'Court Sorcerer', '', 'a_mageguild_master_FHuman', 8.00, 23.00, 77, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 193, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7425, 35342, 'Guard', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 77, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 593, 1, 1421, 544, 971, 398, 253, 0, 506, 1376, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7426, 35343, 'Bodyguard', '', 'e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 93, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7427, 35344, 'Bodyguard', '', 'e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7428, 35345, 'Bodyguard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7429, 35346, 'Bodyguard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7430, 35347, 'Bodyguard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7431, 35348, 'Bodyguard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7432, 35349, 'Bodyguard', '', 'e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7433, 35350, 'Bodyguard', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 76, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7434, 35351, 'Bodyguard', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 1, 1304, 523, 891, 384, 253, 0, 506, 280, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7435, 35352, 'Gatekeeper', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'godad_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7436, 35353, 'Gatekeeper', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'godad_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7437, 35354, 'Gatekeeper', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'godad_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7438, 35355, 'Mass Gatekeeper', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7439, 35356, 'Outer Doorman', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7440, 35357, 'Inner Doorman', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7441, 35358, 'Inner Doorman', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7442, 35359, 'Gatekeeper', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7443, 35360, 'Gatekeeper', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7444, 35361, 'Blacksmith', '', 'a_smith_MDwarf', 7.00, 16.50, 75, 'male', 'L2CastleBlacksmith', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7445, 35362, 'Warehouse Keeper', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 75, 'male', 'L2CastleWarehouse', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7446, 35363, 'Alfred', '', 'a_chamberlain_MHuman', 9.50, 22.50, 75, 'male', 'L2CastleChamberlain', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7447, 35364, 'Hadley', '', 'a_common_peopleC_Mhuman', 10.00, 24.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7448, 35365, 'Rowell', '', 'a_common_peopleC_Mhuman', 10.00, 24.00, 75, 'male', 'L2MercManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7449, 35366, 'Manor Manager', '', 'a_chamberlain_MHuman', 9.50, 22.50, 75, 'male', 'L2ManorManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7450, 35367, 'Daven', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleMessenger', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 74, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7451, 35368, 'Bloody Lord Nurka', '', 'oel_mahum', 20.00, 37.00, 73, 'male', 'L2SiegeBoss', 'Fighter', 40, 1150000, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 2665, 1, 1220, 502, 833, 368, 253, 0, 506, 72, 0, 0, 70, 110, 'partisan_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7452, 35369, 'Partisan Healer', '', 'batur_orc_shaman', 11.00, 16.00, 70, 'male', 'L2SiegeGuard', 'Priest', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 2450, 1, 1096, 471, 747, 345, 253, 0, 506, 7, 0, 0, 50, 120, 'partisan_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7453, 35370, 'Partisan Court Guard', '', 'ol_mahum_champion', 14.00, 27.00, 70, 'male', 'L2SiegeGuard', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 2450, 1, 1096, 471, 747, 345, 253, 0, 506, 69, 0, 0, 50, 110, 'partisan_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7454, 35371, 'Partisan Court Guard', '', 'ol_mahum_archer', 14.00, 25.00, 70, 'male', 'L2SiegeGuard', 'Ranger', 1100, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 2450, 1, 1096, 471, 747, 345, 253, 0, 506, 14, 0, 0, 50, 110, 'partisan_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.93, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7455, 35372, 'Partisan Soldier', '', 'ol_mahum', 13.50, 25.00, 68, 'male', 'L2SiegeGuard', 'Fighter', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 2312, 1, 1014, 449, 692, 330, 253, 0, 506, 2, 0, 0, 50, 110, 'partisan_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7456, 35373, 'Partisan Sorcerer', '', 'batur_orc_shaman', 11.00, 16.00, 68, 'male', 'L2SiegeGuard', 'Mystic', 40, 2346, 7.500, 1282, 2.700, 22, 27, 21, 41, 20, 20, 2312, 1, 1014, 449, 692, 330, 253, 0, 506, 7, 0, 0, 50, 120, 'partisan_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7457, 35374, 'Partisan Archer', '', 'ol_mahum_archer', 14.00, 25.00, 68, 'male', 'L2SiegeGuard', 'Ranger', 1100, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 2312, 1, 1014, 449, 692, 330, 253, 0, 506, 14, 0, 0, 50, 110, 'partisan_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.93, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7458, 35375, 'Bloody Lord Nurka', '', 'oel_mahum', 20.00, 37.00, 73, 'male', 'L2SpecialMonster', 'Fighter', 40, 1150000, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 2665, 1, 1220, 502, 833, 368, 253, 0, 506, 72, 0, 0, 70, 110, 'partisan_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7459, 35376, 'Partisan Healer', '', 'batur_orc_shaman', 11.00, 16.00, 70, 'male', 'L2SpecialMonster', 'Priest', 40, 2444, 7.500, 1346, 2.700, 22, 27, 21, 41, 20, 20, 2450, 1, 1096, 471, 747, 345, 253, 0, 506, 7, 0, 0, 50, 120, 'partisan_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7460, 35377, 'Partisan Court Guard', '', 'ol_mahum_champion', 14.00, 27.00, 70, 'male', 'L2SpecialMonster', 'Fighter', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 2450, 1, 1096, 471, 747, 345, 253, 0, 506, 69, 0, 0, 50, 110, 'partisan_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7461, 35378, 'Partisan Court Guard', '', 'ol_mahum_archer', 14.00, 25.00, 70, 'male', 'L2SpecialMonster', 'Ranger', 1100, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 2450, 1, 1096, 471, 747, 345, 253, 0, 506, 14, 0, 0, 50, 110, 'partisan_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.93, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7462, 35379, 'Partisan Soldier', '', 'ol_mahum', 13.50, 25.00, 68, 'male', 'L2Monster', 'Fighter', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 2312, 1, 1014, 449, 692, 330, 253, 0, 506, 2, 0, 0, 50, 110, 'partisan_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7463, 35380, 'Partisan Sorcerer', '', 'batur_orc_shaman', 11.00, 16.00, 68, 'male', 'L2Monster', 'Mystic', 40, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 2312, 1, 1014, 449, 692, 330, 253, 0, 506, 7, 0, 0, 50, 120, 'partisan_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.30, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7464, 35381, 'Partisan Archer', '', 'ol_mahum_archer', 14.00, 25.00, 68, 'male', 'L2Monster', 'Ranger', 1100, 2346, 7.500, 1282, 2.700, 40, 43, 30, 21, 20, 20, 2312, 1, 1014, 449, 692, 330, 253, 0, 506, 14, 0, 0, 50, 110, 'partisan_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.93, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7465, 35382, 'Brakel', '', 'ol_mahum_champion', 14.00, 27.00, 70, 'male', 'L2ClanHallMessenger', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7466, 35383, 'Tamutak', '', 'ol_mahum_champion', 14.00, 27.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7467, 35384, 'Black', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7468, 35385, 'Renny', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7469, 35386, 'Boyer', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7470, 35387, 'Baback', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7471, 35388, 'Tim', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7472, 35389, 'Loring', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7473, 35390, 'Dillon', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7474, 35391, 'Latif', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7475, 35392, 'Bremmer', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7476, 35393, 'Faolan', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7477, 35394, 'Kalis', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7478, 35395, 'Kogan', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7479, 35396, 'Winker', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7480, 35397, 'Merton', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7481, 35398, 'Ruben', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7482, 35399, 'Luce', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7483, 35400, 'Horner', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7484, 35401, 'Amiel', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7485, 35402, 'Borna', '', 'a_casino_MHuman', 9.00, 22.25, 70, 'female', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7486, 35403, 'Ron', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7487, 35404, 'Jamal', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7488, 35405, 'Flynn', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7489, 35406, 'Jabilo', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7490, 35407, 'Seth', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7491, 35408, 'Dietrich', '', 'headless_knight', 21.00, 31.00, 76, 'male', 'L2SiegeBoss', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 60, 57, 73, 76, 70, 80, 578, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 70, 180, '', 300, 0, 0, 0, 1, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7492, 35409, 'Mikhail', '', 'headless_knight', 21.00, 31.00, 76, 'male', 'L2SiegeBoss', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 60, 57, 73, 76, 70, 80, 578, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 70, 180, '', 300, 0, 0, 0, 1, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7493, 35410, 'Gustav', '', 'headless_knight', 21.00, 31.00, 78, 'male', 'L2SiegeBoss', 'SiegeGuardFighter', 40, 4137000, 8.500, 1607, 3.000, 60, 57, 73, 76, 70, 80, 608, 0, 2228, 556, 252, 406, 253, 0, 506, 0, 0, 0, 70, 180, '', 300, 0, 0, 0, 1, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7494, 35411, 'Doom Servant', '', 'hungry_spirit', 30.00, 40.00, 73, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2587, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 533, 0, 1220, 502, 833, 368, 253, 150, 506, 0, 0, 0, 15, 120, 'gustav_clan', 1000, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7495, 35412, 'Doom Guard', '', 'hungry_spirit', 30.00, 40.00, 74, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 548, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 15, 120, 'gustav_clan', 1000, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7496, 35413, 'Doom Archer', '', 'skeleton_archer', 11.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 0, 1304, 523, 891, 384, 253, 0, 506, 286, 0, 0, 40, 140, 'gustav_clan', 700, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.80, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7497, 35414, 'Doom Trooper ', '', 'skeleton_pikeman', 10.00, 28.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 578, 0, 1360, 535, 929, 391, 253, 0, 506, 301, 0, 0, 50, 155, 'gustav_clan', 1000, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.21, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7498, 35415, 'Doom Warrior', '', 'skeleton_knight', 10.00, 25.00, 77, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 593, 0, 1421, 544, 971, 398, 253, 150, 506, 71, 0, 0, 40, 160, 'gustav_clan', 1000, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.17, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7499, 35416, 'Doom Knight', '', 'death_blader', 15.00, 45.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 608, 0, 1488, 556, 1015, 406, 253, 150, 506, 1472, 0, 0, 100, 170, 'gustav_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7500, 35417, 'Doorman of Hell', '', 'dwarf_ghost', 9.00, 16.50, 75, 'male', 'L2ClanHallDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 150, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7501, 35418, 'Doorman of Hell', '', 'dwarf_ghost', 9.00, 16.50, 75, 'male', 'L2ClanHallDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 150, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7502, 35419, 'Hephaeston', '', 'human_ghost', 8.00, 22.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 80, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7503, 35420, 'Loken', '', 'human_ghost', 8.00, 22.00, 75, 'male', 'L2ClanHallMessenger', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 74, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.39, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7504, 35421, 'Biggerstaff', '', 'elf_ghost', 7.00, 21.00, 75, 'male', 'L2ClanHallManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.41, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7505, 35422, 'Flag of Winner', '', 'azit_a', 100.00, 72.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7506, 35423, 'Red Flag', '', 'azit_b', 75.00, 55.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7507, 35424, 'Yellow Flag', '', 'azit_b', 75.00, 55.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7508, 35425, 'Green Flag', '', 'azit_b', 75.00, 55.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7509, 35426, 'Blue Flag', '', 'azit_b', 75.00, 55.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7510, 35427, 'Purple Flag', '', 'azit_b', 75.00, 55.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7511, 35428, 'Oel Mahum Berserker', '', 'oel_mahum_warrior', 20.00, 38.00, 73, 'male', 'L2SpecialMonster', 'Fighter', 40, 70387, 8.500, 2144, 3.000, 40, 43, 30, 21, 20, 20, 6395, 247, 476, 2010, 1014, 368, 253, 0, 506, 0, 0, 0, 70, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7512, 35429, 'Oel Mahum Scout', '', 'oel_mahum_warrior', 20.00, 38.00, 73, 'male', 'L2SpecialMonster', 'Fighter', 40, 31674, 8.500, 2144, 3.000, 40, 43, 30, 21, 20, 20, 6395, 247, 476, 2010, 1014, 368, 253, 0, 506, 0, 0, 0, 70, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.65, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7513, 35430, 'Oel Mahum Leader', '', 'oel_mahum_witch_doctor', 15.00, 34.00, 73, 'male', 'L2SpecialMonster', 'Fighter', 40, 35193, 8.500, 2144, 3.000, 40, 43, 30, 21, 20, 20, 6395, 247, 476, 2010, 1014, 368, 253, 0, 506, 0, 0, 0, 70, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7514, 35431, 'Oel Mahum Cleric', '', 'oel_mahum_witch_doctor', 15.00, 34.00, 73, 'male', 'L2SpecialMonster', 'Priest', 40, 35193, 8.500, 2144, 3.000, 40, 43, 30, 21, 20, 20, 6395, 247, 476, 2010, 1014, 368, 253, 0, 506, 0, 0, 0, 70, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.26, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7515, 35432, 'Oel Mahum Thief', '', 'oel_mahum_40_sm', 12.00, 19.00, 73, 'male', 'L2SpecialMonster', 'Fighter', 40, 28155, 8.500, 2144, 3.000, 40, 43, 30, 21, 20, 20, 6395, 247, 476, 2010, 1014, 368, 253, 0, 506, 0, 0, 0, 70, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7516, 35433, 'Inner Doorman', '', 'oel_mahum', 20.00, 37.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 70, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7517, 35434, 'Inner Doorman', '', 'oel_mahum', 20.00, 37.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 70, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7518, 35435, 'Outer Doorman', '', 'oel_mahum', 20.00, 37.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 70, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7519, 35436, 'Outer Doorman', '', 'oel_mahum', 20.00, 37.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 70, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7520, 35437, 'Messenger', '', 'oel_mahum', 20.00, 37.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 70, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7521, 35438, 'Chamberlain', '', 'oel_mahum', 20.00, 37.00, 75, 'male', 'L2ClanHallManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 563, 10, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 70, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7522, 35439, 'Carey', '', 'a_maidB_FHuman', 8.00, 22.00, 70, 'female', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7523, 35440, 'Daniel', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7524, 35441, 'Dianne', '', 'a_maidA_FHuman', 8.00, 20.50, 70, 'female', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7525, 35442, 'Jacques', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7526, 35443, 'Crissy', '', 'a_common_peopleB_FHuman', 8.00, 20.50, 70, 'female', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7527, 35444, 'Joff', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7528, 35445, 'Albert', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7529, 35446, 'Niels', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7530, 35447, 'Korgen', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7531, 35448, 'Rudy', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7532, 35449, 'DiMaggio', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7533, 35450, 'Gellar', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7534, 35451, 'Emma', '', 'a_common_peopleB_FHuman', 8.00, 20.50, 70, 'female', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7535, 35452, 'Theobolt', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7536, 35453, 'Adrienne', '', 'a_maidA_FHuman', 8.00, 20.50, 70, 'female', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7537, 35454, 'Rosconne', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7538, 35455, 'Bianca', '', 'a_maidB_FHuman', 8.00, 22.00, 70, 'female', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7539, 35456, 'Stewart', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7540, 35457, 'Gladys', '', 'a_maidA_FHuman', 8.00, 20.50, 70, 'female', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7541, 35458, 'Theron', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7542, 35459, 'Regina', '', 'a_maidB_FHuman', 8.00, 22.00, 70, 'female', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7543, 35460, 'Trey', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7544, 35461, 'Aida', '', 'a_traderC_Fhuman', 6.50, 17.70, 70, 'female', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7545, 35462, 'Kalmer', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7546, 35463, 'Helga', '', 'a_common_peopleB_FHuman', 8.00, 20.50, 70, 'female', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7547, 35464, 'Volfrem', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7548, 35465, 'Millicent', '', 'a_common_peopleB_FHuman', 8.00, 20.50, 70, 'female', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7549, 35466, 'Gerard', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7550, 35467, 'Branhillde', '', 'a_traderC_Fhuman', 8.00, 22.50, 70, 'female', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7551, 35468, 'Lambert', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7552, 35469, 'Gods Altar', '', 'rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7553, 35470, 'Astair van Halter', '', 'a_lord_MHuman', 7.00, 23.00, 85, 'male', 'L2Npc', 'npc', 40, 42341, 8.500, 5540, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 6207, 630, 1413, 461, 253, 0, 506, 80, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7554, 35471, 'Royal Knight', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 81, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 34618, 8.500, 5126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 5163, 588, 1175, 430, 253, 0, 506, 2, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7555, 35472, 'Court Sorcerer', '', 'a_patriarch_MElf', 8.00, 22.50, 79, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 31278, 8.500, 4923, 3.000, 22, 27, 21, 41, 20, 20, 0, 0, 4687, 566, 1067, 415, 253, 0, 506, 7, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7556, 35473, 'Court Sorcerer', '', 'a_mageguild_master_FHuman', 8.00, 23.00, 79, 'female', 'L2SiegeGuard', 'Mystic', 40, 31278, 8.500, 4923, 3.000, 22, 27, 21, 41, 20, 20, 0, 0, 4687, 566, 1067, 415, 253, 0, 506, 92, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7557, 35474, 'Court Guard', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 79, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 31278, 8.500, 4923, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4687, 566, 1067, 415, 253, 0, 506, 1376, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7558, 35475, 'Guard', '', 'e_guard_MDwarf', 8.00, 19.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 300, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7559, 35476, 'Guard', '', 'e_guard_MDwarf', 8.00, 19.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 132, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7560, 35477, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 1100, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 14, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7561, 35478, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 78, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 16, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7562, 35479, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 78, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 2, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7563, 35480, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 78, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 1100, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 14, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7564, 35481, 'Guard', '', 'e_guard_MOrc', 8.00, 27.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 16, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7565, 35482, 'Guard', '', 'e_guard_MOrc', 8.00, 27.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 2, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7566, 35483, 'Guard', '', 'a_guard_MHuman', 8.00, 24.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 1100, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 14, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7567, 35484, 'Royal Knight', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 81, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 34618, 8.500, 5126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 5163, 588, 1175, 430, 253, 0, 506, 142, 633, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7568, 35485, 'Court Sorcerer', '', 'a_patriarch_MElf', 8.00, 22.50, 79, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 31278, 8.500, 4923, 3.000, 22, 27, 21, 41, 20, 20, 0, 0, 4687, 566, 1067, 415, 253, 0, 506, 326, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7569, 35486, 'Court Sorcerer', '', 'a_mageguild_master_FHuman', 8.00, 23.00, 79, 'female', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 31278, 8.500, 4923, 3.000, 22, 27, 21, 41, 20, 20, 0, 0, 4687, 566, 1067, 415, 253, 0, 506, 325, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7570, 35487, 'Court Guard', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 79, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 31278, 8.500, 4923, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4687, 566, 1067, 415, 253, 0, 506, 300, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7571, 35488, 'Guard', '', 'e_guard_MDwarf', 8.00, 19.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 16, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7572, 35489, 'Guard', '', 'e_guard_MDwarf', 8.00, 19.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 2, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7573, 35490, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 1100, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 285, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7574, 35491, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 78, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 16, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7575, 35492, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 78, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 2, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7576, 35493, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 78, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 1100, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 14, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7577, 35494, 'Guard', '', 'e_guard_MOrc', 8.00, 27.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 16, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7578, 35495, 'Guard', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 2, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7579, 35496, 'Guard', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 1100, 29744, 8.500, 4822, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4462, 556, 1015, 406, 253, 0, 506, 14, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7580, 35497, 'Gatekeeper', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'rune_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7581, 35498, 'Gatekeeper', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'rune_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7582, 35499, 'Gatekeeper', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'rune_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7583, 35500, 'Gatekeeper', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'rune_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7584, 35501, 'Gatekeeper', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'rune_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7585, 35502, 'Group Gatekeeper', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7586, 35503, 'Outer Doorman', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7587, 35504, 'Inner Doorman', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7588, 35505, 'Inner Doorman', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7589, 35506, 'Dungeon Gatekeeper', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Merchant', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7590, 35507, 'Blacksmith', '', 'a_smith_MDwarf', 7.00, 16.50, 75, 'male', 'L2CastleBlacksmith', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7591, 35508, 'Warehouse Keeper', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 75, 'male', 'L2CastleWarehouse', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7592, 35509, 'Frederick', '', 'a_chamberlain_MHuman', 9.50, 22.50, 75, 'male', 'L2CastleChamberlain', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7593, 35510, 'Titus', '', 'a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7594, 35511, 'Gompus', '', 'a_common_peopleC_Mhuman', 10.00, 24.00, 75, 'male', 'L2MercManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7595, 35512, 'Manor Manager', '', 'a_chamberlain_MHuman', 9.50, 22.50, 75, 'male', 'L2ManorManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7596, 35513, 'Sherman', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleMessenger', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 135, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7597, 35514, 'Altar of Wind', '', 'godad_holything', 34.00, 65.00, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7598, 35515, 'Altar of Earth', '', 'godad_holything', 34.00, 65.00, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7599, 35516, 'Verus', '', 'big_boom', 8.00, 23.50, 81, 'male', 'L2Pet', 'npc', 40, 34618, 8.500, 5126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 5163, 588, 1175, 430, 253, 0, 506, 142, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7600, 35517, 'Swain Ken Orwen', '', 'a_lord_MHuman', 7.00, 23.00, 83, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 40, 38356, 8.500, 5332, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 5673, 609, 1292, 445, 253, 0, 506, 79, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7601, 35518, 'Royal Knight', '', 'a_royal_guardA_MHuman', 7.00, 24.00, 79, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 0, 506, 76, 2497, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7602, 35519, 'Court Sorcerer', '', 'a_patriarch_MElf', 8.00, 22.50, 77, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 0, 0, 1421, 544, 971, 398, 253, 0, 506, 325, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7603, 35520, 'Court Sorcerer', '', 'a_mageguild_master_FHuman', 8.00, 23.00, 77, 'female', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 0, 0, 1421, 544, 971, 398, 253, 0, 506, 193, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7604, 35521, 'Court Guard', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 77, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1421, 544, 971, 398, 253, 0, 506, 1376, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7605, 35522, 'Guard', '', 'e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 93, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7606, 35523, 'Guard', '', 'e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7607, 35524, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7608, 35525, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7609, 35526, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7610, 35527, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7611, 35528, 'Guard', '', 'e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7612, 35529, 'Guard', '', 'silver_cat', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7613, 35530, 'Guard', '', 'blue_eye', 8.00, 24.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 280, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7614, 35531, 'Royal Knight', '', 'shadeless', 7.00, 24.00, 79, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 3128, 8.500, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1562, 566, 1067, 415, 253, 0, 506, 76, 2497, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7615, 35532, 'Court Sorcerer', '', 'headless_knight', 8.00, 22.50, 77, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 0, 0, 1421, 544, 971, 398, 253, 0, 506, 325, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7616, 35533, 'Court Sorcerer', '', 'headless_knight', 8.00, 23.00, 77, 'female', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2857, 8.500, 1574, 3.000, 22, 27, 21, 41, 20, 20, 0, 0, 1421, 544, 971, 398, 253, 0, 506, 193, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7617, 35534, 'Court Guard', '', 'headless_knight', 8.00, 23.50, 77, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2857, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1421, 544, 971, 398, 253, 0, 506, 1376, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7618, 35535, 'Guard', '', 'e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 93, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7619, 35536, 'Guard', '', 'e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7620, 35537, 'Guard', '', 'a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7621, 35538, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7622, 35539, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 2, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7623, 35540, 'Guard', '', 'a_guard_FDarkelf', 7.00, 25.00, 75, 'female', 'L2SiegeGuard', 'SiegeGuardFighter', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 14, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7624, 35541, 'Guard', '', 'e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 16, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7625, 35542, 'Guard', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 76, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7626, 35543, 'Guard', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 280, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7627, 35544, 'Gatekeeper', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'schutt_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7628, 35545, 'Gatekeeper', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'schutt_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7629, 35546, 'Gatekeeper', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'schutt_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7630, 35547, 'Group Gatekeeper', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleTeleporter', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7631, 35548, 'Outer Doorman', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7632, 35549, 'Inner Doorman', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7633, 35550, 'Inner Doorman', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7634, 35551, 'Doorman  ', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7635, 35552, 'Doorman  ', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7636, 35553, 'Blacksmith', '', 'a_smith_MDwarf', 7.00, 16.50, 75, 'male', 'L2CastleBlacksmith', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 89, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7637, 35554, 'Warehouse Keeper', '', 'a_warehouse_keeper_MDwarf', 8.00, 17.00, 75, 'male', 'L2CastleWarehouse', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7638, 35555, 'August', '', 'a_chamberlain_MHuman', 9.50, 22.50, 75, 'male', 'L2CastleChamberlain', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7639, 35556, 'Gallic', '', 'a_common_peopleC_Mhuman', 10.00, 24.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7640, 35557, 'Kendrew', '', 'a_common_peopleC_Mhuman', 10.00, 24.00, 75, 'male', 'L2MercManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7641, 35558, 'Manor Manager', '', 'a_chamberlain_MHuman', 9.50, 22.50, 75, 'male', 'L2ManorManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7642, 35559, 'Daguerre', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2CastleMessenger', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 74, 0, 0, 50, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7643, 35560, 'Mass Gatekeeper', '', 'oel_mahum', 20.00, 37.00, 56, 'male', 'L2Merchant', 'npc', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 589, 331, 402, 242, 253, 0, 506, 0, 0, 0, 70, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7644, 35561, 'Mass Gatekeeper', '', 'oel_mahum', 20.00, 37.00, 56, 'male', 'L2Merchant', 'npc', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 589, 331, 402, 242, 253, 0, 506, 0, 0, 0, 70, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7645, 35562, 'Mass Gatekeeper', '', 'oel_mahum', 20.00, 37.00, 56, 'male', 'L2Merchant', 'npc', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 589, 331, 402, 242, 253, 0, 506, 0, 0, 0, 70, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7646, 35563, 'Mass Gatekeeper', '', 'oel_mahum', 20.00, 37.00, 56, 'male', 'L2Merchant', 'npc', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 589, 331, 402, 242, 253, 0, 506, 0, 0, 0, 70, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7647, 35564, 'Mass Gatekeeper', '', 'oel_mahum', 20.00, 37.00, 56, 'male', 'L2Merchant', 'npc', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 589, 331, 402, 242, 253, 0, 506, 0, 0, 0, 70, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7648, 35565, 'Mass Gatekeeper', '', 'oel_mahum', 20.00, 37.00, 56, 'male', 'L2Merchant', 'npc', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 589, 331, 402, 242, 253, 0, 506, 0, 0, 0, 70, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7649, 35566, 'Ronald', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7650, 35567, 'Emil', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7651, 35568, 'Wayne', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7652, 35569, 'Daniel', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7653, 35570, 'Patty', '', 'a_traderC_Fhuman', 9.00, 22.25, 70, 'female', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7654, 35571, 'Dale', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7655, 35572, 'Jimmy', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7656, 35573, 'Shawn', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7657, 35574, 'Michael', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7658, 35575, 'Ryan', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7659, 35576, 'Jack', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7660, 35577, 'Harry', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7661, 35578, 'Karuto', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7662, 35579, 'Egon', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7663, 35580, 'Carol', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7664, 35581, 'Osho', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7665, 35582, 'Stanley', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7666, 35583, 'Walter', '', 'a_common_peopleB_MHuman', 8.00, 22.00, 70, 'male', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7667, 35584, 'Billy', '', 'a_casino_MHuman', 8.00, 23.00, 70, 'male', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7668, 35585, 'Alice', '', 'a_traderC_Fhuman', 9.00, 22.25, 70, 'female', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7669, 35586, 'Serena', '', 'a_maidA_FHuman', 8.00, 20.50, 70, 'female', 'L2ClanHallManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 1, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7670, 35587, 'Neria', '', 'a_traderC_Fhuman', 6.50, 17.70, 70, 'female', 'L2ClanHallDoormen', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7671, 35588, 'Hot Springs Gourd', '', 'drop_gourd_50_bi', 34.00, 40.00, 56, 'etc', 'L2Npc', 'npc', 40, 623000, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 589, 1435500, 402, 1435500, 253, 0, 506, 0, 0, 0, 50, 100, 'rainbow_clan', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7672, 35589, 'Hot Springs Gourd', '', 'drop_gourd_50_bi', 34.00, 40.00, 56, 'etc', 'L2Npc', 'npc', 40, 623000, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 589, 1435500, 402, 1435500, 253, 0, 506, 0, 0, 0, 50, 100, 'rainbow_clan', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7673, 35590, 'Hot Springs Gourd', '', 'drop_gourd_50_bi', 34.00, 40.00, 56, 'etc', 'L2Npc', 'npc', 40, 623000, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 589, 1435500, 402, 1435500, 253, 0, 506, 0, 0, 0, 50, 100, 'rainbow_clan', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7674, 35591, 'Hot Springs Gourd', '', 'drop_gourd_50_bi', 34.00, 40.00, 56, 'etc', 'L2Npc', 'npc', 40, 623000, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 589, 1435500, 402, 1435500, 253, 0, 506, 0, 0, 0, 50, 100, 'rainbow_clan', 0, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7675, 35592, 'Enraged Yeti', '', 'yeti', 15.00, 27.50, 56, 'male', 'L2Npc', 'npc', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 589, 331, 402, 242, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7676, 35593, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 52, 'male', 'L2Npc', 'npc', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 475, 296, 324, 216, 253, 0, 506, 0, 0, 0, 80, 156, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7677, 35594, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 52, 'male', 'L2Npc', 'npc', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 475, 296, 324, 216, 253, 0, 506, 0, 0, 0, 80, 156, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7678, 35595, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 52, 'male', 'L2Npc', 'npc', 40, 1520, 6.500, 804, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 475, 296, 324, 216, 253, 0, 506, 0, 0, 0, 80, 156, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7679, 35596, 'Hot Springs Yeti', '', 'yeti_cute', 5.00, 10.50, 56, 'male', 'L2Npc', 'npc', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 14500, 331, 402, 242, 253, 0, 506, 0, 0, 0, 50, 120, 'rainbow_clan', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7680, 35597, 'Hot Springs Yeti', '', 'yeti_cute', 5.00, 10.50, 56, 'male', 'L2Npc', 'npc', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 14500, 331, 402, 242, 253, 0, 506, 0, 0, 0, 50, 120, 'rainbow_clan', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7681, 35598, 'Hot Springs Yeti', '', 'yeti_cute', 5.00, 10.50, 56, 'male', 'L2Npc', 'npc', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 14500, 331, 402, 242, 253, 0, 506, 0, 0, 0, 50, 120, 'rainbow_clan', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7682, 35599, 'Hot Springs Yeti', '', 'yeti_cute', 5.00, 10.50, 56, 'male', 'L2Npc', 'npc', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 14500, 331, 402, 242, 253, 0, 506, 0, 0, 0, 50, 120, 'rainbow_clan', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7683, 35600, 'Manager', '', 'yeti_cute', 5.00, 10.50, 56, 'male', 'L2Npc', 'npc', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 589, 331, 402, 242, 253, 0, 506, 0, 0, 0, 50, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7684, 35601, 'Doorman', '', 'yeti_cute', 5.00, 10.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7685, 35602, 'Doorman', '', 'yeti_cute', 5.00, 10.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7686, 35603, 'Coordinator', '', 'yeti', 15.00, 27.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 80, 120, '', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7687, 35604, 'Messenger', '', 'yeti_cute', 5.00, 10.50, 56, 'male', 'L2Npc', 'npc', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 589, 331, 402, 242, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7688, 35605, 'Angout', '', 'yeti', 15.00, 27.50, 56, 'male', 'L2Npc', 'npc', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 589, 331, 402, 242, 253, 0, 506, 0, 0, 0, 80, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7689, 35606, 'Victors Flag', '', 'azit_contest_pile_winner', 63.50, 97.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7690, 35607, 'Red Flag', '', 'azit_contest_pile_a', 51.80, 108.25, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7691, 35608, 'Yellow Flag', '', 'azit_contest_pile_b', 51.80, 108.25, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7692, 35609, 'Green Flag', '', 'azit_contest_pile_c', 51.80, 108.25, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7693, 35610, 'Blue Flag', '', 'azit_contest_pile_d', 51.80, 108.25, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7694, 35611, 'Purple Flag', '', 'azit_contest_pile_e', 51.80, 108.25, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7695, 35612, 'Group Gatekeeper', '', 'kel_mahum', 13.00, 26.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7696, 35613, 'Group Gatekeeper', '', 'kel_mahum', 13.00, 26.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7697, 35614, 'Group Gatekeeper', '', 'kel_mahum', 13.00, 26.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7698, 35615, 'Group Gatekeeper', '', 'kel_mahum', 13.00, 26.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7699, 35616, 'Group Gatekeeper', '', 'kel_mahum', 13.00, 26.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7700, 35617, 'Group Gatekeeper', '', 'kel_mahum', 13.00, 26.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7701, 35618, 'Frenzied Cougar', '', 'saber_toothed_tiger', 34.00, 28.00, 73, 'male', 'L2Npc', 'npc', 40, 70387, 8.500, 2144, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 476, 2010, 1014, 368, 253, 0, 506, 0, 0, 0, 60, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7702, 35619, 'Frenzied Buffalo', '', 'buffalo', 22.00, 31.00, 73, 'male', 'L2Npc', 'npc', 40, 31674, 8.500, 2144, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 476, 2010, 1014, 368, 253, 0, 506, 0, 0, 0, 80, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7703, 35620, 'Frenzied Kookaburra', '', 'rough_ostrich', 10.00, 33.00, 73, 'male', 'L2Npc', 'npc', 40, 35193, 8.500, 2144, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 476, 4019, 1014, 368, 253, 0, 506, 0, 0, 0, 23, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7704, 35621, 'Frenzied Buffalo Baby', '', 'baby_buffalo', 8.00, 15.00, 73, 'male', 'L2Npc', 'npc', 40, 35193, 8.500, 2144, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 476, 1004, 1014, 368, 253, 0, 506, 0, 0, 0, 30, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7705, 35622, 'Frenzied Baby Cougar', '', 'baby_tiger', 8.00, 15.70, 73, 'male', 'L2Npc', 'npc', 40, 28155, 8.500, 2144, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 381, 1607, 1014, 368, 253, 0, 506, 0, 0, 0, 28, 140, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7706, 35623, 'Inner Doorman', '', 'a_guard_MHuman', 13.00, 32.00, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7707, 35624, 'Inner Doorman', '', 'kel_mahum_champion', 13.00, 32.00, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7708, 35625, 'Outer Doorman', '', 'a_guard_MHuman', 13.00, 32.00, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7709, 35626, 'Outer Doorman', '', 'kel_mahum_champion', 13.00, 32.00, 75, 'male', 'L2CastleDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7710, 35627, 'Messenger', '', 'kel_mahum_champion', 13.00, 32.00, 75, 'male', 'L2CastleMessenger', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7711, 35628, 'Quigby', '', 'kel_mahum_champion', 13.00, 32.00, 75, 'male', 'L2Merchant', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7712, 35629, 'Lidia von Hellmann', '', 'lidia_von_helmann', 10.00, 25.40, 78, 'female', 'L2SiegeBoss', 'SiegeGuardFighter', 40, 903214, 37.300, 1607, 3.000, 60, 57, 73, 76, 70, 80, 0, 0, 2632, 1667, 929, 813, 253, 0, 506, 8209, 0, 0, 20, 180, 'lidia_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.43, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7713, 35630, 'Alfred von Hellmann', '', 'vampire_warrior', 19.00, 35.00, 77, 'male', 'L2SiegeBoss', 'SiegeGuardFighter', 80, 110192, 22.500, 1574, 3.000, 60, 57, 73, 76, 70, 80, 0, 0, 2390, 1635, 206, 797, 253, 0, 506, 8679, 0, 0, 60, 180, 'lidia_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7714, 35631, 'Giselle von Hellmann', '', 'vampire_wizard', 5.50, 28.00, 77, 'female', 'L2SiegeBoss', 'SiegeGuardFighter', 40, 110192, 22.500, 1574, 3.000, 60, 57, 73, 76, 70, 80, 0, 0, 2390, 1635, 206, 797, 253, 0, 506, 99, 0, 0, 46, 180, 'lidia_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7715, 35632, 'Vampire Adept', '', 'vampire_witch', 6.00, 21.50, 73, 'female', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 7144, 8.500, 1442, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2791, 502, 222, 368, 253, 0, 506, 946, 0, 0, 64, 120, 'lidia_clan', 1000, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7716, 35633, 'Vampire Soldier', '', 'vampire_soldier', 8.00, 23.50, 74, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 7897, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2787, 513, 861, 375, 253, 0, 506, 234, 0, 0, 60, 120, 'lidia_clan', 1000, 0, 0, 0, 7, 10, 8, 0, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7717, 35634, 'Vampire Caster', '', 'vampire_witch', 6.00, 21.50, 75, 'female', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 8030, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 5783, 523, 891, 384, 253, 0, 506, 946, 0, 0, 64, 140, 'lidia_clan', 700, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7718, 35635, 'Vampire Magister', '', 'vampire_wizard', 5.50, 28.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 8274, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 3173, 535, 929, 391, 253, 0, 506, 99, 0, 0, 46, 155, 'lidia_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.46, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7719, 35636, 'Vampire Warlord', '', 'vampire_warrior', 9.00, 31.50, 77, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 8570, 8.500, 1574, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2844, 544, 971, 398, 253, 0, 506, 6723, 0, 0, 43, 160, 'lidia_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7720, 35637, 'Vampire Leader', '', 'vampire_lord', 7.50, 25.80, 78, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 8923, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2599, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 15, 170, 'lidia_clan', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7721, 35638, 'Valens', '', 'vampire_soldier', 8.00, 23.50, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7722, 35639, 'Jacquard', '', 'vampire_soldier', 8.00, 23.50, 75, 'male', 'L2ClanHallMessenger', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7723, 35640, 'Bandello', '', 'vampire_soldier', 8.00, 23.50, 75, 'male', 'L2ClanHallManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7724, 35641, 'Fortress Guard', '', 'vampire_soldier', 8.00, 23.50, 75, 'male', 'L2ClanHallDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7725, 35642, 'Fortress Guard', '', 'vampire_soldier', 8.00, 23.50, 75, 'male', 'L2ClanHallDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7726, 35643, 'Gate  ', '', 'farm_hedge', 184.00, 24.00, 56, 'etc', 'L2Npc', 'npc', 40, 1725, 6.500, 919, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 589, 331, 402, 242, 253, 0, 506, 0, 0, 0, 50, 120, 'dion_siege_clan', 600, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7727, 35644, 'Manor Manager', '', 'a_traderA_MDwarf', 8.00, 17.00, 70, 'male', 'L2ManorManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7728, 35645, 'Manor Manager', '', 'e_trader_MOrc', 8.00, 23.50, 70, 'male', 'L2ManorManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7729, 35646, 'Vampire Caster', '', 'vampire_witch', 6.00, 21.50, 70, 'female', 'L2Npc', 'npc', 1100, 6886, 7.500, 1251, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 4409, 448, 679, 328, 253, 0, 506, 946, 0, 0, 64, 140, 'lidia_clan', 700, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7730, 35647, 'Vampire Leader', '', 'vampire_lord', 7.50, 25.80, 73, 'male', 'L2Npc', 'npc', 40, 7333, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1950, 480, 761, 352, 253, 0, 506, 0, 0, 0, 15, 170, 'lidia_clan', 100, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7731, 35648, 'Court Magician', '', 'Elite_Mage', 6.50, 21.96, 70, 'female', 'L2CastleCourt', 'npc', 40, 2444, 7.500, 1346, 2.700, 22, 27, 21, 41, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8687, 0, 0, 33, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7732, 35649, 'Court Magician', '', 'Elite_Mage', 6.50, 21.96, 70, 'female', 'L2CastleCourt', 'npc', 40, 2444, 7.500, 1346, 2.700, 22, 27, 21, 41, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8687, 0, 0, 33, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7733, 35650, 'Court Magician', '', 'Elite_Mage', 6.50, 21.96, 70, 'female', 'L2CastleCourt', 'npc', 40, 2444, 7.500, 1346, 2.700, 22, 27, 21, 41, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8687, 0, 0, 33, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7734, 35651, 'Court Magician', '', 'Elite_Mage', 6.50, 21.96, 70, 'female', 'L2CastleCourt', 'npc', 40, 2444, 7.500, 1346, 2.700, 22, 27, 21, 41, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8687, 0, 0, 33, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7735, 35652, 'Court Magician', '', 'Elite_Mage', 6.50, 21.96, 70, 'female', 'L2CastleCourt', 'npc', 40, 2444, 7.500, 1346, 2.700, 22, 27, 21, 41, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8687, 0, 0, 33, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7736, 35653, 'Court Magician', '', 'Elite_Mage', 6.50, 21.96, 70, 'female', 'L2CastleCourt', 'npc', 40, 2444, 7.500, 1346, 2.700, 22, 27, 21, 41, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8687, 0, 0, 33, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7737, 35654, 'Court Magician', '', 'Elite_Mage', 6.50, 21.96, 70, 'female', 'L2CastleCourt', 'npc', 40, 2444, 7.500, 1346, 2.700, 22, 27, 21, 41, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8687, 0, 0, 33, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7738, 35655, 'Court Magician', '', 'Elite_Mage', 6.50, 21.96, 70, 'female', 'L2CastleCourt', 'npc', 40, 2444, 7.500, 1346, 2.700, 22, 27, 21, 41, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8687, 0, 0, 33, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7739, 35656, 'Court Magician', '', 'Elite_Mage', 6.50, 21.96, 70, 'female', 'L2CastleCourt', 'npc', 40, 2444, 7.500, 1346, 2.700, 22, 27, 21, 41, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8687, 0, 0, 33, 120, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7740, 35657, 'Flagpole', '', 'LineageNpcEV.Rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 40, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7741, 35658, 'Foreman', '', 'LineageNPC.Royal_guard', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7742, 35659, 'Suspicious Merchant', '', 'LineageNPC.Guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantShanty', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7743, 35660, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7744, 35661, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7745, 35662, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7746, 35663, 'Engineering Manager', '', 'LineageNPC.Guard_Dwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7747, 35664, 'Logistics Officer', '', 'LineageNPC.Collector_teacher', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7748, 35665, 'Supply Box', '', 'LineageMonster.Mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7749, 35666, 'Detention Camp Warden', '', 'LineageNPC.Elmore_guard', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7750, 35667, 'Doorman', '', 'LineageNPC.Elmore_guard', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7751, 35668, 'Doorman', '', 'LineageNPC.Elmore_guard', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7752, 35669, 'Doorman', '', 'LineageNPC.Elmore_guard', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7753, 35670, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7754, 35671, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7755, 35672, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7756, 35673, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7757, 35674, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7758, 35675, 'Power Control Unit', '', 'LineageNpcEV.Strange_mechanical', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7759, 35676, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7760, 35677, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7761, 35678, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7762, 35679, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7763, 35680, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7764, 35681, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7765, 35682, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7766, 35683, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7767, 35684, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7768, 35685, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7769, 35686, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7770, 35687, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7771, 35688, 'Flagpole', '', 'LineageNpcEV.Rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7772, 35689, 'Foreman', '', 'LineageNPC.Royal_guard', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7773, 35690, 'Suspicious Merchant', '', 'LineageNPC.Guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantSouthernGludio', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7774, 35691, 'Guard Captain', '', 'LineageNPC2.Garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7775, 35692, 'Archer Captain', '', 'LineageNPC2.Archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7776, 35693, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 9813, 9813, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7777, 35694, 'Support Unit Captain', '', 'LineageNPC2.Mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7778, 35695, 'Engineering Manager', '', 'LineageNPC.Guard_Dwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7779, 35696, 'Logistics Officer', '', 'LineageNPC.Collector_teacher', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7780, 35697, 'Supply Box', '', 'LineageMonster.Mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7781, 35698, 'Detention Camp Warden', '', 'LineageNPC.Elmore_guard', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7782, 35699, 'Doorman', '', 'LineageNPC.Elmore_guard', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7783, 35700, 'Doorman', '', 'LineageNPC.Elmore_guard', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7784, 35701, 'Doorman', '', 'LineageNPC.Elmore_guard', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7785, 35702, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7786, 35703, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7787, 35704, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7788, 35705, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7789, 35706, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7790, 35707, 'Main Machine', '', 'LineageNpcEV.Machine_guard', 46.00, 35.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7791, 35708, 'Backup Power Unit', '', 'LineageNpcEV.Strange_mechanical', 16.00, 15.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7792, 35709, 'Control Unit', '', 'LineageNpcEV.Willer', 39.00, 42.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 1, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7793, 35710, 'Power Control Unit', '', 'LineageNpcEV.Strange_mechanical', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7794, 35711, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7795, 35712, 'Scout Golem', '', 'LineageMonster.Mechanic_golem', 5.00, 19.00, 74, 'male', 'L2Npc', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 2738, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7796, 35713, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7797, 35714, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7798, 35715, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7799, 35716, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7800, 35717, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7801, 35718, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7802, 35719, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7803, 35720, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7804, 35721, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 78, 'male', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 9813, 9813, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7805, 35722, 'Minister ', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 7895, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7806, 35723, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7807, 35724, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7808, 35725, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7809, 35726, 'Flagpole', '', 'LineageNpcEV.Rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7810, 35727, 'Foreman', '', 'LineageNPC.Royal_guard', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7811, 35728, 'Suspicious Merchant', '', 'LineageNPC.Guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantHive', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7812, 35729, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7813, 35730, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7814, 35731, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7815, 35732, 'Engineering Manager', '', 'LineageNPC.Guard_Dwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7816, 35733, 'Logistics Officer', '', 'LineageNPC.Collector_teacher', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7817, 35734, 'Supply Box', '', 'LineageMonster.Mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7818, 35735, 'Detention Camp Warden', '', 'LineageNPC.Elmore_guard', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7819, 35736, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7820, 35737, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7821, 35738, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7822, 35739, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7823, 35740, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7824, 35741, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7825, 35742, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7826, 35743, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7827, 35744, 'Power Control Unit', '', 'LineageNpcEV.Strange_mechanical', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7828, 35745, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7829, 35746, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7830, 35747, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7831, 35748, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7832, 35749, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7833, 35750, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7834, 35751, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7835, 35752, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7836, 35753, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7837, 35754, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7838, 35755, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7839, 35756, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7840, 35757, 'Flagpole', '', 'LineageNpcEV.rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7841, 35758, 'Foreman', '', 'LineageNPC.Royal_guard', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7842, 35759, 'Suspicious Merchant', '', 'LineageNPC.Guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantValley', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7843, 35760, 'Guard Captain', '', 'LineageNPC2.Garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7844, 35761, 'Archer Captain', '', 'LineageNPC2.Archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7845, 35762, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 9813, 9813, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7846, 35763, 'Support Unit Captain', '', 'LineageNPC2.Mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7847, 35764, 'Engineering Manager', '', 'LineageNPC.Guard_Dwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7848, 35765, 'Logistics Officer', '', 'LineageNPC.Collector_teacher', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7849, 35766, 'Supply Box', '', 'LineageMonster.Mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7850, 35767, 'Detention Camp Warden', '', 'LineageNPC.Elmore_guard', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7851, 35768, 'Doorman', '', 'LineageNPC.Elmore_guard', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7852, 35769, 'Doorman', '', 'LineageNPC.Elmore_guard', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7853, 35770, 'Doorman', '', 'LineageNPC.Elmore_guard', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7854, 35771, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7855, 35772, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7856, 35773, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7857, 35774, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7858, 35775, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7859, 35776, 'Main Machine', '', 'LineageNpcEV.Machine_guard', 46.00, 35.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7860, 35777, 'Backup Power Unit', '', 'LineageNpcEV.Strange_mechanical', 16.00, 15.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7861, 35778, 'Control Unit', '', 'LineageNpcEV.Willer', 39.00, 42.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 1, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7862, 35779, 'Power Control Unit', '', 'LineageNpcEV.Strange_mechanical', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7863, 35780, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7864, 35781, 'Scout Golem', '', 'LineageMonster.Mechanic_golem', 5.00, 19.00, 74, 'male', 'L2Npc', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 2738, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7865, 35782, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7866, 35783, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7867, 35784, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7868, 35785, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7869, 35786, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7870, 35787, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7871, 35788, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7872, 35789, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7873, 35790, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 78, 'male', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 9813, 9813, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7874, 35791, 'Minister ', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 7895, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7875, 35792, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7876, 35793, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7877, 35794, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7878, 35795, 'Flagpole', '', 'LineageNpcEV.Rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7879, 35796, 'Foreman', '', 'LineageNPC.Royal_guard', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7880, 35797, 'Suspicious Merchant', '', 'LineageNPC.Guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantIvoryTower', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7881, 35798, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7882, 35799, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7883, 35800, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7884, 35801, 'Engineering Manager', '', 'LineageNPC.Guard_Dwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7885, 35802, 'Logistics Officer', '', 'LineageNPC.Collector_teacher', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7886, 35803, 'Supply Box', '', 'LineageMonster.Mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7887, 35804, 'Detention Camp Warden', '', 'LineageNPC.Elmore_guard', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7888, 35805, 'Doorman', '', 'LineageNPC.Elmore_guard', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7889, 35806, 'Doorman', '', 'LineageNPC.Elmore_guard', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7890, 35807, 'Doorman', '', 'LineageNPC.Elmore_guard', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7891, 35808, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7892, 35809, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7893, 35810, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7894, 35811, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7895, 35812, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7896, 35813, 'Power Control Unit', '', 'LineageNpcEV.Strange_mechanical', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7897, 35814, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7898, 35815, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7899, 35816, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7900, 35817, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7901, 35818, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7902, 35819, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7903, 35820, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7904, 35821, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7905, 35822, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7906, 35823, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7907, 35824, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7908, 35825, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7909, 35826, 'Flagpole', '', 'LineageNpcEV.Rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7910, 35827, 'Foreman', '', 'LineageNPC.Royal_guard', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7911, 35828, 'Suspicious Merchant', '', 'LineageNPC.Guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantNarsell', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7912, 35829, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7913, 35830, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7914, 35831, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7915, 35832, 'Engineering Manager', '', 'LineageNPC.Guard_Dwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7916, 35833, 'Logistics Officer', '', 'LineageNPC.Collector_teacher', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7917, 35834, 'Supply Box', '', 'LineageMonster.Mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7918, 35835, 'Detention Camp Warden', '', 'LineageNPC.Eleno_guard', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7919, 35836, 'Doorman', '', 'LineageNPC.Eleno_guard', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7920, 35837, 'Doorman', '', 'LineageNPC.Eleno_guard', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7921, 35838, 'Doorman', '', 'LineageNPC.Eleno_guard', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7922, 35839, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7923, 35840, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7924, 35841, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7925, 35842, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7926, 35843, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7927, 35844, 'Power Control Unit', '', 'LineageNpcEV.Strange_mechanical', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7928, 35845, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7929, 35846, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7930, 35847, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7931, 35848, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7932, 35849, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7933, 35850, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7934, 35851, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7935, 35852, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7936, 35853, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7937, 35854, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7938, 35855, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7939, 35856, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7940, 35857, 'Flagpole', '', 'LineageNpcEV.rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7941, 35858, 'Foreman', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7942, 35859, 'Suspicious Merchant', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantBayou', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7943, 35860, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7944, 35861, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7945, 35862, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 9813, 9813, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7946, 35863, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7947, 35864, 'Engineering Manager', '', 'LineageNPC.e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7948, 35865, 'Logistics Officer', '', 'LineageNPC.e_collector_teacher_MDwarf', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7949, 35866, 'Supply Box', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7950, 35867, 'Detention Camp Warden', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7951, 35868, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7952, 35869, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7953, 35870, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7954, 35871, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7955, 35872, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7956, 35873, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7957, 35874, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7958, 35875, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7959, 35876, 'Main Machine', '', 'LineageNpcEV.machine_guard_a', 46.00, 35.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7960, 35877, 'Backup Power Unit', '', 'LineageNpcEV.strange_mechanical_instrume', 16.00, 15.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7961, 35878, 'Control Unit', '', 'LineageNpcEV.door_lock', 39.00, 42.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 1, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7962, 35879, 'Power Control Unit', '', 'LineageNpcEV.machine_construction_a', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7963, 35880, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7964, 35881, 'Scout Golem', '', 'LineageMonster.mechanic_golem', 5.00, 19.00, 74, 'male', 'L2Npc', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 2738, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7965, 35882, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7966, 35883, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7967, 35884, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7968, 35885, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (7969, 35886, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7970, 35887, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7971, 35888, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7972, 35889, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7973, 35890, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 78, 'male', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 9813, 9813, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7974, 35891, 'Minister ', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 7895, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7975, 35892, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7976, 35893, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7977, 35894, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7978, 35895, 'Flagpole', '', 'LineageNpcEV.rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7979, 35896, 'Foreman', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7980, 35897, 'Suspicious Merchant', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantWhiteSands', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7981, 35898, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7982, 35899, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7983, 35900, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7984, 35901, 'Engineering Manager', '', 'LineageNPC.e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7985, 35902, 'Logistics Officer', '', 'LineageNPC.e_collector_teacher_MDwarf', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7986, 35903, 'Supply Box', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7987, 35904, 'Detention Camp Warden', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7988, 35905, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7989, 35906, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7990, 35907, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (7991, 35908, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7992, 35909, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7993, 35910, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7994, 35911, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7995, 35912, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7996, 35913, 'Power Control Unit', '', 'LineageNpcEV.machine_construction_a', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7997, 35914, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (7998, 35915, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (7999, 35916, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8000, 35917, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8001, 35918, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (8002, 35919, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8003, 35920, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8004, 35921, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8005, 35922, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8006, 35923, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8007, 35924, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8008, 35925, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8009, 35926, 'Flagpole', '', 'LineageNpcEV.rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8010, 35927, 'Foreman', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8011, 35928, 'Suspicious Merchant', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantBorderland', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8012, 35929, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8013, 35930, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8014, 35931, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 9813, 9813, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8015, 35932, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8016, 35933, 'Engineering Manager', '', 'LineageNPC.e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8017, 35934, 'Logistics Officer', '', 'LineageNPC.e_collector_teacher_MDwarf', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8018, 35935, 'Supply Box', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8019, 35936, 'Detention Camp Warden', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8020, 35937, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8021, 35938, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8022, 35939, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8023, 35940, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8024, 35941, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8025, 35942, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8026, 35943, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8027, 35944, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8028, 35945, 'Main Machine', '', 'LineageNpcEV.machine_guard_a', 46.00, 35.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8029, 35946, 'Backup Power Unit', '', 'LineageNpcEV.strange_mechanical_instrume', 16.00, 15.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8030, 35947, 'Control Unit', '', 'LineageNpcEV.door_lock', 39.00, 42.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 1, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8031, 35948, 'Power Control Unit', '', 'LineageNpcEV.machine_construction_a', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8032, 35949, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8033, 35950, 'Scout Golem', '', 'LineageMonster.mechanic_golem', 5.00, 19.00, 74, 'male', 'L2Npc', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 2738, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8034, 35951, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8035, 35952, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8036, 35953, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8037, 35954, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (8038, 35955, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8039, 35956, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8040, 35957, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8041, 35958, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8042, 35959, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 78, 'male', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 9813, 9813, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8043, 35960, 'Minister ', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 7895, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8044, 35961, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8045, 35962, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8046, 35963, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8047, 35964, 'Flagpole', '', 'LineageNpcEV.rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8048, 35965, 'Foreman', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8049, 35966, 'Suspicious Merchant', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantMarshland', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8050, 35967, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8051, 35968, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8052, 35969, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 9813, 9813, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8053, 35970, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8054, 35971, 'Engineering Manager', '', 'LineageNPC.e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8055, 35972, 'Logistics Officer', '', 'LineageNPC.e_collector_teacher_MDwarf', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8056, 35973, 'Supply Box', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8057, 35974, 'Detention Camp Warden', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8058, 35975, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8059, 35976, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8060, 35977, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8061, 35978, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8062, 35979, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8063, 35980, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8064, 35981, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8065, 35982, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8066, 35983, 'Main Machine', '', 'LineageNpcEV.machine_guard_a', 46.00, 35.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8067, 35984, 'Backup Power Unit', '', 'LineageNpcEV.strange_mechanical_instrume', 16.00, 15.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8068, 35985, 'Control Unit', '', 'LineageNpcEV.door_lock', 39.00, 42.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 1, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8069, 35986, 'Power Control Unit', '', 'LineageNpcEV.machine_construction_a', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8070, 35987, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8071, 35988, 'Scout Golem', '', 'LineageMonster.mechanic_golem', 5.00, 19.00, 74, 'male', 'L2Npc', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 2738, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8072, 35989, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8073, 35990, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8074, 35991, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8075, 35992, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (8076, 35993, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8077, 35994, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8078, 35995, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8079, 35996, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8080, 35997, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 78, 'male', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 9813, 9813, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8081, 35998, 'Minister ', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 7895, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8082, 35999, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8083, 36000, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8084, 36001, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8085, 36002, 'Flagpole', '', 'LineageNpcEV.rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8086, 36003, 'Foreman', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8087, 36004, 'Suspicious Merchant', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantArchaic', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8088, 36005, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8089, 36006, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8090, 36007, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8091, 36008, 'Engineering Manager', '', 'LineageNPC.e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8092, 36009, 'Logistics Officer', '', 'LineageNPC.e_collector_teacher_MDwarf', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8093, 36010, 'Supply Box', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8094, 36011, 'Detention Camp Warden', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8095, 36012, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8096, 36013, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8097, 36014, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8098, 36015, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8099, 36016, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8100, 36017, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8101, 36018, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8102, 36019, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8103, 36020, 'Power Control Unit', '', 'LineageNpcEV.machine_construction_a', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8104, 36021, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8105, 36022, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8106, 36023, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8107, 36024, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8108, 36025, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (8109, 36026, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8110, 36027, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8111, 36028, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8112, 36029, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8113, 36030, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8114, 36031, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8115, 36032, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8116, 36033, 'Flagpole', '', 'LineageNpcEV.rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8117, 36034, 'Foreman', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8118, 36035, 'Suspicious Merchant', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantFloran', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8119, 36036, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8120, 36037, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8121, 36038, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 9813, 9813, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8122, 36039, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8123, 36040, 'Engineering Manager', '', 'LineageNPC.e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8124, 36041, 'Logistics Officer', '', 'LineageNPC.e_collector_teacher_MDwarf', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8125, 36042, 'Supply Box', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8126, 36043, 'Detention Camp Warden', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8127, 36044, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8128, 36045, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8129, 36046, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8130, 36047, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8131, 36048, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8132, 36049, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8133, 36050, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8134, 36051, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8135, 36052, 'Main Machine', '', 'LineageNpcEV.machine_guard_a', 46.00, 35.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8136, 36053, 'Backup Power Unit', '', 'LineageNpcEV.strange_mechanical_instrume', 16.00, 15.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8137, 36054, 'Control Unit', '', 'LineageNpcEV.door_lock', 39.00, 42.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 1, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8138, 36055, 'Power Control Unit', '', 'LineageNpcEV.machine_construction_a', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8139, 36056, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8140, 36057, 'Scout Golem', '', 'LineageMonster.mechanic_golem', 5.00, 19.00, 74, 'male', 'L2Npc', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 2738, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8141, 36058, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8142, 36059, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8143, 36060, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8144, 36061, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (8145, 36062, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8146, 36063, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8147, 36064, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8148, 36065, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8149, 36066, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 78, 'male', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 9813, 9813, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8150, 36067, 'Minister', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 7895, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8151, 36068, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8152, 36069, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8153, 36070, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8154, 36071, 'Flagpole', '', 'LineageNpcEV.rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8155, 36072, 'Foreman', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8156, 36073, 'Suspicious Merchant', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantCloud', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8157, 36074, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8158, 36075, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8159, 36076, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 9813, 9813, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8160, 36077, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8161, 36078, 'Engineering Manager', '', 'LineageNPC.e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8162, 36079, 'Logistics Officer', '', 'LineageNPC.e_collector_teacher_MDwarf', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8163, 36080, 'Supply Box', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8164, 36081, 'Detention Camp Warden', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8165, 36082, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8166, 36083, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8167, 36084, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8168, 36085, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8169, 36086, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8170, 36087, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8171, 36088, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8172, 36089, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8173, 36090, 'Main Machine', '', 'LineageNpcEV.machine_guard_a', 46.00, 35.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8174, 36091, 'Backup Power Unit', '', 'LineageNpcEV.strange_mechanical_instrume', 16.00, 15.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8175, 36092, 'Control Unit', '', 'LineageNpcEV.door_lock', 39.00, 42.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 1, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8176, 36093, 'Power Control Unit', '', 'LineageNpcEV.machine_construction_a', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8177, 36094, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8178, 36095, 'Scout Golem', '', 'LineageMonster.mechanic_golem', 5.00, 19.00, 74, 'male', 'L2Npc', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 2738, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8179, 36096, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8180, 36097, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8181, 36098, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8182, 36099, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (8183, 36100, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8184, 36101, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8185, 36102, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8186, 36103, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8187, 36104, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 78, 'male', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 9813, 9813, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8188, 36105, 'Minister', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 7895, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8189, 36106, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8190, 36107, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8191, 36108, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8192, 36109, 'Flagpole', '', 'LineageNpcEV.rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8193, 36110, 'Foreman', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8194, 36111, 'Suspicious Merchant', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantTanor', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8195, 36112, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8196, 36113, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8197, 36114, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8198, 36115, 'Engineering Manager', '', 'LineageNPC.e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8199, 36116, 'Logistics Officer', '', 'LineageNPC.e_collector_teacher_MDwarf', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8200, 36117, 'Supply Box', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8201, 36118, 'Detention Camp Warden', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8202, 36119, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8203, 36120, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8204, 36121, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8205, 36122, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8206, 36123, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8207, 36124, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8208, 36125, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8209, 36126, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8210, 36127, 'Power Control Unit', '', 'LineageNpcEV.machine_construction_a', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8211, 36128, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8212, 36129, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8213, 36130, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8214, 36131, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8215, 36132, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (8216, 36133, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8217, 36134, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8218, 36135, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8219, 36136, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8220, 36137, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8221, 36138, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8222, 36139, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8223, 36140, 'Flagpole', '', 'LineageNpcEV.rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8224, 36141, 'Foreman', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8225, 36142, 'Suspicious Merchant', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantDragonspine', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8226, 36143, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8227, 36144, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8228, 36145, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8229, 36146, 'Engineering Manager', '', 'LineageNPC.e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8230, 36147, 'Logistics Officer', '', 'LineageNPC.e_collector_teacher_MDwarf', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8231, 36148, 'Supply Box', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8232, 36149, 'Detention Camp Warden', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8233, 36150, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8234, 36151, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8235, 36152, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8236, 36153, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8237, 36154, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8238, 36155, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8239, 36156, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8240, 36157, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8241, 36158, 'Power Control Unit', '', 'LineageNpcEV.machine_construction_a', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8242, 36159, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8243, 36160, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8244, 36161, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8245, 36162, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8246, 36163, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (8247, 36164, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8248, 36165, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8249, 36166, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8250, 36167, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8251, 36168, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8252, 36169, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8253, 36170, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8254, 36171, 'Flagpole', '', 'LineageNpcEV.rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8255, 36172, 'Foreman', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8256, 36173, 'Suspicious Merchant', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantAntharas', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8257, 36174, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8258, 36175, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8259, 36176, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 9813, 9813, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8260, 36177, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8261, 36178, 'Engineering Manager', '', 'LineageNPC.e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8262, 36179, 'Logistics Officer', '', 'LineageNPC.e_collector_teacher_MDwarf', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8263, 36180, 'Supply Box', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8264, 36181, 'Detention Camp Warden', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8265, 36182, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8266, 36183, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8267, 36184, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8268, 36185, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8269, 36186, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8270, 36187, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8271, 36188, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8272, 36189, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8273, 36190, 'Main Machine', '', 'LineageNpcEV.machine_guard_a', 46.00, 35.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8274, 36191, 'Backup Power Unit', '', 'LineageNpcEV.strange_mechanical_instrume', 16.00, 15.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8275, 36192, 'Control Unit', '', 'LineageNpcEV.door_lock', 39.00, 42.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 1, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8276, 36193, 'Power Control Unit', '', 'LineageNpcEV.machine_construction_a', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8277, 36194, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8278, 36195, 'Scout Golem', '', 'LineageMonster.mechanic_golem', 5.00, 19.00, 74, 'male', 'L2Npc', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 2738, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8279, 36196, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8280, 36197, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8281, 36198, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8282, 36199, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (8283, 36200, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8284, 36201, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8285, 36202, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8286, 36203, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8287, 36204, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 78, 'male', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 9813, 9813, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8288, 36205, 'Minister', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 7895, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8289, 36206, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8290, 36207, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8291, 36208, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8292, 36209, 'Flagpole', '', 'LineageNpcEV.rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8293, 36210, 'Foreman', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8294, 36211, 'Suspicious Merchant', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantWestern', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8295, 36212, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8296, 36213, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8297, 36214, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 9813, 9813, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8298, 36215, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8299, 36216, 'Engineering Manager', '', 'LineageNPC.e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8300, 36217, 'Logistics Officer', '', 'LineageNPC.e_collector_teacher_MDwarf', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8301, 36218, 'Supply Box', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8302, 36219, 'Detention Camp Warden', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8303, 36220, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8304, 36221, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8305, 36222, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8306, 36223, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8307, 36224, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8308, 36225, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8309, 36226, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8310, 36227, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8311, 36228, 'Main Machine', '', 'LineageNpcEV.machine_guard_a', 46.00, 35.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8312, 36229, 'Backup Power Unit', '', 'LineageNpcEV.strange_mechanical_instrume', 16.00, 15.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8313, 36230, 'Control Unit', '', 'LineageNpcEV.door_lock', 39.00, 42.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 1, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8314, 36231, 'Power Control Unit', '', 'LineageNpcEV.machine_construction_a', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8315, 36232, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8316, 36233, 'Scout Golem', '', 'LineageMonster.mechanic_golem', 5.00, 19.00, 74, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 2738, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8317, 36234, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8318, 36235, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8319, 36236, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8320, 36237, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (8321, 36238, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8322, 36239, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8323, 36240, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8324, 36241, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8325, 36242, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 78, 'male', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 9813, 9813, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8326, 36243, 'Minister ', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 7895, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8327, 36244, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8328, 36245, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8329, 36246, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8330, 36247, 'Flagpole', '', 'LineageNpcEV.rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8331, 36248, 'Foreman', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8332, 36249, 'Suspicious Merchant', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantHunters', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8333, 36250, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8334, 36251, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8335, 36252, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 9813, 9813, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8336, 36253, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8337, 36254, 'Engineering Manager', '', 'LineageNPC.e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8338, 36255, 'Logistics Officer', '', 'LineageNPC.e_collector_teacher_MDwarf', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8339, 36256, 'Supply Box', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8340, 36257, 'Detention Camp Warden', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8341, 36258, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8342, 36259, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8343, 36260, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8344, 36261, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8345, 36262, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8346, 36263, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8347, 36264, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8348, 36265, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8349, 36266, 'Main Machine', '', 'LineageNpcEV.machine_guard_a', 46.00, 35.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8350, 36267, 'Backup Power Unit', '', 'LineageNpcEV.strange_mechanical_instrume', 16.00, 15.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8351, 36268, 'Control Unit', '', 'LineageNpcEV.door_lock', 39.00, 42.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 1, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8352, 36269, 'Power Control Unit', '', 'LineageNpcEV.machine_construction_a', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8353, 36270, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8354, 36271, 'Scout Golem', '', 'LineageMonster.mechanic_golem', 5.00, 19.00, 74, 'male', 'L2Npc', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 2738, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8355, 36272, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8356, 36273, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8357, 36274, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8358, 36275, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (8359, 36276, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8360, 36277, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8361, 36278, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8362, 36279, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8363, 36280, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 78, 'male', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 9813, 9813, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8364, 36281, 'Minister', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 7895, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8365, 36282, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8366, 36283, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8367, 36284, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8368, 36285, 'Flagpole', '', 'LineageNpcEV.rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8369, 36286, 'Foreman', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8370, 36287, 'Suspicious Merchant', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantAaru', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8371, 36288, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8372, 36289, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8373, 36290, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8374, 36291, 'Engineering Manager', '', 'LineageNPC.e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8375, 36292, 'Logistics Officer', '', 'LineageNPC.e_collector_teacher_MDwarf', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8376, 36293, 'Supply Box', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8377, 36294, 'Detention Camp Warden', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8378, 36295, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8379, 36296, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8380, 36297, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8381, 36298, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8382, 36299, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8383, 36300, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8384, 36301, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8385, 36302, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8386, 36303, 'Power Control Unit', '', 'LineageNpcEV.machine_construction_a', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8387, 36304, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8388, 36305, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8389, 36306, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8390, 36307, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8391, 36308, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (8392, 36309, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8393, 36310, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8394, 36311, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8395, 36312, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8396, 36313, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8397, 36314, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8398, 36315, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8399, 36316, 'Flagpole', '', 'LineageNpcEV.rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8400, 36317, 'Foreman', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8401, 36318, 'Suspicious Merchant', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantDemon', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8402, 36319, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8403, 36320, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8404, 36321, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 9813, 9813, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8405, 36322, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8406, 36323, 'Engineering Manager', '', 'LineageNPC.e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8407, 36324, 'Logistics Officer', '', 'LineageNPC.e_collector_teacher_MDwarf', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8408, 36325, 'Supply Box', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8409, 36326, 'Detention Camp Warden', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8410, 36327, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8411, 36328, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8412, 36329, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8413, 36330, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8414, 36331, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8415, 36332, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8416, 36333, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8417, 36334, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8418, 36335, 'Main Machine', '', 'LineageNpcEV.machine_guard_a', 46.00, 35.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8419, 36336, 'Backup Power Unit', '', 'LineageNpcEV.strange_mechanical_instrume', 16.00, 15.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8420, 36337, 'Control Unit', '', 'LineageNpcEV.door_lock', 39.00, 42.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 1, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8421, 36338, 'Power Control Unit', '', 'LineageNpcEV.machine_construction_a', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8422, 36339, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8423, 36340, 'Scout Golem', '', 'LineageMonster.mechanic_golem', 5.00, 19.00, 74, 'male', 'L2Npc', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 2738, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8424, 36341, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8425, 36342, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8426, 36343, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8427, 36344, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (8428, 36345, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8429, 36346, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8430, 36347, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8431, 36348, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8432, 36349, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 78, 'male', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 9813, 9813, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8433, 36350, 'Minister', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 7895, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8434, 36351, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8435, 36352, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8436, 36353, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8437, 36354, 'Flagpole', '', 'LineageNpcEV.rune_holything', 46.00, 72.50, 20, 'etc', 'L2Npc', 'npc', 40, 343, 2.500, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 48, 95, 33, 70, 253, 0, 506, 0, 0, 0, 50, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8438, 36355, 'Foreman', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 75, 'male', 'L2FortressManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8439, 36356, 'Suspicious Merchant', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SuspiciousMerchant', 'SuspiciousMerchantMonastic', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 100, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8440, 36357, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 80, 641, 0, 30, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8441, 36358, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 30, 120, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8442, 36359, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 9813, 9813, 0, 60, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8443, 36360, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 75, 'female', 'L2SupportUnit', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8444, 36361, 'Engineering Manager', '', 'LineageNPC.e_guard_MDwarf', 8.00, 19.00, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8445, 36362, 'Logistics Officer', '', 'LineageNPC.e_collector_teacher_MDwarf', 8.00, 17.50, 75, 'male', 'L2LogisticsOfficer', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8446, 36363, 'Supply Box', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8447, 36364, 'Detention Camp Warden', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8448, 36365, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8449, 36366, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8450, 36367, 'Doorman', '', 'LineageNPC.a_guard_MHuman', 8.00, 24.00, 75, 'male', 'L2FortressDoormen', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8451, 36368, 'Rebel Commander', '', 'LineageNPC2.chief_of_insurgents', 10.00, 26.99, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 3200, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8452, 36369, 'Decorated Rebel Soldier', '', 'LineageMonster.shadow_50_bi', 15.00, 45.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 80, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.54, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8453, 36370, 'Rebel Private', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 97, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8454, 36371, 'Court Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 72, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 98, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8455, 36372, 'Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 72, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2540, 8.500, 1410, 3.000, 40, 43, 30, 21, 20, 20, 2592, 0, 1179, 491, 805, 359, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8456, 36373, 'Main Machine', '', 'LineageNpcEV.machine_guard_a', 46.00, 35.00, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8457, 36374, 'Backup Power Unit', '', 'LineageNpcEV.strange_mechanical_instrume', 16.00, 15.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8458, 36375, 'Control Unit', '', 'LineageNpcEV.door_lock', 39.00, 42.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 2813, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 1, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8459, 36376, 'Power Control Unit', '', 'LineageNpcEV.machine_construction_a', 54.00, 59.50, 75, 'etc', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8460, 36377, 'Dwarven Gunnery Sergeant', '', 'LineageNPC2.battery_of_insurgents', 13.00, 17.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8461, 36378, 'Scout Golem', '', 'LineageMonster.mechanic_golem', 5.00, 19.00, 74, 'male', 'L2Npc', 'npc', 40, 2632, 8.500, 1475, 3.000, 40, 43, 30, 21, 20, 20, 2738, 0, 1262, 513, 861, 375, 253, 0, 506, 0, 0, 0, 30, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.72, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8462, 36379, 'Guard Captain', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 78, 'female', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 80, 641, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8463, 36380, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8464, 36381, 'Guard', '', 'LineageNPC.a_royal_guardB_MHuman', 7.00, 24.00, 76, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 75, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8465, 36382, 'Support Unit Captain', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 78, 'female', 'L2Commander', 'SiegeGuardMystic', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 0, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL_BSPIRIT', 0, 0);
INSERT INTO `npc` VALUES (8466, 36383, 'Wizard', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardMystic', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 325, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8467, 36384, 'Healer', '', 'LineageNPC.a_mageguild_master_FHuman', 8.00, 23.00, 76, 'female', 'L2SiegeGuard', 'SiegeGuardPriest', 40, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 92, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8468, 36385, 'Archer Captain', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 78, 'male', 'L2Commander', 'SiegeGuardRanger', 1100, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 10212, 0, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8469, 36386, 'Archer', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 76, 'male', 'L2SiegeGuard', 'SiegeGuardRanger', 1100, 2758, 8.500, 1541, 3.000, 40, 43, 30, 21, 20, 20, 2888, 0, 1360, 535, 929, 391, 253, 0, 506, 287, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8470, 36387, 'General', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 78, 'male', 'L2Commander', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 9813, 9813, 0, 60, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'SOUL', 0, 0);
INSERT INTO `npc` VALUES (8471, 36388, 'Minister', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 78, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 681762, 397.497, 1607, 3.000, 40, 43, 30, 21, 20, 20, 3042, 0, 11939, 888, 8153, 975, 253, 0, 506, 7895, 0, 0, 50, 120, 'fortress_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8472, 36389, 'Ballista', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Ballista', 'Ballista', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8473, 36390, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 80, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 40, 679374, 391.418, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 12636, 923, 8627, 1014, 253, 0, 506, 2500, 6377, 0, 36, 100, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8474, 36391, 'Mercenary Private', '', 'LineageNPC.e_guard_MOrc', 8.00, 27.00, 75, 'male', 'L2SiegeGuard', 'SiegeGuardFighter', 80, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 96, 0, 0, 50, 120, 'fortress_attacker_clan', 300, 0, 0, 0, 7, 30, 4, 0, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8475, 36392, 'Improvised Explosive', '', 'orc', 10.00, 21.00, 60, 'male', 'L2Npc', 'npc', 40, 1933, 6.500, 1037, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 717, 370, 490, 270, 253, 0, 506, 0, 0, 0, 45, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.48, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8476, 36393, 'Special Envoy', '', 'a_teleporter_FHuman', 8.00, 25.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8477, 36394, 'Special Envoy', '', 'a_teleporter_FHuman', 8.00, 25.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8478, 36395, 'Special Envoy', '', 'a_maidB_FHuman', 8.00, 22.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8479, 36396, 'Special Envoy', '', 'a_sanctuary_teacher_FHuman', 8.00, 22.50, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8480, 36397, 'Special Envoy', '', 'a_clergyman_FDarkElf', 8.00, 25.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8481, 36398, 'Special Envoy', '', 'a_maidB_FHuman', 8.00, 22.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8482, 36399, 'Special Envoy', '', 'a_maidB_FHuman', 8.00, 22.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8483, 36400, 'Special Envoy', '', 'a_teleporter_FElf', 8.50, 23.50, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8484, 36401, 'Special Envoy', '', 'e_teleporter_Fhuman', 8.00, 25.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8485, 36402, 'Olympiad Host', '', 'a_fighterguild_master_Mhuman', 8.00, 23.50, 70, 'male', 'L2OlympiadBuffer', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 70, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8486, 36403, 'Warden', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8487, 36404, 'Warden', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8488, 36405, 'Warden', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8489, 36406, 'Warden', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8490, 36407, 'Warden', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8491, 36408, 'Warden', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8492, 36409, 'Warden', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8493, 36410, 'Warden', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8494, 36411, 'Warden', '', 'e_elmore_guard_Mhuman', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8495, 36412, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8496, 36413, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8497, 36414, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8498, 36415, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8499, 36416, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8500, 36417, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8501, 36418, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8502, 36419, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8503, 36420, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8504, 36421, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8505, 36422, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8506, 36423, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8507, 36424, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8508, 36425, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8509, 36426, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8510, 36427, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8511, 36428, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8512, 36429, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8513, 36430, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8514, 36431, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8515, 36432, 'Fortress Trap', '', 'Organ_Dummy', 1.00, 35.00, 78, 'female', 'L2Npc', 'npc', 40, 2974, 8.500, 1607, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1488, 556, 1015, 406, 253, 0, 506, 0, 0, 0, 10, 1, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8516, 36433, 'Special Envoy', '', 'a_maidB_FHuman', 8.00, 22.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8517, 36434, 'Special Envoy', '', 'e_traderA_FDwarf', 7.00, 18.50, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8518, 36435, 'Special Envoy', '', 'a_teleporter_FHuman', 8.00, 25.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8519, 36436, 'Special Envoy', '', 'a_maidB_FHuman', 8.00, 22.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8520, 36437, 'Special Envoy', '', 'a_teleporter_FHuman', 8.00, 25.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8521, 36438, 'Special Envoy', '', 'a_clergyman_FDarkElf', 8.00, 25.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8522, 36439, 'Special Envoy', '', 'a_maidB_FHuman', 8.00, 22.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8523, 36440, 'Special Envoy', '', 'a_sanctuary_teacher_FHuman', 8.00, 22.50, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8524, 36441, 'Special Envoy', '', 'a_maidB_FHuman', 8.00, 22.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8525, 36442, 'Special Envoy', '', 'a_clergyman_FDarkElf', 8.00, 25.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8526, 36443, 'Special Envoy', '', 'a_clergyman_FDarkElf', 8.00, 25.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8527, 36444, 'Special Envoy', '', 'a_sanctuary_teacher_FHuman', 8.00, 22.50, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8528, 36445, 'Special Envoy', '', 'a_maidB_FHuman', 8.00, 22.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8529, 36446, 'Special Envoy', '', 'a_clergyman_FDarkElf', 8.00, 25.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8530, 36447, 'Special Envoy', '', 'e_teleporter_Fhuman', 8.00, 25.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8531, 36448, 'Special Envoy', '', 'a_maidB_FHuman', 8.00, 22.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8532, 36449, 'Special Envoy', '', 'a_sanctuary_teacher_FHuman', 8.00, 22.50, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8533, 36450, 'Special Envoy', '', 'a_teleporter_FElf', 8.50, 23.50, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8534, 36451, 'Special Envoy', '', 'a_sanctuary_teacher_FHuman', 8.00, 22.50, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8535, 36452, 'Special Envoy', '', 'a_maidB_FHuman', 8.00, 22.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8536, 36453, 'Special Envoy', '', 'e_teleporter_Fhuman', 8.00, 25.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8537, 36454, 'Special Envoy', '', 'a_maidB_FHuman', 8.00, 22.00, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8538, 36455, 'Special Envoy', '', 'e_traderA_FDwarf', 7.00, 18.50, 75, 'female', 'L2Npc', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8539, 36456, 'Manor Manager', '', 'K_M1_normal', 13.00, 25.00, 75, 'male', 'L2ManorManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 28, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8540, 36457, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8541, 36458, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8542, 36459, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8543, 36460, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8544, 36461, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8545, 36462, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8546, 36463, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8547, 36464, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8548, 36465, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8549, 36466, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8550, 36467, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8551, 36468, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8552, 36469, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8553, 36470, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8554, 36471, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8555, 36472, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8556, 36473, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8557, 36474, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8558, 36475, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8559, 36476, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8560, 36477, 'Wyvern Manager', '', 'LineageNPC.a_fighterguild_teacher_MHuman', 8.00, 23.00, 75, 'male', 'L2WyvernManager', 'npc', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8561, 36478, 'Mickey', '', 'LineageNPC.e_collector_teacher_FDwarf', 8.00, 17.50, 70, 'female', 'L2Merchant', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8562, 36479, 'Rapidus', '', 'LineageNPC.a_fighterguild_master_Mhuman', 8.00, 23.50, 70, 'male', 'L2FameManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8563, 36480, 'Scipio', '', 'LineageNPC.a_fighterguild_master_Mhuman', 8.00, 23.50, 70, 'male', 'L2FameManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (8564, 36481, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 70, 'male', 'L2MercenaryCaptain', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 2500, 6377, 0, 36, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8565, 36482, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 70, 'male', 'L2MercenaryCaptain', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 2500, 6377, 0, 36, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8566, 36483, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 70, 'male', 'L2MercenaryCaptain', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 2500, 6377, 0, 36, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8567, 36484, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 70, 'male', 'L2MercenaryCaptain', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 2500, 6377, 0, 36, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8568, 36485, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 70, 'male', 'L2MercenaryCaptain', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 2500, 6377, 0, 36, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8569, 36486, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 70, 'male', 'L2MercenaryCaptain', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 2500, 6377, 0, 36, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8570, 36487, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 70, 'male', 'L2MercenaryCaptain', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 2500, 6377, 0, 36, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8571, 36488, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 70, 'male', 'L2MercenaryCaptain', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 2500, 6377, 0, 36, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8572, 36489, 'Mercenary Captain', '', 'LineageMonster3.Kight_of_Dawn', 12.00, 24.50, 70, 'male', 'L2MercenaryCaptain', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 2500, 6377, 0, 36, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8573, 36490, 'Territory Manager', '', 'LineageNPC2.feudal_custodian', 10.00, 22.50, 70, 'male', 'L2TerritoryManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8574, 36491, 'Territory Manager', '', 'LineageNPC2.feudal_custodian', 10.00, 22.50, 70, 'male', 'L2TerritoryManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8575, 36492, 'Territory Manager', '', 'LineageNPC2.feudal_custodian', 10.00, 22.50, 70, 'male', 'L2TerritoryManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8576, 36493, 'Territory Manager', '', 'LineageNPC2.feudal_custodian', 10.00, 22.50, 70, 'male', 'L2TerritoryManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8577, 36494, 'Territory Manager', '', 'LineageNPC2.feudal_custodian', 10.00, 22.50, 70, 'male', 'L2TerritoryManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8578, 36495, 'Territory Manager', '', 'LineageNPC2.feudal_custodian', 10.00, 22.50, 70, 'male', 'L2TerritoryManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8579, 36496, 'Territory Manager', '', 'LineageNPC2.feudal_custodian', 10.00, 22.50, 70, 'male', 'L2TerritoryManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8580, 36497, 'Territory Manager', '', 'LineageNPC2.feudal_custodian', 10.00, 22.50, 70, 'male', 'L2TerritoryManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8581, 36498, 'Territory Manager', '', 'LineageNPC2.feudal_custodian', 10.00, 22.50, 70, 'male', 'L2TerritoryManager', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8582, 36499, 'Territory Catapult', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8583, 36500, 'Territory Catapult', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8584, 36501, 'Territory Catapult', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8585, 36502, 'Territory Catapult', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8586, 36503, 'Territory Catapult', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8587, 36504, 'Territory Catapult', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8588, 36505, 'Territory Catapult', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8589, 36506, 'Territory Catapult', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8590, 36507, 'Territory Catapult', '', 'LineageNpcEV.ballista', 112.00, 59.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8591, 36508, 'Military Association Leader', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 40, 43, 30, 21, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 76, 2497, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8592, 36509, 'Territory Border Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8678, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8593, 36510, 'Religious Association Leader', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 22, 27, 21, 41, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 8687, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8594, 36511, 'Territory Guard', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 9442, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8595, 36512, 'Territory Border Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 8684, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8596, 36513, 'Economic Association Leader', '', 'LineageNPC.a_traderB_MHuman', 8.00, 25.00, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 40, 43, 30, 21, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 6365, 0, 0, 50, 120, 'gludio_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8597, 36514, 'Military Association Leader', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 40, 43, 30, 21, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 76, 2497, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8598, 36515, 'Territory Border Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8678, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8599, 36516, 'Religious Association Leader', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 22, 27, 21, 41, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 8687, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8600, 36517, 'Territory Guard', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 9442, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8601, 36518, 'Territory Border Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 8684, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8602, 36519, 'Economic Association Leader', '', 'LineageNPC.a_traderB_MHuman', 8.00, 25.00, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 40, 43, 30, 21, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 6365, 0, 0, 50, 120, 'dion_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8603, 36520, 'Military Association Leader', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 40, 43, 30, 21, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 76, 2497, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8604, 36521, 'Territory Border Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8678, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8605, 36522, 'Religious Association Leader', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 22, 27, 21, 41, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 8687, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8606, 36523, 'Territory Guard', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 9442, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8607, 36524, 'Territory Border Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 8684, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8608, 36525, 'Economic Association Leader', '', 'LineageNPC.a_traderB_MHuman', 8.00, 25.00, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 40, 43, 30, 21, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 6365, 0, 0, 50, 120, 'giran_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8609, 36526, 'Military Association Leader', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 40, 43, 30, 21, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 76, 2497, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8610, 36527, 'Territory Border Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8678, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8611, 36528, 'Religious Association Leader', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 22, 27, 21, 41, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 8687, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8612, 36529, 'Territory Guard', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 9442, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8613, 36530, 'Territory Border Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 8684, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8614, 36531, 'Economic Association Leader', '', 'LineageNPC.a_traderB_MHuman', 8.00, 25.00, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 40, 43, 30, 21, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 6365, 0, 0, 50, 120, 'oren_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8615, 36532, 'Military Association Leader', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 40, 43, 30, 21, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 76, 2497, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8616, 36533, 'Territory Border Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8678, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8617, 36534, 'Religious Association Leader', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 22, 27, 21, 41, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 8687, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8618, 36535, 'Territory Guard', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 9442, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8619, 36536, 'Territory Border Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 8684, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8620, 36537, 'Economic Association Leader', '', 'LineageNPC.a_traderB_MHuman', 8.00, 25.00, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 40, 43, 30, 21, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 6365, 0, 0, 50, 120, 'aden_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8621, 36538, 'Military Association Leader', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 40, 43, 30, 21, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 76, 2497, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8622, 36539, 'Territory Border Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8678, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8623, 36540, 'Religious Association Leader', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 22, 27, 21, 41, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 8687, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8624, 36541, 'Territory Guard', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 9442, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8625, 36542, 'Territory Border Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 8684, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8626, 36543, 'Economic Association Leader', '', 'LineageNPC.a_traderB_MHuman', 8.00, 25.00, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 40, 43, 30, 21, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 6365, 0, 0, 50, 120, 'innadrile_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8627, 36544, 'Military Association Leader', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 40, 43, 30, 21, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 76, 2497, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8628, 36545, 'Territory Border Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8678, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8629, 36546, 'Religious Association Leader', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 22, 27, 21, 41, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 8687, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8630, 36547, 'Territory Guard', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 9442, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8631, 36548, 'Territory Border Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 8684, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8632, 36549, 'Economic Association Leader', '', 'LineageNPC.a_traderB_MHuman', 8.00, 25.00, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 40, 43, 30, 21, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 6365, 0, 0, 50, 120, 'godad_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8633, 36550, 'Military Association Leader', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 40, 43, 30, 21, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 76, 2497, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8634, 36551, 'Territory Border Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8678, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8635, 36552, 'Religious Association Leader', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 22, 27, 21, 41, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 8687, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8636, 36553, 'Territory Guard', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 9442, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8637, 36554, 'Territory Border Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 8684, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8638, 36555, 'Economic Association Leader', '', 'LineageNPC.a_traderB_MHuman', 8.00, 25.00, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 40, 43, 30, 21, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 6365, 0, 0, 50, 120, 'rune_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8639, 36556, 'Military Association Leader', '', 'LineageNPC.a_royal_guardA_MHuman', 7.00, 24.00, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 40, 43, 30, 21, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 76, 2497, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8640, 36557, 'Territory Border Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 8678, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8641, 36558, 'Religious Association Leader', '', 'LineageNPC.a_patriarch_MElf', 8.00, 22.50, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 22, 27, 21, 41, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 8687, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8642, 36559, 'Territory Guard', '', 'LineageNPC.e_elmore_guard_Mhuman', 8.00, 23.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 9442, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8643, 36560, 'Territory Border Guard', '', 'LineageNPC.a_guard_MElf', 8.00, 23.50, 75, 'male', 'L2Npc', 'npc', 1100, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 8684, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8644, 36561, 'Economic Association Leader', '', 'LineageNPC.a_traderB_MHuman', 8.00, 25.00, 80, 'male', 'L2Npc', 'npc', 40, 463876, 981.000, 1675, 3.000, 40, 43, 30, 21, 20, 20, 64129, 77672, 4921, 576, 3360, 423, 253, 0, 506, 6365, 0, 0, 50, 120, 'schutt_siege_clan', 1200, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8645, 36562, 'Seduced Knight', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 83, 'female', 'SeducedMob', 'SeducedFighter', 40, 58333, 8.500, 1777, 3.000, 40, 43, 30, 21, 26, 20, 0, 0, 1890, 913, 1292, 445, 336, 0, 672, 80, 641, 0, 30, 120, 'bold_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8646, 36563, 'Seduced Ranger', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 83, 'male', 'SeducedMob', 'SeducedRanger', 1100, 58333, 8.500, 1777, 3.000, 40, 43, 30, 21, 26, 20, 0, 0, 1890, 913, 1292, 445, 336, 0, 672, 10212, 0, 0, 30, 120, 'bold_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8647, 36564, 'Seduced Mage', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 83, 'female', 'SeducedMob', 'SeducedMage', 40, 58333, 8.500, 1777, 3.000, 40, 43, 30, 21, 26, 20, 0, 0, 1890, 913, 1292, 445, 336, 0, 672, 0, 0, 0, 28, 120, 'bold_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8648, 36565, 'Seduced Warrior', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 83, 'male', 'SeducedMob', 'SeducedFighter', 40, 58333, 8.500, 1777, 3.000, 40, 43, 30, 21, 26, 20, 0, 0, 1890, 913, 1292, 445, 336, 0, 672, 9813, 9813, 0, 40, 120, 'bold_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8649, 36566, 'Seduced Knight', '', 'LineageNPC2.garrison_of_insurgents', 10.00, 23.75, 77, 'female', 'SeducedMob', 'SeducedFighter', 40, 43728, 7.500, 1405, 2.700, 40, 43, 30, 21, 26, 20, 0, 0, 1232, 629, 842, 370, 336, 0, 672, 80, 641, 0, 30, 120, 'bold_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8650, 36567, 'Seduced Ranger', '', 'LineageNPC2.archer_of_insurgents', 10.00, 23.50, 77, 'male', 'SeducedMob', 'SeducedRanger', 1100, 43728, 7.500, 1405, 2.700, 40, 43, 30, 21, 26, 20, 0, 0, 1232, 629, 842, 370, 336, 0, 672, 10212, 0, 0, 30, 120, 'bold_clan', 300, 0, 0, 0, 7, 10, 8, 0, 1500, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8651, 36568, 'Seduced Mage', '', 'LineageNPC2.mage_of_insurgents', 9.00, 23.50, 77, 'female', 'SeducedMob', 'SeducedMage', 40, 43728, 7.500, 1405, 2.700, 40, 43, 30, 21, 26, 20, 0, 0, 1232, 629, 842, 370, 336, 0, 672, 0, 0, 0, 28, 120, 'bold_clan', 300, 0, 0, 0, 7, 50, 1, 9, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8652, 36569, 'Seduced Warrior', '', 'LineageNPC2.officer_of_insurgents_orc', 14.50, 30.00, 77, 'male', 'SeducedMob', 'SeducedFighter', 40, 43728, 7.500, 1405, 2.700, 40, 43, 30, 21, 26, 20, 0, 0, 1232, 629, 842, 370, 336, 0, 672, 9813, 9813, 0, 40, 120, 'bold_clan', 300, 0, 0, 0, 7, 10, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8653, 36570, 'Emery Compressor', '', 'LineageNpcEV.source_facility', 62.00, 140.00, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8654, 36571, 'Vortex', '', 'LineageNpcEV.war_gate', 300.00, 130.00, 80, 'female', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8655, 36572, 'Gludio Ward', '', 'LineageNpcEV.native_thing_of_territory', 10.00, 35.00, 80, 'female', 'L2TerritoryFlag', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8656, 36573, 'Dion Ward', '', 'LineageNpcEV.native_thing_of_territory', 10.00, 35.00, 80, 'female', 'L2TerritoryFlag', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8657, 36574, 'Giran Ward', '', 'LineageNpcEV.native_thing_of_territory', 10.00, 35.00, 80, 'female', 'L2TerritoryFlag', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8658, 36575, 'Oren Ward', '', 'LineageNpcEV.native_thing_of_territory', 10.00, 35.00, 80, 'female', 'L2TerritoryFlag', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8659, 36576, 'Aden Ward', '', 'LineageNpcEV.native_thing_of_territory', 10.00, 35.00, 80, 'female', 'L2TerritoryFlag', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8660, 36577, 'Innadril Ward', '', 'LineageNpcEV.native_thing_of_territory', 10.00, 35.00, 80, 'female', 'L2TerritoryFlag', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8661, 36578, 'Goddard Ward', '', 'LineageNpcEV.native_thing_of_territory', 10.00, 35.00, 80, 'female', 'L2TerritoryFlag', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8662, 36579, 'Rune Ward', '', 'LineageNpcEV.native_thing_of_territory', 10.00, 35.00, 80, 'female', 'L2TerritoryFlag', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8663, 36580, 'Schuttgart Ward', '', 'LineageNpcEV.native_thing_of_territory', 10.00, 35.00, 80, 'female', 'L2TerritoryFlag', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8664, 36581, 'Territory Catapult', '', 'LineageNpcEV.damaged_ballista', 125.00, 43.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8665, 36582, 'Territory Catapult', '', 'LineageNpcEV.damaged_ballista', 125.00, 43.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8666, 36583, 'Territory Catapult', '', 'LineageNpcEV.damaged_ballista', 125.00, 43.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8667, 36584, 'Territory Catapult', '', 'LineageNpcEV.damaged_ballista', 125.00, 43.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8668, 36585, 'Territory Catapult', '', 'LineageNpcEV.damaged_ballista', 125.00, 43.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8669, 36586, 'Territory Catapult', '', 'LineageNpcEV.damaged_ballista', 125.00, 43.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8670, 36587, 'Territory Catapult', '', 'LineageNpcEV.damaged_ballista', 125.00, 43.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8671, 36588, 'Territory Catapult', '', 'LineageNpcEV.damaged_ballista', 125.00, 43.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8672, 36589, 'Territory Catapult', '', 'LineageNpcEV.damaged_ballista', 125.00, 43.00, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 1, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8673, 36590, 'Outpost', '', 'LineageNpcEV.Advance_quarters', 110.00, 70.00, 1, 'female', 'L2Npc', 'npc', 40, 40, 2.000, 40, 0.900, 40, 43, 30, 21, 20, 20, 0, 0, 7, 40, 5, 30, 253, 0, 506, 0, 0, 0, 1, 120, '', 1000, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8674, 36591, 'Supplies Safe', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8675, 36592, 'Supplies Safe', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8676, 36593, 'Supplies Safe', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8677, 36594, 'Supplies Safe', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8678, 36595, 'Supplies Safe', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8679, 36596, 'Supplies Safe', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8680, 36597, 'Supplies Safe', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8681, 36598, 'Supplies Safe', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (8682, 36599, 'Supplies Safe', '', 'LineageMonster.mimic', 8.50, 8.50, 80, 'male', 'L2Npc', 'npc', 40, 3290, 8.500, 1675, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1641, 576, 1120, 423, 253, 0, 506, 0, 0, 0, 80, 1, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (20000, 39912, 'Buffer', '', 'npc_buffer', 8.50, 20.00, 85, 'male', 'L2Merchant', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 870, 870, 870, 870, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 31225, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22842, 22842, 'Maluk Banshee', '', 'LineageMonster5.twisted_banshee_a', 15.00, 35.00, 85, 'female', 'L2Monster', 'Fighter', 40, 18605, 190.745, 1846, 2.700, 40, 43, 50, 21, 20, 10, 336705, 33738, 15627, 685, 10781, 911, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22838, 22838, 'Maluk Leader', '', 'LineageMonster5.leader_mind_of_silen_a', 15.00, 45.00, 85, 'male', 'L2Monster', 'Fighter', 40, 55817, 190.745, 1846, 2.700, 40, 43, 50, 21, 20, 10, 555716, 58594, 15627, 685, 10781, 911, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22853, 22853, 'Dragon Mage', '', 'LineageMonster4.dragon_mage_065p_a', 15.00, 33.00, 85, 'male', 'L2Monster', 'Mystic', 40, 55817, 190.745, 1846, 2.700, 40, 43, 50, 21, 20, 10, 548640, 57848, 15627, 685, 10781, 911, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22844, 22844, 'Dragon Knight', '', 'LineageMonster4.Dragon_archmage_100p', 15.00, 37.00, 85, 'male', 'L2Monster', 'DragonKnight1', 40, 88192, 190.745, 2253, 2.700, 40, 43, 50, 21, 20, 10, 589013, 59033, 15627, 685, 10781, 911, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22845, 22845, 'Dragon Knight', '', 'LineageMonster4.Dragon_archmage_135p_a', 15.00, 50.00, 85, 'male', 'L2Monster', 'DragonKnight2', 40, 88192, 190.745, 2253, 2.700, 40, 43, 50, 21, 20, 10, 585225, 58916, 15627, 685, 10781, 911, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22847, 22847, 'Dragon Knight Warrior', '', 'LineageMonster4.Dragon_centurion_100p', 15.00, 35.00, 85, 'male', 'L2Monster', 'Fighter', 40, 32596, 190.745, 1846, 2.700, 40, 43, 50, 21, 20, 10, 361543, 38120, 15627, 685, 10781, 911, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22848, 22848, 'Drake Leader', '', 'LineageMonster4.Dragon_archmage_135p_a', 15.00, 50.00, 85, 'male', 'L2Monster', 'DrakeLeader', 40, 55817, 190.745, 1846, 2.700, 40, 43, 50, 21, 20, 10, 600571, 63323, 15627, 685, 10781, 911, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22851, 22851, 'Drake Mage', '', 'LineageMonster4.dragon_mage_075p_b', 15.00, 42.00, 85, 'male', 'L2Monster', 'DrakeMage', 40, 32596, 190.745, 1846, 2.700, 40, 43, 50, 21, 20, 10, 342513, 36114, 15627, 685, 10781, 911, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22849, 22849, 'Drake Warrior', '', 'LineageMonster4.Dragon_centurion_120p_b', 15.00, 39.00, 85, 'male', 'L2Monster', 'DrakeWarrior', 40, 18605, 190.745, 1846, 2.700, 40, 43, 50, 21, 20, 10, 372672, 37354, 15627, 685, 10781, 911, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22850, 22850, 'Drake Scout', '', 'LineageMonster4.dragon_peltast_80p', 15.00, 38.00, 85, 'male', 'L2Monster', 'DrakeScout', 40, 32596, 190.745, 1846, 2.700, 40, 43, 50, 21, 20, 10, 135650, 13605, 15627, 685, 10781, 911, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22857, 22857, 'Knoriks', '', 'LineageMonster6.transform_clanicus', 15.00, 42.00, 85, 'male', 'L2Monster', 'Knoriks', 40, 334640, 190.745, 1846, 2.700, 40, 43, 50, 21, 20, 10, 3301929, 348153, 25784, 1129, 17789, 1502, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22840, 22840, 'Maluk Hunter', '', 'LineageMonster5.vicious_mind_of_silen_a', 15.00, 34.00, 85, 'male', 'L2Monster', 'Fighter', 40, 55817, 190.745, 1846, 2.700, 40, 43, 50, 21, 20, 10, 203619, 20360, 15627, 685, 10781, 911, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22839, 22839, 'Maluk Warlord', '', 'LineageMonster5.dimension_caller_a', 15.00, 60.00, 85, 'male', 'L2Monster', 'Fighter', 40, 55817, 190.745, 1846, 2.700, 40, 43, 50, 21, 20, 10, 537433, 56666, 15627, 685, 10781, 911, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22841, 22841, 'Maluk Princess', '', 'LineageMonster5.bloody_princess_a', 15.00, 40.00, 85, 'female', 'L2Monster', 'Fighter', 40, 18605, 190.745, 1846, 2.700, 40, 43, 50, 21, 20, 10, 336705, 33738, 15627, 685, 10781, 911, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22843, 22843, 'Maluk Sniper ', '', 'LineageMonster5.skeleton_sniper_80p', 15.00, 27.00, 85, 'male', 'L2Monster', 'Ranger', 900, 55817, 190.745, 1846, 2.700, 40, 43, 50, 21, 20, 10, 200088, 19988, 15627, 685, 10781, 911, 278, 550, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22846, 22846, 'Elite Dragon Knight', '', 'LineageMonster4.Dragon_archmage_135p_a', 15.00, 49.00, 85, 'male', 'L2Monster', 'Fighter', 40, 18605, 190.745, 1846, 2.700, 40, 43, 50, 21, 20, 10, 765812, 76753, 15627, 685, 10781, 911, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22855, 22855, 'Bloody Berserker', '', 'LineageMonster5.leader_anakazel_low_a_130p', 15.00, 47.00, 86, 'male', 'L2Monster', 'Fighter', 40, 333456, 190.745, 1881, 2.700, 40, 43, 50, 21, 20, 10, 614011, 62855, 17189, 753, 11859, 1001, 278, 500, 333, 0, 0, 0, 110, 180, 'bloody_loa', 300, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22854, 22854, 'Bloody Karik', '', 'LineageMonster5.leader_anakazel_high_a_140p', 15.00, 57.00, 86, 'male', 'L2Monster', 'Fighter', 40, 333456, 190.745, 1881, 2.700, 40, 43, 50, 21, 20, 10, 868728, 88089, 17189, 753, 11859, 1001, 278, 500, 333, 0, 0, 0, 110, 180, 'bloody_loa', 300, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22856, 22856, 'Bloody Karinness', '', 'LineageMonster5.leader_anakazel_mid_a_130p', 15.00, 35.00, 86, 'female', 'L2Monster', 'Fighter', 40, 333456, 190.745, 1881, 2.700, 40, 43, 50, 21, 20, 10, 614011, 62855, 17189, 753, 11859, 1001, 278, 500, 333, 0, 0, 0, 110, 180, 'bloody_loa', 300, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (25726, 25726, 'Behemoth Leader', '', 'LineageMonster3.antaras_ex_a_raid', 15.00, 54.00, 85, 'male', 'L2RaidBoss', 'Fighter', 40, 3902308, 190.745, 18468, 2.700, 40, 43, 50, 21, 20, 10, 0, 0, 15000, 1500, 18000, 1800, 253, 600, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (25727, 25727, 'Dragon Beast', '', 'LineageMonster.kaim_vanul_50_bi_a', 15.00, 85.00, 85, 'male', 'L2RaidBoss', 'Fighter', 40, 3902308, 190.745, 18468, 2.700, 40, 43, 50, 21, 20, 10, 0, 0, 15000, 1500, 18000, 1800, 253, 600, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (25725, 25725, 'Drake Lord', '', 'LineageMonster6.transform_clodecus', 15.00, 49.00, 85, 'male', 'L2RaidBoss', 'Fighter', 40, 3902308, 190.745, 18468, 2.700, 40, 43, 50, 21, 20, 10, 0, 0, 15000, 1500, 18000, 1800, 253, 600, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (25718, 25718, 'Emerald Horn', '', 'LineageMonster4.drac_raid', 15.00, 63.00, 84, 'male', 'L2RaidBoss', 'Fighter', 40, 3750258, 190.745, 18120, 2.700, 40, 43, 50, 21, 20, 10, 14073897, 1903975, 33066, 1339, 11765, 1794, 278, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (25720, 25720, 'Bleeding Fly', '', 'LineageMonster4.m_drake_wing_knave_raid', 15.00, 120.00, 84, 'male', 'L2RaidBoss', 'Fighter', 40, 3750258, 190.745, 18120, 2.700, 40, 43, 50, 21, 20, 10, 19351609, 2617966, 33066, 1339, 11765, 1784, 278, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (25724, 25724, 'Muscle Bomber', '', 'LineageMonster4.dragon_berserker_raid', 15.00, 72.00, 84, 'male', 'L2RaidBoss', 'Fighter', 40, 3750258, 190.745, 18120, 2.700, 40, 43, 50, 21, 20, 10, 26388558, 3569954, 33066, 1339, 11765, 1784, 278, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (25719, 25719, 'Dust Rider', '', 'LineageMonster4.Mutant_drake_raid', 15.00, 60.00, 84, 'male', 'L2RaidBoss', 'Fighter', 40, 3187719, 190.745, 18120, 2.700, 40, 43, 30, 21, 20, 10, 17240524, 2332370, 33066, 1339, 11765, 1794, 278, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (25722, 25722, 'Shadow Summoner', '', 'LineageMonster4.dragon_shadow_raid', 15.00, 82.00, 84, 'male', 'L2RaidBoss', 'Fighter', 40, 3750258, 190.745, 18120, 2.700, 40, 43, 50, 21, 20, 10, 22870083, 3093960, 33066, 1339, 11765, 1784, 278, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (25721, 25721, 'Blackdagger Wing', '', 'LineageMonster4.mutant_drake_wing_raid', 15.00, 85.00, 84, 'male', 'L2RaidBoss', 'Fighter', 40, 3750258, 190.745, 18120, 2.700, 40, 43, 50, 21, 20, 10, 21110846, 2855963, 33066, 1339, 11765, 1784, 278, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (25723, 25723, 'Spike Slasher', '', 'LineageMonster3.antaras_ex_b_tr_raid', 15.00, 54.00, 84, 'male', 'L2RaidBoss', 'Fighter', 40, 2625180, 190.745, 18120, 2.700, 40, 43, 50, 21, 20, 10, 24629320, 3331957, 33066, 1339, 11765, 1784, 278, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (22858, 22858, 'Necromancer of the Valley', '', 'LineageMonster4.floating_skeleton_50p', 15.00, 25.00, 82, 'male', 'L2Monster', 'Mystic', 40, 3643, 7.500, 1743, 2.700, 40, 43, 30, 21, 20, 10, 26974, 2949, 500, 500, 6443, 500, 253, 400, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22815, 22815, 'Drakos', '', 'LineageMonster4.Death_slayer_080p', 15.00, 27.00, 80, 'male', 'L2Monster', 'Fighter', 40, 3290, 7.500, 1674, 2.700, 40, 43, 30, 21, 20, 10, 41310, 4436, 7814, 342, 5390, 455, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22830, 22830, 'Gem Dragon', '', 'LineageMonster3.antaras_ex_b_tr', 15.00, 24.00, 83, 'male', 'L2Monster', 'Fighter', 40, 18734, 190.745, 1777, 2.700, 40, 43, 30, 21, 20, 10, 285853, 29384, 12502, 548, 8624, 728, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22860, 22860, 'Hungry Parasitic Leech', '', 'LineageMonster.giant_leech_60p', 15.00, 15.00, 82, 'male', 'L2Monster', 'Mystic', 40, 18801, 190.745, 1743, 2.700, 40, 43, 30, 21, 20, 10, 289372, 30117, 9273, 4000, 6443, 4000, 300, 400, 500, 0, 0, 0, 30, 55, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22826, 22826, 'Scorpion Bones', '', 'LineageMonster2.scorpion_a_40p', 15.00, 23.00, 83, 'female', 'L2Monster', 'Fighter', 40, 18734, 190.745, 1777, 2.700, 40, 43, 30, 21, 20, 10, 286890, 29496, 12502, 548, 8624, 728, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22823, 22823, 'Drakos Assassin', '', 'LineageMonster4.Death_slayer_080p', 15.00, 27.00, 83, 'male', 'L2Monster', 'Fighter', 40, 18734, 190.745, 1777, 2.700, 40, 43, 30, 21, 20, 10, 289444, 29772, 12502, 548, 8624, 728, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22829, 22829, 'Emerald Drake', '', 'LineageMonster4.drac_50p', 15.00, 51.00, 82, 'male', 'L2Monster', 'Mystic', 40, 56403, 190.745, 1743, 2.700, 40, 43, 30, 21, 20, 10, 500143, 54691, 10939, 479, 7546, 638, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22862, 22862, 'Drakos Hunter', '', 'LineageMonster4.dragon_berserker_090p', 15.00, 51.00, 83, 'male', 'L2Monster', 'Fighter', 40, 18734, 190.745, 1777, 2.700, 40, 43, 30, 21, 20, 10, 410695, 42195, 9273, 4000, 6443, 4000, 300, 400, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22827, 22827, 'Batwing Drake', '', 'LineageMonster4.mutant_drake_wing_50p', 15.00, 75.00, 84, 'male', 'L2Monster', 'Mystic', 40, 56054, 190.745, 1812, 2.700, 40, 43, 30, 21, 20, 10, 529071, 56448, 14064, 616, 9702, 820, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22825, 22825, 'Giant Scorpion Bones', '', 'LineageMonster2.scorpion', 15.00, 63.00, 83, 'male', 'L2Monster', 'Fighter', 40, 56202, 190.745, 1777, 3.000, 40, 43, 30, 21, 20, 10, 494068, 53357, 12502, 548, 8624, 728, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32871, 32871, 'Dragon Vortex', '', 'LineageNPC.collision_dummy_dragon', 120.00, 50.00, 1, 'male', 'DragonVortex', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32864, 32864, 'Separated Soul', '', 'LineageNPC.a_temple_master_Mhuman', 10.00, 25.00, 1, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32865, 32865, 'Separated Soul', '', 'LineageNPC.a_temple_master_Mhuman', 10.00, 25.00, 1, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32866, 32866, 'Separated Soul', '', 'LineageNPC.a_temple_master_Mhuman', 10.00, 30.00, 1, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32867, 32867, 'Separated Soul', '', 'LineageNPC.a_temple_master_Mhuman', 10.00, 25.00, 1, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32868, 32868, 'Separated Soul', '', 'LineageNPC.a_temple_master_Mhuman', 10.00, 25.00, 1, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32869, 32869, 'Separated Soul', '', 'LineageNPC.a_temple_master_Mhuman', 10.00, 25.00, 1, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32870, 32870, 'Separated Soul', '', 'LineageNPC.a_temple_master_Mhuman', 10.00, 25.00, 1, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32891, 32891, 'Separated Soul', '', 'LineageNPC.a_temple_master_Mhuman', 10.00, 25.00, 1, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22818, 22818, 'Exploding Orc Ghost', '', 'LineageMonster3.zombie_enlisted_man', 15.00, 20.00, 81, 'male', 'L2Monster', 'Fighter', 40, 3461, 50.000, 1708, 1.600, 40, 43, 30, 21, 20, 20, 25020, 2771, 9376, 410, 6468, 546, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22819, 22819, 'Wrathful Orc Ghost', '', 'LineageMonster3.zombie_laborer', 15.00, 23.00, 81, 'male', 'L2Monster', 'Fighter', 40, 3461, 50.000, 1708, 1.600, 40, 43, 30, 21, 20, 20, 25020, 2771, 9376, 410, 6468, 546, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22822, 22822, 'Drakos Warrior', '', 'LineageMonster4.dragon_berserker_090p', 15.00, 47.00, 83, 'male', 'L2Monster', 'Fighter', 40, 18734, 110.000, 1777, 3.000, 40, 43, 30, 21, 20, 20, 417476, 42928, 12502, 548, 8624, 728, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22828, 22828, 'Parasitic Leech', '', 'LineageMonster.giant_leech_60p', 15.00, 19.00, 83, 'male', 'L2Monster', 'Fighter', 40, 18734, 110.000, 1777, 3.000, 40, 43, 30, 21, 20, 20, 287945, 29610, 12502, 548, 8624, 728, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22831, 22831, 'Dragon Tracker of the Valley', '', 'LineageMonster3.antaras_ex_a_70p', 15.00, 38.00, 83, 'male', 'L2Monster', 'Fighter', 40, 56202, 180.000, 1777, 3.000, 40, 43, 30, 21, 20, 20, 593073, 64049, 12502, 548, 8624, 728, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22833, 22833, 'Sand Drake Tracker', '', 'LineageMonster4.m_drake_wing_knave_50p', 15.00, 60.00, 83, 'male', 'L2Monster', 'Fighter', 40, 56202, 180.000, 1777, 3.000, 40, 43, 30, 21, 20, 20, 619381, 66891, 12502, 548, 8624, 728, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22835, 22835, 'Magma Drake Mother', '', 'LineageMonster2.inferno_drake_120p', 15.00, 42.00, 83, 'male', 'L2Monster', 'Fighter', 40, 127834, 340.000, 1777, 3.000, 40, 43, 30, 21, 20, 20, 1999647, 216237, 12502, 548, 8624, 728, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22836, 22836, 'Magma Drake Hatchling', '', 'LineageMonster2.inferno_drake_50p', 15.00, 16.00, 83, 'male', 'L2Monster', 'Fighter', 40, 38350, 110.000, 1777, 3.000, 40, 43, 30, 21, 20, 20, 749867, 81089, 12502, 548, 8624, 728, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22837, 22837, 'Gem Dragon Hatchling', '', 'LineageMonster3.antaras_ex_b_tr_70p', 15.00, 16.00, 83, 'male', 'L2Monster', 'Fighter', 40, 38350, 110.000, 1777, 3.000, 40, 43, 30, 21, 20, 20, 999823, 108118, 12502, 548, 8624, 728, 278, 400, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (50848, 50848, 'Dead Drake Leader', '', 'LineageMonster4.Dragon_archmage_135p_a', 15.00, 50.00, 85, 'female', 'L2Merchant', 'npc', 40, 3862, 8.500, 1494, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 333, 0, 0, 0, 50, 160, '', 300, 25725, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (50726, 50726, 'Dead Behemoth Leader', '', 'LineageMonster4.Dragon_archmage_135p_a', 15.00, 50.00, 85, 'female', 'L2Merchant', 'npc', 40, 3862, 8.500, 1494, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 333, 0, 0, 0, 50, 160, '', 300, 25726, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (50727, 50727, 'Dead Dragon Beast', '', 'LineageMonster4.Dragon_archmage_135p_a', 15.00, 50.00, 85, 'female', 'L2Merchant', 'npc', 40, 3862, 8.500, 1494, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 333, 0, 0, 0, 50, 160, '', 300, 25727, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (50728, 50728, 'Dragon Vortex', '', 'LineageNPC.collision_dummy_dragon', 120.00, 50.00, 1, 'male', 'L2DragonVortex', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (50729, 50729, 'Dragon Vortex', '', 'LineageNPC.collision_dummy_dragon', 120.00, 50.00, 1, 'male', 'L2DragonVortex', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (50730, 50730, 'Dragon Vortex', '', 'LineageNPC.collision_dummy_dragon', 120.00, 50.00, 1, 'male', 'L2DragonVortex', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (29028, 91107, 'Valakas', '', 'valakas', 190.00, 335.00, 85, 'male', 'L2Boss', 'BossRandomAi', 40, 93742616, 1836.000, 2025740, 1000.000, 60, 57, 73, 76, 70, 80, 296105312, 29014318, 28016, 7604, 11606, 2064, 253, 1500, 506, 0, 0, 0, 120, 300, 'valakas_clan', 300, 0, 0, 0, 21, 50, 1, 9, 0, 3, 0.60, 'false', 'NONE', 0, 1);
INSERT INTO `npc` VALUES (2425, 25735, 'Greyclaw Kutus', '', 'ol_mahum_champion_50_bi', 21.00, 43.50, 23, 'male', 'L2RaidBoss', 'Fighter', 40, 40330, 17.535, 232, 1.500, 60, 57, 73, 76, 70, 80, 2690117, 69902, 71, 321, 4, 157, 253, 0, 506, 67, 633, 0, 50, 170, '', 300, 0, 20, 383, 7, 30, 4, 5, 0, -18, 0.63, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2426, 25736, 'Guard of Kutus', '', 'ol_mahum', 13.50, 25.00, 22, 'male', 'L2Minion', 'Fighter', 40, 4186, 17.158, 219, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 171, 154, 29, 151, 253, 0, 506, 7, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2427, 25737, 'Pawn of Kutus', '', 'ol_mahum', 13.50, 25.00, 22, 'male', 'L2Minion', 'Fighter', 40, 6247, 17.158, 219, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 256, 154, 64, 151, 253, 0, 506, 123, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2781, 25738, 'Tracker Leader Sharuk', '', 'virud_lizardman_warrior', 12.00, 30.00, 23, 'male', 'L2RaidBoss', 'Fighter', 40, 40330, 17.535, 232, 1.500, 60, 57, 73, 76, 70, 80, 2690117, 69902, 71, 321, 4, 157, 253, 0, 506, 291, 0, 0, 52, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.59, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2782, 25739, 'Sharuks Tracker', '', 'virud_lizardman', 10.00, 23.00, 22, 'male', 'L2Minion', 'Fighter', 40, 3124, 17.158, 219, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 129, 154, 17, 151, 253, 0, 506, 2, 0, 0, 43, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2783, 25740, 'Sharuks Marksman', '', 'virud_lizardman_scout', 10.00, 22.00, 22, 'male', 'L2Minion', 'Ranger', 1100, 4186, 17.158, 219, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 129, 154, 17, 151, 253, 0, 506, 2507, 0, 0, 43, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.72, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2776, 25741, 'Sukar Wererat Chief', '', 'wererat', 14.00, 25.00, 21, 'male', 'L2RaidBoss', 'Fighter', 40, 37886, 16.827, 205, 1.500, 60, 57, 73, 76, 70, 80, 2646358, 60367, 58, 296, 3, 144, 253, 0, 506, 216, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.61, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2777, 25742, 'Sukar Wererat Guard', '', 'wererat_sm', 12.00, 18.70, 20, 'male', 'L2Minion', 'Fighter', 40, 5896, 16.540, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 213, 142, 41, 138, 253, 0, 506, 216, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2778, 25743, 'Sukar Wererat Priest', '', 'wererat_sm', 12.00, 18.70, 20, 'male', 'L2Minion', 'Priest', 40, 5896, 16.540, 192, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 107, 142, 11, 138, 253, 0, 506, 179, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.61, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2588, 25744, 'Ikuntai', '', 'skeleton_knight_50_bi', 15.00, 39.00, 25, 'male', 'L2RaidBoss', 'Fighter', 40, 56644, 24.086, 259, 1.500, 60, 57, 73, 76, 70, 80, 1589296, 122871, 157, 349, 18, 170, 253, 0, 506, 150, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.17, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2589, 25745, 'Ikuntais Servitor', '', 'silhouette', 8.00, 23.00, 24, 'female', 'L2Minion', 'Priest', 40, 8726, 23.437, 246, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 287, 167, 67, 163, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2590, 25746, 'Pawn of Ikuntai', '', 'skeleton_pikeman', 10.00, 28.00, 24, 'male', 'L2Minion', 'Fighter', 40, 4363, 23.437, 246, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 287, 167, 67, 163, 253, 0, 506, 299, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.21, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2573, 25747, 'Zombie Lord Crowl', '', 'zombie_100_bi', 30.00, 21.25, 25, 'male', 'L2RaidBoss', 'Fighter', 40, 43316, 18.439, 259, 1.500, 60, 57, 73, 76, 70, 80, 2541013, 79280, 84, 349, 6, 170, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2574, 25748, 'Evil Spirit Archer', '', 'skeleton_archer', 11.00, 27.00, 24, 'male', 'L2Minion', 'Ranger', 1100, 4476, 17.961, 246, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 155, 167, 19, 163, 253, 0, 506, 14, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2575, 25749, 'Evil Spirit Warrior', '', 'skeleton', 11.00, 25.00, 24, 'male', 'L2Minion', 'Fighter', 40, 3340, 17.961, 246, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 155, 167, 19, 163, 253, 0, 506, 946, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.30, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2794, 25750, 'Zombie Lord Farakelsus', '', 'zombie_bi', 12.00, 27.50, 20, 'male', 'L2RaidBoss', 'Fighter', 40, 36847, 16.540, 192, 1.200, 60, 57, 73, 76, 70, 80, 3041767, 59634, 53, 284, 2, 138, 253, 0, 506, 0, 0, 0, 15, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.43, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2795, 25751, 'Warrior Zombie of Farakelsus', '', 'zombie', 13.00, 21.00, 19, 'male', 'L2Minion', 'Mystic', 40, 5747, 16.294, 183, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 193, 136, 37, 133, 253, 0, 506, 0, 0, 0, 15, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2796, 25752, 'Priest Zombie of Farakelsus', '', 'zombie', 13.00, 21.00, 19, 'male', 'L2Minion', 'Priest', 40, 5747, 16.294, 183, 1.200, 40, 43, 30, 21, 20, 20, 0, 0, 97, 136, 9, 133, 253, 0, 506, 0, 0, 0, 15, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.43, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2542, 25753, 'Guilotine, Warden of the Execution Grounds', '', 'skeleton_pikeman_100_bi', 20.00, 58.00, 35, 'male', 'L2RaidBoss', 'Fighter', 40, 138899, 66.986, 403, 1.800, 60, 57, 73, 76, 70, 80, 1912395, 144137, 405, 508, 64, 248, 253, 0, 506, 96, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.21, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2576, 25754, 'Flame Lord Shadar', '', 'dre_vanul_100_bi', 28.00, 75.00, 35, 'male', 'L2RaidBoss', 'Fighter', 40, 69450, 26.794, 403, 1.800, 60, 57, 73, 76, 70, 80, 1912395, 144137, 203, 508, 16, 248, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.35, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2577, 25755, 'Claws of Shadar', '', 'imp', 10.00, 24.00, 34, 'male', 'L2Minion', 'Fighter', 40, 10527, 25.613, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 747, 245, 237, 240, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2578, 25756, 'Whip of Shadar', '', 'succubus', 10.00, 36.00, 34, 'female', 'L2Minion', 'Mystic', 40, 5263, 25.613, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 373, 245, 59, 240, 253, 0, 506, 0, 0, 0, 60, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2642, 25757, 'Soul Collector Acheron', '', 'vale_master_50_bi', 18.00, 63.00, 35, 'male', 'L2RaidBoss', 'Fighter', 40, 69450, 26.794, 403, 1.800, 60, 57, 73, 76, 70, 80, 1912395, 144137, 203, 508, 16, 248, 253, 0, 506, 192, 0, 0, 70, 160, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.74, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2643, 25758, 'Soul Slasher', '', 'dark_horror', 20.00, 35.00, 34, 'male', 'L2Minion', 'Fighter', 40, 7053, 25.613, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 498, 245, 106, 240, 253, 0, 506, 0, 0, 0, 100, 140, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.37, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2644, 25759, 'Soul Strainer', '', 'hungry_spirit', 30.00, 40.00, 34, 'male', 'L2Minion', 'Fighter', 40, 10527, 25.613, 388, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 747, 245, 237, 240, 253, 0, 506, 0, 0, 0, 15, 155, '', 0, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2826, 25760, 'Lord Ishka ', '', 'death_blader_bi', 22.00, 67.00, 60, 'male', 'L2RaidBoss', 'Fighter', 40, 221100, 72.964, 1037, 2.400, 60, 57, 73, 76, 70, 80, 2735033, 394692, 1170, 1107, 200, 539, 253, 0, 506, 1472, 0, 0, 100, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2827, 25761, 'Ishkas Elite Officer', '', 'skeleton_royal_guard', 11.00, 28.50, 59, 'male', 'L2Minion', 'Fighter', 40, 34433, 71.371, 1007, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 4433, 539, 2904, 525, 253, 0, 506, 946, 945, 0, 80, 190, '', 300, 0, 20, 486, 7, 10, 8, 0, 0, -18, 0.52, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2828, 25762, 'Ishkas Elite Soldier', '', 'skeleton_knight_20_bi', 12.00, 30.50, 59, 'male', 'L2Minion', 'Fighter', 40, 34433, 71.371, 1007, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 4433, 539, 2904, 525, 253, 0, 506, 150, 103, 0, 40, 190, '', 300, 0, 20, 486, 7, 30, 4, 5, 0, -18, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2604, 25763, 'Demon Kurikups', '', 'karik_100_bi', 50.00, 180.00, 59, 'male', 'L2RaidBoss', 'Fighter', 40, 215208, 71.371, 1007, 2.400, 60, 57, 73, 76, 70, 80, 2684275, 381459, 1109, 1077, 182, 525, 253, 0, 506, 0, 0, 0, 37, 200, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2605, 25764, 'Kurikups Wife', '', 'bloody_queen', 14.00, 40.00, 58, 'female', 'L2Minion', 'Mystic', 40, 33456, 69.691, 977, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2096, 525, 676, 512, 253, 0, 506, 0, 0, 0, 80, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2606, 25765, 'Devil Blader of Chaos', '', 'death_blader', 15.00, 45.00, 58, 'male', 'L2Minion', 'Fighter', 40, 16728, 69.691, 977, 2.400, 40, 43, 30, 21, 20, 20, 0, 0, 2096, 525, 676, 512, 253, 0, 506, 1472, 0, 0, 100, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (2653, 25766, 'Ancient Weird Drake', '', 'drake_50_bi', 45.00, 150.00, 60, 'male', 'L2RaidBoss', 'Fighter', 40, 442200, 182.411, 1037, 2.400, 60, 57, 73, 76, 70, 80, 2735033, 394692, 2339, 1107, 796, 539, 253, 0, 506, 0, 0, 0, 70, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.84, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2555, 25767, 'Carnage Lord Gato', '', 'oel_mahum_50_bi', 30.00, 57.00, 50, 'male', 'L2RaidBoss', 'Fighter', 40, 155046, 53.855, 748, 2.100, 60, 57, 73, 76, 70, 80, 2389767, 281312, 637, 835, 79, 407, 253, 0, 506, 71, 0, 0, 70, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.48, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2556, 25768, 'Gatos Marksman', '', 'ol_mahum_archer', 14.00, 25.00, 49, 'male', 'L2Minion', 'Ranger', 1100, 15874, 51.719, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1191, 404, 287, 395, 253, 0, 506, 273, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.93, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2557, 25769, 'Gatos Troop Leader', '', 'ol_mahum_champion', 14.00, 27.00, 49, 'male', 'L2Minion', 'Fighter', 40, 11846, 51.719, 720, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1191, 404, 287, 395, 253, 0, 506, 69, 0, 0, 50, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.63, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2450, 25770, 'Katu Van Leader Atui', '', 'ketra_orc_overload', 12.00, 24.00, 49, 'male', 'L2RaidBoss', 'Fighter', 40, 148076, 51.719, 720, 2.100, 60, 57, 73, 76, 70, 80, 2328069, 284981, 595, 810, 72, 395, 253, 0, 506, 84, 0, 0, 33, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.48, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2451, 25771, 'Katu Van Marksman', '', 'ketra_orc_archer', 12.00, 27.00, 48, 'male', 'L2Minion', 'Ranger', 1100, 15134, 49.588, 692, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1110, 393, 262, 384, 253, 0, 506, 279, 0, 0, 45, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.91, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2452, 25772, 'Katu Van Raider', '', 'ketra_orc_warrior', 12.00, 24.00, 48, 'male', 'L2Minion', 'Fighter', 40, 11294, 49.588, 692, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1110, 393, 262, 384, 253, 0, 506, 128, 0, 0, 36, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.54, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2481, 25773, 'Biconne of Blue Sky', '', 'lienrik', 12.00, 50.00, 45, 'male', 'L2RaidBoss', 'Fighter', 40, 121183, 43.343, 611, 2.100, 60, 57, 73, 76, 70, 80, 2085510, 229987, 448, 714, 48, 348, 253, 0, 506, 0, 0, 0, 100, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.46, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2482, 25774, 'Biconnes Shooter', '', 'skeleton_archer', 11.00, 27.00, 44, 'male', 'L2Minion', 'Ranger', 1100, 12313, 41.347, 584, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 830, 346, 174, 338, 253, 0, 506, 279, 0, 0, 40, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.80, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2483, 25775, 'Biconnes Warrior', '', 'skeleton_knight', 10.00, 25.00, 44, 'male', 'L2Minion', 'Fighter', 40, 9189, 41.347, 584, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 830, 346, 174, 338, 253, 0, 506, 150, 0, 0, 40, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.17, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2614, 25776, 'Earth Protector Panathen', '', 'farhite', 16.00, 31.00, 43, 'male', 'L2RaidBoss', 'Fighter', 40, 108760, 39.411, 557, 2.100, 60, 57, 73, 76, 70, 80, 1976893, 206038, 385, 669, 40, 327, 253, 0, 506, 183, 0, 0, 15, 170, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.74, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2615, 25777, 'Panathens Knight', '', 'nos', 26.00, 42.00, 42, 'male', 'L2Minion', 'Fighter', 40, 16463, 37.544, 531, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 1425, 324, 567, 316, 253, 0, 506, 5130, 0, 0, 18, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.78, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2616, 25778, 'Panathens Protectors', '', 'dailaon', 20.00, 28.00, 42, 'male', 'L2Minion', 'Ranger', 1100, 8231, 37.544, 531, 2.100, 40, 43, 30, 21, 20, 20, 0, 0, 713, 324, 141, 316, 253, 0, 506, 5127, 0, 0, 18, 170, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.91, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2845, 25779, 'Betrayer of Urutu Freki', '', 'werewolf_bi', 11.00, 29.70, 25, 'male', 'L2RaidBoss', 'Fighter', 40, 43316, 18.439, 259, 1.500, 60, 57, 73, 76, 70, 80, 2541013, 79280, 84, 349, 6, 170, 253, 0, 506, 0, 0, 0, 50, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.43, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2846, 25780, 'Frekis Vampire Bat', '', 'vampire_bat', 10.00, 33.50, 24, 'male', 'L2Minion', 'Mystic', 40, 6680, 17.961, 246, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 308, 167, 78, 163, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.50, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2847, 25781, 'Frekis Wild Bear', '', 'grizzly', 21.00, 40.00, 24, 'male', 'L2Minion', 'Fighter', 40, 6680, 17.961, 246, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 308, 167, 78, 163, 253, 0, 506, 0, 0, 0, 40, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2923, 25782, 'Nellis Vengeful Spirit', '', 'a_mageguild_teacher_Mhuman_mon_120p', 10.00, 28.10, 39, 'male', 'L2RaidBoss', 'Fighter', 40, 86871, 32.412, 463, 1.800, 60, 57, 73, 76, 70, 80, 1988451, 173127, 282, 585, 22, 285, 253, 0, 506, 8532, 0, 0, 50, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.63, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2924, 25783, 'Nellis Follower', '', 'dwarf_ghost', 9.00, 16.50, 38, 'male', 'L2Minion', 'Fighter', 40, 13134, 30.873, 448, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 1039, 283, 328, 276, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.39, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2925, 25784, 'Rayito the Looter', '', 'ol_mahum_champion_05te_120p', 16.00, 33.20, 37, 'male', 'L2RaidBoss', 'Fighter', 40, 77593, 29.423, 433, 1.800, 60, 57, 73, 76, 70, 80, 1932589, 153693, 239, 546, 19, 266, 253, 0, 506, 67, 633, 0, 50, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.63, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2926, 25785, 'Rayitos Henchman', '', 'ol_mahum_05te_110p', 14.50, 28.00, 36, 'male', 'L2Minion', 'Fighter', 40, 11741, 28.064, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 883, 264, 281, 258, 253, 0, 506, 123, 19, 0, 50, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2927, 25786, 'Rayitos Henchman', '', 'northern_goblin_110p', 6.00, 16.60, 36, 'male', 'L2Minion', 'Fighter', 40, 7866, 28.064, 418, 1.800, 40, 43, 30, 21, 20, 20, 0, 0, 589, 264, 125, 258, 253, 0, 506, 66, 102, 0, 30, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2718, 25787, 'Ketras Hero Hekaton', '', 'ketra_orc_chieftain_20_bi', 17.00, 46.20, 80, 'male', 'L2RaidBoss', 'Fighter', 40, 300327, 92.339, 1675, 3.000, 60, 57, 73, 76, 70, 80, 3775961, 557272, 2442, 1731, 475, 845, 253, 0, 506, 6719, 0, 0, 24, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.51, 'false', 'SOUL', 1, 1);
INSERT INTO `npc` VALUES (2719, 25788, 'Scout of Hekaton', '', 'ketra_orc_archer', 12.00, 27.00, 79, 'male', 'L2Minion', 'Ranger', 1100, 31867, 91.493, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4786, 850, 1858, 828, 253, 0, 506, 288, 0, 0, 45, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 1500, -18, 0.91, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2720, 25789, 'Servant of Hekaton', '', 'ketra_orc', 12.00, 29.00, 79, 'male', 'L2Minion', 'Fighter', 40, 23781, 91.493, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4786, 850, 1858, 828, 253, 0, 506, 79, 0, 0, 45, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.46, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2728, 25790, 'Varkas Hero Shadith', '', 'barka_silenos_shaman_20_bi', 17.00, 47.50, 80, 'male', 'L2RaidBoss', 'Mystic', 40, 300327, 92.339, 1675, 3.000, 60, 57, 73, 76, 70, 80, 3775961, 557272, 2442, 1731, 475, 845, 253, 0, 506, 6716, 0, 0, 36, 190, '', 300, 0, 0, 0, 7, 50, 1, 9, 0, -18, 0.54, 'false', 'SOUL_BSPIRIT', 1, 1);
INSERT INTO `npc` VALUES (2729, 25791, 'Shadiths Royal Guard Captain', '', 'barka_silenos_warrior', 16.00, 41.00, 79, 'male', 'L2Minion', 'Fighter', 40, 47562, 91.493, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 9573, 850, 7432, 828, 253, 0, 506, 142, 6918, 0, 34, 190, '', 300, 0, 20, 674, 7, 30, 4, 5, 0, -18, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2730, 25792, 'Shadiths Sentinel', '', 'barka_silenos_hunter', 16.00, 38.00, 79, 'male', 'L2Minion', 'Fighter', 40, 23781, 91.493, 1641, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 4786, 850, 1858, 828, 253, 0, 506, 2504, 0, 0, 44, 190, '', 300, 0, 0, 0, 7, 10, 8, 0, 0, -18, 0.48, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2667, 25793, 'Doom Blade Tanatos', '', 'death_blader_bi', 15.00, 32.50, 72, 'male', 'L2RaidBoss', 'Fighter', 40, 766920, 299.923, 1410, 3.000, 60, 57, 73, 76, 70, 80, 5140647, 827123, 7343, 1475, 5241, 720, 253, 0, 506, 0, 0, 0, 60, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.60, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2478, 25794, 'Kernon', '', 'kaim_vanul', 24.00, 40.00, 75, 'male', 'L2RaidBoss', 'Kernon', 40, 397437, 123.216, 1508, 3.000, 60, 57, 73, 76, 70, 80, 5231148, 864099, 4020, 1571, 1425, 766, 253, 0, 506, 0, 0, 0, 37, 170, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2479, 25795, 'Taliadon', '', 'death_blader', 15.00, 45.00, 74, 'male', 'L2Minion', 'Fighter', 40, 62863, 122.143, 1475, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 15628, 769, 22217, 751, 253, 0, 506, 1472, 0, 0, 100, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.45, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2480, 25796, 'Vemsk', '', 'death_knight', 12.00, 31.00, 74, 'male', 'L2Minion', 'Fighter', 40, 31432, 122.143, 1475, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 7814, 769, 5555, 751, 253, 0, 506, 142, 0, 0, 27, 170, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.71, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2872, 25797, 'Meanas Anor', '', 'wyrm_50_bi', 58.00, 108.00, 70, 'male', 'L2RaidBoss', 'Fighter', 40, 373386, 117.684, 1346, 2.700, 60, 57, 73, 76, 70, 80, 4596480, 802604, 3426, 1412, 1140, 688, 253, 0, 506, 0, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.19, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2873, 25798, 'Wyvern of Marsh', '', 'wyrm', 29.00, 72.00, 69, 'male', 'L2Minion', 'Fighter', 40, 39455, 116.469, 1314, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 8802, 690, 7789, 673, 253, 0, 506, 0, 0, 0, 70, 190, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, -18, 0.19, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2874, 25799, 'Succubus of Marsh', '', 'succubus', 10.00, 36.00, 69, 'female', 'L2Minion', 'Mystic', 40, 58887, 116.469, 1314, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 6603, 690, 4383, 673, 253, 0, 506, 0, 0, 0, 60, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.84, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (2848, 25800, 'Mammon Collector Talos', '', 'ashuras', 13.00, 37.50, 25, 'male', 'L2RaidBoss', 'Fighter', 40, 43316, 18.439, 259, 1.500, 60, 57, 73, 76, 70, 80, 2541013, 79280, 84, 349, 6, 170, 253, 0, 506, 0, 0, 0, 41, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.50, 'false', 'NONE', 1, 1);
INSERT INTO `npc` VALUES (2849, 25801, 'Talos Cohort', '', 'dre_vanul', 14.00, 36.00, 22, 'male', 'L2Minion', 'Fighter', 40, 6247, 17.158, 219, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 256, 154, 64, 151, 253, 0, 506, 0, 0, 0, 80, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.35, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (50729, 4325, 'Altar Guard', '', 'LineageNPC.a_guard_MHuman', 6.00, 23.00, 85, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (50730, 4326, 'Nevit\'s Herald', '', 'LineageNPC.a_sanctuary_teacher_FHuman', 6.00, 23.00, 85, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (50731, 4327, 'Worshipper', 'Sinister', 'LineageNPC2.solina_father_dead', 6.00, 25.00, 85, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (50732, 4328, 'Altar Guard', '', 'LineageNPC2.a_guard_Mhuman_dead', 6.00, 25.00, 85, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (50733, 4329, 'Miss Queen', 'Happy Messenger', 'LineageMonster2.queen_of_cat', 6.00, 16.00, 85, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (50734, 4315, 'Warehouse Keeper', 'Fantasy Isle Warehouse Keeper ', 'LineageNPC.e_teleporter_FDwarf', 8.00, 23.50, 85, 'male', 'L2Warehouse', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (50735, 4316, 'Photo Snow', 'Photographer', 'LineageNPC2.br_tp_actor', 6.00, 16.00, 85, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (50736, 4317, 'Photo Snow', 'Photographer', 'LineageNPC2.br_tp_actor', 6.00, 16.00, 85, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (50737, 4318, 'Photo Snow', 'Photographer', 'LineageNPC2.br_tp_actor', 6.00, 16.00, 85, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (50738, 4319, 'Photo Snow', 'Photographer', 'LineageNPC2.br_tp_actor', 6.00, 16.00, 85, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (50739, 4320, 'Photo Snow', 'Photographer', 'LineageNPC2.br_tp_actor', 6.00, 16.00, 85, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (50740, 4321, 'Photo Snow', 'Photographer', 'LineageNPC2.br_tp_actor', 6.00, 16.00, 85, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (50741, 4322, 'Photo Snow', 'Photographer', 'LineageNPC2.br_tp_actor', 6.00, 16.00, 85, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (50742, 4323, 'Photo Snow', 'Photographer', 'LineageNPC2.br_tp_actor', 6.00, 16.00, 85, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32845, 32845, 'Treasure Chest', '', 'mimic', 8.50, 8.50, 78, 'male', 'L2Chest', 'Fighter', 40, 3365, 3.210, 1976, 3.210, 40, 43, 30, 21, 20, 20, 0, 0, 1757, 668, 1284, 404, 253, 0, 506, 0, 0, 0, 80, 1, '', 0, 0, 0, 0, 7, 30, 4, 12, 0, 7, 0.56, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22852, 22852, 'Drake Guard', '', '', 20.00, 50.00, 85, 'male', 'L2Monster', 'Fighter', 40, 55817, 200.000, 1846, 2.700, 40, 43, 30, 21, 20, 10, 1031278, 103445, 12000, 1200, 12000, 1500, 333, 500, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32862, 32862, 'Gruff-looking Man', 'Priest', 'LineageNPC.a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (27421, 27421, 'Creature of the Dusk', '', 'LineageMonster.skeleton_royal_guard', 21.00, 40.00, 81, 'male', 'L2Monster', 'Fighter', 40, 6680, 17.961, 246, 1.500, 40, 43, 30, 21, 20, 20, 0, 0, 308, 167, 78, 163, 253, 0, 506, 0, 0, 0, 40, 190, '', 300, 0, 0, 0, 7, 10, 4, 5, 0, -18, 0.34, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (3976, 2501, 'Fortune Bug', '', 'LineageNPC2.br_LuckyPig', 16.00, 22.50, 75, 'male', 'L2Monster', 'Fighter', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 45, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3976, 2502, 'Wingless Luckpy Luckpy ', '', 'LineageNPC2.E_pig_ball', 16.00, 22.50, 75, 'male', 'L2Monster', 'Luckpy', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 45, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (3976, 2503, 'Wingless Luckpy Luckpy ', '', 'LineageNPC2.E_pig_ball', 16.00, 22.50, 75, 'male', 'L2Monster', 'Luckpy', 40, 2677, 8.500, 1508, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 1304, 523, 891, 384, 253, 0, 506, 0, 0, 0, 45, 160, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6705, 32861, 'Sofia', 'Library Director of Saints', 'LineageNPC.a_mageguild_teacher_FElf', 7.00, 21.20, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6705, 32863, 'Sofia', 'Library Director of Saints', 'LineageNPC.a_mageguild_teacher_FElf', 7.00, 21.20, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6705, 32809, 'Sofia', 'Library Director of Saints', 'LineageNPC.a_mageguild_teacher_FElf', 7.00, 21.20, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6705, 32810, 'Sofia', 'Library Director of Saints', 'LineageNPC.a_mageguild_teacher_FElf', 7.00, 21.20, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6705, 32811, 'Sofia', 'Library Director of Saints', 'LineageNPC.a_mageguild_teacher_FElf', 7.00, 21.20, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6705, 32812, 'Sofia', 'Library Director of Saints', 'LineageNPC.a_mageguild_teacher_FElf', 7.00, 21.20, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6705, 32813, 'Sofia', 'Library Director of Saints', 'LineageNPC.a_mageguild_teacher_FElf', 7.00, 21.20, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (6705, 32814, 'Sofia', 'Library Director of Saints', 'LineageNPC.a_mageguild_teacher_FElf', 7.00, 21.20, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32784, 32784, 'Elcadia', 'Priest', 'LineageNPC.a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32785, 32785, 'Elcadia', 'Priest', 'LineageNPC.a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32786, 32786, 'Elcadia', 'Priest', 'LineageNPC.a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32787, 32787, 'Elcadia', 'Priest', 'LineageNPC.a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32788, 32788, 'Elcadia', 'Priest', 'LineageNPC.a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32789, 32789, 'Elcadia', 'Priest', 'LineageNPC.a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32790, 32790, 'Elcadia', 'Priest', 'LineageNPC.a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32791, 32791, 'Elcadia', 'Priest', 'LineageNPC.a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32798, 32798, 'Elcadia', 'Priest', 'LineageNPC.a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32792, 32792, 'Eris\\\'s Evil Thoughts', 'Director', 'LineageNPC.a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 10, 0, 0, 500, 500, 500, 500, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32793, 32793, 'Solina\'s Evil Thoughts', 'Saintess of Elmore-Aden', 'LineageNpc2.solina_the_saint', 12.00, 23.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32794, 32794, 'Solina', 'Saintess of Elmore-Aden', 'LineageNpc2.solina_the_saint', 12.00, 23.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32795, 32795, 'Eris', 'Solina\'s Disciple', 'LineageNpc2.elyss_the_silent', 11.00, 22.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32796, 32796, 'Anais', 'Solina\'s Disciple', 'LineageNpc2.officiating_minister', 14.00, 27.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32797, 32797, 'Jude van Etina', 'Solina\'s Disciple', 'LineageNpc2.udit_van_etina', 13.00, 20.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32820, 32820, 'Teleport Control Device', '', 'LineageNPC.camera_target_dummy', 18.00, 50.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32837, 32837, 'Teleport Control Device', '', 'LineageNPC.camera_target_dummy', 18.00, 50.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32838, 32838, 'Powerful Device', '', 'LineageNpcEV.ssq2_stick_main', 42.00, 58.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32839, 32839, 'Powerful Device', '', 'LineageNpcEV.ssq2_stick_main', 42.00, 58.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32840, 32840, 'Powerful Device', '', 'LineageNpcEV.ssq2_stick_main', 42.00, 58.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32841, 32841, 'Powerful Device', '', 'LineageNpcEV.ssq2_stick_main', 42.00, 58.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32842, 32842, 'Teleport Control Device', '', 'LineageNPC.camera_target_dummy', 18.00, 50.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32843, 32843, 'Tomb of the Saintess', '', 'LineageNPC.camera_target_dummy', 18.00, 50.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32844, 32844, 'Teleport Control Device', '', 'LineageNPC.camera_target_dummy', 18.00, 50.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32853, 32853, 'Altar of Hallows', '', 'LineageMonster5.bounded_mimic', 16.00, 35.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32854, 32854, 'Altar of Hallows', '', 'LineageMonster5.bounded_mimic', 16.00, 35.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32855, 32855, 'Altar of Hallows', '', 'LineageMonster5.bounded_mimic', 16.00, 35.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32856, 32856, 'Altar of Hallows', '', 'LineageMonster5.bounded_mimic', 16.00, 35.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32857, 32857, 'Altar of Hallows', '', 'LineageNpcEV.staff_altar', 16.00, 88.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32858, 32858, 'Altar of Hallows', '', 'LineageNpcEV.sword_altar', 16.00, 90.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32859, 32859, 'Altar of Hallows', '', 'LineageNpcEV.book_altar', 16.00, 50.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32860, 32860, 'Altar of Hallows', '', 'LineageNpcEV.shield_altar', 16.00, 70.00, 80, 'male', 'L2Npc', 'npc', 40, 2444, 7.500, 2444, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 500, 500, 500, 500, 253, 0, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (18949, 18949, 'Etis van Etina', 'Head of the Embryo', 'LineageMonster6.etis_van_etina_tran', 17.00, 29.50, 84, 'male', 'L2Monster', 'Fighter', 40, 5757, 8.500, 2126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2165, 500, 500, 500, 253, 2000, 333, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (18952, 18952, 'Solina\'s Guardian', '', 'LineageNpc2.fallow_of_solina', 15.00, 30.00, 82, 'male', 'L2Monster', 'Fighter', 40, 5757, 8.500, 2126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2165, 598, 1707, 534, 278, 300, 333, 0, 0, 0, 60, 120, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (18953, 18953, 'Solina\'s Guardian', '', 'LineageNpc2.fallow_of_solina', 15.00, 30.00, 82, 'male', 'L2Monster', 'Fighter', 40, 5757, 8.500, 2126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2165, 598, 1707, 534, 278, 300, 333, 0, 0, 0, 60, 120, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (18954, 18954, 'Solina\'s Guardian', '', 'LineageNpc2.fallow_of_solina', 15.00, 30.00, 82, 'male', 'L2Monster', 'Fighter', 40, 5757, 8.500, 2126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2165, 598, 1707, 534, 278, 300, 333, 0, 0, 0, 60, 120, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (18955, 18955, 'Solina\'s Guardian', '', 'LineageNpc2.fallow_of_solina', 15.00, 30.00, 82, 'male', 'L2Monster', 'Fighter', 40, 5757, 8.500, 2126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2165, 598, 1707, 534, 278, 300, 333, 0, 0, 0, 60, 120, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (18956, 18956, 'Guardian of the Tomb', '', 'LineageMonster3.apostle_grail_a', 15.00, 47.00, 82, 'male', 'L2Monster', 'Fighter', 1100, 5757, 8.500, 2126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2165, 598, 1707, 534, 278, 0, 333, 0, 0, 0, 110, 180, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (18957, 18957, 'Guardian of the Tomb', '', 'LineageMonster3.apostle_grail_a', 15.00, 47.00, 82, 'male', 'L2Monster', 'Fighter', 1100, 5757, 8.500, 2126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2165, 598, 1707, 534, 278, 0, 333, 0, 0, 0, 110, 180, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (18958, 18958, 'Guardian of the Tomb', '', 'LineageMonster3.apostle_grail_a', 15.00, 47.00, 82, 'male', 'L2Monster', 'Fighter', 1100, 5757, 8.500, 2126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2165, 598, 1707, 534, 278, 0, 333, 0, 0, 0, 110, 180, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (18959, 18959, 'Guardian of the Tomb', '', 'LineageMonster3.apostle_grail_a', 15.00, 47.00, 82, 'male', 'L2Monster', 'Fighter', 1100, 5757, 8.500, 2126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2165, 598, 1707, 534, 278, 0, 333, 0, 0, 0, 110, 180, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (27405, 27405, 'Monastic Pilgrim', '', 'LineageMonster.angel_080p', 12.00, 27.80, 80, 'male', 'L2Monster', 'Fighter', 40, 5757, 8.500, 2126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2165, 598, 1707, 534, 278, 300, 333, 148, 0, 0, 33, 132, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 7, 0, 2, 0.52, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (27407, 27407, 'Solina Lay Brother', '', 'LineageMonster3.solina_brother', 9.00, 23.40, 80, 'male', 'L2Monster', 'Fighter', 40, 5757, 8.500, 2126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2165, 598, 1707, 534, 278, 300, 333, 0, 0, 0, 67, 198, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (27409, 27409, 'Solina Knight Captain', '', 'LineageMonster5.solina_knight', 14.00, 31.50, 81, 'male', 'L2Monster', 'Fighter', 40, 5757, 8.500, 2126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2165, 598, 1707, 534, 278, 300, 333, 0, 0, 0, 80, 160, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (27410, 27410, 'Solina Knights', '', 'LineageMonster3.monk_warrior', 12.00, 28.40, 80, 'male', 'L2Monster', 'Fighter', 40, 5757, 8.500, 2126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2165, 598, 1707, 534, 278, 300, 333, 0, 0, 0, 80, 160, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (27412, 27412, 'Divinity Supervisor', '', 'LineageMonster3.apostle_grail', 13.00, 47.00, 80, 'male', 'L2Monster', 'Fighter', 40, 5757, 8.500, 2126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2165, 598, 1707, 534, 278, 300, 333, 0, 0, 0, 80, 160, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (27413, 27413, 'Divinity Fighter', '', 'LineageMonster5.guardian_covenant_a', 24.00, 49.00, 80, 'male', 'L2Monster', 'Fighter', 40, 5757, 8.500, 2126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2165, 598, 1707, 534, 278, 300, 333, 0, 0, 0, 80, 160, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (27414, 27414, 'Divinity Magus', '', 'LineageMonster5.messenger_covenant_a', 18.00, 40.00, 80, 'male', 'L2Monster', 'Mystic', 40, 5757, 8.500, 2126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2165, 598, 1707, 534, 278, 300, 333, 0, 0, 0, 80, 160, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.52, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (27417, 27417, 'Mutant Archer', '', 'LineageMonster.skeleton_archer', 11.00, 27.00, 80, 'male', 'L2Monster', 'Ranger', 1100, 5757, 8.500, 2126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2165, 598, 1707, 534, 278, 300, 333, 14, 0, 0, 44, 154, 'solina_clan', 300, 0, 0, 0, 7, 10, 8, 5, 1500, 0, 0.80, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (27418, 27418, 'Mutant Warrior', '', 'LineageMonster.skeleton_knight', 10.00, 25.00, 80, 'male', 'L2Monster', 'Fighter', 40, 5757, 8.500, 2126, 3.000, 40, 43, 30, 21, 20, 20, 0, 0, 2165, 598, 1707, 534, 278, 300, 333, 150, 0, 0, 44, 176, 'solina_clan', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.17, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32803, 32803, 'Relic Guardian', '', 'LineageNPC.a_sanctuary_teacher_FHuman', 8.00, 22.50, 70, 'female', 'L2Npc', 'npc', 40, 3862, 1.500, 1494, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1303, 471, 607, 382, 253, 0, 500, 0, 0, 0, 110, 180, '', 0, 0, 0, 0, 7, 30, 4, 4, 0, 0, 0.60, 'true', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (32999, 32999, 'Marselle', '', 'e_mine_master_MDwarf', 8.00, 19.70, 70, 'male', 'L2VillageMaster', 'npc', 40, 2444, 7.500, 1346, 2.700, 40, 43, 30, 21, 20, 20, 0, 0, 1096, 471, 747, 345, 253, 0, 506, 0, 0, 0, 50, 120, '', 300, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 1, 0);
INSERT INTO `npc` VALUES (22820, 22820, 'Mesmer Drake', 'Scout', 'LineageMonster4.m_drake_wing_knave_50p', 40.00, 44.00, 82, 'male', 'L2Monster', 'Fighter', 40, 3643, 7.500, 1743, 2.700, 40, 43, 30, 21, 20, 20, 40787, 4459, 18024, 1007, 20878, 1259, 278, 500, 333, 0, 0, 0, 46, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22832, 22832, 'Dragon Scout of the Valley', 'Scout', 'LineageMonster4.m_drake_wing_knave_50p', 37.00, 28.00, 83, 'male', 'L2Monster', 'Fighter', 40, 44514, 7.500, 1777, 2.700, 40, 43, 30, 21, 20, 20, 618202, 66763, 24513, 1007, 20878, 1259, 278, 500, 333, 0, 0, 0, 200, 160, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22834, 22834, 'Dust Dragon Tracker', 'Tracker', 'LineageMonster4.m_drake_wing_knave_50p', 15.00, 60.00, 84, 'male', 'L2Monster', 'Fighter', 40, 44397, 7.500, 1812, 2.700, 40, 43, 30, 21, 20, 20, 691073, 73733, 24513, 1007, 20878, 1259, 278, 500, 333, 0, 0, 0, 46, 140, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22859, 22859, 'Howl', 'Tracker', 'LineageMonster4.m_drake_wing_knave_50p', 28.00, 36.00, 83, 'male', 'L2Monster', 'Fighter', 40, 44514, 7.500, 1777, 2.700, 40, 43, 30, 21, 20, 20, 516919, 55825, 12024, 1007, 15878, 1259, 278, 500, 333, 0, 0, 0, 37, 170, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22824, 22824, 'Drakos Guardian', '', 'LineageMonster4.m_drake_wing_knave_50p', 50.00, 55.00, 84, 'male', 'L2Monster', 'Fighter', 40, 14799, 7.500, 1812, 2.700, 40, 43, 30, 21, 20, 20, 601562, 61123, 18024, 1007, 20878, 1259, 278, 500, 333, 0, 0, 0, 100, 200, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
INSERT INTO `npc` VALUES (22861, 22861, 'Hard Scorpion Bones', '', 'LineageMonster4.m_drake_wing_knave_50p', 28.00, 66.00, 81, 'male', 'L2Monster', 'Fighter', 40, 3461, 7.500, 1708, 2.700, 40, 43, 30, 21, 20, 10, 25020, 2771, 9376, 410, 6468, 546, 278, 500, 333, 0, 0, 0, 140, 200, '', 0, 0, 0, 0, 7, 30, 4, 5, 0, 0, 0.60, 'false', 'NONE', 0, 0);
